/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(901), /*)*//*default:*//*Label 154*/ GIMT_Encode4(418949),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3402),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36397),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50625),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(53146),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(53228), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(53310),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(61056),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(72835), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(80027), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(87551), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(97527),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(98018),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(98509),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(98777),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(98927),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(99418), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(99451),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(108389),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(109439), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(112488), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(126014),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(127365),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(128357),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(129349),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(130841), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(132333),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(133325),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(134317),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(135309),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(136301),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(137293),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(138285), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(138990),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(139695),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(140400),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(141105), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(141810), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(141861),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(251597), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(263113),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(263403),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(264840),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(264960), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(265201),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(267099),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(268753),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(271532),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(272357),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(272795), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(273620),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(273750), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(274292), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(282069), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(283114),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(283598),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(284082),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(284512),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(284942),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(285372), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(285802),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(287600),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(288338),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(292434), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(308707), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(309323),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(312830),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(313078),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(313266),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(314243),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(315220),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(319848),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(323854),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(324174),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(324494), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(325351),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(325633),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(326011),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(326389),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(326739),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(327089),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(327792), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    694 */ /*TargetOpcode::G_SMIN*//*Label 81*/ GIMT_Encode4(328495),
     /*    698 */ /*TargetOpcode::G_SMAX*//*Label 82*/ GIMT_Encode4(328899),
     /*    702 */ /*TargetOpcode::G_UMIN*//*Label 83*/ GIMT_Encode4(329303),
     /*    706 */ /*TargetOpcode::G_UMAX*//*Label 84*/ GIMT_Encode4(329707),
     /*    710 */ /*TargetOpcode::G_ABS*//*Label 85*/ GIMT_Encode4(330111),
     /*    714 */ /*TargetOpcode::G_LROUND*//*Label 86*/ GIMT_Encode4(330926),
     /*    718 */ /*TargetOpcode::G_LLROUND*//*Label 87*/ GIMT_Encode4(331092),
     /*    722 */ /*TargetOpcode::G_BR*//*Label 88*/ GIMT_Encode4(331191), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    738 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 89*/ GIMT_Encode4(331207),
     /*    742 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(336579),
     /*    746 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(365724), GIMT_Encode4(0),
     /*    754 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 92*/ GIMT_Encode4(368642), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTTZ*//*Label 93*/ GIMT_Encode4(370962), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTLZ*//*Label 94*/ GIMT_Encode4(371114), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTPOP*//*Label 95*/ GIMT_Encode4(371788),
     /*    786 */ /*TargetOpcode::G_BSWAP*//*Label 96*/ GIMT_Encode4(371948),
     /*    790 */ /*TargetOpcode::G_BITREVERSE*//*Label 97*/ GIMT_Encode4(372262),
     /*    794 */ /*TargetOpcode::G_FCEIL*//*Label 98*/ GIMT_Encode4(372416), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    842 */ /*TargetOpcode::G_FSQRT*//*Label 99*/ GIMT_Encode4(372907),
     /*    846 */ /*TargetOpcode::G_FFLOOR*//*Label 100*/ GIMT_Encode4(373207),
     /*    850 */ /*TargetOpcode::G_FRINT*//*Label 101*/ GIMT_Encode4(373698),
     /*    854 */ /*TargetOpcode::G_FNEARBYINT*//*Label 102*/ GIMT_Encode4(374189), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    882 */ /*TargetOpcode::G_STRICT_FADD*//*Label 103*/ GIMT_Encode4(374680),
     /*    886 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 104*/ GIMT_Encode4(375806),
     /*    890 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 105*/ GIMT_Encode4(376422),
     /*    894 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 106*/ GIMT_Encode4(380144), GIMT_Encode4(0),
     /*    902 */ /*TargetOpcode::G_STRICT_FMA*//*Label 107*/ GIMT_Encode4(380760),
     /*    906 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 108*/ GIMT_Encode4(396367), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    942 */ /*TargetOpcode::G_TRAP*//*Label 109*/ GIMT_Encode4(396667),
     /*    946 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 110*/ GIMT_Encode4(396681),
     /*    950 */ /*TargetOpcode::G_UBSANTRAP*//*Label 111*/ GIMT_Encode4(396702), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 112*/ GIMT_Encode4(396727), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 113*/ GIMT_Encode4(397037),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 114*/ GIMT_Encode4(397208),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 115*/ GIMT_Encode4(397379),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 116*/ GIMT_Encode4(397550),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 117*/ GIMT_Encode4(397721), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 118*/ GIMT_Encode4(398850),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 119*/ GIMT_Encode4(399053),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 120*/ GIMT_Encode4(399256),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 121*/ GIMT_Encode4(399459), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3270 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 122*/ GIMT_Encode4(399662), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_BSP*//*Label 123*/ GIMT_Encode4(399802),
     /*   3282 */ /*AArch64::G_DUP*//*Label 124*/ GIMT_Encode4(400342),
     /*   3286 */ /*AArch64::G_DUPLANE16*//*Label 125*/ GIMT_Encode4(402165),
     /*   3290 */ /*AArch64::G_DUPLANE32*//*Label 126*/ GIMT_Encode4(402420),
     /*   3294 */ /*AArch64::G_DUPLANE64*//*Label 127*/ GIMT_Encode4(402675),
     /*   3298 */ /*AArch64::G_DUPLANE8*//*Label 128*/ GIMT_Encode4(402821),
     /*   3302 */ /*AArch64::G_EXT*//*Label 129*/ GIMT_Encode4(403000),
     /*   3306 */ /*AArch64::G_FCMEQ*//*Label 130*/ GIMT_Encode4(404650),
     /*   3310 */ /*AArch64::G_FCMGE*//*Label 131*/ GIMT_Encode4(405209),
     /*   3314 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(406301),
     /*   3318 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(407393),
     /*   3322 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(407547),
     /*   3326 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(407723),
     /*   3330 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(407997),
     /*   3334 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(408203),
     /*   3338 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(408602),
     /*   3342 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(408972),
     /*   3346 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(409089),
     /*   3350 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(410322),
     /*   3354 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(411102),
     /*   3358 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(411882),
     /*   3362 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(412088),
     /*   3366 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(412955),
     /*   3370 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(413325),
     /*   3374 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(413442),
     /*   3378 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(414675),
     /*   3382 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(415455),
     /*   3386 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(416235),
     /*   3390 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(416933),
     /*   3394 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(417389),
     /*   3398 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(418169),
     /*   3402 */ // Label 0: @3402
     /*   3402 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(36396),
     /*   3413 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3501),
     /*   3417 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(6280), GIMT_Encode4(0),
     /*   3425 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(11608),
     /*   3429 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(15216),
     /*   3433 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(21118),
     /*   3437 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(24616),
     /*   3441 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(30794),
     /*   3445 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(31644),
     /*   3449 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(35222), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3469 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(35946), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3481 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(36318), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(36344), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(36370),
     /*   3501 */ // Label 155: @3501
     /*   3501 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(6279),
     /*   3506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3512 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3545), // Rule ID 13227 //
     /*   3517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3532 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3543 */     GIR_RootConstrainSelectedInstOperands,
     /*   3544 */     // GIR_Coverage, 13227,
     /*   3544 */     GIR_EraseRootFromParent_Done,
     /*   3545 */   // Label 170: @3545
     /*   3545 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3697), // Rule ID 13654 //
     /*   3550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3577 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3580 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3585 */     // MIs[2] pattern
     /*   3585 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3588 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3599 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3599 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3602 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3606 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3625 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3628 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3632 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3635 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3662 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3669 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3696 */     // GIR_Coverage, 13654,
     /*   3696 */     GIR_EraseRootFromParent_Done,
     /*   3697 */   // Label 171: @3697
     /*   3697 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3849), // Rule ID 15508 //
     /*   3702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3729 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3732 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3737 */     // MIs[2] pattern
     /*   3737 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3740 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3751 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3751 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3754 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3758 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3777 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3780 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3784 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3787 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3792 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3797 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3814 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3831 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3848 */     // GIR_Coverage, 15508,
     /*   3848 */     GIR_EraseRootFromParent_Done,
     /*   3849 */   // Label 172: @3849
     /*   3849 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4001), // Rule ID 15520 //
     /*   3854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3881 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3884 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3889 */     // MIs[2] pattern
     /*   3889 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3892 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3903 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3903 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3906 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3910 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3929 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3932 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3936 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3949 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3966 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3983 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4000 */     // GIR_Coverage, 15520,
     /*   4000 */     GIR_EraseRootFromParent_Done,
     /*   4001 */   // Label 173: @4001
     /*   4001 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4153), // Rule ID 15532 //
     /*   4006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4033 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4036 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4041 */     // MIs[2] pattern
     /*   4041 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4044 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4055 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4055 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4058 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4062 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4081 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4084 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4088 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4101 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4135 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4152 */     // GIR_Coverage, 15532,
     /*   4152 */     GIR_EraseRootFromParent_Done,
     /*   4153 */   // Label 174: @4153
     /*   4153 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4186), // Rule ID 91 //
     /*   4158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4173 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4184 */     GIR_RootConstrainSelectedInstOperands,
     /*   4185 */     // GIR_Coverage, 91,
     /*   4185 */     GIR_EraseRootFromParent_Done,
     /*   4186 */   // Label 175: @4186
     /*   4186 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4338), // Rule ID 2656 //
     /*   4191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4222 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4225 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4230 */     // MIs[2] pattern
     /*   4230 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4233 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4240 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4240 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4243 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4247 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4266 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4273 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4310 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4320 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4337 */     // GIR_Coverage, 2656,
     /*   4337 */     GIR_EraseRootFromParent_Done,
     /*   4338 */   // Label 176: @4338
     /*   4338 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4490), // Rule ID 9965 //
     /*   4343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4374 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4377 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4382 */     // MIs[2] pattern
     /*   4382 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4385 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4392 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4392 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4395 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4399 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4418 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4425 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4433 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4438 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4472 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4489 */     // GIR_Coverage, 9965,
     /*   4489 */     GIR_EraseRootFromParent_Done,
     /*   4490 */   // Label 177: @4490
     /*   4490 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4642), // Rule ID 9977 //
     /*   4495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4526 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4529 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4534 */     // MIs[2] pattern
     /*   4534 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4537 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4544 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4544 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4547 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4551 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4558 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4561 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4565 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4570 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4573 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4577 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4580 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4614 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4624 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4641 */     // GIR_Coverage, 9977,
     /*   4641 */     GIR_EraseRootFromParent_Done,
     /*   4642 */   // Label 178: @4642
     /*   4642 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4794), // Rule ID 9989 //
     /*   4647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4678 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4681 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4686 */     // MIs[2] pattern
     /*   4686 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4689 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4696 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4696 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4699 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4703 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4722 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4725 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4729 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4742 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4766 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4776 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4793 */     // GIR_Coverage, 9989,
     /*   4793 */     GIR_EraseRootFromParent_Done,
     /*   4794 */   // Label 179: @4794
     /*   4794 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4951), // Rule ID 15551 //
     /*   4799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4826 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4829 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4845 */     // MIs[2] pred
     /*   4845 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4856 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4856 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4859 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4863 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4882 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4885 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4889 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4902 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4919 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4923 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4933 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4950 */     // GIR_Coverage, 15551,
     /*   4950 */     GIR_EraseRootFromParent_Done,
     /*   4951 */   // Label 180: @4951
     /*   4951 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5108), // Rule ID 15552 //
     /*   4956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4983 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4986 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   4995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5002 */     // MIs[2] pred
     /*   5002 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5013 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5013 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5016 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5020 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5039 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5042 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5046 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5080 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5090 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5107 */     // GIR_Coverage, 15552,
     /*   5107 */     GIR_EraseRootFromParent_Done,
     /*   5108 */   // Label 181: @5108
     /*   5108 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5265), // Rule ID 15553 //
     /*   5113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5140 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5143 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5159 */     // MIs[2] pred
     /*   5159 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5170 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5184 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5187 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5191 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5196 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5203 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5206 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5247 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5264 */     // GIR_Coverage, 15553,
     /*   5264 */     GIR_EraseRootFromParent_Done,
     /*   5265 */   // Label 182: @5265
     /*   5265 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5422), // Rule ID 15554 //
     /*   5270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5297 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5300 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5309 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5316 */     // MIs[2] pred
     /*   5316 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5327 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5327 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5330 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5334 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5353 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5356 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5360 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5404 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5421 */     // GIR_Coverage, 15554,
     /*   5421 */     GIR_EraseRootFromParent_Done,
     /*   5422 */   // Label 183: @5422
     /*   5422 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5579), // Rule ID 10081 //
     /*   5427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5458 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5461 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5470 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5477 */     // MIs[2] pred
     /*   5477 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5484 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5484 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5487 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5491 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5510 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5517 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5530 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5551 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5561 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5578 */     // GIR_Coverage, 10081,
     /*   5578 */     GIR_EraseRootFromParent_Done,
     /*   5579 */   // Label 184: @5579
     /*   5579 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5736), // Rule ID 10082 //
     /*   5584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5615 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5618 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5627 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5634 */     // MIs[2] pred
     /*   5634 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5641 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5641 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5644 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5648 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5667 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5670 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5674 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5718 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5735 */     // GIR_Coverage, 10082,
     /*   5735 */     GIR_EraseRootFromParent_Done,
     /*   5736 */   // Label 185: @5736
     /*   5736 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5893), // Rule ID 10083 //
     /*   5741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5772 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5775 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5784 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5791 */     // MIs[2] pred
     /*   5791 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5798 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5798 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5801 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5805 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5812 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5815 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5819 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5824 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5831 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5834 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5839 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5844 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5865 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5875 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5892 */     // GIR_Coverage, 10083,
     /*   5892 */     GIR_EraseRootFromParent_Done,
     /*   5893 */   // Label 186: @5893
     /*   5893 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6050), // Rule ID 10084 //
     /*   5898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5929 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5932 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5941 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5948 */     // MIs[2] pred
     /*   5948 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5955 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5955 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5958 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5962 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5969 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5972 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5976 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5981 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5984 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5988 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6032 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6049 */     // GIR_Coverage, 10084,
     /*   6049 */     GIR_EraseRootFromParent_Done,
     /*   6050 */   // Label 187: @6050
     /*   6050 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6083), // Rule ID 13231 //
     /*   6055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6070 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6081 */     GIR_RootConstrainSelectedInstOperands,
     /*   6082 */     // GIR_Coverage, 13231,
     /*   6082 */     GIR_EraseRootFromParent_Done,
     /*   6083 */   // Label 188: @6083
     /*   6083 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6119), // Rule ID 13794 //
     /*   6088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6103 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6117 */     GIR_RootConstrainSelectedInstOperands,
     /*   6118 */     // GIR_Coverage, 13794,
     /*   6118 */     GIR_EraseRootFromParent_Done,
     /*   6119 */   // Label 189: @6119
     /*   6119 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6152), // Rule ID 97 //
     /*   6124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6139 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6150 */     GIR_RootConstrainSelectedInstOperands,
     /*   6151 */     // GIR_Coverage, 97,
     /*   6151 */     GIR_EraseRootFromParent_Done,
     /*   6152 */   // Label 190: @6152
     /*   6152 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6188), // Rule ID 3921 //
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6172 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6186 */     GIR_RootConstrainSelectedInstOperands,
     /*   6187 */     // GIR_Coverage, 3921,
     /*   6187 */     GIR_EraseRootFromParent_Done,
     /*   6188 */   // Label 191: @6188
     /*   6188 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6221), // Rule ID 13229 //
     /*   6193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6208 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6219 */     GIR_RootConstrainSelectedInstOperands,
     /*   6220 */     // GIR_Coverage, 13229,
     /*   6220 */     GIR_EraseRootFromParent_Done,
     /*   6221 */   // Label 192: @6221
     /*   6221 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6254), // Rule ID 95 //
     /*   6226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6241 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6252 */     GIR_RootConstrainSelectedInstOperands,
     /*   6253 */     // GIR_Coverage, 95,
     /*   6253 */     GIR_EraseRootFromParent_Done,
     /*   6254 */   // Label 193: @6254
     /*   6254 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6278), // Rule ID 93 //
     /*   6259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6276 */     GIR_RootConstrainSelectedInstOperands,
     /*   6277 */     // GIR_Coverage, 93,
     /*   6277 */     GIR_Done,
     /*   6278 */   // Label 194: @6278
     /*   6278 */   GIM_Reject,
     /*   6279 */ // Label 169: @6279
     /*   6279 */ GIM_Reject,
     /*   6280 */ // Label 156: @6280
     /*   6280 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(11607),
     /*   6285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6427), // Rule ID 5377 //
     /*   6296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6329 */     // MIs[1] Operand 2
     /*   6329 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6348 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6352 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6356 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6360 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6364 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6369 */     // MIs[3] Operand 2
     /*   6369 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6382 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6426 */     // GIR_Coverage, 5377,
     /*   6426 */     GIR_EraseRootFromParent_Done,
     /*   6427 */   // Label 196: @6427
     /*   6427 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6563), // Rule ID 5376 //
     /*   6432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6465 */     // MIs[1] Operand 2
     /*   6465 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6492 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6496 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6500 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6505 */     // MIs[3] Operand 2
     /*   6505 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6518 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6545 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6562 */     // GIR_Coverage, 5376,
     /*   6562 */     GIR_EraseRootFromParent_Done,
     /*   6563 */   // Label 197: @6563
     /*   6563 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6699), // Rule ID 5386 //
     /*   6568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6601 */     // MIs[1] Operand 2
     /*   6601 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6620 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6628 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6632 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6636 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6641 */     // MIs[3] Operand 2
     /*   6641 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6652 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6654 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6698 */     // GIR_Coverage, 5386,
     /*   6698 */     GIR_EraseRootFromParent_Done,
     /*   6699 */   // Label 198: @6699
     /*   6699 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6835), // Rule ID 5375 //
     /*   6704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6737 */     // MIs[1] Operand 2
     /*   6737 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6760 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6764 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6768 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6772 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6777 */     // MIs[3] Operand 2
     /*   6777 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6788 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6790 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6817 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6834 */     // GIR_Coverage, 5375,
     /*   6834 */     GIR_EraseRootFromParent_Done,
     /*   6835 */   // Label 199: @6835
     /*   6835 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6971), // Rule ID 5374 //
     /*   6840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6873 */     // MIs[1] Operand 2
     /*   6873 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6900 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6904 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6908 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6913 */     // MIs[3] Operand 2
     /*   6913 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6924 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6926 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6970 */     // GIR_Coverage, 5374,
     /*   6970 */     GIR_EraseRootFromParent_Done,
     /*   6971 */   // Label 200: @6971
     /*   6971 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7039), // Rule ID 6917 //
     /*   6976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7001 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7017 */     // MIs[2] Rn
     /*   7017 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7022 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7028 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7037 */     GIR_RootConstrainSelectedInstOperands,
     /*   7038 */     // GIR_Coverage, 6917,
     /*   7038 */     GIR_EraseRootFromParent_Done,
     /*   7039 */   // Label 201: @7039
     /*   7039 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7107), // Rule ID 13952 //
     /*   7044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7069 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7085 */     // MIs[2] Rn
     /*   7085 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7090 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7096 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 13952,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 202: @7107
     /*   7107 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7140), // Rule ID 13228 //
     /*   7112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7127 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7138 */     GIR_RootConstrainSelectedInstOperands,
     /*   7139 */     // GIR_Coverage, 13228,
     /*   7139 */     GIR_EraseRootFromParent_Done,
     /*   7140 */   // Label 203: @7140
     /*   7140 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7273), // Rule ID 3973 //
     /*   7145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7182 */     // MIs[2] Operand 2
     /*   7182 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7201 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7205 */     // MIs[3] Operand 1
     /*   7205 */     // No operand predicates
     /*   7205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7211 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7223 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7242 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7271 */     GIR_RootConstrainSelectedInstOperands,
     /*   7272 */     // GIR_Coverage, 3973,
     /*   7272 */     GIR_EraseRootFromParent_Done,
     /*   7273 */   // Label 204: @7273
     /*   7273 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7368), // Rule ID 3971 //
     /*   7278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7323 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7327 */     // MIs[3] Operand 1
     /*   7327 */     // No operand predicates
     /*   7327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7333 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7345 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7366 */     GIR_RootConstrainSelectedInstOperands,
     /*   7367 */     // GIR_Coverage, 3971,
     /*   7367 */     GIR_EraseRootFromParent_Done,
     /*   7368 */   // Label 205: @7368
     /*   7368 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7463), // Rule ID 3972 //
     /*   7373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7418 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7422 */     // MIs[3] Operand 1
     /*   7422 */     // No operand predicates
     /*   7422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7428 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7440 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7461 */     GIR_RootConstrainSelectedInstOperands,
     /*   7462 */     // GIR_Coverage, 3972,
     /*   7462 */     GIR_EraseRootFromParent_Done,
     /*   7463 */   // Label 206: @7463
     /*   7463 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7496), // Rule ID 92 //
     /*   7468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7483 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7494 */     GIR_RootConstrainSelectedInstOperands,
     /*   7495 */     // GIR_Coverage, 92,
     /*   7495 */     GIR_EraseRootFromParent_Done,
     /*   7496 */   // Label 207: @7496
     /*   7496 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7629), // Rule ID 13804 //
     /*   7501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7542 */     // MIs[2] Operand 2
     /*   7542 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7561 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7565 */     // MIs[3] Operand 1
     /*   7565 */     // No operand predicates
     /*   7565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7567 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7579 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7598 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7627 */     GIR_RootConstrainSelectedInstOperands,
     /*   7628 */     // GIR_Coverage, 13804,
     /*   7628 */     GIR_EraseRootFromParent_Done,
     /*   7629 */   // Label 208: @7629
     /*   7629 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7724), // Rule ID 13802 //
     /*   7634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7683 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7687 */     // MIs[3] Operand 1
     /*   7687 */     // No operand predicates
     /*   7687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7689 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7701 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7722 */     GIR_RootConstrainSelectedInstOperands,
     /*   7723 */     // GIR_Coverage, 13802,
     /*   7723 */     GIR_EraseRootFromParent_Done,
     /*   7724 */   // Label 209: @7724
     /*   7724 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7819), // Rule ID 13803 //
     /*   7729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7778 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7782 */     // MIs[3] Operand 1
     /*   7782 */     // No operand predicates
     /*   7782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7784 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7796 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7817 */     GIR_RootConstrainSelectedInstOperands,
     /*   7818 */     // GIR_Coverage, 13803,
     /*   7818 */     GIR_EraseRootFromParent_Done,
     /*   7819 */   // Label 210: @7819
     /*   7819 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7901), // Rule ID 13239 //
     /*   7824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7869 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7873 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7884 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 13239,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 211: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7983), // Rule ID 13240 //
     /*   7906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7951 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7955 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7966 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7981 */     GIR_RootConstrainSelectedInstOperands,
     /*   7982 */     // GIR_Coverage, 13240,
     /*   7982 */     GIR_EraseRootFromParent_Done,
     /*   7983 */   // Label 212: @7983
     /*   7983 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8065), // Rule ID 123 //
     /*   7988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8037 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8041 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8048 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8063 */     GIR_RootConstrainSelectedInstOperands,
     /*   8064 */     // GIR_Coverage, 123,
     /*   8064 */     GIR_EraseRootFromParent_Done,
     /*   8065 */   // Label 213: @8065
     /*   8065 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8147), // Rule ID 125 //
     /*   8070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8119 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8130 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8145 */     GIR_RootConstrainSelectedInstOperands,
     /*   8146 */     // GIR_Coverage, 125,
     /*   8146 */     GIR_EraseRootFromParent_Done,
     /*   8147 */   // Label 214: @8147
     /*   8147 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8205), // Rule ID 13649 //
     /*   8152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8167 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8170 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8175 */     // MIs[1] pattern
     /*   8175 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8178 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8189 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8203 */     GIR_RootConstrainSelectedInstOperands,
     /*   8204 */     // GIR_Coverage, 13649,
     /*   8204 */     GIR_EraseRootFromParent_Done,
     /*   8205 */   // Label 215: @8205
     /*   8205 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8263), // Rule ID 15503 //
     /*   8210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8225 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8228 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8233 */     // MIs[1] pattern
     /*   8233 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8236 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8247 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8261 */     GIR_RootConstrainSelectedInstOperands,
     /*   8262 */     // GIR_Coverage, 15503,
     /*   8262 */     GIR_EraseRootFromParent_Done,
     /*   8263 */   // Label 216: @8263
     /*   8263 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8321), // Rule ID 15515 //
     /*   8268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8283 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8286 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8291 */     // MIs[1] pattern
     /*   8291 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8294 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8305 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8319 */     GIR_RootConstrainSelectedInstOperands,
     /*   8320 */     // GIR_Coverage, 15515,
     /*   8320 */     GIR_EraseRootFromParent_Done,
     /*   8321 */   // Label 217: @8321
     /*   8321 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8379), // Rule ID 15527 //
     /*   8326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8341 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8344 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8349 */     // MIs[1] pattern
     /*   8349 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8352 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8363 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8377 */     GIR_RootConstrainSelectedInstOperands,
     /*   8378 */     // GIR_Coverage, 15527,
     /*   8378 */     GIR_EraseRootFromParent_Done,
     /*   8379 */   // Label 218: @8379
     /*   8379 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8437), // Rule ID 2653 //
     /*   8384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8403 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8406 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8411 */     // MIs[1] pattern
     /*   8411 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8414 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8421 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8435 */     GIR_RootConstrainSelectedInstOperands,
     /*   8436 */     // GIR_Coverage, 2653,
     /*   8436 */     GIR_EraseRootFromParent_Done,
     /*   8437 */   // Label 219: @8437
     /*   8437 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8495), // Rule ID 9962 //
     /*   8442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8461 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8464 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8469 */     // MIs[1] pattern
     /*   8469 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8472 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8479 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8493 */     GIR_RootConstrainSelectedInstOperands,
     /*   8494 */     // GIR_Coverage, 9962,
     /*   8494 */     GIR_EraseRootFromParent_Done,
     /*   8495 */   // Label 220: @8495
     /*   8495 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8553), // Rule ID 9974 //
     /*   8500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8519 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8522 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8527 */     // MIs[1] pattern
     /*   8527 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8530 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8537 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8551 */     GIR_RootConstrainSelectedInstOperands,
     /*   8552 */     // GIR_Coverage, 9974,
     /*   8552 */     GIR_EraseRootFromParent_Done,
     /*   8553 */   // Label 221: @8553
     /*   8553 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8611), // Rule ID 9986 //
     /*   8558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8577 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8580 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8585 */     // MIs[1] pattern
     /*   8585 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8588 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8609 */     GIR_RootConstrainSelectedInstOperands,
     /*   8610 */     // GIR_Coverage, 9986,
     /*   8610 */     GIR_EraseRootFromParent_Done,
     /*   8611 */   // Label 222: @8611
     /*   8611 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8774), // Rule ID 13924 //
     /*   8616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8658 */     // MIs[1] Operand 2
     /*   8658 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8675 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8675 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8678 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8682 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8701 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8704 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8708 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8738 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8756 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8773 */     // GIR_Coverage, 13924,
     /*   8773 */     GIR_EraseRootFromParent_Done,
     /*   8774 */   // Label 223: @8774
     /*   8774 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8937), // Rule ID 13921 //
     /*   8779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8821 */     // MIs[1] Operand 2
     /*   8821 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8838 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8864 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8871 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8874 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8879 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8919 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8936 */     // GIR_Coverage, 13921,
     /*   8936 */     GIR_EraseRootFromParent_Done,
     /*   8937 */   // Label 224: @8937
     /*   8937 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(9087), // Rule ID 13930 //
     /*   8942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8975 */     // MIs[1] Operand 2
     /*   8975 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8992 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8992 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8995 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8999 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9018 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9021 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9025 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9028 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9033 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9069 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9086 */     // GIR_Coverage, 13930,
     /*   9086 */     GIR_EraseRootFromParent_Done,
     /*   9087 */   // Label 225: @9087
     /*   9087 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9237), // Rule ID 13933 //
     /*   9092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9125 */     // MIs[1] Operand 2
     /*   9125 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9142 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9142 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9145 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9149 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9168 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9175 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9178 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9219 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9236 */     // GIR_Coverage, 13933,
     /*   9236 */     GIR_EraseRootFromParent_Done,
     /*   9237 */   // Label 226: @9237
     /*   9237 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9387), // Rule ID 13929 //
     /*   9242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9275 */     // MIs[1] Operand 2
     /*   9275 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9292 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9292 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9295 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9299 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9318 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9321 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9325 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9369 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9386 */     // GIR_Coverage, 13929,
     /*   9386 */     GIR_EraseRootFromParent_Done,
     /*   9387 */   // Label 227: @9387
     /*   9387 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9550), // Rule ID 5359 //
     /*   9392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9438 */     // MIs[1] Operand 2
     /*   9438 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9451 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9451 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9454 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9458 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9477 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9480 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9484 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9514 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9517 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9532 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9549 */     // GIR_Coverage, 5359,
     /*   9549 */     GIR_EraseRootFromParent_Done,
     /*   9550 */   // Label 228: @9550
     /*   9550 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9713), // Rule ID 5356 //
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9601 */     // MIs[1] Operand 2
     /*   9601 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9614 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9640 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9695 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9712 */     // GIR_Coverage, 5356,
     /*   9712 */     GIR_EraseRootFromParent_Done,
     /*   9713 */   // Label 229: @9713
     /*   9713 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9863), // Rule ID 5383 //
     /*   9718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9755 */     // MIs[1] Operand 2
     /*   9755 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9768 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9768 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9771 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9775 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9782 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9785 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9789 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9794 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9797 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9801 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9831 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9845 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9862 */     // GIR_Coverage, 5383,
     /*   9862 */     GIR_EraseRootFromParent_Done,
     /*   9863 */   // Label 230: @9863
     /*   9863 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(10013), // Rule ID 5389 //
     /*   9868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9905 */     // MIs[1] Operand 2
     /*   9905 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9918 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9918 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9921 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9925 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9944 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9947 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9951 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9995 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10012 */     // GIR_Coverage, 5389,
     /*  10012 */     GIR_EraseRootFromParent_Done,
     /*  10013 */   // Label 231: @10013
     /*  10013 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(10163), // Rule ID 5382 //
     /*  10018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10055 */     // MIs[1] Operand 2
     /*  10055 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10068 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10068 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10071 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10075 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10094 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10097 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10101 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10131 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10145 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10162 */     // GIR_Coverage, 5382,
     /*  10162 */     GIR_EraseRootFromParent_Done,
     /*  10163 */   // Label 232: @10163
     /*  10163 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10196), // Rule ID 13232 //
     /*  10168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10183 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10194 */     GIR_RootConstrainSelectedInstOperands,
     /*  10195 */     // GIR_Coverage, 13232,
     /*  10195 */     GIR_EraseRootFromParent_Done,
     /*  10196 */   // Label 233: @10196
     /*  10196 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10232), // Rule ID 13795 //
     /*  10201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10216 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10230 */     GIR_RootConstrainSelectedInstOperands,
     /*  10231 */     // GIR_Coverage, 13795,
     /*  10231 */     GIR_EraseRootFromParent_Done,
     /*  10232 */   // Label 234: @10232
     /*  10232 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10265), // Rule ID 98 //
     /*  10237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10252 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10263 */     GIR_RootConstrainSelectedInstOperands,
     /*  10264 */     // GIR_Coverage, 98,
     /*  10264 */     GIR_EraseRootFromParent_Done,
     /*  10265 */   // Label 235: @10265
     /*  10265 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10301), // Rule ID 3922 //
     /*  10270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10285 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10299 */     GIR_RootConstrainSelectedInstOperands,
     /*  10300 */     // GIR_Coverage, 3922,
     /*  10300 */     GIR_EraseRootFromParent_Done,
     /*  10301 */   // Label 236: @10301
     /*  10301 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10334), // Rule ID 13230 //
     /*  10306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10321 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10332 */     GIR_RootConstrainSelectedInstOperands,
     /*  10333 */     // GIR_Coverage, 13230,
     /*  10333 */     GIR_EraseRootFromParent_Done,
     /*  10334 */   // Label 237: @10334
     /*  10334 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10397), // Rule ID 15543 //
     /*  10339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10354 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10357 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10373 */     // MIs[1] pred
     /*  10373 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10384 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10395 */     GIR_RootConstrainSelectedInstOperands,
     /*  10396 */     // GIR_Coverage, 15543,
     /*  10396 */     GIR_EraseRootFromParent_Done,
     /*  10397 */   // Label 238: @10397
     /*  10397 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10460), // Rule ID 15544 //
     /*  10402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10417 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10420 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10429 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10436 */     // MIs[1] pred
     /*  10436 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10447 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10458 */     GIR_RootConstrainSelectedInstOperands,
     /*  10459 */     // GIR_Coverage, 15544,
     /*  10459 */     GIR_EraseRootFromParent_Done,
     /*  10460 */   // Label 239: @10460
     /*  10460 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10523), // Rule ID 15545 //
     /*  10465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10480 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10483 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10499 */     // MIs[1] pred
     /*  10499 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10510 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10521 */     GIR_RootConstrainSelectedInstOperands,
     /*  10522 */     // GIR_Coverage, 15545,
     /*  10522 */     GIR_EraseRootFromParent_Done,
     /*  10523 */   // Label 240: @10523
     /*  10523 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10586), // Rule ID 15546 //
     /*  10528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10543 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10546 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10555 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10562 */     // MIs[1] pred
     /*  10562 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10573 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10584 */     GIR_RootConstrainSelectedInstOperands,
     /*  10585 */     // GIR_Coverage, 15546,
     /*  10585 */     GIR_EraseRootFromParent_Done,
     /*  10586 */   // Label 241: @10586
     /*  10586 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10619), // Rule ID 96 //
     /*  10591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10606 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10617 */     GIR_RootConstrainSelectedInstOperands,
     /*  10618 */     // GIR_Coverage, 96,
     /*  10618 */     GIR_EraseRootFromParent_Done,
     /*  10619 */   // Label 242: @10619
     /*  10619 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10682), // Rule ID 10073 //
     /*  10624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10643 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10646 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10655 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10662 */     // MIs[1] pred
     /*  10662 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10669 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10680 */     GIR_RootConstrainSelectedInstOperands,
     /*  10681 */     // GIR_Coverage, 10073,
     /*  10681 */     GIR_EraseRootFromParent_Done,
     /*  10682 */   // Label 243: @10682
     /*  10682 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10745), // Rule ID 10074 //
     /*  10687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10706 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10709 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10718 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10725 */     // MIs[1] pred
     /*  10725 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10732 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10743 */     GIR_RootConstrainSelectedInstOperands,
     /*  10744 */     // GIR_Coverage, 10074,
     /*  10744 */     GIR_EraseRootFromParent_Done,
     /*  10745 */   // Label 244: @10745
     /*  10745 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10808), // Rule ID 10075 //
     /*  10750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10769 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10772 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10788 */     // MIs[1] pred
     /*  10788 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10795 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10806 */     GIR_RootConstrainSelectedInstOperands,
     /*  10807 */     // GIR_Coverage, 10075,
     /*  10807 */     GIR_EraseRootFromParent_Done,
     /*  10808 */   // Label 245: @10808
     /*  10808 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10871), // Rule ID 10076 //
     /*  10813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10832 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10835 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10851 */     // MIs[1] pred
     /*  10851 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10858 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10869 */     GIR_RootConstrainSelectedInstOperands,
     /*  10870 */     // GIR_Coverage, 10076,
     /*  10870 */     GIR_EraseRootFromParent_Done,
     /*  10871 */   // Label 246: @10871
     /*  10871 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10927), // Rule ID 13338 //
     /*  10876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10891 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10894 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10914 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10925 */     GIR_RootConstrainSelectedInstOperands,
     /*  10926 */     // GIR_Coverage, 13338,
     /*  10926 */     GIR_EraseRootFromParent_Done,
     /*  10927 */   // Label 247: @10927
     /*  10927 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10983), // Rule ID 13350 //
     /*  10932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10947 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10950 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10970 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10981 */     GIR_RootConstrainSelectedInstOperands,
     /*  10982 */     // GIR_Coverage, 13350,
     /*  10982 */     GIR_EraseRootFromParent_Done,
     /*  10983 */   // Label 248: @10983
     /*  10983 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11050), // Rule ID 13556 //
     /*  10988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11012 */     // MIs[1] imm
     /*  11012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11024 */     // MIs[2] Operand 1
     /*  11024 */     // No operand predicates
     /*  11024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11034 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11048 */     GIR_RootConstrainSelectedInstOperands,
     /*  11049 */     // GIR_Coverage, 13556,
     /*  11049 */     GIR_EraseRootFromParent_Done,
     /*  11050 */   // Label 249: @11050
     /*  11050 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11117), // Rule ID 13559 //
     /*  11055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11079 */     // MIs[1] imm
     /*  11079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11091 */     // MIs[2] Operand 1
     /*  11091 */     // No operand predicates
     /*  11091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11101 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11115 */     GIR_RootConstrainSelectedInstOperands,
     /*  11116 */     // GIR_Coverage, 13559,
     /*  11116 */     GIR_EraseRootFromParent_Done,
     /*  11117 */   // Label 250: @11117
     /*  11117 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11173), // Rule ID 997 //
     /*  11122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11141 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11144 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11160 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11171 */     GIR_RootConstrainSelectedInstOperands,
     /*  11172 */     // GIR_Coverage, 997,
     /*  11172 */     GIR_EraseRootFromParent_Done,
     /*  11173 */   // Label 251: @11173
     /*  11173 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11229), // Rule ID 1058 //
     /*  11178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11197 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11200 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11216 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11227 */     GIR_RootConstrainSelectedInstOperands,
     /*  11228 */     // GIR_Coverage, 1058,
     /*  11228 */     GIR_EraseRootFromParent_Done,
     /*  11229 */   // Label 252: @11229
     /*  11229 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11296), // Rule ID 2121 //
     /*  11234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11262 */     // MIs[1] imm
     /*  11262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11270 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11274 */     // MIs[2] Operand 1
     /*  11274 */     // No operand predicates
     /*  11274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11280 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11294 */     GIR_RootConstrainSelectedInstOperands,
     /*  11295 */     // GIR_Coverage, 2121,
     /*  11295 */     GIR_EraseRootFromParent_Done,
     /*  11296 */   // Label 253: @11296
     /*  11296 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11363), // Rule ID 2130 //
     /*  11301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11329 */     // MIs[1] imm
     /*  11329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11337 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11341 */     // MIs[2] Operand 1
     /*  11341 */     // No operand predicates
     /*  11341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11347 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11361 */     GIR_RootConstrainSelectedInstOperands,
     /*  11362 */     // GIR_Coverage, 2130,
     /*  11362 */     GIR_EraseRootFromParent_Done,
     /*  11363 */   // Label 254: @11363
     /*  11363 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11411), // Rule ID 13337 //
     /*  11368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11398 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11409 */     GIR_RootConstrainSelectedInstOperands,
     /*  11410 */     // GIR_Coverage, 13337,
     /*  11410 */     GIR_EraseRootFromParent_Done,
     /*  11411 */   // Label 255: @11411
     /*  11411 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11459), // Rule ID 13349 //
     /*  11416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11446 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11457 */     GIR_RootConstrainSelectedInstOperands,
     /*  11458 */     // GIR_Coverage, 13349,
     /*  11458 */     GIR_EraseRootFromParent_Done,
     /*  11459 */   // Label 256: @11459
     /*  11459 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11507), // Rule ID 996 //
     /*  11464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11494 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11505 */     GIR_RootConstrainSelectedInstOperands,
     /*  11506 */     // GIR_Coverage, 996,
     /*  11506 */     GIR_EraseRootFromParent_Done,
     /*  11507 */   // Label 257: @11507
     /*  11507 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11555), // Rule ID 1057 //
     /*  11512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11542 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11553 */     GIR_RootConstrainSelectedInstOperands,
     /*  11554 */     // GIR_Coverage, 1057,
     /*  11554 */     GIR_EraseRootFromParent_Done,
     /*  11555 */   // Label 258: @11555
     /*  11555 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11579), // Rule ID 94 //
     /*  11560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11572 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11577 */     GIR_RootConstrainSelectedInstOperands,
     /*  11578 */     // GIR_Coverage, 94,
     /*  11578 */     GIR_Done,
     /*  11579 */   // Label 259: @11579
     /*  11579 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11606), // Rule ID 1607 //
     /*  11584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11599 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11604 */     GIR_RootConstrainSelectedInstOperands,
     /*  11605 */     // GIR_Coverage, 1607,
     /*  11605 */     GIR_Done,
     /*  11606 */   // Label 260: @11606
     /*  11606 */   GIM_Reject,
     /*  11607 */ // Label 195: @11607
     /*  11607 */ GIM_Reject,
     /*  11608 */ // Label 157: @11608
     /*  11608 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(15215),
     /*  11613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11619 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11807), // Rule ID 6938 //
     /*  11624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11661 */     // MIs[2] Operand 2
     /*  11661 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11680 */     // MIs[3] Rn
     /*  11680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11685 */     // MIs[3] Operand 2
     /*  11685 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11704 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11708 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11712 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11716 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11720 */     // MIs[5] Rn
     /*  11720 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11725 */     // MIs[5] Operand 2
     /*  11725 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11736 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11740 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11744 */     // MIs[6] Rn
     /*  11744 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11749 */     // MIs[6] Operand 2
     /*  11749 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11760 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11762 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11806 */     // GIR_Coverage, 6938,
     /*  11806 */     GIR_EraseRootFromParent_Done,
     /*  11807 */   // Label 262: @11807
     /*  11807 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11995), // Rule ID 13963 //
     /*  11812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11849 */     // MIs[2] Operand 2
     /*  11849 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11868 */     // MIs[3] Rn
     /*  11868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11873 */     // MIs[3] Operand 2
     /*  11873 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11884 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11888 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11892 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11896 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11900 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11904 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11908 */     // MIs[5] Rn
     /*  11908 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11913 */     // MIs[5] Operand 2
     /*  11913 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11924 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11928 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11932 */     // MIs[6] Rn
     /*  11932 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11937 */     // MIs[6] Operand 2
     /*  11937 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11948 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11950 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11977 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11994 */     // GIR_Coverage, 13963,
     /*  11994 */     GIR_EraseRootFromParent_Done,
     /*  11995 */   // Label 263: @11995
     /*  11995 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12131), // Rule ID 5373 //
     /*  12000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12033 */     // MIs[1] Operand 2
     /*  12033 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12052 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12056 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12060 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12064 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12068 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12073 */     // MIs[3] Operand 2
     /*  12073 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12084 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12086 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12113 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12130 */     // GIR_Coverage, 5373,
     /*  12130 */     GIR_EraseRootFromParent_Done,
     /*  12131 */   // Label 264: @12131
     /*  12131 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12267), // Rule ID 5372 //
     /*  12136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12169 */     // MIs[1] Operand 2
     /*  12169 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12188 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12200 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12204 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12209 */     // MIs[3] Operand 2
     /*  12209 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12220 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12222 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12249 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12266 */     // GIR_Coverage, 5372,
     /*  12266 */     GIR_EraseRootFromParent_Done,
     /*  12267 */   // Label 265: @12267
     /*  12267 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12403), // Rule ID 5385 //
     /*  12272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12305 */     // MIs[1] Operand 2
     /*  12305 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12324 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12332 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12336 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12345 */     // MIs[3] Operand 2
     /*  12345 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12356 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12358 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12385 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12402 */     // GIR_Coverage, 5385,
     /*  12402 */     GIR_EraseRootFromParent_Done,
     /*  12403 */   // Label 266: @12403
     /*  12403 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12539), // Rule ID 5371 //
     /*  12408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12441 */     // MIs[1] Operand 2
     /*  12441 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12468 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12472 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12476 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12481 */     // MIs[3] Operand 2
     /*  12481 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12492 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12494 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12521 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12538 */     // GIR_Coverage, 5371,
     /*  12538 */     GIR_EraseRootFromParent_Done,
     /*  12539 */   // Label 267: @12539
     /*  12539 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12675), // Rule ID 5370 //
     /*  12544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12577 */     // MIs[1] Operand 2
     /*  12577 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12608 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12612 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12617 */     // MIs[3] Operand 2
     /*  12617 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12628 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12630 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12657 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12674 */     // GIR_Coverage, 5370,
     /*  12674 */     GIR_EraseRootFromParent_Done,
     /*  12675 */   // Label 268: @12675
     /*  12675 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12838), // Rule ID 13923 //
     /*  12680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12722 */     // MIs[1] Operand 2
     /*  12722 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12739 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12739 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12742 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12746 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12753 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12756 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12760 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12765 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12768 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12772 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12775 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12780 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12785 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12802 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12820 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12837 */     // GIR_Coverage, 13923,
     /*  12837 */     GIR_EraseRootFromParent_Done,
     /*  12838 */   // Label 269: @12838
     /*  12838 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(13001), // Rule ID 13920 //
     /*  12843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12885 */     // MIs[1] Operand 2
     /*  12885 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12902 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12902 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12905 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12909 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12919 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12923 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12928 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12935 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12983 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13000 */     // GIR_Coverage, 13920,
     /*  13000 */     GIR_EraseRootFromParent_Done,
     /*  13001 */   // Label 270: @13001
     /*  13001 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(13151), // Rule ID 13928 //
     /*  13006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13039 */     // MIs[1] Operand 2
     /*  13039 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13056 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13056 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13059 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13063 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13082 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13085 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13089 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13097 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13102 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13133 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13150 */     // GIR_Coverage, 13928,
     /*  13150 */     GIR_EraseRootFromParent_Done,
     /*  13151 */   // Label 271: @13151
     /*  13151 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13301), // Rule ID 13932 //
     /*  13156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13189 */     // MIs[1] Operand 2
     /*  13189 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13206 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13206 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13209 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13213 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13232 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13235 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13239 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13247 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13283 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13300 */     // GIR_Coverage, 13932,
     /*  13300 */     GIR_EraseRootFromParent_Done,
     /*  13301 */   // Label 272: @13301
     /*  13301 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13451), // Rule ID 13927 //
     /*  13306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13339 */     // MIs[1] Operand 2
     /*  13339 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13356 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13356 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13359 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13363 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13377 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13382 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13385 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13389 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13397 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13402 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13433 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13450 */     // GIR_Coverage, 13927,
     /*  13450 */     GIR_EraseRootFromParent_Done,
     /*  13451 */   // Label 273: @13451
     /*  13451 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13614), // Rule ID 5358 //
     /*  13456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13502 */     // MIs[1] Operand 2
     /*  13502 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13515 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13515 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13518 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13522 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13529 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13532 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13536 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13541 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13544 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13548 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13596 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13613 */     // GIR_Coverage, 5358,
     /*  13613 */     GIR_EraseRootFromParent_Done,
     /*  13614 */   // Label 274: @13614
     /*  13614 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13777), // Rule ID 5355 //
     /*  13619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13665 */     // MIs[1] Operand 2
     /*  13665 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13678 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13678 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13681 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13685 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13692 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13695 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13699 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13704 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13711 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13741 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13759 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13776 */     // GIR_Coverage, 5355,
     /*  13776 */     GIR_EraseRootFromParent_Done,
     /*  13777 */   // Label 275: @13777
     /*  13777 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13927), // Rule ID 5381 //
     /*  13782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13819 */     // MIs[1] Operand 2
     /*  13819 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13832 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13832 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13835 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13839 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13858 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13861 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13865 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13926 */     // GIR_Coverage, 5381,
     /*  13926 */     GIR_EraseRootFromParent_Done,
     /*  13927 */   // Label 276: @13927
     /*  13927 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(14077), // Rule ID 5388 //
     /*  13932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13969 */     // MIs[1] Operand 2
     /*  13969 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13982 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13982 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13985 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13989 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13996 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13999 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14003 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14008 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14015 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14018 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14028 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14045 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14059 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14076 */     // GIR_Coverage, 5388,
     /*  14076 */     GIR_EraseRootFromParent_Done,
     /*  14077 */   // Label 277: @14077
     /*  14077 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(14227), // Rule ID 5380 //
     /*  14082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14119 */     // MIs[1] Operand 2
     /*  14119 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14132 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14158 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14161 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14165 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14178 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14195 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14209 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14226 */     // GIR_Coverage, 5380,
     /*  14226 */     GIR_EraseRootFromParent_Done,
     /*  14227 */   // Label 278: @14227
     /*  14227 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14296), // Rule ID 13372 //
     /*  14232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14247 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14250 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14279 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14294 */     GIR_RootConstrainSelectedInstOperands,
     /*  14295 */     // GIR_Coverage, 13372,
     /*  14295 */     GIR_EraseRootFromParent_Done,
     /*  14296 */   // Label 279: @14296
     /*  14296 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14365), // Rule ID 13384 //
     /*  14301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14316 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14319 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14328 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14348 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14363 */     GIR_RootConstrainSelectedInstOperands,
     /*  14364 */     // GIR_Coverage, 13384,
     /*  14364 */     GIR_EraseRootFromParent_Done,
     /*  14365 */   // Label 280: @14365
     /*  14365 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14421), // Rule ID 13334 //
     /*  14370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14385 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14388 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14408 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14419 */     GIR_RootConstrainSelectedInstOperands,
     /*  14420 */     // GIR_Coverage, 13334,
     /*  14420 */     GIR_EraseRootFromParent_Done,
     /*  14421 */   // Label 281: @14421
     /*  14421 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14477), // Rule ID 13346 //
     /*  14426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14441 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14444 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14464 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14475 */     GIR_RootConstrainSelectedInstOperands,
     /*  14476 */     // GIR_Coverage, 13346,
     /*  14476 */     GIR_EraseRootFromParent_Done,
     /*  14477 */   // Label 282: @14477
     /*  14477 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14544), // Rule ID 13576 //
     /*  14482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14506 */     // MIs[1] imm
     /*  14506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14518 */     // MIs[2] Operand 1
     /*  14518 */     // No operand predicates
     /*  14518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14528 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14542 */     GIR_RootConstrainSelectedInstOperands,
     /*  14543 */     // GIR_Coverage, 13576,
     /*  14543 */     GIR_EraseRootFromParent_Done,
     /*  14544 */   // Label 283: @14544
     /*  14544 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14611), // Rule ID 13597 //
     /*  14549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14573 */     // MIs[1] imm
     /*  14573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14585 */     // MIs[2] Operand 1
     /*  14585 */     // No operand predicates
     /*  14585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14595 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14609 */     GIR_RootConstrainSelectedInstOperands,
     /*  14610 */     // GIR_Coverage, 13597,
     /*  14610 */     GIR_EraseRootFromParent_Done,
     /*  14611 */   // Label 284: @14611
     /*  14611 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14680), // Rule ID 1365 //
     /*  14616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14635 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14638 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14663 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14678 */     GIR_RootConstrainSelectedInstOperands,
     /*  14679 */     // GIR_Coverage, 1365,
     /*  14679 */     GIR_EraseRootFromParent_Done,
     /*  14680 */   // Label 285: @14680
     /*  14680 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14749), // Rule ID 1488 //
     /*  14685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14704 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14707 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14732 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14747 */     GIR_RootConstrainSelectedInstOperands,
     /*  14748 */     // GIR_Coverage, 1488,
     /*  14748 */     GIR_EraseRootFromParent_Done,
     /*  14749 */   // Label 286: @14749
     /*  14749 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14805), // Rule ID 993 //
     /*  14754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14773 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14776 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14792 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14803 */     GIR_RootConstrainSelectedInstOperands,
     /*  14804 */     // GIR_Coverage, 993,
     /*  14804 */     GIR_EraseRootFromParent_Done,
     /*  14805 */   // Label 287: @14805
     /*  14805 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14861), // Rule ID 1054 //
     /*  14810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14829 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14832 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14848 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14859 */     GIR_RootConstrainSelectedInstOperands,
     /*  14860 */     // GIR_Coverage, 1054,
     /*  14860 */     GIR_EraseRootFromParent_Done,
     /*  14861 */   // Label 288: @14861
     /*  14861 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14928), // Rule ID 2238 //
     /*  14866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14894 */     // MIs[1] imm
     /*  14894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14906 */     // MIs[2] Operand 1
     /*  14906 */     // No operand predicates
     /*  14906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14912 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14926 */     GIR_RootConstrainSelectedInstOperands,
     /*  14927 */     // GIR_Coverage, 2238,
     /*  14927 */     GIR_EraseRootFromParent_Done,
     /*  14928 */   // Label 289: @14928
     /*  14928 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14995), // Rule ID 2297 //
     /*  14933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14961 */     // MIs[1] imm
     /*  14961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14969 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14973 */     // MIs[2] Operand 1
     /*  14973 */     // No operand predicates
     /*  14973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14979 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14993 */     GIR_RootConstrainSelectedInstOperands,
     /*  14994 */     // GIR_Coverage, 2297,
     /*  14994 */     GIR_EraseRootFromParent_Done,
     /*  14995 */   // Label 290: @14995
     /*  14995 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15043), // Rule ID 13333 //
     /*  15000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15030 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15041 */     GIR_RootConstrainSelectedInstOperands,
     /*  15042 */     // GIR_Coverage, 13333,
     /*  15042 */     GIR_EraseRootFromParent_Done,
     /*  15043 */   // Label 291: @15043
     /*  15043 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15091), // Rule ID 13345 //
     /*  15048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15078 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15089 */     GIR_RootConstrainSelectedInstOperands,
     /*  15090 */     // GIR_Coverage, 13345,
     /*  15090 */     GIR_EraseRootFromParent_Done,
     /*  15091 */   // Label 292: @15091
     /*  15091 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15139), // Rule ID 992 //
     /*  15096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15126 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15137 */     GIR_RootConstrainSelectedInstOperands,
     /*  15138 */     // GIR_Coverage, 992,
     /*  15138 */     GIR_EraseRootFromParent_Done,
     /*  15139 */   // Label 293: @15139
     /*  15139 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15187), // Rule ID 1053 //
     /*  15144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15174 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15185 */     GIR_RootConstrainSelectedInstOperands,
     /*  15186 */     // GIR_Coverage, 1053,
     /*  15186 */     GIR_EraseRootFromParent_Done,
     /*  15187 */   // Label 294: @15187
     /*  15187 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15214), // Rule ID 1104 //
     /*  15192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15207 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15212 */     GIR_RootConstrainSelectedInstOperands,
     /*  15213 */     // GIR_Coverage, 1104,
     /*  15213 */     GIR_Done,
     /*  15214 */   // Label 295: @15214
     /*  15214 */   GIM_Reject,
     /*  15215 */ // Label 261: @15215
     /*  15215 */ GIM_Reject,
     /*  15216 */ // Label 158: @15216
     /*  15216 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(21117),
     /*  15221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15227 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15345), // Rule ID 13511 //
     /*  15232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15275 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15279 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15283 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15288 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15292 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15296 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15300 */     // MIs[4] Operand 1
     /*  15300 */     // No operand predicates
     /*  15300 */     // MIs[2] Operand 2
     /*  15300 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15315 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15324 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15343 */     GIR_RootConstrainSelectedInstOperands,
     /*  15344 */     // GIR_Coverage, 13511,
     /*  15344 */     GIR_EraseRootFromParent_Done,
     /*  15345 */   // Label 297: @15345
     /*  15345 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15463), // Rule ID 13512 //
     /*  15350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15393 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15397 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15401 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15410 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15414 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15418 */     // MIs[4] Operand 1
     /*  15418 */     // No operand predicates
     /*  15418 */     // MIs[2] Operand 2
     /*  15418 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15433 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15442 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15461 */     GIR_RootConstrainSelectedInstOperands,
     /*  15462 */     // GIR_Coverage, 13512,
     /*  15462 */     GIR_EraseRootFromParent_Done,
     /*  15463 */   // Label 298: @15463
     /*  15463 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15581), // Rule ID 13541 //
     /*  15468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15511 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15515 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15519 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15524 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15528 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15532 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15536 */     // MIs[4] Operand 1
     /*  15536 */     // No operand predicates
     /*  15536 */     // MIs[2] Operand 2
     /*  15536 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15551 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15560 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15579 */     GIR_RootConstrainSelectedInstOperands,
     /*  15580 */     // GIR_Coverage, 13541,
     /*  15580 */     GIR_EraseRootFromParent_Done,
     /*  15581 */   // Label 299: @15581
     /*  15581 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15699), // Rule ID 13542 //
     /*  15586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15629 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15633 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15637 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15650 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15654 */     // MIs[4] Operand 1
     /*  15654 */     // No operand predicates
     /*  15654 */     // MIs[2] Operand 2
     /*  15654 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15669 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15678 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15697 */     GIR_RootConstrainSelectedInstOperands,
     /*  15698 */     // GIR_Coverage, 13542,
     /*  15698 */     GIR_EraseRootFromParent_Done,
     /*  15699 */   // Label 300: @15699
     /*  15699 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15817), // Rule ID 2042 //
     /*  15704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15751 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15755 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15759 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15764 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15768 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15772 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15776 */     // MIs[4] Operand 1
     /*  15776 */     // No operand predicates
     /*  15776 */     // MIs[2] Operand 2
     /*  15776 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15787 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15796 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15815 */     GIR_RootConstrainSelectedInstOperands,
     /*  15816 */     // GIR_Coverage, 2042,
     /*  15816 */     GIR_EraseRootFromParent_Done,
     /*  15817 */   // Label 301: @15817
     /*  15817 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15935), // Rule ID 13510 //
     /*  15822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15869 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15873 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15877 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15882 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15886 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15890 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15894 */     // MIs[4] Operand 1
     /*  15894 */     // No operand predicates
     /*  15894 */     // MIs[2] Operand 2
     /*  15894 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15905 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15914 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15933 */     GIR_RootConstrainSelectedInstOperands,
     /*  15934 */     // GIR_Coverage, 13510,
     /*  15934 */     GIR_EraseRootFromParent_Done,
     /*  15935 */   // Label 302: @15935
     /*  15935 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(16053), // Rule ID 2094 //
     /*  15940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15987 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15991 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15995 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16008 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16012 */     // MIs[4] Operand 1
     /*  16012 */     // No operand predicates
     /*  16012 */     // MIs[2] Operand 2
     /*  16012 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16023 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16032 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16051 */     GIR_RootConstrainSelectedInstOperands,
     /*  16052 */     // GIR_Coverage, 2094,
     /*  16052 */     GIR_EraseRootFromParent_Done,
     /*  16053 */   // Label 303: @16053
     /*  16053 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16171), // Rule ID 13540 //
     /*  16058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16109 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16113 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16122 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16126 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16130 */     // MIs[4] Operand 1
     /*  16130 */     // No operand predicates
     /*  16130 */     // MIs[2] Operand 2
     /*  16130 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16141 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16150 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16169 */     GIR_RootConstrainSelectedInstOperands,
     /*  16170 */     // GIR_Coverage, 13540,
     /*  16170 */     GIR_EraseRootFromParent_Done,
     /*  16171 */   // Label 304: @16171
     /*  16171 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16258), // Rule ID 13416 //
     /*  16176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16203 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16206 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16215 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16232 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16239 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16256 */     GIR_RootConstrainSelectedInstOperands,
     /*  16257 */     // GIR_Coverage, 13416,
     /*  16257 */     GIR_EraseRootFromParent_Done,
     /*  16258 */   // Label 305: @16258
     /*  16258 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16345), // Rule ID 13440 //
     /*  16263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16290 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16293 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16302 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16326 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16343 */     GIR_RootConstrainSelectedInstOperands,
     /*  16344 */     // GIR_Coverage, 13440,
     /*  16344 */     GIR_EraseRootFromParent_Done,
     /*  16345 */   // Label 306: @16345
     /*  16345 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16432), // Rule ID 1699 //
     /*  16350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16381 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16384 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16393 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16413 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16430 */     GIR_RootConstrainSelectedInstOperands,
     /*  16431 */     // GIR_Coverage, 1699,
     /*  16431 */     GIR_EraseRootFromParent_Done,
     /*  16432 */   // Label 307: @16432
     /*  16432 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16519), // Rule ID 1777 //
     /*  16437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16468 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16471 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16480 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16500 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16517 */     GIR_RootConstrainSelectedInstOperands,
     /*  16518 */     // GIR_Coverage, 1777,
     /*  16518 */     GIR_EraseRootFromParent_Done,
     /*  16519 */   // Label 308: @16519
     /*  16519 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16634), // Rule ID 13506 //
     /*  16524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16567 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16575 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16584 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16588 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16592 */     // MIs[4] Operand 1
     /*  16592 */     // No operand predicates
     /*  16592 */     // MIs[2] Operand 2
     /*  16592 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16612 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16614 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16632 */     GIR_RootConstrainSelectedInstOperands,
     /*  16633 */     // GIR_Coverage, 13506,
     /*  16633 */     GIR_EraseRootFromParent_Done,
     /*  16634 */   // Label 309: @16634
     /*  16634 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16749), // Rule ID 13505 //
     /*  16639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16687 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16691 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16695 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16700 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16704 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16708 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16712 */     // MIs[4] Operand 1
     /*  16712 */     // No operand predicates
     /*  16712 */     // MIs[2] Operand 2
     /*  16712 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16727 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16729 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16747 */     GIR_RootConstrainSelectedInstOperands,
     /*  16748 */     // GIR_Coverage, 13505,
     /*  16748 */     GIR_EraseRootFromParent_Done,
     /*  16749 */   // Label 310: @16749
     /*  16749 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16864), // Rule ID 13536 //
     /*  16754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16797 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16801 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16805 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16818 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16822 */     // MIs[4] Operand 1
     /*  16822 */     // No operand predicates
     /*  16822 */     // MIs[2] Operand 2
     /*  16822 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16842 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16844 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16862 */     GIR_RootConstrainSelectedInstOperands,
     /*  16863 */     // GIR_Coverage, 13536,
     /*  16863 */     GIR_EraseRootFromParent_Done,
     /*  16864 */   // Label 311: @16864
     /*  16864 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16979), // Rule ID 13535 //
     /*  16869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16917 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16921 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16925 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16930 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16934 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16938 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16942 */     // MIs[4] Operand 1
     /*  16942 */     // No operand predicates
     /*  16942 */     // MIs[2] Operand 2
     /*  16942 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16957 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16959 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16977 */     GIR_RootConstrainSelectedInstOperands,
     /*  16978 */     // GIR_Coverage, 13535,
     /*  16978 */     GIR_EraseRootFromParent_Done,
     /*  16979 */   // Label 312: @16979
     /*  16979 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17048), // Rule ID 1801 //
     /*  16984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  16999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17031 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17046 */     GIR_RootConstrainSelectedInstOperands,
     /*  17047 */     // GIR_Coverage, 1801,
     /*  17047 */     GIR_EraseRootFromParent_Done,
     /*  17048 */   // Label 313: @17048
     /*  17048 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17117), // Rule ID 1800 //
     /*  17053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17100 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17115 */     GIR_RootConstrainSelectedInstOperands,
     /*  17116 */     // GIR_Coverage, 1800,
     /*  17116 */     GIR_EraseRootFromParent_Done,
     /*  17117 */   // Label 314: @17117
     /*  17117 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17186), // Rule ID 1717 //
     /*  17122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17169 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17184 */     GIR_RootConstrainSelectedInstOperands,
     /*  17185 */     // GIR_Coverage, 1717,
     /*  17185 */     GIR_EraseRootFromParent_Done,
     /*  17186 */   // Label 315: @17186
     /*  17186 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17255), // Rule ID 1799 //
     /*  17191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17238 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17253 */     GIR_RootConstrainSelectedInstOperands,
     /*  17254 */     // GIR_Coverage, 1799,
     /*  17254 */     GIR_EraseRootFromParent_Done,
     /*  17255 */   // Label 316: @17255
     /*  17255 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17324), // Rule ID 1798 //
     /*  17260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17307 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17322 */     GIR_RootConstrainSelectedInstOperands,
     /*  17323 */     // GIR_Coverage, 1798,
     /*  17323 */     GIR_EraseRootFromParent_Done,
     /*  17324 */   // Label 317: @17324
     /*  17324 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17439), // Rule ID 13504 //
     /*  17329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17380 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17384 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17389 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17393 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17397 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17401 */     // MIs[4] Operand 1
     /*  17401 */     // No operand predicates
     /*  17401 */     // MIs[2] Operand 2
     /*  17401 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17417 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17419 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17437 */     GIR_RootConstrainSelectedInstOperands,
     /*  17438 */     // GIR_Coverage, 13504,
     /*  17438 */     GIR_EraseRootFromParent_Done,
     /*  17439 */   // Label 318: @17439
     /*  17439 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17554), // Rule ID 2040 //
     /*  17444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17496 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17500 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17504 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17509 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17513 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17517 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17521 */     // MIs[4] Operand 1
     /*  17521 */     // No operand predicates
     /*  17521 */     // MIs[2] Operand 2
     /*  17521 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17532 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17534 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17552 */     GIR_RootConstrainSelectedInstOperands,
     /*  17553 */     // GIR_Coverage, 2040,
     /*  17553 */     GIR_EraseRootFromParent_Done,
     /*  17554 */   // Label 319: @17554
     /*  17554 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17669), // Rule ID 13534 //
     /*  17559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17610 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17614 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17619 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17623 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17627 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17631 */     // MIs[4] Operand 1
     /*  17631 */     // No operand predicates
     /*  17631 */     // MIs[2] Operand 2
     /*  17631 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17647 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17649 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17667 */     GIR_RootConstrainSelectedInstOperands,
     /*  17668 */     // GIR_Coverage, 13534,
     /*  17668 */     GIR_EraseRootFromParent_Done,
     /*  17669 */   // Label 320: @17669
     /*  17669 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17784), // Rule ID 2092 //
     /*  17674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17730 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17734 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17739 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17743 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17747 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17751 */     // MIs[4] Operand 1
     /*  17751 */     // No operand predicates
     /*  17751 */     // MIs[2] Operand 2
     /*  17751 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17762 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17764 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17782 */     GIR_RootConstrainSelectedInstOperands,
     /*  17783 */     // GIR_Coverage, 2092,
     /*  17783 */     GIR_EraseRootFromParent_Done,
     /*  17784 */   // Label 321: @17784
     /*  17784 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17851), // Rule ID 13428 //
     /*  17789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17832 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17849 */     GIR_RootConstrainSelectedInstOperands,
     /*  17850 */     // GIR_Coverage, 13428,
     /*  17850 */     GIR_EraseRootFromParent_Done,
     /*  17851 */   // Label 322: @17851
     /*  17851 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17918), // Rule ID 13458 //
     /*  17856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17899 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17916 */     GIR_RootConstrainSelectedInstOperands,
     /*  17917 */     // GIR_Coverage, 13458,
     /*  17917 */     GIR_EraseRootFromParent_Done,
     /*  17918 */   // Label 323: @17918
     /*  17918 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17985), // Rule ID 1729 //
     /*  17923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17966 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17983 */     GIR_RootConstrainSelectedInstOperands,
     /*  17984 */     // GIR_Coverage, 1729,
     /*  17984 */     GIR_EraseRootFromParent_Done,
     /*  17985 */   // Label 324: @17985
     /*  17985 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18052), // Rule ID 1819 //
     /*  17990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18033 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18050 */     GIR_RootConstrainSelectedInstOperands,
     /*  18051 */     // GIR_Coverage, 1819,
     /*  18051 */     GIR_EraseRootFromParent_Done,
     /*  18052 */   // Label 325: @18052
     /*  18052 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18133), // Rule ID 13414 //
     /*  18057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18084 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18087 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18096 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18116 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18131 */     GIR_RootConstrainSelectedInstOperands,
     /*  18132 */     // GIR_Coverage, 13414,
     /*  18132 */     GIR_EraseRootFromParent_Done,
     /*  18133 */   // Label 326: @18133
     /*  18133 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18214), // Rule ID 13438 //
     /*  18138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18165 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18168 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18177 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18197 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18212 */     GIR_RootConstrainSelectedInstOperands,
     /*  18213 */     // GIR_Coverage, 13438,
     /*  18213 */     GIR_EraseRootFromParent_Done,
     /*  18214 */   // Label 327: @18214
     /*  18214 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18295), // Rule ID 1697 //
     /*  18219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18250 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18253 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18262 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18278 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18293 */     GIR_RootConstrainSelectedInstOperands,
     /*  18294 */     // GIR_Coverage, 1697,
     /*  18294 */     GIR_EraseRootFromParent_Done,
     /*  18295 */   // Label 328: @18295
     /*  18295 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18376), // Rule ID 1775 //
     /*  18300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18331 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18334 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18343 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18359 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18374 */     GIR_RootConstrainSelectedInstOperands,
     /*  18375 */     // GIR_Coverage, 1775,
     /*  18375 */     GIR_EraseRootFromParent_Done,
     /*  18376 */   // Label 329: @18376
     /*  18376 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18468), // Rule ID 13509 //
     /*  18381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18433 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18437 */     // MIs[3] Operand 1
     /*  18437 */     // No operand predicates
     /*  18437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18448 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18466 */     GIR_RootConstrainSelectedInstOperands,
     /*  18467 */     // GIR_Coverage, 13509,
     /*  18467 */     GIR_EraseRootFromParent_Done,
     /*  18468 */   // Label 330: @18468
     /*  18468 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18560), // Rule ID 13508 //
     /*  18473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18530 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18534 */     // MIs[3] Operand 1
     /*  18534 */     // No operand predicates
     /*  18534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18540 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18558 */     GIR_RootConstrainSelectedInstOperands,
     /*  18559 */     // GIR_Coverage, 13508,
     /*  18559 */     GIR_EraseRootFromParent_Done,
     /*  18560 */   // Label 331: @18560
     /*  18560 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18652), // Rule ID 13539 //
     /*  18565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18617 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18621 */     // MIs[3] Operand 1
     /*  18621 */     // No operand predicates
     /*  18621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18632 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18650 */     GIR_RootConstrainSelectedInstOperands,
     /*  18651 */     // GIR_Coverage, 13539,
     /*  18651 */     GIR_EraseRootFromParent_Done,
     /*  18652 */   // Label 332: @18652
     /*  18652 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18744), // Rule ID 13538 //
     /*  18657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18714 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18718 */     // MIs[3] Operand 1
     /*  18718 */     // No operand predicates
     /*  18718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18724 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18742 */     GIR_RootConstrainSelectedInstOperands,
     /*  18743 */     // GIR_Coverage, 13538,
     /*  18743 */     GIR_EraseRootFromParent_Done,
     /*  18744 */   // Label 333: @18744
     /*  18744 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18836), // Rule ID 13507 //
     /*  18749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18805 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18809 */     // MIs[3] Operand 1
     /*  18809 */     // No operand predicates
     /*  18809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18816 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18834 */     GIR_RootConstrainSelectedInstOperands,
     /*  18835 */     // GIR_Coverage, 13507,
     /*  18835 */     GIR_EraseRootFromParent_Done,
     /*  18836 */   // Label 334: @18836
     /*  18836 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18928), // Rule ID 2041 //
     /*  18841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18902 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18906 */     // MIs[3] Operand 1
     /*  18906 */     // No operand predicates
     /*  18906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18908 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18926 */     GIR_RootConstrainSelectedInstOperands,
     /*  18927 */     // GIR_Coverage, 2041,
     /*  18927 */     GIR_EraseRootFromParent_Done,
     /*  18928 */   // Label 335: @18928
     /*  18928 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19020), // Rule ID 13537 //
     /*  18933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18993 */     // MIs[3] Operand 1
     /*  18993 */     // No operand predicates
     /*  18993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19000 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19018 */     GIR_RootConstrainSelectedInstOperands,
     /*  19019 */     // GIR_Coverage, 13537,
     /*  19019 */     GIR_EraseRootFromParent_Done,
     /*  19020 */   // Label 336: @19020
     /*  19020 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19112), // Rule ID 2093 //
     /*  19025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19090 */     // MIs[3] Operand 1
     /*  19090 */     // No operand predicates
     /*  19090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19092 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19110 */     GIR_RootConstrainSelectedInstOperands,
     /*  19111 */     // GIR_Coverage, 2093,
     /*  19111 */     GIR_EraseRootFromParent_Done,
     /*  19112 */   // Label 337: @19112
     /*  19112 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19163), // Rule ID 13452 //
     /*  19117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19149 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19161 */     GIR_RootConstrainSelectedInstOperands,
     /*  19162 */     // GIR_Coverage, 13452,
     /*  19162 */     GIR_EraseRootFromParent_Done,
     /*  19163 */   // Label 338: @19163
     /*  19163 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19214), // Rule ID 13422 //
     /*  19168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19200 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19212 */     GIR_RootConstrainSelectedInstOperands,
     /*  19213 */     // GIR_Coverage, 13422,
     /*  19213 */     GIR_EraseRootFromParent_Done,
     /*  19214 */   // Label 339: @19214
     /*  19214 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19265), // Rule ID 13451 //
     /*  19219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19251 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19263 */     GIR_RootConstrainSelectedInstOperands,
     /*  19264 */     // GIR_Coverage, 13451,
     /*  19264 */     GIR_EraseRootFromParent_Done,
     /*  19265 */   // Label 340: @19265
     /*  19265 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19316), // Rule ID 1813 //
     /*  19270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19302 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19314 */     GIR_RootConstrainSelectedInstOperands,
     /*  19315 */     // GIR_Coverage, 1813,
     /*  19315 */     GIR_EraseRootFromParent_Done,
     /*  19316 */   // Label 341: @19316
     /*  19316 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19367), // Rule ID 1723 //
     /*  19321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19353 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19365 */     GIR_RootConstrainSelectedInstOperands,
     /*  19366 */     // GIR_Coverage, 1723,
     /*  19366 */     GIR_EraseRootFromParent_Done,
     /*  19367 */   // Label 342: @19367
     /*  19367 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19418), // Rule ID 1812 //
     /*  19372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19404 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19416 */     GIR_RootConstrainSelectedInstOperands,
     /*  19417 */     // GIR_Coverage, 1812,
     /*  19417 */     GIR_EraseRootFromParent_Done,
     /*  19418 */   // Label 343: @19418
     /*  19418 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19474), // Rule ID 13340 //
     /*  19423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19438 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19441 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19461 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19472 */     GIR_RootConstrainSelectedInstOperands,
     /*  19473 */     // GIR_Coverage, 13340,
     /*  19473 */     GIR_EraseRootFromParent_Done,
     /*  19474 */   // Label 344: @19474
     /*  19474 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19530), // Rule ID 13352 //
     /*  19479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19494 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19497 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19517 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19528 */     GIR_RootConstrainSelectedInstOperands,
     /*  19529 */     // GIR_Coverage, 13352,
     /*  19529 */     GIR_EraseRootFromParent_Done,
     /*  19530 */   // Label 345: @19530
     /*  19530 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19597), // Rule ID 13580 //
     /*  19535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19559 */     // MIs[1] imm
     /*  19559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19571 */     // MIs[2] Operand 1
     /*  19571 */     // No operand predicates
     /*  19571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19581 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19595 */     GIR_RootConstrainSelectedInstOperands,
     /*  19596 */     // GIR_Coverage, 13580,
     /*  19596 */     GIR_EraseRootFromParent_Done,
     /*  19597 */   // Label 346: @19597
     /*  19597 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19664), // Rule ID 13601 //
     /*  19602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19626 */     // MIs[1] imm
     /*  19626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19634 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19638 */     // MIs[2] Operand 1
     /*  19638 */     // No operand predicates
     /*  19638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19648 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19662 */     GIR_RootConstrainSelectedInstOperands,
     /*  19663 */     // GIR_Coverage, 13601,
     /*  19663 */     GIR_EraseRootFromParent_Done,
     /*  19664 */   // Label 347: @19664
     /*  19664 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19720), // Rule ID 999 //
     /*  19669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19688 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19691 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19707 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19718 */     GIR_RootConstrainSelectedInstOperands,
     /*  19719 */     // GIR_Coverage, 999,
     /*  19719 */     GIR_EraseRootFromParent_Done,
     /*  19720 */   // Label 348: @19720
     /*  19720 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19776), // Rule ID 1060 //
     /*  19725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19744 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19747 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19763 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19774 */     GIR_RootConstrainSelectedInstOperands,
     /*  19775 */     // GIR_Coverage, 1060,
     /*  19775 */     GIR_EraseRootFromParent_Done,
     /*  19776 */   // Label 349: @19776
     /*  19776 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19843), // Rule ID 2242 //
     /*  19781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19809 */     // MIs[1] imm
     /*  19809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19817 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19821 */     // MIs[2] Operand 1
     /*  19821 */     // No operand predicates
     /*  19821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19827 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19841 */     GIR_RootConstrainSelectedInstOperands,
     /*  19842 */     // GIR_Coverage, 2242,
     /*  19842 */     GIR_EraseRootFromParent_Done,
     /*  19843 */   // Label 350: @19843
     /*  19843 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19910), // Rule ID 2301 //
     /*  19848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19876 */     // MIs[1] imm
     /*  19876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19888 */     // MIs[2] Operand 1
     /*  19888 */     // No operand predicates
     /*  19888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19894 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19908 */     GIR_RootConstrainSelectedInstOperands,
     /*  19909 */     // GIR_Coverage, 2301,
     /*  19909 */     GIR_EraseRootFromParent_Done,
     /*  19910 */   // Label 351: @19910
     /*  19910 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19980), // Rule ID 6934 //
     /*  19915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19953 */     // MIs[2] Rn
     /*  19953 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19958 */     // MIs[2] Rm
     /*  19958 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19965 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19978 */     GIR_RootConstrainSelectedInstOperands,
     /*  19979 */     // GIR_Coverage, 6934,
     /*  19979 */     GIR_EraseRootFromParent_Done,
     /*  19980 */   // Label 352: @19980
     /*  19980 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20050), // Rule ID 13959 //
     /*  19985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20023 */     // MIs[2] Rn
     /*  20023 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20028 */     // MIs[2] Rm
     /*  20028 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20035 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20048 */     GIR_RootConstrainSelectedInstOperands,
     /*  20049 */     // GIR_Coverage, 13959,
     /*  20049 */     GIR_EraseRootFromParent_Done,
     /*  20050 */   // Label 353: @20050
     /*  20050 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20113), // Rule ID 1797 //
     /*  20055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20098 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20111 */     GIR_RootConstrainSelectedInstOperands,
     /*  20112 */     // GIR_Coverage, 1797,
     /*  20112 */     GIR_EraseRootFromParent_Done,
     /*  20113 */   // Label 354: @20113
     /*  20113 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20176), // Rule ID 1796 //
     /*  20118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20161 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20174 */     GIR_RootConstrainSelectedInstOperands,
     /*  20175 */     // GIR_Coverage, 1796,
     /*  20175 */     GIR_EraseRootFromParent_Done,
     /*  20176 */   // Label 355: @20176
     /*  20176 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20239), // Rule ID 1716 //
     /*  20181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20224 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20237 */     GIR_RootConstrainSelectedInstOperands,
     /*  20238 */     // GIR_Coverage, 1716,
     /*  20238 */     GIR_EraseRootFromParent_Done,
     /*  20239 */   // Label 356: @20239
     /*  20239 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20302), // Rule ID 1795 //
     /*  20244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20287 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20300 */     GIR_RootConstrainSelectedInstOperands,
     /*  20301 */     // GIR_Coverage, 1795,
     /*  20301 */     GIR_EraseRootFromParent_Done,
     /*  20302 */   // Label 357: @20302
     /*  20302 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20365), // Rule ID 1794 //
     /*  20307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20350 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20363 */     GIR_RootConstrainSelectedInstOperands,
     /*  20364 */     // GIR_Coverage, 1794,
     /*  20364 */     GIR_EraseRootFromParent_Done,
     /*  20365 */   // Label 358: @20365
     /*  20365 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20426), // Rule ID 13427 //
     /*  20370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20409 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20424 */     GIR_RootConstrainSelectedInstOperands,
     /*  20425 */     // GIR_Coverage, 13427,
     /*  20425 */     GIR_EraseRootFromParent_Done,
     /*  20426 */   // Label 359: @20426
     /*  20426 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20487), // Rule ID 13457 //
     /*  20431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20470 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20485 */     GIR_RootConstrainSelectedInstOperands,
     /*  20486 */     // GIR_Coverage, 13457,
     /*  20486 */     GIR_EraseRootFromParent_Done,
     /*  20487 */   // Label 360: @20487
     /*  20487 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20535), // Rule ID 13450 //
     /*  20492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20522 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20533 */     GIR_RootConstrainSelectedInstOperands,
     /*  20534 */     // GIR_Coverage, 13450,
     /*  20534 */     GIR_EraseRootFromParent_Done,
     /*  20535 */   // Label 361: @20535
     /*  20535 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20583), // Rule ID 13339 //
     /*  20540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20570 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20581 */     GIR_RootConstrainSelectedInstOperands,
     /*  20582 */     // GIR_Coverage, 13339,
     /*  20582 */     GIR_EraseRootFromParent_Done,
     /*  20583 */   // Label 362: @20583
     /*  20583 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20631), // Rule ID 13421 //
     /*  20588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20618 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20629 */     GIR_RootConstrainSelectedInstOperands,
     /*  20630 */     // GIR_Coverage, 13421,
     /*  20630 */     GIR_EraseRootFromParent_Done,
     /*  20631 */   // Label 363: @20631
     /*  20631 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20679), // Rule ID 13351 //
     /*  20636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20666 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20677 */     GIR_RootConstrainSelectedInstOperands,
     /*  20678 */     // GIR_Coverage, 13351,
     /*  20678 */     GIR_EraseRootFromParent_Done,
     /*  20679 */   // Label 364: @20679
     /*  20679 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20727), // Rule ID 13449 //
     /*  20684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20714 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20725 */     GIR_RootConstrainSelectedInstOperands,
     /*  20726 */     // GIR_Coverage, 13449,
     /*  20726 */     GIR_EraseRootFromParent_Done,
     /*  20727 */   // Label 365: @20727
     /*  20727 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20788), // Rule ID 1728 //
     /*  20732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20771 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20786 */     GIR_RootConstrainSelectedInstOperands,
     /*  20787 */     // GIR_Coverage, 1728,
     /*  20787 */     GIR_EraseRootFromParent_Done,
     /*  20788 */   // Label 366: @20788
     /*  20788 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20849), // Rule ID 1818 //
     /*  20793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20832 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20847 */     GIR_RootConstrainSelectedInstOperands,
     /*  20848 */     // GIR_Coverage, 1818,
     /*  20848 */     GIR_EraseRootFromParent_Done,
     /*  20849 */   // Label 367: @20849
     /*  20849 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20897), // Rule ID 1811 //
     /*  20854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20884 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20895 */     GIR_RootConstrainSelectedInstOperands,
     /*  20896 */     // GIR_Coverage, 1811,
     /*  20896 */     GIR_EraseRootFromParent_Done,
     /*  20897 */   // Label 368: @20897
     /*  20897 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20945), // Rule ID 998 //
     /*  20902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20932 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20943 */     GIR_RootConstrainSelectedInstOperands,
     /*  20944 */     // GIR_Coverage, 998,
     /*  20944 */     GIR_EraseRootFromParent_Done,
     /*  20945 */   // Label 369: @20945
     /*  20945 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20993), // Rule ID 1722 //
     /*  20950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20980 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20991 */     GIR_RootConstrainSelectedInstOperands,
     /*  20992 */     // GIR_Coverage, 1722,
     /*  20992 */     GIR_EraseRootFromParent_Done,
     /*  20993 */   // Label 370: @20993
     /*  20993 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21041), // Rule ID 1059 //
     /*  20998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21028 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21039 */     GIR_RootConstrainSelectedInstOperands,
     /*  21040 */     // GIR_Coverage, 1059,
     /*  21040 */     GIR_EraseRootFromParent_Done,
     /*  21041 */   // Label 371: @21041
     /*  21041 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21089), // Rule ID 1810 //
     /*  21046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21076 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21087 */     GIR_RootConstrainSelectedInstOperands,
     /*  21088 */     // GIR_Coverage, 1810,
     /*  21088 */     GIR_EraseRootFromParent_Done,
     /*  21089 */   // Label 372: @21089
     /*  21089 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21116), // Rule ID 1106 //
     /*  21094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21109 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21114 */     GIR_RootConstrainSelectedInstOperands,
     /*  21115 */     // GIR_Coverage, 1106,
     /*  21115 */     GIR_Done,
     /*  21116 */   // Label 373: @21116
     /*  21116 */   GIM_Reject,
     /*  21117 */ // Label 296: @21117
     /*  21117 */ GIM_Reject,
     /*  21118 */ // Label 159: @21118
     /*  21118 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(24615),
     /*  21123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21129 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21265), // Rule ID 5369 //
     /*  21134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21167 */     // MIs[1] Operand 2
     /*  21167 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21194 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21198 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21202 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21207 */     // MIs[3] Operand 2
     /*  21207 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21218 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21220 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21247 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21264 */     // GIR_Coverage, 5369,
     /*  21264 */     GIR_EraseRootFromParent_Done,
     /*  21265 */   // Label 375: @21265
     /*  21265 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21401), // Rule ID 5368 //
     /*  21270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21303 */     // MIs[1] Operand 2
     /*  21303 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21326 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21330 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21334 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21338 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21343 */     // MIs[3] Operand 2
     /*  21343 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21354 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21356 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21383 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21400 */     // GIR_Coverage, 5368,
     /*  21400 */     GIR_EraseRootFromParent_Done,
     /*  21401 */   // Label 376: @21401
     /*  21401 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21537), // Rule ID 5384 //
     /*  21406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21439 */     // MIs[1] Operand 2
     /*  21439 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21458 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21462 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21466 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21470 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21474 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21479 */     // MIs[3] Operand 2
     /*  21479 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21490 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21492 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21519 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21536 */     // GIR_Coverage, 5384,
     /*  21536 */     GIR_EraseRootFromParent_Done,
     /*  21537 */   // Label 377: @21537
     /*  21537 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21673), // Rule ID 5367 //
     /*  21542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21575 */     // MIs[1] Operand 2
     /*  21575 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21602 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21606 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21610 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21615 */     // MIs[3] Operand 2
     /*  21615 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21626 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21628 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21655 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21672 */     // GIR_Coverage, 5367,
     /*  21672 */     GIR_EraseRootFromParent_Done,
     /*  21673 */   // Label 378: @21673
     /*  21673 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21809), // Rule ID 5366 //
     /*  21678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21711 */     // MIs[1] Operand 2
     /*  21711 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21730 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21734 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21738 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21742 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21746 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21751 */     // MIs[3] Operand 2
     /*  21751 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21762 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21764 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21791 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21803 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21808 */     // GIR_Coverage, 5366,
     /*  21808 */     GIR_EraseRootFromParent_Done,
     /*  21809 */   // Label 379: @21809
     /*  21809 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21942), // Rule ID 13964 //
     /*  21814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21859 */     // MIs[1] Operand 2
     /*  21859 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21870 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21874 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21878 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21882 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21886 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21890 */     // MIs[5] Rn
     /*  21890 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21895 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21897 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21924 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21941 */     // GIR_Coverage, 13964,
     /*  21941 */     GIR_EraseRootFromParent_Done,
     /*  21942 */   // Label 380: @21942
     /*  21942 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22075), // Rule ID 6939 //
     /*  21947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22000 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22004 */     // MIs[4] Rn
     /*  22004 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22009 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22013 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22017 */     // MIs[3] Operand 2
     /*  22017 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22028 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22030 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22074 */     // GIR_Coverage, 6939,
     /*  22074 */     GIR_EraseRootFromParent_Done,
     /*  22075 */   // Label 381: @22075
     /*  22075 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22238), // Rule ID 13922 //
     /*  22080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22122 */     // MIs[1] Operand 2
     /*  22122 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22139 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22139 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22142 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22146 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22153 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22156 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22160 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22165 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22168 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22172 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22175 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22180 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22185 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22202 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22220 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22237 */     // GIR_Coverage, 13922,
     /*  22237 */     GIR_EraseRootFromParent_Done,
     /*  22238 */   // Label 382: @22238
     /*  22238 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22401), // Rule ID 13919 //
     /*  22243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22285 */     // MIs[1] Operand 2
     /*  22285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22302 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22302 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22305 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22309 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22328 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22331 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22335 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22383 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22400 */     // GIR_Coverage, 13919,
     /*  22400 */     GIR_EraseRootFromParent_Done,
     /*  22401 */   // Label 383: @22401
     /*  22401 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22551), // Rule ID 13926 //
     /*  22406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22439 */     // MIs[1] Operand 2
     /*  22439 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22456 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22456 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22459 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22463 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22482 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22485 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22489 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22550 */     // GIR_Coverage, 13926,
     /*  22550 */     GIR_EraseRootFromParent_Done,
     /*  22551 */   // Label 384: @22551
     /*  22551 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22701), // Rule ID 13931 //
     /*  22556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22589 */     // MIs[1] Operand 2
     /*  22589 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22606 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22606 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22609 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22613 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22632 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22639 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22683 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22700 */     // GIR_Coverage, 13931,
     /*  22700 */     GIR_EraseRootFromParent_Done,
     /*  22701 */   // Label 385: @22701
     /*  22701 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22851), // Rule ID 13925 //
     /*  22706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22739 */     // MIs[1] Operand 2
     /*  22739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22756 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22756 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22759 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22763 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22782 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22785 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22789 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22792 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22797 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22802 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22833 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22850 */     // GIR_Coverage, 13925,
     /*  22850 */     GIR_EraseRootFromParent_Done,
     /*  22851 */   // Label 386: @22851
     /*  22851 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(23014), // Rule ID 5357 //
     /*  22856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22902 */     // MIs[1] Operand 2
     /*  22902 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22915 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22915 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22918 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22922 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22941 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22948 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22961 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22978 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22996 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23013 */     // GIR_Coverage, 5357,
     /*  23013 */     GIR_EraseRootFromParent_Done,
     /*  23014 */   // Label 387: @23014
     /*  23014 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(23177), // Rule ID 5354 //
     /*  23019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23065 */     // MIs[1] Operand 2
     /*  23065 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23078 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23095 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23099 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23104 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23111 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23148 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23159 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23176 */     // GIR_Coverage, 5354,
     /*  23176 */     GIR_EraseRootFromParent_Done,
     /*  23177 */   // Label 388: @23177
     /*  23177 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23327), // Rule ID 5379 //
     /*  23182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23219 */     // MIs[1] Operand 2
     /*  23219 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23232 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23232 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23235 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23239 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23258 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23261 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23265 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23309 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23326 */     // GIR_Coverage, 5379,
     /*  23326 */     GIR_EraseRootFromParent_Done,
     /*  23327 */   // Label 389: @23327
     /*  23327 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23477), // Rule ID 5387 //
     /*  23332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23369 */     // MIs[1] Operand 2
     /*  23369 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23382 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23382 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23385 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23389 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23396 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23399 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23403 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23408 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23411 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23415 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23418 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23459 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23476 */     // GIR_Coverage, 5387,
     /*  23476 */     GIR_EraseRootFromParent_Done,
     /*  23477 */   // Label 390: @23477
     /*  23477 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23627), // Rule ID 5378 //
     /*  23482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23519 */     // MIs[1] Operand 2
     /*  23519 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23532 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23532 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23535 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23539 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23558 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23561 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23565 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23609 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23626 */     // GIR_Coverage, 5378,
     /*  23626 */     GIR_EraseRootFromParent_Done,
     /*  23627 */   // Label 391: @23627
     /*  23627 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23696), // Rule ID 13368 //
     /*  23632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23647 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23650 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23679 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23694 */     GIR_RootConstrainSelectedInstOperands,
     /*  23695 */     // GIR_Coverage, 13368,
     /*  23695 */     GIR_EraseRootFromParent_Done,
     /*  23696 */   // Label 392: @23696
     /*  23696 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23765), // Rule ID 13380 //
     /*  23701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23716 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23719 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23728 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23748 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23763 */     GIR_RootConstrainSelectedInstOperands,
     /*  23764 */     // GIR_Coverage, 13380,
     /*  23764 */     GIR_EraseRootFromParent_Done,
     /*  23765 */   // Label 393: @23765
     /*  23765 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23821), // Rule ID 13330 //
     /*  23770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23785 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23788 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23808 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23819 */     GIR_RootConstrainSelectedInstOperands,
     /*  23820 */     // GIR_Coverage, 13330,
     /*  23820 */     GIR_EraseRootFromParent_Done,
     /*  23821 */   // Label 394: @23821
     /*  23821 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23877), // Rule ID 13342 //
     /*  23826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23841 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23844 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23864 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23875 */     GIR_RootConstrainSelectedInstOperands,
     /*  23876 */     // GIR_Coverage, 13342,
     /*  23876 */     GIR_EraseRootFromParent_Done,
     /*  23877 */   // Label 395: @23877
     /*  23877 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23944), // Rule ID 13572 //
     /*  23882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23906 */     // MIs[1] imm
     /*  23906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23918 */     // MIs[2] Operand 1
     /*  23918 */     // No operand predicates
     /*  23918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23928 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23942 */     GIR_RootConstrainSelectedInstOperands,
     /*  23943 */     // GIR_Coverage, 13572,
     /*  23943 */     GIR_EraseRootFromParent_Done,
     /*  23944 */   // Label 396: @23944
     /*  23944 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24011), // Rule ID 13593 //
     /*  23949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23973 */     // MIs[1] imm
     /*  23973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23981 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23985 */     // MIs[2] Operand 1
     /*  23985 */     // No operand predicates
     /*  23985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23995 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  23998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24009 */     GIR_RootConstrainSelectedInstOperands,
     /*  24010 */     // GIR_Coverage, 13593,
     /*  24010 */     GIR_EraseRootFromParent_Done,
     /*  24011 */   // Label 397: @24011
     /*  24011 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24080), // Rule ID 1361 //
     /*  24016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24035 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24038 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24047 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24063 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24078 */     GIR_RootConstrainSelectedInstOperands,
     /*  24079 */     // GIR_Coverage, 1361,
     /*  24079 */     GIR_EraseRootFromParent_Done,
     /*  24080 */   // Label 398: @24080
     /*  24080 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24149), // Rule ID 1484 //
     /*  24085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24104 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24107 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24116 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24132 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24147 */     GIR_RootConstrainSelectedInstOperands,
     /*  24148 */     // GIR_Coverage, 1484,
     /*  24148 */     GIR_EraseRootFromParent_Done,
     /*  24149 */   // Label 399: @24149
     /*  24149 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24205), // Rule ID 989 //
     /*  24154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24173 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24176 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24192 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24203 */     GIR_RootConstrainSelectedInstOperands,
     /*  24204 */     // GIR_Coverage, 989,
     /*  24204 */     GIR_EraseRootFromParent_Done,
     /*  24205 */   // Label 400: @24205
     /*  24205 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24261), // Rule ID 1050 //
     /*  24210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24229 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24232 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24248 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24259 */     GIR_RootConstrainSelectedInstOperands,
     /*  24260 */     // GIR_Coverage, 1050,
     /*  24260 */     GIR_EraseRootFromParent_Done,
     /*  24261 */   // Label 401: @24261
     /*  24261 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24328), // Rule ID 2234 //
     /*  24266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24294 */     // MIs[1] imm
     /*  24294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24302 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24306 */     // MIs[2] Operand 1
     /*  24306 */     // No operand predicates
     /*  24306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24312 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24326 */     GIR_RootConstrainSelectedInstOperands,
     /*  24327 */     // GIR_Coverage, 2234,
     /*  24327 */     GIR_EraseRootFromParent_Done,
     /*  24328 */   // Label 402: @24328
     /*  24328 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24395), // Rule ID 2293 //
     /*  24333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24361 */     // MIs[1] imm
     /*  24361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24369 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24373 */     // MIs[2] Operand 1
     /*  24373 */     // No operand predicates
     /*  24373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24379 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24393 */     GIR_RootConstrainSelectedInstOperands,
     /*  24394 */     // GIR_Coverage, 2293,
     /*  24394 */     GIR_EraseRootFromParent_Done,
     /*  24395 */   // Label 403: @24395
     /*  24395 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24443), // Rule ID 13329 //
     /*  24400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24430 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24441 */     GIR_RootConstrainSelectedInstOperands,
     /*  24442 */     // GIR_Coverage, 13329,
     /*  24442 */     GIR_EraseRootFromParent_Done,
     /*  24443 */   // Label 404: @24443
     /*  24443 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24491), // Rule ID 13341 //
     /*  24448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24478 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24489 */     GIR_RootConstrainSelectedInstOperands,
     /*  24490 */     // GIR_Coverage, 13341,
     /*  24490 */     GIR_EraseRootFromParent_Done,
     /*  24491 */   // Label 405: @24491
     /*  24491 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24539), // Rule ID 988 //
     /*  24496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24526 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24537 */     GIR_RootConstrainSelectedInstOperands,
     /*  24538 */     // GIR_Coverage, 988,
     /*  24538 */     GIR_EraseRootFromParent_Done,
     /*  24539 */   // Label 406: @24539
     /*  24539 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24587), // Rule ID 1049 //
     /*  24544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24574 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24585 */     GIR_RootConstrainSelectedInstOperands,
     /*  24586 */     // GIR_Coverage, 1049,
     /*  24586 */     GIR_EraseRootFromParent_Done,
     /*  24587 */   // Label 407: @24587
     /*  24587 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24614), // Rule ID 1102 //
     /*  24592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24607 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24612 */     GIR_RootConstrainSelectedInstOperands,
     /*  24613 */     // GIR_Coverage, 1102,
     /*  24613 */     GIR_Done,
     /*  24614 */   // Label 408: @24614
     /*  24614 */   GIM_Reject,
     /*  24615 */ // Label 374: @24615
     /*  24615 */ GIM_Reject,
     /*  24616 */ // Label 160: @24616
     /*  24616 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(30793),
     /*  24621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24627 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24745), // Rule ID 13502 //
     /*  24632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24675 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24679 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24683 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24688 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24692 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24696 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24700 */     // MIs[4] Operand 1
     /*  24700 */     // No operand predicates
     /*  24700 */     // MIs[2] Operand 2
     /*  24700 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24724 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24743 */     GIR_RootConstrainSelectedInstOperands,
     /*  24744 */     // GIR_Coverage, 13502,
     /*  24744 */     GIR_EraseRootFromParent_Done,
     /*  24745 */   // Label 410: @24745
     /*  24745 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24863), // Rule ID 13503 //
     /*  24750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24793 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24797 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24801 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24806 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24810 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24814 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24818 */     // MIs[4] Operand 1
     /*  24818 */     // No operand predicates
     /*  24818 */     // MIs[2] Operand 2
     /*  24818 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24833 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24842 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24861 */     GIR_RootConstrainSelectedInstOperands,
     /*  24862 */     // GIR_Coverage, 13503,
     /*  24862 */     GIR_EraseRootFromParent_Done,
     /*  24863 */   // Label 411: @24863
     /*  24863 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24981), // Rule ID 13532 //
     /*  24868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24911 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24932 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24936 */     // MIs[4] Operand 1
     /*  24936 */     // No operand predicates
     /*  24936 */     // MIs[2] Operand 2
     /*  24936 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24951 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24960 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24979 */     GIR_RootConstrainSelectedInstOperands,
     /*  24980 */     // GIR_Coverage, 13532,
     /*  24980 */     GIR_EraseRootFromParent_Done,
     /*  24981 */   // Label 412: @24981
     /*  24981 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25099), // Rule ID 13533 //
     /*  24986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25033 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25037 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25046 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25050 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25054 */     // MIs[4] Operand 1
     /*  25054 */     // No operand predicates
     /*  25054 */     // MIs[2] Operand 2
     /*  25054 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25078 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25097 */     GIR_RootConstrainSelectedInstOperands,
     /*  25098 */     // GIR_Coverage, 13533,
     /*  25098 */     GIR_EraseRootFromParent_Done,
     /*  25099 */   // Label 413: @25099
     /*  25099 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25217), // Rule ID 2039 //
     /*  25104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25151 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25155 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25159 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25168 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25172 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25176 */     // MIs[4] Operand 1
     /*  25176 */     // No operand predicates
     /*  25176 */     // MIs[2] Operand 2
     /*  25176 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25187 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25196 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25215 */     GIR_RootConstrainSelectedInstOperands,
     /*  25216 */     // GIR_Coverage, 2039,
     /*  25216 */     GIR_EraseRootFromParent_Done,
     /*  25217 */   // Label 414: @25217
     /*  25217 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25335), // Rule ID 13501 //
     /*  25222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25269 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25273 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25277 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25286 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25290 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25294 */     // MIs[4] Operand 1
     /*  25294 */     // No operand predicates
     /*  25294 */     // MIs[2] Operand 2
     /*  25294 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25305 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25314 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25333 */     GIR_RootConstrainSelectedInstOperands,
     /*  25334 */     // GIR_Coverage, 13501,
     /*  25334 */     GIR_EraseRootFromParent_Done,
     /*  25335 */   // Label 415: @25335
     /*  25335 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25453), // Rule ID 2091 //
     /*  25340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25387 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25391 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25395 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25408 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25412 */     // MIs[4] Operand 1
     /*  25412 */     // No operand predicates
     /*  25412 */     // MIs[2] Operand 2
     /*  25412 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25423 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25432 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25451 */     GIR_RootConstrainSelectedInstOperands,
     /*  25452 */     // GIR_Coverage, 2091,
     /*  25452 */     GIR_EraseRootFromParent_Done,
     /*  25453 */   // Label 416: @25453
     /*  25453 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25571), // Rule ID 13531 //
     /*  25458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25505 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25509 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25513 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25522 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25526 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25530 */     // MIs[4] Operand 1
     /*  25530 */     // No operand predicates
     /*  25530 */     // MIs[2] Operand 2
     /*  25530 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25541 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25550 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25569 */     GIR_RootConstrainSelectedInstOperands,
     /*  25570 */     // GIR_Coverage, 13531,
     /*  25570 */     GIR_EraseRootFromParent_Done,
     /*  25571 */   // Label 417: @25571
     /*  25571 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25658), // Rule ID 13412 //
     /*  25576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25603 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25606 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25615 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25639 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25656 */     GIR_RootConstrainSelectedInstOperands,
     /*  25657 */     // GIR_Coverage, 13412,
     /*  25657 */     GIR_EraseRootFromParent_Done,
     /*  25658 */   // Label 418: @25658
     /*  25658 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25745), // Rule ID 13436 //
     /*  25663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25690 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25693 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25702 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25726 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25743 */     GIR_RootConstrainSelectedInstOperands,
     /*  25744 */     // GIR_Coverage, 13436,
     /*  25744 */     GIR_EraseRootFromParent_Done,
     /*  25745 */   // Label 419: @25745
     /*  25745 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25832), // Rule ID 1695 //
     /*  25750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25781 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25784 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25793 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25813 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25830 */     GIR_RootConstrainSelectedInstOperands,
     /*  25831 */     // GIR_Coverage, 1695,
     /*  25831 */     GIR_EraseRootFromParent_Done,
     /*  25832 */   // Label 420: @25832
     /*  25832 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25919), // Rule ID 1773 //
     /*  25837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25868 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25871 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25880 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25900 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25917 */     GIR_RootConstrainSelectedInstOperands,
     /*  25918 */     // GIR_Coverage, 1773,
     /*  25918 */     GIR_EraseRootFromParent_Done,
     /*  25919 */   // Label 421: @25919
     /*  25919 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26034), // Rule ID 13497 //
     /*  25924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25967 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25971 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25975 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25980 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25984 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25988 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25992 */     // MIs[4] Operand 1
     /*  25992 */     // No operand predicates
     /*  25992 */     // MIs[2] Operand 2
     /*  25992 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26012 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26014 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26032 */     GIR_RootConstrainSelectedInstOperands,
     /*  26033 */     // GIR_Coverage, 13497,
     /*  26033 */     GIR_EraseRootFromParent_Done,
     /*  26034 */   // Label 422: @26034
     /*  26034 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26149), // Rule ID 13496 //
     /*  26039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26087 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26091 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26095 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26100 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26104 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26108 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26112 */     // MIs[4] Operand 1
     /*  26112 */     // No operand predicates
     /*  26112 */     // MIs[2] Operand 2
     /*  26112 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26127 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26129 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26147 */     GIR_RootConstrainSelectedInstOperands,
     /*  26148 */     // GIR_Coverage, 13496,
     /*  26148 */     GIR_EraseRootFromParent_Done,
     /*  26149 */   // Label 423: @26149
     /*  26149 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26264), // Rule ID 13527 //
     /*  26154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26197 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26201 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26205 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26210 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26214 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26218 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26222 */     // MIs[4] Operand 1
     /*  26222 */     // No operand predicates
     /*  26222 */     // MIs[2] Operand 2
     /*  26222 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26242 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26244 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26262 */     GIR_RootConstrainSelectedInstOperands,
     /*  26263 */     // GIR_Coverage, 13527,
     /*  26263 */     GIR_EraseRootFromParent_Done,
     /*  26264 */   // Label 424: @26264
     /*  26264 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26379), // Rule ID 13526 //
     /*  26269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26317 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26321 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26325 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26334 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26338 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26342 */     // MIs[4] Operand 1
     /*  26342 */     // No operand predicates
     /*  26342 */     // MIs[2] Operand 2
     /*  26342 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26357 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26359 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26377 */     GIR_RootConstrainSelectedInstOperands,
     /*  26378 */     // GIR_Coverage, 13526,
     /*  26378 */     GIR_EraseRootFromParent_Done,
     /*  26379 */   // Label 425: @26379
     /*  26379 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26448), // Rule ID 1793 //
     /*  26384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26431 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26446 */     GIR_RootConstrainSelectedInstOperands,
     /*  26447 */     // GIR_Coverage, 1793,
     /*  26447 */     GIR_EraseRootFromParent_Done,
     /*  26448 */   // Label 426: @26448
     /*  26448 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26517), // Rule ID 1792 //
     /*  26453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26500 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26515 */     GIR_RootConstrainSelectedInstOperands,
     /*  26516 */     // GIR_Coverage, 1792,
     /*  26516 */     GIR_EraseRootFromParent_Done,
     /*  26517 */   // Label 427: @26517
     /*  26517 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26586), // Rule ID 1715 //
     /*  26522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26569 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26584 */     GIR_RootConstrainSelectedInstOperands,
     /*  26585 */     // GIR_Coverage, 1715,
     /*  26585 */     GIR_EraseRootFromParent_Done,
     /*  26586 */   // Label 428: @26586
     /*  26586 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26655), // Rule ID 1791 //
     /*  26591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26638 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26653 */     GIR_RootConstrainSelectedInstOperands,
     /*  26654 */     // GIR_Coverage, 1791,
     /*  26654 */     GIR_EraseRootFromParent_Done,
     /*  26655 */   // Label 429: @26655
     /*  26655 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26724), // Rule ID 1790 //
     /*  26660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26707 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26722 */     GIR_RootConstrainSelectedInstOperands,
     /*  26723 */     // GIR_Coverage, 1790,
     /*  26723 */     GIR_EraseRootFromParent_Done,
     /*  26724 */   // Label 430: @26724
     /*  26724 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26839), // Rule ID 13495 //
     /*  26729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26789 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26793 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26797 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26801 */     // MIs[4] Operand 1
     /*  26801 */     // No operand predicates
     /*  26801 */     // MIs[2] Operand 2
     /*  26801 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26817 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26819 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26837 */     GIR_RootConstrainSelectedInstOperands,
     /*  26838 */     // GIR_Coverage, 13495,
     /*  26838 */     GIR_EraseRootFromParent_Done,
     /*  26839 */   // Label 431: @26839
     /*  26839 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26954), // Rule ID 2037 //
     /*  26844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26900 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26904 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26909 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26913 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26917 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26921 */     // MIs[4] Operand 1
     /*  26921 */     // No operand predicates
     /*  26921 */     // MIs[2] Operand 2
     /*  26921 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26934 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26952 */     GIR_RootConstrainSelectedInstOperands,
     /*  26953 */     // GIR_Coverage, 2037,
     /*  26953 */     GIR_EraseRootFromParent_Done,
     /*  26954 */   // Label 432: @26954
     /*  26954 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27069), // Rule ID 13525 //
     /*  26959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27006 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27010 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27014 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27019 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27023 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27027 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27031 */     // MIs[4] Operand 1
     /*  27031 */     // No operand predicates
     /*  27031 */     // MIs[2] Operand 2
     /*  27031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27047 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27049 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27067 */     GIR_RootConstrainSelectedInstOperands,
     /*  27068 */     // GIR_Coverage, 13525,
     /*  27068 */     GIR_EraseRootFromParent_Done,
     /*  27069 */   // Label 433: @27069
     /*  27069 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27184), // Rule ID 2089 //
     /*  27074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27130 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27134 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27139 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27143 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27147 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27151 */     // MIs[4] Operand 1
     /*  27151 */     // No operand predicates
     /*  27151 */     // MIs[2] Operand 2
     /*  27151 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27162 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27164 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27182 */     GIR_RootConstrainSelectedInstOperands,
     /*  27183 */     // GIR_Coverage, 2089,
     /*  27183 */     GIR_EraseRootFromParent_Done,
     /*  27184 */   // Label 434: @27184
     /*  27184 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27251), // Rule ID 13426 //
     /*  27189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27232 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27249 */     GIR_RootConstrainSelectedInstOperands,
     /*  27250 */     // GIR_Coverage, 13426,
     /*  27250 */     GIR_EraseRootFromParent_Done,
     /*  27251 */   // Label 435: @27251
     /*  27251 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27318), // Rule ID 13456 //
     /*  27256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27299 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27316 */     GIR_RootConstrainSelectedInstOperands,
     /*  27317 */     // GIR_Coverage, 13456,
     /*  27317 */     GIR_EraseRootFromParent_Done,
     /*  27318 */   // Label 436: @27318
     /*  27318 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27385), // Rule ID 1727 //
     /*  27323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27366 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27383 */     GIR_RootConstrainSelectedInstOperands,
     /*  27384 */     // GIR_Coverage, 1727,
     /*  27384 */     GIR_EraseRootFromParent_Done,
     /*  27385 */   // Label 437: @27385
     /*  27385 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27452), // Rule ID 1817 //
     /*  27390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27433 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27450 */     GIR_RootConstrainSelectedInstOperands,
     /*  27451 */     // GIR_Coverage, 1817,
     /*  27451 */     GIR_EraseRootFromParent_Done,
     /*  27452 */   // Label 438: @27452
     /*  27452 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27533), // Rule ID 13410 //
     /*  27457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27484 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27487 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27496 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27516 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27531 */     GIR_RootConstrainSelectedInstOperands,
     /*  27532 */     // GIR_Coverage, 13410,
     /*  27532 */     GIR_EraseRootFromParent_Done,
     /*  27533 */   // Label 439: @27533
     /*  27533 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27614), // Rule ID 13434 //
     /*  27538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27565 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27568 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27577 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27597 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27612 */     GIR_RootConstrainSelectedInstOperands,
     /*  27613 */     // GIR_Coverage, 13434,
     /*  27613 */     GIR_EraseRootFromParent_Done,
     /*  27614 */   // Label 440: @27614
     /*  27614 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27695), // Rule ID 1693 //
     /*  27619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27650 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27653 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27662 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27678 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27693 */     GIR_RootConstrainSelectedInstOperands,
     /*  27694 */     // GIR_Coverage, 1693,
     /*  27694 */     GIR_EraseRootFromParent_Done,
     /*  27695 */   // Label 441: @27695
     /*  27695 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27776), // Rule ID 1771 //
     /*  27700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27731 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27734 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27743 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27759 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27774 */     GIR_RootConstrainSelectedInstOperands,
     /*  27775 */     // GIR_Coverage, 1771,
     /*  27775 */     GIR_EraseRootFromParent_Done,
     /*  27776 */   // Label 442: @27776
     /*  27776 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27868), // Rule ID 13500 //
     /*  27781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27833 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27837 */     // MIs[3] Operand 1
     /*  27837 */     // No operand predicates
     /*  27837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27848 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27866 */     GIR_RootConstrainSelectedInstOperands,
     /*  27867 */     // GIR_Coverage, 13500,
     /*  27867 */     GIR_EraseRootFromParent_Done,
     /*  27868 */   // Label 443: @27868
     /*  27868 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27960), // Rule ID 13499 //
     /*  27873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27930 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27934 */     // MIs[3] Operand 1
     /*  27934 */     // No operand predicates
     /*  27934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27940 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27958 */     GIR_RootConstrainSelectedInstOperands,
     /*  27959 */     // GIR_Coverage, 13499,
     /*  27959 */     GIR_EraseRootFromParent_Done,
     /*  27960 */   // Label 444: @27960
     /*  27960 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28052), // Rule ID 13530 //
     /*  27965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28017 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28021 */     // MIs[3] Operand 1
     /*  28021 */     // No operand predicates
     /*  28021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28032 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28050 */     GIR_RootConstrainSelectedInstOperands,
     /*  28051 */     // GIR_Coverage, 13530,
     /*  28051 */     GIR_EraseRootFromParent_Done,
     /*  28052 */   // Label 445: @28052
     /*  28052 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28144), // Rule ID 13529 //
     /*  28057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28114 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28118 */     // MIs[3] Operand 1
     /*  28118 */     // No operand predicates
     /*  28118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28124 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28142 */     GIR_RootConstrainSelectedInstOperands,
     /*  28143 */     // GIR_Coverage, 13529,
     /*  28143 */     GIR_EraseRootFromParent_Done,
     /*  28144 */   // Label 446: @28144
     /*  28144 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28236), // Rule ID 13498 //
     /*  28149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28205 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28209 */     // MIs[3] Operand 1
     /*  28209 */     // No operand predicates
     /*  28209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28216 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28234 */     GIR_RootConstrainSelectedInstOperands,
     /*  28235 */     // GIR_Coverage, 13498,
     /*  28235 */     GIR_EraseRootFromParent_Done,
     /*  28236 */   // Label 447: @28236
     /*  28236 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28328), // Rule ID 2038 //
     /*  28241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28302 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28306 */     // MIs[3] Operand 1
     /*  28306 */     // No operand predicates
     /*  28306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28308 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28326 */     GIR_RootConstrainSelectedInstOperands,
     /*  28327 */     // GIR_Coverage, 2038,
     /*  28327 */     GIR_EraseRootFromParent_Done,
     /*  28328 */   // Label 448: @28328
     /*  28328 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28420), // Rule ID 13528 //
     /*  28333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28389 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28393 */     // MIs[3] Operand 1
     /*  28393 */     // No operand predicates
     /*  28393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28400 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28418 */     GIR_RootConstrainSelectedInstOperands,
     /*  28419 */     // GIR_Coverage, 13528,
     /*  28419 */     GIR_EraseRootFromParent_Done,
     /*  28420 */   // Label 449: @28420
     /*  28420 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28512), // Rule ID 2090 //
     /*  28425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28486 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28490 */     // MIs[3] Operand 1
     /*  28490 */     // No operand predicates
     /*  28490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28492 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28510 */     GIR_RootConstrainSelectedInstOperands,
     /*  28511 */     // GIR_Coverage, 2090,
     /*  28511 */     GIR_EraseRootFromParent_Done,
     /*  28512 */   // Label 450: @28512
     /*  28512 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28563), // Rule ID 13448 //
     /*  28517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28549 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28561 */     GIR_RootConstrainSelectedInstOperands,
     /*  28562 */     // GIR_Coverage, 13448,
     /*  28562 */     GIR_EraseRootFromParent_Done,
     /*  28563 */   // Label 451: @28563
     /*  28563 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28614), // Rule ID 13420 //
     /*  28568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28600 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28612 */     GIR_RootConstrainSelectedInstOperands,
     /*  28613 */     // GIR_Coverage, 13420,
     /*  28613 */     GIR_EraseRootFromParent_Done,
     /*  28614 */   // Label 452: @28614
     /*  28614 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28665), // Rule ID 13447 //
     /*  28619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28651 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28663 */     GIR_RootConstrainSelectedInstOperands,
     /*  28664 */     // GIR_Coverage, 13447,
     /*  28664 */     GIR_EraseRootFromParent_Done,
     /*  28665 */   // Label 453: @28665
     /*  28665 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28716), // Rule ID 1809 //
     /*  28670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28702 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28714 */     GIR_RootConstrainSelectedInstOperands,
     /*  28715 */     // GIR_Coverage, 1809,
     /*  28715 */     GIR_EraseRootFromParent_Done,
     /*  28716 */   // Label 454: @28716
     /*  28716 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28767), // Rule ID 1721 //
     /*  28721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28753 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28765 */     GIR_RootConstrainSelectedInstOperands,
     /*  28766 */     // GIR_Coverage, 1721,
     /*  28766 */     GIR_EraseRootFromParent_Done,
     /*  28767 */   // Label 455: @28767
     /*  28767 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28818), // Rule ID 1808 //
     /*  28772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28804 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28816 */     GIR_RootConstrainSelectedInstOperands,
     /*  28817 */     // GIR_Coverage, 1808,
     /*  28817 */     GIR_EraseRootFromParent_Done,
     /*  28818 */   // Label 456: @28818
     /*  28818 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28887), // Rule ID 13374 //
     /*  28823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28838 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28841 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28850 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28870 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28885 */     GIR_RootConstrainSelectedInstOperands,
     /*  28886 */     // GIR_Coverage, 13374,
     /*  28886 */     GIR_EraseRootFromParent_Done,
     /*  28887 */   // Label 457: @28887
     /*  28887 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28956), // Rule ID 13386 //
     /*  28892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28907 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28910 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28919 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28939 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28954 */     GIR_RootConstrainSelectedInstOperands,
     /*  28955 */     // GIR_Coverage, 13386,
     /*  28955 */     GIR_EraseRootFromParent_Done,
     /*  28956 */   // Label 458: @28956
     /*  28956 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29012), // Rule ID 13336 //
     /*  28961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28976 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28979 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28999 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29010 */     GIR_RootConstrainSelectedInstOperands,
     /*  29011 */     // GIR_Coverage, 13336,
     /*  29011 */     GIR_EraseRootFromParent_Done,
     /*  29012 */   // Label 459: @29012
     /*  29012 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29068), // Rule ID 13348 //
     /*  29017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29032 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29035 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29055 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29066 */     GIR_RootConstrainSelectedInstOperands,
     /*  29067 */     // GIR_Coverage, 13348,
     /*  29067 */     GIR_EraseRootFromParent_Done,
     /*  29068 */   // Label 460: @29068
     /*  29068 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29135), // Rule ID 13578 //
     /*  29073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29097 */     // MIs[1] imm
     /*  29097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29105 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29109 */     // MIs[2] Operand 1
     /*  29109 */     // No operand predicates
     /*  29109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29119 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29133 */     GIR_RootConstrainSelectedInstOperands,
     /*  29134 */     // GIR_Coverage, 13578,
     /*  29134 */     GIR_EraseRootFromParent_Done,
     /*  29135 */   // Label 461: @29135
     /*  29135 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29202), // Rule ID 13599 //
     /*  29140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29164 */     // MIs[1] imm
     /*  29164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29176 */     // MIs[2] Operand 1
     /*  29176 */     // No operand predicates
     /*  29176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29186 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29200 */     GIR_RootConstrainSelectedInstOperands,
     /*  29201 */     // GIR_Coverage, 13599,
     /*  29201 */     GIR_EraseRootFromParent_Done,
     /*  29202 */   // Label 462: @29202
     /*  29202 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29271), // Rule ID 1367 //
     /*  29207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29226 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29229 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29238 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29254 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29269 */     GIR_RootConstrainSelectedInstOperands,
     /*  29270 */     // GIR_Coverage, 1367,
     /*  29270 */     GIR_EraseRootFromParent_Done,
     /*  29271 */   // Label 463: @29271
     /*  29271 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29340), // Rule ID 1490 //
     /*  29276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29295 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29298 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29323 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29338 */     GIR_RootConstrainSelectedInstOperands,
     /*  29339 */     // GIR_Coverage, 1490,
     /*  29339 */     GIR_EraseRootFromParent_Done,
     /*  29340 */   // Label 464: @29340
     /*  29340 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29396), // Rule ID 995 //
     /*  29345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29364 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29367 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29383 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29394 */     GIR_RootConstrainSelectedInstOperands,
     /*  29395 */     // GIR_Coverage, 995,
     /*  29395 */     GIR_EraseRootFromParent_Done,
     /*  29396 */   // Label 465: @29396
     /*  29396 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29452), // Rule ID 1056 //
     /*  29401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29420 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29423 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29439 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29450 */     GIR_RootConstrainSelectedInstOperands,
     /*  29451 */     // GIR_Coverage, 1056,
     /*  29451 */     GIR_EraseRootFromParent_Done,
     /*  29452 */   // Label 466: @29452
     /*  29452 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29519), // Rule ID 2240 //
     /*  29457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29485 */     // MIs[1] imm
     /*  29485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29497 */     // MIs[2] Operand 1
     /*  29497 */     // No operand predicates
     /*  29497 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29503 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29517 */     GIR_RootConstrainSelectedInstOperands,
     /*  29518 */     // GIR_Coverage, 2240,
     /*  29518 */     GIR_EraseRootFromParent_Done,
     /*  29519 */   // Label 467: @29519
     /*  29519 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29586), // Rule ID 2299 //
     /*  29524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29552 */     // MIs[1] imm
     /*  29552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29560 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29564 */     // MIs[2] Operand 1
     /*  29564 */     // No operand predicates
     /*  29564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29570 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29584 */     GIR_RootConstrainSelectedInstOperands,
     /*  29585 */     // GIR_Coverage, 2299,
     /*  29585 */     GIR_EraseRootFromParent_Done,
     /*  29586 */   // Label 468: @29586
     /*  29586 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29656), // Rule ID 6935 //
     /*  29591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29629 */     // MIs[2] Rn
     /*  29629 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29634 */     // MIs[2] Rm
     /*  29634 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29641 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29654 */     GIR_RootConstrainSelectedInstOperands,
     /*  29655 */     // GIR_Coverage, 6935,
     /*  29655 */     GIR_EraseRootFromParent_Done,
     /*  29656 */   // Label 469: @29656
     /*  29656 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29726), // Rule ID 13960 //
     /*  29661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29699 */     // MIs[2] Rn
     /*  29699 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29704 */     // MIs[2] Rm
     /*  29704 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29711 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29724 */     GIR_RootConstrainSelectedInstOperands,
     /*  29725 */     // GIR_Coverage, 13960,
     /*  29725 */     GIR_EraseRootFromParent_Done,
     /*  29726 */   // Label 470: @29726
     /*  29726 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29789), // Rule ID 1789 //
     /*  29731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29774 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29787 */     GIR_RootConstrainSelectedInstOperands,
     /*  29788 */     // GIR_Coverage, 1789,
     /*  29788 */     GIR_EraseRootFromParent_Done,
     /*  29789 */   // Label 471: @29789
     /*  29789 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29852), // Rule ID 1788 //
     /*  29794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29837 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29850 */     GIR_RootConstrainSelectedInstOperands,
     /*  29851 */     // GIR_Coverage, 1788,
     /*  29851 */     GIR_EraseRootFromParent_Done,
     /*  29852 */   // Label 472: @29852
     /*  29852 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29915), // Rule ID 1714 //
     /*  29857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29900 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29913 */     GIR_RootConstrainSelectedInstOperands,
     /*  29914 */     // GIR_Coverage, 1714,
     /*  29914 */     GIR_EraseRootFromParent_Done,
     /*  29915 */   // Label 473: @29915
     /*  29915 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29978), // Rule ID 1787 //
     /*  29920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29963 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29976 */     GIR_RootConstrainSelectedInstOperands,
     /*  29977 */     // GIR_Coverage, 1787,
     /*  29977 */     GIR_EraseRootFromParent_Done,
     /*  29978 */   // Label 474: @29978
     /*  29978 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30041), // Rule ID 1786 //
     /*  29983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30026 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30039 */     GIR_RootConstrainSelectedInstOperands,
     /*  30040 */     // GIR_Coverage, 1786,
     /*  30040 */     GIR_EraseRootFromParent_Done,
     /*  30041 */   // Label 475: @30041
     /*  30041 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30102), // Rule ID 13425 //
     /*  30046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30085 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30100 */     GIR_RootConstrainSelectedInstOperands,
     /*  30101 */     // GIR_Coverage, 13425,
     /*  30101 */     GIR_EraseRootFromParent_Done,
     /*  30102 */   // Label 476: @30102
     /*  30102 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30163), // Rule ID 13455 //
     /*  30107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30146 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30161 */     GIR_RootConstrainSelectedInstOperands,
     /*  30162 */     // GIR_Coverage, 13455,
     /*  30162 */     GIR_EraseRootFromParent_Done,
     /*  30163 */   // Label 477: @30163
     /*  30163 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30211), // Rule ID 13446 //
     /*  30168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30198 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30209 */     GIR_RootConstrainSelectedInstOperands,
     /*  30210 */     // GIR_Coverage, 13446,
     /*  30210 */     GIR_EraseRootFromParent_Done,
     /*  30211 */   // Label 478: @30211
     /*  30211 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30259), // Rule ID 13335 //
     /*  30216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30246 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30257 */     GIR_RootConstrainSelectedInstOperands,
     /*  30258 */     // GIR_Coverage, 13335,
     /*  30258 */     GIR_EraseRootFromParent_Done,
     /*  30259 */   // Label 479: @30259
     /*  30259 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30307), // Rule ID 13419 //
     /*  30264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30294 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30305 */     GIR_RootConstrainSelectedInstOperands,
     /*  30306 */     // GIR_Coverage, 13419,
     /*  30306 */     GIR_EraseRootFromParent_Done,
     /*  30307 */   // Label 480: @30307
     /*  30307 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30355), // Rule ID 13347 //
     /*  30312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30342 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30353 */     GIR_RootConstrainSelectedInstOperands,
     /*  30354 */     // GIR_Coverage, 13347,
     /*  30354 */     GIR_EraseRootFromParent_Done,
     /*  30355 */   // Label 481: @30355
     /*  30355 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30403), // Rule ID 13445 //
     /*  30360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30390 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30401 */     GIR_RootConstrainSelectedInstOperands,
     /*  30402 */     // GIR_Coverage, 13445,
     /*  30402 */     GIR_EraseRootFromParent_Done,
     /*  30403 */   // Label 482: @30403
     /*  30403 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30464), // Rule ID 1726 //
     /*  30408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30447 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30462 */     GIR_RootConstrainSelectedInstOperands,
     /*  30463 */     // GIR_Coverage, 1726,
     /*  30463 */     GIR_EraseRootFromParent_Done,
     /*  30464 */   // Label 483: @30464
     /*  30464 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30525), // Rule ID 1816 //
     /*  30469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30508 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30523 */     GIR_RootConstrainSelectedInstOperands,
     /*  30524 */     // GIR_Coverage, 1816,
     /*  30524 */     GIR_EraseRootFromParent_Done,
     /*  30525 */   // Label 484: @30525
     /*  30525 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30573), // Rule ID 1807 //
     /*  30530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30560 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30571 */     GIR_RootConstrainSelectedInstOperands,
     /*  30572 */     // GIR_Coverage, 1807,
     /*  30572 */     GIR_EraseRootFromParent_Done,
     /*  30573 */   // Label 485: @30573
     /*  30573 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30621), // Rule ID 994 //
     /*  30578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30608 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30619 */     GIR_RootConstrainSelectedInstOperands,
     /*  30620 */     // GIR_Coverage, 994,
     /*  30620 */     GIR_EraseRootFromParent_Done,
     /*  30621 */   // Label 486: @30621
     /*  30621 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30669), // Rule ID 1720 //
     /*  30626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30656 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30667 */     GIR_RootConstrainSelectedInstOperands,
     /*  30668 */     // GIR_Coverage, 1720,
     /*  30668 */     GIR_EraseRootFromParent_Done,
     /*  30669 */   // Label 487: @30669
     /*  30669 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30717), // Rule ID 1055 //
     /*  30674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30704 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30715 */     GIR_RootConstrainSelectedInstOperands,
     /*  30716 */     // GIR_Coverage, 1055,
     /*  30716 */     GIR_EraseRootFromParent_Done,
     /*  30717 */   // Label 488: @30717
     /*  30717 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30765), // Rule ID 1806 //
     /*  30722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30752 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30763 */     GIR_RootConstrainSelectedInstOperands,
     /*  30764 */     // GIR_Coverage, 1806,
     /*  30764 */     GIR_EraseRootFromParent_Done,
     /*  30765 */   // Label 489: @30765
     /*  30765 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30792), // Rule ID 1105 //
     /*  30770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30785 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30790 */     GIR_RootConstrainSelectedInstOperands,
     /*  30791 */     // GIR_Coverage, 1105,
     /*  30791 */     GIR_Done,
     /*  30792 */   // Label 490: @30792
     /*  30792 */   GIM_Reject,
     /*  30793 */ // Label 409: @30793
     /*  30793 */ GIM_Reject,
     /*  30794 */ // Label 161: @30794
     /*  30794 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31643),
     /*  30799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30805 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30938), // Rule ID 13965 //
     /*  30810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30855 */     // MIs[1] Operand 2
     /*  30855 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30866 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30870 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30874 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30878 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30882 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30886 */     // MIs[5] Rn
     /*  30886 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30891 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30893 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30920 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30937 */     // GIR_Coverage, 13965,
     /*  30937 */     GIR_EraseRootFromParent_Done,
     /*  30938 */   // Label 492: @30938
     /*  30938 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31071), // Rule ID 6940 //
     /*  30943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  30992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  30996 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31000 */     // MIs[4] Rn
     /*  31000 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31005 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31009 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31013 */     // MIs[3] Operand 2
     /*  31013 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31024 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31026 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31070 */     // GIR_Coverage, 6940,
     /*  31070 */     GIR_EraseRootFromParent_Done,
     /*  31071 */   // Label 493: @31071
     /*  31071 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31140), // Rule ID 13364 //
     /*  31076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31091 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31094 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31103 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31123 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31138 */     GIR_RootConstrainSelectedInstOperands,
     /*  31139 */     // GIR_Coverage, 13364,
     /*  31139 */     GIR_EraseRootFromParent_Done,
     /*  31140 */   // Label 494: @31140
     /*  31140 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31209), // Rule ID 13376 //
     /*  31145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31160 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31163 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31172 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31192 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31207 */     GIR_RootConstrainSelectedInstOperands,
     /*  31208 */     // GIR_Coverage, 13376,
     /*  31208 */     GIR_EraseRootFromParent_Done,
     /*  31209 */   // Label 495: @31209
     /*  31209 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31276), // Rule ID 13568 //
     /*  31214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31238 */     // MIs[1] imm
     /*  31238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31250 */     // MIs[2] Operand 1
     /*  31250 */     // No operand predicates
     /*  31250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31260 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31274 */     GIR_RootConstrainSelectedInstOperands,
     /*  31275 */     // GIR_Coverage, 13568,
     /*  31275 */     GIR_EraseRootFromParent_Done,
     /*  31276 */   // Label 496: @31276
     /*  31276 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31343), // Rule ID 13589 //
     /*  31281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31305 */     // MIs[1] imm
     /*  31305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31317 */     // MIs[2] Operand 1
     /*  31317 */     // No operand predicates
     /*  31317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31327 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31341 */     GIR_RootConstrainSelectedInstOperands,
     /*  31342 */     // GIR_Coverage, 13589,
     /*  31342 */     GIR_EraseRootFromParent_Done,
     /*  31343 */   // Label 497: @31343
     /*  31343 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31412), // Rule ID 1357 //
     /*  31348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31367 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31370 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31379 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31395 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31410 */     GIR_RootConstrainSelectedInstOperands,
     /*  31411 */     // GIR_Coverage, 1357,
     /*  31411 */     GIR_EraseRootFromParent_Done,
     /*  31412 */   // Label 498: @31412
     /*  31412 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31481), // Rule ID 1480 //
     /*  31417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31436 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31439 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31448 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31464 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31479 */     GIR_RootConstrainSelectedInstOperands,
     /*  31480 */     // GIR_Coverage, 1480,
     /*  31480 */     GIR_EraseRootFromParent_Done,
     /*  31481 */   // Label 499: @31481
     /*  31481 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31548), // Rule ID 2230 //
     /*  31486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31514 */     // MIs[1] imm
     /*  31514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31526 */     // MIs[2] Operand 1
     /*  31526 */     // No operand predicates
     /*  31526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31532 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31546 */     GIR_RootConstrainSelectedInstOperands,
     /*  31547 */     // GIR_Coverage, 2230,
     /*  31547 */     GIR_EraseRootFromParent_Done,
     /*  31548 */   // Label 500: @31548
     /*  31548 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31615), // Rule ID 2289 //
     /*  31553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31581 */     // MIs[1] imm
     /*  31581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31593 */     // MIs[2] Operand 1
     /*  31593 */     // No operand predicates
     /*  31593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31599 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31613 */     GIR_RootConstrainSelectedInstOperands,
     /*  31614 */     // GIR_Coverage, 2289,
     /*  31614 */     GIR_EraseRootFromParent_Done,
     /*  31615 */   // Label 501: @31615
     /*  31615 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31642), // Rule ID 1100 //
     /*  31620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31635 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31640 */     GIR_RootConstrainSelectedInstOperands,
     /*  31641 */     // GIR_Coverage, 1100,
     /*  31641 */     GIR_Done,
     /*  31642 */   // Label 502: @31642
     /*  31642 */   GIM_Reject,
     /*  31643 */ // Label 491: @31643
     /*  31643 */ GIM_Reject,
     /*  31644 */ // Label 162: @31644
     /*  31644 */ GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(35221),
     /*  31649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31655 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31742), // Rule ID 13408 //
     /*  31660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31687 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31690 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31699 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31723 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31740 */     GIR_RootConstrainSelectedInstOperands,
     /*  31741 */     // GIR_Coverage, 13408,
     /*  31741 */     GIR_EraseRootFromParent_Done,
     /*  31742 */   // Label 504: @31742
     /*  31742 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31829), // Rule ID 13432 //
     /*  31747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31774 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31777 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31786 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31810 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31827 */     GIR_RootConstrainSelectedInstOperands,
     /*  31828 */     // GIR_Coverage, 13432,
     /*  31828 */     GIR_EraseRootFromParent_Done,
     /*  31829 */   // Label 505: @31829
     /*  31829 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31916), // Rule ID 1691 //
     /*  31834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31865 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31868 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31877 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31897 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31914 */     GIR_RootConstrainSelectedInstOperands,
     /*  31915 */     // GIR_Coverage, 1691,
     /*  31915 */     GIR_EraseRootFromParent_Done,
     /*  31916 */   // Label 506: @31916
     /*  31916 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32003), // Rule ID 1769 //
     /*  31921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31952 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31955 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31964 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31970 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31984 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32001 */     GIR_RootConstrainSelectedInstOperands,
     /*  32002 */     // GIR_Coverage, 1769,
     /*  32002 */     GIR_EraseRootFromParent_Done,
     /*  32003 */   // Label 507: @32003
     /*  32003 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32072), // Rule ID 1785 //
     /*  32008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32055 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32070 */     GIR_RootConstrainSelectedInstOperands,
     /*  32071 */     // GIR_Coverage, 1785,
     /*  32071 */     GIR_EraseRootFromParent_Done,
     /*  32072 */   // Label 508: @32072
     /*  32072 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32141), // Rule ID 1784 //
     /*  32077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32124 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32139 */     GIR_RootConstrainSelectedInstOperands,
     /*  32140 */     // GIR_Coverage, 1784,
     /*  32140 */     GIR_EraseRootFromParent_Done,
     /*  32141 */   // Label 509: @32141
     /*  32141 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32210), // Rule ID 1713 //
     /*  32146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32193 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32208 */     GIR_RootConstrainSelectedInstOperands,
     /*  32209 */     // GIR_Coverage, 1713,
     /*  32209 */     GIR_EraseRootFromParent_Done,
     /*  32210 */   // Label 510: @32210
     /*  32210 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32279), // Rule ID 1783 //
     /*  32215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32262 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32277 */     GIR_RootConstrainSelectedInstOperands,
     /*  32278 */     // GIR_Coverage, 1783,
     /*  32278 */     GIR_EraseRootFromParent_Done,
     /*  32279 */   // Label 511: @32279
     /*  32279 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32348), // Rule ID 1782 //
     /*  32284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32331 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32346 */     GIR_RootConstrainSelectedInstOperands,
     /*  32347 */     // GIR_Coverage, 1782,
     /*  32347 */     GIR_EraseRootFromParent_Done,
     /*  32348 */   // Label 512: @32348
     /*  32348 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32415), // Rule ID 13424 //
     /*  32353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32396 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32413 */     GIR_RootConstrainSelectedInstOperands,
     /*  32414 */     // GIR_Coverage, 13424,
     /*  32414 */     GIR_EraseRootFromParent_Done,
     /*  32415 */   // Label 513: @32415
     /*  32415 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32482), // Rule ID 13454 //
     /*  32420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32463 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32480 */     GIR_RootConstrainSelectedInstOperands,
     /*  32481 */     // GIR_Coverage, 13454,
     /*  32481 */     GIR_EraseRootFromParent_Done,
     /*  32482 */   // Label 514: @32482
     /*  32482 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32549), // Rule ID 1725 //
     /*  32487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32530 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32547 */     GIR_RootConstrainSelectedInstOperands,
     /*  32548 */     // GIR_Coverage, 1725,
     /*  32548 */     GIR_EraseRootFromParent_Done,
     /*  32549 */   // Label 515: @32549
     /*  32549 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32616), // Rule ID 1815 //
     /*  32554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32597 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32614 */     GIR_RootConstrainSelectedInstOperands,
     /*  32615 */     // GIR_Coverage, 1815,
     /*  32615 */     GIR_EraseRootFromParent_Done,
     /*  32616 */   // Label 516: @32616
     /*  32616 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32697), // Rule ID 13406 //
     /*  32621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32648 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32651 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32660 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32680 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32695 */     GIR_RootConstrainSelectedInstOperands,
     /*  32696 */     // GIR_Coverage, 13406,
     /*  32696 */     GIR_EraseRootFromParent_Done,
     /*  32697 */   // Label 517: @32697
     /*  32697 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32778), // Rule ID 13430 //
     /*  32702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32729 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32732 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32741 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32761 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32776 */     GIR_RootConstrainSelectedInstOperands,
     /*  32777 */     // GIR_Coverage, 13430,
     /*  32777 */     GIR_EraseRootFromParent_Done,
     /*  32778 */   // Label 518: @32778
     /*  32778 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32859), // Rule ID 1689 //
     /*  32783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32814 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32817 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32826 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32842 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32857 */     GIR_RootConstrainSelectedInstOperands,
     /*  32858 */     // GIR_Coverage, 1689,
     /*  32858 */     GIR_EraseRootFromParent_Done,
     /*  32859 */   // Label 519: @32859
     /*  32859 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32940), // Rule ID 1767 //
     /*  32864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32895 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32898 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32907 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32923 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32938 */     GIR_RootConstrainSelectedInstOperands,
     /*  32939 */     // GIR_Coverage, 1767,
     /*  32939 */     GIR_EraseRootFromParent_Done,
     /*  32940 */   // Label 520: @32940
     /*  32940 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32991), // Rule ID 13444 //
     /*  32945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32977 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32989 */     GIR_RootConstrainSelectedInstOperands,
     /*  32990 */     // GIR_Coverage, 13444,
     /*  32990 */     GIR_EraseRootFromParent_Done,
     /*  32991 */   // Label 521: @32991
     /*  32991 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33042), // Rule ID 13418 //
     /*  32996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33028 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33040 */     GIR_RootConstrainSelectedInstOperands,
     /*  33041 */     // GIR_Coverage, 13418,
     /*  33041 */     GIR_EraseRootFromParent_Done,
     /*  33042 */   // Label 522: @33042
     /*  33042 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33093), // Rule ID 13443 //
     /*  33047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33079 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33091 */     GIR_RootConstrainSelectedInstOperands,
     /*  33092 */     // GIR_Coverage, 13443,
     /*  33092 */     GIR_EraseRootFromParent_Done,
     /*  33093 */   // Label 523: @33093
     /*  33093 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33144), // Rule ID 1805 //
     /*  33098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33130 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33142 */     GIR_RootConstrainSelectedInstOperands,
     /*  33143 */     // GIR_Coverage, 1805,
     /*  33143 */     GIR_EraseRootFromParent_Done,
     /*  33144 */   // Label 524: @33144
     /*  33144 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33195), // Rule ID 1719 //
     /*  33149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33181 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33193 */     GIR_RootConstrainSelectedInstOperands,
     /*  33194 */     // GIR_Coverage, 1719,
     /*  33194 */     GIR_EraseRootFromParent_Done,
     /*  33195 */   // Label 525: @33195
     /*  33195 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33246), // Rule ID 1804 //
     /*  33200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33232 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33244 */     GIR_RootConstrainSelectedInstOperands,
     /*  33245 */     // GIR_Coverage, 1804,
     /*  33245 */     GIR_EraseRootFromParent_Done,
     /*  33246 */   // Label 526: @33246
     /*  33246 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33315), // Rule ID 13370 //
     /*  33251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33266 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33269 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33278 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33298 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33313 */     GIR_RootConstrainSelectedInstOperands,
     /*  33314 */     // GIR_Coverage, 13370,
     /*  33314 */     GIR_EraseRootFromParent_Done,
     /*  33315 */   // Label 527: @33315
     /*  33315 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33384), // Rule ID 13382 //
     /*  33320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33335 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33338 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33347 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33367 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33382 */     GIR_RootConstrainSelectedInstOperands,
     /*  33383 */     // GIR_Coverage, 13382,
     /*  33383 */     GIR_EraseRootFromParent_Done,
     /*  33384 */   // Label 528: @33384
     /*  33384 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33440), // Rule ID 13332 //
     /*  33389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33404 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33407 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33427 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33438 */     GIR_RootConstrainSelectedInstOperands,
     /*  33439 */     // GIR_Coverage, 13332,
     /*  33439 */     GIR_EraseRootFromParent_Done,
     /*  33440 */   // Label 529: @33440
     /*  33440 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33496), // Rule ID 13344 //
     /*  33445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33460 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33463 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33483 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33494 */     GIR_RootConstrainSelectedInstOperands,
     /*  33495 */     // GIR_Coverage, 13344,
     /*  33495 */     GIR_EraseRootFromParent_Done,
     /*  33496 */   // Label 530: @33496
     /*  33496 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33563), // Rule ID 13574 //
     /*  33501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33525 */     // MIs[1] imm
     /*  33525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33537 */     // MIs[2] Operand 1
     /*  33537 */     // No operand predicates
     /*  33537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33547 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33561 */     GIR_RootConstrainSelectedInstOperands,
     /*  33562 */     // GIR_Coverage, 13574,
     /*  33562 */     GIR_EraseRootFromParent_Done,
     /*  33563 */   // Label 531: @33563
     /*  33563 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33630), // Rule ID 13595 //
     /*  33568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33592 */     // MIs[1] imm
     /*  33592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33600 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33604 */     // MIs[2] Operand 1
     /*  33604 */     // No operand predicates
     /*  33604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33614 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33628 */     GIR_RootConstrainSelectedInstOperands,
     /*  33629 */     // GIR_Coverage, 13595,
     /*  33629 */     GIR_EraseRootFromParent_Done,
     /*  33630 */   // Label 532: @33630
     /*  33630 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33699), // Rule ID 1363 //
     /*  33635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33654 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33657 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33666 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33682 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33697 */     GIR_RootConstrainSelectedInstOperands,
     /*  33698 */     // GIR_Coverage, 1363,
     /*  33698 */     GIR_EraseRootFromParent_Done,
     /*  33699 */   // Label 533: @33699
     /*  33699 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33768), // Rule ID 1486 //
     /*  33704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33723 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33726 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33735 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33751 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33766 */     GIR_RootConstrainSelectedInstOperands,
     /*  33767 */     // GIR_Coverage, 1486,
     /*  33767 */     GIR_EraseRootFromParent_Done,
     /*  33768 */   // Label 534: @33768
     /*  33768 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33824), // Rule ID 991 //
     /*  33773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33792 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33795 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33811 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33822 */     GIR_RootConstrainSelectedInstOperands,
     /*  33823 */     // GIR_Coverage, 991,
     /*  33823 */     GIR_EraseRootFromParent_Done,
     /*  33824 */   // Label 535: @33824
     /*  33824 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33880), // Rule ID 1052 //
     /*  33829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33848 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33851 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33867 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33878 */     GIR_RootConstrainSelectedInstOperands,
     /*  33879 */     // GIR_Coverage, 1052,
     /*  33879 */     GIR_EraseRootFromParent_Done,
     /*  33880 */   // Label 536: @33880
     /*  33880 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33947), // Rule ID 2236 //
     /*  33885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33913 */     // MIs[1] imm
     /*  33913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33921 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33925 */     // MIs[2] Operand 1
     /*  33925 */     // No operand predicates
     /*  33925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33931 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33945 */     GIR_RootConstrainSelectedInstOperands,
     /*  33946 */     // GIR_Coverage, 2236,
     /*  33946 */     GIR_EraseRootFromParent_Done,
     /*  33947 */   // Label 537: @33947
     /*  33947 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34014), // Rule ID 2295 //
     /*  33952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33980 */     // MIs[1] imm
     /*  33980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33988 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33992 */     // MIs[2] Operand 1
     /*  33992 */     // No operand predicates
     /*  33992 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33998 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34012 */     GIR_RootConstrainSelectedInstOperands,
     /*  34013 */     // GIR_Coverage, 2295,
     /*  34013 */     GIR_EraseRootFromParent_Done,
     /*  34014 */   // Label 538: @34014
     /*  34014 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34084), // Rule ID 6936 //
     /*  34019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34057 */     // MIs[2] Rn
     /*  34057 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34062 */     // MIs[2] Rm
     /*  34062 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34069 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34082 */     GIR_RootConstrainSelectedInstOperands,
     /*  34083 */     // GIR_Coverage, 6936,
     /*  34083 */     GIR_EraseRootFromParent_Done,
     /*  34084 */   // Label 539: @34084
     /*  34084 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34154), // Rule ID 13961 //
     /*  34089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34127 */     // MIs[2] Rn
     /*  34127 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34132 */     // MIs[2] Rm
     /*  34132 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34139 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34152 */     GIR_RootConstrainSelectedInstOperands,
     /*  34153 */     // GIR_Coverage, 13961,
     /*  34153 */     GIR_EraseRootFromParent_Done,
     /*  34154 */   // Label 540: @34154
     /*  34154 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34217), // Rule ID 1781 //
     /*  34159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34202 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34215 */     GIR_RootConstrainSelectedInstOperands,
     /*  34216 */     // GIR_Coverage, 1781,
     /*  34216 */     GIR_EraseRootFromParent_Done,
     /*  34217 */   // Label 541: @34217
     /*  34217 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34280), // Rule ID 1780 //
     /*  34222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34265 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34278 */     GIR_RootConstrainSelectedInstOperands,
     /*  34279 */     // GIR_Coverage, 1780,
     /*  34279 */     GIR_EraseRootFromParent_Done,
     /*  34280 */   // Label 542: @34280
     /*  34280 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34343), // Rule ID 1712 //
     /*  34285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34328 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34341 */     GIR_RootConstrainSelectedInstOperands,
     /*  34342 */     // GIR_Coverage, 1712,
     /*  34342 */     GIR_EraseRootFromParent_Done,
     /*  34343 */   // Label 543: @34343
     /*  34343 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34406), // Rule ID 1779 //
     /*  34348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34391 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34404 */     GIR_RootConstrainSelectedInstOperands,
     /*  34405 */     // GIR_Coverage, 1779,
     /*  34405 */     GIR_EraseRootFromParent_Done,
     /*  34406 */   // Label 544: @34406
     /*  34406 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34469), // Rule ID 1778 //
     /*  34411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34454 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34467 */     GIR_RootConstrainSelectedInstOperands,
     /*  34468 */     // GIR_Coverage, 1778,
     /*  34468 */     GIR_EraseRootFromParent_Done,
     /*  34469 */   // Label 545: @34469
     /*  34469 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34530), // Rule ID 13423 //
     /*  34474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34513 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34528 */     GIR_RootConstrainSelectedInstOperands,
     /*  34529 */     // GIR_Coverage, 13423,
     /*  34529 */     GIR_EraseRootFromParent_Done,
     /*  34530 */   // Label 546: @34530
     /*  34530 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34591), // Rule ID 13453 //
     /*  34535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34574 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34589 */     GIR_RootConstrainSelectedInstOperands,
     /*  34590 */     // GIR_Coverage, 13453,
     /*  34590 */     GIR_EraseRootFromParent_Done,
     /*  34591 */   // Label 547: @34591
     /*  34591 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34639), // Rule ID 13442 //
     /*  34596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34626 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34637 */     GIR_RootConstrainSelectedInstOperands,
     /*  34638 */     // GIR_Coverage, 13442,
     /*  34638 */     GIR_EraseRootFromParent_Done,
     /*  34639 */   // Label 548: @34639
     /*  34639 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34687), // Rule ID 13331 //
     /*  34644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34674 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34685 */     GIR_RootConstrainSelectedInstOperands,
     /*  34686 */     // GIR_Coverage, 13331,
     /*  34686 */     GIR_EraseRootFromParent_Done,
     /*  34687 */   // Label 549: @34687
     /*  34687 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34735), // Rule ID 13417 //
     /*  34692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34722 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34733 */     GIR_RootConstrainSelectedInstOperands,
     /*  34734 */     // GIR_Coverage, 13417,
     /*  34734 */     GIR_EraseRootFromParent_Done,
     /*  34735 */   // Label 550: @34735
     /*  34735 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34783), // Rule ID 13343 //
     /*  34740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34770 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34781 */     GIR_RootConstrainSelectedInstOperands,
     /*  34782 */     // GIR_Coverage, 13343,
     /*  34782 */     GIR_EraseRootFromParent_Done,
     /*  34783 */   // Label 551: @34783
     /*  34783 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34831), // Rule ID 13441 //
     /*  34788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34818 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34829 */     GIR_RootConstrainSelectedInstOperands,
     /*  34830 */     // GIR_Coverage, 13441,
     /*  34830 */     GIR_EraseRootFromParent_Done,
     /*  34831 */   // Label 552: @34831
     /*  34831 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34892), // Rule ID 1724 //
     /*  34836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34875 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34890 */     GIR_RootConstrainSelectedInstOperands,
     /*  34891 */     // GIR_Coverage, 1724,
     /*  34891 */     GIR_EraseRootFromParent_Done,
     /*  34892 */   // Label 553: @34892
     /*  34892 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34953), // Rule ID 1814 //
     /*  34897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34936 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34951 */     GIR_RootConstrainSelectedInstOperands,
     /*  34952 */     // GIR_Coverage, 1814,
     /*  34952 */     GIR_EraseRootFromParent_Done,
     /*  34953 */   // Label 554: @34953
     /*  34953 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35001), // Rule ID 1803 //
     /*  34958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34988 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  34995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34999 */     GIR_RootConstrainSelectedInstOperands,
     /*  35000 */     // GIR_Coverage, 1803,
     /*  35000 */     GIR_EraseRootFromParent_Done,
     /*  35001 */   // Label 555: @35001
     /*  35001 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35049), // Rule ID 990 //
     /*  35006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35036 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35047 */     GIR_RootConstrainSelectedInstOperands,
     /*  35048 */     // GIR_Coverage, 990,
     /*  35048 */     GIR_EraseRootFromParent_Done,
     /*  35049 */   // Label 556: @35049
     /*  35049 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35097), // Rule ID 1718 //
     /*  35054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35084 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35095 */     GIR_RootConstrainSelectedInstOperands,
     /*  35096 */     // GIR_Coverage, 1718,
     /*  35096 */     GIR_EraseRootFromParent_Done,
     /*  35097 */   // Label 557: @35097
     /*  35097 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35145), // Rule ID 1051 //
     /*  35102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35132 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35143 */     GIR_RootConstrainSelectedInstOperands,
     /*  35144 */     // GIR_Coverage, 1051,
     /*  35144 */     GIR_EraseRootFromParent_Done,
     /*  35145 */   // Label 558: @35145
     /*  35145 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35193), // Rule ID 1802 //
     /*  35150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35180 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35191 */     GIR_RootConstrainSelectedInstOperands,
     /*  35192 */     // GIR_Coverage, 1802,
     /*  35192 */     GIR_EraseRootFromParent_Done,
     /*  35193 */   // Label 559: @35193
     /*  35193 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35220), // Rule ID 1103 //
     /*  35198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35213 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35218 */     GIR_RootConstrainSelectedInstOperands,
     /*  35219 */     // GIR_Coverage, 1103,
     /*  35219 */     GIR_Done,
     /*  35220 */   // Label 560: @35220
     /*  35220 */   GIM_Reject,
     /*  35221 */ // Label 503: @35221
     /*  35221 */ GIM_Reject,
     /*  35222 */ // Label 163: @35222
     /*  35222 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35945),
     /*  35227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35233 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35302), // Rule ID 13366 //
     /*  35238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35253 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35256 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35265 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35285 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35300 */     GIR_RootConstrainSelectedInstOperands,
     /*  35301 */     // GIR_Coverage, 13366,
     /*  35301 */     GIR_EraseRootFromParent_Done,
     /*  35302 */   // Label 562: @35302
     /*  35302 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35371), // Rule ID 13378 //
     /*  35307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35322 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35325 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35334 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35354 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35369 */     GIR_RootConstrainSelectedInstOperands,
     /*  35370 */     // GIR_Coverage, 13378,
     /*  35370 */     GIR_EraseRootFromParent_Done,
     /*  35371 */   // Label 563: @35371
     /*  35371 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35438), // Rule ID 13570 //
     /*  35376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35400 */     // MIs[1] imm
     /*  35400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35408 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35412 */     // MIs[2] Operand 1
     /*  35412 */     // No operand predicates
     /*  35412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35422 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35436 */     GIR_RootConstrainSelectedInstOperands,
     /*  35437 */     // GIR_Coverage, 13570,
     /*  35437 */     GIR_EraseRootFromParent_Done,
     /*  35438 */   // Label 564: @35438
     /*  35438 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35505), // Rule ID 13591 //
     /*  35443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35467 */     // MIs[1] imm
     /*  35467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35479 */     // MIs[2] Operand 1
     /*  35479 */     // No operand predicates
     /*  35479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35489 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35503 */     GIR_RootConstrainSelectedInstOperands,
     /*  35504 */     // GIR_Coverage, 13591,
     /*  35504 */     GIR_EraseRootFromParent_Done,
     /*  35505 */   // Label 565: @35505
     /*  35505 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35574), // Rule ID 1359 //
     /*  35510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35529 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35532 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35541 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35557 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35572 */     GIR_RootConstrainSelectedInstOperands,
     /*  35573 */     // GIR_Coverage, 1359,
     /*  35573 */     GIR_EraseRootFromParent_Done,
     /*  35574 */   // Label 566: @35574
     /*  35574 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35643), // Rule ID 1482 //
     /*  35579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35598 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35601 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35610 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35626 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35641 */     GIR_RootConstrainSelectedInstOperands,
     /*  35642 */     // GIR_Coverage, 1482,
     /*  35642 */     GIR_EraseRootFromParent_Done,
     /*  35643 */   // Label 567: @35643
     /*  35643 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35710), // Rule ID 2232 //
     /*  35648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35676 */     // MIs[1] imm
     /*  35676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35684 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35688 */     // MIs[2] Operand 1
     /*  35688 */     // No operand predicates
     /*  35688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35694 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35708 */     GIR_RootConstrainSelectedInstOperands,
     /*  35709 */     // GIR_Coverage, 2232,
     /*  35709 */     GIR_EraseRootFromParent_Done,
     /*  35710 */   // Label 568: @35710
     /*  35710 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35777), // Rule ID 2291 //
     /*  35715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35743 */     // MIs[1] imm
     /*  35743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35751 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35755 */     // MIs[2] Operand 1
     /*  35755 */     // No operand predicates
     /*  35755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35761 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35775 */     GIR_RootConstrainSelectedInstOperands,
     /*  35776 */     // GIR_Coverage, 2291,
     /*  35776 */     GIR_EraseRootFromParent_Done,
     /*  35777 */   // Label 569: @35777
     /*  35777 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35847), // Rule ID 6937 //
     /*  35782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35820 */     // MIs[2] Rn
     /*  35820 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35825 */     // MIs[2] Rm
     /*  35825 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35832 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35845 */     GIR_RootConstrainSelectedInstOperands,
     /*  35846 */     // GIR_Coverage, 6937,
     /*  35846 */     GIR_EraseRootFromParent_Done,
     /*  35847 */   // Label 570: @35847
     /*  35847 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35917), // Rule ID 13962 //
     /*  35852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35890 */     // MIs[2] Rn
     /*  35890 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35895 */     // MIs[2] Rm
     /*  35895 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35902 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35915 */     GIR_RootConstrainSelectedInstOperands,
     /*  35916 */     // GIR_Coverage, 13962,
     /*  35916 */     GIR_EraseRootFromParent_Done,
     /*  35917 */   // Label 571: @35917
     /*  35917 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35944), // Rule ID 1101 //
     /*  35922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35937 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35942 */     GIR_RootConstrainSelectedInstOperands,
     /*  35943 */     // GIR_Coverage, 1101,
     /*  35943 */     GIR_Done,
     /*  35944 */   // Label 572: @35944
     /*  35944 */   GIM_Reject,
     /*  35945 */ // Label 561: @35945
     /*  35945 */ GIM_Reject,
     /*  35946 */ // Label 164: @35946
     /*  35946 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36317),
     /*  35951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35961 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36023), // Rule ID 15146 //
     /*  35966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  35993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  35997 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36010 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36021 */     GIR_RootConstrainSelectedInstOperands,
     /*  36022 */     // GIR_Coverage, 15146,
     /*  36022 */     GIR_EraseRootFromParent_Done,
     /*  36023 */   // Label 574: @36023
     /*  36023 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36085), // Rule ID 15145 //
     /*  36028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36059 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36072 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36083 */     GIR_RootConstrainSelectedInstOperands,
     /*  36084 */     // GIR_Coverage, 15145,
     /*  36084 */     GIR_EraseRootFromParent_Done,
     /*  36085 */   // Label 575: @36085
     /*  36085 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36147), // Rule ID 15144 //
     /*  36090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36121 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36134 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36145 */     GIR_RootConstrainSelectedInstOperands,
     /*  36146 */     // GIR_Coverage, 15144,
     /*  36146 */     GIR_EraseRootFromParent_Done,
     /*  36147 */   // Label 576: @36147
     /*  36147 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36209), // Rule ID 8912 //
     /*  36152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36183 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36196 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36207 */     GIR_RootConstrainSelectedInstOperands,
     /*  36208 */     // GIR_Coverage, 8912,
     /*  36208 */     GIR_EraseRootFromParent_Done,
     /*  36209 */   // Label 577: @36209
     /*  36209 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36255), // Rule ID 15147 //
     /*  36214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36229 */     // MIs[1] Operand 2
     /*  36229 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36242 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36253 */     GIR_RootConstrainSelectedInstOperands,
     /*  36254 */     // GIR_Coverage, 15147,
     /*  36254 */     GIR_EraseRootFromParent_Done,
     /*  36255 */   // Label 578: @36255
     /*  36255 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36301), // Rule ID 8913 //
     /*  36260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36275 */     // MIs[1] Operand 2
     /*  36275 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36288 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36299 */     GIR_RootConstrainSelectedInstOperands,
     /*  36300 */     // GIR_Coverage, 8913,
     /*  36300 */     GIR_EraseRootFromParent_Done,
     /*  36301 */   // Label 579: @36301
     /*  36301 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36316), // Rule ID 2780 //
     /*  36306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36309 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36314 */     GIR_RootConstrainSelectedInstOperands,
     /*  36315 */     // GIR_Coverage, 2780,
     /*  36315 */     GIR_Done,
     /*  36316 */   // Label 580: @36316
     /*  36316 */   GIM_Reject,
     /*  36317 */ // Label 573: @36317
     /*  36317 */ GIM_Reject,
     /*  36318 */ // Label 165: @36318
     /*  36318 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36343), // Rule ID 2779 //
     /*  36323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36336 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36341 */   GIR_RootConstrainSelectedInstOperands,
     /*  36342 */   // GIR_Coverage, 2779,
     /*  36342 */   GIR_Done,
     /*  36343 */ // Label 581: @36343
     /*  36343 */ GIM_Reject,
     /*  36344 */ // Label 166: @36344
     /*  36344 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36369), // Rule ID 2778 //
     /*  36349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36362 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36367 */   GIR_RootConstrainSelectedInstOperands,
     /*  36368 */   // GIR_Coverage, 2778,
     /*  36368 */   GIR_Done,
     /*  36369 */ // Label 582: @36369
     /*  36369 */ GIM_Reject,
     /*  36370 */ // Label 167: @36370
     /*  36370 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36395), // Rule ID 2777 //
     /*  36375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36388 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36393 */   GIR_RootConstrainSelectedInstOperands,
     /*  36394 */   // GIR_Coverage, 2777,
     /*  36394 */   GIR_Done,
     /*  36395 */ // Label 583: @36395
     /*  36395 */ GIM_Reject,
     /*  36396 */ // Label 168: @36396
     /*  36396 */ GIM_Reject,
     /*  36397 */ // Label 1: @36397
     /*  36397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 597*/ GIMT_Encode4(50624),
     /*  36408 */ /*GILLT_s32*//*Label 584*/ GIMT_Encode4(36496),
     /*  36412 */ /*GILLT_s64*//*Label 585*/ GIMT_Encode4(37978), GIMT_Encode4(0),
     /*  36420 */ /*GILLT_v2s32*//*Label 586*/ GIMT_Encode4(41260),
     /*  36424 */ /*GILLT_v2s64*//*Label 587*/ GIMT_Encode4(42751),
     /*  36428 */ /*GILLT_v4s16*//*Label 588*/ GIMT_Encode4(45211),
     /*  36432 */ /*GILLT_v4s32*//*Label 589*/ GIMT_Encode4(46702),
     /*  36436 */ /*GILLT_v8s8*//*Label 590*/ GIMT_Encode4(49162),
     /*  36440 */ /*GILLT_v8s16*//*Label 591*/ GIMT_Encode4(49237),
     /*  36444 */ /*GILLT_v16s8*//*Label 592*/ GIMT_Encode4(50445), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36464 */ /*GILLT_nxv2s64*//*Label 593*/ GIMT_Encode4(50520), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36476 */ /*GILLT_nxv4s32*//*Label 594*/ GIMT_Encode4(50546), GIMT_Encode4(0),
     /*  36484 */ /*GILLT_nxv8s16*//*Label 595*/ GIMT_Encode4(50572), GIMT_Encode4(0),
     /*  36492 */ /*GILLT_nxv16s8*//*Label 596*/ GIMT_Encode4(50598),
     /*  36496 */ // Label 584: @36496
     /*  36496 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(37977),
     /*  36501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36507 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36659), // Rule ID 9959 //
     /*  36512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36543 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36546 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36551 */     // MIs[2] pattern
     /*  36551 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36554 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36561 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36587 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36631 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36641 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36658 */     // GIR_Coverage, 9959,
     /*  36658 */     GIR_EraseRootFromParent_Done,
     /*  36659 */   // Label 599: @36659
     /*  36659 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36811), // Rule ID 9971 //
     /*  36664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36695 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36698 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36703 */     // MIs[2] pattern
     /*  36703 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36706 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36713 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36713 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36716 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36720 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36727 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36730 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36734 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36739 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36742 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36746 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36776 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36793 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36810 */     // GIR_Coverage, 9971,
     /*  36810 */     GIR_EraseRootFromParent_Done,
     /*  36811 */   // Label 600: @36811
     /*  36811 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36963), // Rule ID 9983 //
     /*  36816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36847 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36850 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36855 */     // MIs[2] pattern
     /*  36855 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36858 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36865 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36865 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36868 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36872 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36891 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36898 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36901 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36906 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36928 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36945 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36962 */     // GIR_Coverage, 9983,
     /*  36962 */     GIR_EraseRootFromParent_Done,
     /*  36963 */   // Label 601: @36963
     /*  36963 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(37115), // Rule ID 9995 //
     /*  36968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36999 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37002 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37007 */     // MIs[2] pattern
     /*  37007 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37010 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37017 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37017 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37020 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37024 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37043 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37046 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37050 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37058 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37063 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37080 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37087 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37097 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37114 */     // GIR_Coverage, 9995,
     /*  37114 */     GIR_EraseRootFromParent_Done,
     /*  37115 */   // Label 602: @37115
     /*  37115 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(37177), // Rule ID 3953 //
     /*  37120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37156 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37175 */     GIR_RootConstrainSelectedInstOperands,
     /*  37176 */     // GIR_Coverage, 3953,
     /*  37176 */     GIR_EraseRootFromParent_Done,
     /*  37177 */   // Label 603: @37177
     /*  37177 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(37334), // Rule ID 10097 //
     /*  37182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37213 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37216 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37232 */     // MIs[2] pred
     /*  37232 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37239 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37239 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37242 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37246 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37265 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37268 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37272 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37306 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37316 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37333 */     // GIR_Coverage, 10097,
     /*  37333 */     GIR_EraseRootFromParent_Done,
     /*  37334 */   // Label 604: @37334
     /*  37334 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37491), // Rule ID 10098 //
     /*  37339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37370 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37373 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37382 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37389 */     // MIs[2] pred
     /*  37389 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37396 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37396 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37399 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37403 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37422 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37425 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37429 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37432 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37437 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37473 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37490 */     // GIR_Coverage, 10098,
     /*  37490 */     GIR_EraseRootFromParent_Done,
     /*  37491 */   // Label 605: @37491
     /*  37491 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37648), // Rule ID 10099 //
     /*  37496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37527 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37530 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37539 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37546 */     // MIs[2] pred
     /*  37546 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37553 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37579 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37582 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37586 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37620 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37630 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37647 */     // GIR_Coverage, 10099,
     /*  37647 */     GIR_EraseRootFromParent_Done,
     /*  37648 */   // Label 606: @37648
     /*  37648 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37805), // Rule ID 10100 //
     /*  37653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37684 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37687 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37696 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37703 */     // MIs[2] pred
     /*  37703 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37710 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37710 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37713 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37717 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37736 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37739 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37743 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37746 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37787 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37804 */     // GIR_Coverage, 10100,
     /*  37804 */     GIR_EraseRootFromParent_Done,
     /*  37805 */   // Label 607: @37805
     /*  37805 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37841), // Rule ID 3918 //
     /*  37810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37825 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37830 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37839 */     GIR_RootConstrainSelectedInstOperands,
     /*  37840 */     // GIR_Coverage, 3918,
     /*  37840 */     GIR_EraseRootFromParent_Done,
     /*  37841 */   // Label 608: @37841
     /*  37841 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37874), // Rule ID 3923 //
     /*  37846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37861 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37872 */     GIR_RootConstrainSelectedInstOperands,
     /*  37873 */     // GIR_Coverage, 3923,
     /*  37873 */     GIR_EraseRootFromParent_Done,
     /*  37874 */   // Label 609: @37874
     /*  37874 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37910), // Rule ID 3912 //
     /*  37879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37894 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37901 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37908 */     GIR_RootConstrainSelectedInstOperands,
     /*  37909 */     // GIR_Coverage, 3912,
     /*  37909 */     GIR_EraseRootFromParent_Done,
     /*  37910 */   // Label 610: @37910
     /*  37910 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37946), // Rule ID 3916 //
     /*  37915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37930 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37937 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37944 */     GIR_RootConstrainSelectedInstOperands,
     /*  37945 */     // GIR_Coverage, 3916,
     /*  37945 */     GIR_EraseRootFromParent_Done,
     /*  37946 */   // Label 611: @37946
     /*  37946 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37976), // Rule ID 3914 //
     /*  37951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37963 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37968 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37974 */     GIR_RootConstrainSelectedInstOperands,
     /*  37975 */     // GIR_Coverage, 3914,
     /*  37975 */     GIR_Done,
     /*  37976 */   // Label 612: @37976
     /*  37976 */   GIM_Reject,
     /*  37977 */ // Label 598: @37977
     /*  37977 */ GIM_Reject,
     /*  37978 */ // Label 585: @37978
     /*  37978 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(41259),
     /*  37983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37989 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38125), // Rule ID 5401 //
     /*  37994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38027 */     // MIs[1] Operand 2
     /*  38027 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38046 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38058 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38062 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38067 */     // MIs[3] Operand 2
     /*  38067 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38078 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38080 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38107 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38124 */     // GIR_Coverage, 5401,
     /*  38124 */     GIR_EraseRootFromParent_Done,
     /*  38125 */   // Label 614: @38125
     /*  38125 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38261), // Rule ID 5400 //
     /*  38130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38163 */     // MIs[1] Operand 2
     /*  38163 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38182 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38186 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38190 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38194 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38198 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38203 */     // MIs[3] Operand 2
     /*  38203 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38214 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38216 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38243 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38260 */     // GIR_Coverage, 5400,
     /*  38260 */     GIR_EraseRootFromParent_Done,
     /*  38261 */   // Label 615: @38261
     /*  38261 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38397), // Rule ID 5410 //
     /*  38266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38299 */     // MIs[1] Operand 2
     /*  38299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38318 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38330 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38334 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38339 */     // MIs[3] Operand 2
     /*  38339 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38350 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38352 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38396 */     // GIR_Coverage, 5410,
     /*  38396 */     GIR_EraseRootFromParent_Done,
     /*  38397 */   // Label 616: @38397
     /*  38397 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38533), // Rule ID 5399 //
     /*  38402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38435 */     // MIs[1] Operand 2
     /*  38435 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38454 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38462 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38466 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38470 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38475 */     // MIs[3] Operand 2
     /*  38475 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38488 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38515 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38532 */     // GIR_Coverage, 5399,
     /*  38532 */     GIR_EraseRootFromParent_Done,
     /*  38533 */   // Label 617: @38533
     /*  38533 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38669), // Rule ID 5398 //
     /*  38538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38571 */     // MIs[1] Operand 2
     /*  38571 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38594 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38598 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38602 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38606 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38611 */     // MIs[3] Operand 2
     /*  38611 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38624 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38668 */     // GIR_Coverage, 5398,
     /*  38668 */     GIR_EraseRootFromParent_Done,
     /*  38669 */   // Label 618: @38669
     /*  38669 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38806), // Rule ID 3970 //
     /*  38674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38715 */     // MIs[2] Operand 2
     /*  38715 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38734 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38738 */     // MIs[3] Operand 1
     /*  38738 */     // No operand predicates
     /*  38738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38740 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38740 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38743 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38747 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38752 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38804 */     GIR_RootConstrainSelectedInstOperands,
     /*  38805 */     // GIR_Coverage, 3970,
     /*  38805 */     GIR_EraseRootFromParent_Done,
     /*  38806 */   // Label 619: @38806
     /*  38806 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38905), // Rule ID 3968 //
     /*  38811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38860 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38864 */     // MIs[3] Operand 1
     /*  38864 */     // No operand predicates
     /*  38864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38866 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38878 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38903 */     GIR_RootConstrainSelectedInstOperands,
     /*  38904 */     // GIR_Coverage, 3968,
     /*  38904 */     GIR_EraseRootFromParent_Done,
     /*  38905 */   // Label 620: @38905
     /*  38905 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(39004), // Rule ID 3969 //
     /*  38910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38963 */     // MIs[3] Operand 1
     /*  38963 */     // No operand predicates
     /*  38963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38965 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38977 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39002 */     GIR_RootConstrainSelectedInstOperands,
     /*  39003 */     // GIR_Coverage, 3969,
     /*  39003 */     GIR_EraseRootFromParent_Done,
     /*  39004 */   // Label 621: @39004
     /*  39004 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39090), // Rule ID 3963 //
     /*  39009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39062 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39069 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39088 */     GIR_RootConstrainSelectedInstOperands,
     /*  39089 */     // GIR_Coverage, 3963,
     /*  39089 */     GIR_EraseRootFromParent_Done,
     /*  39090 */   // Label 622: @39090
     /*  39090 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39176), // Rule ID 3964 //
     /*  39095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39144 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39148 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39155 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39174 */     GIR_RootConstrainSelectedInstOperands,
     /*  39175 */     // GIR_Coverage, 3964,
     /*  39175 */     GIR_EraseRootFromParent_Done,
     /*  39176 */   // Label 623: @39176
     /*  39176 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39309), // Rule ID 3976 //
     /*  39181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39222 */     // MIs[2] Operand 2
     /*  39222 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39241 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39245 */     // MIs[3] Operand 1
     /*  39245 */     // No operand predicates
     /*  39245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39247 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39259 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39278 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39307 */     GIR_RootConstrainSelectedInstOperands,
     /*  39308 */     // GIR_Coverage, 3976,
     /*  39308 */     GIR_EraseRootFromParent_Done,
     /*  39309 */   // Label 624: @39309
     /*  39309 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39404), // Rule ID 3974 //
     /*  39314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39363 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39367 */     // MIs[3] Operand 1
     /*  39367 */     // No operand predicates
     /*  39367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39369 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39381 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39402 */     GIR_RootConstrainSelectedInstOperands,
     /*  39403 */     // GIR_Coverage, 3974,
     /*  39403 */     GIR_EraseRootFromParent_Done,
     /*  39404 */   // Label 625: @39404
     /*  39404 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39499), // Rule ID 3975 //
     /*  39409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39458 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39462 */     // MIs[3] Operand 1
     /*  39462 */     // No operand predicates
     /*  39462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39464 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39476 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39497 */     GIR_RootConstrainSelectedInstOperands,
     /*  39498 */     // GIR_Coverage, 3975,
     /*  39498 */     GIR_EraseRootFromParent_Done,
     /*  39499 */   // Label 626: @39499
     /*  39499 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39581), // Rule ID 124 //
     /*  39504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39553 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39564 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39579 */     GIR_RootConstrainSelectedInstOperands,
     /*  39580 */     // GIR_Coverage, 124,
     /*  39580 */     GIR_EraseRootFromParent_Done,
     /*  39581 */   // Label 627: @39581
     /*  39581 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39663), // Rule ID 126 //
     /*  39586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39635 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39639 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39646 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39661 */     GIR_RootConstrainSelectedInstOperands,
     /*  39662 */     // GIR_Coverage, 126,
     /*  39662 */     GIR_EraseRootFromParent_Done,
     /*  39663 */   // Label 628: @39663
     /*  39663 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39725), // Rule ID 3954 //
     /*  39668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39704 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39723 */     GIR_RootConstrainSelectedInstOperands,
     /*  39724 */     // GIR_Coverage, 3954,
     /*  39724 */     GIR_EraseRootFromParent_Done,
     /*  39725 */   // Label 629: @39725
     /*  39725 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39783), // Rule ID 9956 //
     /*  39730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39749 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39752 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39757 */     // MIs[1] pattern
     /*  39757 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39760 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39767 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39781 */     GIR_RootConstrainSelectedInstOperands,
     /*  39782 */     // GIR_Coverage, 9956,
     /*  39782 */     GIR_EraseRootFromParent_Done,
     /*  39783 */   // Label 630: @39783
     /*  39783 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39841), // Rule ID 9968 //
     /*  39788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39807 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39810 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39815 */     // MIs[1] pattern
     /*  39815 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39818 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39825 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39839 */     GIR_RootConstrainSelectedInstOperands,
     /*  39840 */     // GIR_Coverage, 9968,
     /*  39840 */     GIR_EraseRootFromParent_Done,
     /*  39841 */   // Label 631: @39841
     /*  39841 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39899), // Rule ID 9980 //
     /*  39846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39865 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39868 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39873 */     // MIs[1] pattern
     /*  39873 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39876 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39883 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39897 */     GIR_RootConstrainSelectedInstOperands,
     /*  39898 */     // GIR_Coverage, 9980,
     /*  39898 */     GIR_EraseRootFromParent_Done,
     /*  39899 */   // Label 632: @39899
     /*  39899 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39957), // Rule ID 9992 //
     /*  39904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39923 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39926 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39931 */     // MIs[1] pattern
     /*  39931 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39934 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39941 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39955 */     GIR_RootConstrainSelectedInstOperands,
     /*  39956 */     // GIR_Coverage, 9992,
     /*  39956 */     GIR_EraseRootFromParent_Done,
     /*  39957 */   // Label 633: @39957
     /*  39957 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40120), // Rule ID 5365 //
     /*  39962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40008 */     // MIs[1] Operand 2
     /*  40008 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40021 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40084 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40087 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40102 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40119 */     // GIR_Coverage, 5365,
     /*  40119 */     GIR_EraseRootFromParent_Done,
     /*  40120 */   // Label 634: @40120
     /*  40120 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40283), // Rule ID 5362 //
     /*  40125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40171 */     // MIs[1] Operand 2
     /*  40171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40184 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40184 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40187 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40191 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40210 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40213 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40217 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40265 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40282 */     // GIR_Coverage, 5362,
     /*  40282 */     GIR_EraseRootFromParent_Done,
     /*  40283 */   // Label 635: @40283
     /*  40283 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40433), // Rule ID 5407 //
     /*  40288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40325 */     // MIs[1] Operand 2
     /*  40325 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40338 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40338 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40341 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40345 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40352 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40355 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40359 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40364 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40371 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40401 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40415 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40432 */     // GIR_Coverage, 5407,
     /*  40432 */     GIR_EraseRootFromParent_Done,
     /*  40433 */   // Label 636: @40433
     /*  40433 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40583), // Rule ID 5413 //
     /*  40438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40475 */     // MIs[1] Operand 2
     /*  40475 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40488 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40488 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40491 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40495 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40502 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40505 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40509 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40514 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40517 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40521 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40524 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40534 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40551 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40565 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40582 */     // GIR_Coverage, 5413,
     /*  40582 */     GIR_EraseRootFromParent_Done,
     /*  40583 */   // Label 637: @40583
     /*  40583 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40733), // Rule ID 5406 //
     /*  40588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40625 */     // MIs[1] Operand 2
     /*  40625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40638 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40638 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40641 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40645 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40652 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40655 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40659 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40664 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40671 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40674 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40701 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40715 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40732 */     // GIR_Coverage, 5406,
     /*  40732 */     GIR_EraseRootFromParent_Done,
     /*  40733 */   // Label 638: @40733
     /*  40733 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40769), // Rule ID 3919 //
     /*  40738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40753 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40758 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40767 */     GIR_RootConstrainSelectedInstOperands,
     /*  40768 */     // GIR_Coverage, 3919,
     /*  40768 */     GIR_EraseRootFromParent_Done,
     /*  40769 */   // Label 639: @40769
     /*  40769 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40802), // Rule ID 3924 //
     /*  40774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40789 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40800 */     GIR_RootConstrainSelectedInstOperands,
     /*  40801 */     // GIR_Coverage, 3924,
     /*  40801 */     GIR_EraseRootFromParent_Done,
     /*  40802 */   // Label 640: @40802
     /*  40802 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40838), // Rule ID 3913 //
     /*  40807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40822 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40836 */     GIR_RootConstrainSelectedInstOperands,
     /*  40837 */     // GIR_Coverage, 3913,
     /*  40837 */     GIR_EraseRootFromParent_Done,
     /*  40838 */   // Label 641: @40838
     /*  40838 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40874), // Rule ID 3917 //
     /*  40843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40858 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40872 */     GIR_RootConstrainSelectedInstOperands,
     /*  40873 */     // GIR_Coverage, 3917,
     /*  40873 */     GIR_EraseRootFromParent_Done,
     /*  40874 */   // Label 642: @40874
     /*  40874 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40937), // Rule ID 10089 //
     /*  40879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40898 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40901 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40910 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40917 */     // MIs[1] pred
     /*  40917 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40924 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40935 */     GIR_RootConstrainSelectedInstOperands,
     /*  40936 */     // GIR_Coverage, 10089,
     /*  40936 */     GIR_EraseRootFromParent_Done,
     /*  40937 */   // Label 643: @40937
     /*  40937 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41000), // Rule ID 10090 //
     /*  40942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40961 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40964 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40980 */     // MIs[1] pred
     /*  40980 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40987 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40998 */     GIR_RootConstrainSelectedInstOperands,
     /*  40999 */     // GIR_Coverage, 10090,
     /*  40999 */     GIR_EraseRootFromParent_Done,
     /*  41000 */   // Label 644: @41000
     /*  41000 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41063), // Rule ID 10091 //
     /*  41005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41024 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41027 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41036 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41043 */     // MIs[1] pred
     /*  41043 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41050 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41061 */     GIR_RootConstrainSelectedInstOperands,
     /*  41062 */     // GIR_Coverage, 10091,
     /*  41062 */     GIR_EraseRootFromParent_Done,
     /*  41063 */   // Label 645: @41063
     /*  41063 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41126), // Rule ID 10092 //
     /*  41068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41087 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41090 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41106 */     // MIs[1] pred
     /*  41106 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41113 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41124 */     GIR_RootConstrainSelectedInstOperands,
     /*  41125 */     // GIR_Coverage, 10092,
     /*  41125 */     GIR_EraseRootFromParent_Done,
     /*  41126 */   // Label 646: @41126
     /*  41126 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41165), // Rule ID 1655 //
     /*  41131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41142 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41148 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41156 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41163 */     GIR_RootConstrainSelectedInstOperands,
     /*  41164 */     // GIR_Coverage, 1655,
     /*  41164 */     GIR_EraseRootFromParent_Done,
     /*  41165 */   // Label 647: @41165
     /*  41165 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41201), // Rule ID 5248 //
     /*  41170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41178 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41184 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41192 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41199 */     GIR_RootConstrainSelectedInstOperands,
     /*  41200 */     // GIR_Coverage, 5248,
     /*  41200 */     GIR_EraseRootFromParent_Done,
     /*  41201 */   // Label 648: @41201
     /*  41201 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41228), // Rule ID 1644 //
     /*  41206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41221 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41226 */     GIR_RootConstrainSelectedInstOperands,
     /*  41227 */     // GIR_Coverage, 1644,
     /*  41227 */     GIR_Done,
     /*  41228 */   // Label 649: @41228
     /*  41228 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41258), // Rule ID 3915 //
     /*  41233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41245 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41250 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41256 */     GIR_RootConstrainSelectedInstOperands,
     /*  41257 */     // GIR_Coverage, 3915,
     /*  41257 */     GIR_Done,
     /*  41258 */   // Label 650: @41258
     /*  41258 */   GIM_Reject,
     /*  41259 */ // Label 613: @41259
     /*  41259 */ GIM_Reject,
     /*  41260 */ // Label 586: @41260
     /*  41260 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(42750),
     /*  41265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41275 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41407), // Rule ID 5397 //
     /*  41280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41309 */     // MIs[1] Operand 2
     /*  41309 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41332 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41336 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41340 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41344 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41349 */     // MIs[3] Operand 2
     /*  41349 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41360 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41362 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41406 */     // GIR_Coverage, 5397,
     /*  41406 */     GIR_EraseRootFromParent_Done,
     /*  41407 */   // Label 652: @41407
     /*  41407 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41539), // Rule ID 5396 //
     /*  41412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41441 */     // MIs[1] Operand 2
     /*  41441 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41468 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41472 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41476 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41481 */     // MIs[3] Operand 2
     /*  41481 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41492 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41494 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41521 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41538 */     // GIR_Coverage, 5396,
     /*  41538 */     GIR_EraseRootFromParent_Done,
     /*  41539 */   // Label 653: @41539
     /*  41539 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41671), // Rule ID 5409 //
     /*  41544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41573 */     // MIs[1] Operand 2
     /*  41573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41592 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41596 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41600 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41604 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41608 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41613 */     // MIs[3] Operand 2
     /*  41613 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41624 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41626 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41670 */     // GIR_Coverage, 5409,
     /*  41670 */     GIR_EraseRootFromParent_Done,
     /*  41671 */   // Label 654: @41671
     /*  41671 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41803), // Rule ID 5395 //
     /*  41676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41705 */     // MIs[1] Operand 2
     /*  41705 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41724 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41732 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41736 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41740 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41745 */     // MIs[3] Operand 2
     /*  41745 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41756 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41758 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41802 */     // GIR_Coverage, 5395,
     /*  41802 */     GIR_EraseRootFromParent_Done,
     /*  41803 */   // Label 655: @41803
     /*  41803 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41935), // Rule ID 5394 //
     /*  41808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41837 */     // MIs[1] Operand 2
     /*  41837 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41864 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41868 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41872 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41877 */     // MIs[3] Operand 2
     /*  41877 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41888 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41890 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41934 */     // GIR_Coverage, 5394,
     /*  41934 */     GIR_EraseRootFromParent_Done,
     /*  41935 */   // Label 656: @41935
     /*  41935 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42094), // Rule ID 5364 //
     /*  41940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41982 */     // MIs[1] Operand 2
     /*  41982 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41995 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41995 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  41998 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42002 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42009 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42012 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42016 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42021 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42024 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42028 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42058 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42076 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42093 */     // GIR_Coverage, 5364,
     /*  42093 */     GIR_EraseRootFromParent_Done,
     /*  42094 */   // Label 657: @42094
     /*  42094 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42253), // Rule ID 5361 //
     /*  42099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42141 */     // MIs[1] Operand 2
     /*  42141 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42154 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42154 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42157 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42161 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42168 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42171 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42175 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42180 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42187 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42190 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42195 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42235 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42252 */     // GIR_Coverage, 5361,
     /*  42252 */     GIR_EraseRootFromParent_Done,
     /*  42253 */   // Label 658: @42253
     /*  42253 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42399), // Rule ID 5405 //
     /*  42258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42291 */     // MIs[1] Operand 2
     /*  42291 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42304 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42304 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42307 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42311 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42330 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42337 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42398 */     // GIR_Coverage, 5405,
     /*  42398 */     GIR_EraseRootFromParent_Done,
     /*  42399 */   // Label 659: @42399
     /*  42399 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42545), // Rule ID 5412 //
     /*  42404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42437 */     // MIs[1] Operand 2
     /*  42437 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42450 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42450 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42453 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42457 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42464 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42467 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42471 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42476 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42483 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42486 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42491 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42496 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42513 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42527 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42544 */     // GIR_Coverage, 5412,
     /*  42544 */     GIR_EraseRootFromParent_Done,
     /*  42545 */   // Label 660: @42545
     /*  42545 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42691), // Rule ID 5404 //
     /*  42550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42583 */     // MIs[1] Operand 2
     /*  42583 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42596 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42596 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42599 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42603 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42622 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42629 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42673 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42690 */     // GIR_Coverage, 5404,
     /*  42690 */     GIR_EraseRootFromParent_Done,
     /*  42691 */   // Label 661: @42691
     /*  42691 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42726), // Rule ID 969 //
     /*  42696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42709 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42717 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42724 */     GIR_RootConstrainSelectedInstOperands,
     /*  42725 */     // GIR_Coverage, 969,
     /*  42725 */     GIR_EraseRootFromParent_Done,
     /*  42726 */   // Label 662: @42726
     /*  42726 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42749), // Rule ID 1476 //
     /*  42731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42742 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42747 */     GIR_RootConstrainSelectedInstOperands,
     /*  42748 */     // GIR_Coverage, 1476,
     /*  42748 */     GIR_Done,
     /*  42749 */   // Label 663: @42749
     /*  42749 */   GIM_Reject,
     /*  42750 */ // Label 651: @42750
     /*  42750 */ GIM_Reject,
     /*  42751 */ // Label 587: @42751
     /*  42751 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(45210),
     /*  42756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42766 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42880), // Rule ID 2048 //
     /*  42771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42822 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42835 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42839 */     // MIs[4] Operand 1
     /*  42839 */     // No operand predicates
     /*  42839 */     // MIs[2] Operand 2
     /*  42839 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42859 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42878 */     GIR_RootConstrainSelectedInstOperands,
     /*  42879 */     // GIR_Coverage, 2048,
     /*  42879 */     GIR_EraseRootFromParent_Done,
     /*  42880 */   // Label 665: @42880
     /*  42880 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42994), // Rule ID 13518 //
     /*  42885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42928 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42932 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42936 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42941 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42945 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42949 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42953 */     // MIs[4] Operand 1
     /*  42953 */     // No operand predicates
     /*  42953 */     // MIs[2] Operand 2
     /*  42953 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42964 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42973 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42992 */     GIR_RootConstrainSelectedInstOperands,
     /*  42993 */     // GIR_Coverage, 13518,
     /*  42993 */     GIR_EraseRootFromParent_Done,
     /*  42994 */   // Label 666: @42994
     /*  42994 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43108), // Rule ID 2100 //
     /*  42999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43042 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43046 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43050 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43055 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43059 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43063 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43067 */     // MIs[4] Operand 1
     /*  43067 */     // No operand predicates
     /*  43067 */     // MIs[2] Operand 2
     /*  43067 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43078 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43087 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43106 */     GIR_RootConstrainSelectedInstOperands,
     /*  43107 */     // GIR_Coverage, 2100,
     /*  43107 */     GIR_EraseRootFromParent_Done,
     /*  43108 */   // Label 667: @43108
     /*  43108 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43222), // Rule ID 13548 //
     /*  43113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43164 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43177 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43181 */     // MIs[4] Operand 1
     /*  43181 */     // No operand predicates
     /*  43181 */     // MIs[2] Operand 2
     /*  43181 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43192 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43201 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43220 */     GIR_RootConstrainSelectedInstOperands,
     /*  43221 */     // GIR_Coverage, 13548,
     /*  43221 */     GIR_EraseRootFromParent_Done,
     /*  43222 */   // Label 668: @43222
     /*  43222 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43287), // Rule ID 1855 //
     /*  43227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43270 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43285 */     GIR_RootConstrainSelectedInstOperands,
     /*  43286 */     // GIR_Coverage, 1855,
     /*  43286 */     GIR_EraseRootFromParent_Done,
     /*  43287 */   // Label 669: @43287
     /*  43287 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43352), // Rule ID 1854 //
     /*  43292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43335 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43350 */     GIR_RootConstrainSelectedInstOperands,
     /*  43351 */     // GIR_Coverage, 1854,
     /*  43351 */     GIR_EraseRootFromParent_Done,
     /*  43352 */   // Label 670: @43352
     /*  43352 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43417), // Rule ID 1759 //
     /*  43357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43393 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43400 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43415 */     GIR_RootConstrainSelectedInstOperands,
     /*  43416 */     // GIR_Coverage, 1759,
     /*  43416 */     GIR_EraseRootFromParent_Done,
     /*  43417 */   // Label 671: @43417
     /*  43417 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43482), // Rule ID 1853 //
     /*  43422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43465 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43480 */     GIR_RootConstrainSelectedInstOperands,
     /*  43481 */     // GIR_Coverage, 1853,
     /*  43481 */     GIR_EraseRootFromParent_Done,
     /*  43482 */   // Label 672: @43482
     /*  43482 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43547), // Rule ID 1852 //
     /*  43487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43530 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43545 */     GIR_RootConstrainSelectedInstOperands,
     /*  43546 */     // GIR_Coverage, 1852,
     /*  43546 */     GIR_EraseRootFromParent_Done,
     /*  43547 */   // Label 673: @43547
     /*  43547 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43658), // Rule ID 13516 //
     /*  43552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43595 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43599 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43603 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43616 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43620 */     // MIs[4] Operand 1
     /*  43620 */     // No operand predicates
     /*  43620 */     // MIs[2] Operand 2
     /*  43620 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43638 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43656 */     GIR_RootConstrainSelectedInstOperands,
     /*  43657 */     // GIR_Coverage, 13516,
     /*  43657 */     GIR_EraseRootFromParent_Done,
     /*  43658 */   // Label 674: @43658
     /*  43658 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43769), // Rule ID 2046 //
     /*  43663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43711 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43715 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43719 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43724 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43728 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43732 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43736 */     // MIs[4] Operand 1
     /*  43736 */     // No operand predicates
     /*  43736 */     // MIs[2] Operand 2
     /*  43736 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43749 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43767 */     GIR_RootConstrainSelectedInstOperands,
     /*  43768 */     // GIR_Coverage, 2046,
     /*  43768 */     GIR_EraseRootFromParent_Done,
     /*  43769 */   // Label 675: @43769
     /*  43769 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43880), // Rule ID 13546 //
     /*  43774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43830 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43834 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43838 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43842 */     // MIs[4] Operand 1
     /*  43842 */     // No operand predicates
     /*  43842 */     // MIs[2] Operand 2
     /*  43842 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43858 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43860 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43878 */     GIR_RootConstrainSelectedInstOperands,
     /*  43879 */     // GIR_Coverage, 13546,
     /*  43879 */     GIR_EraseRootFromParent_Done,
     /*  43880 */   // Label 676: @43880
     /*  43880 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43991), // Rule ID 2098 //
     /*  43885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43933 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43937 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43950 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43954 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43958 */     // MIs[4] Operand 1
     /*  43958 */     // No operand predicates
     /*  43958 */     // MIs[2] Operand 2
     /*  43958 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43969 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43971 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43989 */     GIR_RootConstrainSelectedInstOperands,
     /*  43990 */     // GIR_Coverage, 2098,
     /*  43990 */     GIR_EraseRootFromParent_Done,
     /*  43991 */   // Label 677: @43991
     /*  43991 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44054), // Rule ID 1735 //
     /*  43996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44035 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44052 */     GIR_RootConstrainSelectedInstOperands,
     /*  44053 */     // GIR_Coverage, 1735,
     /*  44053 */     GIR_EraseRootFromParent_Done,
     /*  44054 */   // Label 678: @44054
     /*  44054 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44117), // Rule ID 1825 //
     /*  44059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44098 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44115 */     GIR_RootConstrainSelectedInstOperands,
     /*  44116 */     // GIR_Coverage, 1825,
     /*  44116 */     GIR_EraseRootFromParent_Done,
     /*  44117 */   // Label 679: @44117
     /*  44117 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44205), // Rule ID 13517 //
     /*  44122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44174 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44178 */     // MIs[3] Operand 1
     /*  44178 */     // No operand predicates
     /*  44178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44185 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44203 */     GIR_RootConstrainSelectedInstOperands,
     /*  44204 */     // GIR_Coverage, 13517,
     /*  44204 */     GIR_EraseRootFromParent_Done,
     /*  44205 */   // Label 680: @44205
     /*  44205 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44293), // Rule ID 2047 //
     /*  44210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44271 */     // MIs[3] Operand 1
     /*  44271 */     // No operand predicates
     /*  44271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44273 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44291 */     GIR_RootConstrainSelectedInstOperands,
     /*  44292 */     // GIR_Coverage, 2047,
     /*  44292 */     GIR_EraseRootFromParent_Done,
     /*  44293 */   // Label 681: @44293
     /*  44293 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44381), // Rule ID 13547 //
     /*  44298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44350 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44354 */     // MIs[3] Operand 1
     /*  44354 */     // No operand predicates
     /*  44354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44361 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44379 */     GIR_RootConstrainSelectedInstOperands,
     /*  44380 */     // GIR_Coverage, 13547,
     /*  44380 */     GIR_EraseRootFromParent_Done,
     /*  44381 */   // Label 682: @44381
     /*  44381 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44469), // Rule ID 2099 //
     /*  44386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44443 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44447 */     // MIs[3] Operand 1
     /*  44447 */     // No operand predicates
     /*  44447 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44449 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44467 */     GIR_RootConstrainSelectedInstOperands,
     /*  44468 */     // GIR_Coverage, 2099,
     /*  44468 */     GIR_EraseRootFromParent_Done,
     /*  44469 */   // Label 683: @44469
     /*  44469 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44516), // Rule ID 1867 //
     /*  44474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44502 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44514 */     GIR_RootConstrainSelectedInstOperands,
     /*  44515 */     // GIR_Coverage, 1867,
     /*  44515 */     GIR_EraseRootFromParent_Done,
     /*  44516 */   // Label 684: @44516
     /*  44516 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44563), // Rule ID 1765 //
     /*  44521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44549 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44561 */     GIR_RootConstrainSelectedInstOperands,
     /*  44562 */     // GIR_Coverage, 1765,
     /*  44562 */     GIR_EraseRootFromParent_Done,
     /*  44563 */   // Label 685: @44563
     /*  44563 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44610), // Rule ID 1866 //
     /*  44568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44596 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44608 */     GIR_RootConstrainSelectedInstOperands,
     /*  44609 */     // GIR_Coverage, 1866,
     /*  44609 */     GIR_EraseRootFromParent_Done,
     /*  44610 */   // Label 686: @44610
     /*  44610 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44669), // Rule ID 1851 //
     /*  44615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44654 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44667 */     GIR_RootConstrainSelectedInstOperands,
     /*  44668 */     // GIR_Coverage, 1851,
     /*  44668 */     GIR_EraseRootFromParent_Done,
     /*  44669 */   // Label 687: @44669
     /*  44669 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44728), // Rule ID 1850 //
     /*  44674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44713 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44726 */     GIR_RootConstrainSelectedInstOperands,
     /*  44727 */     // GIR_Coverage, 1850,
     /*  44727 */     GIR_EraseRootFromParent_Done,
     /*  44728 */   // Label 688: @44728
     /*  44728 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44787), // Rule ID 1758 //
     /*  44733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44772 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44785 */     GIR_RootConstrainSelectedInstOperands,
     /*  44786 */     // GIR_Coverage, 1758,
     /*  44786 */     GIR_EraseRootFromParent_Done,
     /*  44787 */   // Label 689: @44787
     /*  44787 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44846), // Rule ID 1849 //
     /*  44792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44831 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44844 */     GIR_RootConstrainSelectedInstOperands,
     /*  44845 */     // GIR_Coverage, 1849,
     /*  44845 */     GIR_EraseRootFromParent_Done,
     /*  44846 */   // Label 690: @44846
     /*  44846 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44905), // Rule ID 1848 //
     /*  44851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44890 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44903 */     GIR_RootConstrainSelectedInstOperands,
     /*  44904 */     // GIR_Coverage, 1848,
     /*  44904 */     GIR_EraseRootFromParent_Done,
     /*  44905 */   // Label 691: @44905
     /*  44905 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44940), // Rule ID 971 //
     /*  44910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44917 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44923 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44931 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44938 */     GIR_RootConstrainSelectedInstOperands,
     /*  44939 */     // GIR_Coverage, 971,
     /*  44939 */     GIR_EraseRootFromParent_Done,
     /*  44940 */   // Label 692: @44940
     /*  44940 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44997), // Rule ID 1734 //
     /*  44945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44980 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  44995 */     GIR_RootConstrainSelectedInstOperands,
     /*  44996 */     // GIR_Coverage, 1734,
     /*  44996 */     GIR_EraseRootFromParent_Done,
     /*  44997 */   // Label 693: @44997
     /*  44997 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45054), // Rule ID 1824 //
     /*  45002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45037 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45052 */     GIR_RootConstrainSelectedInstOperands,
     /*  45053 */     // GIR_Coverage, 1824,
     /*  45053 */     GIR_EraseRootFromParent_Done,
     /*  45054 */   // Label 694: @45054
     /*  45054 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45098), // Rule ID 1865 //
     /*  45059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45085 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45096 */     GIR_RootConstrainSelectedInstOperands,
     /*  45097 */     // GIR_Coverage, 1865,
     /*  45097 */     GIR_EraseRootFromParent_Done,
     /*  45098 */   // Label 695: @45098
     /*  45098 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45142), // Rule ID 1764 //
     /*  45103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45129 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45140 */     GIR_RootConstrainSelectedInstOperands,
     /*  45141 */     // GIR_Coverage, 1764,
     /*  45141 */     GIR_EraseRootFromParent_Done,
     /*  45142 */   // Label 696: @45142
     /*  45142 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45186), // Rule ID 1864 //
     /*  45147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45173 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45184 */     GIR_RootConstrainSelectedInstOperands,
     /*  45185 */     // GIR_Coverage, 1864,
     /*  45185 */     GIR_EraseRootFromParent_Done,
     /*  45186 */   // Label 697: @45186
     /*  45186 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45209), // Rule ID 1478 //
     /*  45191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45202 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45207 */     GIR_RootConstrainSelectedInstOperands,
     /*  45208 */     // GIR_Coverage, 1478,
     /*  45208 */     GIR_Done,
     /*  45209 */   // Label 698: @45209
     /*  45209 */   GIM_Reject,
     /*  45210 */ // Label 664: @45210
     /*  45210 */ GIM_Reject,
     /*  45211 */ // Label 588: @45211
     /*  45211 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(46701),
     /*  45216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45226 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45358), // Rule ID 5393 //
     /*  45231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45260 */     // MIs[1] Operand 2
     /*  45260 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45279 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45283 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45287 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45291 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45295 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45300 */     // MIs[3] Operand 2
     /*  45300 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45311 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45313 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45340 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45357 */     // GIR_Coverage, 5393,
     /*  45357 */     GIR_EraseRootFromParent_Done,
     /*  45358 */   // Label 700: @45358
     /*  45358 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45490), // Rule ID 5392 //
     /*  45363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45392 */     // MIs[1] Operand 2
     /*  45392 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45411 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45415 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45419 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45423 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45427 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45432 */     // MIs[3] Operand 2
     /*  45432 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45443 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45445 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45472 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45489 */     // GIR_Coverage, 5392,
     /*  45489 */     GIR_EraseRootFromParent_Done,
     /*  45490 */   // Label 701: @45490
     /*  45490 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45622), // Rule ID 5408 //
     /*  45495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45524 */     // MIs[1] Operand 2
     /*  45524 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45543 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45547 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45551 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45555 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45559 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45564 */     // MIs[3] Operand 2
     /*  45564 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45575 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45577 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45621 */     // GIR_Coverage, 5408,
     /*  45621 */     GIR_EraseRootFromParent_Done,
     /*  45622 */   // Label 702: @45622
     /*  45622 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45754), // Rule ID 5391 //
     /*  45627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45656 */     // MIs[1] Operand 2
     /*  45656 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45675 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45679 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45683 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45687 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45691 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45696 */     // MIs[3] Operand 2
     /*  45696 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45707 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45709 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45725 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45736 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45753 */     // GIR_Coverage, 5391,
     /*  45753 */     GIR_EraseRootFromParent_Done,
     /*  45754 */   // Label 703: @45754
     /*  45754 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45886), // Rule ID 5390 //
     /*  45759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45788 */     // MIs[1] Operand 2
     /*  45788 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45807 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45819 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45823 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45828 */     // MIs[3] Operand 2
     /*  45828 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45839 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45841 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45868 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45885 */     // GIR_Coverage, 5390,
     /*  45885 */     GIR_EraseRootFromParent_Done,
     /*  45886 */   // Label 704: @45886
     /*  45886 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46045), // Rule ID 5363 //
     /*  45891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45933 */     // MIs[1] Operand 2
     /*  45933 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45946 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45972 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45979 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45992 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  46004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46027 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46044 */     // GIR_Coverage, 5363,
     /*  46044 */     GIR_EraseRootFromParent_Done,
     /*  46045 */   // Label 705: @46045
     /*  46045 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46204), // Rule ID 5360 //
     /*  46050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46092 */     // MIs[1] Operand 2
     /*  46092 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46105 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46119 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46122 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46126 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46131 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46138 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46141 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46146 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46151 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46168 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46186 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46203 */     // GIR_Coverage, 5360,
     /*  46203 */     GIR_EraseRootFromParent_Done,
     /*  46204 */   // Label 706: @46204
     /*  46204 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46350), // Rule ID 5403 //
     /*  46209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46242 */     // MIs[1] Operand 2
     /*  46242 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46255 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46255 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46258 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46262 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46269 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46272 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46276 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46281 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46284 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46288 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46296 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46301 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46332 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46349 */     // GIR_Coverage, 5403,
     /*  46349 */     GIR_EraseRootFromParent_Done,
     /*  46350 */   // Label 707: @46350
     /*  46350 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46496), // Rule ID 5411 //
     /*  46355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46388 */     // MIs[1] Operand 2
     /*  46388 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46401 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46401 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46404 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46408 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46427 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46430 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46434 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46437 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46464 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46478 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46495 */     // GIR_Coverage, 5411,
     /*  46495 */     GIR_EraseRootFromParent_Done,
     /*  46496 */   // Label 708: @46496
     /*  46496 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46642), // Rule ID 5402 //
     /*  46501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46534 */     // MIs[1] Operand 2
     /*  46534 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46547 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46547 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46550 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46554 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46561 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46564 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46568 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46573 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46576 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46580 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46610 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46613 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46624 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46641 */     // GIR_Coverage, 5402,
     /*  46641 */     GIR_EraseRootFromParent_Done,
     /*  46642 */   // Label 709: @46642
     /*  46642 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46677), // Rule ID 967 //
     /*  46647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46654 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46660 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46668 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46675 */     GIR_RootConstrainSelectedInstOperands,
     /*  46676 */     // GIR_Coverage, 967,
     /*  46676 */     GIR_EraseRootFromParent_Done,
     /*  46677 */   // Label 710: @46677
     /*  46677 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46700), // Rule ID 1474 //
     /*  46682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46693 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46698 */     GIR_RootConstrainSelectedInstOperands,
     /*  46699 */     // GIR_Coverage, 1474,
     /*  46699 */     GIR_Done,
     /*  46700 */   // Label 711: @46700
     /*  46700 */   GIM_Reject,
     /*  46701 */ // Label 699: @46701
     /*  46701 */ GIM_Reject,
     /*  46702 */ // Label 589: @46702
     /*  46702 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(49161),
     /*  46707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46717 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46831), // Rule ID 2045 //
     /*  46722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46765 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46769 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46773 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46778 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46782 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46786 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46790 */     // MIs[4] Operand 1
     /*  46790 */     // No operand predicates
     /*  46790 */     // MIs[2] Operand 2
     /*  46790 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46801 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46810 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46829 */     GIR_RootConstrainSelectedInstOperands,
     /*  46830 */     // GIR_Coverage, 2045,
     /*  46830 */     GIR_EraseRootFromParent_Done,
     /*  46831 */   // Label 713: @46831
     /*  46831 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46945), // Rule ID 13515 //
     /*  46836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46879 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46883 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46887 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46900 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46904 */     // MIs[4] Operand 1
     /*  46904 */     // No operand predicates
     /*  46904 */     // MIs[2] Operand 2
     /*  46904 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46915 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46924 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46943 */     GIR_RootConstrainSelectedInstOperands,
     /*  46944 */     // GIR_Coverage, 13515,
     /*  46944 */     GIR_EraseRootFromParent_Done,
     /*  46945 */   // Label 714: @46945
     /*  46945 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(47059), // Rule ID 2097 //
     /*  46950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46993 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46997 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47001 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47006 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47010 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47014 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47018 */     // MIs[4] Operand 1
     /*  47018 */     // No operand predicates
     /*  47018 */     // MIs[2] Operand 2
     /*  47018 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47029 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47038 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47057 */     GIR_RootConstrainSelectedInstOperands,
     /*  47058 */     // GIR_Coverage, 2097,
     /*  47058 */     GIR_EraseRootFromParent_Done,
     /*  47059 */   // Label 715: @47059
     /*  47059 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47173), // Rule ID 13545 //
     /*  47064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47115 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47124 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47128 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47132 */     // MIs[4] Operand 1
     /*  47132 */     // No operand predicates
     /*  47132 */     // MIs[2] Operand 2
     /*  47132 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47143 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47152 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47171 */     GIR_RootConstrainSelectedInstOperands,
     /*  47172 */     // GIR_Coverage, 13545,
     /*  47172 */     GIR_EraseRootFromParent_Done,
     /*  47173 */   // Label 716: @47173
     /*  47173 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47238), // Rule ID 1847 //
     /*  47178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47221 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47236 */     GIR_RootConstrainSelectedInstOperands,
     /*  47237 */     // GIR_Coverage, 1847,
     /*  47237 */     GIR_EraseRootFromParent_Done,
     /*  47238 */   // Label 717: @47238
     /*  47238 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47303), // Rule ID 1846 //
     /*  47243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47286 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47301 */     GIR_RootConstrainSelectedInstOperands,
     /*  47302 */     // GIR_Coverage, 1846,
     /*  47302 */     GIR_EraseRootFromParent_Done,
     /*  47303 */   // Label 718: @47303
     /*  47303 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47368), // Rule ID 1757 //
     /*  47308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47351 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47366 */     GIR_RootConstrainSelectedInstOperands,
     /*  47367 */     // GIR_Coverage, 1757,
     /*  47367 */     GIR_EraseRootFromParent_Done,
     /*  47368 */   // Label 719: @47368
     /*  47368 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47433), // Rule ID 1845 //
     /*  47373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47416 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47431 */     GIR_RootConstrainSelectedInstOperands,
     /*  47432 */     // GIR_Coverage, 1845,
     /*  47432 */     GIR_EraseRootFromParent_Done,
     /*  47433 */   // Label 720: @47433
     /*  47433 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47498), // Rule ID 1844 //
     /*  47438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47481 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47496 */     GIR_RootConstrainSelectedInstOperands,
     /*  47497 */     // GIR_Coverage, 1844,
     /*  47497 */     GIR_EraseRootFromParent_Done,
     /*  47498 */   // Label 721: @47498
     /*  47498 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47609), // Rule ID 13513 //
     /*  47503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47546 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47550 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47554 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47559 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47563 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47567 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47571 */     // MIs[4] Operand 1
     /*  47571 */     // No operand predicates
     /*  47571 */     // MIs[2] Operand 2
     /*  47571 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47587 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47589 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47607 */     GIR_RootConstrainSelectedInstOperands,
     /*  47608 */     // GIR_Coverage, 13513,
     /*  47608 */     GIR_EraseRootFromParent_Done,
     /*  47609 */   // Label 722: @47609
     /*  47609 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47720), // Rule ID 2043 //
     /*  47614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47662 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47666 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47670 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47679 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47683 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47687 */     // MIs[4] Operand 1
     /*  47687 */     // No operand predicates
     /*  47687 */     // MIs[2] Operand 2
     /*  47687 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47698 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47700 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47718 */     GIR_RootConstrainSelectedInstOperands,
     /*  47719 */     // GIR_Coverage, 2043,
     /*  47719 */     GIR_EraseRootFromParent_Done,
     /*  47720 */   // Label 723: @47720
     /*  47720 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47831), // Rule ID 13543 //
     /*  47725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47768 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47772 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47776 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47781 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47785 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47789 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47793 */     // MIs[4] Operand 1
     /*  47793 */     // No operand predicates
     /*  47793 */     // MIs[2] Operand 2
     /*  47793 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47811 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47829 */     GIR_RootConstrainSelectedInstOperands,
     /*  47830 */     // GIR_Coverage, 13543,
     /*  47830 */     GIR_EraseRootFromParent_Done,
     /*  47831 */   // Label 724: @47831
     /*  47831 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47942), // Rule ID 2095 //
     /*  47836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47892 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47901 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47905 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47909 */     // MIs[4] Operand 1
     /*  47909 */     // No operand predicates
     /*  47909 */     // MIs[2] Operand 2
     /*  47909 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47920 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47922 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47940 */     GIR_RootConstrainSelectedInstOperands,
     /*  47941 */     // GIR_Coverage, 2095,
     /*  47941 */     GIR_EraseRootFromParent_Done,
     /*  47942 */   // Label 725: @47942
     /*  47942 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48005), // Rule ID 1733 //
     /*  47947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47986 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48003 */     GIR_RootConstrainSelectedInstOperands,
     /*  48004 */     // GIR_Coverage, 1733,
     /*  48004 */     GIR_EraseRootFromParent_Done,
     /*  48005 */   // Label 726: @48005
     /*  48005 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48068), // Rule ID 1823 //
     /*  48010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48049 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48066 */     GIR_RootConstrainSelectedInstOperands,
     /*  48067 */     // GIR_Coverage, 1823,
     /*  48067 */     GIR_EraseRootFromParent_Done,
     /*  48068 */   // Label 727: @48068
     /*  48068 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48156), // Rule ID 13514 //
     /*  48073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48125 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48129 */     // MIs[3] Operand 1
     /*  48129 */     // No operand predicates
     /*  48129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48136 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48154 */     GIR_RootConstrainSelectedInstOperands,
     /*  48155 */     // GIR_Coverage, 13514,
     /*  48155 */     GIR_EraseRootFromParent_Done,
     /*  48156 */   // Label 728: @48156
     /*  48156 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48244), // Rule ID 2044 //
     /*  48161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48218 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48222 */     // MIs[3] Operand 1
     /*  48222 */     // No operand predicates
     /*  48222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48224 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48242 */     GIR_RootConstrainSelectedInstOperands,
     /*  48243 */     // GIR_Coverage, 2044,
     /*  48243 */     GIR_EraseRootFromParent_Done,
     /*  48244 */   // Label 729: @48244
     /*  48244 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48332), // Rule ID 13544 //
     /*  48249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48301 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48305 */     // MIs[3] Operand 1
     /*  48305 */     // No operand predicates
     /*  48305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48312 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48330 */     GIR_RootConstrainSelectedInstOperands,
     /*  48331 */     // GIR_Coverage, 13544,
     /*  48331 */     GIR_EraseRootFromParent_Done,
     /*  48332 */   // Label 730: @48332
     /*  48332 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48420), // Rule ID 2096 //
     /*  48337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48394 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48398 */     // MIs[3] Operand 1
     /*  48398 */     // No operand predicates
     /*  48398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48400 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48418 */     GIR_RootConstrainSelectedInstOperands,
     /*  48419 */     // GIR_Coverage, 2096,
     /*  48419 */     GIR_EraseRootFromParent_Done,
     /*  48420 */   // Label 731: @48420
     /*  48420 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48467), // Rule ID 1863 //
     /*  48425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48453 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48465 */     GIR_RootConstrainSelectedInstOperands,
     /*  48466 */     // GIR_Coverage, 1863,
     /*  48466 */     GIR_EraseRootFromParent_Done,
     /*  48467 */   // Label 732: @48467
     /*  48467 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48514), // Rule ID 1763 //
     /*  48472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48500 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48512 */     GIR_RootConstrainSelectedInstOperands,
     /*  48513 */     // GIR_Coverage, 1763,
     /*  48513 */     GIR_EraseRootFromParent_Done,
     /*  48514 */   // Label 733: @48514
     /*  48514 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48561), // Rule ID 1862 //
     /*  48519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48547 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48559 */     GIR_RootConstrainSelectedInstOperands,
     /*  48560 */     // GIR_Coverage, 1862,
     /*  48560 */     GIR_EraseRootFromParent_Done,
     /*  48561 */   // Label 734: @48561
     /*  48561 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48620), // Rule ID 1843 //
     /*  48566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48605 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48618 */     GIR_RootConstrainSelectedInstOperands,
     /*  48619 */     // GIR_Coverage, 1843,
     /*  48619 */     GIR_EraseRootFromParent_Done,
     /*  48620 */   // Label 735: @48620
     /*  48620 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48679), // Rule ID 1842 //
     /*  48625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48664 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48677 */     GIR_RootConstrainSelectedInstOperands,
     /*  48678 */     // GIR_Coverage, 1842,
     /*  48678 */     GIR_EraseRootFromParent_Done,
     /*  48679 */   // Label 736: @48679
     /*  48679 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48738), // Rule ID 1756 //
     /*  48684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48723 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48736 */     GIR_RootConstrainSelectedInstOperands,
     /*  48737 */     // GIR_Coverage, 1756,
     /*  48737 */     GIR_EraseRootFromParent_Done,
     /*  48738 */   // Label 737: @48738
     /*  48738 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48797), // Rule ID 1841 //
     /*  48743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48782 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48795 */     GIR_RootConstrainSelectedInstOperands,
     /*  48796 */     // GIR_Coverage, 1841,
     /*  48796 */     GIR_EraseRootFromParent_Done,
     /*  48797 */   // Label 738: @48797
     /*  48797 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48856), // Rule ID 1840 //
     /*  48802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48841 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48854 */     GIR_RootConstrainSelectedInstOperands,
     /*  48855 */     // GIR_Coverage, 1840,
     /*  48855 */     GIR_EraseRootFromParent_Done,
     /*  48856 */   // Label 739: @48856
     /*  48856 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48891), // Rule ID 970 //
     /*  48861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48868 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48874 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48882 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48889 */     GIR_RootConstrainSelectedInstOperands,
     /*  48890 */     // GIR_Coverage, 970,
     /*  48890 */     GIR_EraseRootFromParent_Done,
     /*  48891 */   // Label 740: @48891
     /*  48891 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48948), // Rule ID 1732 //
     /*  48896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48931 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48946 */     GIR_RootConstrainSelectedInstOperands,
     /*  48947 */     // GIR_Coverage, 1732,
     /*  48947 */     GIR_EraseRootFromParent_Done,
     /*  48948 */   // Label 741: @48948
     /*  48948 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49005), // Rule ID 1822 //
     /*  48953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48988 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49003 */     GIR_RootConstrainSelectedInstOperands,
     /*  49004 */     // GIR_Coverage, 1822,
     /*  49004 */     GIR_EraseRootFromParent_Done,
     /*  49005 */   // Label 742: @49005
     /*  49005 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49049), // Rule ID 1861 //
     /*  49010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49036 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49047 */     GIR_RootConstrainSelectedInstOperands,
     /*  49048 */     // GIR_Coverage, 1861,
     /*  49048 */     GIR_EraseRootFromParent_Done,
     /*  49049 */   // Label 743: @49049
     /*  49049 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49093), // Rule ID 1762 //
     /*  49054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49080 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49091 */     GIR_RootConstrainSelectedInstOperands,
     /*  49092 */     // GIR_Coverage, 1762,
     /*  49092 */     GIR_EraseRootFromParent_Done,
     /*  49093 */   // Label 744: @49093
     /*  49093 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49137), // Rule ID 1860 //
     /*  49098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49124 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49135 */     GIR_RootConstrainSelectedInstOperands,
     /*  49136 */     // GIR_Coverage, 1860,
     /*  49136 */     GIR_EraseRootFromParent_Done,
     /*  49137 */   // Label 745: @49137
     /*  49137 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49160), // Rule ID 1477 //
     /*  49142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49153 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49158 */     GIR_RootConstrainSelectedInstOperands,
     /*  49159 */     // GIR_Coverage, 1477,
     /*  49159 */     GIR_Done,
     /*  49160 */   // Label 746: @49160
     /*  49160 */   GIM_Reject,
     /*  49161 */ // Label 712: @49161
     /*  49161 */ GIM_Reject,
     /*  49162 */ // Label 590: @49162
     /*  49162 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49236),
     /*  49167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49177 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49212), // Rule ID 965 //
     /*  49182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49203 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49210 */     GIR_RootConstrainSelectedInstOperands,
     /*  49211 */     // GIR_Coverage, 965,
     /*  49211 */     GIR_EraseRootFromParent_Done,
     /*  49212 */   // Label 748: @49212
     /*  49212 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49235), // Rule ID 1472 //
     /*  49217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49228 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49233 */     GIR_RootConstrainSelectedInstOperands,
     /*  49234 */     // GIR_Coverage, 1472,
     /*  49234 */     GIR_Done,
     /*  49235 */   // Label 749: @49235
     /*  49235 */   GIM_Reject,
     /*  49236 */ // Label 747: @49236
     /*  49236 */ GIM_Reject,
     /*  49237 */ // Label 591: @49237
     /*  49237 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(50444),
     /*  49242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49252 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49317), // Rule ID 1839 //
     /*  49257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49300 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49315 */     GIR_RootConstrainSelectedInstOperands,
     /*  49316 */     // GIR_Coverage, 1839,
     /*  49316 */     GIR_EraseRootFromParent_Done,
     /*  49317 */   // Label 751: @49317
     /*  49317 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49382), // Rule ID 1838 //
     /*  49322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49365 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49380 */     GIR_RootConstrainSelectedInstOperands,
     /*  49381 */     // GIR_Coverage, 1838,
     /*  49381 */     GIR_EraseRootFromParent_Done,
     /*  49382 */   // Label 752: @49382
     /*  49382 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49447), // Rule ID 1755 //
     /*  49387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49430 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49445 */     GIR_RootConstrainSelectedInstOperands,
     /*  49446 */     // GIR_Coverage, 1755,
     /*  49446 */     GIR_EraseRootFromParent_Done,
     /*  49447 */   // Label 753: @49447
     /*  49447 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49512), // Rule ID 1837 //
     /*  49452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49495 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49510 */     GIR_RootConstrainSelectedInstOperands,
     /*  49511 */     // GIR_Coverage, 1837,
     /*  49511 */     GIR_EraseRootFromParent_Done,
     /*  49512 */   // Label 754: @49512
     /*  49512 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49577), // Rule ID 1836 //
     /*  49517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49560 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49575 */     GIR_RootConstrainSelectedInstOperands,
     /*  49576 */     // GIR_Coverage, 1836,
     /*  49576 */     GIR_EraseRootFromParent_Done,
     /*  49577 */   // Label 755: @49577
     /*  49577 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49640), // Rule ID 1731 //
     /*  49582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49621 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49638 */     GIR_RootConstrainSelectedInstOperands,
     /*  49639 */     // GIR_Coverage, 1731,
     /*  49639 */     GIR_EraseRootFromParent_Done,
     /*  49640 */   // Label 756: @49640
     /*  49640 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49703), // Rule ID 1821 //
     /*  49645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49684 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49701 */     GIR_RootConstrainSelectedInstOperands,
     /*  49702 */     // GIR_Coverage, 1821,
     /*  49702 */     GIR_EraseRootFromParent_Done,
     /*  49703 */   // Label 757: @49703
     /*  49703 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49750), // Rule ID 1859 //
     /*  49708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49736 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49748 */     GIR_RootConstrainSelectedInstOperands,
     /*  49749 */     // GIR_Coverage, 1859,
     /*  49749 */     GIR_EraseRootFromParent_Done,
     /*  49750 */   // Label 758: @49750
     /*  49750 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49797), // Rule ID 1761 //
     /*  49755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49783 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49795 */     GIR_RootConstrainSelectedInstOperands,
     /*  49796 */     // GIR_Coverage, 1761,
     /*  49796 */     GIR_EraseRootFromParent_Done,
     /*  49797 */   // Label 759: @49797
     /*  49797 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49844), // Rule ID 1858 //
     /*  49802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49830 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49842 */     GIR_RootConstrainSelectedInstOperands,
     /*  49843 */     // GIR_Coverage, 1858,
     /*  49843 */     GIR_EraseRootFromParent_Done,
     /*  49844 */   // Label 760: @49844
     /*  49844 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49903), // Rule ID 1835 //
     /*  49849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49888 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49901 */     GIR_RootConstrainSelectedInstOperands,
     /*  49902 */     // GIR_Coverage, 1835,
     /*  49902 */     GIR_EraseRootFromParent_Done,
     /*  49903 */   // Label 761: @49903
     /*  49903 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49962), // Rule ID 1834 //
     /*  49908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49947 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49960 */     GIR_RootConstrainSelectedInstOperands,
     /*  49961 */     // GIR_Coverage, 1834,
     /*  49961 */     GIR_EraseRootFromParent_Done,
     /*  49962 */   // Label 762: @49962
     /*  49962 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50021), // Rule ID 1754 //
     /*  49967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50006 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50019 */     GIR_RootConstrainSelectedInstOperands,
     /*  50020 */     // GIR_Coverage, 1754,
     /*  50020 */     GIR_EraseRootFromParent_Done,
     /*  50021 */   // Label 763: @50021
     /*  50021 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50080), // Rule ID 1833 //
     /*  50026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50065 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50078 */     GIR_RootConstrainSelectedInstOperands,
     /*  50079 */     // GIR_Coverage, 1833,
     /*  50079 */     GIR_EraseRootFromParent_Done,
     /*  50080 */   // Label 764: @50080
     /*  50080 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50139), // Rule ID 1832 //
     /*  50085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50124 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50137 */     GIR_RootConstrainSelectedInstOperands,
     /*  50138 */     // GIR_Coverage, 1832,
     /*  50138 */     GIR_EraseRootFromParent_Done,
     /*  50139 */   // Label 765: @50139
     /*  50139 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50174), // Rule ID 968 //
     /*  50144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50151 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50157 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50165 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50172 */     GIR_RootConstrainSelectedInstOperands,
     /*  50173 */     // GIR_Coverage, 968,
     /*  50173 */     GIR_EraseRootFromParent_Done,
     /*  50174 */   // Label 766: @50174
     /*  50174 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50231), // Rule ID 1730 //
     /*  50179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50214 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50229 */     GIR_RootConstrainSelectedInstOperands,
     /*  50230 */     // GIR_Coverage, 1730,
     /*  50230 */     GIR_EraseRootFromParent_Done,
     /*  50231 */   // Label 767: @50231
     /*  50231 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50288), // Rule ID 1820 //
     /*  50236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50271 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50286 */     GIR_RootConstrainSelectedInstOperands,
     /*  50287 */     // GIR_Coverage, 1820,
     /*  50287 */     GIR_EraseRootFromParent_Done,
     /*  50288 */   // Label 768: @50288
     /*  50288 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50332), // Rule ID 1857 //
     /*  50293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50319 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50330 */     GIR_RootConstrainSelectedInstOperands,
     /*  50331 */     // GIR_Coverage, 1857,
     /*  50331 */     GIR_EraseRootFromParent_Done,
     /*  50332 */   // Label 769: @50332
     /*  50332 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50376), // Rule ID 1760 //
     /*  50337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50363 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50374 */     GIR_RootConstrainSelectedInstOperands,
     /*  50375 */     // GIR_Coverage, 1760,
     /*  50375 */     GIR_EraseRootFromParent_Done,
     /*  50376 */   // Label 770: @50376
     /*  50376 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50420), // Rule ID 1856 //
     /*  50381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50407 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50418 */     GIR_RootConstrainSelectedInstOperands,
     /*  50419 */     // GIR_Coverage, 1856,
     /*  50419 */     GIR_EraseRootFromParent_Done,
     /*  50420 */   // Label 771: @50420
     /*  50420 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50443), // Rule ID 1475 //
     /*  50425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50436 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50441 */     GIR_RootConstrainSelectedInstOperands,
     /*  50442 */     // GIR_Coverage, 1475,
     /*  50442 */     GIR_Done,
     /*  50443 */   // Label 772: @50443
     /*  50443 */   GIM_Reject,
     /*  50444 */ // Label 750: @50444
     /*  50444 */ GIM_Reject,
     /*  50445 */ // Label 592: @50445
     /*  50445 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50519),
     /*  50450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50460 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50495), // Rule ID 966 //
     /*  50465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50478 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50486 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50493 */     GIR_RootConstrainSelectedInstOperands,
     /*  50494 */     // GIR_Coverage, 966,
     /*  50494 */     GIR_EraseRootFromParent_Done,
     /*  50495 */   // Label 774: @50495
     /*  50495 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50518), // Rule ID 1473 //
     /*  50500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50511 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50516 */     GIR_RootConstrainSelectedInstOperands,
     /*  50517 */     // GIR_Coverage, 1473,
     /*  50517 */     GIR_Done,
     /*  50518 */   // Label 775: @50518
     /*  50518 */   GIM_Reject,
     /*  50519 */ // Label 773: @50519
     /*  50519 */ GIM_Reject,
     /*  50520 */ // Label 593: @50520
     /*  50520 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50545), // Rule ID 7459 //
     /*  50525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50538 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50543 */   GIR_RootConstrainSelectedInstOperands,
     /*  50544 */   // GIR_Coverage, 7459,
     /*  50544 */   GIR_Done,
     /*  50545 */ // Label 776: @50545
     /*  50545 */ GIM_Reject,
     /*  50546 */ // Label 594: @50546
     /*  50546 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50571), // Rule ID 7458 //
     /*  50551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50564 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50569 */   GIR_RootConstrainSelectedInstOperands,
     /*  50570 */   // GIR_Coverage, 7458,
     /*  50570 */   GIR_Done,
     /*  50571 */ // Label 777: @50571
     /*  50571 */ GIM_Reject,
     /*  50572 */ // Label 595: @50572
     /*  50572 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50597), // Rule ID 7457 //
     /*  50577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50590 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50595 */   GIR_RootConstrainSelectedInstOperands,
     /*  50596 */   // GIR_Coverage, 7457,
     /*  50596 */   GIR_Done,
     /*  50597 */ // Label 778: @50597
     /*  50597 */ GIM_Reject,
     /*  50598 */ // Label 596: @50598
     /*  50598 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50623), // Rule ID 7456 //
     /*  50603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50616 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50621 */   GIR_RootConstrainSelectedInstOperands,
     /*  50622 */   // GIR_Coverage, 7456,
     /*  50622 */   GIR_Done,
     /*  50623 */ // Label 779: @50623
     /*  50623 */ GIM_Reject,
     /*  50624 */ // Label 597: @50624
     /*  50624 */ GIM_Reject,
     /*  50625 */ // Label 2: @50625
     /*  50625 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 788*/ GIMT_Encode4(53145),
     /*  50636 */ /*GILLT_s32*//*Label 780*/ GIMT_Encode4(50676),
     /*  50640 */ /*GILLT_s64*//*Label 781*/ GIMT_Encode4(50833), GIMT_Encode4(0),
     /*  50648 */ /*GILLT_v2s32*//*Label 782*/ GIMT_Encode4(52069), GIMT_Encode4(0),
     /*  50656 */ /*GILLT_v4s16*//*Label 783*/ GIMT_Encode4(52407),
     /*  50660 */ /*GILLT_v4s32*//*Label 784*/ GIMT_Encode4(52745),
     /*  50664 */ /*GILLT_v8s8*//*Label 785*/ GIMT_Encode4(52911),
     /*  50668 */ /*GILLT_v8s16*//*Label 786*/ GIMT_Encode4(52945),
     /*  50672 */ /*GILLT_v16s8*//*Label 787*/ GIMT_Encode4(53111),
     /*  50676 */ // Label 780: @50676
     /*  50676 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(50832),
     /*  50681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50691 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(50746), // Rule ID 3955 //
     /*  50696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50712 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50727 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50744 */     GIR_RootConstrainSelectedInstOperands,
     /*  50745 */     // GIR_Coverage, 3955,
     /*  50745 */     GIR_EraseRootFromParent_Done,
     /*  50746 */   // Label 790: @50746
     /*  50746 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(50801), // Rule ID 13798 //
     /*  50751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50782 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50799 */     GIR_RootConstrainSelectedInstOperands,
     /*  50800 */     // GIR_Coverage, 13798,
     /*  50800 */     GIR_EraseRootFromParent_Done,
     /*  50801 */   // Label 791: @50801
     /*  50801 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50831), // Rule ID 3951 //
     /*  50806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50814 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50829 */     GIR_RootConstrainSelectedInstOperands,
     /*  50830 */     // GIR_Coverage, 3951,
     /*  50830 */     GIR_EraseRootFromParent_Done,
     /*  50831 */   // Label 792: @50831
     /*  50831 */   GIM_Reject,
     /*  50832 */ // Label 789: @50832
     /*  50832 */ GIM_Reject,
     /*  50833 */ // Label 781: @50833
     /*  50833 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(52068),
     /*  50838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50848 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(50994), // Rule ID 3960 //
     /*  50853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50874 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50906 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50919 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  50919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50931 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  50937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50942 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  50965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  50978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  50986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50992 */     GIR_RootConstrainSelectedInstOperands,
     /*  50993 */     // GIR_Coverage, 3960,
     /*  50993 */     GIR_EraseRootFromParent_Done,
     /*  50994 */   // Label 794: @50994
     /*  50994 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(51098), // Rule ID 3961 //
     /*  50999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51020 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51050 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51096 */     GIR_RootConstrainSelectedInstOperands,
     /*  51097 */     // GIR_Coverage, 3961,
     /*  51097 */     GIR_EraseRootFromParent_Done,
     /*  51098 */   // Label 795: @51098
     /*  51098 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51202), // Rule ID 13801 //
     /*  51103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51141 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51154 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51166 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51200 */     GIR_RootConstrainSelectedInstOperands,
     /*  51201 */     // GIR_Coverage, 13801,
     /*  51201 */     GIR_EraseRootFromParent_Done,
     /*  51202 */   // Label 796: @51202
     /*  51202 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(51257), // Rule ID 3956 //
     /*  51207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51238 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51255 */     GIR_RootConstrainSelectedInstOperands,
     /*  51256 */     // GIR_Coverage, 3956,
     /*  51256 */     GIR_EraseRootFromParent_Done,
     /*  51257 */   // Label 797: @51257
     /*  51257 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51312), // Rule ID 13799 //
     /*  51262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51293 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51310 */     GIR_RootConstrainSelectedInstOperands,
     /*  51311 */     // GIR_Coverage, 13799,
     /*  51311 */     GIR_EraseRootFromParent_Done,
     /*  51312 */   // Label 798: @51312
     /*  51312 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51425), // Rule ID 3967 //
     /*  51317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51334 */     // MIs[1] Operand 2
     /*  51334 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51353 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51357 */     // MIs[2] Operand 1
     /*  51357 */     // No operand predicates
     /*  51357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51359 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51371 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51390 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51423 */     GIR_RootConstrainSelectedInstOperands,
     /*  51424 */     // GIR_Coverage, 3967,
     /*  51424 */     GIR_EraseRootFromParent_Done,
     /*  51425 */   // Label 799: @51425
     /*  51425 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51500), // Rule ID 3965 //
     /*  51430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51459 */     // MIs[2] Operand 1
     /*  51459 */     // No operand predicates
     /*  51459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51461 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51473 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51498 */     GIR_RootConstrainSelectedInstOperands,
     /*  51499 */     // GIR_Coverage, 3965,
     /*  51499 */     GIR_EraseRootFromParent_Done,
     /*  51500 */   // Label 800: @51500
     /*  51500 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51575), // Rule ID 3966 //
     /*  51505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51534 */     // MIs[2] Operand 1
     /*  51534 */     // No operand predicates
     /*  51534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51536 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51548 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51573 */     GIR_RootConstrainSelectedInstOperands,
     /*  51574 */     // GIR_Coverage, 3966,
     /*  51574 */     GIR_EraseRootFromParent_Done,
     /*  51575 */   // Label 801: @51575
     /*  51575 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51713), // Rule ID 3957 //
     /*  51580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51597 */     // MIs[1] Operand 2
     /*  51597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51625 */     // MIs[2] Operand 2
     /*  51625 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51638 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  51638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51650 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  51656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51661 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51678 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51711 */     GIR_RootConstrainSelectedInstOperands,
     /*  51712 */     // GIR_Coverage, 3957,
     /*  51712 */     GIR_EraseRootFromParent_Done,
     /*  51713 */   // Label 802: @51713
     /*  51713 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51813), // Rule ID 3958 //
     /*  51718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51735 */     // MIs[1] Operand 2
     /*  51735 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51765 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51777 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51811 */     GIR_RootConstrainSelectedInstOperands,
     /*  51812 */     // GIR_Coverage, 3958,
     /*  51812 */     GIR_EraseRootFromParent_Done,
     /*  51813 */   // Label 803: @51813
     /*  51813 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51913), // Rule ID 13800 //
     /*  51818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51852 */     // MIs[2] Operand 2
     /*  51852 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51865 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51877 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51911 */     GIR_RootConstrainSelectedInstOperands,
     /*  51912 */     // GIR_Coverage, 13800,
     /*  51912 */     GIR_EraseRootFromParent_Done,
     /*  51913 */   // Label 804: @51913
     /*  51913 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51975), // Rule ID 3959 //
     /*  51918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51954 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51973 */     GIR_RootConstrainSelectedInstOperands,
     /*  51974 */     // GIR_Coverage, 3959,
     /*  51974 */     GIR_EraseRootFromParent_Done,
     /*  51975 */   // Label 805: @51975
     /*  51975 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52037), // Rule ID 3962 //
     /*  51980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52016 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52029 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52035 */     GIR_RootConstrainSelectedInstOperands,
     /*  52036 */     // GIR_Coverage, 3962,
     /*  52036 */     GIR_EraseRootFromParent_Done,
     /*  52037 */   // Label 806: @52037
     /*  52037 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52067), // Rule ID 3952 //
     /*  52042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52050 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  52053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52065 */     GIR_RootConstrainSelectedInstOperands,
     /*  52066 */     // GIR_Coverage, 3952,
     /*  52066 */     GIR_EraseRootFromParent_Done,
     /*  52067 */   // Label 807: @52067
     /*  52067 */   GIM_Reject,
     /*  52068 */ // Label 793: @52068
     /*  52068 */ GIM_Reject,
     /*  52069 */ // Label 782: @52069
     /*  52069 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52406),
     /*  52074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52084 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52170), // Rule ID 13492 //
     /*  52089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52133 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52137 */     // MIs[3] Operand 1
     /*  52137 */     // No operand predicates
     /*  52137 */     // MIs[1] Operand 2
     /*  52137 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52154 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52168 */     GIR_RootConstrainSelectedInstOperands,
     /*  52169 */     // GIR_Coverage, 13492,
     /*  52169 */     GIR_EraseRootFromParent_Done,
     /*  52170 */   // Label 809: @52170
     /*  52170 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52256), // Rule ID 2034 //
     /*  52175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52223 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52227 */     // MIs[3] Operand 1
     /*  52227 */     // No operand predicates
     /*  52227 */     // MIs[1] Operand 2
     /*  52227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52240 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52254 */     GIR_RootConstrainSelectedInstOperands,
     /*  52255 */     // GIR_Coverage, 2034,
     /*  52255 */     GIR_EraseRootFromParent_Done,
     /*  52256 */   // Label 810: @52256
     /*  52256 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52319), // Rule ID 13493 //
     /*  52261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52297 */     // MIs[2] Operand 1
     /*  52297 */     // No operand predicates
     /*  52297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52303 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52317 */     GIR_RootConstrainSelectedInstOperands,
     /*  52318 */     // GIR_Coverage, 13493,
     /*  52318 */     GIR_EraseRootFromParent_Done,
     /*  52319 */   // Label 811: @52319
     /*  52319 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52382), // Rule ID 2035 //
     /*  52324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52364 */     // MIs[2] Operand 1
     /*  52364 */     // No operand predicates
     /*  52364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52366 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52380 */     GIR_RootConstrainSelectedInstOperands,
     /*  52381 */     // GIR_Coverage, 2035,
     /*  52381 */     GIR_EraseRootFromParent_Done,
     /*  52382 */   // Label 812: @52382
     /*  52382 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52405), // Rule ID 1352 //
     /*  52387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52398 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  52398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  52403 */     GIR_RootConstrainSelectedInstOperands,
     /*  52404 */     // GIR_Coverage, 1352,
     /*  52404 */     GIR_Done,
     /*  52405 */   // Label 813: @52405
     /*  52405 */   GIM_Reject,
     /*  52406 */ // Label 808: @52406
     /*  52406 */ GIM_Reject,
     /*  52407 */ // Label 783: @52407
     /*  52407 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52744),
     /*  52412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52422 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52508), // Rule ID 13489 //
     /*  52427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52458 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52471 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52475 */     // MIs[3] Operand 1
     /*  52475 */     // No operand predicates
     /*  52475 */     // MIs[1] Operand 2
     /*  52475 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52492 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52506 */     GIR_RootConstrainSelectedInstOperands,
     /*  52507 */     // GIR_Coverage, 13489,
     /*  52507 */     GIR_EraseRootFromParent_Done,
     /*  52508 */   // Label 815: @52508
     /*  52508 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52594), // Rule ID 2031 //
     /*  52513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52561 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52565 */     // MIs[3] Operand 1
     /*  52565 */     // No operand predicates
     /*  52565 */     // MIs[1] Operand 2
     /*  52565 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52578 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52592 */     GIR_RootConstrainSelectedInstOperands,
     /*  52593 */     // GIR_Coverage, 2031,
     /*  52593 */     GIR_EraseRootFromParent_Done,
     /*  52594 */   // Label 816: @52594
     /*  52594 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52657), // Rule ID 13490 //
     /*  52599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52631 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52635 */     // MIs[2] Operand 1
     /*  52635 */     // No operand predicates
     /*  52635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52641 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52655 */     GIR_RootConstrainSelectedInstOperands,
     /*  52656 */     // GIR_Coverage, 13490,
     /*  52656 */     GIR_EraseRootFromParent_Done,
     /*  52657 */   // Label 817: @52657
     /*  52657 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52720), // Rule ID 2032 //
     /*  52662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52698 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52702 */     // MIs[2] Operand 1
     /*  52702 */     // No operand predicates
     /*  52702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52704 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52718 */     GIR_RootConstrainSelectedInstOperands,
     /*  52719 */     // GIR_Coverage, 2032,
     /*  52719 */     GIR_EraseRootFromParent_Done,
     /*  52720 */   // Label 818: @52720
     /*  52720 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52743), // Rule ID 1350 //
     /*  52725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52736 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52741 */     GIR_RootConstrainSelectedInstOperands,
     /*  52742 */     // GIR_Coverage, 1350,
     /*  52742 */     GIR_Done,
     /*  52743 */   // Label 819: @52743
     /*  52743 */   GIM_Reject,
     /*  52744 */ // Label 814: @52744
     /*  52744 */ GIM_Reject,
     /*  52745 */ // Label 784: @52745
     /*  52745 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52910),
     /*  52750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52760 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52823), // Rule ID 13494 //
     /*  52765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52797 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52801 */     // MIs[2] Operand 1
     /*  52801 */     // No operand predicates
     /*  52801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52807 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52821 */     GIR_RootConstrainSelectedInstOperands,
     /*  52822 */     // GIR_Coverage, 13494,
     /*  52822 */     GIR_EraseRootFromParent_Done,
     /*  52823 */   // Label 821: @52823
     /*  52823 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52886), // Rule ID 2036 //
     /*  52828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52864 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52868 */     // MIs[2] Operand 1
     /*  52868 */     // No operand predicates
     /*  52868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52870 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52884 */     GIR_RootConstrainSelectedInstOperands,
     /*  52885 */     // GIR_Coverage, 2036,
     /*  52885 */     GIR_EraseRootFromParent_Done,
     /*  52886 */   // Label 822: @52886
     /*  52886 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52909), // Rule ID 1353 //
     /*  52891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52902 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52907 */     GIR_RootConstrainSelectedInstOperands,
     /*  52908 */     // GIR_Coverage, 1353,
     /*  52908 */     GIR_Done,
     /*  52909 */   // Label 823: @52909
     /*  52909 */   GIM_Reject,
     /*  52910 */ // Label 820: @52910
     /*  52910 */ GIM_Reject,
     /*  52911 */ // Label 785: @52911
     /*  52911 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52944), // Rule ID 1348 //
     /*  52916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52937 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52942 */   GIR_RootConstrainSelectedInstOperands,
     /*  52943 */   // GIR_Coverage, 1348,
     /*  52943 */   GIR_Done,
     /*  52944 */ // Label 824: @52944
     /*  52944 */ GIM_Reject,
     /*  52945 */ // Label 786: @52945
     /*  52945 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53110),
     /*  52950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52960 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53023), // Rule ID 13491 //
     /*  52965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52997 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53001 */     // MIs[2] Operand 1
     /*  53001 */     // No operand predicates
     /*  53001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53007 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53021 */     GIR_RootConstrainSelectedInstOperands,
     /*  53022 */     // GIR_Coverage, 13491,
     /*  53022 */     GIR_EraseRootFromParent_Done,
     /*  53023 */   // Label 826: @53023
     /*  53023 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53086), // Rule ID 2033 //
     /*  53028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53068 */     // MIs[2] Operand 1
     /*  53068 */     // No operand predicates
     /*  53068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53070 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53084 */     GIR_RootConstrainSelectedInstOperands,
     /*  53085 */     // GIR_Coverage, 2033,
     /*  53085 */     GIR_EraseRootFromParent_Done,
     /*  53086 */   // Label 827: @53086
     /*  53086 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53109), // Rule ID 1351 //
     /*  53091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53102 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  53102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  53107 */     GIR_RootConstrainSelectedInstOperands,
     /*  53108 */     // GIR_Coverage, 1351,
     /*  53108 */     GIR_Done,
     /*  53109 */   // Label 828: @53109
     /*  53109 */   GIM_Reject,
     /*  53110 */ // Label 825: @53110
     /*  53110 */ GIM_Reject,
     /*  53111 */ // Label 787: @53111
     /*  53111 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(53144), // Rule ID 1349 //
     /*  53116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53137 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  53142 */   GIR_RootConstrainSelectedInstOperands,
     /*  53143 */   // GIR_Coverage, 1349,
     /*  53143 */   GIR_Done,
     /*  53144 */ // Label 829: @53144
     /*  53144 */ GIM_Reject,
     /*  53145 */ // Label 788: @53145
     /*  53145 */ GIM_Reject,
     /*  53146 */ // Label 3: @53146
     /*  53146 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 832*/ GIMT_Encode4(53227),
     /*  53157 */ /*GILLT_s32*//*Label 830*/ GIMT_Encode4(53165),
     /*  53161 */ /*GILLT_s64*//*Label 831*/ GIMT_Encode4(53196),
     /*  53165 */ // Label 830: @53165
     /*  53165 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(53195), // Rule ID 117 //
     /*  53170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53188 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  53193 */   GIR_RootConstrainSelectedInstOperands,
     /*  53194 */   // GIR_Coverage, 117,
     /*  53194 */   GIR_Done,
     /*  53195 */ // Label 833: @53195
     /*  53195 */ GIM_Reject,
     /*  53196 */ // Label 831: @53196
     /*  53196 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(53226), // Rule ID 118 //
     /*  53201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53219 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  53224 */   GIR_RootConstrainSelectedInstOperands,
     /*  53225 */   // GIR_Coverage, 118,
     /*  53225 */   GIR_Done,
     /*  53226 */ // Label 834: @53226
     /*  53226 */ GIM_Reject,
     /*  53227 */ // Label 832: @53227
     /*  53227 */ GIM_Reject,
     /*  53228 */ // Label 4: @53228
     /*  53228 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 837*/ GIMT_Encode4(53309),
     /*  53239 */ /*GILLT_s32*//*Label 835*/ GIMT_Encode4(53247),
     /*  53243 */ /*GILLT_s64*//*Label 836*/ GIMT_Encode4(53278),
     /*  53247 */ // Label 835: @53247
     /*  53247 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(53277), // Rule ID 115 //
     /*  53252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53270 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  53275 */   GIR_RootConstrainSelectedInstOperands,
     /*  53276 */   // GIR_Coverage, 115,
     /*  53276 */   GIR_Done,
     /*  53277 */ // Label 838: @53277
     /*  53277 */ GIM_Reject,
     /*  53278 */ // Label 836: @53278
     /*  53278 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(53308), // Rule ID 116 //
     /*  53283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53301 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  53306 */   GIR_RootConstrainSelectedInstOperands,
     /*  53307 */   // GIR_Coverage, 116,
     /*  53307 */   GIR_Done,
     /*  53308 */ // Label 839: @53308
     /*  53308 */ GIM_Reject,
     /*  53309 */ // Label 837: @53309
     /*  53309 */ GIM_Reject,
     /*  53310 */ // Label 5: @53310
     /*  53310 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 858*/ GIMT_Encode4(61055),
     /*  53321 */ /*GILLT_s32*//*Label 840*/ GIMT_Encode4(53409),
     /*  53325 */ /*GILLT_s64*//*Label 841*/ GIMT_Encode4(53907), GIMT_Encode4(0),
     /*  53333 */ /*GILLT_v2s32*//*Label 842*/ GIMT_Encode4(55342),
     /*  53337 */ /*GILLT_v2s64*//*Label 843*/ GIMT_Encode4(55502),
     /*  53341 */ /*GILLT_v4s16*//*Label 844*/ GIMT_Encode4(55662),
     /*  53345 */ /*GILLT_v4s32*//*Label 845*/ GIMT_Encode4(55822),
     /*  53349 */ /*GILLT_v8s8*//*Label 846*/ GIMT_Encode4(55982),
     /*  53353 */ /*GILLT_v8s16*//*Label 847*/ GIMT_Encode4(56142),
     /*  53357 */ /*GILLT_v16s8*//*Label 848*/ GIMT_Encode4(56302),
     /*  53361 */ /*GILLT_nxv1s1*//*Label 849*/ GIMT_Encode4(56462),
     /*  53365 */ /*GILLT_nxv2s1*//*Label 850*/ GIMT_Encode4(57003), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  53377 */ /*GILLT_nxv2s64*//*Label 851*/ GIMT_Encode4(57544),
     /*  53381 */ /*GILLT_nxv4s1*//*Label 852*/ GIMT_Encode4(58016), GIMT_Encode4(0),
     /*  53389 */ /*GILLT_nxv4s32*//*Label 853*/ GIMT_Encode4(58557),
     /*  53393 */ /*GILLT_nxv8s1*//*Label 854*/ GIMT_Encode4(59029),
     /*  53397 */ /*GILLT_nxv8s16*//*Label 855*/ GIMT_Encode4(59570),
     /*  53401 */ /*GILLT_nxv16s1*//*Label 856*/ GIMT_Encode4(60042),
     /*  53405 */ /*GILLT_nxv16s8*//*Label 857*/ GIMT_Encode4(60583),
     /*  53409 */ // Label 840: @53409
     /*  53409 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53906),
     /*  53414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53420 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53475), // Rule ID 13251 //
     /*  53425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53445 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53462 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53473 */     GIR_RootConstrainSelectedInstOperands,
     /*  53474 */     // GIR_Coverage, 13251,
     /*  53474 */     GIR_EraseRootFromParent_Done,
     /*  53475 */   // Label 860: @53475
     /*  53475 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53530), // Rule ID 162 //
     /*  53480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53517 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53528 */     GIR_RootConstrainSelectedInstOperands,
     /*  53529 */     // GIR_Coverage, 162,
     /*  53529 */     GIR_EraseRootFromParent_Done,
     /*  53530 */   // Label 861: @53530
     /*  53530 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53599), // Rule ID 5660 //
     /*  53535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53568 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53572 */     // MIs[2] Operand 1
     /*  53572 */     // No operand predicates
     /*  53572 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53585 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53597 */     GIR_RootConstrainSelectedInstOperands,
     /*  53598 */     // GIR_Coverage, 5660,
     /*  53598 */     GIR_EraseRootFromParent_Done,
     /*  53599 */   // Label 862: @53599
     /*  53599 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53668), // Rule ID 5661 //
     /*  53604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53637 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53641 */     // MIs[2] Operand 1
     /*  53641 */     // No operand predicates
     /*  53641 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53654 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53666 */     GIR_RootConstrainSelectedInstOperands,
     /*  53667 */     // GIR_Coverage, 5661,
     /*  53667 */     GIR_EraseRootFromParent_Done,
     /*  53668 */   // Label 863: @53668
     /*  53668 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53721), // Rule ID 13249 //
     /*  53673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53698 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53708 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53719 */     GIR_RootConstrainSelectedInstOperands,
     /*  53720 */     // GIR_Coverage, 13249,
     /*  53720 */     GIR_EraseRootFromParent_Done,
     /*  53721 */   // Label 864: @53721
     /*  53721 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53774), // Rule ID 160 //
     /*  53726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53755 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53761 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53772 */     GIR_RootConstrainSelectedInstOperands,
     /*  53773 */     // GIR_Coverage, 160,
     /*  53773 */     GIR_EraseRootFromParent_Done,
     /*  53774 */   // Label 865: @53774
     /*  53774 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53815), // Rule ID 142 //
     /*  53779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53795 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53799 */     // MIs[1] Operand 1
     /*  53799 */     // No operand predicates
     /*  53799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53801 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53808 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53813 */     GIR_RootConstrainSelectedInstOperands,
     /*  53814 */     // GIR_Coverage, 142,
     /*  53814 */     GIR_EraseRootFromParent_Done,
     /*  53815 */   // Label 866: @53815
     /*  53815 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53848), // Rule ID 13247 //
     /*  53820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53835 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53846 */     GIR_RootConstrainSelectedInstOperands,
     /*  53847 */     // GIR_Coverage, 13247,
     /*  53847 */     GIR_EraseRootFromParent_Done,
     /*  53848 */   // Label 867: @53848
     /*  53848 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53881), // Rule ID 158 //
     /*  53853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53868 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53879 */     GIR_RootConstrainSelectedInstOperands,
     /*  53880 */     // GIR_Coverage, 158,
     /*  53880 */     GIR_EraseRootFromParent_Done,
     /*  53881 */   // Label 868: @53881
     /*  53881 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53905), // Rule ID 156 //
     /*  53886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53898 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53903 */     GIR_RootConstrainSelectedInstOperands,
     /*  53904 */     // GIR_Coverage, 156,
     /*  53904 */     GIR_Done,
     /*  53905 */   // Label 869: @53905
     /*  53905 */   GIM_Reject,
     /*  53906 */ // Label 859: @53906
     /*  53906 */ GIM_Reject,
     /*  53907 */ // Label 841: @53907
     /*  53907 */ GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(55341),
     /*  53912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53918 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(53973), // Rule ID 13252 //
     /*  53923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53960 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53971 */     GIR_RootConstrainSelectedInstOperands,
     /*  53972 */     // GIR_Coverage, 13252,
     /*  53972 */     GIR_EraseRootFromParent_Done,
     /*  53973 */   // Label 871: @53973
     /*  53973 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54028), // Rule ID 163 //
     /*  53978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54002 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54015 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  54018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54026 */     GIR_RootConstrainSelectedInstOperands,
     /*  54027 */     // GIR_Coverage, 163,
     /*  54027 */     GIR_EraseRootFromParent_Done,
     /*  54028 */   // Label 872: @54028
     /*  54028 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54141), // Rule ID 5662 //
     /*  54033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54078 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  54082 */     // MIs[3] Operand 1
     /*  54082 */     // No operand predicates
     /*  54082 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54095 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  54095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  54102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54140 */     // GIR_Coverage, 5662,
     /*  54140 */     GIR_EraseRootFromParent_Done,
     /*  54141 */   // Label 873: @54141
     /*  54141 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54254), // Rule ID 5663 //
     /*  54146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54191 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54195 */     // MIs[3] Operand 1
     /*  54195 */     // No operand predicates
     /*  54195 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54208 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  54208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  54215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54253 */     // GIR_Coverage, 5663,
     /*  54253 */     GIR_EraseRootFromParent_Done,
     /*  54254 */   // Label 874: @54254
     /*  54254 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54353), // Rule ID 7108 //
     /*  54259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54271 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54274 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54279 */     // MIs[1] addr
     /*  54279 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54288 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  54292 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54305 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  54312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54321 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54352 */     // GIR_Coverage, 7108,
     /*  54352 */     GIR_EraseRootFromParent_Done,
     /*  54353 */   // Label 875: @54353
     /*  54353 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54452), // Rule ID 7109 //
     /*  54358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54370 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54373 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54378 */     // MIs[1] addr
     /*  54378 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54387 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  54391 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54404 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  54411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54420 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54451 */     // GIR_Coverage, 7109,
     /*  54451 */     GIR_EraseRootFromParent_Done,
     /*  54452 */   // Label 876: @54452
     /*  54452 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54551), // Rule ID 7110 //
     /*  54457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54469 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54472 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54477 */     // MIs[1] addr
     /*  54477 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54486 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54490 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54503 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54519 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54550 */     // GIR_Coverage, 7110,
     /*  54550 */     GIR_EraseRootFromParent_Done,
     /*  54551 */   // Label 877: @54551
     /*  54551 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54650), // Rule ID 7115 //
     /*  54556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54568 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54571 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54576 */     // MIs[1] addr
     /*  54576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54585 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54589 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54602 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54618 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54649 */     // GIR_Coverage, 7115,
     /*  54649 */     GIR_EraseRootFromParent_Done,
     /*  54650 */   // Label 878: @54650
     /*  54650 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54749), // Rule ID 7116 //
     /*  54655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54667 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54670 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54675 */     // MIs[1] addr
     /*  54675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54684 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54688 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54701 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54717 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54748 */     // GIR_Coverage, 7116,
     /*  54748 */     GIR_EraseRootFromParent_Done,
     /*  54749 */   // Label 879: @54749
     /*  54749 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54848), // Rule ID 7117 //
     /*  54754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54766 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54769 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54774 */     // MIs[1] addr
     /*  54774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54783 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54787 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54800 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54816 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54847 */     // GIR_Coverage, 7117,
     /*  54847 */     GIR_EraseRootFromParent_Done,
     /*  54848 */   // Label 880: @54848
     /*  54848 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54901), // Rule ID 13250 //
     /*  54853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54878 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54888 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54899 */     GIR_RootConstrainSelectedInstOperands,
     /*  54900 */     // GIR_Coverage, 13250,
     /*  54900 */     GIR_EraseRootFromParent_Done,
     /*  54901 */   // Label 881: @54901
     /*  54901 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54954), // Rule ID 161 //
     /*  54906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54935 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54941 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54952 */     GIR_RootConstrainSelectedInstOperands,
     /*  54953 */     // GIR_Coverage, 161,
     /*  54953 */     GIR_EraseRootFromParent_Done,
     /*  54954 */   // Label 882: @54954
     /*  54954 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55054), // Rule ID 4004 //
     /*  54959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54967 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54978 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54978 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54981 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54985 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54990 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  54996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  55013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55018 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55053 */     // GIR_Coverage, 4004,
     /*  55053 */     GIR_EraseRootFromParent_Done,
     /*  55054 */   // Label 883: @55054
     /*  55054 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55095), // Rule ID 143 //
     /*  55059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55075 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  55079 */     // MIs[1] Operand 1
     /*  55079 */     // No operand predicates
     /*  55079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55081 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  55081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  55084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55088 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  55093 */     GIR_RootConstrainSelectedInstOperands,
     /*  55094 */     // GIR_Coverage, 143,
     /*  55094 */     GIR_EraseRootFromParent_Done,
     /*  55095 */   // Label 884: @55095
     /*  55095 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55128), // Rule ID 13248 //
     /*  55100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55115 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55126 */     GIR_RootConstrainSelectedInstOperands,
     /*  55127 */     // GIR_Coverage, 13248,
     /*  55127 */     GIR_EraseRootFromParent_Done,
     /*  55128 */   // Label 885: @55128
     /*  55128 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55161), // Rule ID 159 //
     /*  55133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55148 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55159 */     GIR_RootConstrainSelectedInstOperands,
     /*  55160 */     // GIR_Coverage, 159,
     /*  55160 */     GIR_EraseRootFromParent_Done,
     /*  55161 */   // Label 886: @55161
     /*  55161 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55225), // Rule ID 13906 //
     /*  55166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55212 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55223 */     GIR_RootConstrainSelectedInstOperands,
     /*  55224 */     // GIR_Coverage, 13906,
     /*  55224 */     GIR_EraseRootFromParent_Done,
     /*  55225 */   // Label 887: @55225
     /*  55225 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55289), // Rule ID 5044 //
     /*  55230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55266 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55272 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55276 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55281 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55287 */     GIR_RootConstrainSelectedInstOperands,
     /*  55288 */     // GIR_Coverage, 5044,
     /*  55288 */     GIR_EraseRootFromParent_Done,
     /*  55289 */   // Label 888: @55289
     /*  55289 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55313), // Rule ID 157 //
     /*  55294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55306 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  55306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  55311 */     GIR_RootConstrainSelectedInstOperands,
     /*  55312 */     // GIR_Coverage, 157,
     /*  55312 */     GIR_Done,
     /*  55313 */   // Label 889: @55313
     /*  55313 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55340), // Rule ID 2484 //
     /*  55318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55333 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55338 */     GIR_RootConstrainSelectedInstOperands,
     /*  55339 */     // GIR_Coverage, 2484,
     /*  55339 */     GIR_Done,
     /*  55340 */   // Label 890: @55340
     /*  55340 */   GIM_Reject,
     /*  55341 */ // Label 870: @55341
     /*  55341 */ GIM_Reject,
     /*  55342 */ // Label 842: @55342
     /*  55342 */ GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55501),
     /*  55347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55357 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55417), // Rule ID 13905 //
     /*  55362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55390 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55404 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55409 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55415 */     GIR_RootConstrainSelectedInstOperands,
     /*  55416 */     // GIR_Coverage, 13905,
     /*  55416 */     GIR_EraseRootFromParent_Done,
     /*  55417 */   // Label 892: @55417
     /*  55417 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(55477), // Rule ID 5043 //
     /*  55422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55454 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55464 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55469 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55475 */     GIR_RootConstrainSelectedInstOperands,
     /*  55476 */     // GIR_Coverage, 5043,
     /*  55476 */     GIR_EraseRootFromParent_Done,
     /*  55477 */   // Label 893: @55477
     /*  55477 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55500), // Rule ID 2483 //
     /*  55482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55493 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55498 */     GIR_RootConstrainSelectedInstOperands,
     /*  55499 */     // GIR_Coverage, 2483,
     /*  55499 */     GIR_Done,
     /*  55500 */   // Label 894: @55500
     /*  55500 */   GIM_Reject,
     /*  55501 */ // Label 891: @55501
     /*  55501 */ GIM_Reject,
     /*  55502 */ // Label 843: @55502
     /*  55502 */ GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55661),
     /*  55507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55517 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55577), // Rule ID 13909 //
     /*  55522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55550 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55556 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55564 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55569 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55575 */     GIR_RootConstrainSelectedInstOperands,
     /*  55576 */     // GIR_Coverage, 13909,
     /*  55576 */     GIR_EraseRootFromParent_Done,
     /*  55577 */   // Label 896: @55577
     /*  55577 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55637), // Rule ID 5047 //
     /*  55582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55614 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55624 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55629 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55635 */     GIR_RootConstrainSelectedInstOperands,
     /*  55636 */     // GIR_Coverage, 5047,
     /*  55636 */     GIR_EraseRootFromParent_Done,
     /*  55637 */   // Label 897: @55637
     /*  55637 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55660), // Rule ID 2487 //
     /*  55642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55653 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55658 */     GIR_RootConstrainSelectedInstOperands,
     /*  55659 */     // GIR_Coverage, 2487,
     /*  55659 */     GIR_Done,
     /*  55660 */   // Label 898: @55660
     /*  55660 */   GIM_Reject,
     /*  55661 */ // Label 895: @55661
     /*  55661 */ GIM_Reject,
     /*  55662 */ // Label 844: @55662
     /*  55662 */ GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55821),
     /*  55667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55677 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55737), // Rule ID 13904 //
     /*  55682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55710 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55724 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55729 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55735 */     GIR_RootConstrainSelectedInstOperands,
     /*  55736 */     // GIR_Coverage, 13904,
     /*  55736 */     GIR_EraseRootFromParent_Done,
     /*  55737 */   // Label 900: @55737
     /*  55737 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55797), // Rule ID 5042 //
     /*  55742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55784 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55789 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55795 */     GIR_RootConstrainSelectedInstOperands,
     /*  55796 */     // GIR_Coverage, 5042,
     /*  55796 */     GIR_EraseRootFromParent_Done,
     /*  55797 */   // Label 901: @55797
     /*  55797 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55820), // Rule ID 2482 //
     /*  55802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55813 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55818 */     GIR_RootConstrainSelectedInstOperands,
     /*  55819 */     // GIR_Coverage, 2482,
     /*  55819 */     GIR_Done,
     /*  55820 */   // Label 902: @55820
     /*  55820 */   GIM_Reject,
     /*  55821 */ // Label 899: @55821
     /*  55821 */ GIM_Reject,
     /*  55822 */ // Label 845: @55822
     /*  55822 */ GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55981),
     /*  55827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55837 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55897), // Rule ID 13908 //
     /*  55842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55870 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55876 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55884 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55889 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55895 */     GIR_RootConstrainSelectedInstOperands,
     /*  55896 */     // GIR_Coverage, 13908,
     /*  55896 */     GIR_EraseRootFromParent_Done,
     /*  55897 */   // Label 904: @55897
     /*  55897 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55957), // Rule ID 5046 //
     /*  55902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55934 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55940 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55944 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55949 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55955 */     GIR_RootConstrainSelectedInstOperands,
     /*  55956 */     // GIR_Coverage, 5046,
     /*  55956 */     GIR_EraseRootFromParent_Done,
     /*  55957 */   // Label 905: @55957
     /*  55957 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55980), // Rule ID 2486 //
     /*  55962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55973 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55978 */     GIR_RootConstrainSelectedInstOperands,
     /*  55979 */     // GIR_Coverage, 2486,
     /*  55979 */     GIR_Done,
     /*  55980 */   // Label 906: @55980
     /*  55980 */   GIM_Reject,
     /*  55981 */ // Label 903: @55981
     /*  55981 */ GIM_Reject,
     /*  55982 */ // Label 846: @55982
     /*  55982 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56141),
     /*  55987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55997 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56057), // Rule ID 13387 //
     /*  56002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56030 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56036 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56044 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56055 */     GIR_RootConstrainSelectedInstOperands,
     /*  56056 */     // GIR_Coverage, 13387,
     /*  56056 */     GIR_EraseRootFromParent_Done,
     /*  56057 */   // Label 908: @56057
     /*  56057 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56117), // Rule ID 1597 //
     /*  56062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56094 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56104 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56115 */     GIR_RootConstrainSelectedInstOperands,
     /*  56116 */     // GIR_Coverage, 1597,
     /*  56116 */     GIR_EraseRootFromParent_Done,
     /*  56117 */   // Label 909: @56117
     /*  56117 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(56140), // Rule ID 1595 //
     /*  56122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56133 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56138 */     GIR_RootConstrainSelectedInstOperands,
     /*  56139 */     // GIR_Coverage, 1595,
     /*  56139 */     GIR_Done,
     /*  56140 */   // Label 910: @56140
     /*  56140 */   GIM_Reject,
     /*  56141 */ // Label 907: @56141
     /*  56141 */ GIM_Reject,
     /*  56142 */ // Label 847: @56142
     /*  56142 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(56301),
     /*  56147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56157 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(56217), // Rule ID 13907 //
     /*  56162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56190 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56196 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56204 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56209 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56215 */     GIR_RootConstrainSelectedInstOperands,
     /*  56216 */     // GIR_Coverage, 13907,
     /*  56216 */     GIR_EraseRootFromParent_Done,
     /*  56217 */   // Label 912: @56217
     /*  56217 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(56277), // Rule ID 5045 //
     /*  56222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56254 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56264 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56269 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56275 */     GIR_RootConstrainSelectedInstOperands,
     /*  56276 */     // GIR_Coverage, 5045,
     /*  56276 */     GIR_EraseRootFromParent_Done,
     /*  56277 */   // Label 913: @56277
     /*  56277 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(56300), // Rule ID 2485 //
     /*  56282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56293 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56298 */     GIR_RootConstrainSelectedInstOperands,
     /*  56299 */     // GIR_Coverage, 2485,
     /*  56299 */     GIR_Done,
     /*  56300 */   // Label 914: @56300
     /*  56300 */   GIM_Reject,
     /*  56301 */ // Label 911: @56301
     /*  56301 */ GIM_Reject,
     /*  56302 */ // Label 848: @56302
     /*  56302 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(56461),
     /*  56307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56317 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56377), // Rule ID 13388 //
     /*  56322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56350 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56356 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56364 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56375 */     GIR_RootConstrainSelectedInstOperands,
     /*  56376 */     // GIR_Coverage, 13388,
     /*  56376 */     GIR_EraseRootFromParent_Done,
     /*  56377 */   // Label 916: @56377
     /*  56377 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(56437), // Rule ID 1598 //
     /*  56382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56414 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56424 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56435 */     GIR_RootConstrainSelectedInstOperands,
     /*  56436 */     // GIR_Coverage, 1598,
     /*  56436 */     GIR_EraseRootFromParent_Done,
     /*  56437 */   // Label 917: @56437
     /*  56437 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(56460), // Rule ID 1596 //
     /*  56442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56453 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56458 */     GIR_RootConstrainSelectedInstOperands,
     /*  56459 */     // GIR_Coverage, 1596,
     /*  56459 */     GIR_Done,
     /*  56460 */   // Label 918: @56460
     /*  56460 */   GIM_Reject,
     /*  56461 */ // Label 915: @56461
     /*  56461 */ GIM_Reject,
     /*  56462 */ // Label 849: @56462
     /*  56462 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57002),
     /*  56467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56477 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56534), // Rule ID 15101 //
     /*  56482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56513 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56519 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56532 */     GIR_RootConstrainSelectedInstOperands,
     /*  56533 */     // GIR_Coverage, 15101,
     /*  56533 */     GIR_EraseRootFromParent_Done,
     /*  56534 */   // Label 920: @56534
     /*  56534 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56591), // Rule ID 15104 //
     /*  56539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56570 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56576 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56589 */     GIR_RootConstrainSelectedInstOperands,
     /*  56590 */     // GIR_Coverage, 15104,
     /*  56590 */     GIR_EraseRootFromParent_Done,
     /*  56591 */   // Label 921: @56591
     /*  56591 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56648), // Rule ID 15100 //
     /*  56596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56627 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56633 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56646 */     GIR_RootConstrainSelectedInstOperands,
     /*  56647 */     // GIR_Coverage, 15100,
     /*  56647 */     GIR_EraseRootFromParent_Done,
     /*  56648 */   // Label 922: @56648
     /*  56648 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56705), // Rule ID 15103 //
     /*  56653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56690 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56703 */     GIR_RootConstrainSelectedInstOperands,
     /*  56704 */     // GIR_Coverage, 15103,
     /*  56704 */     GIR_EraseRootFromParent_Done,
     /*  56705 */   // Label 923: @56705
     /*  56705 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56762), // Rule ID 15099 //
     /*  56710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56747 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56760 */     GIR_RootConstrainSelectedInstOperands,
     /*  56761 */     // GIR_Coverage, 15099,
     /*  56761 */     GIR_EraseRootFromParent_Done,
     /*  56762 */   // Label 924: @56762
     /*  56762 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56819), // Rule ID 15102 //
     /*  56767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56798 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56804 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56817 */     GIR_RootConstrainSelectedInstOperands,
     /*  56818 */     // GIR_Coverage, 15102,
     /*  56818 */     GIR_EraseRootFromParent_Done,
     /*  56819 */   // Label 925: @56819
     /*  56819 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56876), // Rule ID 8451 //
     /*  56824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56855 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56861 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56874 */     GIR_RootConstrainSelectedInstOperands,
     /*  56875 */     // GIR_Coverage, 8451,
     /*  56875 */     GIR_EraseRootFromParent_Done,
     /*  56876 */   // Label 926: @56876
     /*  56876 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56933), // Rule ID 8452 //
     /*  56881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56912 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56918 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56931 */     GIR_RootConstrainSelectedInstOperands,
     /*  56932 */     // GIR_Coverage, 8452,
     /*  56932 */     GIR_EraseRootFromParent_Done,
     /*  56933 */   // Label 927: @56933
     /*  56933 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56980), // Rule ID 10715 //
     /*  56938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56949 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56978 */     GIR_RootConstrainSelectedInstOperands,
     /*  56979 */     // GIR_Coverage, 10715,
     /*  56979 */     GIR_EraseRootFromParent_Done,
     /*  56980 */   // Label 928: @56980
     /*  56980 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57001), // Rule ID 2753 //
     /*  56985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56988 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56999 */     GIR_RootConstrainSelectedInstOperands,
     /*  57000 */     // GIR_Coverage, 2753,
     /*  57000 */     GIR_EraseRootFromParent_Done,
     /*  57001 */   // Label 929: @57001
     /*  57001 */   GIM_Reject,
     /*  57002 */ // Label 919: @57002
     /*  57002 */ GIM_Reject,
     /*  57003 */ // Label 850: @57003
     /*  57003 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57543),
     /*  57008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57018 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57075), // Rule ID 15092 //
     /*  57023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57054 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57060 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57073 */     GIR_RootConstrainSelectedInstOperands,
     /*  57074 */     // GIR_Coverage, 15092,
     /*  57074 */     GIR_EraseRootFromParent_Done,
     /*  57075 */   // Label 931: @57075
     /*  57075 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57132), // Rule ID 15095 //
     /*  57080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57111 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57117 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57130 */     GIR_RootConstrainSelectedInstOperands,
     /*  57131 */     // GIR_Coverage, 15095,
     /*  57131 */     GIR_EraseRootFromParent_Done,
     /*  57132 */   // Label 932: @57132
     /*  57132 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57189), // Rule ID 15091 //
     /*  57137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57168 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57174 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57187 */     GIR_RootConstrainSelectedInstOperands,
     /*  57188 */     // GIR_Coverage, 15091,
     /*  57188 */     GIR_EraseRootFromParent_Done,
     /*  57189 */   // Label 933: @57189
     /*  57189 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57246), // Rule ID 15094 //
     /*  57194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57225 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57231 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57244 */     GIR_RootConstrainSelectedInstOperands,
     /*  57245 */     // GIR_Coverage, 15094,
     /*  57245 */     GIR_EraseRootFromParent_Done,
     /*  57246 */   // Label 934: @57246
     /*  57246 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(57303), // Rule ID 15090 //
     /*  57251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57288 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57301 */     GIR_RootConstrainSelectedInstOperands,
     /*  57302 */     // GIR_Coverage, 15090,
     /*  57302 */     GIR_EraseRootFromParent_Done,
     /*  57303 */   // Label 935: @57303
     /*  57303 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57360), // Rule ID 15093 //
     /*  57308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57339 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57345 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57358 */     GIR_RootConstrainSelectedInstOperands,
     /*  57359 */     // GIR_Coverage, 15093,
     /*  57359 */     GIR_EraseRootFromParent_Done,
     /*  57360 */   // Label 936: @57360
     /*  57360 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57417), // Rule ID 8447 //
     /*  57365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57396 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57402 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57415 */     GIR_RootConstrainSelectedInstOperands,
     /*  57416 */     // GIR_Coverage, 8447,
     /*  57416 */     GIR_EraseRootFromParent_Done,
     /*  57417 */   // Label 937: @57417
     /*  57417 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57474), // Rule ID 8448 //
     /*  57422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57453 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57459 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57472 */     GIR_RootConstrainSelectedInstOperands,
     /*  57473 */     // GIR_Coverage, 8448,
     /*  57473 */     GIR_EraseRootFromParent_Done,
     /*  57474 */   // Label 938: @57474
     /*  57474 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57521), // Rule ID 10714 //
     /*  57479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57490 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57502 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57519 */     GIR_RootConstrainSelectedInstOperands,
     /*  57520 */     // GIR_Coverage, 10714,
     /*  57520 */     GIR_EraseRootFromParent_Done,
     /*  57521 */   // Label 939: @57521
     /*  57521 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57542), // Rule ID 2752 //
     /*  57526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57529 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57540 */     GIR_RootConstrainSelectedInstOperands,
     /*  57541 */     // GIR_Coverage, 2752,
     /*  57541 */     GIR_EraseRootFromParent_Done,
     /*  57542 */   // Label 940: @57542
     /*  57542 */   GIM_Reject,
     /*  57543 */ // Label 930: @57543
     /*  57543 */ GIM_Reject,
     /*  57544 */ // Label 851: @57544
     /*  57544 */ GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58015),
     /*  57549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57559 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57614), // Rule ID 15032 //
     /*  57564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57595 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57601 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57612 */     GIR_RootConstrainSelectedInstOperands,
     /*  57613 */     // GIR_Coverage, 15032,
     /*  57613 */     GIR_EraseRootFromParent_Done,
     /*  57614 */   // Label 942: @57614
     /*  57614 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57669), // Rule ID 15035 //
     /*  57619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57650 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57656 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57667 */     GIR_RootConstrainSelectedInstOperands,
     /*  57668 */     // GIR_Coverage, 15035,
     /*  57668 */     GIR_EraseRootFromParent_Done,
     /*  57669 */   // Label 943: @57669
     /*  57669 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57724), // Rule ID 15031 //
     /*  57674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57705 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57711 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57722 */     GIR_RootConstrainSelectedInstOperands,
     /*  57723 */     // GIR_Coverage, 15031,
     /*  57723 */     GIR_EraseRootFromParent_Done,
     /*  57724 */   // Label 944: @57724
     /*  57724 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57779), // Rule ID 15034 //
     /*  57729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57760 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57766 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57777 */     GIR_RootConstrainSelectedInstOperands,
     /*  57778 */     // GIR_Coverage, 15034,
     /*  57778 */     GIR_EraseRootFromParent_Done,
     /*  57779 */   // Label 945: @57779
     /*  57779 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57834), // Rule ID 15030 //
     /*  57784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57815 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57821 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57832 */     GIR_RootConstrainSelectedInstOperands,
     /*  57833 */     // GIR_Coverage, 15030,
     /*  57833 */     GIR_EraseRootFromParent_Done,
     /*  57834 */   // Label 946: @57834
     /*  57834 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57889), // Rule ID 15033 //
     /*  57839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57870 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57876 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57887 */     GIR_RootConstrainSelectedInstOperands,
     /*  57888 */     // GIR_Coverage, 15033,
     /*  57888 */     GIR_EraseRootFromParent_Done,
     /*  57889 */   // Label 947: @57889
     /*  57889 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57944), // Rule ID 7496 //
     /*  57894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57925 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57931 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57942 */     GIR_RootConstrainSelectedInstOperands,
     /*  57943 */     // GIR_Coverage, 7496,
     /*  57943 */     GIR_EraseRootFromParent_Done,
     /*  57944 */   // Label 948: @57944
     /*  57944 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(57999), // Rule ID 7497 //
     /*  57949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57980 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57986 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57997 */     GIR_RootConstrainSelectedInstOperands,
     /*  57998 */     // GIR_Coverage, 7497,
     /*  57998 */     GIR_EraseRootFromParent_Done,
     /*  57999 */   // Label 949: @57999
     /*  57999 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58014), // Rule ID 3146 //
     /*  58004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58007 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  58007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58012 */     GIR_RootConstrainSelectedInstOperands,
     /*  58013 */     // GIR_Coverage, 3146,
     /*  58013 */     GIR_Done,
     /*  58014 */   // Label 950: @58014
     /*  58014 */   GIM_Reject,
     /*  58015 */ // Label 941: @58015
     /*  58015 */ GIM_Reject,
     /*  58016 */ // Label 852: @58016
     /*  58016 */ GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58556),
     /*  58021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58031 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58088), // Rule ID 15083 //
     /*  58036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58067 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58073 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58086 */     GIR_RootConstrainSelectedInstOperands,
     /*  58087 */     // GIR_Coverage, 15083,
     /*  58087 */     GIR_EraseRootFromParent_Done,
     /*  58088 */   // Label 952: @58088
     /*  58088 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58145), // Rule ID 15086 //
     /*  58093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58124 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58130 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58143 */     GIR_RootConstrainSelectedInstOperands,
     /*  58144 */     // GIR_Coverage, 15086,
     /*  58144 */     GIR_EraseRootFromParent_Done,
     /*  58145 */   // Label 953: @58145
     /*  58145 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58202), // Rule ID 15082 //
     /*  58150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58181 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58187 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58200 */     GIR_RootConstrainSelectedInstOperands,
     /*  58201 */     // GIR_Coverage, 15082,
     /*  58201 */     GIR_EraseRootFromParent_Done,
     /*  58202 */   // Label 954: @58202
     /*  58202 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(58259), // Rule ID 15085 //
     /*  58207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58238 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58244 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58257 */     GIR_RootConstrainSelectedInstOperands,
     /*  58258 */     // GIR_Coverage, 15085,
     /*  58258 */     GIR_EraseRootFromParent_Done,
     /*  58259 */   // Label 955: @58259
     /*  58259 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(58316), // Rule ID 15081 //
     /*  58264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58295 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58301 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58314 */     GIR_RootConstrainSelectedInstOperands,
     /*  58315 */     // GIR_Coverage, 15081,
     /*  58315 */     GIR_EraseRootFromParent_Done,
     /*  58316 */   // Label 956: @58316
     /*  58316 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58373), // Rule ID 15084 //
     /*  58321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58352 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58358 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58371 */     GIR_RootConstrainSelectedInstOperands,
     /*  58372 */     // GIR_Coverage, 15084,
     /*  58372 */     GIR_EraseRootFromParent_Done,
     /*  58373 */   // Label 957: @58373
     /*  58373 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58430), // Rule ID 8443 //
     /*  58378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58409 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58415 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58428 */     GIR_RootConstrainSelectedInstOperands,
     /*  58429 */     // GIR_Coverage, 8443,
     /*  58429 */     GIR_EraseRootFromParent_Done,
     /*  58430 */   // Label 958: @58430
     /*  58430 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58487), // Rule ID 8444 //
     /*  58435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58466 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58472 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58485 */     GIR_RootConstrainSelectedInstOperands,
     /*  58486 */     // GIR_Coverage, 8444,
     /*  58486 */     GIR_EraseRootFromParent_Done,
     /*  58487 */   // Label 959: @58487
     /*  58487 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58534), // Rule ID 10713 //
     /*  58492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58503 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58532 */     GIR_RootConstrainSelectedInstOperands,
     /*  58533 */     // GIR_Coverage, 10713,
     /*  58533 */     GIR_EraseRootFromParent_Done,
     /*  58534 */   // Label 960: @58534
     /*  58534 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58555), // Rule ID 2751 //
     /*  58539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58542 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58553 */     GIR_RootConstrainSelectedInstOperands,
     /*  58554 */     // GIR_Coverage, 2751,
     /*  58554 */     GIR_EraseRootFromParent_Done,
     /*  58555 */   // Label 961: @58555
     /*  58555 */   GIM_Reject,
     /*  58556 */ // Label 951: @58556
     /*  58556 */ GIM_Reject,
     /*  58557 */ // Label 853: @58557
     /*  58557 */ GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59028),
     /*  58562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58572 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58627), // Rule ID 15023 //
     /*  58577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58614 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58625 */     GIR_RootConstrainSelectedInstOperands,
     /*  58626 */     // GIR_Coverage, 15023,
     /*  58626 */     GIR_EraseRootFromParent_Done,
     /*  58627 */   // Label 963: @58627
     /*  58627 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58682), // Rule ID 15026 //
     /*  58632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58663 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58669 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58680 */     GIR_RootConstrainSelectedInstOperands,
     /*  58681 */     // GIR_Coverage, 15026,
     /*  58681 */     GIR_EraseRootFromParent_Done,
     /*  58682 */   // Label 964: @58682
     /*  58682 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58737), // Rule ID 15022 //
     /*  58687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58718 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58724 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58735 */     GIR_RootConstrainSelectedInstOperands,
     /*  58736 */     // GIR_Coverage, 15022,
     /*  58736 */     GIR_EraseRootFromParent_Done,
     /*  58737 */   // Label 965: @58737
     /*  58737 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58792), // Rule ID 15025 //
     /*  58742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58773 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58779 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58790 */     GIR_RootConstrainSelectedInstOperands,
     /*  58791 */     // GIR_Coverage, 15025,
     /*  58791 */     GIR_EraseRootFromParent_Done,
     /*  58792 */   // Label 966: @58792
     /*  58792 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58847), // Rule ID 15021 //
     /*  58797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58828 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58834 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58845 */     GIR_RootConstrainSelectedInstOperands,
     /*  58846 */     // GIR_Coverage, 15021,
     /*  58846 */     GIR_EraseRootFromParent_Done,
     /*  58847 */   // Label 967: @58847
     /*  58847 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58902), // Rule ID 15024 //
     /*  58852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58883 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58889 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58900 */     GIR_RootConstrainSelectedInstOperands,
     /*  58901 */     // GIR_Coverage, 15024,
     /*  58901 */     GIR_EraseRootFromParent_Done,
     /*  58902 */   // Label 968: @58902
     /*  58902 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58957), // Rule ID 7492 //
     /*  58907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58938 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58944 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58955 */     GIR_RootConstrainSelectedInstOperands,
     /*  58956 */     // GIR_Coverage, 7492,
     /*  58956 */     GIR_EraseRootFromParent_Done,
     /*  58957 */   // Label 969: @58957
     /*  58957 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59012), // Rule ID 7493 //
     /*  58962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58993 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58999 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59010 */     GIR_RootConstrainSelectedInstOperands,
     /*  59011 */     // GIR_Coverage, 7493,
     /*  59011 */     GIR_EraseRootFromParent_Done,
     /*  59012 */   // Label 970: @59012
     /*  59012 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59027), // Rule ID 3145 //
     /*  59017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59020 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59025 */     GIR_RootConstrainSelectedInstOperands,
     /*  59026 */     // GIR_Coverage, 3145,
     /*  59026 */     GIR_Done,
     /*  59027 */   // Label 971: @59027
     /*  59027 */   GIM_Reject,
     /*  59028 */ // Label 962: @59028
     /*  59028 */ GIM_Reject,
     /*  59029 */ // Label 854: @59029
     /*  59029 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59569),
     /*  59034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59044 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59101), // Rule ID 15074 //
     /*  59049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59080 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59086 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59099 */     GIR_RootConstrainSelectedInstOperands,
     /*  59100 */     // GIR_Coverage, 15074,
     /*  59100 */     GIR_EraseRootFromParent_Done,
     /*  59101 */   // Label 973: @59101
     /*  59101 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59158), // Rule ID 15077 //
     /*  59106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59137 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59143 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59156 */     GIR_RootConstrainSelectedInstOperands,
     /*  59157 */     // GIR_Coverage, 15077,
     /*  59157 */     GIR_EraseRootFromParent_Done,
     /*  59158 */   // Label 974: @59158
     /*  59158 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59215), // Rule ID 15073 //
     /*  59163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59194 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59200 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59213 */     GIR_RootConstrainSelectedInstOperands,
     /*  59214 */     // GIR_Coverage, 15073,
     /*  59214 */     GIR_EraseRootFromParent_Done,
     /*  59215 */   // Label 975: @59215
     /*  59215 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(59272), // Rule ID 15076 //
     /*  59220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59251 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59257 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59270 */     GIR_RootConstrainSelectedInstOperands,
     /*  59271 */     // GIR_Coverage, 15076,
     /*  59271 */     GIR_EraseRootFromParent_Done,
     /*  59272 */   // Label 976: @59272
     /*  59272 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(59329), // Rule ID 15072 //
     /*  59277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59308 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59314 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59327 */     GIR_RootConstrainSelectedInstOperands,
     /*  59328 */     // GIR_Coverage, 15072,
     /*  59328 */     GIR_EraseRootFromParent_Done,
     /*  59329 */   // Label 977: @59329
     /*  59329 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59386), // Rule ID 15075 //
     /*  59334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59365 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59371 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59384 */     GIR_RootConstrainSelectedInstOperands,
     /*  59385 */     // GIR_Coverage, 15075,
     /*  59385 */     GIR_EraseRootFromParent_Done,
     /*  59386 */   // Label 978: @59386
     /*  59386 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59443), // Rule ID 8439 //
     /*  59391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59422 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59428 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59441 */     GIR_RootConstrainSelectedInstOperands,
     /*  59442 */     // GIR_Coverage, 8439,
     /*  59442 */     GIR_EraseRootFromParent_Done,
     /*  59443 */   // Label 979: @59443
     /*  59443 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59500), // Rule ID 8440 //
     /*  59448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59479 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59485 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59498 */     GIR_RootConstrainSelectedInstOperands,
     /*  59499 */     // GIR_Coverage, 8440,
     /*  59499 */     GIR_EraseRootFromParent_Done,
     /*  59500 */   // Label 980: @59500
     /*  59500 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59547), // Rule ID 10712 //
     /*  59505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59516 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59528 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59545 */     GIR_RootConstrainSelectedInstOperands,
     /*  59546 */     // GIR_Coverage, 10712,
     /*  59546 */     GIR_EraseRootFromParent_Done,
     /*  59547 */   // Label 981: @59547
     /*  59547 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59568), // Rule ID 2750 //
     /*  59552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59555 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59566 */     GIR_RootConstrainSelectedInstOperands,
     /*  59567 */     // GIR_Coverage, 2750,
     /*  59567 */     GIR_EraseRootFromParent_Done,
     /*  59568 */   // Label 982: @59568
     /*  59568 */   GIM_Reject,
     /*  59569 */ // Label 972: @59569
     /*  59569 */ GIM_Reject,
     /*  59570 */ // Label 855: @59570
     /*  59570 */ GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60041),
     /*  59575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59585 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59640), // Rule ID 15014 //
     /*  59590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59627 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59638 */     GIR_RootConstrainSelectedInstOperands,
     /*  59639 */     // GIR_Coverage, 15014,
     /*  59639 */     GIR_EraseRootFromParent_Done,
     /*  59640 */   // Label 984: @59640
     /*  59640 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59695), // Rule ID 15017 //
     /*  59645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59676 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59682 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59693 */     GIR_RootConstrainSelectedInstOperands,
     /*  59694 */     // GIR_Coverage, 15017,
     /*  59694 */     GIR_EraseRootFromParent_Done,
     /*  59695 */   // Label 985: @59695
     /*  59695 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59750), // Rule ID 15013 //
     /*  59700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59731 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59737 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59748 */     GIR_RootConstrainSelectedInstOperands,
     /*  59749 */     // GIR_Coverage, 15013,
     /*  59749 */     GIR_EraseRootFromParent_Done,
     /*  59750 */   // Label 986: @59750
     /*  59750 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59805), // Rule ID 15016 //
     /*  59755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59786 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59792 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59803 */     GIR_RootConstrainSelectedInstOperands,
     /*  59804 */     // GIR_Coverage, 15016,
     /*  59804 */     GIR_EraseRootFromParent_Done,
     /*  59805 */   // Label 987: @59805
     /*  59805 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59860), // Rule ID 15012 //
     /*  59810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59841 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59847 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59858 */     GIR_RootConstrainSelectedInstOperands,
     /*  59859 */     // GIR_Coverage, 15012,
     /*  59859 */     GIR_EraseRootFromParent_Done,
     /*  59860 */   // Label 988: @59860
     /*  59860 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59915), // Rule ID 15015 //
     /*  59865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59896 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59902 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59913 */     GIR_RootConstrainSelectedInstOperands,
     /*  59914 */     // GIR_Coverage, 15015,
     /*  59914 */     GIR_EraseRootFromParent_Done,
     /*  59915 */   // Label 989: @59915
     /*  59915 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59970), // Rule ID 7488 //
     /*  59920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59951 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59957 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59968 */     GIR_RootConstrainSelectedInstOperands,
     /*  59969 */     // GIR_Coverage, 7488,
     /*  59969 */     GIR_EraseRootFromParent_Done,
     /*  59970 */   // Label 990: @59970
     /*  59970 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60025), // Rule ID 7489 //
     /*  59975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60006 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60012 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60023 */     GIR_RootConstrainSelectedInstOperands,
     /*  60024 */     // GIR_Coverage, 7489,
     /*  60024 */     GIR_EraseRootFromParent_Done,
     /*  60025 */   // Label 991: @60025
     /*  60025 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60040), // Rule ID 3144 //
     /*  60030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60033 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60038 */     GIR_RootConstrainSelectedInstOperands,
     /*  60039 */     // GIR_Coverage, 3144,
     /*  60039 */     GIR_Done,
     /*  60040 */   // Label 992: @60040
     /*  60040 */   GIM_Reject,
     /*  60041 */ // Label 983: @60041
     /*  60041 */ GIM_Reject,
     /*  60042 */ // Label 856: @60042
     /*  60042 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60582),
     /*  60047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60057 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60114), // Rule ID 15065 //
     /*  60062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60093 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60099 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60112 */     GIR_RootConstrainSelectedInstOperands,
     /*  60113 */     // GIR_Coverage, 15065,
     /*  60113 */     GIR_EraseRootFromParent_Done,
     /*  60114 */   // Label 994: @60114
     /*  60114 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60171), // Rule ID 15068 //
     /*  60119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60150 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60156 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60169 */     GIR_RootConstrainSelectedInstOperands,
     /*  60170 */     // GIR_Coverage, 15068,
     /*  60170 */     GIR_EraseRootFromParent_Done,
     /*  60171 */   // Label 995: @60171
     /*  60171 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60228), // Rule ID 15064 //
     /*  60176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60207 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60213 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60226 */     GIR_RootConstrainSelectedInstOperands,
     /*  60227 */     // GIR_Coverage, 15064,
     /*  60227 */     GIR_EraseRootFromParent_Done,
     /*  60228 */   // Label 996: @60228
     /*  60228 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(60285), // Rule ID 15067 //
     /*  60233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60264 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60270 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60283 */     GIR_RootConstrainSelectedInstOperands,
     /*  60284 */     // GIR_Coverage, 15067,
     /*  60284 */     GIR_EraseRootFromParent_Done,
     /*  60285 */   // Label 997: @60285
     /*  60285 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(60342), // Rule ID 15063 //
     /*  60290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60321 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60327 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60340 */     GIR_RootConstrainSelectedInstOperands,
     /*  60341 */     // GIR_Coverage, 15063,
     /*  60341 */     GIR_EraseRootFromParent_Done,
     /*  60342 */   // Label 998: @60342
     /*  60342 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(60399), // Rule ID 15066 //
     /*  60347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60378 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60384 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60397 */     GIR_RootConstrainSelectedInstOperands,
     /*  60398 */     // GIR_Coverage, 15066,
     /*  60398 */     GIR_EraseRootFromParent_Done,
     /*  60399 */   // Label 999: @60399
     /*  60399 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(60456), // Rule ID 8435 //
     /*  60404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60435 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60441 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60454 */     GIR_RootConstrainSelectedInstOperands,
     /*  60455 */     // GIR_Coverage, 8435,
     /*  60455 */     GIR_EraseRootFromParent_Done,
     /*  60456 */   // Label 1000: @60456
     /*  60456 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60513), // Rule ID 8436 //
     /*  60461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60492 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60498 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60511 */     GIR_RootConstrainSelectedInstOperands,
     /*  60512 */     // GIR_Coverage, 8436,
     /*  60512 */     GIR_EraseRootFromParent_Done,
     /*  60513 */   // Label 1001: @60513
     /*  60513 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60560), // Rule ID 10711 //
     /*  60518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60529 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60541 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60558 */     GIR_RootConstrainSelectedInstOperands,
     /*  60559 */     // GIR_Coverage, 10711,
     /*  60559 */     GIR_EraseRootFromParent_Done,
     /*  60560 */   // Label 1002: @60560
     /*  60560 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60581), // Rule ID 2749 //
     /*  60565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60568 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60579 */     GIR_RootConstrainSelectedInstOperands,
     /*  60580 */     // GIR_Coverage, 2749,
     /*  60580 */     GIR_EraseRootFromParent_Done,
     /*  60581 */   // Label 1003: @60581
     /*  60581 */   GIM_Reject,
     /*  60582 */ // Label 993: @60582
     /*  60582 */ GIM_Reject,
     /*  60583 */ // Label 857: @60583
     /*  60583 */ GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61054),
     /*  60588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60598 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60653), // Rule ID 15005 //
     /*  60603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60634 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60640 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60651 */     GIR_RootConstrainSelectedInstOperands,
     /*  60652 */     // GIR_Coverage, 15005,
     /*  60652 */     GIR_EraseRootFromParent_Done,
     /*  60653 */   // Label 1005: @60653
     /*  60653 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60708), // Rule ID 15008 //
     /*  60658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60695 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60706 */     GIR_RootConstrainSelectedInstOperands,
     /*  60707 */     // GIR_Coverage, 15008,
     /*  60707 */     GIR_EraseRootFromParent_Done,
     /*  60708 */   // Label 1006: @60708
     /*  60708 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60763), // Rule ID 15004 //
     /*  60713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60744 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60750 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60761 */     GIR_RootConstrainSelectedInstOperands,
     /*  60762 */     // GIR_Coverage, 15004,
     /*  60762 */     GIR_EraseRootFromParent_Done,
     /*  60763 */   // Label 1007: @60763
     /*  60763 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60818), // Rule ID 15007 //
     /*  60768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60799 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60805 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60816 */     GIR_RootConstrainSelectedInstOperands,
     /*  60817 */     // GIR_Coverage, 15007,
     /*  60817 */     GIR_EraseRootFromParent_Done,
     /*  60818 */   // Label 1008: @60818
     /*  60818 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60873), // Rule ID 15003 //
     /*  60823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60854 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60860 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60871 */     GIR_RootConstrainSelectedInstOperands,
     /*  60872 */     // GIR_Coverage, 15003,
     /*  60872 */     GIR_EraseRootFromParent_Done,
     /*  60873 */   // Label 1009: @60873
     /*  60873 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60928), // Rule ID 15006 //
     /*  60878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60909 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60915 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60926 */     GIR_RootConstrainSelectedInstOperands,
     /*  60927 */     // GIR_Coverage, 15006,
     /*  60927 */     GIR_EraseRootFromParent_Done,
     /*  60928 */   // Label 1010: @60928
     /*  60928 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(60983), // Rule ID 7484 //
     /*  60933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60964 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60970 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60981 */     GIR_RootConstrainSelectedInstOperands,
     /*  60982 */     // GIR_Coverage, 7484,
     /*  60982 */     GIR_EraseRootFromParent_Done,
     /*  60983 */   // Label 1011: @60983
     /*  60983 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61038), // Rule ID 7485 //
     /*  60988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  61003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  61007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61019 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61025 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61036 */     GIR_RootConstrainSelectedInstOperands,
     /*  61037 */     // GIR_Coverage, 7485,
     /*  61037 */     GIR_EraseRootFromParent_Done,
     /*  61038 */   // Label 1012: @61038
     /*  61038 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61053), // Rule ID 3143 //
     /*  61043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61046 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61046 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61051 */     GIR_RootConstrainSelectedInstOperands,
     /*  61052 */     // GIR_Coverage, 3143,
     /*  61052 */     GIR_Done,
     /*  61053 */   // Label 1013: @61053
     /*  61053 */   GIM_Reject,
     /*  61054 */ // Label 1004: @61054
     /*  61054 */ GIM_Reject,
     /*  61055 */ // Label 858: @61055
     /*  61055 */ GIM_Reject,
     /*  61056 */ // Label 6: @61056
     /*  61056 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1032*/ GIMT_Encode4(72834),
     /*  61067 */ /*GILLT_s32*//*Label 1014*/ GIMT_Encode4(61155),
     /*  61071 */ /*GILLT_s64*//*Label 1015*/ GIMT_Encode4(61515), GIMT_Encode4(0),
     /*  61079 */ /*GILLT_v2s32*//*Label 1016*/ GIMT_Encode4(63414),
     /*  61083 */ /*GILLT_v2s64*//*Label 1017*/ GIMT_Encode4(64722),
     /*  61087 */ /*GILLT_v4s16*//*Label 1018*/ GIMT_Encode4(66030),
     /*  61091 */ /*GILLT_v4s32*//*Label 1019*/ GIMT_Encode4(67338),
     /*  61095 */ /*GILLT_v8s8*//*Label 1020*/ GIMT_Encode4(68646),
     /*  61099 */ /*GILLT_v8s16*//*Label 1021*/ GIMT_Encode4(69954),
     /*  61103 */ /*GILLT_v16s8*//*Label 1022*/ GIMT_Encode4(71262),
     /*  61107 */ /*GILLT_nxv1s1*//*Label 1023*/ GIMT_Encode4(72570),
     /*  61111 */ /*GILLT_nxv2s1*//*Label 1024*/ GIMT_Encode4(72602), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  61123 */ /*GILLT_nxv2s64*//*Label 1025*/ GIMT_Encode4(72634),
     /*  61127 */ /*GILLT_nxv4s1*//*Label 1026*/ GIMT_Encode4(72660), GIMT_Encode4(0),
     /*  61135 */ /*GILLT_nxv4s32*//*Label 1027*/ GIMT_Encode4(72692),
     /*  61139 */ /*GILLT_nxv8s1*//*Label 1028*/ GIMT_Encode4(72718),
     /*  61143 */ /*GILLT_nxv8s16*//*Label 1029*/ GIMT_Encode4(72750),
     /*  61147 */ /*GILLT_nxv16s1*//*Label 1030*/ GIMT_Encode4(72776),
     /*  61151 */ /*GILLT_nxv16s8*//*Label 1031*/ GIMT_Encode4(72808),
     /*  61155 */ // Label 1014: @61155
     /*  61155 */ GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(61514),
     /*  61160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61166 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61221), // Rule ID 13271 //
     /*  61171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61191 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61208 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61219 */     GIR_RootConstrainSelectedInstOperands,
     /*  61220 */     // GIR_Coverage, 13271,
     /*  61220 */     GIR_EraseRootFromParent_Done,
     /*  61221 */   // Label 1034: @61221
     /*  61221 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(61276), // Rule ID 174 //
     /*  61226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61250 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61263 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61274 */     GIR_RootConstrainSelectedInstOperands,
     /*  61275 */     // GIR_Coverage, 174,
     /*  61275 */     GIR_EraseRootFromParent_Done,
     /*  61276 */   // Label 1035: @61276
     /*  61276 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61317), // Rule ID 146 //
     /*  61281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  61285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61297 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  61301 */     // MIs[1] Operand 1
     /*  61301 */     // No operand predicates
     /*  61301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61303 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  61303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  61306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61310 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  61315 */     GIR_RootConstrainSelectedInstOperands,
     /*  61316 */     // GIR_Coverage, 146,
     /*  61316 */     GIR_EraseRootFromParent_Done,
     /*  61317 */   // Label 1036: @61317
     /*  61317 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61350), // Rule ID 13273 //
     /*  61322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61337 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61348 */     GIR_RootConstrainSelectedInstOperands,
     /*  61349 */     // GIR_Coverage, 13273,
     /*  61349 */     GIR_EraseRootFromParent_Done,
     /*  61350 */   // Label 1037: @61350
     /*  61350 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61383), // Rule ID 178 //
     /*  61355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61370 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61381 */     GIR_RootConstrainSelectedInstOperands,
     /*  61382 */     // GIR_Coverage, 178,
     /*  61382 */     GIR_EraseRootFromParent_Done,
     /*  61383 */   // Label 1038: @61383
     /*  61383 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(61436), // Rule ID 13269 //
     /*  61388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61413 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61423 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61434 */     GIR_RootConstrainSelectedInstOperands,
     /*  61435 */     // GIR_Coverage, 13269,
     /*  61435 */     GIR_EraseRootFromParent_Done,
     /*  61436 */   // Label 1039: @61436
     /*  61436 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(61489), // Rule ID 172 //
     /*  61441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61476 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61487 */     GIR_RootConstrainSelectedInstOperands,
     /*  61488 */     // GIR_Coverage, 172,
     /*  61488 */     GIR_EraseRootFromParent_Done,
     /*  61489 */   // Label 1040: @61489
     /*  61489 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61513), // Rule ID 176 //
     /*  61494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61506 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61511 */     GIR_RootConstrainSelectedInstOperands,
     /*  61512 */     // GIR_Coverage, 176,
     /*  61512 */     GIR_Done,
     /*  61513 */   // Label 1041: @61513
     /*  61513 */   GIM_Reject,
     /*  61514 */ // Label 1033: @61514
     /*  61514 */ GIM_Reject,
     /*  61515 */ // Label 1015: @61515
     /*  61515 */ GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(63413),
     /*  61520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61526 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61648), // Rule ID 4017 //
     /*  61531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61572 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61576 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61595 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61599 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61603 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61607 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61611 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61615 */     // MIs[4] Rn
     /*  61615 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61620 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61624 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61635 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61637 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61646 */     GIR_RootConstrainSelectedInstOperands,
     /*  61647 */     // GIR_Coverage, 4017,
     /*  61647 */     GIR_EraseRootFromParent_Done,
     /*  61648 */   // Label 1043: @61648
     /*  61648 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61770), // Rule ID 13821 //
     /*  61653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61694 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61698 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61717 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61721 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61725 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61729 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61733 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61737 */     // MIs[4] Rn
     /*  61737 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61742 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61746 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61757 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61759 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61768 */     GIR_RootConstrainSelectedInstOperands,
     /*  61769 */     // GIR_Coverage, 13821,
     /*  61769 */     GIR_EraseRootFromParent_Done,
     /*  61770 */   // Label 1044: @61770
     /*  61770 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61825), // Rule ID 13272 //
     /*  61775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61795 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61812 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61823 */     GIR_RootConstrainSelectedInstOperands,
     /*  61824 */     // GIR_Coverage, 13272,
     /*  61824 */     GIR_EraseRootFromParent_Done,
     /*  61825 */   // Label 1045: @61825
     /*  61825 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61880), // Rule ID 175 //
     /*  61830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61854 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61867 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61878 */     GIR_RootConstrainSelectedInstOperands,
     /*  61879 */     // GIR_Coverage, 175,
     /*  61879 */     GIR_EraseRootFromParent_Done,
     /*  61880 */   // Label 1046: @61880
     /*  61880 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61989), // Rule ID 13621 //
     /*  61885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61933 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61950 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61954 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61958 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61963 */     // MIs[4] LHS
     /*  61963 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61968 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61970 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61987 */     GIR_RootConstrainSelectedInstOperands,
     /*  61988 */     // GIR_Coverage, 13621,
     /*  61988 */     GIR_EraseRootFromParent_Done,
     /*  61989 */   // Label 1047: @61989
     /*  61989 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62098), // Rule ID 13620 //
     /*  61994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62042 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62055 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62059 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62063 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62067 */     // MIs[4] LHS
     /*  62067 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62072 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62077 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62079 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62096 */     GIR_RootConstrainSelectedInstOperands,
     /*  62097 */     // GIR_Coverage, 13620,
     /*  62097 */     GIR_EraseRootFromParent_Done,
     /*  62098 */   // Label 1048: @62098
     /*  62098 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62207), // Rule ID 13623 //
     /*  62103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62156 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62162 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62168 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62172 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  62176 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62181 */     // MIs[4] LHS
     /*  62181 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62188 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62205 */     GIR_RootConstrainSelectedInstOperands,
     /*  62206 */     // GIR_Coverage, 13623,
     /*  62206 */     GIR_EraseRootFromParent_Done,
     /*  62207 */   // Label 1049: @62207
     /*  62207 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62316), // Rule ID 13622 //
     /*  62212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62265 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62277 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62281 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62285 */     // MIs[4] LHS
     /*  62285 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62290 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62295 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62297 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62314 */     GIR_RootConstrainSelectedInstOperands,
     /*  62315 */     // GIR_Coverage, 13622,
     /*  62315 */     GIR_EraseRootFromParent_Done,
     /*  62316 */   // Label 1050: @62316
     /*  62316 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62425), // Rule ID 2471 //
     /*  62321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62378 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62382 */     // MIs[3] LHS
     /*  62382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62387 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62391 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62404 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62406 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62423 */     GIR_RootConstrainSelectedInstOperands,
     /*  62424 */     // GIR_Coverage, 2471,
     /*  62424 */     GIR_EraseRootFromParent_Done,
     /*  62425 */   // Label 1051: @62425
     /*  62425 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62534), // Rule ID 13618 //
     /*  62430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62491 */     // MIs[3] LHS
     /*  62491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62500 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62506 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62513 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62515 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62532 */     GIR_RootConstrainSelectedInstOperands,
     /*  62533 */     // GIR_Coverage, 13618,
     /*  62533 */     GIR_EraseRootFromParent_Done,
     /*  62534 */   // Label 1052: @62534
     /*  62534 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62643), // Rule ID 13617 //
     /*  62539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62601 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62605 */     // MIs[3] LHS
     /*  62605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62610 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62614 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62624 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62641 */     GIR_RootConstrainSelectedInstOperands,
     /*  62642 */     // GIR_Coverage, 13617,
     /*  62642 */     GIR_EraseRootFromParent_Done,
     /*  62643 */   // Label 1053: @62643
     /*  62643 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62752), // Rule ID 13619 //
     /*  62648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62710 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62714 */     // MIs[3] LHS
     /*  62714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62719 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62723 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62731 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62733 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62750 */     GIR_RootConstrainSelectedInstOperands,
     /*  62751 */     // GIR_Coverage, 13619,
     /*  62751 */     GIR_EraseRootFromParent_Done,
     /*  62752 */   // Label 1054: @62752
     /*  62752 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62793), // Rule ID 147 //
     /*  62757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62773 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62777 */     // MIs[1] Operand 1
     /*  62777 */     // No operand predicates
     /*  62777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62779 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62786 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62791 */     GIR_RootConstrainSelectedInstOperands,
     /*  62792 */     // GIR_Coverage, 147,
     /*  62792 */     GIR_EraseRootFromParent_Done,
     /*  62793 */   // Label 1055: @62793
     /*  62793 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62826), // Rule ID 13274 //
     /*  62798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62813 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62824 */     GIR_RootConstrainSelectedInstOperands,
     /*  62825 */     // GIR_Coverage, 13274,
     /*  62825 */     GIR_EraseRootFromParent_Done,
     /*  62826 */   // Label 1056: @62826
     /*  62826 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62859), // Rule ID 179 //
     /*  62831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62846 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62857 */     GIR_RootConstrainSelectedInstOperands,
     /*  62858 */     // GIR_Coverage, 179,
     /*  62858 */     GIR_EraseRootFromParent_Done,
     /*  62859 */   // Label 1057: @62859
     /*  62859 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62926), // Rule ID 13557 //
     /*  62864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62888 */     // MIs[1] imm
     /*  62888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62896 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62900 */     // MIs[2] Operand 1
     /*  62900 */     // No operand predicates
     /*  62900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62910 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62924 */     GIR_RootConstrainSelectedInstOperands,
     /*  62925 */     // GIR_Coverage, 13557,
     /*  62925 */     GIR_EraseRootFromParent_Done,
     /*  62926 */   // Label 1058: @62926
     /*  62926 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(62993), // Rule ID 13560 //
     /*  62931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62955 */     // MIs[1] imm
     /*  62955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62963 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62967 */     // MIs[2] Operand 1
     /*  62967 */     // No operand predicates
     /*  62967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62977 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62991 */     GIR_RootConstrainSelectedInstOperands,
     /*  62992 */     // GIR_Coverage, 13560,
     /*  62992 */     GIR_EraseRootFromParent_Done,
     /*  62993 */   // Label 1059: @62993
     /*  62993 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63046), // Rule ID 13270 //
     /*  62998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63023 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63033 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63044 */     GIR_RootConstrainSelectedInstOperands,
     /*  63045 */     // GIR_Coverage, 13270,
     /*  63045 */     GIR_EraseRootFromParent_Done,
     /*  63046 */   // Label 1060: @63046
     /*  63046 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63113), // Rule ID 2122 //
     /*  63051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63079 */     // MIs[1] imm
     /*  63079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63091 */     // MIs[2] Operand 1
     /*  63091 */     // No operand predicates
     /*  63091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63097 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  63100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63111 */     GIR_RootConstrainSelectedInstOperands,
     /*  63112 */     // GIR_Coverage, 2122,
     /*  63112 */     GIR_EraseRootFromParent_Done,
     /*  63113 */   // Label 1061: @63113
     /*  63113 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63180), // Rule ID 2131 //
     /*  63118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63146 */     // MIs[1] imm
     /*  63146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63158 */     // MIs[2] Operand 1
     /*  63158 */     // No operand predicates
     /*  63158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63164 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  63167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63178 */     GIR_RootConstrainSelectedInstOperands,
     /*  63179 */     // GIR_Coverage, 2131,
     /*  63179 */     GIR_EraseRootFromParent_Done,
     /*  63180 */   // Label 1062: @63180
     /*  63180 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63233), // Rule ID 173 //
     /*  63185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63214 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63220 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63231 */     GIR_RootConstrainSelectedInstOperands,
     /*  63232 */     // GIR_Coverage, 173,
     /*  63232 */     GIR_EraseRootFromParent_Done,
     /*  63233 */   // Label 1063: @63233
     /*  63233 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63297), // Rule ID 13912 //
     /*  63238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63270 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63276 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63284 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63289 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63295 */     GIR_RootConstrainSelectedInstOperands,
     /*  63296 */     // GIR_Coverage, 13912,
     /*  63296 */     GIR_EraseRootFromParent_Done,
     /*  63297 */   // Label 1064: @63297
     /*  63297 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63361), // Rule ID 5056 //
     /*  63302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63338 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63348 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63353 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63359 */     GIR_RootConstrainSelectedInstOperands,
     /*  63360 */     // GIR_Coverage, 5056,
     /*  63360 */     GIR_EraseRootFromParent_Done,
     /*  63361 */   // Label 1065: @63361
     /*  63361 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63385), // Rule ID 177 //
     /*  63366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63378 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63383 */     GIR_RootConstrainSelectedInstOperands,
     /*  63384 */     // GIR_Coverage, 177,
     /*  63384 */     GIR_Done,
     /*  63385 */   // Label 1066: @63385
     /*  63385 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63412), // Rule ID 5062 //
     /*  63390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63405 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63410 */     GIR_RootConstrainSelectedInstOperands,
     /*  63411 */     // GIR_Coverage, 5062,
     /*  63411 */     GIR_Done,
     /*  63412 */   // Label 1067: @63412
     /*  63412 */   GIM_Reject,
     /*  63413 */ // Label 1042: @63413
     /*  63413 */ GIM_Reject,
     /*  63414 */ // Label 1016: @63414
     /*  63414 */ GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64721),
     /*  63419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63425 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63534), // Rule ID 13614 //
     /*  63430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63478 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63484 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63491 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63495 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63499 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63503 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63508 */     // MIs[4] LHS
     /*  63508 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63513 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63515 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63532 */     GIR_RootConstrainSelectedInstOperands,
     /*  63533 */     // GIR_Coverage, 13614,
     /*  63533 */     GIR_EraseRootFromParent_Done,
     /*  63534 */   // Label 1069: @63534
     /*  63534 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63643), // Rule ID 13613 //
     /*  63539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63587 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63608 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63612 */     // MIs[4] LHS
     /*  63612 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63617 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63624 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63641 */     GIR_RootConstrainSelectedInstOperands,
     /*  63642 */     // GIR_Coverage, 13613,
     /*  63642 */     GIR_EraseRootFromParent_Done,
     /*  63643 */   // Label 1070: @63643
     /*  63643 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63752), // Rule ID 13616 //
     /*  63648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63701 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63707 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63721 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63726 */     // MIs[4] LHS
     /*  63726 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63731 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63733 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63750 */     GIR_RootConstrainSelectedInstOperands,
     /*  63751 */     // GIR_Coverage, 13616,
     /*  63751 */     GIR_EraseRootFromParent_Done,
     /*  63752 */   // Label 1071: @63752
     /*  63752 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63861), // Rule ID 13615 //
     /*  63757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63810 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63816 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63826 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63830 */     // MIs[4] LHS
     /*  63830 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63835 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63840 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63842 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63859 */     GIR_RootConstrainSelectedInstOperands,
     /*  63860 */     // GIR_Coverage, 13615,
     /*  63860 */     GIR_EraseRootFromParent_Done,
     /*  63861 */   // Label 1072: @63861
     /*  63861 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63970), // Rule ID 2470 //
     /*  63866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63927 */     // MIs[3] LHS
     /*  63927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63936 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63949 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63951 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63968 */     GIR_RootConstrainSelectedInstOperands,
     /*  63969 */     // GIR_Coverage, 2470,
     /*  63969 */     GIR_EraseRootFromParent_Done,
     /*  63970 */   // Label 1073: @63970
     /*  63970 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64079), // Rule ID 13611 //
     /*  63975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64032 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64036 */     // MIs[3] LHS
     /*  64036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64041 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64045 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64051 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64060 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64077 */     GIR_RootConstrainSelectedInstOperands,
     /*  64078 */     // GIR_Coverage, 13611,
     /*  64078 */     GIR_EraseRootFromParent_Done,
     /*  64079 */   // Label 1074: @64079
     /*  64079 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64188), // Rule ID 13610 //
     /*  64084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64146 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64150 */     // MIs[3] LHS
     /*  64150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64155 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64159 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64167 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64169 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64186 */     GIR_RootConstrainSelectedInstOperands,
     /*  64187 */     // GIR_Coverage, 13610,
     /*  64187 */     GIR_EraseRootFromParent_Done,
     /*  64188 */   // Label 1075: @64188
     /*  64188 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64297), // Rule ID 13612 //
     /*  64193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64255 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64259 */     // MIs[3] LHS
     /*  64259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64268 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64274 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64278 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64295 */     GIR_RootConstrainSelectedInstOperands,
     /*  64296 */     // GIR_Coverage, 13612,
     /*  64296 */     GIR_EraseRootFromParent_Done,
     /*  64297 */   // Label 1076: @64297
     /*  64297 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64364), // Rule ID 13577 //
     /*  64302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64326 */     // MIs[1] imm
     /*  64326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64334 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64338 */     // MIs[2] Operand 1
     /*  64338 */     // No operand predicates
     /*  64338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64342 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64348 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64362 */     GIR_RootConstrainSelectedInstOperands,
     /*  64363 */     // GIR_Coverage, 13577,
     /*  64363 */     GIR_EraseRootFromParent_Done,
     /*  64364 */   // Label 1077: @64364
     /*  64364 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64431), // Rule ID 13598 //
     /*  64369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64393 */     // MIs[1] imm
     /*  64393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64401 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64405 */     // MIs[2] Operand 1
     /*  64405 */     // No operand predicates
     /*  64405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64415 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64429 */     GIR_RootConstrainSelectedInstOperands,
     /*  64430 */     // GIR_Coverage, 13598,
     /*  64430 */     GIR_EraseRootFromParent_Done,
     /*  64431 */   // Label 1078: @64431
     /*  64431 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64498), // Rule ID 2239 //
     /*  64436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64464 */     // MIs[1] imm
     /*  64464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64472 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64476 */     // MIs[2] Operand 1
     /*  64476 */     // No operand predicates
     /*  64476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64482 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64496 */     GIR_RootConstrainSelectedInstOperands,
     /*  64497 */     // GIR_Coverage, 2239,
     /*  64497 */     GIR_EraseRootFromParent_Done,
     /*  64498 */   // Label 1079: @64498
     /*  64498 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64565), // Rule ID 2298 //
     /*  64503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64531 */     // MIs[1] imm
     /*  64531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64539 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64543 */     // MIs[2] Operand 1
     /*  64543 */     // No operand predicates
     /*  64543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64549 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64563 */     GIR_RootConstrainSelectedInstOperands,
     /*  64564 */     // GIR_Coverage, 2298,
     /*  64564 */     GIR_EraseRootFromParent_Done,
     /*  64565 */   // Label 1080: @64565
     /*  64565 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64629), // Rule ID 13911 //
     /*  64570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64602 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64616 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64621 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64627 */     GIR_RootConstrainSelectedInstOperands,
     /*  64628 */     // GIR_Coverage, 13911,
     /*  64628 */     GIR_EraseRootFromParent_Done,
     /*  64629 */   // Label 1081: @64629
     /*  64629 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64693), // Rule ID 5055 //
     /*  64634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64670 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64676 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64680 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64685 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64691 */     GIR_RootConstrainSelectedInstOperands,
     /*  64692 */     // GIR_Coverage, 5055,
     /*  64692 */     GIR_EraseRootFromParent_Done,
     /*  64693 */   // Label 1082: @64693
     /*  64693 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64720), // Rule ID 5061 //
     /*  64698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64713 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64718 */     GIR_RootConstrainSelectedInstOperands,
     /*  64719 */     // GIR_Coverage, 5061,
     /*  64719 */     GIR_Done,
     /*  64720 */   // Label 1083: @64720
     /*  64720 */   GIM_Reject,
     /*  64721 */ // Label 1068: @64721
     /*  64721 */ GIM_Reject,
     /*  64722 */ // Label 1017: @64722
     /*  64722 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66029),
     /*  64727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64733 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64842), // Rule ID 13642 //
     /*  64738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64786 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64792 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64799 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64803 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64807 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64811 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64816 */     // MIs[4] LHS
     /*  64816 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64821 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64823 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64840 */     GIR_RootConstrainSelectedInstOperands,
     /*  64841 */     // GIR_Coverage, 13642,
     /*  64841 */     GIR_EraseRootFromParent_Done,
     /*  64842 */   // Label 1085: @64842
     /*  64842 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64951), // Rule ID 13641 //
     /*  64847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64895 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64916 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64920 */     // MIs[4] LHS
     /*  64920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64925 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64930 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64932 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64949 */     GIR_RootConstrainSelectedInstOperands,
     /*  64950 */     // GIR_Coverage, 13641,
     /*  64950 */     GIR_EraseRootFromParent_Done,
     /*  64951 */   // Label 1086: @64951
     /*  64951 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65060), // Rule ID 13644 //
     /*  64956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65009 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65017 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65021 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65025 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65029 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65034 */     // MIs[4] LHS
     /*  65034 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65039 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65041 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65058 */     GIR_RootConstrainSelectedInstOperands,
     /*  65059 */     // GIR_Coverage, 13644,
     /*  65059 */     GIR_EraseRootFromParent_Done,
     /*  65060 */   // Label 1087: @65060
     /*  65060 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65169), // Rule ID 13643 //
     /*  65065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65118 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65124 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65130 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65134 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65138 */     // MIs[4] LHS
     /*  65138 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65143 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65148 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65150 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65167 */     GIR_RootConstrainSelectedInstOperands,
     /*  65168 */     // GIR_Coverage, 13643,
     /*  65168 */     GIR_EraseRootFromParent_Done,
     /*  65169 */   // Label 1088: @65169
     /*  65169 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65278), // Rule ID 2474 //
     /*  65174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65231 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65235 */     // MIs[3] LHS
     /*  65235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65240 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65244 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65250 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65257 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65259 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65276 */     GIR_RootConstrainSelectedInstOperands,
     /*  65277 */     // GIR_Coverage, 2474,
     /*  65277 */     GIR_EraseRootFromParent_Done,
     /*  65278 */   // Label 1089: @65278
     /*  65278 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65387), // Rule ID 13639 //
     /*  65283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65340 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65344 */     // MIs[3] LHS
     /*  65344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65349 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65353 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65359 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65366 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65368 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65385 */     GIR_RootConstrainSelectedInstOperands,
     /*  65386 */     // GIR_Coverage, 13639,
     /*  65386 */     GIR_EraseRootFromParent_Done,
     /*  65387 */   // Label 1090: @65387
     /*  65387 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65496), // Rule ID 13638 //
     /*  65392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65454 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65458 */     // MIs[3] LHS
     /*  65458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65463 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65467 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65475 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65477 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65494 */     GIR_RootConstrainSelectedInstOperands,
     /*  65495 */     // GIR_Coverage, 13638,
     /*  65495 */     GIR_EraseRootFromParent_Done,
     /*  65496 */   // Label 1091: @65496
     /*  65496 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65605), // Rule ID 13640 //
     /*  65501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65563 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65567 */     // MIs[3] LHS
     /*  65567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65572 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65576 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65582 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65584 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65586 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65603 */     GIR_RootConstrainSelectedInstOperands,
     /*  65604 */     // GIR_Coverage, 13640,
     /*  65604 */     GIR_EraseRootFromParent_Done,
     /*  65605 */   // Label 1092: @65605
     /*  65605 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65672), // Rule ID 13581 //
     /*  65610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65634 */     // MIs[1] imm
     /*  65634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65646 */     // MIs[2] Operand 1
     /*  65646 */     // No operand predicates
     /*  65646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65656 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65670 */     GIR_RootConstrainSelectedInstOperands,
     /*  65671 */     // GIR_Coverage, 13581,
     /*  65671 */     GIR_EraseRootFromParent_Done,
     /*  65672 */   // Label 1093: @65672
     /*  65672 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65739), // Rule ID 13602 //
     /*  65677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65701 */     // MIs[1] imm
     /*  65701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65709 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65713 */     // MIs[2] Operand 1
     /*  65713 */     // No operand predicates
     /*  65713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65723 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65737 */     GIR_RootConstrainSelectedInstOperands,
     /*  65738 */     // GIR_Coverage, 13602,
     /*  65738 */     GIR_EraseRootFromParent_Done,
     /*  65739 */   // Label 1094: @65739
     /*  65739 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65806), // Rule ID 2243 //
     /*  65744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65772 */     // MIs[1] imm
     /*  65772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65784 */     // MIs[2] Operand 1
     /*  65784 */     // No operand predicates
     /*  65784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65790 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65804 */     GIR_RootConstrainSelectedInstOperands,
     /*  65805 */     // GIR_Coverage, 2243,
     /*  65805 */     GIR_EraseRootFromParent_Done,
     /*  65806 */   // Label 1095: @65806
     /*  65806 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65873), // Rule ID 2302 //
     /*  65811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65839 */     // MIs[1] imm
     /*  65839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65847 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65851 */     // MIs[2] Operand 1
     /*  65851 */     // No operand predicates
     /*  65851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65857 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65871 */     GIR_RootConstrainSelectedInstOperands,
     /*  65872 */     // GIR_Coverage, 2302,
     /*  65872 */     GIR_EraseRootFromParent_Done,
     /*  65873 */   // Label 1096: @65873
     /*  65873 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65937), // Rule ID 13915 //
     /*  65878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65910 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65924 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65929 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65935 */     GIR_RootConstrainSelectedInstOperands,
     /*  65936 */     // GIR_Coverage, 13915,
     /*  65936 */     GIR_EraseRootFromParent_Done,
     /*  65937 */   // Label 1097: @65937
     /*  65937 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66001), // Rule ID 5059 //
     /*  65942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65978 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65984 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65988 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65993 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65999 */     GIR_RootConstrainSelectedInstOperands,
     /*  66000 */     // GIR_Coverage, 5059,
     /*  66000 */     GIR_EraseRootFromParent_Done,
     /*  66001 */   // Label 1098: @66001
     /*  66001 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66028), // Rule ID 5065 //
     /*  66006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66021 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  66021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  66026 */     GIR_RootConstrainSelectedInstOperands,
     /*  66027 */     // GIR_Coverage, 5065,
     /*  66027 */     GIR_Done,
     /*  66028 */   // Label 1099: @66028
     /*  66028 */   GIM_Reject,
     /*  66029 */ // Label 1084: @66029
     /*  66029 */ GIM_Reject,
     /*  66030 */ // Label 1018: @66030
     /*  66030 */ GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67337),
     /*  66035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66041 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66150), // Rule ID 13607 //
     /*  66046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66094 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66107 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66111 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66115 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66119 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66124 */     // MIs[4] LHS
     /*  66124 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66129 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66131 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66148 */     GIR_RootConstrainSelectedInstOperands,
     /*  66149 */     // GIR_Coverage, 13607,
     /*  66149 */     GIR_EraseRootFromParent_Done,
     /*  66150 */   // Label 1101: @66150
     /*  66150 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66259), // Rule ID 13606 //
     /*  66155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66203 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66216 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66220 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66224 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66228 */     // MIs[4] LHS
     /*  66228 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66233 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66238 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66240 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66257 */     GIR_RootConstrainSelectedInstOperands,
     /*  66258 */     // GIR_Coverage, 13606,
     /*  66258 */     GIR_EraseRootFromParent_Done,
     /*  66259 */   // Label 1102: @66259
     /*  66259 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66368), // Rule ID 13609 //
     /*  66264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66317 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66325 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66329 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66333 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66337 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66342 */     // MIs[4] LHS
     /*  66342 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66349 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66366 */     GIR_RootConstrainSelectedInstOperands,
     /*  66367 */     // GIR_Coverage, 13609,
     /*  66367 */     GIR_EraseRootFromParent_Done,
     /*  66368 */   // Label 1103: @66368
     /*  66368 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66477), // Rule ID 13608 //
     /*  66373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66426 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66432 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66438 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66442 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66446 */     // MIs[4] LHS
     /*  66446 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66451 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66458 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66475 */     GIR_RootConstrainSelectedInstOperands,
     /*  66476 */     // GIR_Coverage, 13608,
     /*  66476 */     GIR_EraseRootFromParent_Done,
     /*  66477 */   // Label 1104: @66477
     /*  66477 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66586), // Rule ID 2469 //
     /*  66482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66539 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66543 */     // MIs[3] LHS
     /*  66543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66552 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66558 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66565 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66567 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66584 */     GIR_RootConstrainSelectedInstOperands,
     /*  66585 */     // GIR_Coverage, 2469,
     /*  66585 */     GIR_EraseRootFromParent_Done,
     /*  66586 */   // Label 1105: @66586
     /*  66586 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66695), // Rule ID 13604 //
     /*  66591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66648 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66652 */     // MIs[3] LHS
     /*  66652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66657 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66661 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66667 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66674 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66676 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66693 */     GIR_RootConstrainSelectedInstOperands,
     /*  66694 */     // GIR_Coverage, 13604,
     /*  66694 */     GIR_EraseRootFromParent_Done,
     /*  66695 */   // Label 1106: @66695
     /*  66695 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66804), // Rule ID 13603 //
     /*  66700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66762 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66766 */     // MIs[3] LHS
     /*  66766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66771 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66775 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66781 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66783 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66785 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66802 */     GIR_RootConstrainSelectedInstOperands,
     /*  66803 */     // GIR_Coverage, 13603,
     /*  66803 */     GIR_EraseRootFromParent_Done,
     /*  66804 */   // Label 1107: @66804
     /*  66804 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66913), // Rule ID 13605 //
     /*  66809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66871 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66875 */     // MIs[3] LHS
     /*  66875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66880 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66884 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66892 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66894 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66911 */     GIR_RootConstrainSelectedInstOperands,
     /*  66912 */     // GIR_Coverage, 13605,
     /*  66912 */     GIR_EraseRootFromParent_Done,
     /*  66913 */   // Label 1108: @66913
     /*  66913 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66980), // Rule ID 13573 //
     /*  66918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66942 */     // MIs[1] imm
     /*  66942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66954 */     // MIs[2] Operand 1
     /*  66954 */     // No operand predicates
     /*  66954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66964 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66978 */     GIR_RootConstrainSelectedInstOperands,
     /*  66979 */     // GIR_Coverage, 13573,
     /*  66979 */     GIR_EraseRootFromParent_Done,
     /*  66980 */   // Label 1109: @66980
     /*  66980 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67047), // Rule ID 13594 //
     /*  66985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67009 */     // MIs[1] imm
     /*  67009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67017 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67021 */     // MIs[2] Operand 1
     /*  67021 */     // No operand predicates
     /*  67021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67031 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67045 */     GIR_RootConstrainSelectedInstOperands,
     /*  67046 */     // GIR_Coverage, 13594,
     /*  67046 */     GIR_EraseRootFromParent_Done,
     /*  67047 */   // Label 1110: @67047
     /*  67047 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67114), // Rule ID 2235 //
     /*  67052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67080 */     // MIs[1] imm
     /*  67080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67092 */     // MIs[2] Operand 1
     /*  67092 */     // No operand predicates
     /*  67092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67098 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  67101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67112 */     GIR_RootConstrainSelectedInstOperands,
     /*  67113 */     // GIR_Coverage, 2235,
     /*  67113 */     GIR_EraseRootFromParent_Done,
     /*  67114 */   // Label 1111: @67114
     /*  67114 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67181), // Rule ID 2294 //
     /*  67119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67147 */     // MIs[1] imm
     /*  67147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67155 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67159 */     // MIs[2] Operand 1
     /*  67159 */     // No operand predicates
     /*  67159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67165 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67179 */     GIR_RootConstrainSelectedInstOperands,
     /*  67180 */     // GIR_Coverage, 2294,
     /*  67180 */     GIR_EraseRootFromParent_Done,
     /*  67181 */   // Label 1112: @67181
     /*  67181 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67245), // Rule ID 13910 //
     /*  67186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67232 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67237 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67243 */     GIR_RootConstrainSelectedInstOperands,
     /*  67244 */     // GIR_Coverage, 13910,
     /*  67244 */     GIR_EraseRootFromParent_Done,
     /*  67245 */   // Label 1113: @67245
     /*  67245 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67309), // Rule ID 5054 //
     /*  67250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67286 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67296 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67301 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67307 */     GIR_RootConstrainSelectedInstOperands,
     /*  67308 */     // GIR_Coverage, 5054,
     /*  67308 */     GIR_EraseRootFromParent_Done,
     /*  67309 */   // Label 1114: @67309
     /*  67309 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67336), // Rule ID 5060 //
     /*  67314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67329 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67334 */     GIR_RootConstrainSelectedInstOperands,
     /*  67335 */     // GIR_Coverage, 5060,
     /*  67335 */     GIR_Done,
     /*  67336 */   // Label 1115: @67336
     /*  67336 */   GIM_Reject,
     /*  67337 */ // Label 1100: @67337
     /*  67337 */ GIM_Reject,
     /*  67338 */ // Label 1019: @67338
     /*  67338 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68645),
     /*  67343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67349 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67458), // Rule ID 13635 //
     /*  67354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67402 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67408 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67415 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67419 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67423 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67427 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67432 */     // MIs[4] LHS
     /*  67432 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67439 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67456 */     GIR_RootConstrainSelectedInstOperands,
     /*  67457 */     // GIR_Coverage, 13635,
     /*  67457 */     GIR_EraseRootFromParent_Done,
     /*  67458 */   // Label 1117: @67458
     /*  67458 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67567), // Rule ID 13634 //
     /*  67463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67511 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67517 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67524 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67528 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67532 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67536 */     // MIs[4] LHS
     /*  67536 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67541 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67548 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67565 */     GIR_RootConstrainSelectedInstOperands,
     /*  67566 */     // GIR_Coverage, 13634,
     /*  67566 */     GIR_EraseRootFromParent_Done,
     /*  67567 */   // Label 1118: @67567
     /*  67567 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67676), // Rule ID 13637 //
     /*  67572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67625 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67633 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67637 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67641 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67645 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67650 */     // MIs[4] LHS
     /*  67650 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67657 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67674 */     GIR_RootConstrainSelectedInstOperands,
     /*  67675 */     // GIR_Coverage, 13637,
     /*  67675 */     GIR_EraseRootFromParent_Done,
     /*  67676 */   // Label 1119: @67676
     /*  67676 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67785), // Rule ID 13636 //
     /*  67681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67734 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67742 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67746 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67754 */     // MIs[4] LHS
     /*  67754 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67759 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67766 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67783 */     GIR_RootConstrainSelectedInstOperands,
     /*  67784 */     // GIR_Coverage, 13636,
     /*  67784 */     GIR_EraseRootFromParent_Done,
     /*  67785 */   // Label 1120: @67785
     /*  67785 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67894), // Rule ID 2473 //
     /*  67790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67847 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67851 */     // MIs[3] LHS
     /*  67851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67860 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67873 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67875 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67892 */     GIR_RootConstrainSelectedInstOperands,
     /*  67893 */     // GIR_Coverage, 2473,
     /*  67893 */     GIR_EraseRootFromParent_Done,
     /*  67894 */   // Label 1121: @67894
     /*  67894 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68003), // Rule ID 13632 //
     /*  67899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67956 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67960 */     // MIs[3] LHS
     /*  67960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67965 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67969 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67975 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67982 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67984 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68001 */     GIR_RootConstrainSelectedInstOperands,
     /*  68002 */     // GIR_Coverage, 13632,
     /*  68002 */     GIR_EraseRootFromParent_Done,
     /*  68003 */   // Label 1122: @68003
     /*  68003 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68112), // Rule ID 13631 //
     /*  68008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68070 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68074 */     // MIs[3] LHS
     /*  68074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68079 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68083 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68091 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68093 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68110 */     GIR_RootConstrainSelectedInstOperands,
     /*  68111 */     // GIR_Coverage, 13631,
     /*  68111 */     GIR_EraseRootFromParent_Done,
     /*  68112 */   // Label 1123: @68112
     /*  68112 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68221), // Rule ID 13633 //
     /*  68117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68179 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68183 */     // MIs[3] LHS
     /*  68183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68188 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68192 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68198 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68202 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68219 */     GIR_RootConstrainSelectedInstOperands,
     /*  68220 */     // GIR_Coverage, 13633,
     /*  68220 */     GIR_EraseRootFromParent_Done,
     /*  68221 */   // Label 1124: @68221
     /*  68221 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68288), // Rule ID 13579 //
     /*  68226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68250 */     // MIs[1] imm
     /*  68250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68258 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68262 */     // MIs[2] Operand 1
     /*  68262 */     // No operand predicates
     /*  68262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68272 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68286 */     GIR_RootConstrainSelectedInstOperands,
     /*  68287 */     // GIR_Coverage, 13579,
     /*  68287 */     GIR_EraseRootFromParent_Done,
     /*  68288 */   // Label 1125: @68288
     /*  68288 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68355), // Rule ID 13600 //
     /*  68293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68317 */     // MIs[1] imm
     /*  68317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68325 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68329 */     // MIs[2] Operand 1
     /*  68329 */     // No operand predicates
     /*  68329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68339 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68353 */     GIR_RootConstrainSelectedInstOperands,
     /*  68354 */     // GIR_Coverage, 13600,
     /*  68354 */     GIR_EraseRootFromParent_Done,
     /*  68355 */   // Label 1126: @68355
     /*  68355 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68422), // Rule ID 2241 //
     /*  68360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68388 */     // MIs[1] imm
     /*  68388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68396 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68400 */     // MIs[2] Operand 1
     /*  68400 */     // No operand predicates
     /*  68400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68406 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68420 */     GIR_RootConstrainSelectedInstOperands,
     /*  68421 */     // GIR_Coverage, 2241,
     /*  68421 */     GIR_EraseRootFromParent_Done,
     /*  68422 */   // Label 1127: @68422
     /*  68422 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68489), // Rule ID 2300 //
     /*  68427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68455 */     // MIs[1] imm
     /*  68455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68467 */     // MIs[2] Operand 1
     /*  68467 */     // No operand predicates
     /*  68467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68473 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68487 */     GIR_RootConstrainSelectedInstOperands,
     /*  68488 */     // GIR_Coverage, 2300,
     /*  68488 */     GIR_EraseRootFromParent_Done,
     /*  68489 */   // Label 1128: @68489
     /*  68489 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68553), // Rule ID 13914 //
     /*  68494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68526 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68540 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68545 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68551 */     GIR_RootConstrainSelectedInstOperands,
     /*  68552 */     // GIR_Coverage, 13914,
     /*  68552 */     GIR_EraseRootFromParent_Done,
     /*  68553 */   // Label 1129: @68553
     /*  68553 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68617), // Rule ID 5058 //
     /*  68558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68594 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68604 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68609 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68615 */     GIR_RootConstrainSelectedInstOperands,
     /*  68616 */     // GIR_Coverage, 5058,
     /*  68616 */     GIR_EraseRootFromParent_Done,
     /*  68617 */   // Label 1130: @68617
     /*  68617 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68644), // Rule ID 5064 //
     /*  68622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68637 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68642 */     GIR_RootConstrainSelectedInstOperands,
     /*  68643 */     // GIR_Coverage, 5064,
     /*  68643 */     GIR_Done,
     /*  68644 */   // Label 1131: @68644
     /*  68644 */   GIM_Reject,
     /*  68645 */ // Label 1116: @68645
     /*  68645 */ GIM_Reject,
     /*  68646 */ // Label 1020: @68646
     /*  68646 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(69953),
     /*  68651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68657 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68766), // Rule ID 13395 //
     /*  68662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68710 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68723 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68727 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68731 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68735 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68740 */     // MIs[4] Rd
     /*  68740 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68745 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68747 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68764 */     GIR_RootConstrainSelectedInstOperands,
     /*  68765 */     // GIR_Coverage, 13395,
     /*  68765 */     GIR_EraseRootFromParent_Done,
     /*  68766 */   // Label 1133: @68766
     /*  68766 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68875), // Rule ID 13394 //
     /*  68771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68819 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68832 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68836 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68840 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68844 */     // MIs[4] Rd
     /*  68844 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68849 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68856 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68873 */     GIR_RootConstrainSelectedInstOperands,
     /*  68874 */     // GIR_Coverage, 13394,
     /*  68874 */     GIR_EraseRootFromParent_Done,
     /*  68875 */   // Label 1134: @68875
     /*  68875 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68984), // Rule ID 13397 //
     /*  68880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68933 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68941 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68945 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68949 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68953 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68958 */     // MIs[4] Rd
     /*  68958 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68965 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68982 */     GIR_RootConstrainSelectedInstOperands,
     /*  68983 */     // GIR_Coverage, 13397,
     /*  68983 */     GIR_EraseRootFromParent_Done,
     /*  68984 */   // Label 1135: @68984
     /*  68984 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69093), // Rule ID 13396 //
     /*  68989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69042 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69058 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69062 */     // MIs[4] Rd
     /*  69062 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69067 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69074 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  69083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69091 */     GIR_RootConstrainSelectedInstOperands,
     /*  69092 */     // GIR_Coverage, 13396,
     /*  69092 */     GIR_EraseRootFromParent_Done,
     /*  69093 */   // Label 1136: @69093
     /*  69093 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69202), // Rule ID 1605 //
     /*  69098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69155 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69159 */     // MIs[3] Rd
     /*  69159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69168 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69181 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69183 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69200 */     GIR_RootConstrainSelectedInstOperands,
     /*  69201 */     // GIR_Coverage, 1605,
     /*  69201 */     GIR_EraseRootFromParent_Done,
     /*  69202 */   // Label 1137: @69202
     /*  69202 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69311), // Rule ID 13392 //
     /*  69207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69264 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69268 */     // MIs[3] Rd
     /*  69268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69277 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69290 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69292 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69309 */     GIR_RootConstrainSelectedInstOperands,
     /*  69310 */     // GIR_Coverage, 13392,
     /*  69310 */     GIR_EraseRootFromParent_Done,
     /*  69311 */   // Label 1138: @69311
     /*  69311 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69420), // Rule ID 13391 //
     /*  69316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69378 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69382 */     // MIs[3] Rd
     /*  69382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69387 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69391 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69399 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69401 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69418 */     GIR_RootConstrainSelectedInstOperands,
     /*  69419 */     // GIR_Coverage, 13391,
     /*  69419 */     GIR_EraseRootFromParent_Done,
     /*  69420 */   // Label 1139: @69420
     /*  69420 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69529), // Rule ID 13393 //
     /*  69425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69491 */     // MIs[3] Rd
     /*  69491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69500 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69506 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69508 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69510 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69527 */     GIR_RootConstrainSelectedInstOperands,
     /*  69528 */     // GIR_Coverage, 13393,
     /*  69528 */     GIR_EraseRootFromParent_Done,
     /*  69529 */   // Label 1140: @69529
     /*  69529 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69596), // Rule ID 13569 //
     /*  69534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69558 */     // MIs[1] imm
     /*  69558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69566 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69570 */     // MIs[2] Operand 1
     /*  69570 */     // No operand predicates
     /*  69570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69580 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69594 */     GIR_RootConstrainSelectedInstOperands,
     /*  69595 */     // GIR_Coverage, 13569,
     /*  69595 */     GIR_EraseRootFromParent_Done,
     /*  69596 */   // Label 1141: @69596
     /*  69596 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69663), // Rule ID 13590 //
     /*  69601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69625 */     // MIs[1] imm
     /*  69625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69633 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69637 */     // MIs[2] Operand 1
     /*  69637 */     // No operand predicates
     /*  69637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69647 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69661 */     GIR_RootConstrainSelectedInstOperands,
     /*  69662 */     // GIR_Coverage, 13590,
     /*  69662 */     GIR_EraseRootFromParent_Done,
     /*  69663 */   // Label 1142: @69663
     /*  69663 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69730), // Rule ID 2231 //
     /*  69668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69696 */     // MIs[1] imm
     /*  69696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69704 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69708 */     // MIs[2] Operand 1
     /*  69708 */     // No operand predicates
     /*  69708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69714 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69728 */     GIR_RootConstrainSelectedInstOperands,
     /*  69729 */     // GIR_Coverage, 2231,
     /*  69729 */     GIR_EraseRootFromParent_Done,
     /*  69730 */   // Label 1143: @69730
     /*  69730 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69797), // Rule ID 2290 //
     /*  69735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69763 */     // MIs[1] imm
     /*  69763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69775 */     // MIs[2] Operand 1
     /*  69775 */     // No operand predicates
     /*  69775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69781 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69795 */     GIR_RootConstrainSelectedInstOperands,
     /*  69796 */     // GIR_Coverage, 2290,
     /*  69796 */     GIR_EraseRootFromParent_Done,
     /*  69797 */   // Label 1144: @69797
     /*  69797 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69861), // Rule ID 13389 //
     /*  69802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69834 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69840 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69848 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69859 */     GIR_RootConstrainSelectedInstOperands,
     /*  69860 */     // GIR_Coverage, 13389,
     /*  69860 */     GIR_EraseRootFromParent_Done,
     /*  69861 */   // Label 1145: @69861
     /*  69861 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69925), // Rule ID 1601 //
     /*  69866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69902 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69912 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69923 */     GIR_RootConstrainSelectedInstOperands,
     /*  69924 */     // GIR_Coverage, 1601,
     /*  69924 */     GIR_EraseRootFromParent_Done,
     /*  69925 */   // Label 1146: @69925
     /*  69925 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69952), // Rule ID 1603 //
     /*  69930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69945 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69950 */     GIR_RootConstrainSelectedInstOperands,
     /*  69951 */     // GIR_Coverage, 1603,
     /*  69951 */     GIR_Done,
     /*  69952 */   // Label 1147: @69952
     /*  69952 */   GIM_Reject,
     /*  69953 */ // Label 1132: @69953
     /*  69953 */ GIM_Reject,
     /*  69954 */ // Label 1021: @69954
     /*  69954 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71261),
     /*  69959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69965 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70074), // Rule ID 13628 //
     /*  69970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70018 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70039 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70043 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70048 */     // MIs[4] LHS
     /*  70048 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70055 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70072 */     GIR_RootConstrainSelectedInstOperands,
     /*  70073 */     // GIR_Coverage, 13628,
     /*  70073 */     GIR_EraseRootFromParent_Done,
     /*  70074 */   // Label 1149: @70074
     /*  70074 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70183), // Rule ID 13627 //
     /*  70079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70127 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70140 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70144 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70148 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70152 */     // MIs[4] LHS
     /*  70152 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70157 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70162 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70164 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70181 */     GIR_RootConstrainSelectedInstOperands,
     /*  70182 */     // GIR_Coverage, 13627,
     /*  70182 */     GIR_EraseRootFromParent_Done,
     /*  70183 */   // Label 1150: @70183
     /*  70183 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70292), // Rule ID 13630 //
     /*  70188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70241 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70249 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70253 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70257 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70261 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70266 */     // MIs[4] LHS
     /*  70266 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70271 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70273 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70290 */     GIR_RootConstrainSelectedInstOperands,
     /*  70291 */     // GIR_Coverage, 13630,
     /*  70291 */     GIR_EraseRootFromParent_Done,
     /*  70292 */   // Label 1151: @70292
     /*  70292 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70401), // Rule ID 13629 //
     /*  70297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70350 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70356 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70358 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70362 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70366 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70370 */     // MIs[4] LHS
     /*  70370 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70375 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70382 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70399 */     GIR_RootConstrainSelectedInstOperands,
     /*  70400 */     // GIR_Coverage, 13629,
     /*  70400 */     GIR_EraseRootFromParent_Done,
     /*  70401 */   // Label 1152: @70401
     /*  70401 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70510), // Rule ID 2472 //
     /*  70406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70463 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70467 */     // MIs[3] LHS
     /*  70467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70476 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70482 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70489 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70491 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70508 */     GIR_RootConstrainSelectedInstOperands,
     /*  70509 */     // GIR_Coverage, 2472,
     /*  70509 */     GIR_EraseRootFromParent_Done,
     /*  70510 */   // Label 1153: @70510
     /*  70510 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70619), // Rule ID 13625 //
     /*  70515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70572 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70576 */     // MIs[3] LHS
     /*  70576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70581 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70585 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70591 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70598 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70600 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70617 */     GIR_RootConstrainSelectedInstOperands,
     /*  70618 */     // GIR_Coverage, 13625,
     /*  70618 */     GIR_EraseRootFromParent_Done,
     /*  70619 */   // Label 1154: @70619
     /*  70619 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70728), // Rule ID 13624 //
     /*  70624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70686 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70690 */     // MIs[3] LHS
     /*  70690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70695 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70699 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70705 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70707 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70709 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70726 */     GIR_RootConstrainSelectedInstOperands,
     /*  70727 */     // GIR_Coverage, 13624,
     /*  70727 */     GIR_EraseRootFromParent_Done,
     /*  70728 */   // Label 1155: @70728
     /*  70728 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70837), // Rule ID 13626 //
     /*  70733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70799 */     // MIs[3] LHS
     /*  70799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70808 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70816 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70818 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70835 */     GIR_RootConstrainSelectedInstOperands,
     /*  70836 */     // GIR_Coverage, 13626,
     /*  70836 */     GIR_EraseRootFromParent_Done,
     /*  70837 */   // Label 1156: @70837
     /*  70837 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70904), // Rule ID 13575 //
     /*  70842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70866 */     // MIs[1] imm
     /*  70866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70878 */     // MIs[2] Operand 1
     /*  70878 */     // No operand predicates
     /*  70878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70882 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70888 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70902 */     GIR_RootConstrainSelectedInstOperands,
     /*  70903 */     // GIR_Coverage, 13575,
     /*  70903 */     GIR_EraseRootFromParent_Done,
     /*  70904 */   // Label 1157: @70904
     /*  70904 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70971), // Rule ID 13596 //
     /*  70909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70933 */     // MIs[1] imm
     /*  70933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70941 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70945 */     // MIs[2] Operand 1
     /*  70945 */     // No operand predicates
     /*  70945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70955 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70969 */     GIR_RootConstrainSelectedInstOperands,
     /*  70970 */     // GIR_Coverage, 13596,
     /*  70970 */     GIR_EraseRootFromParent_Done,
     /*  70971 */   // Label 1158: @70971
     /*  70971 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71038), // Rule ID 2237 //
     /*  70976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71004 */     // MIs[1] imm
     /*  71004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71012 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71016 */     // MIs[2] Operand 1
     /*  71016 */     // No operand predicates
     /*  71016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71022 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  71025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71036 */     GIR_RootConstrainSelectedInstOperands,
     /*  71037 */     // GIR_Coverage, 2237,
     /*  71037 */     GIR_EraseRootFromParent_Done,
     /*  71038 */   // Label 1159: @71038
     /*  71038 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71105), // Rule ID 2296 //
     /*  71043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71071 */     // MIs[1] imm
     /*  71071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71083 */     // MIs[2] Operand 1
     /*  71083 */     // No operand predicates
     /*  71083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71089 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  71092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71103 */     GIR_RootConstrainSelectedInstOperands,
     /*  71104 */     // GIR_Coverage, 2296,
     /*  71104 */     GIR_EraseRootFromParent_Done,
     /*  71105 */   // Label 1160: @71105
     /*  71105 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71169), // Rule ID 13913 //
     /*  71110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71142 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71156 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71161 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  71163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71167 */     GIR_RootConstrainSelectedInstOperands,
     /*  71168 */     // GIR_Coverage, 13913,
     /*  71168 */     GIR_EraseRootFromParent_Done,
     /*  71169 */   // Label 1161: @71169
     /*  71169 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71233), // Rule ID 5057 //
     /*  71174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71210 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71216 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71220 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71225 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71231 */     GIR_RootConstrainSelectedInstOperands,
     /*  71232 */     // GIR_Coverage, 5057,
     /*  71232 */     GIR_EraseRootFromParent_Done,
     /*  71233 */   // Label 1162: @71233
     /*  71233 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71260), // Rule ID 5063 //
     /*  71238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71253 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71258 */     GIR_RootConstrainSelectedInstOperands,
     /*  71259 */     // GIR_Coverage, 5063,
     /*  71259 */     GIR_Done,
     /*  71260 */   // Label 1163: @71260
     /*  71260 */   GIM_Reject,
     /*  71261 */ // Label 1148: @71261
     /*  71261 */ GIM_Reject,
     /*  71262 */ // Label 1022: @71262
     /*  71262 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72569),
     /*  71267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71273 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71382), // Rule ID 13402 //
     /*  71278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71326 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71351 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71356 */     // MIs[4] Rd
     /*  71356 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71361 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71363 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71380 */     GIR_RootConstrainSelectedInstOperands,
     /*  71381 */     // GIR_Coverage, 13402,
     /*  71381 */     GIR_EraseRootFromParent_Done,
     /*  71382 */   // Label 1165: @71382
     /*  71382 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71491), // Rule ID 13401 //
     /*  71387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71435 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71448 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71452 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71456 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71460 */     // MIs[4] Rd
     /*  71460 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71465 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71472 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71489 */     GIR_RootConstrainSelectedInstOperands,
     /*  71490 */     // GIR_Coverage, 13401,
     /*  71490 */     GIR_EraseRootFromParent_Done,
     /*  71491 */   // Label 1166: @71491
     /*  71491 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71600), // Rule ID 13404 //
     /*  71496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71549 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71561 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71565 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71569 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71574 */     // MIs[4] Rd
     /*  71574 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71581 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71598 */     GIR_RootConstrainSelectedInstOperands,
     /*  71599 */     // GIR_Coverage, 13404,
     /*  71599 */     GIR_EraseRootFromParent_Done,
     /*  71600 */   // Label 1167: @71600
     /*  71600 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71709), // Rule ID 13403 //
     /*  71605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71658 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71664 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71666 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71670 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71674 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71678 */     // MIs[4] Rd
     /*  71678 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71690 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71707 */     GIR_RootConstrainSelectedInstOperands,
     /*  71708 */     // GIR_Coverage, 13403,
     /*  71708 */     GIR_EraseRootFromParent_Done,
     /*  71709 */   // Label 1168: @71709
     /*  71709 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71818), // Rule ID 1606 //
     /*  71714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71771 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71775 */     // MIs[3] Rd
     /*  71775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71780 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71784 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71790 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71797 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71799 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71816 */     GIR_RootConstrainSelectedInstOperands,
     /*  71817 */     // GIR_Coverage, 1606,
     /*  71817 */     GIR_EraseRootFromParent_Done,
     /*  71818 */   // Label 1169: @71818
     /*  71818 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71927), // Rule ID 13399 //
     /*  71823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71884 */     // MIs[3] Rd
     /*  71884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71893 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71906 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71908 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71925 */     GIR_RootConstrainSelectedInstOperands,
     /*  71926 */     // GIR_Coverage, 13399,
     /*  71926 */     GIR_EraseRootFromParent_Done,
     /*  71927 */   // Label 1170: @71927
     /*  71927 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72036), // Rule ID 13398 //
     /*  71932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71994 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71998 */     // MIs[3] Rd
     /*  71998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72003 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72007 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72015 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72017 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  72026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72034 */     GIR_RootConstrainSelectedInstOperands,
     /*  72035 */     // GIR_Coverage, 13398,
     /*  72035 */     GIR_EraseRootFromParent_Done,
     /*  72036 */   // Label 1171: @72036
     /*  72036 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72145), // Rule ID 13400 //
     /*  72041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72107 */     // MIs[3] Rd
     /*  72107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72116 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72122 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72124 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72126 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  72135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72143 */     GIR_RootConstrainSelectedInstOperands,
     /*  72144 */     // GIR_Coverage, 13400,
     /*  72144 */     GIR_EraseRootFromParent_Done,
     /*  72145 */   // Label 1172: @72145
     /*  72145 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72212), // Rule ID 13571 //
     /*  72150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72174 */     // MIs[1] imm
     /*  72174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72182 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72186 */     // MIs[2] Operand 1
     /*  72186 */     // No operand predicates
     /*  72186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72196 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72210 */     GIR_RootConstrainSelectedInstOperands,
     /*  72211 */     // GIR_Coverage, 13571,
     /*  72211 */     GIR_EraseRootFromParent_Done,
     /*  72212 */   // Label 1173: @72212
     /*  72212 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72279), // Rule ID 13592 //
     /*  72217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72241 */     // MIs[1] imm
     /*  72241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72253 */     // MIs[2] Operand 1
     /*  72253 */     // No operand predicates
     /*  72253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72263 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72277 */     GIR_RootConstrainSelectedInstOperands,
     /*  72278 */     // GIR_Coverage, 13592,
     /*  72278 */     GIR_EraseRootFromParent_Done,
     /*  72279 */   // Label 1174: @72279
     /*  72279 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72346), // Rule ID 2233 //
     /*  72284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72312 */     // MIs[1] imm
     /*  72312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72320 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72324 */     // MIs[2] Operand 1
     /*  72324 */     // No operand predicates
     /*  72324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72330 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72344 */     GIR_RootConstrainSelectedInstOperands,
     /*  72345 */     // GIR_Coverage, 2233,
     /*  72345 */     GIR_EraseRootFromParent_Done,
     /*  72346 */   // Label 1175: @72346
     /*  72346 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72413), // Rule ID 2292 //
     /*  72351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72379 */     // MIs[1] imm
     /*  72379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72391 */     // MIs[2] Operand 1
     /*  72391 */     // No operand predicates
     /*  72391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72397 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72411 */     GIR_RootConstrainSelectedInstOperands,
     /*  72412 */     // GIR_Coverage, 2292,
     /*  72412 */     GIR_EraseRootFromParent_Done,
     /*  72413 */   // Label 1176: @72413
     /*  72413 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72477), // Rule ID 13390 //
     /*  72418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72450 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72464 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72475 */     GIR_RootConstrainSelectedInstOperands,
     /*  72476 */     // GIR_Coverage, 13390,
     /*  72476 */     GIR_EraseRootFromParent_Done,
     /*  72477 */   // Label 1177: @72477
     /*  72477 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72541), // Rule ID 1602 //
     /*  72482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72518 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72524 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72528 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72539 */     GIR_RootConstrainSelectedInstOperands,
     /*  72540 */     // GIR_Coverage, 1602,
     /*  72540 */     GIR_EraseRootFromParent_Done,
     /*  72541 */   // Label 1178: @72541
     /*  72541 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72568), // Rule ID 1604 //
     /*  72546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72561 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72566 */     GIR_RootConstrainSelectedInstOperands,
     /*  72567 */     // GIR_Coverage, 1604,
     /*  72567 */     GIR_Done,
     /*  72568 */   // Label 1179: @72568
     /*  72568 */   GIM_Reject,
     /*  72569 */ // Label 1164: @72569
     /*  72569 */ GIM_Reject,
     /*  72570 */ // Label 1023: @72570
     /*  72570 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72601), // Rule ID 8474 //
     /*  72575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72588 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72593 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72595 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72597 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72599 */   GIR_RootConstrainSelectedInstOperands,
     /*  72600 */   // GIR_Coverage, 8474,
     /*  72600 */   GIR_EraseRootFromParent_Done,
     /*  72601 */ // Label 1180: @72601
     /*  72601 */ GIM_Reject,
     /*  72602 */ // Label 1024: @72602
     /*  72602 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72633), // Rule ID 8473 //
     /*  72607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72620 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72625 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72627 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72629 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72631 */   GIR_RootConstrainSelectedInstOperands,
     /*  72632 */   // GIR_Coverage, 8473,
     /*  72632 */   GIR_EraseRootFromParent_Done,
     /*  72633 */ // Label 1181: @72633
     /*  72633 */ GIM_Reject,
     /*  72634 */ // Label 1025: @72634
     /*  72634 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72659), // Rule ID 7479 //
     /*  72639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72652 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  72652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72657 */   GIR_RootConstrainSelectedInstOperands,
     /*  72658 */   // GIR_Coverage, 7479,
     /*  72658 */   GIR_Done,
     /*  72659 */ // Label 1182: @72659
     /*  72659 */ GIM_Reject,
     /*  72660 */ // Label 1026: @72660
     /*  72660 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72691), // Rule ID 8472 //
     /*  72665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  72671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  72674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72678 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  72678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72683 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72685 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72687 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72689 */   GIR_RootConstrainSelectedInstOperands,
     /*  72690 */   // GIR_Coverage, 8472,
     /*  72690 */   GIR_EraseRootFromParent_Done,
     /*  72691 */ // Label 1183: @72691
     /*  72691 */ GIM_Reject,
     /*  72692 */ // Label 1027: @72692
     /*  72692 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72717), // Rule ID 7478 //
     /*  72697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  72703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  72706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72710 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  72710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72715 */   GIR_RootConstrainSelectedInstOperands,
     /*  72716 */   // GIR_Coverage, 7478,
     /*  72716 */   GIR_Done,
     /*  72717 */ // Label 1184: @72717
     /*  72717 */ GIM_Reject,
     /*  72718 */ // Label 1028: @72718
     /*  72718 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(72749), // Rule ID 8471 //
     /*  72723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  72729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  72732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72736 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  72736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72741 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72745 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72747 */   GIR_RootConstrainSelectedInstOperands,
     /*  72748 */   // GIR_Coverage, 8471,
     /*  72748 */   GIR_EraseRootFromParent_Done,
     /*  72749 */ // Label 1185: @72749
     /*  72749 */ GIM_Reject,
     /*  72750 */ // Label 1029: @72750
     /*  72750 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(72775), // Rule ID 7477 //
     /*  72755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  72761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  72764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72768 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  72768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72773 */   GIR_RootConstrainSelectedInstOperands,
     /*  72774 */   // GIR_Coverage, 7477,
     /*  72774 */   GIR_Done,
     /*  72775 */ // Label 1186: @72775
     /*  72775 */ GIM_Reject,
     /*  72776 */ // Label 1030: @72776
     /*  72776 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(72807), // Rule ID 8470 //
     /*  72781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  72787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  72790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72794 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  72794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72799 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72801 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72803 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72805 */   GIR_RootConstrainSelectedInstOperands,
     /*  72806 */   // GIR_Coverage, 8470,
     /*  72806 */   GIR_EraseRootFromParent_Done,
     /*  72807 */ // Label 1187: @72807
     /*  72807 */ GIM_Reject,
     /*  72808 */ // Label 1031: @72808
     /*  72808 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(72833), // Rule ID 7476 //
     /*  72813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  72819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  72822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72826 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  72826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72831 */   GIR_RootConstrainSelectedInstOperands,
     /*  72832 */   // GIR_Coverage, 7476,
     /*  72832 */   GIR_Done,
     /*  72833 */ // Label 1188: @72833
     /*  72833 */ GIM_Reject,
     /*  72834 */ // Label 1032: @72834
     /*  72834 */ GIM_Reject,
     /*  72835 */ // Label 7: @72835
     /*  72835 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1207*/ GIMT_Encode4(80026),
     /*  72846 */ /*GILLT_s32*//*Label 1189*/ GIMT_Encode4(72934),
     /*  72850 */ /*GILLT_s64*//*Label 1190*/ GIMT_Encode4(73614), GIMT_Encode4(0),
     /*  72858 */ /*GILLT_v2s32*//*Label 1191*/ GIMT_Encode4(74457),
     /*  72862 */ /*GILLT_v2s64*//*Label 1192*/ GIMT_Encode4(74692),
     /*  72866 */ /*GILLT_v4s16*//*Label 1193*/ GIMT_Encode4(75381),
     /*  72870 */ /*GILLT_v4s32*//*Label 1194*/ GIMT_Encode4(75616),
     /*  72874 */ /*GILLT_v8s8*//*Label 1195*/ GIMT_Encode4(76305),
     /*  72878 */ /*GILLT_v8s16*//*Label 1196*/ GIMT_Encode4(76543),
     /*  72882 */ /*GILLT_v16s8*//*Label 1197*/ GIMT_Encode4(77232),
     /*  72886 */ /*GILLT_nxv1s1*//*Label 1198*/ GIMT_Encode4(77924),
     /*  72890 */ /*GILLT_nxv2s1*//*Label 1199*/ GIMT_Encode4(77974), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72902 */ /*GILLT_nxv2s64*//*Label 1200*/ GIMT_Encode4(78024),
     /*  72906 */ /*GILLT_nxv4s1*//*Label 1201*/ GIMT_Encode4(78487), GIMT_Encode4(0),
     /*  72914 */ /*GILLT_nxv4s32*//*Label 1202*/ GIMT_Encode4(78537),
     /*  72918 */ /*GILLT_nxv8s1*//*Label 1203*/ GIMT_Encode4(79000),
     /*  72922 */ /*GILLT_nxv8s16*//*Label 1204*/ GIMT_Encode4(79050),
     /*  72926 */ /*GILLT_nxv16s1*//*Label 1205*/ GIMT_Encode4(79513),
     /*  72930 */ /*GILLT_nxv16s8*//*Label 1206*/ GIMT_Encode4(79563),
     /*  72934 */ // Label 1189: @72934
     /*  72934 */ GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(73613),
     /*  72939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72945 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(73003), // Rule ID 13260 //
     /*  72950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72975 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72988 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73001 */     GIR_RootConstrainSelectedInstOperands,
     /*  73002 */     // GIR_Coverage, 13260,
     /*  73002 */     GIR_EraseRootFromParent_Done,
     /*  73003 */   // Label 1209: @73003
     /*  73003 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(73058), // Rule ID 13259 //
     /*  73008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73045 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73056 */     GIR_RootConstrainSelectedInstOperands,
     /*  73057 */     // GIR_Coverage, 13259,
     /*  73057 */     GIR_EraseRootFromParent_Done,
     /*  73058 */   // Label 1210: @73058
     /*  73058 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(73116), // Rule ID 13257 //
     /*  73063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73101 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73114 */     GIR_RootConstrainSelectedInstOperands,
     /*  73115 */     // GIR_Coverage, 13257,
     /*  73115 */     GIR_EraseRootFromParent_Done,
     /*  73116 */   // Label 1211: @73116
     /*  73116 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(73174), // Rule ID 166 //
     /*  73121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73159 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73172 */     GIR_RootConstrainSelectedInstOperands,
     /*  73173 */     // GIR_Coverage, 166,
     /*  73173 */     GIR_EraseRootFromParent_Done,
     /*  73174 */   // Label 1212: @73174
     /*  73174 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(73232), // Rule ID 13258 //
     /*  73179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73204 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73217 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73230 */     GIR_RootConstrainSelectedInstOperands,
     /*  73231 */     // GIR_Coverage, 13258,
     /*  73231 */     GIR_EraseRootFromParent_Done,
     /*  73232 */   // Label 1213: @73232
     /*  73232 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(73287), // Rule ID 13261 //
     /*  73237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73261 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73274 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73285 */     GIR_RootConstrainSelectedInstOperands,
     /*  73286 */     // GIR_Coverage, 13261,
     /*  73286 */     GIR_EraseRootFromParent_Done,
     /*  73287 */   // Label 1214: @73287
     /*  73287 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(73328), // Rule ID 144 //
     /*  73292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  73296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73308 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  73312 */     // MIs[1] Operand 1
     /*  73312 */     // No operand predicates
     /*  73312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73314 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  73314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  73317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73321 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  73326 */     GIR_RootConstrainSelectedInstOperands,
     /*  73327 */     // GIR_Coverage, 144,
     /*  73327 */     GIR_EraseRootFromParent_Done,
     /*  73328 */   // Label 1215: @73328
     /*  73328 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(73361), // Rule ID 13267 //
     /*  73333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73348 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73359 */     GIR_RootConstrainSelectedInstOperands,
     /*  73360 */     // GIR_Coverage, 13267,
     /*  73360 */     GIR_EraseRootFromParent_Done,
     /*  73361 */   // Label 1216: @73361
     /*  73361 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(73394), // Rule ID 170 //
     /*  73366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73381 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73392 */     GIR_RootConstrainSelectedInstOperands,
     /*  73393 */     // GIR_Coverage, 170,
     /*  73393 */     GIR_EraseRootFromParent_Done,
     /*  73394 */   // Label 1217: @73394
     /*  73394 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(73447), // Rule ID 13253 //
     /*  73399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73434 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73445 */     GIR_RootConstrainSelectedInstOperands,
     /*  73446 */     // GIR_Coverage, 13253,
     /*  73446 */     GIR_EraseRootFromParent_Done,
     /*  73447 */   // Label 1218: @73447
     /*  73447 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(73503), // Rule ID 164 //
     /*  73452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73488 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73501 */     GIR_RootConstrainSelectedInstOperands,
     /*  73502 */     // GIR_Coverage, 164,
     /*  73502 */     GIR_EraseRootFromParent_Done,
     /*  73503 */   // Label 1219: @73503
     /*  73503 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(73556), // Rule ID 13254 //
     /*  73508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73537 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73543 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  73554 */     GIR_RootConstrainSelectedInstOperands,
     /*  73555 */     // GIR_Coverage, 13254,
     /*  73555 */     GIR_EraseRootFromParent_Done,
     /*  73556 */   // Label 1220: @73556
     /*  73556 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(73588), // Rule ID 4002 //
     /*  73561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73573 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  73573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  73576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  73586 */     GIR_RootConstrainSelectedInstOperands,
     /*  73587 */     // GIR_Coverage, 4002,
     /*  73587 */     GIR_EraseRootFromParent_Done,
     /*  73588 */   // Label 1221: @73588
     /*  73588 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(73612), // Rule ID 168 //
     /*  73593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73605 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  73610 */     GIR_RootConstrainSelectedInstOperands,
     /*  73611 */     // GIR_Coverage, 168,
     /*  73611 */     GIR_Done,
     /*  73612 */   // Label 1222: @73612
     /*  73612 */   GIM_Reject,
     /*  73613 */ // Label 1208: @73613
     /*  73613 */ GIM_Reject,
     /*  73614 */ // Label 1190: @73614
     /*  73614 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(74456),
     /*  73619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  73622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  73625 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(73683), // Rule ID 13265 //
     /*  73630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73655 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73668 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73681 */     GIR_RootConstrainSelectedInstOperands,
     /*  73682 */     // GIR_Coverage, 13265,
     /*  73682 */     GIR_EraseRootFromParent_Done,
     /*  73683 */   // Label 1224: @73683
     /*  73683 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(73738), // Rule ID 13264 //
     /*  73688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73708 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73725 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73736 */     GIR_RootConstrainSelectedInstOperands,
     /*  73737 */     // GIR_Coverage, 13264,
     /*  73737 */     GIR_EraseRootFromParent_Done,
     /*  73738 */   // Label 1225: @73738
     /*  73738 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(73796), // Rule ID 13262 //
     /*  73743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73781 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73790 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73794 */     GIR_RootConstrainSelectedInstOperands,
     /*  73795 */     // GIR_Coverage, 13262,
     /*  73795 */     GIR_EraseRootFromParent_Done,
     /*  73796 */   // Label 1226: @73796
     /*  73796 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(73854), // Rule ID 167 //
     /*  73801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73839 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73852 */     GIR_RootConstrainSelectedInstOperands,
     /*  73853 */     // GIR_Coverage, 167,
     /*  73853 */     GIR_EraseRootFromParent_Done,
     /*  73854 */   // Label 1227: @73854
     /*  73854 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(73912), // Rule ID 13263 //
     /*  73859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73884 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73897 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73910 */     GIR_RootConstrainSelectedInstOperands,
     /*  73911 */     // GIR_Coverage, 13263,
     /*  73911 */     GIR_EraseRootFromParent_Done,
     /*  73912 */   // Label 1228: @73912
     /*  73912 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(73967), // Rule ID 13266 //
     /*  73917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73954 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73965 */     GIR_RootConstrainSelectedInstOperands,
     /*  73966 */     // GIR_Coverage, 13266,
     /*  73966 */     GIR_EraseRootFromParent_Done,
     /*  73967 */   // Label 1229: @73967
     /*  73967 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(74067), // Rule ID 1613 //
     /*  73972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73991 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  73995 */     // MIs[1] Operand 1
     /*  73995 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  74012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  74016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74030 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74036 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74038 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74042 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74050 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74052 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  74052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  74055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74065 */     GIR_RootConstrainSelectedInstOperands,
     /*  74066 */     // GIR_Coverage, 1613,
     /*  74066 */     GIR_EraseRootFromParent_Done,
     /*  74067 */   // Label 1230: @74067
     /*  74067 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(74108), // Rule ID 145 //
     /*  74072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  74076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74088 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  74092 */     // MIs[1] Operand 1
     /*  74092 */     // No operand predicates
     /*  74092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74094 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  74094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  74097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74101 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  74106 */     GIR_RootConstrainSelectedInstOperands,
     /*  74107 */     // GIR_Coverage, 145,
     /*  74107 */     GIR_EraseRootFromParent_Done,
     /*  74108 */   // Label 1231: @74108
     /*  74108 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(74141), // Rule ID 13268 //
     /*  74113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  74128 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  74128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  74131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  74135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  74139 */     GIR_RootConstrainSelectedInstOperands,
     /*  74140 */     // GIR_Coverage, 13268,
     /*  74140 */     GIR_EraseRootFromParent_Done,
     /*  74141 */   // Label 1232: @74141
     /*  74141 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(74174), // Rule ID 171 //
     /*  74146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  74161 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  74161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  74164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  74172 */     GIR_RootConstrainSelectedInstOperands,
     /*  74173 */     // GIR_Coverage, 171,
     /*  74173 */     GIR_EraseRootFromParent_Done,
     /*  74174 */   // Label 1233: @74174
     /*  74174 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(74227), // Rule ID 13255 //
     /*  74179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74204 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74214 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  74225 */     GIR_RootConstrainSelectedInstOperands,
     /*  74226 */     // GIR_Coverage, 13255,
     /*  74226 */     GIR_EraseRootFromParent_Done,
     /*  74227 */   // Label 1234: @74227
     /*  74227 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(74283), // Rule ID 165 //
     /*  74232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74268 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  74281 */     GIR_RootConstrainSelectedInstOperands,
     /*  74282 */     // GIR_Coverage, 165,
     /*  74282 */     GIR_EraseRootFromParent_Done,
     /*  74283 */   // Label 1235: @74283
     /*  74283 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(74336), // Rule ID 13256 //
     /*  74288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74317 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74323 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  74334 */     GIR_RootConstrainSelectedInstOperands,
     /*  74335 */     // GIR_Coverage, 13256,
     /*  74335 */     GIR_EraseRootFromParent_Done,
     /*  74336 */   // Label 1236: @74336
     /*  74336 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(74368), // Rule ID 4003 //
     /*  74341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74353 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  74353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  74356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  74366 */     GIR_RootConstrainSelectedInstOperands,
     /*  74367 */     // GIR_Coverage, 4003,
     /*  74367 */     GIR_EraseRootFromParent_Done,
     /*  74368 */   // Label 1237: @74368
     /*  74368 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(74404), // Rule ID 4951 //
     /*  74373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74385 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74391 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74395 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  74395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74402 */     GIR_RootConstrainSelectedInstOperands,
     /*  74403 */     // GIR_Coverage, 4951,
     /*  74403 */     GIR_EraseRootFromParent_Done,
     /*  74404 */   // Label 1238: @74404
     /*  74404 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(74428), // Rule ID 169 //
     /*  74409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74421 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  74426 */     GIR_RootConstrainSelectedInstOperands,
     /*  74427 */     // GIR_Coverage, 169,
     /*  74427 */     GIR_Done,
     /*  74428 */   // Label 1239: @74428
     /*  74428 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(74455), // Rule ID 5050 //
     /*  74433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74448 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  74448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74453 */     GIR_RootConstrainSelectedInstOperands,
     /*  74454 */     // GIR_Coverage, 5050,
     /*  74454 */     GIR_Done,
     /*  74455 */   // Label 1240: @74455
     /*  74455 */   GIM_Reject,
     /*  74456 */ // Label 1223: @74456
     /*  74456 */ GIM_Reject,
     /*  74457 */ // Label 1191: @74457
     /*  74457 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(74691),
     /*  74462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74472 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(74568), // Rule ID 1160 //
     /*  74477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  74496 */     // MIs[1] Operand 1
     /*  74496 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74531 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74537 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74539 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74543 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74551 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74553 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  74553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  74556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74566 */     GIR_RootConstrainSelectedInstOperands,
     /*  74567 */     // GIR_Coverage, 1160,
     /*  74567 */     GIR_EraseRootFromParent_Done,
     /*  74568 */   // Label 1242: @74568
     /*  74568 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(74635), // Rule ID 4998 //
     /*  74573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74585 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  74589 */     // MIs[1] Operand 1
     /*  74589 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74598 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74604 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74610 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74620 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  74620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  74623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74633 */     GIR_RootConstrainSelectedInstOperands,
     /*  74634 */     // GIR_Coverage, 4998,
     /*  74634 */     GIR_EraseRootFromParent_Done,
     /*  74635 */   // Label 1243: @74635
     /*  74635 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(74667), // Rule ID 4949 //
     /*  74640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74648 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74658 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  74658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74665 */     GIR_RootConstrainSelectedInstOperands,
     /*  74666 */     // GIR_Coverage, 4949,
     /*  74666 */     GIR_EraseRootFromParent_Done,
     /*  74667 */   // Label 1244: @74667
     /*  74667 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(74690), // Rule ID 5049 //
     /*  74672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74683 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  74683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74688 */     GIR_RootConstrainSelectedInstOperands,
     /*  74689 */     // GIR_Coverage, 5049,
     /*  74689 */     GIR_Done,
     /*  74690 */   // Label 1245: @74690
     /*  74690 */   GIM_Reject,
     /*  74691 */ // Label 1241: @74691
     /*  74691 */ GIM_Reject,
     /*  74692 */ // Label 1192: @74692
     /*  74692 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(75380),
     /*  74697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74707 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(74803), // Rule ID 1162 //
     /*  74712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74727 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74731 */     // MIs[1] Operand 1
     /*  74731 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74766 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74772 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74774 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74778 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74786 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74788 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  74788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74801 */     GIR_RootConstrainSelectedInstOperands,
     /*  74802 */     // GIR_Coverage, 1162,
     /*  74802 */     GIR_EraseRootFromParent_Done,
     /*  74803 */   // Label 1247: @74803
     /*  74803 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(74870), // Rule ID 5000 //
     /*  74808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74820 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74824 */     // MIs[1] Operand 1
     /*  74824 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74833 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74839 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74845 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74855 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  74855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74868 */     GIR_RootConstrainSelectedInstOperands,
     /*  74869 */     // GIR_Coverage, 5000,
     /*  74869 */     GIR_EraseRootFromParent_Done,
     /*  74870 */   // Label 1248: @74870
     /*  74870 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(74955), // Rule ID 13790 //
     /*  74875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74919 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74938 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74953 */     GIR_RootConstrainSelectedInstOperands,
     /*  74954 */     // GIR_Coverage, 13790,
     /*  74954 */     GIR_EraseRootFromParent_Done,
     /*  74955 */   // Label 1249: @74955
     /*  74955 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(75040), // Rule ID 13789 //
     /*  74960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75009 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75021 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75023 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75038 */     GIR_RootConstrainSelectedInstOperands,
     /*  75039 */     // GIR_Coverage, 13789,
     /*  75039 */     GIR_EraseRootFromParent_Done,
     /*  75040 */   // Label 1250: @75040
     /*  75040 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(75125), // Rule ID 13788 //
     /*  75045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75093 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75108 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75123 */     GIR_RootConstrainSelectedInstOperands,
     /*  75124 */     // GIR_Coverage, 13788,
     /*  75124 */     GIR_EraseRootFromParent_Done,
     /*  75125 */   // Label 1251: @75125
     /*  75125 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(75210), // Rule ID 3830 //
     /*  75130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75183 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75193 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75208 */     GIR_RootConstrainSelectedInstOperands,
     /*  75209 */     // GIR_Coverage, 3830,
     /*  75209 */     GIR_EraseRootFromParent_Done,
     /*  75210 */   // Label 1252: @75210
     /*  75210 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(75242), // Rule ID 4952 //
     /*  75215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75223 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75229 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75233 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  75233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75240 */     GIR_RootConstrainSelectedInstOperands,
     /*  75241 */     // GIR_Coverage, 4952,
     /*  75241 */     GIR_EraseRootFromParent_Done,
     /*  75242 */   // Label 1253: @75242
     /*  75242 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(75299), // Rule ID 3826 //
     /*  75247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75282 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75297 */     GIR_RootConstrainSelectedInstOperands,
     /*  75298 */     // GIR_Coverage, 3826,
     /*  75298 */     GIR_EraseRootFromParent_Done,
     /*  75299 */   // Label 1254: @75299
     /*  75299 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(75356), // Rule ID 13778 //
     /*  75304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75339 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75354 */     GIR_RootConstrainSelectedInstOperands,
     /*  75355 */     // GIR_Coverage, 13778,
     /*  75355 */     GIR_EraseRootFromParent_Done,
     /*  75356 */   // Label 1255: @75356
     /*  75356 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(75379), // Rule ID 5053 //
     /*  75361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75372 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  75372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75377 */     GIR_RootConstrainSelectedInstOperands,
     /*  75378 */     // GIR_Coverage, 5053,
     /*  75378 */     GIR_Done,
     /*  75379 */   // Label 1256: @75379
     /*  75379 */   GIM_Reject,
     /*  75380 */ // Label 1246: @75380
     /*  75380 */ GIM_Reject,
     /*  75381 */ // Label 1193: @75381
     /*  75381 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(75615),
     /*  75386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  75389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75396 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(75492), // Rule ID 1158 //
     /*  75401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75416 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  75420 */     // MIs[1] Operand 1
     /*  75420 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  75437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75455 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75461 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75463 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75467 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75475 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75477 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  75477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  75480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75490 */     GIR_RootConstrainSelectedInstOperands,
     /*  75491 */     // GIR_Coverage, 1158,
     /*  75491 */     GIR_EraseRootFromParent_Done,
     /*  75492 */   // Label 1258: @75492
     /*  75492 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(75559), // Rule ID 4996 //
     /*  75497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75509 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  75513 */     // MIs[1] Operand 1
     /*  75513 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75522 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75528 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75534 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75544 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  75544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  75547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75557 */     GIR_RootConstrainSelectedInstOperands,
     /*  75558 */     // GIR_Coverage, 4996,
     /*  75558 */     GIR_EraseRootFromParent_Done,
     /*  75559 */   // Label 1259: @75559
     /*  75559 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(75591), // Rule ID 4947 //
     /*  75564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75572 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75582 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  75582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  75585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75589 */     GIR_RootConstrainSelectedInstOperands,
     /*  75590 */     // GIR_Coverage, 4947,
     /*  75590 */     GIR_EraseRootFromParent_Done,
     /*  75591 */   // Label 1260: @75591
     /*  75591 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(75614), // Rule ID 5048 //
     /*  75596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75607 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  75607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  75612 */     GIR_RootConstrainSelectedInstOperands,
     /*  75613 */     // GIR_Coverage, 5048,
     /*  75613 */     GIR_Done,
     /*  75614 */   // Label 1261: @75614
     /*  75614 */   GIM_Reject,
     /*  75615 */ // Label 1257: @75615
     /*  75615 */ GIM_Reject,
     /*  75616 */ // Label 1194: @75616
     /*  75616 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(76304),
     /*  75621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75631 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75727), // Rule ID 1161 //
     /*  75636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75655 */     // MIs[1] Operand 1
     /*  75655 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75690 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75696 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75698 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75702 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75710 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75712 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  75712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75725 */     GIR_RootConstrainSelectedInstOperands,
     /*  75726 */     // GIR_Coverage, 1161,
     /*  75726 */     GIR_EraseRootFromParent_Done,
     /*  75727 */   // Label 1263: @75727
     /*  75727 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75794), // Rule ID 4999 //
     /*  75732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75744 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75748 */     // MIs[1] Operand 1
     /*  75748 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75757 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75763 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75779 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  75779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75792 */     GIR_RootConstrainSelectedInstOperands,
     /*  75793 */     // GIR_Coverage, 4999,
     /*  75793 */     GIR_EraseRootFromParent_Done,
     /*  75794 */   // Label 1264: @75794
     /*  75794 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(75879), // Rule ID 13787 //
     /*  75799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75843 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75862 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75877 */     GIR_RootConstrainSelectedInstOperands,
     /*  75878 */     // GIR_Coverage, 13787,
     /*  75878 */     GIR_EraseRootFromParent_Done,
     /*  75879 */   // Label 1265: @75879
     /*  75879 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(75964), // Rule ID 13786 //
     /*  75884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75933 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75947 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75962 */     GIR_RootConstrainSelectedInstOperands,
     /*  75963 */     // GIR_Coverage, 13786,
     /*  75963 */     GIR_EraseRootFromParent_Done,
     /*  75964 */   // Label 1266: @75964
     /*  75964 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(76049), // Rule ID 13785 //
     /*  75969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76017 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76032 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76047 */     GIR_RootConstrainSelectedInstOperands,
     /*  76048 */     // GIR_Coverage, 13785,
     /*  76048 */     GIR_EraseRootFromParent_Done,
     /*  76049 */   // Label 1267: @76049
     /*  76049 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(76134), // Rule ID 3829 //
     /*  76054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76107 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76113 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76117 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76132 */     GIR_RootConstrainSelectedInstOperands,
     /*  76133 */     // GIR_Coverage, 3829,
     /*  76133 */     GIR_EraseRootFromParent_Done,
     /*  76134 */   // Label 1268: @76134
     /*  76134 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(76166), // Rule ID 4950 //
     /*  76139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76147 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76153 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76157 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  76157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  76160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76164 */     GIR_RootConstrainSelectedInstOperands,
     /*  76165 */     // GIR_Coverage, 4950,
     /*  76165 */     GIR_EraseRootFromParent_Done,
     /*  76166 */   // Label 1269: @76166
     /*  76166 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(76223), // Rule ID 3825 //
     /*  76171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76206 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76221 */     GIR_RootConstrainSelectedInstOperands,
     /*  76222 */     // GIR_Coverage, 3825,
     /*  76222 */     GIR_EraseRootFromParent_Done,
     /*  76223 */   // Label 1270: @76223
     /*  76223 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(76280), // Rule ID 13777 //
     /*  76228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76263 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  76278 */     GIR_RootConstrainSelectedInstOperands,
     /*  76279 */     // GIR_Coverage, 13777,
     /*  76279 */     GIR_EraseRootFromParent_Done,
     /*  76280 */   // Label 1271: @76280
     /*  76280 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(76303), // Rule ID 5052 //
     /*  76285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76296 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  76296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  76301 */     GIR_RootConstrainSelectedInstOperands,
     /*  76302 */     // GIR_Coverage, 5052,
     /*  76302 */     GIR_Done,
     /*  76303 */   // Label 1272: @76303
     /*  76303 */   GIM_Reject,
     /*  76304 */ // Label 1262: @76304
     /*  76304 */ GIM_Reject,
     /*  76305 */ // Label 1195: @76305
     /*  76305 */ GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(76542),
     /*  76310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  76313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76320 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(76416), // Rule ID 1156 //
     /*  76325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76340 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76344 */     // MIs[1] Operand 1
     /*  76344 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  76361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76379 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76385 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76387 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76391 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76399 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76401 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  76401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  76404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76414 */     GIR_RootConstrainSelectedInstOperands,
     /*  76415 */     // GIR_Coverage, 1156,
     /*  76415 */     GIR_EraseRootFromParent_Done,
     /*  76416 */   // Label 1274: @76416
     /*  76416 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(76483), // Rule ID 4994 //
     /*  76421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76433 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76437 */     // MIs[1] Operand 1
     /*  76437 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76446 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76452 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76458 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76468 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  76468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  76471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76481 */     GIR_RootConstrainSelectedInstOperands,
     /*  76482 */     // GIR_Coverage, 4994,
     /*  76482 */     GIR_EraseRootFromParent_Done,
     /*  76483 */   // Label 1275: @76483
     /*  76483 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(76518), // Rule ID 972 //
     /*  76488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76499 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76505 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76509 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  76509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  76512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76516 */     GIR_RootConstrainSelectedInstOperands,
     /*  76517 */     // GIR_Coverage, 972,
     /*  76517 */     GIR_EraseRootFromParent_Done,
     /*  76518 */   // Label 1276: @76518
     /*  76518 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(76541), // Rule ID 1599 //
     /*  76523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76534 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  76534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  76539 */     GIR_RootConstrainSelectedInstOperands,
     /*  76540 */     // GIR_Coverage, 1599,
     /*  76540 */     GIR_Done,
     /*  76541 */   // Label 1277: @76541
     /*  76541 */   GIM_Reject,
     /*  76542 */ // Label 1273: @76542
     /*  76542 */ GIM_Reject,
     /*  76543 */ // Label 1196: @76543
     /*  76543 */ GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(77231),
     /*  76548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76558 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(76654), // Rule ID 1159 //
     /*  76563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76578 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76582 */     // MIs[1] Operand 1
     /*  76582 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76617 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76623 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76625 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76629 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76635 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76639 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  76639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76652 */     GIR_RootConstrainSelectedInstOperands,
     /*  76653 */     // GIR_Coverage, 1159,
     /*  76653 */     GIR_EraseRootFromParent_Done,
     /*  76654 */   // Label 1279: @76654
     /*  76654 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(76721), // Rule ID 4997 //
     /*  76659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76671 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76675 */     // MIs[1] Operand 1
     /*  76675 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76684 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76690 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76696 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76706 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  76706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76719 */     GIR_RootConstrainSelectedInstOperands,
     /*  76720 */     // GIR_Coverage, 4997,
     /*  76720 */     GIR_EraseRootFromParent_Done,
     /*  76721 */   // Label 1280: @76721
     /*  76721 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(76806), // Rule ID 13784 //
     /*  76726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76770 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76776 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76789 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76804 */     GIR_RootConstrainSelectedInstOperands,
     /*  76805 */     // GIR_Coverage, 13784,
     /*  76805 */     GIR_EraseRootFromParent_Done,
     /*  76806 */   // Label 1281: @76806
     /*  76806 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(76891), // Rule ID 13783 //
     /*  76811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76860 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76874 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76889 */     GIR_RootConstrainSelectedInstOperands,
     /*  76890 */     // GIR_Coverage, 13783,
     /*  76890 */     GIR_EraseRootFromParent_Done,
     /*  76891 */   // Label 1282: @76891
     /*  76891 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(76976), // Rule ID 13782 //
     /*  76896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76944 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76959 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76974 */     GIR_RootConstrainSelectedInstOperands,
     /*  76975 */     // GIR_Coverage, 13782,
     /*  76975 */     GIR_EraseRootFromParent_Done,
     /*  76976 */   // Label 1283: @76976
     /*  76976 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(77061), // Rule ID 3828 //
     /*  76981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77034 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77044 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77059 */     GIR_RootConstrainSelectedInstOperands,
     /*  77060 */     // GIR_Coverage, 3828,
     /*  77060 */     GIR_EraseRootFromParent_Done,
     /*  77061 */   // Label 1284: @77061
     /*  77061 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(77093), // Rule ID 4948 //
     /*  77066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77074 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77080 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77084 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  77084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77091 */     GIR_RootConstrainSelectedInstOperands,
     /*  77092 */     // GIR_Coverage, 4948,
     /*  77092 */     GIR_EraseRootFromParent_Done,
     /*  77093 */   // Label 1285: @77093
     /*  77093 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(77150), // Rule ID 3824 //
     /*  77098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77133 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77148 */     GIR_RootConstrainSelectedInstOperands,
     /*  77149 */     // GIR_Coverage, 3824,
     /*  77149 */     GIR_EraseRootFromParent_Done,
     /*  77150 */   // Label 1286: @77150
     /*  77150 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(77207), // Rule ID 13776 //
     /*  77155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77190 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77205 */     GIR_RootConstrainSelectedInstOperands,
     /*  77206 */     // GIR_Coverage, 13776,
     /*  77206 */     GIR_EraseRootFromParent_Done,
     /*  77207 */   // Label 1287: @77207
     /*  77207 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(77230), // Rule ID 5051 //
     /*  77212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77223 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  77223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77228 */     GIR_RootConstrainSelectedInstOperands,
     /*  77229 */     // GIR_Coverage, 5051,
     /*  77229 */     GIR_Done,
     /*  77230 */   // Label 1288: @77230
     /*  77230 */   GIM_Reject,
     /*  77231 */ // Label 1278: @77231
     /*  77231 */ GIM_Reject,
     /*  77232 */ // Label 1197: @77232
     /*  77232 */ GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(77923),
     /*  77237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77247 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(77343), // Rule ID 1157 //
     /*  77252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  77263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77271 */     // MIs[1] Operand 1
     /*  77271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  77276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77306 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77312 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  77314 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77318 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77326 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77328 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  77331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  77341 */     GIR_RootConstrainSelectedInstOperands,
     /*  77342 */     // GIR_Coverage, 1157,
     /*  77342 */     GIR_EraseRootFromParent_Done,
     /*  77343 */   // Label 1290: @77343
     /*  77343 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(77410), // Rule ID 4995 //
     /*  77348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  77356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77364 */     // MIs[1] Operand 1
     /*  77364 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  77369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  77373 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77379 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  77381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  77385 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77391 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77395 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  77395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  77398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77408 */     GIR_RootConstrainSelectedInstOperands,
     /*  77409 */     // GIR_Coverage, 4995,
     /*  77409 */     GIR_EraseRootFromParent_Done,
     /*  77410 */   // Label 1291: @77410
     /*  77410 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(77495), // Rule ID 13781 //
     /*  77415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77459 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77478 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  77485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77493 */     GIR_RootConstrainSelectedInstOperands,
     /*  77494 */     // GIR_Coverage, 13781,
     /*  77494 */     GIR_EraseRootFromParent_Done,
     /*  77495 */   // Label 1292: @77495
     /*  77495 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(77580), // Rule ID 13780 //
     /*  77500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77549 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77563 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  77570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77578 */     GIR_RootConstrainSelectedInstOperands,
     /*  77579 */     // GIR_Coverage, 13780,
     /*  77579 */     GIR_EraseRootFromParent_Done,
     /*  77580 */   // Label 1293: @77580
     /*  77580 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(77665), // Rule ID 13779 //
     /*  77585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77648 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77663 */     GIR_RootConstrainSelectedInstOperands,
     /*  77664 */     // GIR_Coverage, 13779,
     /*  77664 */     GIR_EraseRootFromParent_Done,
     /*  77665 */   // Label 1294: @77665
     /*  77665 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(77750), // Rule ID 3827 //
     /*  77670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77733 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77748 */     GIR_RootConstrainSelectedInstOperands,
     /*  77749 */     // GIR_Coverage, 3827,
     /*  77749 */     GIR_EraseRootFromParent_Done,
     /*  77750 */   // Label 1295: @77750
     /*  77750 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(77785), // Rule ID 973 //
     /*  77755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77766 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77776 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  77776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77783 */     GIR_RootConstrainSelectedInstOperands,
     /*  77784 */     // GIR_Coverage, 973,
     /*  77784 */     GIR_EraseRootFromParent_Done,
     /*  77785 */   // Label 1296: @77785
     /*  77785 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(77842), // Rule ID 3823 //
     /*  77790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77825 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77840 */     GIR_RootConstrainSelectedInstOperands,
     /*  77841 */     // GIR_Coverage, 3823,
     /*  77841 */     GIR_EraseRootFromParent_Done,
     /*  77842 */   // Label 1297: @77842
     /*  77842 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(77899), // Rule ID 13775 //
     /*  77847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77882 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77897 */     GIR_RootConstrainSelectedInstOperands,
     /*  77898 */     // GIR_Coverage, 13775,
     /*  77898 */     GIR_EraseRootFromParent_Done,
     /*  77899 */   // Label 1298: @77899
     /*  77899 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(77922), // Rule ID 1600 //
     /*  77904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77915 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77920 */     GIR_RootConstrainSelectedInstOperands,
     /*  77921 */     // GIR_Coverage, 1600,
     /*  77921 */     GIR_Done,
     /*  77922 */   // Label 1299: @77922
     /*  77922 */   GIM_Reject,
     /*  77923 */ // Label 1289: @77923
     /*  77923 */ GIM_Reject,
     /*  77924 */ // Label 1198: @77924
     /*  77924 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(77973), // Rule ID 8464 //
     /*  77929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  77935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  77938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77942 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  77942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77954 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77967 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77969 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77971 */   GIR_RootConstrainSelectedInstOperands,
     /*  77972 */   // GIR_Coverage, 8464,
     /*  77972 */   GIR_EraseRootFromParent_Done,
     /*  77973 */ // Label 1300: @77973
     /*  77973 */ GIM_Reject,
     /*  77974 */ // Label 1199: @77974
     /*  77974 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(78023), // Rule ID 8463 //
     /*  77979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  77985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  77988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77992 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  77992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78004 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78017 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78019 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78021 */   GIR_RootConstrainSelectedInstOperands,
     /*  78022 */   // GIR_Coverage, 8463,
     /*  78022 */   GIR_EraseRootFromParent_Done,
     /*  78023 */ // Label 1301: @78023
     /*  78023 */ GIM_Reject,
     /*  78024 */ // Label 1200: @78024
     /*  78024 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(78486),
     /*  78029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78039 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(78110), // Rule ID 15642 //
     /*  78044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78083 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78093 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78108 */     GIR_RootConstrainSelectedInstOperands,
     /*  78109 */     // GIR_Coverage, 15642,
     /*  78109 */     GIR_EraseRootFromParent_Done,
     /*  78110 */   // Label 1303: @78110
     /*  78110 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(78181), // Rule ID 15641 //
     /*  78115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78154 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78160 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78164 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78179 */     GIR_RootConstrainSelectedInstOperands,
     /*  78180 */     // GIR_Coverage, 15641,
     /*  78180 */     GIR_EraseRootFromParent_Done,
     /*  78181 */   // Label 1304: @78181
     /*  78181 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(78252), // Rule ID 15640 //
     /*  78186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78225 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78231 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78235 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78250 */     GIR_RootConstrainSelectedInstOperands,
     /*  78251 */     // GIR_Coverage, 15640,
     /*  78251 */     GIR_EraseRootFromParent_Done,
     /*  78252 */   // Label 1305: @78252
     /*  78252 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(78323), // Rule ID 11894 //
     /*  78257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78296 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78302 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78306 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78321 */     GIR_RootConstrainSelectedInstOperands,
     /*  78322 */     // GIR_Coverage, 11894,
     /*  78322 */     GIR_EraseRootFromParent_Done,
     /*  78323 */   // Label 1306: @78323
     /*  78323 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(78384), // Rule ID 11918 //
     /*  78328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78347 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  78351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78355 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78361 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78365 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78382 */     GIR_RootConstrainSelectedInstOperands,
     /*  78383 */     // GIR_Coverage, 11918,
     /*  78383 */     GIR_EraseRootFromParent_Done,
     /*  78384 */   // Label 1307: @78384
     /*  78384 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(78427), // Rule ID 13742 //
     /*  78389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78410 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78425 */     GIR_RootConstrainSelectedInstOperands,
     /*  78426 */     // GIR_Coverage, 13742,
     /*  78426 */     GIR_EraseRootFromParent_Done,
     /*  78427 */   // Label 1308: @78427
     /*  78427 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(78470), // Rule ID 3154 //
     /*  78432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78453 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78468 */     GIR_RootConstrainSelectedInstOperands,
     /*  78469 */     // GIR_Coverage, 3154,
     /*  78469 */     GIR_EraseRootFromParent_Done,
     /*  78470 */   // Label 1309: @78470
     /*  78470 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(78485), // Rule ID 7483 //
     /*  78475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78478 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  78478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78483 */     GIR_RootConstrainSelectedInstOperands,
     /*  78484 */     // GIR_Coverage, 7483,
     /*  78484 */     GIR_Done,
     /*  78485 */   // Label 1310: @78485
     /*  78485 */   GIM_Reject,
     /*  78486 */ // Label 1302: @78486
     /*  78486 */ GIM_Reject,
     /*  78487 */ // Label 1201: @78487
     /*  78487 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(78536), // Rule ID 8462 //
     /*  78492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  78498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  78501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78505 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  78505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  78512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78517 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78530 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78532 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78534 */   GIR_RootConstrainSelectedInstOperands,
     /*  78535 */   // GIR_Coverage, 8462,
     /*  78535 */   GIR_EraseRootFromParent_Done,
     /*  78536 */ // Label 1311: @78536
     /*  78536 */ GIM_Reject,
     /*  78537 */ // Label 1202: @78537
     /*  78537 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(78999),
     /*  78542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78552 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(78623), // Rule ID 15639 //
     /*  78557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78596 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78606 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78621 */     GIR_RootConstrainSelectedInstOperands,
     /*  78622 */     // GIR_Coverage, 15639,
     /*  78622 */     GIR_EraseRootFromParent_Done,
     /*  78623 */   // Label 1313: @78623
     /*  78623 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(78694), // Rule ID 15638 //
     /*  78628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78667 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78677 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78692 */     GIR_RootConstrainSelectedInstOperands,
     /*  78693 */     // GIR_Coverage, 15638,
     /*  78693 */     GIR_EraseRootFromParent_Done,
     /*  78694 */   // Label 1314: @78694
     /*  78694 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(78765), // Rule ID 15637 //
     /*  78699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78738 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78748 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78763 */     GIR_RootConstrainSelectedInstOperands,
     /*  78764 */     // GIR_Coverage, 15637,
     /*  78764 */     GIR_EraseRootFromParent_Done,
     /*  78765 */   // Label 1315: @78765
     /*  78765 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(78836), // Rule ID 11892 //
     /*  78770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78809 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78815 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78819 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78834 */     GIR_RootConstrainSelectedInstOperands,
     /*  78835 */     // GIR_Coverage, 11892,
     /*  78835 */     GIR_EraseRootFromParent_Done,
     /*  78836 */   // Label 1316: @78836
     /*  78836 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(78897), // Rule ID 11916 //
     /*  78841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78860 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  78864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78868 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78878 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78895 */     GIR_RootConstrainSelectedInstOperands,
     /*  78896 */     // GIR_Coverage, 11916,
     /*  78896 */     GIR_EraseRootFromParent_Done,
     /*  78897 */   // Label 1317: @78897
     /*  78897 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(78940), // Rule ID 13741 //
     /*  78902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78923 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78938 */     GIR_RootConstrainSelectedInstOperands,
     /*  78939 */     // GIR_Coverage, 13741,
     /*  78939 */     GIR_EraseRootFromParent_Done,
     /*  78940 */   // Label 1318: @78940
     /*  78940 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(78983), // Rule ID 3152 //
     /*  78945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78966 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78981 */     GIR_RootConstrainSelectedInstOperands,
     /*  78982 */     // GIR_Coverage, 3152,
     /*  78982 */     GIR_EraseRootFromParent_Done,
     /*  78983 */   // Label 1319: @78983
     /*  78983 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(78998), // Rule ID 7482 //
     /*  78988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78991 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  78991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78996 */     GIR_RootConstrainSelectedInstOperands,
     /*  78997 */     // GIR_Coverage, 7482,
     /*  78997 */     GIR_Done,
     /*  78998 */   // Label 1320: @78998
     /*  78998 */   GIM_Reject,
     /*  78999 */ // Label 1312: @78999
     /*  78999 */ GIM_Reject,
     /*  79000 */ // Label 1203: @79000
     /*  79000 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(79049), // Rule ID 8461 //
     /*  79005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  79011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  79014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79018 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  79018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  79021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  79025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79030 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  79033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  79038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79043 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79045 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79047 */   GIR_RootConstrainSelectedInstOperands,
     /*  79048 */   // GIR_Coverage, 8461,
     /*  79048 */   GIR_EraseRootFromParent_Done,
     /*  79049 */ // Label 1321: @79049
     /*  79049 */ GIM_Reject,
     /*  79050 */ // Label 1204: @79050
     /*  79050 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(79512),
     /*  79055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79065 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(79136), // Rule ID 15636 //
     /*  79070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79109 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79115 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79119 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79134 */     GIR_RootConstrainSelectedInstOperands,
     /*  79135 */     // GIR_Coverage, 15636,
     /*  79135 */     GIR_EraseRootFromParent_Done,
     /*  79136 */   // Label 1323: @79136
     /*  79136 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(79207), // Rule ID 15635 //
     /*  79141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79180 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79190 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79205 */     GIR_RootConstrainSelectedInstOperands,
     /*  79206 */     // GIR_Coverage, 15635,
     /*  79206 */     GIR_EraseRootFromParent_Done,
     /*  79207 */   // Label 1324: @79207
     /*  79207 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(79278), // Rule ID 15634 //
     /*  79212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79251 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79257 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79261 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79276 */     GIR_RootConstrainSelectedInstOperands,
     /*  79277 */     // GIR_Coverage, 15634,
     /*  79277 */     GIR_EraseRootFromParent_Done,
     /*  79278 */   // Label 1325: @79278
     /*  79278 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(79349), // Rule ID 11890 //
     /*  79283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79322 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79332 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79347 */     GIR_RootConstrainSelectedInstOperands,
     /*  79348 */     // GIR_Coverage, 11890,
     /*  79348 */     GIR_EraseRootFromParent_Done,
     /*  79349 */   // Label 1326: @79349
     /*  79349 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(79410), // Rule ID 11914 //
     /*  79354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79373 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  79377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79381 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79391 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79408 */     GIR_RootConstrainSelectedInstOperands,
     /*  79409 */     // GIR_Coverage, 11914,
     /*  79409 */     GIR_EraseRootFromParent_Done,
     /*  79410 */   // Label 1327: @79410
     /*  79410 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(79453), // Rule ID 13740 //
     /*  79415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79436 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79451 */     GIR_RootConstrainSelectedInstOperands,
     /*  79452 */     // GIR_Coverage, 13740,
     /*  79452 */     GIR_EraseRootFromParent_Done,
     /*  79453 */   // Label 1328: @79453
     /*  79453 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(79496), // Rule ID 3150 //
     /*  79458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79479 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79494 */     GIR_RootConstrainSelectedInstOperands,
     /*  79495 */     // GIR_Coverage, 3150,
     /*  79495 */     GIR_EraseRootFromParent_Done,
     /*  79496 */   // Label 1329: @79496
     /*  79496 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(79511), // Rule ID 7481 //
     /*  79501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79504 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  79504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79509 */     GIR_RootConstrainSelectedInstOperands,
     /*  79510 */     // GIR_Coverage, 7481,
     /*  79510 */     GIR_Done,
     /*  79511 */   // Label 1330: @79511
     /*  79511 */   GIM_Reject,
     /*  79512 */ // Label 1322: @79512
     /*  79512 */ GIM_Reject,
     /*  79513 */ // Label 1205: @79513
     /*  79513 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(79562), // Rule ID 8460 //
     /*  79518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  79524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  79527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79531 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  79531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  79534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  79538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79543 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  79546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  79551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79556 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79558 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79560 */   GIR_RootConstrainSelectedInstOperands,
     /*  79561 */   // GIR_Coverage, 8460,
     /*  79561 */   GIR_EraseRootFromParent_Done,
     /*  79562 */ // Label 1331: @79562
     /*  79562 */ GIM_Reject,
     /*  79563 */ // Label 1206: @79563
     /*  79563 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(80025),
     /*  79568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79578 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(79649), // Rule ID 15633 //
     /*  79583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79622 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79632 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79647 */     GIR_RootConstrainSelectedInstOperands,
     /*  79648 */     // GIR_Coverage, 15633,
     /*  79648 */     GIR_EraseRootFromParent_Done,
     /*  79649 */   // Label 1333: @79649
     /*  79649 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(79720), // Rule ID 15632 //
     /*  79654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79693 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79699 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79703 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79718 */     GIR_RootConstrainSelectedInstOperands,
     /*  79719 */     // GIR_Coverage, 15632,
     /*  79719 */     GIR_EraseRootFromParent_Done,
     /*  79720 */   // Label 1334: @79720
     /*  79720 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(79791), // Rule ID 15631 //
     /*  79725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79764 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79770 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79774 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79789 */     GIR_RootConstrainSelectedInstOperands,
     /*  79790 */     // GIR_Coverage, 15631,
     /*  79790 */     GIR_EraseRootFromParent_Done,
     /*  79791 */   // Label 1335: @79791
     /*  79791 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(79862), // Rule ID 11888 //
     /*  79796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79835 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79841 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79845 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79860 */     GIR_RootConstrainSelectedInstOperands,
     /*  79861 */     // GIR_Coverage, 11888,
     /*  79861 */     GIR_EraseRootFromParent_Done,
     /*  79862 */   // Label 1336: @79862
     /*  79862 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(79923), // Rule ID 11912 //
     /*  79867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79886 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  79890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79894 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79904 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79921 */     GIR_RootConstrainSelectedInstOperands,
     /*  79922 */     // GIR_Coverage, 11912,
     /*  79922 */     GIR_EraseRootFromParent_Done,
     /*  79923 */   // Label 1337: @79923
     /*  79923 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(79966), // Rule ID 13739 //
     /*  79928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79949 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79964 */     GIR_RootConstrainSelectedInstOperands,
     /*  79965 */     // GIR_Coverage, 13739,
     /*  79965 */     GIR_EraseRootFromParent_Done,
     /*  79966 */   // Label 1338: @79966
     /*  79966 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(80009), // Rule ID 3148 //
     /*  79971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79992 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80007 */     GIR_RootConstrainSelectedInstOperands,
     /*  80008 */     // GIR_Coverage, 3148,
     /*  80008 */     GIR_EraseRootFromParent_Done,
     /*  80009 */   // Label 1339: @80009
     /*  80009 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(80024), // Rule ID 7480 //
     /*  80014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80017 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  80017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  80022 */     GIR_RootConstrainSelectedInstOperands,
     /*  80023 */     // GIR_Coverage, 7480,
     /*  80023 */     GIR_Done,
     /*  80024 */   // Label 1340: @80024
     /*  80024 */   GIM_Reject,
     /*  80025 */ // Label 1332: @80025
     /*  80025 */ GIM_Reject,
     /*  80026 */ // Label 1207: @80026
     /*  80026 */ GIM_Reject,
     /*  80027 */ // Label 8: @80027
     /*  80027 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(87550),
     /*  80032 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  80035 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1353*/ GIMT_Encode4(87549),
     /*  80046 */   /*GILLT_v2s64*//*Label 1342*/ GIMT_Encode4(80114), GIMT_Encode4(0),
     /*  80054 */   /*GILLT_v4s32*//*Label 1343*/ GIMT_Encode4(80635), GIMT_Encode4(0),
     /*  80062 */   /*GILLT_v8s16*//*Label 1344*/ GIMT_Encode4(83047),
     /*  80066 */   /*GILLT_v16s8*//*Label 1345*/ GIMT_Encode4(85456), GIMT_Encode4(0),
     /*  80074 */   /*GILLT_nxv2s1*//*Label 1346*/ GIMT_Encode4(87367), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  80090 */   /*GILLT_nxv4s1*//*Label 1347*/ GIMT_Encode4(87393),
     /*  80094 */   /*GILLT_nxv4s16*//*Label 1348*/ GIMT_Encode4(87419),
     /*  80098 */   /*GILLT_nxv4s32*//*Label 1349*/ GIMT_Encode4(87445),
     /*  80102 */   /*GILLT_nxv8s1*//*Label 1350*/ GIMT_Encode4(87471),
     /*  80106 */   /*GILLT_nxv8s16*//*Label 1351*/ GIMT_Encode4(87497),
     /*  80110 */   /*GILLT_nxv16s1*//*Label 1352*/ GIMT_Encode4(87523),
     /*  80114 */   // Label 1342: @80114
     /*  80114 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(80634),
     /*  80119 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  80122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  80125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80133 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(80195), // Rule ID 5794 //
     /*  80138 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80142 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80148 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80150 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80152 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  80152 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80155 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80159 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80164 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80168 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80170 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80173 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80175 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80178 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80181 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80184 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80189 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80194 */       // GIR_Coverage, 5794,
     /*  80194 */       GIR_EraseRootFromParent_Done,
     /*  80195 */     // Label 1355: @80195
     /*  80195 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(80257), // Rule ID 5798 //
     /*  80200 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80204 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80210 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80212 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80214 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  80214 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80217 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80221 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80226 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80230 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80232 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80235 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80237 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80240 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80243 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80246 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80251 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80256 */       // GIR_Coverage, 5798,
     /*  80256 */       GIR_EraseRootFromParent_Done,
     /*  80257 */     // Label 1356: @80257
     /*  80257 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(80315), // Rule ID 5795 //
     /*  80262 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80266 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80270 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80272 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  80272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  80275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80284 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80286 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80289 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80291 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80294 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80296 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80299 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80314 */       // GIR_Coverage, 5795,
     /*  80314 */       GIR_EraseRootFromParent_Done,
     /*  80315 */     // Label 1357: @80315
     /*  80315 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(80373), // Rule ID 5799 //
     /*  80320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80324 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80328 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80330 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  80330 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  80333 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80337 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80342 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80344 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80347 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80349 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80352 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80354 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80357 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80362 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80367 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80372 */       // GIR_Coverage, 5799,
     /*  80372 */       GIR_EraseRootFromParent_Done,
     /*  80373 */     // Label 1358: @80373
     /*  80373 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(80503), // Rule ID 5793 //
     /*  80378 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80382 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80382 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80385 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80389 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80394 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80396 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80399 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80403 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80408 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80411 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80415 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80418 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80423 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80428 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80433 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80436 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80440 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80445 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80447 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80450 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80454 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80459 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80462 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80466 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80469 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80474 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80479 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80484 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80487 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80489 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80492 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80495 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80501 */       GIR_RootConstrainSelectedInstOperands,
     /*  80502 */       // GIR_Coverage, 5793,
     /*  80502 */       GIR_EraseRootFromParent_Done,
     /*  80503 */     // Label 1359: @80503
     /*  80503 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(80633), // Rule ID 5797 //
     /*  80508 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80512 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80512 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80515 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80519 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80524 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80526 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80529 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80533 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80538 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80541 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80545 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80548 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80553 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80558 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80563 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80566 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80570 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80575 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80577 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80580 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80584 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80589 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80592 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80596 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80599 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80604 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80609 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80614 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80617 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80619 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80622 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80625 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80628 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80631 */       GIR_RootConstrainSelectedInstOperands,
     /*  80632 */       // GIR_Coverage, 5797,
     /*  80632 */       GIR_EraseRootFromParent_Done,
     /*  80633 */     // Label 1360: @80633
     /*  80633 */     GIM_Reject,
     /*  80634 */   // Label 1354: @80634
     /*  80634 */   GIM_Reject,
     /*  80635 */   // Label 1343: @80635
     /*  80635 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(83046),
     /*  80640 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  80643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  80646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80650 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80779), // Rule ID 5431 //
     /*  80655 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80659 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80663 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80667 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80671 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80675 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80679 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80683 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80687 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80691 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80695 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80699 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80704 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80708 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80714 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80716 */       // MIs[2] Operand 2
     /*  80716 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80727 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80729 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  80729 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80732 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80736 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80741 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80744 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80748 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80751 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80756 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80761 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80764 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80766 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80769 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80773 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80777 */       GIR_RootConstrainSelectedInstOperands,
     /*  80778 */       // GIR_Coverage, 5431,
     /*  80778 */       GIR_EraseRootFromParent_Done,
     /*  80779 */     // Label 1362: @80779
     /*  80779 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80901), // Rule ID 5427 //
     /*  80784 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80788 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80792 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80796 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80800 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80804 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80808 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80812 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80816 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  80820 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80824 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80828 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80833 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80838 */       // MIs[2] Operand 2
     /*  80838 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80849 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80851 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80851 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80854 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80858 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80863 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80866 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80870 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80873 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80878 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80883 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  80886 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80888 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80891 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80895 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80899 */       GIR_RootConstrainSelectedInstOperands,
     /*  80900 */       // GIR_Coverage, 5427,
     /*  80900 */       GIR_EraseRootFromParent_Done,
     /*  80901 */     // Label 1363: @80901
     /*  80901 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(81023), // Rule ID 5429 //
     /*  80906 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80910 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80914 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80918 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80922 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80926 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80930 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80934 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80938 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80942 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80946 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80950 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80955 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80960 */       // MIs[2] Operand 2
     /*  80960 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80971 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80973 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80973 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80976 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80980 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80985 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80988 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80992 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80995 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81000 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81005 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81008 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81010 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81013 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81017 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81021 */       GIR_RootConstrainSelectedInstOperands,
     /*  81022 */       // GIR_Coverage, 5429,
     /*  81022 */       GIR_EraseRootFromParent_Done,
     /*  81023 */     // Label 1364: @81023
     /*  81023 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(81125), // Rule ID 5577 //
     /*  81028 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81032 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81036 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81040 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81044 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81048 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81052 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81057 */       // MIs[2] Operand 2
     /*  81057 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  81068 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  81072 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81076 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81080 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  81084 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81088 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81092 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81097 */       // MIs[4] Operand 2
     /*  81097 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  81108 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81110 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  81110 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  81113 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81115 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  81119 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  81123 */       GIR_RootConstrainSelectedInstOperands,
     /*  81124 */       // GIR_Coverage, 5577,
     /*  81124 */       GIR_EraseRootFromParent_Done,
     /*  81125 */     // Label 1365: @81125
     /*  81125 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(81254), // Rule ID 6349 //
     /*  81130 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81134 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81138 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81142 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81145 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81150 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81154 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81158 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81163 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  81167 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81169 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  81169 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  81172 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  81176 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81181 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  81184 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  81186 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81189 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81193 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81198 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81200 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81203 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81207 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81212 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81215 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  81219 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81222 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81227 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81232 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81237 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  81240 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81242 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81245 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  81249 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81252 */       GIR_RootConstrainSelectedInstOperands,
     /*  81253 */       // GIR_Coverage, 6349,
     /*  81253 */       GIR_EraseRootFromParent_Done,
     /*  81254 */     // Label 1366: @81254
     /*  81254 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(81296), // Rule ID 5804 //
     /*  81259 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  81266 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  81273 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  81273 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81276 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81278 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81283 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81286 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81291 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81294 */       GIR_RootConstrainSelectedInstOperands,
     /*  81295 */       // GIR_Coverage, 5804,
     /*  81295 */       GIR_EraseRootFromParent_Done,
     /*  81296 */     // Label 1367: @81296
     /*  81296 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(81338), // Rule ID 5808 //
     /*  81301 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  81308 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  81315 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  81315 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81318 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81320 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81325 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81328 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81333 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81336 */       GIR_RootConstrainSelectedInstOperands,
     /*  81337 */       // GIR_Coverage, 5808,
     /*  81337 */       GIR_EraseRootFromParent_Done,
     /*  81338 */     // Label 1368: @81338
     /*  81338 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(81461), // Rule ID 2578 //
     /*  81343 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81346 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81350 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81354 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81358 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81361 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81366 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81370 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81374 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81379 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  81383 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81387 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81391 */       // MIs[2] Operand 1
     /*  81391 */       // No operand predicates
     /*  81391 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81393 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  81393 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81396 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81400 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81405 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81407 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81410 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81414 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81419 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81422 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81426 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81429 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81434 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81439 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81444 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  81447 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81449 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81452 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81456 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  81459 */       GIR_RootConstrainSelectedInstOperands,
     /*  81460 */       // GIR_Coverage, 2578,
     /*  81460 */       GIR_EraseRootFromParent_Done,
     /*  81461 */     // Label 1369: @81461
     /*  81461 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(81584), // Rule ID 6319 //
     /*  81466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81469 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81473 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81477 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81481 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81485 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81489 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  81493 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81497 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81502 */       // MIs[2] imm
     /*  81502 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81506 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81510 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81514 */       // MIs[3] Operand 1
     /*  81514 */       // No operand predicates
     /*  81514 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81516 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  81516 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81519 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81523 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81528 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81530 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81533 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81537 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81542 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81545 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81549 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81552 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81557 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81562 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81567 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  81570 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81572 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81575 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  81579 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81582 */       GIR_RootConstrainSelectedInstOperands,
     /*  81583 */       // GIR_Coverage, 6319,
     /*  81583 */       GIR_EraseRootFromParent_Done,
     /*  81584 */     // Label 1370: @81584
     /*  81584 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(81704), // Rule ID 6355 //
     /*  81589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81605 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81609 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81613 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81617 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81622 */       // MIs[2] imm
     /*  81622 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81626 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81630 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81634 */       // MIs[3] Operand 1
     /*  81634 */       // No operand predicates
     /*  81634 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81636 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  81636 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81639 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81643 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81648 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81650 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81653 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81657 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81662 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81665 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81669 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81672 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81677 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81682 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81687 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  81690 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81692 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81695 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  81699 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81702 */       GIR_RootConstrainSelectedInstOperands,
     /*  81703 */       // GIR_Coverage, 6355,
     /*  81703 */       GIR_EraseRootFromParent_Done,
     /*  81704 */     // Label 1371: @81704
     /*  81704 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81821), // Rule ID 2501 //
     /*  81709 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81712 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81716 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81720 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81724 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81727 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  81732 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81736 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81740 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81745 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81750 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81752 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81752 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81755 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81759 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81764 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81766 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81769 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81773 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81778 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81781 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81785 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81788 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81793 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81798 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81803 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  81806 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81808 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81811 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81815 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81819 */       GIR_RootConstrainSelectedInstOperands,
     /*  81820 */       // GIR_Coverage, 2501,
     /*  81820 */       GIR_EraseRootFromParent_Done,
     /*  81821 */     // Label 1372: @81821
     /*  81821 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81938), // Rule ID 5347 //
     /*  81826 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81829 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81833 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81837 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81841 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81844 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  81849 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81853 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81857 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81862 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81867 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81869 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81869 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81872 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81876 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81881 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81883 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81886 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81890 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81895 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81898 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81902 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81905 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81910 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81915 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81920 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81923 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81925 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81928 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81932 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81936 */       GIR_RootConstrainSelectedInstOperands,
     /*  81937 */       // GIR_Coverage, 5347,
     /*  81937 */       GIR_EraseRootFromParent_Done,
     /*  81938 */     // Label 1373: @81938
     /*  81938 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(82055), // Rule ID 5350 //
     /*  81943 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81946 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81950 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81954 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81958 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81961 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  81966 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81970 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81974 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81979 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81984 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81986 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81986 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81989 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81993 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81998 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82000 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82003 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82007 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82012 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82015 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82019 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82022 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82027 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82032 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82037 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  82040 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82042 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82045 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82049 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82053 */       GIR_RootConstrainSelectedInstOperands,
     /*  82054 */       // GIR_Coverage, 5350,
     /*  82054 */       GIR_EraseRootFromParent_Done,
     /*  82055 */     // Label 1374: @82055
     /*  82055 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(82172), // Rule ID 5353 //
     /*  82060 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82063 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82067 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82071 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82075 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82078 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  82083 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82087 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  82091 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82096 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82101 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82103 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  82103 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82106 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82110 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82115 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82117 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82120 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82124 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82129 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82132 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82136 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82139 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82144 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82149 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82154 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  82157 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82159 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82162 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82166 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82170 */       GIR_RootConstrainSelectedInstOperands,
     /*  82171 */       // GIR_Coverage, 5353,
     /*  82171 */       GIR_EraseRootFromParent_Done,
     /*  82172 */     // Label 1375: @82172
     /*  82172 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(82276), // Rule ID 2497 //
     /*  82177 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82180 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82188 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82192 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  82195 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  82200 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82204 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82209 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82211 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  82211 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82214 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82218 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82223 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82225 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82228 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82232 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82237 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82240 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82244 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82247 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82252 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82257 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82262 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  82265 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82267 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82270 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82274 */       GIR_RootConstrainSelectedInstOperands,
     /*  82275 */       // GIR_Coverage, 2497,
     /*  82275 */       GIR_EraseRootFromParent_Done,
     /*  82276 */     // Label 1376: @82276
     /*  82276 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(82332), // Rule ID 5510 //
     /*  82281 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82285 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82289 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82293 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82298 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82302 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82306 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82310 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82315 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82317 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  82317 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  82320 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82322 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  82326 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  82330 */       GIR_RootConstrainSelectedInstOperands,
     /*  82331 */       // GIR_Coverage, 5510,
     /*  82331 */       GIR_EraseRootFromParent_Done,
     /*  82332 */     // Label 1377: @82332
     /*  82332 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(82398), // Rule ID 5802 //
     /*  82337 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82341 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82345 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82351 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82353 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82355 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  82355 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82358 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82362 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82367 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82371 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82373 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82376 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82378 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82381 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82384 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82397 */       // GIR_Coverage, 5802,
     /*  82397 */       GIR_EraseRootFromParent_Done,
     /*  82398 */     // Label 1378: @82398
     /*  82398 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(82464), // Rule ID 5806 //
     /*  82403 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82407 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82411 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82417 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82419 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82421 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  82421 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82424 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82428 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82433 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82437 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82439 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82442 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82444 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82447 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82450 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82453 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82458 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82463 */       // GIR_Coverage, 5806,
     /*  82463 */       GIR_EraseRootFromParent_Done,
     /*  82464 */     // Label 1379: @82464
     /*  82464 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(82557), // Rule ID 4914 //
     /*  82469 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82473 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82477 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  82481 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82485 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82490 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82492 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  82492 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82495 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82499 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82504 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82506 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82509 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82513 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82518 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82521 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82525 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82528 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82533 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82538 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82543 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  82546 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82548 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82551 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82555 */       GIR_RootConstrainSelectedInstOperands,
     /*  82556 */       // GIR_Coverage, 4914,
     /*  82556 */       GIR_EraseRootFromParent_Done,
     /*  82557 */     // Label 1380: @82557
     /*  82557 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(82653), // Rule ID 4961 //
     /*  82562 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82565 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82569 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82573 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82577 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82581 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82586 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82588 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  82588 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82591 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82595 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82600 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82602 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82605 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82609 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82614 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82617 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82621 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82624 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82629 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82634 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82639 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  82642 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82644 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82647 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82651 */       GIR_RootConstrainSelectedInstOperands,
     /*  82652 */       // GIR_Coverage, 4961,
     /*  82652 */       GIR_EraseRootFromParent_Done,
     /*  82653 */     // Label 1381: @82653
     /*  82653 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82715), // Rule ID 5803 //
     /*  82658 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82662 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82666 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82670 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82672 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  82672 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82675 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82679 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82684 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82686 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82689 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82691 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82694 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82696 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82699 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82704 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82709 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82714 */       // GIR_Coverage, 5803,
     /*  82714 */       GIR_EraseRootFromParent_Done,
     /*  82715 */     // Label 1382: @82715
     /*  82715 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82777), // Rule ID 5807 //
     /*  82720 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82724 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82728 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82732 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82734 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  82734 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82737 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82741 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82746 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82753 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82756 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82758 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82761 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82766 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82771 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82776 */       // GIR_Coverage, 5807,
     /*  82776 */       GIR_EraseRootFromParent_Done,
     /*  82777 */     // Label 1383: @82777
     /*  82777 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82911), // Rule ID 5801 //
     /*  82782 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82786 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82790 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82790 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82793 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82797 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82802 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82804 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82807 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82811 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82816 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82819 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82823 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82826 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82831 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82836 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82841 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82844 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82848 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82853 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82855 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82858 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82862 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82867 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82870 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82874 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82877 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82882 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82887 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82892 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82895 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82897 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82900 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82903 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82906 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82909 */       GIR_RootConstrainSelectedInstOperands,
     /*  82910 */       // GIR_Coverage, 5801,
     /*  82910 */       GIR_EraseRootFromParent_Done,
     /*  82911 */     // Label 1384: @82911
     /*  82911 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(83045), // Rule ID 5805 //
     /*  82916 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82920 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82924 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82924 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82927 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82931 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82936 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82938 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82941 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82945 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82950 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82953 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82957 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82960 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82965 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82970 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82975 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82978 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82982 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82987 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82989 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82992 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82996 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83001 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83004 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83008 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83011 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83016 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83021 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83026 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83029 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83031 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83034 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83037 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83040 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83043 */       GIR_RootConstrainSelectedInstOperands,
     /*  83044 */       // GIR_Coverage, 5805,
     /*  83044 */       GIR_EraseRootFromParent_Done,
     /*  83045 */     // Label 1385: @83045
     /*  83045 */     GIM_Reject,
     /*  83046 */   // Label 1361: @83046
     /*  83046 */   GIM_Reject,
     /*  83047 */   // Label 1344: @83047
     /*  83047 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(85455),
     /*  83052 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  83055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  83058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83062 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(83191), // Rule ID 5425 //
     /*  83067 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83071 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83075 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83079 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83083 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83087 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83091 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83095 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83099 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83103 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83107 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83111 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83116 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83120 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83126 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83128 */       // MIs[2] Operand 2
     /*  83128 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83139 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83141 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  83141 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83144 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83148 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83153 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83156 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83160 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83168 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83173 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83176 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83178 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83181 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83185 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83189 */       GIR_RootConstrainSelectedInstOperands,
     /*  83190 */       // GIR_Coverage, 5425,
     /*  83190 */       GIR_EraseRootFromParent_Done,
     /*  83191 */     // Label 1387: @83191
     /*  83191 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(83313), // Rule ID 5421 //
     /*  83196 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83200 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83204 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83208 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83212 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83216 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83220 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83224 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83228 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  83232 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83236 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83240 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83245 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83250 */       // MIs[2] Operand 2
     /*  83250 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83261 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83263 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83263 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83266 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83270 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83275 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83278 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83282 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83285 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83290 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83295 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  83298 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83300 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83303 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83307 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83311 */       GIR_RootConstrainSelectedInstOperands,
     /*  83312 */       // GIR_Coverage, 5421,
     /*  83312 */       GIR_EraseRootFromParent_Done,
     /*  83313 */     // Label 1388: @83313
     /*  83313 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(83435), // Rule ID 5423 //
     /*  83318 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83322 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83326 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83330 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83334 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83338 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83342 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83346 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83350 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  83354 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83358 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83362 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83367 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83372 */       // MIs[2] Operand 2
     /*  83372 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83383 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83385 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83385 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83388 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83392 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83397 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83400 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83404 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83407 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83412 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83417 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83420 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83422 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83425 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83429 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83433 */       GIR_RootConstrainSelectedInstOperands,
     /*  83434 */       // GIR_Coverage, 5423,
     /*  83434 */       GIR_EraseRootFromParent_Done,
     /*  83435 */     // Label 1389: @83435
     /*  83435 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(83537), // Rule ID 5576 //
     /*  83440 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83444 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83448 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83452 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83456 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83460 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83464 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83469 */       // MIs[2] Operand 2
     /*  83469 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83480 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  83484 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83488 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83492 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  83496 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83500 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83504 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83509 */       // MIs[4] Operand 2
     /*  83509 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  83520 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83522 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  83522 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  83525 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  83527 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  83531 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  83535 */       GIR_RootConstrainSelectedInstOperands,
     /*  83536 */       // GIR_Coverage, 5576,
     /*  83536 */       GIR_EraseRootFromParent_Done,
     /*  83537 */     // Label 1390: @83537
     /*  83537 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(83666), // Rule ID 6348 //
     /*  83542 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83546 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83550 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83554 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83557 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83562 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83566 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83570 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83575 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  83579 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83581 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  83581 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  83584 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  83588 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83593 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  83596 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  83598 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83601 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83605 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83610 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83612 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83615 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83619 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83624 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83627 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  83631 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83634 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83639 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83644 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83649 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  83652 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83654 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83657 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  83661 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83664 */       GIR_RootConstrainSelectedInstOperands,
     /*  83665 */       // GIR_Coverage, 6348,
     /*  83665 */       GIR_EraseRootFromParent_Done,
     /*  83666 */     // Label 1391: @83666
     /*  83666 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83708), // Rule ID 5812 //
     /*  83671 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  83678 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  83685 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  83685 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83688 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83690 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83695 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83698 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83703 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83706 */       GIR_RootConstrainSelectedInstOperands,
     /*  83707 */       // GIR_Coverage, 5812,
     /*  83707 */       GIR_EraseRootFromParent_Done,
     /*  83708 */     // Label 1392: @83708
     /*  83708 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83750), // Rule ID 5816 //
     /*  83713 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83720 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83727 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  83727 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83730 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83732 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83737 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83740 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83745 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83748 */       GIR_RootConstrainSelectedInstOperands,
     /*  83749 */       // GIR_Coverage, 5816,
     /*  83749 */       GIR_EraseRootFromParent_Done,
     /*  83750 */     // Label 1393: @83750
     /*  83750 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83873), // Rule ID 2576 //
     /*  83755 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83758 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83762 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83766 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83770 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83773 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83778 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83782 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83786 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83791 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  83795 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83799 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83803 */       // MIs[2] Operand 1
     /*  83803 */       // No operand predicates
     /*  83803 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83805 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83805 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83808 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83812 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83817 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83819 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83822 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83826 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83831 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83834 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83838 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83841 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83846 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83851 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83856 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  83859 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83861 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83864 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83868 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  83871 */       GIR_RootConstrainSelectedInstOperands,
     /*  83872 */       // GIR_Coverage, 2576,
     /*  83872 */       GIR_EraseRootFromParent_Done,
     /*  83873 */     // Label 1394: @83873
     /*  83873 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83996), // Rule ID 6318 //
     /*  83878 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83881 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83885 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83889 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83893 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83897 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83901 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  83905 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83909 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83914 */       // MIs[2] imm
     /*  83914 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83918 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83922 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83926 */       // MIs[3] Operand 1
     /*  83926 */       // No operand predicates
     /*  83926 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83928 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83928 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83931 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83935 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83940 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83942 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83945 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83949 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83954 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83957 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83961 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83964 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83969 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83974 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83979 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83982 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83984 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83987 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83991 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83994 */       GIR_RootConstrainSelectedInstOperands,
     /*  83995 */       // GIR_Coverage, 6318,
     /*  83995 */       GIR_EraseRootFromParent_Done,
     /*  83996 */     // Label 1395: @83996
     /*  83996 */     GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(84116), // Rule ID 6354 //
     /*  84001 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84005 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84009 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84013 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84017 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84021 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84025 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84029 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84034 */       // MIs[2] imm
     /*  84034 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84038 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84042 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  84046 */       // MIs[3] Operand 1
     /*  84046 */       // No operand predicates
     /*  84046 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84048 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  84048 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84051 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84055 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84060 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84062 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84065 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84069 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84074 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84077 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84081 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84084 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84089 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84094 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  84102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84104 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84107 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  84111 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  84114 */       GIR_RootConstrainSelectedInstOperands,
     /*  84115 */       // GIR_Coverage, 6354,
     /*  84115 */       GIR_EraseRootFromParent_Done,
     /*  84116 */     // Label 1396: @84116
     /*  84116 */     GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(84233), // Rule ID 2500 //
     /*  84121 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84124 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84128 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84132 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84136 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84139 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  84144 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84148 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84152 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84157 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84162 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84164 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84164 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84167 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84171 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84176 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84178 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84181 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84185 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84190 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84193 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84197 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84200 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84205 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84210 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84215 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  84218 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84220 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84223 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84227 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84231 */       GIR_RootConstrainSelectedInstOperands,
     /*  84232 */       // GIR_Coverage, 2500,
     /*  84232 */       GIR_EraseRootFromParent_Done,
     /*  84233 */     // Label 1397: @84233
     /*  84233 */     GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(84350), // Rule ID 5346 //
     /*  84238 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84241 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84245 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84249 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84253 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84256 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  84261 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84265 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84269 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84274 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84279 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84281 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84281 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84284 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84288 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84293 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84295 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84298 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84302 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84307 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84310 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84314 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84317 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84322 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84327 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84332 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  84335 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84337 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84340 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84344 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84348 */       GIR_RootConstrainSelectedInstOperands,
     /*  84349 */       // GIR_Coverage, 5346,
     /*  84349 */       GIR_EraseRootFromParent_Done,
     /*  84350 */     // Label 1398: @84350
     /*  84350 */     GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(84467), // Rule ID 5349 //
     /*  84355 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84358 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84362 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84366 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84370 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84373 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  84378 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84382 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84386 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84391 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84396 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84398 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84398 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84401 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84405 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84410 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84412 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84415 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84419 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84424 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84427 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84431 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84434 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84439 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84444 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84449 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  84452 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84454 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84457 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84461 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84465 */       GIR_RootConstrainSelectedInstOperands,
     /*  84466 */       // GIR_Coverage, 5349,
     /*  84466 */       GIR_EraseRootFromParent_Done,
     /*  84467 */     // Label 1399: @84467
     /*  84467 */     GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(84584), // Rule ID 5352 //
     /*  84472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84475 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84479 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84483 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84487 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84490 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  84495 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84499 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84503 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84508 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84513 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84515 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84515 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84518 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84522 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84527 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84529 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84532 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84536 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84541 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84544 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84548 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84551 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84556 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84561 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84566 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  84569 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84571 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84574 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84578 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84582 */       GIR_RootConstrainSelectedInstOperands,
     /*  84583 */       // GIR_Coverage, 5352,
     /*  84583 */       GIR_EraseRootFromParent_Done,
     /*  84584 */     // Label 1400: @84584
     /*  84584 */     GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(84685), // Rule ID 4908 //
     /*  84589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84601 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  84604 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  84609 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84613 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84618 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84620 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84620 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84623 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84627 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84632 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84634 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84637 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84641 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84646 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84649 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84653 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84656 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84661 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84666 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84671 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84674 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84676 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84679 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84683 */       GIR_RootConstrainSelectedInstOperands,
     /*  84684 */       // GIR_Coverage, 4908,
     /*  84684 */       GIR_EraseRootFromParent_Done,
     /*  84685 */     // Label 1401: @84685
     /*  84685 */     GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(84741), // Rule ID 5501 //
     /*  84690 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84694 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84698 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84702 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84707 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84711 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84715 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84719 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84724 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84726 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  84726 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  84729 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84731 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  84735 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  84739 */       GIR_RootConstrainSelectedInstOperands,
     /*  84740 */       // GIR_Coverage, 5501,
     /*  84740 */       GIR_EraseRootFromParent_Done,
     /*  84741 */     // Label 1402: @84741
     /*  84741 */     GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(84807), // Rule ID 5810 //
     /*  84746 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84750 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84754 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84760 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84762 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84764 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  84764 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84767 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84771 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84776 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84780 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84782 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84785 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84787 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84790 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84793 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84796 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84801 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84806 */       // GIR_Coverage, 5810,
     /*  84806 */       GIR_EraseRootFromParent_Done,
     /*  84807 */     // Label 1403: @84807
     /*  84807 */     GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(84873), // Rule ID 5814 //
     /*  84812 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84816 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84820 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84826 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84828 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84830 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  84830 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84833 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84837 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84842 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84846 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84848 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84851 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84853 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84856 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84859 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84862 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84867 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84872 */       // GIR_Coverage, 5814,
     /*  84872 */       GIR_EraseRootFromParent_Done,
     /*  84873 */     // Label 1404: @84873
     /*  84873 */     GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(84966), // Rule ID 4916 //
     /*  84878 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84882 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84886 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  84890 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84894 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84899 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84901 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84901 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84904 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84908 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84913 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84915 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84918 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84922 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84927 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84930 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84934 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84937 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84942 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84947 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84952 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84955 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84957 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84960 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84964 */       GIR_RootConstrainSelectedInstOperands,
     /*  84965 */       // GIR_Coverage, 4916,
     /*  84965 */       GIR_EraseRootFromParent_Done,
     /*  84966 */     // Label 1405: @84966
     /*  84966 */     GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(85062), // Rule ID 4960 //
     /*  84971 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84974 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84978 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84982 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84986 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84990 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84995 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84997 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  84997 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85000 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85004 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85009 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85011 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85014 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85018 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85023 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85026 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85030 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85033 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85043 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85048 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  85051 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85053 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85056 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  85060 */       GIR_RootConstrainSelectedInstOperands,
     /*  85061 */       // GIR_Coverage, 4960,
     /*  85061 */       GIR_EraseRootFromParent_Done,
     /*  85062 */     // Label 1406: @85062
     /*  85062 */     GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(85124), // Rule ID 5811 //
     /*  85067 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85071 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85075 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  85079 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85081 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  85081 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  85084 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85088 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85093 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  85095 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85098 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85100 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85103 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  85105 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  85108 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85113 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85118 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85123 */       // GIR_Coverage, 5811,
     /*  85123 */       GIR_EraseRootFromParent_Done,
     /*  85124 */     // Label 1407: @85124
     /*  85124 */     GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(85186), // Rule ID 5815 //
     /*  85129 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85133 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85137 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  85141 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85143 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  85143 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  85146 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85150 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85155 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  85157 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85160 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85162 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85165 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  85167 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  85170 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85175 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85180 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85185 */       // GIR_Coverage, 5815,
     /*  85185 */       GIR_EraseRootFromParent_Done,
     /*  85186 */     // Label 1408: @85186
     /*  85186 */     GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(85320), // Rule ID 5809 //
     /*  85191 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85195 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85199 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  85199 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  85202 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85206 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85211 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85213 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85216 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85220 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85225 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85228 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85232 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85235 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85240 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85245 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85250 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85253 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85257 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85262 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85264 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85267 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85271 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85276 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85279 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85283 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85286 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85291 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85296 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85301 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85304 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85306 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85309 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85312 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85315 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85318 */       GIR_RootConstrainSelectedInstOperands,
     /*  85319 */       // GIR_Coverage, 5809,
     /*  85319 */       GIR_EraseRootFromParent_Done,
     /*  85320 */     // Label 1409: @85320
     /*  85320 */     GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(85454), // Rule ID 5813 //
     /*  85325 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85329 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85333 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  85333 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  85336 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85340 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85345 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85347 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85350 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85354 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85359 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85362 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85366 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85369 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85374 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85379 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85384 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85387 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85391 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85396 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85398 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85401 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85405 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85410 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85413 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85417 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85420 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85425 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85430 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85440 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85443 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85446 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85449 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85452 */       GIR_RootConstrainSelectedInstOperands,
     /*  85453 */       // GIR_Coverage, 5813,
     /*  85453 */       GIR_EraseRootFromParent_Done,
     /*  85454 */     // Label 1410: @85454
     /*  85454 */     GIM_Reject,
     /*  85455 */   // Label 1386: @85455
     /*  85455 */   GIM_Reject,
     /*  85456 */   // Label 1345: @85456
     /*  85456 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(87366),
     /*  85461 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  85467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85471 */     GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(85600), // Rule ID 5419 //
     /*  85476 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85480 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85484 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85488 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85492 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85496 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85500 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85504 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85508 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85512 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85516 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85520 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85525 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85529 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85535 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85537 */       // MIs[2] Operand 2
     /*  85537 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85548 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85550 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  85550 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85553 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85557 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85562 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85565 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85569 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85572 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85577 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85582 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85585 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85587 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85590 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85594 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85598 */       GIR_RootConstrainSelectedInstOperands,
     /*  85599 */       // GIR_Coverage, 5419,
     /*  85599 */       GIR_EraseRootFromParent_Done,
     /*  85600 */     // Label 1412: @85600
     /*  85600 */     GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(85722), // Rule ID 5415 //
     /*  85605 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85609 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85613 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85617 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85621 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85625 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85629 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85633 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85637 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  85641 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85645 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85649 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85654 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85659 */       // MIs[2] Operand 2
     /*  85659 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85670 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85672 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85672 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85675 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85679 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85684 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85687 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85691 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85699 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85704 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85707 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85709 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85712 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85716 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85720 */       GIR_RootConstrainSelectedInstOperands,
     /*  85721 */       // GIR_Coverage, 5415,
     /*  85721 */       GIR_EraseRootFromParent_Done,
     /*  85722 */     // Label 1413: @85722
     /*  85722 */     GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(85844), // Rule ID 5417 //
     /*  85727 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85731 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85735 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85739 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85743 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85747 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85751 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85755 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85759 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  85763 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85767 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85771 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85776 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85781 */       // MIs[2] Operand 2
     /*  85781 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85792 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85794 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85794 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85797 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85801 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85806 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85809 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85813 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85816 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85821 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85826 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85829 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85831 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85834 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85838 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85842 */       GIR_RootConstrainSelectedInstOperands,
     /*  85843 */       // GIR_Coverage, 5417,
     /*  85843 */       GIR_EraseRootFromParent_Done,
     /*  85844 */     // Label 1414: @85844
     /*  85844 */     GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(85946), // Rule ID 5575 //
     /*  85849 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85853 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85857 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85861 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85865 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85869 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85873 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85878 */       // MIs[2] Operand 2
     /*  85878 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85889 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  85893 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85897 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85901 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  85905 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85909 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85913 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85918 */       // MIs[4] Operand 2
     /*  85918 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  85929 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85931 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  85931 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  85934 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85936 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  85940 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  85944 */       GIR_RootConstrainSelectedInstOperands,
     /*  85945 */       // GIR_Coverage, 5575,
     /*  85945 */       GIR_EraseRootFromParent_Done,
     /*  85946 */     // Label 1415: @85946
     /*  85946 */     GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(86075), // Rule ID 6347 //
     /*  85951 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85955 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85959 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85963 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85966 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85971 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85975 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85979 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85984 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  85988 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85990 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  85990 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  85993 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  85997 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86002 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  86005 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  86007 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86010 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86014 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86019 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86021 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86024 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86028 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86033 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86036 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  86040 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86043 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86048 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86053 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86058 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86061 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86063 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86066 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  86070 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  86073 */       GIR_RootConstrainSelectedInstOperands,
     /*  86074 */       // GIR_Coverage, 6347,
     /*  86074 */       GIR_EraseRootFromParent_Done,
     /*  86075 */     // Label 1416: @86075
     /*  86075 */     GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(86117), // Rule ID 5820 //
     /*  86080 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  86087 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  86094 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  86094 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  86097 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86099 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  86104 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86107 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86112 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  86115 */       GIR_RootConstrainSelectedInstOperands,
     /*  86116 */       // GIR_Coverage, 5820,
     /*  86116 */       GIR_EraseRootFromParent_Done,
     /*  86117 */     // Label 1417: @86117
     /*  86117 */     GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(86240), // Rule ID 2574 //
     /*  86122 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86125 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86129 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86133 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86137 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86140 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  86145 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86149 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  86153 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86158 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  86162 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86166 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86170 */       // MIs[2] Operand 1
     /*  86170 */       // No operand predicates
     /*  86170 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86172 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86172 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86175 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86179 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86184 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86186 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86189 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86193 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86198 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86201 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86205 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86208 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86213 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86218 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86223 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  86226 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86228 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86231 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86235 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  86238 */       GIR_RootConstrainSelectedInstOperands,
     /*  86239 */       // GIR_Coverage, 2574,
     /*  86239 */       GIR_EraseRootFromParent_Done,
     /*  86240 */     // Label 1418: @86240
     /*  86240 */     GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(86363), // Rule ID 6317 //
     /*  86245 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86248 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86252 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86256 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86260 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86264 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86268 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  86272 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86276 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86281 */       // MIs[2] imm
     /*  86281 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86285 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86289 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86293 */       // MIs[3] Operand 1
     /*  86293 */       // No operand predicates
     /*  86293 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86295 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86295 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86298 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86302 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86307 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86309 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86312 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86316 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86321 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86324 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86328 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86331 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86336 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86341 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86346 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  86349 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86351 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86354 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  86358 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  86361 */       GIR_RootConstrainSelectedInstOperands,
     /*  86362 */       // GIR_Coverage, 6317,
     /*  86362 */       GIR_EraseRootFromParent_Done,
     /*  86363 */     // Label 1419: @86363
     /*  86363 */     GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(86483), // Rule ID 6353 //
     /*  86368 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86372 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86376 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86380 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86384 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86388 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  86392 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86396 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86401 */       // MIs[2] imm
     /*  86401 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86405 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86409 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86413 */       // MIs[3] Operand 1
     /*  86413 */       // No operand predicates
     /*  86413 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86415 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  86469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86474 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  86478 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  86481 */       GIR_RootConstrainSelectedInstOperands,
     /*  86482 */       // GIR_Coverage, 6353,
     /*  86482 */       GIR_EraseRootFromParent_Done,
     /*  86483 */     // Label 1420: @86483
     /*  86483 */     GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(86600), // Rule ID 2499 //
     /*  86488 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86491 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86495 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86499 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86503 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86506 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  86511 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86515 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86519 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86524 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86529 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86531 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86531 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86534 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86538 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86543 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86545 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86548 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86552 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86557 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86560 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86564 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86567 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86572 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86577 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86582 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  86585 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86587 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86590 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86594 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86598 */       GIR_RootConstrainSelectedInstOperands,
     /*  86599 */       // GIR_Coverage, 2499,
     /*  86599 */       GIR_EraseRootFromParent_Done,
     /*  86600 */     // Label 1421: @86600
     /*  86600 */     GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(86717), // Rule ID 5345 //
     /*  86605 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86608 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86612 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86616 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86620 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86623 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  86628 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86632 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86636 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86641 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86646 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86648 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86648 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86651 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86655 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86660 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86662 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86665 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86669 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86674 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86677 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86681 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86684 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86689 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86699 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  86702 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86704 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86707 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86711 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86715 */       GIR_RootConstrainSelectedInstOperands,
     /*  86716 */       // GIR_Coverage, 5345,
     /*  86716 */       GIR_EraseRootFromParent_Done,
     /*  86717 */     // Label 1422: @86717
     /*  86717 */     GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(86834), // Rule ID 5348 //
     /*  86722 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86725 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86729 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86733 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86737 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86740 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  86745 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86749 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86753 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86758 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86763 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86765 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86765 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86768 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86772 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86777 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86779 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86782 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86786 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86791 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86794 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86798 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86801 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86806 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86811 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86816 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86819 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86821 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86824 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86828 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86832 */       GIR_RootConstrainSelectedInstOperands,
     /*  86833 */       // GIR_Coverage, 5348,
     /*  86833 */       GIR_EraseRootFromParent_Done,
     /*  86834 */     // Label 1423: @86834
     /*  86834 */     GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(86951), // Rule ID 5351 //
     /*  86839 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86842 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86846 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86850 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86854 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86857 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  86862 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86866 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86870 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86875 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86880 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86882 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86882 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86885 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86889 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86894 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86896 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86899 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86903 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86908 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86911 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86915 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86918 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86923 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86928 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86933 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  86936 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86938 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86941 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86945 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86949 */       GIR_RootConstrainSelectedInstOperands,
     /*  86950 */       // GIR_Coverage, 5351,
     /*  86950 */       GIR_EraseRootFromParent_Done,
     /*  86951 */     // Label 1424: @86951
     /*  86951 */     GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(87007), // Rule ID 5492 //
     /*  86956 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86960 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86964 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86968 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86973 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86977 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86981 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86985 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86990 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86992 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  86992 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  86995 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86997 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  87001 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  87005 */       GIR_RootConstrainSelectedInstOperands,
     /*  87006 */       // GIR_Coverage, 5492,
     /*  87006 */       GIR_EraseRootFromParent_Done,
     /*  87007 */     // Label 1425: @87007
     /*  87007 */     GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(87073), // Rule ID 5818 //
     /*  87012 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87016 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87020 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87026 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  87028 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87030 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  87030 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87033 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  87037 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87042 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  87046 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  87048 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  87051 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87053 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87056 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87059 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  87062 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87067 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87072 */       // GIR_Coverage, 5818,
     /*  87072 */       GIR_EraseRootFromParent_Done,
     /*  87073 */     // Label 1426: @87073
     /*  87073 */     GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(87169), // Rule ID 4959 //
     /*  87078 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87081 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87085 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87089 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  87093 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87097 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87102 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87104 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  87104 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  87107 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87111 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87116 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  87118 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  87121 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87125 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87130 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  87133 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  87137 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  87140 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87145 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87150 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87155 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  87158 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87160 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87163 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87167 */       GIR_RootConstrainSelectedInstOperands,
     /*  87168 */       // GIR_Coverage, 4959,
     /*  87168 */       GIR_EraseRootFromParent_Done,
     /*  87169 */     // Label 1427: @87169
     /*  87169 */     GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(87231), // Rule ID 5819 //
     /*  87174 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87178 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87182 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  87186 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87188 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  87188 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  87191 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87195 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87200 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  87202 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87205 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87207 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87210 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87212 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  87215 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87220 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87225 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87230 */       // GIR_Coverage, 5819,
     /*  87230 */       GIR_EraseRootFromParent_Done,
     /*  87231 */     // Label 1428: @87231
     /*  87231 */     GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(87365), // Rule ID 5817 //
     /*  87236 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87240 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87244 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  87244 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  87247 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87251 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87256 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  87258 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  87261 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87265 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87270 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  87273 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  87277 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  87280 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87285 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87290 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87295 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  87298 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87302 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87307 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  87309 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  87312 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87316 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87321 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  87324 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  87328 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  87331 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87336 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87341 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87346 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  87349 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87351 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87354 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  87357 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  87360 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87363 */       GIR_RootConstrainSelectedInstOperands,
     /*  87364 */       // GIR_Coverage, 5817,
     /*  87364 */       GIR_EraseRootFromParent_Done,
     /*  87365 */     // Label 1429: @87365
     /*  87365 */     GIM_Reject,
     /*  87366 */   // Label 1411: @87366
     /*  87366 */   GIM_Reject,
     /*  87367 */   // Label 1346: @87367
     /*  87367 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(87392), // Rule ID 9091 //
     /*  87372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87375 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  87378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  87381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87385 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  87385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  87390 */     GIR_RootConstrainSelectedInstOperands,
     /*  87391 */     // GIR_Coverage, 9091,
     /*  87391 */     GIR_Done,
     /*  87392 */   // Label 1430: @87392
     /*  87392 */   GIM_Reject,
     /*  87393 */   // Label 1347: @87393
     /*  87393 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(87418), // Rule ID 9092 //
     /*  87398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87401 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  87404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  87407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87411 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  87411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  87416 */     GIR_RootConstrainSelectedInstOperands,
     /*  87417 */     // GIR_Coverage, 9092,
     /*  87417 */     GIR_Done,
     /*  87418 */   // Label 1431: @87418
     /*  87418 */   GIM_Reject,
     /*  87419 */   // Label 1348: @87419
     /*  87419 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(87444), // Rule ID 9095 //
     /*  87424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87427 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  87430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  87433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87437 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  87437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  87442 */     GIR_RootConstrainSelectedInstOperands,
     /*  87443 */     // GIR_Coverage, 9095,
     /*  87443 */     GIR_Done,
     /*  87444 */   // Label 1432: @87444
     /*  87444 */   GIM_Reject,
     /*  87445 */   // Label 1349: @87445
     /*  87445 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(87470), // Rule ID 9097 //
     /*  87450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87453 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  87456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  87459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87463 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  87463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  87468 */     GIR_RootConstrainSelectedInstOperands,
     /*  87469 */     // GIR_Coverage, 9097,
     /*  87469 */     GIR_Done,
     /*  87470 */   // Label 1433: @87470
     /*  87470 */   GIM_Reject,
     /*  87471 */   // Label 1350: @87471
     /*  87471 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(87496), // Rule ID 9093 //
     /*  87476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87479 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  87482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  87485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87489 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  87489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  87494 */     GIR_RootConstrainSelectedInstOperands,
     /*  87495 */     // GIR_Coverage, 9093,
     /*  87495 */     GIR_Done,
     /*  87496 */   // Label 1434: @87496
     /*  87496 */   GIM_Reject,
     /*  87497 */   // Label 1351: @87497
     /*  87497 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(87522), // Rule ID 9096 //
     /*  87502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87505 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  87508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  87511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87515 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  87515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  87520 */     GIR_RootConstrainSelectedInstOperands,
     /*  87521 */     // GIR_Coverage, 9096,
     /*  87521 */     GIR_Done,
     /*  87522 */   // Label 1435: @87522
     /*  87522 */   GIM_Reject,
     /*  87523 */   // Label 1352: @87523
     /*  87523 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(87548), // Rule ID 9094 //
     /*  87528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87531 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  87534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  87537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87541 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  87541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  87546 */     GIR_RootConstrainSelectedInstOperands,
     /*  87547 */     // GIR_Coverage, 9094,
     /*  87547 */     GIR_Done,
     /*  87548 */   // Label 1436: @87548
     /*  87548 */   GIM_Reject,
     /*  87549 */   // Label 1353: @87549
     /*  87549 */   GIM_Reject,
     /*  87550 */ // Label 1341: @87550
     /*  87550 */ GIM_Reject,
     /*  87551 */ // Label 9: @87551
     /*  87551 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1451*/ GIMT_Encode4(97526),
     /*  87562 */ /*GILLT_s32*//*Label 1437*/ GIMT_Encode4(87650),
     /*  87566 */ /*GILLT_s64*//*Label 1438*/ GIMT_Encode4(88047),
     /*  87570 */ /*GILLT_s128*//*Label 1439*/ GIMT_Encode4(90038),
     /*  87574 */ /*GILLT_v2s32*//*Label 1440*/ GIMT_Encode4(90684),
     /*  87578 */ /*GILLT_v2s64*//*Label 1441*/ GIMT_Encode4(91599),
     /*  87582 */ /*GILLT_v4s16*//*Label 1442*/ GIMT_Encode4(92368),
     /*  87586 */ /*GILLT_v4s32*//*Label 1443*/ GIMT_Encode4(93283),
     /*  87590 */ /*GILLT_v8s8*//*Label 1444*/ GIMT_Encode4(94128),
     /*  87594 */ /*GILLT_v8s16*//*Label 1445*/ GIMT_Encode4(94689),
     /*  87598 */ /*GILLT_v16s8*//*Label 1446*/ GIMT_Encode4(95534), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87618 */ /*GILLT_nxv2s64*//*Label 1447*/ GIMT_Encode4(95986), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87630 */ /*GILLT_nxv4s32*//*Label 1448*/ GIMT_Encode4(96435), GIMT_Encode4(0),
     /*  87638 */ /*GILLT_nxv8s16*//*Label 1449*/ GIMT_Encode4(96884), GIMT_Encode4(0),
     /*  87646 */ /*GILLT_nxv16s8*//*Label 1450*/ GIMT_Encode4(97333),
     /*  87650 */ // Label 1437: @87650
     /*  87650 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(88046),
     /*  87655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  87658 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(87732), // Rule ID 7068 //
     /*  87663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87675 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87682 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87689 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  87705 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15883>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  87705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  87708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87730 */     GIR_RootConstrainSelectedInstOperands,
     /*  87731 */     // GIR_Coverage, 7068,
     /*  87731 */     GIR_EraseRootFromParent_Done,
     /*  87732 */   // Label 1453: @87732
     /*  87732 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(87806), // Rule ID 7069 //
     /*  87737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87749 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87752 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87756 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87763 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  87779 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15883>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  87779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  87782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87804 */     GIR_RootConstrainSelectedInstOperands,
     /*  87805 */     // GIR_Coverage, 7069,
     /*  87805 */     GIR_EraseRootFromParent_Done,
     /*  87806 */   // Label 1454: @87806
     /*  87806 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(87875), // Rule ID 7070 //
     /*  87811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87823 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87830 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87837 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  87853 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15883>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  87856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87873 */     GIR_RootConstrainSelectedInstOperands,
     /*  87874 */     // GIR_Coverage, 7070,
     /*  87874 */     GIR_EraseRootFromParent_Done,
     /*  87875 */   // Label 1455: @87875
     /*  87875 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(87944), // Rule ID 7071 //
     /*  87880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87892 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87899 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87906 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  87922 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15883>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  87925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87942 */     GIR_RootConstrainSelectedInstOperands,
     /*  87943 */     // GIR_Coverage, 7071,
     /*  87943 */     GIR_EraseRootFromParent_Done,
     /*  87944 */   // Label 1456: @87944
     /*  87944 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(87997), // Rule ID 5784 //
     /*  87949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87969 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87975 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  87975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87980 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  87986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87996 */     // GIR_Coverage, 5784,
     /*  87996 */     GIR_EraseRootFromParent_Done,
     /*  87997 */   // Label 1457: @87997
     /*  87997 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(88021), // Rule ID 6679 //
     /*  88002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  88006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88010 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  88010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  88020 */     // GIR_Coverage, 6679,
     /*  88020 */     GIR_Done,
     /*  88021 */   // Label 1458: @88021
     /*  88021 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(88045), // Rule ID 6680 //
     /*  88026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  88034 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  88034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88044 */     // GIR_Coverage, 6680,
     /*  88044 */     GIR_Done,
     /*  88045 */   // Label 1459: @88045
     /*  88045 */   GIM_Reject,
     /*  88046 */ // Label 1452: @88046
     /*  88046 */ GIM_Reject,
     /*  88047 */ // Label 1438: @88047
     /*  88047 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(88124), // Rule ID 7072 //
     /*  88052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88067 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88074 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88081 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88084 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88088 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88090 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  88097 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15891>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  88097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  88100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  88112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  88117 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88122 */   GIR_RootConstrainSelectedInstOperands,
     /*  88123 */   // GIR_Coverage, 7072,
     /*  88123 */   GIR_EraseRootFromParent_Done,
     /*  88124 */ // Label 1460: @88124
     /*  88124 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(88201), // Rule ID 7073 //
     /*  88129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88151 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88158 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88161 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88167 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  88174 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15891>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  88174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  88177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  88189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  88194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88199 */   GIR_RootConstrainSelectedInstOperands,
     /*  88200 */   // GIR_Coverage, 7073,
     /*  88200 */   GIR_EraseRootFromParent_Done,
     /*  88201 */ // Label 1461: @88201
     /*  88201 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(88273), // Rule ID 7074 //
     /*  88206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88224 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88228 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88235 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88238 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88242 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88244 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  88251 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15891>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  88251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  88254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88271 */   GIR_RootConstrainSelectedInstOperands,
     /*  88272 */   // GIR_Coverage, 7074,
     /*  88272 */   GIR_EraseRootFromParent_Done,
     /*  88273 */ // Label 1462: @88273
     /*  88273 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(88345), // Rule ID 7075 //
     /*  88278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88293 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88296 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88300 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88307 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88310 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88316 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  88323 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15891>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  88323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  88326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88343 */   GIR_RootConstrainSelectedInstOperands,
     /*  88344 */   // GIR_Coverage, 7075,
     /*  88344 */   GIR_EraseRootFromParent_Done,
     /*  88345 */ // Label 1463: @88345
     /*  88345 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(88401), // Rule ID 5786 //
     /*  88350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  88365 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88369 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88373 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  88377 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88379 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  88379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88384 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  88390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88400 */   // GIR_Coverage, 5786,
     /*  88400 */   GIR_EraseRootFromParent_Done,
     /*  88401 */ // Label 1464: @88401
     /*  88401 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(88431), // Rule ID 6654 //
     /*  88406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88420 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  88420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88430 */   // GIR_Coverage, 6654,
     /*  88430 */   GIR_Done,
     /*  88431 */ // Label 1465: @88431
     /*  88431 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(88461), // Rule ID 6655 //
     /*  88436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88450 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  88450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88460 */   // GIR_Coverage, 6655,
     /*  88460 */   GIR_Done,
     /*  88461 */ // Label 1466: @88461
     /*  88461 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(88491), // Rule ID 6656 //
     /*  88466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88480 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  88480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88490 */   // GIR_Coverage, 6656,
     /*  88490 */   GIR_Done,
     /*  88491 */ // Label 1467: @88491
     /*  88491 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(88521), // Rule ID 6657 //
     /*  88496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88510 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  88510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88520 */   // GIR_Coverage, 6657,
     /*  88520 */   GIR_Done,
     /*  88521 */ // Label 1468: @88521
     /*  88521 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(88551), // Rule ID 6658 //
     /*  88526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88540 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  88540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88550 */   // GIR_Coverage, 6658,
     /*  88550 */   GIR_Done,
     /*  88551 */ // Label 1469: @88551
     /*  88551 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(88581), // Rule ID 6659 //
     /*  88556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88570 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88580 */   // GIR_Coverage, 6659,
     /*  88580 */   GIR_Done,
     /*  88581 */ // Label 1470: @88581
     /*  88581 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(88631), // Rule ID 6665 //
     /*  88586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88600 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  88600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88612 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88629 */   GIR_RootConstrainSelectedInstOperands,
     /*  88630 */   // GIR_Coverage, 6665,
     /*  88630 */   GIR_EraseRootFromParent_Done,
     /*  88631 */ // Label 1471: @88631
     /*  88631 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(88681), // Rule ID 6666 //
     /*  88636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88650 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88662 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88679 */   GIR_RootConstrainSelectedInstOperands,
     /*  88680 */   // GIR_Coverage, 6666,
     /*  88680 */   GIR_EraseRootFromParent_Done,
     /*  88681 */ // Label 1472: @88681
     /*  88681 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(88731), // Rule ID 6667 //
     /*  88686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88700 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88712 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88729 */   GIR_RootConstrainSelectedInstOperands,
     /*  88730 */   // GIR_Coverage, 6667,
     /*  88730 */   GIR_EraseRootFromParent_Done,
     /*  88731 */ // Label 1473: @88731
     /*  88731 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(88781), // Rule ID 6668 //
     /*  88736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88750 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88762 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88766 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88779 */   GIR_RootConstrainSelectedInstOperands,
     /*  88780 */   // GIR_Coverage, 6668,
     /*  88780 */   GIR_EraseRootFromParent_Done,
     /*  88781 */ // Label 1474: @88781
     /*  88781 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(88831), // Rule ID 6669 //
     /*  88786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88800 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88812 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88816 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88829 */   GIR_RootConstrainSelectedInstOperands,
     /*  88830 */   // GIR_Coverage, 6669,
     /*  88830 */   GIR_EraseRootFromParent_Done,
     /*  88831 */ // Label 1475: @88831
     /*  88831 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(88858), // Rule ID 6670 //
     /*  88836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88847 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88852 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88857 */   // GIR_Coverage, 6670,
     /*  88857 */   GIR_Done,
     /*  88858 */ // Label 1476: @88858
     /*  88858 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(88885), // Rule ID 6671 //
     /*  88863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88874 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88884 */   // GIR_Coverage, 6671,
     /*  88884 */   GIR_Done,
     /*  88885 */ // Label 1477: @88885
     /*  88885 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(88912), // Rule ID 6672 //
     /*  88890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88901 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  88901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88906 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88911 */   // GIR_Coverage, 6672,
     /*  88911 */   GIR_Done,
     /*  88912 */ // Label 1478: @88912
     /*  88912 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(88939), // Rule ID 6681 //
     /*  88917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88928 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88938 */   // GIR_Coverage, 6681,
     /*  88938 */   GIR_Done,
     /*  88939 */ // Label 1479: @88939
     /*  88939 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(88966), // Rule ID 6682 //
     /*  88944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88955 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  88955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88960 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88965 */   // GIR_Coverage, 6682,
     /*  88965 */   GIR_Done,
     /*  88966 */ // Label 1480: @88966
     /*  88966 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(88993), // Rule ID 6683 //
     /*  88971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88982 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88992 */   // GIR_Coverage, 6683,
     /*  88992 */   GIR_Done,
     /*  88993 */ // Label 1481: @88993
     /*  88993 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(89025), // Rule ID 6684 //
     /*  88998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89012 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89015 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89024 */   // GIR_Coverage, 6684,
     /*  89024 */   GIR_EraseRootFromParent_Done,
     /*  89025 */ // Label 1482: @89025
     /*  89025 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(89057), // Rule ID 6685 //
     /*  89030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89044 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89056 */   // GIR_Coverage, 6685,
     /*  89056 */   GIR_EraseRootFromParent_Done,
     /*  89057 */ // Label 1483: @89057
     /*  89057 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(89089), // Rule ID 6686 //
     /*  89062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89076 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89079 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89081 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89088 */   // GIR_Coverage, 6686,
     /*  89088 */   GIR_EraseRootFromParent_Done,
     /*  89089 */ // Label 1484: @89089
     /*  89089 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(89121), // Rule ID 6687 //
     /*  89094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89108 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89120 */   // GIR_Coverage, 6687,
     /*  89120 */   GIR_EraseRootFromParent_Done,
     /*  89121 */ // Label 1485: @89121
     /*  89121 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(89153), // Rule ID 6688 //
     /*  89126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89140 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89143 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89145 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89152 */   // GIR_Coverage, 6688,
     /*  89152 */   GIR_EraseRootFromParent_Done,
     /*  89153 */ // Label 1486: @89153
     /*  89153 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(89179), // Rule ID 6689 //
     /*  89158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89172 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  89172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89177 */   GIR_RootConstrainSelectedInstOperands,
     /*  89178 */   // GIR_Coverage, 6689,
     /*  89178 */   GIR_Done,
     /*  89179 */ // Label 1487: @89179
     /*  89179 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(89205), // Rule ID 6690 //
     /*  89184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89198 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  89198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89203 */   GIR_RootConstrainSelectedInstOperands,
     /*  89204 */   // GIR_Coverage, 6690,
     /*  89204 */   GIR_Done,
     /*  89205 */ // Label 1488: @89205
     /*  89205 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(89231), // Rule ID 6691 //
     /*  89210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89224 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  89224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89229 */   GIR_RootConstrainSelectedInstOperands,
     /*  89230 */   // GIR_Coverage, 6691,
     /*  89230 */   GIR_Done,
     /*  89231 */ // Label 1489: @89231
     /*  89231 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(89257), // Rule ID 6692 //
     /*  89236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89250 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  89250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89255 */   GIR_RootConstrainSelectedInstOperands,
     /*  89256 */   // GIR_Coverage, 6692,
     /*  89256 */   GIR_Done,
     /*  89257 */ // Label 1490: @89257
     /*  89257 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(89283), // Rule ID 6693 //
     /*  89262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89276 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  89276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89281 */   GIR_RootConstrainSelectedInstOperands,
     /*  89282 */   // GIR_Coverage, 6693,
     /*  89282 */   GIR_Done,
     /*  89283 */ // Label 1491: @89283
     /*  89283 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(89312), // Rule ID 6694 //
     /*  89288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89299 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89302 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89304 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89306 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89311 */   // GIR_Coverage, 6694,
     /*  89311 */   GIR_EraseRootFromParent_Done,
     /*  89312 */ // Label 1492: @89312
     /*  89312 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(89341), // Rule ID 6695 //
     /*  89317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89328 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89331 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89333 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89340 */   // GIR_Coverage, 6695,
     /*  89340 */   GIR_EraseRootFromParent_Done,
     /*  89341 */ // Label 1493: @89341
     /*  89341 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(89373), // Rule ID 6749 //
     /*  89346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89360 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89363 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89372 */   // GIR_Coverage, 6749,
     /*  89372 */   GIR_EraseRootFromParent_Done,
     /*  89373 */ // Label 1494: @89373
     /*  89373 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(89405), // Rule ID 6750 //
     /*  89378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89392 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89404 */   // GIR_Coverage, 6750,
     /*  89404 */   GIR_EraseRootFromParent_Done,
     /*  89405 */ // Label 1495: @89405
     /*  89405 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(89437), // Rule ID 6751 //
     /*  89410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89424 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89436 */   // GIR_Coverage, 6751,
     /*  89436 */   GIR_EraseRootFromParent_Done,
     /*  89437 */ // Label 1496: @89437
     /*  89437 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(89469), // Rule ID 6752 //
     /*  89442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89456 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89459 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89468 */   // GIR_Coverage, 6752,
     /*  89468 */   GIR_EraseRootFromParent_Done,
     /*  89469 */ // Label 1497: @89469
     /*  89469 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(89501), // Rule ID 6753 //
     /*  89474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89488 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89491 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89493 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89500 */   // GIR_Coverage, 6753,
     /*  89500 */   GIR_EraseRootFromParent_Done,
     /*  89501 */ // Label 1498: @89501
     /*  89501 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(89527), // Rule ID 6754 //
     /*  89506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89520 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89525 */   GIR_RootConstrainSelectedInstOperands,
     /*  89526 */   // GIR_Coverage, 6754,
     /*  89526 */   GIR_Done,
     /*  89527 */ // Label 1499: @89527
     /*  89527 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(89553), // Rule ID 6755 //
     /*  89532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89546 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89551 */   GIR_RootConstrainSelectedInstOperands,
     /*  89552 */   // GIR_Coverage, 6755,
     /*  89552 */   GIR_Done,
     /*  89553 */ // Label 1500: @89553
     /*  89553 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(89579), // Rule ID 6756 //
     /*  89558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89572 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89577 */   GIR_RootConstrainSelectedInstOperands,
     /*  89578 */   // GIR_Coverage, 6756,
     /*  89578 */   GIR_Done,
     /*  89579 */ // Label 1501: @89579
     /*  89579 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(89605), // Rule ID 6757 //
     /*  89584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89598 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89603 */   GIR_RootConstrainSelectedInstOperands,
     /*  89604 */   // GIR_Coverage, 6757,
     /*  89604 */   GIR_Done,
     /*  89605 */ // Label 1502: @89605
     /*  89605 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(89631), // Rule ID 6758 //
     /*  89610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89624 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89629 */   GIR_RootConstrainSelectedInstOperands,
     /*  89630 */   // GIR_Coverage, 6758,
     /*  89630 */   GIR_Done,
     /*  89631 */ // Label 1503: @89631
     /*  89631 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(89660), // Rule ID 6759 //
     /*  89636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89647 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89650 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89652 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89654 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89659 */   // GIR_Coverage, 6759,
     /*  89659 */   GIR_EraseRootFromParent_Done,
     /*  89660 */ // Label 1504: @89660
     /*  89660 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(89689), // Rule ID 6760 //
     /*  89665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89676 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89679 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89681 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89688 */   // GIR_Coverage, 6760,
     /*  89688 */   GIR_EraseRootFromParent_Done,
     /*  89689 */ // Label 1505: @89689
     /*  89689 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(89721), // Rule ID 6761 //
     /*  89694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89708 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89711 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89713 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89720 */   // GIR_Coverage, 6761,
     /*  89720 */   GIR_EraseRootFromParent_Done,
     /*  89721 */ // Label 1506: @89721
     /*  89721 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(89753), // Rule ID 6762 //
     /*  89726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89740 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89752 */   // GIR_Coverage, 6762,
     /*  89752 */   GIR_EraseRootFromParent_Done,
     /*  89753 */ // Label 1507: @89753
     /*  89753 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(89785), // Rule ID 6763 //
     /*  89758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89772 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89775 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89777 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89784 */   // GIR_Coverage, 6763,
     /*  89784 */   GIR_EraseRootFromParent_Done,
     /*  89785 */ // Label 1508: @89785
     /*  89785 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(89817), // Rule ID 6764 //
     /*  89790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89804 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89816 */   // GIR_Coverage, 6764,
     /*  89816 */   GIR_EraseRootFromParent_Done,
     /*  89817 */ // Label 1509: @89817
     /*  89817 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(89849), // Rule ID 6765 //
     /*  89822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89836 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89848 */   // GIR_Coverage, 6765,
     /*  89848 */   GIR_EraseRootFromParent_Done,
     /*  89849 */ // Label 1510: @89849
     /*  89849 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(89875), // Rule ID 6766 //
     /*  89854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89868 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89873 */   GIR_RootConstrainSelectedInstOperands,
     /*  89874 */   // GIR_Coverage, 6766,
     /*  89874 */   GIR_Done,
     /*  89875 */ // Label 1511: @89875
     /*  89875 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(89901), // Rule ID 6767 //
     /*  89880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89894 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89894 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89899 */   GIR_RootConstrainSelectedInstOperands,
     /*  89900 */   // GIR_Coverage, 6767,
     /*  89900 */   GIR_Done,
     /*  89901 */ // Label 1512: @89901
     /*  89901 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(89927), // Rule ID 6768 //
     /*  89906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89920 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89925 */   GIR_RootConstrainSelectedInstOperands,
     /*  89926 */   // GIR_Coverage, 6768,
     /*  89926 */   GIR_Done,
     /*  89927 */ // Label 1513: @89927
     /*  89927 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(89953), // Rule ID 6769 //
     /*  89932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89946 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89951 */   GIR_RootConstrainSelectedInstOperands,
     /*  89952 */   // GIR_Coverage, 6769,
     /*  89952 */   GIR_Done,
     /*  89953 */ // Label 1514: @89953
     /*  89953 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(89979), // Rule ID 6770 //
     /*  89958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89972 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89977 */   GIR_RootConstrainSelectedInstOperands,
     /*  89978 */   // GIR_Coverage, 6770,
     /*  89978 */   GIR_Done,
     /*  89979 */ // Label 1515: @89979
     /*  89979 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(90008), // Rule ID 6771 //
     /*  89984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89995 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89998 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90000 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90002 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90007 */   // GIR_Coverage, 6771,
     /*  90007 */   GIR_EraseRootFromParent_Done,
     /*  90008 */ // Label 1516: @90008
     /*  90008 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(90037), // Rule ID 6772 //
     /*  90013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90024 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  90024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90027 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90029 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90036 */   // GIR_Coverage, 6772,
     /*  90036 */   GIR_EraseRootFromParent_Done,
     /*  90037 */ // Label 1517: @90037
     /*  90037 */ GIM_Reject,
     /*  90038 */ // Label 1439: @90038
     /*  90038 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(90070), // Rule ID 6786 //
     /*  90043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90057 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90069 */   // GIR_Coverage, 6786,
     /*  90069 */   GIR_EraseRootFromParent_Done,
     /*  90070 */ // Label 1518: @90070
     /*  90070 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(90102), // Rule ID 6787 //
     /*  90075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90089 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90101 */   // GIR_Coverage, 6787,
     /*  90101 */   GIR_EraseRootFromParent_Done,
     /*  90102 */ // Label 1519: @90102
     /*  90102 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(90134), // Rule ID 6788 //
     /*  90107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90121 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90133 */   // GIR_Coverage, 6788,
     /*  90133 */   GIR_EraseRootFromParent_Done,
     /*  90134 */ // Label 1520: @90134
     /*  90134 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(90166), // Rule ID 6789 //
     /*  90139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90153 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90165 */   // GIR_Coverage, 6789,
     /*  90165 */   GIR_EraseRootFromParent_Done,
     /*  90166 */ // Label 1521: @90166
     /*  90166 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(90198), // Rule ID 6790 //
     /*  90171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90185 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90197 */   // GIR_Coverage, 6790,
     /*  90197 */   GIR_EraseRootFromParent_Done,
     /*  90198 */ // Label 1522: @90198
     /*  90198 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(90230), // Rule ID 6791 //
     /*  90203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90217 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90229 */   // GIR_Coverage, 6791,
     /*  90229 */   GIR_EraseRootFromParent_Done,
     /*  90230 */ // Label 1523: @90230
     /*  90230 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(90262), // Rule ID 6792 //
     /*  90235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90249 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90252 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90254 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90261 */   // GIR_Coverage, 6792,
     /*  90261 */   GIR_EraseRootFromParent_Done,
     /*  90262 */ // Label 1524: @90262
     /*  90262 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(90295), // Rule ID 6793 //
     /*  90267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90281 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  90281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90286 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90288 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90293 */   GIR_RootConstrainSelectedInstOperands,
     /*  90294 */   // GIR_Coverage, 6793,
     /*  90294 */   GIR_EraseRootFromParent_Done,
     /*  90295 */ // Label 1525: @90295
     /*  90295 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(90366), // Rule ID 6794 //
     /*  90300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90314 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  90314 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90317 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90321 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90326 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90344 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90364 */   GIR_RootConstrainSelectedInstOperands,
     /*  90365 */   // GIR_Coverage, 6794,
     /*  90365 */   GIR_EraseRootFromParent_Done,
     /*  90366 */ // Label 1526: @90366
     /*  90366 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(90437), // Rule ID 6795 //
     /*  90371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90385 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  90385 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90388 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90392 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90397 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90435 */   GIR_RootConstrainSelectedInstOperands,
     /*  90436 */   // GIR_Coverage, 6795,
     /*  90436 */   GIR_EraseRootFromParent_Done,
     /*  90437 */ // Label 1527: @90437
     /*  90437 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(90508), // Rule ID 6796 //
     /*  90442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90456 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  90456 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90459 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90463 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90468 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90486 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90506 */   GIR_RootConstrainSelectedInstOperands,
     /*  90507 */   // GIR_Coverage, 6796,
     /*  90507 */   GIR_EraseRootFromParent_Done,
     /*  90508 */ // Label 1528: @90508
     /*  90508 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(90541), // Rule ID 6797 //
     /*  90513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  90527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90532 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90534 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90539 */   GIR_RootConstrainSelectedInstOperands,
     /*  90540 */   // GIR_Coverage, 6797,
     /*  90540 */   GIR_EraseRootFromParent_Done,
     /*  90541 */ // Label 1529: @90541
     /*  90541 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(90612), // Rule ID 6798 //
     /*  90546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90560 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  90560 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90563 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90567 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90572 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90590 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90610 */   GIR_RootConstrainSelectedInstOperands,
     /*  90611 */   // GIR_Coverage, 6798,
     /*  90611 */   GIR_EraseRootFromParent_Done,
     /*  90612 */ // Label 1530: @90612
     /*  90612 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(90683), // Rule ID 6799 //
     /*  90617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90631 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  90631 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90634 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90638 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90643 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90661 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90681 */   GIR_RootConstrainSelectedInstOperands,
     /*  90682 */   // GIR_Coverage, 6799,
     /*  90682 */   GIR_EraseRootFromParent_Done,
     /*  90683 */ // Label 1531: @90683
     /*  90683 */ GIM_Reject,
     /*  90684 */ // Label 1440: @90684
     /*  90684 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(90714), // Rule ID 6651 //
     /*  90689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90703 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90708 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90713 */   // GIR_Coverage, 6651,
     /*  90713 */   GIR_Done,
     /*  90714 */ // Label 1532: @90714
     /*  90714 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(90744), // Rule ID 6653 //
     /*  90719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90733 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90743 */   // GIR_Coverage, 6653,
     /*  90743 */   GIR_Done,
     /*  90744 */ // Label 1533: @90744
     /*  90744 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(90794), // Rule ID 6662 //
     /*  90749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90763 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90775 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90792 */   GIR_RootConstrainSelectedInstOperands,
     /*  90793 */   // GIR_Coverage, 6662,
     /*  90793 */   GIR_EraseRootFromParent_Done,
     /*  90794 */ // Label 1534: @90794
     /*  90794 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(90844), // Rule ID 6664 //
     /*  90799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90813 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90825 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90842 */   GIR_RootConstrainSelectedInstOperands,
     /*  90843 */   // GIR_Coverage, 6664,
     /*  90843 */   GIR_EraseRootFromParent_Done,
     /*  90844 */ // Label 1535: @90844
     /*  90844 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(90876), // Rule ID 6696 //
     /*  90849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90863 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90866 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90868 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90875 */   // GIR_Coverage, 6696,
     /*  90875 */   GIR_EraseRootFromParent_Done,
     /*  90876 */ // Label 1536: @90876
     /*  90876 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(90908), // Rule ID 6697 //
     /*  90881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90895 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90898 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90900 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90907 */   // GIR_Coverage, 6697,
     /*  90907 */   GIR_EraseRootFromParent_Done,
     /*  90908 */ // Label 1537: @90908
     /*  90908 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(90940), // Rule ID 6698 //
     /*  90913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90927 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90930 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90932 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90939 */   // GIR_Coverage, 6698,
     /*  90939 */   GIR_EraseRootFromParent_Done,
     /*  90940 */ // Label 1538: @90940
     /*  90940 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(90972), // Rule ID 6699 //
     /*  90945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90959 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90962 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90971 */   // GIR_Coverage, 6699,
     /*  90971 */   GIR_EraseRootFromParent_Done,
     /*  90972 */ // Label 1539: @90972
     /*  90972 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(91004), // Rule ID 6700 //
     /*  90977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90991 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90994 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90996 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91003 */   // GIR_Coverage, 6700,
     /*  91003 */   GIR_EraseRootFromParent_Done,
     /*  91004 */ // Label 1540: @91004
     /*  91004 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(91036), // Rule ID 6701 //
     /*  91009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91023 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  91023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91026 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91028 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91035 */   // GIR_Coverage, 6701,
     /*  91035 */   GIR_EraseRootFromParent_Done,
     /*  91036 */ // Label 1541: @91036
     /*  91036 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(91062), // Rule ID 6702 //
     /*  91041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91055 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  91055 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91060 */   GIR_RootConstrainSelectedInstOperands,
     /*  91061 */   // GIR_Coverage, 6702,
     /*  91061 */   GIR_Done,
     /*  91062 */ // Label 1542: @91062
     /*  91062 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(91088), // Rule ID 6703 //
     /*  91067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91081 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  91081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91086 */   GIR_RootConstrainSelectedInstOperands,
     /*  91087 */   // GIR_Coverage, 6703,
     /*  91087 */   GIR_Done,
     /*  91088 */ // Label 1543: @91088
     /*  91088 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(91114), // Rule ID 6704 //
     /*  91093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91107 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  91107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  91112 */   GIR_RootConstrainSelectedInstOperands,
     /*  91113 */   // GIR_Coverage, 6704,
     /*  91113 */   GIR_Done,
     /*  91114 */ // Label 1544: @91114
     /*  91114 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(91140), // Rule ID 6705 //
     /*  91119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91133 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  91133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91138 */   GIR_RootConstrainSelectedInstOperands,
     /*  91139 */   // GIR_Coverage, 6705,
     /*  91139 */   GIR_Done,
     /*  91140 */ // Label 1545: @91140
     /*  91140 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(91166), // Rule ID 6706 //
     /*  91145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91159 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  91159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91164 */   GIR_RootConstrainSelectedInstOperands,
     /*  91165 */   // GIR_Coverage, 6706,
     /*  91165 */   GIR_Done,
     /*  91166 */ // Label 1546: @91166
     /*  91166 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(91192), // Rule ID 6707 //
     /*  91171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91185 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  91185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91190 */   GIR_RootConstrainSelectedInstOperands,
     /*  91191 */   // GIR_Coverage, 6707,
     /*  91191 */   GIR_Done,
     /*  91192 */ // Label 1547: @91192
     /*  91192 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(91221), // Rule ID 6708 //
     /*  91197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91208 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  91208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91211 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91213 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91215 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91220 */   // GIR_Coverage, 6708,
     /*  91220 */   GIR_EraseRootFromParent_Done,
     /*  91221 */ // Label 1548: @91221
     /*  91221 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(91253), // Rule ID 6773 //
     /*  91226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91240 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91243 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91245 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91247 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91252 */   // GIR_Coverage, 6773,
     /*  91252 */   GIR_EraseRootFromParent_Done,
     /*  91253 */ // Label 1549: @91253
     /*  91253 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(91285), // Rule ID 6774 //
     /*  91258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91272 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91275 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91277 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91284 */   // GIR_Coverage, 6774,
     /*  91284 */   GIR_EraseRootFromParent_Done,
     /*  91285 */ // Label 1550: @91285
     /*  91285 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(91317), // Rule ID 6775 //
     /*  91290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91304 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91307 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91309 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91311 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91316 */   // GIR_Coverage, 6775,
     /*  91316 */   GIR_EraseRootFromParent_Done,
     /*  91317 */ // Label 1551: @91317
     /*  91317 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(91349), // Rule ID 6776 //
     /*  91322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91336 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91339 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91341 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91348 */   // GIR_Coverage, 6776,
     /*  91348 */   GIR_EraseRootFromParent_Done,
     /*  91349 */ // Label 1552: @91349
     /*  91349 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(91381), // Rule ID 6777 //
     /*  91354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91368 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91371 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91373 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91380 */   // GIR_Coverage, 6777,
     /*  91380 */   GIR_EraseRootFromParent_Done,
     /*  91381 */ // Label 1553: @91381
     /*  91381 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(91413), // Rule ID 6778 //
     /*  91386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91400 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91403 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91405 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91407 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91412 */   // GIR_Coverage, 6778,
     /*  91412 */   GIR_EraseRootFromParent_Done,
     /*  91413 */ // Label 1554: @91413
     /*  91413 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(91439), // Rule ID 6779 //
     /*  91418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91432 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  91432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91437 */   GIR_RootConstrainSelectedInstOperands,
     /*  91438 */   // GIR_Coverage, 6779,
     /*  91438 */   GIR_Done,
     /*  91439 */ // Label 1555: @91439
     /*  91439 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(91465), // Rule ID 6780 //
     /*  91444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91458 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  91458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91463 */   GIR_RootConstrainSelectedInstOperands,
     /*  91464 */   // GIR_Coverage, 6780,
     /*  91464 */   GIR_Done,
     /*  91465 */ // Label 1556: @91465
     /*  91465 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(91491), // Rule ID 6781 //
     /*  91470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91484 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  91484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  91489 */   GIR_RootConstrainSelectedInstOperands,
     /*  91490 */   // GIR_Coverage, 6781,
     /*  91490 */   GIR_Done,
     /*  91491 */ // Label 1557: @91491
     /*  91491 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(91517), // Rule ID 6782 //
     /*  91496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91510 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  91510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91515 */   GIR_RootConstrainSelectedInstOperands,
     /*  91516 */   // GIR_Coverage, 6782,
     /*  91516 */   GIR_Done,
     /*  91517 */ // Label 1558: @91517
     /*  91517 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(91543), // Rule ID 6783 //
     /*  91522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91536 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  91536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91541 */   GIR_RootConstrainSelectedInstOperands,
     /*  91542 */   // GIR_Coverage, 6783,
     /*  91542 */   GIR_Done,
     /*  91543 */ // Label 1559: @91543
     /*  91543 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(91569), // Rule ID 6784 //
     /*  91548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91562 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  91562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91567 */   GIR_RootConstrainSelectedInstOperands,
     /*  91568 */   // GIR_Coverage, 6784,
     /*  91568 */   GIR_Done,
     /*  91569 */ // Label 1560: @91569
     /*  91569 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(91598), // Rule ID 6785 //
     /*  91574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91585 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91588 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91590 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91597 */   // GIR_Coverage, 6785,
     /*  91597 */   GIR_EraseRootFromParent_Done,
     /*  91598 */ // Label 1561: @91598
     /*  91598 */ GIM_Reject,
     /*  91599 */ // Label 1441: @91599
     /*  91599 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(91631), // Rule ID 6800 //
     /*  91604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91618 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91621 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91623 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91630 */   // GIR_Coverage, 6800,
     /*  91630 */   GIR_EraseRootFromParent_Done,
     /*  91631 */ // Label 1562: @91631
     /*  91631 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(91663), // Rule ID 6801 //
     /*  91636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91650 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91653 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91655 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91662 */   // GIR_Coverage, 6801,
     /*  91662 */   GIR_EraseRootFromParent_Done,
     /*  91663 */ // Label 1563: @91663
     /*  91663 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(91695), // Rule ID 6802 //
     /*  91668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91682 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91685 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91687 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91694 */   // GIR_Coverage, 6802,
     /*  91694 */   GIR_EraseRootFromParent_Done,
     /*  91695 */ // Label 1564: @91695
     /*  91695 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(91727), // Rule ID 6803 //
     /*  91700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91714 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91717 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91719 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91726 */   // GIR_Coverage, 6803,
     /*  91726 */   GIR_EraseRootFromParent_Done,
     /*  91727 */ // Label 1565: @91727
     /*  91727 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(91759), // Rule ID 6804 //
     /*  91732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91746 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91749 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91751 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91753 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91758 */   // GIR_Coverage, 6804,
     /*  91758 */   GIR_EraseRootFromParent_Done,
     /*  91759 */ // Label 1566: @91759
     /*  91759 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(91791), // Rule ID 6805 //
     /*  91764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91778 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91781 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91783 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91790 */   // GIR_Coverage, 6805,
     /*  91790 */   GIR_EraseRootFromParent_Done,
     /*  91791 */ // Label 1567: @91791
     /*  91791 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(91824), // Rule ID 6806 //
     /*  91796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91810 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91815 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91822 */   GIR_RootConstrainSelectedInstOperands,
     /*  91823 */   // GIR_Coverage, 6806,
     /*  91823 */   GIR_EraseRootFromParent_Done,
     /*  91824 */ // Label 1568: @91824
     /*  91824 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(91850), // Rule ID 6807 //
     /*  91829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91843 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  91843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91848 */   GIR_RootConstrainSelectedInstOperands,
     /*  91849 */   // GIR_Coverage, 6807,
     /*  91849 */   GIR_Done,
     /*  91850 */ // Label 1569: @91850
     /*  91850 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(91876), // Rule ID 6808 //
     /*  91855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91869 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  91869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91874 */   GIR_RootConstrainSelectedInstOperands,
     /*  91875 */   // GIR_Coverage, 6808,
     /*  91875 */   GIR_Done,
     /*  91876 */ // Label 1570: @91876
     /*  91876 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(91902), // Rule ID 6809 //
     /*  91881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91895 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  91895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91900 */   GIR_RootConstrainSelectedInstOperands,
     /*  91901 */   // GIR_Coverage, 6809,
     /*  91901 */   GIR_Done,
     /*  91902 */ // Label 1571: @91902
     /*  91902 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(91928), // Rule ID 6810 //
     /*  91907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91921 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  91921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91926 */   GIR_RootConstrainSelectedInstOperands,
     /*  91927 */   // GIR_Coverage, 6810,
     /*  91927 */   GIR_Done,
     /*  91928 */ // Label 1572: @91928
     /*  91928 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(91954), // Rule ID 6811 //
     /*  91933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91947 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  91947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91952 */   GIR_RootConstrainSelectedInstOperands,
     /*  91953 */   // GIR_Coverage, 6811,
     /*  91953 */   GIR_Done,
     /*  91954 */ // Label 1573: @91954
     /*  91954 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(91983), // Rule ID 6812 //
     /*  91959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91970 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91973 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91975 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91982 */   // GIR_Coverage, 6812,
     /*  91982 */   GIR_EraseRootFromParent_Done,
     /*  91983 */ // Label 1574: @91983
     /*  91983 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(92015), // Rule ID 6826 //
     /*  91988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92002 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92005 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92007 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92014 */   // GIR_Coverage, 6826,
     /*  92014 */   GIR_EraseRootFromParent_Done,
     /*  92015 */ // Label 1575: @92015
     /*  92015 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(92047), // Rule ID 6827 //
     /*  92020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92034 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92046 */   // GIR_Coverage, 6827,
     /*  92046 */   GIR_EraseRootFromParent_Done,
     /*  92047 */ // Label 1576: @92047
     /*  92047 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(92079), // Rule ID 6828 //
     /*  92052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92066 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92069 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92078 */   // GIR_Coverage, 6828,
     /*  92078 */   GIR_EraseRootFromParent_Done,
     /*  92079 */ // Label 1577: @92079
     /*  92079 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(92111), // Rule ID 6829 //
     /*  92084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92098 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92110 */   // GIR_Coverage, 6829,
     /*  92110 */   GIR_EraseRootFromParent_Done,
     /*  92111 */ // Label 1578: @92111
     /*  92111 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(92143), // Rule ID 6830 //
     /*  92116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92130 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92133 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92142 */   // GIR_Coverage, 6830,
     /*  92142 */   GIR_EraseRootFromParent_Done,
     /*  92143 */ // Label 1579: @92143
     /*  92143 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(92175), // Rule ID 6831 //
     /*  92148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92162 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92174 */   // GIR_Coverage, 6831,
     /*  92174 */   GIR_EraseRootFromParent_Done,
     /*  92175 */ // Label 1580: @92175
     /*  92175 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(92208), // Rule ID 6832 //
     /*  92180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92194 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  92194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  92197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92199 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  92206 */   GIR_RootConstrainSelectedInstOperands,
     /*  92207 */   // GIR_Coverage, 6832,
     /*  92207 */   GIR_EraseRootFromParent_Done,
     /*  92208 */ // Label 1581: @92208
     /*  92208 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(92234), // Rule ID 6833 //
     /*  92213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92227 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  92227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92232 */   GIR_RootConstrainSelectedInstOperands,
     /*  92233 */   // GIR_Coverage, 6833,
     /*  92233 */   GIR_Done,
     /*  92234 */ // Label 1582: @92234
     /*  92234 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(92260), // Rule ID 6834 //
     /*  92239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92253 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  92253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  92258 */   GIR_RootConstrainSelectedInstOperands,
     /*  92259 */   // GIR_Coverage, 6834,
     /*  92259 */   GIR_Done,
     /*  92260 */ // Label 1583: @92260
     /*  92260 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(92286), // Rule ID 6835 //
     /*  92265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92279 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  92279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  92284 */   GIR_RootConstrainSelectedInstOperands,
     /*  92285 */   // GIR_Coverage, 6835,
     /*  92285 */   GIR_Done,
     /*  92286 */ // Label 1584: @92286
     /*  92286 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(92312), // Rule ID 6836 //
     /*  92291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92305 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  92305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92310 */   GIR_RootConstrainSelectedInstOperands,
     /*  92311 */   // GIR_Coverage, 6836,
     /*  92311 */   GIR_Done,
     /*  92312 */ // Label 1585: @92312
     /*  92312 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(92338), // Rule ID 6837 //
     /*  92317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92331 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  92331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  92336 */   GIR_RootConstrainSelectedInstOperands,
     /*  92337 */   // GIR_Coverage, 6837,
     /*  92337 */   GIR_Done,
     /*  92338 */ // Label 1586: @92338
     /*  92338 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(92367), // Rule ID 6838 //
     /*  92343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92354 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92366 */   // GIR_Coverage, 6838,
     /*  92366 */   GIR_EraseRootFromParent_Done,
     /*  92367 */ // Label 1587: @92367
     /*  92367 */ GIM_Reject,
     /*  92368 */ // Label 1442: @92368
     /*  92368 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(92398), // Rule ID 6650 //
     /*  92373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92387 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92397 */   // GIR_Coverage, 6650,
     /*  92397 */   GIR_Done,
     /*  92398 */ // Label 1588: @92398
     /*  92398 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(92428), // Rule ID 6652 //
     /*  92403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92417 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92427 */   // GIR_Coverage, 6652,
     /*  92427 */   GIR_Done,
     /*  92428 */ // Label 1589: @92428
     /*  92428 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(92478), // Rule ID 6661 //
     /*  92433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92447 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92459 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92476 */   GIR_RootConstrainSelectedInstOperands,
     /*  92477 */   // GIR_Coverage, 6661,
     /*  92477 */   GIR_EraseRootFromParent_Done,
     /*  92478 */ // Label 1590: @92478
     /*  92478 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(92528), // Rule ID 6663 //
     /*  92483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92497 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92526 */   GIR_RootConstrainSelectedInstOperands,
     /*  92527 */   // GIR_Coverage, 6663,
     /*  92527 */   GIR_EraseRootFromParent_Done,
     /*  92528 */ // Label 1591: @92528
     /*  92528 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(92560), // Rule ID 6709 //
     /*  92533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92547 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92550 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92552 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92559 */   // GIR_Coverage, 6709,
     /*  92559 */   GIR_EraseRootFromParent_Done,
     /*  92560 */ // Label 1592: @92560
     /*  92560 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(92592), // Rule ID 6710 //
     /*  92565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92579 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92582 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92584 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92586 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92591 */   // GIR_Coverage, 6710,
     /*  92591 */   GIR_EraseRootFromParent_Done,
     /*  92592 */ // Label 1593: @92592
     /*  92592 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(92624), // Rule ID 6711 //
     /*  92597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92611 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92614 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92616 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92623 */   // GIR_Coverage, 6711,
     /*  92623 */   GIR_EraseRootFromParent_Done,
     /*  92624 */ // Label 1594: @92624
     /*  92624 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(92656), // Rule ID 6712 //
     /*  92629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92643 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92655 */   // GIR_Coverage, 6712,
     /*  92655 */   GIR_EraseRootFromParent_Done,
     /*  92656 */ // Label 1595: @92656
     /*  92656 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(92688), // Rule ID 6713 //
     /*  92661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92675 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92687 */   // GIR_Coverage, 6713,
     /*  92687 */   GIR_EraseRootFromParent_Done,
     /*  92688 */ // Label 1596: @92688
     /*  92688 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(92720), // Rule ID 6714 //
     /*  92693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92707 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92719 */   // GIR_Coverage, 6714,
     /*  92719 */   GIR_EraseRootFromParent_Done,
     /*  92720 */ // Label 1597: @92720
     /*  92720 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(92746), // Rule ID 6715 //
     /*  92725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92739 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  92739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92744 */   GIR_RootConstrainSelectedInstOperands,
     /*  92745 */   // GIR_Coverage, 6715,
     /*  92745 */   GIR_Done,
     /*  92746 */ // Label 1598: @92746
     /*  92746 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(92772), // Rule ID 6716 //
     /*  92751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92765 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  92765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92770 */   GIR_RootConstrainSelectedInstOperands,
     /*  92771 */   // GIR_Coverage, 6716,
     /*  92771 */   GIR_Done,
     /*  92772 */ // Label 1599: @92772
     /*  92772 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(92798), // Rule ID 6717 //
     /*  92777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92791 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  92791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92796 */   GIR_RootConstrainSelectedInstOperands,
     /*  92797 */   // GIR_Coverage, 6717,
     /*  92797 */   GIR_Done,
     /*  92798 */ // Label 1600: @92798
     /*  92798 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(92824), // Rule ID 6718 //
     /*  92803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92817 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  92817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92822 */   GIR_RootConstrainSelectedInstOperands,
     /*  92823 */   // GIR_Coverage, 6718,
     /*  92823 */   GIR_Done,
     /*  92824 */ // Label 1601: @92824
     /*  92824 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(92850), // Rule ID 6719 //
     /*  92829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92843 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  92843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92848 */   GIR_RootConstrainSelectedInstOperands,
     /*  92849 */   // GIR_Coverage, 6719,
     /*  92849 */   GIR_Done,
     /*  92850 */ // Label 1602: @92850
     /*  92850 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(92876), // Rule ID 6720 //
     /*  92855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92869 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  92869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92874 */   GIR_RootConstrainSelectedInstOperands,
     /*  92875 */   // GIR_Coverage, 6720,
     /*  92875 */   GIR_Done,
     /*  92876 */ // Label 1603: @92876
     /*  92876 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(92905), // Rule ID 6721 //
     /*  92881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92892 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92895 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92897 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92904 */   // GIR_Coverage, 6721,
     /*  92904 */   GIR_EraseRootFromParent_Done,
     /*  92905 */ // Label 1604: @92905
     /*  92905 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(92937), // Rule ID 6722 //
     /*  92910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92924 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92936 */   // GIR_Coverage, 6722,
     /*  92936 */   GIR_EraseRootFromParent_Done,
     /*  92937 */ // Label 1605: @92937
     /*  92937 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(92969), // Rule ID 6723 //
     /*  92942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92956 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92968 */   // GIR_Coverage, 6723,
     /*  92968 */   GIR_EraseRootFromParent_Done,
     /*  92969 */ // Label 1606: @92969
     /*  92969 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(93001), // Rule ID 6724 //
     /*  92974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92988 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93000 */   // GIR_Coverage, 6724,
     /*  93000 */   GIR_EraseRootFromParent_Done,
     /*  93001 */ // Label 1607: @93001
     /*  93001 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(93033), // Rule ID 6725 //
     /*  93006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93020 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93032 */   // GIR_Coverage, 6725,
     /*  93032 */   GIR_EraseRootFromParent_Done,
     /*  93033 */ // Label 1608: @93033
     /*  93033 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(93065), // Rule ID 6726 //
     /*  93038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93052 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93064 */   // GIR_Coverage, 6726,
     /*  93064 */   GIR_EraseRootFromParent_Done,
     /*  93065 */ // Label 1609: @93065
     /*  93065 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(93097), // Rule ID 6727 //
     /*  93070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93084 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93096 */   // GIR_Coverage, 6727,
     /*  93096 */   GIR_EraseRootFromParent_Done,
     /*  93097 */ // Label 1610: @93097
     /*  93097 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(93123), // Rule ID 6728 //
     /*  93102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93116 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  93116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93121 */   GIR_RootConstrainSelectedInstOperands,
     /*  93122 */   // GIR_Coverage, 6728,
     /*  93122 */   GIR_Done,
     /*  93123 */ // Label 1611: @93123
     /*  93123 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(93149), // Rule ID 6729 //
     /*  93128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93142 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  93142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  93147 */   GIR_RootConstrainSelectedInstOperands,
     /*  93148 */   // GIR_Coverage, 6729,
     /*  93148 */   GIR_Done,
     /*  93149 */ // Label 1612: @93149
     /*  93149 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(93175), // Rule ID 6730 //
     /*  93154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  93160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93168 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  93168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93173 */   GIR_RootConstrainSelectedInstOperands,
     /*  93174 */   // GIR_Coverage, 6730,
     /*  93174 */   GIR_Done,
     /*  93175 */ // Label 1613: @93175
     /*  93175 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(93201), // Rule ID 6731 //
     /*  93180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93194 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  93194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93199 */   GIR_RootConstrainSelectedInstOperands,
     /*  93200 */   // GIR_Coverage, 6731,
     /*  93200 */   GIR_Done,
     /*  93201 */ // Label 1614: @93201
     /*  93201 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(93227), // Rule ID 6732 //
     /*  93206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93220 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  93220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  93225 */   GIR_RootConstrainSelectedInstOperands,
     /*  93226 */   // GIR_Coverage, 6732,
     /*  93226 */   GIR_Done,
     /*  93227 */ // Label 1615: @93227
     /*  93227 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(93253), // Rule ID 6733 //
     /*  93232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93246 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  93246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93251 */   GIR_RootConstrainSelectedInstOperands,
     /*  93252 */   // GIR_Coverage, 6733,
     /*  93252 */   GIR_Done,
     /*  93253 */ // Label 1616: @93253
     /*  93253 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(93282), // Rule ID 6734 //
     /*  93258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93269 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93272 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93274 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93281 */   // GIR_Coverage, 6734,
     /*  93281 */   GIR_EraseRootFromParent_Done,
     /*  93282 */ // Label 1617: @93282
     /*  93282 */ GIM_Reject,
     /*  93283 */ // Label 1443: @93283
     /*  93283 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(93315), // Rule ID 6813 //
     /*  93288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93302 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93305 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93307 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93314 */   // GIR_Coverage, 6813,
     /*  93314 */   GIR_EraseRootFromParent_Done,
     /*  93315 */ // Label 1618: @93315
     /*  93315 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(93347), // Rule ID 6814 //
     /*  93320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93334 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93337 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93339 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93346 */   // GIR_Coverage, 6814,
     /*  93346 */   GIR_EraseRootFromParent_Done,
     /*  93347 */ // Label 1619: @93347
     /*  93347 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(93379), // Rule ID 6815 //
     /*  93352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93366 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93369 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93378 */   // GIR_Coverage, 6815,
     /*  93378 */   GIR_EraseRootFromParent_Done,
     /*  93379 */ // Label 1620: @93379
     /*  93379 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(93411), // Rule ID 6816 //
     /*  93384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93398 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93401 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93403 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93410 */   // GIR_Coverage, 6816,
     /*  93410 */   GIR_EraseRootFromParent_Done,
     /*  93411 */ // Label 1621: @93411
     /*  93411 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(93443), // Rule ID 6817 //
     /*  93416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93430 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93433 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93442 */   // GIR_Coverage, 6817,
     /*  93442 */   GIR_EraseRootFromParent_Done,
     /*  93443 */ // Label 1622: @93443
     /*  93443 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(93475), // Rule ID 6818 //
     /*  93448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93462 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93465 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93474 */   // GIR_Coverage, 6818,
     /*  93474 */   GIR_EraseRootFromParent_Done,
     /*  93475 */ // Label 1623: @93475
     /*  93475 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(93546), // Rule ID 6819 //
     /*  93480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93494 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93494 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93497 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93501 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93506 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93524 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93544 */   GIR_RootConstrainSelectedInstOperands,
     /*  93545 */   // GIR_Coverage, 6819,
     /*  93545 */   GIR_EraseRootFromParent_Done,
     /*  93546 */ // Label 1624: @93546
     /*  93546 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(93572), // Rule ID 6820 //
     /*  93551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93565 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  93565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93570 */   GIR_RootConstrainSelectedInstOperands,
     /*  93571 */   // GIR_Coverage, 6820,
     /*  93571 */   GIR_Done,
     /*  93572 */ // Label 1625: @93572
     /*  93572 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(93598), // Rule ID 6821 //
     /*  93577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93591 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  93591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93596 */   GIR_RootConstrainSelectedInstOperands,
     /*  93597 */   // GIR_Coverage, 6821,
     /*  93597 */   GIR_Done,
     /*  93598 */ // Label 1626: @93598
     /*  93598 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(93624), // Rule ID 6822 //
     /*  93603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93617 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  93617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  93622 */   GIR_RootConstrainSelectedInstOperands,
     /*  93623 */   // GIR_Coverage, 6822,
     /*  93623 */   GIR_Done,
     /*  93624 */ // Label 1627: @93624
     /*  93624 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(93650), // Rule ID 6823 //
     /*  93629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93643 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  93643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93648 */   GIR_RootConstrainSelectedInstOperands,
     /*  93649 */   // GIR_Coverage, 6823,
     /*  93649 */   GIR_Done,
     /*  93650 */ // Label 1628: @93650
     /*  93650 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(93676), // Rule ID 6824 //
     /*  93655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93669 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  93669 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93674 */   GIR_RootConstrainSelectedInstOperands,
     /*  93675 */   // GIR_Coverage, 6824,
     /*  93675 */   GIR_Done,
     /*  93676 */ // Label 1629: @93676
     /*  93676 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(93705), // Rule ID 6825 //
     /*  93681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93692 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93695 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93697 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93704 */   // GIR_Coverage, 6825,
     /*  93704 */   GIR_EraseRootFromParent_Done,
     /*  93705 */ // Label 1630: @93705
     /*  93705 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(93737), // Rule ID 6839 //
     /*  93710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93724 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93727 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93729 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93731 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93736 */   // GIR_Coverage, 6839,
     /*  93736 */   GIR_EraseRootFromParent_Done,
     /*  93737 */ // Label 1631: @93737
     /*  93737 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(93769), // Rule ID 6840 //
     /*  93742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93756 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93759 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93763 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93768 */   // GIR_Coverage, 6840,
     /*  93768 */   GIR_EraseRootFromParent_Done,
     /*  93769 */ // Label 1632: @93769
     /*  93769 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(93801), // Rule ID 6841 //
     /*  93774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93788 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93791 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93793 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93795 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93800 */   // GIR_Coverage, 6841,
     /*  93800 */   GIR_EraseRootFromParent_Done,
     /*  93801 */ // Label 1633: @93801
     /*  93801 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(93833), // Rule ID 6842 //
     /*  93806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93820 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93823 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93825 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93832 */   // GIR_Coverage, 6842,
     /*  93832 */   GIR_EraseRootFromParent_Done,
     /*  93833 */ // Label 1634: @93833
     /*  93833 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(93865), // Rule ID 6843 //
     /*  93838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93852 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93855 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93857 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93864 */   // GIR_Coverage, 6843,
     /*  93864 */   GIR_EraseRootFromParent_Done,
     /*  93865 */ // Label 1635: @93865
     /*  93865 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(93897), // Rule ID 6844 //
     /*  93870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93884 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93887 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93889 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93891 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93896 */   // GIR_Coverage, 6844,
     /*  93896 */   GIR_EraseRootFromParent_Done,
     /*  93897 */ // Label 1636: @93897
     /*  93897 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(93968), // Rule ID 6845 //
     /*  93902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93916 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93916 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93919 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93923 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93928 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93946 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93966 */   GIR_RootConstrainSelectedInstOperands,
     /*  93967 */   // GIR_Coverage, 6845,
     /*  93967 */   GIR_EraseRootFromParent_Done,
     /*  93968 */ // Label 1637: @93968
     /*  93968 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(93994), // Rule ID 6846 //
     /*  93973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93987 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  93987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93992 */   GIR_RootConstrainSelectedInstOperands,
     /*  93993 */   // GIR_Coverage, 6846,
     /*  93993 */   GIR_Done,
     /*  93994 */ // Label 1638: @93994
     /*  93994 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(94020), // Rule ID 6847 //
     /*  93999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94013 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  94013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94018 */   GIR_RootConstrainSelectedInstOperands,
     /*  94019 */   // GIR_Coverage, 6847,
     /*  94019 */   GIR_Done,
     /*  94020 */ // Label 1639: @94020
     /*  94020 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(94046), // Rule ID 6848 //
     /*  94025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94039 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  94039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  94044 */   GIR_RootConstrainSelectedInstOperands,
     /*  94045 */   // GIR_Coverage, 6848,
     /*  94045 */   GIR_Done,
     /*  94046 */ // Label 1640: @94046
     /*  94046 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(94072), // Rule ID 6849 //
     /*  94051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94065 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  94065 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  94070 */   GIR_RootConstrainSelectedInstOperands,
     /*  94071 */   // GIR_Coverage, 6849,
     /*  94071 */   GIR_Done,
     /*  94072 */ // Label 1641: @94072
     /*  94072 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(94098), // Rule ID 6850 //
     /*  94077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94091 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  94091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94096 */   GIR_RootConstrainSelectedInstOperands,
     /*  94097 */   // GIR_Coverage, 6850,
     /*  94097 */   GIR_Done,
     /*  94098 */ // Label 1642: @94098
     /*  94098 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(94127), // Rule ID 6851 //
     /*  94103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94114 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  94114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94117 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94126 */   // GIR_Coverage, 6851,
     /*  94126 */   GIR_EraseRootFromParent_Done,
     /*  94127 */ // Label 1643: @94127
     /*  94127 */ GIM_Reject,
     /*  94128 */ // Label 1444: @94128
     /*  94128 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(94202), // Rule ID 5668 //
     /*  94133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94140 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  94148 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  94152 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94159 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  94159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  94166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94171 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  94175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  94180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  94191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94201 */   // GIR_Coverage, 5668,
     /*  94201 */   GIR_EraseRootFromParent_Done,
     /*  94202 */ // Label 1644: @94202
     /*  94202 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(94232), // Rule ID 6649 //
     /*  94207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94221 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  94221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94226 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94231 */   // GIR_Coverage, 6649,
     /*  94231 */   GIR_Done,
     /*  94232 */ // Label 1645: @94232
     /*  94232 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(94282), // Rule ID 6660 //
     /*  94237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94251 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  94251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94263 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  94267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94280 */   GIR_RootConstrainSelectedInstOperands,
     /*  94281 */   // GIR_Coverage, 6660,
     /*  94281 */   GIR_EraseRootFromParent_Done,
     /*  94282 */ // Label 1646: @94282
     /*  94282 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(94314), // Rule ID 6735 //
     /*  94287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94301 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94304 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94313 */   // GIR_Coverage, 6735,
     /*  94313 */   GIR_EraseRootFromParent_Done,
     /*  94314 */ // Label 1647: @94314
     /*  94314 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(94346), // Rule ID 6736 //
     /*  94319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94333 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94336 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94338 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94340 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94345 */   // GIR_Coverage, 6736,
     /*  94345 */   GIR_EraseRootFromParent_Done,
     /*  94346 */ // Label 1648: @94346
     /*  94346 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(94378), // Rule ID 6737 //
     /*  94351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94365 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94368 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94370 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94372 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94377 */   // GIR_Coverage, 6737,
     /*  94377 */   GIR_EraseRootFromParent_Done,
     /*  94378 */ // Label 1649: @94378
     /*  94378 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(94410), // Rule ID 6738 //
     /*  94383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94397 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94400 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94402 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94404 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94409 */   // GIR_Coverage, 6738,
     /*  94409 */   GIR_EraseRootFromParent_Done,
     /*  94410 */ // Label 1650: @94410
     /*  94410 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(94442), // Rule ID 6739 //
     /*  94415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94429 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94432 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94434 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94436 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94441 */   // GIR_Coverage, 6739,
     /*  94441 */   GIR_EraseRootFromParent_Done,
     /*  94442 */ // Label 1651: @94442
     /*  94442 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(94474), // Rule ID 6740 //
     /*  94447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94461 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94464 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94466 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94473 */   // GIR_Coverage, 6740,
     /*  94473 */   GIR_EraseRootFromParent_Done,
     /*  94474 */ // Label 1652: @94474
     /*  94474 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(94506), // Rule ID 6741 //
     /*  94479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94493 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94496 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94500 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94505 */   // GIR_Coverage, 6741,
     /*  94505 */   GIR_EraseRootFromParent_Done,
     /*  94506 */ // Label 1653: @94506
     /*  94506 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(94532), // Rule ID 6742 //
     /*  94511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94525 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  94525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94530 */   GIR_RootConstrainSelectedInstOperands,
     /*  94531 */   // GIR_Coverage, 6742,
     /*  94531 */   GIR_Done,
     /*  94532 */ // Label 1654: @94532
     /*  94532 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(94558), // Rule ID 6743 //
     /*  94537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94551 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  94551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  94556 */   GIR_RootConstrainSelectedInstOperands,
     /*  94557 */   // GIR_Coverage, 6743,
     /*  94557 */   GIR_Done,
     /*  94558 */ // Label 1655: @94558
     /*  94558 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(94584), // Rule ID 6744 //
     /*  94563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94577 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  94577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  94582 */   GIR_RootConstrainSelectedInstOperands,
     /*  94583 */   // GIR_Coverage, 6744,
     /*  94583 */   GIR_Done,
     /*  94584 */ // Label 1656: @94584
     /*  94584 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(94610), // Rule ID 6745 //
     /*  94589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94603 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  94603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94608 */   GIR_RootConstrainSelectedInstOperands,
     /*  94609 */   // GIR_Coverage, 6745,
     /*  94609 */   GIR_Done,
     /*  94610 */ // Label 1657: @94610
     /*  94610 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(94636), // Rule ID 6746 //
     /*  94615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94629 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  94629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  94634 */   GIR_RootConstrainSelectedInstOperands,
     /*  94635 */   // GIR_Coverage, 6746,
     /*  94635 */   GIR_Done,
     /*  94636 */ // Label 1658: @94636
     /*  94636 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(94662), // Rule ID 6747 //
     /*  94641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94655 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  94655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94660 */   GIR_RootConstrainSelectedInstOperands,
     /*  94661 */   // GIR_Coverage, 6747,
     /*  94661 */   GIR_Done,
     /*  94662 */ // Label 1659: @94662
     /*  94662 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(94688), // Rule ID 6748 //
     /*  94667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94681 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  94681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  94686 */   GIR_RootConstrainSelectedInstOperands,
     /*  94687 */   // GIR_Coverage, 6748,
     /*  94687 */   GIR_Done,
     /*  94688 */ // Label 1660: @94688
     /*  94688 */ GIM_Reject,
     /*  94689 */ // Label 1445: @94689
     /*  94689 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(94721), // Rule ID 6852 //
     /*  94694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94708 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94711 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94713 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94720 */   // GIR_Coverage, 6852,
     /*  94720 */   GIR_EraseRootFromParent_Done,
     /*  94721 */ // Label 1661: @94721
     /*  94721 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(94753), // Rule ID 6853 //
     /*  94726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94740 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94752 */   // GIR_Coverage, 6853,
     /*  94752 */   GIR_EraseRootFromParent_Done,
     /*  94753 */ // Label 1662: @94753
     /*  94753 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(94785), // Rule ID 6854 //
     /*  94758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94772 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94775 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94777 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94784 */   // GIR_Coverage, 6854,
     /*  94784 */   GIR_EraseRootFromParent_Done,
     /*  94785 */ // Label 1663: @94785
     /*  94785 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(94817), // Rule ID 6855 //
     /*  94790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94804 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94816 */   // GIR_Coverage, 6855,
     /*  94816 */   GIR_EraseRootFromParent_Done,
     /*  94817 */ // Label 1664: @94817
     /*  94817 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(94849), // Rule ID 6856 //
     /*  94822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94836 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94848 */   // GIR_Coverage, 6856,
     /*  94848 */   GIR_EraseRootFromParent_Done,
     /*  94849 */ // Label 1665: @94849
     /*  94849 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(94881), // Rule ID 6857 //
     /*  94854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94868 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94880 */   // GIR_Coverage, 6857,
     /*  94880 */   GIR_EraseRootFromParent_Done,
     /*  94881 */ // Label 1666: @94881
     /*  94881 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(94952), // Rule ID 6858 //
     /*  94886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94900 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94912 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94930 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94950 */   GIR_RootConstrainSelectedInstOperands,
     /*  94951 */   // GIR_Coverage, 6858,
     /*  94951 */   GIR_EraseRootFromParent_Done,
     /*  94952 */ // Label 1667: @94952
     /*  94952 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(94978), // Rule ID 6859 //
     /*  94957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94971 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  94971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94976 */   GIR_RootConstrainSelectedInstOperands,
     /*  94977 */   // GIR_Coverage, 6859,
     /*  94977 */   GIR_Done,
     /*  94978 */ // Label 1668: @94978
     /*  94978 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(95004), // Rule ID 6860 //
     /*  94983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94997 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  94997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95002 */   GIR_RootConstrainSelectedInstOperands,
     /*  95003 */   // GIR_Coverage, 6860,
     /*  95003 */   GIR_Done,
     /*  95004 */ // Label 1669: @95004
     /*  95004 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(95030), // Rule ID 6861 //
     /*  95009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95023 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  95023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95028 */   GIR_RootConstrainSelectedInstOperands,
     /*  95029 */   // GIR_Coverage, 6861,
     /*  95029 */   GIR_Done,
     /*  95030 */ // Label 1670: @95030
     /*  95030 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(95056), // Rule ID 6862 //
     /*  95035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95049 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  95049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95054 */   GIR_RootConstrainSelectedInstOperands,
     /*  95055 */   // GIR_Coverage, 6862,
     /*  95055 */   GIR_Done,
     /*  95056 */ // Label 1671: @95056
     /*  95056 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(95082), // Rule ID 6863 //
     /*  95061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95075 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  95075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95080 */   GIR_RootConstrainSelectedInstOperands,
     /*  95081 */   // GIR_Coverage, 6863,
     /*  95081 */   GIR_Done,
     /*  95082 */ // Label 1672: @95082
     /*  95082 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(95111), // Rule ID 6864 //
     /*  95087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95098 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  95098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95110 */   // GIR_Coverage, 6864,
     /*  95110 */   GIR_EraseRootFromParent_Done,
     /*  95111 */ // Label 1673: @95111
     /*  95111 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(95143), // Rule ID 6865 //
     /*  95116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95130 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95133 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95142 */   // GIR_Coverage, 6865,
     /*  95142 */   GIR_EraseRootFromParent_Done,
     /*  95143 */ // Label 1674: @95143
     /*  95143 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(95175), // Rule ID 6866 //
     /*  95148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95162 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95174 */   // GIR_Coverage, 6866,
     /*  95174 */   GIR_EraseRootFromParent_Done,
     /*  95175 */ // Label 1675: @95175
     /*  95175 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(95207), // Rule ID 6867 //
     /*  95180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95194 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95197 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95199 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95206 */   // GIR_Coverage, 6867,
     /*  95206 */   GIR_EraseRootFromParent_Done,
     /*  95207 */ // Label 1676: @95207
     /*  95207 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(95239), // Rule ID 6868 //
     /*  95212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95226 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95238 */   // GIR_Coverage, 6868,
     /*  95238 */   GIR_EraseRootFromParent_Done,
     /*  95239 */ // Label 1677: @95239
     /*  95239 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(95271), // Rule ID 6869 //
     /*  95244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95258 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95261 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95263 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95270 */   // GIR_Coverage, 6869,
     /*  95270 */   GIR_EraseRootFromParent_Done,
     /*  95271 */ // Label 1678: @95271
     /*  95271 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(95303), // Rule ID 6870 //
     /*  95276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95290 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95293 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95295 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95302 */   // GIR_Coverage, 6870,
     /*  95302 */   GIR_EraseRootFromParent_Done,
     /*  95303 */ // Label 1679: @95303
     /*  95303 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(95374), // Rule ID 6871 //
     /*  95308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95322 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95322 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95325 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95329 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95334 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95352 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95372 */   GIR_RootConstrainSelectedInstOperands,
     /*  95373 */   // GIR_Coverage, 6871,
     /*  95373 */   GIR_EraseRootFromParent_Done,
     /*  95374 */ // Label 1680: @95374
     /*  95374 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(95400), // Rule ID 6872 //
     /*  95379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95393 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  95393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95398 */   GIR_RootConstrainSelectedInstOperands,
     /*  95399 */   // GIR_Coverage, 6872,
     /*  95399 */   GIR_Done,
     /*  95400 */ // Label 1681: @95400
     /*  95400 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(95426), // Rule ID 6873 //
     /*  95405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95419 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  95419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95424 */   GIR_RootConstrainSelectedInstOperands,
     /*  95425 */   // GIR_Coverage, 6873,
     /*  95425 */   GIR_Done,
     /*  95426 */ // Label 1682: @95426
     /*  95426 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(95452), // Rule ID 6874 //
     /*  95431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95445 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  95445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95450 */   GIR_RootConstrainSelectedInstOperands,
     /*  95451 */   // GIR_Coverage, 6874,
     /*  95451 */   GIR_Done,
     /*  95452 */ // Label 1683: @95452
     /*  95452 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(95478), // Rule ID 6875 //
     /*  95457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95471 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  95471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95476 */   GIR_RootConstrainSelectedInstOperands,
     /*  95477 */   // GIR_Coverage, 6875,
     /*  95477 */   GIR_Done,
     /*  95478 */ // Label 1684: @95478
     /*  95478 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(95504), // Rule ID 6876 //
     /*  95483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95497 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  95497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95502 */   GIR_RootConstrainSelectedInstOperands,
     /*  95503 */   // GIR_Coverage, 6876,
     /*  95503 */   GIR_Done,
     /*  95504 */ // Label 1685: @95504
     /*  95504 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(95533), // Rule ID 6877 //
     /*  95509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95520 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95523 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95525 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95532 */   // GIR_Coverage, 6877,
     /*  95532 */   GIR_EraseRootFromParent_Done,
     /*  95533 */ // Label 1686: @95533
     /*  95533 */ GIM_Reject,
     /*  95534 */ // Label 1446: @95534
     /*  95534 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(95566), // Rule ID 6878 //
     /*  95539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95553 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95556 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95558 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95565 */   // GIR_Coverage, 6878,
     /*  95565 */   GIR_EraseRootFromParent_Done,
     /*  95566 */ // Label 1687: @95566
     /*  95566 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(95598), // Rule ID 6879 //
     /*  95571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95585 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95588 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95590 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95597 */   // GIR_Coverage, 6879,
     /*  95597 */   GIR_EraseRootFromParent_Done,
     /*  95598 */ // Label 1688: @95598
     /*  95598 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(95630), // Rule ID 6880 //
     /*  95603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95617 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95620 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95622 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95629 */   // GIR_Coverage, 6880,
     /*  95629 */   GIR_EraseRootFromParent_Done,
     /*  95630 */ // Label 1689: @95630
     /*  95630 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(95662), // Rule ID 6881 //
     /*  95635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95649 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95652 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95661 */   // GIR_Coverage, 6881,
     /*  95661 */   GIR_EraseRootFromParent_Done,
     /*  95662 */ // Label 1690: @95662
     /*  95662 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(95694), // Rule ID 6882 //
     /*  95667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95681 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95684 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95686 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95693 */   // GIR_Coverage, 6882,
     /*  95693 */   GIR_EraseRootFromParent_Done,
     /*  95694 */ // Label 1691: @95694
     /*  95694 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(95726), // Rule ID 6883 //
     /*  95699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95713 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95716 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95725 */   // GIR_Coverage, 6883,
     /*  95725 */   GIR_EraseRootFromParent_Done,
     /*  95726 */ // Label 1692: @95726
     /*  95726 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(95758), // Rule ID 6884 //
     /*  95731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95745 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95750 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95757 */   // GIR_Coverage, 6884,
     /*  95757 */   GIR_EraseRootFromParent_Done,
     /*  95758 */ // Label 1693: @95758
     /*  95758 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(95829), // Rule ID 6885 //
     /*  95763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95777 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95777 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95780 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95784 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95789 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95807 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95827 */   GIR_RootConstrainSelectedInstOperands,
     /*  95828 */   // GIR_Coverage, 6885,
     /*  95828 */   GIR_EraseRootFromParent_Done,
     /*  95829 */ // Label 1694: @95829
     /*  95829 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(95855), // Rule ID 6886 //
     /*  95834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95848 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  95848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95853 */   GIR_RootConstrainSelectedInstOperands,
     /*  95854 */   // GIR_Coverage, 6886,
     /*  95854 */   GIR_Done,
     /*  95855 */ // Label 1695: @95855
     /*  95855 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(95881), // Rule ID 6887 //
     /*  95860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95874 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  95874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95879 */   GIR_RootConstrainSelectedInstOperands,
     /*  95880 */   // GIR_Coverage, 6887,
     /*  95880 */   GIR_Done,
     /*  95881 */ // Label 1696: @95881
     /*  95881 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(95907), // Rule ID 6888 //
     /*  95886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95900 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  95900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95905 */   GIR_RootConstrainSelectedInstOperands,
     /*  95906 */   // GIR_Coverage, 6888,
     /*  95906 */   GIR_Done,
     /*  95907 */ // Label 1697: @95907
     /*  95907 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(95933), // Rule ID 6889 //
     /*  95912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95926 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  95926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95931 */   GIR_RootConstrainSelectedInstOperands,
     /*  95932 */   // GIR_Coverage, 6889,
     /*  95932 */   GIR_Done,
     /*  95933 */ // Label 1698: @95933
     /*  95933 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(95959), // Rule ID 6890 //
     /*  95938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95952 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  95952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95957 */   GIR_RootConstrainSelectedInstOperands,
     /*  95958 */   // GIR_Coverage, 6890,
     /*  95958 */   GIR_Done,
     /*  95959 */ // Label 1699: @95959
     /*  95959 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(95985), // Rule ID 6891 //
     /*  95964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95978 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  95978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95983 */   GIR_RootConstrainSelectedInstOperands,
     /*  95984 */   // GIR_Coverage, 6891,
     /*  95984 */   GIR_Done,
     /*  95985 */ // Label 1700: @95985
     /*  95985 */ GIM_Reject,
     /*  95986 */ // Label 1447: @95986
     /*  95986 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(96018), // Rule ID 10592 //
     /*  95991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96005 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96008 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96010 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96017 */   // GIR_Coverage, 10592,
     /*  96017 */   GIR_EraseRootFromParent_Done,
     /*  96018 */ // Label 1701: @96018
     /*  96018 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(96050), // Rule ID 10593 //
     /*  96023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96037 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96040 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96042 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96049 */   // GIR_Coverage, 10593,
     /*  96049 */   GIR_EraseRootFromParent_Done,
     /*  96050 */ // Label 1702: @96050
     /*  96050 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(96082), // Rule ID 10594 //
     /*  96055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96069 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96072 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96074 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96076 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96081 */   // GIR_Coverage, 10594,
     /*  96081 */   GIR_EraseRootFromParent_Done,
     /*  96082 */ // Label 1703: @96082
     /*  96082 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(96114), // Rule ID 10595 //
     /*  96087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96101 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96104 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96106 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96108 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96113 */   // GIR_Coverage, 10595,
     /*  96113 */   GIR_EraseRootFromParent_Done,
     /*  96114 */ // Label 1704: @96114
     /*  96114 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(96146), // Rule ID 10596 //
     /*  96119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96133 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96136 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96145 */   // GIR_Coverage, 10596,
     /*  96145 */   GIR_EraseRootFromParent_Done,
     /*  96146 */ // Label 1705: @96146
     /*  96146 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(96178), // Rule ID 10597 //
     /*  96151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96165 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96168 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96170 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96177 */   // GIR_Coverage, 10597,
     /*  96177 */   GIR_EraseRootFromParent_Done,
     /*  96178 */ // Label 1706: @96178
     /*  96178 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(96210), // Rule ID 10610 //
     /*  96183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96197 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96200 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96209 */   // GIR_Coverage, 10610,
     /*  96209 */   GIR_EraseRootFromParent_Done,
     /*  96210 */ // Label 1707: @96210
     /*  96210 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(96242), // Rule ID 10611 //
     /*  96215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96229 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96232 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96234 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96241 */   // GIR_Coverage, 10611,
     /*  96241 */   GIR_EraseRootFromParent_Done,
     /*  96242 */ // Label 1708: @96242
     /*  96242 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(96274), // Rule ID 10612 //
     /*  96247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96261 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96264 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96273 */   // GIR_Coverage, 10612,
     /*  96273 */   GIR_EraseRootFromParent_Done,
     /*  96274 */ // Label 1709: @96274
     /*  96274 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(96306), // Rule ID 10613 //
     /*  96279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96293 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96296 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96305 */   // GIR_Coverage, 10613,
     /*  96305 */   GIR_EraseRootFromParent_Done,
     /*  96306 */ // Label 1710: @96306
     /*  96306 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(96338), // Rule ID 10614 //
     /*  96311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96325 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96337 */   // GIR_Coverage, 10614,
     /*  96337 */   GIR_EraseRootFromParent_Done,
     /*  96338 */ // Label 1711: @96338
     /*  96338 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(96370), // Rule ID 10615 //
     /*  96343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96357 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96360 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96369 */   // GIR_Coverage, 10615,
     /*  96369 */   GIR_EraseRootFromParent_Done,
     /*  96370 */ // Label 1712: @96370
     /*  96370 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(96402), // Rule ID 10620 //
     /*  96375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96389 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96401 */   // GIR_Coverage, 10620,
     /*  96401 */   GIR_EraseRootFromParent_Done,
     /*  96402 */ // Label 1713: @96402
     /*  96402 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(96434), // Rule ID 10621 //
     /*  96407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96421 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96433 */   // GIR_Coverage, 10621,
     /*  96433 */   GIR_EraseRootFromParent_Done,
     /*  96434 */ // Label 1714: @96434
     /*  96434 */ GIM_Reject,
     /*  96435 */ // Label 1448: @96435
     /*  96435 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(96467), // Rule ID 10586 //
     /*  96440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96454 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96457 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96466 */   // GIR_Coverage, 10586,
     /*  96466 */   GIR_EraseRootFromParent_Done,
     /*  96467 */ // Label 1715: @96467
     /*  96467 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(96499), // Rule ID 10587 //
     /*  96472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96486 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96489 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96493 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96498 */   // GIR_Coverage, 10587,
     /*  96498 */   GIR_EraseRootFromParent_Done,
     /*  96499 */ // Label 1716: @96499
     /*  96499 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(96531), // Rule ID 10588 //
     /*  96504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96518 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96521 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96523 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96525 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96530 */   // GIR_Coverage, 10588,
     /*  96530 */   GIR_EraseRootFromParent_Done,
     /*  96531 */ // Label 1717: @96531
     /*  96531 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(96563), // Rule ID 10589 //
     /*  96536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96550 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96553 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96555 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96557 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96562 */   // GIR_Coverage, 10589,
     /*  96562 */   GIR_EraseRootFromParent_Done,
     /*  96563 */ // Label 1718: @96563
     /*  96563 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(96595), // Rule ID 10590 //
     /*  96568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96582 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96585 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96594 */   // GIR_Coverage, 10590,
     /*  96594 */   GIR_EraseRootFromParent_Done,
     /*  96595 */ // Label 1719: @96595
     /*  96595 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(96627), // Rule ID 10591 //
     /*  96600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96614 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96617 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96619 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96626 */   // GIR_Coverage, 10591,
     /*  96626 */   GIR_EraseRootFromParent_Done,
     /*  96627 */ // Label 1720: @96627
     /*  96627 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(96659), // Rule ID 10604 //
     /*  96632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96646 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96649 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96651 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96658 */   // GIR_Coverage, 10604,
     /*  96658 */   GIR_EraseRootFromParent_Done,
     /*  96659 */ // Label 1721: @96659
     /*  96659 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(96691), // Rule ID 10605 //
     /*  96664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96678 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96690 */   // GIR_Coverage, 10605,
     /*  96690 */   GIR_EraseRootFromParent_Done,
     /*  96691 */ // Label 1722: @96691
     /*  96691 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(96723), // Rule ID 10606 //
     /*  96696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96710 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96722 */   // GIR_Coverage, 10606,
     /*  96722 */   GIR_EraseRootFromParent_Done,
     /*  96723 */ // Label 1723: @96723
     /*  96723 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(96755), // Rule ID 10607 //
     /*  96728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96742 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96754 */   // GIR_Coverage, 10607,
     /*  96754 */   GIR_EraseRootFromParent_Done,
     /*  96755 */ // Label 1724: @96755
     /*  96755 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(96787), // Rule ID 10608 //
     /*  96760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96774 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96786 */   // GIR_Coverage, 10608,
     /*  96786 */   GIR_EraseRootFromParent_Done,
     /*  96787 */ // Label 1725: @96787
     /*  96787 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(96819), // Rule ID 10609 //
     /*  96792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96806 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96818 */   // GIR_Coverage, 10609,
     /*  96818 */   GIR_EraseRootFromParent_Done,
     /*  96819 */ // Label 1726: @96819
     /*  96819 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(96851), // Rule ID 10618 //
     /*  96824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96838 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96850 */   // GIR_Coverage, 10618,
     /*  96850 */   GIR_EraseRootFromParent_Done,
     /*  96851 */ // Label 1727: @96851
     /*  96851 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(96883), // Rule ID 10619 //
     /*  96856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96870 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96882 */   // GIR_Coverage, 10619,
     /*  96882 */   GIR_EraseRootFromParent_Done,
     /*  96883 */ // Label 1728: @96883
     /*  96883 */ GIM_Reject,
     /*  96884 */ // Label 1449: @96884
     /*  96884 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(96916), // Rule ID 10580 //
     /*  96889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96903 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96915 */   // GIR_Coverage, 10580,
     /*  96915 */   GIR_EraseRootFromParent_Done,
     /*  96916 */ // Label 1729: @96916
     /*  96916 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(96948), // Rule ID 10581 //
     /*  96921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96935 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96940 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96947 */   // GIR_Coverage, 10581,
     /*  96947 */   GIR_EraseRootFromParent_Done,
     /*  96948 */ // Label 1730: @96948
     /*  96948 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(96980), // Rule ID 10582 //
     /*  96953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96967 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96970 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96979 */   // GIR_Coverage, 10582,
     /*  96979 */   GIR_EraseRootFromParent_Done,
     /*  96980 */ // Label 1731: @96980
     /*  96980 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(97012), // Rule ID 10583 //
     /*  96985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96999 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97002 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97004 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97011 */   // GIR_Coverage, 10583,
     /*  97011 */   GIR_EraseRootFromParent_Done,
     /*  97012 */ // Label 1732: @97012
     /*  97012 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(97044), // Rule ID 10584 //
     /*  97017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97031 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97043 */   // GIR_Coverage, 10584,
     /*  97043 */   GIR_EraseRootFromParent_Done,
     /*  97044 */ // Label 1733: @97044
     /*  97044 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(97076), // Rule ID 10585 //
     /*  97049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97063 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97075 */   // GIR_Coverage, 10585,
     /*  97075 */   GIR_EraseRootFromParent_Done,
     /*  97076 */ // Label 1734: @97076
     /*  97076 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(97108), // Rule ID 10598 //
     /*  97081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97095 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97098 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97107 */   // GIR_Coverage, 10598,
     /*  97107 */   GIR_EraseRootFromParent_Done,
     /*  97108 */ // Label 1735: @97108
     /*  97108 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(97140), // Rule ID 10599 //
     /*  97113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97127 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97130 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97132 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97139 */   // GIR_Coverage, 10599,
     /*  97139 */   GIR_EraseRootFromParent_Done,
     /*  97140 */ // Label 1736: @97140
     /*  97140 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(97172), // Rule ID 10600 //
     /*  97145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97159 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97162 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97164 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97171 */   // GIR_Coverage, 10600,
     /*  97171 */   GIR_EraseRootFromParent_Done,
     /*  97172 */ // Label 1737: @97172
     /*  97172 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(97204), // Rule ID 10601 //
     /*  97177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97191 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97194 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97196 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97203 */   // GIR_Coverage, 10601,
     /*  97203 */   GIR_EraseRootFromParent_Done,
     /*  97204 */ // Label 1738: @97204
     /*  97204 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(97236), // Rule ID 10602 //
     /*  97209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97223 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97226 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97228 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97235 */   // GIR_Coverage, 10602,
     /*  97235 */   GIR_EraseRootFromParent_Done,
     /*  97236 */ // Label 1739: @97236
     /*  97236 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(97268), // Rule ID 10603 //
     /*  97241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97255 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97258 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97260 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97267 */   // GIR_Coverage, 10603,
     /*  97267 */   GIR_EraseRootFromParent_Done,
     /*  97268 */ // Label 1740: @97268
     /*  97268 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(97300), // Rule ID 10616 //
     /*  97273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97287 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97290 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97292 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97294 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97299 */   // GIR_Coverage, 10616,
     /*  97299 */   GIR_EraseRootFromParent_Done,
     /*  97300 */ // Label 1741: @97300
     /*  97300 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(97332), // Rule ID 10617 //
     /*  97305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97319 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97322 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97331 */   // GIR_Coverage, 10617,
     /*  97331 */   GIR_EraseRootFromParent_Done,
     /*  97332 */ // Label 1742: @97332
     /*  97332 */ GIM_Reject,
     /*  97333 */ // Label 1450: @97333
     /*  97333 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(97365), // Rule ID 10574 //
     /*  97338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97352 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97355 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97357 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97364 */   // GIR_Coverage, 10574,
     /*  97364 */   GIR_EraseRootFromParent_Done,
     /*  97365 */ // Label 1743: @97365
     /*  97365 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(97397), // Rule ID 10575 //
     /*  97370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97384 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97387 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97389 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97396 */   // GIR_Coverage, 10575,
     /*  97396 */   GIR_EraseRootFromParent_Done,
     /*  97397 */ // Label 1744: @97397
     /*  97397 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(97429), // Rule ID 10576 //
     /*  97402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97416 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97419 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97421 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97428 */   // GIR_Coverage, 10576,
     /*  97428 */   GIR_EraseRootFromParent_Done,
     /*  97429 */ // Label 1745: @97429
     /*  97429 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(97461), // Rule ID 10577 //
     /*  97434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97448 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97451 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97460 */   // GIR_Coverage, 10577,
     /*  97460 */   GIR_EraseRootFromParent_Done,
     /*  97461 */ // Label 1746: @97461
     /*  97461 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(97493), // Rule ID 10578 //
     /*  97466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97480 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97483 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97492 */   // GIR_Coverage, 10578,
     /*  97492 */   GIR_EraseRootFromParent_Done,
     /*  97493 */ // Label 1747: @97493
     /*  97493 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(97525), // Rule ID 10579 //
     /*  97498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97512 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97515 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97524 */   // GIR_Coverage, 10579,
     /*  97524 */   GIR_EraseRootFromParent_Done,
     /*  97525 */ // Label 1748: @97525
     /*  97525 */ GIM_Reject,
     /*  97526 */ // Label 1451: @97526
     /*  97526 */ GIM_Reject,
     /*  97527 */ // Label 10: @97527
     /*  97527 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1757*/ GIMT_Encode4(98017),
     /*  97538 */ /*GILLT_s16*//*Label 1749*/ GIMT_Encode4(97578),
     /*  97542 */ /*GILLT_s32*//*Label 1750*/ GIMT_Encode4(97609),
     /*  97546 */ /*GILLT_s64*//*Label 1751*/ GIMT_Encode4(97640), GIMT_Encode4(0),
     /*  97554 */ /*GILLT_v2s32*//*Label 1752*/ GIMT_Encode4(97671),
     /*  97558 */ /*GILLT_v2s64*//*Label 1753*/ GIMT_Encode4(97702),
     /*  97562 */ /*GILLT_v4s16*//*Label 1754*/ GIMT_Encode4(97733),
     /*  97566 */ /*GILLT_v4s32*//*Label 1755*/ GIMT_Encode4(97764), GIMT_Encode4(0),
     /*  97574 */ /*GILLT_v8s16*//*Label 1756*/ GIMT_Encode4(97795),
     /*  97578 */ // Label 1749: @97578
     /*  97578 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(97608), // Rule ID 564 //
     /*  97583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97597 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  97602 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97606 */   GIR_RootConstrainSelectedInstOperands,
     /*  97607 */   // GIR_Coverage, 564,
     /*  97607 */   GIR_Done,
     /*  97608 */ // Label 1758: @97608
     /*  97608 */ GIM_Reject,
     /*  97609 */ // Label 1750: @97609
     /*  97609 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(97639), // Rule ID 566 //
     /*  97614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97628 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  97633 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97637 */   GIR_RootConstrainSelectedInstOperands,
     /*  97638 */   // GIR_Coverage, 566,
     /*  97638 */   GIR_Done,
     /*  97639 */ // Label 1759: @97639
     /*  97639 */ GIM_Reject,
     /*  97640 */ // Label 1751: @97640
     /*  97640 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(97670), // Rule ID 568 //
     /*  97645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97659 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  97664 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97668 */   GIR_RootConstrainSelectedInstOperands,
     /*  97669 */   // GIR_Coverage, 568,
     /*  97669 */   GIR_Done,
     /*  97670 */ // Label 1760: @97670
     /*  97670 */ GIM_Reject,
     /*  97671 */ // Label 1752: @97671
     /*  97671 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97701), // Rule ID 933 //
     /*  97676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97690 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  97695 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97699 */   GIR_RootConstrainSelectedInstOperands,
     /*  97700 */   // GIR_Coverage, 933,
     /*  97700 */   GIR_Done,
     /*  97701 */ // Label 1761: @97701
     /*  97701 */ GIM_Reject,
     /*  97702 */ // Label 1753: @97702
     /*  97702 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97732), // Rule ID 937 //
     /*  97707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97721 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  97726 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97730 */   GIR_RootConstrainSelectedInstOperands,
     /*  97731 */   // GIR_Coverage, 937,
     /*  97731 */   GIR_Done,
     /*  97732 */ // Label 1762: @97732
     /*  97732 */ GIM_Reject,
     /*  97733 */ // Label 1754: @97733
     /*  97733 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97763), // Rule ID 929 //
     /*  97738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97752 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  97757 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97761 */   GIR_RootConstrainSelectedInstOperands,
     /*  97762 */   // GIR_Coverage, 929,
     /*  97762 */   GIR_Done,
     /*  97763 */ // Label 1763: @97763
     /*  97763 */ GIM_Reject,
     /*  97764 */ // Label 1755: @97764
     /*  97764 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97794), // Rule ID 935 //
     /*  97769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97783 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97788 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97792 */   GIR_RootConstrainSelectedInstOperands,
     /*  97793 */   // GIR_Coverage, 935,
     /*  97793 */   GIR_Done,
     /*  97794 */ // Label 1764: @97794
     /*  97794 */ GIM_Reject,
     /*  97795 */ // Label 1756: @97795
     /*  97795 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(98016),
     /*  97800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97811 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97830), // Rule ID 931 //
     /*  97816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97819 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  97824 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97828 */     GIR_RootConstrainSelectedInstOperands,
     /*  97829 */     // GIR_Coverage, 931,
     /*  97829 */     GIR_Done,
     /*  97830 */   // Label 1766: @97830
     /*  97830 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(98015), // Rule ID 7010 //
     /*  97835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97838 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97838 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97841 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97845 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97850 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97856 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97859 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97863 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97868 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97873 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97876 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97880 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97885 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97891 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97896 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97901 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97904 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97908 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97913 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97918 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97921 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97925 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97930 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97935 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97938 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97942 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97947 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97978 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97984 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98013 */     GIR_RootConstrainSelectedInstOperands,
     /*  98014 */     // GIR_Coverage, 7010,
     /*  98014 */     GIR_EraseRootFromParent_Done,
     /*  98015 */   // Label 1767: @98015
     /*  98015 */   GIM_Reject,
     /*  98016 */ // Label 1765: @98016
     /*  98016 */ GIM_Reject,
     /*  98017 */ // Label 1757: @98017
     /*  98017 */ GIM_Reject,
     /*  98018 */ // Label 11: @98018
     /*  98018 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1776*/ GIMT_Encode4(98508),
     /*  98029 */ /*GILLT_s16*//*Label 1768*/ GIMT_Encode4(98069),
     /*  98033 */ /*GILLT_s32*//*Label 1769*/ GIMT_Encode4(98100),
     /*  98037 */ /*GILLT_s64*//*Label 1770*/ GIMT_Encode4(98131), GIMT_Encode4(0),
     /*  98045 */ /*GILLT_v2s32*//*Label 1771*/ GIMT_Encode4(98162),
     /*  98049 */ /*GILLT_v2s64*//*Label 1772*/ GIMT_Encode4(98193),
     /*  98053 */ /*GILLT_v4s16*//*Label 1773*/ GIMT_Encode4(98224),
     /*  98057 */ /*GILLT_v4s32*//*Label 1774*/ GIMT_Encode4(98255), GIMT_Encode4(0),
     /*  98065 */ /*GILLT_v8s16*//*Label 1775*/ GIMT_Encode4(98286),
     /*  98069 */ // Label 1768: @98069
     /*  98069 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98099), // Rule ID 528 //
     /*  98074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98088 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  98093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98097 */   GIR_RootConstrainSelectedInstOperands,
     /*  98098 */   // GIR_Coverage, 528,
     /*  98098 */   GIR_Done,
     /*  98099 */ // Label 1777: @98099
     /*  98099 */ GIM_Reject,
     /*  98100 */ // Label 1769: @98100
     /*  98100 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98130), // Rule ID 530 //
     /*  98105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98119 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  98119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  98124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98128 */   GIR_RootConstrainSelectedInstOperands,
     /*  98129 */   // GIR_Coverage, 530,
     /*  98129 */   GIR_Done,
     /*  98130 */ // Label 1778: @98130
     /*  98130 */ GIM_Reject,
     /*  98131 */ // Label 1770: @98131
     /*  98131 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98161), // Rule ID 532 //
     /*  98136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98150 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  98150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  98155 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98159 */   GIR_RootConstrainSelectedInstOperands,
     /*  98160 */   // GIR_Coverage, 532,
     /*  98160 */   GIR_Done,
     /*  98161 */ // Label 1779: @98161
     /*  98161 */ GIM_Reject,
     /*  98162 */ // Label 1771: @98162
     /*  98162 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98192), // Rule ID 873 //
     /*  98167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98181 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  98181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  98186 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98190 */   GIR_RootConstrainSelectedInstOperands,
     /*  98191 */   // GIR_Coverage, 873,
     /*  98191 */   GIR_Done,
     /*  98192 */ // Label 1780: @98192
     /*  98192 */ GIM_Reject,
     /*  98193 */ // Label 1772: @98193
     /*  98193 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98223), // Rule ID 877 //
     /*  98198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98212 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  98212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  98217 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98221 */   GIR_RootConstrainSelectedInstOperands,
     /*  98222 */   // GIR_Coverage, 877,
     /*  98222 */   GIR_Done,
     /*  98223 */ // Label 1781: @98223
     /*  98223 */ GIM_Reject,
     /*  98224 */ // Label 1773: @98224
     /*  98224 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98254), // Rule ID 869 //
     /*  98229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98243 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  98243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  98248 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98252 */   GIR_RootConstrainSelectedInstOperands,
     /*  98253 */   // GIR_Coverage, 869,
     /*  98253 */   GIR_Done,
     /*  98254 */ // Label 1782: @98254
     /*  98254 */ GIM_Reject,
     /*  98255 */ // Label 1774: @98255
     /*  98255 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98285), // Rule ID 875 //
     /*  98260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98274 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  98274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98279 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98283 */   GIR_RootConstrainSelectedInstOperands,
     /*  98284 */   // GIR_Coverage, 875,
     /*  98284 */   GIR_Done,
     /*  98285 */ // Label 1783: @98285
     /*  98285 */ GIM_Reject,
     /*  98286 */ // Label 1775: @98286
     /*  98286 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98507),
     /*  98291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98302 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98321), // Rule ID 871 //
     /*  98307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98310 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  98310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  98315 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98319 */     GIR_RootConstrainSelectedInstOperands,
     /*  98320 */     // GIR_Coverage, 871,
     /*  98320 */     GIR_Done,
     /*  98321 */   // Label 1785: @98321
     /*  98321 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98506), // Rule ID 7004 //
     /*  98326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  98329 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  98329 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  98332 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  98336 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98341 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  98347 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  98350 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98354 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98359 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  98362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  98364 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  98367 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98371 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98376 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  98382 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98387 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98392 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  98395 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  98399 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98404 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  98407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  98409 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  98412 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98416 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98421 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  98424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98426 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  98429 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  98433 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98438 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  98441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98469 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  98475 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98504 */     GIR_RootConstrainSelectedInstOperands,
     /*  98505 */     // GIR_Coverage, 7004,
     /*  98505 */     GIR_EraseRootFromParent_Done,
     /*  98506 */   // Label 1786: @98506
     /*  98506 */   GIM_Reject,
     /*  98507 */ // Label 1784: @98507
     /*  98507 */ GIM_Reject,
     /*  98508 */ // Label 1776: @98508
     /*  98508 */ GIM_Reject,
     /*  98509 */ // Label 12: @98509
     /*  98509 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1789*/ GIMT_Encode4(98776),
     /*  98520 */ /*GILLT_s32*//*Label 1787*/ GIMT_Encode4(98528),
     /*  98524 */ /*GILLT_s64*//*Label 1788*/ GIMT_Encode4(98652),
     /*  98528 */ // Label 1787: @98528
     /*  98528 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98571), // Rule ID 4785 //
     /*  98533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98543 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98555 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  98564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98569 */   GIR_RootConstrainSelectedInstOperands,
     /*  98570 */   // GIR_Coverage, 4785,
     /*  98570 */   GIR_EraseRootFromParent_Done,
     /*  98571 */ // Label 1790: @98571
     /*  98571 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98611), // Rule ID 4791 //
     /*  98576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98583 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98595 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  98604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98609 */   GIR_RootConstrainSelectedInstOperands,
     /*  98610 */   // GIR_Coverage, 4791,
     /*  98610 */   GIR_EraseRootFromParent_Done,
     /*  98611 */ // Label 1791: @98611
     /*  98611 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98651), // Rule ID 4793 //
     /*  98616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98623 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98623 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98626 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98630 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98635 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  98644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98649 */   GIR_RootConstrainSelectedInstOperands,
     /*  98650 */   // GIR_Coverage, 4793,
     /*  98650 */   GIR_EraseRootFromParent_Done,
     /*  98651 */ // Label 1792: @98651
     /*  98651 */ GIM_Reject,
     /*  98652 */ // Label 1788: @98652
     /*  98652 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98695), // Rule ID 4787 //
     /*  98657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98667 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98679 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98693 */   GIR_RootConstrainSelectedInstOperands,
     /*  98694 */   // GIR_Coverage, 4787,
     /*  98694 */   GIR_EraseRootFromParent_Done,
     /*  98695 */ // Label 1793: @98695
     /*  98695 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(98735), // Rule ID 4795 //
     /*  98700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98707 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98719 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98733 */   GIR_RootConstrainSelectedInstOperands,
     /*  98734 */   // GIR_Coverage, 4795,
     /*  98734 */   GIR_EraseRootFromParent_Done,
     /*  98735 */ // Label 1794: @98735
     /*  98735 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(98775), // Rule ID 4797 //
     /*  98740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98747 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98747 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98750 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98754 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98759 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98770 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98773 */   GIR_RootConstrainSelectedInstOperands,
     /*  98774 */   // GIR_Coverage, 4797,
     /*  98774 */   GIR_EraseRootFromParent_Done,
     /*  98775 */ // Label 1795: @98775
     /*  98775 */ GIM_Reject,
     /*  98776 */ // Label 1789: @98776
     /*  98776 */ GIM_Reject,
     /*  98777 */ // Label 13: @98777
     /*  98777 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(98926),
     /*  98782 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98785 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1800*/ GIMT_Encode4(98925),
     /*  98796 */   /*GILLT_s16*//*Label 1797*/ GIMT_Encode4(98808),
     /*  98800 */   /*GILLT_s32*//*Label 1798*/ GIMT_Encode4(98849),
     /*  98804 */   /*GILLT_s64*//*Label 1799*/ GIMT_Encode4(98887),
     /*  98808 */   // Label 1797: @98808
     /*  98808 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(98848), // Rule ID 4789 //
     /*  98813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98820 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98832 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98846 */     GIR_RootConstrainSelectedInstOperands,
     /*  98847 */     // GIR_Coverage, 4789,
     /*  98847 */     GIR_EraseRootFromParent_Done,
     /*  98848 */   // Label 1801: @98848
     /*  98848 */   GIM_Reject,
     /*  98849 */   // Label 1798: @98849
     /*  98849 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(98886), // Rule ID 4799 //
     /*  98854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98858 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98884 */     GIR_RootConstrainSelectedInstOperands,
     /*  98885 */     // GIR_Coverage, 4799,
     /*  98885 */     GIR_EraseRootFromParent_Done,
     /*  98886 */   // Label 1802: @98886
     /*  98886 */   GIM_Reject,
     /*  98887 */   // Label 1799: @98887
     /*  98887 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(98924), // Rule ID 4801 //
     /*  98892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98896 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98922 */     GIR_RootConstrainSelectedInstOperands,
     /*  98923 */     // GIR_Coverage, 4801,
     /*  98923 */     GIR_EraseRootFromParent_Done,
     /*  98924 */   // Label 1803: @98924
     /*  98924 */   GIM_Reject,
     /*  98925 */   // Label 1800: @98925
     /*  98925 */   GIM_Reject,
     /*  98926 */ // Label 1796: @98926
     /*  98926 */ GIM_Reject,
     /*  98927 */ // Label 14: @98927
     /*  98927 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1812*/ GIMT_Encode4(99417),
     /*  98938 */ /*GILLT_s16*//*Label 1804*/ GIMT_Encode4(98978),
     /*  98942 */ /*GILLT_s32*//*Label 1805*/ GIMT_Encode4(99009),
     /*  98946 */ /*GILLT_s64*//*Label 1806*/ GIMT_Encode4(99040), GIMT_Encode4(0),
     /*  98954 */ /*GILLT_v2s32*//*Label 1807*/ GIMT_Encode4(99071),
     /*  98958 */ /*GILLT_v2s64*//*Label 1808*/ GIMT_Encode4(99102),
     /*  98962 */ /*GILLT_v4s16*//*Label 1809*/ GIMT_Encode4(99133),
     /*  98966 */ /*GILLT_v4s32*//*Label 1810*/ GIMT_Encode4(99164), GIMT_Encode4(0),
     /*  98974 */ /*GILLT_v8s16*//*Label 1811*/ GIMT_Encode4(99195),
     /*  98978 */ // Label 1804: @98978
     /*  98978 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99008), // Rule ID 546 //
     /*  98983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98997 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  99002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99006 */   GIR_RootConstrainSelectedInstOperands,
     /*  99007 */   // GIR_Coverage, 546,
     /*  99007 */   GIR_Done,
     /*  99008 */ // Label 1813: @99008
     /*  99008 */ GIM_Reject,
     /*  99009 */ // Label 1805: @99009
     /*  99009 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99039), // Rule ID 548 //
     /*  99014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  99020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99028 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  99028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  99033 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99037 */   GIR_RootConstrainSelectedInstOperands,
     /*  99038 */   // GIR_Coverage, 548,
     /*  99038 */   GIR_Done,
     /*  99039 */ // Label 1814: @99039
     /*  99039 */ GIM_Reject,
     /*  99040 */ // Label 1806: @99040
     /*  99040 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99070), // Rule ID 550 //
     /*  99045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  99051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99059 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  99059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  99064 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99068 */   GIR_RootConstrainSelectedInstOperands,
     /*  99069 */   // GIR_Coverage, 550,
     /*  99069 */   GIR_Done,
     /*  99070 */ // Label 1815: @99070
     /*  99070 */ GIM_Reject,
     /*  99071 */ // Label 1807: @99071
     /*  99071 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99101), // Rule ID 903 //
     /*  99076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99090 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  99090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  99095 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99099 */   GIR_RootConstrainSelectedInstOperands,
     /*  99100 */   // GIR_Coverage, 903,
     /*  99100 */   GIR_Done,
     /*  99101 */ // Label 1816: @99101
     /*  99101 */ GIM_Reject,
     /*  99102 */ // Label 1808: @99102
     /*  99102 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99132), // Rule ID 907 //
     /*  99107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99121 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  99121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  99126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99130 */   GIR_RootConstrainSelectedInstOperands,
     /*  99131 */   // GIR_Coverage, 907,
     /*  99131 */   GIR_Done,
     /*  99132 */ // Label 1817: @99132
     /*  99132 */ GIM_Reject,
     /*  99133 */ // Label 1809: @99133
     /*  99133 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99163), // Rule ID 899 //
     /*  99138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  99141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99152 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  99152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  99157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99161 */   GIR_RootConstrainSelectedInstOperands,
     /*  99162 */   // GIR_Coverage, 899,
     /*  99162 */   GIR_Done,
     /*  99163 */ // Label 1818: @99163
     /*  99163 */ GIM_Reject,
     /*  99164 */ // Label 1810: @99164
     /*  99164 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(99194), // Rule ID 905 //
     /*  99169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99183 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  99183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99188 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99192 */   GIR_RootConstrainSelectedInstOperands,
     /*  99193 */   // GIR_Coverage, 905,
     /*  99193 */   GIR_Done,
     /*  99194 */ // Label 1819: @99194
     /*  99194 */ GIM_Reject,
     /*  99195 */ // Label 1811: @99195
     /*  99195 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(99416),
     /*  99200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99211 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99230), // Rule ID 901 //
     /*  99216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  99219 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  99219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  99224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99228 */     GIR_RootConstrainSelectedInstOperands,
     /*  99229 */     // GIR_Coverage, 901,
     /*  99229 */     GIR_Done,
     /*  99230 */   // Label 1821: @99230
     /*  99230 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(99415), // Rule ID 7006 //
     /*  99235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  99238 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  99238 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  99241 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  99245 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99250 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  99256 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  99259 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99263 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99268 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  99271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  99273 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  99276 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99280 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99285 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  99291 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99296 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99301 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  99304 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  99308 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99313 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  99316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  99318 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  99321 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99325 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99330 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  99333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  99338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  99342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99347 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99352 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99355 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99359 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  99384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  99405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  99413 */     GIR_RootConstrainSelectedInstOperands,
     /*  99414 */     // GIR_Coverage, 7006,
     /*  99414 */     GIR_EraseRootFromParent_Done,
     /*  99415 */   // Label 1822: @99415
     /*  99415 */   GIM_Reject,
     /*  99416 */ // Label 1820: @99416
     /*  99416 */ GIM_Reject,
     /*  99417 */ // Label 1812: @99417
     /*  99417 */ GIM_Reject,
     /*  99418 */ // Label 15: @99418
     /*  99418 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(99450), // Rule ID 3904 //
     /*  99423 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  99426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99430 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  99430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  99433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99435 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  99445 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  99448 */   GIR_RootConstrainSelectedInstOperands,
     /*  99449 */   // GIR_Coverage, 3904,
     /*  99449 */   GIR_EraseRootFromParent_Done,
     /*  99450 */ // Label 1823: @99450
     /*  99450 */ GIM_Reject,
     /*  99451 */ // Label 16: @99451
     /*  99451 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1844*/ GIMT_Encode4(108388),
     /*  99462 */ /*GILLT_s8*//*Label 1824*/ GIMT_Encode4(99558),
     /*  99466 */ /*GILLT_s16*//*Label 1825*/ GIMT_Encode4(99734),
     /*  99470 */ /*GILLT_s32*//*Label 1826*/ GIMT_Encode4(99910),
     /*  99474 */ /*GILLT_s64*//*Label 1827*/ GIMT_Encode4(102304),
     /*  99478 */ /*GILLT_s128*//*Label 1828*/ GIMT_Encode4(105017),
     /*  99482 */ /*GILLT_v2s32*//*Label 1829*/ GIMT_Encode4(105226),
     /*  99486 */ /*GILLT_v2s64*//*Label 1830*/ GIMT_Encode4(105604),
     /*  99490 */ /*GILLT_v4s16*//*Label 1831*/ GIMT_Encode4(105982),
     /*  99494 */ /*GILLT_v4s32*//*Label 1832*/ GIMT_Encode4(106360),
     /*  99498 */ /*GILLT_v8s8*//*Label 1833*/ GIMT_Encode4(106738),
     /*  99502 */ /*GILLT_v8s16*//*Label 1834*/ GIMT_Encode4(106946),
     /*  99506 */ /*GILLT_v16s8*//*Label 1835*/ GIMT_Encode4(107324), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99518 */ /*GILLT_nxv2s16*//*Label 1836*/ GIMT_Encode4(107532),
     /*  99522 */ /*GILLT_nxv2s32*//*Label 1837*/ GIMT_Encode4(107596),
     /*  99526 */ /*GILLT_nxv2s64*//*Label 1838*/ GIMT_Encode4(107660), GIMT_Encode4(0),
     /*  99534 */ /*GILLT_nxv4s16*//*Label 1839*/ GIMT_Encode4(107834),
     /*  99538 */ /*GILLT_nxv4s32*//*Label 1840*/ GIMT_Encode4(107898), GIMT_Encode4(0),
     /*  99546 */ /*GILLT_nxv8s16*//*Label 1841*/ GIMT_Encode4(108072),
     /*  99550 */ /*GILLT_nxv16s1*//*Label 1842*/ GIMT_Encode4(108246),
     /*  99554 */ /*GILLT_nxv16s8*//*Label 1843*/ GIMT_Encode4(108290),
     /*  99558 */ // Label 1824: @99558
     /*  99558 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(99733),
     /*  99563 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99566 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  99574 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99578 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(99619), // Rule ID 237 //
     /*  99583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99593 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  99593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  99596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99617 */     GIR_RootConstrainSelectedInstOperands,
     /*  99618 */     // GIR_Coverage, 237,
     /*  99618 */     GIR_EraseRootFromParent_Done,
     /*  99619 */   // Label 1846: @99619
     /*  99619 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(99660), // Rule ID 238 //
     /*  99624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99634 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  99634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  99637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99658 */     GIR_RootConstrainSelectedInstOperands,
     /*  99659 */     // GIR_Coverage, 238,
     /*  99659 */     GIR_EraseRootFromParent_Done,
     /*  99660 */   // Label 1847: @99660
     /*  99660 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(99696), // Rule ID 261 //
     /*  99665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99675 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  99675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  99678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99694 */     GIR_RootConstrainSelectedInstOperands,
     /*  99695 */     // GIR_Coverage, 261,
     /*  99695 */     GIR_EraseRootFromParent_Done,
     /*  99696 */   // Label 1848: @99696
     /*  99696 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(99732), // Rule ID 282 //
     /*  99701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  99711 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  99714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99730 */     GIR_RootConstrainSelectedInstOperands,
     /*  99731 */     // GIR_Coverage, 282,
     /*  99731 */     GIR_EraseRootFromParent_Done,
     /*  99732 */   // Label 1849: @99732
     /*  99732 */   GIM_Reject,
     /*  99733 */ // Label 1845: @99733
     /*  99733 */ GIM_Reject,
     /*  99734 */ // Label 1825: @99734
     /*  99734 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(99909),
     /*  99739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  99750 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99754 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(99795), // Rule ID 239 //
     /*  99759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99769 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  99772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99793 */     GIR_RootConstrainSelectedInstOperands,
     /*  99794 */     // GIR_Coverage, 239,
     /*  99794 */     GIR_EraseRootFromParent_Done,
     /*  99795 */   // Label 1851: @99795
     /*  99795 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(99836), // Rule ID 240 //
     /*  99800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99810 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  99813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99834 */     GIR_RootConstrainSelectedInstOperands,
     /*  99835 */     // GIR_Coverage, 240,
     /*  99835 */     GIR_EraseRootFromParent_Done,
     /*  99836 */   // Label 1852: @99836
     /*  99836 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(99872), // Rule ID 262 //
     /*  99841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99851 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  99851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  99854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99870 */     GIR_RootConstrainSelectedInstOperands,
     /*  99871 */     // GIR_Coverage, 262,
     /*  99871 */     GIR_EraseRootFromParent_Done,
     /*  99872 */   // Label 1853: @99872
     /*  99872 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(99908), // Rule ID 283 //
     /*  99877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99887 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  99890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99906 */     GIR_RootConstrainSelectedInstOperands,
     /*  99907 */     // GIR_Coverage, 283,
     /*  99907 */     GIR_EraseRootFromParent_Done,
     /*  99908 */   // Label 1854: @99908
     /*  99908 */   GIM_Reject,
     /*  99909 */ // Label 1850: @99909
     /*  99909 */ GIM_Reject,
     /*  99910 */ // Label 1826: @99910
     /*  99910 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(99963), // Rule ID 233 //
     /*  99915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99926 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99930 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99937 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99961 */   GIR_RootConstrainSelectedInstOperands,
     /*  99962 */   // GIR_Coverage, 233,
     /*  99962 */   GIR_EraseRootFromParent_Done,
     /*  99963 */ // Label 1855: @99963
     /*  99963 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100016), // Rule ID 234 //
     /*  99968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99971 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99990 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100010 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100014 */   GIR_RootConstrainSelectedInstOperands,
     /* 100015 */   // GIR_Coverage, 234,
     /* 100015 */   GIR_EraseRootFromParent_Done,
     /* 100016 */ // Label 1856: @100016
     /* 100016 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(100072), // Rule ID 241 //
     /* 100021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100024 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100027 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100039 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100046 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 100049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100070 */   GIR_RootConstrainSelectedInstOperands,
     /* 100071 */   // GIR_Coverage, 241,
     /* 100071 */   GIR_EraseRootFromParent_Done,
     /* 100072 */ // Label 1857: @100072
     /* 100072 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(100128), // Rule ID 242 //
     /* 100077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100080 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100083 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100102 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 100105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100126 */   GIR_RootConstrainSelectedInstOperands,
     /* 100127 */   // GIR_Coverage, 242,
     /* 100127 */   GIR_EraseRootFromParent_Done,
     /* 100128 */ // Label 1858: @100128
     /* 100128 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(100188), // Rule ID 4120 //
     /* 100133 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100136 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 100162 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 100162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 100165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100186 */   GIR_RootConstrainSelectedInstOperands,
     /* 100187 */   // GIR_Coverage, 4120,
     /* 100187 */   GIR_EraseRootFromParent_Done,
     /* 100188 */ // Label 1859: @100188
     /* 100188 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(100248), // Rule ID 4121 //
     /* 100193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 100222 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 100222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 100225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100246 */   GIR_RootConstrainSelectedInstOperands,
     /* 100247 */   // GIR_Coverage, 4121,
     /* 100247 */   GIR_EraseRootFromParent_Done,
     /* 100248 */ // Label 1860: @100248
     /* 100248 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(100308), // Rule ID 4122 //
     /* 100253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100256 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100282 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100306 */   GIR_RootConstrainSelectedInstOperands,
     /* 100307 */   // GIR_Coverage, 4122,
     /* 100307 */   GIR_EraseRootFromParent_Done,
     /* 100308 */ // Label 1861: @100308
     /* 100308 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(100368), // Rule ID 4123 //
     /* 100313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100316 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100342 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100366 */   GIR_RootConstrainSelectedInstOperands,
     /* 100367 */   // GIR_Coverage, 4123,
     /* 100367 */   GIR_EraseRootFromParent_Done,
     /* 100368 */ // Label 1862: @100368
     /* 100368 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(100428), // Rule ID 4124 //
     /* 100373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100376 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100380 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100402 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100426 */   GIR_RootConstrainSelectedInstOperands,
     /* 100427 */   // GIR_Coverage, 4124,
     /* 100427 */   GIR_EraseRootFromParent_Done,
     /* 100428 */ // Label 1863: @100428
     /* 100428 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(100488), // Rule ID 4125 //
     /* 100433 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100436 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100440 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100451 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100455 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100462 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100482 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100486 */   GIR_RootConstrainSelectedInstOperands,
     /* 100487 */   // GIR_Coverage, 4125,
     /* 100487 */   GIR_EraseRootFromParent_Done,
     /* 100488 */ // Label 1864: @100488
     /* 100488 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(100536), // Rule ID 260 //
     /* 100493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100504 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100508 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100515 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 100518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100534 */   GIR_RootConstrainSelectedInstOperands,
     /* 100535 */   // GIR_Coverage, 260,
     /* 100535 */   GIR_EraseRootFromParent_Done,
     /* 100536 */ // Label 1865: @100536
     /* 100536 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100587), // Rule ID 263 //
     /* 100541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100566 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 100569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100585 */   GIR_RootConstrainSelectedInstOperands,
     /* 100586 */   // GIR_Coverage, 263,
     /* 100586 */   GIR_EraseRootFromParent_Done,
     /* 100587 */ // Label 1866: @100587
     /* 100587 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100650), // Rule ID 7036 //
     /* 100592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100595 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100599 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100606 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100613 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100617 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 100624 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15867>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 100624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 100627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100648 */   GIR_RootConstrainSelectedInstOperands,
     /* 100649 */   // GIR_Coverage, 7036,
     /* 100649 */   GIR_EraseRootFromParent_Done,
     /* 100650 */ // Label 1867: @100650
     /* 100650 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(100713), // Rule ID 7038 //
     /* 100655 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100658 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100662 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100669 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100680 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 100687 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15867>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 100687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 100690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100711 */   GIR_RootConstrainSelectedInstOperands,
     /* 100712 */   // GIR_Coverage, 7038,
     /* 100712 */   GIR_EraseRootFromParent_Done,
     /* 100713 */ // Label 1868: @100713
     /* 100713 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100776), // Rule ID 7048 //
     /* 100718 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100721 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100725 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100732 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100750 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15875>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100774 */   GIR_RootConstrainSelectedInstOperands,
     /* 100775 */   // GIR_Coverage, 7048,
     /* 100775 */   GIR_EraseRootFromParent_Done,
     /* 100776 */ // Label 1869: @100776
     /* 100776 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(100839), // Rule ID 7050 //
     /* 100781 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100784 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100788 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100795 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100806 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100813 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15875>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100837 */   GIR_RootConstrainSelectedInstOperands,
     /* 100838 */   // GIR_Coverage, 7050,
     /* 100838 */   GIR_EraseRootFromParent_Done,
     /* 100839 */ // Label 1870: @100839
     /* 100839 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(100902), // Rule ID 7058 //
     /* 100844 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100851 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100858 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100865 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100869 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100876 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15883>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100900 */   GIR_RootConstrainSelectedInstOperands,
     /* 100901 */   // GIR_Coverage, 7058,
     /* 100901 */   GIR_EraseRootFromParent_Done,
     /* 100902 */ // Label 1871: @100902
     /* 100902 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(100965), // Rule ID 7059 //
     /* 100907 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100910 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100914 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100921 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100939 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15883>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100963 */   GIR_RootConstrainSelectedInstOperands,
     /* 100964 */   // GIR_Coverage, 7059,
     /* 100964 */   GIR_EraseRootFromParent_Done,
     /* 100965 */ // Label 1872: @100965
     /* 100965 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101013), // Rule ID 281 //
     /* 100970 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100973 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100985 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100992 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101011 */   GIR_RootConstrainSelectedInstOperands,
     /* 101012 */   // GIR_Coverage, 281,
     /* 101012 */   GIR_EraseRootFromParent_Done,
     /* 101013 */ // Label 1873: @101013
     /* 101013 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101064), // Rule ID 284 //
     /* 101018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101021 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101024 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 101032 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101036 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101043 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 101043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 101046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101058 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101062 */   GIR_RootConstrainSelectedInstOperands,
     /* 101063 */   // GIR_Coverage, 284,
     /* 101063 */   GIR_EraseRootFromParent_Done,
     /* 101064 */ // Label 1874: @101064
     /* 101064 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101119), // Rule ID 4147 //
     /* 101069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101072 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101076 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 101098 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 101098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 101101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101113 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101117 */   GIR_RootConstrainSelectedInstOperands,
     /* 101118 */   // GIR_Coverage, 4147,
     /* 101118 */   GIR_EraseRootFromParent_Done,
     /* 101119 */ // Label 1875: @101119
     /* 101119 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(101174), // Rule ID 4148 //
     /* 101124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101127 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101131 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101142 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101146 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101153 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101168 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101172 */   GIR_RootConstrainSelectedInstOperands,
     /* 101173 */   // GIR_Coverage, 4148,
     /* 101173 */   GIR_EraseRootFromParent_Done,
     /* 101174 */ // Label 1876: @101174
     /* 101174 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(101229), // Rule ID 4149 //
     /* 101179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101182 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101186 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101201 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101208 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101227 */   GIR_RootConstrainSelectedInstOperands,
     /* 101228 */   // GIR_Coverage, 4149,
     /* 101228 */   GIR_EraseRootFromParent_Done,
     /* 101229 */ // Label 1877: @101229
     /* 101229 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(101284), // Rule ID 4170 //
     /* 101234 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101237 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101256 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101263 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101282 */   GIR_RootConstrainSelectedInstOperands,
     /* 101283 */   // GIR_Coverage, 4170,
     /* 101283 */   GIR_EraseRootFromParent_Done,
     /* 101284 */ // Label 1878: @101284
     /* 101284 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(101339), // Rule ID 4171 //
     /* 101289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101292 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101318 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101337 */   GIR_RootConstrainSelectedInstOperands,
     /* 101338 */   // GIR_Coverage, 4171,
     /* 101338 */   GIR_EraseRootFromParent_Done,
     /* 101339 */ // Label 1879: @101339
     /* 101339 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(101394), // Rule ID 4172 //
     /* 101344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101347 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101351 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101362 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101366 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101373 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101383 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101392 */   GIR_RootConstrainSelectedInstOperands,
     /* 101393 */   // GIR_Coverage, 4172,
     /* 101393 */   GIR_EraseRootFromParent_Done,
     /* 101394 */ // Label 1880: @101394
     /* 101394 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101452), // Rule ID 7040 //
     /* 101399 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101402 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101413 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101420 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101424 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101431 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15867>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101446 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101450 */   GIR_RootConstrainSelectedInstOperands,
     /* 101451 */   // GIR_Coverage, 7040,
     /* 101451 */   GIR_EraseRootFromParent_Done,
     /* 101452 */ // Label 1881: @101452
     /* 101452 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(101510), // Rule ID 7042 //
     /* 101457 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101460 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101464 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101471 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101489 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15867>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101508 */   GIR_RootConstrainSelectedInstOperands,
     /* 101509 */   // GIR_Coverage, 7042,
     /* 101509 */   GIR_EraseRootFromParent_Done,
     /* 101510 */ // Label 1882: @101510
     /* 101510 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(101568), // Rule ID 7052 //
     /* 101515 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101518 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101529 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101540 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 101547 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15875>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 101547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 101550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101562 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101566 */   GIR_RootConstrainSelectedInstOperands,
     /* 101567 */   // GIR_Coverage, 7052,
     /* 101567 */   GIR_EraseRootFromParent_Done,
     /* 101568 */ // Label 1883: @101568
     /* 101568 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(101626), // Rule ID 7054 //
     /* 101573 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101576 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101580 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101587 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101594 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101605 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15875>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101624 */   GIR_RootConstrainSelectedInstOperands,
     /* 101625 */   // GIR_Coverage, 7054,
     /* 101625 */   GIR_EraseRootFromParent_Done,
     /* 101626 */ // Label 1884: @101626
     /* 101626 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101684), // Rule ID 7060 //
     /* 101631 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101634 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101638 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101645 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101652 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101656 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 101663 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15883>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 101663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 101666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101682 */   GIR_RootConstrainSelectedInstOperands,
     /* 101683 */   // GIR_Coverage, 7060,
     /* 101683 */   GIR_EraseRootFromParent_Done,
     /* 101684 */ // Label 1885: @101684
     /* 101684 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(101742), // Rule ID 7061 //
     /* 101689 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101696 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101703 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101721 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15883>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 101724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101740 */   GIR_RootConstrainSelectedInstOperands,
     /* 101741 */   // GIR_Coverage, 7061,
     /* 101741 */   GIR_EraseRootFromParent_Done,
     /* 101742 */ // Label 1886: @101742
     /* 101742 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(101803), // Rule ID 7446 //
     /* 101747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101750 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101753 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101764 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101771 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101775 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101782 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15856>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 101785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101801 */   GIR_RootConstrainSelectedInstOperands,
     /* 101802 */   // GIR_Coverage, 7446,
     /* 101802 */   GIR_EraseRootFromParent_Done,
     /* 101803 */ // Label 1887: @101803
     /* 101803 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101864), // Rule ID 7448 //
     /* 101808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101811 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101814 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101825 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101832 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101836 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101843 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15858>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 101846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101862 */   GIR_RootConstrainSelectedInstOperands,
     /* 101863 */   // GIR_Coverage, 7448,
     /* 101863 */   GIR_EraseRootFromParent_Done,
     /* 101864 */ // Label 1888: @101864
     /* 101864 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101925), // Rule ID 7450 //
     /* 101869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101872 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101893 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101897 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101904 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15860>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 101907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101923 */   GIR_RootConstrainSelectedInstOperands,
     /* 101924 */   // GIR_Coverage, 7450,
     /* 101924 */   GIR_EraseRootFromParent_Done,
     /* 101925 */ // Label 1889: @101925
     /* 101925 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101969), // Rule ID 7026 //
     /* 101930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101933 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101936 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101940 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101954 */   // MIs[0] ptr
     /* 101954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101962 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15856>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 101967 */   GIR_RootConstrainSelectedInstOperands,
     /* 101968 */   // GIR_Coverage, 7026,
     /* 101968 */   GIR_Done,
     /* 101969 */ // Label 1890: @101969
     /* 101969 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(102013), // Rule ID 7028 //
     /* 101974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101977 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101980 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101984 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101998 */   // MIs[0] ptr
     /* 101998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102006 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15858>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 102011 */   GIR_RootConstrainSelectedInstOperands,
     /* 102012 */   // GIR_Coverage, 7028,
     /* 102012 */   GIR_Done,
     /* 102013 */ // Label 1891: @102013
     /* 102013 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(102057), // Rule ID 7030 //
     /* 102018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 102021 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102024 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102042 */   // MIs[0] ptr
     /* 102042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102050 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15860>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 102055 */   GIR_RootConstrainSelectedInstOperands,
     /* 102056 */   // GIR_Coverage, 7030,
     /* 102056 */   GIR_Done,
     /* 102057 */ // Label 1892: @102057
     /* 102057 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(102098), // Rule ID 7032 //
     /* 102062 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102065 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102069 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 102079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102083 */   // MIs[0] ptr
     /* 102083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102091 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15864>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 102096 */   GIR_RootConstrainSelectedInstOperands,
     /* 102097 */   // GIR_Coverage, 7032,
     /* 102097 */   GIR_Done,
     /* 102098 */ // Label 1893: @102098
     /* 102098 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(102139), // Rule ID 7034 //
     /* 102103 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102106 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102110 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102124 */   // MIs[0] ptr
     /* 102124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102132 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15856>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 102137 */   GIR_RootConstrainSelectedInstOperands,
     /* 102138 */   // GIR_Coverage, 7034,
     /* 102138 */   GIR_Done,
     /* 102139 */ // Label 1894: @102139
     /* 102139 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(102180), // Rule ID 7044 //
     /* 102144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102147 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102151 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 102161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102165 */   // MIs[0] ptr
     /* 102165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102173 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15872>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 102178 */   GIR_RootConstrainSelectedInstOperands,
     /* 102179 */   // GIR_Coverage, 7044,
     /* 102179 */   GIR_Done,
     /* 102180 */ // Label 1895: @102180
     /* 102180 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102221), // Rule ID 7046 //
     /* 102185 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102188 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102192 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102206 */   // MIs[0] ptr
     /* 102206 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102214 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15858>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 102219 */   GIR_RootConstrainSelectedInstOperands,
     /* 102220 */   // GIR_Coverage, 7046,
     /* 102220 */   GIR_Done,
     /* 102221 */ // Label 1896: @102221
     /* 102221 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(102262), // Rule ID 7056 //
     /* 102226 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102233 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102240 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 102243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102247 */   // MIs[0] ptr
     /* 102247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102255 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15880>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 102260 */   GIR_RootConstrainSelectedInstOperands,
     /* 102261 */   // GIR_Coverage, 7056,
     /* 102261 */   GIR_Done,
     /* 102262 */ // Label 1897: @102262
     /* 102262 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(102303), // Rule ID 7057 //
     /* 102267 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102270 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102288 */   // MIs[0] ptr
     /* 102288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102296 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15860>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 102301 */   GIR_RootConstrainSelectedInstOperands,
     /* 102302 */   // GIR_Coverage, 7057,
     /* 102302 */   GIR_Done,
     /* 102303 */ // Label 1898: @102303
     /* 102303 */ GIM_Reject,
     /* 102304 */ // Label 1827: @102304
     /* 102304 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(102357), // Rule ID 235 //
     /* 102309 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102312 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102320 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102324 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102331 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 102334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102355 */   GIR_RootConstrainSelectedInstOperands,
     /* 102356 */   // GIR_Coverage, 235,
     /* 102356 */   GIR_EraseRootFromParent_Done,
     /* 102357 */ // Label 1899: @102357
     /* 102357 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(102410), // Rule ID 236 //
     /* 102362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102365 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102384 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 102387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102408 */   GIR_RootConstrainSelectedInstOperands,
     /* 102409 */   // GIR_Coverage, 236,
     /* 102409 */   GIR_EraseRootFromParent_Done,
     /* 102410 */ // Label 1900: @102410
     /* 102410 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(102466), // Rule ID 243 //
     /* 102415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102440 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102464 */   GIR_RootConstrainSelectedInstOperands,
     /* 102465 */   // GIR_Coverage, 243,
     /* 102465 */   GIR_EraseRootFromParent_Done,
     /* 102466 */ // Label 1901: @102466
     /* 102466 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102522), // Rule ID 244 //
     /* 102471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102474 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102477 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102485 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102489 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102496 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102520 */   GIR_RootConstrainSelectedInstOperands,
     /* 102521 */   // GIR_Coverage, 244,
     /* 102521 */   GIR_EraseRootFromParent_Done,
     /* 102522 */ // Label 1902: @102522
     /* 102522 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102575), // Rule ID 4086 //
     /* 102527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102530 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102542 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102549 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102573 */   GIR_RootConstrainSelectedInstOperands,
     /* 102574 */   // GIR_Coverage, 4086,
     /* 102574 */   GIR_EraseRootFromParent_Done,
     /* 102575 */ // Label 1903: @102575
     /* 102575 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102628), // Rule ID 4087 //
     /* 102580 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102583 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102591 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102595 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102602 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102626 */   GIR_RootConstrainSelectedInstOperands,
     /* 102627 */   // GIR_Coverage, 4087,
     /* 102627 */   GIR_EraseRootFromParent_Done,
     /* 102628 */ // Label 1904: @102628
     /* 102628 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102681), // Rule ID 4088 //
     /* 102633 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102636 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102648 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102655 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102679 */   GIR_RootConstrainSelectedInstOperands,
     /* 102680 */   // GIR_Coverage, 4088,
     /* 102680 */   GIR_EraseRootFromParent_Done,
     /* 102681 */ // Label 1905: @102681
     /* 102681 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102734), // Rule ID 4089 //
     /* 102686 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102689 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102697 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102701 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102708 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102732 */   GIR_RootConstrainSelectedInstOperands,
     /* 102733 */   // GIR_Coverage, 4089,
     /* 102733 */   GIR_EraseRootFromParent_Done,
     /* 102734 */ // Label 1906: @102734
     /* 102734 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102826), // Rule ID 4112 //
     /* 102739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102742 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 102768 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 102775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102795 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102825 */   // GIR_Coverage, 4112,
     /* 102825 */   GIR_EraseRootFromParent_Done,
     /* 102826 */ // Label 1907: @102826
     /* 102826 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102918), // Rule ID 4113 //
     /* 102831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102834 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102849 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102853 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102860 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102887 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102917 */   // GIR_Coverage, 4113,
     /* 102917 */   GIR_EraseRootFromParent_Done,
     /* 102918 */ // Label 1908: @102918
     /* 102918 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(103010), // Rule ID 4114 //
     /* 102923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102926 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 102952 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 102959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102979 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102999 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103009 */   // GIR_Coverage, 4114,
     /* 103009 */   GIR_EraseRootFromParent_Done,
     /* 103010 */ // Label 1909: @103010
     /* 103010 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(103102), // Rule ID 4115 //
     /* 103015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103018 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103037 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 103044 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 103051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103071 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103101 */   // GIR_Coverage, 4115,
     /* 103101 */   GIR_EraseRootFromParent_Done,
     /* 103102 */ // Label 1910: @103102
     /* 103102 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(103194), // Rule ID 4116 //
     /* 103107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103110 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103114 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 103136 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 103143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103163 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103193 */   // GIR_Coverage, 4116,
     /* 103193 */   GIR_EraseRootFromParent_Done,
     /* 103194 */ // Label 1911: @103194
     /* 103194 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(103286), // Rule ID 4117 //
     /* 103199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103202 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103221 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 103228 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 103235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103255 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103275 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103280 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103285 */   // GIR_Coverage, 4117,
     /* 103285 */   GIR_EraseRootFromParent_Done,
     /* 103286 */ // Label 1912: @103286
     /* 103286 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(103378), // Rule ID 4118 //
     /* 103291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103294 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103313 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 103320 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103320 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103323 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 103327 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103347 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103372 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103377 */   // GIR_Coverage, 4118,
     /* 103377 */   GIR_EraseRootFromParent_Done,
     /* 103378 */ // Label 1913: @103378
     /* 103378 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(103470), // Rule ID 4119 //
     /* 103383 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103386 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103390 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103405 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 103412 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 103419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103439 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103469 */   // GIR_Coverage, 4119,
     /* 103469 */   GIR_EraseRootFromParent_Done,
     /* 103470 */ // Label 1914: @103470
     /* 103470 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(103518), // Rule ID 259 //
     /* 103475 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103478 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103497 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 103500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103516 */   GIR_RootConstrainSelectedInstOperands,
     /* 103517 */   // GIR_Coverage, 259,
     /* 103517 */   GIR_EraseRootFromParent_Done,
     /* 103518 */ // Label 1915: @103518
     /* 103518 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(103569), // Rule ID 264 //
     /* 103523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103529 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103541 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103548 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103567 */   GIR_RootConstrainSelectedInstOperands,
     /* 103568 */   // GIR_Coverage, 264,
     /* 103568 */   GIR_EraseRootFromParent_Done,
     /* 103569 */ // Label 1916: @103569
     /* 103569 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(103632), // Rule ID 7064 //
     /* 103574 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103581 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103588 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103595 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103599 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 103606 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15891>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 103606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 103609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103630 */   GIR_RootConstrainSelectedInstOperands,
     /* 103631 */   // GIR_Coverage, 7064,
     /* 103631 */   GIR_EraseRootFromParent_Done,
     /* 103632 */ // Label 1917: @103632
     /* 103632 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(103695), // Rule ID 7065 //
     /* 103637 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103651 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 103669 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15891>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 103669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 103672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103693 */   GIR_RootConstrainSelectedInstOperands,
     /* 103694 */   // GIR_Coverage, 7065,
     /* 103694 */   GIR_EraseRootFromParent_Done,
     /* 103695 */ // Label 1918: @103695
     /* 103695 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(103743), // Rule ID 280 //
     /* 103700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103722 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103741 */   GIR_RootConstrainSelectedInstOperands,
     /* 103742 */   // GIR_Coverage, 280,
     /* 103742 */   GIR_EraseRootFromParent_Done,
     /* 103743 */ // Label 1919: @103743
     /* 103743 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103794), // Rule ID 285 //
     /* 103748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103773 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103792 */   GIR_RootConstrainSelectedInstOperands,
     /* 103793 */   // GIR_Coverage, 285,
     /* 103793 */   GIR_EraseRootFromParent_Done,
     /* 103794 */ // Label 1920: @103794
     /* 103794 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103842), // Rule ID 4133 //
     /* 103799 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103802 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103821 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103840 */   GIR_RootConstrainSelectedInstOperands,
     /* 103841 */   // GIR_Coverage, 4133,
     /* 103841 */   GIR_EraseRootFromParent_Done,
     /* 103842 */ // Label 1921: @103842
     /* 103842 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103890), // Rule ID 4134 //
     /* 103847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103869 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103884 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103888 */   GIR_RootConstrainSelectedInstOperands,
     /* 103889 */   // GIR_Coverage, 4134,
     /* 103889 */   GIR_EraseRootFromParent_Done,
     /* 103890 */ // Label 1922: @103890
     /* 103890 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103977), // Rule ID 4150 //
     /* 103895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103898 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103902 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 103924 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103924 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103927 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 103931 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103946 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103976 */   // GIR_Coverage, 4150,
     /* 103976 */   GIR_EraseRootFromParent_Done,
     /* 103977 */ // Label 1923: @103977
     /* 103977 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(104064), // Rule ID 4151 //
     /* 103982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103985 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104011 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 104018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104033 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104063 */   // GIR_Coverage, 4151,
     /* 104063 */   GIR_EraseRootFromParent_Done,
     /* 104064 */ // Label 1924: @104064
     /* 104064 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(104151), // Rule ID 4152 //
     /* 104069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104072 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104076 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104098 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 104105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104120 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104145 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104150 */   // GIR_Coverage, 4152,
     /* 104150 */   GIR_EraseRootFromParent_Done,
     /* 104151 */ // Label 1925: @104151
     /* 104151 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(104238), // Rule ID 4153 //
     /* 104156 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104159 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104185 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 104192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104207 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104237 */   // GIR_Coverage, 4153,
     /* 104237 */   GIR_EraseRootFromParent_Done,
     /* 104238 */ // Label 1926: @104238
     /* 104238 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(104286), // Rule ID 4161 //
     /* 104243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104265 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104280 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104284 */   GIR_RootConstrainSelectedInstOperands,
     /* 104285 */   // GIR_Coverage, 4161,
     /* 104285 */   GIR_EraseRootFromParent_Done,
     /* 104286 */ // Label 1927: @104286
     /* 104286 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(104334), // Rule ID 4162 //
     /* 104291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104294 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104306 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104313 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104332 */   GIR_RootConstrainSelectedInstOperands,
     /* 104333 */   // GIR_Coverage, 4162,
     /* 104333 */   GIR_EraseRootFromParent_Done,
     /* 104334 */ // Label 1928: @104334
     /* 104334 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(104421), // Rule ID 4173 //
     /* 104339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104342 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104346 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104357 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 104368 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 104375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104390 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104420 */   // GIR_Coverage, 4173,
     /* 104420 */   GIR_EraseRootFromParent_Done,
     /* 104421 */ // Label 1929: @104421
     /* 104421 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(104508), // Rule ID 4174 //
     /* 104426 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104429 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104444 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104448 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104455 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 104462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104477 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104507 */   // GIR_Coverage, 4174,
     /* 104507 */   GIR_EraseRootFromParent_Done,
     /* 104508 */ // Label 1930: @104508
     /* 104508 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(104595), // Rule ID 4175 //
     /* 104513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104516 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104520 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104531 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104535 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104542 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 104549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104564 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104584 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104594 */   // GIR_Coverage, 4175,
     /* 104594 */   GIR_EraseRootFromParent_Done,
     /* 104595 */ // Label 1931: @104595
     /* 104595 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(104682), // Rule ID 4176 //
     /* 104600 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104603 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104607 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104629 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 104636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104651 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104681 */   // GIR_Coverage, 4176,
     /* 104681 */   GIR_EraseRootFromParent_Done,
     /* 104682 */ // Label 1932: @104682
     /* 104682 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(104740), // Rule ID 7066 //
     /* 104687 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104690 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104701 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104719 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15891>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 104722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104738 */   GIR_RootConstrainSelectedInstOperands,
     /* 104739 */   // GIR_Coverage, 7066,
     /* 104739 */   GIR_EraseRootFromParent_Done,
     /* 104740 */ // Label 1933: @104740
     /* 104740 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104798), // Rule ID 7067 //
     /* 104745 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104752 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104759 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104766 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104770 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104777 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15891>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 104780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104796 */   GIR_RootConstrainSelectedInstOperands,
     /* 104797 */   // GIR_Coverage, 7067,
     /* 104797 */   GIR_EraseRootFromParent_Done,
     /* 104798 */ // Label 1934: @104798
     /* 104798 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(104859), // Rule ID 7451 //
     /* 104803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 104806 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104813 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104838 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15862>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 104841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104857 */   GIR_RootConstrainSelectedInstOperands,
     /* 104858 */   // GIR_Coverage, 7451,
     /* 104858 */   GIR_EraseRootFromParent_Done,
     /* 104859 */ // Label 1935: @104859
     /* 104859 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(104890), // Rule ID 6409 //
     /* 104864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104875 */   // MIs[0] Rn
     /* 104875 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104883 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 104888 */   GIR_RootConstrainSelectedInstOperands,
     /* 104889 */   // GIR_Coverage, 6409,
     /* 104889 */   GIR_Done,
     /* 104890 */ // Label 1936: @104890
     /* 104890 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(104934), // Rule ID 7031 //
     /* 104895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 104898 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104901 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104919 */   // MIs[0] ptr
     /* 104919 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104927 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15862>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 104932 */   GIR_RootConstrainSelectedInstOperands,
     /* 104933 */   // GIR_Coverage, 7031,
     /* 104933 */   GIR_Done,
     /* 104934 */ // Label 1937: @104934
     /* 104934 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104975), // Rule ID 7062 //
     /* 104939 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104946 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104953 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 104956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104960 */   // MIs[0] ptr
     /* 104960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104968 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15888>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104973 */   GIR_RootConstrainSelectedInstOperands,
     /* 104974 */   // GIR_Coverage, 7062,
     /* 104974 */   GIR_Done,
     /* 104975 */ // Label 1938: @104975
     /* 104975 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(105016), // Rule ID 7063 //
     /* 104980 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104983 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104987 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104994 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105001 */   // MIs[0] ptr
     /* 105001 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105009 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15862>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 105009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 105014 */   GIR_RootConstrainSelectedInstOperands,
     /* 105015 */   // GIR_Coverage, 7063,
     /* 105015 */   GIR_Done,
     /* 105016 */ // Label 1939: @105016
     /* 105016 */ GIM_Reject,
     /* 105017 */ // Label 1828: @105017
     /* 105017 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(105225),
     /* 105022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105037 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(105078), // Rule ID 245 //
     /* 105042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105052 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105076 */     GIR_RootConstrainSelectedInstOperands,
     /* 105077 */     // GIR_Coverage, 245,
     /* 105077 */     GIR_EraseRootFromParent_Done,
     /* 105078 */   // Label 1941: @105078
     /* 105078 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(105119), // Rule ID 246 //
     /* 105083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105093 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105117 */     GIR_RootConstrainSelectedInstOperands,
     /* 105118 */     // GIR_Coverage, 246,
     /* 105118 */     GIR_EraseRootFromParent_Done,
     /* 105119 */   // Label 1942: @105119
     /* 105119 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(105155), // Rule ID 265 //
     /* 105124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105134 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105153 */     GIR_RootConstrainSelectedInstOperands,
     /* 105154 */     // GIR_Coverage, 265,
     /* 105154 */     GIR_EraseRootFromParent_Done,
     /* 105155 */   // Label 1943: @105155
     /* 105155 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(105191), // Rule ID 286 //
     /* 105160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105170 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105189 */     GIR_RootConstrainSelectedInstOperands,
     /* 105190 */     // GIR_Coverage, 286,
     /* 105190 */     GIR_EraseRootFromParent_Done,
     /* 105191 */   // Label 1944: @105191
     /* 105191 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(105224), // Rule ID 4142 //
     /* 105196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105203 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105222 */     GIR_RootConstrainSelectedInstOperands,
     /* 105223 */     // GIR_Coverage, 4142,
     /* 105223 */     GIR_EraseRootFromParent_Done,
     /* 105224 */   // Label 1945: @105224
     /* 105224 */   GIM_Reject,
     /* 105225 */ // Label 1940: @105225
     /* 105225 */ GIM_Reject,
     /* 105226 */ // Label 1829: @105226
     /* 105226 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(105603),
     /* 105231 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105234 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105242 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(105287), // Rule ID 4076 //
     /* 105247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105261 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105285 */     GIR_RootConstrainSelectedInstOperands,
     /* 105286 */     // GIR_Coverage, 4076,
     /* 105286 */     GIR_EraseRootFromParent_Done,
     /* 105287 */   // Label 1947: @105287
     /* 105287 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(105332), // Rule ID 4077 //
     /* 105292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105306 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105330 */     GIR_RootConstrainSelectedInstOperands,
     /* 105331 */     // GIR_Coverage, 4077,
     /* 105331 */     GIR_EraseRootFromParent_Done,
     /* 105332 */   // Label 1948: @105332
     /* 105332 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(105377), // Rule ID 4078 //
     /* 105337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105351 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105375 */     GIR_RootConstrainSelectedInstOperands,
     /* 105376 */     // GIR_Coverage, 4078,
     /* 105376 */     GIR_EraseRootFromParent_Done,
     /* 105377 */   // Label 1949: @105377
     /* 105377 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(105422), // Rule ID 4079 //
     /* 105382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105396 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105420 */     GIR_RootConstrainSelectedInstOperands,
     /* 105421 */     // GIR_Coverage, 4079,
     /* 105421 */     GIR_EraseRootFromParent_Done,
     /* 105422 */   // Label 1950: @105422
     /* 105422 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(105462), // Rule ID 4128 //
     /* 105427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105441 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105460 */     GIR_RootConstrainSelectedInstOperands,
     /* 105461 */     // GIR_Coverage, 4128,
     /* 105461 */     GIR_EraseRootFromParent_Done,
     /* 105462 */   // Label 1951: @105462
     /* 105462 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(105502), // Rule ID 4131 //
     /* 105467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105481 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105500 */     GIR_RootConstrainSelectedInstOperands,
     /* 105501 */     // GIR_Coverage, 4131,
     /* 105501 */     GIR_EraseRootFromParent_Done,
     /* 105502 */   // Label 1952: @105502
     /* 105502 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(105542), // Rule ID 4156 //
     /* 105507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105521 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105540 */     GIR_RootConstrainSelectedInstOperands,
     /* 105541 */     // GIR_Coverage, 4156,
     /* 105541 */     GIR_EraseRootFromParent_Done,
     /* 105542 */   // Label 1953: @105542
     /* 105542 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(105582), // Rule ID 4157 //
     /* 105547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105561 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105580 */     GIR_RootConstrainSelectedInstOperands,
     /* 105581 */     // GIR_Coverage, 4157,
     /* 105581 */     GIR_EraseRootFromParent_Done,
     /* 105582 */   // Label 1954: @105582
     /* 105582 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(105602), // Rule ID 6408 //
     /* 105587 */     // MIs[0] Rn
     /* 105587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105595 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 105600 */     GIR_RootConstrainSelectedInstOperands,
     /* 105601 */     // GIR_Coverage, 6408,
     /* 105601 */     GIR_Done,
     /* 105602 */   // Label 1955: @105602
     /* 105602 */   GIM_Reject,
     /* 105603 */ // Label 1946: @105603
     /* 105603 */ GIM_Reject,
     /* 105604 */ // Label 1830: @105604
     /* 105604 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(105981),
     /* 105609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105612 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105620 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(105665), // Rule ID 4090 //
     /* 105625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105639 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105663 */     GIR_RootConstrainSelectedInstOperands,
     /* 105664 */     // GIR_Coverage, 4090,
     /* 105664 */     GIR_EraseRootFromParent_Done,
     /* 105665 */   // Label 1957: @105665
     /* 105665 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(105710), // Rule ID 4091 //
     /* 105670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105684 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105708 */     GIR_RootConstrainSelectedInstOperands,
     /* 105709 */     // GIR_Coverage, 4091,
     /* 105709 */     GIR_EraseRootFromParent_Done,
     /* 105710 */   // Label 1958: @105710
     /* 105710 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(105755), // Rule ID 4092 //
     /* 105715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105729 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105753 */     GIR_RootConstrainSelectedInstOperands,
     /* 105754 */     // GIR_Coverage, 4092,
     /* 105754 */     GIR_EraseRootFromParent_Done,
     /* 105755 */   // Label 1959: @105755
     /* 105755 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(105800), // Rule ID 4093 //
     /* 105760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105774 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105798 */     GIR_RootConstrainSelectedInstOperands,
     /* 105799 */     // GIR_Coverage, 4093,
     /* 105799 */     GIR_EraseRootFromParent_Done,
     /* 105800 */   // Label 1960: @105800
     /* 105800 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(105840), // Rule ID 4136 //
     /* 105805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105819 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105838 */     GIR_RootConstrainSelectedInstOperands,
     /* 105839 */     // GIR_Coverage, 4136,
     /* 105839 */     GIR_EraseRootFromParent_Done,
     /* 105840 */   // Label 1961: @105840
     /* 105840 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(105880), // Rule ID 4140 //
     /* 105845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105859 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105878 */     GIR_RootConstrainSelectedInstOperands,
     /* 105879 */     // GIR_Coverage, 4140,
     /* 105879 */     GIR_EraseRootFromParent_Done,
     /* 105880 */   // Label 1962: @105880
     /* 105880 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(105920), // Rule ID 4163 //
     /* 105885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105899 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105918 */     GIR_RootConstrainSelectedInstOperands,
     /* 105919 */     // GIR_Coverage, 4163,
     /* 105919 */     GIR_EraseRootFromParent_Done,
     /* 105920 */   // Label 1963: @105920
     /* 105920 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(105960), // Rule ID 4164 //
     /* 105925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105939 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105958 */     GIR_RootConstrainSelectedInstOperands,
     /* 105959 */     // GIR_Coverage, 4164,
     /* 105959 */     GIR_EraseRootFromParent_Done,
     /* 105960 */   // Label 1964: @105960
     /* 105960 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(105980), // Rule ID 6405 //
     /* 105965 */     // MIs[0] Rn
     /* 105965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105973 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 105978 */     GIR_RootConstrainSelectedInstOperands,
     /* 105979 */     // GIR_Coverage, 6405,
     /* 105979 */     GIR_Done,
     /* 105980 */   // Label 1965: @105980
     /* 105980 */   GIM_Reject,
     /* 105981 */ // Label 1956: @105981
     /* 105981 */ GIM_Reject,
     /* 105982 */ // Label 1831: @105982
     /* 105982 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(106359),
     /* 105987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105990 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105998 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(106043), // Rule ID 4082 //
     /* 106003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106017 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106041 */     GIR_RootConstrainSelectedInstOperands,
     /* 106042 */     // GIR_Coverage, 4082,
     /* 106042 */     GIR_EraseRootFromParent_Done,
     /* 106043 */   // Label 1967: @106043
     /* 106043 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(106088), // Rule ID 4083 //
     /* 106048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106062 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106086 */     GIR_RootConstrainSelectedInstOperands,
     /* 106087 */     // GIR_Coverage, 4083,
     /* 106087 */     GIR_EraseRootFromParent_Done,
     /* 106088 */   // Label 1968: @106088
     /* 106088 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(106133), // Rule ID 4084 //
     /* 106093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106107 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106131 */     GIR_RootConstrainSelectedInstOperands,
     /* 106132 */     // GIR_Coverage, 4084,
     /* 106132 */     GIR_EraseRootFromParent_Done,
     /* 106133 */   // Label 1969: @106133
     /* 106133 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(106178), // Rule ID 4085 //
     /* 106138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106152 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106176 */     GIR_RootConstrainSelectedInstOperands,
     /* 106177 */     // GIR_Coverage, 4085,
     /* 106177 */     GIR_EraseRootFromParent_Done,
     /* 106178 */   // Label 1970: @106178
     /* 106178 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(106218), // Rule ID 4130 //
     /* 106183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106197 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106216 */     GIR_RootConstrainSelectedInstOperands,
     /* 106217 */     // GIR_Coverage, 4130,
     /* 106217 */     GIR_EraseRootFromParent_Done,
     /* 106218 */   // Label 1971: @106218
     /* 106218 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(106258), // Rule ID 4132 //
     /* 106223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106237 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106256 */     GIR_RootConstrainSelectedInstOperands,
     /* 106257 */     // GIR_Coverage, 4132,
     /* 106257 */     GIR_EraseRootFromParent_Done,
     /* 106258 */   // Label 1972: @106258
     /* 106258 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(106298), // Rule ID 4158 //
     /* 106263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106277 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106296 */     GIR_RootConstrainSelectedInstOperands,
     /* 106297 */     // GIR_Coverage, 4158,
     /* 106297 */     GIR_EraseRootFromParent_Done,
     /* 106298 */   // Label 1973: @106298
     /* 106298 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(106338), // Rule ID 4160 //
     /* 106303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106317 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106336 */     GIR_RootConstrainSelectedInstOperands,
     /* 106337 */     // GIR_Coverage, 4160,
     /* 106337 */     GIR_EraseRootFromParent_Done,
     /* 106338 */   // Label 1974: @106338
     /* 106338 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(106358), // Rule ID 6407 //
     /* 106343 */     // MIs[0] Rn
     /* 106343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106351 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 106356 */     GIR_RootConstrainSelectedInstOperands,
     /* 106357 */     // GIR_Coverage, 6407,
     /* 106357 */     GIR_Done,
     /* 106358 */   // Label 1975: @106358
     /* 106358 */   GIM_Reject,
     /* 106359 */ // Label 1966: @106359
     /* 106359 */ GIM_Reject,
     /* 106360 */ // Label 1832: @106360
     /* 106360 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(106737),
     /* 106365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106368 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106376 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(106421), // Rule ID 4094 //
     /* 106381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106395 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106419 */     GIR_RootConstrainSelectedInstOperands,
     /* 106420 */     // GIR_Coverage, 4094,
     /* 106420 */     GIR_EraseRootFromParent_Done,
     /* 106421 */   // Label 1977: @106421
     /* 106421 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(106466), // Rule ID 4095 //
     /* 106426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106440 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106464 */     GIR_RootConstrainSelectedInstOperands,
     /* 106465 */     // GIR_Coverage, 4095,
     /* 106465 */     GIR_EraseRootFromParent_Done,
     /* 106466 */   // Label 1978: @106466
     /* 106466 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(106511), // Rule ID 4096 //
     /* 106471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106485 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106509 */     GIR_RootConstrainSelectedInstOperands,
     /* 106510 */     // GIR_Coverage, 4096,
     /* 106510 */     GIR_EraseRootFromParent_Done,
     /* 106511 */   // Label 1979: @106511
     /* 106511 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(106556), // Rule ID 4097 //
     /* 106516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106530 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106554 */     GIR_RootConstrainSelectedInstOperands,
     /* 106555 */     // GIR_Coverage, 4097,
     /* 106555 */     GIR_EraseRootFromParent_Done,
     /* 106556 */   // Label 1980: @106556
     /* 106556 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(106596), // Rule ID 4135 //
     /* 106561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106575 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106594 */     GIR_RootConstrainSelectedInstOperands,
     /* 106595 */     // GIR_Coverage, 4135,
     /* 106595 */     GIR_EraseRootFromParent_Done,
     /* 106596 */   // Label 1981: @106596
     /* 106596 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(106636), // Rule ID 4139 //
     /* 106601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106615 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106634 */     GIR_RootConstrainSelectedInstOperands,
     /* 106635 */     // GIR_Coverage, 4139,
     /* 106635 */     GIR_EraseRootFromParent_Done,
     /* 106636 */   // Label 1982: @106636
     /* 106636 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(106676), // Rule ID 4165 //
     /* 106641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106655 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106674 */     GIR_RootConstrainSelectedInstOperands,
     /* 106675 */     // GIR_Coverage, 4165,
     /* 106675 */     GIR_EraseRootFromParent_Done,
     /* 106676 */   // Label 1983: @106676
     /* 106676 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(106716), // Rule ID 4166 //
     /* 106681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106695 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106714 */     GIR_RootConstrainSelectedInstOperands,
     /* 106715 */     // GIR_Coverage, 4166,
     /* 106715 */     GIR_EraseRootFromParent_Done,
     /* 106716 */   // Label 1984: @106716
     /* 106716 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(106736), // Rule ID 6404 //
     /* 106721 */     // MIs[0] Rn
     /* 106721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106729 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 106734 */     GIR_RootConstrainSelectedInstOperands,
     /* 106735 */     // GIR_Coverage, 6404,
     /* 106735 */     GIR_Done,
     /* 106736 */   // Label 1985: @106736
     /* 106736 */   GIM_Reject,
     /* 106737 */ // Label 1976: @106737
     /* 106737 */ GIM_Reject,
     /* 106738 */ // Label 1833: @106738
     /* 106738 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(106945),
     /* 106743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106754 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(106799), // Rule ID 4080 //
     /* 106759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106773 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106797 */     GIR_RootConstrainSelectedInstOperands,
     /* 106798 */     // GIR_Coverage, 4080,
     /* 106798 */     GIR_EraseRootFromParent_Done,
     /* 106799 */   // Label 1987: @106799
     /* 106799 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(106844), // Rule ID 4081 //
     /* 106804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106818 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106842 */     GIR_RootConstrainSelectedInstOperands,
     /* 106843 */     // GIR_Coverage, 4081,
     /* 106843 */     GIR_EraseRootFromParent_Done,
     /* 106844 */   // Label 1988: @106844
     /* 106844 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(106884), // Rule ID 4129 //
     /* 106849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106863 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106882 */     GIR_RootConstrainSelectedInstOperands,
     /* 106883 */     // GIR_Coverage, 4129,
     /* 106883 */     GIR_EraseRootFromParent_Done,
     /* 106884 */   // Label 1989: @106884
     /* 106884 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(106924), // Rule ID 4159 //
     /* 106889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106903 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106922 */     GIR_RootConstrainSelectedInstOperands,
     /* 106923 */     // GIR_Coverage, 4159,
     /* 106923 */     GIR_EraseRootFromParent_Done,
     /* 106924 */   // Label 1990: @106924
     /* 106924 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(106944), // Rule ID 6406 //
     /* 106929 */     // MIs[0] Rn
     /* 106929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106937 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 106942 */     GIR_RootConstrainSelectedInstOperands,
     /* 106943 */     // GIR_Coverage, 6406,
     /* 106943 */     GIR_Done,
     /* 106944 */   // Label 1991: @106944
     /* 106944 */   GIM_Reject,
     /* 106945 */ // Label 1986: @106945
     /* 106945 */ GIM_Reject,
     /* 106946 */ // Label 1834: @106946
     /* 106946 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(107323),
     /* 106951 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106954 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106962 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(107007), // Rule ID 4098 //
     /* 106967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106981 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107005 */     GIR_RootConstrainSelectedInstOperands,
     /* 107006 */     // GIR_Coverage, 4098,
     /* 107006 */     GIR_EraseRootFromParent_Done,
     /* 107007 */   // Label 1993: @107007
     /* 107007 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(107052), // Rule ID 4099 //
     /* 107012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107026 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107050 */     GIR_RootConstrainSelectedInstOperands,
     /* 107051 */     // GIR_Coverage, 4099,
     /* 107051 */     GIR_EraseRootFromParent_Done,
     /* 107052 */   // Label 1994: @107052
     /* 107052 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(107097), // Rule ID 4100 //
     /* 107057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 107071 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 107071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 107074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107095 */     GIR_RootConstrainSelectedInstOperands,
     /* 107096 */     // GIR_Coverage, 4100,
     /* 107096 */     GIR_EraseRootFromParent_Done,
     /* 107097 */   // Label 1995: @107097
     /* 107097 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(107142), // Rule ID 4101 //
     /* 107102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107116 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107140 */     GIR_RootConstrainSelectedInstOperands,
     /* 107141 */     // GIR_Coverage, 4101,
     /* 107141 */     GIR_EraseRootFromParent_Done,
     /* 107142 */   // Label 1996: @107142
     /* 107142 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(107182), // Rule ID 4138 //
     /* 107147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107161 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107180 */     GIR_RootConstrainSelectedInstOperands,
     /* 107181 */     // GIR_Coverage, 4138,
     /* 107181 */     GIR_EraseRootFromParent_Done,
     /* 107182 */   // Label 1997: @107182
     /* 107182 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(107222), // Rule ID 4141 //
     /* 107187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107201 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107220 */     GIR_RootConstrainSelectedInstOperands,
     /* 107221 */     // GIR_Coverage, 4141,
     /* 107221 */     GIR_EraseRootFromParent_Done,
     /* 107222 */   // Label 1998: @107222
     /* 107222 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(107262), // Rule ID 4167 //
     /* 107227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107241 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107260 */     GIR_RootConstrainSelectedInstOperands,
     /* 107261 */     // GIR_Coverage, 4167,
     /* 107261 */     GIR_EraseRootFromParent_Done,
     /* 107262 */   // Label 1999: @107262
     /* 107262 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(107302), // Rule ID 4169 //
     /* 107267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107281 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107300 */     GIR_RootConstrainSelectedInstOperands,
     /* 107301 */     // GIR_Coverage, 4169,
     /* 107301 */     GIR_EraseRootFromParent_Done,
     /* 107302 */   // Label 2000: @107302
     /* 107302 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(107322), // Rule ID 6403 //
     /* 107307 */     // MIs[0] Rn
     /* 107307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107315 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 107315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 107320 */     GIR_RootConstrainSelectedInstOperands,
     /* 107321 */     // GIR_Coverage, 6403,
     /* 107321 */     GIR_Done,
     /* 107322 */   // Label 2001: @107322
     /* 107322 */   GIM_Reject,
     /* 107323 */ // Label 1992: @107323
     /* 107323 */ GIM_Reject,
     /* 107324 */ // Label 1835: @107324
     /* 107324 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(107531),
     /* 107329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107332 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107340 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(107385), // Rule ID 4102 //
     /* 107345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 107359 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 107359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 107362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107383 */     GIR_RootConstrainSelectedInstOperands,
     /* 107384 */     // GIR_Coverage, 4102,
     /* 107384 */     GIR_EraseRootFromParent_Done,
     /* 107385 */   // Label 2003: @107385
     /* 107385 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(107430), // Rule ID 4103 //
     /* 107390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107404 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107428 */     GIR_RootConstrainSelectedInstOperands,
     /* 107429 */     // GIR_Coverage, 4103,
     /* 107429 */     GIR_EraseRootFromParent_Done,
     /* 107430 */   // Label 2004: @107430
     /* 107430 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(107470), // Rule ID 4137 //
     /* 107435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107449 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107468 */     GIR_RootConstrainSelectedInstOperands,
     /* 107469 */     // GIR_Coverage, 4137,
     /* 107469 */     GIR_EraseRootFromParent_Done,
     /* 107470 */   // Label 2005: @107470
     /* 107470 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(107510), // Rule ID 4168 //
     /* 107475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107489 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107508 */     GIR_RootConstrainSelectedInstOperands,
     /* 107509 */     // GIR_Coverage, 4168,
     /* 107509 */     GIR_EraseRootFromParent_Done,
     /* 107510 */   // Label 2006: @107510
     /* 107510 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(107530), // Rule ID 6402 //
     /* 107515 */     // MIs[0] Rn
     /* 107515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107523 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 107523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 107528 */     GIR_RootConstrainSelectedInstOperands,
     /* 107529 */     // GIR_Coverage, 6402,
     /* 107529 */     GIR_Done,
     /* 107530 */   // Label 2007: @107530
     /* 107530 */   GIM_Reject,
     /* 107531 */ // Label 2002: @107531
     /* 107531 */ GIM_Reject,
     /* 107532 */ // Label 1836: @107532
     /* 107532 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(107595), // Rule ID 10976 //
     /* 107537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107540 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107543 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107551 */   // MIs[0] base
     /* 107551 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107559 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107571 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 107579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107584 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107593 */   GIR_RootConstrainSelectedInstOperands,
     /* 107594 */   // GIR_Coverage, 10976,
     /* 107594 */   GIR_EraseRootFromParent_Done,
     /* 107595 */ // Label 2008: @107595
     /* 107595 */ GIM_Reject,
     /* 107596 */ // Label 1837: @107596
     /* 107596 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(107659), // Rule ID 10982 //
     /* 107601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107604 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107607 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107615 */   // MIs[0] base
     /* 107615 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107623 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107623 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107626 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107630 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107635 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 107643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107648 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107653 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107657 */   GIR_RootConstrainSelectedInstOperands,
     /* 107658 */   // GIR_Coverage, 10982,
     /* 107658 */   GIR_EraseRootFromParent_Done,
     /* 107659 */ // Label 2009: @107659
     /* 107659 */ GIM_Reject,
     /* 107660 */ // Label 1838: @107660
     /* 107660 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(107833),
     /* 107665 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107668 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107680 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(107728), // Rule ID 10967 //
     /* 107685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107692 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 107712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107717 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107726 */     GIR_RootConstrainSelectedInstOperands,
     /* 107727 */     // GIR_Coverage, 10967,
     /* 107727 */     GIR_EraseRootFromParent_Done,
     /* 107728 */   // Label 2011: @107728
     /* 107728 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(107776), // Rule ID 10985 //
     /* 107733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107740 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107752 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 107760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107765 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107774 */     GIR_RootConstrainSelectedInstOperands,
     /* 107775 */     // GIR_Coverage, 10985,
     /* 107775 */     GIR_EraseRootFromParent_Done,
     /* 107776 */   // Label 2012: @107776
     /* 107776 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107804), // Rule ID 11012 //
     /* 107781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107788 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107793 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107802 */     GIR_RootConstrainSelectedInstOperands,
     /* 107803 */     // GIR_Coverage, 11012,
     /* 107803 */     GIR_EraseRootFromParent_Done,
     /* 107804 */   // Label 2013: @107804
     /* 107804 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107832), // Rule ID 11024 //
     /* 107809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107816 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107821 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107830 */     GIR_RootConstrainSelectedInstOperands,
     /* 107831 */     // GIR_Coverage, 11024,
     /* 107831 */     GIR_EraseRootFromParent_Done,
     /* 107832 */   // Label 2014: @107832
     /* 107832 */   GIM_Reject,
     /* 107833 */ // Label 2010: @107833
     /* 107833 */ GIM_Reject,
     /* 107834 */ // Label 1839: @107834
     /* 107834 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107897), // Rule ID 10973 //
     /* 107839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107845 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107853 */   // MIs[0] base
     /* 107853 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107861 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107873 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 107881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107886 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107895 */   GIR_RootConstrainSelectedInstOperands,
     /* 107896 */   // GIR_Coverage, 10973,
     /* 107896 */   GIR_EraseRootFromParent_Done,
     /* 107897 */ // Label 2015: @107897
     /* 107897 */ GIM_Reject,
     /* 107898 */ // Label 1840: @107898
     /* 107898 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(108071),
     /* 107903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107918 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107966), // Rule ID 10955 //
     /* 107923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107930 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107955 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107964 */     GIR_RootConstrainSelectedInstOperands,
     /* 107965 */     // GIR_Coverage, 10955,
     /* 107965 */     GIR_EraseRootFromParent_Done,
     /* 107966 */   // Label 2017: @107966
     /* 107966 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(108014), // Rule ID 10979 //
     /* 107971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107978 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108003 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108012 */     GIR_RootConstrainSelectedInstOperands,
     /* 108013 */     // GIR_Coverage, 10979,
     /* 108013 */     GIR_EraseRootFromParent_Done,
     /* 108014 */   // Label 2018: @108014
     /* 108014 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(108042), // Rule ID 11008 //
     /* 108019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108026 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108031 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108040 */     GIR_RootConstrainSelectedInstOperands,
     /* 108041 */     // GIR_Coverage, 11008,
     /* 108041 */     GIR_EraseRootFromParent_Done,
     /* 108042 */   // Label 2019: @108042
     /* 108042 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(108070), // Rule ID 11020 //
     /* 108047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108054 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108059 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108068 */     GIR_RootConstrainSelectedInstOperands,
     /* 108069 */     // GIR_Coverage, 11020,
     /* 108069 */     GIR_EraseRootFromParent_Done,
     /* 108070 */   // Label 2020: @108070
     /* 108070 */   GIM_Reject,
     /* 108071 */ // Label 2016: @108071
     /* 108071 */ GIM_Reject,
     /* 108072 */ // Label 1841: @108072
     /* 108072 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(108245),
     /* 108077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108080 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 108088 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108092 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(108140), // Rule ID 10934 //
     /* 108097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108104 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 108111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108116 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 108124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108129 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108138 */     GIR_RootConstrainSelectedInstOperands,
     /* 108139 */     // GIR_Coverage, 10934,
     /* 108139 */     GIR_EraseRootFromParent_Done,
     /* 108140 */   // Label 2022: @108140
     /* 108140 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(108188), // Rule ID 10970 //
     /* 108145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108152 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 108159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108164 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 108172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108177 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108186 */     GIR_RootConstrainSelectedInstOperands,
     /* 108187 */     // GIR_Coverage, 10970,
     /* 108187 */     GIR_EraseRootFromParent_Done,
     /* 108188 */   // Label 2023: @108188
     /* 108188 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(108216), // Rule ID 11004 //
     /* 108193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108200 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108205 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108214 */     GIR_RootConstrainSelectedInstOperands,
     /* 108215 */     // GIR_Coverage, 11004,
     /* 108215 */     GIR_EraseRootFromParent_Done,
     /* 108216 */   // Label 2024: @108216
     /* 108216 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(108244), // Rule ID 11016 //
     /* 108221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108228 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108233 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108242 */     GIR_RootConstrainSelectedInstOperands,
     /* 108243 */     // GIR_Coverage, 11016,
     /* 108243 */     GIR_EraseRootFromParent_Done,
     /* 108244 */   // Label 2025: @108244
     /* 108244 */   GIM_Reject,
     /* 108245 */ // Label 2021: @108245
     /* 108245 */ GIM_Reject,
     /* 108246 */ // Label 1842: @108246
     /* 108246 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(108289), // Rule ID 2428 //
     /* 108251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108257 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 108265 */   // MIs[0] base
     /* 108265 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108273 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 108276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 108278 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108283 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108287 */   GIR_RootConstrainSelectedInstOperands,
     /* 108288 */   // GIR_Coverage, 2428,
     /* 108288 */   GIR_EraseRootFromParent_Done,
     /* 108289 */ // Label 2026: @108289
     /* 108289 */ GIM_Reject,
     /* 108290 */ // Label 1843: @108290
     /* 108290 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(108387),
     /* 108295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 108306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108310 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(108358), // Rule ID 10902 //
     /* 108315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108322 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 108329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 108342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108347 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108356 */     GIR_RootConstrainSelectedInstOperands,
     /* 108357 */     // GIR_Coverage, 10902,
     /* 108357 */     GIR_EraseRootFromParent_Done,
     /* 108358 */   // Label 2028: @108358
     /* 108358 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(108386), // Rule ID 11000 //
     /* 108363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108370 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108375 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108384 */     GIR_RootConstrainSelectedInstOperands,
     /* 108385 */     // GIR_Coverage, 11000,
     /* 108385 */     GIR_EraseRootFromParent_Done,
     /* 108386 */   // Label 2029: @108386
     /* 108386 */   GIM_Reject,
     /* 108387 */ // Label 2027: @108387
     /* 108387 */ GIM_Reject,
     /* 108388 */ // Label 1844: @108388
     /* 108388 */ GIM_Reject,
     /* 108389 */ // Label 17: @108389
     /* 108389 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2032*/ GIMT_Encode4(109438),
     /* 108400 */ /*GILLT_s32*//*Label 2030*/ GIMT_Encode4(108408),
     /* 108404 */ /*GILLT_s64*//*Label 2031*/ GIMT_Encode4(108822),
     /* 108408 */ // Label 2030: @108408
     /* 108408 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(108821),
     /* 108413 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108416 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108469), // Rule ID 247 //
     /* 108421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108443 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 108446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108467 */     GIR_RootConstrainSelectedInstOperands,
     /* 108468 */     // GIR_Coverage, 247,
     /* 108468 */     GIR_EraseRootFromParent_Done,
     /* 108469 */   // Label 2034: @108469
     /* 108469 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108522), // Rule ID 248 //
     /* 108474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108496 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 108499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108520 */     GIR_RootConstrainSelectedInstOperands,
     /* 108521 */     // GIR_Coverage, 248,
     /* 108521 */     GIR_EraseRootFromParent_Done,
     /* 108522 */   // Label 2035: @108522
     /* 108522 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108575), // Rule ID 251 //
     /* 108527 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108549 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 108552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108573 */     GIR_RootConstrainSelectedInstOperands,
     /* 108574 */     // GIR_Coverage, 251,
     /* 108574 */     GIR_EraseRootFromParent_Done,
     /* 108575 */   // Label 2036: @108575
     /* 108575 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(108628), // Rule ID 252 //
     /* 108580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108602 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 108605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108626 */     GIR_RootConstrainSelectedInstOperands,
     /* 108627 */     // GIR_Coverage, 252,
     /* 108627 */     GIR_EraseRootFromParent_Done,
     /* 108628 */   // Label 2037: @108628
     /* 108628 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(108676), // Rule ID 268 //
     /* 108633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108655 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 108658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108674 */     GIR_RootConstrainSelectedInstOperands,
     /* 108675 */     // GIR_Coverage, 268,
     /* 108675 */     GIR_EraseRootFromParent_Done,
     /* 108676 */   // Label 2038: @108676
     /* 108676 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108724), // Rule ID 270 //
     /* 108681 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108703 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 108706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108722 */     GIR_RootConstrainSelectedInstOperands,
     /* 108723 */     // GIR_Coverage, 270,
     /* 108723 */     GIR_EraseRootFromParent_Done,
     /* 108724 */   // Label 2039: @108724
     /* 108724 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(108772), // Rule ID 289 //
     /* 108729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108751 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 108754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108770 */     GIR_RootConstrainSelectedInstOperands,
     /* 108771 */     // GIR_Coverage, 289,
     /* 108771 */     GIR_EraseRootFromParent_Done,
     /* 108772 */   // Label 2040: @108772
     /* 108772 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108820), // Rule ID 291 //
     /* 108777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108799 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 108802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108818 */     GIR_RootConstrainSelectedInstOperands,
     /* 108819 */     // GIR_Coverage, 291,
     /* 108819 */     GIR_EraseRootFromParent_Done,
     /* 108820 */   // Label 2041: @108820
     /* 108820 */   GIM_Reject,
     /* 108821 */ // Label 2033: @108821
     /* 108821 */ GIM_Reject,
     /* 108822 */ // Label 2031: @108822
     /* 108822 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(109437),
     /* 108827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108830 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(108883), // Rule ID 249 //
     /* 108835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108857 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 108860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108881 */     GIR_RootConstrainSelectedInstOperands,
     /* 108882 */     // GIR_Coverage, 249,
     /* 108882 */     GIR_EraseRootFromParent_Done,
     /* 108883 */   // Label 2043: @108883
     /* 108883 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(108936), // Rule ID 250 //
     /* 108888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108910 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 108913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108934 */     GIR_RootConstrainSelectedInstOperands,
     /* 108935 */     // GIR_Coverage, 250,
     /* 108935 */     GIR_EraseRootFromParent_Done,
     /* 108936 */   // Label 2044: @108936
     /* 108936 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108989), // Rule ID 253 //
     /* 108941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108963 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 108966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108987 */     GIR_RootConstrainSelectedInstOperands,
     /* 108988 */     // GIR_Coverage, 253,
     /* 108988 */     GIR_EraseRootFromParent_Done,
     /* 108989 */   // Label 2045: @108989
     /* 108989 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(109042), // Rule ID 254 //
     /* 108994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109016 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 109019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109040 */     GIR_RootConstrainSelectedInstOperands,
     /* 109041 */     // GIR_Coverage, 254,
     /* 109041 */     GIR_EraseRootFromParent_Done,
     /* 109042 */   // Label 2046: @109042
     /* 109042 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(109095), // Rule ID 255 //
     /* 109047 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109069 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 109069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 109072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109093 */     GIR_RootConstrainSelectedInstOperands,
     /* 109094 */     // GIR_Coverage, 255,
     /* 109094 */     GIR_EraseRootFromParent_Done,
     /* 109095 */   // Label 2047: @109095
     /* 109095 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(109148), // Rule ID 256 //
     /* 109100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109122 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 109125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109146 */     GIR_RootConstrainSelectedInstOperands,
     /* 109147 */     // GIR_Coverage, 256,
     /* 109147 */     GIR_EraseRootFromParent_Done,
     /* 109148 */   // Label 2048: @109148
     /* 109148 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(109196), // Rule ID 269 //
     /* 109153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109175 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 109178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109194 */     GIR_RootConstrainSelectedInstOperands,
     /* 109195 */     // GIR_Coverage, 269,
     /* 109195 */     GIR_EraseRootFromParent_Done,
     /* 109196 */   // Label 2049: @109196
     /* 109196 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109244), // Rule ID 271 //
     /* 109201 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109223 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 109226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109242 */     GIR_RootConstrainSelectedInstOperands,
     /* 109243 */     // GIR_Coverage, 271,
     /* 109243 */     GIR_EraseRootFromParent_Done,
     /* 109244 */   // Label 2050: @109244
     /* 109244 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109292), // Rule ID 272 //
     /* 109249 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 109271 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 109271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 109274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109290 */     GIR_RootConstrainSelectedInstOperands,
     /* 109291 */     // GIR_Coverage, 272,
     /* 109291 */     GIR_EraseRootFromParent_Done,
     /* 109292 */   // Label 2051: @109292
     /* 109292 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109340), // Rule ID 290 //
     /* 109297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109319 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 109322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109338 */     GIR_RootConstrainSelectedInstOperands,
     /* 109339 */     // GIR_Coverage, 290,
     /* 109339 */     GIR_EraseRootFromParent_Done,
     /* 109340 */   // Label 2052: @109340
     /* 109340 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109388), // Rule ID 292 //
     /* 109345 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109367 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 109370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109386 */     GIR_RootConstrainSelectedInstOperands,
     /* 109387 */     // GIR_Coverage, 292,
     /* 109387 */     GIR_EraseRootFromParent_Done,
     /* 109388 */   // Label 2053: @109388
     /* 109388 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109436), // Rule ID 293 //
     /* 109393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 109415 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 109418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109434 */     GIR_RootConstrainSelectedInstOperands,
     /* 109435 */     // GIR_Coverage, 293,
     /* 109435 */     GIR_EraseRootFromParent_Done,
     /* 109436 */   // Label 2054: @109436
     /* 109436 */   GIM_Reject,
     /* 109437 */ // Label 2042: @109437
     /* 109437 */ GIM_Reject,
     /* 109438 */ // Label 2032: @109438
     /* 109438 */ GIM_Reject,
     /* 109439 */ // Label 18: @109439
     /* 109439 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2057*/ GIMT_Encode4(112487),
     /* 109450 */ /*GILLT_s32*//*Label 2055*/ GIMT_Encode4(109458),
     /* 109454 */ /*GILLT_s64*//*Label 2056*/ GIMT_Encode4(110997),
     /* 109458 */ // Label 2055: @109458
     /* 109458 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109514), // Rule ID 229 //
     /* 109463 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109466 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109481 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109488 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 109488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109512 */   GIR_RootConstrainSelectedInstOperands,
     /* 109513 */   // GIR_Coverage, 229,
     /* 109513 */   GIR_EraseRootFromParent_Done,
     /* 109514 */ // Label 2058: @109514
     /* 109514 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109570), // Rule ID 230 //
     /* 109519 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109544 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109568 */   GIR_RootConstrainSelectedInstOperands,
     /* 109569 */   // GIR_Coverage, 230,
     /* 109569 */   GIR_EraseRootFromParent_Done,
     /* 109570 */ // Label 2059: @109570
     /* 109570 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109626), // Rule ID 231 //
     /* 109575 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109593 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109600 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109624 */   GIR_RootConstrainSelectedInstOperands,
     /* 109625 */   // GIR_Coverage, 231,
     /* 109625 */   GIR_EraseRootFromParent_Done,
     /* 109626 */ // Label 2060: @109626
     /* 109626 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109682), // Rule ID 232 //
     /* 109631 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109634 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109656 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109680 */   GIR_RootConstrainSelectedInstOperands,
     /* 109681 */   // GIR_Coverage, 232,
     /* 109681 */   GIR_EraseRootFromParent_Done,
     /* 109682 */ // Label 2061: @109682
     /* 109682 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109738), // Rule ID 4126 //
     /* 109687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109701 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109705 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109712 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 109712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109736 */   GIR_RootConstrainSelectedInstOperands,
     /* 109737 */   // GIR_Coverage, 4126,
     /* 109737 */   GIR_EraseRootFromParent_Done,
     /* 109738 */ // Label 2062: @109738
     /* 109738 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109794), // Rule ID 4127 //
     /* 109743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109768 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109792 */   GIR_RootConstrainSelectedInstOperands,
     /* 109793 */   // GIR_Coverage, 4127,
     /* 109793 */   GIR_EraseRootFromParent_Done,
     /* 109794 */ // Label 2063: @109794
     /* 109794 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109845), // Rule ID 266 //
     /* 109799 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109802 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109813 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109824 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 109827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109839 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109843 */   GIR_RootConstrainSelectedInstOperands,
     /* 109844 */   // GIR_Coverage, 266,
     /* 109844 */   GIR_EraseRootFromParent_Done,
     /* 109845 */ // Label 2064: @109845
     /* 109845 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109896), // Rule ID 267 //
     /* 109850 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109853 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109864 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109868 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109875 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109894 */   GIR_RootConstrainSelectedInstOperands,
     /* 109895 */   // GIR_Coverage, 267,
     /* 109895 */   GIR_EraseRootFromParent_Done,
     /* 109896 */ // Label 2065: @109896
     /* 109896 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109955), // Rule ID 7037 //
     /* 109901 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109911 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109922 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109929 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15867>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 109929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109953 */   GIR_RootConstrainSelectedInstOperands,
     /* 109954 */   // GIR_Coverage, 7037,
     /* 109954 */   GIR_EraseRootFromParent_Done,
     /* 109955 */ // Label 2066: @109955
     /* 109955 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(110014), // Rule ID 7039 //
     /* 109960 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109963 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109970 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109988 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15867>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 109988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110012 */   GIR_RootConstrainSelectedInstOperands,
     /* 110013 */   // GIR_Coverage, 7039,
     /* 110013 */   GIR_EraseRootFromParent_Done,
     /* 110014 */ // Label 2067: @110014
     /* 110014 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(110073), // Rule ID 7049 //
     /* 110019 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110029 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 110047 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15875>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 110047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 110050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110067 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110071 */   GIR_RootConstrainSelectedInstOperands,
     /* 110072 */   // GIR_Coverage, 7049,
     /* 110072 */   GIR_EraseRootFromParent_Done,
     /* 110073 */ // Label 2068: @110073
     /* 110073 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(110132), // Rule ID 7051 //
     /* 110078 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110081 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110088 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110095 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 110106 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15875>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 110106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 110109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110130 */   GIR_RootConstrainSelectedInstOperands,
     /* 110131 */   // GIR_Coverage, 7051,
     /* 110131 */   GIR_EraseRootFromParent_Done,
     /* 110132 */ // Label 2069: @110132
     /* 110132 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(110183), // Rule ID 287 //
     /* 110137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110162 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 110162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110177 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110181 */   GIR_RootConstrainSelectedInstOperands,
     /* 110182 */   // GIR_Coverage, 287,
     /* 110182 */   GIR_EraseRootFromParent_Done,
     /* 110183 */ // Label 2070: @110183
     /* 110183 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(110234), // Rule ID 288 //
     /* 110188 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110191 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110202 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110206 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110213 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 110213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110228 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110232 */   GIR_RootConstrainSelectedInstOperands,
     /* 110233 */   // GIR_Coverage, 288,
     /* 110233 */   GIR_EraseRootFromParent_Done,
     /* 110234 */ // Label 2071: @110234
     /* 110234 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(110285), // Rule ID 4145 //
     /* 110239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110242 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110253 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110257 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110264 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 110264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110283 */   GIR_RootConstrainSelectedInstOperands,
     /* 110284 */   // GIR_Coverage, 4145,
     /* 110284 */   GIR_EraseRootFromParent_Done,
     /* 110285 */ // Label 2072: @110285
     /* 110285 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(110336), // Rule ID 4177 //
     /* 110290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110293 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110304 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110315 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110334 */   GIR_RootConstrainSelectedInstOperands,
     /* 110335 */   // GIR_Coverage, 4177,
     /* 110335 */   GIR_EraseRootFromParent_Done,
     /* 110336 */ // Label 2073: @110336
     /* 110336 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(110387), // Rule ID 4178 //
     /* 110341 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110359 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110366 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110385 */   GIR_RootConstrainSelectedInstOperands,
     /* 110386 */   // GIR_Coverage, 4178,
     /* 110386 */   GIR_EraseRootFromParent_Done,
     /* 110387 */ // Label 2074: @110387
     /* 110387 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110438), // Rule ID 4179 //
     /* 110392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110417 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110436 */   GIR_RootConstrainSelectedInstOperands,
     /* 110437 */   // GIR_Coverage, 4179,
     /* 110437 */   GIR_EraseRootFromParent_Done,
     /* 110438 */ // Label 2075: @110438
     /* 110438 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110492), // Rule ID 7041 //
     /* 110443 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110453 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110471 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15867>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 110471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110490 */   GIR_RootConstrainSelectedInstOperands,
     /* 110491 */   // GIR_Coverage, 7041,
     /* 110491 */   GIR_EraseRootFromParent_Done,
     /* 110492 */ // Label 2076: @110492
     /* 110492 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110546), // Rule ID 7043 //
     /* 110497 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110507 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110518 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110525 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15867>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110544 */   GIR_RootConstrainSelectedInstOperands,
     /* 110545 */   // GIR_Coverage, 7043,
     /* 110545 */   GIR_EraseRootFromParent_Done,
     /* 110546 */ // Label 2077: @110546
     /* 110546 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110600), // Rule ID 7053 //
     /* 110551 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110554 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110561 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110579 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15875>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 110579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 110582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110598 */   GIR_RootConstrainSelectedInstOperands,
     /* 110599 */   // GIR_Coverage, 7053,
     /* 110599 */   GIR_EraseRootFromParent_Done,
     /* 110600 */ // Label 2078: @110600
     /* 110600 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110654), // Rule ID 7055 //
     /* 110605 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110615 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110626 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110633 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15875>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110652 */   GIR_RootConstrainSelectedInstOperands,
     /* 110653 */   // GIR_Coverage, 7055,
     /* 110653 */   GIR_EraseRootFromParent_Done,
     /* 110654 */ // Label 2079: @110654
     /* 110654 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110711), // Rule ID 7447 //
     /* 110659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 110662 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110665 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110690 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15856>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 110693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110709 */   GIR_RootConstrainSelectedInstOperands,
     /* 110710 */   // GIR_Coverage, 7447,
     /* 110710 */   GIR_EraseRootFromParent_Done,
     /* 110711 */ // Label 2080: @110711
     /* 110711 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110768), // Rule ID 7449 //
     /* 110716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 110719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110729 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110747 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15858>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 110750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110766 */   GIR_RootConstrainSelectedInstOperands,
     /* 110767 */   // GIR_Coverage, 7449,
     /* 110767 */   GIR_EraseRootFromParent_Done,
     /* 110768 */ // Label 2081: @110768
     /* 110768 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110808), // Rule ID 7027 //
     /* 110773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 110776 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110779 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110793 */   // MIs[0] ptr
     /* 110793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110801 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15856>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 110806 */   GIR_RootConstrainSelectedInstOperands,
     /* 110807 */   // GIR_Coverage, 7027,
     /* 110807 */   GIR_Done,
     /* 110808 */ // Label 2082: @110808
     /* 110808 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110848), // Rule ID 7029 //
     /* 110813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 110816 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110833 */   // MIs[0] ptr
     /* 110833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110841 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15858>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 110846 */   GIR_RootConstrainSelectedInstOperands,
     /* 110847 */   // GIR_Coverage, 7029,
     /* 110847 */   GIR_Done,
     /* 110848 */ // Label 2083: @110848
     /* 110848 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110885), // Rule ID 7033 //
     /* 110853 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110856 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110863 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110870 */   // MIs[0] ptr
     /* 110870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110878 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15864>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 110883 */   GIR_RootConstrainSelectedInstOperands,
     /* 110884 */   // GIR_Coverage, 7033,
     /* 110884 */   GIR_Done,
     /* 110885 */ // Label 2084: @110885
     /* 110885 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110922), // Rule ID 7035 //
     /* 110890 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110900 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110907 */   // MIs[0] ptr
     /* 110907 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110915 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15856>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 110920 */   GIR_RootConstrainSelectedInstOperands,
     /* 110921 */   // GIR_Coverage, 7035,
     /* 110921 */   GIR_Done,
     /* 110922 */ // Label 2085: @110922
     /* 110922 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110959), // Rule ID 7045 //
     /* 110927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110944 */   // MIs[0] ptr
     /* 110944 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110952 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15872>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110957 */   GIR_RootConstrainSelectedInstOperands,
     /* 110958 */   // GIR_Coverage, 7045,
     /* 110958 */   GIR_Done,
     /* 110959 */ // Label 2086: @110959
     /* 110959 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110996), // Rule ID 7047 //
     /* 110964 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110967 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110974 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110981 */   // MIs[0] ptr
     /* 110981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110989 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15858>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110994 */   GIR_RootConstrainSelectedInstOperands,
     /* 110995 */   // GIR_Coverage, 7047,
     /* 110995 */   GIR_Done,
     /* 110996 */ // Label 2087: @110996
     /* 110996 */ GIM_Reject,
     /* 110997 */ // Label 2056: @110997
     /* 110997 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(112486),
     /* 111002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111005 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(111090), // Rule ID 4104 //
     /* 111010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111032 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 111039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111059 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111089 */     // GIR_Coverage, 4104,
     /* 111089 */     GIR_EraseRootFromParent_Done,
     /* 111090 */   // Label 2089: @111090
     /* 111090 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(111175), // Rule ID 4105 //
     /* 111095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111117 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 111124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111144 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111174 */     // GIR_Coverage, 4105,
     /* 111174 */     GIR_EraseRootFromParent_Done,
     /* 111175 */   // Label 2090: @111175
     /* 111175 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(111260), // Rule ID 4106 //
     /* 111180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 111202 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 111209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111229 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111259 */     // GIR_Coverage, 4106,
     /* 111259 */     GIR_EraseRootFromParent_Done,
     /* 111260 */   // Label 2091: @111260
     /* 111260 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(111345), // Rule ID 4107 //
     /* 111265 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 111287 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 111294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111344 */     // GIR_Coverage, 4107,
     /* 111344 */     GIR_EraseRootFromParent_Done,
     /* 111345 */   // Label 2092: @111345
     /* 111345 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(111430), // Rule ID 4108 //
     /* 111350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 111372 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 111379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111399 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111429 */     // GIR_Coverage, 4108,
     /* 111429 */     GIR_EraseRootFromParent_Done,
     /* 111430 */   // Label 2093: @111430
     /* 111430 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(111515), // Rule ID 4109 //
     /* 111435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 111457 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 111464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111484 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111514 */     // GIR_Coverage, 4109,
     /* 111514 */     GIR_EraseRootFromParent_Done,
     /* 111515 */   // Label 2094: @111515
     /* 111515 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111600), // Rule ID 4110 //
     /* 111520 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111542 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 111549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111569 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111599 */     // GIR_Coverage, 4110,
     /* 111599 */     GIR_EraseRootFromParent_Done,
     /* 111600 */   // Label 2095: @111600
     /* 111600 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111685), // Rule ID 4111 //
     /* 111605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111627 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 111634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111654 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111684 */     // GIR_Coverage, 4111,
     /* 111684 */     GIR_EraseRootFromParent_Done,
     /* 111685 */   // Label 2096: @111685
     /* 111685 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111765), // Rule ID 4143 //
     /* 111690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111712 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 111719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111734 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111764 */     // GIR_Coverage, 4143,
     /* 111764 */     GIR_EraseRootFromParent_Done,
     /* 111765 */   // Label 2097: @111765
     /* 111765 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111845), // Rule ID 4144 //
     /* 111770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 111792 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 111799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111814 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111844 */     // GIR_Coverage, 4144,
     /* 111844 */     GIR_EraseRootFromParent_Done,
     /* 111845 */   // Label 2098: @111845
     /* 111845 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111925), // Rule ID 4146 //
     /* 111850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111872 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 111879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111894 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111924 */     // GIR_Coverage, 4146,
     /* 111924 */     GIR_EraseRootFromParent_Done,
     /* 111925 */   // Label 2099: @111925
     /* 111925 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(112005), // Rule ID 4154 //
     /* 111930 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 111952 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 111959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111974 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112004 */     // GIR_Coverage, 4154,
     /* 112004 */     GIR_EraseRootFromParent_Done,
     /* 112005 */   // Label 2100: @112005
     /* 112005 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(112085), // Rule ID 4180 //
     /* 112010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 112032 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 112039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112054 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112084 */     // GIR_Coverage, 4180,
     /* 112084 */     GIR_EraseRootFromParent_Done,
     /* 112085 */   // Label 2101: @112085
     /* 112085 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(112165), // Rule ID 4181 //
     /* 112090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 112112 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 112119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112134 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112164 */     // GIR_Coverage, 4181,
     /* 112164 */     GIR_EraseRootFromParent_Done,
     /* 112165 */   // Label 2102: @112165
     /* 112165 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(112245), // Rule ID 4182 //
     /* 112170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112192 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112214 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112244 */     // GIR_Coverage, 4182,
     /* 112244 */     GIR_EraseRootFromParent_Done,
     /* 112245 */   // Label 2103: @112245
     /* 112245 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(112325), // Rule ID 4183 //
     /* 112250 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112272 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112324 */     // GIR_Coverage, 4183,
     /* 112324 */     GIR_EraseRootFromParent_Done,
     /* 112325 */   // Label 2104: @112325
     /* 112325 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(112405), // Rule ID 4184 //
     /* 112330 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112352 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112374 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112404 */     // GIR_Coverage, 4184,
     /* 112404 */     GIR_EraseRootFromParent_Done,
     /* 112405 */   // Label 2105: @112405
     /* 112405 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(112485), // Rule ID 4185 //
     /* 112410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 112432 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 112439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112454 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112484 */     // GIR_Coverage, 4185,
     /* 112484 */     GIR_EraseRootFromParent_Done,
     /* 112485 */   // Label 2106: @112485
     /* 112485 */   GIM_Reject,
     /* 112486 */ // Label 2088: @112486
     /* 112486 */ GIM_Reject,
     /* 112487 */ // Label 2057: @112487
     /* 112487 */ GIM_Reject,
     /* 112488 */ // Label 19: @112488
     /* 112488 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2127*/ GIMT_Encode4(126013),
     /* 112499 */ /*GILLT_s8*//*Label 2107*/ GIMT_Encode4(112595),
     /* 112503 */ /*GILLT_s16*//*Label 2108*/ GIMT_Encode4(112962),
     /* 112507 */ /*GILLT_s32*//*Label 2109*/ GIMT_Encode4(114101),
     /* 112511 */ /*GILLT_s64*//*Label 2110*/ GIMT_Encode4(118696),
     /* 112515 */ /*GILLT_s128*//*Label 2111*/ GIMT_Encode4(122465),
     /* 112519 */ /*GILLT_v2s32*//*Label 2112*/ GIMT_Encode4(122671),
     /* 112523 */ /*GILLT_v2s64*//*Label 2113*/ GIMT_Encode4(123077),
     /* 112527 */ /*GILLT_v4s16*//*Label 2114*/ GIMT_Encode4(123527),
     /* 112531 */ /*GILLT_v4s32*//*Label 2115*/ GIMT_Encode4(123933),
     /* 112535 */ /*GILLT_v8s8*//*Label 2116*/ GIMT_Encode4(124339),
     /* 112539 */ /*GILLT_v8s16*//*Label 2117*/ GIMT_Encode4(124559),
     /* 112543 */ /*GILLT_v16s8*//*Label 2118*/ GIMT_Encode4(124965), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112555 */ /*GILLT_nxv2s16*//*Label 2119*/ GIMT_Encode4(125185),
     /* 112559 */ /*GILLT_nxv2s32*//*Label 2120*/ GIMT_Encode4(125245),
     /* 112563 */ /*GILLT_nxv2s64*//*Label 2121*/ GIMT_Encode4(125305), GIMT_Encode4(0),
     /* 112571 */ /*GILLT_nxv4s16*//*Label 2122*/ GIMT_Encode4(125475),
     /* 112575 */ /*GILLT_nxv4s32*//*Label 2123*/ GIMT_Encode4(125535), GIMT_Encode4(0),
     /* 112583 */ /*GILLT_nxv8s16*//*Label 2124*/ GIMT_Encode4(125705),
     /* 112587 */ /*GILLT_nxv16s1*//*Label 2125*/ GIMT_Encode4(125875),
     /* 112591 */ /*GILLT_nxv16s8*//*Label 2126*/ GIMT_Encode4(125919),
     /* 112595 */ // Label 2107: @112595
     /* 112595 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112961),
     /* 112600 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112607 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112675), // Rule ID 13212 //
     /* 112612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 112645 */     // MIs[2] Operand 1
     /* 112645 */     // No operand predicates
     /* 112645 */     // MIs[0] Rn
     /* 112645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112655 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 112658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112673 */     GIR_RootConstrainSelectedInstOperands,
     /* 112674 */     // GIR_Coverage, 13212,
     /* 112674 */     GIR_EraseRootFromParent_Done,
     /* 112675 */   // Label 2129: @112675
     /* 112675 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112774), // Rule ID 13213 //
     /* 112680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 112692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112709 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 112713 */     // MIs[2] Operand 1
     /* 112713 */     // No operand predicates
     /* 112713 */     // MIs[0] Rn
     /* 112713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112723 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112735 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 112738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112742 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 112745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 112758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112772 */     GIR_RootConstrainSelectedInstOperands,
     /* 112773 */     // GIR_Coverage, 13213,
     /* 112773 */     GIR_EraseRootFromParent_Done,
     /* 112774 */   // Label 2130: @112774
     /* 112774 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112823), // Rule ID 303 //
     /* 112779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112797 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 112800 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112821 */     GIR_RootConstrainSelectedInstOperands,
     /* 112822 */     // GIR_Coverage, 303,
     /* 112822 */     GIR_EraseRootFromParent_Done,
     /* 112823 */   // Label 2131: @112823
     /* 112823 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112872), // Rule ID 304 //
     /* 112828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112846 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 112849 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112870 */     GIR_RootConstrainSelectedInstOperands,
     /* 112871 */     // GIR_Coverage, 304,
     /* 112871 */     GIR_EraseRootFromParent_Done,
     /* 112872 */   // Label 2132: @112872
     /* 112872 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112916), // Rule ID 313 //
     /* 112877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 112895 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 112895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 112898 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112914 */     GIR_RootConstrainSelectedInstOperands,
     /* 112915 */     // GIR_Coverage, 313,
     /* 112915 */     GIR_EraseRootFromParent_Done,
     /* 112916 */   // Label 2133: @112916
     /* 112916 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112960), // Rule ID 321 //
     /* 112921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112939 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 112939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 112942 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112958 */     GIR_RootConstrainSelectedInstOperands,
     /* 112959 */     // GIR_Coverage, 321,
     /* 112959 */     GIR_EraseRootFromParent_Done,
     /* 112960 */   // Label 2134: @112960
     /* 112960 */   GIM_Reject,
     /* 112961 */ // Label 2128: @112961
     /* 112961 */ GIM_Reject,
     /* 112962 */ // Label 2108: @112962
     /* 112962 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(114100),
     /* 112967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112974 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113073), // Rule ID 4482 //
     /* 112979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113000 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113017 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113029 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113071 */     GIR_RootConstrainSelectedInstOperands,
     /* 113072 */     // GIR_Coverage, 4482,
     /* 113072 */     GIR_EraseRootFromParent_Done,
     /* 113073 */   // Label 2136: @113073
     /* 113073 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113172), // Rule ID 4483 //
     /* 113078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113099 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113116 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113128 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113170 */     GIR_RootConstrainSelectedInstOperands,
     /* 113171 */     // GIR_Coverage, 4483,
     /* 113171 */     GIR_EraseRootFromParent_Done,
     /* 113172 */   // Label 2137: @113172
     /* 113172 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(113271), // Rule ID 13210 //
     /* 113177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113198 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113215 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113227 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113269 */     GIR_RootConstrainSelectedInstOperands,
     /* 113270 */     // GIR_Coverage, 13210,
     /* 113270 */     GIR_EraseRootFromParent_Done,
     /* 113271 */   // Label 2138: @113271
     /* 113271 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(113370), // Rule ID 13211 //
     /* 113276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113297 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113314 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113326 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113368 */     GIR_RootConstrainSelectedInstOperands,
     /* 113369 */     // GIR_Coverage, 13211,
     /* 113369 */     GIR_EraseRootFromParent_Done,
     /* 113370 */   // Label 2139: @113370
     /* 113370 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(113464), // Rule ID 4511 //
     /* 113375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113396 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113413 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113425 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113462 */     GIR_RootConstrainSelectedInstOperands,
     /* 113463 */     // GIR_Coverage, 4511,
     /* 113463 */     GIR_EraseRootFromParent_Done,
     /* 113464 */   // Label 2140: @113464
     /* 113464 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(113558), // Rule ID 4538 //
     /* 113469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113490 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 113507 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113519 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113556 */     GIR_RootConstrainSelectedInstOperands,
     /* 113557 */     // GIR_Coverage, 4538,
     /* 113557 */     GIR_EraseRootFromParent_Done,
     /* 113558 */   // Label 2141: @113558
     /* 113558 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(113652), // Rule ID 13209 //
     /* 113563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113601 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113613 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113650 */     GIR_RootConstrainSelectedInstOperands,
     /* 113651 */     // GIR_Coverage, 13209,
     /* 113651 */     GIR_EraseRootFromParent_Done,
     /* 113652 */   // Label 2142: @113652
     /* 113652 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113746), // Rule ID 13215 //
     /* 113657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113678 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 113695 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113707 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113744 */     GIR_RootConstrainSelectedInstOperands,
     /* 113745 */     // GIR_Coverage, 13215,
     /* 113745 */     GIR_EraseRootFromParent_Done,
     /* 113746 */   // Label 2143: @113746
     /* 113746 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113814), // Rule ID 6469 //
     /* 113751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 113784 */     // MIs[2] Operand 1
     /* 113784 */     // No operand predicates
     /* 113784 */     // MIs[0] Rn
     /* 113784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113794 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 113794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 113797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 113801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 113804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 113806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 113812 */     GIR_RootConstrainSelectedInstOperands,
     /* 113813 */     // GIR_Coverage, 6469,
     /* 113813 */     GIR_EraseRootFromParent_Done,
     /* 113814 */   // Label 2144: @113814
     /* 113814 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113913), // Rule ID 6474 //
     /* 113819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113848 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 113852 */     // MIs[2] Operand 1
     /* 113852 */     // No operand predicates
     /* 113852 */     // MIs[0] Rn
     /* 113852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113862 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 113862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 113869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 113877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 113881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 113884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 113897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 113903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 113905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 113911 */     GIR_RootConstrainSelectedInstOperands,
     /* 113912 */     // GIR_Coverage, 6474,
     /* 113912 */     GIR_EraseRootFromParent_Done,
     /* 113913 */   // Label 2145: @113913
     /* 113913 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113962), // Rule ID 305 //
     /* 113918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113936 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113939 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113960 */     GIR_RootConstrainSelectedInstOperands,
     /* 113961 */     // GIR_Coverage, 305,
     /* 113961 */     GIR_EraseRootFromParent_Done,
     /* 113962 */   // Label 2146: @113962
     /* 113962 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(114011), // Rule ID 306 //
     /* 113967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113985 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113988 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114009 */     GIR_RootConstrainSelectedInstOperands,
     /* 114010 */     // GIR_Coverage, 306,
     /* 114010 */     GIR_EraseRootFromParent_Done,
     /* 114011 */   // Label 2147: @114011
     /* 114011 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(114055), // Rule ID 314 //
     /* 114016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 114034 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 114034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 114037 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114053 */     GIR_RootConstrainSelectedInstOperands,
     /* 114054 */     // GIR_Coverage, 314,
     /* 114054 */     GIR_EraseRootFromParent_Done,
     /* 114055 */   // Label 2148: @114055
     /* 114055 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(114099), // Rule ID 322 //
     /* 114060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 114078 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 114078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 114081 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114097 */     GIR_RootConstrainSelectedInstOperands,
     /* 114098 */     // GIR_Coverage, 322,
     /* 114098 */     GIR_EraseRootFromParent_Done,
     /* 114099 */   // Label 2149: @114099
     /* 114099 */   GIM_Reject,
     /* 114100 */ // Label 2135: @114100
     /* 114100 */ GIM_Reject,
     /* 114101 */ // Label 2109: @114101
     /* 114101 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(114214), // Rule ID 4480 //
     /* 114106 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114109 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114120 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114128 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114132 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114136 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114141 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114151 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 114158 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 114158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114170 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114181 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 114189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114212 */   GIR_RootConstrainSelectedInstOperands,
     /* 114213 */   // GIR_Coverage, 4480,
     /* 114213 */   GIR_EraseRootFromParent_Done,
     /* 114214 */ // Label 2150: @114214
     /* 114214 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(114327), // Rule ID 4481 //
     /* 114219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114222 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114241 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114249 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114254 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 114271 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 114271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114283 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114289 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114294 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 114302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114320 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114325 */   GIR_RootConstrainSelectedInstOperands,
     /* 114326 */   // GIR_Coverage, 4481,
     /* 114326 */   GIR_EraseRootFromParent_Done,
     /* 114327 */ // Label 2151: @114327
     /* 114327 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(114433), // Rule ID 4484 //
     /* 114332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114335 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114347 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114351 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114355 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114360 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114377 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114389 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114400 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114426 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114431 */   GIR_RootConstrainSelectedInstOperands,
     /* 114432 */   // GIR_Coverage, 4484,
     /* 114432 */   GIR_EraseRootFromParent_Done,
     /* 114433 */ // Label 2152: @114433
     /* 114433 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(114539), // Rule ID 4485 //
     /* 114438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114445 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114453 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114457 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114461 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114466 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114470 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114483 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114495 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114501 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114506 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114537 */   GIR_RootConstrainSelectedInstOperands,
     /* 114538 */   // GIR_Coverage, 4485,
     /* 114538 */   GIR_EraseRootFromParent_Done,
     /* 114539 */ // Label 2153: @114539
     /* 114539 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(114645), // Rule ID 4486 //
     /* 114544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114551 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114559 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114563 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114567 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114572 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114580 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114589 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114601 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114612 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114643 */   GIR_RootConstrainSelectedInstOperands,
     /* 114644 */   // GIR_Coverage, 4486,
     /* 114644 */   GIR_EraseRootFromParent_Done,
     /* 114645 */ // Label 2154: @114645
     /* 114645 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(114751), // Rule ID 4487 //
     /* 114650 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114653 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114657 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114661 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114665 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114669 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114673 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114678 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114682 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114686 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114695 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114707 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114713 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114718 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114744 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114749 */   GIR_RootConstrainSelectedInstOperands,
     /* 114750 */   // GIR_Coverage, 4487,
     /* 114750 */   GIR_EraseRootFromParent_Done,
     /* 114751 */ // Label 2155: @114751
     /* 114751 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(114857), // Rule ID 13217 //
     /* 114756 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114759 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114771 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114775 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114779 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114784 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114792 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114801 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114813 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114855 */   GIR_RootConstrainSelectedInstOperands,
     /* 114856 */   // GIR_Coverage, 13217,
     /* 114856 */   GIR_EraseRootFromParent_Done,
     /* 114857 */ // Label 2156: @114857
     /* 114857 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(114963), // Rule ID 13218 //
     /* 114862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114865 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114869 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114877 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114881 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114885 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114890 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114894 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114898 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114900 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114907 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114919 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114925 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114930 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114956 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114961 */   GIR_RootConstrainSelectedInstOperands,
     /* 114962 */   // GIR_Coverage, 13218,
     /* 114962 */   GIR_EraseRootFromParent_Done,
     /* 114963 */ // Label 2157: @114963
     /* 114963 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(115071), // Rule ID 4510 //
     /* 114968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114971 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114975 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114982 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114990 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114994 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114998 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115003 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115011 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115013 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 115020 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 115020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115032 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 115038 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115043 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 115051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115069 */   GIR_RootConstrainSelectedInstOperands,
     /* 115070 */   // GIR_Coverage, 4510,
     /* 115070 */   GIR_EraseRootFromParent_Done,
     /* 115071 */ // Label 2158: @115071
     /* 115071 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(115172), // Rule ID 4512 //
     /* 115076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115079 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115091 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115095 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115099 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115104 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115108 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115112 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115114 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115121 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115121 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115128 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115133 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115139 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115144 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115165 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115170 */   GIR_RootConstrainSelectedInstOperands,
     /* 115171 */   // GIR_Coverage, 4512,
     /* 115171 */   GIR_EraseRootFromParent_Done,
     /* 115172 */ // Label 2159: @115172
     /* 115172 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(115273), // Rule ID 4513 //
     /* 115177 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115184 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115192 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115196 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115200 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115205 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115209 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115222 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115234 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115240 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115245 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115271 */   GIR_RootConstrainSelectedInstOperands,
     /* 115272 */   // GIR_Coverage, 4513,
     /* 115272 */   GIR_EraseRootFromParent_Done,
     /* 115273 */ // Label 2160: @115273
     /* 115273 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(115381), // Rule ID 4537 //
     /* 115278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115281 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115285 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115300 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115304 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115308 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115313 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115321 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115330 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115342 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 115348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 115361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115374 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115379 */   GIR_RootConstrainSelectedInstOperands,
     /* 115380 */   // GIR_Coverage, 4537,
     /* 115380 */   GIR_EraseRootFromParent_Done,
     /* 115381 */ // Label 2161: @115381
     /* 115381 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(115482), // Rule ID 4539 //
     /* 115386 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115389 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115393 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115401 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115405 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115409 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115414 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115418 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115424 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115431 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115443 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115449 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115454 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115480 */   GIR_RootConstrainSelectedInstOperands,
     /* 115481 */   // GIR_Coverage, 4539,
     /* 115481 */   GIR_EraseRootFromParent_Done,
     /* 115482 */ // Label 2162: @115482
     /* 115482 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(115583), // Rule ID 4540 //
     /* 115487 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115490 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115502 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115506 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115510 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115515 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115525 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115532 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115544 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115555 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115581 */   GIR_RootConstrainSelectedInstOperands,
     /* 115582 */   // GIR_Coverage, 4540,
     /* 115582 */   GIR_EraseRootFromParent_Done,
     /* 115583 */ // Label 2163: @115583
     /* 115583 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(115684), // Rule ID 13214 //
     /* 115588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115591 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115603 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115607 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115611 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115616 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115624 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115626 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115633 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115645 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115651 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115656 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115682 */   GIR_RootConstrainSelectedInstOperands,
     /* 115683 */   // GIR_Coverage, 13214,
     /* 115683 */   GIR_EraseRootFromParent_Done,
     /* 115684 */ // Label 2164: @115684
     /* 115684 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(115785), // Rule ID 13216 //
     /* 115689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115704 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115708 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115712 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115717 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 115734 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115746 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115752 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115757 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115778 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115783 */   GIR_RootConstrainSelectedInstOperands,
     /* 115784 */   // GIR_Coverage, 13216,
     /* 115784 */   GIR_EraseRootFromParent_Done,
     /* 115785 */ // Label 2165: @115785
     /* 115785 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(115867), // Rule ID 6463 //
     /* 115790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115793 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115797 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115812 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115816 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115820 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115825 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115829 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115833 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 115837 */   // MIs[2] Operand 1
     /* 115837 */   // No operand predicates
     /* 115837 */   // MIs[0] Rn
     /* 115837 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115845 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115847 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 115850 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115854 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115857 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115865 */   GIR_RootConstrainSelectedInstOperands,
     /* 115866 */   // GIR_Coverage, 6463,
     /* 115866 */   GIR_EraseRootFromParent_Done,
     /* 115867 */ // Label 2166: @115867
     /* 115867 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(115949), // Rule ID 6464 //
     /* 115872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115875 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115886 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115894 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115898 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115907 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115911 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115915 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 115919 */   // MIs[2] Operand 1
     /* 115919 */   // No operand predicates
     /* 115919 */   // MIs[0] Rn
     /* 115919 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115927 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115929 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 115932 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115936 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115939 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115947 */   GIR_RootConstrainSelectedInstOperands,
     /* 115948 */   // GIR_Coverage, 6464,
     /* 115948 */   GIR_EraseRootFromParent_Done,
     /* 115949 */ // Label 2167: @115949
     /* 115949 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(116024), // Rule ID 6465 //
     /* 115954 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115957 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115961 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115969 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115973 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115977 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115982 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115986 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115990 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115994 */   // MIs[2] Operand 1
     /* 115994 */   // No operand predicates
     /* 115994 */   // MIs[0] Rn
     /* 115994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116002 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116004 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116007 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116011 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116014 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116016 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116022 */   GIR_RootConstrainSelectedInstOperands,
     /* 116023 */   // GIR_Coverage, 6465,
     /* 116023 */   GIR_EraseRootFromParent_Done,
     /* 116024 */ // Label 2168: @116024
     /* 116024 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(116099), // Rule ID 6466 //
     /* 116029 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116032 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116044 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116048 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116052 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116057 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116061 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116065 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116069 */   // MIs[2] Operand 1
     /* 116069 */   // No operand predicates
     /* 116069 */   // MIs[0] Rn
     /* 116069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116077 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116079 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116082 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116086 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116089 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116097 */   GIR_RootConstrainSelectedInstOperands,
     /* 116098 */   // GIR_Coverage, 6466,
     /* 116098 */   GIR_EraseRootFromParent_Done,
     /* 116099 */ // Label 2169: @116099
     /* 116099 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(116212), // Rule ID 6470 //
     /* 116104 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116107 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116118 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116126 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 116130 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116134 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116139 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116143 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116147 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 116151 */   // MIs[2] Operand 1
     /* 116151 */   // No operand predicates
     /* 116151 */   // MIs[0] Rn
     /* 116151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116159 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116161 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116173 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116176 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116180 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116183 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116188 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 116196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116199 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116202 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116210 */   GIR_RootConstrainSelectedInstOperands,
     /* 116211 */   // GIR_Coverage, 6470,
     /* 116211 */   GIR_EraseRootFromParent_Done,
     /* 116212 */ // Label 2170: @116212
     /* 116212 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(116325), // Rule ID 6471 //
     /* 116217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116220 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116239 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116243 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116247 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116252 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116256 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116260 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 116264 */   // MIs[2] Operand 1
     /* 116264 */   // No operand predicates
     /* 116264 */   // MIs[0] Rn
     /* 116264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116272 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116274 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116286 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116289 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116293 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116296 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116301 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 116309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116312 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116315 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116323 */   GIR_RootConstrainSelectedInstOperands,
     /* 116324 */   // GIR_Coverage, 6471,
     /* 116324 */   GIR_EraseRootFromParent_Done,
     /* 116325 */ // Label 2171: @116325
     /* 116325 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(116431), // Rule ID 6472 //
     /* 116330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116333 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116337 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116341 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116345 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116349 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116353 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116358 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116362 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116366 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116370 */   // MIs[2] Operand 1
     /* 116370 */   // No operand predicates
     /* 116370 */   // MIs[0] Rn
     /* 116370 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116378 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116380 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116392 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116395 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116399 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116418 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116421 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116429 */   GIR_RootConstrainSelectedInstOperands,
     /* 116430 */   // GIR_Coverage, 6472,
     /* 116430 */   GIR_EraseRootFromParent_Done,
     /* 116431 */ // Label 2172: @116431
     /* 116431 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(116537), // Rule ID 6473 //
     /* 116436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116439 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116451 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116455 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116459 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116464 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116468 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116472 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116476 */   // MIs[2] Operand 1
     /* 116476 */   // No operand predicates
     /* 116476 */   // MIs[0] Rn
     /* 116476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116484 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116486 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116498 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116505 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116524 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116527 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116529 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116535 */   GIR_RootConstrainSelectedInstOperands,
     /* 116536 */   // GIR_Coverage, 6473,
     /* 116536 */   GIR_EraseRootFromParent_Done,
     /* 116537 */ // Label 2173: @116537
     /* 116537 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(116597), // Rule ID 295 //
     /* 116542 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116545 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116549 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116571 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 116574 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116591 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116595 */   GIR_RootConstrainSelectedInstOperands,
     /* 116596 */   // GIR_Coverage, 295,
     /* 116596 */   GIR_EraseRootFromParent_Done,
     /* 116597 */ // Label 2174: @116597
     /* 116597 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(116657), // Rule ID 296 //
     /* 116602 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116605 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116609 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116624 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116631 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 116634 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116655 */   GIR_RootConstrainSelectedInstOperands,
     /* 116656 */   // GIR_Coverage, 296,
     /* 116656 */   GIR_EraseRootFromParent_Done,
     /* 116657 */ // Label 2175: @116657
     /* 116657 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(116717), // Rule ID 297 //
     /* 116662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116665 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116684 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116691 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 116694 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116715 */   GIR_RootConstrainSelectedInstOperands,
     /* 116716 */   // GIR_Coverage, 297,
     /* 116716 */   GIR_EraseRootFromParent_Done,
     /* 116717 */ // Label 2176: @116717
     /* 116717 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(116777), // Rule ID 298 //
     /* 116722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116725 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 116751 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 116751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 116754 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116775 */   GIR_RootConstrainSelectedInstOperands,
     /* 116776 */   // GIR_Coverage, 298,
     /* 116776 */   GIR_EraseRootFromParent_Done,
     /* 116777 */ // Label 2177: @116777
     /* 116777 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(116830), // Rule ID 299 //
     /* 116782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116804 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 116807 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116824 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116828 */   GIR_RootConstrainSelectedInstOperands,
     /* 116829 */   // GIR_Coverage, 299,
     /* 116829 */   GIR_EraseRootFromParent_Done,
     /* 116830 */ // Label 2178: @116830
     /* 116830 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(116883), // Rule ID 300 //
     /* 116835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116850 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116857 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 116860 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116881 */   GIR_RootConstrainSelectedInstOperands,
     /* 116882 */   // GIR_Coverage, 300,
     /* 116882 */   GIR_EraseRootFromParent_Done,
     /* 116883 */ // Label 2179: @116883
     /* 116883 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(116939), // Rule ID 307 //
     /* 116888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116906 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116913 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 116916 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116937 */   GIR_RootConstrainSelectedInstOperands,
     /* 116938 */   // GIR_Coverage, 307,
     /* 116938 */   GIR_EraseRootFromParent_Done,
     /* 116939 */ // Label 2180: @116939
     /* 116939 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(116995), // Rule ID 308 //
     /* 116944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116958 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116962 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116969 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116972 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116993 */   GIR_RootConstrainSelectedInstOperands,
     /* 116994 */   // GIR_Coverage, 308,
     /* 116994 */   GIR_EraseRootFromParent_Done,
     /* 116995 */ // Label 2181: @116995
     /* 116995 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(117047), // Rule ID 312 //
     /* 117000 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117003 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117022 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 117025 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117045 */   GIR_RootConstrainSelectedInstOperands,
     /* 117046 */   // GIR_Coverage, 312,
     /* 117046 */   GIR_EraseRootFromParent_Done,
     /* 117047 */ // Label 2182: @117047
     /* 117047 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(117098), // Rule ID 315 //
     /* 117052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117077 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 117080 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117096 */   GIR_RootConstrainSelectedInstOperands,
     /* 117097 */   // GIR_Coverage, 315,
     /* 117097 */   GIR_EraseRootFromParent_Done,
     /* 117098 */ // Label 2183: @117098
     /* 117098 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(117157), // Rule ID 317 //
     /* 117103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117106 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117110 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117121 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117125 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117132 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 117135 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117155 */   GIR_RootConstrainSelectedInstOperands,
     /* 117156 */   // GIR_Coverage, 317,
     /* 117156 */   GIR_EraseRootFromParent_Done,
     /* 117157 */ // Label 2184: @117157
     /* 117157 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(117216), // Rule ID 318 //
     /* 117162 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117165 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117169 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 117191 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 117191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 117194 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117214 */   GIR_RootConstrainSelectedInstOperands,
     /* 117215 */   // GIR_Coverage, 318,
     /* 117215 */   GIR_EraseRootFromParent_Done,
     /* 117216 */ // Label 2185: @117216
     /* 117216 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(117293), // Rule ID 7096 //
     /* 117221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117231 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117242 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117246 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117255 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117257 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117264 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15920>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 117267 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117286 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117291 */   GIR_RootConstrainSelectedInstOperands,
     /* 117292 */   // GIR_Coverage, 7096,
     /* 117292 */   GIR_EraseRootFromParent_Done,
     /* 117293 */ // Label 2186: @117293
     /* 117293 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(117370), // Rule ID 7097 //
     /* 117298 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117301 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117308 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117319 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117323 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117341 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15920>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 117344 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117368 */   GIR_RootConstrainSelectedInstOperands,
     /* 117369 */   // GIR_Coverage, 7097,
     /* 117369 */   GIR_EraseRootFromParent_Done,
     /* 117370 */ // Label 2187: @117370
     /* 117370 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(117429), // Rule ID 7077 //
     /* 117375 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117378 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117385 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117396 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117403 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15906>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 117403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 117406 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117427 */   GIR_RootConstrainSelectedInstOperands,
     /* 117428 */   // GIR_Coverage, 7077,
     /* 117428 */   GIR_EraseRootFromParent_Done,
     /* 117429 */ // Label 2188: @117429
     /* 117429 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(117488), // Rule ID 7078 //
     /* 117434 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117437 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117444 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117451 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117455 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117462 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15906>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 117462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 117465 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117482 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117486 */   GIR_RootConstrainSelectedInstOperands,
     /* 117487 */   // GIR_Coverage, 7078,
     /* 117487 */   GIR_EraseRootFromParent_Done,
     /* 117488 */ // Label 2189: @117488
     /* 117488 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(117547), // Rule ID 7082 //
     /* 117493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117496 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117503 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117510 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117514 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117521 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15913>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 117524 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117545 */   GIR_RootConstrainSelectedInstOperands,
     /* 117546 */   // GIR_Coverage, 7082,
     /* 117546 */   GIR_EraseRootFromParent_Done,
     /* 117547 */ // Label 2190: @117547
     /* 117547 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(117606), // Rule ID 7083 //
     /* 117552 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117562 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117573 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117580 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15913>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 117583 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117604 */   GIR_RootConstrainSelectedInstOperands,
     /* 117605 */   // GIR_Coverage, 7083,
     /* 117605 */   GIR_EraseRootFromParent_Done,
     /* 117606 */ // Label 2191: @117606
     /* 117606 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(117665), // Rule ID 7087 //
     /* 117611 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117614 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117621 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117639 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15920>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 117642 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117663 */   GIR_RootConstrainSelectedInstOperands,
     /* 117664 */   // GIR_Coverage, 7087,
     /* 117664 */   GIR_EraseRootFromParent_Done,
     /* 117665 */ // Label 2192: @117665
     /* 117665 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(117724), // Rule ID 7088 //
     /* 117670 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117680 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117698 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15920>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 117701 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117722 */   GIR_RootConstrainSelectedInstOperands,
     /* 117723 */   // GIR_Coverage, 7088,
     /* 117723 */   GIR_EraseRootFromParent_Done,
     /* 117724 */ // Label 2193: @117724
     /* 117724 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(117796), // Rule ID 7098 //
     /* 117729 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117732 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117739 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117750 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117765 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117772 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15920>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 117775 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117794 */   GIR_RootConstrainSelectedInstOperands,
     /* 117795 */   // GIR_Coverage, 7098,
     /* 117795 */   GIR_EraseRootFromParent_Done,
     /* 117796 */ // Label 2194: @117796
     /* 117796 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(117868), // Rule ID 7099 //
     /* 117801 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117804 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117811 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117822 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117826 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117835 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117844 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15920>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117847 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117866 */   GIR_RootConstrainSelectedInstOperands,
     /* 117867 */   // GIR_Coverage, 7099,
     /* 117867 */   GIR_EraseRootFromParent_Done,
     /* 117868 */ // Label 2195: @117868
     /* 117868 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(117920), // Rule ID 320 //
     /* 117873 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117876 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117895 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117898 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117914 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117918 */   GIR_RootConstrainSelectedInstOperands,
     /* 117919 */   // GIR_Coverage, 320,
     /* 117919 */   GIR_EraseRootFromParent_Done,
     /* 117920 */ // Label 2196: @117920
     /* 117920 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(117971), // Rule ID 323 //
     /* 117925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117928 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117931 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117943 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117950 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117953 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117969 */   GIR_RootConstrainSelectedInstOperands,
     /* 117970 */   // GIR_Coverage, 323,
     /* 117970 */   GIR_EraseRootFromParent_Done,
     /* 117971 */ // Label 2197: @117971
     /* 117971 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(118030), // Rule ID 326 //
     /* 117976 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117979 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118005 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 118008 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 118014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118028 */   GIR_RootConstrainSelectedInstOperands,
     /* 118029 */   // GIR_Coverage, 326,
     /* 118029 */   GIR_EraseRootFromParent_Done,
     /* 118030 */ // Label 2198: @118030
     /* 118030 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(118089), // Rule ID 327 //
     /* 118035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118038 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118042 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118064 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 118067 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 118073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118087 */   GIR_RootConstrainSelectedInstOperands,
     /* 118088 */   // GIR_Coverage, 327,
     /* 118088 */   GIR_EraseRootFromParent_Done,
     /* 118089 */ // Label 2199: @118089
     /* 118089 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(118143), // Rule ID 7079 //
     /* 118094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118104 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118111 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118115 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118122 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15906>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 118125 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118141 */   GIR_RootConstrainSelectedInstOperands,
     /* 118142 */   // GIR_Coverage, 7079,
     /* 118142 */   GIR_EraseRootFromParent_Done,
     /* 118143 */ // Label 2200: @118143
     /* 118143 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(118197), // Rule ID 7080 //
     /* 118148 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118151 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118158 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118176 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15906>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 118179 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118191 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118195 */   GIR_RootConstrainSelectedInstOperands,
     /* 118196 */   // GIR_Coverage, 7080,
     /* 118196 */   GIR_EraseRootFromParent_Done,
     /* 118197 */ // Label 2201: @118197
     /* 118197 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(118251), // Rule ID 7084 //
     /* 118202 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118205 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118212 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118230 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15913>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 118233 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118245 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118249 */   GIR_RootConstrainSelectedInstOperands,
     /* 118250 */   // GIR_Coverage, 7084,
     /* 118250 */   GIR_EraseRootFromParent_Done,
     /* 118251 */ // Label 2202: @118251
     /* 118251 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(118305), // Rule ID 7085 //
     /* 118256 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118259 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118266 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118273 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118277 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118284 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15913>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 118287 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118299 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118303 */   GIR_RootConstrainSelectedInstOperands,
     /* 118304 */   // GIR_Coverage, 7085,
     /* 118304 */   GIR_EraseRootFromParent_Done,
     /* 118305 */ // Label 2203: @118305
     /* 118305 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(118359), // Rule ID 7089 //
     /* 118310 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118313 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118320 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118327 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118331 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 118338 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15920>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 118338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 118341 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118353 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118357 */   GIR_RootConstrainSelectedInstOperands,
     /* 118358 */   // GIR_Coverage, 7089,
     /* 118358 */   GIR_EraseRootFromParent_Done,
     /* 118359 */ // Label 2204: @118359
     /* 118359 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(118413), // Rule ID 7090 //
     /* 118364 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118367 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118374 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118381 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118392 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15920>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 118395 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118407 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118411 */   GIR_RootConstrainSelectedInstOperands,
     /* 118412 */   // GIR_Coverage, 7090,
     /* 118412 */   GIR_EraseRootFromParent_Done,
     /* 118413 */ // Label 2205: @118413
     /* 118413 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(118470), // Rule ID 7452 //
     /* 118418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118421 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118424 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118431 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118438 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118442 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118449 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15904>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 118452 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118468 */   GIR_RootConstrainSelectedInstOperands,
     /* 118469 */   // GIR_Coverage, 7452,
     /* 118469 */   GIR_EraseRootFromParent_Done,
     /* 118470 */ // Label 2206: @118470
     /* 118470 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(118527), // Rule ID 7453 //
     /* 118475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118478 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118481 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118488 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118499 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118506 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15911>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 118509 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118525 */   GIR_RootConstrainSelectedInstOperands,
     /* 118526 */   // GIR_Coverage, 7453,
     /* 118526 */   GIR_EraseRootFromParent_Done,
     /* 118527 */ // Label 2207: @118527
     /* 118527 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(118584), // Rule ID 7454 //
     /* 118532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118535 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118538 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118545 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118556 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118563 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15918>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 118566 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118578 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118582 */   GIR_RootConstrainSelectedInstOperands,
     /* 118583 */   // GIR_Coverage, 7454,
     /* 118583 */   GIR_EraseRootFromParent_Done,
     /* 118584 */ // Label 2208: @118584
     /* 118584 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(118621), // Rule ID 7076 //
     /* 118589 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118592 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118599 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118606 */   // MIs[0] ptr
     /* 118606 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118614 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15904>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 118619 */   GIR_RootConstrainSelectedInstOperands,
     /* 118620 */   // GIR_Coverage, 7076,
     /* 118620 */   GIR_Done,
     /* 118621 */ // Label 2209: @118621
     /* 118621 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(118658), // Rule ID 7081 //
     /* 118626 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118629 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118636 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118643 */   // MIs[0] ptr
     /* 118643 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118651 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15911>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 118656 */   GIR_RootConstrainSelectedInstOperands,
     /* 118657 */   // GIR_Coverage, 7081,
     /* 118657 */   GIR_Done,
     /* 118658 */ // Label 2210: @118658
     /* 118658 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(118695), // Rule ID 7086 //
     /* 118663 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118673 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118680 */   // MIs[0] ptr
     /* 118680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118688 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15918>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 118693 */   GIR_RootConstrainSelectedInstOperands,
     /* 118694 */   // GIR_Coverage, 7086,
     /* 118694 */   GIR_Done,
     /* 118695 */ // Label 2211: @118695
     /* 118695 */ GIM_Reject,
     /* 118696 */ // Label 2110: @118696
     /* 118696 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(118802), // Rule ID 4488 //
     /* 118701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118704 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118716 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118720 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118724 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118729 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118746 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118758 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118764 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118769 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118800 */   GIR_RootConstrainSelectedInstOperands,
     /* 118801 */   // GIR_Coverage, 4488,
     /* 118801 */   GIR_EraseRootFromParent_Done,
     /* 118802 */ // Label 2212: @118802
     /* 118802 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(118908), // Rule ID 4489 //
     /* 118807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118810 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118822 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118826 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118830 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118835 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118839 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118852 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118864 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118870 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118875 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118906 */   GIR_RootConstrainSelectedInstOperands,
     /* 118907 */   // GIR_Coverage, 4489,
     /* 118907 */   GIR_EraseRootFromParent_Done,
     /* 118908 */ // Label 2213: @118908
     /* 118908 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(119014), // Rule ID 4490 //
     /* 118913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118928 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118932 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118936 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118941 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118945 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118949 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118958 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118970 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118976 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118981 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119012 */   GIR_RootConstrainSelectedInstOperands,
     /* 119013 */   // GIR_Coverage, 4490,
     /* 119013 */   GIR_EraseRootFromParent_Done,
     /* 119014 */ // Label 2214: @119014
     /* 119014 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(119120), // Rule ID 4491 //
     /* 119019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119022 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119026 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119034 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119038 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119042 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119047 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119051 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119055 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119064 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119076 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119082 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119113 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119118 */   GIR_RootConstrainSelectedInstOperands,
     /* 119119 */   // GIR_Coverage, 4491,
     /* 119119 */   GIR_EraseRootFromParent_Done,
     /* 119120 */ // Label 2215: @119120
     /* 119120 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(119221), // Rule ID 4514 //
     /* 119125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119128 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119140 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119144 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119148 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119153 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119163 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119170 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119182 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119188 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119193 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119219 */   GIR_RootConstrainSelectedInstOperands,
     /* 119220 */   // GIR_Coverage, 4514,
     /* 119220 */   GIR_EraseRootFromParent_Done,
     /* 119221 */ // Label 2216: @119221
     /* 119221 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(119322), // Rule ID 4515 //
     /* 119226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119241 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119249 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119254 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119271 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119283 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119289 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119294 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119315 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119320 */   GIR_RootConstrainSelectedInstOperands,
     /* 119321 */   // GIR_Coverage, 4515,
     /* 119321 */   GIR_EraseRootFromParent_Done,
     /* 119322 */ // Label 2217: @119322
     /* 119322 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(119423), // Rule ID 4541 //
     /* 119327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119342 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119346 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119350 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119355 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119359 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119365 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119372 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119384 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119390 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119421 */   GIR_RootConstrainSelectedInstOperands,
     /* 119422 */   // GIR_Coverage, 4541,
     /* 119422 */   GIR_EraseRootFromParent_Done,
     /* 119423 */ // Label 2218: @119423
     /* 119423 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(119524), // Rule ID 4542 //
     /* 119428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119435 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119443 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119447 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119451 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119456 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119464 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119466 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119473 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119485 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119491 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119496 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119517 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119522 */   GIR_RootConstrainSelectedInstOperands,
     /* 119523 */   // GIR_Coverage, 4542,
     /* 119523 */   GIR_EraseRootFromParent_Done,
     /* 119524 */ // Label 2219: @119524
     /* 119524 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(119599), // Rule ID 6467 //
     /* 119529 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119532 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119544 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119548 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119552 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119557 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 119561 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119565 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119569 */   // MIs[2] Operand 1
     /* 119569 */   // No operand predicates
     /* 119569 */   // MIs[0] Rn
     /* 119569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119577 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119579 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 119582 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 119586 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 119589 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119591 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119597 */   GIR_RootConstrainSelectedInstOperands,
     /* 119598 */   // GIR_Coverage, 6467,
     /* 119598 */   GIR_EraseRootFromParent_Done,
     /* 119599 */ // Label 2220: @119599
     /* 119599 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(119674), // Rule ID 6468 //
     /* 119604 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119607 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119619 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119623 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119627 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119632 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 119636 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119640 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119644 */   // MIs[2] Operand 1
     /* 119644 */   // No operand predicates
     /* 119644 */   // MIs[0] Rn
     /* 119644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119652 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119654 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 119657 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 119661 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 119664 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119672 */   GIR_RootConstrainSelectedInstOperands,
     /* 119673 */   // GIR_Coverage, 6468,
     /* 119673 */   GIR_EraseRootFromParent_Done,
     /* 119674 */ // Label 2221: @119674
     /* 119674 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(119727), // Rule ID 301 //
     /* 119679 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119682 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119694 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119701 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 119704 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119725 */   GIR_RootConstrainSelectedInstOperands,
     /* 119726 */   // GIR_Coverage, 301,
     /* 119726 */   GIR_EraseRootFromParent_Done,
     /* 119727 */ // Label 2222: @119727
     /* 119727 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(119780), // Rule ID 302 //
     /* 119732 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119735 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119743 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119747 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119754 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 119757 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119774 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119778 */   GIR_RootConstrainSelectedInstOperands,
     /* 119779 */   // GIR_Coverage, 302,
     /* 119779 */   GIR_EraseRootFromParent_Done,
     /* 119780 */ // Label 2223: @119780
     /* 119780 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(119836), // Rule ID 309 //
     /* 119785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119788 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119791 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119810 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119813 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119834 */   GIR_RootConstrainSelectedInstOperands,
     /* 119835 */   // GIR_Coverage, 309,
     /* 119835 */   GIR_EraseRootFromParent_Done,
     /* 119836 */ // Label 2224: @119836
     /* 119836 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(119892), // Rule ID 310 //
     /* 119841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119866 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119869 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119886 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119890 */   GIR_RootConstrainSelectedInstOperands,
     /* 119891 */   // GIR_Coverage, 310,
     /* 119891 */   GIR_EraseRootFromParent_Done,
     /* 119892 */ // Label 2225: @119892
     /* 119892 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(119981), // Rule ID 4446 //
     /* 119897 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119900 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119919 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119926 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 119926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119938 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119949 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 119957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119975 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119979 */   GIR_RootConstrainSelectedInstOperands,
     /* 119980 */   // GIR_Coverage, 4446,
     /* 119980 */   GIR_EraseRootFromParent_Done,
     /* 119981 */ // Label 2226: @119981
     /* 119981 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(120070), // Rule ID 4447 //
     /* 119986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119989 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120015 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 120015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120027 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120033 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120038 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 120046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120068 */   GIR_RootConstrainSelectedInstOperands,
     /* 120069 */   // GIR_Coverage, 4447,
     /* 120069 */   GIR_EraseRootFromParent_Done,
     /* 120070 */ // Label 2227: @120070
     /* 120070 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(120159), // Rule ID 4448 //
     /* 120075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120078 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120093 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 120104 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 120104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120116 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 120135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120157 */   GIR_RootConstrainSelectedInstOperands,
     /* 120158 */   // GIR_Coverage, 4448,
     /* 120158 */   GIR_EraseRootFromParent_Done,
     /* 120159 */ // Label 2228: @120159
     /* 120159 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(120248), // Rule ID 4449 //
     /* 120164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120167 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 120193 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 120193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120205 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120211 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120216 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 120224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120246 */   GIR_RootConstrainSelectedInstOperands,
     /* 120247 */   // GIR_Coverage, 4449,
     /* 120247 */   GIR_EraseRootFromParent_Done,
     /* 120248 */ // Label 2229: @120248
     /* 120248 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(120337), // Rule ID 4450 //
     /* 120253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120256 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 120282 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 120282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120294 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120300 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120305 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 120313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120331 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120335 */   GIR_RootConstrainSelectedInstOperands,
     /* 120336 */   // GIR_Coverage, 4450,
     /* 120336 */   GIR_EraseRootFromParent_Done,
     /* 120337 */ // Label 2230: @120337
     /* 120337 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(120426), // Rule ID 4451 //
     /* 120342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120345 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 120371 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 120371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120383 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120389 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120394 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 120402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120424 */   GIR_RootConstrainSelectedInstOperands,
     /* 120425 */   // GIR_Coverage, 4451,
     /* 120425 */   GIR_EraseRootFromParent_Done,
     /* 120426 */ // Label 2231: @120426
     /* 120426 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(120479), // Rule ID 4462 //
     /* 120431 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120434 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120446 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120453 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120456 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120477 */   GIR_RootConstrainSelectedInstOperands,
     /* 120478 */   // GIR_Coverage, 4462,
     /* 120478 */   GIR_EraseRootFromParent_Done,
     /* 120479 */ // Label 2232: @120479
     /* 120479 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(120532), // Rule ID 4463 //
     /* 120484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120487 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120499 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120506 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120509 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120526 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120530 */   GIR_RootConstrainSelectedInstOperands,
     /* 120531 */   // GIR_Coverage, 4463,
     /* 120531 */   GIR_EraseRootFromParent_Done,
     /* 120532 */ // Label 2233: @120532
     /* 120532 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(120585), // Rule ID 4464 //
     /* 120537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120540 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120548 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120552 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120559 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120562 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120579 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120583 */   GIR_RootConstrainSelectedInstOperands,
     /* 120584 */   // GIR_Coverage, 4464,
     /* 120584 */   GIR_EraseRootFromParent_Done,
     /* 120585 */ // Label 2234: @120585
     /* 120585 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(120638), // Rule ID 4465 //
     /* 120590 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120601 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120605 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120612 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120615 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120632 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120636 */   GIR_RootConstrainSelectedInstOperands,
     /* 120637 */   // GIR_Coverage, 4465,
     /* 120637 */   GIR_EraseRootFromParent_Done,
     /* 120638 */ // Label 2235: @120638
     /* 120638 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(120690), // Rule ID 311 //
     /* 120643 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120646 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120654 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120658 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120665 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 120668 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 120674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120688 */   GIR_RootConstrainSelectedInstOperands,
     /* 120689 */   // GIR_Coverage, 311,
     /* 120689 */   GIR_EraseRootFromParent_Done,
     /* 120690 */ // Label 2236: @120690
     /* 120690 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(120741), // Rule ID 316 //
     /* 120695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120698 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120701 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120713 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120720 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120723 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120739 */   GIR_RootConstrainSelectedInstOperands,
     /* 120740 */   // GIR_Coverage, 316,
     /* 120740 */   GIR_EraseRootFromParent_Done,
     /* 120741 */ // Label 2237: @120741
     /* 120741 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(120789), // Rule ID 4492 //
     /* 120746 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120749 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120768 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120771 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120787 */   GIR_RootConstrainSelectedInstOperands,
     /* 120788 */   // GIR_Coverage, 4492,
     /* 120788 */   GIR_EraseRootFromParent_Done,
     /* 120789 */ // Label 2238: @120789
     /* 120789 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(120837), // Rule ID 4493 //
     /* 120794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120797 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120816 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120819 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120835 */   GIR_RootConstrainSelectedInstOperands,
     /* 120836 */   // GIR_Coverage, 4493,
     /* 120836 */   GIR_EraseRootFromParent_Done,
     /* 120837 */ // Label 2239: @120837
     /* 120837 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(120921), // Rule ID 4507 //
     /* 120842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120845 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120849 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120864 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 120871 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120871 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120874 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120878 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120883 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 120902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120919 */   GIR_RootConstrainSelectedInstOperands,
     /* 120920 */   // GIR_Coverage, 4507,
     /* 120920 */   GIR_EraseRootFromParent_Done,
     /* 120921 */ // Label 2240: @120921
     /* 120921 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(121005), // Rule ID 4508 //
     /* 120926 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120929 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120933 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120944 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120948 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120955 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120967 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 120986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121003 */   GIR_RootConstrainSelectedInstOperands,
     /* 121004 */   // GIR_Coverage, 4508,
     /* 121004 */   GIR_EraseRootFromParent_Done,
     /* 121005 */ // Label 2241: @121005
     /* 121005 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(121089), // Rule ID 4509 //
     /* 121010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121013 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121017 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121039 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 121039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121051 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 121070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121087 */   GIR_RootConstrainSelectedInstOperands,
     /* 121088 */   // GIR_Coverage, 4509,
     /* 121088 */   GIR_EraseRootFromParent_Done,
     /* 121089 */ // Label 2242: @121089
     /* 121089 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(121166), // Rule ID 7100 //
     /* 121094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121104 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121107 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121111 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121115 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121119 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121137 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15927>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121140 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121159 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121164 */   GIR_RootConstrainSelectedInstOperands,
     /* 121165 */   // GIR_Coverage, 7100,
     /* 121165 */   GIR_EraseRootFromParent_Done,
     /* 121166 */ // Label 2243: @121166
     /* 121166 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(121243), // Rule ID 7101 //
     /* 121171 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121174 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121181 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121184 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121192 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121196 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121205 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121207 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121214 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15927>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121217 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121241 */   GIR_RootConstrainSelectedInstOperands,
     /* 121242 */   // GIR_Coverage, 7101,
     /* 121242 */   GIR_EraseRootFromParent_Done,
     /* 121243 */ // Label 2244: @121243
     /* 121243 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(121302), // Rule ID 7092 //
     /* 121248 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121251 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121258 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121265 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121269 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121276 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15927>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 121279 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121296 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121300 */   GIR_RootConstrainSelectedInstOperands,
     /* 121301 */   // GIR_Coverage, 7092,
     /* 121301 */   GIR_EraseRootFromParent_Done,
     /* 121302 */ // Label 2245: @121302
     /* 121302 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(121361), // Rule ID 7093 //
     /* 121307 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121310 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121317 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121335 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15927>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 121338 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121355 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121359 */   GIR_RootConstrainSelectedInstOperands,
     /* 121360 */   // GIR_Coverage, 7093,
     /* 121360 */   GIR_EraseRootFromParent_Done,
     /* 121361 */ // Label 2246: @121361
     /* 121361 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(121433), // Rule ID 7102 //
     /* 121366 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121369 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121376 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121387 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121391 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121400 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121402 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121409 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15927>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 121409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121412 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121426 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121431 */   GIR_RootConstrainSelectedInstOperands,
     /* 121432 */   // GIR_Coverage, 7102,
     /* 121432 */   GIR_EraseRootFromParent_Done,
     /* 121433 */ // Label 2247: @121433
     /* 121433 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(121505), // Rule ID 7103 //
     /* 121438 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121441 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121448 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121451 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121455 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121459 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121463 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121474 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121481 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15927>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121484 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121503 */   GIR_RootConstrainSelectedInstOperands,
     /* 121504 */   // GIR_Coverage, 7103,
     /* 121504 */   GIR_EraseRootFromParent_Done,
     /* 121505 */ // Label 2248: @121505
     /* 121505 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(121602), // Rule ID 7444 //
     /* 121510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121513 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121516 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121523 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121534 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121538 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 121542 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 121546 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 121550 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 121554 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121559 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 121563 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121567 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 121571 */   // MIs[3] Operand 1
     /* 121571 */   // No operand predicates
     /* 121571 */   // MIs[0] Rn
     /* 121571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121579 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 121581 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15925>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 121581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121584 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 121588 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 121591 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121593 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 121600 */   GIR_RootConstrainSelectedInstOperands,
     /* 121601 */   // GIR_Coverage, 7444,
     /* 121601 */   GIR_EraseRootFromParent_Done,
     /* 121602 */ // Label 2249: @121602
     /* 121602 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(121654), // Rule ID 319 //
     /* 121607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121629 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 121632 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 121638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121652 */   GIR_RootConstrainSelectedInstOperands,
     /* 121653 */   // GIR_Coverage, 319,
     /* 121653 */   GIR_EraseRootFromParent_Done,
     /* 121654 */ // Label 2250: @121654
     /* 121654 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(121705), // Rule ID 324 //
     /* 121659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121665 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121673 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121684 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121687 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121703 */   GIR_RootConstrainSelectedInstOperands,
     /* 121704 */   // GIR_Coverage, 324,
     /* 121704 */   GIR_EraseRootFromParent_Done,
     /* 121705 */ // Label 2251: @121705
     /* 121705 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(121759), // Rule ID 7094 //
     /* 121710 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121713 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121720 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121727 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121731 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121738 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15927>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 121741 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121753 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121757 */   GIR_RootConstrainSelectedInstOperands,
     /* 121758 */   // GIR_Coverage, 7094,
     /* 121758 */   GIR_EraseRootFromParent_Done,
     /* 121759 */ // Label 2252: @121759
     /* 121759 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(121813), // Rule ID 7095 //
     /* 121764 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121767 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121774 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121792 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15927>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 121795 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121811 */   GIR_RootConstrainSelectedInstOperands,
     /* 121812 */   // GIR_Coverage, 7095,
     /* 121812 */   GIR_EraseRootFromParent_Done,
     /* 121813 */ // Label 2253: @121813
     /* 121813 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(121870), // Rule ID 7455 //
     /* 121818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 121821 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121824 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121831 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121838 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121842 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121849 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15925>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 121852 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121868 */   GIR_RootConstrainSelectedInstOperands,
     /* 121869 */   // GIR_Coverage, 7455,
     /* 121869 */   GIR_EraseRootFromParent_Done,
     /* 121870 */ // Label 2254: @121870
     /* 121870 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(121918), // Rule ID 4516 //
     /* 121875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121878 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121897 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121900 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121916 */   GIR_RootConstrainSelectedInstOperands,
     /* 121917 */   // GIR_Coverage, 4516,
     /* 121917 */   GIR_EraseRootFromParent_Done,
     /* 121918 */ // Label 2255: @121918
     /* 121918 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(121966), // Rule ID 4517 //
     /* 121923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121926 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121945 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121948 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121964 */   GIR_RootConstrainSelectedInstOperands,
     /* 121965 */   // GIR_Coverage, 4517,
     /* 121965 */   GIR_EraseRootFromParent_Done,
     /* 121966 */ // Label 2256: @121966
     /* 121966 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(122050), // Rule ID 4532 //
     /* 121971 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121974 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121989 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121993 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 122000 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122012 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 122018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 122031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122048 */   GIR_RootConstrainSelectedInstOperands,
     /* 122049 */   // GIR_Coverage, 4532,
     /* 122049 */   GIR_EraseRootFromParent_Done,
     /* 122050 */ // Label 2257: @122050
     /* 122050 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(122134), // Rule ID 4533 //
     /* 122055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122058 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 122084 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122096 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 122102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 122115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122132 */   GIR_RootConstrainSelectedInstOperands,
     /* 122133 */   // GIR_Coverage, 4533,
     /* 122133 */   GIR_EraseRootFromParent_Done,
     /* 122134 */ // Label 2258: @122134
     /* 122134 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(122218), // Rule ID 4534 //
     /* 122139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122142 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122146 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 122168 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122180 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 122186 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122191 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 122199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122216 */   GIR_RootConstrainSelectedInstOperands,
     /* 122217 */   // GIR_Coverage, 4534,
     /* 122217 */   GIR_EraseRootFromParent_Done,
     /* 122218 */ // Label 2259: @122218
     /* 122218 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(122302), // Rule ID 7443 //
     /* 122223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 122226 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122229 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122236 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 122243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 122247 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 122251 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122255 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122260 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 122264 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122268 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 122272 */   // MIs[2] Operand 1
     /* 122272 */   // No operand predicates
     /* 122272 */   // MIs[0] Rn
     /* 122272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122280 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122282 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15925>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 122282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 122285 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 122289 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 122292 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122300 */   GIR_RootConstrainSelectedInstOperands,
     /* 122301 */   // GIR_Coverage, 7443,
     /* 122301 */   GIR_EraseRootFromParent_Done,
     /* 122302 */ // Label 2260: @122302
     /* 122302 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(122400), // Rule ID 7445 //
     /* 122307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 122310 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122313 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 122327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 122331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 122335 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122340 */   // MIs[0] Rn
     /* 122340 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122348 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122350 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15925>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 122350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 122353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122362 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122365 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 122369 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 122372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122377 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 122385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122391 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122398 */   GIR_RootConstrainSelectedInstOperands,
     /* 122399 */   // GIR_Coverage, 7445,
     /* 122399 */   GIR_EraseRootFromParent_Done,
     /* 122400 */ // Label 2261: @122400
     /* 122400 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(122437), // Rule ID 7091 //
     /* 122405 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122408 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122415 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122422 */   // MIs[0] ptr
     /* 122422 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122430 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15925>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 122430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 122435 */   GIR_RootConstrainSelectedInstOperands,
     /* 122436 */   // GIR_Coverage, 7091,
     /* 122436 */   GIR_Done,
     /* 122437 */ // Label 2262: @122437
     /* 122437 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(122464), // Rule ID 6417 //
     /* 122442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122445 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122449 */   // MIs[0] Rn
     /* 122449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122457 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 122462 */   GIR_RootConstrainSelectedInstOperands,
     /* 122463 */   // GIR_Coverage, 6417,
     /* 122463 */   GIR_Done,
     /* 122464 */ // Label 2263: @122464
     /* 122464 */ GIM_Reject,
     /* 122465 */ // Label 2111: @122465
     /* 122465 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(122670),
     /* 122470 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122473 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122481 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122485 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(122526), // Rule ID 4444 //
     /* 122490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 122493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122500 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122503 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122524 */     GIR_RootConstrainSelectedInstOperands,
     /* 122525 */     // GIR_Coverage, 4444,
     /* 122525 */     GIR_EraseRootFromParent_Done,
     /* 122526 */   // Label 2265: @122526
     /* 122526 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(122567), // Rule ID 4445 //
     /* 122531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 122534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122541 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122544 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122565 */     GIR_RootConstrainSelectedInstOperands,
     /* 122566 */     // GIR_Coverage, 4445,
     /* 122566 */     GIR_EraseRootFromParent_Done,
     /* 122567 */   // Label 2266: @122567
     /* 122567 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(122600), // Rule ID 4499 //
     /* 122572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122579 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122582 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122598 */     GIR_RootConstrainSelectedInstOperands,
     /* 122599 */     // GIR_Coverage, 4499,
     /* 122599 */     GIR_EraseRootFromParent_Done,
     /* 122600 */   // Label 2267: @122600
     /* 122600 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(122633), // Rule ID 4523 //
     /* 122605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122612 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122615 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122631 */     GIR_RootConstrainSelectedInstOperands,
     /* 122632 */     // GIR_Coverage, 4523,
     /* 122632 */     GIR_EraseRootFromParent_Done,
     /* 122633 */   // Label 2268: @122633
     /* 122633 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(122669), // Rule ID 325 //
     /* 122638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122648 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122651 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122667 */     GIR_RootConstrainSelectedInstOperands,
     /* 122668 */     // GIR_Coverage, 325,
     /* 122668 */     GIR_EraseRootFromParent_Done,
     /* 122669 */   // Label 2269: @122669
     /* 122669 */   GIM_Reject,
     /* 122670 */ // Label 2264: @122670
     /* 122670 */ GIM_Reject,
     /* 122671 */ // Label 2112: @122671
     /* 122671 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(123076),
     /* 122676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122683 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(122732), // Rule ID 4452 //
     /* 122688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122706 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122709 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122730 */     GIR_RootConstrainSelectedInstOperands,
     /* 122731 */     // GIR_Coverage, 4452,
     /* 122731 */     GIR_EraseRootFromParent_Done,
     /* 122732 */   // Label 2271: @122732
     /* 122732 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(122781), // Rule ID 4453 //
     /* 122737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122755 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122758 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122779 */     GIR_RootConstrainSelectedInstOperands,
     /* 122780 */     // GIR_Coverage, 4453,
     /* 122780 */     GIR_EraseRootFromParent_Done,
     /* 122781 */   // Label 2272: @122781
     /* 122781 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(122830), // Rule ID 4454 //
     /* 122786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122804 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122807 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122828 */     GIR_RootConstrainSelectedInstOperands,
     /* 122829 */     // GIR_Coverage, 4454,
     /* 122829 */     GIR_EraseRootFromParent_Done,
     /* 122830 */   // Label 2273: @122830
     /* 122830 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(122879), // Rule ID 4455 //
     /* 122835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122853 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122856 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122877 */     GIR_RootConstrainSelectedInstOperands,
     /* 122878 */     // GIR_Coverage, 4455,
     /* 122878 */     GIR_EraseRootFromParent_Done,
     /* 122879 */   // Label 2274: @122879
     /* 122879 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(122923), // Rule ID 4494 //
     /* 122884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122902 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122905 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122921 */     GIR_RootConstrainSelectedInstOperands,
     /* 122922 */     // GIR_Coverage, 4494,
     /* 122922 */     GIR_EraseRootFromParent_Done,
     /* 122923 */   // Label 2275: @122923
     /* 122923 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(122967), // Rule ID 4497 //
     /* 122928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122946 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122949 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122965 */     GIR_RootConstrainSelectedInstOperands,
     /* 122966 */     // GIR_Coverage, 4497,
     /* 122966 */     GIR_EraseRootFromParent_Done,
     /* 122967 */   // Label 2276: @122967
     /* 122967 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(123011), // Rule ID 4518 //
     /* 122972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122990 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122993 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123009 */     GIR_RootConstrainSelectedInstOperands,
     /* 123010 */     // GIR_Coverage, 4518,
     /* 123010 */     GIR_EraseRootFromParent_Done,
     /* 123011 */   // Label 2277: @123011
     /* 123011 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(123055), // Rule ID 4521 //
     /* 123016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123034 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123037 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123053 */     GIR_RootConstrainSelectedInstOperands,
     /* 123054 */     // GIR_Coverage, 4521,
     /* 123054 */     GIR_EraseRootFromParent_Done,
     /* 123055 */   // Label 2278: @123055
     /* 123055 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(123075), // Rule ID 6416 //
     /* 123060 */     // MIs[0] Rn
     /* 123060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123068 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 123073 */     GIR_RootConstrainSelectedInstOperands,
     /* 123074 */     // GIR_Coverage, 6416,
     /* 123074 */     GIR_Done,
     /* 123075 */   // Label 2279: @123075
     /* 123075 */   GIM_Reject,
     /* 123076 */ // Label 2270: @123076
     /* 123076 */ GIM_Reject,
     /* 123077 */ // Label 2113: @123077
     /* 123077 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(123526),
     /* 123082 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123085 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123089 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(123138), // Rule ID 4466 //
     /* 123094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123112 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123115 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123136 */     GIR_RootConstrainSelectedInstOperands,
     /* 123137 */     // GIR_Coverage, 4466,
     /* 123137 */     GIR_EraseRootFromParent_Done,
     /* 123138 */   // Label 2281: @123138
     /* 123138 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(123187), // Rule ID 4467 //
     /* 123143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123161 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123164 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123185 */     GIR_RootConstrainSelectedInstOperands,
     /* 123186 */     // GIR_Coverage, 4467,
     /* 123186 */     GIR_EraseRootFromParent_Done,
     /* 123187 */   // Label 2282: @123187
     /* 123187 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(123236), // Rule ID 4468 //
     /* 123192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123210 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123213 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123234 */     GIR_RootConstrainSelectedInstOperands,
     /* 123235 */     // GIR_Coverage, 4468,
     /* 123235 */     GIR_EraseRootFromParent_Done,
     /* 123236 */   // Label 2283: @123236
     /* 123236 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(123285), // Rule ID 4469 //
     /* 123241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123259 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123262 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123283 */     GIR_RootConstrainSelectedInstOperands,
     /* 123284 */     // GIR_Coverage, 4469,
     /* 123284 */     GIR_EraseRootFromParent_Done,
     /* 123285 */   // Label 2284: @123285
     /* 123285 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(123329), // Rule ID 4501 //
     /* 123290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123308 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123311 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123327 */     GIR_RootConstrainSelectedInstOperands,
     /* 123328 */     // GIR_Coverage, 4501,
     /* 123328 */     GIR_EraseRootFromParent_Done,
     /* 123329 */   // Label 2285: @123329
     /* 123329 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(123373), // Rule ID 4505 //
     /* 123334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123352 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123355 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123371 */     GIR_RootConstrainSelectedInstOperands,
     /* 123372 */     // GIR_Coverage, 4505,
     /* 123372 */     GIR_EraseRootFromParent_Done,
     /* 123373 */   // Label 2286: @123373
     /* 123373 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(123417), // Rule ID 4525 //
     /* 123378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123396 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123399 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123415 */     GIR_RootConstrainSelectedInstOperands,
     /* 123416 */     // GIR_Coverage, 4525,
     /* 123416 */     GIR_EraseRootFromParent_Done,
     /* 123417 */   // Label 2287: @123417
     /* 123417 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(123461), // Rule ID 4529 //
     /* 123422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123440 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123443 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123459 */     GIR_RootConstrainSelectedInstOperands,
     /* 123460 */     // GIR_Coverage, 4529,
     /* 123460 */     GIR_EraseRootFromParent_Done,
     /* 123461 */   // Label 2288: @123461
     /* 123461 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(123505), // Rule ID 4530 //
     /* 123466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123484 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123487 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123503 */     GIR_RootConstrainSelectedInstOperands,
     /* 123504 */     // GIR_Coverage, 4530,
     /* 123504 */     GIR_EraseRootFromParent_Done,
     /* 123505 */   // Label 2289: @123505
     /* 123505 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(123525), // Rule ID 6413 //
     /* 123510 */     // MIs[0] Rn
     /* 123510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123518 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 123523 */     GIR_RootConstrainSelectedInstOperands,
     /* 123524 */     // GIR_Coverage, 6413,
     /* 123524 */     GIR_Done,
     /* 123525 */   // Label 2290: @123525
     /* 123525 */   GIM_Reject,
     /* 123526 */ // Label 2280: @123526
     /* 123526 */ GIM_Reject,
     /* 123527 */ // Label 2114: @123527
     /* 123527 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(123932),
     /* 123532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123535 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123539 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(123588), // Rule ID 4456 //
     /* 123544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123562 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123565 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123586 */     GIR_RootConstrainSelectedInstOperands,
     /* 123587 */     // GIR_Coverage, 4456,
     /* 123587 */     GIR_EraseRootFromParent_Done,
     /* 123588 */   // Label 2292: @123588
     /* 123588 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(123637), // Rule ID 4457 //
     /* 123593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123611 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123614 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123635 */     GIR_RootConstrainSelectedInstOperands,
     /* 123636 */     // GIR_Coverage, 4457,
     /* 123636 */     GIR_EraseRootFromParent_Done,
     /* 123637 */   // Label 2293: @123637
     /* 123637 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(123686), // Rule ID 4460 //
     /* 123642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123660 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123663 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123684 */     GIR_RootConstrainSelectedInstOperands,
     /* 123685 */     // GIR_Coverage, 4460,
     /* 123685 */     GIR_EraseRootFromParent_Done,
     /* 123686 */   // Label 2294: @123686
     /* 123686 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(123735), // Rule ID 4461 //
     /* 123691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123709 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123712 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123733 */     GIR_RootConstrainSelectedInstOperands,
     /* 123734 */     // GIR_Coverage, 4461,
     /* 123734 */     GIR_EraseRootFromParent_Done,
     /* 123735 */   // Label 2295: @123735
     /* 123735 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(123779), // Rule ID 4496 //
     /* 123740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123758 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123761 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123777 */     GIR_RootConstrainSelectedInstOperands,
     /* 123778 */     // GIR_Coverage, 4496,
     /* 123778 */     GIR_EraseRootFromParent_Done,
     /* 123779 */   // Label 2296: @123779
     /* 123779 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(123823), // Rule ID 4498 //
     /* 123784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123802 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123805 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123821 */     GIR_RootConstrainSelectedInstOperands,
     /* 123822 */     // GIR_Coverage, 4498,
     /* 123822 */     GIR_EraseRootFromParent_Done,
     /* 123823 */   // Label 2297: @123823
     /* 123823 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(123867), // Rule ID 4520 //
     /* 123828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123846 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123849 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123865 */     GIR_RootConstrainSelectedInstOperands,
     /* 123866 */     // GIR_Coverage, 4520,
     /* 123866 */     GIR_EraseRootFromParent_Done,
     /* 123867 */   // Label 2298: @123867
     /* 123867 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(123911), // Rule ID 4522 //
     /* 123872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123890 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123893 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123909 */     GIR_RootConstrainSelectedInstOperands,
     /* 123910 */     // GIR_Coverage, 4522,
     /* 123910 */     GIR_EraseRootFromParent_Done,
     /* 123911 */   // Label 2299: @123911
     /* 123911 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(123931), // Rule ID 6415 //
     /* 123916 */     // MIs[0] Rn
     /* 123916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123924 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 123929 */     GIR_RootConstrainSelectedInstOperands,
     /* 123930 */     // GIR_Coverage, 6415,
     /* 123930 */     GIR_Done,
     /* 123931 */   // Label 2300: @123931
     /* 123931 */   GIM_Reject,
     /* 123932 */ // Label 2291: @123932
     /* 123932 */ GIM_Reject,
     /* 123933 */ // Label 2115: @123933
     /* 123933 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(124338),
     /* 123938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123941 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123945 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(123994), // Rule ID 4470 //
     /* 123950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123968 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123971 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123992 */     GIR_RootConstrainSelectedInstOperands,
     /* 123993 */     // GIR_Coverage, 4470,
     /* 123993 */     GIR_EraseRootFromParent_Done,
     /* 123994 */   // Label 2302: @123994
     /* 123994 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(124043), // Rule ID 4471 //
     /* 123999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124017 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124020 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124041 */     GIR_RootConstrainSelectedInstOperands,
     /* 124042 */     // GIR_Coverage, 4471,
     /* 124042 */     GIR_EraseRootFromParent_Done,
     /* 124043 */   // Label 2303: @124043
     /* 124043 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(124092), // Rule ID 4472 //
     /* 124048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124066 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124069 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124090 */     GIR_RootConstrainSelectedInstOperands,
     /* 124091 */     // GIR_Coverage, 4472,
     /* 124091 */     GIR_EraseRootFromParent_Done,
     /* 124092 */   // Label 2304: @124092
     /* 124092 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(124141), // Rule ID 4473 //
     /* 124097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124115 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124118 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124139 */     GIR_RootConstrainSelectedInstOperands,
     /* 124140 */     // GIR_Coverage, 4473,
     /* 124140 */     GIR_EraseRootFromParent_Done,
     /* 124141 */   // Label 2305: @124141
     /* 124141 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(124185), // Rule ID 4500 //
     /* 124146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124164 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124167 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124183 */     GIR_RootConstrainSelectedInstOperands,
     /* 124184 */     // GIR_Coverage, 4500,
     /* 124184 */     GIR_EraseRootFromParent_Done,
     /* 124185 */   // Label 2306: @124185
     /* 124185 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(124229), // Rule ID 4504 //
     /* 124190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124208 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124211 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124227 */     GIR_RootConstrainSelectedInstOperands,
     /* 124228 */     // GIR_Coverage, 4504,
     /* 124228 */     GIR_EraseRootFromParent_Done,
     /* 124229 */   // Label 2307: @124229
     /* 124229 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(124273), // Rule ID 4524 //
     /* 124234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124252 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124255 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124271 */     GIR_RootConstrainSelectedInstOperands,
     /* 124272 */     // GIR_Coverage, 4524,
     /* 124272 */     GIR_EraseRootFromParent_Done,
     /* 124273 */   // Label 2308: @124273
     /* 124273 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(124317), // Rule ID 4528 //
     /* 124278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124296 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124299 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124315 */     GIR_RootConstrainSelectedInstOperands,
     /* 124316 */     // GIR_Coverage, 4528,
     /* 124316 */     GIR_EraseRootFromParent_Done,
     /* 124317 */   // Label 2309: @124317
     /* 124317 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(124337), // Rule ID 6412 //
     /* 124322 */     // MIs[0] Rn
     /* 124322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124330 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 124335 */     GIR_RootConstrainSelectedInstOperands,
     /* 124336 */     // GIR_Coverage, 6412,
     /* 124336 */     GIR_Done,
     /* 124337 */   // Label 2310: @124337
     /* 124337 */   GIM_Reject,
     /* 124338 */ // Label 2301: @124338
     /* 124338 */ GIM_Reject,
     /* 124339 */ // Label 2116: @124339
     /* 124339 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(124558),
     /* 124344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124351 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(124400), // Rule ID 4458 //
     /* 124356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124374 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 124377 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124398 */     GIR_RootConstrainSelectedInstOperands,
     /* 124399 */     // GIR_Coverage, 4458,
     /* 124399 */     GIR_EraseRootFromParent_Done,
     /* 124400 */   // Label 2312: @124400
     /* 124400 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(124449), // Rule ID 4459 //
     /* 124405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124423 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 124426 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124447 */     GIR_RootConstrainSelectedInstOperands,
     /* 124448 */     // GIR_Coverage, 4459,
     /* 124448 */     GIR_EraseRootFromParent_Done,
     /* 124449 */   // Label 2313: @124449
     /* 124449 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(124493), // Rule ID 4495 //
     /* 124454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124472 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 124475 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124491 */     GIR_RootConstrainSelectedInstOperands,
     /* 124492 */     // GIR_Coverage, 4495,
     /* 124492 */     GIR_EraseRootFromParent_Done,
     /* 124493 */   // Label 2314: @124493
     /* 124493 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(124537), // Rule ID 4519 //
     /* 124498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124516 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 124519 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124535 */     GIR_RootConstrainSelectedInstOperands,
     /* 124536 */     // GIR_Coverage, 4519,
     /* 124536 */     GIR_EraseRootFromParent_Done,
     /* 124537 */   // Label 2315: @124537
     /* 124537 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(124557), // Rule ID 6414 //
     /* 124542 */     // MIs[0] Rn
     /* 124542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124550 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 124555 */     GIR_RootConstrainSelectedInstOperands,
     /* 124556 */     // GIR_Coverage, 6414,
     /* 124556 */     GIR_Done,
     /* 124557 */   // Label 2316: @124557
     /* 124557 */   GIM_Reject,
     /* 124558 */ // Label 2311: @124558
     /* 124558 */ GIM_Reject,
     /* 124559 */ // Label 2117: @124559
     /* 124559 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(124964),
     /* 124564 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124567 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124571 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(124620), // Rule ID 4474 //
     /* 124576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124594 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124597 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124618 */     GIR_RootConstrainSelectedInstOperands,
     /* 124619 */     // GIR_Coverage, 4474,
     /* 124619 */     GIR_EraseRootFromParent_Done,
     /* 124620 */   // Label 2318: @124620
     /* 124620 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(124669), // Rule ID 4475 //
     /* 124625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124643 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124646 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124667 */     GIR_RootConstrainSelectedInstOperands,
     /* 124668 */     // GIR_Coverage, 4475,
     /* 124668 */     GIR_EraseRootFromParent_Done,
     /* 124669 */   // Label 2319: @124669
     /* 124669 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(124718), // Rule ID 4478 //
     /* 124674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124692 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124695 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124716 */     GIR_RootConstrainSelectedInstOperands,
     /* 124717 */     // GIR_Coverage, 4478,
     /* 124717 */     GIR_EraseRootFromParent_Done,
     /* 124718 */   // Label 2320: @124718
     /* 124718 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(124767), // Rule ID 4479 //
     /* 124723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124741 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124744 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124765 */     GIR_RootConstrainSelectedInstOperands,
     /* 124766 */     // GIR_Coverage, 4479,
     /* 124766 */     GIR_EraseRootFromParent_Done,
     /* 124767 */   // Label 2321: @124767
     /* 124767 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(124811), // Rule ID 4503 //
     /* 124772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124790 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124793 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124809 */     GIR_RootConstrainSelectedInstOperands,
     /* 124810 */     // GIR_Coverage, 4503,
     /* 124810 */     GIR_EraseRootFromParent_Done,
     /* 124811 */   // Label 2322: @124811
     /* 124811 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(124855), // Rule ID 4506 //
     /* 124816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124834 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124837 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124853 */     GIR_RootConstrainSelectedInstOperands,
     /* 124854 */     // GIR_Coverage, 4506,
     /* 124854 */     GIR_EraseRootFromParent_Done,
     /* 124855 */   // Label 2323: @124855
     /* 124855 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(124899), // Rule ID 4527 //
     /* 124860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124878 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124881 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124897 */     GIR_RootConstrainSelectedInstOperands,
     /* 124898 */     // GIR_Coverage, 4527,
     /* 124898 */     GIR_EraseRootFromParent_Done,
     /* 124899 */   // Label 2324: @124899
     /* 124899 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(124943), // Rule ID 4531 //
     /* 124904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124922 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124925 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124941 */     GIR_RootConstrainSelectedInstOperands,
     /* 124942 */     // GIR_Coverage, 4531,
     /* 124942 */     GIR_EraseRootFromParent_Done,
     /* 124943 */   // Label 2325: @124943
     /* 124943 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(124963), // Rule ID 6411 //
     /* 124948 */     // MIs[0] Rn
     /* 124948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124956 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 124961 */     GIR_RootConstrainSelectedInstOperands,
     /* 124962 */     // GIR_Coverage, 6411,
     /* 124962 */     GIR_Done,
     /* 124963 */   // Label 2326: @124963
     /* 124963 */   GIM_Reject,
     /* 124964 */ // Label 2317: @124964
     /* 124964 */ GIM_Reject,
     /* 124965 */ // Label 2118: @124965
     /* 124965 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(125184),
     /* 124970 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124973 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124977 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(125026), // Rule ID 4476 //
     /* 124982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125000 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 125003 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125024 */     GIR_RootConstrainSelectedInstOperands,
     /* 125025 */     // GIR_Coverage, 4476,
     /* 125025 */     GIR_EraseRootFromParent_Done,
     /* 125026 */   // Label 2328: @125026
     /* 125026 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(125075), // Rule ID 4477 //
     /* 125031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 125034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125049 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 125052 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125073 */     GIR_RootConstrainSelectedInstOperands,
     /* 125074 */     // GIR_Coverage, 4477,
     /* 125074 */     GIR_EraseRootFromParent_Done,
     /* 125075 */   // Label 2329: @125075
     /* 125075 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(125119), // Rule ID 4502 //
     /* 125080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125098 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 125101 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125117 */     GIR_RootConstrainSelectedInstOperands,
     /* 125118 */     // GIR_Coverage, 4502,
     /* 125118 */     GIR_EraseRootFromParent_Done,
     /* 125119 */   // Label 2330: @125119
     /* 125119 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(125163), // Rule ID 4526 //
     /* 125124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125142 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 125145 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125161 */     GIR_RootConstrainSelectedInstOperands,
     /* 125162 */     // GIR_Coverage, 4526,
     /* 125162 */     GIR_EraseRootFromParent_Done,
     /* 125163 */   // Label 2331: @125163
     /* 125163 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(125183), // Rule ID 6410 //
     /* 125168 */     // MIs[0] Rn
     /* 125168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125176 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 125176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 125181 */     GIR_RootConstrainSelectedInstOperands,
     /* 125182 */     // GIR_Coverage, 6410,
     /* 125182 */     GIR_Done,
     /* 125183 */   // Label 2332: @125183
     /* 125183 */   GIM_Reject,
     /* 125184 */ // Label 2327: @125184
     /* 125184 */ GIM_Reject,
     /* 125185 */ // Label 2119: @125185
     /* 125185 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(125244), // Rule ID 10892 //
     /* 125190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125200 */   // MIs[0] base
     /* 125200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125208 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125220 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 125228 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125233 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125242 */   GIR_RootConstrainSelectedInstOperands,
     /* 125243 */   // GIR_Coverage, 10892,
     /* 125243 */   GIR_EraseRootFromParent_Done,
     /* 125244 */ // Label 2333: @125244
     /* 125244 */ GIM_Reject,
     /* 125245 */ // Label 2120: @125245
     /* 125245 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(125304), // Rule ID 10898 //
     /* 125250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125260 */   // MIs[0] base
     /* 125260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125268 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125280 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 125288 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125293 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125302 */   GIR_RootConstrainSelectedInstOperands,
     /* 125303 */   // GIR_Coverage, 10898,
     /* 125303 */   GIR_EraseRootFromParent_Done,
     /* 125304 */ // Label 2334: @125304
     /* 125304 */ GIM_Reject,
     /* 125305 */ // Label 2121: @125305
     /* 125305 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(125474),
     /* 125310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125321 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(125369), // Rule ID 10883 //
     /* 125326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125333 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 125353 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125358 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125367 */     GIR_RootConstrainSelectedInstOperands,
     /* 125368 */     // GIR_Coverage, 10883,
     /* 125368 */     GIR_EraseRootFromParent_Done,
     /* 125369 */   // Label 2336: @125369
     /* 125369 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(125417), // Rule ID 10901 //
     /* 125374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125381 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125393 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 125401 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125406 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125415 */     GIR_RootConstrainSelectedInstOperands,
     /* 125416 */     // GIR_Coverage, 10901,
     /* 125416 */     GIR_EraseRootFromParent_Done,
     /* 125417 */   // Label 2337: @125417
     /* 125417 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(125445), // Rule ID 11013 //
     /* 125422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125429 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125432 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125434 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125443 */     GIR_RootConstrainSelectedInstOperands,
     /* 125444 */     // GIR_Coverage, 11013,
     /* 125444 */     GIR_EraseRootFromParent_Done,
     /* 125445 */   // Label 2338: @125445
     /* 125445 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(125473), // Rule ID 11025 //
     /* 125450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125457 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125460 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125462 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125471 */     GIR_RootConstrainSelectedInstOperands,
     /* 125472 */     // GIR_Coverage, 11025,
     /* 125472 */     GIR_EraseRootFromParent_Done,
     /* 125473 */   // Label 2339: @125473
     /* 125473 */   GIM_Reject,
     /* 125474 */ // Label 2335: @125474
     /* 125474 */ GIM_Reject,
     /* 125475 */ // Label 2122: @125475
     /* 125475 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(125534), // Rule ID 10889 //
     /* 125480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125486 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125490 */   // MIs[0] base
     /* 125490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125498 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125510 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 125518 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125523 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125532 */   GIR_RootConstrainSelectedInstOperands,
     /* 125533 */   // GIR_Coverage, 10889,
     /* 125533 */   GIR_EraseRootFromParent_Done,
     /* 125534 */ // Label 2340: @125534
     /* 125534 */ GIM_Reject,
     /* 125535 */ // Label 2123: @125535
     /* 125535 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(125704),
     /* 125540 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125543 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125547 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125551 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(125599), // Rule ID 10877 //
     /* 125556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125563 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 125583 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125588 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125597 */     GIR_RootConstrainSelectedInstOperands,
     /* 125598 */     // GIR_Coverage, 10877,
     /* 125598 */     GIR_EraseRootFromParent_Done,
     /* 125599 */   // Label 2342: @125599
     /* 125599 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(125647), // Rule ID 10895 //
     /* 125604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125611 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 125631 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125636 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125645 */     GIR_RootConstrainSelectedInstOperands,
     /* 125646 */     // GIR_Coverage, 10895,
     /* 125646 */     GIR_EraseRootFromParent_Done,
     /* 125647 */   // Label 2343: @125647
     /* 125647 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(125675), // Rule ID 11009 //
     /* 125652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125659 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125662 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125664 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125673 */     GIR_RootConstrainSelectedInstOperands,
     /* 125674 */     // GIR_Coverage, 11009,
     /* 125674 */     GIR_EraseRootFromParent_Done,
     /* 125675 */   // Label 2344: @125675
     /* 125675 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(125703), // Rule ID 11021 //
     /* 125680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125687 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125690 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125692 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125701 */     GIR_RootConstrainSelectedInstOperands,
     /* 125702 */     // GIR_Coverage, 11021,
     /* 125702 */     GIR_EraseRootFromParent_Done,
     /* 125703 */   // Label 2345: @125703
     /* 125703 */   GIM_Reject,
     /* 125704 */ // Label 2341: @125704
     /* 125704 */ GIM_Reject,
     /* 125705 */ // Label 2124: @125705
     /* 125705 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(125874),
     /* 125710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125721 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(125769), // Rule ID 10868 //
     /* 125726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125733 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125745 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 125753 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125758 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125767 */     GIR_RootConstrainSelectedInstOperands,
     /* 125768 */     // GIR_Coverage, 10868,
     /* 125768 */     GIR_EraseRootFromParent_Done,
     /* 125769 */   // Label 2347: @125769
     /* 125769 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(125817), // Rule ID 10886 //
     /* 125774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125781 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125793 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 125801 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125806 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125815 */     GIR_RootConstrainSelectedInstOperands,
     /* 125816 */     // GIR_Coverage, 10886,
     /* 125816 */     GIR_EraseRootFromParent_Done,
     /* 125817 */   // Label 2348: @125817
     /* 125817 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(125845), // Rule ID 11005 //
     /* 125822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125829 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125832 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125834 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125843 */     GIR_RootConstrainSelectedInstOperands,
     /* 125844 */     // GIR_Coverage, 11005,
     /* 125844 */     GIR_EraseRootFromParent_Done,
     /* 125845 */   // Label 2349: @125845
     /* 125845 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(125873), // Rule ID 11017 //
     /* 125850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125857 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125860 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125862 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125871 */     GIR_RootConstrainSelectedInstOperands,
     /* 125872 */     // GIR_Coverage, 11017,
     /* 125872 */     GIR_EraseRootFromParent_Done,
     /* 125873 */   // Label 2350: @125873
     /* 125873 */   GIM_Reject,
     /* 125874 */ // Label 2346: @125874
     /* 125874 */ GIM_Reject,
     /* 125875 */ // Label 2125: @125875
     /* 125875 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(125918), // Rule ID 2430 //
     /* 125880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 125894 */   // MIs[0] base
     /* 125894 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125902 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 125905 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 125907 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125916 */   GIR_RootConstrainSelectedInstOperands,
     /* 125917 */   // GIR_Coverage, 2430,
     /* 125917 */   GIR_EraseRootFromParent_Done,
     /* 125918 */ // Label 2351: @125918
     /* 125918 */ GIM_Reject,
     /* 125919 */ // Label 2126: @125919
     /* 125919 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(126012),
     /* 125924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125927 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125935 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(125983), // Rule ID 10854 //
     /* 125940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125947 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 125967 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125972 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125981 */     GIR_RootConstrainSelectedInstOperands,
     /* 125982 */     // GIR_Coverage, 10854,
     /* 125982 */     GIR_EraseRootFromParent_Done,
     /* 125983 */   // Label 2353: @125983
     /* 125983 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(126011), // Rule ID 11001 //
     /* 125988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125995 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125998 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 126000 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126009 */     GIR_RootConstrainSelectedInstOperands,
     /* 126010 */     // GIR_Coverage, 11001,
     /* 126010 */     GIR_EraseRootFromParent_Done,
     /* 126011 */   // Label 2354: @126011
     /* 126011 */   GIM_Reject,
     /* 126012 */ // Label 2352: @126012
     /* 126012 */ GIM_Reject,
     /* 126013 */ // Label 2127: @126013
     /* 126013 */ GIM_Reject,
     /* 126014 */ // Label 20: @126014
     /* 126014 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2357*/ GIMT_Encode4(127364),
     /* 126025 */ /*GILLT_s32*//*Label 2355*/ GIMT_Encode4(126033),
     /* 126029 */ /*GILLT_s64*//*Label 2356*/ GIMT_Encode4(127051),
     /* 126033 */ // Label 2355: @126033
     /* 126033 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(127050),
     /* 126038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126044 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(126099), // Rule ID 7314 //
     /* 126049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126066 */     // MIs[0] Rn
     /* 126066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126082 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 126085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126097 */     GIR_RootConstrainSelectedInstOperands,
     /* 126098 */     // GIR_Coverage, 7314,
     /* 126098 */     GIR_EraseRootFromParent_Done,
     /* 126099 */   // Label 2359: @126099
     /* 126099 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(126154), // Rule ID 7315 //
     /* 126104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126121 */     // MIs[0] Rn
     /* 126121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126137 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 126140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126152 */     GIR_RootConstrainSelectedInstOperands,
     /* 126153 */     // GIR_Coverage, 7315,
     /* 126153 */     GIR_EraseRootFromParent_Done,
     /* 126154 */   // Label 2360: @126154
     /* 126154 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(126209), // Rule ID 7316 //
     /* 126159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126162 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126169 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126176 */     // MIs[0] Rn
     /* 126176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126192 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 126195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126207 */     GIR_RootConstrainSelectedInstOperands,
     /* 126208 */     // GIR_Coverage, 7316,
     /* 126208 */     GIR_EraseRootFromParent_Done,
     /* 126209 */   // Label 2361: @126209
     /* 126209 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(126264), // Rule ID 7317 //
     /* 126214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126217 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126224 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126231 */     // MIs[0] Rn
     /* 126231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126247 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 126250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126262 */     GIR_RootConstrainSelectedInstOperands,
     /* 126263 */     // GIR_Coverage, 7317,
     /* 126263 */     GIR_EraseRootFromParent_Done,
     /* 126264 */   // Label 2362: @126264
     /* 126264 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(126319), // Rule ID 7318 //
     /* 126269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126286 */     // MIs[0] Rn
     /* 126286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126302 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 126305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126317 */     GIR_RootConstrainSelectedInstOperands,
     /* 126318 */     // GIR_Coverage, 7318,
     /* 126318 */     GIR_EraseRootFromParent_Done,
     /* 126319 */   // Label 2363: @126319
     /* 126319 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(126374), // Rule ID 7319 //
     /* 126324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126341 */     // MIs[0] Rn
     /* 126341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126357 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 126360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126372 */     GIR_RootConstrainSelectedInstOperands,
     /* 126373 */     // GIR_Coverage, 7319,
     /* 126373 */     GIR_EraseRootFromParent_Done,
     /* 126374 */   // Label 2364: @126374
     /* 126374 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(126429), // Rule ID 7320 //
     /* 126379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126382 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126396 */     // MIs[0] Rn
     /* 126396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126412 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 126415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126427 */     GIR_RootConstrainSelectedInstOperands,
     /* 126428 */     // GIR_Coverage, 7320,
     /* 126428 */     GIR_EraseRootFromParent_Done,
     /* 126429 */   // Label 2365: @126429
     /* 126429 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(126484), // Rule ID 7321 //
     /* 126434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126444 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126451 */     // MIs[0] Rn
     /* 126451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126467 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 126470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126482 */     GIR_RootConstrainSelectedInstOperands,
     /* 126483 */     // GIR_Coverage, 7321,
     /* 126483 */     GIR_EraseRootFromParent_Done,
     /* 126484 */   // Label 2366: @126484
     /* 126484 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(126539), // Rule ID 7322 //
     /* 126489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126506 */     // MIs[0] Rn
     /* 126506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126522 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 126525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126537 */     GIR_RootConstrainSelectedInstOperands,
     /* 126538 */     // GIR_Coverage, 7322,
     /* 126538 */     GIR_EraseRootFromParent_Done,
     /* 126539 */   // Label 2367: @126539
     /* 126539 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(126594), // Rule ID 7323 //
     /* 126544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126561 */     // MIs[0] Rn
     /* 126561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126577 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 126580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126592 */     GIR_RootConstrainSelectedInstOperands,
     /* 126593 */     // GIR_Coverage, 7323,
     /* 126593 */     GIR_EraseRootFromParent_Done,
     /* 126594 */   // Label 2368: @126594
     /* 126594 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(126649), // Rule ID 7324 //
     /* 126599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126602 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126616 */     // MIs[0] Rn
     /* 126616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126632 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 126635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126647 */     GIR_RootConstrainSelectedInstOperands,
     /* 126648 */     // GIR_Coverage, 7324,
     /* 126648 */     GIR_EraseRootFromParent_Done,
     /* 126649 */   // Label 2369: @126649
     /* 126649 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(126704), // Rule ID 7325 //
     /* 126654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126671 */     // MIs[0] Rn
     /* 126671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126687 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 126690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126702 */     GIR_RootConstrainSelectedInstOperands,
     /* 126703 */     // GIR_Coverage, 7325,
     /* 126703 */     GIR_EraseRootFromParent_Done,
     /* 126704 */   // Label 2370: @126704
     /* 126704 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(126759), // Rule ID 7326 //
     /* 126709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126726 */     // MIs[0] Rn
     /* 126726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126742 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 126745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126757 */     GIR_RootConstrainSelectedInstOperands,
     /* 126758 */     // GIR_Coverage, 7326,
     /* 126758 */     GIR_EraseRootFromParent_Done,
     /* 126759 */   // Label 2371: @126759
     /* 126759 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(126814), // Rule ID 7327 //
     /* 126764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126767 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126781 */     // MIs[0] Rn
     /* 126781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126797 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 126800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126812 */     GIR_RootConstrainSelectedInstOperands,
     /* 126813 */     // GIR_Coverage, 7327,
     /* 126813 */     GIR_EraseRootFromParent_Done,
     /* 126814 */   // Label 2372: @126814
     /* 126814 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(126869), // Rule ID 7328 //
     /* 126819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126836 */     // MIs[0] Rn
     /* 126836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126852 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 126855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126867 */     GIR_RootConstrainSelectedInstOperands,
     /* 126868 */     // GIR_Coverage, 7328,
     /* 126868 */     GIR_EraseRootFromParent_Done,
     /* 126869 */   // Label 2373: @126869
     /* 126869 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(126929), // Rule ID 13141 //
     /* 126874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126888 */     // MIs[0] addr
     /* 126888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126904 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 126910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126912 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126917 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126919 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126921 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126927 */     GIR_RootConstrainSelectedInstOperands,
     /* 126928 */     // GIR_Coverage, 13141,
     /* 126928 */     GIR_EraseRootFromParent_Done,
     /* 126929 */   // Label 2374: @126929
     /* 126929 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(126989), // Rule ID 13142 //
     /* 126934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126948 */     // MIs[0] addr
     /* 126948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126964 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 126970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126972 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126977 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126979 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126981 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126987 */     GIR_RootConstrainSelectedInstOperands,
     /* 126988 */     // GIR_Coverage, 13142,
     /* 126988 */     GIR_EraseRootFromParent_Done,
     /* 126989 */   // Label 2375: @126989
     /* 126989 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(127049), // Rule ID 13143 //
     /* 126994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127008 */     // MIs[0] addr
     /* 127008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127024 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 127024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 127030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127032 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 127037 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 127039 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 127041 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 127043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127047 */     GIR_RootConstrainSelectedInstOperands,
     /* 127048 */     // GIR_Coverage, 13143,
     /* 127048 */     GIR_EraseRootFromParent_Done,
     /* 127049 */   // Label 2376: @127049
     /* 127049 */   GIM_Reject,
     /* 127050 */ // Label 2358: @127050
     /* 127050 */ GIM_Reject,
     /* 127051 */ // Label 2356: @127051
     /* 127051 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(127363),
     /* 127056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 127062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127069 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(127117), // Rule ID 2589 //
     /* 127074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127084 */     // MIs[0] Rn
     /* 127084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127100 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 127103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127115 */     GIR_RootConstrainSelectedInstOperands,
     /* 127116 */     // GIR_Coverage, 2589,
     /* 127116 */     GIR_EraseRootFromParent_Done,
     /* 127117 */   // Label 2378: @127117
     /* 127117 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(127165), // Rule ID 2590 //
     /* 127122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127132 */     // MIs[0] Rn
     /* 127132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127148 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 127151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127163 */     GIR_RootConstrainSelectedInstOperands,
     /* 127164 */     // GIR_Coverage, 2590,
     /* 127164 */     GIR_EraseRootFromParent_Done,
     /* 127165 */   // Label 2379: @127165
     /* 127165 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(127213), // Rule ID 2591 //
     /* 127170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127180 */     // MIs[0] Rn
     /* 127180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127196 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 127199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127211 */     GIR_RootConstrainSelectedInstOperands,
     /* 127212 */     // GIR_Coverage, 2591,
     /* 127212 */     GIR_EraseRootFromParent_Done,
     /* 127213 */   // Label 2380: @127213
     /* 127213 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(127261), // Rule ID 2592 //
     /* 127218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127228 */     // MIs[0] Rn
     /* 127228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127244 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 127247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127259 */     GIR_RootConstrainSelectedInstOperands,
     /* 127260 */     // GIR_Coverage, 2592,
     /* 127260 */     GIR_EraseRootFromParent_Done,
     /* 127261 */   // Label 2381: @127261
     /* 127261 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(127309), // Rule ID 2593 //
     /* 127266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127276 */     // MIs[0] Rn
     /* 127276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127292 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 127295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127307 */     GIR_RootConstrainSelectedInstOperands,
     /* 127308 */     // GIR_Coverage, 2593,
     /* 127308 */     GIR_EraseRootFromParent_Done,
     /* 127309 */   // Label 2382: @127309
     /* 127309 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(127362), // Rule ID 13144 //
     /* 127314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 127317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127321 */     // MIs[0] addr
     /* 127321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127337 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 127337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 127343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127345 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 127350 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 127352 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 127354 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 127356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127360 */     GIR_RootConstrainSelectedInstOperands,
     /* 127361 */     // GIR_Coverage, 13144,
     /* 127361 */     GIR_EraseRootFromParent_Done,
     /* 127362 */   // Label 2383: @127362
     /* 127362 */   GIM_Reject,
     /* 127363 */ // Label 2377: @127363
     /* 127363 */ GIM_Reject,
     /* 127364 */ // Label 2357: @127364
     /* 127364 */ GIM_Reject,
     /* 127365 */ // Label 21: @127365
     /* 127365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2386*/ GIMT_Encode4(128356),
     /* 127376 */ /*GILLT_s32*//*Label 2384*/ GIMT_Encode4(127384),
     /* 127380 */ /*GILLT_s64*//*Label 2385*/ GIMT_Encode4(128129),
     /* 127384 */ // Label 2384: @127384
     /* 127384 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(128128),
     /* 127389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127392 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(127441), // Rule ID 7299 //
     /* 127397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127414 */     // MIs[0] Rn
     /* 127414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127426 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 127429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127439 */     GIR_RootConstrainSelectedInstOperands,
     /* 127440 */     // GIR_Coverage, 7299,
     /* 127440 */     GIR_EraseRootFromParent_Done,
     /* 127441 */   // Label 2388: @127441
     /* 127441 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(127490), // Rule ID 7300 //
     /* 127446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127463 */     // MIs[0] Rn
     /* 127463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127475 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 127478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127488 */     GIR_RootConstrainSelectedInstOperands,
     /* 127489 */     // GIR_Coverage, 7300,
     /* 127489 */     GIR_EraseRootFromParent_Done,
     /* 127490 */   // Label 2389: @127490
     /* 127490 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(127539), // Rule ID 7301 //
     /* 127495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127512 */     // MIs[0] Rn
     /* 127512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127524 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 127527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127537 */     GIR_RootConstrainSelectedInstOperands,
     /* 127538 */     // GIR_Coverage, 7301,
     /* 127538 */     GIR_EraseRootFromParent_Done,
     /* 127539 */   // Label 2390: @127539
     /* 127539 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(127588), // Rule ID 7302 //
     /* 127544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127561 */     // MIs[0] Rn
     /* 127561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127573 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 127576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127586 */     GIR_RootConstrainSelectedInstOperands,
     /* 127587 */     // GIR_Coverage, 7302,
     /* 127587 */     GIR_EraseRootFromParent_Done,
     /* 127588 */   // Label 2391: @127588
     /* 127588 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(127637), // Rule ID 7303 //
     /* 127593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127610 */     // MIs[0] Rn
     /* 127610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127622 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 127625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127635 */     GIR_RootConstrainSelectedInstOperands,
     /* 127636 */     // GIR_Coverage, 7303,
     /* 127636 */     GIR_EraseRootFromParent_Done,
     /* 127637 */   // Label 2392: @127637
     /* 127637 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(127686), // Rule ID 7304 //
     /* 127642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127659 */     // MIs[0] Rn
     /* 127659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127671 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 127674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127684 */     GIR_RootConstrainSelectedInstOperands,
     /* 127685 */     // GIR_Coverage, 7304,
     /* 127685 */     GIR_EraseRootFromParent_Done,
     /* 127686 */   // Label 2393: @127686
     /* 127686 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(127735), // Rule ID 7305 //
     /* 127691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127708 */     // MIs[0] Rn
     /* 127708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127720 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 127723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127733 */     GIR_RootConstrainSelectedInstOperands,
     /* 127734 */     // GIR_Coverage, 7305,
     /* 127734 */     GIR_EraseRootFromParent_Done,
     /* 127735 */   // Label 2394: @127735
     /* 127735 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(127784), // Rule ID 7306 //
     /* 127740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127757 */     // MIs[0] Rn
     /* 127757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127769 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 127772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127782 */     GIR_RootConstrainSelectedInstOperands,
     /* 127783 */     // GIR_Coverage, 7306,
     /* 127783 */     GIR_EraseRootFromParent_Done,
     /* 127784 */   // Label 2395: @127784
     /* 127784 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(127833), // Rule ID 7307 //
     /* 127789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127806 */     // MIs[0] Rn
     /* 127806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127818 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 127821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127831 */     GIR_RootConstrainSelectedInstOperands,
     /* 127832 */     // GIR_Coverage, 7307,
     /* 127832 */     GIR_EraseRootFromParent_Done,
     /* 127833 */   // Label 2396: @127833
     /* 127833 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(127882), // Rule ID 7308 //
     /* 127838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127848 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127855 */     // MIs[0] Rn
     /* 127855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127867 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 127870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127880 */     GIR_RootConstrainSelectedInstOperands,
     /* 127881 */     // GIR_Coverage, 7308,
     /* 127881 */     GIR_EraseRootFromParent_Done,
     /* 127882 */   // Label 2397: @127882
     /* 127882 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(127931), // Rule ID 7309 //
     /* 127887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127890 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127897 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127904 */     // MIs[0] Rn
     /* 127904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127916 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 127919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127929 */     GIR_RootConstrainSelectedInstOperands,
     /* 127930 */     // GIR_Coverage, 7309,
     /* 127930 */     GIR_EraseRootFromParent_Done,
     /* 127931 */   // Label 2398: @127931
     /* 127931 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(127980), // Rule ID 7310 //
     /* 127936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127953 */     // MIs[0] Rn
     /* 127953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127965 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 127968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127978 */     GIR_RootConstrainSelectedInstOperands,
     /* 127979 */     // GIR_Coverage, 7310,
     /* 127979 */     GIR_EraseRootFromParent_Done,
     /* 127980 */   // Label 2399: @127980
     /* 127980 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(128029), // Rule ID 7311 //
     /* 127985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128002 */     // MIs[0] Rn
     /* 128002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128014 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 128017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128027 */     GIR_RootConstrainSelectedInstOperands,
     /* 128028 */     // GIR_Coverage, 7311,
     /* 128028 */     GIR_EraseRootFromParent_Done,
     /* 128029 */   // Label 2400: @128029
     /* 128029 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(128078), // Rule ID 7312 //
     /* 128034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128037 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128044 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128051 */     // MIs[0] Rn
     /* 128051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128063 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 128066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128076 */     GIR_RootConstrainSelectedInstOperands,
     /* 128077 */     // GIR_Coverage, 7312,
     /* 128077 */     GIR_EraseRootFromParent_Done,
     /* 128078 */   // Label 2401: @128078
     /* 128078 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(128127), // Rule ID 7313 //
     /* 128083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128086 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128093 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128100 */     // MIs[0] Rn
     /* 128100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128112 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 128115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128125 */     GIR_RootConstrainSelectedInstOperands,
     /* 128126 */     // GIR_Coverage, 7313,
     /* 128126 */     GIR_EraseRootFromParent_Done,
     /* 128127 */   // Label 2402: @128127
     /* 128127 */   GIM_Reject,
     /* 128128 */ // Label 2387: @128128
     /* 128128 */ GIM_Reject,
     /* 128129 */ // Label 2385: @128129
     /* 128129 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(128355),
     /* 128134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128144 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(128186), // Rule ID 7294 //
     /* 128149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128159 */     // MIs[0] Rn
     /* 128159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128171 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 128174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128184 */     GIR_RootConstrainSelectedInstOperands,
     /* 128185 */     // GIR_Coverage, 7294,
     /* 128185 */     GIR_EraseRootFromParent_Done,
     /* 128186 */   // Label 2404: @128186
     /* 128186 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(128228), // Rule ID 7295 //
     /* 128191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128201 */     // MIs[0] Rn
     /* 128201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128213 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 128216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128226 */     GIR_RootConstrainSelectedInstOperands,
     /* 128227 */     // GIR_Coverage, 7295,
     /* 128227 */     GIR_EraseRootFromParent_Done,
     /* 128228 */   // Label 2405: @128228
     /* 128228 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(128270), // Rule ID 7296 //
     /* 128233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128243 */     // MIs[0] Rn
     /* 128243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128255 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 128258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128268 */     GIR_RootConstrainSelectedInstOperands,
     /* 128269 */     // GIR_Coverage, 7296,
     /* 128269 */     GIR_EraseRootFromParent_Done,
     /* 128270 */   // Label 2406: @128270
     /* 128270 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(128312), // Rule ID 7297 //
     /* 128275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128285 */     // MIs[0] Rn
     /* 128285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128297 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 128300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128310 */     GIR_RootConstrainSelectedInstOperands,
     /* 128311 */     // GIR_Coverage, 7297,
     /* 128311 */     GIR_EraseRootFromParent_Done,
     /* 128312 */   // Label 2407: @128312
     /* 128312 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(128354), // Rule ID 7298 //
     /* 128317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128327 */     // MIs[0] Rn
     /* 128327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128339 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 128342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128352 */     GIR_RootConstrainSelectedInstOperands,
     /* 128353 */     // GIR_Coverage, 7298,
     /* 128353 */     GIR_EraseRootFromParent_Done,
     /* 128354 */   // Label 2408: @128354
     /* 128354 */   GIM_Reject,
     /* 128355 */ // Label 2403: @128355
     /* 128355 */ GIM_Reject,
     /* 128356 */ // Label 2386: @128356
     /* 128356 */ GIM_Reject,
     /* 128357 */ // Label 22: @128357
     /* 128357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2411*/ GIMT_Encode4(129348),
     /* 128368 */ /*GILLT_s32*//*Label 2409*/ GIMT_Encode4(128376),
     /* 128372 */ /*GILLT_s64*//*Label 2410*/ GIMT_Encode4(129121),
     /* 128376 */ // Label 2409: @128376
     /* 128376 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(129120),
     /* 128381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128384 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(128433), // Rule ID 7139 //
     /* 128389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128406 */     // MIs[0] Rn
     /* 128406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128418 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 128421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128431 */     GIR_RootConstrainSelectedInstOperands,
     /* 128432 */     // GIR_Coverage, 7139,
     /* 128432 */     GIR_EraseRootFromParent_Done,
     /* 128433 */   // Label 2413: @128433
     /* 128433 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(128482), // Rule ID 7140 //
     /* 128438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128455 */     // MIs[0] Rn
     /* 128455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128467 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 128470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128480 */     GIR_RootConstrainSelectedInstOperands,
     /* 128481 */     // GIR_Coverage, 7140,
     /* 128481 */     GIR_EraseRootFromParent_Done,
     /* 128482 */   // Label 2414: @128482
     /* 128482 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(128531), // Rule ID 7141 //
     /* 128487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128504 */     // MIs[0] Rn
     /* 128504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128516 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 128519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128529 */     GIR_RootConstrainSelectedInstOperands,
     /* 128530 */     // GIR_Coverage, 7141,
     /* 128530 */     GIR_EraseRootFromParent_Done,
     /* 128531 */   // Label 2415: @128531
     /* 128531 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(128580), // Rule ID 7142 //
     /* 128536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128553 */     // MIs[0] Rn
     /* 128553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128565 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128578 */     GIR_RootConstrainSelectedInstOperands,
     /* 128579 */     // GIR_Coverage, 7142,
     /* 128579 */     GIR_EraseRootFromParent_Done,
     /* 128580 */   // Label 2416: @128580
     /* 128580 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(128629), // Rule ID 7143 //
     /* 128585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128602 */     // MIs[0] Rn
     /* 128602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128614 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128627 */     GIR_RootConstrainSelectedInstOperands,
     /* 128628 */     // GIR_Coverage, 7143,
     /* 128628 */     GIR_EraseRootFromParent_Done,
     /* 128629 */   // Label 2417: @128629
     /* 128629 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(128678), // Rule ID 7144 //
     /* 128634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128651 */     // MIs[0] Rn
     /* 128651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128663 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 128666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128676 */     GIR_RootConstrainSelectedInstOperands,
     /* 128677 */     // GIR_Coverage, 7144,
     /* 128677 */     GIR_EraseRootFromParent_Done,
     /* 128678 */   // Label 2418: @128678
     /* 128678 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(128727), // Rule ID 7145 //
     /* 128683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128700 */     // MIs[0] Rn
     /* 128700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128712 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 128715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128725 */     GIR_RootConstrainSelectedInstOperands,
     /* 128726 */     // GIR_Coverage, 7145,
     /* 128726 */     GIR_EraseRootFromParent_Done,
     /* 128727 */   // Label 2419: @128727
     /* 128727 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(128776), // Rule ID 7146 //
     /* 128732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128749 */     // MIs[0] Rn
     /* 128749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128761 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 128764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128774 */     GIR_RootConstrainSelectedInstOperands,
     /* 128775 */     // GIR_Coverage, 7146,
     /* 128775 */     GIR_EraseRootFromParent_Done,
     /* 128776 */   // Label 2420: @128776
     /* 128776 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(128825), // Rule ID 7147 //
     /* 128781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128798 */     // MIs[0] Rn
     /* 128798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128810 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128823 */     GIR_RootConstrainSelectedInstOperands,
     /* 128824 */     // GIR_Coverage, 7147,
     /* 128824 */     GIR_EraseRootFromParent_Done,
     /* 128825 */   // Label 2421: @128825
     /* 128825 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(128874), // Rule ID 7148 //
     /* 128830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128833 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128847 */     // MIs[0] Rn
     /* 128847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128859 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128872 */     GIR_RootConstrainSelectedInstOperands,
     /* 128873 */     // GIR_Coverage, 7148,
     /* 128873 */     GIR_EraseRootFromParent_Done,
     /* 128874 */   // Label 2422: @128874
     /* 128874 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(128923), // Rule ID 7149 //
     /* 128879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128882 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128896 */     // MIs[0] Rn
     /* 128896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128908 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 128911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128921 */     GIR_RootConstrainSelectedInstOperands,
     /* 128922 */     // GIR_Coverage, 7149,
     /* 128922 */     GIR_EraseRootFromParent_Done,
     /* 128923 */   // Label 2423: @128923
     /* 128923 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(128972), // Rule ID 7150 //
     /* 128928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128931 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128945 */     // MIs[0] Rn
     /* 128945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128957 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 128960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128970 */     GIR_RootConstrainSelectedInstOperands,
     /* 128971 */     // GIR_Coverage, 7150,
     /* 128971 */     GIR_EraseRootFromParent_Done,
     /* 128972 */   // Label 2424: @128972
     /* 128972 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(129021), // Rule ID 7151 //
     /* 128977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128994 */     // MIs[0] Rn
     /* 128994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129006 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 129009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129019 */     GIR_RootConstrainSelectedInstOperands,
     /* 129020 */     // GIR_Coverage, 7151,
     /* 129020 */     GIR_EraseRootFromParent_Done,
     /* 129021 */   // Label 2425: @129021
     /* 129021 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(129070), // Rule ID 7152 //
     /* 129026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129029 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129036 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129043 */     // MIs[0] Rn
     /* 129043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129055 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129068 */     GIR_RootConstrainSelectedInstOperands,
     /* 129069 */     // GIR_Coverage, 7152,
     /* 129069 */     GIR_EraseRootFromParent_Done,
     /* 129070 */   // Label 2426: @129070
     /* 129070 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(129119), // Rule ID 7153 //
     /* 129075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129085 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129092 */     // MIs[0] Rn
     /* 129092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129104 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129117 */     GIR_RootConstrainSelectedInstOperands,
     /* 129118 */     // GIR_Coverage, 7153,
     /* 129118 */     GIR_EraseRootFromParent_Done,
     /* 129119 */   // Label 2427: @129119
     /* 129119 */   GIM_Reject,
     /* 129120 */ // Label 2412: @129120
     /* 129120 */ GIM_Reject,
     /* 129121 */ // Label 2410: @129121
     /* 129121 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(129347),
     /* 129126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129129 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129136 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(129178), // Rule ID 2579 //
     /* 129141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129151 */     // MIs[0] Rn
     /* 129151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129163 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 129166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129176 */     GIR_RootConstrainSelectedInstOperands,
     /* 129177 */     // GIR_Coverage, 2579,
     /* 129177 */     GIR_EraseRootFromParent_Done,
     /* 129178 */   // Label 2429: @129178
     /* 129178 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(129220), // Rule ID 2580 //
     /* 129183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129193 */     // MIs[0] Rn
     /* 129193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129205 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 129208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129218 */     GIR_RootConstrainSelectedInstOperands,
     /* 129219 */     // GIR_Coverage, 2580,
     /* 129219 */     GIR_EraseRootFromParent_Done,
     /* 129220 */   // Label 2430: @129220
     /* 129220 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(129262), // Rule ID 2581 //
     /* 129225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129235 */     // MIs[0] Rn
     /* 129235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129247 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 129250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129260 */     GIR_RootConstrainSelectedInstOperands,
     /* 129261 */     // GIR_Coverage, 2581,
     /* 129261 */     GIR_EraseRootFromParent_Done,
     /* 129262 */   // Label 2431: @129262
     /* 129262 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(129304), // Rule ID 2582 //
     /* 129267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129277 */     // MIs[0] Rn
     /* 129277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129289 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129302 */     GIR_RootConstrainSelectedInstOperands,
     /* 129303 */     // GIR_Coverage, 2582,
     /* 129303 */     GIR_EraseRootFromParent_Done,
     /* 129304 */   // Label 2432: @129304
     /* 129304 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(129346), // Rule ID 2583 //
     /* 129309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129319 */     // MIs[0] Rn
     /* 129319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129331 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129344 */     GIR_RootConstrainSelectedInstOperands,
     /* 129345 */     // GIR_Coverage, 2583,
     /* 129345 */     GIR_EraseRootFromParent_Done,
     /* 129346 */   // Label 2433: @129346
     /* 129346 */   GIM_Reject,
     /* 129347 */ // Label 2428: @129347
     /* 129347 */ GIM_Reject,
     /* 129348 */ // Label 2411: @129348
     /* 129348 */ GIM_Reject,
     /* 129349 */ // Label 23: @129349
     /* 129349 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2436*/ GIMT_Encode4(130840),
     /* 129360 */ /*GILLT_s32*//*Label 2434*/ GIMT_Encode4(129368),
     /* 129364 */ /*GILLT_s64*//*Label 2435*/ GIMT_Encode4(130488),
     /* 129368 */ // Label 2434: @129368
     /* 129368 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(130487),
     /* 129373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129376 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(129450), // Rule ID 7334 //
     /* 129381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129398 */     // MIs[0] Rn
     /* 129398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129410 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129422 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 129437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129448 */     GIR_RootConstrainSelectedInstOperands,
     /* 129449 */     // GIR_Coverage, 7334,
     /* 129449 */     GIR_EraseRootFromParent_Done,
     /* 129450 */   // Label 2438: @129450
     /* 129450 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(129524), // Rule ID 7335 //
     /* 129455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129472 */     // MIs[0] Rn
     /* 129472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129484 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129496 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 129511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129522 */     GIR_RootConstrainSelectedInstOperands,
     /* 129523 */     // GIR_Coverage, 7335,
     /* 129523 */     GIR_EraseRootFromParent_Done,
     /* 129524 */   // Label 2439: @129524
     /* 129524 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(129598), // Rule ID 7336 //
     /* 129529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129546 */     // MIs[0] Rn
     /* 129546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129558 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129570 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 129585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129596 */     GIR_RootConstrainSelectedInstOperands,
     /* 129597 */     // GIR_Coverage, 7336,
     /* 129597 */     GIR_EraseRootFromParent_Done,
     /* 129598 */   // Label 2440: @129598
     /* 129598 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(129672), // Rule ID 7337 //
     /* 129603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129620 */     // MIs[0] Rn
     /* 129620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129632 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129644 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 129659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129670 */     GIR_RootConstrainSelectedInstOperands,
     /* 129671 */     // GIR_Coverage, 7337,
     /* 129671 */     GIR_EraseRootFromParent_Done,
     /* 129672 */   // Label 2441: @129672
     /* 129672 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(129746), // Rule ID 7338 //
     /* 129677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129694 */     // MIs[0] Rn
     /* 129694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129706 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129718 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 129733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129744 */     GIR_RootConstrainSelectedInstOperands,
     /* 129745 */     // GIR_Coverage, 7338,
     /* 129745 */     GIR_EraseRootFromParent_Done,
     /* 129746 */   // Label 2442: @129746
     /* 129746 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(129820), // Rule ID 7339 //
     /* 129751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129768 */     // MIs[0] Rn
     /* 129768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129780 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129792 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 129807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129818 */     GIR_RootConstrainSelectedInstOperands,
     /* 129819 */     // GIR_Coverage, 7339,
     /* 129819 */     GIR_EraseRootFromParent_Done,
     /* 129820 */   // Label 2443: @129820
     /* 129820 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(129894), // Rule ID 7340 //
     /* 129825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129842 */     // MIs[0] Rn
     /* 129842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129854 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129866 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 129881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129892 */     GIR_RootConstrainSelectedInstOperands,
     /* 129893 */     // GIR_Coverage, 7340,
     /* 129893 */     GIR_EraseRootFromParent_Done,
     /* 129894 */   // Label 2444: @129894
     /* 129894 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(129968), // Rule ID 7341 //
     /* 129899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129916 */     // MIs[0] Rn
     /* 129916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129928 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129940 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 129955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129966 */     GIR_RootConstrainSelectedInstOperands,
     /* 129967 */     // GIR_Coverage, 7341,
     /* 129967 */     GIR_EraseRootFromParent_Done,
     /* 129968 */   // Label 2445: @129968
     /* 129968 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(130042), // Rule ID 7342 //
     /* 129973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129976 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129990 */     // MIs[0] Rn
     /* 129990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130002 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130014 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 130029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130040 */     GIR_RootConstrainSelectedInstOperands,
     /* 130041 */     // GIR_Coverage, 7342,
     /* 130041 */     GIR_EraseRootFromParent_Done,
     /* 130042 */   // Label 2446: @130042
     /* 130042 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(130116), // Rule ID 7343 //
     /* 130047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130064 */     // MIs[0] Rn
     /* 130064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130076 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130088 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 130103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130114 */     GIR_RootConstrainSelectedInstOperands,
     /* 130115 */     // GIR_Coverage, 7343,
     /* 130115 */     GIR_EraseRootFromParent_Done,
     /* 130116 */   // Label 2447: @130116
     /* 130116 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(130190), // Rule ID 7344 //
     /* 130121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130124 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130131 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130138 */     // MIs[0] Rn
     /* 130138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130150 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130162 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 130177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130188 */     GIR_RootConstrainSelectedInstOperands,
     /* 130189 */     // GIR_Coverage, 7344,
     /* 130189 */     GIR_EraseRootFromParent_Done,
     /* 130190 */   // Label 2448: @130190
     /* 130190 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(130264), // Rule ID 7345 //
     /* 130195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130212 */     // MIs[0] Rn
     /* 130212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130224 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130236 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 130251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130262 */     GIR_RootConstrainSelectedInstOperands,
     /* 130263 */     // GIR_Coverage, 7345,
     /* 130263 */     GIR_EraseRootFromParent_Done,
     /* 130264 */   // Label 2449: @130264
     /* 130264 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(130338), // Rule ID 7346 //
     /* 130269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130286 */     // MIs[0] Rn
     /* 130286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130298 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130310 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 130325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130336 */     GIR_RootConstrainSelectedInstOperands,
     /* 130337 */     // GIR_Coverage, 7346,
     /* 130337 */     GIR_EraseRootFromParent_Done,
     /* 130338 */   // Label 2450: @130338
     /* 130338 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(130412), // Rule ID 7347 //
     /* 130343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130360 */     // MIs[0] Rn
     /* 130360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130372 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130384 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 130399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130410 */     GIR_RootConstrainSelectedInstOperands,
     /* 130411 */     // GIR_Coverage, 7347,
     /* 130411 */     GIR_EraseRootFromParent_Done,
     /* 130412 */   // Label 2451: @130412
     /* 130412 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(130486), // Rule ID 7348 //
     /* 130417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130434 */     // MIs[0] Rn
     /* 130434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130446 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130458 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 130473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130484 */     GIR_RootConstrainSelectedInstOperands,
     /* 130485 */     // GIR_Coverage, 7348,
     /* 130485 */     GIR_EraseRootFromParent_Done,
     /* 130486 */   // Label 2452: @130486
     /* 130486 */   GIM_Reject,
     /* 130487 */ // Label 2437: @130487
     /* 130487 */ GIM_Reject,
     /* 130488 */ // Label 2435: @130488
     /* 130488 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(130839),
     /* 130493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130496 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130503 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(130570), // Rule ID 7329 //
     /* 130508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130511 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130518 */     // MIs[0] Rn
     /* 130518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130530 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130542 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 130557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130568 */     GIR_RootConstrainSelectedInstOperands,
     /* 130569 */     // GIR_Coverage, 7329,
     /* 130569 */     GIR_EraseRootFromParent_Done,
     /* 130570 */   // Label 2454: @130570
     /* 130570 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(130637), // Rule ID 7330 //
     /* 130575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130585 */     // MIs[0] Rn
     /* 130585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130597 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130609 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130615 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 130624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130635 */     GIR_RootConstrainSelectedInstOperands,
     /* 130636 */     // GIR_Coverage, 7330,
     /* 130636 */     GIR_EraseRootFromParent_Done,
     /* 130637 */   // Label 2455: @130637
     /* 130637 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(130704), // Rule ID 7331 //
     /* 130642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130652 */     // MIs[0] Rn
     /* 130652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130664 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130676 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 130691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130702 */     GIR_RootConstrainSelectedInstOperands,
     /* 130703 */     // GIR_Coverage, 7331,
     /* 130703 */     GIR_EraseRootFromParent_Done,
     /* 130704 */   // Label 2456: @130704
     /* 130704 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(130771), // Rule ID 7332 //
     /* 130709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130719 */     // MIs[0] Rn
     /* 130719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130731 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130743 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 130758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130769 */     GIR_RootConstrainSelectedInstOperands,
     /* 130770 */     // GIR_Coverage, 7332,
     /* 130770 */     GIR_EraseRootFromParent_Done,
     /* 130771 */   // Label 2457: @130771
     /* 130771 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(130838), // Rule ID 7333 //
     /* 130776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130786 */     // MIs[0] Rn
     /* 130786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130798 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130810 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 130825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130836 */     GIR_RootConstrainSelectedInstOperands,
     /* 130837 */     // GIR_Coverage, 7333,
     /* 130837 */     GIR_EraseRootFromParent_Done,
     /* 130838 */   // Label 2458: @130838
     /* 130838 */   GIM_Reject,
     /* 130839 */ // Label 2453: @130839
     /* 130839 */ GIM_Reject,
     /* 130840 */ // Label 2436: @130840
     /* 130840 */ GIM_Reject,
     /* 130841 */ // Label 24: @130841
     /* 130841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2461*/ GIMT_Encode4(132332),
     /* 130852 */ /*GILLT_s32*//*Label 2459*/ GIMT_Encode4(130860),
     /* 130856 */ /*GILLT_s64*//*Label 2460*/ GIMT_Encode4(131980),
     /* 130860 */ // Label 2459: @130860
     /* 130860 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(131979),
     /* 130865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130868 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(130942), // Rule ID 7354 //
     /* 130873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130890 */     // MIs[0] Rn
     /* 130890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130902 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130914 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 130929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130940 */     GIR_RootConstrainSelectedInstOperands,
     /* 130941 */     // GIR_Coverage, 7354,
     /* 130941 */     GIR_EraseRootFromParent_Done,
     /* 130942 */   // Label 2463: @130942
     /* 130942 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(131016), // Rule ID 7355 //
     /* 130947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130964 */     // MIs[0] Rn
     /* 130964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130976 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130988 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 131003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131014 */     GIR_RootConstrainSelectedInstOperands,
     /* 131015 */     // GIR_Coverage, 7355,
     /* 131015 */     GIR_EraseRootFromParent_Done,
     /* 131016 */   // Label 2464: @131016
     /* 131016 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(131090), // Rule ID 7356 //
     /* 131021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131038 */     // MIs[0] Rn
     /* 131038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131050 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131062 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 131077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131088 */     GIR_RootConstrainSelectedInstOperands,
     /* 131089 */     // GIR_Coverage, 7356,
     /* 131089 */     GIR_EraseRootFromParent_Done,
     /* 131090 */   // Label 2465: @131090
     /* 131090 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(131164), // Rule ID 7357 //
     /* 131095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131112 */     // MIs[0] Rn
     /* 131112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131124 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131136 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 131151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131162 */     GIR_RootConstrainSelectedInstOperands,
     /* 131163 */     // GIR_Coverage, 7357,
     /* 131163 */     GIR_EraseRootFromParent_Done,
     /* 131164 */   // Label 2466: @131164
     /* 131164 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(131238), // Rule ID 7358 //
     /* 131169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131186 */     // MIs[0] Rn
     /* 131186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131198 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131210 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 131225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131236 */     GIR_RootConstrainSelectedInstOperands,
     /* 131237 */     // GIR_Coverage, 7358,
     /* 131237 */     GIR_EraseRootFromParent_Done,
     /* 131238 */   // Label 2467: @131238
     /* 131238 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(131312), // Rule ID 7359 //
     /* 131243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131260 */     // MIs[0] Rn
     /* 131260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131272 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131284 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 131299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131310 */     GIR_RootConstrainSelectedInstOperands,
     /* 131311 */     // GIR_Coverage, 7359,
     /* 131311 */     GIR_EraseRootFromParent_Done,
     /* 131312 */   // Label 2468: @131312
     /* 131312 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(131386), // Rule ID 7360 //
     /* 131317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131334 */     // MIs[0] Rn
     /* 131334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131346 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131358 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 131373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131384 */     GIR_RootConstrainSelectedInstOperands,
     /* 131385 */     // GIR_Coverage, 7360,
     /* 131385 */     GIR_EraseRootFromParent_Done,
     /* 131386 */   // Label 2469: @131386
     /* 131386 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(131460), // Rule ID 7361 //
     /* 131391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131408 */     // MIs[0] Rn
     /* 131408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131420 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131432 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 131447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131458 */     GIR_RootConstrainSelectedInstOperands,
     /* 131459 */     // GIR_Coverage, 7361,
     /* 131459 */     GIR_EraseRootFromParent_Done,
     /* 131460 */   // Label 2470: @131460
     /* 131460 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(131534), // Rule ID 7362 //
     /* 131465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131482 */     // MIs[0] Rn
     /* 131482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131494 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131506 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 131521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131532 */     GIR_RootConstrainSelectedInstOperands,
     /* 131533 */     // GIR_Coverage, 7362,
     /* 131533 */     GIR_EraseRootFromParent_Done,
     /* 131534 */   // Label 2471: @131534
     /* 131534 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(131608), // Rule ID 7363 //
     /* 131539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131556 */     // MIs[0] Rn
     /* 131556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131568 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131580 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 131595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131606 */     GIR_RootConstrainSelectedInstOperands,
     /* 131607 */     // GIR_Coverage, 7363,
     /* 131607 */     GIR_EraseRootFromParent_Done,
     /* 131608 */   // Label 2472: @131608
     /* 131608 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(131682), // Rule ID 7364 //
     /* 131613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131630 */     // MIs[0] Rn
     /* 131630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131642 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131654 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131660 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 131669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131680 */     GIR_RootConstrainSelectedInstOperands,
     /* 131681 */     // GIR_Coverage, 7364,
     /* 131681 */     GIR_EraseRootFromParent_Done,
     /* 131682 */   // Label 2473: @131682
     /* 131682 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(131756), // Rule ID 7365 //
     /* 131687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131704 */     // MIs[0] Rn
     /* 131704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131716 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131728 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 131743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131754 */     GIR_RootConstrainSelectedInstOperands,
     /* 131755 */     // GIR_Coverage, 7365,
     /* 131755 */     GIR_EraseRootFromParent_Done,
     /* 131756 */   // Label 2474: @131756
     /* 131756 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(131830), // Rule ID 7366 //
     /* 131761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131778 */     // MIs[0] Rn
     /* 131778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131790 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131802 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 131817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131828 */     GIR_RootConstrainSelectedInstOperands,
     /* 131829 */     // GIR_Coverage, 7366,
     /* 131829 */     GIR_EraseRootFromParent_Done,
     /* 131830 */   // Label 2475: @131830
     /* 131830 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(131904), // Rule ID 7367 //
     /* 131835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131852 */     // MIs[0] Rn
     /* 131852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131864 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131876 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131902 */     GIR_RootConstrainSelectedInstOperands,
     /* 131903 */     // GIR_Coverage, 7367,
     /* 131903 */     GIR_EraseRootFromParent_Done,
     /* 131904 */   // Label 2476: @131904
     /* 131904 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(131978), // Rule ID 7368 //
     /* 131909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131926 */     // MIs[0] Rn
     /* 131926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131938 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131950 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131976 */     GIR_RootConstrainSelectedInstOperands,
     /* 131977 */     // GIR_Coverage, 7368,
     /* 131977 */     GIR_EraseRootFromParent_Done,
     /* 131978 */   // Label 2477: @131978
     /* 131978 */   GIM_Reject,
     /* 131979 */ // Label 2462: @131979
     /* 131979 */ GIM_Reject,
     /* 131980 */ // Label 2460: @131980
     /* 131980 */ GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(132331),
     /* 131985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131988 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131995 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(132062), // Rule ID 7349 //
     /* 132000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132010 */     // MIs[0] Rn
     /* 132010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132022 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132034 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 132049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132060 */     GIR_RootConstrainSelectedInstOperands,
     /* 132061 */     // GIR_Coverage, 7349,
     /* 132061 */     GIR_EraseRootFromParent_Done,
     /* 132062 */   // Label 2479: @132062
     /* 132062 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(132129), // Rule ID 7350 //
     /* 132067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132077 */     // MIs[0] Rn
     /* 132077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132089 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132101 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 132116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132127 */     GIR_RootConstrainSelectedInstOperands,
     /* 132128 */     // GIR_Coverage, 7350,
     /* 132128 */     GIR_EraseRootFromParent_Done,
     /* 132129 */   // Label 2480: @132129
     /* 132129 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(132196), // Rule ID 7351 //
     /* 132134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132144 */     // MIs[0] Rn
     /* 132144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132156 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132168 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 132183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132194 */     GIR_RootConstrainSelectedInstOperands,
     /* 132195 */     // GIR_Coverage, 7351,
     /* 132195 */     GIR_EraseRootFromParent_Done,
     /* 132196 */   // Label 2481: @132196
     /* 132196 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(132263), // Rule ID 7352 //
     /* 132201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132211 */     // MIs[0] Rn
     /* 132211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132223 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132235 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 132250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132261 */     GIR_RootConstrainSelectedInstOperands,
     /* 132262 */     // GIR_Coverage, 7352,
     /* 132262 */     GIR_EraseRootFromParent_Done,
     /* 132263 */   // Label 2482: @132263
     /* 132263 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(132330), // Rule ID 7353 //
     /* 132268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132278 */     // MIs[0] Rn
     /* 132278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132290 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132302 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 132317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132328 */     GIR_RootConstrainSelectedInstOperands,
     /* 132329 */     // GIR_Coverage, 7353,
     /* 132329 */     GIR_EraseRootFromParent_Done,
     /* 132330 */   // Label 2483: @132330
     /* 132330 */   GIM_Reject,
     /* 132331 */ // Label 2478: @132331
     /* 132331 */ GIM_Reject,
     /* 132332 */ // Label 2461: @132332
     /* 132332 */ GIM_Reject,
     /* 132333 */ // Label 25: @132333
     /* 132333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2486*/ GIMT_Encode4(133324),
     /* 132344 */ /*GILLT_s32*//*Label 2484*/ GIMT_Encode4(132352),
     /* 132348 */ /*GILLT_s64*//*Label 2485*/ GIMT_Encode4(133097),
     /* 132352 */ // Label 2484: @132352
     /* 132352 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(133096),
     /* 132357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132360 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(132409), // Rule ID 7159 //
     /* 132365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132382 */     // MIs[0] Rn
     /* 132382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132394 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 132397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132407 */     GIR_RootConstrainSelectedInstOperands,
     /* 132408 */     // GIR_Coverage, 7159,
     /* 132408 */     GIR_EraseRootFromParent_Done,
     /* 132409 */   // Label 2488: @132409
     /* 132409 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(132458), // Rule ID 7160 //
     /* 132414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132431 */     // MIs[0] Rn
     /* 132431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132443 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 132446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132456 */     GIR_RootConstrainSelectedInstOperands,
     /* 132457 */     // GIR_Coverage, 7160,
     /* 132457 */     GIR_EraseRootFromParent_Done,
     /* 132458 */   // Label 2489: @132458
     /* 132458 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(132507), // Rule ID 7161 //
     /* 132463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132480 */     // MIs[0] Rn
     /* 132480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132492 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 132495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132505 */     GIR_RootConstrainSelectedInstOperands,
     /* 132506 */     // GIR_Coverage, 7161,
     /* 132506 */     GIR_EraseRootFromParent_Done,
     /* 132507 */   // Label 2490: @132507
     /* 132507 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(132556), // Rule ID 7162 //
     /* 132512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132529 */     // MIs[0] Rn
     /* 132529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132541 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 132544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132554 */     GIR_RootConstrainSelectedInstOperands,
     /* 132555 */     // GIR_Coverage, 7162,
     /* 132555 */     GIR_EraseRootFromParent_Done,
     /* 132556 */   // Label 2491: @132556
     /* 132556 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(132605), // Rule ID 7163 //
     /* 132561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132578 */     // MIs[0] Rn
     /* 132578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132590 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 132593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132603 */     GIR_RootConstrainSelectedInstOperands,
     /* 132604 */     // GIR_Coverage, 7163,
     /* 132604 */     GIR_EraseRootFromParent_Done,
     /* 132605 */   // Label 2492: @132605
     /* 132605 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(132654), // Rule ID 7164 //
     /* 132610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132627 */     // MIs[0] Rn
     /* 132627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132639 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 132642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132652 */     GIR_RootConstrainSelectedInstOperands,
     /* 132653 */     // GIR_Coverage, 7164,
     /* 132653 */     GIR_EraseRootFromParent_Done,
     /* 132654 */   // Label 2493: @132654
     /* 132654 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(132703), // Rule ID 7165 //
     /* 132659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132676 */     // MIs[0] Rn
     /* 132676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132688 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 132691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132701 */     GIR_RootConstrainSelectedInstOperands,
     /* 132702 */     // GIR_Coverage, 7165,
     /* 132702 */     GIR_EraseRootFromParent_Done,
     /* 132703 */   // Label 2494: @132703
     /* 132703 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(132752), // Rule ID 7166 //
     /* 132708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132725 */     // MIs[0] Rn
     /* 132725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132737 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 132740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132750 */     GIR_RootConstrainSelectedInstOperands,
     /* 132751 */     // GIR_Coverage, 7166,
     /* 132751 */     GIR_EraseRootFromParent_Done,
     /* 132752 */   // Label 2495: @132752
     /* 132752 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(132801), // Rule ID 7167 //
     /* 132757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132774 */     // MIs[0] Rn
     /* 132774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132786 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 132789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132799 */     GIR_RootConstrainSelectedInstOperands,
     /* 132800 */     // GIR_Coverage, 7167,
     /* 132800 */     GIR_EraseRootFromParent_Done,
     /* 132801 */   // Label 2496: @132801
     /* 132801 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(132850), // Rule ID 7168 //
     /* 132806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132809 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132816 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132823 */     // MIs[0] Rn
     /* 132823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132835 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 132838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132848 */     GIR_RootConstrainSelectedInstOperands,
     /* 132849 */     // GIR_Coverage, 7168,
     /* 132849 */     GIR_EraseRootFromParent_Done,
     /* 132850 */   // Label 2497: @132850
     /* 132850 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(132899), // Rule ID 7169 //
     /* 132855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132872 */     // MIs[0] Rn
     /* 132872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132884 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 132887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132897 */     GIR_RootConstrainSelectedInstOperands,
     /* 132898 */     // GIR_Coverage, 7169,
     /* 132898 */     GIR_EraseRootFromParent_Done,
     /* 132899 */   // Label 2498: @132899
     /* 132899 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(132948), // Rule ID 7170 //
     /* 132904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132914 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132921 */     // MIs[0] Rn
     /* 132921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132933 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 132936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132946 */     GIR_RootConstrainSelectedInstOperands,
     /* 132947 */     // GIR_Coverage, 7170,
     /* 132947 */     GIR_EraseRootFromParent_Done,
     /* 132948 */   // Label 2499: @132948
     /* 132948 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(132997), // Rule ID 7171 //
     /* 132953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132963 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132970 */     // MIs[0] Rn
     /* 132970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132982 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 132985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132995 */     GIR_RootConstrainSelectedInstOperands,
     /* 132996 */     // GIR_Coverage, 7171,
     /* 132996 */     GIR_EraseRootFromParent_Done,
     /* 132997 */   // Label 2500: @132997
     /* 132997 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(133046), // Rule ID 7172 //
     /* 133002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133012 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133019 */     // MIs[0] Rn
     /* 133019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133031 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 133034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133044 */     GIR_RootConstrainSelectedInstOperands,
     /* 133045 */     // GIR_Coverage, 7172,
     /* 133045 */     GIR_EraseRootFromParent_Done,
     /* 133046 */   // Label 2501: @133046
     /* 133046 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(133095), // Rule ID 7173 //
     /* 133051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133068 */     // MIs[0] Rn
     /* 133068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133080 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 133083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133093 */     GIR_RootConstrainSelectedInstOperands,
     /* 133094 */     // GIR_Coverage, 7173,
     /* 133094 */     GIR_EraseRootFromParent_Done,
     /* 133095 */   // Label 2502: @133095
     /* 133095 */   GIM_Reject,
     /* 133096 */ // Label 2487: @133096
     /* 133096 */ GIM_Reject,
     /* 133097 */ // Label 2485: @133097
     /* 133097 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(133323),
     /* 133102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133112 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(133154), // Rule ID 7154 //
     /* 133117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133127 */     // MIs[0] Rn
     /* 133127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133139 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 133142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133152 */     GIR_RootConstrainSelectedInstOperands,
     /* 133153 */     // GIR_Coverage, 7154,
     /* 133153 */     GIR_EraseRootFromParent_Done,
     /* 133154 */   // Label 2504: @133154
     /* 133154 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(133196), // Rule ID 7155 //
     /* 133159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133169 */     // MIs[0] Rn
     /* 133169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133181 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 133184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133194 */     GIR_RootConstrainSelectedInstOperands,
     /* 133195 */     // GIR_Coverage, 7155,
     /* 133195 */     GIR_EraseRootFromParent_Done,
     /* 133196 */   // Label 2505: @133196
     /* 133196 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(133238), // Rule ID 7156 //
     /* 133201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133211 */     // MIs[0] Rn
     /* 133211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133223 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 133226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133236 */     GIR_RootConstrainSelectedInstOperands,
     /* 133237 */     // GIR_Coverage, 7156,
     /* 133237 */     GIR_EraseRootFromParent_Done,
     /* 133238 */   // Label 2506: @133238
     /* 133238 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(133280), // Rule ID 7157 //
     /* 133243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133253 */     // MIs[0] Rn
     /* 133253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133265 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 133268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133278 */     GIR_RootConstrainSelectedInstOperands,
     /* 133279 */     // GIR_Coverage, 7157,
     /* 133279 */     GIR_EraseRootFromParent_Done,
     /* 133280 */   // Label 2507: @133280
     /* 133280 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(133322), // Rule ID 7158 //
     /* 133285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133295 */     // MIs[0] Rn
     /* 133295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133307 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 133310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133320 */     GIR_RootConstrainSelectedInstOperands,
     /* 133321 */     // GIR_Coverage, 7158,
     /* 133321 */     GIR_EraseRootFromParent_Done,
     /* 133322 */   // Label 2508: @133322
     /* 133322 */   GIM_Reject,
     /* 133323 */ // Label 2503: @133323
     /* 133323 */ GIM_Reject,
     /* 133324 */ // Label 2486: @133324
     /* 133324 */ GIM_Reject,
     /* 133325 */ // Label 26: @133325
     /* 133325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2511*/ GIMT_Encode4(134316),
     /* 133336 */ /*GILLT_s32*//*Label 2509*/ GIMT_Encode4(133344),
     /* 133340 */ /*GILLT_s64*//*Label 2510*/ GIMT_Encode4(134089),
     /* 133344 */ // Label 2509: @133344
     /* 133344 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(134088),
     /* 133349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133352 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(133401), // Rule ID 7179 //
     /* 133357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133374 */     // MIs[0] Rn
     /* 133374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133386 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 133389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133399 */     GIR_RootConstrainSelectedInstOperands,
     /* 133400 */     // GIR_Coverage, 7179,
     /* 133400 */     GIR_EraseRootFromParent_Done,
     /* 133401 */   // Label 2513: @133401
     /* 133401 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(133450), // Rule ID 7180 //
     /* 133406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133423 */     // MIs[0] Rn
     /* 133423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133435 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 133438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133448 */     GIR_RootConstrainSelectedInstOperands,
     /* 133449 */     // GIR_Coverage, 7180,
     /* 133449 */     GIR_EraseRootFromParent_Done,
     /* 133450 */   // Label 2514: @133450
     /* 133450 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(133499), // Rule ID 7181 //
     /* 133455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133472 */     // MIs[0] Rn
     /* 133472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133484 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 133487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133497 */     GIR_RootConstrainSelectedInstOperands,
     /* 133498 */     // GIR_Coverage, 7181,
     /* 133498 */     GIR_EraseRootFromParent_Done,
     /* 133499 */   // Label 2515: @133499
     /* 133499 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(133548), // Rule ID 7182 //
     /* 133504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133521 */     // MIs[0] Rn
     /* 133521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133533 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 133536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133546 */     GIR_RootConstrainSelectedInstOperands,
     /* 133547 */     // GIR_Coverage, 7182,
     /* 133547 */     GIR_EraseRootFromParent_Done,
     /* 133548 */   // Label 2516: @133548
     /* 133548 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(133597), // Rule ID 7183 //
     /* 133553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133570 */     // MIs[0] Rn
     /* 133570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133582 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 133585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133595 */     GIR_RootConstrainSelectedInstOperands,
     /* 133596 */     // GIR_Coverage, 7183,
     /* 133596 */     GIR_EraseRootFromParent_Done,
     /* 133597 */   // Label 2517: @133597
     /* 133597 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(133646), // Rule ID 7184 //
     /* 133602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133619 */     // MIs[0] Rn
     /* 133619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133631 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 133634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133644 */     GIR_RootConstrainSelectedInstOperands,
     /* 133645 */     // GIR_Coverage, 7184,
     /* 133645 */     GIR_EraseRootFromParent_Done,
     /* 133646 */   // Label 2518: @133646
     /* 133646 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(133695), // Rule ID 7185 //
     /* 133651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133668 */     // MIs[0] Rn
     /* 133668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133680 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 133683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133693 */     GIR_RootConstrainSelectedInstOperands,
     /* 133694 */     // GIR_Coverage, 7185,
     /* 133694 */     GIR_EraseRootFromParent_Done,
     /* 133695 */   // Label 2519: @133695
     /* 133695 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(133744), // Rule ID 7186 //
     /* 133700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133717 */     // MIs[0] Rn
     /* 133717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133729 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 133732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133742 */     GIR_RootConstrainSelectedInstOperands,
     /* 133743 */     // GIR_Coverage, 7186,
     /* 133743 */     GIR_EraseRootFromParent_Done,
     /* 133744 */   // Label 2520: @133744
     /* 133744 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(133793), // Rule ID 7187 //
     /* 133749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133766 */     // MIs[0] Rn
     /* 133766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133778 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 133781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133791 */     GIR_RootConstrainSelectedInstOperands,
     /* 133792 */     // GIR_Coverage, 7187,
     /* 133792 */     GIR_EraseRootFromParent_Done,
     /* 133793 */   // Label 2521: @133793
     /* 133793 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(133842), // Rule ID 7188 //
     /* 133798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133815 */     // MIs[0] Rn
     /* 133815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133827 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 133830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133840 */     GIR_RootConstrainSelectedInstOperands,
     /* 133841 */     // GIR_Coverage, 7188,
     /* 133841 */     GIR_EraseRootFromParent_Done,
     /* 133842 */   // Label 2522: @133842
     /* 133842 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(133891), // Rule ID 7189 //
     /* 133847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133864 */     // MIs[0] Rn
     /* 133864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133876 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 133879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133889 */     GIR_RootConstrainSelectedInstOperands,
     /* 133890 */     // GIR_Coverage, 7189,
     /* 133890 */     GIR_EraseRootFromParent_Done,
     /* 133891 */   // Label 2523: @133891
     /* 133891 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(133940), // Rule ID 7190 //
     /* 133896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133913 */     // MIs[0] Rn
     /* 133913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133925 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 133928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133938 */     GIR_RootConstrainSelectedInstOperands,
     /* 133939 */     // GIR_Coverage, 7190,
     /* 133939 */     GIR_EraseRootFromParent_Done,
     /* 133940 */   // Label 2524: @133940
     /* 133940 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(133989), // Rule ID 7191 //
     /* 133945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133962 */     // MIs[0] Rn
     /* 133962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133974 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 133977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133987 */     GIR_RootConstrainSelectedInstOperands,
     /* 133988 */     // GIR_Coverage, 7191,
     /* 133988 */     GIR_EraseRootFromParent_Done,
     /* 133989 */   // Label 2525: @133989
     /* 133989 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(134038), // Rule ID 7192 //
     /* 133994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134004 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134011 */     // MIs[0] Rn
     /* 134011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134023 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 134026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134036 */     GIR_RootConstrainSelectedInstOperands,
     /* 134037 */     // GIR_Coverage, 7192,
     /* 134037 */     GIR_EraseRootFromParent_Done,
     /* 134038 */   // Label 2526: @134038
     /* 134038 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(134087), // Rule ID 7193 //
     /* 134043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134046 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134060 */     // MIs[0] Rn
     /* 134060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134072 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 134075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134085 */     GIR_RootConstrainSelectedInstOperands,
     /* 134086 */     // GIR_Coverage, 7193,
     /* 134086 */     GIR_EraseRootFromParent_Done,
     /* 134087 */   // Label 2527: @134087
     /* 134087 */   GIM_Reject,
     /* 134088 */ // Label 2512: @134088
     /* 134088 */ GIM_Reject,
     /* 134089 */ // Label 2510: @134089
     /* 134089 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(134315),
     /* 134094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134104 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(134146), // Rule ID 7174 //
     /* 134109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134119 */     // MIs[0] Rn
     /* 134119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134131 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 134134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134144 */     GIR_RootConstrainSelectedInstOperands,
     /* 134145 */     // GIR_Coverage, 7174,
     /* 134145 */     GIR_EraseRootFromParent_Done,
     /* 134146 */   // Label 2529: @134146
     /* 134146 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(134188), // Rule ID 7175 //
     /* 134151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134161 */     // MIs[0] Rn
     /* 134161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134173 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 134176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134186 */     GIR_RootConstrainSelectedInstOperands,
     /* 134187 */     // GIR_Coverage, 7175,
     /* 134187 */     GIR_EraseRootFromParent_Done,
     /* 134188 */   // Label 2530: @134188
     /* 134188 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(134230), // Rule ID 7176 //
     /* 134193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134203 */     // MIs[0] Rn
     /* 134203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134215 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 134218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134228 */     GIR_RootConstrainSelectedInstOperands,
     /* 134229 */     // GIR_Coverage, 7176,
     /* 134229 */     GIR_EraseRootFromParent_Done,
     /* 134230 */   // Label 2531: @134230
     /* 134230 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(134272), // Rule ID 7177 //
     /* 134235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134245 */     // MIs[0] Rn
     /* 134245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134257 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 134260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134270 */     GIR_RootConstrainSelectedInstOperands,
     /* 134271 */     // GIR_Coverage, 7177,
     /* 134271 */     GIR_EraseRootFromParent_Done,
     /* 134272 */   // Label 2532: @134272
     /* 134272 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(134314), // Rule ID 7178 //
     /* 134277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134287 */     // MIs[0] Rn
     /* 134287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134299 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 134302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134312 */     GIR_RootConstrainSelectedInstOperands,
     /* 134313 */     // GIR_Coverage, 7178,
     /* 134313 */     GIR_EraseRootFromParent_Done,
     /* 134314 */   // Label 2533: @134314
     /* 134314 */   GIM_Reject,
     /* 134315 */ // Label 2528: @134315
     /* 134315 */ GIM_Reject,
     /* 134316 */ // Label 2511: @134316
     /* 134316 */ GIM_Reject,
     /* 134317 */ // Label 27: @134317
     /* 134317 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2536*/ GIMT_Encode4(135308),
     /* 134328 */ /*GILLT_s32*//*Label 2534*/ GIMT_Encode4(134336),
     /* 134332 */ /*GILLT_s64*//*Label 2535*/ GIMT_Encode4(135081),
     /* 134336 */ // Label 2534: @134336
     /* 134336 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(135080),
     /* 134341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134344 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(134393), // Rule ID 7219 //
     /* 134349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134366 */     // MIs[0] Rn
     /* 134366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134378 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 134381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134391 */     GIR_RootConstrainSelectedInstOperands,
     /* 134392 */     // GIR_Coverage, 7219,
     /* 134392 */     GIR_EraseRootFromParent_Done,
     /* 134393 */   // Label 2538: @134393
     /* 134393 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(134442), // Rule ID 7220 //
     /* 134398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134415 */     // MIs[0] Rn
     /* 134415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134427 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 134430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134440 */     GIR_RootConstrainSelectedInstOperands,
     /* 134441 */     // GIR_Coverage, 7220,
     /* 134441 */     GIR_EraseRootFromParent_Done,
     /* 134442 */   // Label 2539: @134442
     /* 134442 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(134491), // Rule ID 7221 //
     /* 134447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134464 */     // MIs[0] Rn
     /* 134464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134476 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 134479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134489 */     GIR_RootConstrainSelectedInstOperands,
     /* 134490 */     // GIR_Coverage, 7221,
     /* 134490 */     GIR_EraseRootFromParent_Done,
     /* 134491 */   // Label 2540: @134491
     /* 134491 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(134540), // Rule ID 7222 //
     /* 134496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134513 */     // MIs[0] Rn
     /* 134513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134525 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 134528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134538 */     GIR_RootConstrainSelectedInstOperands,
     /* 134539 */     // GIR_Coverage, 7222,
     /* 134539 */     GIR_EraseRootFromParent_Done,
     /* 134540 */   // Label 2541: @134540
     /* 134540 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(134589), // Rule ID 7223 //
     /* 134545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134562 */     // MIs[0] Rn
     /* 134562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134574 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 134577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134587 */     GIR_RootConstrainSelectedInstOperands,
     /* 134588 */     // GIR_Coverage, 7223,
     /* 134588 */     GIR_EraseRootFromParent_Done,
     /* 134589 */   // Label 2542: @134589
     /* 134589 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(134638), // Rule ID 7224 //
     /* 134594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134611 */     // MIs[0] Rn
     /* 134611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134623 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 134626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134636 */     GIR_RootConstrainSelectedInstOperands,
     /* 134637 */     // GIR_Coverage, 7224,
     /* 134637 */     GIR_EraseRootFromParent_Done,
     /* 134638 */   // Label 2543: @134638
     /* 134638 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(134687), // Rule ID 7225 //
     /* 134643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134660 */     // MIs[0] Rn
     /* 134660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134672 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 134675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134685 */     GIR_RootConstrainSelectedInstOperands,
     /* 134686 */     // GIR_Coverage, 7225,
     /* 134686 */     GIR_EraseRootFromParent_Done,
     /* 134687 */   // Label 2544: @134687
     /* 134687 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(134736), // Rule ID 7226 //
     /* 134692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134709 */     // MIs[0] Rn
     /* 134709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134721 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 134724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134734 */     GIR_RootConstrainSelectedInstOperands,
     /* 134735 */     // GIR_Coverage, 7226,
     /* 134735 */     GIR_EraseRootFromParent_Done,
     /* 134736 */   // Label 2545: @134736
     /* 134736 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(134785), // Rule ID 7227 //
     /* 134741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134758 */     // MIs[0] Rn
     /* 134758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134770 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 134773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134783 */     GIR_RootConstrainSelectedInstOperands,
     /* 134784 */     // GIR_Coverage, 7227,
     /* 134784 */     GIR_EraseRootFromParent_Done,
     /* 134785 */   // Label 2546: @134785
     /* 134785 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(134834), // Rule ID 7228 //
     /* 134790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134793 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134807 */     // MIs[0] Rn
     /* 134807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134819 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 134822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134832 */     GIR_RootConstrainSelectedInstOperands,
     /* 134833 */     // GIR_Coverage, 7228,
     /* 134833 */     GIR_EraseRootFromParent_Done,
     /* 134834 */   // Label 2547: @134834
     /* 134834 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(134883), // Rule ID 7229 //
     /* 134839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134856 */     // MIs[0] Rn
     /* 134856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134868 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 134871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134881 */     GIR_RootConstrainSelectedInstOperands,
     /* 134882 */     // GIR_Coverage, 7229,
     /* 134882 */     GIR_EraseRootFromParent_Done,
     /* 134883 */   // Label 2548: @134883
     /* 134883 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(134932), // Rule ID 7230 //
     /* 134888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134905 */     // MIs[0] Rn
     /* 134905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134917 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 134920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134930 */     GIR_RootConstrainSelectedInstOperands,
     /* 134931 */     // GIR_Coverage, 7230,
     /* 134931 */     GIR_EraseRootFromParent_Done,
     /* 134932 */   // Label 2549: @134932
     /* 134932 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(134981), // Rule ID 7231 //
     /* 134937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134954 */     // MIs[0] Rn
     /* 134954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134966 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 134969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134979 */     GIR_RootConstrainSelectedInstOperands,
     /* 134980 */     // GIR_Coverage, 7231,
     /* 134980 */     GIR_EraseRootFromParent_Done,
     /* 134981 */   // Label 2550: @134981
     /* 134981 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(135030), // Rule ID 7232 //
     /* 134986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135003 */     // MIs[0] Rn
     /* 135003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135015 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 135018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135028 */     GIR_RootConstrainSelectedInstOperands,
     /* 135029 */     // GIR_Coverage, 7232,
     /* 135029 */     GIR_EraseRootFromParent_Done,
     /* 135030 */   // Label 2551: @135030
     /* 135030 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(135079), // Rule ID 7233 //
     /* 135035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135052 */     // MIs[0] Rn
     /* 135052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135064 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 135067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135077 */     GIR_RootConstrainSelectedInstOperands,
     /* 135078 */     // GIR_Coverage, 7233,
     /* 135078 */     GIR_EraseRootFromParent_Done,
     /* 135079 */   // Label 2552: @135079
     /* 135079 */   GIM_Reject,
     /* 135080 */ // Label 2537: @135080
     /* 135080 */ GIM_Reject,
     /* 135081 */ // Label 2535: @135081
     /* 135081 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(135307),
     /* 135086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135089 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135096 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(135138), // Rule ID 7214 //
     /* 135101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135111 */     // MIs[0] Rn
     /* 135111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135123 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 135126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135136 */     GIR_RootConstrainSelectedInstOperands,
     /* 135137 */     // GIR_Coverage, 7214,
     /* 135137 */     GIR_EraseRootFromParent_Done,
     /* 135138 */   // Label 2554: @135138
     /* 135138 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(135180), // Rule ID 7215 //
     /* 135143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135146 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135153 */     // MIs[0] Rn
     /* 135153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135165 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 135168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135178 */     GIR_RootConstrainSelectedInstOperands,
     /* 135179 */     // GIR_Coverage, 7215,
     /* 135179 */     GIR_EraseRootFromParent_Done,
     /* 135180 */   // Label 2555: @135180
     /* 135180 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(135222), // Rule ID 7216 //
     /* 135185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135195 */     // MIs[0] Rn
     /* 135195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135207 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 135210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135220 */     GIR_RootConstrainSelectedInstOperands,
     /* 135221 */     // GIR_Coverage, 7216,
     /* 135221 */     GIR_EraseRootFromParent_Done,
     /* 135222 */   // Label 2556: @135222
     /* 135222 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(135264), // Rule ID 7217 //
     /* 135227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135237 */     // MIs[0] Rn
     /* 135237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135249 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 135252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135262 */     GIR_RootConstrainSelectedInstOperands,
     /* 135263 */     // GIR_Coverage, 7217,
     /* 135263 */     GIR_EraseRootFromParent_Done,
     /* 135264 */   // Label 2557: @135264
     /* 135264 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(135306), // Rule ID 7218 //
     /* 135269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135272 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135279 */     // MIs[0] Rn
     /* 135279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135291 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 135294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135304 */     GIR_RootConstrainSelectedInstOperands,
     /* 135305 */     // GIR_Coverage, 7218,
     /* 135305 */     GIR_EraseRootFromParent_Done,
     /* 135306 */   // Label 2558: @135306
     /* 135306 */   GIM_Reject,
     /* 135307 */ // Label 2553: @135307
     /* 135307 */ GIM_Reject,
     /* 135308 */ // Label 2536: @135308
     /* 135308 */ GIM_Reject,
     /* 135309 */ // Label 28: @135309
     /* 135309 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2561*/ GIMT_Encode4(136300),
     /* 135320 */ /*GILLT_s32*//*Label 2559*/ GIMT_Encode4(135328),
     /* 135324 */ /*GILLT_s64*//*Label 2560*/ GIMT_Encode4(136073),
     /* 135328 */ // Label 2559: @135328
     /* 135328 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(136072),
     /* 135333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135336 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(135385), // Rule ID 7239 //
     /* 135341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135358 */     // MIs[0] Rn
     /* 135358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135370 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 135373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135383 */     GIR_RootConstrainSelectedInstOperands,
     /* 135384 */     // GIR_Coverage, 7239,
     /* 135384 */     GIR_EraseRootFromParent_Done,
     /* 135385 */   // Label 2563: @135385
     /* 135385 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(135434), // Rule ID 7240 //
     /* 135390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135407 */     // MIs[0] Rn
     /* 135407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135419 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 135422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135432 */     GIR_RootConstrainSelectedInstOperands,
     /* 135433 */     // GIR_Coverage, 7240,
     /* 135433 */     GIR_EraseRootFromParent_Done,
     /* 135434 */   // Label 2564: @135434
     /* 135434 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(135483), // Rule ID 7241 //
     /* 135439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135456 */     // MIs[0] Rn
     /* 135456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135468 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 135471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135481 */     GIR_RootConstrainSelectedInstOperands,
     /* 135482 */     // GIR_Coverage, 7241,
     /* 135482 */     GIR_EraseRootFromParent_Done,
     /* 135483 */   // Label 2565: @135483
     /* 135483 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(135532), // Rule ID 7242 //
     /* 135488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135505 */     // MIs[0] Rn
     /* 135505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135517 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 135520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135530 */     GIR_RootConstrainSelectedInstOperands,
     /* 135531 */     // GIR_Coverage, 7242,
     /* 135531 */     GIR_EraseRootFromParent_Done,
     /* 135532 */   // Label 2566: @135532
     /* 135532 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(135581), // Rule ID 7243 //
     /* 135537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135554 */     // MIs[0] Rn
     /* 135554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135566 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 135569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135579 */     GIR_RootConstrainSelectedInstOperands,
     /* 135580 */     // GIR_Coverage, 7243,
     /* 135580 */     GIR_EraseRootFromParent_Done,
     /* 135581 */   // Label 2567: @135581
     /* 135581 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(135630), // Rule ID 7244 //
     /* 135586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135603 */     // MIs[0] Rn
     /* 135603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135615 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 135618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135628 */     GIR_RootConstrainSelectedInstOperands,
     /* 135629 */     // GIR_Coverage, 7244,
     /* 135629 */     GIR_EraseRootFromParent_Done,
     /* 135630 */   // Label 2568: @135630
     /* 135630 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(135679), // Rule ID 7245 //
     /* 135635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135652 */     // MIs[0] Rn
     /* 135652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135664 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 135667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135677 */     GIR_RootConstrainSelectedInstOperands,
     /* 135678 */     // GIR_Coverage, 7245,
     /* 135678 */     GIR_EraseRootFromParent_Done,
     /* 135679 */   // Label 2569: @135679
     /* 135679 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(135728), // Rule ID 7246 //
     /* 135684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135701 */     // MIs[0] Rn
     /* 135701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135713 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 135716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135726 */     GIR_RootConstrainSelectedInstOperands,
     /* 135727 */     // GIR_Coverage, 7246,
     /* 135727 */     GIR_EraseRootFromParent_Done,
     /* 135728 */   // Label 2570: @135728
     /* 135728 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(135777), // Rule ID 7247 //
     /* 135733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135750 */     // MIs[0] Rn
     /* 135750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135762 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 135765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135775 */     GIR_RootConstrainSelectedInstOperands,
     /* 135776 */     // GIR_Coverage, 7247,
     /* 135776 */     GIR_EraseRootFromParent_Done,
     /* 135777 */   // Label 2571: @135777
     /* 135777 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(135826), // Rule ID 7248 //
     /* 135782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135785 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135799 */     // MIs[0] Rn
     /* 135799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135811 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 135814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135824 */     GIR_RootConstrainSelectedInstOperands,
     /* 135825 */     // GIR_Coverage, 7248,
     /* 135825 */     GIR_EraseRootFromParent_Done,
     /* 135826 */   // Label 2572: @135826
     /* 135826 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(135875), // Rule ID 7249 //
     /* 135831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135834 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135841 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135848 */     // MIs[0] Rn
     /* 135848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135860 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 135863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135873 */     GIR_RootConstrainSelectedInstOperands,
     /* 135874 */     // GIR_Coverage, 7249,
     /* 135874 */     GIR_EraseRootFromParent_Done,
     /* 135875 */   // Label 2573: @135875
     /* 135875 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(135924), // Rule ID 7250 //
     /* 135880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135897 */     // MIs[0] Rn
     /* 135897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135909 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 135912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135922 */     GIR_RootConstrainSelectedInstOperands,
     /* 135923 */     // GIR_Coverage, 7250,
     /* 135923 */     GIR_EraseRootFromParent_Done,
     /* 135924 */   // Label 2574: @135924
     /* 135924 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(135973), // Rule ID 7251 //
     /* 135929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135946 */     // MIs[0] Rn
     /* 135946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135958 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 135961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135971 */     GIR_RootConstrainSelectedInstOperands,
     /* 135972 */     // GIR_Coverage, 7251,
     /* 135972 */     GIR_EraseRootFromParent_Done,
     /* 135973 */   // Label 2575: @135973
     /* 135973 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(136022), // Rule ID 7252 //
     /* 135978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135995 */     // MIs[0] Rn
     /* 135995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136007 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 136010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136020 */     GIR_RootConstrainSelectedInstOperands,
     /* 136021 */     // GIR_Coverage, 7252,
     /* 136021 */     GIR_EraseRootFromParent_Done,
     /* 136022 */   // Label 2576: @136022
     /* 136022 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(136071), // Rule ID 7253 //
     /* 136027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136044 */     // MIs[0] Rn
     /* 136044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136056 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 136059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136069 */     GIR_RootConstrainSelectedInstOperands,
     /* 136070 */     // GIR_Coverage, 7253,
     /* 136070 */     GIR_EraseRootFromParent_Done,
     /* 136071 */   // Label 2577: @136071
     /* 136071 */   GIM_Reject,
     /* 136072 */ // Label 2562: @136072
     /* 136072 */ GIM_Reject,
     /* 136073 */ // Label 2560: @136073
     /* 136073 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(136299),
     /* 136078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136081 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 136088 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(136130), // Rule ID 7234 //
     /* 136093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136103 */     // MIs[0] Rn
     /* 136103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136115 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 136118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136128 */     GIR_RootConstrainSelectedInstOperands,
     /* 136129 */     // GIR_Coverage, 7234,
     /* 136129 */     GIR_EraseRootFromParent_Done,
     /* 136130 */   // Label 2579: @136130
     /* 136130 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(136172), // Rule ID 7235 //
     /* 136135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136145 */     // MIs[0] Rn
     /* 136145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136157 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 136160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136170 */     GIR_RootConstrainSelectedInstOperands,
     /* 136171 */     // GIR_Coverage, 7235,
     /* 136171 */     GIR_EraseRootFromParent_Done,
     /* 136172 */   // Label 2580: @136172
     /* 136172 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(136214), // Rule ID 7236 //
     /* 136177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136187 */     // MIs[0] Rn
     /* 136187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136199 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 136202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136212 */     GIR_RootConstrainSelectedInstOperands,
     /* 136213 */     // GIR_Coverage, 7236,
     /* 136213 */     GIR_EraseRootFromParent_Done,
     /* 136214 */   // Label 2581: @136214
     /* 136214 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(136256), // Rule ID 7237 //
     /* 136219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136229 */     // MIs[0] Rn
     /* 136229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136241 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 136244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136254 */     GIR_RootConstrainSelectedInstOperands,
     /* 136255 */     // GIR_Coverage, 7237,
     /* 136255 */     GIR_EraseRootFromParent_Done,
     /* 136256 */   // Label 2582: @136256
     /* 136256 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(136298), // Rule ID 7238 //
     /* 136261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136271 */     // MIs[0] Rn
     /* 136271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136283 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 136286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136296 */     GIR_RootConstrainSelectedInstOperands,
     /* 136297 */     // GIR_Coverage, 7238,
     /* 136297 */     GIR_EraseRootFromParent_Done,
     /* 136298 */   // Label 2583: @136298
     /* 136298 */   GIM_Reject,
     /* 136299 */ // Label 2578: @136299
     /* 136299 */ GIM_Reject,
     /* 136300 */ // Label 2561: @136300
     /* 136300 */ GIM_Reject,
     /* 136301 */ // Label 29: @136301
     /* 136301 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2586*/ GIMT_Encode4(137292),
     /* 136312 */ /*GILLT_s32*//*Label 2584*/ GIMT_Encode4(136320),
     /* 136316 */ /*GILLT_s64*//*Label 2585*/ GIMT_Encode4(137065),
     /* 136320 */ // Label 2584: @136320
     /* 136320 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(137064),
     /* 136325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136328 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(136377), // Rule ID 7259 //
     /* 136333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136350 */     // MIs[0] Rn
     /* 136350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136362 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 136365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136375 */     GIR_RootConstrainSelectedInstOperands,
     /* 136376 */     // GIR_Coverage, 7259,
     /* 136376 */     GIR_EraseRootFromParent_Done,
     /* 136377 */   // Label 2588: @136377
     /* 136377 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(136426), // Rule ID 7260 //
     /* 136382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136399 */     // MIs[0] Rn
     /* 136399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136411 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 136414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136424 */     GIR_RootConstrainSelectedInstOperands,
     /* 136425 */     // GIR_Coverage, 7260,
     /* 136425 */     GIR_EraseRootFromParent_Done,
     /* 136426 */   // Label 2589: @136426
     /* 136426 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(136475), // Rule ID 7261 //
     /* 136431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136448 */     // MIs[0] Rn
     /* 136448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136460 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 136463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136473 */     GIR_RootConstrainSelectedInstOperands,
     /* 136474 */     // GIR_Coverage, 7261,
     /* 136474 */     GIR_EraseRootFromParent_Done,
     /* 136475 */   // Label 2590: @136475
     /* 136475 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(136524), // Rule ID 7262 //
     /* 136480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136497 */     // MIs[0] Rn
     /* 136497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136509 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 136512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136522 */     GIR_RootConstrainSelectedInstOperands,
     /* 136523 */     // GIR_Coverage, 7262,
     /* 136523 */     GIR_EraseRootFromParent_Done,
     /* 136524 */   // Label 2591: @136524
     /* 136524 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(136573), // Rule ID 7263 //
     /* 136529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136546 */     // MIs[0] Rn
     /* 136546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136558 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 136561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136571 */     GIR_RootConstrainSelectedInstOperands,
     /* 136572 */     // GIR_Coverage, 7263,
     /* 136572 */     GIR_EraseRootFromParent_Done,
     /* 136573 */   // Label 2592: @136573
     /* 136573 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(136622), // Rule ID 7264 //
     /* 136578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136595 */     // MIs[0] Rn
     /* 136595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136607 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 136610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136620 */     GIR_RootConstrainSelectedInstOperands,
     /* 136621 */     // GIR_Coverage, 7264,
     /* 136621 */     GIR_EraseRootFromParent_Done,
     /* 136622 */   // Label 2593: @136622
     /* 136622 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(136671), // Rule ID 7265 //
     /* 136627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136644 */     // MIs[0] Rn
     /* 136644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136656 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 136659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136669 */     GIR_RootConstrainSelectedInstOperands,
     /* 136670 */     // GIR_Coverage, 7265,
     /* 136670 */     GIR_EraseRootFromParent_Done,
     /* 136671 */   // Label 2594: @136671
     /* 136671 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(136720), // Rule ID 7266 //
     /* 136676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136693 */     // MIs[0] Rn
     /* 136693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136705 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 136708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136718 */     GIR_RootConstrainSelectedInstOperands,
     /* 136719 */     // GIR_Coverage, 7266,
     /* 136719 */     GIR_EraseRootFromParent_Done,
     /* 136720 */   // Label 2595: @136720
     /* 136720 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(136769), // Rule ID 7267 //
     /* 136725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136742 */     // MIs[0] Rn
     /* 136742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136754 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 136757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136767 */     GIR_RootConstrainSelectedInstOperands,
     /* 136768 */     // GIR_Coverage, 7267,
     /* 136768 */     GIR_EraseRootFromParent_Done,
     /* 136769 */   // Label 2596: @136769
     /* 136769 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(136818), // Rule ID 7268 //
     /* 136774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136791 */     // MIs[0] Rn
     /* 136791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136803 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 136806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136816 */     GIR_RootConstrainSelectedInstOperands,
     /* 136817 */     // GIR_Coverage, 7268,
     /* 136817 */     GIR_EraseRootFromParent_Done,
     /* 136818 */   // Label 2597: @136818
     /* 136818 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(136867), // Rule ID 7269 //
     /* 136823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136840 */     // MIs[0] Rn
     /* 136840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136852 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 136855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136865 */     GIR_RootConstrainSelectedInstOperands,
     /* 136866 */     // GIR_Coverage, 7269,
     /* 136866 */     GIR_EraseRootFromParent_Done,
     /* 136867 */   // Label 2598: @136867
     /* 136867 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(136916), // Rule ID 7270 //
     /* 136872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136875 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136882 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136889 */     // MIs[0] Rn
     /* 136889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136901 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 136904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136914 */     GIR_RootConstrainSelectedInstOperands,
     /* 136915 */     // GIR_Coverage, 7270,
     /* 136915 */     GIR_EraseRootFromParent_Done,
     /* 136916 */   // Label 2599: @136916
     /* 136916 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(136965), // Rule ID 7271 //
     /* 136921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136938 */     // MIs[0] Rn
     /* 136938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136950 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 136953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136963 */     GIR_RootConstrainSelectedInstOperands,
     /* 136964 */     // GIR_Coverage, 7271,
     /* 136964 */     GIR_EraseRootFromParent_Done,
     /* 136965 */   // Label 2600: @136965
     /* 136965 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(137014), // Rule ID 7272 //
     /* 136970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136987 */     // MIs[0] Rn
     /* 136987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136999 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 137002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137012 */     GIR_RootConstrainSelectedInstOperands,
     /* 137013 */     // GIR_Coverage, 7272,
     /* 137013 */     GIR_EraseRootFromParent_Done,
     /* 137014 */   // Label 2601: @137014
     /* 137014 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(137063), // Rule ID 7273 //
     /* 137019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137036 */     // MIs[0] Rn
     /* 137036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137048 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 137051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137061 */     GIR_RootConstrainSelectedInstOperands,
     /* 137062 */     // GIR_Coverage, 7273,
     /* 137062 */     GIR_EraseRootFromParent_Done,
     /* 137063 */   // Label 2602: @137063
     /* 137063 */   GIM_Reject,
     /* 137064 */ // Label 2587: @137064
     /* 137064 */ GIM_Reject,
     /* 137065 */ // Label 2585: @137065
     /* 137065 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(137291),
     /* 137070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137080 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(137122), // Rule ID 7254 //
     /* 137085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137095 */     // MIs[0] Rn
     /* 137095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137107 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 137110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137120 */     GIR_RootConstrainSelectedInstOperands,
     /* 137121 */     // GIR_Coverage, 7254,
     /* 137121 */     GIR_EraseRootFromParent_Done,
     /* 137122 */   // Label 2604: @137122
     /* 137122 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(137164), // Rule ID 7255 //
     /* 137127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137137 */     // MIs[0] Rn
     /* 137137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137149 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 137152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137162 */     GIR_RootConstrainSelectedInstOperands,
     /* 137163 */     // GIR_Coverage, 7255,
     /* 137163 */     GIR_EraseRootFromParent_Done,
     /* 137164 */   // Label 2605: @137164
     /* 137164 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(137206), // Rule ID 7256 //
     /* 137169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137179 */     // MIs[0] Rn
     /* 137179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137191 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 137194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137204 */     GIR_RootConstrainSelectedInstOperands,
     /* 137205 */     // GIR_Coverage, 7256,
     /* 137205 */     GIR_EraseRootFromParent_Done,
     /* 137206 */   // Label 2606: @137206
     /* 137206 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(137248), // Rule ID 7257 //
     /* 137211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137221 */     // MIs[0] Rn
     /* 137221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137233 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 137236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137246 */     GIR_RootConstrainSelectedInstOperands,
     /* 137247 */     // GIR_Coverage, 7257,
     /* 137247 */     GIR_EraseRootFromParent_Done,
     /* 137248 */   // Label 2607: @137248
     /* 137248 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(137290), // Rule ID 7258 //
     /* 137253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137263 */     // MIs[0] Rn
     /* 137263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137275 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 137278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137288 */     GIR_RootConstrainSelectedInstOperands,
     /* 137289 */     // GIR_Coverage, 7258,
     /* 137289 */     GIR_EraseRootFromParent_Done,
     /* 137290 */   // Label 2608: @137290
     /* 137290 */   GIM_Reject,
     /* 137291 */ // Label 2603: @137291
     /* 137291 */ GIM_Reject,
     /* 137292 */ // Label 2586: @137292
     /* 137292 */ GIM_Reject,
     /* 137293 */ // Label 30: @137293
     /* 137293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2611*/ GIMT_Encode4(138284),
     /* 137304 */ /*GILLT_s32*//*Label 2609*/ GIMT_Encode4(137312),
     /* 137308 */ /*GILLT_s64*//*Label 2610*/ GIMT_Encode4(138057),
     /* 137312 */ // Label 2609: @137312
     /* 137312 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(138056),
     /* 137317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137320 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(137369), // Rule ID 7279 //
     /* 137325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137342 */     // MIs[0] Rn
     /* 137342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137354 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 137357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137367 */     GIR_RootConstrainSelectedInstOperands,
     /* 137368 */     // GIR_Coverage, 7279,
     /* 137368 */     GIR_EraseRootFromParent_Done,
     /* 137369 */   // Label 2613: @137369
     /* 137369 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(137418), // Rule ID 7280 //
     /* 137374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137391 */     // MIs[0] Rn
     /* 137391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137403 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 137406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137416 */     GIR_RootConstrainSelectedInstOperands,
     /* 137417 */     // GIR_Coverage, 7280,
     /* 137417 */     GIR_EraseRootFromParent_Done,
     /* 137418 */   // Label 2614: @137418
     /* 137418 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(137467), // Rule ID 7281 //
     /* 137423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137440 */     // MIs[0] Rn
     /* 137440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137452 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 137455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137465 */     GIR_RootConstrainSelectedInstOperands,
     /* 137466 */     // GIR_Coverage, 7281,
     /* 137466 */     GIR_EraseRootFromParent_Done,
     /* 137467 */   // Label 2615: @137467
     /* 137467 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(137516), // Rule ID 7282 //
     /* 137472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137489 */     // MIs[0] Rn
     /* 137489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137501 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 137504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137514 */     GIR_RootConstrainSelectedInstOperands,
     /* 137515 */     // GIR_Coverage, 7282,
     /* 137515 */     GIR_EraseRootFromParent_Done,
     /* 137516 */   // Label 2616: @137516
     /* 137516 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(137565), // Rule ID 7283 //
     /* 137521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137538 */     // MIs[0] Rn
     /* 137538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137550 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 137553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137563 */     GIR_RootConstrainSelectedInstOperands,
     /* 137564 */     // GIR_Coverage, 7283,
     /* 137564 */     GIR_EraseRootFromParent_Done,
     /* 137565 */   // Label 2617: @137565
     /* 137565 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(137614), // Rule ID 7284 //
     /* 137570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137587 */     // MIs[0] Rn
     /* 137587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137599 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 137602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137612 */     GIR_RootConstrainSelectedInstOperands,
     /* 137613 */     // GIR_Coverage, 7284,
     /* 137613 */     GIR_EraseRootFromParent_Done,
     /* 137614 */   // Label 2618: @137614
     /* 137614 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(137663), // Rule ID 7285 //
     /* 137619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137636 */     // MIs[0] Rn
     /* 137636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137648 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 137651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137661 */     GIR_RootConstrainSelectedInstOperands,
     /* 137662 */     // GIR_Coverage, 7285,
     /* 137662 */     GIR_EraseRootFromParent_Done,
     /* 137663 */   // Label 2619: @137663
     /* 137663 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(137712), // Rule ID 7286 //
     /* 137668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137685 */     // MIs[0] Rn
     /* 137685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137697 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 137700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137710 */     GIR_RootConstrainSelectedInstOperands,
     /* 137711 */     // GIR_Coverage, 7286,
     /* 137711 */     GIR_EraseRootFromParent_Done,
     /* 137712 */   // Label 2620: @137712
     /* 137712 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(137761), // Rule ID 7287 //
     /* 137717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137734 */     // MIs[0] Rn
     /* 137734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137746 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 137749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137759 */     GIR_RootConstrainSelectedInstOperands,
     /* 137760 */     // GIR_Coverage, 7287,
     /* 137760 */     GIR_EraseRootFromParent_Done,
     /* 137761 */   // Label 2621: @137761
     /* 137761 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(137810), // Rule ID 7288 //
     /* 137766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137783 */     // MIs[0] Rn
     /* 137783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137795 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 137798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137808 */     GIR_RootConstrainSelectedInstOperands,
     /* 137809 */     // GIR_Coverage, 7288,
     /* 137809 */     GIR_EraseRootFromParent_Done,
     /* 137810 */   // Label 2622: @137810
     /* 137810 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(137859), // Rule ID 7289 //
     /* 137815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137832 */     // MIs[0] Rn
     /* 137832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137844 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 137847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137857 */     GIR_RootConstrainSelectedInstOperands,
     /* 137858 */     // GIR_Coverage, 7289,
     /* 137858 */     GIR_EraseRootFromParent_Done,
     /* 137859 */   // Label 2623: @137859
     /* 137859 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(137908), // Rule ID 7290 //
     /* 137864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137874 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137881 */     // MIs[0] Rn
     /* 137881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137893 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 137896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137906 */     GIR_RootConstrainSelectedInstOperands,
     /* 137907 */     // GIR_Coverage, 7290,
     /* 137907 */     GIR_EraseRootFromParent_Done,
     /* 137908 */   // Label 2624: @137908
     /* 137908 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(137957), // Rule ID 7291 //
     /* 137913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137930 */     // MIs[0] Rn
     /* 137930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137942 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 137945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137955 */     GIR_RootConstrainSelectedInstOperands,
     /* 137956 */     // GIR_Coverage, 7291,
     /* 137956 */     GIR_EraseRootFromParent_Done,
     /* 137957 */   // Label 2625: @137957
     /* 137957 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(138006), // Rule ID 7292 //
     /* 137962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137965 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137972 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137979 */     // MIs[0] Rn
     /* 137979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137991 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138004 */     GIR_RootConstrainSelectedInstOperands,
     /* 138005 */     // GIR_Coverage, 7292,
     /* 138005 */     GIR_EraseRootFromParent_Done,
     /* 138006 */   // Label 2626: @138006
     /* 138006 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(138055), // Rule ID 7293 //
     /* 138011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138028 */     // MIs[0] Rn
     /* 138028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138040 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 138043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138053 */     GIR_RootConstrainSelectedInstOperands,
     /* 138054 */     // GIR_Coverage, 7293,
     /* 138054 */     GIR_EraseRootFromParent_Done,
     /* 138055 */   // Label 2627: @138055
     /* 138055 */   GIM_Reject,
     /* 138056 */ // Label 2612: @138056
     /* 138056 */ GIM_Reject,
     /* 138057 */ // Label 2610: @138057
     /* 138057 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(138283),
     /* 138062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138072 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(138114), // Rule ID 7274 //
     /* 138077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138087 */     // MIs[0] Rn
     /* 138087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138099 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 138102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138112 */     GIR_RootConstrainSelectedInstOperands,
     /* 138113 */     // GIR_Coverage, 7274,
     /* 138113 */     GIR_EraseRootFromParent_Done,
     /* 138114 */   // Label 2629: @138114
     /* 138114 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(138156), // Rule ID 7275 //
     /* 138119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138129 */     // MIs[0] Rn
     /* 138129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138141 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 138144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138154 */     GIR_RootConstrainSelectedInstOperands,
     /* 138155 */     // GIR_Coverage, 7275,
     /* 138155 */     GIR_EraseRootFromParent_Done,
     /* 138156 */   // Label 2630: @138156
     /* 138156 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(138198), // Rule ID 7276 //
     /* 138161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138171 */     // MIs[0] Rn
     /* 138171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138183 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 138186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138196 */     GIR_RootConstrainSelectedInstOperands,
     /* 138197 */     // GIR_Coverage, 7276,
     /* 138197 */     GIR_EraseRootFromParent_Done,
     /* 138198 */   // Label 2631: @138198
     /* 138198 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(138240), // Rule ID 7277 //
     /* 138203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138213 */     // MIs[0] Rn
     /* 138213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138225 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 138228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138238 */     GIR_RootConstrainSelectedInstOperands,
     /* 138239 */     // GIR_Coverage, 7277,
     /* 138239 */     GIR_EraseRootFromParent_Done,
     /* 138240 */   // Label 2632: @138240
     /* 138240 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(138282), // Rule ID 7278 //
     /* 138245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138255 */     // MIs[0] Rn
     /* 138255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138267 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 138270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138280 */     GIR_RootConstrainSelectedInstOperands,
     /* 138281 */     // GIR_Coverage, 7278,
     /* 138281 */     GIR_EraseRootFromParent_Done,
     /* 138282 */   // Label 2633: @138282
     /* 138282 */   GIM_Reject,
     /* 138283 */ // Label 2628: @138283
     /* 138283 */ GIM_Reject,
     /* 138284 */ // Label 2611: @138284
     /* 138284 */ GIM_Reject,
     /* 138285 */ // Label 31: @138285
     /* 138285 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2637*/ GIMT_Encode4(138989),
     /* 138296 */ /*GILLT_s16*//*Label 2634*/ GIMT_Encode4(138308),
     /* 138300 */ /*GILLT_s32*//*Label 2635*/ GIMT_Encode4(138535),
     /* 138304 */ /*GILLT_s64*//*Label 2636*/ GIMT_Encode4(138762),
     /* 138308 */ // Label 2634: @138308
     /* 138308 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(138534),
     /* 138313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138316 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138323 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(138365), // Rule ID 2584 //
     /* 138328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138338 */     // MIs[0] Rn
     /* 138338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138350 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 138353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138363 */     GIR_RootConstrainSelectedInstOperands,
     /* 138364 */     // GIR_Coverage, 2584,
     /* 138364 */     GIR_EraseRootFromParent_Done,
     /* 138365 */   // Label 2639: @138365
     /* 138365 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(138407), // Rule ID 2585 //
     /* 138370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138373 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138380 */     // MIs[0] Rn
     /* 138380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138392 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 138395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138405 */     GIR_RootConstrainSelectedInstOperands,
     /* 138406 */     // GIR_Coverage, 2585,
     /* 138406 */     GIR_EraseRootFromParent_Done,
     /* 138407 */   // Label 2640: @138407
     /* 138407 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(138449), // Rule ID 2586 //
     /* 138412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138422 */     // MIs[0] Rn
     /* 138422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138434 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 138437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138447 */     GIR_RootConstrainSelectedInstOperands,
     /* 138448 */     // GIR_Coverage, 2586,
     /* 138448 */     GIR_EraseRootFromParent_Done,
     /* 138449 */   // Label 2641: @138449
     /* 138449 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(138491), // Rule ID 2587 //
     /* 138454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138464 */     // MIs[0] Rn
     /* 138464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138476 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 138479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138489 */     GIR_RootConstrainSelectedInstOperands,
     /* 138490 */     // GIR_Coverage, 2587,
     /* 138490 */     GIR_EraseRootFromParent_Done,
     /* 138491 */   // Label 2642: @138491
     /* 138491 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(138533), // Rule ID 2588 //
     /* 138496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138506 */     // MIs[0] Rn
     /* 138506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138518 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 138521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138531 */     GIR_RootConstrainSelectedInstOperands,
     /* 138532 */     // GIR_Coverage, 2588,
     /* 138532 */     GIR_EraseRootFromParent_Done,
     /* 138533 */   // Label 2643: @138533
     /* 138533 */   GIM_Reject,
     /* 138534 */ // Label 2638: @138534
     /* 138534 */ GIM_Reject,
     /* 138535 */ // Label 2635: @138535
     /* 138535 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(138761),
     /* 138540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138543 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138550 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(138592), // Rule ID 7369 //
     /* 138555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138565 */     // MIs[0] Rn
     /* 138565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138577 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 138580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138590 */     GIR_RootConstrainSelectedInstOperands,
     /* 138591 */     // GIR_Coverage, 7369,
     /* 138591 */     GIR_EraseRootFromParent_Done,
     /* 138592 */   // Label 2645: @138592
     /* 138592 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(138634), // Rule ID 7370 //
     /* 138597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138600 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138607 */     // MIs[0] Rn
     /* 138607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138619 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 138622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138632 */     GIR_RootConstrainSelectedInstOperands,
     /* 138633 */     // GIR_Coverage, 7370,
     /* 138633 */     GIR_EraseRootFromParent_Done,
     /* 138634 */   // Label 2646: @138634
     /* 138634 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(138676), // Rule ID 7371 //
     /* 138639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138642 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138649 */     // MIs[0] Rn
     /* 138649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138661 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 138664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138674 */     GIR_RootConstrainSelectedInstOperands,
     /* 138675 */     // GIR_Coverage, 7371,
     /* 138675 */     GIR_EraseRootFromParent_Done,
     /* 138676 */   // Label 2647: @138676
     /* 138676 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(138718), // Rule ID 7372 //
     /* 138681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138684 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138691 */     // MIs[0] Rn
     /* 138691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138703 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 138706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138716 */     GIR_RootConstrainSelectedInstOperands,
     /* 138717 */     // GIR_Coverage, 7372,
     /* 138717 */     GIR_EraseRootFromParent_Done,
     /* 138718 */   // Label 2648: @138718
     /* 138718 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(138760), // Rule ID 7373 //
     /* 138723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138733 */     // MIs[0] Rn
     /* 138733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138745 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 138748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138758 */     GIR_RootConstrainSelectedInstOperands,
     /* 138759 */     // GIR_Coverage, 7373,
     /* 138759 */     GIR_EraseRootFromParent_Done,
     /* 138760 */   // Label 2649: @138760
     /* 138760 */   GIM_Reject,
     /* 138761 */ // Label 2644: @138761
     /* 138761 */ GIM_Reject,
     /* 138762 */ // Label 2636: @138762
     /* 138762 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(138988),
     /* 138767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138770 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138777 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(138819), // Rule ID 7374 //
     /* 138782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138792 */     // MIs[0] Rn
     /* 138792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138804 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 138807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138817 */     GIR_RootConstrainSelectedInstOperands,
     /* 138818 */     // GIR_Coverage, 7374,
     /* 138818 */     GIR_EraseRootFromParent_Done,
     /* 138819 */   // Label 2651: @138819
     /* 138819 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(138861), // Rule ID 7375 //
     /* 138824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138834 */     // MIs[0] Rn
     /* 138834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138846 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 138849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138859 */     GIR_RootConstrainSelectedInstOperands,
     /* 138860 */     // GIR_Coverage, 7375,
     /* 138860 */     GIR_EraseRootFromParent_Done,
     /* 138861 */   // Label 2652: @138861
     /* 138861 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(138903), // Rule ID 7376 //
     /* 138866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138876 */     // MIs[0] Rn
     /* 138876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138888 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 138891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138901 */     GIR_RootConstrainSelectedInstOperands,
     /* 138902 */     // GIR_Coverage, 7376,
     /* 138902 */     GIR_EraseRootFromParent_Done,
     /* 138903 */   // Label 2653: @138903
     /* 138903 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(138945), // Rule ID 7377 //
     /* 138908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138918 */     // MIs[0] Rn
     /* 138918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138930 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138943 */     GIR_RootConstrainSelectedInstOperands,
     /* 138944 */     // GIR_Coverage, 7377,
     /* 138944 */     GIR_EraseRootFromParent_Done,
     /* 138945 */   // Label 2654: @138945
     /* 138945 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(138987), // Rule ID 7378 //
     /* 138950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138960 */     // MIs[0] Rn
     /* 138960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138972 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138985 */     GIR_RootConstrainSelectedInstOperands,
     /* 138986 */     // GIR_Coverage, 7378,
     /* 138986 */     GIR_EraseRootFromParent_Done,
     /* 138987 */   // Label 2655: @138987
     /* 138987 */   GIM_Reject,
     /* 138988 */ // Label 2650: @138988
     /* 138988 */ GIM_Reject,
     /* 138989 */ // Label 2637: @138989
     /* 138989 */ GIM_Reject,
     /* 138990 */ // Label 32: @138990
     /* 138990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2659*/ GIMT_Encode4(139694),
     /* 139001 */ /*GILLT_s16*//*Label 2656*/ GIMT_Encode4(139013),
     /* 139005 */ /*GILLT_s32*//*Label 2657*/ GIMT_Encode4(139240),
     /* 139009 */ /*GILLT_s64*//*Label 2658*/ GIMT_Encode4(139467),
     /* 139013 */ // Label 2656: @139013
     /* 139013 */ GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(139239),
     /* 139018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139021 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139028 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(139070), // Rule ID 7379 //
     /* 139033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139036 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139043 */     // MIs[0] Rn
     /* 139043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139055 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 139058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139068 */     GIR_RootConstrainSelectedInstOperands,
     /* 139069 */     // GIR_Coverage, 7379,
     /* 139069 */     GIR_EraseRootFromParent_Done,
     /* 139070 */   // Label 2661: @139070
     /* 139070 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(139112), // Rule ID 7380 //
     /* 139075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139085 */     // MIs[0] Rn
     /* 139085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139097 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 139100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139110 */     GIR_RootConstrainSelectedInstOperands,
     /* 139111 */     // GIR_Coverage, 7380,
     /* 139111 */     GIR_EraseRootFromParent_Done,
     /* 139112 */   // Label 2662: @139112
     /* 139112 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(139154), // Rule ID 7381 //
     /* 139117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139127 */     // MIs[0] Rn
     /* 139127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139139 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 139142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139152 */     GIR_RootConstrainSelectedInstOperands,
     /* 139153 */     // GIR_Coverage, 7381,
     /* 139153 */     GIR_EraseRootFromParent_Done,
     /* 139154 */   // Label 2663: @139154
     /* 139154 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(139196), // Rule ID 7382 //
     /* 139159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139169 */     // MIs[0] Rn
     /* 139169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139181 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 139184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139194 */     GIR_RootConstrainSelectedInstOperands,
     /* 139195 */     // GIR_Coverage, 7382,
     /* 139195 */     GIR_EraseRootFromParent_Done,
     /* 139196 */   // Label 2664: @139196
     /* 139196 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(139238), // Rule ID 7383 //
     /* 139201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139211 */     // MIs[0] Rn
     /* 139211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139223 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 139226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139236 */     GIR_RootConstrainSelectedInstOperands,
     /* 139237 */     // GIR_Coverage, 7383,
     /* 139237 */     GIR_EraseRootFromParent_Done,
     /* 139238 */   // Label 2665: @139238
     /* 139238 */   GIM_Reject,
     /* 139239 */ // Label 2660: @139239
     /* 139239 */ GIM_Reject,
     /* 139240 */ // Label 2657: @139240
     /* 139240 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(139466),
     /* 139245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139255 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(139297), // Rule ID 7384 //
     /* 139260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139270 */     // MIs[0] Rn
     /* 139270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139282 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 139285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139295 */     GIR_RootConstrainSelectedInstOperands,
     /* 139296 */     // GIR_Coverage, 7384,
     /* 139296 */     GIR_EraseRootFromParent_Done,
     /* 139297 */   // Label 2667: @139297
     /* 139297 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(139339), // Rule ID 7385 //
     /* 139302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139305 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139312 */     // MIs[0] Rn
     /* 139312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139324 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 139327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139337 */     GIR_RootConstrainSelectedInstOperands,
     /* 139338 */     // GIR_Coverage, 7385,
     /* 139338 */     GIR_EraseRootFromParent_Done,
     /* 139339 */   // Label 2668: @139339
     /* 139339 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(139381), // Rule ID 7386 //
     /* 139344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139347 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139354 */     // MIs[0] Rn
     /* 139354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139366 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 139369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139379 */     GIR_RootConstrainSelectedInstOperands,
     /* 139380 */     // GIR_Coverage, 7386,
     /* 139380 */     GIR_EraseRootFromParent_Done,
     /* 139381 */   // Label 2669: @139381
     /* 139381 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(139423), // Rule ID 7387 //
     /* 139386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139396 */     // MIs[0] Rn
     /* 139396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139408 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 139411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139421 */     GIR_RootConstrainSelectedInstOperands,
     /* 139422 */     // GIR_Coverage, 7387,
     /* 139422 */     GIR_EraseRootFromParent_Done,
     /* 139423 */   // Label 2670: @139423
     /* 139423 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(139465), // Rule ID 7388 //
     /* 139428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139438 */     // MIs[0] Rn
     /* 139438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139450 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 139453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139463 */     GIR_RootConstrainSelectedInstOperands,
     /* 139464 */     // GIR_Coverage, 7388,
     /* 139464 */     GIR_EraseRootFromParent_Done,
     /* 139465 */   // Label 2671: @139465
     /* 139465 */   GIM_Reject,
     /* 139466 */ // Label 2666: @139466
     /* 139466 */ GIM_Reject,
     /* 139467 */ // Label 2658: @139467
     /* 139467 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(139693),
     /* 139472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139475 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139482 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(139524), // Rule ID 7389 //
     /* 139487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139497 */     // MIs[0] Rn
     /* 139497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139509 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 139512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139522 */     GIR_RootConstrainSelectedInstOperands,
     /* 139523 */     // GIR_Coverage, 7389,
     /* 139523 */     GIR_EraseRootFromParent_Done,
     /* 139524 */   // Label 2673: @139524
     /* 139524 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(139566), // Rule ID 7390 //
     /* 139529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139539 */     // MIs[0] Rn
     /* 139539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139551 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 139554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139564 */     GIR_RootConstrainSelectedInstOperands,
     /* 139565 */     // GIR_Coverage, 7390,
     /* 139565 */     GIR_EraseRootFromParent_Done,
     /* 139566 */   // Label 2674: @139566
     /* 139566 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(139608), // Rule ID 7391 //
     /* 139571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139581 */     // MIs[0] Rn
     /* 139581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139593 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 139596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139606 */     GIR_RootConstrainSelectedInstOperands,
     /* 139607 */     // GIR_Coverage, 7391,
     /* 139607 */     GIR_EraseRootFromParent_Done,
     /* 139608 */   // Label 2675: @139608
     /* 139608 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(139650), // Rule ID 7392 //
     /* 139613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139616 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139623 */     // MIs[0] Rn
     /* 139623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139635 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 139638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139648 */     GIR_RootConstrainSelectedInstOperands,
     /* 139649 */     // GIR_Coverage, 7392,
     /* 139649 */     GIR_EraseRootFromParent_Done,
     /* 139650 */   // Label 2676: @139650
     /* 139650 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(139692), // Rule ID 7393 //
     /* 139655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139658 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139665 */     // MIs[0] Rn
     /* 139665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139677 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 139680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139690 */     GIR_RootConstrainSelectedInstOperands,
     /* 139691 */     // GIR_Coverage, 7393,
     /* 139691 */     GIR_EraseRootFromParent_Done,
     /* 139692 */   // Label 2677: @139692
     /* 139692 */   GIM_Reject,
     /* 139693 */ // Label 2672: @139693
     /* 139693 */ GIM_Reject,
     /* 139694 */ // Label 2659: @139694
     /* 139694 */ GIM_Reject,
     /* 139695 */ // Label 33: @139695
     /* 139695 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2681*/ GIMT_Encode4(140399),
     /* 139706 */ /*GILLT_s16*//*Label 2678*/ GIMT_Encode4(139718),
     /* 139710 */ /*GILLT_s32*//*Label 2679*/ GIMT_Encode4(139945),
     /* 139714 */ /*GILLT_s64*//*Label 2680*/ GIMT_Encode4(140172),
     /* 139718 */ // Label 2678: @139718
     /* 139718 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(139944),
     /* 139723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139726 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139733 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(139775), // Rule ID 7394 //
     /* 139738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139748 */     // MIs[0] Rn
     /* 139748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139760 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 139763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139773 */     GIR_RootConstrainSelectedInstOperands,
     /* 139774 */     // GIR_Coverage, 7394,
     /* 139774 */     GIR_EraseRootFromParent_Done,
     /* 139775 */   // Label 2683: @139775
     /* 139775 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(139817), // Rule ID 7395 //
     /* 139780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139790 */     // MIs[0] Rn
     /* 139790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139802 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 139805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139815 */     GIR_RootConstrainSelectedInstOperands,
     /* 139816 */     // GIR_Coverage, 7395,
     /* 139816 */     GIR_EraseRootFromParent_Done,
     /* 139817 */   // Label 2684: @139817
     /* 139817 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(139859), // Rule ID 7396 //
     /* 139822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139832 */     // MIs[0] Rn
     /* 139832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139844 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 139847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139857 */     GIR_RootConstrainSelectedInstOperands,
     /* 139858 */     // GIR_Coverage, 7396,
     /* 139858 */     GIR_EraseRootFromParent_Done,
     /* 139859 */   // Label 2685: @139859
     /* 139859 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(139901), // Rule ID 7397 //
     /* 139864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139874 */     // MIs[0] Rn
     /* 139874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139886 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 139889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139899 */     GIR_RootConstrainSelectedInstOperands,
     /* 139900 */     // GIR_Coverage, 7397,
     /* 139900 */     GIR_EraseRootFromParent_Done,
     /* 139901 */   // Label 2686: @139901
     /* 139901 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(139943), // Rule ID 7398 //
     /* 139906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139916 */     // MIs[0] Rn
     /* 139916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139928 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 139931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139941 */     GIR_RootConstrainSelectedInstOperands,
     /* 139942 */     // GIR_Coverage, 7398,
     /* 139942 */     GIR_EraseRootFromParent_Done,
     /* 139943 */   // Label 2687: @139943
     /* 139943 */   GIM_Reject,
     /* 139944 */ // Label 2682: @139944
     /* 139944 */ GIM_Reject,
     /* 139945 */ // Label 2679: @139945
     /* 139945 */ GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(140171),
     /* 139950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139953 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139960 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(140002), // Rule ID 7399 //
     /* 139965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139975 */     // MIs[0] Rn
     /* 139975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139987 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 139990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140000 */     GIR_RootConstrainSelectedInstOperands,
     /* 140001 */     // GIR_Coverage, 7399,
     /* 140001 */     GIR_EraseRootFromParent_Done,
     /* 140002 */   // Label 2689: @140002
     /* 140002 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(140044), // Rule ID 7400 //
     /* 140007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140017 */     // MIs[0] Rn
     /* 140017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140029 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 140032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140042 */     GIR_RootConstrainSelectedInstOperands,
     /* 140043 */     // GIR_Coverage, 7400,
     /* 140043 */     GIR_EraseRootFromParent_Done,
     /* 140044 */   // Label 2690: @140044
     /* 140044 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(140086), // Rule ID 7401 //
     /* 140049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140052 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140059 */     // MIs[0] Rn
     /* 140059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140071 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 140074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140084 */     GIR_RootConstrainSelectedInstOperands,
     /* 140085 */     // GIR_Coverage, 7401,
     /* 140085 */     GIR_EraseRootFromParent_Done,
     /* 140086 */   // Label 2691: @140086
     /* 140086 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(140128), // Rule ID 7402 //
     /* 140091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140094 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140101 */     // MIs[0] Rn
     /* 140101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140113 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 140116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140126 */     GIR_RootConstrainSelectedInstOperands,
     /* 140127 */     // GIR_Coverage, 7402,
     /* 140127 */     GIR_EraseRootFromParent_Done,
     /* 140128 */   // Label 2692: @140128
     /* 140128 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(140170), // Rule ID 7403 //
     /* 140133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140143 */     // MIs[0] Rn
     /* 140143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140155 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 140158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140168 */     GIR_RootConstrainSelectedInstOperands,
     /* 140169 */     // GIR_Coverage, 7403,
     /* 140169 */     GIR_EraseRootFromParent_Done,
     /* 140170 */   // Label 2693: @140170
     /* 140170 */   GIM_Reject,
     /* 140171 */ // Label 2688: @140171
     /* 140171 */ GIM_Reject,
     /* 140172 */ // Label 2680: @140172
     /* 140172 */ GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(140398),
     /* 140177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140180 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140187 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(140229), // Rule ID 7404 //
     /* 140192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140202 */     // MIs[0] Rn
     /* 140202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140214 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 140217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140227 */     GIR_RootConstrainSelectedInstOperands,
     /* 140228 */     // GIR_Coverage, 7404,
     /* 140228 */     GIR_EraseRootFromParent_Done,
     /* 140229 */   // Label 2695: @140229
     /* 140229 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(140271), // Rule ID 7405 //
     /* 140234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140244 */     // MIs[0] Rn
     /* 140244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140256 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 140259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140269 */     GIR_RootConstrainSelectedInstOperands,
     /* 140270 */     // GIR_Coverage, 7405,
     /* 140270 */     GIR_EraseRootFromParent_Done,
     /* 140271 */   // Label 2696: @140271
     /* 140271 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(140313), // Rule ID 7406 //
     /* 140276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140286 */     // MIs[0] Rn
     /* 140286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140298 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 140301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140311 */     GIR_RootConstrainSelectedInstOperands,
     /* 140312 */     // GIR_Coverage, 7406,
     /* 140312 */     GIR_EraseRootFromParent_Done,
     /* 140313 */   // Label 2697: @140313
     /* 140313 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(140355), // Rule ID 7407 //
     /* 140318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140321 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140328 */     // MIs[0] Rn
     /* 140328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140340 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 140343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140353 */     GIR_RootConstrainSelectedInstOperands,
     /* 140354 */     // GIR_Coverage, 7407,
     /* 140354 */     GIR_EraseRootFromParent_Done,
     /* 140355 */   // Label 2698: @140355
     /* 140355 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(140397), // Rule ID 7408 //
     /* 140360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140370 */     // MIs[0] Rn
     /* 140370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140382 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 140385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140395 */     GIR_RootConstrainSelectedInstOperands,
     /* 140396 */     // GIR_Coverage, 7408,
     /* 140396 */     GIR_EraseRootFromParent_Done,
     /* 140397 */   // Label 2699: @140397
     /* 140397 */   GIM_Reject,
     /* 140398 */ // Label 2694: @140398
     /* 140398 */ GIM_Reject,
     /* 140399 */ // Label 2681: @140399
     /* 140399 */ GIM_Reject,
     /* 140400 */ // Label 34: @140400
     /* 140400 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2703*/ GIMT_Encode4(141104),
     /* 140411 */ /*GILLT_s16*//*Label 2700*/ GIMT_Encode4(140423),
     /* 140415 */ /*GILLT_s32*//*Label 2701*/ GIMT_Encode4(140650),
     /* 140419 */ /*GILLT_s64*//*Label 2702*/ GIMT_Encode4(140877),
     /* 140423 */ // Label 2700: @140423
     /* 140423 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(140649),
     /* 140428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 140438 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(140480), // Rule ID 7409 //
     /* 140443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140446 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140453 */     // MIs[0] Rn
     /* 140453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140465 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 140468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140478 */     GIR_RootConstrainSelectedInstOperands,
     /* 140479 */     // GIR_Coverage, 7409,
     /* 140479 */     GIR_EraseRootFromParent_Done,
     /* 140480 */   // Label 2705: @140480
     /* 140480 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(140522), // Rule ID 7410 //
     /* 140485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140488 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140495 */     // MIs[0] Rn
     /* 140495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140507 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 140510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140520 */     GIR_RootConstrainSelectedInstOperands,
     /* 140521 */     // GIR_Coverage, 7410,
     /* 140521 */     GIR_EraseRootFromParent_Done,
     /* 140522 */   // Label 2706: @140522
     /* 140522 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(140564), // Rule ID 7411 //
     /* 140527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140537 */     // MIs[0] Rn
     /* 140537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140549 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 140552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140562 */     GIR_RootConstrainSelectedInstOperands,
     /* 140563 */     // GIR_Coverage, 7411,
     /* 140563 */     GIR_EraseRootFromParent_Done,
     /* 140564 */   // Label 2707: @140564
     /* 140564 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(140606), // Rule ID 7412 //
     /* 140569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140579 */     // MIs[0] Rn
     /* 140579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140591 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 140594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140604 */     GIR_RootConstrainSelectedInstOperands,
     /* 140605 */     // GIR_Coverage, 7412,
     /* 140605 */     GIR_EraseRootFromParent_Done,
     /* 140606 */   // Label 2708: @140606
     /* 140606 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(140648), // Rule ID 7413 //
     /* 140611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140621 */     // MIs[0] Rn
     /* 140621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140633 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 140636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140646 */     GIR_RootConstrainSelectedInstOperands,
     /* 140647 */     // GIR_Coverage, 7413,
     /* 140647 */     GIR_EraseRootFromParent_Done,
     /* 140648 */   // Label 2709: @140648
     /* 140648 */   GIM_Reject,
     /* 140649 */ // Label 2704: @140649
     /* 140649 */ GIM_Reject,
     /* 140650 */ // Label 2701: @140650
     /* 140650 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(140876),
     /* 140655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 140665 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(140707), // Rule ID 7414 //
     /* 140670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140680 */     // MIs[0] Rn
     /* 140680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140692 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 140695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140705 */     GIR_RootConstrainSelectedInstOperands,
     /* 140706 */     // GIR_Coverage, 7414,
     /* 140706 */     GIR_EraseRootFromParent_Done,
     /* 140707 */   // Label 2711: @140707
     /* 140707 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(140749), // Rule ID 7415 //
     /* 140712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140715 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140722 */     // MIs[0] Rn
     /* 140722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140734 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 140737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140747 */     GIR_RootConstrainSelectedInstOperands,
     /* 140748 */     // GIR_Coverage, 7415,
     /* 140748 */     GIR_EraseRootFromParent_Done,
     /* 140749 */   // Label 2712: @140749
     /* 140749 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(140791), // Rule ID 7416 //
     /* 140754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140764 */     // MIs[0] Rn
     /* 140764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140776 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 140779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140789 */     GIR_RootConstrainSelectedInstOperands,
     /* 140790 */     // GIR_Coverage, 7416,
     /* 140790 */     GIR_EraseRootFromParent_Done,
     /* 140791 */   // Label 2713: @140791
     /* 140791 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(140833), // Rule ID 7417 //
     /* 140796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140806 */     // MIs[0] Rn
     /* 140806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140818 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 140821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140831 */     GIR_RootConstrainSelectedInstOperands,
     /* 140832 */     // GIR_Coverage, 7417,
     /* 140832 */     GIR_EraseRootFromParent_Done,
     /* 140833 */   // Label 2714: @140833
     /* 140833 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(140875), // Rule ID 7418 //
     /* 140838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140841 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140848 */     // MIs[0] Rn
     /* 140848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140860 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 140863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140873 */     GIR_RootConstrainSelectedInstOperands,
     /* 140874 */     // GIR_Coverage, 7418,
     /* 140874 */     GIR_EraseRootFromParent_Done,
     /* 140875 */   // Label 2715: @140875
     /* 140875 */   GIM_Reject,
     /* 140876 */ // Label 2710: @140876
     /* 140876 */ GIM_Reject,
     /* 140877 */ // Label 2702: @140877
     /* 140877 */ GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(141103),
     /* 140882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140885 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140892 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(140934), // Rule ID 7419 //
     /* 140897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140907 */     // MIs[0] Rn
     /* 140907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140919 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 140922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140932 */     GIR_RootConstrainSelectedInstOperands,
     /* 140933 */     // GIR_Coverage, 7419,
     /* 140933 */     GIR_EraseRootFromParent_Done,
     /* 140934 */   // Label 2717: @140934
     /* 140934 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(140976), // Rule ID 7420 //
     /* 140939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140949 */     // MIs[0] Rn
     /* 140949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140961 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 140964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140974 */     GIR_RootConstrainSelectedInstOperands,
     /* 140975 */     // GIR_Coverage, 7420,
     /* 140975 */     GIR_EraseRootFromParent_Done,
     /* 140976 */   // Label 2718: @140976
     /* 140976 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(141018), // Rule ID 7421 //
     /* 140981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140991 */     // MIs[0] Rn
     /* 140991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141003 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 141006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141016 */     GIR_RootConstrainSelectedInstOperands,
     /* 141017 */     // GIR_Coverage, 7421,
     /* 141017 */     GIR_EraseRootFromParent_Done,
     /* 141018 */   // Label 2719: @141018
     /* 141018 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(141060), // Rule ID 7422 //
     /* 141023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 141029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141033 */     // MIs[0] Rn
     /* 141033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141045 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 141048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141058 */     GIR_RootConstrainSelectedInstOperands,
     /* 141059 */     // GIR_Coverage, 7422,
     /* 141059 */     GIR_EraseRootFromParent_Done,
     /* 141060 */   // Label 2720: @141060
     /* 141060 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(141102), // Rule ID 7423 //
     /* 141065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141068 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 141071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141075 */     // MIs[0] Rn
     /* 141075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141087 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 141090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141100 */     GIR_RootConstrainSelectedInstOperands,
     /* 141101 */     // GIR_Coverage, 7423,
     /* 141101 */     GIR_EraseRootFromParent_Done,
     /* 141102 */   // Label 2721: @141102
     /* 141102 */   GIM_Reject,
     /* 141103 */ // Label 2716: @141103
     /* 141103 */ GIM_Reject,
     /* 141104 */ // Label 2703: @141104
     /* 141104 */ GIM_Reject,
     /* 141105 */ // Label 35: @141105
     /* 141105 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2725*/ GIMT_Encode4(141809),
     /* 141116 */ /*GILLT_s16*//*Label 2722*/ GIMT_Encode4(141128),
     /* 141120 */ /*GILLT_s32*//*Label 2723*/ GIMT_Encode4(141355),
     /* 141124 */ /*GILLT_s64*//*Label 2724*/ GIMT_Encode4(141582),
     /* 141128 */ // Label 2722: @141128
     /* 141128 */ GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(141354),
     /* 141133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141136 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 141143 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(141185), // Rule ID 7424 //
     /* 141148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 141154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141158 */     // MIs[0] Rn
     /* 141158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141170 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 141173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141183 */     GIR_RootConstrainSelectedInstOperands,
     /* 141184 */     // GIR_Coverage, 7424,
     /* 141184 */     GIR_EraseRootFromParent_Done,
     /* 141185 */   // Label 2727: @141185
     /* 141185 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(141227), // Rule ID 7425 //
     /* 141190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 141196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141200 */     // MIs[0] Rn
     /* 141200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141212 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 141215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141225 */     GIR_RootConstrainSelectedInstOperands,
     /* 141226 */     // GIR_Coverage, 7425,
     /* 141226 */     GIR_EraseRootFromParent_Done,
     /* 141227 */   // Label 2728: @141227
     /* 141227 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(141269), // Rule ID 7426 //
     /* 141232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141242 */     // MIs[0] Rn
     /* 141242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141254 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 141257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141267 */     GIR_RootConstrainSelectedInstOperands,
     /* 141268 */     // GIR_Coverage, 7426,
     /* 141268 */     GIR_EraseRootFromParent_Done,
     /* 141269 */   // Label 2729: @141269
     /* 141269 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(141311), // Rule ID 7427 //
     /* 141274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 141280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141284 */     // MIs[0] Rn
     /* 141284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141296 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 141299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141309 */     GIR_RootConstrainSelectedInstOperands,
     /* 141310 */     // GIR_Coverage, 7427,
     /* 141310 */     GIR_EraseRootFromParent_Done,
     /* 141311 */   // Label 2730: @141311
     /* 141311 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(141353), // Rule ID 7428 //
     /* 141316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 141322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141326 */     // MIs[0] Rn
     /* 141326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141338 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 141341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141351 */     GIR_RootConstrainSelectedInstOperands,
     /* 141352 */     // GIR_Coverage, 7428,
     /* 141352 */     GIR_EraseRootFromParent_Done,
     /* 141353 */   // Label 2731: @141353
     /* 141353 */   GIM_Reject,
     /* 141354 */ // Label 2726: @141354
     /* 141354 */ GIM_Reject,
     /* 141355 */ // Label 2723: @141355
     /* 141355 */ GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(141581),
     /* 141360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141363 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 141370 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(141412), // Rule ID 7429 //
     /* 141375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 141381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141385 */     // MIs[0] Rn
     /* 141385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141397 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 141400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141410 */     GIR_RootConstrainSelectedInstOperands,
     /* 141411 */     // GIR_Coverage, 7429,
     /* 141411 */     GIR_EraseRootFromParent_Done,
     /* 141412 */   // Label 2733: @141412
     /* 141412 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(141454), // Rule ID 7430 //
     /* 141417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 141423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141427 */     // MIs[0] Rn
     /* 141427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141439 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 141442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141452 */     GIR_RootConstrainSelectedInstOperands,
     /* 141453 */     // GIR_Coverage, 7430,
     /* 141453 */     GIR_EraseRootFromParent_Done,
     /* 141454 */   // Label 2734: @141454
     /* 141454 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(141496), // Rule ID 7431 //
     /* 141459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141462 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141469 */     // MIs[0] Rn
     /* 141469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141481 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 141484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141494 */     GIR_RootConstrainSelectedInstOperands,
     /* 141495 */     // GIR_Coverage, 7431,
     /* 141495 */     GIR_EraseRootFromParent_Done,
     /* 141496 */   // Label 2735: @141496
     /* 141496 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(141538), // Rule ID 7432 //
     /* 141501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 141507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141511 */     // MIs[0] Rn
     /* 141511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141523 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 141526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141536 */     GIR_RootConstrainSelectedInstOperands,
     /* 141537 */     // GIR_Coverage, 7432,
     /* 141537 */     GIR_EraseRootFromParent_Done,
     /* 141538 */   // Label 2736: @141538
     /* 141538 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(141580), // Rule ID 7433 //
     /* 141543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 141549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141553 */     // MIs[0] Rn
     /* 141553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141565 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 141568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141578 */     GIR_RootConstrainSelectedInstOperands,
     /* 141579 */     // GIR_Coverage, 7433,
     /* 141579 */     GIR_EraseRootFromParent_Done,
     /* 141580 */   // Label 2737: @141580
     /* 141580 */   GIM_Reject,
     /* 141581 */ // Label 2732: @141581
     /* 141581 */ GIM_Reject,
     /* 141582 */ // Label 2724: @141582
     /* 141582 */ GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(141808),
     /* 141587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141590 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141597 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(141639), // Rule ID 7434 //
     /* 141602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 141608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141612 */     // MIs[0] Rn
     /* 141612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141624 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 141627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141637 */     GIR_RootConstrainSelectedInstOperands,
     /* 141638 */     // GIR_Coverage, 7434,
     /* 141638 */     GIR_EraseRootFromParent_Done,
     /* 141639 */   // Label 2739: @141639
     /* 141639 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(141681), // Rule ID 7435 //
     /* 141644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 141650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141654 */     // MIs[0] Rn
     /* 141654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141666 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 141669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141679 */     GIR_RootConstrainSelectedInstOperands,
     /* 141680 */     // GIR_Coverage, 7435,
     /* 141680 */     GIR_EraseRootFromParent_Done,
     /* 141681 */   // Label 2740: @141681
     /* 141681 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(141723), // Rule ID 7436 //
     /* 141686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141696 */     // MIs[0] Rn
     /* 141696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141708 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 141711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141721 */     GIR_RootConstrainSelectedInstOperands,
     /* 141722 */     // GIR_Coverage, 7436,
     /* 141722 */     GIR_EraseRootFromParent_Done,
     /* 141723 */   // Label 2741: @141723
     /* 141723 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(141765), // Rule ID 7437 //
     /* 141728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 141734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141738 */     // MIs[0] Rn
     /* 141738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141750 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 141753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141763 */     GIR_RootConstrainSelectedInstOperands,
     /* 141764 */     // GIR_Coverage, 7437,
     /* 141764 */     GIR_EraseRootFromParent_Done,
     /* 141765 */   // Label 2742: @141765
     /* 141765 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(141807), // Rule ID 7438 //
     /* 141770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 141773 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 141776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141780 */     // MIs[0] Rn
     /* 141780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141792 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 141792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 141795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 141797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 141799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141805 */     GIR_RootConstrainSelectedInstOperands,
     /* 141806 */     // GIR_Coverage, 7438,
     /* 141806 */     GIR_EraseRootFromParent_Done,
     /* 141807 */   // Label 2743: @141807
     /* 141807 */   GIM_Reject,
     /* 141808 */ // Label 2738: @141808
     /* 141808 */ GIM_Reject,
     /* 141809 */ // Label 2725: @141809
     /* 141809 */ GIM_Reject,
     /* 141810 */ // Label 36: @141810
     /* 141810 */ GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(141837), // Rule ID 7024 //
     /* 141815 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141818 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 141822 */   // MIs[0] Operand 1
     /* 141822 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 141825 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 141825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 141828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 141831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141835 */   GIR_RootConstrainSelectedInstOperands,
     /* 141836 */   // GIR_Coverage, 7024,
     /* 141836 */   GIR_EraseRootFromParent_Done,
     /* 141837 */ // Label 2744: @141837
     /* 141837 */ GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(141860), // Rule ID 7025 //
     /* 141842 */   // MIs[0] Operand 0
     /* 141842 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 141845 */   // MIs[0] Operand 1
     /* 141845 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 141848 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 141848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 141851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 141854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141858 */   GIR_RootConstrainSelectedInstOperands,
     /* 141859 */   // GIR_Coverage, 7025,
     /* 141859 */   GIR_EraseRootFromParent_Done,
     /* 141860 */ // Label 2745: @141860
     /* 141860 */ GIM_Reject,
     /* 141861 */ // Label 37: @141861
     /* 141861 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(154388),
     /* 141866 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 141869 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(141960), // Rule ID 6503 //
     /* 141874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 141877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 141882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 141885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 141900 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 141903 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 141908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141912 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 141916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141928 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 141928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 141931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 141935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 141944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 141948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 141953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141958 */     GIR_RootConstrainSelectedInstOperands,
     /* 141959 */     // GIR_Coverage, 6503,
     /* 141959 */     GIR_EraseRootFromParent_Done,
     /* 141960 */   // Label 2747: @141960
     /* 141960 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(142051), // Rule ID 6504 //
     /* 141965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 141968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 141973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 141976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 141991 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 141994 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 141999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142003 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 142007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142019 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 142019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 142026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 142035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 142039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 142044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142049 */     GIR_RootConstrainSelectedInstOperands,
     /* 142050 */     // GIR_Coverage, 6504,
     /* 142050 */     GIR_EraseRootFromParent_Done,
     /* 142051 */   // Label 2748: @142051
     /* 142051 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(142112), // Rule ID 4898 //
     /* 142056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 142061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 142079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 142083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142088 */     // MIs[1] Operand 2
     /* 142088 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 142099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142101 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 142101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 142104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 142110 */     GIR_RootConstrainSelectedInstOperands,
     /* 142111 */     // GIR_Coverage, 4898,
     /* 142111 */     GIR_EraseRootFromParent_Done,
     /* 142112 */   // Label 2749: @142112
     /* 142112 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(142152), // Rule ID 2651 //
     /* 142117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 142125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142132 */     // MIs[0] pattern
     /* 142132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 142135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 142140 */     // (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 142140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 142143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142145 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 142147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142150 */     GIR_RootConstrainSelectedInstOperands,
     /* 142151 */     // GIR_Coverage, 2651,
     /* 142151 */     GIR_EraseRootFromParent_Done,
     /* 142152 */   // Label 2750: @142152
     /* 142152 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(142192), // Rule ID 9945 //
     /* 142157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 142165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142172 */     // MIs[0] pattern
     /* 142172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 142175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 142180 */     // (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 142180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 142183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142185 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 142187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142190 */     GIR_RootConstrainSelectedInstOperands,
     /* 142191 */     // GIR_Coverage, 9945,
     /* 142191 */     GIR_EraseRootFromParent_Done,
     /* 142192 */   // Label 2751: @142192
     /* 142192 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(142232), // Rule ID 9948 //
     /* 142197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 142205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142212 */     // MIs[0] pattern
     /* 142212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 142215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 142220 */     // (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 142220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 142223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142225 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 142227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142230 */     GIR_RootConstrainSelectedInstOperands,
     /* 142231 */     // GIR_Coverage, 9948,
     /* 142231 */     GIR_EraseRootFromParent_Done,
     /* 142232 */   // Label 2752: @142232
     /* 142232 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(142272), // Rule ID 9951 //
     /* 142237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 142245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142252 */     // MIs[0] pattern
     /* 142252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 142255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 142260 */     // (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 142260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 142263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142265 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 142267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142270 */     GIR_RootConstrainSelectedInstOperands,
     /* 142271 */     // GIR_Coverage, 9951,
     /* 142271 */     GIR_EraseRootFromParent_Done,
     /* 142272 */   // Label 2753: @142272
     /* 142272 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(142311), // Rule ID 66 //
     /* 142277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 142280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 142285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142299 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 142302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 142309 */     GIR_RootConstrainSelectedInstOperands,
     /* 142310 */     // GIR_Coverage, 66,
     /* 142310 */     GIR_EraseRootFromParent_Done,
     /* 142311 */   // Label 2754: @142311
     /* 142311 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(142347), // Rule ID 346 //
     /* 142316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142338 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 142341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142345 */     GIR_RootConstrainSelectedInstOperands,
     /* 142346 */     // GIR_Coverage, 346,
     /* 142346 */     GIR_EraseRootFromParent_Done,
     /* 142347 */   // Label 2755: @142347
     /* 142347 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(142383), // Rule ID 347 //
     /* 142352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142374 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 142377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142381 */     GIR_RootConstrainSelectedInstOperands,
     /* 142382 */     // GIR_Coverage, 347,
     /* 142382 */     GIR_EraseRootFromParent_Done,
     /* 142383 */   // Label 2756: @142383
     /* 142383 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(142419), // Rule ID 348 //
     /* 142388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142410 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 142413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142417 */     GIR_RootConstrainSelectedInstOperands,
     /* 142418 */     // GIR_Coverage, 348,
     /* 142418 */     GIR_EraseRootFromParent_Done,
     /* 142419 */   // Label 2757: @142419
     /* 142419 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(142455), // Rule ID 349 //
     /* 142424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142446 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 142449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142453 */     GIR_RootConstrainSelectedInstOperands,
     /* 142454 */     // GIR_Coverage, 349,
     /* 142454 */     GIR_EraseRootFromParent_Done,
     /* 142455 */   // Label 2758: @142455
     /* 142455 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(142491), // Rule ID 350 //
     /* 142460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142482 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 142485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142489 */     GIR_RootConstrainSelectedInstOperands,
     /* 142490 */     // GIR_Coverage, 350,
     /* 142490 */     GIR_EraseRootFromParent_Done,
     /* 142491 */   // Label 2759: @142491
     /* 142491 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(142527), // Rule ID 351 //
     /* 142496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142518 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 142521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142525 */     GIR_RootConstrainSelectedInstOperands,
     /* 142526 */     // GIR_Coverage, 351,
     /* 142526 */     GIR_EraseRootFromParent_Done,
     /* 142527 */   // Label 2760: @142527
     /* 142527 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(142563), // Rule ID 352 //
     /* 142532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142554 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 142557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142561 */     GIR_RootConstrainSelectedInstOperands,
     /* 142562 */     // GIR_Coverage, 352,
     /* 142562 */     GIR_EraseRootFromParent_Done,
     /* 142563 */   // Label 2761: @142563
     /* 142563 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(142599), // Rule ID 353 //
     /* 142568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142590 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 142593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142597 */     GIR_RootConstrainSelectedInstOperands,
     /* 142598 */     // GIR_Coverage, 353,
     /* 142598 */     GIR_EraseRootFromParent_Done,
     /* 142599 */   // Label 2762: @142599
     /* 142599 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(142635), // Rule ID 354 //
     /* 142604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142626 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 142629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142633 */     GIR_RootConstrainSelectedInstOperands,
     /* 142634 */     // GIR_Coverage, 354,
     /* 142634 */     GIR_EraseRootFromParent_Done,
     /* 142635 */   // Label 2763: @142635
     /* 142635 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(142671), // Rule ID 355 //
     /* 142640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142662 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 142665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142669 */     GIR_RootConstrainSelectedInstOperands,
     /* 142670 */     // GIR_Coverage, 355,
     /* 142670 */     GIR_EraseRootFromParent_Done,
     /* 142671 */   // Label 2764: @142671
     /* 142671 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(142707), // Rule ID 356 //
     /* 142676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142698 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 142701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142705 */     GIR_RootConstrainSelectedInstOperands,
     /* 142706 */     // GIR_Coverage, 356,
     /* 142706 */     GIR_EraseRootFromParent_Done,
     /* 142707 */   // Label 2765: @142707
     /* 142707 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(142743), // Rule ID 357 //
     /* 142712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142734 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 142737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142741 */     GIR_RootConstrainSelectedInstOperands,
     /* 142742 */     // GIR_Coverage, 357,
     /* 142742 */     GIR_EraseRootFromParent_Done,
     /* 142743 */   // Label 2766: @142743
     /* 142743 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(142779), // Rule ID 358 //
     /* 142748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142770 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 142773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142777 */     GIR_RootConstrainSelectedInstOperands,
     /* 142778 */     // GIR_Coverage, 358,
     /* 142778 */     GIR_EraseRootFromParent_Done,
     /* 142779 */   // Label 2767: @142779
     /* 142779 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(142815), // Rule ID 359 //
     /* 142784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142806 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 142809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142813 */     GIR_RootConstrainSelectedInstOperands,
     /* 142814 */     // GIR_Coverage, 359,
     /* 142814 */     GIR_EraseRootFromParent_Done,
     /* 142815 */   // Label 2768: @142815
     /* 142815 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(142851), // Rule ID 360 //
     /* 142820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142842 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 142845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142849 */     GIR_RootConstrainSelectedInstOperands,
     /* 142850 */     // GIR_Coverage, 360,
     /* 142850 */     GIR_EraseRootFromParent_Done,
     /* 142851 */   // Label 2769: @142851
     /* 142851 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(142887), // Rule ID 361 //
     /* 142856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142878 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 142881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142885 */     GIR_RootConstrainSelectedInstOperands,
     /* 142886 */     // GIR_Coverage, 361,
     /* 142886 */     GIR_EraseRootFromParent_Done,
     /* 142887 */   // Label 2770: @142887
     /* 142887 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(142923), // Rule ID 362 //
     /* 142892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142914 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 142917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142921 */     GIR_RootConstrainSelectedInstOperands,
     /* 142922 */     // GIR_Coverage, 362,
     /* 142922 */     GIR_EraseRootFromParent_Done,
     /* 142923 */   // Label 2771: @142923
     /* 142923 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(142959), // Rule ID 363 //
     /* 142928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142950 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 142953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142957 */     GIR_RootConstrainSelectedInstOperands,
     /* 142958 */     // GIR_Coverage, 363,
     /* 142958 */     GIR_EraseRootFromParent_Done,
     /* 142959 */   // Label 2772: @142959
     /* 142959 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(142995), // Rule ID 364 //
     /* 142964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142986 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 142989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142993 */     GIR_RootConstrainSelectedInstOperands,
     /* 142994 */     // GIR_Coverage, 364,
     /* 142994 */     GIR_EraseRootFromParent_Done,
     /* 142995 */   // Label 2773: @142995
     /* 142995 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(143031), // Rule ID 365 //
     /* 143000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143022 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 143025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143029 */     GIR_RootConstrainSelectedInstOperands,
     /* 143030 */     // GIR_Coverage, 365,
     /* 143030 */     GIR_EraseRootFromParent_Done,
     /* 143031 */   // Label 2774: @143031
     /* 143031 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(143067), // Rule ID 366 //
     /* 143036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143058 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 143061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143065 */     GIR_RootConstrainSelectedInstOperands,
     /* 143066 */     // GIR_Coverage, 366,
     /* 143066 */     GIR_EraseRootFromParent_Done,
     /* 143067 */   // Label 2775: @143067
     /* 143067 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(143103), // Rule ID 367 //
     /* 143072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143094 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 143097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143101 */     GIR_RootConstrainSelectedInstOperands,
     /* 143102 */     // GIR_Coverage, 367,
     /* 143102 */     GIR_EraseRootFromParent_Done,
     /* 143103 */   // Label 2776: @143103
     /* 143103 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(143139), // Rule ID 368 //
     /* 143108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143130 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 143133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143137 */     GIR_RootConstrainSelectedInstOperands,
     /* 143138 */     // GIR_Coverage, 368,
     /* 143138 */     GIR_EraseRootFromParent_Done,
     /* 143139 */   // Label 2777: @143139
     /* 143139 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(143175), // Rule ID 369 //
     /* 143144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143166 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 143166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 143169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143173 */     GIR_RootConstrainSelectedInstOperands,
     /* 143174 */     // GIR_Coverage, 369,
     /* 143174 */     GIR_EraseRootFromParent_Done,
     /* 143175 */   // Label 2778: @143175
     /* 143175 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(143211), // Rule ID 370 //
     /* 143180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143202 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 143202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 143205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143209 */     GIR_RootConstrainSelectedInstOperands,
     /* 143210 */     // GIR_Coverage, 370,
     /* 143210 */     GIR_EraseRootFromParent_Done,
     /* 143211 */   // Label 2779: @143211
     /* 143211 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(143247), // Rule ID 371 //
     /* 143216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143238 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 143241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143245 */     GIR_RootConstrainSelectedInstOperands,
     /* 143246 */     // GIR_Coverage, 371,
     /* 143246 */     GIR_EraseRootFromParent_Done,
     /* 143247 */   // Label 2780: @143247
     /* 143247 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(143283), // Rule ID 372 //
     /* 143252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143274 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 143277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143281 */     GIR_RootConstrainSelectedInstOperands,
     /* 143282 */     // GIR_Coverage, 372,
     /* 143282 */     GIR_EraseRootFromParent_Done,
     /* 143283 */   // Label 2781: @143283
     /* 143283 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(143319), // Rule ID 373 //
     /* 143288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143310 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 143313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143317 */     GIR_RootConstrainSelectedInstOperands,
     /* 143318 */     // GIR_Coverage, 373,
     /* 143318 */     GIR_EraseRootFromParent_Done,
     /* 143319 */   // Label 2782: @143319
     /* 143319 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(143355), // Rule ID 374 //
     /* 143324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143346 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 143349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143353 */     GIR_RootConstrainSelectedInstOperands,
     /* 143354 */     // GIR_Coverage, 374,
     /* 143354 */     GIR_EraseRootFromParent_Done,
     /* 143355 */   // Label 2783: @143355
     /* 143355 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(143391), // Rule ID 375 //
     /* 143360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143382 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 143382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 143385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143389 */     GIR_RootConstrainSelectedInstOperands,
     /* 143390 */     // GIR_Coverage, 375,
     /* 143390 */     GIR_EraseRootFromParent_Done,
     /* 143391 */   // Label 2784: @143391
     /* 143391 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(143427), // Rule ID 376 //
     /* 143396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143418 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 143418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 143421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143425 */     GIR_RootConstrainSelectedInstOperands,
     /* 143426 */     // GIR_Coverage, 376,
     /* 143426 */     GIR_EraseRootFromParent_Done,
     /* 143427 */   // Label 2785: @143427
     /* 143427 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(143463), // Rule ID 377 //
     /* 143432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143454 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 143457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143461 */     GIR_RootConstrainSelectedInstOperands,
     /* 143462 */     // GIR_Coverage, 377,
     /* 143462 */     GIR_EraseRootFromParent_Done,
     /* 143463 */   // Label 2786: @143463
     /* 143463 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(143499), // Rule ID 378 //
     /* 143468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143490 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 143493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143497 */     GIR_RootConstrainSelectedInstOperands,
     /* 143498 */     // GIR_Coverage, 378,
     /* 143498 */     GIR_EraseRootFromParent_Done,
     /* 143499 */   // Label 2787: @143499
     /* 143499 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(143535), // Rule ID 379 //
     /* 143504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143526 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 143529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143533 */     GIR_RootConstrainSelectedInstOperands,
     /* 143534 */     // GIR_Coverage, 379,
     /* 143534 */     GIR_EraseRootFromParent_Done,
     /* 143535 */   // Label 2788: @143535
     /* 143535 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(143571), // Rule ID 380 //
     /* 143540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143562 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 143565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143569 */     GIR_RootConstrainSelectedInstOperands,
     /* 143570 */     // GIR_Coverage, 380,
     /* 143570 */     GIR_EraseRootFromParent_Done,
     /* 143571 */   // Label 2789: @143571
     /* 143571 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(143607), // Rule ID 381 //
     /* 143576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143598 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 143598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 143601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143605 */     GIR_RootConstrainSelectedInstOperands,
     /* 143606 */     // GIR_Coverage, 381,
     /* 143606 */     GIR_EraseRootFromParent_Done,
     /* 143607 */   // Label 2790: @143607
     /* 143607 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(143643), // Rule ID 382 //
     /* 143612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143634 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 143634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 143637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143641 */     GIR_RootConstrainSelectedInstOperands,
     /* 143642 */     // GIR_Coverage, 382,
     /* 143642 */     GIR_EraseRootFromParent_Done,
     /* 143643 */   // Label 2791: @143643
     /* 143643 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(143679), // Rule ID 383 //
     /* 143648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143670 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 143673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143677 */     GIR_RootConstrainSelectedInstOperands,
     /* 143678 */     // GIR_Coverage, 383,
     /* 143678 */     GIR_EraseRootFromParent_Done,
     /* 143679 */   // Label 2792: @143679
     /* 143679 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(143715), // Rule ID 384 //
     /* 143684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143706 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 143709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143713 */     GIR_RootConstrainSelectedInstOperands,
     /* 143714 */     // GIR_Coverage, 384,
     /* 143714 */     GIR_EraseRootFromParent_Done,
     /* 143715 */   // Label 2793: @143715
     /* 143715 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(143751), // Rule ID 385 //
     /* 143720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143742 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 143745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143749 */     GIR_RootConstrainSelectedInstOperands,
     /* 143750 */     // GIR_Coverage, 385,
     /* 143750 */     GIR_EraseRootFromParent_Done,
     /* 143751 */   // Label 2794: @143751
     /* 143751 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(143787), // Rule ID 386 //
     /* 143756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143778 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 143781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143785 */     GIR_RootConstrainSelectedInstOperands,
     /* 143786 */     // GIR_Coverage, 386,
     /* 143786 */     GIR_EraseRootFromParent_Done,
     /* 143787 */   // Label 2795: @143787
     /* 143787 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(143823), // Rule ID 387 //
     /* 143792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143814 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 143814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 143817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143821 */     GIR_RootConstrainSelectedInstOperands,
     /* 143822 */     // GIR_Coverage, 387,
     /* 143822 */     GIR_EraseRootFromParent_Done,
     /* 143823 */   // Label 2796: @143823
     /* 143823 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(143859), // Rule ID 388 //
     /* 143828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143850 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 143850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 143853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143857 */     GIR_RootConstrainSelectedInstOperands,
     /* 143858 */     // GIR_Coverage, 388,
     /* 143858 */     GIR_EraseRootFromParent_Done,
     /* 143859 */   // Label 2797: @143859
     /* 143859 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(143895), // Rule ID 389 //
     /* 143864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 143867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143886 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 143886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 143889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143893 */     GIR_RootConstrainSelectedInstOperands,
     /* 143894 */     // GIR_Coverage, 389,
     /* 143894 */     GIR_EraseRootFromParent_Done,
     /* 143895 */   // Label 2798: @143895
     /* 143895 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(143931), // Rule ID 390 //
     /* 143900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143922 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 143922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 143925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143929 */     GIR_RootConstrainSelectedInstOperands,
     /* 143930 */     // GIR_Coverage, 390,
     /* 143930 */     GIR_EraseRootFromParent_Done,
     /* 143931 */   // Label 2799: @143931
     /* 143931 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(143967), // Rule ID 391 //
     /* 143936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143958 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 143958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 143961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143965 */     GIR_RootConstrainSelectedInstOperands,
     /* 143966 */     // GIR_Coverage, 391,
     /* 143966 */     GIR_EraseRootFromParent_Done,
     /* 143967 */   // Label 2800: @143967
     /* 143967 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(144003), // Rule ID 392 //
     /* 143972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 143975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143994 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 143994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 143997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144001 */     GIR_RootConstrainSelectedInstOperands,
     /* 144002 */     // GIR_Coverage, 392,
     /* 144002 */     GIR_EraseRootFromParent_Done,
     /* 144003 */   // Label 2801: @144003
     /* 144003 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(144039), // Rule ID 393 //
     /* 144008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 144011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144030 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 144030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 144033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144037 */     GIR_RootConstrainSelectedInstOperands,
     /* 144038 */     // GIR_Coverage, 393,
     /* 144038 */     GIR_EraseRootFromParent_Done,
     /* 144039 */   // Label 2802: @144039
     /* 144039 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(144075), // Rule ID 575 //
     /* 144044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 144052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144066 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 144069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144073 */     GIR_RootConstrainSelectedInstOperands,
     /* 144074 */     // GIR_Coverage, 575,
     /* 144074 */     GIR_EraseRootFromParent_Done,
     /* 144075 */   // Label 2803: @144075
     /* 144075 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(144111), // Rule ID 576 //
     /* 144080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 144088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144102 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 144105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144109 */     GIR_RootConstrainSelectedInstOperands,
     /* 144110 */     // GIR_Coverage, 576,
     /* 144110 */     GIR_EraseRootFromParent_Done,
     /* 144111 */   // Label 2804: @144111
     /* 144111 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(144147), // Rule ID 577 //
     /* 144116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 144124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144138 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 144141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144145 */     GIR_RootConstrainSelectedInstOperands,
     /* 144146 */     // GIR_Coverage, 577,
     /* 144146 */     GIR_EraseRootFromParent_Done,
     /* 144147 */   // Label 2805: @144147
     /* 144147 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(144183), // Rule ID 578 //
     /* 144152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 144160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144174 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 144177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144181 */     GIR_RootConstrainSelectedInstOperands,
     /* 144182 */     // GIR_Coverage, 578,
     /* 144182 */     GIR_EraseRootFromParent_Done,
     /* 144183 */   // Label 2806: @144183
     /* 144183 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(144219), // Rule ID 579 //
     /* 144188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 144196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144210 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 144213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144217 */     GIR_RootConstrainSelectedInstOperands,
     /* 144218 */     // GIR_Coverage, 579,
     /* 144218 */     GIR_EraseRootFromParent_Done,
     /* 144219 */   // Label 2807: @144219
     /* 144219 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(144255), // Rule ID 580 //
     /* 144224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 144232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144246 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 144249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144253 */     GIR_RootConstrainSelectedInstOperands,
     /* 144254 */     // GIR_Coverage, 580,
     /* 144254 */     GIR_EraseRootFromParent_Done,
     /* 144255 */   // Label 2808: @144255
     /* 144255 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(144291), // Rule ID 581 //
     /* 144260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 144268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144282 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 144285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144289 */     GIR_RootConstrainSelectedInstOperands,
     /* 144290 */     // GIR_Coverage, 581,
     /* 144290 */     GIR_EraseRootFromParent_Done,
     /* 144291 */   // Label 2809: @144291
     /* 144291 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(144327), // Rule ID 582 //
     /* 144296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 144304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144318 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 144321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144325 */     GIR_RootConstrainSelectedInstOperands,
     /* 144326 */     // GIR_Coverage, 582,
     /* 144326 */     GIR_EraseRootFromParent_Done,
     /* 144327 */   // Label 2810: @144327
     /* 144327 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(144363), // Rule ID 710 //
     /* 144332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144354 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 144357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144361 */     GIR_RootConstrainSelectedInstOperands,
     /* 144362 */     // GIR_Coverage, 710,
     /* 144362 */     GIR_EraseRootFromParent_Done,
     /* 144363 */   // Label 2811: @144363
     /* 144363 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(144399), // Rule ID 711 //
     /* 144368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144390 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 144393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144397 */     GIR_RootConstrainSelectedInstOperands,
     /* 144398 */     // GIR_Coverage, 711,
     /* 144398 */     GIR_EraseRootFromParent_Done,
     /* 144399 */   // Label 2812: @144399
     /* 144399 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(144435), // Rule ID 712 //
     /* 144404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144426 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 144429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144433 */     GIR_RootConstrainSelectedInstOperands,
     /* 144434 */     // GIR_Coverage, 712,
     /* 144434 */     GIR_EraseRootFromParent_Done,
     /* 144435 */   // Label 2813: @144435
     /* 144435 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(144471), // Rule ID 713 //
     /* 144440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144462 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 144465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144469 */     GIR_RootConstrainSelectedInstOperands,
     /* 144470 */     // GIR_Coverage, 713,
     /* 144470 */     GIR_EraseRootFromParent_Done,
     /* 144471 */   // Label 2814: @144471
     /* 144471 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(144507), // Rule ID 714 //
     /* 144476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144498 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 144501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144505 */     GIR_RootConstrainSelectedInstOperands,
     /* 144506 */     // GIR_Coverage, 714,
     /* 144506 */     GIR_EraseRootFromParent_Done,
     /* 144507 */   // Label 2815: @144507
     /* 144507 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(144543), // Rule ID 715 //
     /* 144512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 144520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144534 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 144537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144541 */     GIR_RootConstrainSelectedInstOperands,
     /* 144542 */     // GIR_Coverage, 715,
     /* 144542 */     GIR_EraseRootFromParent_Done,
     /* 144543 */   // Label 2816: @144543
     /* 144543 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(144579), // Rule ID 796 //
     /* 144548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144570 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 144570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 144573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144577 */     GIR_RootConstrainSelectedInstOperands,
     /* 144578 */     // GIR_Coverage, 796,
     /* 144578 */     GIR_EraseRootFromParent_Done,
     /* 144579 */   // Label 2817: @144579
     /* 144579 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(144615), // Rule ID 797 //
     /* 144584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144606 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 144609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144613 */     GIR_RootConstrainSelectedInstOperands,
     /* 144614 */     // GIR_Coverage, 797,
     /* 144614 */     GIR_EraseRootFromParent_Done,
     /* 144615 */   // Label 2818: @144615
     /* 144615 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(144651), // Rule ID 798 //
     /* 144620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144642 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 144642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 144645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144649 */     GIR_RootConstrainSelectedInstOperands,
     /* 144650 */     // GIR_Coverage, 798,
     /* 144650 */     GIR_EraseRootFromParent_Done,
     /* 144651 */   // Label 2819: @144651
     /* 144651 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(144687), // Rule ID 799 //
     /* 144656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144678 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 144678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 144681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144685 */     GIR_RootConstrainSelectedInstOperands,
     /* 144686 */     // GIR_Coverage, 799,
     /* 144686 */     GIR_EraseRootFromParent_Done,
     /* 144687 */   // Label 2820: @144687
     /* 144687 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(144723), // Rule ID 800 //
     /* 144692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 144700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144714 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 144714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 144717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144721 */     GIR_RootConstrainSelectedInstOperands,
     /* 144722 */     // GIR_Coverage, 800,
     /* 144722 */     GIR_EraseRootFromParent_Done,
     /* 144723 */   // Label 2821: @144723
     /* 144723 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(144759), // Rule ID 801 //
     /* 144728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144750 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 144750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 144753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144757 */     GIR_RootConstrainSelectedInstOperands,
     /* 144758 */     // GIR_Coverage, 801,
     /* 144758 */     GIR_EraseRootFromParent_Done,
     /* 144759 */   // Label 2822: @144759
     /* 144759 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(144795), // Rule ID 802 //
     /* 144764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144786 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 144789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144793 */     GIR_RootConstrainSelectedInstOperands,
     /* 144794 */     // GIR_Coverage, 802,
     /* 144794 */     GIR_EraseRootFromParent_Done,
     /* 144795 */   // Label 2823: @144795
     /* 144795 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(144831), // Rule ID 803 //
     /* 144800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144822 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 144822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 144825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144829 */     GIR_RootConstrainSelectedInstOperands,
     /* 144830 */     // GIR_Coverage, 803,
     /* 144830 */     GIR_EraseRootFromParent_Done,
     /* 144831 */   // Label 2824: @144831
     /* 144831 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(144867), // Rule ID 804 //
     /* 144836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144858 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 144858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 144861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144865 */     GIR_RootConstrainSelectedInstOperands,
     /* 144866 */     // GIR_Coverage, 804,
     /* 144866 */     GIR_EraseRootFromParent_Done,
     /* 144867 */   // Label 2825: @144867
     /* 144867 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(144903), // Rule ID 805 //
     /* 144872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 144880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144894 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 144894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 144897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144901 */     GIR_RootConstrainSelectedInstOperands,
     /* 144902 */     // GIR_Coverage, 805,
     /* 144902 */     GIR_EraseRootFromParent_Done,
     /* 144903 */   // Label 2826: @144903
     /* 144903 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(144939), // Rule ID 806 //
     /* 144908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 144916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144930 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 144930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 144933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144937 */     GIR_RootConstrainSelectedInstOperands,
     /* 144938 */     // GIR_Coverage, 806,
     /* 144938 */     GIR_EraseRootFromParent_Done,
     /* 144939 */   // Label 2827: @144939
     /* 144939 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(144975), // Rule ID 807 //
     /* 144944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 144952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144966 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 144969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144973 */     GIR_RootConstrainSelectedInstOperands,
     /* 144974 */     // GIR_Coverage, 807,
     /* 144974 */     GIR_EraseRootFromParent_Done,
     /* 144975 */   // Label 2828: @144975
     /* 144975 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(145011), // Rule ID 808 //
     /* 144980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 144988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145002 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 145005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145009 */     GIR_RootConstrainSelectedInstOperands,
     /* 145010 */     // GIR_Coverage, 808,
     /* 145010 */     GIR_EraseRootFromParent_Done,
     /* 145011 */   // Label 2829: @145011
     /* 145011 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(145047), // Rule ID 809 //
     /* 145016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 145024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145038 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 145041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145045 */     GIR_RootConstrainSelectedInstOperands,
     /* 145046 */     // GIR_Coverage, 809,
     /* 145046 */     GIR_EraseRootFromParent_Done,
     /* 145047 */   // Label 2830: @145047
     /* 145047 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(145083), // Rule ID 810 //
     /* 145052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 145060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145074 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 145077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145081 */     GIR_RootConstrainSelectedInstOperands,
     /* 145082 */     // GIR_Coverage, 810,
     /* 145082 */     GIR_EraseRootFromParent_Done,
     /* 145083 */   // Label 2831: @145083
     /* 145083 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(145119), // Rule ID 811 //
     /* 145088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145110 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 145113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145117 */     GIR_RootConstrainSelectedInstOperands,
     /* 145118 */     // GIR_Coverage, 811,
     /* 145118 */     GIR_EraseRootFromParent_Done,
     /* 145119 */   // Label 2832: @145119
     /* 145119 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(145155), // Rule ID 812 //
     /* 145124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145146 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 145149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145153 */     GIR_RootConstrainSelectedInstOperands,
     /* 145154 */     // GIR_Coverage, 812,
     /* 145154 */     GIR_EraseRootFromParent_Done,
     /* 145155 */   // Label 2833: @145155
     /* 145155 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(145191), // Rule ID 813 //
     /* 145160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145182 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 145185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145189 */     GIR_RootConstrainSelectedInstOperands,
     /* 145190 */     // GIR_Coverage, 813,
     /* 145190 */     GIR_EraseRootFromParent_Done,
     /* 145191 */   // Label 2834: @145191
     /* 145191 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(145227), // Rule ID 814 //
     /* 145196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145218 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 145221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145225 */     GIR_RootConstrainSelectedInstOperands,
     /* 145226 */     // GIR_Coverage, 814,
     /* 145226 */     GIR_EraseRootFromParent_Done,
     /* 145227 */   // Label 2835: @145227
     /* 145227 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(145263), // Rule ID 815 //
     /* 145232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 145240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145254 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 145257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145261 */     GIR_RootConstrainSelectedInstOperands,
     /* 145262 */     // GIR_Coverage, 815,
     /* 145262 */     GIR_EraseRootFromParent_Done,
     /* 145263 */   // Label 2836: @145263
     /* 145263 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(145299), // Rule ID 816 //
     /* 145268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145290 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 145293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145297 */     GIR_RootConstrainSelectedInstOperands,
     /* 145298 */     // GIR_Coverage, 816,
     /* 145298 */     GIR_EraseRootFromParent_Done,
     /* 145299 */   // Label 2837: @145299
     /* 145299 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(145335), // Rule ID 817 //
     /* 145304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145326 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 145329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145333 */     GIR_RootConstrainSelectedInstOperands,
     /* 145334 */     // GIR_Coverage, 817,
     /* 145334 */     GIR_EraseRootFromParent_Done,
     /* 145335 */   // Label 2838: @145335
     /* 145335 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(145371), // Rule ID 818 //
     /* 145340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145362 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 145365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145369 */     GIR_RootConstrainSelectedInstOperands,
     /* 145370 */     // GIR_Coverage, 818,
     /* 145370 */     GIR_EraseRootFromParent_Done,
     /* 145371 */   // Label 2839: @145371
     /* 145371 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(145407), // Rule ID 819 //
     /* 145376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145398 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 145401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145405 */     GIR_RootConstrainSelectedInstOperands,
     /* 145406 */     // GIR_Coverage, 819,
     /* 145406 */     GIR_EraseRootFromParent_Done,
     /* 145407 */   // Label 2840: @145407
     /* 145407 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(145443), // Rule ID 820 //
     /* 145412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 145420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145434 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 145437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145441 */     GIR_RootConstrainSelectedInstOperands,
     /* 145442 */     // GIR_Coverage, 820,
     /* 145442 */     GIR_EraseRootFromParent_Done,
     /* 145443 */   // Label 2841: @145443
     /* 145443 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(145479), // Rule ID 821 //
     /* 145448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145470 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 145473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145477 */     GIR_RootConstrainSelectedInstOperands,
     /* 145478 */     // GIR_Coverage, 821,
     /* 145478 */     GIR_EraseRootFromParent_Done,
     /* 145479 */   // Label 2842: @145479
     /* 145479 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(145515), // Rule ID 822 //
     /* 145484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145506 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 145509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145513 */     GIR_RootConstrainSelectedInstOperands,
     /* 145514 */     // GIR_Coverage, 822,
     /* 145514 */     GIR_EraseRootFromParent_Done,
     /* 145515 */   // Label 2843: @145515
     /* 145515 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(145551), // Rule ID 823 //
     /* 145520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145542 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 145545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145549 */     GIR_RootConstrainSelectedInstOperands,
     /* 145550 */     // GIR_Coverage, 823,
     /* 145550 */     GIR_EraseRootFromParent_Done,
     /* 145551 */   // Label 2844: @145551
     /* 145551 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(145587), // Rule ID 824 //
     /* 145556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145578 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 145581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145585 */     GIR_RootConstrainSelectedInstOperands,
     /* 145586 */     // GIR_Coverage, 824,
     /* 145586 */     GIR_EraseRootFromParent_Done,
     /* 145587 */   // Label 2845: @145587
     /* 145587 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(145623), // Rule ID 825 //
     /* 145592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 145600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145614 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 145617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145621 */     GIR_RootConstrainSelectedInstOperands,
     /* 145622 */     // GIR_Coverage, 825,
     /* 145622 */     GIR_EraseRootFromParent_Done,
     /* 145623 */   // Label 2846: @145623
     /* 145623 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(145659), // Rule ID 826 //
     /* 145628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145650 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 145653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145657 */     GIR_RootConstrainSelectedInstOperands,
     /* 145658 */     // GIR_Coverage, 826,
     /* 145658 */     GIR_EraseRootFromParent_Done,
     /* 145659 */   // Label 2847: @145659
     /* 145659 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(145695), // Rule ID 827 //
     /* 145664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145686 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 145689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145693 */     GIR_RootConstrainSelectedInstOperands,
     /* 145694 */     // GIR_Coverage, 827,
     /* 145694 */     GIR_EraseRootFromParent_Done,
     /* 145695 */   // Label 2848: @145695
     /* 145695 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(145731), // Rule ID 828 //
     /* 145700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145722 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 145725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145729 */     GIR_RootConstrainSelectedInstOperands,
     /* 145730 */     // GIR_Coverage, 828,
     /* 145730 */     GIR_EraseRootFromParent_Done,
     /* 145731 */   // Label 2849: @145731
     /* 145731 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(145767), // Rule ID 829 //
     /* 145736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145758 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 145761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145765 */     GIR_RootConstrainSelectedInstOperands,
     /* 145766 */     // GIR_Coverage, 829,
     /* 145766 */     GIR_EraseRootFromParent_Done,
     /* 145767 */   // Label 2850: @145767
     /* 145767 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(145803), // Rule ID 830 //
     /* 145772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 145780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145794 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 145797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145801 */     GIR_RootConstrainSelectedInstOperands,
     /* 145802 */     // GIR_Coverage, 830,
     /* 145802 */     GIR_EraseRootFromParent_Done,
     /* 145803 */   // Label 2851: @145803
     /* 145803 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(145839), // Rule ID 831 //
     /* 145808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145830 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 145830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 145833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145837 */     GIR_RootConstrainSelectedInstOperands,
     /* 145838 */     // GIR_Coverage, 831,
     /* 145838 */     GIR_EraseRootFromParent_Done,
     /* 145839 */   // Label 2852: @145839
     /* 145839 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(145875), // Rule ID 832 //
     /* 145844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145866 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 145866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 145869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145873 */     GIR_RootConstrainSelectedInstOperands,
     /* 145874 */     // GIR_Coverage, 832,
     /* 145874 */     GIR_EraseRootFromParent_Done,
     /* 145875 */   // Label 2853: @145875
     /* 145875 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(145911), // Rule ID 833 //
     /* 145880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145902 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 145902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 145905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145909 */     GIR_RootConstrainSelectedInstOperands,
     /* 145910 */     // GIR_Coverage, 833,
     /* 145910 */     GIR_EraseRootFromParent_Done,
     /* 145911 */   // Label 2854: @145911
     /* 145911 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(145947), // Rule ID 834 //
     /* 145916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145938 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 145938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 145941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145945 */     GIR_RootConstrainSelectedInstOperands,
     /* 145946 */     // GIR_Coverage, 834,
     /* 145946 */     GIR_EraseRootFromParent_Done,
     /* 145947 */   // Label 2855: @145947
     /* 145947 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(145983), // Rule ID 835 //
     /* 145952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 145960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145974 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 145974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 145977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145981 */     GIR_RootConstrainSelectedInstOperands,
     /* 145982 */     // GIR_Coverage, 835,
     /* 145982 */     GIR_EraseRootFromParent_Done,
     /* 145983 */   // Label 2856: @145983
     /* 145983 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(146019), // Rule ID 836 //
     /* 145988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 145996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146010 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 146010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 146013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146017 */     GIR_RootConstrainSelectedInstOperands,
     /* 146018 */     // GIR_Coverage, 836,
     /* 146018 */     GIR_EraseRootFromParent_Done,
     /* 146019 */   // Label 2857: @146019
     /* 146019 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(146055), // Rule ID 863 //
     /* 146024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 146035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146046 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 146049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146053 */     GIR_RootConstrainSelectedInstOperands,
     /* 146054 */     // GIR_Coverage, 863,
     /* 146054 */     GIR_EraseRootFromParent_Done,
     /* 146055 */   // Label 2858: @146055
     /* 146055 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(146091), // Rule ID 864 //
     /* 146060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 146071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146082 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 146085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146089 */     GIR_RootConstrainSelectedInstOperands,
     /* 146090 */     // GIR_Coverage, 864,
     /* 146090 */     GIR_EraseRootFromParent_Done,
     /* 146091 */   // Label 2859: @146091
     /* 146091 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(146127), // Rule ID 865 //
     /* 146096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146118 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 146121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146125 */     GIR_RootConstrainSelectedInstOperands,
     /* 146126 */     // GIR_Coverage, 865,
     /* 146126 */     GIR_EraseRootFromParent_Done,
     /* 146127 */   // Label 2860: @146127
     /* 146127 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(146163), // Rule ID 866 //
     /* 146132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146154 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 146157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146161 */     GIR_RootConstrainSelectedInstOperands,
     /* 146162 */     // GIR_Coverage, 866,
     /* 146162 */     GIR_EraseRootFromParent_Done,
     /* 146163 */   // Label 2861: @146163
     /* 146163 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(146199), // Rule ID 867 //
     /* 146168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146190 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 146193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146197 */     GIR_RootConstrainSelectedInstOperands,
     /* 146198 */     // GIR_Coverage, 867,
     /* 146198 */     GIR_EraseRootFromParent_Done,
     /* 146199 */   // Label 2862: @146199
     /* 146199 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(146235), // Rule ID 938 //
     /* 146204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146226 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 146229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146233 */     GIR_RootConstrainSelectedInstOperands,
     /* 146234 */     // GIR_Coverage, 938,
     /* 146234 */     GIR_EraseRootFromParent_Done,
     /* 146235 */   // Label 2863: @146235
     /* 146235 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(146271), // Rule ID 939 //
     /* 146240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146262 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 146265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146269 */     GIR_RootConstrainSelectedInstOperands,
     /* 146270 */     // GIR_Coverage, 939,
     /* 146270 */     GIR_EraseRootFromParent_Done,
     /* 146271 */   // Label 2864: @146271
     /* 146271 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(146307), // Rule ID 940 //
     /* 146276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146298 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 146301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146305 */     GIR_RootConstrainSelectedInstOperands,
     /* 146306 */     // GIR_Coverage, 940,
     /* 146306 */     GIR_EraseRootFromParent_Done,
     /* 146307 */   // Label 2865: @146307
     /* 146307 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(146343), // Rule ID 941 //
     /* 146312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146334 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 146337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146341 */     GIR_RootConstrainSelectedInstOperands,
     /* 146342 */     // GIR_Coverage, 941,
     /* 146342 */     GIR_EraseRootFromParent_Done,
     /* 146343 */   // Label 2866: @146343
     /* 146343 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(146379), // Rule ID 942 //
     /* 146348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146370 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 146373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146377 */     GIR_RootConstrainSelectedInstOperands,
     /* 146378 */     // GIR_Coverage, 942,
     /* 146378 */     GIR_EraseRootFromParent_Done,
     /* 146379 */   // Label 2867: @146379
     /* 146379 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(146415), // Rule ID 943 //
     /* 146384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146406 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 146409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146413 */     GIR_RootConstrainSelectedInstOperands,
     /* 146414 */     // GIR_Coverage, 943,
     /* 146414 */     GIR_EraseRootFromParent_Done,
     /* 146415 */   // Label 2868: @146415
     /* 146415 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(146451), // Rule ID 944 //
     /* 146420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146442 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 146445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146449 */     GIR_RootConstrainSelectedInstOperands,
     /* 146450 */     // GIR_Coverage, 944,
     /* 146450 */     GIR_EraseRootFromParent_Done,
     /* 146451 */   // Label 2869: @146451
     /* 146451 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(146487), // Rule ID 945 //
     /* 146456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146478 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 146481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146485 */     GIR_RootConstrainSelectedInstOperands,
     /* 146486 */     // GIR_Coverage, 945,
     /* 146486 */     GIR_EraseRootFromParent_Done,
     /* 146487 */   // Label 2870: @146487
     /* 146487 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(146523), // Rule ID 946 //
     /* 146492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146514 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 146517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146521 */     GIR_RootConstrainSelectedInstOperands,
     /* 146522 */     // GIR_Coverage, 946,
     /* 146522 */     GIR_EraseRootFromParent_Done,
     /* 146523 */   // Label 2871: @146523
     /* 146523 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(146559), // Rule ID 947 //
     /* 146528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146550 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 146553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146557 */     GIR_RootConstrainSelectedInstOperands,
     /* 146558 */     // GIR_Coverage, 947,
     /* 146558 */     GIR_EraseRootFromParent_Done,
     /* 146559 */   // Label 2872: @146559
     /* 146559 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(146595), // Rule ID 948 //
     /* 146564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146586 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 146589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146593 */     GIR_RootConstrainSelectedInstOperands,
     /* 146594 */     // GIR_Coverage, 948,
     /* 146594 */     GIR_EraseRootFromParent_Done,
     /* 146595 */   // Label 2873: @146595
     /* 146595 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(146631), // Rule ID 949 //
     /* 146600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 146603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146622 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 146625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146629 */     GIR_RootConstrainSelectedInstOperands,
     /* 146630 */     // GIR_Coverage, 949,
     /* 146630 */     GIR_EraseRootFromParent_Done,
     /* 146631 */   // Label 2874: @146631
     /* 146631 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(146667), // Rule ID 950 //
     /* 146636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 146647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146658 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 146661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146665 */     GIR_RootConstrainSelectedInstOperands,
     /* 146666 */     // GIR_Coverage, 950,
     /* 146666 */     GIR_EraseRootFromParent_Done,
     /* 146667 */   // Label 2875: @146667
     /* 146667 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(146703), // Rule ID 951 //
     /* 146672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 146683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146694 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 146697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146701 */     GIR_RootConstrainSelectedInstOperands,
     /* 146702 */     // GIR_Coverage, 951,
     /* 146702 */     GIR_EraseRootFromParent_Done,
     /* 146703 */   // Label 2876: @146703
     /* 146703 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(146739), // Rule ID 952 //
     /* 146708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146730 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 146730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 146733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146737 */     GIR_RootConstrainSelectedInstOperands,
     /* 146738 */     // GIR_Coverage, 952,
     /* 146738 */     GIR_EraseRootFromParent_Done,
     /* 146739 */   // Label 2877: @146739
     /* 146739 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(146775), // Rule ID 953 //
     /* 146744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146766 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 146769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146773 */     GIR_RootConstrainSelectedInstOperands,
     /* 146774 */     // GIR_Coverage, 953,
     /* 146774 */     GIR_EraseRootFromParent_Done,
     /* 146775 */   // Label 2878: @146775
     /* 146775 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(146811), // Rule ID 954 //
     /* 146780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146802 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 146802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 146805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146809 */     GIR_RootConstrainSelectedInstOperands,
     /* 146810 */     // GIR_Coverage, 954,
     /* 146810 */     GIR_EraseRootFromParent_Done,
     /* 146811 */   // Label 2879: @146811
     /* 146811 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(146847), // Rule ID 1001 //
     /* 146816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 146827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 146830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146838 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 146838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 146841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146845 */     GIR_RootConstrainSelectedInstOperands,
     /* 146846 */     // GIR_Coverage, 1001,
     /* 146846 */     GIR_EraseRootFromParent_Done,
     /* 146847 */   // Label 2880: @146847
     /* 146847 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(146883), // Rule ID 1003 //
     /* 146852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 146863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146874 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 146874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 146877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146881 */     GIR_RootConstrainSelectedInstOperands,
     /* 146882 */     // GIR_Coverage, 1003,
     /* 146882 */     GIR_EraseRootFromParent_Done,
     /* 146883 */   // Label 2881: @146883
     /* 146883 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(146919), // Rule ID 1005 //
     /* 146888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146910 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 146910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 146913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146917 */     GIR_RootConstrainSelectedInstOperands,
     /* 146918 */     // GIR_Coverage, 1005,
     /* 146918 */     GIR_EraseRootFromParent_Done,
     /* 146919 */   // Label 2882: @146919
     /* 146919 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(146955), // Rule ID 1007 //
     /* 146924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146946 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 146946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 146949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146953 */     GIR_RootConstrainSelectedInstOperands,
     /* 146954 */     // GIR_Coverage, 1007,
     /* 146954 */     GIR_EraseRootFromParent_Done,
     /* 146955 */   // Label 2883: @146955
     /* 146955 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(146991), // Rule ID 1009 //
     /* 146960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 146968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146982 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 146982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 146985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146989 */     GIR_RootConstrainSelectedInstOperands,
     /* 146990 */     // GIR_Coverage, 1009,
     /* 146990 */     GIR_EraseRootFromParent_Done,
     /* 146991 */   // Label 2884: @146991
     /* 146991 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(147027), // Rule ID 1011 //
     /* 146996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 147004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147018 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 147018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 147021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147025 */     GIR_RootConstrainSelectedInstOperands,
     /* 147026 */     // GIR_Coverage, 1011,
     /* 147026 */     GIR_EraseRootFromParent_Done,
     /* 147027 */   // Label 2885: @147027
     /* 147027 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(147063), // Rule ID 1022 //
     /* 147032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 147043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 147046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147054 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 147054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 147057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147061 */     GIR_RootConstrainSelectedInstOperands,
     /* 147062 */     // GIR_Coverage, 1022,
     /* 147062 */     GIR_EraseRootFromParent_Done,
     /* 147063 */   // Label 2886: @147063
     /* 147063 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(147099), // Rule ID 1023 //
     /* 147068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 147079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147090 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 147090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 147093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147097 */     GIR_RootConstrainSelectedInstOperands,
     /* 147098 */     // GIR_Coverage, 1023,
     /* 147098 */     GIR_EraseRootFromParent_Done,
     /* 147099 */   // Label 2887: @147099
     /* 147099 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(147135), // Rule ID 1024 //
     /* 147104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147126 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 147126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 147129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147133 */     GIR_RootConstrainSelectedInstOperands,
     /* 147134 */     // GIR_Coverage, 1024,
     /* 147134 */     GIR_EraseRootFromParent_Done,
     /* 147135 */   // Label 2888: @147135
     /* 147135 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(147171), // Rule ID 1025 //
     /* 147140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 147151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147162 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 147162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 147165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147169 */     GIR_RootConstrainSelectedInstOperands,
     /* 147170 */     // GIR_Coverage, 1025,
     /* 147170 */     GIR_EraseRootFromParent_Done,
     /* 147171 */   // Label 2889: @147171
     /* 147171 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(147207), // Rule ID 1026 //
     /* 147176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147198 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 147198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 147201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147205 */     GIR_RootConstrainSelectedInstOperands,
     /* 147206 */     // GIR_Coverage, 1026,
     /* 147206 */     GIR_EraseRootFromParent_Done,
     /* 147207 */   // Label 2890: @147207
     /* 147207 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(147243), // Rule ID 1027 //
     /* 147212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147234 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 147234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 147237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147241 */     GIR_RootConstrainSelectedInstOperands,
     /* 147242 */     // GIR_Coverage, 1027,
     /* 147242 */     GIR_EraseRootFromParent_Done,
     /* 147243 */   // Label 2891: @147243
     /* 147243 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(147279), // Rule ID 1028 //
     /* 147248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147270 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 147270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 147273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147277 */     GIR_RootConstrainSelectedInstOperands,
     /* 147278 */     // GIR_Coverage, 1028,
     /* 147278 */     GIR_EraseRootFromParent_Done,
     /* 147279 */   // Label 2892: @147279
     /* 147279 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(147315), // Rule ID 1029 //
     /* 147284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 147295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 147298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147306 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 147306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 147309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147313 */     GIR_RootConstrainSelectedInstOperands,
     /* 147314 */     // GIR_Coverage, 1029,
     /* 147314 */     GIR_EraseRootFromParent_Done,
     /* 147315 */   // Label 2893: @147315
     /* 147315 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(147351), // Rule ID 1030 //
     /* 147320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 147331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147342 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 147342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 147345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147349 */     GIR_RootConstrainSelectedInstOperands,
     /* 147350 */     // GIR_Coverage, 1030,
     /* 147350 */     GIR_EraseRootFromParent_Done,
     /* 147351 */   // Label 2894: @147351
     /* 147351 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(147387), // Rule ID 1031 //
     /* 147356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147378 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 147378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 147381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147385 */     GIR_RootConstrainSelectedInstOperands,
     /* 147386 */     // GIR_Coverage, 1031,
     /* 147386 */     GIR_EraseRootFromParent_Done,
     /* 147387 */   // Label 2895: @147387
     /* 147387 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(147423), // Rule ID 1032 //
     /* 147392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 147403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147414 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 147414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 147417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147421 */     GIR_RootConstrainSelectedInstOperands,
     /* 147422 */     // GIR_Coverage, 1032,
     /* 147422 */     GIR_EraseRootFromParent_Done,
     /* 147423 */   // Label 2896: @147423
     /* 147423 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(147459), // Rule ID 1033 //
     /* 147428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147450 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 147450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 147453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147457 */     GIR_RootConstrainSelectedInstOperands,
     /* 147458 */     // GIR_Coverage, 1033,
     /* 147458 */     GIR_EraseRootFromParent_Done,
     /* 147459 */   // Label 2897: @147459
     /* 147459 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(147495), // Rule ID 1034 //
     /* 147464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147486 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 147486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 147489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147493 */     GIR_RootConstrainSelectedInstOperands,
     /* 147494 */     // GIR_Coverage, 1034,
     /* 147494 */     GIR_EraseRootFromParent_Done,
     /* 147495 */   // Label 2898: @147495
     /* 147495 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(147531), // Rule ID 1035 //
     /* 147500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147522 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 147522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 147525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147529 */     GIR_RootConstrainSelectedInstOperands,
     /* 147530 */     // GIR_Coverage, 1035,
     /* 147530 */     GIR_EraseRootFromParent_Done,
     /* 147531 */   // Label 2899: @147531
     /* 147531 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(147567), // Rule ID 1062 //
     /* 147536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 147550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147558 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 147558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 147561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147565 */     GIR_RootConstrainSelectedInstOperands,
     /* 147566 */     // GIR_Coverage, 1062,
     /* 147566 */     GIR_EraseRootFromParent_Done,
     /* 147567 */   // Label 2900: @147567
     /* 147567 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(147603), // Rule ID 1064 //
     /* 147572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 147583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147594 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 147594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 147597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147601 */     GIR_RootConstrainSelectedInstOperands,
     /* 147602 */     // GIR_Coverage, 1064,
     /* 147602 */     GIR_EraseRootFromParent_Done,
     /* 147603 */   // Label 2901: @147603
     /* 147603 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(147639), // Rule ID 1066 //
     /* 147608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147630 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 147630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 147633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147637 */     GIR_RootConstrainSelectedInstOperands,
     /* 147638 */     // GIR_Coverage, 1066,
     /* 147638 */     GIR_EraseRootFromParent_Done,
     /* 147639 */   // Label 2902: @147639
     /* 147639 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(147675), // Rule ID 1068 //
     /* 147644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147666 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 147666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 147669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147673 */     GIR_RootConstrainSelectedInstOperands,
     /* 147674 */     // GIR_Coverage, 1068,
     /* 147674 */     GIR_EraseRootFromParent_Done,
     /* 147675 */   // Label 2903: @147675
     /* 147675 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(147711), // Rule ID 1070 //
     /* 147680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147702 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 147702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 147705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147709 */     GIR_RootConstrainSelectedInstOperands,
     /* 147710 */     // GIR_Coverage, 1070,
     /* 147710 */     GIR_EraseRootFromParent_Done,
     /* 147711 */   // Label 2904: @147711
     /* 147711 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(147747), // Rule ID 1072 //
     /* 147716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 147724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147738 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 147738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 147741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147745 */     GIR_RootConstrainSelectedInstOperands,
     /* 147746 */     // GIR_Coverage, 1072,
     /* 147746 */     GIR_EraseRootFromParent_Done,
     /* 147747 */   // Label 2905: @147747
     /* 147747 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(147783), // Rule ID 1086 //
     /* 147752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 147760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147774 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 147774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 147777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147781 */     GIR_RootConstrainSelectedInstOperands,
     /* 147782 */     // GIR_Coverage, 1086,
     /* 147782 */     GIR_EraseRootFromParent_Done,
     /* 147783 */   // Label 2906: @147783
     /* 147783 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(147819), // Rule ID 1087 //
     /* 147788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 147796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147810 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 147810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 147813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147817 */     GIR_RootConstrainSelectedInstOperands,
     /* 147818 */     // GIR_Coverage, 1087,
     /* 147818 */     GIR_EraseRootFromParent_Done,
     /* 147819 */   // Label 2907: @147819
     /* 147819 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(147855), // Rule ID 1088 //
     /* 147824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 147832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147846 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 147846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 147849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147853 */     GIR_RootConstrainSelectedInstOperands,
     /* 147854 */     // GIR_Coverage, 1088,
     /* 147854 */     GIR_EraseRootFromParent_Done,
     /* 147855 */   // Label 2908: @147855
     /* 147855 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147891), // Rule ID 1089 //
     /* 147860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 147868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147882 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 147882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 147885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147889 */     GIR_RootConstrainSelectedInstOperands,
     /* 147890 */     // GIR_Coverage, 1089,
     /* 147890 */     GIR_EraseRootFromParent_Done,
     /* 147891 */   // Label 2909: @147891
     /* 147891 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147927), // Rule ID 1653 //
     /* 147896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 147904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147918 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 147918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 147921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147925 */     GIR_RootConstrainSelectedInstOperands,
     /* 147926 */     // GIR_Coverage, 1653,
     /* 147926 */     GIR_EraseRootFromParent_Done,
     /* 147927 */   // Label 2910: @147927
     /* 147927 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147963), // Rule ID 1659 //
     /* 147932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147954 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 147954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 147957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147961 */     GIR_RootConstrainSelectedInstOperands,
     /* 147962 */     // GIR_Coverage, 1659,
     /* 147962 */     GIR_EraseRootFromParent_Done,
     /* 147963 */   // Label 2911: @147963
     /* 147963 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147999), // Rule ID 1660 //
     /* 147968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147990 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 147990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 147993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147997 */     GIR_RootConstrainSelectedInstOperands,
     /* 147998 */     // GIR_Coverage, 1660,
     /* 147998 */     GIR_EraseRootFromParent_Done,
     /* 147999 */   // Label 2912: @147999
     /* 147999 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(148035), // Rule ID 1661 //
     /* 148004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 148012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148026 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 148026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 148029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148033 */     GIR_RootConstrainSelectedInstOperands,
     /* 148034 */     // GIR_Coverage, 1661,
     /* 148034 */     GIR_EraseRootFromParent_Done,
     /* 148035 */   // Label 2913: @148035
     /* 148035 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(148071), // Rule ID 1662 //
     /* 148040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 148048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148062 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 148062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 148065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148069 */     GIR_RootConstrainSelectedInstOperands,
     /* 148070 */     // GIR_Coverage, 1662,
     /* 148070 */     GIR_EraseRootFromParent_Done,
     /* 148071 */   // Label 2914: @148071
     /* 148071 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(148107), // Rule ID 1663 //
     /* 148076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 148084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148098 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 148098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 148101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148105 */     GIR_RootConstrainSelectedInstOperands,
     /* 148106 */     // GIR_Coverage, 1663,
     /* 148106 */     GIR_EraseRootFromParent_Done,
     /* 148107 */   // Label 2915: @148107
     /* 148107 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(148143), // Rule ID 1664 //
     /* 148112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 148120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148134 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 148134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 148137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148141 */     GIR_RootConstrainSelectedInstOperands,
     /* 148142 */     // GIR_Coverage, 1664,
     /* 148142 */     GIR_EraseRootFromParent_Done,
     /* 148143 */   // Label 2916: @148143
     /* 148143 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(148179), // Rule ID 1670 //
     /* 148148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 148156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148170 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 148170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 148173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148177 */     GIR_RootConstrainSelectedInstOperands,
     /* 148178 */     // GIR_Coverage, 1670,
     /* 148178 */     GIR_EraseRootFromParent_Done,
     /* 148179 */   // Label 2917: @148179
     /* 148179 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(148215), // Rule ID 1943 //
     /* 148184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148206 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 148206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 148209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148213 */     GIR_RootConstrainSelectedInstOperands,
     /* 148214 */     // GIR_Coverage, 1943,
     /* 148214 */     GIR_EraseRootFromParent_Done,
     /* 148215 */   // Label 2918: @148215
     /* 148215 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(148251), // Rule ID 1945 //
     /* 148220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148242 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 148242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 148245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148249 */     GIR_RootConstrainSelectedInstOperands,
     /* 148250 */     // GIR_Coverage, 1945,
     /* 148250 */     GIR_EraseRootFromParent_Done,
     /* 148251 */   // Label 2919: @148251
     /* 148251 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(148287), // Rule ID 1947 //
     /* 148256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148278 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 148278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 148281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148285 */     GIR_RootConstrainSelectedInstOperands,
     /* 148286 */     // GIR_Coverage, 1947,
     /* 148286 */     GIR_EraseRootFromParent_Done,
     /* 148287 */   // Label 2920: @148287
     /* 148287 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(148323), // Rule ID 1949 //
     /* 148292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148314 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 148314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 148317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148321 */     GIR_RootConstrainSelectedInstOperands,
     /* 148322 */     // GIR_Coverage, 1949,
     /* 148322 */     GIR_EraseRootFromParent_Done,
     /* 148323 */   // Label 2921: @148323
     /* 148323 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(148359), // Rule ID 1951 //
     /* 148328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148350 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 148350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 148353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148357 */     GIR_RootConstrainSelectedInstOperands,
     /* 148358 */     // GIR_Coverage, 1951,
     /* 148358 */     GIR_EraseRootFromParent_Done,
     /* 148359 */   // Label 2922: @148359
     /* 148359 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148395), // Rule ID 1953 //
     /* 148364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148386 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 148386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 148389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148393 */     GIR_RootConstrainSelectedInstOperands,
     /* 148394 */     // GIR_Coverage, 1953,
     /* 148394 */     GIR_EraseRootFromParent_Done,
     /* 148395 */   // Label 2923: @148395
     /* 148395 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148431), // Rule ID 1955 //
     /* 148400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148422 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 148422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 148425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148429 */     GIR_RootConstrainSelectedInstOperands,
     /* 148430 */     // GIR_Coverage, 1955,
     /* 148430 */     GIR_EraseRootFromParent_Done,
     /* 148431 */   // Label 2924: @148431
     /* 148431 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(148467), // Rule ID 1957 //
     /* 148436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148458 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 148458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 148461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148465 */     GIR_RootConstrainSelectedInstOperands,
     /* 148466 */     // GIR_Coverage, 1957,
     /* 148466 */     GIR_EraseRootFromParent_Done,
     /* 148467 */   // Label 2925: @148467
     /* 148467 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(148503), // Rule ID 1959 //
     /* 148472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148494 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 148494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 148497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148501 */     GIR_RootConstrainSelectedInstOperands,
     /* 148502 */     // GIR_Coverage, 1959,
     /* 148502 */     GIR_EraseRootFromParent_Done,
     /* 148503 */   // Label 2926: @148503
     /* 148503 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(148539), // Rule ID 1961 //
     /* 148508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148530 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 148530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 148533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148537 */     GIR_RootConstrainSelectedInstOperands,
     /* 148538 */     // GIR_Coverage, 1961,
     /* 148538 */     GIR_EraseRootFromParent_Done,
     /* 148539 */   // Label 2927: @148539
     /* 148539 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148575), // Rule ID 1963 //
     /* 148544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 148547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148566 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 148566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 148569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148573 */     GIR_RootConstrainSelectedInstOperands,
     /* 148574 */     // GIR_Coverage, 1963,
     /* 148574 */     GIR_EraseRootFromParent_Done,
     /* 148575 */   // Label 2928: @148575
     /* 148575 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148611), // Rule ID 1965 //
     /* 148580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148602 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 148602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 148605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148609 */     GIR_RootConstrainSelectedInstOperands,
     /* 148610 */     // GIR_Coverage, 1965,
     /* 148610 */     GIR_EraseRootFromParent_Done,
     /* 148611 */   // Label 2929: @148611
     /* 148611 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148647), // Rule ID 2305 //
     /* 148616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 148619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 148624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 148627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148638 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 148641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148645 */     GIR_RootConstrainSelectedInstOperands,
     /* 148646 */     // GIR_Coverage, 2305,
     /* 148646 */     GIR_EraseRootFromParent_Done,
     /* 148647 */   // Label 2930: @148647
     /* 148647 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148683), // Rule ID 2306 //
     /* 148652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 148655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 148660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 148663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148674 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 148677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148681 */     GIR_RootConstrainSelectedInstOperands,
     /* 148682 */     // GIR_Coverage, 2306,
     /* 148682 */     GIR_EraseRootFromParent_Done,
     /* 148683 */   // Label 2931: @148683
     /* 148683 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148719), // Rule ID 2314 //
     /* 148688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 148691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 148696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148710 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 148710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 148713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148717 */     GIR_RootConstrainSelectedInstOperands,
     /* 148718 */     // GIR_Coverage, 2314,
     /* 148718 */     GIR_EraseRootFromParent_Done,
     /* 148719 */   // Label 2932: @148719
     /* 148719 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148755), // Rule ID 2515 //
     /* 148724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 148732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148746 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 148746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 148749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148753 */     GIR_RootConstrainSelectedInstOperands,
     /* 148754 */     // GIR_Coverage, 2515,
     /* 148754 */     GIR_EraseRootFromParent_Done,
     /* 148755 */   // Label 2933: @148755
     /* 148755 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148794), // Rule ID 3548 //
     /* 148760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 148768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 148771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 148774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148782 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 148782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 148785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 148789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148792 */     GIR_RootConstrainSelectedInstOperands,
     /* 148793 */     // GIR_Coverage, 3548,
     /* 148793 */     GIR_EraseRootFromParent_Done,
     /* 148794 */   // Label 2934: @148794
     /* 148794 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(148833), // Rule ID 3549 //
     /* 148799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 148807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 148810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 148813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148821 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 148821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 148824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 148828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148831 */     GIR_RootConstrainSelectedInstOperands,
     /* 148832 */     // GIR_Coverage, 3549,
     /* 148832 */     GIR_EraseRootFromParent_Done,
     /* 148833 */   // Label 2935: @148833
     /* 148833 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(148872), // Rule ID 3550 //
     /* 148838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 148846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 148849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 148852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 148860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 148863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 148867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148870 */     GIR_RootConstrainSelectedInstOperands,
     /* 148871 */     // GIR_Coverage, 3550,
     /* 148871 */     GIR_EraseRootFromParent_Done,
     /* 148872 */   // Label 2936: @148872
     /* 148872 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148911), // Rule ID 3551 //
     /* 148877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 148885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 148888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 148891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148899 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 148899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 148902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 148906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148909 */     GIR_RootConstrainSelectedInstOperands,
     /* 148910 */     // GIR_Coverage, 3551,
     /* 148910 */     GIR_EraseRootFromParent_Done,
     /* 148911 */   // Label 2937: @148911
     /* 148911 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(148967), // Rule ID 3555 //
     /* 148916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 148924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 148927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 148930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148938 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1629:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 148938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 148941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 148955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 148957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 148965 */     GIR_RootConstrainSelectedInstOperands,
     /* 148966 */     // GIR_Coverage, 3555,
     /* 148966 */     GIR_EraseRootFromParent_Done,
     /* 148967 */   // Label 2938: @148967
     /* 148967 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(149023), // Rule ID 3556 //
     /* 148972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 148975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 148980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 148983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 148986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1629:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 148994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 148997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 149011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 149013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149021 */     GIR_RootConstrainSelectedInstOperands,
     /* 149022 */     // GIR_Coverage, 3556,
     /* 149022 */     GIR_EraseRootFromParent_Done,
     /* 149023 */   // Label 2939: @149023
     /* 149023 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(149079), // Rule ID 3557 //
     /* 149028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 149031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 149036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 149039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 149042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 149046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 149050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 149050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 149053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 149067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 149069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149077 */     GIR_RootConstrainSelectedInstOperands,
     /* 149078 */     // GIR_Coverage, 3557,
     /* 149078 */     GIR_EraseRootFromParent_Done,
     /* 149079 */   // Label 2940: @149079
     /* 149079 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(149135), // Rule ID 3558 //
     /* 149084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 149087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 149092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 149095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 149098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 149102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 149106 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1629:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 149106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 149109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 149123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 149125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149133 */     GIR_RootConstrainSelectedInstOperands,
     /* 149134 */     // GIR_Coverage, 3558,
     /* 149134 */     GIR_EraseRootFromParent_Done,
     /* 149135 */   // Label 2941: @149135
     /* 149135 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(149168), // Rule ID 4009 //
     /* 149140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 149145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149159 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 149159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 149162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149166 */     GIR_RootConstrainSelectedInstOperands,
     /* 149167 */     // GIR_Coverage, 4009,
     /* 149167 */     GIR_EraseRootFromParent_Done,
     /* 149168 */   // Label 2942: @149168
     /* 149168 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(149233), // Rule ID 4010 //
     /* 149173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 149178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149192 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 149192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 149199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149215 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 149222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149232 */     // GIR_Coverage, 4010,
     /* 149232 */     GIR_EraseRootFromParent_Done,
     /* 149233 */   // Label 2943: @149233
     /* 149233 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(149266), // Rule ID 4780 //
     /* 149238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 149243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149257 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 149260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149264 */     GIR_RootConstrainSelectedInstOperands,
     /* 149265 */     // GIR_Coverage, 4780,
     /* 149265 */     GIR_EraseRootFromParent_Done,
     /* 149266 */   // Label 2944: @149266
     /* 149266 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(149299), // Rule ID 4781 //
     /* 149271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 149276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149290 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 149293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149297 */     GIR_RootConstrainSelectedInstOperands,
     /* 149298 */     // GIR_Coverage, 4781,
     /* 149298 */     GIR_EraseRootFromParent_Done,
     /* 149299 */   // Label 2945: @149299
     /* 149299 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(149332), // Rule ID 4782 //
     /* 149304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 149309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149323 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 149326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149330 */     GIR_RootConstrainSelectedInstOperands,
     /* 149331 */     // GIR_Coverage, 4782,
     /* 149331 */     GIR_EraseRootFromParent_Done,
     /* 149332 */   // Label 2946: @149332
     /* 149332 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(149365), // Rule ID 4783 //
     /* 149337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 149342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149356 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 149359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149363 */     GIR_RootConstrainSelectedInstOperands,
     /* 149364 */     // GIR_Coverage, 4783,
     /* 149364 */     GIR_EraseRootFromParent_Done,
     /* 149365 */   // Label 2947: @149365
     /* 149365 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(149398), // Rule ID 4897 //
     /* 149370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 149375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 149378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149389 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 149389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 149392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149396 */     GIR_RootConstrainSelectedInstOperands,
     /* 149397 */     // GIR_Coverage, 4897,
     /* 149397 */     GIR_EraseRootFromParent_Done,
     /* 149398 */   // Label 2948: @149398
     /* 149398 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(149431), // Rule ID 4907 //
     /* 149403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 149408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 149411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149422 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 149422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 149425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149429 */     GIR_RootConstrainSelectedInstOperands,
     /* 149430 */     // GIR_Coverage, 4907,
     /* 149430 */     GIR_EraseRootFromParent_Done,
     /* 149431 */   // Label 2949: @149431
     /* 149431 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(149467), // Rule ID 5249 //
     /* 149436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 149444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149458 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 149458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 149461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149465 */     GIR_RootConstrainSelectedInstOperands,
     /* 149466 */     // GIR_Coverage, 5249,
     /* 149466 */     GIR_EraseRootFromParent_Done,
     /* 149467 */   // Label 2950: @149467
     /* 149467 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(149500), // Rule ID 5252 //
     /* 149472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 149477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149491 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 149494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149498 */     GIR_RootConstrainSelectedInstOperands,
     /* 149499 */     // GIR_Coverage, 5252,
     /* 149499 */     GIR_EraseRootFromParent_Done,
     /* 149500 */   // Label 2951: @149500
     /* 149500 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(149533), // Rule ID 5253 //
     /* 149505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 149510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149524 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 149527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149531 */     GIR_RootConstrainSelectedInstOperands,
     /* 149532 */     // GIR_Coverage, 5253,
     /* 149532 */     GIR_EraseRootFromParent_Done,
     /* 149533 */   // Label 2952: @149533
     /* 149533 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(149566), // Rule ID 5254 //
     /* 149538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 149543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149557 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 149560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149564 */     GIR_RootConstrainSelectedInstOperands,
     /* 149565 */     // GIR_Coverage, 5254,
     /* 149565 */     GIR_EraseRootFromParent_Done,
     /* 149566 */   // Label 2953: @149566
     /* 149566 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(149599), // Rule ID 5255 //
     /* 149571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 149576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149590 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 149593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149597 */     GIR_RootConstrainSelectedInstOperands,
     /* 149598 */     // GIR_Coverage, 5255,
     /* 149598 */     GIR_EraseRootFromParent_Done,
     /* 149599 */   // Label 2954: @149599
     /* 149599 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(149632), // Rule ID 5256 //
     /* 149604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 149609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149623 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 149626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149630 */     GIR_RootConstrainSelectedInstOperands,
     /* 149631 */     // GIR_Coverage, 5256,
     /* 149631 */     GIR_EraseRootFromParent_Done,
     /* 149632 */   // Label 2955: @149632
     /* 149632 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(149665), // Rule ID 5257 //
     /* 149637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 149642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149656 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 149659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149663 */     GIR_RootConstrainSelectedInstOperands,
     /* 149664 */     // GIR_Coverage, 5257,
     /* 149664 */     GIR_EraseRootFromParent_Done,
     /* 149665 */   // Label 2956: @149665
     /* 149665 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(149698), // Rule ID 5258 //
     /* 149670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 149675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149689 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 149692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149696 */     GIR_RootConstrainSelectedInstOperands,
     /* 149697 */     // GIR_Coverage, 5258,
     /* 149697 */     GIR_EraseRootFromParent_Done,
     /* 149698 */   // Label 2957: @149698
     /* 149698 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(149731), // Rule ID 5259 //
     /* 149703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 149708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149722 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 149725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149729 */     GIR_RootConstrainSelectedInstOperands,
     /* 149730 */     // GIR_Coverage, 5259,
     /* 149730 */     GIR_EraseRootFromParent_Done,
     /* 149731 */   // Label 2958: @149731
     /* 149731 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(149764), // Rule ID 5260 //
     /* 149736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 149741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149755 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 149758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149762 */     GIR_RootConstrainSelectedInstOperands,
     /* 149763 */     // GIR_Coverage, 5260,
     /* 149763 */     GIR_EraseRootFromParent_Done,
     /* 149764 */   // Label 2959: @149764
     /* 149764 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(149797), // Rule ID 5261 //
     /* 149769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 149774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149788 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 149791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149795 */     GIR_RootConstrainSelectedInstOperands,
     /* 149796 */     // GIR_Coverage, 5261,
     /* 149796 */     GIR_EraseRootFromParent_Done,
     /* 149797 */   // Label 2960: @149797
     /* 149797 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(149830), // Rule ID 5262 //
     /* 149802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 149807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149821 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 149821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 149824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149828 */     GIR_RootConstrainSelectedInstOperands,
     /* 149829 */     // GIR_Coverage, 5262,
     /* 149829 */     GIR_EraseRootFromParent_Done,
     /* 149830 */   // Label 2961: @149830
     /* 149830 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(149863), // Rule ID 5263 //
     /* 149835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 149840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149854 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 149854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 149857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149861 */     GIR_RootConstrainSelectedInstOperands,
     /* 149862 */     // GIR_Coverage, 5263,
     /* 149862 */     GIR_EraseRootFromParent_Done,
     /* 149863 */   // Label 2962: @149863
     /* 149863 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(149896), // Rule ID 5264 //
     /* 149868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 149873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149887 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 149887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 149890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149894 */     GIR_RootConstrainSelectedInstOperands,
     /* 149895 */     // GIR_Coverage, 5264,
     /* 149895 */     GIR_EraseRootFromParent_Done,
     /* 149896 */   // Label 2963: @149896
     /* 149896 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(149929), // Rule ID 5265 //
     /* 149901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 149906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149920 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 149920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 149923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149927 */     GIR_RootConstrainSelectedInstOperands,
     /* 149928 */     // GIR_Coverage, 5265,
     /* 149928 */     GIR_EraseRootFromParent_Done,
     /* 149929 */   // Label 2964: @149929
     /* 149929 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(149962), // Rule ID 5277 //
     /* 149934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 149939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149953 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 149953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 149956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149960 */     GIR_RootConstrainSelectedInstOperands,
     /* 149961 */     // GIR_Coverage, 5277,
     /* 149961 */     GIR_EraseRootFromParent_Done,
     /* 149962 */   // Label 2965: @149962
     /* 149962 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(149995), // Rule ID 5278 //
     /* 149967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 149972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149986 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 149986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 149989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149993 */     GIR_RootConstrainSelectedInstOperands,
     /* 149994 */     // GIR_Coverage, 5278,
     /* 149994 */     GIR_EraseRootFromParent_Done,
     /* 149995 */   // Label 2966: @149995
     /* 149995 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(150028), // Rule ID 5279 //
     /* 150000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 150005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150019 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 150019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 150022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150026 */     GIR_RootConstrainSelectedInstOperands,
     /* 150027 */     // GIR_Coverage, 5279,
     /* 150027 */     GIR_EraseRootFromParent_Done,
     /* 150028 */   // Label 2967: @150028
     /* 150028 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(150061), // Rule ID 5280 //
     /* 150033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 150038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 150044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150052 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 150052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 150055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150059 */     GIR_RootConstrainSelectedInstOperands,
     /* 150060 */     // GIR_Coverage, 5280,
     /* 150060 */     GIR_EraseRootFromParent_Done,
     /* 150061 */   // Label 2968: @150061
     /* 150061 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(150094), // Rule ID 5281 //
     /* 150066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 150071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150085 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 150085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 150088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150092 */     GIR_RootConstrainSelectedInstOperands,
     /* 150093 */     // GIR_Coverage, 5281,
     /* 150093 */     GIR_EraseRootFromParent_Done,
     /* 150094 */   // Label 2969: @150094
     /* 150094 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(150127), // Rule ID 5282 //
     /* 150099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 150104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150118 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 150118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 150121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150125 */     GIR_RootConstrainSelectedInstOperands,
     /* 150126 */     // GIR_Coverage, 5282,
     /* 150126 */     GIR_EraseRootFromParent_Done,
     /* 150127 */   // Label 2970: @150127
     /* 150127 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(150160), // Rule ID 5283 //
     /* 150132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 150137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150151 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 150151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 150154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150158 */     GIR_RootConstrainSelectedInstOperands,
     /* 150159 */     // GIR_Coverage, 5283,
     /* 150159 */     GIR_EraseRootFromParent_Done,
     /* 150160 */   // Label 2971: @150160
     /* 150160 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(150193), // Rule ID 5613 //
     /* 150165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 150170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150184 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 150187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150191 */     GIR_RootConstrainSelectedInstOperands,
     /* 150192 */     // GIR_Coverage, 5613,
     /* 150192 */     GIR_EraseRootFromParent_Done,
     /* 150193 */   // Label 2972: @150193
     /* 150193 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(150278), // Rule ID 5614 //
     /* 150198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 150203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150217 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 150217 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 150220 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 150224 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150229 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150233 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150251 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 150258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 150271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150276 */     GIR_RootConstrainSelectedInstOperands,
     /* 150277 */     // GIR_Coverage, 5614,
     /* 150277 */     GIR_EraseRootFromParent_Done,
     /* 150278 */   // Label 2973: @150278
     /* 150278 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(150311), // Rule ID 5615 //
     /* 150283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 150288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150302 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 150305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150309 */     GIR_RootConstrainSelectedInstOperands,
     /* 150310 */     // GIR_Coverage, 5615,
     /* 150310 */     GIR_EraseRootFromParent_Done,
     /* 150311 */   // Label 2974: @150311
     /* 150311 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(150344), // Rule ID 5617 //
     /* 150316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 150321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150335 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 150338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150342 */     GIR_RootConstrainSelectedInstOperands,
     /* 150343 */     // GIR_Coverage, 5617,
     /* 150343 */     GIR_EraseRootFromParent_Done,
     /* 150344 */   // Label 2975: @150344
     /* 150344 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(150377), // Rule ID 5619 //
     /* 150349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 150354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150368 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 150371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150375 */     GIR_RootConstrainSelectedInstOperands,
     /* 150376 */     // GIR_Coverage, 5619,
     /* 150376 */     GIR_EraseRootFromParent_Done,
     /* 150377 */   // Label 2976: @150377
     /* 150377 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(150410), // Rule ID 5621 //
     /* 150382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 150387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150401 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 150404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150408 */     GIR_RootConstrainSelectedInstOperands,
     /* 150409 */     // GIR_Coverage, 5621,
     /* 150409 */     GIR_EraseRootFromParent_Done,
     /* 150410 */   // Label 2977: @150410
     /* 150410 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(150443), // Rule ID 5623 //
     /* 150415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 150420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150434 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 150437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150441 */     GIR_RootConstrainSelectedInstOperands,
     /* 150442 */     // GIR_Coverage, 5623,
     /* 150442 */     GIR_EraseRootFromParent_Done,
     /* 150443 */   // Label 2978: @150443
     /* 150443 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(150476), // Rule ID 5625 //
     /* 150448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 150453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150467 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 150470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150474 */     GIR_RootConstrainSelectedInstOperands,
     /* 150475 */     // GIR_Coverage, 5625,
     /* 150475 */     GIR_EraseRootFromParent_Done,
     /* 150476 */   // Label 2979: @150476
     /* 150476 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(150509), // Rule ID 5627 //
     /* 150481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 150486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150500 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 150503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150507 */     GIR_RootConstrainSelectedInstOperands,
     /* 150508 */     // GIR_Coverage, 5627,
     /* 150508 */     GIR_EraseRootFromParent_Done,
     /* 150509 */   // Label 2980: @150509
     /* 150509 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(150542), // Rule ID 5629 //
     /* 150514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 150519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150533 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 150533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 150536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150540 */     GIR_RootConstrainSelectedInstOperands,
     /* 150541 */     // GIR_Coverage, 5629,
     /* 150541 */     GIR_EraseRootFromParent_Done,
     /* 150542 */   // Label 2981: @150542
     /* 150542 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(150575), // Rule ID 5631 //
     /* 150547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 150552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150566 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 150566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 150569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150573 */     GIR_RootConstrainSelectedInstOperands,
     /* 150574 */     // GIR_Coverage, 5631,
     /* 150574 */     GIR_EraseRootFromParent_Done,
     /* 150575 */   // Label 2982: @150575
     /* 150575 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(150608), // Rule ID 13148 //
     /* 150580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150599 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 150602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150606 */     GIR_RootConstrainSelectedInstOperands,
     /* 150607 */     // GIR_Coverage, 13148,
     /* 150607 */     GIR_EraseRootFromParent_Done,
     /* 150608 */   // Label 2983: @150608
     /* 150608 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(150641), // Rule ID 13150 //
     /* 150613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150632 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 150635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150639 */     GIR_RootConstrainSelectedInstOperands,
     /* 150640 */     // GIR_Coverage, 13150,
     /* 150640 */     GIR_EraseRootFromParent_Done,
     /* 150641 */   // Label 2984: @150641
     /* 150641 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(150674), // Rule ID 13152 //
     /* 150646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150665 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 150668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150672 */     GIR_RootConstrainSelectedInstOperands,
     /* 150673 */     // GIR_Coverage, 13152,
     /* 150673 */     GIR_EraseRootFromParent_Done,
     /* 150674 */   // Label 2985: @150674
     /* 150674 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(150707), // Rule ID 13154 //
     /* 150679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150698 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 150701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150705 */     GIR_RootConstrainSelectedInstOperands,
     /* 150706 */     // GIR_Coverage, 13154,
     /* 150706 */     GIR_EraseRootFromParent_Done,
     /* 150707 */   // Label 2986: @150707
     /* 150707 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(150822), // Rule ID 13155 //
     /* 150712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 150717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150731 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150731 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150734 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 150738 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150743 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150749 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150752 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150756 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150778 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150781 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150804 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150821 */     // GIR_Coverage, 13155,
     /* 150821 */     GIR_EraseRootFromParent_Done,
     /* 150822 */   // Label 2987: @150822
     /* 150822 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(150855), // Rule ID 13157 //
     /* 150827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150846 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 150849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150853 */     GIR_RootConstrainSelectedInstOperands,
     /* 150854 */     // GIR_Coverage, 13157,
     /* 150854 */     GIR_EraseRootFromParent_Done,
     /* 150855 */   // Label 2988: @150855
     /* 150855 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(150888), // Rule ID 13159 //
     /* 150860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150879 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 150882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150886 */     GIR_RootConstrainSelectedInstOperands,
     /* 150887 */     // GIR_Coverage, 13159,
     /* 150887 */     GIR_EraseRootFromParent_Done,
     /* 150888 */   // Label 2989: @150888
     /* 150888 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(150921), // Rule ID 13161 //
     /* 150893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150912 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 150915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150919 */     GIR_RootConstrainSelectedInstOperands,
     /* 150920 */     // GIR_Coverage, 13161,
     /* 150920 */     GIR_EraseRootFromParent_Done,
     /* 150921 */   // Label 2990: @150921
     /* 150921 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(150954), // Rule ID 13163 //
     /* 150926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150945 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 150948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150952 */     GIR_RootConstrainSelectedInstOperands,
     /* 150953 */     // GIR_Coverage, 13163,
     /* 150953 */     GIR_EraseRootFromParent_Done,
     /* 150954 */   // Label 2991: @150954
     /* 150954 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(151069), // Rule ID 13164 //
     /* 150959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 150964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150978 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 150985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150990 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150996 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150999 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151003 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151025 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 151031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151051 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151068 */     // GIR_Coverage, 13164,
     /* 151068 */     GIR_EraseRootFromParent_Done,
     /* 151069 */   // Label 2992: @151069
     /* 151069 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(151188), // Rule ID 13165 //
     /* 151074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 151079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151093 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151093 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151096 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 151100 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151105 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151109 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151170 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151187 */     // GIR_Coverage, 13165,
     /* 151187 */     GIR_EraseRootFromParent_Done,
     /* 151188 */   // Label 2993: @151188
     /* 151188 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(151303), // Rule ID 13166 //
     /* 151193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 151198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151212 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 151212 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151215 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 151219 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151224 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151230 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 151233 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151237 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 151247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151256 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151259 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151285 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 151292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151302 */     // GIR_Coverage, 13166,
     /* 151302 */     GIR_EraseRootFromParent_Done,
     /* 151303 */   // Label 2994: @151303
     /* 151303 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(151422), // Rule ID 13167 //
     /* 151308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 151313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151327 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151327 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151330 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 151334 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151339 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151343 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151404 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151421 */     // GIR_Coverage, 13167,
     /* 151421 */     GIR_EraseRootFromParent_Done,
     /* 151422 */   // Label 2995: @151422
     /* 151422 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(151537), // Rule ID 13168 //
     /* 151427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 151432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151446 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 151446 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151449 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 151453 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151458 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151464 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 151467 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151471 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 151481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151493 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151496 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151519 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 151526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151536 */     // GIR_Coverage, 13168,
     /* 151536 */     GIR_EraseRootFromParent_Done,
     /* 151537 */   // Label 2996: @151537
     /* 151537 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(151570), // Rule ID 13170 //
     /* 151542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 151553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151561 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 151561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 151564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151568 */     GIR_RootConstrainSelectedInstOperands,
     /* 151569 */     // GIR_Coverage, 13170,
     /* 151569 */     GIR_EraseRootFromParent_Done,
     /* 151570 */   // Label 2997: @151570
     /* 151570 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(151603), // Rule ID 13172 //
     /* 151575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 151586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151594 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 151594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 151597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151601 */     GIR_RootConstrainSelectedInstOperands,
     /* 151602 */     // GIR_Coverage, 13172,
     /* 151602 */     GIR_EraseRootFromParent_Done,
     /* 151603 */   // Label 2998: @151603
     /* 151603 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(151636), // Rule ID 13174 //
     /* 151608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151627 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 151627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 151630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151634 */     GIR_RootConstrainSelectedInstOperands,
     /* 151635 */     // GIR_Coverage, 13174,
     /* 151635 */     GIR_EraseRootFromParent_Done,
     /* 151636 */   // Label 2999: @151636
     /* 151636 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(151669), // Rule ID 13176 //
     /* 151641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151660 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 151660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 151663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151667 */     GIR_RootConstrainSelectedInstOperands,
     /* 151668 */     // GIR_Coverage, 13176,
     /* 151668 */     GIR_EraseRootFromParent_Done,
     /* 151669 */   // Label 3000: @151669
     /* 151669 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(151784), // Rule ID 13177 //
     /* 151674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151693 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151693 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 151696 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 151700 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151705 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 151746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151766 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151783 */     // GIR_Coverage, 13177,
     /* 151783 */     GIR_EraseRootFromParent_Done,
     /* 151784 */   // Label 3001: @151784
     /* 151784 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(151903), // Rule ID 13178 //
     /* 151789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 151794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151808 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151808 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151811 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 151815 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151820 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151824 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151856 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151862 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151885 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151902 */     // GIR_Coverage, 13178,
     /* 151902 */     GIR_EraseRootFromParent_Done,
     /* 151903 */   // Label 3002: @151903
     /* 151903 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(151936), // Rule ID 13180 //
     /* 151908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 151913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 151919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151927 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 151927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 151930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151934 */     GIR_RootConstrainSelectedInstOperands,
     /* 151935 */     // GIR_Coverage, 13180,
     /* 151935 */     GIR_EraseRootFromParent_Done,
     /* 151936 */   // Label 3003: @151936
     /* 151936 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(151969), // Rule ID 13182 //
     /* 151941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 151946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 151952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151960 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 151960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 151963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151967 */     GIR_RootConstrainSelectedInstOperands,
     /* 151968 */     // GIR_Coverage, 13182,
     /* 151968 */     GIR_EraseRootFromParent_Done,
     /* 151969 */   // Label 3004: @151969
     /* 151969 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(152002), // Rule ID 13184 //
     /* 151974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 151979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151993 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 151993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 151996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152000 */     GIR_RootConstrainSelectedInstOperands,
     /* 152001 */     // GIR_Coverage, 13184,
     /* 152001 */     GIR_EraseRootFromParent_Done,
     /* 152002 */   // Label 3005: @152002
     /* 152002 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(152035), // Rule ID 13186 //
     /* 152007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 152012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152026 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 152026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 152029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152033 */     GIR_RootConstrainSelectedInstOperands,
     /* 152034 */     // GIR_Coverage, 13186,
     /* 152034 */     GIR_EraseRootFromParent_Done,
     /* 152035 */   // Label 3006: @152035
     /* 152035 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(152150), // Rule ID 13187 //
     /* 152040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 152045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152059 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152059 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 152062 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 152066 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152071 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152109 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 152112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152132 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152149 */     // GIR_Coverage, 13187,
     /* 152149 */     GIR_EraseRootFromParent_Done,
     /* 152150 */   // Label 3007: @152150
     /* 152150 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(152269), // Rule ID 13188 //
     /* 152155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 152160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152174 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152174 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 152177 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 152181 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152186 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152190 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152222 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152228 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 152231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152268 */     // GIR_Coverage, 13188,
     /* 152268 */     GIR_EraseRootFromParent_Done,
     /* 152269 */   // Label 3008: @152269
     /* 152269 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(152302), // Rule ID 13190 //
     /* 152274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 152282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 152285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 152289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152293 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 152293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 152296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152300 */     GIR_RootConstrainSelectedInstOperands,
     /* 152301 */     // GIR_Coverage, 13190,
     /* 152301 */     GIR_EraseRootFromParent_Done,
     /* 152302 */   // Label 3009: @152302
     /* 152302 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(152335), // Rule ID 13192 //
     /* 152307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 152315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 152322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152326 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 152326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 152329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152333 */     GIR_RootConstrainSelectedInstOperands,
     /* 152334 */     // GIR_Coverage, 13192,
     /* 152334 */     GIR_EraseRootFromParent_Done,
     /* 152335 */   // Label 3010: @152335
     /* 152335 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(152368), // Rule ID 13194 //
     /* 152340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152359 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 152359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 152362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152366 */     GIR_RootConstrainSelectedInstOperands,
     /* 152367 */     // GIR_Coverage, 13194,
     /* 152367 */     GIR_EraseRootFromParent_Done,
     /* 152368 */   // Label 3011: @152368
     /* 152368 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(152401), // Rule ID 13196 //
     /* 152373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152392 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 152392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 152395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152399 */     GIR_RootConstrainSelectedInstOperands,
     /* 152400 */     // GIR_Coverage, 13196,
     /* 152400 */     GIR_EraseRootFromParent_Done,
     /* 152401 */   // Label 3012: @152401
     /* 152401 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(152516), // Rule ID 13197 //
     /* 152406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152425 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152425 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 152428 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 152432 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152437 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152469 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152475 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 152478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152498 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152515 */     // GIR_Coverage, 13197,
     /* 152515 */     GIR_EraseRootFromParent_Done,
     /* 152516 */   // Label 3013: @152516
     /* 152516 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(152635), // Rule ID 13198 //
     /* 152521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 152526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152540 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 152543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 152547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152552 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152556 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152588 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152591 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 152597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152634 */     // GIR_Coverage, 13198,
     /* 152634 */     GIR_EraseRootFromParent_Done,
     /* 152635 */   // Label 3014: @152635
     /* 152635 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(152668), // Rule ID 13200 //
     /* 152640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 152648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 152651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 152655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152659 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 152659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 152662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152666 */     GIR_RootConstrainSelectedInstOperands,
     /* 152667 */     // GIR_Coverage, 13200,
     /* 152667 */     GIR_EraseRootFromParent_Done,
     /* 152668 */   // Label 3015: @152668
     /* 152668 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152701), // Rule ID 13202 //
     /* 152673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 152681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 152688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152692 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 152692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 152695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152699 */     GIR_RootConstrainSelectedInstOperands,
     /* 152700 */     // GIR_Coverage, 13202,
     /* 152700 */     GIR_EraseRootFromParent_Done,
     /* 152701 */   // Label 3016: @152701
     /* 152701 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(152734), // Rule ID 13204 //
     /* 152706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152725 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 152725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 152728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152732 */     GIR_RootConstrainSelectedInstOperands,
     /* 152733 */     // GIR_Coverage, 13204,
     /* 152733 */     GIR_EraseRootFromParent_Done,
     /* 152734 */   // Label 3017: @152734
     /* 152734 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152767), // Rule ID 13206 //
     /* 152739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152758 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 152758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 152761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152765 */     GIR_RootConstrainSelectedInstOperands,
     /* 152766 */     // GIR_Coverage, 13206,
     /* 152766 */     GIR_EraseRootFromParent_Done,
     /* 152767 */   // Label 3018: @152767
     /* 152767 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152882), // Rule ID 13207 //
     /* 152772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152791 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152791 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 152794 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 152798 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152803 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152835 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152838 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 152844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152864 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152881 */     // GIR_Coverage, 13207,
     /* 152881 */     GIR_EraseRootFromParent_Done,
     /* 152882 */   // Label 3019: @152882
     /* 152882 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(153001), // Rule ID 13208 //
     /* 152887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 152892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152906 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 152906 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 152909 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 152913 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152918 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152922 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 152926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 152928 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152931 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 152935 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 152949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152954 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152957 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152960 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 152963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152983 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 152990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153000 */     // GIR_Coverage, 13208,
     /* 153000 */     GIR_EraseRootFromParent_Done,
     /* 153001 */   // Label 3020: @153001
     /* 153001 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(153033), // Rule ID 2393 //
     /* 153006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 153014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 153017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 153020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153024 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1669:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 153024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 153027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 153031 */     GIR_RootConstrainSelectedInstOperands,
     /* 153032 */     // GIR_Coverage, 2393,
     /* 153032 */     GIR_EraseRootFromParent_Done,
     /* 153033 */   // Label 3021: @153033
     /* 153033 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(153065), // Rule ID 2394 //
     /* 153038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 153046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 153049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 153052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 153056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 153059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 153063 */     GIR_RootConstrainSelectedInstOperands,
     /* 153064 */     // GIR_Coverage, 2394,
     /* 153064 */     GIR_EraseRootFromParent_Done,
     /* 153065 */   // Label 3022: @153065
     /* 153065 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(153097), // Rule ID 2395 //
     /* 153070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 153078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 153081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 153084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153088 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 153088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 153091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 153095 */     GIR_RootConstrainSelectedInstOperands,
     /* 153096 */     // GIR_Coverage, 2395,
     /* 153096 */     GIR_EraseRootFromParent_Done,
     /* 153097 */   // Label 3023: @153097
     /* 153097 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(153129), // Rule ID 3093 //
     /* 153102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 153105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 153110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 153113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 153116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153120 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 153120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 153123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153127 */     GIR_RootConstrainSelectedInstOperands,
     /* 153128 */     // GIR_Coverage, 3093,
     /* 153128 */     GIR_EraseRootFromParent_Done,
     /* 153129 */   // Label 3024: @153129
     /* 153129 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(153161), // Rule ID 3094 //
     /* 153134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 153137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 153142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 153145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 153148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 153152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 153155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153159 */     GIR_RootConstrainSelectedInstOperands,
     /* 153160 */     // GIR_Coverage, 3094,
     /* 153160 */     GIR_EraseRootFromParent_Done,
     /* 153161 */   // Label 3025: @153161
     /* 153161 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(153193), // Rule ID 3095 //
     /* 153166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 153169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 153174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 153177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 153180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 153184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 153187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153191 */     GIR_RootConstrainSelectedInstOperands,
     /* 153192 */     // GIR_Coverage, 3095,
     /* 153192 */     GIR_EraseRootFromParent_Done,
     /* 153193 */   // Label 3026: @153193
     /* 153193 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(153225), // Rule ID 3349 //
     /* 153198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 153206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 153209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 153212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153216 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1661:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 153216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 153219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153223 */     GIR_RootConstrainSelectedInstOperands,
     /* 153224 */     // GIR_Coverage, 3349,
     /* 153224 */     GIR_EraseRootFromParent_Done,
     /* 153225 */   // Label 3027: @153225
     /* 153225 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(153257), // Rule ID 3350 //
     /* 153230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 153238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 153241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 153244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153248 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1661:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 153248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 153251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153255 */     GIR_RootConstrainSelectedInstOperands,
     /* 153256 */     // GIR_Coverage, 3350,
     /* 153256 */     GIR_EraseRootFromParent_Done,
     /* 153257 */   // Label 3028: @153257
     /* 153257 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(153289), // Rule ID 3351 //
     /* 153262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 153265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 153270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 153273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 153276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 153280 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1661:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 153280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 153283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 153285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153287 */     GIR_RootConstrainSelectedInstOperands,
     /* 153288 */     // GIR_Coverage, 3351,
     /* 153288 */     GIR_EraseRootFromParent_Done,
     /* 153289 */   // Label 3029: @153289
     /* 153289 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(153321), // Rule ID 3430 //
     /* 153294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 153297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 153302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 153305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 153308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153312 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 153312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 153315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153319 */     GIR_RootConstrainSelectedInstOperands,
     /* 153320 */     // GIR_Coverage, 3430,
     /* 153320 */     GIR_EraseRootFromParent_Done,
     /* 153321 */   // Label 3030: @153321
     /* 153321 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(153353), // Rule ID 3431 //
     /* 153326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 153329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 153334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 153337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 153340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153344 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1422:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 153344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 153347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153351 */     GIR_RootConstrainSelectedInstOperands,
     /* 153352 */     // GIR_Coverage, 3431,
     /* 153352 */     GIR_EraseRootFromParent_Done,
     /* 153353 */   // Label 3031: @153353
     /* 153353 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(153385), // Rule ID 3432 //
     /* 153358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 153361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 153366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 153369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 153372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1422:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 153376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 153379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 153381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153383 */     GIR_RootConstrainSelectedInstOperands,
     /* 153384 */     // GIR_Coverage, 3432,
     /* 153384 */     GIR_EraseRootFromParent_Done,
     /* 153385 */   // Label 3032: @153385
     /* 153385 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(153417), // Rule ID 3458 //
     /* 153390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 153393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 153398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 153401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 153404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 153408 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 153408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 153411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 153413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 153415 */     GIR_RootConstrainSelectedInstOperands,
     /* 153416 */     // GIR_Coverage, 3458,
     /* 153416 */     GIR_EraseRootFromParent_Done,
     /* 153417 */   // Label 3033: @153417
     /* 153417 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(153449), // Rule ID 4625 //
     /* 153422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 153425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153440 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 153440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 153443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153447 */     GIR_RootConstrainSelectedInstOperands,
     /* 153448 */     // GIR_Coverage, 4625,
     /* 153448 */     GIR_EraseRootFromParent_Done,
     /* 153449 */   // Label 3034: @153449
     /* 153449 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(153481), // Rule ID 4626 //
     /* 153454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 153457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153472 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 153472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 153475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153479 */     GIR_RootConstrainSelectedInstOperands,
     /* 153480 */     // GIR_Coverage, 4626,
     /* 153480 */     GIR_EraseRootFromParent_Done,
     /* 153481 */   // Label 3035: @153481
     /* 153481 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(153510), // Rule ID 4627 //
     /* 153486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153501 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 153501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 153504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153508 */     GIR_RootConstrainSelectedInstOperands,
     /* 153509 */     // GIR_Coverage, 4627,
     /* 153509 */     GIR_EraseRootFromParent_Done,
     /* 153510 */   // Label 3036: @153510
     /* 153510 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(153539), // Rule ID 4628 //
     /* 153515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153530 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 153530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 153533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153537 */     GIR_RootConstrainSelectedInstOperands,
     /* 153538 */     // GIR_Coverage, 4628,
     /* 153538 */     GIR_EraseRootFromParent_Done,
     /* 153539 */   // Label 3037: @153539
     /* 153539 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(153568), // Rule ID 4629 //
     /* 153544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153559 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 153559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 153562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153566 */     GIR_RootConstrainSelectedInstOperands,
     /* 153567 */     // GIR_Coverage, 4629,
     /* 153567 */     GIR_EraseRootFromParent_Done,
     /* 153568 */   // Label 3038: @153568
     /* 153568 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(153597), // Rule ID 4630 //
     /* 153573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153588 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 153588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 153591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153595 */     GIR_RootConstrainSelectedInstOperands,
     /* 153596 */     // GIR_Coverage, 4630,
     /* 153596 */     GIR_EraseRootFromParent_Done,
     /* 153597 */   // Label 3039: @153597
     /* 153597 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(153629), // Rule ID 4637 //
     /* 153602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 153605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153620 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 153620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 153623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153627 */     GIR_RootConstrainSelectedInstOperands,
     /* 153628 */     // GIR_Coverage, 4637,
     /* 153628 */     GIR_EraseRootFromParent_Done,
     /* 153629 */   // Label 3040: @153629
     /* 153629 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(153661), // Rule ID 4638 //
     /* 153634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 153637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153652 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 153652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 153655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153659 */     GIR_RootConstrainSelectedInstOperands,
     /* 153660 */     // GIR_Coverage, 4638,
     /* 153660 */     GIR_EraseRootFromParent_Done,
     /* 153661 */   // Label 3041: @153661
     /* 153661 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(153690), // Rule ID 4639 //
     /* 153666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153681 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 153681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 153684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153688 */     GIR_RootConstrainSelectedInstOperands,
     /* 153689 */     // GIR_Coverage, 4639,
     /* 153689 */     GIR_EraseRootFromParent_Done,
     /* 153690 */   // Label 3042: @153690
     /* 153690 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(153719), // Rule ID 4640 //
     /* 153695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153710 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 153710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 153713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153717 */     GIR_RootConstrainSelectedInstOperands,
     /* 153718 */     // GIR_Coverage, 4640,
     /* 153718 */     GIR_EraseRootFromParent_Done,
     /* 153719 */   // Label 3043: @153719
     /* 153719 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(153748), // Rule ID 4641 //
     /* 153724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153739 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 153739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 153742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153746 */     GIR_RootConstrainSelectedInstOperands,
     /* 153747 */     // GIR_Coverage, 4641,
     /* 153747 */     GIR_EraseRootFromParent_Done,
     /* 153748 */   // Label 3044: @153748
     /* 153748 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(153777), // Rule ID 4642 //
     /* 153753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153768 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 153768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 153771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153775 */     GIR_RootConstrainSelectedInstOperands,
     /* 153776 */     // GIR_Coverage, 4642,
     /* 153776 */     GIR_EraseRootFromParent_Done,
     /* 153777 */   // Label 3045: @153777
     /* 153777 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(153806), // Rule ID 4937 //
     /* 153782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153797 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 153797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 153800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153804 */     GIR_RootConstrainSelectedInstOperands,
     /* 153805 */     // GIR_Coverage, 4937,
     /* 153805 */     GIR_EraseRootFromParent_Done,
     /* 153806 */   // Label 3046: @153806
     /* 153806 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(153835), // Rule ID 4938 //
     /* 153811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153826 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 153826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 153829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153833 */     GIR_RootConstrainSelectedInstOperands,
     /* 153834 */     // GIR_Coverage, 4938,
     /* 153834 */     GIR_EraseRootFromParent_Done,
     /* 153835 */   // Label 3047: @153835
     /* 153835 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(153864), // Rule ID 4939 //
     /* 153840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 153848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153855 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 153855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 153858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153862 */     GIR_RootConstrainSelectedInstOperands,
     /* 153863 */     // GIR_Coverage, 4939,
     /* 153863 */     GIR_EraseRootFromParent_Done,
     /* 153864 */   // Label 3048: @153864
     /* 153864 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(153893), // Rule ID 4940 //
     /* 153869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153884 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 153884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 153887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153891 */     GIR_RootConstrainSelectedInstOperands,
     /* 153892 */     // GIR_Coverage, 4940,
     /* 153892 */     GIR_EraseRootFromParent_Done,
     /* 153893 */   // Label 3049: @153893
     /* 153893 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(153922), // Rule ID 4941 //
     /* 153898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 153903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153913 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 153913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 153916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153920 */     GIR_RootConstrainSelectedInstOperands,
     /* 153921 */     // GIR_Coverage, 4941,
     /* 153921 */     GIR_EraseRootFromParent_Done,
     /* 153922 */   // Label 3050: @153922
     /* 153922 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(153951), // Rule ID 4942 //
     /* 153927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153942 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 153942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 153945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153949 */     GIR_RootConstrainSelectedInstOperands,
     /* 153950 */     // GIR_Coverage, 4942,
     /* 153950 */     GIR_EraseRootFromParent_Done,
     /* 153951 */   // Label 3051: @153951
     /* 153951 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(153980), // Rule ID 4943 //
     /* 153956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153971 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 153971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 153974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153978 */     GIR_RootConstrainSelectedInstOperands,
     /* 153979 */     // GIR_Coverage, 4943,
     /* 153979 */     GIR_EraseRootFromParent_Done,
     /* 153980 */   // Label 3052: @153980
     /* 153980 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(154009), // Rule ID 4944 //
     /* 153985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 153990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 153993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154000 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 154000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 154003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154007 */     GIR_RootConstrainSelectedInstOperands,
     /* 154008 */     // GIR_Coverage, 4944,
     /* 154008 */     GIR_EraseRootFromParent_Done,
     /* 154009 */   // Label 3053: @154009
     /* 154009 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(154038), // Rule ID 4945 //
     /* 154014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 154019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154029 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 154029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 154032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154036 */     GIR_RootConstrainSelectedInstOperands,
     /* 154037 */     // GIR_Coverage, 4945,
     /* 154037 */     GIR_EraseRootFromParent_Done,
     /* 154038 */   // Label 3054: @154038
     /* 154038 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(154067), // Rule ID 4946 //
     /* 154043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 154048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154058 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 154058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 154061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154065 */     GIR_RootConstrainSelectedInstOperands,
     /* 154066 */     // GIR_Coverage, 4946,
     /* 154066 */     GIR_EraseRootFromParent_Done,
     /* 154067 */   // Label 3055: @154067
     /* 154067 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(154099), // Rule ID 8423 //
     /* 154072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 154075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 154080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 154083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 154086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 154090 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1660:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 154090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 154093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 154095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154097 */     GIR_RootConstrainSelectedInstOperands,
     /* 154098 */     // GIR_Coverage, 8423,
     /* 154098 */     GIR_EraseRootFromParent_Done,
     /* 154099 */   // Label 3056: @154099
     /* 154099 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(154131), // Rule ID 8424 //
     /* 154104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 154107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 154112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 154115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 154118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 154122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1660:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 154122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 154125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 154127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154129 */     GIR_RootConstrainSelectedInstOperands,
     /* 154130 */     // GIR_Coverage, 8424,
     /* 154130 */     GIR_EraseRootFromParent_Done,
     /* 154131 */   // Label 3057: @154131
     /* 154131 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(154163), // Rule ID 8425 //
     /* 154136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 154139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 154144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 154147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 154150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 154154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1660:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 154154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 154157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 154159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154161 */     GIR_RootConstrainSelectedInstOperands,
     /* 154162 */     // GIR_Coverage, 8425,
     /* 154162 */     GIR_EraseRootFromParent_Done,
     /* 154163 */   // Label 3058: @154163
     /* 154163 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(154195), // Rule ID 11834 //
     /* 154168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 154176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 154179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 154182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 154186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 154189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154193 */     GIR_RootConstrainSelectedInstOperands,
     /* 154194 */     // GIR_Coverage, 11834,
     /* 154194 */     GIR_EraseRootFromParent_Done,
     /* 154195 */   // Label 3059: @154195
     /* 154195 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(154227), // Rule ID 11835 //
     /* 154200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 154208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 154211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 154214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 154218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 154221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154225 */     GIR_RootConstrainSelectedInstOperands,
     /* 154226 */     // GIR_Coverage, 11835,
     /* 154226 */     GIR_EraseRootFromParent_Done,
     /* 154227 */   // Label 3060: @154227
     /* 154227 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(154259), // Rule ID 11836 //
     /* 154232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 154240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 154243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 154246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 154250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 154253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154257 */     GIR_RootConstrainSelectedInstOperands,
     /* 154258 */     // GIR_Coverage, 11836,
     /* 154258 */     GIR_EraseRootFromParent_Done,
     /* 154259 */   // Label 3061: @154259
     /* 154259 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(154291), // Rule ID 11837 //
     /* 154264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 154272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 154275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 154278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154282 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 154282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 154285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154289 */     GIR_RootConstrainSelectedInstOperands,
     /* 154290 */     // GIR_Coverage, 11837,
     /* 154290 */     GIR_EraseRootFromParent_Done,
     /* 154291 */   // Label 3062: @154291
     /* 154291 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(154323), // Rule ID 11838 //
     /* 154296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 154304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 154307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 154310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 154314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 154317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154321 */     GIR_RootConstrainSelectedInstOperands,
     /* 154322 */     // GIR_Coverage, 11838,
     /* 154322 */     GIR_EraseRootFromParent_Done,
     /* 154323 */   // Label 3063: @154323
     /* 154323 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(154355), // Rule ID 11839 //
     /* 154328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 154331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 154336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 154339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 154342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 154346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 154349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 154351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154353 */     GIR_RootConstrainSelectedInstOperands,
     /* 154354 */     // GIR_Coverage, 11839,
     /* 154354 */     GIR_EraseRootFromParent_Done,
     /* 154355 */   // Label 3064: @154355
     /* 154355 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(154387), // Rule ID 11994 //
     /* 154360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 154363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 154368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 154371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 154374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 154378 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 154378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 154381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 154383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 154385 */     GIR_RootConstrainSelectedInstOperands,
     /* 154386 */     // GIR_Coverage, 11994,
     /* 154386 */     GIR_EraseRootFromParent_Done,
     /* 154387 */   // Label 3065: @154387
     /* 154387 */   GIM_Reject,
     /* 154388 */ // Label 2746: @154388
     /* 154388 */ GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(200702),
     /* 154393 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 154396 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(154580), // Rule ID 2568 //
     /* 154401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154450 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154453 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154462 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 154475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154479 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 154487 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154491 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154495 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 154499 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154504 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 154508 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154512 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154516 */     // MIs[5] Operand 1
     /* 154516 */     // No operand predicates
     /* 154516 */     // MIs[3] Operand 2
     /* 154516 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 154527 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154531 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 154533 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154545 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 154564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 154575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 154578 */     GIR_RootConstrainSelectedInstOperands,
     /* 154579 */     // GIR_Coverage, 2568,
     /* 154579 */     GIR_EraseRootFromParent_Done,
     /* 154580 */   // Label 3067: @154580
     /* 154580 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(154764), // Rule ID 6273 //
     /* 154585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154634 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154637 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154646 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 154659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154667 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 154671 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154675 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154679 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 154683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154688 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 154692 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154696 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154700 */     // MIs[5] Operand 1
     /* 154700 */     // No operand predicates
     /* 154700 */     // MIs[3] Operand 2
     /* 154700 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 154711 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154715 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 154717 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154729 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 154748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 154759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 154762 */     GIR_RootConstrainSelectedInstOperands,
     /* 154763 */     // GIR_Coverage, 6273,
     /* 154763 */     GIR_EraseRootFromParent_Done,
     /* 154764 */   // Label 3068: @154764
     /* 154764 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(154904), // Rule ID 2057 //
     /* 154769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154802 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154805 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154814 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 154822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 154834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154842 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154846 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154851 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154855 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154859 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154863 */     // MIs[4] Operand 1
     /* 154863 */     // No operand predicates
     /* 154863 */     // MIs[2] Operand 2
     /* 154863 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154883 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 154886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154902 */     GIR_RootConstrainSelectedInstOperands,
     /* 154903 */     // GIR_Coverage, 2057,
     /* 154903 */     GIR_EraseRootFromParent_Done,
     /* 154904 */   // Label 3069: @154904
     /* 154904 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(155044), // Rule ID 2064 //
     /* 154909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154942 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154945 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154954 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 154962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 154974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154982 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154986 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154991 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154995 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154999 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155003 */     // MIs[4] Operand 1
     /* 155003 */     // No operand predicates
     /* 155003 */     // MIs[2] Operand 2
     /* 155003 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 155014 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 155023 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 155026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155042 */     GIR_RootConstrainSelectedInstOperands,
     /* 155043 */     // GIR_Coverage, 2064,
     /* 155043 */     GIR_EraseRootFromParent_Done,
     /* 155044 */   // Label 3070: @155044
     /* 155044 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(155184), // Rule ID 2060 //
     /* 155049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155082 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155085 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155094 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155126 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155139 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155143 */     // MIs[4] Operand 1
     /* 155143 */     // No operand predicates
     /* 155143 */     // MIs[2] Operand 2
     /* 155143 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 155154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 155163 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 155166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155182 */     GIR_RootConstrainSelectedInstOperands,
     /* 155183 */     // GIR_Coverage, 2060,
     /* 155183 */     GIR_EraseRootFromParent_Done,
     /* 155184 */   // Label 3071: @155184
     /* 155184 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(155324), // Rule ID 2067 //
     /* 155189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155222 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155225 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155234 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155258 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155262 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155266 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155271 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155275 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155279 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155283 */     // MIs[4] Operand 1
     /* 155283 */     // No operand predicates
     /* 155283 */     // MIs[2] Operand 2
     /* 155283 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 155294 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 155303 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 155306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155322 */     GIR_RootConstrainSelectedInstOperands,
     /* 155323 */     // GIR_Coverage, 2067,
     /* 155323 */     GIR_EraseRootFromParent_Done,
     /* 155324 */   // Label 3072: @155324
     /* 155324 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(155461), // Rule ID 2055 //
     /* 155329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155362 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155365 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155374 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155403 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155407 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155411 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155416 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155420 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155424 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155428 */     // MIs[4] Operand 1
     /* 155428 */     // No operand predicates
     /* 155428 */     // MIs[2] Operand 2
     /* 155428 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 155439 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155441 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 155444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155459 */     GIR_RootConstrainSelectedInstOperands,
     /* 155460 */     // GIR_Coverage, 2055,
     /* 155460 */     GIR_EraseRootFromParent_Done,
     /* 155461 */   // Label 3073: @155461
     /* 155461 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(155598), // Rule ID 2062 //
     /* 155466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155499 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155502 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155511 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155540 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155544 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155548 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155553 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155557 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155561 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155565 */     // MIs[4] Operand 1
     /* 155565 */     // No operand predicates
     /* 155565 */     // MIs[2] Operand 2
     /* 155565 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 155576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155578 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 155581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155596 */     GIR_RootConstrainSelectedInstOperands,
     /* 155597 */     // GIR_Coverage, 2062,
     /* 155597 */     GIR_EraseRootFromParent_Done,
     /* 155598 */   // Label 3074: @155598
     /* 155598 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(155735), // Rule ID 2058 //
     /* 155603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155636 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155639 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155648 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155681 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155685 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155698 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155702 */     // MIs[4] Operand 1
     /* 155702 */     // No operand predicates
     /* 155702 */     // MIs[2] Operand 2
     /* 155702 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 155713 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155715 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 155718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155733 */     GIR_RootConstrainSelectedInstOperands,
     /* 155734 */     // GIR_Coverage, 2058,
     /* 155734 */     GIR_EraseRootFromParent_Done,
     /* 155735 */   // Label 3075: @155735
     /* 155735 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(155872), // Rule ID 2065 //
     /* 155740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155773 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155776 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155785 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 155810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155822 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155835 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155839 */     // MIs[4] Operand 1
     /* 155839 */     // No operand predicates
     /* 155839 */     // MIs[2] Operand 2
     /* 155839 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 155850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155852 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 155855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 155867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 155870 */     GIR_RootConstrainSelectedInstOperands,
     /* 155871 */     // GIR_Coverage, 2065,
     /* 155871 */     GIR_EraseRootFromParent_Done,
     /* 155872 */   // Label 3076: @155872
     /* 155872 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(156033), // Rule ID 2569 //
     /* 155877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155926 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155929 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155938 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 155951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 155972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155976 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155980 */     // MIs[4] Operand 1
     /* 155980 */     // No operand predicates
     /* 155980 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155984 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 155986 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 155986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155998 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 156017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 156028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 156031 */     GIR_RootConstrainSelectedInstOperands,
     /* 156032 */     // GIR_Coverage, 2569,
     /* 156032 */     GIR_EraseRootFromParent_Done,
     /* 156033 */   // Label 3077: @156033
     /* 156033 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(156194), // Rule ID 6274 //
     /* 156038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156087 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 156090 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156099 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 156112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156129 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 156133 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156137 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156141 */     // MIs[4] Operand 1
     /* 156141 */     // No operand predicates
     /* 156141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156145 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 156147 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156159 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 156178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 156189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 156192 */     GIR_RootConstrainSelectedInstOperands,
     /* 156193 */     // GIR_Coverage, 6274,
     /* 156193 */     GIR_EraseRootFromParent_Done,
     /* 156194 */   // Label 3078: @156194
     /* 156194 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(156304), // Rule ID 2085 //
     /* 156199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156261 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156265 */     // MIs[3] Operand 1
     /* 156265 */     // No operand predicates
     /* 156265 */     // MIs[1] Operand 2
     /* 156265 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 156276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156285 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 156288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156302 */     GIR_RootConstrainSelectedInstOperands,
     /* 156303 */     // GIR_Coverage, 2085,
     /* 156303 */     GIR_EraseRootFromParent_Done,
     /* 156304 */   // Label 3079: @156304
     /* 156304 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(156414), // Rule ID 2088 //
     /* 156309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156371 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156375 */     // MIs[3] Operand 1
     /* 156375 */     // No operand predicates
     /* 156375 */     // MIs[1] Operand 2
     /* 156375 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 156386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156395 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 156398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156412 */     GIR_RootConstrainSelectedInstOperands,
     /* 156413 */     // GIR_Coverage, 2088,
     /* 156413 */     GIR_EraseRootFromParent_Done,
     /* 156414 */   // Label 3080: @156414
     /* 156414 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(156503), // Rule ID 1743 //
     /* 156419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156464 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156484 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 156484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 156487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 156501 */     GIR_RootConstrainSelectedInstOperands,
     /* 156502 */     // GIR_Coverage, 1743,
     /* 156502 */     GIR_EraseRootFromParent_Done,
     /* 156503 */   // Label 3081: @156503
     /* 156503 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(156592), // Rule ID 1745 //
     /* 156508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156541 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156544 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156553 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156573 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 156573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 156576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 156590 */     GIR_RootConstrainSelectedInstOperands,
     /* 156591 */     // GIR_Coverage, 1745,
     /* 156591 */     GIR_EraseRootFromParent_Done,
     /* 156592 */   // Label 3082: @156592
     /* 156592 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(156681), // Rule ID 1747 //
     /* 156597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156630 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156633 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156642 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 156662 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 156662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 156665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 156679 */     GIR_RootConstrainSelectedInstOperands,
     /* 156680 */     // GIR_Coverage, 1747,
     /* 156680 */     GIR_EraseRootFromParent_Done,
     /* 156681 */   // Label 3083: @156681
     /* 156681 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(156770), // Rule ID 1749 //
     /* 156686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156719 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156722 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156731 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 156751 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 156751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 156754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 156763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 156768 */     GIR_RootConstrainSelectedInstOperands,
     /* 156769 */     // GIR_Coverage, 1749,
     /* 156769 */     GIR_EraseRootFromParent_Done,
     /* 156770 */   // Label 3084: @156770
     /* 156770 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(156892), // Rule ID 6925 //
     /* 156775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 156780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156810 */     // MIs[1] Operand 2
     /* 156810 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156829 */     // MIs[2] Rn
     /* 156829 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 156834 */     // MIs[2] Operand 2
     /* 156834 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 156845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156847 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 156847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 156850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 156854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 156863 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 156867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156874 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 156881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156891 */     // GIR_Coverage, 6925,
     /* 156891 */     GIR_EraseRootFromParent_Done,
     /* 156892 */   // Label 3085: @156892
     /* 156892 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(157014), // Rule ID 6927 //
     /* 156897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 156902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156932 */     // MIs[1] Operand 2
     /* 156932 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156951 */     // MIs[2] Rn
     /* 156951 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 156956 */     // MIs[2] Operand 2
     /* 156956 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 156967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156969 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 156969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 156972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 156976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 156985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 156989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156996 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 157003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157013 */     // GIR_Coverage, 6927,
     /* 157013 */     GIR_EraseRootFromParent_Done,
     /* 157014 */   // Label 3086: @157014
     /* 157014 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(157136), // Rule ID 6929 //
     /* 157019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 157024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 157027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 157030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 157033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 157049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157054 */     // MIs[1] Operand 2
     /* 157054 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 157069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157073 */     // MIs[2] Rn
     /* 157073 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 157078 */     // MIs[2] Operand 2
     /* 157078 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 157089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157091 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 157091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 157094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 157098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157118 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 157125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157135 */     // GIR_Coverage, 6929,
     /* 157135 */     GIR_EraseRootFromParent_Done,
     /* 157136 */   // Label 3087: @157136
     /* 157136 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(157258), // Rule ID 6931 //
     /* 157141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 157146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157176 */     // MIs[1] Operand 2
     /* 157176 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 157191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157195 */     // MIs[2] Rn
     /* 157195 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 157200 */     // MIs[2] Operand 2
     /* 157200 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 157211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157213 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 157213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 157216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 157220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157240 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 157247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157257 */     // GIR_Coverage, 6931,
     /* 157257 */     GIR_EraseRootFromParent_Done,
     /* 157258 */   // Label 3088: @157258
     /* 157258 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(157380), // Rule ID 6933 //
     /* 157263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 157268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157298 */     // MIs[1] Operand 2
     /* 157298 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 157313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157317 */     // MIs[2] Rn
     /* 157317 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 157322 */     // MIs[2] Operand 2
     /* 157322 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 157333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157335 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 157335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 157338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 157342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 157355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157362 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 157369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157379 */     // GIR_Coverage, 6933,
     /* 157379 */     GIR_EraseRootFromParent_Done,
     /* 157380 */   // Label 3089: @157380
     /* 157380 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(157563), // Rule ID 2567 //
     /* 157385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157434 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 157437 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157446 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 157464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157466 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 157466 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 157469 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157473 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 157480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 157483 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157487 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157492 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 157495 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 157499 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 157502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157507 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157512 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157529 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 157548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157561 */     GIR_RootConstrainSelectedInstOperands,
     /* 157562 */     // GIR_Coverage, 2567,
     /* 157562 */     GIR_EraseRootFromParent_Done,
     /* 157563 */   // Label 3090: @157563
     /* 157563 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(157746), // Rule ID 6272 //
     /* 157568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157617 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 157620 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157629 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157643 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 157647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157649 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 157649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 157652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 157663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 157666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 157678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 157682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 157685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157712 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 157731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157744 */     GIR_RootConstrainSelectedInstOperands,
     /* 157745 */     // GIR_Coverage, 6272,
     /* 157745 */     GIR_EraseRootFromParent_Done,
     /* 157746 */   // Label 3091: @157746
     /* 157746 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(157850), // Rule ID 13459 //
     /* 157751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157817 */     // MIs[3] Operand 1
     /* 157817 */     // No operand predicates
     /* 157817 */     // MIs[1] Operand 2
     /* 157817 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157834 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 157837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 157841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157848 */     GIR_RootConstrainSelectedInstOperands,
     /* 157849 */     // GIR_Coverage, 13459,
     /* 157849 */     GIR_EraseRootFromParent_Done,
     /* 157850 */   // Label 3092: @157850
     /* 157850 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(157954), // Rule ID 13462 //
     /* 157855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157917 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157921 */     // MIs[3] Operand 1
     /* 157921 */     // No operand predicates
     /* 157921 */     // MIs[1] Operand 2
     /* 157921 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157938 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 157941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 157945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157952 */     GIR_RootConstrainSelectedInstOperands,
     /* 157953 */     // GIR_Coverage, 13462,
     /* 157953 */     GIR_EraseRootFromParent_Done,
     /* 157954 */   // Label 3093: @157954
     /* 157954 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(158085), // Rule ID 2524 //
     /* 157959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 157976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158001 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158034 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158038 */     // MIs[3] Operand 1
     /* 158038 */     // No operand predicates
     /* 158038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158040 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 158040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158052 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 158071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158083 */     GIR_RootConstrainSelectedInstOperands,
     /* 158084 */     // GIR_Coverage, 2524,
     /* 158084 */     GIR_EraseRootFromParent_Done,
     /* 158085 */   // Label 3094: @158085
     /* 158085 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(158216), // Rule ID 2525 //
     /* 158090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158132 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158165 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158169 */     // MIs[3] Operand 1
     /* 158169 */     // No operand predicates
     /* 158169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158171 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 158171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158183 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 158189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 158202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158214 */     GIR_RootConstrainSelectedInstOperands,
     /* 158215 */     // GIR_Coverage, 2525,
     /* 158215 */     GIR_EraseRootFromParent_Done,
     /* 158216 */   // Label 3095: @158216
     /* 158216 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(158347), // Rule ID 2526 //
     /* 158221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158296 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 158300 */     // MIs[3] Operand 1
     /* 158300 */     // No operand predicates
     /* 158300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158302 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 158302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158314 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 158320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 158333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158345 */     GIR_RootConstrainSelectedInstOperands,
     /* 158346 */     // GIR_Coverage, 2526,
     /* 158346 */     GIR_EraseRootFromParent_Done,
     /* 158347 */   // Label 3096: @158347
     /* 158347 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(158478), // Rule ID 13645 //
     /* 158352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 158355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158402 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158406 */     // MIs[2] Operand 1
     /* 158406 */     // No operand predicates
     /* 158406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 158410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 158422 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158427 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 158431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158433 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 158433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 158464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158476 */     GIR_RootConstrainSelectedInstOperands,
     /* 158477 */     // GIR_Coverage, 13645,
     /* 158477 */     GIR_EraseRootFromParent_Done,
     /* 158478 */   // Label 3097: @158478
     /* 158478 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(158609), // Rule ID 13646 //
     /* 158483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158537 */     // MIs[2] Operand 1
     /* 158537 */     // No operand predicates
     /* 158537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 158541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158545 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158549 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 158553 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158558 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 158562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158564 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 158564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158576 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 158582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 158595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158607 */     GIR_RootConstrainSelectedInstOperands,
     /* 158608 */     // GIR_Coverage, 13646,
     /* 158608 */     GIR_EraseRootFromParent_Done,
     /* 158609 */   // Label 3098: @158609
     /* 158609 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(158740), // Rule ID 13647 //
     /* 158614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158664 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 158668 */     // MIs[2] Operand 1
     /* 158668 */     // No operand predicates
     /* 158668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 158672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158680 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 158684 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158689 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 158693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158695 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 158695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158707 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 158713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 158726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158738 */     GIR_RootConstrainSelectedInstOperands,
     /* 158739 */     // GIR_Coverage, 13647,
     /* 158739 */     GIR_EraseRootFromParent_Done,
     /* 158740 */   // Label 3099: @158740
     /* 158740 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(158854), // Rule ID 2056 //
     /* 158745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158778 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158781 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158790 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 158803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158828 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158832 */     // MIs[3] Operand 1
     /* 158832 */     // No operand predicates
     /* 158832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158834 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 158837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158852 */     GIR_RootConstrainSelectedInstOperands,
     /* 158853 */     // GIR_Coverage, 2056,
     /* 158853 */     GIR_EraseRootFromParent_Done,
     /* 158854 */   // Label 3100: @158854
     /* 158854 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(158968), // Rule ID 2063 //
     /* 158859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158892 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158895 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158904 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 158917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158942 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158946 */     // MIs[3] Operand 1
     /* 158946 */     // No operand predicates
     /* 158946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158948 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 158951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158966 */     GIR_RootConstrainSelectedInstOperands,
     /* 158967 */     // GIR_Coverage, 2063,
     /* 158967 */     GIR_EraseRootFromParent_Done,
     /* 158968 */   // Label 3101: @158968
     /* 158968 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(159082), // Rule ID 2059 //
     /* 158973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159006 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159009 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159018 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 159031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159056 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159060 */     // MIs[3] Operand 1
     /* 159060 */     // No operand predicates
     /* 159060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159062 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 159065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159080 */     GIR_RootConstrainSelectedInstOperands,
     /* 159081 */     // GIR_Coverage, 2059,
     /* 159081 */     GIR_EraseRootFromParent_Done,
     /* 159082 */   // Label 3102: @159082
     /* 159082 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(159196), // Rule ID 2066 //
     /* 159087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159120 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159123 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159132 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 159145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159170 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159174 */     // MIs[3] Operand 1
     /* 159174 */     // No operand predicates
     /* 159174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159176 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 159179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159194 */     GIR_RootConstrainSelectedInstOperands,
     /* 159195 */     // GIR_Coverage, 2066,
     /* 159195 */     GIR_EraseRootFromParent_Done,
     /* 159196 */   // Label 3103: @159196
     /* 159196 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(159310), // Rule ID 2061 //
     /* 159201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 159209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159234 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159237 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 159242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 159246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 159250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 159259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159284 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159288 */     // MIs[3] Operand 1
     /* 159288 */     // No operand predicates
     /* 159288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159290 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 159293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159308 */     GIR_RootConstrainSelectedInstOperands,
     /* 159309 */     // GIR_Coverage, 2061,
     /* 159309 */     GIR_EraseRootFromParent_Done,
     /* 159310 */   // Label 3104: @159310
     /* 159310 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(159424), // Rule ID 2068 //
     /* 159315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159348 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159351 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 159356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 159360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 159364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 159373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159398 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159402 */     // MIs[3] Operand 1
     /* 159402 */     // No operand predicates
     /* 159402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159404 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 159407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159422 */     GIR_RootConstrainSelectedInstOperands,
     /* 159423 */     // GIR_Coverage, 2068,
     /* 159423 */     GIR_EraseRootFromParent_Done,
     /* 159424 */   // Label 3105: @159424
     /* 159424 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(159528), // Rule ID 1987 //
     /* 159429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159495 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159499 */     // MIs[3] Operand 1
     /* 159499 */     // No operand predicates
     /* 159499 */     // MIs[1] Operand 2
     /* 159499 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159512 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 159515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159526 */     GIR_RootConstrainSelectedInstOperands,
     /* 159527 */     // GIR_Coverage, 1987,
     /* 159527 */     GIR_EraseRootFromParent_Done,
     /* 159528 */   // Label 3106: @159528
     /* 159528 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(159632), // Rule ID 2017 //
     /* 159533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 159541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159599 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159603 */     // MIs[3] Operand 1
     /* 159603 */     // No operand predicates
     /* 159603 */     // MIs[1] Operand 2
     /* 159603 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159616 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 159619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159630 */     GIR_RootConstrainSelectedInstOperands,
     /* 159631 */     // GIR_Coverage, 2017,
     /* 159631 */     GIR_EraseRootFromParent_Done,
     /* 159632 */   // Label 3107: @159632
     /* 159632 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(159736), // Rule ID 2024 //
     /* 159637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 159645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159703 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159707 */     // MIs[3] Operand 1
     /* 159707 */     // No operand predicates
     /* 159707 */     // MIs[1] Operand 2
     /* 159707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159720 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 159723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159734 */     GIR_RootConstrainSelectedInstOperands,
     /* 159735 */     // GIR_Coverage, 2024,
     /* 159735 */     GIR_EraseRootFromParent_Done,
     /* 159736 */   // Label 3108: @159736
     /* 159736 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(159840), // Rule ID 2083 //
     /* 159741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159807 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159811 */     // MIs[3] Operand 1
     /* 159811 */     // No operand predicates
     /* 159811 */     // MIs[1] Operand 2
     /* 159811 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159824 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 159827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159838 */     GIR_RootConstrainSelectedInstOperands,
     /* 159839 */     // GIR_Coverage, 2083,
     /* 159839 */     GIR_EraseRootFromParent_Done,
     /* 159840 */   // Label 3109: @159840
     /* 159840 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(159944), // Rule ID 1990 //
     /* 159845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 159898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 159907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159911 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159915 */     // MIs[3] Operand 1
     /* 159915 */     // No operand predicates
     /* 159915 */     // MIs[1] Operand 2
     /* 159915 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 159926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 159928 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 159931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 159939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 159942 */     GIR_RootConstrainSelectedInstOperands,
     /* 159943 */     // GIR_Coverage, 1990,
     /* 159943 */     GIR_EraseRootFromParent_Done,
     /* 159944 */   // Label 3110: @159944
     /* 159944 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(160048), // Rule ID 2020 //
     /* 159949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 159957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 160002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 160011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160015 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160019 */     // MIs[3] Operand 1
     /* 160019 */     // No operand predicates
     /* 160019 */     // MIs[1] Operand 2
     /* 160019 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 160030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 160032 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 160035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 160043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 160046 */     GIR_RootConstrainSelectedInstOperands,
     /* 160047 */     // GIR_Coverage, 2020,
     /* 160047 */     GIR_EraseRootFromParent_Done,
     /* 160048 */   // Label 3111: @160048
     /* 160048 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(160152), // Rule ID 2027 //
     /* 160053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 160086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 160094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 160106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 160115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160119 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160123 */     // MIs[3] Operand 1
     /* 160123 */     // No operand predicates
     /* 160123 */     // MIs[1] Operand 2
     /* 160123 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 160134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 160136 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 160139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 160147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 160150 */     GIR_RootConstrainSelectedInstOperands,
     /* 160151 */     // GIR_Coverage, 2027,
     /* 160151 */     GIR_EraseRootFromParent_Done,
     /* 160152 */   // Label 3112: @160152
     /* 160152 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(160256), // Rule ID 2086 //
     /* 160157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 160190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 160198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 160210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 160219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160223 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160227 */     // MIs[3] Operand 1
     /* 160227 */     // No operand predicates
     /* 160227 */     // MIs[1] Operand 2
     /* 160227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 160238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 160240 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 160243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 160251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 160254 */     GIR_RootConstrainSelectedInstOperands,
     /* 160255 */     // GIR_Coverage, 2086,
     /* 160255 */     GIR_EraseRootFromParent_Done,
     /* 160256 */   // Label 3113: @160256
     /* 160256 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(160313), // Rule ID 1751 //
     /* 160261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 160289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 160296 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 160296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 160299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 160306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 160311 */     GIR_RootConstrainSelectedInstOperands,
     /* 160312 */     // GIR_Coverage, 1751,
     /* 160312 */     GIR_EraseRootFromParent_Done,
     /* 160313 */   // Label 3114: @160313
     /* 160313 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(160370), // Rule ID 1753 //
     /* 160318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 160346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 160353 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 160353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 160356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 160363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 160368 */     GIR_RootConstrainSelectedInstOperands,
     /* 160369 */     // GIR_Coverage, 1753,
     /* 160369 */     GIR_EraseRootFromParent_Done,
     /* 160370 */   // Label 3115: @160370
     /* 160370 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(160480), // Rule ID 6291 //
     /* 160375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 160401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 160405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 160409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160414 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 160425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 160429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160433 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 160437 */     // MIs[2] Operand 1
     /* 160437 */     // No operand predicates
     /* 160437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160439 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 160439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 160442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160451 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 160457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 160470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 160478 */     GIR_RootConstrainSelectedInstOperands,
     /* 160479 */     // GIR_Coverage, 6291,
     /* 160479 */     GIR_EraseRootFromParent_Done,
     /* 160480 */   // Label 3116: @160480
     /* 160480 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(160577), // Rule ID 13916 //
     /* 160485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 160488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 160502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160527 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 160531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160537 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 160537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 160540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160549 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 160555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 160568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160575 */     GIR_RootConstrainSelectedInstOperands,
     /* 160576 */     // GIR_Coverage, 13916,
     /* 160576 */     GIR_EraseRootFromParent_Done,
     /* 160577 */   // Label 3117: @160577
     /* 160577 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(160674), // Rule ID 13917 //
     /* 160582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 160585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160624 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 160628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160634 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 160634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160646 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 160652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 160665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160672 */     GIR_RootConstrainSelectedInstOperands,
     /* 160673 */     // GIR_Coverage, 13917,
     /* 160673 */     GIR_EraseRootFromParent_Done,
     /* 160674 */   // Label 3118: @160674
     /* 160674 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(160771), // Rule ID 13918 //
     /* 160679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 160682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160721 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 160725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160731 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 160731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 160734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160743 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 160749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 160762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160769 */     GIR_RootConstrainSelectedInstOperands,
     /* 160770 */     // GIR_Coverage, 13918,
     /* 160770 */     GIR_EraseRootFromParent_Done,
     /* 160771 */   // Label 3119: @160771
     /* 160771 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(160854), // Rule ID 1742 //
     /* 160776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 160784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160809 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160812 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160821 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160837 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 160837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 160840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 160844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 160848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 160852 */     GIR_RootConstrainSelectedInstOperands,
     /* 160853 */     // GIR_Coverage, 1742,
     /* 160853 */     GIR_EraseRootFromParent_Done,
     /* 160854 */   // Label 3120: @160854
     /* 160854 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(160937), // Rule ID 1744 //
     /* 160859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 160867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 160876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160892 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160895 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160904 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160920 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 160920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 160923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 160927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 160931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 160935 */     GIR_RootConstrainSelectedInstOperands,
     /* 160936 */     // GIR_Coverage, 1744,
     /* 160936 */     GIR_EraseRootFromParent_Done,
     /* 160937 */   // Label 3121: @160937
     /* 160937 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(161020), // Rule ID 1746 //
     /* 160942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 160950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160975 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160978 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161003 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 161003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 161006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 161014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 161018 */     GIR_RootConstrainSelectedInstOperands,
     /* 161019 */     // GIR_Coverage, 1746,
     /* 161019 */     GIR_EraseRootFromParent_Done,
     /* 161020 */   // Label 3122: @161020
     /* 161020 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(161103), // Rule ID 1748 //
     /* 161025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 161033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 161058 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 161061 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 161066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161070 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161086 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 161086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 161089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 161097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 161101 */     GIR_RootConstrainSelectedInstOperands,
     /* 161102 */     // GIR_Coverage, 1748,
     /* 161102 */     GIR_EraseRootFromParent_Done,
     /* 161103 */   // Label 3123: @161103
     /* 161103 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(161183), // Rule ID 5237 //
     /* 161108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 161113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 161138 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 161141 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 161146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 161150 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 161154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161166 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 161166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 161169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 161177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 161181 */     GIR_RootConstrainSelectedInstOperands,
     /* 161182 */     // GIR_Coverage, 5237,
     /* 161182 */     GIR_EraseRootFromParent_Done,
     /* 161183 */   // Label 3124: @161183
     /* 161183 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(161263), // Rule ID 5238 //
     /* 161188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 161193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 161218 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 161221 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 161226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 161230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 161234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161246 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 161246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 161249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 161257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 161261 */     GIR_RootConstrainSelectedInstOperands,
     /* 161262 */     // GIR_Coverage, 5238,
     /* 161262 */     GIR_EraseRootFromParent_Done,
     /* 161263 */   // Label 3125: @161263
     /* 161263 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(161360), // Rule ID 5234 //
     /* 161268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 161271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 161279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161314 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 161318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161320 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 161320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 161323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161332 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 161338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 161351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161358 */     GIR_RootConstrainSelectedInstOperands,
     /* 161359 */     // GIR_Coverage, 5234,
     /* 161359 */     GIR_EraseRootFromParent_Done,
     /* 161360 */   // Label 3126: @161360
     /* 161360 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(161457), // Rule ID 5235 //
     /* 161365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 161368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161411 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 161415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161417 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 161417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 161420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161429 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 161435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 161448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161455 */     GIR_RootConstrainSelectedInstOperands,
     /* 161456 */     // GIR_Coverage, 5235,
     /* 161456 */     GIR_EraseRootFromParent_Done,
     /* 161457 */   // Label 3127: @161457
     /* 161457 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(161554), // Rule ID 5236 //
     /* 161462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 161465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 161512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161514 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 161514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 161517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161526 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 161532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 161545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161552 */     GIR_RootConstrainSelectedInstOperands,
     /* 161553 */     // GIR_Coverage, 5236,
     /* 161553 */     GIR_EraseRootFromParent_Done,
     /* 161554 */   // Label 3128: @161554
     /* 161554 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(161635), // Rule ID 13460 //
     /* 161559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 161588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161609 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161613 */     // MIs[2] Operand 1
     /* 161613 */     // No operand predicates
     /* 161613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161619 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 161622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161633 */     GIR_RootConstrainSelectedInstOperands,
     /* 161634 */     // GIR_Coverage, 13460,
     /* 161634 */     GIR_EraseRootFromParent_Done,
     /* 161635 */   // Label 3129: @161635
     /* 161635 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(161716), // Rule ID 13461 //
     /* 161640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 161669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161690 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161694 */     // MIs[2] Operand 1
     /* 161694 */     // No operand predicates
     /* 161694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161700 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 161703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161714 */     GIR_RootConstrainSelectedInstOperands,
     /* 161715 */     // GIR_Coverage, 13461,
     /* 161715 */     GIR_EraseRootFromParent_Done,
     /* 161716 */   // Label 3130: @161716
     /* 161716 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(161797), // Rule ID 13463 //
     /* 161721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161775 */     // MIs[2] Operand 1
     /* 161775 */     // No operand predicates
     /* 161775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161781 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 161784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161795 */     GIR_RootConstrainSelectedInstOperands,
     /* 161796 */     // GIR_Coverage, 13463,
     /* 161796 */     GIR_EraseRootFromParent_Done,
     /* 161797 */   // Label 3131: @161797
     /* 161797 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(161878), // Rule ID 13464 //
     /* 161802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161856 */     // MIs[2] Operand 1
     /* 161856 */     // No operand predicates
     /* 161856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161862 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 161865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161876 */     GIR_RootConstrainSelectedInstOperands,
     /* 161877 */     // GIR_Coverage, 13464,
     /* 161877 */     GIR_EraseRootFromParent_Done,
     /* 161878 */   // Label 3132: @161878
     /* 161878 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(161959), // Rule ID 13465 //
     /* 161883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 161912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161937 */     // MIs[2] Operand 1
     /* 161937 */     // No operand predicates
     /* 161937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161943 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 161946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161957 */     GIR_RootConstrainSelectedInstOperands,
     /* 161958 */     // GIR_Coverage, 13465,
     /* 161958 */     GIR_EraseRootFromParent_Done,
     /* 161959 */   // Label 3133: @161959
     /* 161959 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162040), // Rule ID 13466 //
     /* 161964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 161975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162018 */     // MIs[2] Operand 1
     /* 162018 */     // No operand predicates
     /* 162018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162024 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 162027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162038 */     GIR_RootConstrainSelectedInstOperands,
     /* 162039 */     // GIR_Coverage, 13466,
     /* 162039 */     GIR_EraseRootFromParent_Done,
     /* 162040 */   // Label 3134: @162040
     /* 162040 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(162121), // Rule ID 13467 //
     /* 162045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162099 */     // MIs[2] Operand 1
     /* 162099 */     // No operand predicates
     /* 162099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162105 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 162108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162119 */     GIR_RootConstrainSelectedInstOperands,
     /* 162120 */     // GIR_Coverage, 13467,
     /* 162120 */     GIR_EraseRootFromParent_Done,
     /* 162121 */   // Label 3135: @162121
     /* 162121 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(162202), // Rule ID 13468 //
     /* 162126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 162143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162176 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 162180 */     // MIs[2] Operand 1
     /* 162180 */     // No operand predicates
     /* 162180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162186 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 162189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162200 */     GIR_RootConstrainSelectedInstOperands,
     /* 162201 */     // GIR_Coverage, 13468,
     /* 162201 */     GIR_EraseRootFromParent_Done,
     /* 162202 */   // Label 3136: @162202
     /* 162202 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(162308), // Rule ID 6288 //
     /* 162207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 162215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 162233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 162237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162242 */     // MIs[1] Operand 2
     /* 162242 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 162253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 162257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162261 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 162265 */     // MIs[2] Operand 1
     /* 162265 */     // No operand predicates
     /* 162265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162267 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 162267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 162270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162279 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 162285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 162298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 162306 */     GIR_RootConstrainSelectedInstOperands,
     /* 162307 */     // GIR_Coverage, 6288,
     /* 162307 */     GIR_EraseRootFromParent_Done,
     /* 162308 */   // Label 3137: @162308
     /* 162308 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(162389), // Rule ID 1988 //
     /* 162313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162367 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162371 */     // MIs[2] Operand 1
     /* 162371 */     // No operand predicates
     /* 162371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162373 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 162376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162387 */     GIR_RootConstrainSelectedInstOperands,
     /* 162388 */     // GIR_Coverage, 1988,
     /* 162388 */     GIR_EraseRootFromParent_Done,
     /* 162389 */   // Label 3138: @162389
     /* 162389 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(162470), // Rule ID 1989 //
     /* 162394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162448 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162452 */     // MIs[2] Operand 1
     /* 162452 */     // No operand predicates
     /* 162452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162454 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 162457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162468 */     GIR_RootConstrainSelectedInstOperands,
     /* 162469 */     // GIR_Coverage, 1989,
     /* 162469 */     GIR_EraseRootFromParent_Done,
     /* 162470 */   // Label 3139: @162470
     /* 162470 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(162551), // Rule ID 2018 //
     /* 162475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 162483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162529 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162533 */     // MIs[2] Operand 1
     /* 162533 */     // No operand predicates
     /* 162533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162535 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 162538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162549 */     GIR_RootConstrainSelectedInstOperands,
     /* 162550 */     // GIR_Coverage, 2018,
     /* 162550 */     GIR_EraseRootFromParent_Done,
     /* 162551 */   // Label 3140: @162551
     /* 162551 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(162632), // Rule ID 2019 //
     /* 162556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 162564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162614 */     // MIs[2] Operand 1
     /* 162614 */     // No operand predicates
     /* 162614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162616 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 162619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162630 */     GIR_RootConstrainSelectedInstOperands,
     /* 162631 */     // GIR_Coverage, 2019,
     /* 162631 */     GIR_EraseRootFromParent_Done,
     /* 162632 */   // Label 3141: @162632
     /* 162632 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(162713), // Rule ID 2025 //
     /* 162637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 162645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162691 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162695 */     // MIs[2] Operand 1
     /* 162695 */     // No operand predicates
     /* 162695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162697 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 162700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162711 */     GIR_RootConstrainSelectedInstOperands,
     /* 162712 */     // GIR_Coverage, 2025,
     /* 162712 */     GIR_EraseRootFromParent_Done,
     /* 162713 */   // Label 3142: @162713
     /* 162713 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(162794), // Rule ID 2026 //
     /* 162718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 162726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162772 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162776 */     // MIs[2] Operand 1
     /* 162776 */     // No operand predicates
     /* 162776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162778 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 162781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162792 */     GIR_RootConstrainSelectedInstOperands,
     /* 162793 */     // GIR_Coverage, 2026,
     /* 162793 */     GIR_EraseRootFromParent_Done,
     /* 162794 */   // Label 3143: @162794
     /* 162794 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(162875), // Rule ID 2084 //
     /* 162799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 162807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 162832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162857 */     // MIs[2] Operand 1
     /* 162857 */     // No operand predicates
     /* 162857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162859 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 162862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162873 */     GIR_RootConstrainSelectedInstOperands,
     /* 162874 */     // GIR_Coverage, 2084,
     /* 162874 */     GIR_EraseRootFromParent_Done,
     /* 162875 */   // Label 3144: @162875
     /* 162875 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(162956), // Rule ID 1991 //
     /* 162880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 162913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162934 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162938 */     // MIs[2] Operand 1
     /* 162938 */     // No operand predicates
     /* 162938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162940 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 162943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162954 */     GIR_RootConstrainSelectedInstOperands,
     /* 162955 */     // GIR_Coverage, 1991,
     /* 162955 */     GIR_EraseRootFromParent_Done,
     /* 162956 */   // Label 3145: @162956
     /* 162956 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163037), // Rule ID 1992 //
     /* 162961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 162994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163015 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163019 */     // MIs[2] Operand 1
     /* 163019 */     // No operand predicates
     /* 163019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163021 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 163024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163035 */     GIR_RootConstrainSelectedInstOperands,
     /* 163036 */     // GIR_Coverage, 1992,
     /* 163036 */     GIR_EraseRootFromParent_Done,
     /* 163037 */   // Label 3146: @163037
     /* 163037 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163118), // Rule ID 2021 //
     /* 163042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 163050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163100 */     // MIs[2] Operand 1
     /* 163100 */     // No operand predicates
     /* 163100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163102 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 163105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163116 */     GIR_RootConstrainSelectedInstOperands,
     /* 163117 */     // GIR_Coverage, 2021,
     /* 163117 */     GIR_EraseRootFromParent_Done,
     /* 163118 */   // Label 3147: @163118
     /* 163118 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163199), // Rule ID 2022 //
     /* 163123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 163131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163177 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163181 */     // MIs[2] Operand 1
     /* 163181 */     // No operand predicates
     /* 163181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163183 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 163186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163197 */     GIR_RootConstrainSelectedInstOperands,
     /* 163198 */     // GIR_Coverage, 2022,
     /* 163198 */     GIR_EraseRootFromParent_Done,
     /* 163199 */   // Label 3148: @163199
     /* 163199 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(163280), // Rule ID 2028 //
     /* 163204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 163212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163258 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163262 */     // MIs[2] Operand 1
     /* 163262 */     // No operand predicates
     /* 163262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163264 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 163267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163278 */     GIR_RootConstrainSelectedInstOperands,
     /* 163279 */     // GIR_Coverage, 2028,
     /* 163279 */     GIR_EraseRootFromParent_Done,
     /* 163280 */   // Label 3149: @163280
     /* 163280 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(163361), // Rule ID 2029 //
     /* 163285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 163293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163339 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163343 */     // MIs[2] Operand 1
     /* 163343 */     // No operand predicates
     /* 163343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163345 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 163348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163359 */     GIR_RootConstrainSelectedInstOperands,
     /* 163360 */     // GIR_Coverage, 2029,
     /* 163360 */     GIR_EraseRootFromParent_Done,
     /* 163361 */   // Label 3150: @163361
     /* 163361 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(163442), // Rule ID 2087 //
     /* 163366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 163374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 163399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163424 */     // MIs[2] Operand 1
     /* 163424 */     // No operand predicates
     /* 163424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163426 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 163429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163440 */     GIR_RootConstrainSelectedInstOperands,
     /* 163441 */     // GIR_Coverage, 2087,
     /* 163441 */     GIR_EraseRootFromParent_Done,
     /* 163442 */   // Label 3151: @163442
     /* 163442 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(163523), // Rule ID 1993 //
     /* 163447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 163455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 163480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 163505 */     // MIs[2] Operand 1
     /* 163505 */     // No operand predicates
     /* 163505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163507 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 163510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163521 */     GIR_RootConstrainSelectedInstOperands,
     /* 163522 */     // GIR_Coverage, 1993,
     /* 163522 */     GIR_EraseRootFromParent_Done,
     /* 163523 */   // Label 3152: @163523
     /* 163523 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(163604), // Rule ID 1994 //
     /* 163528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 163536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 163545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 163565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 163574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163582 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 163586 */     // MIs[2] Operand 1
     /* 163586 */     // No operand predicates
     /* 163586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163588 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 163591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163602 */     GIR_RootConstrainSelectedInstOperands,
     /* 163603 */     // GIR_Coverage, 1994,
     /* 163603 */     GIR_EraseRootFromParent_Done,
     /* 163604 */   // Label 3153: @163604
     /* 163604 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(163685), // Rule ID 1995 //
     /* 163609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 163617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163663 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163667 */     // MIs[2] Operand 1
     /* 163667 */     // No operand predicates
     /* 163667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163669 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 163672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163683 */     GIR_RootConstrainSelectedInstOperands,
     /* 163684 */     // GIR_Coverage, 1995,
     /* 163684 */     GIR_EraseRootFromParent_Done,
     /* 163685 */   // Label 3154: @163685
     /* 163685 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(163766), // Rule ID 1996 //
     /* 163690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 163698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 163748 */     // MIs[2] Operand 1
     /* 163748 */     // No operand predicates
     /* 163748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163750 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 163753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163764 */     GIR_RootConstrainSelectedInstOperands,
     /* 163765 */     // GIR_Coverage, 1996,
     /* 163765 */     GIR_EraseRootFromParent_Done,
     /* 163766 */   // Label 3155: @163766
     /* 163766 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(163847), // Rule ID 2023 //
     /* 163771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 163779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163829 */     // MIs[2] Operand 1
     /* 163829 */     // No operand predicates
     /* 163829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163831 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 163834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163845 */     GIR_RootConstrainSelectedInstOperands,
     /* 163846 */     // GIR_Coverage, 2023,
     /* 163846 */     GIR_EraseRootFromParent_Done,
     /* 163847 */   // Label 3156: @163847
     /* 163847 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(163928), // Rule ID 2030 //
     /* 163852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 163860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163910 */     // MIs[2] Operand 1
     /* 163910 */     // No operand predicates
     /* 163910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163912 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 163912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 163915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 163923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 163926 */     GIR_RootConstrainSelectedInstOperands,
     /* 163927 */     // GIR_Coverage, 2030,
     /* 163927 */     GIR_EraseRootFromParent_Done,
     /* 163928 */   // Label 3157: @163928
     /* 163928 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(164006), // Rule ID 6275 //
     /* 163933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 163938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 163963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 163971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 163980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 163988 */     // MIs[2] Operand 1
     /* 163988 */     // No operand predicates
     /* 163988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 163990 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 163990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 163993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 164001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 164004 */     GIR_RootConstrainSelectedInstOperands,
     /* 164005 */     // GIR_Coverage, 6275,
     /* 164005 */     GIR_EraseRootFromParent_Done,
     /* 164006 */   // Label 3158: @164006
     /* 164006 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(164066), // Rule ID 6341 //
     /* 164011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 164037 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 164037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 164040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 164044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164049 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 164052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 164057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 164061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164064 */     GIR_RootConstrainSelectedInstOperands,
     /* 164065 */     // GIR_Coverage, 6341,
     /* 164065 */     GIR_EraseRootFromParent_Done,
     /* 164066 */   // Label 3159: @164066
     /* 164066 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(164126), // Rule ID 6342 //
     /* 164071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 164097 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 164097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 164100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 164104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164109 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 164112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 164117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 164121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164124 */     GIR_RootConstrainSelectedInstOperands,
     /* 164125 */     // GIR_Coverage, 6342,
     /* 164125 */     GIR_EraseRootFromParent_Done,
     /* 164126 */   // Label 3160: @164126
     /* 164126 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(164186), // Rule ID 6343 //
     /* 164131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 164157 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 164157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 164160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 164164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164169 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 164172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 164177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 164181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164184 */     GIR_RootConstrainSelectedInstOperands,
     /* 164185 */     // GIR_Coverage, 6343,
     /* 164185 */     GIR_EraseRootFromParent_Done,
     /* 164186 */   // Label 3161: @164186
     /* 164186 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(164233), // Rule ID 3897 //
     /* 164191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 164194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 164199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164213 */     // MIs[0] Operand 3
     /* 164213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 164224 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 164224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 164227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164231 */     GIR_RootConstrainSelectedInstOperands,
     /* 164232 */     // GIR_Coverage, 3897,
     /* 164232 */     GIR_EraseRootFromParent_Done,
     /* 164233 */   // Label 3162: @164233
     /* 164233 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(164280), // Rule ID 3898 //
     /* 164238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 164241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 164246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164260 */     // MIs[0] Operand 3
     /* 164260 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 164271 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 164271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 164274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164278 */     GIR_RootConstrainSelectedInstOperands,
     /* 164279 */     // GIR_Coverage, 3898,
     /* 164279 */     GIR_EraseRootFromParent_Done,
     /* 164280 */   // Label 3163: @164280
     /* 164280 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(164327), // Rule ID 3899 //
     /* 164285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 164288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 164293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164307 */     // MIs[0] Operand 3
     /* 164307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 164318 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 164318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 164321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164325 */     GIR_RootConstrainSelectedInstOperands,
     /* 164326 */     // GIR_Coverage, 3899,
     /* 164326 */     GIR_EraseRootFromParent_Done,
     /* 164327 */   // Label 3164: @164327
     /* 164327 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(164374), // Rule ID 3900 //
     /* 164332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 164335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 164340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164354 */     // MIs[0] Operand 3
     /* 164354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 164365 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 164365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 164368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164372 */     GIR_RootConstrainSelectedInstOperands,
     /* 164373 */     // GIR_Coverage, 3900,
     /* 164373 */     GIR_EraseRootFromParent_Done,
     /* 164374 */   // Label 3165: @164374
     /* 164374 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(164420), // Rule ID 3544 //
     /* 164379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 164387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 164390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 164397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164401 */     // MIs[0] Idx
     /* 164401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 164409 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 164409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 164412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 164414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 164416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 164418 */     GIR_RootConstrainSelectedInstOperands,
     /* 164419 */     // GIR_Coverage, 3544,
     /* 164419 */     GIR_EraseRootFromParent_Done,
     /* 164420 */   // Label 3166: @164420
     /* 164420 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(164466), // Rule ID 3545 //
     /* 164425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 164433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 164436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 164443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164447 */     // MIs[0] Idx
     /* 164447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 164455 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 164455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 164458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 164460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 164462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 164464 */     GIR_RootConstrainSelectedInstOperands,
     /* 164465 */     // GIR_Coverage, 3545,
     /* 164465 */     GIR_EraseRootFromParent_Done,
     /* 164466 */   // Label 3167: @164466
     /* 164466 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(164512), // Rule ID 3546 //
     /* 164471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 164479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 164482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 164489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164493 */     // MIs[0] Idx
     /* 164493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 164501 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 164501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 164504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 164506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 164508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 164510 */     GIR_RootConstrainSelectedInstOperands,
     /* 164511 */     // GIR_Coverage, 3546,
     /* 164511 */     GIR_EraseRootFromParent_Done,
     /* 164512 */   // Label 3168: @164512
     /* 164512 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(164558), // Rule ID 3547 //
     /* 164517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 164525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 164528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 164535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164539 */     // MIs[0] Idx
     /* 164539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 164547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 164547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 164550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 164552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 164554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 164556 */     GIR_RootConstrainSelectedInstOperands,
     /* 164557 */     // GIR_Coverage, 3547,
     /* 164557 */     GIR_EraseRootFromParent_Done,
     /* 164558 */   // Label 3169: @164558
     /* 164558 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(164614), // Rule ID 2109 //
     /* 164563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 164571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164600 */     // MIs[1] Operand 1
     /* 164600 */     // No operand predicates
     /* 164600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164602 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 164605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164612 */     GIR_RootConstrainSelectedInstOperands,
     /* 164613 */     // GIR_Coverage, 2109,
     /* 164613 */     GIR_EraseRootFromParent_Done,
     /* 164614 */   // Label 3170: @164614
     /* 164614 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(164670), // Rule ID 2110 //
     /* 164619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 164627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164656 */     // MIs[1] Operand 1
     /* 164656 */     // No operand predicates
     /* 164656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164658 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 164661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164668 */     GIR_RootConstrainSelectedInstOperands,
     /* 164669 */     // GIR_Coverage, 2110,
     /* 164669 */     GIR_EraseRootFromParent_Done,
     /* 164670 */   // Label 3171: @164670
     /* 164670 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(164726), // Rule ID 2115 //
     /* 164675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 164683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164712 */     // MIs[1] Operand 1
     /* 164712 */     // No operand predicates
     /* 164712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164714 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 164717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164724 */     GIR_RootConstrainSelectedInstOperands,
     /* 164725 */     // GIR_Coverage, 2115,
     /* 164725 */     GIR_EraseRootFromParent_Done,
     /* 164726 */   // Label 3172: @164726
     /* 164726 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(164782), // Rule ID 2116 //
     /* 164731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 164739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164768 */     // MIs[1] Operand 1
     /* 164768 */     // No operand predicates
     /* 164768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164770 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 164773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164780 */     GIR_RootConstrainSelectedInstOperands,
     /* 164781 */     // GIR_Coverage, 2116,
     /* 164781 */     GIR_EraseRootFromParent_Done,
     /* 164782 */   // Label 3173: @164782
     /* 164782 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(164838), // Rule ID 2123 //
     /* 164787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 164795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164824 */     // MIs[1] Operand 1
     /* 164824 */     // No operand predicates
     /* 164824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164826 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 164829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164836 */     GIR_RootConstrainSelectedInstOperands,
     /* 164837 */     // GIR_Coverage, 2123,
     /* 164837 */     GIR_EraseRootFromParent_Done,
     /* 164838 */   // Label 3174: @164838
     /* 164838 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(164894), // Rule ID 2126 //
     /* 164843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 164851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164880 */     // MIs[1] Operand 1
     /* 164880 */     // No operand predicates
     /* 164880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164882 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 164885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164892 */     GIR_RootConstrainSelectedInstOperands,
     /* 164893 */     // GIR_Coverage, 2126,
     /* 164893 */     GIR_EraseRootFromParent_Done,
     /* 164894 */   // Label 3175: @164894
     /* 164894 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(164950), // Rule ID 2148 //
     /* 164899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 164936 */     // MIs[1] Operand 1
     /* 164936 */     // No operand predicates
     /* 164936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164938 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 164941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164948 */     GIR_RootConstrainSelectedInstOperands,
     /* 164949 */     // GIR_Coverage, 2148,
     /* 164949 */     GIR_EraseRootFromParent_Done,
     /* 164950 */   // Label 3176: @164950
     /* 164950 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(165006), // Rule ID 2150 //
     /* 164955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 164963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 164992 */     // MIs[1] Operand 1
     /* 164992 */     // No operand predicates
     /* 164992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164994 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 164994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 164997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165004 */     GIR_RootConstrainSelectedInstOperands,
     /* 165005 */     // GIR_Coverage, 2150,
     /* 165005 */     GIR_EraseRootFromParent_Done,
     /* 165006 */   // Label 3177: @165006
     /* 165006 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(165062), // Rule ID 2152 //
     /* 165011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 165019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 165048 */     // MIs[1] Operand 1
     /* 165048 */     // No operand predicates
     /* 165048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165050 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 165053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165060 */     GIR_RootConstrainSelectedInstOperands,
     /* 165061 */     // GIR_Coverage, 2152,
     /* 165061 */     GIR_EraseRootFromParent_Done,
     /* 165062 */   // Label 3178: @165062
     /* 165062 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(165115), // Rule ID 6276 //
     /* 165067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 165101 */     // MIs[1] Operand 1
     /* 165101 */     // No operand predicates
     /* 165101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165103 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 165103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 165106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165113 */     GIR_RootConstrainSelectedInstOperands,
     /* 165114 */     // GIR_Coverage, 6276,
     /* 165114 */     GIR_EraseRootFromParent_Done,
     /* 165115 */   // Label 3179: @165115
     /* 165115 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(165168), // Rule ID 6277 //
     /* 165120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 165154 */     // MIs[1] Operand 1
     /* 165154 */     // No operand predicates
     /* 165154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165156 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 165156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 165159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165166 */     GIR_RootConstrainSelectedInstOperands,
     /* 165167 */     // GIR_Coverage, 6277,
     /* 165167 */     GIR_EraseRootFromParent_Done,
     /* 165168 */   // Label 3180: @165168
     /* 165168 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(165221), // Rule ID 6278 //
     /* 165173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165207 */     // MIs[1] Operand 1
     /* 165207 */     // No operand predicates
     /* 165207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165209 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 165212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165219 */     GIR_RootConstrainSelectedInstOperands,
     /* 165220 */     // GIR_Coverage, 6278,
     /* 165220 */     GIR_EraseRootFromParent_Done,
     /* 165221 */   // Label 3181: @165221
     /* 165221 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(165274), // Rule ID 6279 //
     /* 165226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165260 */     // MIs[1] Operand 1
     /* 165260 */     // No operand predicates
     /* 165260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165262 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 165265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165272 */     GIR_RootConstrainSelectedInstOperands,
     /* 165273 */     // GIR_Coverage, 6279,
     /* 165273 */     GIR_EraseRootFromParent_Done,
     /* 165274 */   // Label 3182: @165274
     /* 165274 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(165327), // Rule ID 6280 //
     /* 165279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165313 */     // MIs[1] Operand 1
     /* 165313 */     // No operand predicates
     /* 165313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165315 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 165318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165325 */     GIR_RootConstrainSelectedInstOperands,
     /* 165326 */     // GIR_Coverage, 6280,
     /* 165326 */     GIR_EraseRootFromParent_Done,
     /* 165327 */   // Label 3183: @165327
     /* 165327 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(165380), // Rule ID 6281 //
     /* 165332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165366 */     // MIs[1] Operand 1
     /* 165366 */     // No operand predicates
     /* 165366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165368 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 165371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165378 */     GIR_RootConstrainSelectedInstOperands,
     /* 165379 */     // GIR_Coverage, 6281,
     /* 165379 */     GIR_EraseRootFromParent_Done,
     /* 165380 */   // Label 3184: @165380
     /* 165380 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(165433), // Rule ID 6282 //
     /* 165385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 165419 */     // MIs[1] Operand 1
     /* 165419 */     // No operand predicates
     /* 165419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165421 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 165421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 165424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165431 */     GIR_RootConstrainSelectedInstOperands,
     /* 165432 */     // GIR_Coverage, 6282,
     /* 165432 */     GIR_EraseRootFromParent_Done,
     /* 165433 */   // Label 3185: @165433
     /* 165433 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(165486), // Rule ID 6283 //
     /* 165438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165472 */     // MIs[1] Operand 1
     /* 165472 */     // No operand predicates
     /* 165472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165474 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 165477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165484 */     GIR_RootConstrainSelectedInstOperands,
     /* 165485 */     // GIR_Coverage, 6283,
     /* 165485 */     GIR_EraseRootFromParent_Done,
     /* 165486 */   // Label 3186: @165486
     /* 165486 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(165539), // Rule ID 6284 //
     /* 165491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165525 */     // MIs[1] Operand 1
     /* 165525 */     // No operand predicates
     /* 165525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165527 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 165530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165537 */     GIR_RootConstrainSelectedInstOperands,
     /* 165538 */     // GIR_Coverage, 6284,
     /* 165538 */     GIR_EraseRootFromParent_Done,
     /* 165539 */   // Label 3187: @165539
     /* 165539 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(165592), // Rule ID 6285 //
     /* 165544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165578 */     // MIs[1] Operand 1
     /* 165578 */     // No operand predicates
     /* 165578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165580 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 165583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165590 */     GIR_RootConstrainSelectedInstOperands,
     /* 165591 */     // GIR_Coverage, 6285,
     /* 165591 */     GIR_EraseRootFromParent_Done,
     /* 165592 */   // Label 3188: @165592
     /* 165592 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(165645), // Rule ID 6286 //
     /* 165597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 165631 */     // MIs[1] Operand 1
     /* 165631 */     // No operand predicates
     /* 165631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165633 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 165633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 165636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165643 */     GIR_RootConstrainSelectedInstOperands,
     /* 165644 */     // GIR_Coverage, 6286,
     /* 165644 */     GIR_EraseRootFromParent_Done,
     /* 165645 */   // Label 3189: @165645
     /* 165645 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165698), // Rule ID 6287 //
     /* 165650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 165684 */     // MIs[1] Operand 1
     /* 165684 */     // No operand predicates
     /* 165684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165686 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 165686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 165689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165696 */     GIR_RootConstrainSelectedInstOperands,
     /* 165697 */     // GIR_Coverage, 6287,
     /* 165697 */     GIR_EraseRootFromParent_Done,
     /* 165698 */   // Label 3190: @165698
     /* 165698 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(165780), // Rule ID 6289 //
     /* 165703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 165737 */     // MIs[1] Operand 1
     /* 165737 */     // No operand predicates
     /* 165737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165739 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 165739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 165742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165751 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 165757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 165770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165778 */     GIR_RootConstrainSelectedInstOperands,
     /* 165779 */     // GIR_Coverage, 6289,
     /* 165779 */     GIR_EraseRootFromParent_Done,
     /* 165780 */   // Label 3191: @165780
     /* 165780 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(165862), // Rule ID 6290 //
     /* 165785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 165819 */     // MIs[1] Operand 1
     /* 165819 */     // No operand predicates
     /* 165819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165821 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 165821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 165824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165833 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 165839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 165852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165860 */     GIR_RootConstrainSelectedInstOperands,
     /* 165861 */     // GIR_Coverage, 6290,
     /* 165861 */     GIR_EraseRootFromParent_Done,
     /* 165862 */   // Label 3192: @165862
     /* 165862 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(165944), // Rule ID 6292 //
     /* 165867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 165901 */     // MIs[1] Operand 1
     /* 165901 */     // No operand predicates
     /* 165901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165903 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 165903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 165906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165915 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 165921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 165934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 165939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165942 */     GIR_RootConstrainSelectedInstOperands,
     /* 165943 */     // GIR_Coverage, 6292,
     /* 165943 */     GIR_EraseRootFromParent_Done,
     /* 165944 */   // Label 3193: @165944
     /* 165944 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(166026), // Rule ID 6293 //
     /* 165949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 165983 */     // MIs[1] Operand 1
     /* 165983 */     // No operand predicates
     /* 165983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165985 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 165985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 165988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 165992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 165997 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 166003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 166016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166024 */     GIR_RootConstrainSelectedInstOperands,
     /* 166025 */     // GIR_Coverage, 6293,
     /* 166025 */     GIR_EraseRootFromParent_Done,
     /* 166026 */   // Label 3194: @166026
     /* 166026 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(166132), // Rule ID 6294 //
     /* 166031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 166065 */     // MIs[1] Operand 1
     /* 166065 */     // No operand predicates
     /* 166065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166067 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 166067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 166070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 166074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166079 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 166083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 166086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 166088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 166091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 166105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 166113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 166116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166131 */     // GIR_Coverage, 6294,
     /* 166131 */     GIR_EraseRootFromParent_Done,
     /* 166132 */   // Label 3195: @166132
     /* 166132 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(166238), // Rule ID 6295 //
     /* 166137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 166171 */     // MIs[1] Operand 1
     /* 166171 */     // No operand predicates
     /* 166171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166173 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 166173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 166176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 166180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166185 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 166189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 166192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 166194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 166211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 166219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 166222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166237 */     // GIR_Coverage, 6295,
     /* 166237 */     GIR_EraseRootFromParent_Done,
     /* 166238 */   // Label 3196: @166238
     /* 166238 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(166344), // Rule ID 6296 //
     /* 166243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 166277 */     // MIs[1] Operand 1
     /* 166277 */     // No operand predicates
     /* 166277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166279 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 166279 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 166282 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 166286 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166291 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 166295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 166298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 166300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 166303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 166317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 166325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 166328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166343 */     // GIR_Coverage, 6296,
     /* 166343 */     GIR_EraseRootFromParent_Done,
     /* 166344 */   // Label 3197: @166344
     /* 166344 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(166450), // Rule ID 6297 //
     /* 166349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 166383 */     // MIs[1] Operand 1
     /* 166383 */     // No operand predicates
     /* 166383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166385 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 166385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 166388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 166392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 166401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 166404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 166406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 166423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 166431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 166434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166449 */     // GIR_Coverage, 6297,
     /* 166449 */     GIR_EraseRootFromParent_Done,
     /* 166450 */   // Label 3198: @166450
     /* 166450 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(166508), // Rule ID 6986 //
     /* 166455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 166460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 166469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 166489 */     // MIs[1] Operand 1
     /* 166489 */     // No operand predicates
     /* 166489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166491 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 166491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 166494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166498 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 166503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 166506 */     GIR_RootConstrainSelectedInstOperands,
     /* 166507 */     // GIR_Coverage, 6986,
     /* 166507 */     GIR_EraseRootFromParent_Done,
     /* 166508 */   // Label 3199: @166508
     /* 166508 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(166550), // Rule ID 3045 //
     /* 166513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 166521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166531 */     // MIs[0] Op2
     /* 166531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 166539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 166539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 166542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166548 */     GIR_RootConstrainSelectedInstOperands,
     /* 166549 */     // GIR_Coverage, 3045,
     /* 166549 */     GIR_EraseRootFromParent_Done,
     /* 166550 */   // Label 3200: @166550
     /* 166550 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(166592), // Rule ID 3046 //
     /* 166555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 166563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166573 */     // MIs[0] Op2
     /* 166573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 166581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 166581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 166584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166590 */     GIR_RootConstrainSelectedInstOperands,
     /* 166591 */     // GIR_Coverage, 3046,
     /* 166591 */     GIR_EraseRootFromParent_Done,
     /* 166592 */   // Label 3201: @166592
     /* 166592 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(166634), // Rule ID 3047 //
     /* 166597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 166605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166615 */     // MIs[0] Op2
     /* 166615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 166623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 166623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 166626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166632 */     GIR_RootConstrainSelectedInstOperands,
     /* 166633 */     // GIR_Coverage, 3047,
     /* 166633 */     GIR_EraseRootFromParent_Done,
     /* 166634 */   // Label 3202: @166634
     /* 166634 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(166676), // Rule ID 3081 //
     /* 166639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 166647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166657 */     // MIs[0] Op2
     /* 166657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 166665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 166665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 166668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166674 */     GIR_RootConstrainSelectedInstOperands,
     /* 166675 */     // GIR_Coverage, 3081,
     /* 166675 */     GIR_EraseRootFromParent_Done,
     /* 166676 */   // Label 3203: @166676
     /* 166676 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(166718), // Rule ID 3082 //
     /* 166681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 166689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166699 */     // MIs[0] Op2
     /* 166699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 166707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 166707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 166710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166716 */     GIR_RootConstrainSelectedInstOperands,
     /* 166717 */     // GIR_Coverage, 3082,
     /* 166717 */     GIR_EraseRootFromParent_Done,
     /* 166718 */   // Label 3204: @166718
     /* 166718 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(166760), // Rule ID 3083 //
     /* 166723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 166731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166741 */     // MIs[0] Op2
     /* 166741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 166749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 166749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 166752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166758 */     GIR_RootConstrainSelectedInstOperands,
     /* 166759 */     // GIR_Coverage, 3083,
     /* 166759 */     GIR_EraseRootFromParent_Done,
     /* 166760 */   // Label 3205: @166760
     /* 166760 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(166802), // Rule ID 3530 //
     /* 166765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166783 */     // MIs[0] Op2
     /* 166783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 166791 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1345:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 166791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 166794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166800 */     GIR_RootConstrainSelectedInstOperands,
     /* 166801 */     // GIR_Coverage, 3530,
     /* 166801 */     GIR_EraseRootFromParent_Done,
     /* 166802 */   // Label 3206: @166802
     /* 166802 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(166844), // Rule ID 3531 //
     /* 166807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166825 */     // MIs[0] Op2
     /* 166825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 166833 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1345:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 166833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 166836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166842 */     GIR_RootConstrainSelectedInstOperands,
     /* 166843 */     // GIR_Coverage, 3531,
     /* 166843 */     GIR_EraseRootFromParent_Done,
     /* 166844 */   // Label 3207: @166844
     /* 166844 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(166886), // Rule ID 3532 //
     /* 166849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166867 */     // MIs[0] Op2
     /* 166867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 166875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1345:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 166875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 166878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166884 */     GIR_RootConstrainSelectedInstOperands,
     /* 166885 */     // GIR_Coverage, 3532,
     /* 166885 */     GIR_EraseRootFromParent_Done,
     /* 166886 */   // Label 3208: @166886
     /* 166886 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(166928), // Rule ID 3533 //
     /* 166891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166909 */     // MIs[0] Op2
     /* 166909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166912 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 166917 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1345:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 166917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 166920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166926 */     GIR_RootConstrainSelectedInstOperands,
     /* 166927 */     // GIR_Coverage, 3533,
     /* 166927 */     GIR_EraseRootFromParent_Done,
     /* 166928 */   // Label 3209: @166928
     /* 166928 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(166970), // Rule ID 3534 //
     /* 166933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166951 */     // MIs[0] Op2
     /* 166951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 166959 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1345:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 166959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 166962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166968 */     GIR_RootConstrainSelectedInstOperands,
     /* 166969 */     // GIR_Coverage, 3534,
     /* 166969 */     GIR_EraseRootFromParent_Done,
     /* 166970 */   // Label 3210: @166970
     /* 166970 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(167012), // Rule ID 3535 //
     /* 166975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 166983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166993 */     // MIs[0] Op2
     /* 166993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 167001 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 167001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 167004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167010 */     GIR_RootConstrainSelectedInstOperands,
     /* 167011 */     // GIR_Coverage, 3535,
     /* 167011 */     GIR_EraseRootFromParent_Done,
     /* 167012 */   // Label 3211: @167012
     /* 167012 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(167054), // Rule ID 3536 //
     /* 167017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 167025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 167028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167035 */     // MIs[0] Op2
     /* 167035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 167043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1345:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 167043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 167046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167052 */     GIR_RootConstrainSelectedInstOperands,
     /* 167053 */     // GIR_Coverage, 3536,
     /* 167053 */     GIR_EraseRootFromParent_Done,
     /* 167054 */   // Label 3212: @167054
     /* 167054 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(167096), // Rule ID 11771 //
     /* 167059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 167067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167077 */     // MIs[0] Op2
     /* 167077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 167088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167094 */     GIR_RootConstrainSelectedInstOperands,
     /* 167095 */     // GIR_Coverage, 11771,
     /* 167095 */     GIR_EraseRootFromParent_Done,
     /* 167096 */   // Label 3213: @167096
     /* 167096 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(167138), // Rule ID 11772 //
     /* 167101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 167109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167119 */     // MIs[0] Op2
     /* 167119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167127 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 167130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167136 */     GIR_RootConstrainSelectedInstOperands,
     /* 167137 */     // GIR_Coverage, 11772,
     /* 167137 */     GIR_EraseRootFromParent_Done,
     /* 167138 */   // Label 3214: @167138
     /* 167138 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(167180), // Rule ID 11773 //
     /* 167143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 167151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167161 */     // MIs[0] Op2
     /* 167161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 167172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167178 */     GIR_RootConstrainSelectedInstOperands,
     /* 167179 */     // GIR_Coverage, 11773,
     /* 167179 */     GIR_EraseRootFromParent_Done,
     /* 167180 */   // Label 3215: @167180
     /* 167180 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(167222), // Rule ID 11774 //
     /* 167185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 167193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167203 */     // MIs[0] Op2
     /* 167203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167211 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1718:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 167214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167220 */     GIR_RootConstrainSelectedInstOperands,
     /* 167221 */     // GIR_Coverage, 11774,
     /* 167221 */     GIR_EraseRootFromParent_Done,
     /* 167222 */   // Label 3216: @167222
     /* 167222 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(167264), // Rule ID 11775 //
     /* 167227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 167235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167245 */     // MIs[0] Op2
     /* 167245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167253 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1718:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 167256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167262 */     GIR_RootConstrainSelectedInstOperands,
     /* 167263 */     // GIR_Coverage, 11775,
     /* 167263 */     GIR_EraseRootFromParent_Done,
     /* 167264 */   // Label 3217: @167264
     /* 167264 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(167306), // Rule ID 11776 //
     /* 167269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 167277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167287 */     // MIs[0] Op2
     /* 167287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 167298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167304 */     GIR_RootConstrainSelectedInstOperands,
     /* 167305 */     // GIR_Coverage, 11776,
     /* 167305 */     GIR_EraseRootFromParent_Done,
     /* 167306 */   // Label 3218: @167306
     /* 167306 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(167348), // Rule ID 11778 //
     /* 167311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 167319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167329 */     // MIs[0] Op2
     /* 167329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167337 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 167340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167346 */     GIR_RootConstrainSelectedInstOperands,
     /* 167347 */     // GIR_Coverage, 11778,
     /* 167347 */     GIR_EraseRootFromParent_Done,
     /* 167348 */   // Label 3219: @167348
     /* 167348 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(167390), // Rule ID 11780 //
     /* 167353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 167361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167371 */     // MIs[0] Op2
     /* 167371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 167382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167388 */     GIR_RootConstrainSelectedInstOperands,
     /* 167389 */     // GIR_Coverage, 11780,
     /* 167389 */     GIR_EraseRootFromParent_Done,
     /* 167390 */   // Label 3220: @167390
     /* 167390 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(167432), // Rule ID 11782 //
     /* 167395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 167403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167413 */     // MIs[0] Op2
     /* 167413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167421 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 167424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167430 */     GIR_RootConstrainSelectedInstOperands,
     /* 167431 */     // GIR_Coverage, 11782,
     /* 167431 */     GIR_EraseRootFromParent_Done,
     /* 167432 */   // Label 3221: @167432
     /* 167432 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(167474), // Rule ID 11783 //
     /* 167437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 167445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167455 */     // MIs[0] Op2
     /* 167455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167463 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 167466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167472 */     GIR_RootConstrainSelectedInstOperands,
     /* 167473 */     // GIR_Coverage, 11783,
     /* 167473 */     GIR_EraseRootFromParent_Done,
     /* 167474 */   // Label 3222: @167474
     /* 167474 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(167516), // Rule ID 11784 //
     /* 167479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 167487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167497 */     // MIs[0] Op2
     /* 167497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167505 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 167508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167514 */     GIR_RootConstrainSelectedInstOperands,
     /* 167515 */     // GIR_Coverage, 11784,
     /* 167515 */     GIR_EraseRootFromParent_Done,
     /* 167516 */   // Label 3223: @167516
     /* 167516 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(167558), // Rule ID 11785 //
     /* 167521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 167529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167539 */     // MIs[0] Op2
     /* 167539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 167550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167556 */     GIR_RootConstrainSelectedInstOperands,
     /* 167557 */     // GIR_Coverage, 11785,
     /* 167557 */     GIR_EraseRootFromParent_Done,
     /* 167558 */   // Label 3224: @167558
     /* 167558 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(167600), // Rule ID 11786 //
     /* 167563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 167571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167581 */     // MIs[0] Op2
     /* 167581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167589 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 167592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167598 */     GIR_RootConstrainSelectedInstOperands,
     /* 167599 */     // GIR_Coverage, 11786,
     /* 167599 */     GIR_EraseRootFromParent_Done,
     /* 167600 */   // Label 3225: @167600
     /* 167600 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(167642), // Rule ID 11787 //
     /* 167605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 167613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167623 */     // MIs[0] Op2
     /* 167623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 167634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167640 */     GIR_RootConstrainSelectedInstOperands,
     /* 167641 */     // GIR_Coverage, 11787,
     /* 167641 */     GIR_EraseRootFromParent_Done,
     /* 167642 */   // Label 3226: @167642
     /* 167642 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(167684), // Rule ID 11788 //
     /* 167647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 167655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167665 */     // MIs[0] Op2
     /* 167665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 167676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167682 */     GIR_RootConstrainSelectedInstOperands,
     /* 167683 */     // GIR_Coverage, 11788,
     /* 167683 */     GIR_EraseRootFromParent_Done,
     /* 167684 */   // Label 3227: @167684
     /* 167684 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(167726), // Rule ID 11789 //
     /* 167689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 167697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167707 */     // MIs[0] Op2
     /* 167707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167715 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2038:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 167718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167724 */     GIR_RootConstrainSelectedInstOperands,
     /* 167725 */     // GIR_Coverage, 11789,
     /* 167725 */     GIR_EraseRootFromParent_Done,
     /* 167726 */   // Label 3228: @167726
     /* 167726 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(167768), // Rule ID 11790 //
     /* 167731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 167739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167749 */     // MIs[0] Op2
     /* 167749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167757 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2038:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 167760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167766 */     GIR_RootConstrainSelectedInstOperands,
     /* 167767 */     // GIR_Coverage, 11790,
     /* 167767 */     GIR_EraseRootFromParent_Done,
     /* 167768 */   // Label 3229: @167768
     /* 167768 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(167810), // Rule ID 11791 //
     /* 167773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 167781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167791 */     // MIs[0] Op2
     /* 167791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2038:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 167802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167808 */     GIR_RootConstrainSelectedInstOperands,
     /* 167809 */     // GIR_Coverage, 11791,
     /* 167809 */     GIR_EraseRootFromParent_Done,
     /* 167810 */   // Label 3230: @167810
     /* 167810 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(167852), // Rule ID 11792 //
     /* 167815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 167823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167833 */     // MIs[0] Op2
     /* 167833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 167841 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2035:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 167841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 167844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167850 */     GIR_RootConstrainSelectedInstOperands,
     /* 167851 */     // GIR_Coverage, 11792,
     /* 167851 */     GIR_EraseRootFromParent_Done,
     /* 167852 */   // Label 3231: @167852
     /* 167852 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(167894), // Rule ID 11793 //
     /* 167857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 167865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167875 */     // MIs[0] Op2
     /* 167875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 167883 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2035:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 167883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 167886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167892 */     GIR_RootConstrainSelectedInstOperands,
     /* 167893 */     // GIR_Coverage, 11793,
     /* 167893 */     GIR_EraseRootFromParent_Done,
     /* 167894 */   // Label 3232: @167894
     /* 167894 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(167936), // Rule ID 11794 //
     /* 167899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 167907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167917 */     // MIs[0] Op2
     /* 167917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 167925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2035:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 167925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 167928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167934 */     GIR_RootConstrainSelectedInstOperands,
     /* 167935 */     // GIR_Coverage, 11794,
     /* 167935 */     GIR_EraseRootFromParent_Done,
     /* 167936 */   // Label 3233: @167936
     /* 167936 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(167978), // Rule ID 11852 //
     /* 167941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 167949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 167955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167959 */     // MIs[0] Op2
     /* 167959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 167962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 167967 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 167967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 167970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 167974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 167976 */     GIR_RootConstrainSelectedInstOperands,
     /* 167977 */     // GIR_Coverage, 11852,
     /* 167977 */     GIR_EraseRootFromParent_Done,
     /* 167978 */   // Label 3234: @167978
     /* 167978 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(168020), // Rule ID 11853 //
     /* 167983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 167986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 167991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168001 */     // MIs[0] Op2
     /* 168001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 168009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 168009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 168012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168018 */     GIR_RootConstrainSelectedInstOperands,
     /* 168019 */     // GIR_Coverage, 11853,
     /* 168019 */     GIR_EraseRootFromParent_Done,
     /* 168020 */   // Label 3235: @168020
     /* 168020 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(168062), // Rule ID 11854 //
     /* 168025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 168033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 168036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 168039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168043 */     // MIs[0] Op2
     /* 168043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 168051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 168051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 168054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168060 */     GIR_RootConstrainSelectedInstOperands,
     /* 168061 */     // GIR_Coverage, 11854,
     /* 168061 */     GIR_EraseRootFromParent_Done,
     /* 168062 */   // Label 3236: @168062
     /* 168062 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(168104), // Rule ID 11855 //
     /* 168067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 168075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 168078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 168081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168085 */     // MIs[0] Op2
     /* 168085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 168093 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 168093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 168096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168102 */     GIR_RootConstrainSelectedInstOperands,
     /* 168103 */     // GIR_Coverage, 11855,
     /* 168103 */     GIR_EraseRootFromParent_Done,
     /* 168104 */   // Label 3237: @168104
     /* 168104 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(168146), // Rule ID 11856 //
     /* 168109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 168117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 168120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 168123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168127 */     // MIs[0] Op2
     /* 168127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 168135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 168135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 168138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168144 */     GIR_RootConstrainSelectedInstOperands,
     /* 168145 */     // GIR_Coverage, 11856,
     /* 168145 */     GIR_EraseRootFromParent_Done,
     /* 168146 */   // Label 3238: @168146
     /* 168146 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(168188), // Rule ID 11857 //
     /* 168151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 168159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 168162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 168165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168169 */     // MIs[0] Op2
     /* 168169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 168177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 168177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 168180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168186 */     GIR_RootConstrainSelectedInstOperands,
     /* 168187 */     // GIR_Coverage, 11857,
     /* 168187 */     GIR_EraseRootFromParent_Done,
     /* 168188 */   // Label 3239: @168188
     /* 168188 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(168230), // Rule ID 11858 //
     /* 168193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 168201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 168204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 168207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168211 */     // MIs[0] Op2
     /* 168211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 168219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2059:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 168219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 168222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168228 */     GIR_RootConstrainSelectedInstOperands,
     /* 168229 */     // GIR_Coverage, 11858,
     /* 168229 */     GIR_EraseRootFromParent_Done,
     /* 168230 */   // Label 3240: @168230
     /* 168230 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(168272), // Rule ID 11859 //
     /* 168235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 168243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 168246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 168249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168253 */     // MIs[0] Op2
     /* 168253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 168261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2059:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 168261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 168264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168270 */     GIR_RootConstrainSelectedInstOperands,
     /* 168271 */     // GIR_Coverage, 11859,
     /* 168271 */     GIR_EraseRootFromParent_Done,
     /* 168272 */   // Label 3241: @168272
     /* 168272 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(168314), // Rule ID 11860 //
     /* 168277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 168280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 168285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 168288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 168291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168295 */     // MIs[0] Op2
     /* 168295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 168298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 168303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2059:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 168303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 168306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 168310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 168312 */     GIR_RootConstrainSelectedInstOperands,
     /* 168313 */     // GIR_Coverage, 11860,
     /* 168313 */     GIR_EraseRootFromParent_Done,
     /* 168314 */   // Label 3242: @168314
     /* 168314 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(168366), // Rule ID 2132 //
     /* 168319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168352 */     // MIs[1] Operand 1
     /* 168352 */     // No operand predicates
     /* 168352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168354 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 168357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168364 */     GIR_RootConstrainSelectedInstOperands,
     /* 168365 */     // GIR_Coverage, 2132,
     /* 168365 */     GIR_EraseRootFromParent_Done,
     /* 168366 */   // Label 3243: @168366
     /* 168366 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(168418), // Rule ID 2133 //
     /* 168371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168404 */     // MIs[1] Operand 1
     /* 168404 */     // No operand predicates
     /* 168404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168406 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 168409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168416 */     GIR_RootConstrainSelectedInstOperands,
     /* 168417 */     // GIR_Coverage, 2133,
     /* 168417 */     GIR_EraseRootFromParent_Done,
     /* 168418 */   // Label 3244: @168418
     /* 168418 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(168470), // Rule ID 2134 //
     /* 168423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168456 */     // MIs[1] Operand 1
     /* 168456 */     // No operand predicates
     /* 168456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168458 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 168461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168468 */     GIR_RootConstrainSelectedInstOperands,
     /* 168469 */     // GIR_Coverage, 2134,
     /* 168469 */     GIR_EraseRootFromParent_Done,
     /* 168470 */   // Label 3245: @168470
     /* 168470 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(168522), // Rule ID 2135 //
     /* 168475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168508 */     // MIs[1] Operand 1
     /* 168508 */     // No operand predicates
     /* 168508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168510 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 168513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168520 */     GIR_RootConstrainSelectedInstOperands,
     /* 168521 */     // GIR_Coverage, 2135,
     /* 168521 */     GIR_EraseRootFromParent_Done,
     /* 168522 */   // Label 3246: @168522
     /* 168522 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(168574), // Rule ID 2136 //
     /* 168527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 168535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168560 */     // MIs[1] Operand 1
     /* 168560 */     // No operand predicates
     /* 168560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168562 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 168565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168572 */     GIR_RootConstrainSelectedInstOperands,
     /* 168573 */     // GIR_Coverage, 2136,
     /* 168573 */     GIR_EraseRootFromParent_Done,
     /* 168574 */   // Label 3247: @168574
     /* 168574 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(168626), // Rule ID 2137 //
     /* 168579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168612 */     // MIs[1] Operand 1
     /* 168612 */     // No operand predicates
     /* 168612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168614 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 168617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168624 */     GIR_RootConstrainSelectedInstOperands,
     /* 168625 */     // GIR_Coverage, 2137,
     /* 168625 */     GIR_EraseRootFromParent_Done,
     /* 168626 */   // Label 3248: @168626
     /* 168626 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(168678), // Rule ID 2138 //
     /* 168631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168664 */     // MIs[1] Operand 1
     /* 168664 */     // No operand predicates
     /* 168664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168666 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 168669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168676 */     GIR_RootConstrainSelectedInstOperands,
     /* 168677 */     // GIR_Coverage, 2138,
     /* 168677 */     GIR_EraseRootFromParent_Done,
     /* 168678 */   // Label 3249: @168678
     /* 168678 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(168730), // Rule ID 2139 //
     /* 168683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168716 */     // MIs[1] Operand 1
     /* 168716 */     // No operand predicates
     /* 168716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168718 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 168721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168728 */     GIR_RootConstrainSelectedInstOperands,
     /* 168729 */     // GIR_Coverage, 2139,
     /* 168729 */     GIR_EraseRootFromParent_Done,
     /* 168730 */   // Label 3250: @168730
     /* 168730 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(168782), // Rule ID 2140 //
     /* 168735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168768 */     // MIs[1] Operand 1
     /* 168768 */     // No operand predicates
     /* 168768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168770 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 168773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168780 */     GIR_RootConstrainSelectedInstOperands,
     /* 168781 */     // GIR_Coverage, 2140,
     /* 168781 */     GIR_EraseRootFromParent_Done,
     /* 168782 */   // Label 3251: @168782
     /* 168782 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(168834), // Rule ID 2141 //
     /* 168787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 168795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168820 */     // MIs[1] Operand 1
     /* 168820 */     // No operand predicates
     /* 168820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168822 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 168825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168832 */     GIR_RootConstrainSelectedInstOperands,
     /* 168833 */     // GIR_Coverage, 2141,
     /* 168833 */     GIR_EraseRootFromParent_Done,
     /* 168834 */   // Label 3252: @168834
     /* 168834 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(168886), // Rule ID 2142 //
     /* 168839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 168847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168872 */     // MIs[1] Operand 1
     /* 168872 */     // No operand predicates
     /* 168872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168874 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 168877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168884 */     GIR_RootConstrainSelectedInstOperands,
     /* 168885 */     // GIR_Coverage, 2142,
     /* 168885 */     GIR_EraseRootFromParent_Done,
     /* 168886 */   // Label 3253: @168886
     /* 168886 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(168938), // Rule ID 2143 //
     /* 168891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 168899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168924 */     // MIs[1] Operand 1
     /* 168924 */     // No operand predicates
     /* 168924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168926 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 168929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168936 */     GIR_RootConstrainSelectedInstOperands,
     /* 168937 */     // GIR_Coverage, 2143,
     /* 168937 */     GIR_EraseRootFromParent_Done,
     /* 168938 */   // Label 3254: @168938
     /* 168938 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(168990), // Rule ID 2144 //
     /* 168943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 168951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 168976 */     // MIs[1] Operand 1
     /* 168976 */     // No operand predicates
     /* 168976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168978 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 168978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 168981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 168988 */     GIR_RootConstrainSelectedInstOperands,
     /* 168989 */     // GIR_Coverage, 2144,
     /* 168989 */     GIR_EraseRootFromParent_Done,
     /* 168990 */   // Label 3255: @168990
     /* 168990 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(169042), // Rule ID 2145 //
     /* 168995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 169003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169028 */     // MIs[1] Operand 1
     /* 169028 */     // No operand predicates
     /* 169028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169030 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 169033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169040 */     GIR_RootConstrainSelectedInstOperands,
     /* 169041 */     // GIR_Coverage, 2145,
     /* 169041 */     GIR_EraseRootFromParent_Done,
     /* 169042 */   // Label 3256: @169042
     /* 169042 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(169094), // Rule ID 2146 //
     /* 169047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 169055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169080 */     // MIs[1] Operand 1
     /* 169080 */     // No operand predicates
     /* 169080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169082 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 169085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169092 */     GIR_RootConstrainSelectedInstOperands,
     /* 169093 */     // GIR_Coverage, 2146,
     /* 169093 */     GIR_EraseRootFromParent_Done,
     /* 169094 */   // Label 3257: @169094
     /* 169094 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(169146), // Rule ID 2244 //
     /* 169099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169132 */     // MIs[1] Operand 1
     /* 169132 */     // No operand predicates
     /* 169132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169134 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 169137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169144 */     GIR_RootConstrainSelectedInstOperands,
     /* 169145 */     // GIR_Coverage, 2244,
     /* 169145 */     GIR_EraseRootFromParent_Done,
     /* 169146 */   // Label 3258: @169146
     /* 169146 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(169198), // Rule ID 2245 //
     /* 169151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169184 */     // MIs[1] Operand 1
     /* 169184 */     // No operand predicates
     /* 169184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169186 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 169189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169196 */     GIR_RootConstrainSelectedInstOperands,
     /* 169197 */     // GIR_Coverage, 2245,
     /* 169197 */     GIR_EraseRootFromParent_Done,
     /* 169198 */   // Label 3259: @169198
     /* 169198 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(169250), // Rule ID 2246 //
     /* 169203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169236 */     // MIs[1] Operand 1
     /* 169236 */     // No operand predicates
     /* 169236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169238 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 169241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169248 */     GIR_RootConstrainSelectedInstOperands,
     /* 169249 */     // GIR_Coverage, 2246,
     /* 169249 */     GIR_EraseRootFromParent_Done,
     /* 169250 */   // Label 3260: @169250
     /* 169250 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(169302), // Rule ID 2247 //
     /* 169255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169288 */     // MIs[1] Operand 1
     /* 169288 */     // No operand predicates
     /* 169288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169290 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 169293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169300 */     GIR_RootConstrainSelectedInstOperands,
     /* 169301 */     // GIR_Coverage, 2247,
     /* 169301 */     GIR_EraseRootFromParent_Done,
     /* 169302 */   // Label 3261: @169302
     /* 169302 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(169354), // Rule ID 2248 //
     /* 169307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 169315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 169340 */     // MIs[1] Operand 1
     /* 169340 */     // No operand predicates
     /* 169340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169342 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 169342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 169345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 169352 */     GIR_RootConstrainSelectedInstOperands,
     /* 169353 */     // GIR_Coverage, 2248,
     /* 169353 */     GIR_EraseRootFromParent_Done,
     /* 169354 */   // Label 3262: @169354
     /* 169354 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(169399), // Rule ID 63 //
     /* 169359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 169362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 169367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 169376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 169380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 169384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 169388 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 169388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 169391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169397 */     GIR_RootConstrainSelectedInstOperands,
     /* 169398 */     // GIR_Coverage, 63,
     /* 169398 */     GIR_EraseRootFromParent_Done,
     /* 169399 */   // Label 3263: @169399
     /* 169399 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(169444), // Rule ID 129 //
     /* 169404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 169412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169433 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 169436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169442 */     GIR_RootConstrainSelectedInstOperands,
     /* 169443 */     // GIR_Coverage, 129,
     /* 169443 */     GIR_EraseRootFromParent_Done,
     /* 169444 */   // Label 3264: @169444
     /* 169444 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(169489), // Rule ID 130 //
     /* 169449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 169457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169478 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 169481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169487 */     GIR_RootConstrainSelectedInstOperands,
     /* 169488 */     // GIR_Coverage, 130,
     /* 169488 */     GIR_EraseRootFromParent_Done,
     /* 169489 */   // Label 3265: @169489
     /* 169489 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(169534), // Rule ID 131 //
     /* 169494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 169502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169523 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 169526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169532 */     GIR_RootConstrainSelectedInstOperands,
     /* 169533 */     // GIR_Coverage, 131,
     /* 169533 */     GIR_EraseRootFromParent_Done,
     /* 169534 */   // Label 3266: @169534
     /* 169534 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(169579), // Rule ID 132 //
     /* 169539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 169547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 169556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 169568 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 169568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 169571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169577 */     GIR_RootConstrainSelectedInstOperands,
     /* 169578 */     // GIR_Coverage, 132,
     /* 169578 */     GIR_EraseRootFromParent_Done,
     /* 169579 */   // Label 3267: @169579
     /* 169579 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(169624), // Rule ID 133 //
     /* 169584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 169592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169613 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 169616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169622 */     GIR_RootConstrainSelectedInstOperands,
     /* 169623 */     // GIR_Coverage, 133,
     /* 169623 */     GIR_EraseRootFromParent_Done,
     /* 169624 */   // Label 3268: @169624
     /* 169624 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(169669), // Rule ID 134 //
     /* 169629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 169637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169658 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 169661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169667 */     GIR_RootConstrainSelectedInstOperands,
     /* 169668 */     // GIR_Coverage, 134,
     /* 169668 */     GIR_EraseRootFromParent_Done,
     /* 169669 */   // Label 3269: @169669
     /* 169669 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(169714), // Rule ID 135 //
     /* 169674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 169682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 169691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169703 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 169703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 169706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169712 */     GIR_RootConstrainSelectedInstOperands,
     /* 169713 */     // GIR_Coverage, 135,
     /* 169713 */     GIR_EraseRootFromParent_Done,
     /* 169714 */   // Label 3270: @169714
     /* 169714 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(169759), // Rule ID 136 //
     /* 169719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 169722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 169727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 169736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 169744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 169748 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 169748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 169751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169757 */     GIR_RootConstrainSelectedInstOperands,
     /* 169758 */     // GIR_Coverage, 136,
     /* 169758 */     GIR_EraseRootFromParent_Done,
     /* 169759 */   // Label 3271: @169759
     /* 169759 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(169804), // Rule ID 1042 //
     /* 169764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169793 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 169793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 169796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169802 */     GIR_RootConstrainSelectedInstOperands,
     /* 169803 */     // GIR_Coverage, 1042,
     /* 169803 */     GIR_EraseRootFromParent_Done,
     /* 169804 */   // Label 3272: @169804
     /* 169804 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(169849), // Rule ID 1043 //
     /* 169809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169838 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 169838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 169841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169847 */     GIR_RootConstrainSelectedInstOperands,
     /* 169848 */     // GIR_Coverage, 1043,
     /* 169848 */     GIR_EraseRootFromParent_Done,
     /* 169849 */   // Label 3273: @169849
     /* 169849 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(169894), // Rule ID 1044 //
     /* 169854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169883 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 169883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 169886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169892 */     GIR_RootConstrainSelectedInstOperands,
     /* 169893 */     // GIR_Coverage, 1044,
     /* 169893 */     GIR_EraseRootFromParent_Done,
     /* 169894 */   // Label 3274: @169894
     /* 169894 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(169939), // Rule ID 1045 //
     /* 169899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169928 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 169928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 169931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169937 */     GIR_RootConstrainSelectedInstOperands,
     /* 169938 */     // GIR_Coverage, 1045,
     /* 169938 */     GIR_EraseRootFromParent_Done,
     /* 169939 */   // Label 3275: @169939
     /* 169939 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(169984), // Rule ID 1046 //
     /* 169944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169973 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 169973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 169976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 169980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 169982 */     GIR_RootConstrainSelectedInstOperands,
     /* 169983 */     // GIR_Coverage, 1046,
     /* 169983 */     GIR_EraseRootFromParent_Done,
     /* 169984 */   // Label 3276: @169984
     /* 169984 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(170029), // Rule ID 1047 //
     /* 169989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 169997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 170018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 170021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170027 */     GIR_RootConstrainSelectedInstOperands,
     /* 170028 */     // GIR_Coverage, 1047,
     /* 170028 */     GIR_EraseRootFromParent_Done,
     /* 170029 */   // Label 3277: @170029
     /* 170029 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(170074), // Rule ID 1048 //
     /* 170034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 170042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170063 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 170063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 170066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170072 */     GIR_RootConstrainSelectedInstOperands,
     /* 170073 */     // GIR_Coverage, 1048,
     /* 170073 */     GIR_EraseRootFromParent_Done,
     /* 170074 */   // Label 3278: @170074
     /* 170074 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(170119), // Rule ID 1090 //
     /* 170079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170108 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 170108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 170111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170117 */     GIR_RootConstrainSelectedInstOperands,
     /* 170118 */     // GIR_Coverage, 1090,
     /* 170118 */     GIR_EraseRootFromParent_Done,
     /* 170119 */   // Label 3279: @170119
     /* 170119 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(170164), // Rule ID 1091 //
     /* 170124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170153 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 170153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 170156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170162 */     GIR_RootConstrainSelectedInstOperands,
     /* 170163 */     // GIR_Coverage, 1091,
     /* 170163 */     GIR_EraseRootFromParent_Done,
     /* 170164 */   // Label 3280: @170164
     /* 170164 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(170209), // Rule ID 1092 //
     /* 170169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170198 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 170198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 170201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170207 */     GIR_RootConstrainSelectedInstOperands,
     /* 170208 */     // GIR_Coverage, 1092,
     /* 170208 */     GIR_EraseRootFromParent_Done,
     /* 170209 */   // Label 3281: @170209
     /* 170209 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(170254), // Rule ID 1093 //
     /* 170214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170243 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 170243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 170246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170252 */     GIR_RootConstrainSelectedInstOperands,
     /* 170253 */     // GIR_Coverage, 1093,
     /* 170253 */     GIR_EraseRootFromParent_Done,
     /* 170254 */   // Label 3282: @170254
     /* 170254 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(170299), // Rule ID 1094 //
     /* 170259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170288 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 170288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 170291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170297 */     GIR_RootConstrainSelectedInstOperands,
     /* 170298 */     // GIR_Coverage, 1094,
     /* 170298 */     GIR_EraseRootFromParent_Done,
     /* 170299 */   // Label 3283: @170299
     /* 170299 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(170344), // Rule ID 1095 //
     /* 170304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170333 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 170333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 170336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170342 */     GIR_RootConstrainSelectedInstOperands,
     /* 170343 */     // GIR_Coverage, 1095,
     /* 170343 */     GIR_EraseRootFromParent_Done,
     /* 170344 */   // Label 3284: @170344
     /* 170344 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(170389), // Rule ID 1096 //
     /* 170349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 170357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170378 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 170378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 170381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 170385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 170387 */     GIR_RootConstrainSelectedInstOperands,
     /* 170388 */     // GIR_Coverage, 1096,
     /* 170388 */     GIR_EraseRootFromParent_Done,
     /* 170389 */   // Label 3285: @170389
     /* 170389 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(170434), // Rule ID 1108 //
     /* 170394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170423 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 170426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170432 */     GIR_RootConstrainSelectedInstOperands,
     /* 170433 */     // GIR_Coverage, 1108,
     /* 170433 */     GIR_EraseRootFromParent_Done,
     /* 170434 */   // Label 3286: @170434
     /* 170434 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(170479), // Rule ID 1110 //
     /* 170439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170468 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 170471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170477 */     GIR_RootConstrainSelectedInstOperands,
     /* 170478 */     // GIR_Coverage, 1110,
     /* 170478 */     GIR_EraseRootFromParent_Done,
     /* 170479 */   // Label 3287: @170479
     /* 170479 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(170524), // Rule ID 1112 //
     /* 170484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170513 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 170516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170522 */     GIR_RootConstrainSelectedInstOperands,
     /* 170523 */     // GIR_Coverage, 1112,
     /* 170523 */     GIR_EraseRootFromParent_Done,
     /* 170524 */   // Label 3288: @170524
     /* 170524 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(170569), // Rule ID 1114 //
     /* 170529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170558 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 170561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170567 */     GIR_RootConstrainSelectedInstOperands,
     /* 170568 */     // GIR_Coverage, 1114,
     /* 170568 */     GIR_EraseRootFromParent_Done,
     /* 170569 */   // Label 3289: @170569
     /* 170569 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(170614), // Rule ID 1116 //
     /* 170574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170603 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 170606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170612 */     GIR_RootConstrainSelectedInstOperands,
     /* 170613 */     // GIR_Coverage, 1116,
     /* 170613 */     GIR_EraseRootFromParent_Done,
     /* 170614 */   // Label 3290: @170614
     /* 170614 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(170659), // Rule ID 1118 //
     /* 170619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170648 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 170651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170657 */     GIR_RootConstrainSelectedInstOperands,
     /* 170658 */     // GIR_Coverage, 1118,
     /* 170658 */     GIR_EraseRootFromParent_Done,
     /* 170659 */   // Label 3291: @170659
     /* 170659 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(170704), // Rule ID 1120 //
     /* 170664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 170672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170693 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 170696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170702 */     GIR_RootConstrainSelectedInstOperands,
     /* 170703 */     // GIR_Coverage, 1120,
     /* 170703 */     GIR_EraseRootFromParent_Done,
     /* 170704 */   // Label 3292: @170704
     /* 170704 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(170749), // Rule ID 1163 //
     /* 170709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170738 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 170741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170747 */     GIR_RootConstrainSelectedInstOperands,
     /* 170748 */     // GIR_Coverage, 1163,
     /* 170748 */     GIR_EraseRootFromParent_Done,
     /* 170749 */   // Label 3293: @170749
     /* 170749 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(170794), // Rule ID 1164 //
     /* 170754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170783 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 170786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170792 */     GIR_RootConstrainSelectedInstOperands,
     /* 170793 */     // GIR_Coverage, 1164,
     /* 170793 */     GIR_EraseRootFromParent_Done,
     /* 170794 */   // Label 3294: @170794
     /* 170794 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(170839), // Rule ID 1165 //
     /* 170799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170828 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 170831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170837 */     GIR_RootConstrainSelectedInstOperands,
     /* 170838 */     // GIR_Coverage, 1165,
     /* 170838 */     GIR_EraseRootFromParent_Done,
     /* 170839 */   // Label 3295: @170839
     /* 170839 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(170884), // Rule ID 1166 //
     /* 170844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170873 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 170876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170882 */     GIR_RootConstrainSelectedInstOperands,
     /* 170883 */     // GIR_Coverage, 1166,
     /* 170883 */     GIR_EraseRootFromParent_Done,
     /* 170884 */   // Label 3296: @170884
     /* 170884 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(170929), // Rule ID 1167 //
     /* 170889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 170897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170918 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 170921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170927 */     GIR_RootConstrainSelectedInstOperands,
     /* 170928 */     // GIR_Coverage, 1167,
     /* 170928 */     GIR_EraseRootFromParent_Done,
     /* 170929 */   // Label 3297: @170929
     /* 170929 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(170974), // Rule ID 1169 //
     /* 170934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 170942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170963 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 170966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170972 */     GIR_RootConstrainSelectedInstOperands,
     /* 170973 */     // GIR_Coverage, 1169,
     /* 170973 */     GIR_EraseRootFromParent_Done,
     /* 170974 */   // Label 3298: @170974
     /* 170974 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(171019), // Rule ID 1171 //
     /* 170979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 170987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171008 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 171011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171017 */     GIR_RootConstrainSelectedInstOperands,
     /* 171018 */     // GIR_Coverage, 1171,
     /* 171018 */     GIR_EraseRootFromParent_Done,
     /* 171019 */   // Label 3299: @171019
     /* 171019 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(171064), // Rule ID 1173 //
     /* 171024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171053 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 171056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171062 */     GIR_RootConstrainSelectedInstOperands,
     /* 171063 */     // GIR_Coverage, 1173,
     /* 171063 */     GIR_EraseRootFromParent_Done,
     /* 171064 */   // Label 3300: @171064
     /* 171064 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(171109), // Rule ID 1175 //
     /* 171069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171098 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 171101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171107 */     GIR_RootConstrainSelectedInstOperands,
     /* 171108 */     // GIR_Coverage, 1175,
     /* 171108 */     GIR_EraseRootFromParent_Done,
     /* 171109 */   // Label 3301: @171109
     /* 171109 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(171154), // Rule ID 1177 //
     /* 171114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171143 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 171146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171152 */     GIR_RootConstrainSelectedInstOperands,
     /* 171153 */     // GIR_Coverage, 1177,
     /* 171153 */     GIR_EraseRootFromParent_Done,
     /* 171154 */   // Label 3302: @171154
     /* 171154 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(171199), // Rule ID 1179 //
     /* 171159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171188 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 171191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171197 */     GIR_RootConstrainSelectedInstOperands,
     /* 171198 */     // GIR_Coverage, 1179,
     /* 171198 */     GIR_EraseRootFromParent_Done,
     /* 171199 */   // Label 3303: @171199
     /* 171199 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(171244), // Rule ID 1181 //
     /* 171204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171233 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 171236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171242 */     GIR_RootConstrainSelectedInstOperands,
     /* 171243 */     // GIR_Coverage, 1181,
     /* 171243 */     GIR_EraseRootFromParent_Done,
     /* 171244 */   // Label 3304: @171244
     /* 171244 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(171289), // Rule ID 1183 //
     /* 171249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171278 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 171281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171287 */     GIR_RootConstrainSelectedInstOperands,
     /* 171288 */     // GIR_Coverage, 1183,
     /* 171288 */     GIR_EraseRootFromParent_Done,
     /* 171289 */   // Label 3305: @171289
     /* 171289 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(171334), // Rule ID 1185 //
     /* 171294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171323 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 171326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171332 */     GIR_RootConstrainSelectedInstOperands,
     /* 171333 */     // GIR_Coverage, 1185,
     /* 171333 */     GIR_EraseRootFromParent_Done,
     /* 171334 */   // Label 3306: @171334
     /* 171334 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(171379), // Rule ID 1187 //
     /* 171339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171368 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 171371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171377 */     GIR_RootConstrainSelectedInstOperands,
     /* 171378 */     // GIR_Coverage, 1187,
     /* 171378 */     GIR_EraseRootFromParent_Done,
     /* 171379 */   // Label 3307: @171379
     /* 171379 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(171424), // Rule ID 1189 //
     /* 171384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171413 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 171416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171422 */     GIR_RootConstrainSelectedInstOperands,
     /* 171423 */     // GIR_Coverage, 1189,
     /* 171423 */     GIR_EraseRootFromParent_Done,
     /* 171424 */   // Label 3308: @171424
     /* 171424 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(171469), // Rule ID 1191 //
     /* 171429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171458 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 171461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171467 */     GIR_RootConstrainSelectedInstOperands,
     /* 171468 */     // GIR_Coverage, 1191,
     /* 171468 */     GIR_EraseRootFromParent_Done,
     /* 171469 */   // Label 3309: @171469
     /* 171469 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(171514), // Rule ID 1193 //
     /* 171474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171503 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 171506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171512 */     GIR_RootConstrainSelectedInstOperands,
     /* 171513 */     // GIR_Coverage, 1193,
     /* 171513 */     GIR_EraseRootFromParent_Done,
     /* 171514 */   // Label 3310: @171514
     /* 171514 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(171559), // Rule ID 1195 //
     /* 171519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171548 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 171551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171557 */     GIR_RootConstrainSelectedInstOperands,
     /* 171558 */     // GIR_Coverage, 1195,
     /* 171558 */     GIR_EraseRootFromParent_Done,
     /* 171559 */   // Label 3311: @171559
     /* 171559 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(171604), // Rule ID 1197 //
     /* 171564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 171572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171593 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 171596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171602 */     GIR_RootConstrainSelectedInstOperands,
     /* 171603 */     // GIR_Coverage, 1197,
     /* 171603 */     GIR_EraseRootFromParent_Done,
     /* 171604 */   // Label 3312: @171604
     /* 171604 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(171649), // Rule ID 1233 //
     /* 171609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171638 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 171641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171647 */     GIR_RootConstrainSelectedInstOperands,
     /* 171648 */     // GIR_Coverage, 1233,
     /* 171648 */     GIR_EraseRootFromParent_Done,
     /* 171649 */   // Label 3313: @171649
     /* 171649 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(171694), // Rule ID 1234 //
     /* 171654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171683 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 171686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171692 */     GIR_RootConstrainSelectedInstOperands,
     /* 171693 */     // GIR_Coverage, 1234,
     /* 171693 */     GIR_EraseRootFromParent_Done,
     /* 171694 */   // Label 3314: @171694
     /* 171694 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(171739), // Rule ID 1235 //
     /* 171699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171728 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 171731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171737 */     GIR_RootConstrainSelectedInstOperands,
     /* 171738 */     // GIR_Coverage, 1235,
     /* 171738 */     GIR_EraseRootFromParent_Done,
     /* 171739 */   // Label 3315: @171739
     /* 171739 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(171784), // Rule ID 1236 //
     /* 171744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171773 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 171776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171782 */     GIR_RootConstrainSelectedInstOperands,
     /* 171783 */     // GIR_Coverage, 1236,
     /* 171783 */     GIR_EraseRootFromParent_Done,
     /* 171784 */   // Label 3316: @171784
     /* 171784 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(171829), // Rule ID 1237 //
     /* 171789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 171797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171818 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 171821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171827 */     GIR_RootConstrainSelectedInstOperands,
     /* 171828 */     // GIR_Coverage, 1237,
     /* 171828 */     GIR_EraseRootFromParent_Done,
     /* 171829 */   // Label 3317: @171829
     /* 171829 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(171874), // Rule ID 1248 //
     /* 171834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 171842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171863 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 171866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171872 */     GIR_RootConstrainSelectedInstOperands,
     /* 171873 */     // GIR_Coverage, 1248,
     /* 171873 */     GIR_EraseRootFromParent_Done,
     /* 171874 */   // Label 3318: @171874
     /* 171874 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(171919), // Rule ID 1249 //
     /* 171879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 171887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171908 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 171911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171917 */     GIR_RootConstrainSelectedInstOperands,
     /* 171918 */     // GIR_Coverage, 1249,
     /* 171918 */     GIR_EraseRootFromParent_Done,
     /* 171919 */   // Label 3319: @171919
     /* 171919 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(171964), // Rule ID 1250 //
     /* 171924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 171932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171953 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 171956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171962 */     GIR_RootConstrainSelectedInstOperands,
     /* 171963 */     // GIR_Coverage, 1250,
     /* 171963 */     GIR_EraseRootFromParent_Done,
     /* 171964 */   // Label 3320: @171964
     /* 171964 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(172009), // Rule ID 1251 //
     /* 171969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 171977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171998 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 172001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172007 */     GIR_RootConstrainSelectedInstOperands,
     /* 172008 */     // GIR_Coverage, 1251,
     /* 172008 */     GIR_EraseRootFromParent_Done,
     /* 172009 */   // Label 3321: @172009
     /* 172009 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(172054), // Rule ID 1252 //
     /* 172014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 172022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172043 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 172046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172052 */     GIR_RootConstrainSelectedInstOperands,
     /* 172053 */     // GIR_Coverage, 1252,
     /* 172053 */     GIR_EraseRootFromParent_Done,
     /* 172054 */   // Label 3322: @172054
     /* 172054 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(172099), // Rule ID 1263 //
     /* 172059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172088 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 172091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172097 */     GIR_RootConstrainSelectedInstOperands,
     /* 172098 */     // GIR_Coverage, 1263,
     /* 172098 */     GIR_EraseRootFromParent_Done,
     /* 172099 */   // Label 3323: @172099
     /* 172099 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(172144), // Rule ID 1264 //
     /* 172104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172133 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 172133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 172136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172142 */     GIR_RootConstrainSelectedInstOperands,
     /* 172143 */     // GIR_Coverage, 1264,
     /* 172143 */     GIR_EraseRootFromParent_Done,
     /* 172144 */   // Label 3324: @172144
     /* 172144 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(172189), // Rule ID 1265 //
     /* 172149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172178 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 172178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 172181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172187 */     GIR_RootConstrainSelectedInstOperands,
     /* 172188 */     // GIR_Coverage, 1265,
     /* 172188 */     GIR_EraseRootFromParent_Done,
     /* 172189 */   // Label 3325: @172189
     /* 172189 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(172234), // Rule ID 1266 //
     /* 172194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172223 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 172226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172232 */     GIR_RootConstrainSelectedInstOperands,
     /* 172233 */     // GIR_Coverage, 1266,
     /* 172233 */     GIR_EraseRootFromParent_Done,
     /* 172234 */   // Label 3326: @172234
     /* 172234 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(172279), // Rule ID 1267 //
     /* 172239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 172247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172268 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 172271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172277 */     GIR_RootConstrainSelectedInstOperands,
     /* 172278 */     // GIR_Coverage, 1267,
     /* 172278 */     GIR_EraseRootFromParent_Done,
     /* 172279 */   // Label 3327: @172279
     /* 172279 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(172324), // Rule ID 1278 //
     /* 172284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172313 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 172316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172322 */     GIR_RootConstrainSelectedInstOperands,
     /* 172323 */     // GIR_Coverage, 1278,
     /* 172323 */     GIR_EraseRootFromParent_Done,
     /* 172324 */   // Label 3328: @172324
     /* 172324 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(172369), // Rule ID 1279 //
     /* 172329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172358 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 172358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 172361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172367 */     GIR_RootConstrainSelectedInstOperands,
     /* 172368 */     // GIR_Coverage, 1279,
     /* 172368 */     GIR_EraseRootFromParent_Done,
     /* 172369 */   // Label 3329: @172369
     /* 172369 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(172414), // Rule ID 1280 //
     /* 172374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172403 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 172403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 172406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172412 */     GIR_RootConstrainSelectedInstOperands,
     /* 172413 */     // GIR_Coverage, 1280,
     /* 172413 */     GIR_EraseRootFromParent_Done,
     /* 172414 */   // Label 3330: @172414
     /* 172414 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(172459), // Rule ID 1281 //
     /* 172419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172448 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 172451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172457 */     GIR_RootConstrainSelectedInstOperands,
     /* 172458 */     // GIR_Coverage, 1281,
     /* 172458 */     GIR_EraseRootFromParent_Done,
     /* 172459 */   // Label 3331: @172459
     /* 172459 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(172504), // Rule ID 1282 //
     /* 172464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 172472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172493 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 172496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172502 */     GIR_RootConstrainSelectedInstOperands,
     /* 172503 */     // GIR_Coverage, 1282,
     /* 172503 */     GIR_EraseRootFromParent_Done,
     /* 172504 */   // Label 3332: @172504
     /* 172504 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(172549), // Rule ID 1313 //
     /* 172509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172538 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 172541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172547 */     GIR_RootConstrainSelectedInstOperands,
     /* 172548 */     // GIR_Coverage, 1313,
     /* 172548 */     GIR_EraseRootFromParent_Done,
     /* 172549 */   // Label 3333: @172549
     /* 172549 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(172594), // Rule ID 1314 //
     /* 172554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172583 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 172583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 172586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172592 */     GIR_RootConstrainSelectedInstOperands,
     /* 172593 */     // GIR_Coverage, 1314,
     /* 172593 */     GIR_EraseRootFromParent_Done,
     /* 172594 */   // Label 3334: @172594
     /* 172594 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(172639), // Rule ID 1315 //
     /* 172599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172628 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 172628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 172631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172637 */     GIR_RootConstrainSelectedInstOperands,
     /* 172638 */     // GIR_Coverage, 1315,
     /* 172638 */     GIR_EraseRootFromParent_Done,
     /* 172639 */   // Label 3335: @172639
     /* 172639 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(172684), // Rule ID 1316 //
     /* 172644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172673 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 172676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172682 */     GIR_RootConstrainSelectedInstOperands,
     /* 172683 */     // GIR_Coverage, 1316,
     /* 172683 */     GIR_EraseRootFromParent_Done,
     /* 172684 */   // Label 3336: @172684
     /* 172684 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(172729), // Rule ID 1317 //
     /* 172689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 172697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172718 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 172721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172727 */     GIR_RootConstrainSelectedInstOperands,
     /* 172728 */     // GIR_Coverage, 1317,
     /* 172728 */     GIR_EraseRootFromParent_Done,
     /* 172729 */   // Label 3337: @172729
     /* 172729 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(172774), // Rule ID 1328 //
     /* 172734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172763 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 172766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172772 */     GIR_RootConstrainSelectedInstOperands,
     /* 172773 */     // GIR_Coverage, 1328,
     /* 172773 */     GIR_EraseRootFromParent_Done,
     /* 172774 */   // Label 3338: @172774
     /* 172774 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(172819), // Rule ID 1329 //
     /* 172779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172808 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 172808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 172811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172817 */     GIR_RootConstrainSelectedInstOperands,
     /* 172818 */     // GIR_Coverage, 1329,
     /* 172818 */     GIR_EraseRootFromParent_Done,
     /* 172819 */   // Label 3339: @172819
     /* 172819 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(172864), // Rule ID 1330 //
     /* 172824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172853 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 172853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 172856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172862 */     GIR_RootConstrainSelectedInstOperands,
     /* 172863 */     // GIR_Coverage, 1330,
     /* 172863 */     GIR_EraseRootFromParent_Done,
     /* 172864 */   // Label 3340: @172864
     /* 172864 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(172909), // Rule ID 1331 //
     /* 172869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172898 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 172898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 172901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172907 */     GIR_RootConstrainSelectedInstOperands,
     /* 172908 */     // GIR_Coverage, 1331,
     /* 172908 */     GIR_EraseRootFromParent_Done,
     /* 172909 */   // Label 3341: @172909
     /* 172909 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(172954), // Rule ID 1332 //
     /* 172914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172943 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 172943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 172946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172952 */     GIR_RootConstrainSelectedInstOperands,
     /* 172953 */     // GIR_Coverage, 1332,
     /* 172953 */     GIR_EraseRootFromParent_Done,
     /* 172954 */   // Label 3342: @172954
     /* 172954 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(172999), // Rule ID 1333 //
     /* 172959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 172962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 172967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172988 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 172988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 172991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172997 */     GIR_RootConstrainSelectedInstOperands,
     /* 172998 */     // GIR_Coverage, 1333,
     /* 172998 */     GIR_EraseRootFromParent_Done,
     /* 172999 */   // Label 3343: @172999
     /* 172999 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(173044), // Rule ID 1334 //
     /* 173004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 173007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 173012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173033 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 173033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 173036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173042 */     GIR_RootConstrainSelectedInstOperands,
     /* 173043 */     // GIR_Coverage, 1334,
     /* 173043 */     GIR_EraseRootFromParent_Done,
     /* 173044 */   // Label 3344: @173044
     /* 173044 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(173089), // Rule ID 1335 //
     /* 173049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 173057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173078 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 173078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 173081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173087 */     GIR_RootConstrainSelectedInstOperands,
     /* 173088 */     // GIR_Coverage, 1335,
     /* 173088 */     GIR_EraseRootFromParent_Done,
     /* 173089 */   // Label 3345: @173089
     /* 173089 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(173134), // Rule ID 1336 //
     /* 173094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 173102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173123 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 173123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 173126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173132 */     GIR_RootConstrainSelectedInstOperands,
     /* 173133 */     // GIR_Coverage, 1336,
     /* 173133 */     GIR_EraseRootFromParent_Done,
     /* 173134 */   // Label 3346: @173134
     /* 173134 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(173179), // Rule ID 1337 //
     /* 173139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 173147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173168 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 173168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 173171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173177 */     GIR_RootConstrainSelectedInstOperands,
     /* 173178 */     // GIR_Coverage, 1337,
     /* 173178 */     GIR_EraseRootFromParent_Done,
     /* 173179 */   // Label 3347: @173179
     /* 173179 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(173224), // Rule ID 1354 //
     /* 173184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 173192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173213 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 173216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173222 */     GIR_RootConstrainSelectedInstOperands,
     /* 173223 */     // GIR_Coverage, 1354,
     /* 173223 */     GIR_EraseRootFromParent_Done,
     /* 173224 */   // Label 3348: @173224
     /* 173224 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(173269), // Rule ID 1355 //
     /* 173229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 173237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173258 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 173261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173267 */     GIR_RootConstrainSelectedInstOperands,
     /* 173268 */     // GIR_Coverage, 1355,
     /* 173268 */     GIR_EraseRootFromParent_Done,
     /* 173269 */   // Label 3349: @173269
     /* 173269 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(173314), // Rule ID 1369 //
     /* 173274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173303 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 173306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173312 */     GIR_RootConstrainSelectedInstOperands,
     /* 173313 */     // GIR_Coverage, 1369,
     /* 173313 */     GIR_EraseRootFromParent_Done,
     /* 173314 */   // Label 3350: @173314
     /* 173314 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(173359), // Rule ID 1371 //
     /* 173319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173348 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 173351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173357 */     GIR_RootConstrainSelectedInstOperands,
     /* 173358 */     // GIR_Coverage, 1371,
     /* 173358 */     GIR_EraseRootFromParent_Done,
     /* 173359 */   // Label 3351: @173359
     /* 173359 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(173404), // Rule ID 1373 //
     /* 173364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173393 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 173396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173402 */     GIR_RootConstrainSelectedInstOperands,
     /* 173403 */     // GIR_Coverage, 1373,
     /* 173403 */     GIR_EraseRootFromParent_Done,
     /* 173404 */   // Label 3352: @173404
     /* 173404 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(173449), // Rule ID 1375 //
     /* 173409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173438 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 173441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173447 */     GIR_RootConstrainSelectedInstOperands,
     /* 173448 */     // GIR_Coverage, 1375,
     /* 173448 */     GIR_EraseRootFromParent_Done,
     /* 173449 */   // Label 3353: @173449
     /* 173449 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(173494), // Rule ID 1377 //
     /* 173454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173483 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 173486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173492 */     GIR_RootConstrainSelectedInstOperands,
     /* 173493 */     // GIR_Coverage, 1377,
     /* 173493 */     GIR_EraseRootFromParent_Done,
     /* 173494 */   // Label 3354: @173494
     /* 173494 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(173539), // Rule ID 1379 //
     /* 173499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 173507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173528 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 173531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173537 */     GIR_RootConstrainSelectedInstOperands,
     /* 173538 */     // GIR_Coverage, 1379,
     /* 173538 */     GIR_EraseRootFromParent_Done,
     /* 173539 */   // Label 3355: @173539
     /* 173539 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(173584), // Rule ID 1386 //
     /* 173544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173573 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 173576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173582 */     GIR_RootConstrainSelectedInstOperands,
     /* 173583 */     // GIR_Coverage, 1386,
     /* 173583 */     GIR_EraseRootFromParent_Done,
     /* 173584 */   // Label 3356: @173584
     /* 173584 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(173629), // Rule ID 1387 //
     /* 173589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173618 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 173621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173627 */     GIR_RootConstrainSelectedInstOperands,
     /* 173628 */     // GIR_Coverage, 1387,
     /* 173628 */     GIR_EraseRootFromParent_Done,
     /* 173629 */   // Label 3357: @173629
     /* 173629 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(173674), // Rule ID 1388 //
     /* 173634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173663 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 173666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173672 */     GIR_RootConstrainSelectedInstOperands,
     /* 173673 */     // GIR_Coverage, 1388,
     /* 173673 */     GIR_EraseRootFromParent_Done,
     /* 173674 */   // Label 3358: @173674
     /* 173674 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(173719), // Rule ID 1389 //
     /* 173679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173708 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 173711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173717 */     GIR_RootConstrainSelectedInstOperands,
     /* 173718 */     // GIR_Coverage, 1389,
     /* 173718 */     GIR_EraseRootFromParent_Done,
     /* 173719 */   // Label 3359: @173719
     /* 173719 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(173764), // Rule ID 1390 //
     /* 173724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173753 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 173756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173762 */     GIR_RootConstrainSelectedInstOperands,
     /* 173763 */     // GIR_Coverage, 1390,
     /* 173763 */     GIR_EraseRootFromParent_Done,
     /* 173764 */   // Label 3360: @173764
     /* 173764 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(173809), // Rule ID 1391 //
     /* 173769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 173777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173798 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 173801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173807 */     GIR_RootConstrainSelectedInstOperands,
     /* 173808 */     // GIR_Coverage, 1391,
     /* 173808 */     GIR_EraseRootFromParent_Done,
     /* 173809 */   // Label 3361: @173809
     /* 173809 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(173854), // Rule ID 1392 //
     /* 173814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 173822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173843 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 173846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173852 */     GIR_RootConstrainSelectedInstOperands,
     /* 173853 */     // GIR_Coverage, 1392,
     /* 173853 */     GIR_EraseRootFromParent_Done,
     /* 173854 */   // Label 3362: @173854
     /* 173854 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(173899), // Rule ID 1393 //
     /* 173859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 173867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173888 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 173891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173897 */     GIR_RootConstrainSelectedInstOperands,
     /* 173898 */     // GIR_Coverage, 1393,
     /* 173898 */     GIR_EraseRootFromParent_Done,
     /* 173899 */   // Label 3363: @173899
     /* 173899 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(173944), // Rule ID 1394 //
     /* 173904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 173912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173933 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 173936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173942 */     GIR_RootConstrainSelectedInstOperands,
     /* 173943 */     // GIR_Coverage, 1394,
     /* 173943 */     GIR_EraseRootFromParent_Done,
     /* 173944 */   // Label 3364: @173944
     /* 173944 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(173989), // Rule ID 1395 //
     /* 173949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 173957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173978 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 173981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173987 */     GIR_RootConstrainSelectedInstOperands,
     /* 173988 */     // GIR_Coverage, 1395,
     /* 173988 */     GIR_EraseRootFromParent_Done,
     /* 173989 */   // Label 3365: @173989
     /* 173989 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(174034), // Rule ID 1396 //
     /* 173994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 174002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174023 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 174026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174032 */     GIR_RootConstrainSelectedInstOperands,
     /* 174033 */     // GIR_Coverage, 1396,
     /* 174033 */     GIR_EraseRootFromParent_Done,
     /* 174034 */   // Label 3366: @174034
     /* 174034 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(174079), // Rule ID 1397 //
     /* 174039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 174047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174068 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 174071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174077 */     GIR_RootConstrainSelectedInstOperands,
     /* 174078 */     // GIR_Coverage, 1397,
     /* 174078 */     GIR_EraseRootFromParent_Done,
     /* 174079 */   // Label 3367: @174079
     /* 174079 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(174124), // Rule ID 1404 //
     /* 174084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174113 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 174116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174122 */     GIR_RootConstrainSelectedInstOperands,
     /* 174123 */     // GIR_Coverage, 1404,
     /* 174123 */     GIR_EraseRootFromParent_Done,
     /* 174124 */   // Label 3368: @174124
     /* 174124 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(174169), // Rule ID 1405 //
     /* 174129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174158 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 174161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174167 */     GIR_RootConstrainSelectedInstOperands,
     /* 174168 */     // GIR_Coverage, 1405,
     /* 174168 */     GIR_EraseRootFromParent_Done,
     /* 174169 */   // Label 3369: @174169
     /* 174169 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(174214), // Rule ID 1406 //
     /* 174174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174203 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 174206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174212 */     GIR_RootConstrainSelectedInstOperands,
     /* 174213 */     // GIR_Coverage, 1406,
     /* 174213 */     GIR_EraseRootFromParent_Done,
     /* 174214 */   // Label 3370: @174214
     /* 174214 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(174259), // Rule ID 1407 //
     /* 174219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174248 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 174251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174257 */     GIR_RootConstrainSelectedInstOperands,
     /* 174258 */     // GIR_Coverage, 1407,
     /* 174258 */     GIR_EraseRootFromParent_Done,
     /* 174259 */   // Label 3371: @174259
     /* 174259 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(174304), // Rule ID 1408 //
     /* 174264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174293 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 174296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174302 */     GIR_RootConstrainSelectedInstOperands,
     /* 174303 */     // GIR_Coverage, 1408,
     /* 174303 */     GIR_EraseRootFromParent_Done,
     /* 174304 */   // Label 3372: @174304
     /* 174304 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(174349), // Rule ID 1409 //
     /* 174309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 174317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174338 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 174341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174347 */     GIR_RootConstrainSelectedInstOperands,
     /* 174348 */     // GIR_Coverage, 1409,
     /* 174348 */     GIR_EraseRootFromParent_Done,
     /* 174349 */   // Label 3373: @174349
     /* 174349 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(174394), // Rule ID 1416 //
     /* 174354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174383 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 174386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174392 */     GIR_RootConstrainSelectedInstOperands,
     /* 174393 */     // GIR_Coverage, 1416,
     /* 174393 */     GIR_EraseRootFromParent_Done,
     /* 174394 */   // Label 3374: @174394
     /* 174394 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(174439), // Rule ID 1417 //
     /* 174399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174428 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 174431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174437 */     GIR_RootConstrainSelectedInstOperands,
     /* 174438 */     // GIR_Coverage, 1417,
     /* 174438 */     GIR_EraseRootFromParent_Done,
     /* 174439 */   // Label 3375: @174439
     /* 174439 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(174484), // Rule ID 1418 //
     /* 174444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174473 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 174476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174482 */     GIR_RootConstrainSelectedInstOperands,
     /* 174483 */     // GIR_Coverage, 1418,
     /* 174483 */     GIR_EraseRootFromParent_Done,
     /* 174484 */   // Label 3376: @174484
     /* 174484 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(174529), // Rule ID 1419 //
     /* 174489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174518 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 174521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174527 */     GIR_RootConstrainSelectedInstOperands,
     /* 174528 */     // GIR_Coverage, 1419,
     /* 174528 */     GIR_EraseRootFromParent_Done,
     /* 174529 */   // Label 3377: @174529
     /* 174529 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(174574), // Rule ID 1420 //
     /* 174534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174563 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 174566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174572 */     GIR_RootConstrainSelectedInstOperands,
     /* 174573 */     // GIR_Coverage, 1420,
     /* 174573 */     GIR_EraseRootFromParent_Done,
     /* 174574 */   // Label 3378: @174574
     /* 174574 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(174619), // Rule ID 1421 //
     /* 174579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174608 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 174611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174617 */     GIR_RootConstrainSelectedInstOperands,
     /* 174618 */     // GIR_Coverage, 1421,
     /* 174618 */     GIR_EraseRootFromParent_Done,
     /* 174619 */   // Label 3379: @174619
     /* 174619 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(174664), // Rule ID 1422 //
     /* 174624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174653 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 174656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174662 */     GIR_RootConstrainSelectedInstOperands,
     /* 174663 */     // GIR_Coverage, 1422,
     /* 174663 */     GIR_EraseRootFromParent_Done,
     /* 174664 */   // Label 3380: @174664
     /* 174664 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(174709), // Rule ID 1423 //
     /* 174669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174698 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 174701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174707 */     GIR_RootConstrainSelectedInstOperands,
     /* 174708 */     // GIR_Coverage, 1423,
     /* 174708 */     GIR_EraseRootFromParent_Done,
     /* 174709 */   // Label 3381: @174709
     /* 174709 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(174754), // Rule ID 1424 //
     /* 174714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174743 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 174746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174752 */     GIR_RootConstrainSelectedInstOperands,
     /* 174753 */     // GIR_Coverage, 1424,
     /* 174753 */     GIR_EraseRootFromParent_Done,
     /* 174754 */   // Label 3382: @174754
     /* 174754 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(174799), // Rule ID 1425 //
     /* 174759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174788 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 174791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174797 */     GIR_RootConstrainSelectedInstOperands,
     /* 174798 */     // GIR_Coverage, 1425,
     /* 174798 */     GIR_EraseRootFromParent_Done,
     /* 174799 */   // Label 3383: @174799
     /* 174799 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(174844), // Rule ID 1426 //
     /* 174804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174833 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 174836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174842 */     GIR_RootConstrainSelectedInstOperands,
     /* 174843 */     // GIR_Coverage, 1426,
     /* 174843 */     GIR_EraseRootFromParent_Done,
     /* 174844 */   // Label 3384: @174844
     /* 174844 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(174889), // Rule ID 1427 //
     /* 174849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174878 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 174881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174887 */     GIR_RootConstrainSelectedInstOperands,
     /* 174888 */     // GIR_Coverage, 1427,
     /* 174888 */     GIR_EraseRootFromParent_Done,
     /* 174889 */   // Label 3385: @174889
     /* 174889 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(174934), // Rule ID 1428 //
     /* 174894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174923 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 174926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174932 */     GIR_RootConstrainSelectedInstOperands,
     /* 174933 */     // GIR_Coverage, 1428,
     /* 174933 */     GIR_EraseRootFromParent_Done,
     /* 174934 */   // Label 3386: @174934
     /* 174934 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(174979), // Rule ID 1429 //
     /* 174939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174968 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 174971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174977 */     GIR_RootConstrainSelectedInstOperands,
     /* 174978 */     // GIR_Coverage, 1429,
     /* 174978 */     GIR_EraseRootFromParent_Done,
     /* 174979 */   // Label 3387: @174979
     /* 174979 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175024), // Rule ID 1430 //
     /* 174984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175013 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 175016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175022 */     GIR_RootConstrainSelectedInstOperands,
     /* 175023 */     // GIR_Coverage, 1430,
     /* 175023 */     GIR_EraseRootFromParent_Done,
     /* 175024 */   // Label 3388: @175024
     /* 175024 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175069), // Rule ID 1431 //
     /* 175029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175058 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 175061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175067 */     GIR_RootConstrainSelectedInstOperands,
     /* 175068 */     // GIR_Coverage, 1431,
     /* 175068 */     GIR_EraseRootFromParent_Done,
     /* 175069 */   // Label 3389: @175069
     /* 175069 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(175114), // Rule ID 1432 //
     /* 175074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175103 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 175106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175112 */     GIR_RootConstrainSelectedInstOperands,
     /* 175113 */     // GIR_Coverage, 1432,
     /* 175113 */     GIR_EraseRootFromParent_Done,
     /* 175114 */   // Label 3390: @175114
     /* 175114 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175159), // Rule ID 1433 //
     /* 175119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175148 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 175151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175157 */     GIR_RootConstrainSelectedInstOperands,
     /* 175158 */     // GIR_Coverage, 1433,
     /* 175158 */     GIR_EraseRootFromParent_Done,
     /* 175159 */   // Label 3391: @175159
     /* 175159 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175204), // Rule ID 1434 //
     /* 175164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175193 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 175196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175202 */     GIR_RootConstrainSelectedInstOperands,
     /* 175203 */     // GIR_Coverage, 1434,
     /* 175203 */     GIR_EraseRootFromParent_Done,
     /* 175204 */   // Label 3392: @175204
     /* 175204 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175249), // Rule ID 1435 //
     /* 175209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175238 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 175241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175247 */     GIR_RootConstrainSelectedInstOperands,
     /* 175248 */     // GIR_Coverage, 1435,
     /* 175248 */     GIR_EraseRootFromParent_Done,
     /* 175249 */   // Label 3393: @175249
     /* 175249 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175294), // Rule ID 1436 //
     /* 175254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175283 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 175286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175292 */     GIR_RootConstrainSelectedInstOperands,
     /* 175293 */     // GIR_Coverage, 1436,
     /* 175293 */     GIR_EraseRootFromParent_Done,
     /* 175294 */   // Label 3394: @175294
     /* 175294 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(175339), // Rule ID 1437 //
     /* 175299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175328 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 175331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175337 */     GIR_RootConstrainSelectedInstOperands,
     /* 175338 */     // GIR_Coverage, 1437,
     /* 175338 */     GIR_EraseRootFromParent_Done,
     /* 175339 */   // Label 3395: @175339
     /* 175339 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(175384), // Rule ID 1438 //
     /* 175344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175373 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 175376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175382 */     GIR_RootConstrainSelectedInstOperands,
     /* 175383 */     // GIR_Coverage, 1438,
     /* 175383 */     GIR_EraseRootFromParent_Done,
     /* 175384 */   // Label 3396: @175384
     /* 175384 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(175429), // Rule ID 1439 //
     /* 175389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175418 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 175421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175427 */     GIR_RootConstrainSelectedInstOperands,
     /* 175428 */     // GIR_Coverage, 1439,
     /* 175428 */     GIR_EraseRootFromParent_Done,
     /* 175429 */   // Label 3397: @175429
     /* 175429 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(175474), // Rule ID 1440 //
     /* 175434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175463 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 175466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175472 */     GIR_RootConstrainSelectedInstOperands,
     /* 175473 */     // GIR_Coverage, 1440,
     /* 175473 */     GIR_EraseRootFromParent_Done,
     /* 175474 */   // Label 3398: @175474
     /* 175474 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(175519), // Rule ID 1441 //
     /* 175479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175508 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 175511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175517 */     GIR_RootConstrainSelectedInstOperands,
     /* 175518 */     // GIR_Coverage, 1441,
     /* 175518 */     GIR_EraseRootFromParent_Done,
     /* 175519 */   // Label 3399: @175519
     /* 175519 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(175564), // Rule ID 1442 //
     /* 175524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175553 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 175556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175562 */     GIR_RootConstrainSelectedInstOperands,
     /* 175563 */     // GIR_Coverage, 1442,
     /* 175563 */     GIR_EraseRootFromParent_Done,
     /* 175564 */   // Label 3400: @175564
     /* 175564 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(175609), // Rule ID 1443 //
     /* 175569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175598 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 175601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175607 */     GIR_RootConstrainSelectedInstOperands,
     /* 175608 */     // GIR_Coverage, 1443,
     /* 175608 */     GIR_EraseRootFromParent_Done,
     /* 175609 */   // Label 3401: @175609
     /* 175609 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(175654), // Rule ID 1444 //
     /* 175614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175643 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 175646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175652 */     GIR_RootConstrainSelectedInstOperands,
     /* 175653 */     // GIR_Coverage, 1444,
     /* 175653 */     GIR_EraseRootFromParent_Done,
     /* 175654 */   // Label 3402: @175654
     /* 175654 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(175699), // Rule ID 1445 //
     /* 175659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175688 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 175691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175697 */     GIR_RootConstrainSelectedInstOperands,
     /* 175698 */     // GIR_Coverage, 1445,
     /* 175698 */     GIR_EraseRootFromParent_Done,
     /* 175699 */   // Label 3403: @175699
     /* 175699 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(175744), // Rule ID 1446 //
     /* 175704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175733 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 175736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175742 */     GIR_RootConstrainSelectedInstOperands,
     /* 175743 */     // GIR_Coverage, 1446,
     /* 175743 */     GIR_EraseRootFromParent_Done,
     /* 175744 */   // Label 3404: @175744
     /* 175744 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(175789), // Rule ID 1447 //
     /* 175749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175778 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 175781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175787 */     GIR_RootConstrainSelectedInstOperands,
     /* 175788 */     // GIR_Coverage, 1447,
     /* 175788 */     GIR_EraseRootFromParent_Done,
     /* 175789 */   // Label 3405: @175789
     /* 175789 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(175834), // Rule ID 1448 //
     /* 175794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175823 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 175826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175832 */     GIR_RootConstrainSelectedInstOperands,
     /* 175833 */     // GIR_Coverage, 1448,
     /* 175833 */     GIR_EraseRootFromParent_Done,
     /* 175834 */   // Label 3406: @175834
     /* 175834 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(175879), // Rule ID 1449 //
     /* 175839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175868 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 175871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175877 */     GIR_RootConstrainSelectedInstOperands,
     /* 175878 */     // GIR_Coverage, 1449,
     /* 175878 */     GIR_EraseRootFromParent_Done,
     /* 175879 */   // Label 3407: @175879
     /* 175879 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(175924), // Rule ID 1450 //
     /* 175884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175913 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 175916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175922 */     GIR_RootConstrainSelectedInstOperands,
     /* 175923 */     // GIR_Coverage, 1450,
     /* 175923 */     GIR_EraseRootFromParent_Done,
     /* 175924 */   // Label 3408: @175924
     /* 175924 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(175969), // Rule ID 1451 //
     /* 175929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175958 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 175961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175967 */     GIR_RootConstrainSelectedInstOperands,
     /* 175968 */     // GIR_Coverage, 1451,
     /* 175968 */     GIR_EraseRootFromParent_Done,
     /* 175969 */   // Label 3409: @175969
     /* 175969 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176014), // Rule ID 1458 //
     /* 175974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 175982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176003 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 176006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176012 */     GIR_RootConstrainSelectedInstOperands,
     /* 176013 */     // GIR_Coverage, 1458,
     /* 176013 */     GIR_EraseRootFromParent_Done,
     /* 176014 */   // Label 3410: @176014
     /* 176014 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(176059), // Rule ID 1459 //
     /* 176019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176048 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 176051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176057 */     GIR_RootConstrainSelectedInstOperands,
     /* 176058 */     // GIR_Coverage, 1459,
     /* 176058 */     GIR_EraseRootFromParent_Done,
     /* 176059 */   // Label 3411: @176059
     /* 176059 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(176104), // Rule ID 1460 //
     /* 176064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176093 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 176096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176102 */     GIR_RootConstrainSelectedInstOperands,
     /* 176103 */     // GIR_Coverage, 1460,
     /* 176103 */     GIR_EraseRootFromParent_Done,
     /* 176104 */   // Label 3412: @176104
     /* 176104 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(176149), // Rule ID 1461 //
     /* 176109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176138 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 176141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176147 */     GIR_RootConstrainSelectedInstOperands,
     /* 176148 */     // GIR_Coverage, 1461,
     /* 176148 */     GIR_EraseRootFromParent_Done,
     /* 176149 */   // Label 3413: @176149
     /* 176149 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(176194), // Rule ID 1462 //
     /* 176154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176183 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 176186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176192 */     GIR_RootConstrainSelectedInstOperands,
     /* 176193 */     // GIR_Coverage, 1462,
     /* 176193 */     GIR_EraseRootFromParent_Done,
     /* 176194 */   // Label 3414: @176194
     /* 176194 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(176239), // Rule ID 1463 //
     /* 176199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176228 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 176231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176237 */     GIR_RootConstrainSelectedInstOperands,
     /* 176238 */     // GIR_Coverage, 1463,
     /* 176238 */     GIR_EraseRootFromParent_Done,
     /* 176239 */   // Label 3415: @176239
     /* 176239 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(176284), // Rule ID 1464 //
     /* 176244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176273 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 176276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176282 */     GIR_RootConstrainSelectedInstOperands,
     /* 176283 */     // GIR_Coverage, 1464,
     /* 176283 */     GIR_EraseRootFromParent_Done,
     /* 176284 */   // Label 3416: @176284
     /* 176284 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(176329), // Rule ID 1465 //
     /* 176289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176318 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 176321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176327 */     GIR_RootConstrainSelectedInstOperands,
     /* 176328 */     // GIR_Coverage, 1465,
     /* 176328 */     GIR_EraseRootFromParent_Done,
     /* 176329 */   // Label 3417: @176329
     /* 176329 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(176374), // Rule ID 1466 //
     /* 176334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176363 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 176366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176372 */     GIR_RootConstrainSelectedInstOperands,
     /* 176373 */     // GIR_Coverage, 1466,
     /* 176373 */     GIR_EraseRootFromParent_Done,
     /* 176374 */   // Label 3418: @176374
     /* 176374 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(176419), // Rule ID 1467 //
     /* 176379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176408 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 176411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176417 */     GIR_RootConstrainSelectedInstOperands,
     /* 176418 */     // GIR_Coverage, 1467,
     /* 176418 */     GIR_EraseRootFromParent_Done,
     /* 176419 */   // Label 3419: @176419
     /* 176419 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(176464), // Rule ID 1468 //
     /* 176424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176453 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 176456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176462 */     GIR_RootConstrainSelectedInstOperands,
     /* 176463 */     // GIR_Coverage, 1468,
     /* 176463 */     GIR_EraseRootFromParent_Done,
     /* 176464 */   // Label 3420: @176464
     /* 176464 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(176509), // Rule ID 1469 //
     /* 176469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176498 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 176501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176507 */     GIR_RootConstrainSelectedInstOperands,
     /* 176508 */     // GIR_Coverage, 1469,
     /* 176508 */     GIR_EraseRootFromParent_Done,
     /* 176509 */   // Label 3421: @176509
     /* 176509 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(176554), // Rule ID 1470 //
     /* 176514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176543 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 176546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176552 */     GIR_RootConstrainSelectedInstOperands,
     /* 176553 */     // GIR_Coverage, 1470,
     /* 176553 */     GIR_EraseRootFromParent_Done,
     /* 176554 */   // Label 3422: @176554
     /* 176554 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(176599), // Rule ID 1471 //
     /* 176559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176588 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 176591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176597 */     GIR_RootConstrainSelectedInstOperands,
     /* 176598 */     // GIR_Coverage, 1471,
     /* 176598 */     GIR_EraseRootFromParent_Done,
     /* 176599 */   // Label 3423: @176599
     /* 176599 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(176644), // Rule ID 1492 //
     /* 176604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176633 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 176636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176642 */     GIR_RootConstrainSelectedInstOperands,
     /* 176643 */     // GIR_Coverage, 1492,
     /* 176643 */     GIR_EraseRootFromParent_Done,
     /* 176644 */   // Label 3424: @176644
     /* 176644 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(176689), // Rule ID 1494 //
     /* 176649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176678 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 176681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176687 */     GIR_RootConstrainSelectedInstOperands,
     /* 176688 */     // GIR_Coverage, 1494,
     /* 176688 */     GIR_EraseRootFromParent_Done,
     /* 176689 */   // Label 3425: @176689
     /* 176689 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(176734), // Rule ID 1496 //
     /* 176694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176723 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 176726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176732 */     GIR_RootConstrainSelectedInstOperands,
     /* 176733 */     // GIR_Coverage, 1496,
     /* 176733 */     GIR_EraseRootFromParent_Done,
     /* 176734 */   // Label 3426: @176734
     /* 176734 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(176779), // Rule ID 1498 //
     /* 176739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176768 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 176771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176777 */     GIR_RootConstrainSelectedInstOperands,
     /* 176778 */     // GIR_Coverage, 1498,
     /* 176778 */     GIR_EraseRootFromParent_Done,
     /* 176779 */   // Label 3427: @176779
     /* 176779 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(176824), // Rule ID 1500 //
     /* 176784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176813 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 176816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176822 */     GIR_RootConstrainSelectedInstOperands,
     /* 176823 */     // GIR_Coverage, 1500,
     /* 176823 */     GIR_EraseRootFromParent_Done,
     /* 176824 */   // Label 3428: @176824
     /* 176824 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(176869), // Rule ID 1502 //
     /* 176829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 176837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176858 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 176861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176867 */     GIR_RootConstrainSelectedInstOperands,
     /* 176868 */     // GIR_Coverage, 1502,
     /* 176868 */     GIR_EraseRootFromParent_Done,
     /* 176869 */   // Label 3429: @176869
     /* 176869 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(176914), // Rule ID 1509 //
     /* 176874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 176882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176903 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 176906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176912 */     GIR_RootConstrainSelectedInstOperands,
     /* 176913 */     // GIR_Coverage, 1509,
     /* 176913 */     GIR_EraseRootFromParent_Done,
     /* 176914 */   // Label 3430: @176914
     /* 176914 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(176959), // Rule ID 1510 //
     /* 176919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 176927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176948 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 176951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176957 */     GIR_RootConstrainSelectedInstOperands,
     /* 176958 */     // GIR_Coverage, 1510,
     /* 176958 */     GIR_EraseRootFromParent_Done,
     /* 176959 */   // Label 3431: @176959
     /* 176959 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(177004), // Rule ID 1511 //
     /* 176964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 176972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176993 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 176996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177002 */     GIR_RootConstrainSelectedInstOperands,
     /* 177003 */     // GIR_Coverage, 1511,
     /* 177003 */     GIR_EraseRootFromParent_Done,
     /* 177004 */   // Label 3432: @177004
     /* 177004 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(177049), // Rule ID 1512 //
     /* 177009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 177017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177038 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 177041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177047 */     GIR_RootConstrainSelectedInstOperands,
     /* 177048 */     // GIR_Coverage, 1512,
     /* 177048 */     GIR_EraseRootFromParent_Done,
     /* 177049 */   // Label 3433: @177049
     /* 177049 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(177094), // Rule ID 1513 //
     /* 177054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 177062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177083 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 177086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177092 */     GIR_RootConstrainSelectedInstOperands,
     /* 177093 */     // GIR_Coverage, 1513,
     /* 177093 */     GIR_EraseRootFromParent_Done,
     /* 177094 */   // Label 3434: @177094
     /* 177094 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(177139), // Rule ID 1514 //
     /* 177099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 177107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 177131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177137 */     GIR_RootConstrainSelectedInstOperands,
     /* 177138 */     // GIR_Coverage, 1514,
     /* 177138 */     GIR_EraseRootFromParent_Done,
     /* 177139 */   // Label 3435: @177139
     /* 177139 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(177184), // Rule ID 1515 //
     /* 177144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177173 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 177176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177182 */     GIR_RootConstrainSelectedInstOperands,
     /* 177183 */     // GIR_Coverage, 1515,
     /* 177183 */     GIR_EraseRootFromParent_Done,
     /* 177184 */   // Label 3436: @177184
     /* 177184 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(177229), // Rule ID 1516 //
     /* 177189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177218 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 177221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177227 */     GIR_RootConstrainSelectedInstOperands,
     /* 177228 */     // GIR_Coverage, 1516,
     /* 177228 */     GIR_EraseRootFromParent_Done,
     /* 177229 */   // Label 3437: @177229
     /* 177229 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(177274), // Rule ID 1517 //
     /* 177234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177263 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 177266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177272 */     GIR_RootConstrainSelectedInstOperands,
     /* 177273 */     // GIR_Coverage, 1517,
     /* 177273 */     GIR_EraseRootFromParent_Done,
     /* 177274 */   // Label 3438: @177274
     /* 177274 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(177319), // Rule ID 1518 //
     /* 177279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177308 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 177311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177317 */     GIR_RootConstrainSelectedInstOperands,
     /* 177318 */     // GIR_Coverage, 1518,
     /* 177318 */     GIR_EraseRootFromParent_Done,
     /* 177319 */   // Label 3439: @177319
     /* 177319 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(177364), // Rule ID 1519 //
     /* 177324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177353 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 177356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177362 */     GIR_RootConstrainSelectedInstOperands,
     /* 177363 */     // GIR_Coverage, 1519,
     /* 177363 */     GIR_EraseRootFromParent_Done,
     /* 177364 */   // Label 3440: @177364
     /* 177364 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(177409), // Rule ID 1520 //
     /* 177369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 177377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177398 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 177401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177407 */     GIR_RootConstrainSelectedInstOperands,
     /* 177408 */     // GIR_Coverage, 1520,
     /* 177408 */     GIR_EraseRootFromParent_Done,
     /* 177409 */   // Label 3441: @177409
     /* 177409 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(177454), // Rule ID 1527 //
     /* 177414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177443 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 177446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177452 */     GIR_RootConstrainSelectedInstOperands,
     /* 177453 */     // GIR_Coverage, 1527,
     /* 177453 */     GIR_EraseRootFromParent_Done,
     /* 177454 */   // Label 3442: @177454
     /* 177454 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(177499), // Rule ID 1528 //
     /* 177459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177488 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 177491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177497 */     GIR_RootConstrainSelectedInstOperands,
     /* 177498 */     // GIR_Coverage, 1528,
     /* 177498 */     GIR_EraseRootFromParent_Done,
     /* 177499 */   // Label 3443: @177499
     /* 177499 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(177544), // Rule ID 1529 //
     /* 177504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177533 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 177536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177542 */     GIR_RootConstrainSelectedInstOperands,
     /* 177543 */     // GIR_Coverage, 1529,
     /* 177543 */     GIR_EraseRootFromParent_Done,
     /* 177544 */   // Label 3444: @177544
     /* 177544 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(177589), // Rule ID 1530 //
     /* 177549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177578 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 177581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177587 */     GIR_RootConstrainSelectedInstOperands,
     /* 177588 */     // GIR_Coverage, 1530,
     /* 177588 */     GIR_EraseRootFromParent_Done,
     /* 177589 */   // Label 3445: @177589
     /* 177589 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(177634), // Rule ID 1531 //
     /* 177594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177623 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 177626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177632 */     GIR_RootConstrainSelectedInstOperands,
     /* 177633 */     // GIR_Coverage, 1531,
     /* 177633 */     GIR_EraseRootFromParent_Done,
     /* 177634 */   // Label 3446: @177634
     /* 177634 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(177679), // Rule ID 1532 //
     /* 177639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 177647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177668 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 177671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177677 */     GIR_RootConstrainSelectedInstOperands,
     /* 177678 */     // GIR_Coverage, 1532,
     /* 177678 */     GIR_EraseRootFromParent_Done,
     /* 177679 */   // Label 3447: @177679
     /* 177679 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(177724), // Rule ID 1539 //
     /* 177684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177713 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 177716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177722 */     GIR_RootConstrainSelectedInstOperands,
     /* 177723 */     // GIR_Coverage, 1539,
     /* 177723 */     GIR_EraseRootFromParent_Done,
     /* 177724 */   // Label 3448: @177724
     /* 177724 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(177769), // Rule ID 1540 //
     /* 177729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177758 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 177761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177767 */     GIR_RootConstrainSelectedInstOperands,
     /* 177768 */     // GIR_Coverage, 1540,
     /* 177768 */     GIR_EraseRootFromParent_Done,
     /* 177769 */   // Label 3449: @177769
     /* 177769 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(177814), // Rule ID 1541 //
     /* 177774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177803 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 177806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177812 */     GIR_RootConstrainSelectedInstOperands,
     /* 177813 */     // GIR_Coverage, 1541,
     /* 177813 */     GIR_EraseRootFromParent_Done,
     /* 177814 */   // Label 3450: @177814
     /* 177814 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(177859), // Rule ID 1542 //
     /* 177819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177848 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 177851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177857 */     GIR_RootConstrainSelectedInstOperands,
     /* 177858 */     // GIR_Coverage, 1542,
     /* 177858 */     GIR_EraseRootFromParent_Done,
     /* 177859 */   // Label 3451: @177859
     /* 177859 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(177904), // Rule ID 1543 //
     /* 177864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177893 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 177896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177902 */     GIR_RootConstrainSelectedInstOperands,
     /* 177903 */     // GIR_Coverage, 1543,
     /* 177903 */     GIR_EraseRootFromParent_Done,
     /* 177904 */   // Label 3452: @177904
     /* 177904 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(177949), // Rule ID 1544 //
     /* 177909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177938 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 177941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177947 */     GIR_RootConstrainSelectedInstOperands,
     /* 177948 */     // GIR_Coverage, 1544,
     /* 177948 */     GIR_EraseRootFromParent_Done,
     /* 177949 */   // Label 3453: @177949
     /* 177949 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(177994), // Rule ID 1545 //
     /* 177954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177983 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 177986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177992 */     GIR_RootConstrainSelectedInstOperands,
     /* 177993 */     // GIR_Coverage, 1545,
     /* 177993 */     GIR_EraseRootFromParent_Done,
     /* 177994 */   // Label 3454: @177994
     /* 177994 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(178039), // Rule ID 1546 //
     /* 177999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 178013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 178016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178028 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 178028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 178031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178037 */     GIR_RootConstrainSelectedInstOperands,
     /* 178038 */     // GIR_Coverage, 1546,
     /* 178038 */     GIR_EraseRootFromParent_Done,
     /* 178039 */   // Label 3455: @178039
     /* 178039 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(178084), // Rule ID 1547 //
     /* 178044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 178055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 178058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 178061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178073 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 178073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 178076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178082 */     GIR_RootConstrainSelectedInstOperands,
     /* 178083 */     // GIR_Coverage, 1547,
     /* 178083 */     GIR_EraseRootFromParent_Done,
     /* 178084 */   // Label 3456: @178084
     /* 178084 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(178129), // Rule ID 1548 //
     /* 178089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178118 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 178121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178127 */     GIR_RootConstrainSelectedInstOperands,
     /* 178128 */     // GIR_Coverage, 1548,
     /* 178128 */     GIR_EraseRootFromParent_Done,
     /* 178129 */   // Label 3457: @178129
     /* 178129 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(178174), // Rule ID 1549 //
     /* 178134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178163 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 178166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178172 */     GIR_RootConstrainSelectedInstOperands,
     /* 178173 */     // GIR_Coverage, 1549,
     /* 178173 */     GIR_EraseRootFromParent_Done,
     /* 178174 */   // Label 3458: @178174
     /* 178174 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(178219), // Rule ID 1550 //
     /* 178179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178208 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 178211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178217 */     GIR_RootConstrainSelectedInstOperands,
     /* 178218 */     // GIR_Coverage, 1550,
     /* 178218 */     GIR_EraseRootFromParent_Done,
     /* 178219 */   // Label 3459: @178219
     /* 178219 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(178264), // Rule ID 1551 //
     /* 178224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178253 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 178256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178262 */     GIR_RootConstrainSelectedInstOperands,
     /* 178263 */     // GIR_Coverage, 1551,
     /* 178263 */     GIR_EraseRootFromParent_Done,
     /* 178264 */   // Label 3460: @178264
     /* 178264 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(178309), // Rule ID 1552 //
     /* 178269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178298 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 178301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178307 */     GIR_RootConstrainSelectedInstOperands,
     /* 178308 */     // GIR_Coverage, 1552,
     /* 178308 */     GIR_EraseRootFromParent_Done,
     /* 178309 */   // Label 3461: @178309
     /* 178309 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(178354), // Rule ID 1553 //
     /* 178314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 178328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 178331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178343 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 178343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 178346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178352 */     GIR_RootConstrainSelectedInstOperands,
     /* 178353 */     // GIR_Coverage, 1553,
     /* 178353 */     GIR_EraseRootFromParent_Done,
     /* 178354 */   // Label 3462: @178354
     /* 178354 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(178399), // Rule ID 1554 //
     /* 178359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 178370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 178373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 178376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178388 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 178388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 178391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178397 */     GIR_RootConstrainSelectedInstOperands,
     /* 178398 */     // GIR_Coverage, 1554,
     /* 178398 */     GIR_EraseRootFromParent_Done,
     /* 178399 */   // Label 3463: @178399
     /* 178399 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(178444), // Rule ID 1555 //
     /* 178404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178433 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 178436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178442 */     GIR_RootConstrainSelectedInstOperands,
     /* 178443 */     // GIR_Coverage, 1555,
     /* 178443 */     GIR_EraseRootFromParent_Done,
     /* 178444 */   // Label 3464: @178444
     /* 178444 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(178489), // Rule ID 1556 //
     /* 178449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178478 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 178481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178487 */     GIR_RootConstrainSelectedInstOperands,
     /* 178488 */     // GIR_Coverage, 1556,
     /* 178488 */     GIR_EraseRootFromParent_Done,
     /* 178489 */   // Label 3465: @178489
     /* 178489 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(178534), // Rule ID 1557 //
     /* 178494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178523 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 178526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178532 */     GIR_RootConstrainSelectedInstOperands,
     /* 178533 */     // GIR_Coverage, 1557,
     /* 178533 */     GIR_EraseRootFromParent_Done,
     /* 178534 */   // Label 3466: @178534
     /* 178534 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(178579), // Rule ID 1558 //
     /* 178539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178568 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 178571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178577 */     GIR_RootConstrainSelectedInstOperands,
     /* 178578 */     // GIR_Coverage, 1558,
     /* 178578 */     GIR_EraseRootFromParent_Done,
     /* 178579 */   // Label 3467: @178579
     /* 178579 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(178624), // Rule ID 1559 //
     /* 178584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178613 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 178616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178622 */     GIR_RootConstrainSelectedInstOperands,
     /* 178623 */     // GIR_Coverage, 1559,
     /* 178623 */     GIR_EraseRootFromParent_Done,
     /* 178624 */   // Label 3468: @178624
     /* 178624 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(178669), // Rule ID 1560 //
     /* 178629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 178643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 178646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178658 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 178658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 178661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178667 */     GIR_RootConstrainSelectedInstOperands,
     /* 178668 */     // GIR_Coverage, 1560,
     /* 178668 */     GIR_EraseRootFromParent_Done,
     /* 178669 */   // Label 3469: @178669
     /* 178669 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(178714), // Rule ID 1561 //
     /* 178674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 178685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 178688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 178691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178703 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 178703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 178706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178712 */     GIR_RootConstrainSelectedInstOperands,
     /* 178713 */     // GIR_Coverage, 1561,
     /* 178713 */     GIR_EraseRootFromParent_Done,
     /* 178714 */   // Label 3470: @178714
     /* 178714 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(178759), // Rule ID 1562 //
     /* 178719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178748 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 178751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178757 */     GIR_RootConstrainSelectedInstOperands,
     /* 178758 */     // GIR_Coverage, 1562,
     /* 178758 */     GIR_EraseRootFromParent_Done,
     /* 178759 */   // Label 3471: @178759
     /* 178759 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(178804), // Rule ID 1563 //
     /* 178764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178793 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 178796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178802 */     GIR_RootConstrainSelectedInstOperands,
     /* 178803 */     // GIR_Coverage, 1563,
     /* 178803 */     GIR_EraseRootFromParent_Done,
     /* 178804 */   // Label 3472: @178804
     /* 178804 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(178849), // Rule ID 1564 //
     /* 178809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178838 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 178841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178847 */     GIR_RootConstrainSelectedInstOperands,
     /* 178848 */     // GIR_Coverage, 1564,
     /* 178848 */     GIR_EraseRootFromParent_Done,
     /* 178849 */   // Label 3473: @178849
     /* 178849 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(178894), // Rule ID 1565 //
     /* 178854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178883 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 178886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178892 */     GIR_RootConstrainSelectedInstOperands,
     /* 178893 */     // GIR_Coverage, 1565,
     /* 178893 */     GIR_EraseRootFromParent_Done,
     /* 178894 */   // Label 3474: @178894
     /* 178894 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(178939), // Rule ID 1566 //
     /* 178899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178928 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 178931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178937 */     GIR_RootConstrainSelectedInstOperands,
     /* 178938 */     // GIR_Coverage, 1566,
     /* 178938 */     GIR_EraseRootFromParent_Done,
     /* 178939 */   // Label 3475: @178939
     /* 178939 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(178984), // Rule ID 1573 //
     /* 178944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 178952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 178958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 178961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178973 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 178973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 178976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178982 */     GIR_RootConstrainSelectedInstOperands,
     /* 178983 */     // GIR_Coverage, 1573,
     /* 178983 */     GIR_EraseRootFromParent_Done,
     /* 178984 */   // Label 3476: @178984
     /* 178984 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(179029), // Rule ID 1574 //
     /* 178989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 178997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179018 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 179018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 179021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179027 */     GIR_RootConstrainSelectedInstOperands,
     /* 179028 */     // GIR_Coverage, 1574,
     /* 179028 */     GIR_EraseRootFromParent_Done,
     /* 179029 */   // Label 3477: @179029
     /* 179029 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(179074), // Rule ID 1575 //
     /* 179034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179063 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 179066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179072 */     GIR_RootConstrainSelectedInstOperands,
     /* 179073 */     // GIR_Coverage, 1575,
     /* 179073 */     GIR_EraseRootFromParent_Done,
     /* 179074 */   // Label 3478: @179074
     /* 179074 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(179119), // Rule ID 1576 //
     /* 179079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179108 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 179111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179117 */     GIR_RootConstrainSelectedInstOperands,
     /* 179118 */     // GIR_Coverage, 1576,
     /* 179118 */     GIR_EraseRootFromParent_Done,
     /* 179119 */   // Label 3479: @179119
     /* 179119 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(179164), // Rule ID 1577 //
     /* 179124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179153 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 179156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179162 */     GIR_RootConstrainSelectedInstOperands,
     /* 179163 */     // GIR_Coverage, 1577,
     /* 179163 */     GIR_EraseRootFromParent_Done,
     /* 179164 */   // Label 3480: @179164
     /* 179164 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(179209), // Rule ID 1578 //
     /* 179169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179198 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 179201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179207 */     GIR_RootConstrainSelectedInstOperands,
     /* 179208 */     // GIR_Coverage, 1578,
     /* 179208 */     GIR_EraseRootFromParent_Done,
     /* 179209 */   // Label 3481: @179209
     /* 179209 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(179254), // Rule ID 1579 //
     /* 179214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179243 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 179246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179252 */     GIR_RootConstrainSelectedInstOperands,
     /* 179253 */     // GIR_Coverage, 1579,
     /* 179253 */     GIR_EraseRootFromParent_Done,
     /* 179254 */   // Label 3482: @179254
     /* 179254 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(179299), // Rule ID 1580 //
     /* 179259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 179273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 179276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179288 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 179288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 179291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179297 */     GIR_RootConstrainSelectedInstOperands,
     /* 179298 */     // GIR_Coverage, 1580,
     /* 179298 */     GIR_EraseRootFromParent_Done,
     /* 179299 */   // Label 3483: @179299
     /* 179299 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(179344), // Rule ID 1581 //
     /* 179304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179333 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 179333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 179336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179342 */     GIR_RootConstrainSelectedInstOperands,
     /* 179343 */     // GIR_Coverage, 1581,
     /* 179343 */     GIR_EraseRootFromParent_Done,
     /* 179344 */   // Label 3484: @179344
     /* 179344 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(179389), // Rule ID 1582 //
     /* 179349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179378 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 179381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179387 */     GIR_RootConstrainSelectedInstOperands,
     /* 179388 */     // GIR_Coverage, 1582,
     /* 179388 */     GIR_EraseRootFromParent_Done,
     /* 179389 */   // Label 3485: @179389
     /* 179389 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(179434), // Rule ID 1583 //
     /* 179394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179423 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 179426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179432 */     GIR_RootConstrainSelectedInstOperands,
     /* 179433 */     // GIR_Coverage, 1583,
     /* 179433 */     GIR_EraseRootFromParent_Done,
     /* 179434 */   // Label 3486: @179434
     /* 179434 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(179479), // Rule ID 1584 //
     /* 179439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179468 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 179471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179477 */     GIR_RootConstrainSelectedInstOperands,
     /* 179478 */     // GIR_Coverage, 1584,
     /* 179478 */     GIR_EraseRootFromParent_Done,
     /* 179479 */   // Label 3487: @179479
     /* 179479 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(179524), // Rule ID 1585 //
     /* 179484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179513 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 179516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179522 */     GIR_RootConstrainSelectedInstOperands,
     /* 179523 */     // GIR_Coverage, 1585,
     /* 179523 */     GIR_EraseRootFromParent_Done,
     /* 179524 */   // Label 3488: @179524
     /* 179524 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(179569), // Rule ID 1586 //
     /* 179529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179558 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 179561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179567 */     GIR_RootConstrainSelectedInstOperands,
     /* 179568 */     // GIR_Coverage, 1586,
     /* 179568 */     GIR_EraseRootFromParent_Done,
     /* 179569 */   // Label 3489: @179569
     /* 179569 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(179614), // Rule ID 1614 //
     /* 179574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 179582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179603 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 179603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 179606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179612 */     GIR_RootConstrainSelectedInstOperands,
     /* 179613 */     // GIR_Coverage, 1614,
     /* 179613 */     GIR_EraseRootFromParent_Done,
     /* 179614 */   // Label 3490: @179614
     /* 179614 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(179659), // Rule ID 1615 //
     /* 179619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 179627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179648 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 179648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 179651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179657 */     GIR_RootConstrainSelectedInstOperands,
     /* 179658 */     // GIR_Coverage, 1615,
     /* 179658 */     GIR_EraseRootFromParent_Done,
     /* 179659 */   // Label 3491: @179659
     /* 179659 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(179704), // Rule ID 1616 //
     /* 179664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 179672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179693 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 179693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 179696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179702 */     GIR_RootConstrainSelectedInstOperands,
     /* 179703 */     // GIR_Coverage, 1616,
     /* 179703 */     GIR_EraseRootFromParent_Done,
     /* 179704 */   // Label 3492: @179704
     /* 179704 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(179749), // Rule ID 1617 //
     /* 179709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 179717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179738 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 179738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 179741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179747 */     GIR_RootConstrainSelectedInstOperands,
     /* 179748 */     // GIR_Coverage, 1617,
     /* 179748 */     GIR_EraseRootFromParent_Done,
     /* 179749 */   // Label 3493: @179749
     /* 179749 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(179794), // Rule ID 1618 //
     /* 179754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 179762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179783 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 179783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 179786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179792 */     GIR_RootConstrainSelectedInstOperands,
     /* 179793 */     // GIR_Coverage, 1618,
     /* 179793 */     GIR_EraseRootFromParent_Done,
     /* 179794 */   // Label 3494: @179794
     /* 179794 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(179839), // Rule ID 1619 //
     /* 179799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 179807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179828 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 179828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 179831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179837 */     GIR_RootConstrainSelectedInstOperands,
     /* 179838 */     // GIR_Coverage, 1619,
     /* 179838 */     GIR_EraseRootFromParent_Done,
     /* 179839 */   // Label 3495: @179839
     /* 179839 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(179884), // Rule ID 1620 //
     /* 179844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 179852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179873 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 179873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 179876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179882 */     GIR_RootConstrainSelectedInstOperands,
     /* 179883 */     // GIR_Coverage, 1620,
     /* 179883 */     GIR_EraseRootFromParent_Done,
     /* 179884 */   // Label 3496: @179884
     /* 179884 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(179929), // Rule ID 1627 //
     /* 179889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 179892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179918 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 179918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 179921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179927 */     GIR_RootConstrainSelectedInstOperands,
     /* 179928 */     // GIR_Coverage, 1627,
     /* 179928 */     GIR_EraseRootFromParent_Done,
     /* 179929 */   // Label 3497: @179929
     /* 179929 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(179974), // Rule ID 1628 //
     /* 179934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 179937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179963 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 179963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 179966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179972 */     GIR_RootConstrainSelectedInstOperands,
     /* 179973 */     // GIR_Coverage, 1628,
     /* 179973 */     GIR_EraseRootFromParent_Done,
     /* 179974 */   // Label 3498: @179974
     /* 179974 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(180019), // Rule ID 1629 //
     /* 179979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 179982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180008 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 180008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 180011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180017 */     GIR_RootConstrainSelectedInstOperands,
     /* 180018 */     // GIR_Coverage, 1629,
     /* 180018 */     GIR_EraseRootFromParent_Done,
     /* 180019 */   // Label 3499: @180019
     /* 180019 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(180064), // Rule ID 1630 //
     /* 180024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 180027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 180032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180053 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 180053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 180056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180062 */     GIR_RootConstrainSelectedInstOperands,
     /* 180063 */     // GIR_Coverage, 1630,
     /* 180063 */     GIR_EraseRootFromParent_Done,
     /* 180064 */   // Label 3500: @180064
     /* 180064 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(180109), // Rule ID 1631 //
     /* 180069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 180072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 180077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180098 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 180098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 180101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180107 */     GIR_RootConstrainSelectedInstOperands,
     /* 180108 */     // GIR_Coverage, 1631,
     /* 180108 */     GIR_EraseRootFromParent_Done,
     /* 180109 */   // Label 3501: @180109
     /* 180109 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(180154), // Rule ID 1632 //
     /* 180114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 180117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 180122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 180128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 180131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180143 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 180143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 180146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180152 */     GIR_RootConstrainSelectedInstOperands,
     /* 180153 */     // GIR_Coverage, 1632,
     /* 180153 */     GIR_EraseRootFromParent_Done,
     /* 180154 */   // Label 3502: @180154
     /* 180154 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(180199), // Rule ID 1633 //
     /* 180159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 180162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 180167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180188 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 180188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 180191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180197 */     GIR_RootConstrainSelectedInstOperands,
     /* 180198 */     // GIR_Coverage, 1633,
     /* 180198 */     GIR_EraseRootFromParent_Done,
     /* 180199 */   // Label 3503: @180199
     /* 180199 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(180244), // Rule ID 1634 //
     /* 180204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 180207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 180212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180233 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 180233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 180236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180242 */     GIR_RootConstrainSelectedInstOperands,
     /* 180243 */     // GIR_Coverage, 1634,
     /* 180243 */     GIR_EraseRootFromParent_Done,
     /* 180244 */   // Label 3504: @180244
     /* 180244 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(180289), // Rule ID 1635 //
     /* 180249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 180252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 180257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 180263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 180266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180278 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 180278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 180281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180287 */     GIR_RootConstrainSelectedInstOperands,
     /* 180288 */     // GIR_Coverage, 1635,
     /* 180288 */     GIR_EraseRootFromParent_Done,
     /* 180289 */   // Label 3505: @180289
     /* 180289 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(180334), // Rule ID 1636 //
     /* 180294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180323 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 180326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180332 */     GIR_RootConstrainSelectedInstOperands,
     /* 180333 */     // GIR_Coverage, 1636,
     /* 180333 */     GIR_EraseRootFromParent_Done,
     /* 180334 */   // Label 3506: @180334
     /* 180334 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(180379), // Rule ID 1637 //
     /* 180339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180368 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 180371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180377 */     GIR_RootConstrainSelectedInstOperands,
     /* 180378 */     // GIR_Coverage, 1637,
     /* 180378 */     GIR_EraseRootFromParent_Done,
     /* 180379 */   // Label 3507: @180379
     /* 180379 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(180424), // Rule ID 1638 //
     /* 180384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180413 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 180416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180422 */     GIR_RootConstrainSelectedInstOperands,
     /* 180423 */     // GIR_Coverage, 1638,
     /* 180423 */     GIR_EraseRootFromParent_Done,
     /* 180424 */   // Label 3508: @180424
     /* 180424 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(180469), // Rule ID 1639 //
     /* 180429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 180437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180458 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 180461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180467 */     GIR_RootConstrainSelectedInstOperands,
     /* 180468 */     // GIR_Coverage, 1639,
     /* 180468 */     GIR_EraseRootFromParent_Done,
     /* 180469 */   // Label 3509: @180469
     /* 180469 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(180514), // Rule ID 1640 //
     /* 180474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 180482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180503 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 180506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180512 */     GIR_RootConstrainSelectedInstOperands,
     /* 180513 */     // GIR_Coverage, 1640,
     /* 180513 */     GIR_EraseRootFromParent_Done,
     /* 180514 */   // Label 3510: @180514
     /* 180514 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(180559), // Rule ID 1641 //
     /* 180519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 180527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180548 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 180551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180557 */     GIR_RootConstrainSelectedInstOperands,
     /* 180558 */     // GIR_Coverage, 1641,
     /* 180558 */     GIR_EraseRootFromParent_Done,
     /* 180559 */   // Label 3511: @180559
     /* 180559 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(180604), // Rule ID 1642 //
     /* 180564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 180572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180593 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 180596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180602 */     GIR_RootConstrainSelectedInstOperands,
     /* 180603 */     // GIR_Coverage, 1642,
     /* 180603 */     GIR_EraseRootFromParent_Done,
     /* 180604 */   // Label 3512: @180604
     /* 180604 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(180649), // Rule ID 1643 //
     /* 180609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 180617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180638 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 180641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180647 */     GIR_RootConstrainSelectedInstOperands,
     /* 180648 */     // GIR_Coverage, 1643,
     /* 180648 */     GIR_EraseRootFromParent_Done,
     /* 180649 */   // Label 3513: @180649
     /* 180649 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(180694), // Rule ID 1645 //
     /* 180654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 180662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180683 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 180686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180692 */     GIR_RootConstrainSelectedInstOperands,
     /* 180693 */     // GIR_Coverage, 1645,
     /* 180693 */     GIR_EraseRootFromParent_Done,
     /* 180694 */   // Label 3514: @180694
     /* 180694 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(180739), // Rule ID 1646 //
     /* 180699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 180707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180728 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 180731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180737 */     GIR_RootConstrainSelectedInstOperands,
     /* 180738 */     // GIR_Coverage, 1646,
     /* 180738 */     GIR_EraseRootFromParent_Done,
     /* 180739 */   // Label 3515: @180739
     /* 180739 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(180784), // Rule ID 1647 //
     /* 180744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 180752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180773 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 180776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180782 */     GIR_RootConstrainSelectedInstOperands,
     /* 180783 */     // GIR_Coverage, 1647,
     /* 180783 */     GIR_EraseRootFromParent_Done,
     /* 180784 */   // Label 3516: @180784
     /* 180784 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(180829), // Rule ID 1648 //
     /* 180789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 180797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180818 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 180821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180827 */     GIR_RootConstrainSelectedInstOperands,
     /* 180828 */     // GIR_Coverage, 1648,
     /* 180828 */     GIR_EraseRootFromParent_Done,
     /* 180829 */   // Label 3517: @180829
     /* 180829 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(180874), // Rule ID 1649 //
     /* 180834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 180842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180863 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 180866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180872 */     GIR_RootConstrainSelectedInstOperands,
     /* 180873 */     // GIR_Coverage, 1649,
     /* 180873 */     GIR_EraseRootFromParent_Done,
     /* 180874 */   // Label 3518: @180874
     /* 180874 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(180919), // Rule ID 1650 //
     /* 180879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 180887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180908 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 180908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 180911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180917 */     GIR_RootConstrainSelectedInstOperands,
     /* 180918 */     // GIR_Coverage, 1650,
     /* 180918 */     GIR_EraseRootFromParent_Done,
     /* 180919 */   // Label 3519: @180919
     /* 180919 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(180964), // Rule ID 1651 //
     /* 180924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 180932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180953 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 180956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180962 */     GIR_RootConstrainSelectedInstOperands,
     /* 180963 */     // GIR_Coverage, 1651,
     /* 180963 */     GIR_EraseRootFromParent_Done,
     /* 180964 */   // Label 3520: @180964
     /* 180964 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(181009), // Rule ID 1665 //
     /* 180969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 180977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180998 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 180998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 181001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181007 */     GIR_RootConstrainSelectedInstOperands,
     /* 181008 */     // GIR_Coverage, 1665,
     /* 181008 */     GIR_EraseRootFromParent_Done,
     /* 181009 */   // Label 3521: @181009
     /* 181009 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(181054), // Rule ID 1666 //
     /* 181014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 181022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181043 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 181043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 181046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181052 */     GIR_RootConstrainSelectedInstOperands,
     /* 181053 */     // GIR_Coverage, 1666,
     /* 181053 */     GIR_EraseRootFromParent_Done,
     /* 181054 */   // Label 3522: @181054
     /* 181054 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(181099), // Rule ID 1671 //
     /* 181059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 181067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181088 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 181088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 181091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181097 */     GIR_RootConstrainSelectedInstOperands,
     /* 181098 */     // GIR_Coverage, 1671,
     /* 181098 */     GIR_EraseRootFromParent_Done,
     /* 181099 */   // Label 3523: @181099
     /* 181099 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(181144), // Rule ID 1672 //
     /* 181104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 181112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181133 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 181133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 181136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181142 */     GIR_RootConstrainSelectedInstOperands,
     /* 181143 */     // GIR_Coverage, 1672,
     /* 181143 */     GIR_EraseRootFromParent_Done,
     /* 181144 */   // Label 3524: @181144
     /* 181144 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(181189), // Rule ID 1673 //
     /* 181149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 181157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181178 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 181178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 181181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181187 */     GIR_RootConstrainSelectedInstOperands,
     /* 181188 */     // GIR_Coverage, 1673,
     /* 181188 */     GIR_EraseRootFromParent_Done,
     /* 181189 */   // Label 3525: @181189
     /* 181189 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(181234), // Rule ID 1674 //
     /* 181194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 181202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181223 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 181223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 181226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181232 */     GIR_RootConstrainSelectedInstOperands,
     /* 181233 */     // GIR_Coverage, 1674,
     /* 181233 */     GIR_EraseRootFromParent_Done,
     /* 181234 */   // Label 3526: @181234
     /* 181234 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(181279), // Rule ID 1675 //
     /* 181239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 181247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181268 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 181268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 181271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181277 */     GIR_RootConstrainSelectedInstOperands,
     /* 181278 */     // GIR_Coverage, 1675,
     /* 181278 */     GIR_EraseRootFromParent_Done,
     /* 181279 */   // Label 3527: @181279
     /* 181279 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(181324), // Rule ID 1676 //
     /* 181284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 181292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181313 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 181313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 181316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181322 */     GIR_RootConstrainSelectedInstOperands,
     /* 181323 */     // GIR_Coverage, 1676,
     /* 181323 */     GIR_EraseRootFromParent_Done,
     /* 181324 */   // Label 3528: @181324
     /* 181324 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(181369), // Rule ID 1677 //
     /* 181329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 181337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181358 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 181358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 181361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181367 */     GIR_RootConstrainSelectedInstOperands,
     /* 181368 */     // GIR_Coverage, 1677,
     /* 181368 */     GIR_EraseRootFromParent_Done,
     /* 181369 */   // Label 3529: @181369
     /* 181369 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(181414), // Rule ID 1678 //
     /* 181374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 181382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181403 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 181403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 181406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181412 */     GIR_RootConstrainSelectedInstOperands,
     /* 181413 */     // GIR_Coverage, 1678,
     /* 181413 */     GIR_EraseRootFromParent_Done,
     /* 181414 */   // Label 3530: @181414
     /* 181414 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(181459), // Rule ID 1679 //
     /* 181419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 181427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181448 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 181448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 181451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181457 */     GIR_RootConstrainSelectedInstOperands,
     /* 181458 */     // GIR_Coverage, 1679,
     /* 181458 */     GIR_EraseRootFromParent_Done,
     /* 181459 */   // Label 3531: @181459
     /* 181459 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(181504), // Rule ID 1680 //
     /* 181464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 181472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181493 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 181493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 181496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181502 */     GIR_RootConstrainSelectedInstOperands,
     /* 181503 */     // GIR_Coverage, 1680,
     /* 181503 */     GIR_EraseRootFromParent_Done,
     /* 181504 */   // Label 3532: @181504
     /* 181504 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(181549), // Rule ID 1681 //
     /* 181509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 181517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181538 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 181538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 181541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181547 */     GIR_RootConstrainSelectedInstOperands,
     /* 181548 */     // GIR_Coverage, 1681,
     /* 181548 */     GIR_EraseRootFromParent_Done,
     /* 181549 */   // Label 3533: @181549
     /* 181549 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(181594), // Rule ID 1682 //
     /* 181554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 181562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181583 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 181583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 181586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181592 */     GIR_RootConstrainSelectedInstOperands,
     /* 181593 */     // GIR_Coverage, 1682,
     /* 181593 */     GIR_EraseRootFromParent_Done,
     /* 181594 */   // Label 3534: @181594
     /* 181594 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(181639), // Rule ID 1683 //
     /* 181599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 181607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181628 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 181628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 181631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181637 */     GIR_RootConstrainSelectedInstOperands,
     /* 181638 */     // GIR_Coverage, 1683,
     /* 181638 */     GIR_EraseRootFromParent_Done,
     /* 181639 */   // Label 3535: @181639
     /* 181639 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(181684), // Rule ID 1684 //
     /* 181644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 181652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181673 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 181673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 181676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181682 */     GIR_RootConstrainSelectedInstOperands,
     /* 181683 */     // GIR_Coverage, 1684,
     /* 181683 */     GIR_EraseRootFromParent_Done,
     /* 181684 */   // Label 3536: @181684
     /* 181684 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(181729), // Rule ID 1750 //
     /* 181689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 181697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181718 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 181718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 181721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181727 */     GIR_RootConstrainSelectedInstOperands,
     /* 181728 */     // GIR_Coverage, 1750,
     /* 181728 */     GIR_EraseRootFromParent_Done,
     /* 181729 */   // Label 3537: @181729
     /* 181729 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(181774), // Rule ID 1752 //
     /* 181734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 181742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181763 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 181763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 181766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181772 */     GIR_RootConstrainSelectedInstOperands,
     /* 181773 */     // GIR_Coverage, 1752,
     /* 181773 */     GIR_EraseRootFromParent_Done,
     /* 181774 */   // Label 3538: @181774
     /* 181774 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(181819), // Rule ID 2303 //
     /* 181779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 181782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 181787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 181790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 181793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 181796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181808 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 181808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 181811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181817 */     GIR_RootConstrainSelectedInstOperands,
     /* 181818 */     // GIR_Coverage, 2303,
     /* 181818 */     GIR_EraseRootFromParent_Done,
     /* 181819 */   // Label 3539: @181819
     /* 181819 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(181864), // Rule ID 2304 //
     /* 181824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 181827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 181832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 181835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 181838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 181841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181853 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 181853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 181856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181862 */     GIR_RootConstrainSelectedInstOperands,
     /* 181863 */     // GIR_Coverage, 2304,
     /* 181863 */     GIR_EraseRootFromParent_Done,
     /* 181864 */   // Label 3540: @181864
     /* 181864 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(181909), // Rule ID 2315 //
     /* 181869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 181872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 181877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181898 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 181898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 181901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181907 */     GIR_RootConstrainSelectedInstOperands,
     /* 181908 */     // GIR_Coverage, 2315,
     /* 181908 */     GIR_EraseRootFromParent_Done,
     /* 181909 */   // Label 3541: @181909
     /* 181909 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(181954), // Rule ID 2316 //
     /* 181914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 181917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 181922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181943 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 181943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 181946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181952 */     GIR_RootConstrainSelectedInstOperands,
     /* 181953 */     // GIR_Coverage, 2316,
     /* 181953 */     GIR_EraseRootFromParent_Done,
     /* 181954 */   // Label 3542: @181954
     /* 181954 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(181999), // Rule ID 2339 //
     /* 181959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 181962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 181967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181988 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 181988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 181991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181997 */     GIR_RootConstrainSelectedInstOperands,
     /* 181998 */     // GIR_Coverage, 2339,
     /* 181998 */     GIR_EraseRootFromParent_Done,
     /* 181999 */   // Label 3543: @181999
     /* 181999 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(182044), // Rule ID 2340 //
     /* 182004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 182007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 182012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 182015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 182021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182033 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 182033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 182036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182042 */     GIR_RootConstrainSelectedInstOperands,
     /* 182043 */     // GIR_Coverage, 2340,
     /* 182043 */     GIR_EraseRootFromParent_Done,
     /* 182044 */   // Label 3544: @182044
     /* 182044 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(182089), // Rule ID 2341 //
     /* 182049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 182052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 182057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 182063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 182066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182078 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 182078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 182081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182087 */     GIR_RootConstrainSelectedInstOperands,
     /* 182088 */     // GIR_Coverage, 2341,
     /* 182088 */     GIR_EraseRootFromParent_Done,
     /* 182089 */   // Label 3545: @182089
     /* 182089 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(182134), // Rule ID 2342 //
     /* 182094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 182097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 182102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 182105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 182111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182123 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 182123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 182126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182132 */     GIR_RootConstrainSelectedInstOperands,
     /* 182133 */     // GIR_Coverage, 2342,
     /* 182133 */     GIR_EraseRootFromParent_Done,
     /* 182134 */   // Label 3546: @182134
     /* 182134 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(182179), // Rule ID 2343 //
     /* 182139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 182142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 182147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 182150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 182156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182168 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 182168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 182171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182177 */     GIR_RootConstrainSelectedInstOperands,
     /* 182178 */     // GIR_Coverage, 2343,
     /* 182178 */     GIR_EraseRootFromParent_Done,
     /* 182179 */   // Label 3547: @182179
     /* 182179 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(182224), // Rule ID 2344 //
     /* 182184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 182195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 182198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 182201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182213 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 182213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 182216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182222 */     GIR_RootConstrainSelectedInstOperands,
     /* 182223 */     // GIR_Coverage, 2344,
     /* 182223 */     GIR_EraseRootFromParent_Done,
     /* 182224 */   // Label 3548: @182224
     /* 182224 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(182269), // Rule ID 2347 //
     /* 182229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 182240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 182246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182258 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 182258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 182261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182267 */     GIR_RootConstrainSelectedInstOperands,
     /* 182268 */     // GIR_Coverage, 2347,
     /* 182268 */     GIR_EraseRootFromParent_Done,
     /* 182269 */   // Label 3549: @182269
     /* 182269 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(182314), // Rule ID 2350 //
     /* 182274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 182288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 182291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182303 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 182303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 182306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182312 */     GIR_RootConstrainSelectedInstOperands,
     /* 182313 */     // GIR_Coverage, 2350,
     /* 182313 */     GIR_EraseRootFromParent_Done,
     /* 182314 */   // Label 3550: @182314
     /* 182314 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(182359), // Rule ID 2353 //
     /* 182319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 182330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 182336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182348 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 182348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 182351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182357 */     GIR_RootConstrainSelectedInstOperands,
     /* 182358 */     // GIR_Coverage, 2353,
     /* 182358 */     GIR_EraseRootFromParent_Done,
     /* 182359 */   // Label 3551: @182359
     /* 182359 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(182404), // Rule ID 2356 //
     /* 182364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 182372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 182375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 182381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182393 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 182393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 182396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182402 */     GIR_RootConstrainSelectedInstOperands,
     /* 182403 */     // GIR_Coverage, 2356,
     /* 182403 */     GIR_EraseRootFromParent_Done,
     /* 182404 */   // Label 3552: @182404
     /* 182404 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(182449), // Rule ID 2359 //
     /* 182409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 182420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 182423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 182426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182438 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 182438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 182441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182447 */     GIR_RootConstrainSelectedInstOperands,
     /* 182448 */     // GIR_Coverage, 2359,
     /* 182448 */     GIR_EraseRootFromParent_Done,
     /* 182449 */   // Label 3553: @182449
     /* 182449 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(182494), // Rule ID 2362 //
     /* 182454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 182465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 182471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182483 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 182483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 182486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182492 */     GIR_RootConstrainSelectedInstOperands,
     /* 182493 */     // GIR_Coverage, 2362,
     /* 182493 */     GIR_EraseRootFromParent_Done,
     /* 182494 */   // Label 3554: @182494
     /* 182494 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(182539), // Rule ID 2365 //
     /* 182499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 182513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 182516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182528 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 182528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 182531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182537 */     GIR_RootConstrainSelectedInstOperands,
     /* 182538 */     // GIR_Coverage, 2365,
     /* 182538 */     GIR_EraseRootFromParent_Done,
     /* 182539 */   // Label 3555: @182539
     /* 182539 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(182584), // Rule ID 2368 //
     /* 182544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 182555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 182561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182573 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 182573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 182576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182582 */     GIR_RootConstrainSelectedInstOperands,
     /* 182583 */     // GIR_Coverage, 2368,
     /* 182583 */     GIR_EraseRootFromParent_Done,
     /* 182584 */   // Label 3556: @182584
     /* 182584 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(182629), // Rule ID 2371 //
     /* 182589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 182592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 182597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 182600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 182606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182618 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 182618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 182621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182627 */     GIR_RootConstrainSelectedInstOperands,
     /* 182628 */     // GIR_Coverage, 2371,
     /* 182628 */     GIR_EraseRootFromParent_Done,
     /* 182629 */   // Label 3557: @182629
     /* 182629 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(182674), // Rule ID 2508 //
     /* 182634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 182642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182663 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 182666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182672 */     GIR_RootConstrainSelectedInstOperands,
     /* 182673 */     // GIR_Coverage, 2508,
     /* 182673 */     GIR_EraseRootFromParent_Done,
     /* 182674 */   // Label 3558: @182674
     /* 182674 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(182719), // Rule ID 2509 //
     /* 182679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 182687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182708 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 182711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182717 */     GIR_RootConstrainSelectedInstOperands,
     /* 182718 */     // GIR_Coverage, 2509,
     /* 182718 */     GIR_EraseRootFromParent_Done,
     /* 182719 */   // Label 3559: @182719
     /* 182719 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(182764), // Rule ID 2510 //
     /* 182724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 182732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182753 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 182756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182762 */     GIR_RootConstrainSelectedInstOperands,
     /* 182763 */     // GIR_Coverage, 2510,
     /* 182763 */     GIR_EraseRootFromParent_Done,
     /* 182764 */   // Label 3560: @182764
     /* 182764 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(182809), // Rule ID 2511 //
     /* 182769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 182777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182798 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 182801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182807 */     GIR_RootConstrainSelectedInstOperands,
     /* 182808 */     // GIR_Coverage, 2511,
     /* 182808 */     GIR_EraseRootFromParent_Done,
     /* 182809 */   // Label 3561: @182809
     /* 182809 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(182854), // Rule ID 2516 //
     /* 182814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 182822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182843 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 182843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 182846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182852 */     GIR_RootConstrainSelectedInstOperands,
     /* 182853 */     // GIR_Coverage, 2516,
     /* 182853 */     GIR_EraseRootFromParent_Done,
     /* 182854 */   // Label 3562: @182854
     /* 182854 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(182899), // Rule ID 2634 //
     /* 182859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 182867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 182876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182888 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 182891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182897 */     GIR_RootConstrainSelectedInstOperands,
     /* 182898 */     // GIR_Coverage, 2634,
     /* 182898 */     GIR_EraseRootFromParent_Done,
     /* 182899 */   // Label 3563: @182899
     /* 182899 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(182944), // Rule ID 2635 //
     /* 182904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 182912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 182921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182933 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 182936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182942 */     GIR_RootConstrainSelectedInstOperands,
     /* 182943 */     // GIR_Coverage, 2635,
     /* 182943 */     GIR_EraseRootFromParent_Done,
     /* 182944 */   // Label 3564: @182944
     /* 182944 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(182989), // Rule ID 2636 //
     /* 182949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 182957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 182966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182978 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 182981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182987 */     GIR_RootConstrainSelectedInstOperands,
     /* 182988 */     // GIR_Coverage, 2636,
     /* 182988 */     GIR_EraseRootFromParent_Done,
     /* 182989 */   // Label 3565: @182989
     /* 182989 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(183034), // Rule ID 2637 //
     /* 182994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 183002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183023 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 183026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183032 */     GIR_RootConstrainSelectedInstOperands,
     /* 183033 */     // GIR_Coverage, 2637,
     /* 183033 */     GIR_EraseRootFromParent_Done,
     /* 183034 */   // Label 3566: @183034
     /* 183034 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183079), // Rule ID 2638 //
     /* 183039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 183047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183068 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 183071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183077 */     GIR_RootConstrainSelectedInstOperands,
     /* 183078 */     // GIR_Coverage, 2638,
     /* 183078 */     GIR_EraseRootFromParent_Done,
     /* 183079 */   // Label 3567: @183079
     /* 183079 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183124), // Rule ID 2639 //
     /* 183084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 183092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183113 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 183116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183122 */     GIR_RootConstrainSelectedInstOperands,
     /* 183123 */     // GIR_Coverage, 2639,
     /* 183123 */     GIR_EraseRootFromParent_Done,
     /* 183124 */   // Label 3568: @183124
     /* 183124 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(183169), // Rule ID 2640 //
     /* 183129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 183137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183158 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 183161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183167 */     GIR_RootConstrainSelectedInstOperands,
     /* 183168 */     // GIR_Coverage, 2640,
     /* 183168 */     GIR_EraseRootFromParent_Done,
     /* 183169 */   // Label 3569: @183169
     /* 183169 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(183214), // Rule ID 2641 //
     /* 183174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 183182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183203 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 183206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183212 */     GIR_RootConstrainSelectedInstOperands,
     /* 183213 */     // GIR_Coverage, 2641,
     /* 183213 */     GIR_EraseRootFromParent_Done,
     /* 183214 */   // Label 3570: @183214
     /* 183214 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(183259), // Rule ID 3815 //
     /* 183219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 183222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 183227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 183236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183248 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 183248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 183251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 183253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 183255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 183257 */     GIR_RootConstrainSelectedInstOperands,
     /* 183258 */     // GIR_Coverage, 3815,
     /* 183258 */     GIR_EraseRootFromParent_Done,
     /* 183259 */   // Label 3571: @183259
     /* 183259 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(183304), // Rule ID 3843 //
     /* 183264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 183267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 183272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 183281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183293 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 183293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 183296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 183300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 183302 */     GIR_RootConstrainSelectedInstOperands,
     /* 183303 */     // GIR_Coverage, 3843,
     /* 183303 */     GIR_EraseRootFromParent_Done,
     /* 183304 */   // Label 3572: @183304
     /* 183304 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(183349), // Rule ID 3853 //
     /* 183309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 183312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 183317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 183326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183338 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 183338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 183341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 183345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 183347 */     GIR_RootConstrainSelectedInstOperands,
     /* 183348 */     // GIR_Coverage, 3853,
     /* 183348 */     GIR_EraseRootFromParent_Done,
     /* 183349 */   // Label 3573: @183349
     /* 183349 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(183394), // Rule ID 3854 //
     /* 183354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 183357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 183362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 183371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183383 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 183383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 183386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 183388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 183390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 183392 */     GIR_RootConstrainSelectedInstOperands,
     /* 183393 */     // GIR_Coverage, 3854,
     /* 183393 */     GIR_EraseRootFromParent_Done,
     /* 183394 */   // Label 3574: @183394
     /* 183394 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(183442), // Rule ID 3855 //
     /* 183399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 183402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 183416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183428 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 183428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 183431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183440 */     GIR_RootConstrainSelectedInstOperands,
     /* 183441 */     // GIR_Coverage, 3855,
     /* 183441 */     GIR_EraseRootFromParent_Done,
     /* 183442 */   // Label 3575: @183442
     /* 183442 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(183490), // Rule ID 3856 //
     /* 183447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 183450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 183464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183476 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 183476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 183479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183488 */     GIR_RootConstrainSelectedInstOperands,
     /* 183489 */     // GIR_Coverage, 3856,
     /* 183489 */     GIR_EraseRootFromParent_Done,
     /* 183490 */   // Label 3576: @183490
     /* 183490 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(183538), // Rule ID 3857 //
     /* 183495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 183498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 183512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183524 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 183524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 183527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183536 */     GIR_RootConstrainSelectedInstOperands,
     /* 183537 */     // GIR_Coverage, 3857,
     /* 183537 */     GIR_EraseRootFromParent_Done,
     /* 183538 */   // Label 3577: @183538
     /* 183538 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(183586), // Rule ID 3858 //
     /* 183543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 183546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 183560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183572 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 183572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 183575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183584 */     GIR_RootConstrainSelectedInstOperands,
     /* 183585 */     // GIR_Coverage, 3858,
     /* 183585 */     GIR_EraseRootFromParent_Done,
     /* 183586 */   // Label 3578: @183586
     /* 183586 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(183634), // Rule ID 3859 //
     /* 183591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 183608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183620 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 183620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 183623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183632 */     GIR_RootConstrainSelectedInstOperands,
     /* 183633 */     // GIR_Coverage, 3859,
     /* 183633 */     GIR_EraseRootFromParent_Done,
     /* 183634 */   // Label 3579: @183634
     /* 183634 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(183682), // Rule ID 3860 //
     /* 183639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 183656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183668 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 183668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 183671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183680 */     GIR_RootConstrainSelectedInstOperands,
     /* 183681 */     // GIR_Coverage, 3860,
     /* 183681 */     GIR_EraseRootFromParent_Done,
     /* 183682 */   // Label 3580: @183682
     /* 183682 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(183730), // Rule ID 3861 //
     /* 183687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 183704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183716 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 183716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 183719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183728 */     GIR_RootConstrainSelectedInstOperands,
     /* 183729 */     // GIR_Coverage, 3861,
     /* 183729 */     GIR_EraseRootFromParent_Done,
     /* 183730 */   // Label 3581: @183730
     /* 183730 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(183778), // Rule ID 3862 //
     /* 183735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 183752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183764 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 183764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 183767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183776 */     GIR_RootConstrainSelectedInstOperands,
     /* 183777 */     // GIR_Coverage, 3862,
     /* 183777 */     GIR_EraseRootFromParent_Done,
     /* 183778 */   // Label 3582: @183778
     /* 183778 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(183826), // Rule ID 3863 //
     /* 183783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 183791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 183800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183812 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 183812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 183815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183824 */     GIR_RootConstrainSelectedInstOperands,
     /* 183825 */     // GIR_Coverage, 3863,
     /* 183825 */     GIR_EraseRootFromParent_Done,
     /* 183826 */   // Label 3583: @183826
     /* 183826 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(183874), // Rule ID 3864 //
     /* 183831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 183834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 183839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 183848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183860 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 183860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 183863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 183872 */     GIR_RootConstrainSelectedInstOperands,
     /* 183873 */     // GIR_Coverage, 3864,
     /* 183873 */     GIR_EraseRootFromParent_Done,
     /* 183874 */   // Label 3584: @183874
     /* 183874 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(183916), // Rule ID 3929 //
     /* 183879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 183884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183905 */     // (intrinsic_wo_chain:{ *:[i32] } 2169:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 183905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 183908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183914 */     GIR_RootConstrainSelectedInstOperands,
     /* 183915 */     // GIR_Coverage, 3929,
     /* 183915 */     GIR_EraseRootFromParent_Done,
     /* 183916 */   // Label 3585: @183916
     /* 183916 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(183958), // Rule ID 3930 //
     /* 183921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 183926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183947 */     // (intrinsic_wo_chain:{ *:[i64] } 2169:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 183947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 183950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183956 */     GIR_RootConstrainSelectedInstOperands,
     /* 183957 */     // GIR_Coverage, 3930,
     /* 183957 */     GIR_EraseRootFromParent_Done,
     /* 183958 */   // Label 3586: @183958
     /* 183958 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184000), // Rule ID 3931 //
     /* 183963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 183968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183989 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 183989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 183992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183998 */     GIR_RootConstrainSelectedInstOperands,
     /* 183999 */     // GIR_Coverage, 3931,
     /* 183999 */     GIR_EraseRootFromParent_Done,
     /* 184000 */   // Label 3587: @184000
     /* 184000 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(184042), // Rule ID 3932 //
     /* 184005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 184010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184031 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 184031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 184034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184040 */     GIR_RootConstrainSelectedInstOperands,
     /* 184041 */     // GIR_Coverage, 3932,
     /* 184041 */     GIR_EraseRootFromParent_Done,
     /* 184042 */   // Label 3588: @184042
     /* 184042 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(184084), // Rule ID 5207 //
     /* 184047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 184052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184073 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 184076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184082 */     GIR_RootConstrainSelectedInstOperands,
     /* 184083 */     // GIR_Coverage, 5207,
     /* 184083 */     GIR_EraseRootFromParent_Done,
     /* 184084 */   // Label 3589: @184084
     /* 184084 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184129), // Rule ID 5211 //
     /* 184089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 184097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184118 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 184121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184127 */     GIR_RootConstrainSelectedInstOperands,
     /* 184128 */     // GIR_Coverage, 5211,
     /* 184128 */     GIR_EraseRootFromParent_Done,
     /* 184129 */   // Label 3590: @184129
     /* 184129 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184174), // Rule ID 5215 //
     /* 184134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 184142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184163 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 184166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184172 */     GIR_RootConstrainSelectedInstOperands,
     /* 184173 */     // GIR_Coverage, 5215,
     /* 184173 */     GIR_EraseRootFromParent_Done,
     /* 184174 */   // Label 3591: @184174
     /* 184174 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184219), // Rule ID 5216 //
     /* 184179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 184187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184208 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 184211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184217 */     GIR_RootConstrainSelectedInstOperands,
     /* 184218 */     // GIR_Coverage, 5216,
     /* 184218 */     GIR_EraseRootFromParent_Done,
     /* 184219 */   // Label 3592: @184219
     /* 184219 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184264), // Rule ID 5217 //
     /* 184224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 184232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184253 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 184253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 184256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184262 */     GIR_RootConstrainSelectedInstOperands,
     /* 184263 */     // GIR_Coverage, 5217,
     /* 184263 */     GIR_EraseRootFromParent_Done,
     /* 184264 */   // Label 3593: @184264
     /* 184264 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(184309), // Rule ID 5218 //
     /* 184269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 184277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184298 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 184301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184307 */     GIR_RootConstrainSelectedInstOperands,
     /* 184308 */     // GIR_Coverage, 5218,
     /* 184308 */     GIR_EraseRootFromParent_Done,
     /* 184309 */   // Label 3594: @184309
     /* 184309 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(184354), // Rule ID 5219 //
     /* 184314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 184322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184343 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 184346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184352 */     GIR_RootConstrainSelectedInstOperands,
     /* 184353 */     // GIR_Coverage, 5219,
     /* 184353 */     GIR_EraseRootFromParent_Done,
     /* 184354 */   // Label 3595: @184354
     /* 184354 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(184399), // Rule ID 5220 //
     /* 184359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 184367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184388 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 184391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184397 */     GIR_RootConstrainSelectedInstOperands,
     /* 184398 */     // GIR_Coverage, 5220,
     /* 184398 */     GIR_EraseRootFromParent_Done,
     /* 184399 */   // Label 3596: @184399
     /* 184399 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(184444), // Rule ID 5221 //
     /* 184404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 184412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184433 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 184436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184442 */     GIR_RootConstrainSelectedInstOperands,
     /* 184443 */     // GIR_Coverage, 5221,
     /* 184443 */     GIR_EraseRootFromParent_Done,
     /* 184444 */   // Label 3597: @184444
     /* 184444 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(184489), // Rule ID 5222 //
     /* 184449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 184457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184478 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 184481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184487 */     GIR_RootConstrainSelectedInstOperands,
     /* 184488 */     // GIR_Coverage, 5222,
     /* 184488 */     GIR_EraseRootFromParent_Done,
     /* 184489 */   // Label 3598: @184489
     /* 184489 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(184534), // Rule ID 5223 //
     /* 184494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 184502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184523 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 184526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184532 */     GIR_RootConstrainSelectedInstOperands,
     /* 184533 */     // GIR_Coverage, 5223,
     /* 184533 */     GIR_EraseRootFromParent_Done,
     /* 184534 */   // Label 3599: @184534
     /* 184534 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(184579), // Rule ID 5224 //
     /* 184539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 184547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184568 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 184571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184577 */     GIR_RootConstrainSelectedInstOperands,
     /* 184578 */     // GIR_Coverage, 5224,
     /* 184578 */     GIR_EraseRootFromParent_Done,
     /* 184579 */   // Label 3600: @184579
     /* 184579 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(184624), // Rule ID 5225 //
     /* 184584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 184592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184613 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 184616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184622 */     GIR_RootConstrainSelectedInstOperands,
     /* 184623 */     // GIR_Coverage, 5225,
     /* 184623 */     GIR_EraseRootFromParent_Done,
     /* 184624 */   // Label 3601: @184624
     /* 184624 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(184669), // Rule ID 5226 //
     /* 184629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 184637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184658 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 184661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184667 */     GIR_RootConstrainSelectedInstOperands,
     /* 184668 */     // GIR_Coverage, 5226,
     /* 184668 */     GIR_EraseRootFromParent_Done,
     /* 184669 */   // Label 3602: @184669
     /* 184669 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(184714), // Rule ID 5227 //
     /* 184674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 184682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184703 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 184706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184712 */     GIR_RootConstrainSelectedInstOperands,
     /* 184713 */     // GIR_Coverage, 5227,
     /* 184713 */     GIR_EraseRootFromParent_Done,
     /* 184714 */   // Label 3603: @184714
     /* 184714 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(184759), // Rule ID 5228 //
     /* 184719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 184727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184748 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 184751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184757 */     GIR_RootConstrainSelectedInstOperands,
     /* 184758 */     // GIR_Coverage, 5228,
     /* 184758 */     GIR_EraseRootFromParent_Done,
     /* 184759 */   // Label 3604: @184759
     /* 184759 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(184804), // Rule ID 5229 //
     /* 184764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 184772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184793 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 184796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184802 */     GIR_RootConstrainSelectedInstOperands,
     /* 184803 */     // GIR_Coverage, 5229,
     /* 184803 */     GIR_EraseRootFromParent_Done,
     /* 184804 */   // Label 3605: @184804
     /* 184804 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(184849), // Rule ID 5230 //
     /* 184809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 184817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184838 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 184838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 184841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184847 */     GIR_RootConstrainSelectedInstOperands,
     /* 184848 */     // GIR_Coverage, 5230,
     /* 184848 */     GIR_EraseRootFromParent_Done,
     /* 184849 */   // Label 3606: @184849
     /* 184849 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(184894), // Rule ID 5231 //
     /* 184854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 184862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 184883 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 184883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 184886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184892 */     GIR_RootConstrainSelectedInstOperands,
     /* 184893 */     // GIR_Coverage, 5231,
     /* 184893 */     GIR_EraseRootFromParent_Done,
     /* 184894 */   // Label 3607: @184894
     /* 184894 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(184939), // Rule ID 5250 //
     /* 184899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 184907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184928 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 184928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 184931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184937 */     GIR_RootConstrainSelectedInstOperands,
     /* 184938 */     // GIR_Coverage, 5250,
     /* 184938 */     GIR_EraseRootFromParent_Done,
     /* 184939 */   // Label 3608: @184939
     /* 184939 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(184981), // Rule ID 5584 //
     /* 184944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 184949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 184952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 184958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184970 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 184970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 184973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 184975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 184979 */     GIR_RootConstrainSelectedInstOperands,
     /* 184980 */     // GIR_Coverage, 5584,
     /* 184980 */     GIR_EraseRootFromParent_Done,
     /* 184981 */   // Label 3609: @184981
     /* 184981 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(185023), // Rule ID 5585 //
     /* 184986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 184991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 184994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 185000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185012 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 185012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 185015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 185017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 185019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185021 */     GIR_RootConstrainSelectedInstOperands,
     /* 185022 */     // GIR_Coverage, 5585,
     /* 185022 */     GIR_EraseRootFromParent_Done,
     /* 185023 */   // Label 3610: @185023
     /* 185023 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185120), // Rule ID 6298 //
     /* 185028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 185033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 185039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 185042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185054 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 185054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 185057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 185061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 185070 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 185074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 185076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 185079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 185090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 185104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185119 */     // GIR_Coverage, 6298,
     /* 185119 */     GIR_EraseRootFromParent_Done,
     /* 185120 */   // Label 3611: @185120
     /* 185120 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185217), // Rule ID 6299 //
     /* 185125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 185130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 185136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 185139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185151 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 185151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 185154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 185158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 185167 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 185171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 185173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 185176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 185187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 185201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 185211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 185216 */     // GIR_Coverage, 6299,
     /* 185216 */     GIR_EraseRootFromParent_Done,
     /* 185217 */   // Label 3612: @185217
     /* 185217 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(185259), // Rule ID 6944 //
     /* 185222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 185227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185248 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 185248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 185251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185257 */     GIR_RootConstrainSelectedInstOperands,
     /* 185258 */     // GIR_Coverage, 6944,
     /* 185258 */     GIR_EraseRootFromParent_Done,
     /* 185259 */   // Label 3613: @185259
     /* 185259 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(185301), // Rule ID 6945 //
     /* 185264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 185269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185290 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 185290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 185293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185299 */     GIR_RootConstrainSelectedInstOperands,
     /* 185300 */     // GIR_Coverage, 6945,
     /* 185300 */     GIR_EraseRootFromParent_Done,
     /* 185301 */   // Label 3614: @185301
     /* 185301 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(185343), // Rule ID 6946 //
     /* 185306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 185311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185332 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 185332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 185335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185341 */     GIR_RootConstrainSelectedInstOperands,
     /* 185342 */     // GIR_Coverage, 6946,
     /* 185342 */     GIR_EraseRootFromParent_Done,
     /* 185343 */   // Label 3615: @185343
     /* 185343 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185385), // Rule ID 6947 //
     /* 185348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 185353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185374 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 185374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 185377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185383 */     GIR_RootConstrainSelectedInstOperands,
     /* 185384 */     // GIR_Coverage, 6947,
     /* 185384 */     GIR_EraseRootFromParent_Done,
     /* 185385 */   // Label 3616: @185385
     /* 185385 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185433), // Rule ID 6987 //
     /* 185390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 185395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185416 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 185416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 185419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 185428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 185431 */     GIR_RootConstrainSelectedInstOperands,
     /* 185432 */     // GIR_Coverage, 6987,
     /* 185432 */     GIR_EraseRootFromParent_Done,
     /* 185433 */   // Label 3617: @185433
     /* 185433 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185478), // Rule ID 10045 //
     /* 185438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 185446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185467 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 185470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185476 */     GIR_RootConstrainSelectedInstOperands,
     /* 185477 */     // GIR_Coverage, 10045,
     /* 185477 */     GIR_EraseRootFromParent_Done,
     /* 185478 */   // Label 3618: @185478
     /* 185478 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(185523), // Rule ID 10046 //
     /* 185483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 185491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185512 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 185515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185521 */     GIR_RootConstrainSelectedInstOperands,
     /* 185522 */     // GIR_Coverage, 10046,
     /* 185522 */     GIR_EraseRootFromParent_Done,
     /* 185523 */   // Label 3619: @185523
     /* 185523 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(185568), // Rule ID 10047 //
     /* 185528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 185536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185557 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 185560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185566 */     GIR_RootConstrainSelectedInstOperands,
     /* 185567 */     // GIR_Coverage, 10047,
     /* 185567 */     GIR_EraseRootFromParent_Done,
     /* 185568 */   // Label 3620: @185568
     /* 185568 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(185613), // Rule ID 10048 //
     /* 185573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 185581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185602 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 185605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185611 */     GIR_RootConstrainSelectedInstOperands,
     /* 185612 */     // GIR_Coverage, 10048,
     /* 185612 */     GIR_EraseRootFromParent_Done,
     /* 185613 */   // Label 3621: @185613
     /* 185613 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(185658), // Rule ID 10057 //
     /* 185618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 185626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185647 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 185650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185656 */     GIR_RootConstrainSelectedInstOperands,
     /* 185657 */     // GIR_Coverage, 10057,
     /* 185657 */     GIR_EraseRootFromParent_Done,
     /* 185658 */   // Label 3622: @185658
     /* 185658 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(185703), // Rule ID 10058 //
     /* 185663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 185671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185692 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 185695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185701 */     GIR_RootConstrainSelectedInstOperands,
     /* 185702 */     // GIR_Coverage, 10058,
     /* 185702 */     GIR_EraseRootFromParent_Done,
     /* 185703 */   // Label 3623: @185703
     /* 185703 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(185748), // Rule ID 10059 //
     /* 185708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 185716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185737 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 185740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185746 */     GIR_RootConstrainSelectedInstOperands,
     /* 185747 */     // GIR_Coverage, 10059,
     /* 185747 */     GIR_EraseRootFromParent_Done,
     /* 185748 */   // Label 3624: @185748
     /* 185748 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(185793), // Rule ID 10060 //
     /* 185753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 185761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185782 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 185782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 185785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185791 */     GIR_RootConstrainSelectedInstOperands,
     /* 185792 */     // GIR_Coverage, 10060,
     /* 185792 */     GIR_EraseRootFromParent_Done,
     /* 185793 */   // Label 3625: @185793
     /* 185793 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(185838), // Rule ID 10061 //
     /* 185798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 185806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185827 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 185827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 185830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185836 */     GIR_RootConstrainSelectedInstOperands,
     /* 185837 */     // GIR_Coverage, 10061,
     /* 185837 */     GIR_EraseRootFromParent_Done,
     /* 185838 */   // Label 3626: @185838
     /* 185838 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(185883), // Rule ID 10062 //
     /* 185843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 185851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185872 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 185872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 185875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185881 */     GIR_RootConstrainSelectedInstOperands,
     /* 185882 */     // GIR_Coverage, 10062,
     /* 185882 */     GIR_EraseRootFromParent_Done,
     /* 185883 */   // Label 3627: @185883
     /* 185883 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(185928), // Rule ID 10063 //
     /* 185888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 185896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185917 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 185917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 185920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185926 */     GIR_RootConstrainSelectedInstOperands,
     /* 185927 */     // GIR_Coverage, 10063,
     /* 185927 */     GIR_EraseRootFromParent_Done,
     /* 185928 */   // Label 3628: @185928
     /* 185928 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(185973), // Rule ID 10064 //
     /* 185933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 185941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185962 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 185962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 185965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 185967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 185969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185971 */     GIR_RootConstrainSelectedInstOperands,
     /* 185972 */     // GIR_Coverage, 10064,
     /* 185972 */     GIR_EraseRootFromParent_Done,
     /* 185973 */   // Label 3629: @185973
     /* 185973 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(186018), // Rule ID 10065 //
     /* 185978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 185986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186007 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 186007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 186010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 186012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 186014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186016 */     GIR_RootConstrainSelectedInstOperands,
     /* 186017 */     // GIR_Coverage, 10065,
     /* 186017 */     GIR_EraseRootFromParent_Done,
     /* 186018 */   // Label 3630: @186018
     /* 186018 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(186063), // Rule ID 10066 //
     /* 186023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 186031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 186040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186052 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 186052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 186055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 186057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 186059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186061 */     GIR_RootConstrainSelectedInstOperands,
     /* 186062 */     // GIR_Coverage, 10066,
     /* 186062 */     GIR_EraseRootFromParent_Done,
     /* 186063 */   // Label 3631: @186063
     /* 186063 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(186108), // Rule ID 10067 //
     /* 186068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 186076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 186085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186097 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 186097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 186100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 186102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 186104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186106 */     GIR_RootConstrainSelectedInstOperands,
     /* 186107 */     // GIR_Coverage, 10067,
     /* 186107 */     GIR_EraseRootFromParent_Done,
     /* 186108 */   // Label 3632: @186108
     /* 186108 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(186153), // Rule ID 10068 //
     /* 186113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 186121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 186130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186142 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 186142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 186145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 186147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 186149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186151 */     GIR_RootConstrainSelectedInstOperands,
     /* 186152 */     // GIR_Coverage, 10068,
     /* 186152 */     GIR_EraseRootFromParent_Done,
     /* 186153 */   // Label 3633: @186153
     /* 186153 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(186199), // Rule ID 138 //
     /* 186158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 186161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 186166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186176 */     // MIs[0] Rn
     /* 186176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 186180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186188 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 186191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186197 */     GIR_RootConstrainSelectedInstOperands,
     /* 186198 */     // GIR_Coverage, 138,
     /* 186198 */     GIR_EraseRootFromParent_Done,
     /* 186199 */   // Label 3634: @186199
     /* 186199 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(186246), // Rule ID 139 //
     /* 186204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 186207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 186212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186219 */     // MIs[0] Rn
     /* 186219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 186223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186227 */     // MIs[0] Rm
     /* 186227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 186231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186235 */     // (intrinsic_wo_chain:{ *:[i64] } 1242:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 186235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 186238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186244 */     GIR_RootConstrainSelectedInstOperands,
     /* 186245 */     // GIR_Coverage, 139,
     /* 186245 */     GIR_EraseRootFromParent_Done,
     /* 186246 */   // Label 3635: @186246
     /* 186246 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(186283), // Rule ID 2399 //
     /* 186251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 186259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186272 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2151:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 186275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186281 */     GIR_RootConstrainSelectedInstOperands,
     /* 186282 */     // GIR_Coverage, 2399,
     /* 186282 */     GIR_EraseRootFromParent_Done,
     /* 186283 */   // Label 3636: @186283
     /* 186283 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(186320), // Rule ID 2400 //
     /* 186288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 186296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186309 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 186312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186318 */     GIR_RootConstrainSelectedInstOperands,
     /* 186319 */     // GIR_Coverage, 2400,
     /* 186319 */     GIR_EraseRootFromParent_Done,
     /* 186320 */   // Label 3637: @186320
     /* 186320 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186357), // Rule ID 2401 //
     /* 186325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 186333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186346 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2153:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 186349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186355 */     GIR_RootConstrainSelectedInstOperands,
     /* 186356 */     // GIR_Coverage, 2401,
     /* 186356 */     GIR_EraseRootFromParent_Done,
     /* 186357 */   // Label 3638: @186357
     /* 186357 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186394), // Rule ID 2403 //
     /* 186362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 186370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186383 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2156:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 186386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186392 */     GIR_RootConstrainSelectedInstOperands,
     /* 186393 */     // GIR_Coverage, 2403,
     /* 186393 */     GIR_EraseRootFromParent_Done,
     /* 186394 */   // Label 3639: @186394
     /* 186394 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186431), // Rule ID 2404 //
     /* 186399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 186407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186420 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2157:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 186423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186429 */     GIR_RootConstrainSelectedInstOperands,
     /* 186430 */     // GIR_Coverage, 2404,
     /* 186430 */     GIR_EraseRootFromParent_Done,
     /* 186431 */   // Label 3640: @186431
     /* 186431 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(186468), // Rule ID 2405 //
     /* 186436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 186444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186457 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 186460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186466 */     GIR_RootConstrainSelectedInstOperands,
     /* 186467 */     // GIR_Coverage, 2405,
     /* 186467 */     GIR_EraseRootFromParent_Done,
     /* 186468 */   // Label 3641: @186468
     /* 186468 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(186505), // Rule ID 2407 //
     /* 186473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 186481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186494 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2077:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 186497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186503 */     GIR_RootConstrainSelectedInstOperands,
     /* 186504 */     // GIR_Coverage, 2407,
     /* 186504 */     GIR_EraseRootFromParent_Done,
     /* 186505 */   // Label 3642: @186505
     /* 186505 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186542), // Rule ID 2408 //
     /* 186510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 186518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186531 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2078:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 186534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186540 */     GIR_RootConstrainSelectedInstOperands,
     /* 186541 */     // GIR_Coverage, 2408,
     /* 186541 */     GIR_EraseRootFromParent_Done,
     /* 186542 */   // Label 3643: @186542
     /* 186542 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186579), // Rule ID 2409 //
     /* 186547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 186555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186568 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2079:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 186571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186577 */     GIR_RootConstrainSelectedInstOperands,
     /* 186578 */     // GIR_Coverage, 2409,
     /* 186578 */     GIR_EraseRootFromParent_Done,
     /* 186579 */   // Label 3644: @186579
     /* 186579 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186616), // Rule ID 2411 //
     /* 186584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 186592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186605 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 186608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186614 */     GIR_RootConstrainSelectedInstOperands,
     /* 186615 */     // GIR_Coverage, 2411,
     /* 186615 */     GIR_EraseRootFromParent_Done,
     /* 186616 */   // Label 3645: @186616
     /* 186616 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(186653), // Rule ID 2412 //
     /* 186621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 186629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186642 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2083:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 186645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186651 */     GIR_RootConstrainSelectedInstOperands,
     /* 186652 */     // GIR_Coverage, 2412,
     /* 186652 */     GIR_EraseRootFromParent_Done,
     /* 186653 */   // Label 3646: @186653
     /* 186653 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(186690), // Rule ID 2413 //
     /* 186658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 186666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186679 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 186682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186688 */     GIR_RootConstrainSelectedInstOperands,
     /* 186689 */     // GIR_Coverage, 2413,
     /* 186689 */     GIR_EraseRootFromParent_Done,
     /* 186690 */   // Label 3647: @186690
     /* 186690 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(186727), // Rule ID 2415 //
     /* 186695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 186703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186716 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1921:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 186719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186725 */     GIR_RootConstrainSelectedInstOperands,
     /* 186726 */     // GIR_Coverage, 2415,
     /* 186726 */     GIR_EraseRootFromParent_Done,
     /* 186727 */   // Label 3648: @186727
     /* 186727 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(186764), // Rule ID 2416 //
     /* 186732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 186740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186753 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1922:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 186756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186762 */     GIR_RootConstrainSelectedInstOperands,
     /* 186763 */     // GIR_Coverage, 2416,
     /* 186763 */     GIR_EraseRootFromParent_Done,
     /* 186764 */   // Label 3649: @186764
     /* 186764 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(186801), // Rule ID 2417 //
     /* 186769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 186777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186790 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1923:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 186793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186799 */     GIR_RootConstrainSelectedInstOperands,
     /* 186800 */     // GIR_Coverage, 2417,
     /* 186800 */     GIR_EraseRootFromParent_Done,
     /* 186801 */   // Label 3650: @186801
     /* 186801 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(186838), // Rule ID 2419 //
     /* 186806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 186814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1926:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 186830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186836 */     GIR_RootConstrainSelectedInstOperands,
     /* 186837 */     // GIR_Coverage, 2419,
     /* 186837 */     GIR_EraseRootFromParent_Done,
     /* 186838 */   // Label 3651: @186838
     /* 186838 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(186875), // Rule ID 2420 //
     /* 186843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 186851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1927:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 186867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186873 */     GIR_RootConstrainSelectedInstOperands,
     /* 186874 */     // GIR_Coverage, 2420,
     /* 186874 */     GIR_EraseRootFromParent_Done,
     /* 186875 */   // Label 3652: @186875
     /* 186875 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(186912), // Rule ID 2421 //
     /* 186880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 186888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186901 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 186901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 186904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 186908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 186910 */     GIR_RootConstrainSelectedInstOperands,
     /* 186911 */     // GIR_Coverage, 2421,
     /* 186911 */     GIR_EraseRootFromParent_Done,
     /* 186912 */   // Label 3653: @186912
     /* 186912 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(186949), // Rule ID 2422 //
     /* 186917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 186920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 186925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186938 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1546:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 186938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 186941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 186945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 186947 */     GIR_RootConstrainSelectedInstOperands,
     /* 186948 */     // GIR_Coverage, 2422,
     /* 186948 */     GIR_EraseRootFromParent_Done,
     /* 186949 */   // Label 3654: @186949
     /* 186949 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(186989), // Rule ID 2621 //
     /* 186954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 186962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186975 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 186975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 186978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 186980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186987 */     GIR_RootConstrainSelectedInstOperands,
     /* 186988 */     // GIR_Coverage, 2621,
     /* 186988 */     GIR_EraseRootFromParent_Done,
     /* 186989 */   // Label 3655: @186989
     /* 186989 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(187029), // Rule ID 2622 //
     /* 186994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 187002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187015 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1633:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 187018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 187020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187027 */     GIR_RootConstrainSelectedInstOperands,
     /* 187028 */     // GIR_Coverage, 2622,
     /* 187028 */     GIR_EraseRootFromParent_Done,
     /* 187029 */   // Label 3656: @187029
     /* 187029 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(187069), // Rule ID 2623 //
     /* 187034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 187042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 187051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187055 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1633:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 187055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 187058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 187060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187067 */     GIR_RootConstrainSelectedInstOperands,
     /* 187068 */     // GIR_Coverage, 2623,
     /* 187068 */     GIR_EraseRootFromParent_Done,
     /* 187069 */   // Label 3657: @187069
     /* 187069 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(187109), // Rule ID 2624 //
     /* 187074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 187082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 187091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187095 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1633:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 187095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 187098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 187100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187107 */     GIR_RootConstrainSelectedInstOperands,
     /* 187108 */     // GIR_Coverage, 2624,
     /* 187108 */     GIR_EraseRootFromParent_Done,
     /* 187109 */   // Label 3658: @187109
     /* 187109 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(187149), // Rule ID 2625 //
     /* 187114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 187122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 187125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 187131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187135 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1633:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 187135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 187138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 187140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187147 */     GIR_RootConstrainSelectedInstOperands,
     /* 187148 */     // GIR_Coverage, 2625,
     /* 187148 */     GIR_EraseRootFromParent_Done,
     /* 187149 */   // Label 3659: @187149
     /* 187149 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(187186), // Rule ID 2642 //
     /* 187154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 187162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 187171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 187175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 187178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 187180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187184 */     GIR_RootConstrainSelectedInstOperands,
     /* 187185 */     // GIR_Coverage, 2642,
     /* 187185 */     GIR_EraseRootFromParent_Done,
     /* 187186 */   // Label 3660: @187186
     /* 187186 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(187223), // Rule ID 2643 //
     /* 187191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 187199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 187208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 187212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 187215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 187217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187221 */     GIR_RootConstrainSelectedInstOperands,
     /* 187222 */     // GIR_Coverage, 2643,
     /* 187222 */     GIR_EraseRootFromParent_Done,
     /* 187223 */   // Label 3661: @187223
     /* 187223 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(187260), // Rule ID 2644 //
     /* 187228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 187236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 187245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 187249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 187252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 187254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187258 */     GIR_RootConstrainSelectedInstOperands,
     /* 187259 */     // GIR_Coverage, 2644,
     /* 187259 */     GIR_EraseRootFromParent_Done,
     /* 187260 */   // Label 3662: @187260
     /* 187260 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(187297), // Rule ID 2645 //
     /* 187265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 187273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 187276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 187286 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 187289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187295 */     GIR_RootConstrainSelectedInstOperands,
     /* 187296 */     // GIR_Coverage, 2645,
     /* 187296 */     GIR_EraseRootFromParent_Done,
     /* 187297 */   // Label 3663: @187297
     /* 187297 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(187334), // Rule ID 2646 //
     /* 187302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 187310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 187313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 187319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 187323 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 187323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 187326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187332 */     GIR_RootConstrainSelectedInstOperands,
     /* 187333 */     // GIR_Coverage, 2646,
     /* 187333 */     GIR_EraseRootFromParent_Done,
     /* 187334 */   // Label 3664: @187334
     /* 187334 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187371), // Rule ID 2647 //
     /* 187339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 187347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 187350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 187356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 187360 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 187360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 187363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187369 */     GIR_RootConstrainSelectedInstOperands,
     /* 187370 */     // GIR_Coverage, 2647,
     /* 187370 */     GIR_EraseRootFromParent_Done,
     /* 187371 */   // Label 3665: @187371
     /* 187371 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(187408), // Rule ID 2648 //
     /* 187376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 187384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 187387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 187393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 187397 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 187397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 187400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187406 */     GIR_RootConstrainSelectedInstOperands,
     /* 187407 */     // GIR_Coverage, 2648,
     /* 187407 */     GIR_EraseRootFromParent_Done,
     /* 187408 */   // Label 3666: @187408
     /* 187408 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(187445), // Rule ID 2826 //
     /* 187413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 187421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187434 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1543:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 187437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187443 */     GIR_RootConstrainSelectedInstOperands,
     /* 187444 */     // GIR_Coverage, 2826,
     /* 187444 */     GIR_EraseRootFromParent_Done,
     /* 187445 */   // Label 3667: @187445
     /* 187445 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(187482), // Rule ID 2827 //
     /* 187450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 187458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187471 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1543:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 187474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187480 */     GIR_RootConstrainSelectedInstOperands,
     /* 187481 */     // GIR_Coverage, 2827,
     /* 187481 */     GIR_EraseRootFromParent_Done,
     /* 187482 */   // Label 3668: @187482
     /* 187482 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(187519), // Rule ID 2828 //
     /* 187487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 187495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187508 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1543:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 187511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187517 */     GIR_RootConstrainSelectedInstOperands,
     /* 187518 */     // GIR_Coverage, 2828,
     /* 187518 */     GIR_EraseRootFromParent_Done,
     /* 187519 */   // Label 3669: @187519
     /* 187519 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187556), // Rule ID 2999 //
     /* 187524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 187532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187545 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1795:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 187548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187554 */     GIR_RootConstrainSelectedInstOperands,
     /* 187555 */     // GIR_Coverage, 2999,
     /* 187555 */     GIR_EraseRootFromParent_Done,
     /* 187556 */   // Label 3670: @187556
     /* 187556 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187593), // Rule ID 3000 //
     /* 187561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 187569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187582 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 187585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187591 */     GIR_RootConstrainSelectedInstOperands,
     /* 187592 */     // GIR_Coverage, 3000,
     /* 187592 */     GIR_EraseRootFromParent_Done,
     /* 187593 */   // Label 3671: @187593
     /* 187593 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(187630), // Rule ID 3001 //
     /* 187598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 187606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 187622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187628 */     GIR_RootConstrainSelectedInstOperands,
     /* 187629 */     // GIR_Coverage, 3001,
     /* 187629 */     GIR_EraseRootFromParent_Done,
     /* 187630 */   // Label 3672: @187630
     /* 187630 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(187667), // Rule ID 3002 //
     /* 187635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 187643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 187659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187665 */     GIR_RootConstrainSelectedInstOperands,
     /* 187666 */     // GIR_Coverage, 3002,
     /* 187666 */     GIR_EraseRootFromParent_Done,
     /* 187667 */   // Label 3673: @187667
     /* 187667 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(187704), // Rule ID 3003 //
     /* 187672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 187680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1630:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 187696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187702 */     GIR_RootConstrainSelectedInstOperands,
     /* 187703 */     // GIR_Coverage, 3003,
     /* 187703 */     GIR_EraseRootFromParent_Done,
     /* 187704 */   // Label 3674: @187704
     /* 187704 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(187741), // Rule ID 3025 //
     /* 187709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 187717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 187733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187739 */     GIR_RootConstrainSelectedInstOperands,
     /* 187740 */     // GIR_Coverage, 3025,
     /* 187740 */     GIR_EraseRootFromParent_Done,
     /* 187741 */   // Label 3675: @187741
     /* 187741 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(187778), // Rule ID 3026 //
     /* 187746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 187754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 187770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187776 */     GIR_RootConstrainSelectedInstOperands,
     /* 187777 */     // GIR_Coverage, 3026,
     /* 187777 */     GIR_EraseRootFromParent_Done,
     /* 187778 */   // Label 3676: @187778
     /* 187778 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(187815), // Rule ID 3027 //
     /* 187783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 187791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 187807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187813 */     GIR_RootConstrainSelectedInstOperands,
     /* 187814 */     // GIR_Coverage, 3027,
     /* 187814 */     GIR_EraseRootFromParent_Done,
     /* 187815 */   // Label 3677: @187815
     /* 187815 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(187852), // Rule ID 3031 //
     /* 187820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 187823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 187828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1631:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 187844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187850 */     GIR_RootConstrainSelectedInstOperands,
     /* 187851 */     // GIR_Coverage, 3031,
     /* 187851 */     GIR_EraseRootFromParent_Done,
     /* 187852 */   // Label 3678: @187852
     /* 187852 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(187889), // Rule ID 3032 //
     /* 187857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 187865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1631:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 187881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187887 */     GIR_RootConstrainSelectedInstOperands,
     /* 187888 */     // GIR_Coverage, 3032,
     /* 187888 */     GIR_EraseRootFromParent_Done,
     /* 187889 */   // Label 3679: @187889
     /* 187889 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(187926), // Rule ID 3033 //
     /* 187894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 187902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1631:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 187918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187924 */     GIR_RootConstrainSelectedInstOperands,
     /* 187925 */     // GIR_Coverage, 3033,
     /* 187925 */     GIR_EraseRootFromParent_Done,
     /* 187926 */   // Label 3680: @187926
     /* 187926 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(187963), // Rule ID 3034 //
     /* 187931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 187934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 187939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1273:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 187955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187961 */     GIR_RootConstrainSelectedInstOperands,
     /* 187962 */     // GIR_Coverage, 3034,
     /* 187962 */     GIR_EraseRootFromParent_Done,
     /* 187963 */   // Label 3681: @187963
     /* 187963 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(188000), // Rule ID 3035 //
     /* 187968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 187971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 187976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187989 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1273:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 187992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187998 */     GIR_RootConstrainSelectedInstOperands,
     /* 187999 */     // GIR_Coverage, 3035,
     /* 187999 */     GIR_EraseRootFromParent_Done,
     /* 188000 */   // Label 3682: @188000
     /* 188000 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(188037), // Rule ID 3036 //
     /* 188005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 188008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 188013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1273:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 188029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188035 */     GIR_RootConstrainSelectedInstOperands,
     /* 188036 */     // GIR_Coverage, 3036,
     /* 188036 */     GIR_EraseRootFromParent_Done,
     /* 188037 */   // Label 3683: @188037
     /* 188037 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(188074), // Rule ID 3037 //
     /* 188042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 188045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 188050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188063 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1273:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 188066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188072 */     GIR_RootConstrainSelectedInstOperands,
     /* 188073 */     // GIR_Coverage, 3037,
     /* 188073 */     GIR_EraseRootFromParent_Done,
     /* 188074 */   // Label 3684: @188074
     /* 188074 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(188111), // Rule ID 3038 //
     /* 188079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 188087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 188103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188109 */     GIR_RootConstrainSelectedInstOperands,
     /* 188110 */     // GIR_Coverage, 3038,
     /* 188110 */     GIR_EraseRootFromParent_Done,
     /* 188111 */   // Label 3685: @188111
     /* 188111 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(188148), // Rule ID 3039 //
     /* 188116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 188124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 188140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188146 */     GIR_RootConstrainSelectedInstOperands,
     /* 188147 */     // GIR_Coverage, 3039,
     /* 188147 */     GIR_EraseRootFromParent_Done,
     /* 188148 */   // Label 3686: @188148
     /* 188148 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(188185), // Rule ID 3040 //
     /* 188153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 188161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 188177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188183 */     GIR_RootConstrainSelectedInstOperands,
     /* 188184 */     // GIR_Coverage, 3040,
     /* 188184 */     GIR_EraseRootFromParent_Done,
     /* 188185 */   // Label 3687: @188185
     /* 188185 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(188222), // Rule ID 3087 //
     /* 188190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 188198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188211 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1250:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 188214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188220 */     GIR_RootConstrainSelectedInstOperands,
     /* 188221 */     // GIR_Coverage, 3087,
     /* 188221 */     GIR_EraseRootFromParent_Done,
     /* 188222 */   // Label 3688: @188222
     /* 188222 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(188259), // Rule ID 3088 //
     /* 188227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 188235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1250:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 188251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188257 */     GIR_RootConstrainSelectedInstOperands,
     /* 188258 */     // GIR_Coverage, 3088,
     /* 188258 */     GIR_EraseRootFromParent_Done,
     /* 188259 */   // Label 3689: @188259
     /* 188259 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(188296), // Rule ID 3089 //
     /* 188264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 188272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1250:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 188288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188294 */     GIR_RootConstrainSelectedInstOperands,
     /* 188295 */     // GIR_Coverage, 3089,
     /* 188295 */     GIR_EraseRootFromParent_Done,
     /* 188296 */   // Label 3690: @188296
     /* 188296 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(188333), // Rule ID 3096 //
     /* 188301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 188309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188322 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 188325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188331 */     GIR_RootConstrainSelectedInstOperands,
     /* 188332 */     // GIR_Coverage, 3096,
     /* 188332 */     GIR_EraseRootFromParent_Done,
     /* 188333 */   // Label 3691: @188333
     /* 188333 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(188370), // Rule ID 3097 //
     /* 188338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 188346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188359 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 188362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188368 */     GIR_RootConstrainSelectedInstOperands,
     /* 188369 */     // GIR_Coverage, 3097,
     /* 188369 */     GIR_EraseRootFromParent_Done,
     /* 188370 */   // Label 3692: @188370
     /* 188370 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(188407), // Rule ID 3098 //
     /* 188375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 188383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 188399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188405 */     GIR_RootConstrainSelectedInstOperands,
     /* 188406 */     // GIR_Coverage, 3098,
     /* 188406 */     GIR_EraseRootFromParent_Done,
     /* 188407 */   // Label 3693: @188407
     /* 188407 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(188447), // Rule ID 3202 //
     /* 188412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188433 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 188436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188445 */     GIR_RootConstrainSelectedInstOperands,
     /* 188446 */     // GIR_Coverage, 3202,
     /* 188446 */     GIR_EraseRootFromParent_Done,
     /* 188447 */   // Label 3694: @188447
     /* 188447 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(188487), // Rule ID 3203 //
     /* 188452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188473 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 188476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188485 */     GIR_RootConstrainSelectedInstOperands,
     /* 188486 */     // GIR_Coverage, 3203,
     /* 188486 */     GIR_EraseRootFromParent_Done,
     /* 188487 */   // Label 3695: @188487
     /* 188487 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(188527), // Rule ID 3204 //
     /* 188492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188513 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 188516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188525 */     GIR_RootConstrainSelectedInstOperands,
     /* 188526 */     // GIR_Coverage, 3204,
     /* 188526 */     GIR_EraseRootFromParent_Done,
     /* 188527 */   // Label 3696: @188527
     /* 188527 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(188567), // Rule ID 3205 //
     /* 188532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188553 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 188556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188565 */     GIR_RootConstrainSelectedInstOperands,
     /* 188566 */     // GIR_Coverage, 3205,
     /* 188566 */     GIR_EraseRootFromParent_Done,
     /* 188567 */   // Label 3697: @188567
     /* 188567 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(188607), // Rule ID 3210 //
     /* 188572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188593 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 188596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188605 */     GIR_RootConstrainSelectedInstOperands,
     /* 188606 */     // GIR_Coverage, 3210,
     /* 188606 */     GIR_EraseRootFromParent_Done,
     /* 188607 */   // Label 3698: @188607
     /* 188607 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(188647), // Rule ID 3211 //
     /* 188612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188633 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 188636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188645 */     GIR_RootConstrainSelectedInstOperands,
     /* 188646 */     // GIR_Coverage, 3211,
     /* 188646 */     GIR_EraseRootFromParent_Done,
     /* 188647 */   // Label 3699: @188647
     /* 188647 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(188687), // Rule ID 3212 //
     /* 188652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188673 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 188676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188685 */     GIR_RootConstrainSelectedInstOperands,
     /* 188686 */     // GIR_Coverage, 3212,
     /* 188686 */     GIR_EraseRootFromParent_Done,
     /* 188687 */   // Label 3700: @188687
     /* 188687 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(188727), // Rule ID 3213 //
     /* 188692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 188700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188713 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 188716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188725 */     GIR_RootConstrainSelectedInstOperands,
     /* 188726 */     // GIR_Coverage, 3213,
     /* 188726 */     GIR_EraseRootFromParent_Done,
     /* 188727 */   // Label 3701: @188727
     /* 188727 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(188764), // Rule ID 3402 //
     /* 188732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 188735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 188740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 188746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188753 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 188756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188762 */     GIR_RootConstrainSelectedInstOperands,
     /* 188763 */     // GIR_Coverage, 3402,
     /* 188763 */     GIR_EraseRootFromParent_Done,
     /* 188764 */   // Label 3702: @188764
     /* 188764 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(188801), // Rule ID 3403 //
     /* 188769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 188772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 188777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 188783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188790 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 188790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 188793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188799 */     GIR_RootConstrainSelectedInstOperands,
     /* 188800 */     // GIR_Coverage, 3403,
     /* 188800 */     GIR_EraseRootFromParent_Done,
     /* 188801 */   // Label 3703: @188801
     /* 188801 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(188838), // Rule ID 3404 //
     /* 188806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 188809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 188814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 188820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188827 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 188830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188836 */     GIR_RootConstrainSelectedInstOperands,
     /* 188837 */     // GIR_Coverage, 3404,
     /* 188837 */     GIR_EraseRootFromParent_Done,
     /* 188838 */   // Label 3704: @188838
     /* 188838 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(188875), // Rule ID 3405 //
     /* 188843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 188846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 188851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 188857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188864 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 188864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 188867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188873 */     GIR_RootConstrainSelectedInstOperands,
     /* 188874 */     // GIR_Coverage, 3405,
     /* 188874 */     GIR_EraseRootFromParent_Done,
     /* 188875 */   // Label 3705: @188875
     /* 188875 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(188912), // Rule ID 3427 //
     /* 188880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 188888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188901 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 188904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188910 */     GIR_RootConstrainSelectedInstOperands,
     /* 188911 */     // GIR_Coverage, 3427,
     /* 188911 */     GIR_EraseRootFromParent_Done,
     /* 188912 */   // Label 3706: @188912
     /* 188912 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(188949), // Rule ID 3428 //
     /* 188917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 188925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188938 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 188941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188947 */     GIR_RootConstrainSelectedInstOperands,
     /* 188948 */     // GIR_Coverage, 3428,
     /* 188948 */     GIR_EraseRootFromParent_Done,
     /* 188949 */   // Label 3707: @188949
     /* 188949 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(188986), // Rule ID 3429 //
     /* 188954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 188962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188975 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 188978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188984 */     GIR_RootConstrainSelectedInstOperands,
     /* 188985 */     // GIR_Coverage, 3429,
     /* 188985 */     GIR_EraseRootFromParent_Done,
     /* 188986 */   // Label 3708: @188986
     /* 188986 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(189023), // Rule ID 3451 //
     /* 188991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 188999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 189005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 189008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189012 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 189012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 189015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189021 */     GIR_RootConstrainSelectedInstOperands,
     /* 189022 */     // GIR_Coverage, 3451,
     /* 189022 */     GIR_EraseRootFromParent_Done,
     /* 189023 */   // Label 3709: @189023
     /* 189023 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(189060), // Rule ID 3456 //
     /* 189028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 189031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 189036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 189052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189058 */     GIR_RootConstrainSelectedInstOperands,
     /* 189059 */     // GIR_Coverage, 3456,
     /* 189059 */     GIR_EraseRootFromParent_Done,
     /* 189060 */   // Label 3710: @189060
     /* 189060 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(189097), // Rule ID 3457 //
     /* 189065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 189068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 189073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 189089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189095 */     GIR_RootConstrainSelectedInstOperands,
     /* 189096 */     // GIR_Coverage, 3457,
     /* 189096 */     GIR_EraseRootFromParent_Done,
     /* 189097 */   // Label 3711: @189097
     /* 189097 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(189134), // Rule ID 3466 //
     /* 189102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189123 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189132 */     GIR_RootConstrainSelectedInstOperands,
     /* 189133 */     // GIR_Coverage, 3466,
     /* 189133 */     GIR_EraseRootFromParent_Done,
     /* 189134 */   // Label 3712: @189134
     /* 189134 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(189171), // Rule ID 3467 //
     /* 189139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189169 */     GIR_RootConstrainSelectedInstOperands,
     /* 189170 */     // GIR_Coverage, 3467,
     /* 189170 */     GIR_EraseRootFromParent_Done,
     /* 189171 */   // Label 3713: @189171
     /* 189171 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(189208), // Rule ID 3468 //
     /* 189176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189197 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2154:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189206 */     GIR_RootConstrainSelectedInstOperands,
     /* 189207 */     // GIR_Coverage, 3468,
     /* 189207 */     GIR_EraseRootFromParent_Done,
     /* 189208 */   // Label 3714: @189208
     /* 189208 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(189245), // Rule ID 3469 //
     /* 189213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189243 */     GIR_RootConstrainSelectedInstOperands,
     /* 189244 */     // GIR_Coverage, 3469,
     /* 189244 */     GIR_EraseRootFromParent_Done,
     /* 189245 */   // Label 3715: @189245
     /* 189245 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(189282), // Rule ID 3470 //
     /* 189250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189271 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2154:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189280 */     GIR_RootConstrainSelectedInstOperands,
     /* 189281 */     // GIR_Coverage, 3470,
     /* 189281 */     GIR_EraseRootFromParent_Done,
     /* 189282 */   // Label 3716: @189282
     /* 189282 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(189319), // Rule ID 3471 //
     /* 189287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189317 */     GIR_RootConstrainSelectedInstOperands,
     /* 189318 */     // GIR_Coverage, 3471,
     /* 189318 */     GIR_EraseRootFromParent_Done,
     /* 189319 */   // Label 3717: @189319
     /* 189319 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(189356), // Rule ID 3472 //
     /* 189324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 189332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189345 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2154:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 189348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189354 */     GIR_RootConstrainSelectedInstOperands,
     /* 189355 */     // GIR_Coverage, 3472,
     /* 189355 */     GIR_EraseRootFromParent_Done,
     /* 189356 */   // Label 3718: @189356
     /* 189356 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(189393), // Rule ID 3527 //
     /* 189361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 189369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189382 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 189385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189391 */     GIR_RootConstrainSelectedInstOperands,
     /* 189392 */     // GIR_Coverage, 3527,
     /* 189392 */     GIR_EraseRootFromParent_Done,
     /* 189393 */   // Label 3719: @189393
     /* 189393 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(189430), // Rule ID 3528 //
     /* 189398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 189406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189419 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 189422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189428 */     GIR_RootConstrainSelectedInstOperands,
     /* 189429 */     // GIR_Coverage, 3528,
     /* 189429 */     GIR_EraseRootFromParent_Done,
     /* 189430 */   // Label 3720: @189430
     /* 189430 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(189467), // Rule ID 3529 //
     /* 189435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 189443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189456 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 189459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189465 */     GIR_RootConstrainSelectedInstOperands,
     /* 189466 */     // GIR_Coverage, 3529,
     /* 189466 */     GIR_EraseRootFromParent_Done,
     /* 189467 */   // Label 3721: @189467
     /* 189467 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(189504), // Rule ID 3559 //
     /* 189472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 189480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 189486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189493 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 189496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189502 */     GIR_RootConstrainSelectedInstOperands,
     /* 189503 */     // GIR_Coverage, 3559,
     /* 189503 */     GIR_EraseRootFromParent_Done,
     /* 189504 */   // Label 3722: @189504
     /* 189504 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(189541), // Rule ID 3560 //
     /* 189509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 189517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189530 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 189533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189539 */     GIR_RootConstrainSelectedInstOperands,
     /* 189540 */     // GIR_Coverage, 3560,
     /* 189540 */     GIR_EraseRootFromParent_Done,
     /* 189541 */   // Label 3723: @189541
     /* 189541 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(189578), // Rule ID 3561 //
     /* 189546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 189554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189567 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 189570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189576 */     GIR_RootConstrainSelectedInstOperands,
     /* 189577 */     // GIR_Coverage, 3561,
     /* 189577 */     GIR_EraseRootFromParent_Done,
     /* 189578 */   // Label 3724: @189578
     /* 189578 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(189615), // Rule ID 3562 //
     /* 189583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 189591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189604 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 189607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189613 */     GIR_RootConstrainSelectedInstOperands,
     /* 189614 */     // GIR_Coverage, 3562,
     /* 189614 */     GIR_EraseRootFromParent_Done,
     /* 189615 */   // Label 3725: @189615
     /* 189615 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(189652), // Rule ID 3563 //
     /* 189620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2162:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 189644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189650 */     GIR_RootConstrainSelectedInstOperands,
     /* 189651 */     // GIR_Coverage, 3563,
     /* 189651 */     GIR_EraseRootFromParent_Done,
     /* 189652 */   // Label 3726: @189652
     /* 189652 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(189689), // Rule ID 3564 //
     /* 189657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189678 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2162:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 189681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189687 */     GIR_RootConstrainSelectedInstOperands,
     /* 189688 */     // GIR_Coverage, 3564,
     /* 189688 */     GIR_EraseRootFromParent_Done,
     /* 189689 */   // Label 3727: @189689
     /* 189689 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(189726), // Rule ID 3565 //
     /* 189694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 189718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189724 */     GIR_RootConstrainSelectedInstOperands,
     /* 189725 */     // GIR_Coverage, 3565,
     /* 189725 */     GIR_EraseRootFromParent_Done,
     /* 189726 */   // Label 3728: @189726
     /* 189726 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(189763), // Rule ID 3566 //
     /* 189731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 189755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189761 */     GIR_RootConstrainSelectedInstOperands,
     /* 189762 */     // GIR_Coverage, 3566,
     /* 189762 */     GIR_EraseRootFromParent_Done,
     /* 189763 */   // Label 3729: @189763
     /* 189763 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(189800), // Rule ID 3567 //
     /* 189768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189789 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2162:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 189792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189798 */     GIR_RootConstrainSelectedInstOperands,
     /* 189799 */     // GIR_Coverage, 3567,
     /* 189799 */     GIR_EraseRootFromParent_Done,
     /* 189800 */   // Label 3730: @189800
     /* 189800 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(189837), // Rule ID 3568 //
     /* 189805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189826 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2162:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 189829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189835 */     GIR_RootConstrainSelectedInstOperands,
     /* 189836 */     // GIR_Coverage, 3568,
     /* 189836 */     GIR_EraseRootFromParent_Done,
     /* 189837 */   // Label 3731: @189837
     /* 189837 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(189874), // Rule ID 3569 //
     /* 189842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 189850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189863 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2162:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 189866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189872 */     GIR_RootConstrainSelectedInstOperands,
     /* 189873 */     // GIR_Coverage, 3569,
     /* 189873 */     GIR_EraseRootFromParent_Done,
     /* 189874 */   // Label 3732: @189874
     /* 189874 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(189911), // Rule ID 3570 //
     /* 189879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 189887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189900 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1917:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 189903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189909 */     GIR_RootConstrainSelectedInstOperands,
     /* 189910 */     // GIR_Coverage, 3570,
     /* 189910 */     GIR_EraseRootFromParent_Done,
     /* 189911 */   // Label 3733: @189911
     /* 189911 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(189948), // Rule ID 3571 //
     /* 189916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 189924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189937 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 189940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189946 */     GIR_RootConstrainSelectedInstOperands,
     /* 189947 */     // GIR_Coverage, 3571,
     /* 189947 */     GIR_EraseRootFromParent_Done,
     /* 189948 */   // Label 3734: @189948
     /* 189948 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(189985), // Rule ID 3572 //
     /* 189953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 189961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 189977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189983 */     GIR_RootConstrainSelectedInstOperands,
     /* 189984 */     // GIR_Coverage, 3572,
     /* 189984 */     GIR_EraseRootFromParent_Done,
     /* 189985 */   // Label 3735: @189985
     /* 189985 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(190022), // Rule ID 3573 //
     /* 189990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 189998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190011 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 190014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190020 */     GIR_RootConstrainSelectedInstOperands,
     /* 190021 */     // GIR_Coverage, 3573,
     /* 190021 */     GIR_EraseRootFromParent_Done,
     /* 190022 */   // Label 3736: @190022
     /* 190022 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(190059), // Rule ID 3574 //
     /* 190027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 190035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190048 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1917:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 190051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190057 */     GIR_RootConstrainSelectedInstOperands,
     /* 190058 */     // GIR_Coverage, 3574,
     /* 190058 */     GIR_EraseRootFromParent_Done,
     /* 190059 */   // Label 3737: @190059
     /* 190059 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(190096), // Rule ID 3575 //
     /* 190064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 190072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190085 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1917:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 190088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190094 */     GIR_RootConstrainSelectedInstOperands,
     /* 190095 */     // GIR_Coverage, 3575,
     /* 190095 */     GIR_EraseRootFromParent_Done,
     /* 190096 */   // Label 3738: @190096
     /* 190096 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(190133), // Rule ID 3576 //
     /* 190101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 190109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190122 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1917:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 190125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190131 */     GIR_RootConstrainSelectedInstOperands,
     /* 190132 */     // GIR_Coverage, 3576,
     /* 190132 */     GIR_EraseRootFromParent_Done,
     /* 190133 */   // Label 3739: @190133
     /* 190133 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(190170), // Rule ID 8428 //
     /* 190138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 190146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 190155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190159 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1296:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 190159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 190162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190168 */     GIR_RootConstrainSelectedInstOperands,
     /* 190169 */     // GIR_Coverage, 8428,
     /* 190169 */     GIR_EraseRootFromParent_Done,
     /* 190170 */   // Label 3740: @190170
     /* 190170 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(190207), // Rule ID 8904 //
     /* 190175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 190183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1254:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 190199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190205 */     GIR_RootConstrainSelectedInstOperands,
     /* 190206 */     // GIR_Coverage, 8904,
     /* 190206 */     GIR_EraseRootFromParent_Done,
     /* 190207 */   // Label 3741: @190207
     /* 190207 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(190244), // Rule ID 8905 //
     /* 190212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 190220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1256:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 190236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190242 */     GIR_RootConstrainSelectedInstOperands,
     /* 190243 */     // GIR_Coverage, 8905,
     /* 190243 */     GIR_EraseRootFromParent_Done,
     /* 190244 */   // Label 3742: @190244
     /* 190244 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(190281), // Rule ID 8906 //
     /* 190249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 190257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 190273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190279 */     GIR_RootConstrainSelectedInstOperands,
     /* 190280 */     // GIR_Coverage, 8906,
     /* 190280 */     GIR_EraseRootFromParent_Done,
     /* 190281 */   // Label 3743: @190281
     /* 190281 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(190318), // Rule ID 8907 //
     /* 190286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 190294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 190310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190316 */     GIR_RootConstrainSelectedInstOperands,
     /* 190317 */     // GIR_Coverage, 8907,
     /* 190317 */     GIR_EraseRootFromParent_Done,
     /* 190318 */   // Label 3744: @190318
     /* 190318 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(190355), // Rule ID 8908 //
     /* 190323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 190331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190344 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 190347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190353 */     GIR_RootConstrainSelectedInstOperands,
     /* 190354 */     // GIR_Coverage, 8908,
     /* 190354 */     GIR_EraseRootFromParent_Done,
     /* 190355 */   // Label 3745: @190355
     /* 190355 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(190392), // Rule ID 8909 //
     /* 190360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 190368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1256:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 190384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190390 */     GIR_RootConstrainSelectedInstOperands,
     /* 190391 */     // GIR_Coverage, 8909,
     /* 190391 */     GIR_EraseRootFromParent_Done,
     /* 190392 */   // Label 3746: @190392
     /* 190392 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(190429), // Rule ID 8910 //
     /* 190397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 190405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 190421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190427 */     GIR_RootConstrainSelectedInstOperands,
     /* 190428 */     // GIR_Coverage, 8910,
     /* 190428 */     GIR_EraseRootFromParent_Done,
     /* 190429 */   // Label 3747: @190429
     /* 190429 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(190466), // Rule ID 8911 //
     /* 190434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 190437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 190442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 190458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190464 */     GIR_RootConstrainSelectedInstOperands,
     /* 190465 */     // GIR_Coverage, 8911,
     /* 190465 */     GIR_EraseRootFromParent_Done,
     /* 190466 */   // Label 3748: @190466
     /* 190466 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(190506), // Rule ID 9911 //
     /* 190471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190492 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 190495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190504 */     GIR_RootConstrainSelectedInstOperands,
     /* 190505 */     // GIR_Coverage, 9911,
     /* 190505 */     GIR_EraseRootFromParent_Done,
     /* 190506 */   // Label 3749: @190506
     /* 190506 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(190546), // Rule ID 9912 //
     /* 190511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190532 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 190535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190544 */     GIR_RootConstrainSelectedInstOperands,
     /* 190545 */     // GIR_Coverage, 9912,
     /* 190545 */     GIR_EraseRootFromParent_Done,
     /* 190546 */   // Label 3750: @190546
     /* 190546 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(190586), // Rule ID 9913 //
     /* 190551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 190575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190584 */     GIR_RootConstrainSelectedInstOperands,
     /* 190585 */     // GIR_Coverage, 9913,
     /* 190585 */     GIR_EraseRootFromParent_Done,
     /* 190586 */   // Label 3751: @190586
     /* 190586 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(190626), // Rule ID 9914 //
     /* 190591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190612 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 190615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190624 */     GIR_RootConstrainSelectedInstOperands,
     /* 190625 */     // GIR_Coverage, 9914,
     /* 190625 */     GIR_EraseRootFromParent_Done,
     /* 190626 */   // Label 3752: @190626
     /* 190626 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(190666), // Rule ID 9915 //
     /* 190631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 190639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 190655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190664 */     GIR_RootConstrainSelectedInstOperands,
     /* 190665 */     // GIR_Coverage, 9915,
     /* 190665 */     GIR_EraseRootFromParent_Done,
     /* 190666 */   // Label 3753: @190666
     /* 190666 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(190706), // Rule ID 9916 //
     /* 190671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 190679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190692 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 190695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190704 */     GIR_RootConstrainSelectedInstOperands,
     /* 190705 */     // GIR_Coverage, 9916,
     /* 190705 */     GIR_EraseRootFromParent_Done,
     /* 190706 */   // Label 3754: @190706
     /* 190706 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(190746), // Rule ID 9917 //
     /* 190711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 190719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190732 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 190735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190744 */     GIR_RootConstrainSelectedInstOperands,
     /* 190745 */     // GIR_Coverage, 9917,
     /* 190745 */     GIR_EraseRootFromParent_Done,
     /* 190746 */   // Label 3755: @190746
     /* 190746 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(190786), // Rule ID 9918 //
     /* 190751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 190759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 190775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190784 */     GIR_RootConstrainSelectedInstOperands,
     /* 190785 */     // GIR_Coverage, 9918,
     /* 190785 */     GIR_EraseRootFromParent_Done,
     /* 190786 */   // Label 3756: @190786
     /* 190786 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(190826), // Rule ID 9923 //
     /* 190791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 190799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190812 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 190815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190824 */     GIR_RootConstrainSelectedInstOperands,
     /* 190825 */     // GIR_Coverage, 9923,
     /* 190825 */     GIR_EraseRootFromParent_Done,
     /* 190826 */   // Label 3757: @190826
     /* 190826 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(190866), // Rule ID 9924 //
     /* 190831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 190839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 190855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190864 */     GIR_RootConstrainSelectedInstOperands,
     /* 190865 */     // GIR_Coverage, 9924,
     /* 190865 */     GIR_EraseRootFromParent_Done,
     /* 190866 */   // Label 3758: @190866
     /* 190866 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(190906), // Rule ID 9925 //
     /* 190871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 190879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190892 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 190895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190904 */     GIR_RootConstrainSelectedInstOperands,
     /* 190905 */     // GIR_Coverage, 9925,
     /* 190905 */     GIR_EraseRootFromParent_Done,
     /* 190906 */   // Label 3759: @190906
     /* 190906 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(190946), // Rule ID 9926 //
     /* 190911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 190919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 190935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190944 */     GIR_RootConstrainSelectedInstOperands,
     /* 190945 */     // GIR_Coverage, 9926,
     /* 190945 */     GIR_EraseRootFromParent_Done,
     /* 190946 */   // Label 3760: @190946
     /* 190946 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(190986), // Rule ID 9927 //
     /* 190951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 190965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 190968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 190972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 190975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190984 */     GIR_RootConstrainSelectedInstOperands,
     /* 190985 */     // GIR_Coverage, 9927,
     /* 190985 */     GIR_EraseRootFromParent_Done,
     /* 190986 */   // Label 3761: @190986
     /* 190986 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(191026), // Rule ID 9928 //
     /* 190991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 190999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191012 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 191015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191024 */     GIR_RootConstrainSelectedInstOperands,
     /* 191025 */     // GIR_Coverage, 9928,
     /* 191025 */     GIR_EraseRootFromParent_Done,
     /* 191026 */   // Label 3762: @191026
     /* 191026 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(191066), // Rule ID 9929 //
     /* 191031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 191039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 191055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191064 */     GIR_RootConstrainSelectedInstOperands,
     /* 191065 */     // GIR_Coverage, 9929,
     /* 191065 */     GIR_EraseRootFromParent_Done,
     /* 191066 */   // Label 3763: @191066
     /* 191066 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(191106), // Rule ID 9930 //
     /* 191071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 191079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191092 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 191095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191104 */     GIR_RootConstrainSelectedInstOperands,
     /* 191105 */     // GIR_Coverage, 9930,
     /* 191105 */     GIR_EraseRootFromParent_Done,
     /* 191106 */   // Label 3764: @191106
     /* 191106 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(191146), // Rule ID 9931 //
     /* 191111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 191119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 191135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191144 */     GIR_RootConstrainSelectedInstOperands,
     /* 191145 */     // GIR_Coverage, 9931,
     /* 191145 */     GIR_EraseRootFromParent_Done,
     /* 191146 */   // Label 3765: @191146
     /* 191146 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(191186), // Rule ID 9932 //
     /* 191151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 191159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191172 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 191175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191184 */     GIR_RootConstrainSelectedInstOperands,
     /* 191185 */     // GIR_Coverage, 9932,
     /* 191185 */     GIR_EraseRootFromParent_Done,
     /* 191186 */   // Label 3766: @191186
     /* 191186 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(191226), // Rule ID 9933 //
     /* 191191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 191199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191212 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 191215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191224 */     GIR_RootConstrainSelectedInstOperands,
     /* 191225 */     // GIR_Coverage, 9933,
     /* 191225 */     GIR_EraseRootFromParent_Done,
     /* 191226 */   // Label 3767: @191226
     /* 191226 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(191266), // Rule ID 9934 //
     /* 191231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 191239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 191255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191264 */     GIR_RootConstrainSelectedInstOperands,
     /* 191265 */     // GIR_Coverage, 9934,
     /* 191265 */     GIR_EraseRootFromParent_Done,
     /* 191266 */   // Label 3768: @191266
     /* 191266 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(191306), // Rule ID 9939 //
     /* 191271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 191279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191292 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 191295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191304 */     GIR_RootConstrainSelectedInstOperands,
     /* 191305 */     // GIR_Coverage, 9939,
     /* 191305 */     GIR_EraseRootFromParent_Done,
     /* 191306 */   // Label 3769: @191306
     /* 191306 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(191346), // Rule ID 9940 //
     /* 191311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 191319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 191335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191344 */     GIR_RootConstrainSelectedInstOperands,
     /* 191345 */     // GIR_Coverage, 9940,
     /* 191345 */     GIR_EraseRootFromParent_Done,
     /* 191346 */   // Label 3770: @191346
     /* 191346 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(191386), // Rule ID 9941 //
     /* 191351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 191359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191372 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 191375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191384 */     GIR_RootConstrainSelectedInstOperands,
     /* 191385 */     // GIR_Coverage, 9941,
     /* 191385 */     GIR_EraseRootFromParent_Done,
     /* 191386 */   // Label 3771: @191386
     /* 191386 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(191426), // Rule ID 9942 //
     /* 191391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 191399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191412 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 191415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191424 */     GIR_RootConstrainSelectedInstOperands,
     /* 191425 */     // GIR_Coverage, 9942,
     /* 191425 */     GIR_EraseRootFromParent_Done,
     /* 191426 */   // Label 3772: @191426
     /* 191426 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(191463), // Rule ID 10101 //
     /* 191431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 191439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 191448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2024:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 191452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 191455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191461 */     GIR_RootConstrainSelectedInstOperands,
     /* 191462 */     // GIR_Coverage, 10101,
     /* 191462 */     GIR_EraseRootFromParent_Done,
     /* 191463 */   // Label 3773: @191463
     /* 191463 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(191500), // Rule ID 10102 //
     /* 191468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 191476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 191485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2024:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 191489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 191492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191498 */     GIR_RootConstrainSelectedInstOperands,
     /* 191499 */     // GIR_Coverage, 10102,
     /* 191499 */     GIR_EraseRootFromParent_Done,
     /* 191500 */   // Label 3774: @191500
     /* 191500 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(191537), // Rule ID 10103 //
     /* 191505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 191513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 191522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191526 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2024:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 191526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 191529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191535 */     GIR_RootConstrainSelectedInstOperands,
     /* 191536 */     // GIR_Coverage, 10103,
     /* 191536 */     GIR_EraseRootFromParent_Done,
     /* 191537 */   // Label 3775: @191537
     /* 191537 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(191574), // Rule ID 10104 //
     /* 191542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 191550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 191559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191563 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 191563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 191566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191572 */     GIR_RootConstrainSelectedInstOperands,
     /* 191573 */     // GIR_Coverage, 10104,
     /* 191573 */     GIR_EraseRootFromParent_Done,
     /* 191574 */   // Label 3776: @191574
     /* 191574 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(191611), // Rule ID 10105 //
     /* 191579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 191587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 191596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 191600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 191603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191609 */     GIR_RootConstrainSelectedInstOperands,
     /* 191610 */     // GIR_Coverage, 10105,
     /* 191610 */     GIR_EraseRootFromParent_Done,
     /* 191611 */   // Label 3777: @191611
     /* 191611 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(191648), // Rule ID 10106 //
     /* 191616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 191624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 191633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 191637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 191640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191646 */     GIR_RootConstrainSelectedInstOperands,
     /* 191647 */     // GIR_Coverage, 10106,
     /* 191647 */     GIR_EraseRootFromParent_Done,
     /* 191648 */   // Label 3778: @191648
     /* 191648 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(191685), // Rule ID 10107 //
     /* 191653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 191661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 191670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191674 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2010:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 191674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 191677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191683 */     GIR_RootConstrainSelectedInstOperands,
     /* 191684 */     // GIR_Coverage, 10107,
     /* 191684 */     GIR_EraseRootFromParent_Done,
     /* 191685 */   // Label 3779: @191685
     /* 191685 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(191722), // Rule ID 10108 //
     /* 191690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 191698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 191707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2010:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 191711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 191714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191720 */     GIR_RootConstrainSelectedInstOperands,
     /* 191721 */     // GIR_Coverage, 10108,
     /* 191721 */     GIR_EraseRootFromParent_Done,
     /* 191722 */   // Label 3780: @191722
     /* 191722 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(191759), // Rule ID 10109 //
     /* 191727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 191730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 191735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 191744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 191748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 191751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191757 */     GIR_RootConstrainSelectedInstOperands,
     /* 191758 */     // GIR_Coverage, 10109,
     /* 191758 */     GIR_EraseRootFromParent_Done,
     /* 191759 */   // Label 3781: @191759
     /* 191759 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(191796), // Rule ID 11297 //
     /* 191764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191785 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2159:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191794 */     GIR_RootConstrainSelectedInstOperands,
     /* 191795 */     // GIR_Coverage, 11297,
     /* 191795 */     GIR_EraseRootFromParent_Done,
     /* 191796 */   // Label 3782: @191796
     /* 191796 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(191833), // Rule ID 11298 //
     /* 191801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2159:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191831 */     GIR_RootConstrainSelectedInstOperands,
     /* 191832 */     // GIR_Coverage, 11298,
     /* 191832 */     GIR_EraseRootFromParent_Done,
     /* 191833 */   // Label 3783: @191833
     /* 191833 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(191870), // Rule ID 11299 //
     /* 191838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191859 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2159:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191868 */     GIR_RootConstrainSelectedInstOperands,
     /* 191869 */     // GIR_Coverage, 11299,
     /* 191869 */     GIR_EraseRootFromParent_Done,
     /* 191870 */   // Label 3784: @191870
     /* 191870 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(191907), // Rule ID 11300 //
     /* 191875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2159:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191905 */     GIR_RootConstrainSelectedInstOperands,
     /* 191906 */     // GIR_Coverage, 11300,
     /* 191906 */     GIR_EraseRootFromParent_Done,
     /* 191907 */   // Label 3785: @191907
     /* 191907 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(191944), // Rule ID 11301 //
     /* 191912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191933 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2159:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191942 */     GIR_RootConstrainSelectedInstOperands,
     /* 191943 */     // GIR_Coverage, 11301,
     /* 191943 */     GIR_EraseRootFromParent_Done,
     /* 191944 */   // Label 3786: @191944
     /* 191944 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(191981), // Rule ID 11302 //
     /* 191949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2159:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 191973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191979 */     GIR_RootConstrainSelectedInstOperands,
     /* 191980 */     // GIR_Coverage, 11302,
     /* 191980 */     GIR_EraseRootFromParent_Done,
     /* 191981 */   // Label 3787: @191981
     /* 191981 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(192018), // Rule ID 11303 //
     /* 191986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 191994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192007 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2159:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 192010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192016 */     GIR_RootConstrainSelectedInstOperands,
     /* 192017 */     // GIR_Coverage, 11303,
     /* 192017 */     GIR_EraseRootFromParent_Done,
     /* 192018 */   // Label 3788: @192018
     /* 192018 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(192055), // Rule ID 11304 //
     /* 192023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2080:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192053 */     GIR_RootConstrainSelectedInstOperands,
     /* 192054 */     // GIR_Coverage, 11304,
     /* 192054 */     GIR_EraseRootFromParent_Done,
     /* 192055 */   // Label 3789: @192055
     /* 192055 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(192092), // Rule ID 11305 //
     /* 192060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2080:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192090 */     GIR_RootConstrainSelectedInstOperands,
     /* 192091 */     // GIR_Coverage, 11305,
     /* 192091 */     GIR_EraseRootFromParent_Done,
     /* 192092 */   // Label 3790: @192092
     /* 192092 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(192129), // Rule ID 11306 //
     /* 192097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2080:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192127 */     GIR_RootConstrainSelectedInstOperands,
     /* 192128 */     // GIR_Coverage, 11306,
     /* 192128 */     GIR_EraseRootFromParent_Done,
     /* 192129 */   // Label 3791: @192129
     /* 192129 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(192166), // Rule ID 11307 //
     /* 192134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2080:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192164 */     GIR_RootConstrainSelectedInstOperands,
     /* 192165 */     // GIR_Coverage, 11307,
     /* 192165 */     GIR_EraseRootFromParent_Done,
     /* 192166 */   // Label 3792: @192166
     /* 192166 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(192203), // Rule ID 11308 //
     /* 192171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192192 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2080:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192201 */     GIR_RootConstrainSelectedInstOperands,
     /* 192202 */     // GIR_Coverage, 11308,
     /* 192202 */     GIR_EraseRootFromParent_Done,
     /* 192203 */   // Label 3793: @192203
     /* 192203 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(192240), // Rule ID 11309 //
     /* 192208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192229 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2080:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192238 */     GIR_RootConstrainSelectedInstOperands,
     /* 192239 */     // GIR_Coverage, 11309,
     /* 192239 */     GIR_EraseRootFromParent_Done,
     /* 192240 */   // Label 3794: @192240
     /* 192240 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(192277), // Rule ID 11310 //
     /* 192245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 192253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192266 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2080:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 192269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192275 */     GIR_RootConstrainSelectedInstOperands,
     /* 192276 */     // GIR_Coverage, 11310,
     /* 192276 */     GIR_EraseRootFromParent_Done,
     /* 192277 */   // Label 3795: @192277
     /* 192277 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(192314), // Rule ID 11311 //
     /* 192282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192303 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2085:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192312 */     GIR_RootConstrainSelectedInstOperands,
     /* 192313 */     // GIR_Coverage, 11311,
     /* 192313 */     GIR_EraseRootFromParent_Done,
     /* 192314 */   // Label 3796: @192314
     /* 192314 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(192351), // Rule ID 11312 //
     /* 192319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2085:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192349 */     GIR_RootConstrainSelectedInstOperands,
     /* 192350 */     // GIR_Coverage, 11312,
     /* 192350 */     GIR_EraseRootFromParent_Done,
     /* 192351 */   // Label 3797: @192351
     /* 192351 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(192388), // Rule ID 11313 //
     /* 192356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2085:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192386 */     GIR_RootConstrainSelectedInstOperands,
     /* 192387 */     // GIR_Coverage, 11313,
     /* 192387 */     GIR_EraseRootFromParent_Done,
     /* 192388 */   // Label 3798: @192388
     /* 192388 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(192425), // Rule ID 11314 //
     /* 192393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2085:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192423 */     GIR_RootConstrainSelectedInstOperands,
     /* 192424 */     // GIR_Coverage, 11314,
     /* 192424 */     GIR_EraseRootFromParent_Done,
     /* 192425 */   // Label 3799: @192425
     /* 192425 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(192462), // Rule ID 11315 //
     /* 192430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192451 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2085:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192460 */     GIR_RootConstrainSelectedInstOperands,
     /* 192461 */     // GIR_Coverage, 11315,
     /* 192461 */     GIR_EraseRootFromParent_Done,
     /* 192462 */   // Label 3800: @192462
     /* 192462 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(192499), // Rule ID 11316 //
     /* 192467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2085:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192497 */     GIR_RootConstrainSelectedInstOperands,
     /* 192498 */     // GIR_Coverage, 11316,
     /* 192498 */     GIR_EraseRootFromParent_Done,
     /* 192499 */   // Label 3801: @192499
     /* 192499 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(192536), // Rule ID 11317 //
     /* 192504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 192512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192525 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2085:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 192528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192534 */     GIR_RootConstrainSelectedInstOperands,
     /* 192535 */     // GIR_Coverage, 11317,
     /* 192535 */     GIR_EraseRootFromParent_Done,
     /* 192536 */   // Label 3802: @192536
     /* 192536 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(192573), // Rule ID 11318 //
     /* 192541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192571 */     GIR_RootConstrainSelectedInstOperands,
     /* 192572 */     // GIR_Coverage, 11318,
     /* 192572 */     GIR_EraseRootFromParent_Done,
     /* 192573 */   // Label 3803: @192573
     /* 192573 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(192610), // Rule ID 11319 //
     /* 192578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192608 */     GIR_RootConstrainSelectedInstOperands,
     /* 192609 */     // GIR_Coverage, 11319,
     /* 192609 */     GIR_EraseRootFromParent_Done,
     /* 192610 */   // Label 3804: @192610
     /* 192610 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(192647), // Rule ID 11320 //
     /* 192615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192636 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1924:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192645 */     GIR_RootConstrainSelectedInstOperands,
     /* 192646 */     // GIR_Coverage, 11320,
     /* 192646 */     GIR_EraseRootFromParent_Done,
     /* 192647 */   // Label 3805: @192647
     /* 192647 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(192684), // Rule ID 11321 //
     /* 192652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192682 */     GIR_RootConstrainSelectedInstOperands,
     /* 192683 */     // GIR_Coverage, 11321,
     /* 192683 */     GIR_EraseRootFromParent_Done,
     /* 192684 */   // Label 3806: @192684
     /* 192684 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(192721), // Rule ID 11322 //
     /* 192689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192710 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1924:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192719 */     GIR_RootConstrainSelectedInstOperands,
     /* 192720 */     // GIR_Coverage, 11322,
     /* 192720 */     GIR_EraseRootFromParent_Done,
     /* 192721 */   // Label 3807: @192721
     /* 192721 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(192758), // Rule ID 11323 //
     /* 192726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192747 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192756 */     GIR_RootConstrainSelectedInstOperands,
     /* 192757 */     // GIR_Coverage, 11323,
     /* 192757 */     GIR_EraseRootFromParent_Done,
     /* 192758 */   // Label 3808: @192758
     /* 192758 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(192795), // Rule ID 11324 //
     /* 192763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 192771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1924:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 192787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192793 */     GIR_RootConstrainSelectedInstOperands,
     /* 192794 */     // GIR_Coverage, 11324,
     /* 192794 */     GIR_EraseRootFromParent_Done,
     /* 192795 */   // Label 3809: @192795
     /* 192795 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(192832), // Rule ID 11325 //
     /* 192800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192821 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192830 */     GIR_RootConstrainSelectedInstOperands,
     /* 192831 */     // GIR_Coverage, 11325,
     /* 192831 */     GIR_EraseRootFromParent_Done,
     /* 192832 */   // Label 3810: @192832
     /* 192832 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(192869), // Rule ID 11326 //
     /* 192837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192867 */     GIR_RootConstrainSelectedInstOperands,
     /* 192868 */     // GIR_Coverage, 11326,
     /* 192868 */     GIR_EraseRootFromParent_Done,
     /* 192869 */   // Label 3811: @192869
     /* 192869 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(192906), // Rule ID 11327 //
     /* 192874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192895 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1929:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192904 */     GIR_RootConstrainSelectedInstOperands,
     /* 192905 */     // GIR_Coverage, 11327,
     /* 192905 */     GIR_EraseRootFromParent_Done,
     /* 192906 */   // Label 3812: @192906
     /* 192906 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(192943), // Rule ID 11328 //
     /* 192911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192941 */     GIR_RootConstrainSelectedInstOperands,
     /* 192942 */     // GIR_Coverage, 11328,
     /* 192942 */     GIR_EraseRootFromParent_Done,
     /* 192943 */   // Label 3813: @192943
     /* 192943 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(192980), // Rule ID 11329 //
     /* 192948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192969 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1929:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 192972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192978 */     GIR_RootConstrainSelectedInstOperands,
     /* 192979 */     // GIR_Coverage, 11329,
     /* 192979 */     GIR_EraseRootFromParent_Done,
     /* 192980 */   // Label 3814: @192980
     /* 192980 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(193017), // Rule ID 11330 //
     /* 192985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 192988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 192993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 193009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193015 */     GIR_RootConstrainSelectedInstOperands,
     /* 193016 */     // GIR_Coverage, 11330,
     /* 193016 */     GIR_EraseRootFromParent_Done,
     /* 193017 */   // Label 3815: @193017
     /* 193017 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(193054), // Rule ID 11331 //
     /* 193022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 193025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 193030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1929:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 193043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 193046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193052 */     GIR_RootConstrainSelectedInstOperands,
     /* 193053 */     // GIR_Coverage, 11331,
     /* 193053 */     GIR_EraseRootFromParent_Done,
     /* 193054 */   // Label 3816: @193054
     /* 193054 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(193091), // Rule ID 11351 //
     /* 193059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 193067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193080 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 193083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193089 */     GIR_RootConstrainSelectedInstOperands,
     /* 193090 */     // GIR_Coverage, 11351,
     /* 193090 */     GIR_EraseRootFromParent_Done,
     /* 193091 */   // Label 3817: @193091
     /* 193091 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(193128), // Rule ID 11352 //
     /* 193096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 193104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 193120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193126 */     GIR_RootConstrainSelectedInstOperands,
     /* 193127 */     // GIR_Coverage, 11352,
     /* 193127 */     GIR_EraseRootFromParent_Done,
     /* 193128 */   // Label 3818: @193128
     /* 193128 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(193165), // Rule ID 11353 //
     /* 193133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 193141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 193157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193163 */     GIR_RootConstrainSelectedInstOperands,
     /* 193164 */     // GIR_Coverage, 11353,
     /* 193164 */     GIR_EraseRootFromParent_Done,
     /* 193165 */   // Label 3819: @193165
     /* 193165 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(193202), // Rule ID 11354 //
     /* 193170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 193178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 193194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193200 */     GIR_RootConstrainSelectedInstOperands,
     /* 193201 */     // GIR_Coverage, 11354,
     /* 193201 */     GIR_EraseRootFromParent_Done,
     /* 193202 */   // Label 3820: @193202
     /* 193202 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(193239), // Rule ID 11642 //
     /* 193207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 193215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 193231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193237 */     GIR_RootConstrainSelectedInstOperands,
     /* 193238 */     // GIR_Coverage, 11642,
     /* 193238 */     GIR_EraseRootFromParent_Done,
     /* 193239 */   // Label 3821: @193239
     /* 193239 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(193276), // Rule ID 11643 //
     /* 193244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 193252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 193268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193274 */     GIR_RootConstrainSelectedInstOperands,
     /* 193275 */     // GIR_Coverage, 11643,
     /* 193275 */     GIR_EraseRootFromParent_Done,
     /* 193276 */   // Label 3822: @193276
     /* 193276 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(193313), // Rule ID 11644 //
     /* 193281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 193289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 193305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193311 */     GIR_RootConstrainSelectedInstOperands,
     /* 193312 */     // GIR_Coverage, 11644,
     /* 193312 */     GIR_EraseRootFromParent_Done,
     /* 193313 */   // Label 3823: @193313
     /* 193313 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(193350), // Rule ID 11645 //
     /* 193318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 193326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 193342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193348 */     GIR_RootConstrainSelectedInstOperands,
     /* 193349 */     // GIR_Coverage, 11645,
     /* 193349 */     GIR_EraseRootFromParent_Done,
     /* 193350 */   // Label 3824: @193350
     /* 193350 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(193387), // Rule ID 11646 //
     /* 193355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 193363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 193379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193385 */     GIR_RootConstrainSelectedInstOperands,
     /* 193386 */     // GIR_Coverage, 11646,
     /* 193386 */     GIR_EraseRootFromParent_Done,
     /* 193387 */   // Label 3825: @193387
     /* 193387 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(193424), // Rule ID 11647 //
     /* 193392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 193400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193413 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 193416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193422 */     GIR_RootConstrainSelectedInstOperands,
     /* 193423 */     // GIR_Coverage, 11647,
     /* 193423 */     GIR_EraseRootFromParent_Done,
     /* 193424 */   // Label 3826: @193424
     /* 193424 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(193461), // Rule ID 11648 //
     /* 193429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 193437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193450 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 193453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193459 */     GIR_RootConstrainSelectedInstOperands,
     /* 193460 */     // GIR_Coverage, 11648,
     /* 193460 */     GIR_EraseRootFromParent_Done,
     /* 193461 */   // Label 3827: @193461
     /* 193461 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(193498), // Rule ID 11649 //
     /* 193466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 193474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 193490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193496 */     GIR_RootConstrainSelectedInstOperands,
     /* 193497 */     // GIR_Coverage, 11649,
     /* 193497 */     GIR_EraseRootFromParent_Done,
     /* 193498 */   // Label 3828: @193498
     /* 193498 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(193535), // Rule ID 11650 //
     /* 193503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 193511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 193527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193533 */     GIR_RootConstrainSelectedInstOperands,
     /* 193534 */     // GIR_Coverage, 11650,
     /* 193534 */     GIR_EraseRootFromParent_Done,
     /* 193535 */   // Label 3829: @193535
     /* 193535 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(193572), // Rule ID 11651 //
     /* 193540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 193548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 193564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193570 */     GIR_RootConstrainSelectedInstOperands,
     /* 193571 */     // GIR_Coverage, 11651,
     /* 193571 */     GIR_EraseRootFromParent_Done,
     /* 193572 */   // Label 3830: @193572
     /* 193572 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(193609), // Rule ID 11652 //
     /* 193577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 193585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 193601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193607 */     GIR_RootConstrainSelectedInstOperands,
     /* 193608 */     // GIR_Coverage, 11652,
     /* 193608 */     GIR_EraseRootFromParent_Done,
     /* 193609 */   // Label 3831: @193609
     /* 193609 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(193646), // Rule ID 11653 //
     /* 193614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 193622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193635 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 193638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193644 */     GIR_RootConstrainSelectedInstOperands,
     /* 193645 */     // GIR_Coverage, 11653,
     /* 193645 */     GIR_EraseRootFromParent_Done,
     /* 193646 */   // Label 3832: @193646
     /* 193646 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(193683), // Rule ID 11654 //
     /* 193651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 193659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 193675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193681 */     GIR_RootConstrainSelectedInstOperands,
     /* 193682 */     // GIR_Coverage, 11654,
     /* 193682 */     GIR_EraseRootFromParent_Done,
     /* 193683 */   // Label 3833: @193683
     /* 193683 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(193720), // Rule ID 11655 //
     /* 193688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 193696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 193712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193718 */     GIR_RootConstrainSelectedInstOperands,
     /* 193719 */     // GIR_Coverage, 11655,
     /* 193719 */     GIR_EraseRootFromParent_Done,
     /* 193720 */   // Label 3834: @193720
     /* 193720 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(193757), // Rule ID 11656 //
     /* 193725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 193733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 193749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193755 */     GIR_RootConstrainSelectedInstOperands,
     /* 193756 */     // GIR_Coverage, 11656,
     /* 193756 */     GIR_EraseRootFromParent_Done,
     /* 193757 */   // Label 3835: @193757
     /* 193757 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(193794), // Rule ID 11657 //
     /* 193762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 193770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193783 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 193786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193792 */     GIR_RootConstrainSelectedInstOperands,
     /* 193793 */     // GIR_Coverage, 11657,
     /* 193793 */     GIR_EraseRootFromParent_Done,
     /* 193794 */   // Label 3836: @193794
     /* 193794 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(193831), // Rule ID 11658 //
     /* 193799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 193807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 193823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193829 */     GIR_RootConstrainSelectedInstOperands,
     /* 193830 */     // GIR_Coverage, 11658,
     /* 193830 */     GIR_EraseRootFromParent_Done,
     /* 193831 */   // Label 3837: @193831
     /* 193831 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(193868), // Rule ID 11659 //
     /* 193836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 193844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193857 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 193860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193866 */     GIR_RootConstrainSelectedInstOperands,
     /* 193867 */     // GIR_Coverage, 11659,
     /* 193867 */     GIR_EraseRootFromParent_Done,
     /* 193868 */   // Label 3838: @193868
     /* 193868 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(193905), // Rule ID 11660 //
     /* 193873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 193881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2064:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 193897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193903 */     GIR_RootConstrainSelectedInstOperands,
     /* 193904 */     // GIR_Coverage, 11660,
     /* 193904 */     GIR_EraseRootFromParent_Done,
     /* 193905 */   // Label 3839: @193905
     /* 193905 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(193942), // Rule ID 11661 //
     /* 193910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 193918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193931 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 193934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193940 */     GIR_RootConstrainSelectedInstOperands,
     /* 193941 */     // GIR_Coverage, 11661,
     /* 193941 */     GIR_EraseRootFromParent_Done,
     /* 193942 */   // Label 3840: @193942
     /* 193942 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(193979), // Rule ID 11662 //
     /* 193947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 193955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 193971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193977 */     GIR_RootConstrainSelectedInstOperands,
     /* 193978 */     // GIR_Coverage, 11662,
     /* 193978 */     GIR_EraseRootFromParent_Done,
     /* 193979 */   // Label 3841: @193979
     /* 193979 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(194016), // Rule ID 11663 //
     /* 193984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 193992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194005 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 194008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194014 */     GIR_RootConstrainSelectedInstOperands,
     /* 194015 */     // GIR_Coverage, 11663,
     /* 194015 */     GIR_EraseRootFromParent_Done,
     /* 194016 */   // Label 3842: @194016
     /* 194016 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(194053), // Rule ID 11664 //
     /* 194021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 194029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 194045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194051 */     GIR_RootConstrainSelectedInstOperands,
     /* 194052 */     // GIR_Coverage, 11664,
     /* 194052 */     GIR_EraseRootFromParent_Done,
     /* 194053 */   // Label 3843: @194053
     /* 194053 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(194090), // Rule ID 11665 //
     /* 194058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 194066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194079 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 194082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194088 */     GIR_RootConstrainSelectedInstOperands,
     /* 194089 */     // GIR_Coverage, 11665,
     /* 194089 */     GIR_EraseRootFromParent_Done,
     /* 194090 */   // Label 3844: @194090
     /* 194090 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(194127), // Rule ID 11666 //
     /* 194095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 194103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 194119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194125 */     GIR_RootConstrainSelectedInstOperands,
     /* 194126 */     // GIR_Coverage, 11666,
     /* 194126 */     GIR_EraseRootFromParent_Done,
     /* 194127 */   // Label 3845: @194127
     /* 194127 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(194164), // Rule ID 11667 //
     /* 194132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 194140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 194156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194162 */     GIR_RootConstrainSelectedInstOperands,
     /* 194163 */     // GIR_Coverage, 11667,
     /* 194163 */     GIR_EraseRootFromParent_Done,
     /* 194164 */   // Label 3846: @194164
     /* 194164 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(194201), // Rule ID 11668 //
     /* 194169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 194177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 194193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194199 */     GIR_RootConstrainSelectedInstOperands,
     /* 194200 */     // GIR_Coverage, 11668,
     /* 194200 */     GIR_EraseRootFromParent_Done,
     /* 194201 */   // Label 3847: @194201
     /* 194201 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(194238), // Rule ID 11669 //
     /* 194206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 194214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1935:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 194230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194236 */     GIR_RootConstrainSelectedInstOperands,
     /* 194237 */     // GIR_Coverage, 11669,
     /* 194237 */     GIR_EraseRootFromParent_Done,
     /* 194238 */   // Label 3848: @194238
     /* 194238 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(194275), // Rule ID 11670 //
     /* 194243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 194251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1935:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 194267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194273 */     GIR_RootConstrainSelectedInstOperands,
     /* 194274 */     // GIR_Coverage, 11670,
     /* 194274 */     GIR_EraseRootFromParent_Done,
     /* 194275 */   // Label 3849: @194275
     /* 194275 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(194312), // Rule ID 11671 //
     /* 194280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 194288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194301 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1935:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 194304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194310 */     GIR_RootConstrainSelectedInstOperands,
     /* 194311 */     // GIR_Coverage, 11671,
     /* 194311 */     GIR_EraseRootFromParent_Done,
     /* 194312 */   // Label 3850: @194312
     /* 194312 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(194349), // Rule ID 11672 //
     /* 194317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 194325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194338 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 194341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194347 */     GIR_RootConstrainSelectedInstOperands,
     /* 194348 */     // GIR_Coverage, 11672,
     /* 194348 */     GIR_EraseRootFromParent_Done,
     /* 194349 */   // Label 3851: @194349
     /* 194349 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(194386), // Rule ID 11673 //
     /* 194354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 194362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 194378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194384 */     GIR_RootConstrainSelectedInstOperands,
     /* 194385 */     // GIR_Coverage, 11673,
     /* 194385 */     GIR_EraseRootFromParent_Done,
     /* 194386 */   // Label 3852: @194386
     /* 194386 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(194423), // Rule ID 11674 //
     /* 194391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 194399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 194415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194421 */     GIR_RootConstrainSelectedInstOperands,
     /* 194422 */     // GIR_Coverage, 11674,
     /* 194422 */     GIR_EraseRootFromParent_Done,
     /* 194423 */   // Label 3853: @194423
     /* 194423 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(194460), // Rule ID 11684 //
     /* 194428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 194436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 194452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194458 */     GIR_RootConstrainSelectedInstOperands,
     /* 194459 */     // GIR_Coverage, 11684,
     /* 194459 */     GIR_EraseRootFromParent_Done,
     /* 194460 */   // Label 3854: @194460
     /* 194460 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(194497), // Rule ID 11685 //
     /* 194465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 194473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 194489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194495 */     GIR_RootConstrainSelectedInstOperands,
     /* 194496 */     // GIR_Coverage, 11685,
     /* 194496 */     GIR_EraseRootFromParent_Done,
     /* 194497 */   // Label 3855: @194497
     /* 194497 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(194534), // Rule ID 11686 //
     /* 194502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 194510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 194526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194532 */     GIR_RootConstrainSelectedInstOperands,
     /* 194533 */     // GIR_Coverage, 11686,
     /* 194533 */     GIR_EraseRootFromParent_Done,
     /* 194534 */   // Label 3856: @194534
     /* 194534 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(194571), // Rule ID 11687 //
     /* 194539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 194547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 194563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194569 */     GIR_RootConstrainSelectedInstOperands,
     /* 194570 */     // GIR_Coverage, 11687,
     /* 194570 */     GIR_EraseRootFromParent_Done,
     /* 194571 */   // Label 3857: @194571
     /* 194571 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(194608), // Rule ID 11688 //
     /* 194576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 194584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 194600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194606 */     GIR_RootConstrainSelectedInstOperands,
     /* 194607 */     // GIR_Coverage, 11688,
     /* 194607 */     GIR_EraseRootFromParent_Done,
     /* 194608 */   // Label 3858: @194608
     /* 194608 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(194645), // Rule ID 11689 //
     /* 194613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 194621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 194637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194643 */     GIR_RootConstrainSelectedInstOperands,
     /* 194644 */     // GIR_Coverage, 11689,
     /* 194644 */     GIR_EraseRootFromParent_Done,
     /* 194645 */   // Label 3859: @194645
     /* 194645 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(194682), // Rule ID 11690 //
     /* 194650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 194658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 194674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194680 */     GIR_RootConstrainSelectedInstOperands,
     /* 194681 */     // GIR_Coverage, 11690,
     /* 194681 */     GIR_EraseRootFromParent_Done,
     /* 194682 */   // Label 3860: @194682
     /* 194682 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(194719), // Rule ID 11691 //
     /* 194687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 194695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 194711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194717 */     GIR_RootConstrainSelectedInstOperands,
     /* 194718 */     // GIR_Coverage, 11691,
     /* 194718 */     GIR_EraseRootFromParent_Done,
     /* 194719 */   // Label 3861: @194719
     /* 194719 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(194756), // Rule ID 11692 //
     /* 194724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 194732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194745 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 194748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194754 */     GIR_RootConstrainSelectedInstOperands,
     /* 194755 */     // GIR_Coverage, 11692,
     /* 194755 */     GIR_EraseRootFromParent_Done,
     /* 194756 */   // Label 3862: @194756
     /* 194756 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(194793), // Rule ID 11693 //
     /* 194761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 194769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 194785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194791 */     GIR_RootConstrainSelectedInstOperands,
     /* 194792 */     // GIR_Coverage, 11693,
     /* 194792 */     GIR_EraseRootFromParent_Done,
     /* 194793 */   // Label 3863: @194793
     /* 194793 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(194830), // Rule ID 11694 //
     /* 194798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 194806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 194822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194828 */     GIR_RootConstrainSelectedInstOperands,
     /* 194829 */     // GIR_Coverage, 11694,
     /* 194829 */     GIR_EraseRootFromParent_Done,
     /* 194830 */   // Label 3864: @194830
     /* 194830 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(194867), // Rule ID 11695 //
     /* 194835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 194843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194856 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 194859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194865 */     GIR_RootConstrainSelectedInstOperands,
     /* 194866 */     // GIR_Coverage, 11695,
     /* 194866 */     GIR_EraseRootFromParent_Done,
     /* 194867 */   // Label 3865: @194867
     /* 194867 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(194904), // Rule ID 11696 //
     /* 194872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 194880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1801:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 194896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194902 */     GIR_RootConstrainSelectedInstOperands,
     /* 194903 */     // GIR_Coverage, 11696,
     /* 194903 */     GIR_EraseRootFromParent_Done,
     /* 194904 */   // Label 3866: @194904
     /* 194904 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(194941), // Rule ID 11697 //
     /* 194909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 194917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 194933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194939 */     GIR_RootConstrainSelectedInstOperands,
     /* 194940 */     // GIR_Coverage, 11697,
     /* 194940 */     GIR_EraseRootFromParent_Done,
     /* 194941 */   // Label 3867: @194941
     /* 194941 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(194978), // Rule ID 11698 //
     /* 194946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 194954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194967 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 194970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194976 */     GIR_RootConstrainSelectedInstOperands,
     /* 194977 */     // GIR_Coverage, 11698,
     /* 194977 */     GIR_EraseRootFromParent_Done,
     /* 194978 */   // Label 3868: @194978
     /* 194978 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(195015), // Rule ID 11699 //
     /* 194983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 194991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195004 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 195007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195013 */     GIR_RootConstrainSelectedInstOperands,
     /* 195014 */     // GIR_Coverage, 11699,
     /* 195014 */     GIR_EraseRootFromParent_Done,
     /* 195015 */   // Label 3869: @195015
     /* 195015 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(195052), // Rule ID 11700 //
     /* 195020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 195028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 195044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195050 */     GIR_RootConstrainSelectedInstOperands,
     /* 195051 */     // GIR_Coverage, 11700,
     /* 195051 */     GIR_EraseRootFromParent_Done,
     /* 195052 */   // Label 3870: @195052
     /* 195052 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(195089), // Rule ID 11701 //
     /* 195057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 195065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195078 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 195081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195087 */     GIR_RootConstrainSelectedInstOperands,
     /* 195088 */     // GIR_Coverage, 11701,
     /* 195088 */     GIR_EraseRootFromParent_Done,
     /* 195089 */   // Label 3871: @195089
     /* 195089 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(195126), // Rule ID 11702 //
     /* 195094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 195102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 195118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195124 */     GIR_RootConstrainSelectedInstOperands,
     /* 195125 */     // GIR_Coverage, 11702,
     /* 195125 */     GIR_EraseRootFromParent_Done,
     /* 195126 */   // Label 3872: @195126
     /* 195126 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(195163), // Rule ID 11703 //
     /* 195131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 195139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 195155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195161 */     GIR_RootConstrainSelectedInstOperands,
     /* 195162 */     // GIR_Coverage, 11703,
     /* 195162 */     GIR_EraseRootFromParent_Done,
     /* 195163 */   // Label 3873: @195163
     /* 195163 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(195200), // Rule ID 11704 //
     /* 195168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 195176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 195192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195198 */     GIR_RootConstrainSelectedInstOperands,
     /* 195199 */     // GIR_Coverage, 11704,
     /* 195199 */     GIR_EraseRootFromParent_Done,
     /* 195200 */   // Label 3874: @195200
     /* 195200 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(195237), // Rule ID 11705 //
     /* 195205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 195213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 195229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195235 */     GIR_RootConstrainSelectedInstOperands,
     /* 195236 */     // GIR_Coverage, 11705,
     /* 195236 */     GIR_EraseRootFromParent_Done,
     /* 195237 */   // Label 3875: @195237
     /* 195237 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(195274), // Rule ID 11706 //
     /* 195242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 195250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 195266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195272 */     GIR_RootConstrainSelectedInstOperands,
     /* 195273 */     // GIR_Coverage, 11706,
     /* 195273 */     GIR_EraseRootFromParent_Done,
     /* 195274 */   // Label 3876: @195274
     /* 195274 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(195311), // Rule ID 11707 //
     /* 195279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 195287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 195303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195309 */     GIR_RootConstrainSelectedInstOperands,
     /* 195310 */     // GIR_Coverage, 11707,
     /* 195310 */     GIR_EraseRootFromParent_Done,
     /* 195311 */   // Label 3877: @195311
     /* 195311 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(195348), // Rule ID 11708 //
     /* 195316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 195324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1992:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 195340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195346 */     GIR_RootConstrainSelectedInstOperands,
     /* 195347 */     // GIR_Coverage, 11708,
     /* 195347 */     GIR_EraseRootFromParent_Done,
     /* 195348 */   // Label 3878: @195348
     /* 195348 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(195385), // Rule ID 11709 //
     /* 195353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 195361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 195377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195383 */     GIR_RootConstrainSelectedInstOperands,
     /* 195384 */     // GIR_Coverage, 11709,
     /* 195384 */     GIR_EraseRootFromParent_Done,
     /* 195385 */   // Label 3879: @195385
     /* 195385 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(195422), // Rule ID 11710 //
     /* 195390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 195398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 195414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195420 */     GIR_RootConstrainSelectedInstOperands,
     /* 195421 */     // GIR_Coverage, 11710,
     /* 195421 */     GIR_EraseRootFromParent_Done,
     /* 195422 */   // Label 3880: @195422
     /* 195422 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(195459), // Rule ID 11711 //
     /* 195427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 195435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 195451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195457 */     GIR_RootConstrainSelectedInstOperands,
     /* 195458 */     // GIR_Coverage, 11711,
     /* 195458 */     GIR_EraseRootFromParent_Done,
     /* 195459 */   // Label 3881: @195459
     /* 195459 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(195496), // Rule ID 11712 //
     /* 195464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 195472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195485 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 195488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195494 */     GIR_RootConstrainSelectedInstOperands,
     /* 195495 */     // GIR_Coverage, 11712,
     /* 195495 */     GIR_EraseRootFromParent_Done,
     /* 195496 */   // Label 3882: @195496
     /* 195496 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(195533), // Rule ID 11713 //
     /* 195501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 195509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 195525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195531 */     GIR_RootConstrainSelectedInstOperands,
     /* 195532 */     // GIR_Coverage, 11713,
     /* 195532 */     GIR_EraseRootFromParent_Done,
     /* 195533 */   // Label 3883: @195533
     /* 195533 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(195570), // Rule ID 11714 //
     /* 195538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 195546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195559 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1632:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 195562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195568 */     GIR_RootConstrainSelectedInstOperands,
     /* 195569 */     // GIR_Coverage, 11714,
     /* 195569 */     GIR_EraseRootFromParent_Done,
     /* 195570 */   // Label 3884: @195570
     /* 195570 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(195607), // Rule ID 11715 //
     /* 195575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 195583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1632:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 195599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195605 */     GIR_RootConstrainSelectedInstOperands,
     /* 195606 */     // GIR_Coverage, 11715,
     /* 195606 */     GIR_EraseRootFromParent_Done,
     /* 195607 */   // Label 3885: @195607
     /* 195607 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(195644), // Rule ID 11816 //
     /* 195612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 195620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195633 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 195636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195642 */     GIR_RootConstrainSelectedInstOperands,
     /* 195643 */     // GIR_Coverage, 11816,
     /* 195643 */     GIR_EraseRootFromParent_Done,
     /* 195644 */   // Label 3886: @195644
     /* 195644 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(195681), // Rule ID 11817 //
     /* 195649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 195657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 195673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195679 */     GIR_RootConstrainSelectedInstOperands,
     /* 195680 */     // GIR_Coverage, 11817,
     /* 195680 */     GIR_EraseRootFromParent_Done,
     /* 195681 */   // Label 3887: @195681
     /* 195681 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(195718), // Rule ID 11818 //
     /* 195686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 195694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195707 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 195710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195716 */     GIR_RootConstrainSelectedInstOperands,
     /* 195717 */     // GIR_Coverage, 11818,
     /* 195717 */     GIR_EraseRootFromParent_Done,
     /* 195718 */   // Label 3888: @195718
     /* 195718 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(195755), // Rule ID 11819 //
     /* 195723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 195731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 195747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195753 */     GIR_RootConstrainSelectedInstOperands,
     /* 195754 */     // GIR_Coverage, 11819,
     /* 195754 */     GIR_EraseRootFromParent_Done,
     /* 195755 */   // Label 3889: @195755
     /* 195755 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(195792), // Rule ID 11820 //
     /* 195760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 195768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195781 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 195784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195790 */     GIR_RootConstrainSelectedInstOperands,
     /* 195791 */     // GIR_Coverage, 11820,
     /* 195791 */     GIR_EraseRootFromParent_Done,
     /* 195792 */   // Label 3890: @195792
     /* 195792 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195829), // Rule ID 11821 //
     /* 195797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 195805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 195821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195827 */     GIR_RootConstrainSelectedInstOperands,
     /* 195828 */     // GIR_Coverage, 11821,
     /* 195828 */     GIR_EraseRootFromParent_Done,
     /* 195829 */   // Label 3891: @195829
     /* 195829 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195866), // Rule ID 11822 //
     /* 195834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 195842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195855 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1678:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 195858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195864 */     GIR_RootConstrainSelectedInstOperands,
     /* 195865 */     // GIR_Coverage, 11822,
     /* 195865 */     GIR_EraseRootFromParent_Done,
     /* 195866 */   // Label 3892: @195866
     /* 195866 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195903), // Rule ID 11823 //
     /* 195871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 195879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1678:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 195895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195901 */     GIR_RootConstrainSelectedInstOperands,
     /* 195902 */     // GIR_Coverage, 11823,
     /* 195902 */     GIR_EraseRootFromParent_Done,
     /* 195903 */   // Label 3893: @195903
     /* 195903 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195940), // Rule ID 11824 //
     /* 195908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 195916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1678:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 195932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195938 */     GIR_RootConstrainSelectedInstOperands,
     /* 195939 */     // GIR_Coverage, 11824,
     /* 195939 */     GIR_EraseRootFromParent_Done,
     /* 195940 */   // Label 3894: @195940
     /* 195940 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195977), // Rule ID 11840 //
     /* 195945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 195953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195966 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 195969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195975 */     GIR_RootConstrainSelectedInstOperands,
     /* 195976 */     // GIR_Coverage, 11840,
     /* 195976 */     GIR_EraseRootFromParent_Done,
     /* 195977 */   // Label 3895: @195977
     /* 195977 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(196014), // Rule ID 11841 //
     /* 195982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 195990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196003 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 196006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196012 */     GIR_RootConstrainSelectedInstOperands,
     /* 196013 */     // GIR_Coverage, 11841,
     /* 196013 */     GIR_EraseRootFromParent_Done,
     /* 196014 */   // Label 3896: @196014
     /* 196014 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(196051), // Rule ID 11842 //
     /* 196019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 196027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 196043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196049 */     GIR_RootConstrainSelectedInstOperands,
     /* 196050 */     // GIR_Coverage, 11842,
     /* 196050 */     GIR_EraseRootFromParent_Done,
     /* 196051 */   // Label 3897: @196051
     /* 196051 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(196088), // Rule ID 11843 //
     /* 196056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 196064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 196067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 196080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196086 */     GIR_RootConstrainSelectedInstOperands,
     /* 196087 */     // GIR_Coverage, 11843,
     /* 196087 */     GIR_EraseRootFromParent_Done,
     /* 196088 */   // Label 3898: @196088
     /* 196088 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(196125), // Rule ID 11844 //
     /* 196093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 196101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 196117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196123 */     GIR_RootConstrainSelectedInstOperands,
     /* 196124 */     // GIR_Coverage, 11844,
     /* 196124 */     GIR_EraseRootFromParent_Done,
     /* 196125 */   // Label 3899: @196125
     /* 196125 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(196162), // Rule ID 11845 //
     /* 196130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 196138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 196154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196160 */     GIR_RootConstrainSelectedInstOperands,
     /* 196161 */     // GIR_Coverage, 11845,
     /* 196161 */     GIR_EraseRootFromParent_Done,
     /* 196162 */   // Label 3900: @196162
     /* 196162 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(196199), // Rule ID 11861 //
     /* 196167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 196175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 196191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196197 */     GIR_RootConstrainSelectedInstOperands,
     /* 196198 */     // GIR_Coverage, 11861,
     /* 196198 */     GIR_EraseRootFromParent_Done,
     /* 196199 */   // Label 3901: @196199
     /* 196199 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(196236), // Rule ID 11862 //
     /* 196204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 196212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196225 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 196228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196234 */     GIR_RootConstrainSelectedInstOperands,
     /* 196235 */     // GIR_Coverage, 11862,
     /* 196235 */     GIR_EraseRootFromParent_Done,
     /* 196236 */   // Label 3902: @196236
     /* 196236 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(196273), // Rule ID 11863 //
     /* 196241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 196249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196262 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 196265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196271 */     GIR_RootConstrainSelectedInstOperands,
     /* 196272 */     // GIR_Coverage, 11863,
     /* 196272 */     GIR_EraseRootFromParent_Done,
     /* 196273 */   // Label 3903: @196273
     /* 196273 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(196310), // Rule ID 11864 //
     /* 196278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 196286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 196302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196308 */     GIR_RootConstrainSelectedInstOperands,
     /* 196309 */     // GIR_Coverage, 11864,
     /* 196309 */     GIR_EraseRootFromParent_Done,
     /* 196310 */   // Label 3904: @196310
     /* 196310 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(196347), // Rule ID 11865 //
     /* 196315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 196323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 196339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196345 */     GIR_RootConstrainSelectedInstOperands,
     /* 196346 */     // GIR_Coverage, 11865,
     /* 196346 */     GIR_EraseRootFromParent_Done,
     /* 196347 */   // Label 3905: @196347
     /* 196347 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(196384), // Rule ID 11866 //
     /* 196352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 196360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 196376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196382 */     GIR_RootConstrainSelectedInstOperands,
     /* 196383 */     // GIR_Coverage, 11866,
     /* 196383 */     GIR_EraseRootFromParent_Done,
     /* 196384 */   // Label 3906: @196384
     /* 196384 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(196424), // Rule ID 11941 //
     /* 196389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 196397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196410 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 196413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196422 */     GIR_RootConstrainSelectedInstOperands,
     /* 196423 */     // GIR_Coverage, 11941,
     /* 196423 */     GIR_EraseRootFromParent_Done,
     /* 196424 */   // Label 3907: @196424
     /* 196424 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(196464), // Rule ID 11942 //
     /* 196429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 196437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196450 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 196453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196462 */     GIR_RootConstrainSelectedInstOperands,
     /* 196463 */     // GIR_Coverage, 11942,
     /* 196463 */     GIR_EraseRootFromParent_Done,
     /* 196464 */   // Label 3908: @196464
     /* 196464 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196504), // Rule ID 11943 //
     /* 196469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 196477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196490 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 196493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196502 */     GIR_RootConstrainSelectedInstOperands,
     /* 196503 */     // GIR_Coverage, 11943,
     /* 196503 */     GIR_EraseRootFromParent_Done,
     /* 196504 */   // Label 3909: @196504
     /* 196504 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196544), // Rule ID 11944 //
     /* 196509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 196517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 196520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 196533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196542 */     GIR_RootConstrainSelectedInstOperands,
     /* 196543 */     // GIR_Coverage, 11944,
     /* 196543 */     GIR_EraseRootFromParent_Done,
     /* 196544 */   // Label 3910: @196544
     /* 196544 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196584), // Rule ID 11945 //
     /* 196549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 196557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196570 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 196573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196582 */     GIR_RootConstrainSelectedInstOperands,
     /* 196583 */     // GIR_Coverage, 11945,
     /* 196583 */     GIR_EraseRootFromParent_Done,
     /* 196584 */   // Label 3911: @196584
     /* 196584 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196624), // Rule ID 11946 //
     /* 196589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 196597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196610 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 196613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196622 */     GIR_RootConstrainSelectedInstOperands,
     /* 196623 */     // GIR_Coverage, 11946,
     /* 196623 */     GIR_EraseRootFromParent_Done,
     /* 196624 */   // Label 3912: @196624
     /* 196624 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196664), // Rule ID 11947 //
     /* 196629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 196637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 196653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196662 */     GIR_RootConstrainSelectedInstOperands,
     /* 196663 */     // GIR_Coverage, 11947,
     /* 196663 */     GIR_EraseRootFromParent_Done,
     /* 196664 */   // Label 3913: @196664
     /* 196664 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196704), // Rule ID 11948 //
     /* 196669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 196677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 196680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196690 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 196693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196702 */     GIR_RootConstrainSelectedInstOperands,
     /* 196703 */     // GIR_Coverage, 11948,
     /* 196703 */     GIR_EraseRootFromParent_Done,
     /* 196704 */   // Label 3914: @196704
     /* 196704 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196744), // Rule ID 11953 //
     /* 196709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 196717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 196733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196742 */     GIR_RootConstrainSelectedInstOperands,
     /* 196743 */     // GIR_Coverage, 11953,
     /* 196743 */     GIR_EraseRootFromParent_Done,
     /* 196744 */   // Label 3915: @196744
     /* 196744 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196784), // Rule ID 11954 //
     /* 196749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 196757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 196773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196782 */     GIR_RootConstrainSelectedInstOperands,
     /* 196783 */     // GIR_Coverage, 11954,
     /* 196783 */     GIR_EraseRootFromParent_Done,
     /* 196784 */   // Label 3916: @196784
     /* 196784 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196824), // Rule ID 11955 //
     /* 196789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 196797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 196813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196822 */     GIR_RootConstrainSelectedInstOperands,
     /* 196823 */     // GIR_Coverage, 11955,
     /* 196823 */     GIR_EraseRootFromParent_Done,
     /* 196824 */   // Label 3917: @196824
     /* 196824 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196864), // Rule ID 11956 //
     /* 196829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 196837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 196840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196850 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 196853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196862 */     GIR_RootConstrainSelectedInstOperands,
     /* 196863 */     // GIR_Coverage, 11956,
     /* 196863 */     GIR_EraseRootFromParent_Done,
     /* 196864 */   // Label 3918: @196864
     /* 196864 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196904), // Rule ID 11957 //
     /* 196869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196890 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 196893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196902 */     GIR_RootConstrainSelectedInstOperands,
     /* 196903 */     // GIR_Coverage, 11957,
     /* 196903 */     GIR_EraseRootFromParent_Done,
     /* 196904 */   // Label 3919: @196904
     /* 196904 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196944), // Rule ID 11958 //
     /* 196909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196930 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 196933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196942 */     GIR_RootConstrainSelectedInstOperands,
     /* 196943 */     // GIR_Coverage, 11958,
     /* 196943 */     GIR_EraseRootFromParent_Done,
     /* 196944 */   // Label 3920: @196944
     /* 196944 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(196984), // Rule ID 11959 //
     /* 196949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196970 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 196970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 196973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196982 */     GIR_RootConstrainSelectedInstOperands,
     /* 196983 */     // GIR_Coverage, 11959,
     /* 196983 */     GIR_EraseRootFromParent_Done,
     /* 196984 */   // Label 3921: @196984
     /* 196984 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(197024), // Rule ID 11960 //
     /* 196989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197010 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 197010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 197013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197022 */     GIR_RootConstrainSelectedInstOperands,
     /* 197023 */     // GIR_Coverage, 11960,
     /* 197023 */     GIR_EraseRootFromParent_Done,
     /* 197024 */   // Label 3922: @197024
     /* 197024 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(197064), // Rule ID 11965 //
     /* 197029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 197037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197050 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 197053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197062 */     GIR_RootConstrainSelectedInstOperands,
     /* 197063 */     // GIR_Coverage, 11965,
     /* 197063 */     GIR_EraseRootFromParent_Done,
     /* 197064 */   // Label 3923: @197064
     /* 197064 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(197104), // Rule ID 11966 //
     /* 197069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 197077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197090 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 197093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197102 */     GIR_RootConstrainSelectedInstOperands,
     /* 197103 */     // GIR_Coverage, 11966,
     /* 197103 */     GIR_EraseRootFromParent_Done,
     /* 197104 */   // Label 3924: @197104
     /* 197104 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(197144), // Rule ID 11967 //
     /* 197109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 197117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 197133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197142 */     GIR_RootConstrainSelectedInstOperands,
     /* 197143 */     // GIR_Coverage, 11967,
     /* 197143 */     GIR_EraseRootFromParent_Done,
     /* 197144 */   // Label 3925: @197144
     /* 197144 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(197184), // Rule ID 11968 //
     /* 197149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 197157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197170 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 197173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197182 */     GIR_RootConstrainSelectedInstOperands,
     /* 197183 */     // GIR_Coverage, 11968,
     /* 197183 */     GIR_EraseRootFromParent_Done,
     /* 197184 */   // Label 3926: @197184
     /* 197184 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(197224), // Rule ID 11969 //
     /* 197189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 197197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197210 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 197213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197222 */     GIR_RootConstrainSelectedInstOperands,
     /* 197223 */     // GIR_Coverage, 11969,
     /* 197223 */     GIR_EraseRootFromParent_Done,
     /* 197224 */   // Label 3927: @197224
     /* 197224 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(197264), // Rule ID 11970 //
     /* 197229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 197237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197250 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 197253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197262 */     GIR_RootConstrainSelectedInstOperands,
     /* 197263 */     // GIR_Coverage, 11970,
     /* 197263 */     GIR_EraseRootFromParent_Done,
     /* 197264 */   // Label 3928: @197264
     /* 197264 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(197304), // Rule ID 11971 //
     /* 197269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 197277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197290 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 197293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197302 */     GIR_RootConstrainSelectedInstOperands,
     /* 197303 */     // GIR_Coverage, 11971,
     /* 197303 */     GIR_EraseRootFromParent_Done,
     /* 197304 */   // Label 3929: @197304
     /* 197304 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(197344), // Rule ID 11972 //
     /* 197309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 197317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 197333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197342 */     GIR_RootConstrainSelectedInstOperands,
     /* 197343 */     // GIR_Coverage, 11972,
     /* 197343 */     GIR_EraseRootFromParent_Done,
     /* 197344 */   // Label 3930: @197344
     /* 197344 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(197384), // Rule ID 11977 //
     /* 197349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 197357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 197373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197382 */     GIR_RootConstrainSelectedInstOperands,
     /* 197383 */     // GIR_Coverage, 11977,
     /* 197383 */     GIR_EraseRootFromParent_Done,
     /* 197384 */   // Label 3931: @197384
     /* 197384 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(197424), // Rule ID 11978 //
     /* 197389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 197397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 197413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197422 */     GIR_RootConstrainSelectedInstOperands,
     /* 197423 */     // GIR_Coverage, 11978,
     /* 197423 */     GIR_EraseRootFromParent_Done,
     /* 197424 */   // Label 3932: @197424
     /* 197424 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(197464), // Rule ID 11979 //
     /* 197429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 197437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 197453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197462 */     GIR_RootConstrainSelectedInstOperands,
     /* 197463 */     // GIR_Coverage, 11979,
     /* 197463 */     GIR_EraseRootFromParent_Done,
     /* 197464 */   // Label 3933: @197464
     /* 197464 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(197504), // Rule ID 11980 //
     /* 197469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 197477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197490 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 197493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197502 */     GIR_RootConstrainSelectedInstOperands,
     /* 197503 */     // GIR_Coverage, 11980,
     /* 197503 */     GIR_EraseRootFromParent_Done,
     /* 197504 */   // Label 3934: @197504
     /* 197504 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(197544), // Rule ID 11981 //
     /* 197509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 197533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197542 */     GIR_RootConstrainSelectedInstOperands,
     /* 197543 */     // GIR_Coverage, 11981,
     /* 197543 */     GIR_EraseRootFromParent_Done,
     /* 197544 */   // Label 3935: @197544
     /* 197544 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197584), // Rule ID 11982 //
     /* 197549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197570 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 197573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197582 */     GIR_RootConstrainSelectedInstOperands,
     /* 197583 */     // GIR_Coverage, 11982,
     /* 197583 */     GIR_EraseRootFromParent_Done,
     /* 197584 */   // Label 3936: @197584
     /* 197584 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197624), // Rule ID 11983 //
     /* 197589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 197613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197622 */     GIR_RootConstrainSelectedInstOperands,
     /* 197623 */     // GIR_Coverage, 11983,
     /* 197623 */     GIR_EraseRootFromParent_Done,
     /* 197624 */   // Label 3937: @197624
     /* 197624 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197664), // Rule ID 11984 //
     /* 197629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 197637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197650 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 197653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197662 */     GIR_RootConstrainSelectedInstOperands,
     /* 197663 */     // GIR_Coverage, 11984,
     /* 197663 */     GIR_EraseRootFromParent_Done,
     /* 197664 */   // Label 3938: @197664
     /* 197664 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197701), // Rule ID 11993 //
     /* 197669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 197672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 197677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197690 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 197693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197699 */     GIR_RootConstrainSelectedInstOperands,
     /* 197700 */     // GIR_Coverage, 11993,
     /* 197700 */     GIR_EraseRootFromParent_Done,
     /* 197701 */   // Label 3939: @197701
     /* 197701 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197738), // Rule ID 11995 //
     /* 197706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 197709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 197714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197727 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1632:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 197730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197736 */     GIR_RootConstrainSelectedInstOperands,
     /* 197737 */     // GIR_Coverage, 11995,
     /* 197737 */     GIR_EraseRootFromParent_Done,
     /* 197738 */   // Label 3940: @197738
     /* 197738 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197775), // Rule ID 11996 //
     /* 197743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 197746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 197751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1723:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 197767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197773 */     GIR_RootConstrainSelectedInstOperands,
     /* 197774 */     // GIR_Coverage, 11996,
     /* 197774 */     GIR_EraseRootFromParent_Done,
     /* 197775 */   // Label 3941: @197775
     /* 197775 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197812), // Rule ID 11997 //
     /* 197780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 197783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 197788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197801 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 197804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197810 */     GIR_RootConstrainSelectedInstOperands,
     /* 197811 */     // GIR_Coverage, 11997,
     /* 197811 */     GIR_EraseRootFromParent_Done,
     /* 197812 */   // Label 3942: @197812
     /* 197812 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(197849), // Rule ID 11998 //
     /* 197817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 197825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197838 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1272:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 197841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197847 */     GIR_RootConstrainSelectedInstOperands,
     /* 197848 */     // GIR_Coverage, 11998,
     /* 197848 */     GIR_EraseRootFromParent_Done,
     /* 197849 */   // Label 3943: @197849
     /* 197849 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(197886), // Rule ID 11999 //
     /* 197854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 197862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1272:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 197878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197884 */     GIR_RootConstrainSelectedInstOperands,
     /* 197885 */     // GIR_Coverage, 11999,
     /* 197885 */     GIR_EraseRootFromParent_Done,
     /* 197886 */   // Label 3944: @197886
     /* 197886 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(197923), // Rule ID 12000 //
     /* 197891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 197899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1272:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 197915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197921 */     GIR_RootConstrainSelectedInstOperands,
     /* 197922 */     // GIR_Coverage, 12000,
     /* 197922 */     GIR_EraseRootFromParent_Done,
     /* 197923 */   // Label 3945: @197923
     /* 197923 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(197960), // Rule ID 12001 //
     /* 197928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 197936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197949 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1272:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 197952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197958 */     GIR_RootConstrainSelectedInstOperands,
     /* 197959 */     // GIR_Coverage, 12001,
     /* 197959 */     GIR_EraseRootFromParent_Done,
     /* 197960 */   // Label 3946: @197960
     /* 197960 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(197997), // Rule ID 12002 //
     /* 197965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 197968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 197973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197986 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1289:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 197989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197995 */     GIR_RootConstrainSelectedInstOperands,
     /* 197996 */     // GIR_Coverage, 12002,
     /* 197996 */     GIR_EraseRootFromParent_Done,
     /* 197997 */   // Label 3947: @197997
     /* 197997 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(198034), // Rule ID 12003 //
     /* 198002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 198005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 198010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198023 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1289:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 198026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198032 */     GIR_RootConstrainSelectedInstOperands,
     /* 198033 */     // GIR_Coverage, 12003,
     /* 198033 */     GIR_EraseRootFromParent_Done,
     /* 198034 */   // Label 3948: @198034
     /* 198034 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(198071), // Rule ID 12004 //
     /* 198039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 198042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 198047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1289:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 198063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198069 */     GIR_RootConstrainSelectedInstOperands,
     /* 198070 */     // GIR_Coverage, 12004,
     /* 198070 */     GIR_EraseRootFromParent_Done,
     /* 198071 */   // Label 3949: @198071
     /* 198071 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(198108), // Rule ID 12005 //
     /* 198076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 198079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 198084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198097 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1289:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 198100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198106 */     GIR_RootConstrainSelectedInstOperands,
     /* 198107 */     // GIR_Coverage, 12005,
     /* 198107 */     GIR_EraseRootFromParent_Done,
     /* 198108 */   // Label 3950: @198108
     /* 198108 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(198145), // Rule ID 12118 //
     /* 198113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 198121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198134 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1438:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 198137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198143 */     GIR_RootConstrainSelectedInstOperands,
     /* 198144 */     // GIR_Coverage, 12118,
     /* 198144 */     GIR_EraseRootFromParent_Done,
     /* 198145 */   // Label 3951: @198145
     /* 198145 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(198182), // Rule ID 12119 //
     /* 198150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 198158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198171 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1438:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 198174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198180 */     GIR_RootConstrainSelectedInstOperands,
     /* 198181 */     // GIR_Coverage, 12119,
     /* 198181 */     GIR_EraseRootFromParent_Done,
     /* 198182 */   // Label 3952: @198182
     /* 198182 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(198219), // Rule ID 12120 //
     /* 198187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 198195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198208 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1438:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 198211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198217 */     GIR_RootConstrainSelectedInstOperands,
     /* 198218 */     // GIR_Coverage, 12120,
     /* 198218 */     GIR_EraseRootFromParent_Done,
     /* 198219 */   // Label 3953: @198219
     /* 198219 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(198256), // Rule ID 12121 //
     /* 198224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 198232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198245 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 198248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198254 */     GIR_RootConstrainSelectedInstOperands,
     /* 198255 */     // GIR_Coverage, 12121,
     /* 198255 */     GIR_EraseRootFromParent_Done,
     /* 198256 */   // Label 3954: @198256
     /* 198256 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(198293), // Rule ID 12122 //
     /* 198261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 198269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198282 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 198285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198291 */     GIR_RootConstrainSelectedInstOperands,
     /* 198292 */     // GIR_Coverage, 12122,
     /* 198292 */     GIR_EraseRootFromParent_Done,
     /* 198293 */   // Label 3955: @198293
     /* 198293 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(198330), // Rule ID 12123 //
     /* 198298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 198306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198319 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 198322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198328 */     GIR_RootConstrainSelectedInstOperands,
     /* 198329 */     // GIR_Coverage, 12123,
     /* 198329 */     GIR_EraseRootFromParent_Done,
     /* 198330 */   // Label 3956: @198330
     /* 198330 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(198367), // Rule ID 12124 //
     /* 198335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 198343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198356 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 198359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198365 */     GIR_RootConstrainSelectedInstOperands,
     /* 198366 */     // GIR_Coverage, 12124,
     /* 198366 */     GIR_EraseRootFromParent_Done,
     /* 198367 */   // Label 3957: @198367
     /* 198367 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(198404), // Rule ID 12125 //
     /* 198372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 198380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198393 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 198396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198402 */     GIR_RootConstrainSelectedInstOperands,
     /* 198403 */     // GIR_Coverage, 12125,
     /* 198403 */     GIR_EraseRootFromParent_Done,
     /* 198404 */   // Label 3958: @198404
     /* 198404 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(198441), // Rule ID 12126 //
     /* 198409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 198417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198430 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 198433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198439 */     GIR_RootConstrainSelectedInstOperands,
     /* 198440 */     // GIR_Coverage, 12126,
     /* 198440 */     GIR_EraseRootFromParent_Done,
     /* 198441 */   // Label 3959: @198441
     /* 198441 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(198478), // Rule ID 12127 //
     /* 198446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 198454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198467 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1459:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 198470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198476 */     GIR_RootConstrainSelectedInstOperands,
     /* 198477 */     // GIR_Coverage, 12127,
     /* 198477 */     GIR_EraseRootFromParent_Done,
     /* 198478 */   // Label 3960: @198478
     /* 198478 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(198515), // Rule ID 12128 //
     /* 198483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 198491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198504 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1459:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 198507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198513 */     GIR_RootConstrainSelectedInstOperands,
     /* 198514 */     // GIR_Coverage, 12128,
     /* 198514 */     GIR_EraseRootFromParent_Done,
     /* 198515 */   // Label 3961: @198515
     /* 198515 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(198552), // Rule ID 12129 //
     /* 198520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 198528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198541 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1459:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 198544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198550 */     GIR_RootConstrainSelectedInstOperands,
     /* 198551 */     // GIR_Coverage, 12129,
     /* 198551 */     GIR_EraseRootFromParent_Done,
     /* 198552 */   // Label 3962: @198552
     /* 198552 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198589), // Rule ID 12130 //
     /* 198557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 198565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 198571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198578 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1353:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 198581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198587 */     GIR_RootConstrainSelectedInstOperands,
     /* 198588 */     // GIR_Coverage, 12130,
     /* 198588 */     GIR_EraseRootFromParent_Done,
     /* 198589 */   // Label 3963: @198589
     /* 198589 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198626), // Rule ID 12131 //
     /* 198594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 198602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198615 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 198618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198624 */     GIR_RootConstrainSelectedInstOperands,
     /* 198625 */     // GIR_Coverage, 12131,
     /* 198625 */     GIR_EraseRootFromParent_Done,
     /* 198626 */   // Label 3964: @198626
     /* 198626 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198663), // Rule ID 12132 //
     /* 198631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 198639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198652 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 198655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198661 */     GIR_RootConstrainSelectedInstOperands,
     /* 198662 */     // GIR_Coverage, 12132,
     /* 198662 */     GIR_EraseRootFromParent_Done,
     /* 198663 */   // Label 3965: @198663
     /* 198663 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(198700), // Rule ID 12133 //
     /* 198668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 198676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198689 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 198692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198698 */     GIR_RootConstrainSelectedInstOperands,
     /* 198699 */     // GIR_Coverage, 12133,
     /* 198699 */     GIR_EraseRootFromParent_Done,
     /* 198700 */   // Label 3966: @198700
     /* 198700 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(198737), // Rule ID 12134 //
     /* 198705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 198713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 198719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198726 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1265:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 198729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198735 */     GIR_RootConstrainSelectedInstOperands,
     /* 198736 */     // GIR_Coverage, 12134,
     /* 198736 */     GIR_EraseRootFromParent_Done,
     /* 198737 */   // Label 3967: @198737
     /* 198737 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198774), // Rule ID 12135 //
     /* 198742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 198750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198763 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 198766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198772 */     GIR_RootConstrainSelectedInstOperands,
     /* 198773 */     // GIR_Coverage, 12135,
     /* 198773 */     GIR_EraseRootFromParent_Done,
     /* 198774 */   // Label 3968: @198774
     /* 198774 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(198811), // Rule ID 12136 //
     /* 198779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 198787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198800 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 198803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198809 */     GIR_RootConstrainSelectedInstOperands,
     /* 198810 */     // GIR_Coverage, 12136,
     /* 198810 */     GIR_EraseRootFromParent_Done,
     /* 198811 */   // Label 3969: @198811
     /* 198811 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(198848), // Rule ID 12137 //
     /* 198816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 198824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198837 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 198840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198846 */     GIR_RootConstrainSelectedInstOperands,
     /* 198847 */     // GIR_Coverage, 12137,
     /* 198847 */     GIR_EraseRootFromParent_Done,
     /* 198848 */   // Label 3970: @198848
     /* 198848 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(198885), // Rule ID 12138 //
     /* 198853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 198861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 198867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198874 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 198877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198883 */     GIR_RootConstrainSelectedInstOperands,
     /* 198884 */     // GIR_Coverage, 12138,
     /* 198884 */     GIR_EraseRootFromParent_Done,
     /* 198885 */   // Label 3971: @198885
     /* 198885 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(198922), // Rule ID 12139 //
     /* 198890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 198898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198911 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 198914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198920 */     GIR_RootConstrainSelectedInstOperands,
     /* 198921 */     // GIR_Coverage, 12139,
     /* 198921 */     GIR_EraseRootFromParent_Done,
     /* 198922 */   // Label 3972: @198922
     /* 198922 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(198959), // Rule ID 12140 //
     /* 198927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 198935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198948 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 198951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198957 */     GIR_RootConstrainSelectedInstOperands,
     /* 198958 */     // GIR_Coverage, 12140,
     /* 198958 */     GIR_EraseRootFromParent_Done,
     /* 198959 */   // Label 3973: @198959
     /* 198959 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(198996), // Rule ID 12141 //
     /* 198964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 198972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198985 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 198988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198994 */     GIR_RootConstrainSelectedInstOperands,
     /* 198995 */     // GIR_Coverage, 12141,
     /* 198995 */     GIR_EraseRootFromParent_Done,
     /* 198996 */   // Label 3974: @198996
     /* 198996 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(199033), // Rule ID 12142 //
     /* 199001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 199009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199022 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1732:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 199025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199031 */     GIR_RootConstrainSelectedInstOperands,
     /* 199032 */     // GIR_Coverage, 12142,
     /* 199032 */     GIR_EraseRootFromParent_Done,
     /* 199033 */   // Label 3975: @199033
     /* 199033 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(199070), // Rule ID 12143 //
     /* 199038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 199046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199059 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1732:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 199062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199068 */     GIR_RootConstrainSelectedInstOperands,
     /* 199069 */     // GIR_Coverage, 12143,
     /* 199069 */     GIR_EraseRootFromParent_Done,
     /* 199070 */   // Label 3976: @199070
     /* 199070 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(199107), // Rule ID 12144 //
     /* 199075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 199083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199096 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1732:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 199099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199105 */     GIR_RootConstrainSelectedInstOperands,
     /* 199106 */     // GIR_Coverage, 12144,
     /* 199106 */     GIR_EraseRootFromParent_Done,
     /* 199107 */   // Label 3977: @199107
     /* 199107 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(199144), // Rule ID 12145 //
     /* 199112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 199120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199133 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1732:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 199136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199142 */     GIR_RootConstrainSelectedInstOperands,
     /* 199143 */     // GIR_Coverage, 12145,
     /* 199143 */     GIR_EraseRootFromParent_Done,
     /* 199144 */   // Label 3978: @199144
     /* 199144 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(199181), // Rule ID 12146 //
     /* 199149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 199157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199170 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 199173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199179 */     GIR_RootConstrainSelectedInstOperands,
     /* 199180 */     // GIR_Coverage, 12146,
     /* 199180 */     GIR_EraseRootFromParent_Done,
     /* 199181 */   // Label 3979: @199181
     /* 199181 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(199218), // Rule ID 12147 //
     /* 199186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 199194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199207 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 199210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199216 */     GIR_RootConstrainSelectedInstOperands,
     /* 199217 */     // GIR_Coverage, 12147,
     /* 199217 */     GIR_EraseRootFromParent_Done,
     /* 199218 */   // Label 3980: @199218
     /* 199218 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199255), // Rule ID 12148 //
     /* 199223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 199231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199244 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 199247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199253 */     GIR_RootConstrainSelectedInstOperands,
     /* 199254 */     // GIR_Coverage, 12148,
     /* 199254 */     GIR_EraseRootFromParent_Done,
     /* 199255 */   // Label 3981: @199255
     /* 199255 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(199292), // Rule ID 12149 //
     /* 199260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 199268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199281 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 199284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199290 */     GIR_RootConstrainSelectedInstOperands,
     /* 199291 */     // GIR_Coverage, 12149,
     /* 199291 */     GIR_EraseRootFromParent_Done,
     /* 199292 */   // Label 3982: @199292
     /* 199292 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(199329), // Rule ID 12150 //
     /* 199297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 199305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199318 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 199321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199327 */     GIR_RootConstrainSelectedInstOperands,
     /* 199328 */     // GIR_Coverage, 12150,
     /* 199328 */     GIR_EraseRootFromParent_Done,
     /* 199329 */   // Label 3983: @199329
     /* 199329 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(199366), // Rule ID 12151 //
     /* 199334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 199342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199355 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 199358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199364 */     GIR_RootConstrainSelectedInstOperands,
     /* 199365 */     // GIR_Coverage, 12151,
     /* 199365 */     GIR_EraseRootFromParent_Done,
     /* 199366 */   // Label 3984: @199366
     /* 199366 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(199403), // Rule ID 12152 //
     /* 199371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 199379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199392 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 199395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199401 */     GIR_RootConstrainSelectedInstOperands,
     /* 199402 */     // GIR_Coverage, 12152,
     /* 199402 */     GIR_EraseRootFromParent_Done,
     /* 199403 */   // Label 3985: @199403
     /* 199403 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(199440), // Rule ID 12153 //
     /* 199408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 199416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199429 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 199432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199438 */     GIR_RootConstrainSelectedInstOperands,
     /* 199439 */     // GIR_Coverage, 12153,
     /* 199439 */     GIR_EraseRootFromParent_Done,
     /* 199440 */   // Label 3986: @199440
     /* 199440 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(199477), // Rule ID 12154 //
     /* 199445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 199453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199466 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 199469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199475 */     GIR_RootConstrainSelectedInstOperands,
     /* 199476 */     // GIR_Coverage, 12154,
     /* 199476 */     GIR_EraseRootFromParent_Done,
     /* 199477 */   // Label 3987: @199477
     /* 199477 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(199514), // Rule ID 12155 //
     /* 199482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 199490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199503 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 199506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199512 */     GIR_RootConstrainSelectedInstOperands,
     /* 199513 */     // GIR_Coverage, 12155,
     /* 199513 */     GIR_EraseRootFromParent_Done,
     /* 199514 */   // Label 3988: @199514
     /* 199514 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(199551), // Rule ID 12156 //
     /* 199519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 199527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199540 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 199543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199549 */     GIR_RootConstrainSelectedInstOperands,
     /* 199550 */     // GIR_Coverage, 12156,
     /* 199550 */     GIR_EraseRootFromParent_Done,
     /* 199551 */   // Label 3989: @199551
     /* 199551 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(199588), // Rule ID 12157 //
     /* 199556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 199564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199577 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 199580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 199582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199586 */     GIR_RootConstrainSelectedInstOperands,
     /* 199587 */     // GIR_Coverage, 12157,
     /* 199587 */     GIR_EraseRootFromParent_Done,
     /* 199588 */   // Label 3990: @199588
     /* 199588 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(199625), // Rule ID 12158 //
     /* 199593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 199604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 199607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2163:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 199617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199623 */     GIR_RootConstrainSelectedInstOperands,
     /* 199624 */     // GIR_Coverage, 12158,
     /* 199624 */     GIR_EraseRootFromParent_Done,
     /* 199625 */   // Label 3991: @199625
     /* 199625 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(199662), // Rule ID 12159 //
     /* 199630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 199644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2163:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 199654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199660 */     GIR_RootConstrainSelectedInstOperands,
     /* 199661 */     // GIR_Coverage, 12159,
     /* 199661 */     GIR_EraseRootFromParent_Done,
     /* 199662 */   // Label 3992: @199662
     /* 199662 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(199699), // Rule ID 12160 //
     /* 199667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 199681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 199691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199697 */     GIR_RootConstrainSelectedInstOperands,
     /* 199698 */     // GIR_Coverage, 12160,
     /* 199698 */     GIR_EraseRootFromParent_Done,
     /* 199699 */   // Label 3993: @199699
     /* 199699 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(199736), // Rule ID 12161 //
     /* 199704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 199718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 199728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199734 */     GIR_RootConstrainSelectedInstOperands,
     /* 199735 */     // GIR_Coverage, 12161,
     /* 199735 */     GIR_EraseRootFromParent_Done,
     /* 199736 */   // Label 3994: @199736
     /* 199736 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(199773), // Rule ID 12162 //
     /* 199741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 199755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2163:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 199762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 199765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199771 */     GIR_RootConstrainSelectedInstOperands,
     /* 199772 */     // GIR_Coverage, 12162,
     /* 199772 */     GIR_EraseRootFromParent_Done,
     /* 199773 */   // Label 3995: @199773
     /* 199773 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(199810), // Rule ID 12163 //
     /* 199778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 199792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199799 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2163:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 199799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 199802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199808 */     GIR_RootConstrainSelectedInstOperands,
     /* 199809 */     // GIR_Coverage, 12163,
     /* 199809 */     GIR_EraseRootFromParent_Done,
     /* 199810 */   // Label 3996: @199810
     /* 199810 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(199847), // Rule ID 12164 //
     /* 199815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 199823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 199829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199836 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2163:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 199836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 199839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199845 */     GIR_RootConstrainSelectedInstOperands,
     /* 199846 */     // GIR_Coverage, 12164,
     /* 199846 */     GIR_EraseRootFromParent_Done,
     /* 199847 */   // Label 3997: @199847
     /* 199847 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(199884), // Rule ID 12165 //
     /* 199852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 199860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 199863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 199866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 199869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199873 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2088:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 199873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 199876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199882 */     GIR_RootConstrainSelectedInstOperands,
     /* 199883 */     // GIR_Coverage, 12165,
     /* 199883 */     GIR_EraseRootFromParent_Done,
     /* 199884 */   // Label 3998: @199884
     /* 199884 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(199921), // Rule ID 12166 //
     /* 199889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 199897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 199903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2088:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 199910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 199913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199919 */     GIR_RootConstrainSelectedInstOperands,
     /* 199920 */     // GIR_Coverage, 12166,
     /* 199920 */     GIR_EraseRootFromParent_Done,
     /* 199921 */   // Label 3999: @199921
     /* 199921 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(199958), // Rule ID 12167 //
     /* 199926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 199934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 199940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199947 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2088:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 199947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 199950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199956 */     GIR_RootConstrainSelectedInstOperands,
     /* 199957 */     // GIR_Coverage, 12167,
     /* 199957 */     GIR_EraseRootFromParent_Done,
     /* 199958 */   // Label 4000: @199958
     /* 199958 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(199995), // Rule ID 12168 //
     /* 199963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 199966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 199971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 199977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2088:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 199984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 199987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 199989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199993 */     GIR_RootConstrainSelectedInstOperands,
     /* 199994 */     // GIR_Coverage, 12168,
     /* 199994 */     GIR_EraseRootFromParent_Done,
     /* 199995 */   // Label 4001: @199995
     /* 199995 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(200032), // Rule ID 12169 //
     /* 200000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 200008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200021 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2088:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 200021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 200024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200030 */     GIR_RootConstrainSelectedInstOperands,
     /* 200031 */     // GIR_Coverage, 12169,
     /* 200031 */     GIR_EraseRootFromParent_Done,
     /* 200032 */   // Label 4002: @200032
     /* 200032 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(200069), // Rule ID 12170 //
     /* 200037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 200045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2088:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 200058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 200061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200067 */     GIR_RootConstrainSelectedInstOperands,
     /* 200068 */     // GIR_Coverage, 12170,
     /* 200068 */     GIR_EraseRootFromParent_Done,
     /* 200069 */   // Label 4003: @200069
     /* 200069 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(200106), // Rule ID 12171 //
     /* 200074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 200082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 200088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200095 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2088:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 200095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 200098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200104 */     GIR_RootConstrainSelectedInstOperands,
     /* 200105 */     // GIR_Coverage, 12171,
     /* 200105 */     GIR_EraseRootFromParent_Done,
     /* 200106 */   // Label 4004: @200106
     /* 200106 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(200143), // Rule ID 12172 //
     /* 200111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 200122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 200125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 200128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2089:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 200132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 200135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200141 */     GIR_RootConstrainSelectedInstOperands,
     /* 200142 */     // GIR_Coverage, 12172,
     /* 200142 */     GIR_EraseRootFromParent_Done,
     /* 200143 */   // Label 4005: @200143
     /* 200143 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(200180), // Rule ID 12173 //
     /* 200148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2089:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 200169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 200172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200178 */     GIR_RootConstrainSelectedInstOperands,
     /* 200179 */     // GIR_Coverage, 12173,
     /* 200179 */     GIR_EraseRootFromParent_Done,
     /* 200180 */   // Label 4006: @200180
     /* 200180 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(200217), // Rule ID 12174 //
     /* 200185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2089:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 200206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 200209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200215 */     GIR_RootConstrainSelectedInstOperands,
     /* 200216 */     // GIR_Coverage, 12174,
     /* 200216 */     GIR_EraseRootFromParent_Done,
     /* 200217 */   // Label 4007: @200217
     /* 200217 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(200254), // Rule ID 12175 //
     /* 200222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 200236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2089:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 200243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 200246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200252 */     GIR_RootConstrainSelectedInstOperands,
     /* 200253 */     // GIR_Coverage, 12175,
     /* 200253 */     GIR_EraseRootFromParent_Done,
     /* 200254 */   // Label 4008: @200254
     /* 200254 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(200291), // Rule ID 12176 //
     /* 200259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2089:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 200280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 200283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200289 */     GIR_RootConstrainSelectedInstOperands,
     /* 200290 */     // GIR_Coverage, 12176,
     /* 200290 */     GIR_EraseRootFromParent_Done,
     /* 200291 */   // Label 4009: @200291
     /* 200291 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(200328), // Rule ID 12177 //
     /* 200296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200317 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2089:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 200317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 200320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200326 */     GIR_RootConstrainSelectedInstOperands,
     /* 200327 */     // GIR_Coverage, 12177,
     /* 200327 */     GIR_EraseRootFromParent_Done,
     /* 200328 */   // Label 4010: @200328
     /* 200328 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(200365), // Rule ID 12178 //
     /* 200333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 200336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 200341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 200347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200354 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2089:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 200354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 200357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200363 */     GIR_RootConstrainSelectedInstOperands,
     /* 200364 */     // GIR_Coverage, 12178,
     /* 200364 */     GIR_EraseRootFromParent_Done,
     /* 200365 */   // Label 4011: @200365
     /* 200365 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(200407), // Rule ID 3218 //
     /* 200370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 200378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200385 */     // MIs[0] Op1
     /* 200385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200389 */     // MIs[0] Op2
     /* 200389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200393 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 200396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200405 */     GIR_RootConstrainSelectedInstOperands,
     /* 200406 */     // GIR_Coverage, 3218,
     /* 200406 */     GIR_EraseRootFromParent_Done,
     /* 200407 */   // Label 4012: @200407
     /* 200407 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(200449), // Rule ID 3219 //
     /* 200412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 200420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 200423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200427 */     // MIs[0] Op1
     /* 200427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200431 */     // MIs[0] Op2
     /* 200431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200435 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2144:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 200438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200447 */     GIR_RootConstrainSelectedInstOperands,
     /* 200448 */     // GIR_Coverage, 3219,
     /* 200448 */     GIR_EraseRootFromParent_Done,
     /* 200449 */   // Label 4013: @200449
     /* 200449 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(200491), // Rule ID 3220 //
     /* 200454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 200462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 200465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200469 */     // MIs[0] Op1
     /* 200469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200473 */     // MIs[0] Op2
     /* 200473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200477 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 200480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200489 */     GIR_RootConstrainSelectedInstOperands,
     /* 200490 */     // GIR_Coverage, 3220,
     /* 200490 */     GIR_EraseRootFromParent_Done,
     /* 200491 */   // Label 4014: @200491
     /* 200491 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(200533), // Rule ID 3221 //
     /* 200496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 200504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 200507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200511 */     // MIs[0] Op1
     /* 200511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200515 */     // MIs[0] Op2
     /* 200515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200519 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2143:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 200522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200531 */     GIR_RootConstrainSelectedInstOperands,
     /* 200532 */     // GIR_Coverage, 3221,
     /* 200532 */     GIR_EraseRootFromParent_Done,
     /* 200533 */   // Label 4015: @200533
     /* 200533 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(200575), // Rule ID 11989 //
     /* 200538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 200546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200553 */     // MIs[0] Op1
     /* 200553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200557 */     // MIs[0] Op2
     /* 200557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200561 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2138:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 200564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200573 */     GIR_RootConstrainSelectedInstOperands,
     /* 200574 */     // GIR_Coverage, 11989,
     /* 200574 */     GIR_EraseRootFromParent_Done,
     /* 200575 */   // Label 4016: @200575
     /* 200575 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(200617), // Rule ID 11990 //
     /* 200580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 200588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 200591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200595 */     // MIs[0] Op1
     /* 200595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200599 */     // MIs[0] Op2
     /* 200599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200603 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2140:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 200606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200615 */     GIR_RootConstrainSelectedInstOperands,
     /* 200616 */     // GIR_Coverage, 11990,
     /* 200616 */     GIR_EraseRootFromParent_Done,
     /* 200617 */   // Label 4017: @200617
     /* 200617 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(200659), // Rule ID 11991 //
     /* 200622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 200630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 200633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200637 */     // MIs[0] Op1
     /* 200637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200641 */     // MIs[0] Op2
     /* 200641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200645 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2141:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 200648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200657 */     GIR_RootConstrainSelectedInstOperands,
     /* 200658 */     // GIR_Coverage, 11991,
     /* 200658 */     GIR_EraseRootFromParent_Done,
     /* 200659 */   // Label 4018: @200659
     /* 200659 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(200701), // Rule ID 11992 //
     /* 200664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 200667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 200672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 200675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200679 */     // MIs[0] Op1
     /* 200679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 200683 */     // MIs[0] Op2
     /* 200683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 200687 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 200687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 200690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200699 */     GIR_RootConstrainSelectedInstOperands,
     /* 200700 */     // GIR_Coverage, 11992,
     /* 200700 */     GIR_EraseRootFromParent_Done,
     /* 200701 */   // Label 4019: @200701
     /* 200701 */   GIM_Reject,
     /* 200702 */ // Label 3066: @200702
     /* 200702 */ GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(244485),
     /* 200707 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 200710 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(200823), // Rule ID 2069 //
     /* 200715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 200723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 200726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 200729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 200732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 200735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 200755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 200759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 200767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 200771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 200780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200788 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 200792 */     // MIs[3] Operand 1
     /* 200792 */     // No operand predicates
     /* 200792 */     // MIs[1] Operand 2
     /* 200792 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 200803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200805 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 200805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 200808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200821 */     GIR_RootConstrainSelectedInstOperands,
     /* 200822 */     // GIR_Coverage, 2069,
     /* 200822 */     GIR_EraseRootFromParent_Done,
     /* 200823 */   // Label 4021: @200823
     /* 200823 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(200936), // Rule ID 2076 //
     /* 200828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 200836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 200839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 200842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 200845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 200848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 200868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 200872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 200880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 200884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 200893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200901 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 200905 */     // MIs[3] Operand 1
     /* 200905 */     // No operand predicates
     /* 200905 */     // MIs[1] Operand 2
     /* 200905 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 200916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200918 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 200918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 200921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200934 */     GIR_RootConstrainSelectedInstOperands,
     /* 200935 */     // GIR_Coverage, 2076,
     /* 200935 */     GIR_EraseRootFromParent_Done,
     /* 200936 */   // Label 4022: @200936
     /* 200936 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(201049), // Rule ID 2072 //
     /* 200941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 200949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 200952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 200955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 200958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 200961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 200981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201018 */     // MIs[3] Operand 1
     /* 201018 */     // No operand predicates
     /* 201018 */     // MIs[1] Operand 2
     /* 201018 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 201029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201031 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 201034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201047 */     GIR_RootConstrainSelectedInstOperands,
     /* 201048 */     // GIR_Coverage, 2072,
     /* 201048 */     GIR_EraseRootFromParent_Done,
     /* 201049 */   // Label 4023: @201049
     /* 201049 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(201162), // Rule ID 2079 //
     /* 201054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 201057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 201062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 201065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 201068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 201071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 201074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 201094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201127 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201131 */     // MIs[3] Operand 1
     /* 201131 */     // No operand predicates
     /* 201131 */     // MIs[1] Operand 2
     /* 201131 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 201142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201144 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 201147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201160 */     GIR_RootConstrainSelectedInstOperands,
     /* 201161 */     // GIR_Coverage, 2079,
     /* 201161 */     GIR_EraseRootFromParent_Done,
     /* 201162 */   // Label 4024: @201162
     /* 201162 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(201267), // Rule ID 3869 //
     /* 201167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 201175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 201178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 201181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 201211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201240 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 201244 */     // MIs[3] Operand 1
     /* 201244 */     // No operand predicates
     /* 201244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201246 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 201246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 201249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201265 */     GIR_RootConstrainSelectedInstOperands,
     /* 201266 */     // GIR_Coverage, 3869,
     /* 201266 */     GIR_EraseRootFromParent_Done,
     /* 201267 */   // Label 4025: @201267
     /* 201267 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(201372), // Rule ID 3870 //
     /* 201272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 201280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 201283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 201286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 201316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201345 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 201349 */     // MIs[3] Operand 1
     /* 201349 */     // No operand predicates
     /* 201349 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201351 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 201351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 201354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201370 */     GIR_RootConstrainSelectedInstOperands,
     /* 201371 */     // GIR_Coverage, 3870,
     /* 201371 */     GIR_EraseRootFromParent_Done,
     /* 201372 */   // Label 4026: @201372
     /* 201372 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(201477), // Rule ID 3871 //
     /* 201377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 201385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 201388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 201391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 201421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201450 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 201454 */     // MIs[3] Operand 1
     /* 201454 */     // No operand predicates
     /* 201454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201456 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 201456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 201459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 201475 */     GIR_RootConstrainSelectedInstOperands,
     /* 201476 */     // GIR_Coverage, 3871,
     /* 201476 */     GIR_EraseRootFromParent_Done,
     /* 201477 */   // Label 4027: @201477
     /* 201477 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(201582), // Rule ID 3872 //
     /* 201482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 201490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 201493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 201496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 201526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201555 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 201559 */     // MIs[3] Operand 1
     /* 201559 */     // No operand predicates
     /* 201559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201561 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 201561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 201564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 201580 */     GIR_RootConstrainSelectedInstOperands,
     /* 201581 */     // GIR_Coverage, 3872,
     /* 201581 */     GIR_EraseRootFromParent_Done,
     /* 201582 */   // Label 4028: @201582
     /* 201582 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(201687), // Rule ID 3877 //
     /* 201587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 201595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 201598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 201601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201660 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201664 */     // MIs[3] Operand 1
     /* 201664 */     // No operand predicates
     /* 201664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201666 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 201666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 201669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201685 */     GIR_RootConstrainSelectedInstOperands,
     /* 201686 */     // GIR_Coverage, 3877,
     /* 201686 */     GIR_EraseRootFromParent_Done,
     /* 201687 */   // Label 4029: @201687
     /* 201687 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(201792), // Rule ID 3878 //
     /* 201692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 201700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 201703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 201706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201765 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201769 */     // MIs[3] Operand 1
     /* 201769 */     // No operand predicates
     /* 201769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201771 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 201771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 201774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201790 */     GIR_RootConstrainSelectedInstOperands,
     /* 201791 */     // GIR_Coverage, 3878,
     /* 201791 */     GIR_EraseRootFromParent_Done,
     /* 201792 */   // Label 4030: @201792
     /* 201792 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(201897), // Rule ID 3879 //
     /* 201797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 201805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 201808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 201811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201870 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201874 */     // MIs[3] Operand 1
     /* 201874 */     // No operand predicates
     /* 201874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201876 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 201876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 201879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 201895 */     GIR_RootConstrainSelectedInstOperands,
     /* 201896 */     // GIR_Coverage, 3879,
     /* 201896 */     GIR_EraseRootFromParent_Done,
     /* 201897 */   // Label 4031: @201897
     /* 201897 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202002), // Rule ID 3880 //
     /* 201902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 201905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 201910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 201913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 201916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 201942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 201954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 201962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 201971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201975 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 201979 */     // MIs[3] Operand 1
     /* 201979 */     // No operand predicates
     /* 201979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 201981 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 201981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 201984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 201994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 201997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 202000 */     GIR_RootConstrainSelectedInstOperands,
     /* 202001 */     // GIR_Coverage, 3880,
     /* 202001 */     GIR_EraseRootFromParent_Done,
     /* 202002 */   // Label 4032: @202002
     /* 202002 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202107), // Rule ID 3893 //
     /* 202007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 202010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 202015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 202047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 202059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 202067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 202076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202080 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 202084 */     // MIs[3] Operand 1
     /* 202084 */     // No operand predicates
     /* 202084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 202086 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 202086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 202089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202105 */     GIR_RootConstrainSelectedInstOperands,
     /* 202106 */     // GIR_Coverage, 3893,
     /* 202106 */     GIR_EraseRootFromParent_Done,
     /* 202107 */   // Label 4033: @202107
     /* 202107 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202212), // Rule ID 3894 //
     /* 202112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 202115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 202120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 202152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 202164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 202172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 202181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202185 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 202189 */     // MIs[3] Operand 1
     /* 202189 */     // No operand predicates
     /* 202189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 202191 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 202191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 202194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202210 */     GIR_RootConstrainSelectedInstOperands,
     /* 202211 */     // GIR_Coverage, 3894,
     /* 202211 */     GIR_EraseRootFromParent_Done,
     /* 202212 */   // Label 4034: @202212
     /* 202212 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202317), // Rule ID 3895 //
     /* 202217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 202220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 202225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 202257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 202269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 202277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 202286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202290 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 202294 */     // MIs[3] Operand 1
     /* 202294 */     // No operand predicates
     /* 202294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 202296 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 202296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 202299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 202315 */     GIR_RootConstrainSelectedInstOperands,
     /* 202316 */     // GIR_Coverage, 3895,
     /* 202316 */     GIR_EraseRootFromParent_Done,
     /* 202317 */   // Label 4035: @202317
     /* 202317 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202422), // Rule ID 3896 //
     /* 202322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 202325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 202330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 202362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 202374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 202378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 202382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 202391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202395 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 202399 */     // MIs[3] Operand 1
     /* 202399 */     // No operand predicates
     /* 202399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 202401 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 202401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 202404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 202414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 202417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 202420 */     GIR_RootConstrainSelectedInstOperands,
     /* 202421 */     // GIR_Coverage, 3896,
     /* 202421 */     GIR_EraseRootFromParent_Done,
     /* 202422 */   // Label 4036: @202422
     /* 202422 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202476), // Rule ID 59 //
     /* 202427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202452 */     // MIs[0] Operand 3
     /* 202452 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 202463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 202467 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 202467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 202470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202474 */     GIR_RootConstrainSelectedInstOperands,
     /* 202475 */     // GIR_Coverage, 59,
     /* 202475 */     GIR_EraseRootFromParent_Done,
     /* 202476 */   // Label 4037: @202476
     /* 202476 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202530), // Rule ID 60 //
     /* 202481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202506 */     // MIs[0] Operand 3
     /* 202506 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 202517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 202521 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 202521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 202524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202528 */     GIR_RootConstrainSelectedInstOperands,
     /* 202529 */     // GIR_Coverage, 60,
     /* 202529 */     GIR_EraseRootFromParent_Done,
     /* 202530 */   // Label 4038: @202530
     /* 202530 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202584), // Rule ID 61 //
     /* 202535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202560 */     // MIs[0] Operand 3
     /* 202560 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 202571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 202575 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 202575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 202578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202582 */     GIR_RootConstrainSelectedInstOperands,
     /* 202583 */     // GIR_Coverage, 61,
     /* 202583 */     GIR_EraseRootFromParent_Done,
     /* 202584 */   // Label 4039: @202584
     /* 202584 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202638), // Rule ID 62 //
     /* 202589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202614 */     // MIs[0] Operand 3
     /* 202614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 202625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 202629 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 202629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 202632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202636 */     GIR_RootConstrainSelectedInstOperands,
     /* 202637 */     // GIR_Coverage, 62,
     /* 202637 */     GIR_EraseRootFromParent_Done,
     /* 202638 */   // Label 4040: @202638
     /* 202638 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202694), // Rule ID 2652 //
     /* 202643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 202651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202665 */     // MIs[0] pattern
     /* 202665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202673 */     // MIs[0] imm4
     /* 202673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 202684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202688 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202690 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202692 */     GIR_RootConstrainSelectedInstOperands,
     /* 202693 */     // GIR_Coverage, 2652,
     /* 202693 */     GIR_EraseRootFromParent_Done,
     /* 202694 */   // Label 4041: @202694
     /* 202694 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202750), // Rule ID 2661 //
     /* 202699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 202707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202721 */     // MIs[0] pattern
     /* 202721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202729 */     // MIs[0] imm4
     /* 202729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202737 */     // (intrinsic_wo_chain:{ *:[i32] } 2016:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 202740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202744 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202746 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202748 */     GIR_RootConstrainSelectedInstOperands,
     /* 202749 */     // GIR_Coverage, 2661,
     /* 202749 */     GIR_EraseRootFromParent_Done,
     /* 202750 */   // Label 4042: @202750
     /* 202750 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(202806), // Rule ID 2662 //
     /* 202755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 202763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202777 */     // MIs[0] pattern
     /* 202777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202785 */     // MIs[0] imm4
     /* 202785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202793 */     // (intrinsic_wo_chain:{ *:[i64] } 1806:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 202796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202800 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202802 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202804 */     GIR_RootConstrainSelectedInstOperands,
     /* 202805 */     // GIR_Coverage, 2662,
     /* 202805 */     GIR_EraseRootFromParent_Done,
     /* 202806 */   // Label 4043: @202806
     /* 202806 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(202862), // Rule ID 10000 //
     /* 202811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 202819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202833 */     // MIs[0] pattern
     /* 202833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202841 */     // MIs[0] imm4
     /* 202841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202849 */     // (intrinsic_wo_chain:{ *:[i32] } 2002:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 202852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202856 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202858 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202860 */     GIR_RootConstrainSelectedInstOperands,
     /* 202861 */     // GIR_Coverage, 10000,
     /* 202861 */     GIR_EraseRootFromParent_Done,
     /* 202862 */   // Label 4044: @202862
     /* 202862 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(202918), // Rule ID 10001 //
     /* 202867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 202875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202889 */     // MIs[0] pattern
     /* 202889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202897 */     // MIs[0] imm4
     /* 202897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202905 */     // (intrinsic_wo_chain:{ *:[i64] } 2017:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 202908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202912 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202914 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202916 */     GIR_RootConstrainSelectedInstOperands,
     /* 202917 */     // GIR_Coverage, 10001,
     /* 202917 */     GIR_EraseRootFromParent_Done,
     /* 202918 */   // Label 4045: @202918
     /* 202918 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(202974), // Rule ID 10002 //
     /* 202923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 202931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202945 */     // MIs[0] pattern
     /* 202945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202953 */     // MIs[0] imm4
     /* 202953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202961 */     // (intrinsic_wo_chain:{ *:[i64] } 1772:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 202964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202968 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202970 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202972 */     GIR_RootConstrainSelectedInstOperands,
     /* 202973 */     // GIR_Coverage, 10002,
     /* 202973 */     GIR_EraseRootFromParent_Done,
     /* 202974 */   // Label 4046: @202974
     /* 202974 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(203030), // Rule ID 10003 //
     /* 202979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 202987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203001 */     // MIs[0] pattern
     /* 203001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203009 */     // MIs[0] imm4
     /* 203009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203017 */     // (intrinsic_wo_chain:{ *:[i64] } 2003:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 203020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203024 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203026 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203028 */     GIR_RootConstrainSelectedInstOperands,
     /* 203029 */     // GIR_Coverage, 10003,
     /* 203029 */     GIR_EraseRootFromParent_Done,
     /* 203030 */   // Label 4047: @203030
     /* 203030 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(203086), // Rule ID 10006 //
     /* 203035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 203043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203057 */     // MIs[0] pattern
     /* 203057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203065 */     // MIs[0] imm4
     /* 203065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203073 */     // (intrinsic_wo_chain:{ *:[i32] } 2022:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 203076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203080 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203082 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203084 */     GIR_RootConstrainSelectedInstOperands,
     /* 203085 */     // GIR_Coverage, 10006,
     /* 203085 */     GIR_EraseRootFromParent_Done,
     /* 203086 */   // Label 4048: @203086
     /* 203086 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(203142), // Rule ID 10009 //
     /* 203091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 203099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203113 */     // MIs[0] pattern
     /* 203113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203121 */     // MIs[0] imm4
     /* 203121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203129 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 203132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203136 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203138 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203140 */     GIR_RootConstrainSelectedInstOperands,
     /* 203141 */     // GIR_Coverage, 10009,
     /* 203141 */     GIR_EraseRootFromParent_Done,
     /* 203142 */   // Label 4049: @203142
     /* 203142 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(203198), // Rule ID 10010 //
     /* 203147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 203155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203169 */     // MIs[0] pattern
     /* 203169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203177 */     // MIs[0] imm4
     /* 203177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203185 */     // (intrinsic_wo_chain:{ *:[i64] } 1812:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 203188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203192 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203194 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203196 */     GIR_RootConstrainSelectedInstOperands,
     /* 203197 */     // GIR_Coverage, 10010,
     /* 203197 */     GIR_EraseRootFromParent_Done,
     /* 203198 */   // Label 4050: @203198
     /* 203198 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(203254), // Rule ID 10011 //
     /* 203203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 203211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203225 */     // MIs[0] pattern
     /* 203225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203233 */     // MIs[0] imm4
     /* 203233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203241 */     // (intrinsic_wo_chain:{ *:[i64] } 2023:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 203244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203248 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203250 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203252 */     GIR_RootConstrainSelectedInstOperands,
     /* 203253 */     // GIR_Coverage, 10011,
     /* 203253 */     GIR_EraseRootFromParent_Done,
     /* 203254 */   // Label 4051: @203254
     /* 203254 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(203310), // Rule ID 10012 //
     /* 203259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 203267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203281 */     // MIs[0] pattern
     /* 203281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203289 */     // MIs[0] imm4
     /* 203289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203297 */     // (intrinsic_wo_chain:{ *:[i64] } 1778:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 203300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203304 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203306 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203308 */     GIR_RootConstrainSelectedInstOperands,
     /* 203309 */     // GIR_Coverage, 10012,
     /* 203309 */     GIR_EraseRootFromParent_Done,
     /* 203310 */   // Label 4052: @203310
     /* 203310 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(203366), // Rule ID 10013 //
     /* 203315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 203323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203337 */     // MIs[0] pattern
     /* 203337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203345 */     // MIs[0] imm4
     /* 203345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203353 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 203356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203360 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203362 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203364 */     GIR_RootConstrainSelectedInstOperands,
     /* 203365 */     // GIR_Coverage, 10013,
     /* 203365 */     GIR_EraseRootFromParent_Done,
     /* 203366 */   // Label 4053: @203366
     /* 203366 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(203422), // Rule ID 10016 //
     /* 203371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 203379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203393 */     // MIs[0] pattern
     /* 203393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203401 */     // MIs[0] imm4
     /* 203401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203409 */     // (intrinsic_wo_chain:{ *:[i32] } 2028:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 203412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203416 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203418 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203420 */     GIR_RootConstrainSelectedInstOperands,
     /* 203421 */     // GIR_Coverage, 10016,
     /* 203421 */     GIR_EraseRootFromParent_Done,
     /* 203422 */   // Label 4054: @203422
     /* 203422 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203478), // Rule ID 10019 //
     /* 203427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 203435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203449 */     // MIs[0] pattern
     /* 203449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203457 */     // MIs[0] imm4
     /* 203457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203465 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 203468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203472 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203474 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203476 */     GIR_RootConstrainSelectedInstOperands,
     /* 203477 */     // GIR_Coverage, 10019,
     /* 203477 */     GIR_EraseRootFromParent_Done,
     /* 203478 */   // Label 4055: @203478
     /* 203478 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203534), // Rule ID 10020 //
     /* 203483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 203491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203505 */     // MIs[0] pattern
     /* 203505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203513 */     // MIs[0] imm4
     /* 203513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203521 */     // (intrinsic_wo_chain:{ *:[i64] } 1818:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 203524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203528 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203530 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203532 */     GIR_RootConstrainSelectedInstOperands,
     /* 203533 */     // GIR_Coverage, 10020,
     /* 203533 */     GIR_EraseRootFromParent_Done,
     /* 203534 */   // Label 4056: @203534
     /* 203534 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203590), // Rule ID 10021 //
     /* 203539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 203547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203561 */     // MIs[0] pattern
     /* 203561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203569 */     // MIs[0] imm4
     /* 203569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203577 */     // (intrinsic_wo_chain:{ *:[i64] } 2029:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 203580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203584 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203586 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203588 */     GIR_RootConstrainSelectedInstOperands,
     /* 203589 */     // GIR_Coverage, 10021,
     /* 203589 */     GIR_EraseRootFromParent_Done,
     /* 203590 */   // Label 4057: @203590
     /* 203590 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203646), // Rule ID 10022 //
     /* 203595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 203603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203617 */     // MIs[0] pattern
     /* 203617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203625 */     // MIs[0] imm4
     /* 203625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203633 */     // (intrinsic_wo_chain:{ *:[i64] } 1784:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 203636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203640 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203642 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203644 */     GIR_RootConstrainSelectedInstOperands,
     /* 203645 */     // GIR_Coverage, 10022,
     /* 203645 */     GIR_EraseRootFromParent_Done,
     /* 203646 */   // Label 4058: @203646
     /* 203646 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(203702), // Rule ID 10023 //
     /* 203651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 203659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203673 */     // MIs[0] pattern
     /* 203673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203681 */     // MIs[0] imm4
     /* 203681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203689 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 203692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203696 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203698 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203700 */     GIR_RootConstrainSelectedInstOperands,
     /* 203701 */     // GIR_Coverage, 10023,
     /* 203701 */     GIR_EraseRootFromParent_Done,
     /* 203702 */   // Label 4059: @203702
     /* 203702 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(203758), // Rule ID 10026 //
     /* 203707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 203715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203729 */     // MIs[0] pattern
     /* 203729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203737 */     // MIs[0] imm4
     /* 203737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203745 */     // (intrinsic_wo_chain:{ *:[i32] } 2019:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 203748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203752 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203754 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203756 */     GIR_RootConstrainSelectedInstOperands,
     /* 203757 */     // GIR_Coverage, 10026,
     /* 203757 */     GIR_EraseRootFromParent_Done,
     /* 203758 */   // Label 4060: @203758
     /* 203758 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(203814), // Rule ID 10029 //
     /* 203763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 203771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203785 */     // MIs[0] pattern
     /* 203785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203793 */     // MIs[0] imm4
     /* 203793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203801 */     // (intrinsic_wo_chain:{ *:[i32] } 2005:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 203804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203808 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203810 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203812 */     GIR_RootConstrainSelectedInstOperands,
     /* 203813 */     // GIR_Coverage, 10029,
     /* 203813 */     GIR_EraseRootFromParent_Done,
     /* 203814 */   // Label 4061: @203814
     /* 203814 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(203870), // Rule ID 10030 //
     /* 203819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 203827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203841 */     // MIs[0] pattern
     /* 203841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203849 */     // MIs[0] imm4
     /* 203849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203857 */     // (intrinsic_wo_chain:{ *:[i64] } 1809:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 203860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203864 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203866 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203868 */     GIR_RootConstrainSelectedInstOperands,
     /* 203869 */     // GIR_Coverage, 10030,
     /* 203869 */     GIR_EraseRootFromParent_Done,
     /* 203870 */   // Label 4062: @203870
     /* 203870 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(203926), // Rule ID 10031 //
     /* 203875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 203883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203897 */     // MIs[0] pattern
     /* 203897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203905 */     // MIs[0] imm4
     /* 203905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203913 */     // (intrinsic_wo_chain:{ *:[i64] } 2020:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 203916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203920 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203922 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203924 */     GIR_RootConstrainSelectedInstOperands,
     /* 203925 */     // GIR_Coverage, 10031,
     /* 203925 */     GIR_EraseRootFromParent_Done,
     /* 203926 */   // Label 4063: @203926
     /* 203926 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(203982), // Rule ID 10032 //
     /* 203931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 203939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203953 */     // MIs[0] pattern
     /* 203953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203961 */     // MIs[0] imm4
     /* 203961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203969 */     // (intrinsic_wo_chain:{ *:[i64] } 1775:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 203972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203976 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203978 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203980 */     GIR_RootConstrainSelectedInstOperands,
     /* 203981 */     // GIR_Coverage, 10032,
     /* 203981 */     GIR_EraseRootFromParent_Done,
     /* 203982 */   // Label 4064: @203982
     /* 203982 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(204038), // Rule ID 10033 //
     /* 203987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 203995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204009 */     // MIs[0] pattern
     /* 204009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204017 */     // MIs[0] imm4
     /* 204017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204025 */     // (intrinsic_wo_chain:{ *:[i64] } 2006:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 204028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 204030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 204032 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204034 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204036 */     GIR_RootConstrainSelectedInstOperands,
     /* 204037 */     // GIR_Coverage, 10033,
     /* 204037 */     GIR_EraseRootFromParent_Done,
     /* 204038 */   // Label 4065: @204038
     /* 204038 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(204094), // Rule ID 10034 //
     /* 204043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 204051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204065 */     // MIs[0] pattern
     /* 204065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204073 */     // MIs[0] imm4
     /* 204073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2021:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 204084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204088 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204090 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204092 */     GIR_RootConstrainSelectedInstOperands,
     /* 204093 */     // GIR_Coverage, 10034,
     /* 204093 */     GIR_EraseRootFromParent_Done,
     /* 204094 */   // Label 4066: @204094
     /* 204094 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(204150), // Rule ID 10035 //
     /* 204099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 204107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204121 */     // MIs[0] pattern
     /* 204121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204129 */     // MIs[0] imm4
     /* 204129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204137 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 204140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204144 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204146 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204148 */     GIR_RootConstrainSelectedInstOperands,
     /* 204149 */     // GIR_Coverage, 10035,
     /* 204149 */     GIR_EraseRootFromParent_Done,
     /* 204150 */   // Label 4067: @204150
     /* 204150 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(204206), // Rule ID 10036 //
     /* 204155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 204163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204177 */     // MIs[0] pattern
     /* 204177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204185 */     // MIs[0] imm4
     /* 204185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2007:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 204196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204200 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204202 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204204 */     GIR_RootConstrainSelectedInstOperands,
     /* 204205 */     // GIR_Coverage, 10036,
     /* 204205 */     GIR_EraseRootFromParent_Done,
     /* 204206 */   // Label 4068: @204206
     /* 204206 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(204262), // Rule ID 10037 //
     /* 204211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 204219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204233 */     // MIs[0] pattern
     /* 204233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204241 */     // MIs[0] imm4
     /* 204241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1816:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 204252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204256 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204258 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204260 */     GIR_RootConstrainSelectedInstOperands,
     /* 204261 */     // GIR_Coverage, 10037,
     /* 204261 */     GIR_EraseRootFromParent_Done,
     /* 204262 */   // Label 4069: @204262
     /* 204262 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(204318), // Rule ID 10038 //
     /* 204267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 204275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204289 */     // MIs[0] pattern
     /* 204289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204297 */     // MIs[0] imm4
     /* 204297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2027:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 204308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204312 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204314 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204316 */     GIR_RootConstrainSelectedInstOperands,
     /* 204317 */     // GIR_Coverage, 10038,
     /* 204317 */     GIR_EraseRootFromParent_Done,
     /* 204318 */   // Label 4070: @204318
     /* 204318 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(204374), // Rule ID 10039 //
     /* 204323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 204331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204345 */     // MIs[0] pattern
     /* 204345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204353 */     // MIs[0] imm4
     /* 204353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 204364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204368 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204370 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204372 */     GIR_RootConstrainSelectedInstOperands,
     /* 204373 */     // GIR_Coverage, 10039,
     /* 204373 */     GIR_EraseRootFromParent_Done,
     /* 204374 */   // Label 4071: @204374
     /* 204374 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(204430), // Rule ID 10040 //
     /* 204379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 204387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204401 */     // MIs[0] pattern
     /* 204401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204409 */     // MIs[0] imm4
     /* 204409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204417 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2013:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 204420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204424 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204426 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204428 */     GIR_RootConstrainSelectedInstOperands,
     /* 204429 */     // GIR_Coverage, 10040,
     /* 204429 */     GIR_EraseRootFromParent_Done,
     /* 204430 */   // Label 4072: @204430
     /* 204430 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(204486), // Rule ID 10041 //
     /* 204435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 204443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204457 */     // MIs[0] pattern
     /* 204457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204465 */     // MIs[0] imm4
     /* 204465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1807:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 204476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204480 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204482 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204484 */     GIR_RootConstrainSelectedInstOperands,
     /* 204485 */     // GIR_Coverage, 10041,
     /* 204485 */     GIR_EraseRootFromParent_Done,
     /* 204486 */   // Label 4073: @204486
     /* 204486 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(204542), // Rule ID 10042 //
     /* 204491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 204499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204513 */     // MIs[0] pattern
     /* 204513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204521 */     // MIs[0] imm4
     /* 204521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204529 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2018:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 204532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204536 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204538 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204540 */     GIR_RootConstrainSelectedInstOperands,
     /* 204541 */     // GIR_Coverage, 10042,
     /* 204541 */     GIR_EraseRootFromParent_Done,
     /* 204542 */   // Label 4074: @204542
     /* 204542 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(204598), // Rule ID 10043 //
     /* 204547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 204555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204569 */     // MIs[0] pattern
     /* 204569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204577 */     // MIs[0] imm4
     /* 204577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 204588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204592 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204594 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204596 */     GIR_RootConstrainSelectedInstOperands,
     /* 204597 */     // GIR_Coverage, 10043,
     /* 204597 */     GIR_EraseRootFromParent_Done,
     /* 204598 */   // Label 4075: @204598
     /* 204598 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(204654), // Rule ID 10044 //
     /* 204603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 204611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204625 */     // MIs[0] pattern
     /* 204625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 204628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 204633 */     // MIs[0] imm4
     /* 204633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 204641 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 204641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 204644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204648 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 204650 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 204652 */     GIR_RootConstrainSelectedInstOperands,
     /* 204653 */     // GIR_Coverage, 10044,
     /* 204653 */     GIR_EraseRootFromParent_Done,
     /* 204654 */   // Label 4076: @204654
     /* 204654 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(204744), // Rule ID 47 //
     /* 204659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 204662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 204667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 204670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 204673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 204676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 204679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204724 */     // MIs[2] Operand 1
     /* 204724 */     // No operand predicates
     /* 204724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204726 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 204729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204742 */     GIR_RootConstrainSelectedInstOperands,
     /* 204743 */     // GIR_Coverage, 47,
     /* 204743 */     GIR_EraseRootFromParent_Done,
     /* 204744 */   // Label 4077: @204744
     /* 204744 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(204834), // Rule ID 48 //
     /* 204749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 204752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 204757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 204763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 204766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 204769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204814 */     // MIs[2] Operand 1
     /* 204814 */     // No operand predicates
     /* 204814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204816 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 204819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204832 */     GIR_RootConstrainSelectedInstOperands,
     /* 204833 */     // GIR_Coverage, 48,
     /* 204833 */     GIR_EraseRootFromParent_Done,
     /* 204834 */   // Label 4078: @204834
     /* 204834 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(204924), // Rule ID 49 //
     /* 204839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 204842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 204847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 204850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 204853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 204856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 204859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204900 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204904 */     // MIs[2] Operand 1
     /* 204904 */     // No operand predicates
     /* 204904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204906 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 204909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204922 */     GIR_RootConstrainSelectedInstOperands,
     /* 204923 */     // GIR_Coverage, 49,
     /* 204923 */     GIR_EraseRootFromParent_Done,
     /* 204924 */   // Label 4079: @204924
     /* 204924 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(205014), // Rule ID 50 //
     /* 204929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 204932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 204937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 204943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 204946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 204949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204990 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204994 */     // MIs[2] Operand 1
     /* 204994 */     // No operand predicates
     /* 204994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204996 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 204999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205012 */     GIR_RootConstrainSelectedInstOperands,
     /* 205013 */     // GIR_Coverage, 50,
     /* 205013 */     GIR_EraseRootFromParent_Done,
     /* 205014 */   // Label 4080: @205014
     /* 205014 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(205104), // Rule ID 51 //
     /* 205019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 205022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 205027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 205030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 205033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 205036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 205039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205080 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205084 */     // MIs[2] Operand 1
     /* 205084 */     // No operand predicates
     /* 205084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205086 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 205089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205102 */     GIR_RootConstrainSelectedInstOperands,
     /* 205103 */     // GIR_Coverage, 51,
     /* 205103 */     GIR_EraseRootFromParent_Done,
     /* 205104 */   // Label 4081: @205104
     /* 205104 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(205194), // Rule ID 52 //
     /* 205109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 205112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 205117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 205120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 205123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 205126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 205129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205174 */     // MIs[2] Operand 1
     /* 205174 */     // No operand predicates
     /* 205174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205176 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 205179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205192 */     GIR_RootConstrainSelectedInstOperands,
     /* 205193 */     // GIR_Coverage, 52,
     /* 205193 */     GIR_EraseRootFromParent_Done,
     /* 205194 */   // Label 4082: @205194
     /* 205194 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(205284), // Rule ID 53 //
     /* 205199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 205202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 205207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 205210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 205213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 205216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 205219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205260 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205264 */     // MIs[2] Operand 1
     /* 205264 */     // No operand predicates
     /* 205264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205266 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 205269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205282 */     GIR_RootConstrainSelectedInstOperands,
     /* 205283 */     // GIR_Coverage, 53,
     /* 205283 */     GIR_EraseRootFromParent_Done,
     /* 205284 */   // Label 4083: @205284
     /* 205284 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(205374), // Rule ID 54 //
     /* 205289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 205292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 205297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 205300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 205303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 205306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 205309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205350 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205354 */     // MIs[2] Operand 1
     /* 205354 */     // No operand predicates
     /* 205354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205356 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 205359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205372 */     GIR_RootConstrainSelectedInstOperands,
     /* 205373 */     // GIR_Coverage, 54,
     /* 205373 */     GIR_EraseRootFromParent_Done,
     /* 205374 */   // Label 4084: @205374
     /* 205374 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(205464), // Rule ID 2070 //
     /* 205379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 205387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 205390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 205393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 205396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 205399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205444 */     // MIs[2] Operand 1
     /* 205444 */     // No operand predicates
     /* 205444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205446 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 205449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205462 */     GIR_RootConstrainSelectedInstOperands,
     /* 205463 */     // GIR_Coverage, 2070,
     /* 205463 */     GIR_EraseRootFromParent_Done,
     /* 205464 */   // Label 4085: @205464
     /* 205464 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(205554), // Rule ID 2071 //
     /* 205469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 205477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 205480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 205483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 205486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 205489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205534 */     // MIs[2] Operand 1
     /* 205534 */     // No operand predicates
     /* 205534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205536 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 205539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205552 */     GIR_RootConstrainSelectedInstOperands,
     /* 205553 */     // GIR_Coverage, 2071,
     /* 205553 */     GIR_EraseRootFromParent_Done,
     /* 205554 */   // Label 4086: @205554
     /* 205554 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(205644), // Rule ID 2077 //
     /* 205559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 205567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 205570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 205573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 205576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 205579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205620 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205624 */     // MIs[2] Operand 1
     /* 205624 */     // No operand predicates
     /* 205624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205626 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 205629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205642 */     GIR_RootConstrainSelectedInstOperands,
     /* 205643 */     // GIR_Coverage, 2077,
     /* 205643 */     GIR_EraseRootFromParent_Done,
     /* 205644 */   // Label 4087: @205644
     /* 205644 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(205734), // Rule ID 2078 //
     /* 205649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 205657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 205660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 205663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 205666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 205669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 205689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 205702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205710 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 205714 */     // MIs[2] Operand 1
     /* 205714 */     // No operand predicates
     /* 205714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205716 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 205719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205732 */     GIR_RootConstrainSelectedInstOperands,
     /* 205733 */     // GIR_Coverage, 2078,
     /* 205733 */     GIR_EraseRootFromParent_Done,
     /* 205734 */   // Label 4088: @205734
     /* 205734 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(205824), // Rule ID 2073 //
     /* 205739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 205747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 205750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 205753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 205756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 205759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 205779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205800 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 205804 */     // MIs[2] Operand 1
     /* 205804 */     // No operand predicates
     /* 205804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205806 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 205809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205822 */     GIR_RootConstrainSelectedInstOperands,
     /* 205823 */     // GIR_Coverage, 2073,
     /* 205823 */     GIR_EraseRootFromParent_Done,
     /* 205824 */   // Label 4089: @205824
     /* 205824 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(205914), // Rule ID 2074 //
     /* 205829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 205837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 205840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 205843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 205846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 205849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 205869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 205894 */     // MIs[2] Operand 1
     /* 205894 */     // No operand predicates
     /* 205894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205896 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 205899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 205912 */     GIR_RootConstrainSelectedInstOperands,
     /* 205913 */     // GIR_Coverage, 2074,
     /* 205913 */     GIR_EraseRootFromParent_Done,
     /* 205914 */   // Label 4090: @205914
     /* 205914 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(206004), // Rule ID 2080 //
     /* 205919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 205922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 205927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 205930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 205933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 205936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 205939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 205951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 205959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 205967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 205976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 205980 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 205984 */     // MIs[2] Operand 1
     /* 205984 */     // No operand predicates
     /* 205984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205986 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 205986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 205989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 205993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 205995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 205999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 206002 */     GIR_RootConstrainSelectedInstOperands,
     /* 206003 */     // GIR_Coverage, 2080,
     /* 206003 */     GIR_EraseRootFromParent_Done,
     /* 206004 */   // Label 4091: @206004
     /* 206004 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(206094), // Rule ID 2081 //
     /* 206009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 206012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 206017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 206020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 206023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 206026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 206029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 206049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 206057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 206066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 206070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 206074 */     // MIs[2] Operand 1
     /* 206074 */     // No operand predicates
     /* 206074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206076 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 206076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 206079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 206085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 206089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 206092 */     GIR_RootConstrainSelectedInstOperands,
     /* 206093 */     // GIR_Coverage, 2081,
     /* 206093 */     GIR_EraseRootFromParent_Done,
     /* 206094 */   // Label 4092: @206094
     /* 206094 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(206184), // Rule ID 2075 //
     /* 206099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 206102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 206107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 206110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 206119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 206139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 206147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 206156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 206160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 206164 */     // MIs[2] Operand 1
     /* 206164 */     // No operand predicates
     /* 206164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206166 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 206166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 206169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 206175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 206179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 206182 */     GIR_RootConstrainSelectedInstOperands,
     /* 206183 */     // GIR_Coverage, 2075,
     /* 206183 */     GIR_EraseRootFromParent_Done,
     /* 206184 */   // Label 4093: @206184
     /* 206184 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(206274), // Rule ID 2082 //
     /* 206189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 206192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 206197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 206200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 206209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 206221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 206229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 206233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 206237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 206246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 206250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 206254 */     // MIs[2] Operand 1
     /* 206254 */     // No operand predicates
     /* 206254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206256 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 206256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 206259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 206265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 206269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 206272 */     GIR_RootConstrainSelectedInstOperands,
     /* 206273 */     // GIR_Coverage, 2082,
     /* 206273 */     GIR_EraseRootFromParent_Done,
     /* 206274 */   // Label 4094: @206274
     /* 206274 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(206351), // Rule ID 2781 //
     /* 206279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206331 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206335 */     // MIs[2] Operand 1
     /* 206335 */     // No operand predicates
     /* 206335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206337 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 206340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206349 */     GIR_RootConstrainSelectedInstOperands,
     /* 206350 */     // GIR_Coverage, 2781,
     /* 206350 */     GIR_EraseRootFromParent_Done,
     /* 206351 */   // Label 4095: @206351
     /* 206351 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(206428), // Rule ID 2782 //
     /* 206356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206408 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206412 */     // MIs[2] Operand 1
     /* 206412 */     // No operand predicates
     /* 206412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206414 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 206417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206426 */     GIR_RootConstrainSelectedInstOperands,
     /* 206427 */     // GIR_Coverage, 2782,
     /* 206427 */     GIR_EraseRootFromParent_Done,
     /* 206428 */   // Label 4096: @206428
     /* 206428 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(206505), // Rule ID 2783 //
     /* 206433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206485 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206489 */     // MIs[2] Operand 1
     /* 206489 */     // No operand predicates
     /* 206489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206491 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 206494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206503 */     GIR_RootConstrainSelectedInstOperands,
     /* 206504 */     // GIR_Coverage, 2783,
     /* 206504 */     GIR_EraseRootFromParent_Done,
     /* 206505 */   // Label 4097: @206505
     /* 206505 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(206582), // Rule ID 2784 //
     /* 206510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206562 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206566 */     // MIs[2] Operand 1
     /* 206566 */     // No operand predicates
     /* 206566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206568 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 206571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206580 */     GIR_RootConstrainSelectedInstOperands,
     /* 206581 */     // GIR_Coverage, 2784,
     /* 206581 */     GIR_EraseRootFromParent_Done,
     /* 206582 */   // Label 4098: @206582
     /* 206582 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(206659), // Rule ID 2785 //
     /* 206587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206639 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206643 */     // MIs[2] Operand 1
     /* 206643 */     // No operand predicates
     /* 206643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206645 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 206648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206657 */     GIR_RootConstrainSelectedInstOperands,
     /* 206658 */     // GIR_Coverage, 2785,
     /* 206658 */     GIR_EraseRootFromParent_Done,
     /* 206659 */   // Label 4099: @206659
     /* 206659 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(206736), // Rule ID 2786 //
     /* 206664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 206672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206716 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206720 */     // MIs[2] Operand 1
     /* 206720 */     // No operand predicates
     /* 206720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206722 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 206725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206734 */     GIR_RootConstrainSelectedInstOperands,
     /* 206735 */     // GIR_Coverage, 2786,
     /* 206735 */     GIR_EraseRootFromParent_Done,
     /* 206736 */   // Label 4100: @206736
     /* 206736 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(206813), // Rule ID 7887 //
     /* 206741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 206749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206793 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206797 */     // MIs[2] Operand 1
     /* 206797 */     // No operand predicates
     /* 206797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206799 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 206802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206811 */     GIR_RootConstrainSelectedInstOperands,
     /* 206812 */     // GIR_Coverage, 7887,
     /* 206812 */     GIR_EraseRootFromParent_Done,
     /* 206813 */   // Label 4101: @206813
     /* 206813 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(206890), // Rule ID 7888 //
     /* 206818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 206826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206870 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206874 */     // MIs[2] Operand 1
     /* 206874 */     // No operand predicates
     /* 206874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206876 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 206879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206888 */     GIR_RootConstrainSelectedInstOperands,
     /* 206889 */     // GIR_Coverage, 7888,
     /* 206889 */     GIR_EraseRootFromParent_Done,
     /* 206890 */   // Label 4102: @206890
     /* 206890 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(206967), // Rule ID 7889 //
     /* 206895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 206903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206947 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206951 */     // MIs[2] Operand 1
     /* 206951 */     // No operand predicates
     /* 206951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206953 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 206956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206965 */     GIR_RootConstrainSelectedInstOperands,
     /* 206966 */     // GIR_Coverage, 7889,
     /* 206966 */     GIR_EraseRootFromParent_Done,
     /* 206967 */   // Label 4103: @206967
     /* 206967 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(207044), // Rule ID 7890 //
     /* 206972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 206980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207024 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207028 */     // MIs[2] Operand 1
     /* 207028 */     // No operand predicates
     /* 207028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207030 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 207033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207042 */     GIR_RootConstrainSelectedInstOperands,
     /* 207043 */     // GIR_Coverage, 7890,
     /* 207043 */     GIR_EraseRootFromParent_Done,
     /* 207044 */   // Label 4104: @207044
     /* 207044 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(207121), // Rule ID 7891 //
     /* 207049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 207057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207101 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207105 */     // MIs[2] Operand 1
     /* 207105 */     // No operand predicates
     /* 207105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207107 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 207110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207119 */     GIR_RootConstrainSelectedInstOperands,
     /* 207120 */     // GIR_Coverage, 7891,
     /* 207120 */     GIR_EraseRootFromParent_Done,
     /* 207121 */   // Label 4105: @207121
     /* 207121 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(207198), // Rule ID 7892 //
     /* 207126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 207134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207178 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207182 */     // MIs[2] Operand 1
     /* 207182 */     // No operand predicates
     /* 207182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207184 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 207187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207196 */     GIR_RootConstrainSelectedInstOperands,
     /* 207197 */     // GIR_Coverage, 7892,
     /* 207197 */     GIR_EraseRootFromParent_Done,
     /* 207198 */   // Label 4106: @207198
     /* 207198 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(207275), // Rule ID 7893 //
     /* 207203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207255 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207259 */     // MIs[2] Operand 1
     /* 207259 */     // No operand predicates
     /* 207259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207261 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 207264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207273 */     GIR_RootConstrainSelectedInstOperands,
     /* 207274 */     // GIR_Coverage, 7893,
     /* 207274 */     GIR_EraseRootFromParent_Done,
     /* 207275 */   // Label 4107: @207275
     /* 207275 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(207352), // Rule ID 7894 //
     /* 207280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207332 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 207336 */     // MIs[2] Operand 1
     /* 207336 */     // No operand predicates
     /* 207336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207338 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 207341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207350 */     GIR_RootConstrainSelectedInstOperands,
     /* 207351 */     // GIR_Coverage, 7894,
     /* 207351 */     GIR_EraseRootFromParent_Done,
     /* 207352 */   // Label 4108: @207352
     /* 207352 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(207429), // Rule ID 7895 //
     /* 207357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207409 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207413 */     // MIs[2] Operand 1
     /* 207413 */     // No operand predicates
     /* 207413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207415 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 207418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207427 */     GIR_RootConstrainSelectedInstOperands,
     /* 207428 */     // GIR_Coverage, 7895,
     /* 207428 */     GIR_EraseRootFromParent_Done,
     /* 207429 */   // Label 4109: @207429
     /* 207429 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(207506), // Rule ID 7896 //
     /* 207434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207486 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 207490 */     // MIs[2] Operand 1
     /* 207490 */     // No operand predicates
     /* 207490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207492 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 207495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207504 */     GIR_RootConstrainSelectedInstOperands,
     /* 207505 */     // GIR_Coverage, 7896,
     /* 207505 */     GIR_EraseRootFromParent_Done,
     /* 207506 */   // Label 4110: @207506
     /* 207506 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(207583), // Rule ID 7897 //
     /* 207511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207563 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207567 */     // MIs[2] Operand 1
     /* 207567 */     // No operand predicates
     /* 207567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207569 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 207572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207581 */     GIR_RootConstrainSelectedInstOperands,
     /* 207582 */     // GIR_Coverage, 7897,
     /* 207582 */     GIR_EraseRootFromParent_Done,
     /* 207583 */   // Label 4111: @207583
     /* 207583 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(207660), // Rule ID 7898 //
     /* 207588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 207596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207640 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 207644 */     // MIs[2] Operand 1
     /* 207644 */     // No operand predicates
     /* 207644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207646 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 207649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207658 */     GIR_RootConstrainSelectedInstOperands,
     /* 207659 */     // GIR_Coverage, 7898,
     /* 207659 */     GIR_EraseRootFromParent_Done,
     /* 207660 */   // Label 4112: @207660
     /* 207660 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(207737), // Rule ID 7899 //
     /* 207665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207717 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207721 */     // MIs[2] Operand 1
     /* 207721 */     // No operand predicates
     /* 207721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207723 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 207726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207735 */     GIR_RootConstrainSelectedInstOperands,
     /* 207736 */     // GIR_Coverage, 7899,
     /* 207736 */     GIR_EraseRootFromParent_Done,
     /* 207737 */   // Label 4113: @207737
     /* 207737 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(207814), // Rule ID 7900 //
     /* 207742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207794 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207798 */     // MIs[2] Operand 1
     /* 207798 */     // No operand predicates
     /* 207798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207800 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 207803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207812 */     GIR_RootConstrainSelectedInstOperands,
     /* 207813 */     // GIR_Coverage, 7900,
     /* 207813 */     GIR_EraseRootFromParent_Done,
     /* 207814 */   // Label 4114: @207814
     /* 207814 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(207891), // Rule ID 7901 //
     /* 207819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207871 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 207875 */     // MIs[2] Operand 1
     /* 207875 */     // No operand predicates
     /* 207875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207877 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 207880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207889 */     GIR_RootConstrainSelectedInstOperands,
     /* 207890 */     // GIR_Coverage, 7901,
     /* 207890 */     GIR_EraseRootFromParent_Done,
     /* 207891 */   // Label 4115: @207891
     /* 207891 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(207968), // Rule ID 7902 //
     /* 207896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207948 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207952 */     // MIs[2] Operand 1
     /* 207952 */     // No operand predicates
     /* 207952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207954 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 207957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207966 */     GIR_RootConstrainSelectedInstOperands,
     /* 207967 */     // GIR_Coverage, 7902,
     /* 207967 */     GIR_EraseRootFromParent_Done,
     /* 207968 */   // Label 4116: @207968
     /* 207968 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208045), // Rule ID 7903 //
     /* 207973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 207981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208025 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 208029 */     // MIs[2] Operand 1
     /* 208029 */     // No operand predicates
     /* 208029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208031 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 208031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 208034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208043 */     GIR_RootConstrainSelectedInstOperands,
     /* 208044 */     // GIR_Coverage, 7903,
     /* 208044 */     GIR_EraseRootFromParent_Done,
     /* 208045 */   // Label 4117: @208045
     /* 208045 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208122), // Rule ID 7904 //
     /* 208050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 208058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208102 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208106 */     // MIs[2] Operand 1
     /* 208106 */     // No operand predicates
     /* 208106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 208108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 208111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208120 */     GIR_RootConstrainSelectedInstOperands,
     /* 208121 */     // GIR_Coverage, 7904,
     /* 208121 */     GIR_EraseRootFromParent_Done,
     /* 208122 */   // Label 4118: @208122
     /* 208122 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208199), // Rule ID 7905 //
     /* 208127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208179 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208183 */     // MIs[2] Operand 1
     /* 208183 */     // No operand predicates
     /* 208183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208185 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 208185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 208188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208197 */     GIR_RootConstrainSelectedInstOperands,
     /* 208198 */     // GIR_Coverage, 7905,
     /* 208198 */     GIR_EraseRootFromParent_Done,
     /* 208199 */   // Label 4119: @208199
     /* 208199 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208276), // Rule ID 7906 //
     /* 208204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208256 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208260 */     // MIs[2] Operand 1
     /* 208260 */     // No operand predicates
     /* 208260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208262 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 208262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 208265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208274 */     GIR_RootConstrainSelectedInstOperands,
     /* 208275 */     // GIR_Coverage, 7906,
     /* 208275 */     GIR_EraseRootFromParent_Done,
     /* 208276 */   // Label 4120: @208276
     /* 208276 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208353), // Rule ID 7907 //
     /* 208281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208333 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208337 */     // MIs[2] Operand 1
     /* 208337 */     // No operand predicates
     /* 208337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 208339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 208342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208351 */     GIR_RootConstrainSelectedInstOperands,
     /* 208352 */     // GIR_Coverage, 7907,
     /* 208352 */     GIR_EraseRootFromParent_Done,
     /* 208353 */   // Label 4121: @208353
     /* 208353 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(208430), // Rule ID 7908 //
     /* 208358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208410 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208414 */     // MIs[2] Operand 1
     /* 208414 */     // No operand predicates
     /* 208414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208416 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 208416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 208419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208428 */     GIR_RootConstrainSelectedInstOperands,
     /* 208429 */     // GIR_Coverage, 7908,
     /* 208429 */     GIR_EraseRootFromParent_Done,
     /* 208430 */   // Label 4122: @208430
     /* 208430 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(208507), // Rule ID 7909 //
     /* 208435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208487 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208491 */     // MIs[2] Operand 1
     /* 208491 */     // No operand predicates
     /* 208491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208493 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 208493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 208496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208505 */     GIR_RootConstrainSelectedInstOperands,
     /* 208506 */     // GIR_Coverage, 7909,
     /* 208506 */     GIR_EraseRootFromParent_Done,
     /* 208507 */   // Label 4123: @208507
     /* 208507 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(208584), // Rule ID 7910 //
     /* 208512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 208520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208564 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208568 */     // MIs[2] Operand 1
     /* 208568 */     // No operand predicates
     /* 208568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208570 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 208570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 208573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208582 */     GIR_RootConstrainSelectedInstOperands,
     /* 208583 */     // GIR_Coverage, 7910,
     /* 208583 */     GIR_EraseRootFromParent_Done,
     /* 208584 */   // Label 4124: @208584
     /* 208584 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(208661), // Rule ID 7911 //
     /* 208589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208641 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208645 */     // MIs[2] Operand 1
     /* 208645 */     // No operand predicates
     /* 208645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208647 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 208647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 208650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208659 */     GIR_RootConstrainSelectedInstOperands,
     /* 208660 */     // GIR_Coverage, 7911,
     /* 208660 */     GIR_EraseRootFromParent_Done,
     /* 208661 */   // Label 4125: @208661
     /* 208661 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(208738), // Rule ID 7912 //
     /* 208666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208718 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208722 */     // MIs[2] Operand 1
     /* 208722 */     // No operand predicates
     /* 208722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208724 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 208724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 208727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208736 */     GIR_RootConstrainSelectedInstOperands,
     /* 208737 */     // GIR_Coverage, 7912,
     /* 208737 */     GIR_EraseRootFromParent_Done,
     /* 208738 */   // Label 4126: @208738
     /* 208738 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(208815), // Rule ID 7913 //
     /* 208743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208795 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208799 */     // MIs[2] Operand 1
     /* 208799 */     // No operand predicates
     /* 208799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208801 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 208801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 208804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208813 */     GIR_RootConstrainSelectedInstOperands,
     /* 208814 */     // GIR_Coverage, 7913,
     /* 208814 */     GIR_EraseRootFromParent_Done,
     /* 208815 */   // Label 4127: @208815
     /* 208815 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(208892), // Rule ID 7914 //
     /* 208820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208872 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208876 */     // MIs[2] Operand 1
     /* 208876 */     // No operand predicates
     /* 208876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208878 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 208878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 208881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208890 */     GIR_RootConstrainSelectedInstOperands,
     /* 208891 */     // GIR_Coverage, 7914,
     /* 208891 */     GIR_EraseRootFromParent_Done,
     /* 208892 */   // Label 4128: @208892
     /* 208892 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(208969), // Rule ID 7915 //
     /* 208897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208949 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208953 */     // MIs[2] Operand 1
     /* 208953 */     // No operand predicates
     /* 208953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208955 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 208955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 208958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208967 */     GIR_RootConstrainSelectedInstOperands,
     /* 208968 */     // GIR_Coverage, 7915,
     /* 208968 */     GIR_EraseRootFromParent_Done,
     /* 208969 */   // Label 4129: @208969
     /* 208969 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209046), // Rule ID 7916 //
     /* 208974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 208982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209026 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209030 */     // MIs[2] Operand 1
     /* 209030 */     // No operand predicates
     /* 209030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209032 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 209032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 209035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209044 */     GIR_RootConstrainSelectedInstOperands,
     /* 209045 */     // GIR_Coverage, 7916,
     /* 209045 */     GIR_EraseRootFromParent_Done,
     /* 209046 */   // Label 4130: @209046
     /* 209046 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209123), // Rule ID 7917 //
     /* 209051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 209095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209103 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209107 */     // MIs[2] Operand 1
     /* 209107 */     // No operand predicates
     /* 209107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209109 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 209109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 209112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209121 */     GIR_RootConstrainSelectedInstOperands,
     /* 209122 */     // GIR_Coverage, 7917,
     /* 209122 */     GIR_EraseRootFromParent_Done,
     /* 209123 */   // Label 4131: @209123
     /* 209123 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209200), // Rule ID 7918 //
     /* 209128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 209172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209180 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209184 */     // MIs[2] Operand 1
     /* 209184 */     // No operand predicates
     /* 209184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209186 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 209186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 209189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209198 */     GIR_RootConstrainSelectedInstOperands,
     /* 209199 */     // GIR_Coverage, 7918,
     /* 209199 */     GIR_EraseRootFromParent_Done,
     /* 209200 */   // Label 4132: @209200
     /* 209200 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209277), // Rule ID 7919 //
     /* 209205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 209249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209257 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209261 */     // MIs[2] Operand 1
     /* 209261 */     // No operand predicates
     /* 209261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209263 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 209263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 209266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209275 */     GIR_RootConstrainSelectedInstOperands,
     /* 209276 */     // GIR_Coverage, 7919,
     /* 209276 */     GIR_EraseRootFromParent_Done,
     /* 209277 */   // Label 4133: @209277
     /* 209277 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209354), // Rule ID 7920 //
     /* 209282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 209326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209334 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209338 */     // MIs[2] Operand 1
     /* 209338 */     // No operand predicates
     /* 209338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209340 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 209340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 209343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209352 */     GIR_RootConstrainSelectedInstOperands,
     /* 209353 */     // GIR_Coverage, 7920,
     /* 209353 */     GIR_EraseRootFromParent_Done,
     /* 209354 */   // Label 4134: @209354
     /* 209354 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209431), // Rule ID 7921 //
     /* 209359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209411 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209415 */     // MIs[2] Operand 1
     /* 209415 */     // No operand predicates
     /* 209415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209417 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 209417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 209420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209429 */     GIR_RootConstrainSelectedInstOperands,
     /* 209430 */     // GIR_Coverage, 7921,
     /* 209430 */     GIR_EraseRootFromParent_Done,
     /* 209431 */   // Label 4135: @209431
     /* 209431 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209508), // Rule ID 7922 //
     /* 209436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 209444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209488 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209492 */     // MIs[2] Operand 1
     /* 209492 */     // No operand predicates
     /* 209492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209494 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 209494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 209497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209506 */     GIR_RootConstrainSelectedInstOperands,
     /* 209507 */     // GIR_Coverage, 7922,
     /* 209507 */     GIR_EraseRootFromParent_Done,
     /* 209508 */   // Label 4136: @209508
     /* 209508 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209585), // Rule ID 7923 //
     /* 209513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 209557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209565 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209569 */     // MIs[2] Operand 1
     /* 209569 */     // No operand predicates
     /* 209569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209571 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 209571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 209574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209583 */     GIR_RootConstrainSelectedInstOperands,
     /* 209584 */     // GIR_Coverage, 7923,
     /* 209584 */     GIR_EraseRootFromParent_Done,
     /* 209585 */   // Label 4137: @209585
     /* 209585 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209662), // Rule ID 7924 //
     /* 209590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 209634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209642 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209646 */     // MIs[2] Operand 1
     /* 209646 */     // No operand predicates
     /* 209646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209648 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 209648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 209651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209660 */     GIR_RootConstrainSelectedInstOperands,
     /* 209661 */     // GIR_Coverage, 7924,
     /* 209661 */     GIR_EraseRootFromParent_Done,
     /* 209662 */   // Label 4138: @209662
     /* 209662 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209739), // Rule ID 7925 //
     /* 209667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 209711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209719 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209723 */     // MIs[2] Operand 1
     /* 209723 */     // No operand predicates
     /* 209723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 209725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 209728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209737 */     GIR_RootConstrainSelectedInstOperands,
     /* 209738 */     // GIR_Coverage, 7925,
     /* 209738 */     GIR_EraseRootFromParent_Done,
     /* 209739 */   // Label 4139: @209739
     /* 209739 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209816), // Rule ID 7926 //
     /* 209744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 209788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209796 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209800 */     // MIs[2] Operand 1
     /* 209800 */     // No operand predicates
     /* 209800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209802 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 209802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 209805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209814 */     GIR_RootConstrainSelectedInstOperands,
     /* 209815 */     // GIR_Coverage, 7926,
     /* 209815 */     GIR_EraseRootFromParent_Done,
     /* 209816 */   // Label 4140: @209816
     /* 209816 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(209893), // Rule ID 7927 //
     /* 209821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209873 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 209877 */     // MIs[2] Operand 1
     /* 209877 */     // No operand predicates
     /* 209877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209879 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 209879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 209882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209891 */     GIR_RootConstrainSelectedInstOperands,
     /* 209892 */     // GIR_Coverage, 7927,
     /* 209892 */     GIR_EraseRootFromParent_Done,
     /* 209893 */   // Label 4141: @209893
     /* 209893 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(209970), // Rule ID 7928 //
     /* 209898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 209906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 209926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 209934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 209938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 209942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 209946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 209950 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 209954 */     // MIs[2] Operand 1
     /* 209954 */     // No operand predicates
     /* 209954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 209956 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 209956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 209959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 209963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 209965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209968 */     GIR_RootConstrainSelectedInstOperands,
     /* 209969 */     // GIR_Coverage, 7928,
     /* 209969 */     GIR_EraseRootFromParent_Done,
     /* 209970 */   // Label 4142: @209970
     /* 209970 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210026), // Rule ID 55 //
     /* 209975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 209978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 209983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 209986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 209992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 209996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210000 */     // MIs[0] Operand 3
     /* 210000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 210011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 210015 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 210015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 210018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 210024 */     GIR_RootConstrainSelectedInstOperands,
     /* 210025 */     // GIR_Coverage, 55,
     /* 210025 */     GIR_EraseRootFromParent_Done,
     /* 210026 */   // Label 4143: @210026
     /* 210026 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210082), // Rule ID 56 //
     /* 210031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 210034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 210039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 210042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 210048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210056 */     // MIs[0] Operand 3
     /* 210056 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 210067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 210071 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 210071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 210074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 210080 */     GIR_RootConstrainSelectedInstOperands,
     /* 210081 */     // GIR_Coverage, 56,
     /* 210081 */     GIR_EraseRootFromParent_Done,
     /* 210082 */   // Label 4144: @210082
     /* 210082 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210138), // Rule ID 57 //
     /* 210087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 210090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 210095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 210098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 210104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210112 */     // MIs[0] Operand 3
     /* 210112 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 210123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 210127 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 210127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 210130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 210136 */     GIR_RootConstrainSelectedInstOperands,
     /* 210137 */     // GIR_Coverage, 57,
     /* 210137 */     GIR_EraseRootFromParent_Done,
     /* 210138 */   // Label 4145: @210138
     /* 210138 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210194), // Rule ID 58 //
     /* 210143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 210146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 210151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 210154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 210160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 210168 */     // MIs[0] Operand 3
     /* 210168 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 210179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 210183 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 210183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 210186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 210192 */     GIR_RootConstrainSelectedInstOperands,
     /* 210193 */     // GIR_Coverage, 58,
     /* 210193 */     GIR_EraseRootFromParent_Done,
     /* 210194 */   // Label 4146: @210194
     /* 210194 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210249), // Rule ID 2799 //
     /* 210199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 210202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 210207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210228 */     // MIs[0] imm
     /* 210228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 210236 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1542:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 210236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 210239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 210243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 210245 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 210247 */     GIR_RootConstrainSelectedInstOperands,
     /* 210248 */     // GIR_Coverage, 2799,
     /* 210248 */     GIR_EraseRootFromParent_Done,
     /* 210249 */   // Label 4147: @210249
     /* 210249 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210304), // Rule ID 2800 //
     /* 210254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 210257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 210262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210283 */     // MIs[0] imm
     /* 210283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 210291 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1542:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 210291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 210294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 210298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 210300 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 210302 */     GIR_RootConstrainSelectedInstOperands,
     /* 210303 */     // GIR_Coverage, 2800,
     /* 210303 */     GIR_EraseRootFromParent_Done,
     /* 210304 */   // Label 4148: @210304
     /* 210304 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210359), // Rule ID 2801 //
     /* 210309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 210312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 210317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210338 */     // MIs[0] imm
     /* 210338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 210346 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1542:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 210346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 210349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 210353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 210355 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 210357 */     GIR_RootConstrainSelectedInstOperands,
     /* 210358 */     // GIR_Coverage, 2801,
     /* 210358 */     GIR_EraseRootFromParent_Done,
     /* 210359 */   // Label 4149: @210359
     /* 210359 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210414), // Rule ID 3552 //
     /* 210364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 210367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 210372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 210381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210393 */     // MIs[0] Idx
     /* 210393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 210401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 210401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 210404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 210408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 210410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 210412 */     GIR_RootConstrainSelectedInstOperands,
     /* 210413 */     // GIR_Coverage, 3552,
     /* 210413 */     GIR_EraseRootFromParent_Done,
     /* 210414 */   // Label 4150: @210414
     /* 210414 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210469), // Rule ID 3553 //
     /* 210419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 210422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 210427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 210436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210448 */     // MIs[0] Idx
     /* 210448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 210456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 210456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 210459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 210463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 210465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 210467 */     GIR_RootConstrainSelectedInstOperands,
     /* 210468 */     // GIR_Coverage, 3553,
     /* 210468 */     GIR_EraseRootFromParent_Done,
     /* 210469 */   // Label 4151: @210469
     /* 210469 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210524), // Rule ID 3554 //
     /* 210474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 210477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 210482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 210491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210503 */     // MIs[0] Idx
     /* 210503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 210511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 210511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 210514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 210518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 210520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 210522 */     GIR_RootConstrainSelectedInstOperands,
     /* 210523 */     // GIR_Coverage, 3554,
     /* 210523 */     GIR_EraseRootFromParent_Done,
     /* 210524 */   // Label 4152: @210524
     /* 210524 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210579), // Rule ID 3844 //
     /* 210529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 210537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210558 */     // MIs[0] imm
     /* 210558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 210566 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 210566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 210569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 210573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 210575 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 210577 */     GIR_RootConstrainSelectedInstOperands,
     /* 210578 */     // GIR_Coverage, 3844,
     /* 210578 */     GIR_EraseRootFromParent_Done,
     /* 210579 */   // Label 4153: @210579
     /* 210579 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210626), // Rule ID 2853 //
     /* 210584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 210587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 210592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210605 */     // MIs[0] idx
     /* 210605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210613 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 210613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 210616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210622 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 210624 */     GIR_RootConstrainSelectedInstOperands,
     /* 210625 */     // GIR_Coverage, 2853,
     /* 210625 */     GIR_EraseRootFromParent_Done,
     /* 210626 */   // Label 4154: @210626
     /* 210626 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210673), // Rule ID 2854 //
     /* 210631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 210634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 210639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210652 */     // MIs[0] idx
     /* 210652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210660 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 210660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 210663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210669 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 210671 */     GIR_RootConstrainSelectedInstOperands,
     /* 210672 */     // GIR_Coverage, 2854,
     /* 210672 */     GIR_EraseRootFromParent_Done,
     /* 210673 */   // Label 4155: @210673
     /* 210673 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210720), // Rule ID 2855 //
     /* 210678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 210681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 210686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210699 */     // MIs[0] idx
     /* 210699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 210707 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 210707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 210710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210716 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 210718 */     GIR_RootConstrainSelectedInstOperands,
     /* 210719 */     // GIR_Coverage, 2855,
     /* 210719 */     GIR_EraseRootFromParent_Done,
     /* 210720 */   // Label 4156: @210720
     /* 210720 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210767), // Rule ID 3004 //
     /* 210725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 210733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210746 */     // MIs[0] Op3
     /* 210746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 210757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210765 */     GIR_RootConstrainSelectedInstOperands,
     /* 210766 */     // GIR_Coverage, 3004,
     /* 210766 */     GIR_EraseRootFromParent_Done,
     /* 210767 */   // Label 4157: @210767
     /* 210767 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210814), // Rule ID 3005 //
     /* 210772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 210780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210793 */     // MIs[0] Op3
     /* 210793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 210804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210812 */     GIR_RootConstrainSelectedInstOperands,
     /* 210813 */     // GIR_Coverage, 3005,
     /* 210813 */     GIR_EraseRootFromParent_Done,
     /* 210814 */   // Label 4158: @210814
     /* 210814 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(210861), // Rule ID 3006 //
     /* 210819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 210827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210840 */     // MIs[0] Op3
     /* 210840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 210848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 210848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 210851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210859 */     GIR_RootConstrainSelectedInstOperands,
     /* 210860 */     // GIR_Coverage, 3006,
     /* 210860 */     GIR_EraseRootFromParent_Done,
     /* 210861 */   // Label 4159: @210861
     /* 210861 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(210908), // Rule ID 3007 //
     /* 210866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 210874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210887 */     // MIs[0] Op3
     /* 210887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 210898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210906 */     GIR_RootConstrainSelectedInstOperands,
     /* 210907 */     // GIR_Coverage, 3007,
     /* 210907 */     GIR_EraseRootFromParent_Done,
     /* 210908 */   // Label 4160: @210908
     /* 210908 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(210955), // Rule ID 3008 //
     /* 210913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 210921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210934 */     // MIs[0] Op3
     /* 210934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 210945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210953 */     GIR_RootConstrainSelectedInstOperands,
     /* 210954 */     // GIR_Coverage, 3008,
     /* 210954 */     GIR_EraseRootFromParent_Done,
     /* 210955 */   // Label 4161: @210955
     /* 210955 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(211002), // Rule ID 3056 //
     /* 210960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 210968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210981 */     // MIs[0] Op3
     /* 210981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210989 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 210992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211000 */     GIR_RootConstrainSelectedInstOperands,
     /* 211001 */     // GIR_Coverage, 3056,
     /* 211001 */     GIR_EraseRootFromParent_Done,
     /* 211002 */   // Label 4162: @211002
     /* 211002 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(211049), // Rule ID 3058 //
     /* 211007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 211015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211028 */     // MIs[0] Op3
     /* 211028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 211039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211047 */     GIR_RootConstrainSelectedInstOperands,
     /* 211048 */     // GIR_Coverage, 3058,
     /* 211048 */     GIR_EraseRootFromParent_Done,
     /* 211049 */   // Label 4163: @211049
     /* 211049 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211096), // Rule ID 3060 //
     /* 211054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 211062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211075 */     // MIs[0] Op3
     /* 211075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 211086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211094 */     GIR_RootConstrainSelectedInstOperands,
     /* 211095 */     // GIR_Coverage, 3060,
     /* 211095 */     GIR_EraseRootFromParent_Done,
     /* 211096 */   // Label 4164: @211096
     /* 211096 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211143), // Rule ID 3062 //
     /* 211101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 211109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211122 */     // MIs[0] Op3
     /* 211122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 211133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211141 */     GIR_RootConstrainSelectedInstOperands,
     /* 211142 */     // GIR_Coverage, 3062,
     /* 211142 */     GIR_EraseRootFromParent_Done,
     /* 211143 */   // Label 4165: @211143
     /* 211143 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211190), // Rule ID 3084 //
     /* 211148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 211156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211169 */     // MIs[0] Op3
     /* 211169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211177 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 211180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211188 */     GIR_RootConstrainSelectedInstOperands,
     /* 211189 */     // GIR_Coverage, 3084,
     /* 211189 */     GIR_EraseRootFromParent_Done,
     /* 211190 */   // Label 4166: @211190
     /* 211190 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211237), // Rule ID 3085 //
     /* 211195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 211203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211216 */     // MIs[0] Op3
     /* 211216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 211227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211235 */     GIR_RootConstrainSelectedInstOperands,
     /* 211236 */     // GIR_Coverage, 3085,
     /* 211236 */     GIR_EraseRootFromParent_Done,
     /* 211237 */   // Label 4167: @211237
     /* 211237 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211284), // Rule ID 3086 //
     /* 211242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 211250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211263 */     // MIs[0] Op3
     /* 211263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 211274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211282 */     GIR_RootConstrainSelectedInstOperands,
     /* 211283 */     // GIR_Coverage, 3086,
     /* 211283 */     GIR_EraseRootFromParent_Done,
     /* 211284 */   // Label 4168: @211284
     /* 211284 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211331), // Rule ID 3155 //
     /* 211289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 211297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211310 */     // MIs[0] Op3
     /* 211310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2147:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 211321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211329 */     GIR_RootConstrainSelectedInstOperands,
     /* 211330 */     // GIR_Coverage, 3155,
     /* 211330 */     GIR_EraseRootFromParent_Done,
     /* 211331 */   // Label 4169: @211331
     /* 211331 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211378), // Rule ID 3156 //
     /* 211336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 211344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211357 */     // MIs[0] Op3
     /* 211357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211365 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2147:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 211368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211376 */     GIR_RootConstrainSelectedInstOperands,
     /* 211377 */     // GIR_Coverage, 3156,
     /* 211377 */     GIR_EraseRootFromParent_Done,
     /* 211378 */   // Label 4170: @211378
     /* 211378 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211425), // Rule ID 3157 //
     /* 211383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 211391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211404 */     // MIs[0] Op3
     /* 211404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2147:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 211415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211423 */     GIR_RootConstrainSelectedInstOperands,
     /* 211424 */     // GIR_Coverage, 3157,
     /* 211424 */     GIR_EraseRootFromParent_Done,
     /* 211425 */   // Label 4171: @211425
     /* 211425 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211472), // Rule ID 3158 //
     /* 211430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 211438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211451 */     // MIs[0] Op3
     /* 211451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211459 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2147:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 211462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211470 */     GIR_RootConstrainSelectedInstOperands,
     /* 211471 */     // GIR_Coverage, 3158,
     /* 211471 */     GIR_EraseRootFromParent_Done,
     /* 211472 */   // Label 4172: @211472
     /* 211472 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211519), // Rule ID 3537 //
     /* 211477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 211485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211498 */     // MIs[0] Op3
     /* 211498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 211506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1357:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 211506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 211509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211517 */     GIR_RootConstrainSelectedInstOperands,
     /* 211518 */     // GIR_Coverage, 3537,
     /* 211518 */     GIR_EraseRootFromParent_Done,
     /* 211519 */   // Label 4173: @211519
     /* 211519 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211566), // Rule ID 3585 //
     /* 211524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 211532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211545 */     // MIs[0] Op3
     /* 211545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 211553 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 211553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 211556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211564 */     GIR_RootConstrainSelectedInstOperands,
     /* 211565 */     // GIR_Coverage, 3585,
     /* 211565 */     GIR_EraseRootFromParent_Done,
     /* 211566 */   // Label 4174: @211566
     /* 211566 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211613), // Rule ID 3586 //
     /* 211571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 211579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211592 */     // MIs[0] Op3
     /* 211592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 211600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 211600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 211603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211611 */     GIR_RootConstrainSelectedInstOperands,
     /* 211612 */     // GIR_Coverage, 3586,
     /* 211612 */     GIR_EraseRootFromParent_Done,
     /* 211613 */   // Label 4175: @211613
     /* 211613 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211660), // Rule ID 3587 //
     /* 211618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 211626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211639 */     // MIs[0] Op3
     /* 211639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 211647 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1596:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 211647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 211650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211658 */     GIR_RootConstrainSelectedInstOperands,
     /* 211659 */     // GIR_Coverage, 3587,
     /* 211659 */     GIR_EraseRootFromParent_Done,
     /* 211660 */   // Label 4176: @211660
     /* 211660 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211707), // Rule ID 3588 //
     /* 211665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 211673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211686 */     // MIs[0] Op3
     /* 211686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 211694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 211694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 211697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211705 */     GIR_RootConstrainSelectedInstOperands,
     /* 211706 */     // GIR_Coverage, 3588,
     /* 211706 */     GIR_EraseRootFromParent_Done,
     /* 211707 */   // Label 4177: @211707
     /* 211707 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211754), // Rule ID 3589 //
     /* 211712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 211720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211733 */     // MIs[0] Op3
     /* 211733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 211741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 211741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 211744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211752 */     GIR_RootConstrainSelectedInstOperands,
     /* 211753 */     // GIR_Coverage, 3589,
     /* 211753 */     GIR_EraseRootFromParent_Done,
     /* 211754 */   // Label 4178: @211754
     /* 211754 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211801), // Rule ID 3590 //
     /* 211759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 211762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 211767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211780 */     // MIs[0] Op3
     /* 211780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 211788 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1597:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 211788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 211791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211799 */     GIR_RootConstrainSelectedInstOperands,
     /* 211800 */     // GIR_Coverage, 3590,
     /* 211800 */     GIR_EraseRootFromParent_Done,
     /* 211801 */   // Label 4179: @211801
     /* 211801 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(211848), // Rule ID 11345 //
     /* 211806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 211814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211827 */     // MIs[0] Op3
     /* 211827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 211835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 211835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 211838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211846 */     GIR_RootConstrainSelectedInstOperands,
     /* 211847 */     // GIR_Coverage, 11345,
     /* 211847 */     GIR_EraseRootFromParent_Done,
     /* 211848 */   // Label 4180: @211848
     /* 211848 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(211895), // Rule ID 11346 //
     /* 211853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 211861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211874 */     // MIs[0] Op3
     /* 211874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 211882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 211882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 211885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211893 */     GIR_RootConstrainSelectedInstOperands,
     /* 211894 */     // GIR_Coverage, 11346,
     /* 211894 */     GIR_EraseRootFromParent_Done,
     /* 211895 */   // Label 4181: @211895
     /* 211895 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(211942), // Rule ID 11347 //
     /* 211900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 211908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211921 */     // MIs[0] Op3
     /* 211921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 211929 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 211929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 211932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211940 */     GIR_RootConstrainSelectedInstOperands,
     /* 211941 */     // GIR_Coverage, 11347,
     /* 211941 */     GIR_EraseRootFromParent_Done,
     /* 211942 */   // Label 4182: @211942
     /* 211942 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(211989), // Rule ID 11348 //
     /* 211947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 211955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211968 */     // MIs[0] Op3
     /* 211968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 211976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 211976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 211979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211987 */     GIR_RootConstrainSelectedInstOperands,
     /* 211988 */     // GIR_Coverage, 11348,
     /* 211988 */     GIR_EraseRootFromParent_Done,
     /* 211989 */   // Label 4183: @211989
     /* 211989 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(212036), // Rule ID 11349 //
     /* 211994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 212002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212015 */     // MIs[0] Op3
     /* 212015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 212026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212034 */     GIR_RootConstrainSelectedInstOperands,
     /* 212035 */     // GIR_Coverage, 11349,
     /* 212035 */     GIR_EraseRootFromParent_Done,
     /* 212036 */   // Label 4184: @212036
     /* 212036 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212083), // Rule ID 11350 //
     /* 212041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 212049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212062 */     // MIs[0] Op3
     /* 212062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 212070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 212070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 212073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212081 */     GIR_RootConstrainSelectedInstOperands,
     /* 212082 */     // GIR_Coverage, 11350,
     /* 212082 */     GIR_EraseRootFromParent_Done,
     /* 212083 */   // Label 4185: @212083
     /* 212083 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212130), // Rule ID 11373 //
     /* 212088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 212096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212109 */     // MIs[0] Op3
     /* 212109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212117 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 212120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212128 */     GIR_RootConstrainSelectedInstOperands,
     /* 212129 */     // GIR_Coverage, 11373,
     /* 212129 */     GIR_EraseRootFromParent_Done,
     /* 212130 */   // Label 4186: @212130
     /* 212130 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212177), // Rule ID 11374 //
     /* 212135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 212143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212156 */     // MIs[0] Op3
     /* 212156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 212167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212175 */     GIR_RootConstrainSelectedInstOperands,
     /* 212176 */     // GIR_Coverage, 11374,
     /* 212176 */     GIR_EraseRootFromParent_Done,
     /* 212177 */   // Label 4187: @212177
     /* 212177 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212224), // Rule ID 11375 //
     /* 212182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 212190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212203 */     // MIs[0] Op3
     /* 212203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 212214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212222 */     GIR_RootConstrainSelectedInstOperands,
     /* 212223 */     // GIR_Coverage, 11375,
     /* 212223 */     GIR_EraseRootFromParent_Done,
     /* 212224 */   // Label 4188: @212224
     /* 212224 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212271), // Rule ID 11376 //
     /* 212229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 212237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212250 */     // MIs[0] Op3
     /* 212250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 212261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212269 */     GIR_RootConstrainSelectedInstOperands,
     /* 212270 */     // GIR_Coverage, 11376,
     /* 212270 */     GIR_EraseRootFromParent_Done,
     /* 212271 */   // Label 4189: @212271
     /* 212271 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212318), // Rule ID 11377 //
     /* 212276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 212284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212297 */     // MIs[0] Op3
     /* 212297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 212308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212316 */     GIR_RootConstrainSelectedInstOperands,
     /* 212317 */     // GIR_Coverage, 11377,
     /* 212317 */     GIR_EraseRootFromParent_Done,
     /* 212318 */   // Label 4190: @212318
     /* 212318 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212365), // Rule ID 11378 //
     /* 212323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 212331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212344 */     // MIs[0] Op3
     /* 212344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212352 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 212355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212363 */     GIR_RootConstrainSelectedInstOperands,
     /* 212364 */     // GIR_Coverage, 11378,
     /* 212364 */     GIR_EraseRootFromParent_Done,
     /* 212365 */   // Label 4191: @212365
     /* 212365 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212412), // Rule ID 11379 //
     /* 212370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 212378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212391 */     // MIs[0] Op3
     /* 212391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 212402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212410 */     GIR_RootConstrainSelectedInstOperands,
     /* 212411 */     // GIR_Coverage, 11379,
     /* 212411 */     GIR_EraseRootFromParent_Done,
     /* 212412 */   // Label 4192: @212412
     /* 212412 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212459), // Rule ID 11380 //
     /* 212417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 212425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212438 */     // MIs[0] Op3
     /* 212438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 212449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212457 */     GIR_RootConstrainSelectedInstOperands,
     /* 212458 */     // GIR_Coverage, 11380,
     /* 212458 */     GIR_EraseRootFromParent_Done,
     /* 212459 */   // Label 4193: @212459
     /* 212459 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212506), // Rule ID 11381 //
     /* 212464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 212472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212485 */     // MIs[0] Op3
     /* 212485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 212493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 212493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 212496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212504 */     GIR_RootConstrainSelectedInstOperands,
     /* 212505 */     // GIR_Coverage, 11381,
     /* 212505 */     GIR_EraseRootFromParent_Done,
     /* 212506 */   // Label 4194: @212506
     /* 212506 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212553), // Rule ID 11382 //
     /* 212511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 212519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212532 */     // MIs[0] Op3
     /* 212532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 212540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 212540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 212543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212551 */     GIR_RootConstrainSelectedInstOperands,
     /* 212552 */     // GIR_Coverage, 11382,
     /* 212552 */     GIR_EraseRootFromParent_Done,
     /* 212553 */   // Label 4195: @212553
     /* 212553 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212600), // Rule ID 11626 //
     /* 212558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 212566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212579 */     // MIs[0] Op3
     /* 212579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212587 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 212590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212598 */     GIR_RootConstrainSelectedInstOperands,
     /* 212599 */     // GIR_Coverage, 11626,
     /* 212599 */     GIR_EraseRootFromParent_Done,
     /* 212600 */   // Label 4196: @212600
     /* 212600 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212647), // Rule ID 11627 //
     /* 212605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 212613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212626 */     // MIs[0] Op3
     /* 212626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 212637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212645 */     GIR_RootConstrainSelectedInstOperands,
     /* 212646 */     // GIR_Coverage, 11627,
     /* 212646 */     GIR_EraseRootFromParent_Done,
     /* 212647 */   // Label 4197: @212647
     /* 212647 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212694), // Rule ID 11628 //
     /* 212652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 212660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212673 */     // MIs[0] Op3
     /* 212673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 212684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212692 */     GIR_RootConstrainSelectedInstOperands,
     /* 212693 */     // GIR_Coverage, 11628,
     /* 212693 */     GIR_EraseRootFromParent_Done,
     /* 212694 */   // Label 4198: @212694
     /* 212694 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212741), // Rule ID 11629 //
     /* 212699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 212707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212720 */     // MIs[0] Op3
     /* 212720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 212728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 212728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 212731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212739 */     GIR_RootConstrainSelectedInstOperands,
     /* 212740 */     // GIR_Coverage, 11629,
     /* 212740 */     GIR_EraseRootFromParent_Done,
     /* 212741 */   // Label 4199: @212741
     /* 212741 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212788), // Rule ID 11630 //
     /* 212746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 212754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212767 */     // MIs[0] Op3
     /* 212767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212775 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 212778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212786 */     GIR_RootConstrainSelectedInstOperands,
     /* 212787 */     // GIR_Coverage, 11630,
     /* 212787 */     GIR_EraseRootFromParent_Done,
     /* 212788 */   // Label 4200: @212788
     /* 212788 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212835), // Rule ID 11632 //
     /* 212793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 212801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212814 */     // MIs[0] Op3
     /* 212814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 212825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212833 */     GIR_RootConstrainSelectedInstOperands,
     /* 212834 */     // GIR_Coverage, 11632,
     /* 212834 */     GIR_EraseRootFromParent_Done,
     /* 212835 */   // Label 4201: @212835
     /* 212835 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(212882), // Rule ID 11634 //
     /* 212840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 212848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212861 */     // MIs[0] Op3
     /* 212861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 212872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212880 */     GIR_RootConstrainSelectedInstOperands,
     /* 212881 */     // GIR_Coverage, 11634,
     /* 212881 */     GIR_EraseRootFromParent_Done,
     /* 212882 */   // Label 4202: @212882
     /* 212882 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(212929), // Rule ID 11636 //
     /* 212887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 212895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212908 */     // MIs[0] Op3
     /* 212908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 212916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 212916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 212919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212927 */     GIR_RootConstrainSelectedInstOperands,
     /* 212928 */     // GIR_Coverage, 11636,
     /* 212928 */     GIR_EraseRootFromParent_Done,
     /* 212929 */   // Label 4203: @212929
     /* 212929 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(212976), // Rule ID 11638 //
     /* 212934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 212942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212955 */     // MIs[0] Op3
     /* 212955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 212963 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1842:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 212963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 212966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212974 */     GIR_RootConstrainSelectedInstOperands,
     /* 212975 */     // GIR_Coverage, 11638,
     /* 212975 */     GIR_EraseRootFromParent_Done,
     /* 212976 */   // Label 4204: @212976
     /* 212976 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213023), // Rule ID 11639 //
     /* 212981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 212989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213002 */     // MIs[0] Op3
     /* 213002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 213010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 213010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 213013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213021 */     GIR_RootConstrainSelectedInstOperands,
     /* 213022 */     // GIR_Coverage, 11639,
     /* 213022 */     GIR_EraseRootFromParent_Done,
     /* 213023 */   // Label 4205: @213023
     /* 213023 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213070), // Rule ID 11640 //
     /* 213028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 213036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213049 */     // MIs[0] Op3
     /* 213049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 213057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 213057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 213060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213068 */     GIR_RootConstrainSelectedInstOperands,
     /* 213069 */     // GIR_Coverage, 11640,
     /* 213069 */     GIR_EraseRootFromParent_Done,
     /* 213070 */   // Label 4206: @213070
     /* 213070 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213117), // Rule ID 11641 //
     /* 213075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 213083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213096 */     // MIs[0] Op3
     /* 213096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 213104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 213104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 213107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213115 */     GIR_RootConstrainSelectedInstOperands,
     /* 213116 */     // GIR_Coverage, 11641,
     /* 213116 */     GIR_EraseRootFromParent_Done,
     /* 213117 */   // Label 4207: @213117
     /* 213117 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213164), // Rule ID 11716 //
     /* 213122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 213130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213143 */     // MIs[0] Op3
     /* 213143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213151 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 213154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213162 */     GIR_RootConstrainSelectedInstOperands,
     /* 213163 */     // GIR_Coverage, 11716,
     /* 213163 */     GIR_EraseRootFromParent_Done,
     /* 213164 */   // Label 4208: @213164
     /* 213164 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213211), // Rule ID 11718 //
     /* 213169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 213177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213190 */     // MIs[0] Op3
     /* 213190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 213201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213209 */     GIR_RootConstrainSelectedInstOperands,
     /* 213210 */     // GIR_Coverage, 11718,
     /* 213210 */     GIR_EraseRootFromParent_Done,
     /* 213211 */   // Label 4209: @213211
     /* 213211 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213258), // Rule ID 11720 //
     /* 213216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 213224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213237 */     // MIs[0] Op3
     /* 213237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 213248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213256 */     GIR_RootConstrainSelectedInstOperands,
     /* 213257 */     // GIR_Coverage, 11720,
     /* 213257 */     GIR_EraseRootFromParent_Done,
     /* 213258 */   // Label 4210: @213258
     /* 213258 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213305), // Rule ID 11722 //
     /* 213263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 213271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213284 */     // MIs[0] Op3
     /* 213284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 213292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 213292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 213295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213303 */     GIR_RootConstrainSelectedInstOperands,
     /* 213304 */     // GIR_Coverage, 11722,
     /* 213304 */     GIR_EraseRootFromParent_Done,
     /* 213305 */   // Label 4211: @213305
     /* 213305 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213352), // Rule ID 11724 //
     /* 213310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 213318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213331 */     // MIs[0] Op3
     /* 213331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213339 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 213342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213350 */     GIR_RootConstrainSelectedInstOperands,
     /* 213351 */     // GIR_Coverage, 11724,
     /* 213351 */     GIR_EraseRootFromParent_Done,
     /* 213352 */   // Label 4212: @213352
     /* 213352 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213399), // Rule ID 11725 //
     /* 213357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 213365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213378 */     // MIs[0] Op3
     /* 213378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 213389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213397 */     GIR_RootConstrainSelectedInstOperands,
     /* 213398 */     // GIR_Coverage, 11725,
     /* 213398 */     GIR_EraseRootFromParent_Done,
     /* 213399 */   // Label 4213: @213399
     /* 213399 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213446), // Rule ID 11726 //
     /* 213404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 213412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213425 */     // MIs[0] Op3
     /* 213425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 213436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213444 */     GIR_RootConstrainSelectedInstOperands,
     /* 213445 */     // GIR_Coverage, 11726,
     /* 213445 */     GIR_EraseRootFromParent_Done,
     /* 213446 */   // Label 4214: @213446
     /* 213446 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213493), // Rule ID 11727 //
     /* 213451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 213459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213472 */     // MIs[0] Op3
     /* 213472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 213480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 213480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 213483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213491 */     GIR_RootConstrainSelectedInstOperands,
     /* 213492 */     // GIR_Coverage, 11727,
     /* 213492 */     GIR_EraseRootFromParent_Done,
     /* 213493 */   // Label 4215: @213493
     /* 213493 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213540), // Rule ID 11732 //
     /* 213498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 213506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213519 */     // MIs[0] Op3
     /* 213519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213527 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 213530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213538 */     GIR_RootConstrainSelectedInstOperands,
     /* 213539 */     // GIR_Coverage, 11732,
     /* 213539 */     GIR_EraseRootFromParent_Done,
     /* 213540 */   // Label 4216: @213540
     /* 213540 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213587), // Rule ID 11733 //
     /* 213545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 213553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213566 */     // MIs[0] Op3
     /* 213566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 213577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213585 */     GIR_RootConstrainSelectedInstOperands,
     /* 213586 */     // GIR_Coverage, 11733,
     /* 213586 */     GIR_EraseRootFromParent_Done,
     /* 213587 */   // Label 4217: @213587
     /* 213587 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(213634), // Rule ID 11734 //
     /* 213592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 213600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213613 */     // MIs[0] Op3
     /* 213613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213621 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 213624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213632 */     GIR_RootConstrainSelectedInstOperands,
     /* 213633 */     // GIR_Coverage, 11734,
     /* 213633 */     GIR_EraseRootFromParent_Done,
     /* 213634 */   // Label 4218: @213634
     /* 213634 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(213681), // Rule ID 11735 //
     /* 213639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 213647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213660 */     // MIs[0] Op3
     /* 213660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 213668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 213668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 213671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213679 */     GIR_RootConstrainSelectedInstOperands,
     /* 213680 */     // GIR_Coverage, 11735,
     /* 213680 */     GIR_EraseRootFromParent_Done,
     /* 213681 */   // Label 4219: @213681
     /* 213681 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(213728), // Rule ID 11795 //
     /* 213686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 213694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213707 */     // MIs[0] Op3
     /* 213707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213715 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 213718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213726 */     GIR_RootConstrainSelectedInstOperands,
     /* 213727 */     // GIR_Coverage, 11795,
     /* 213727 */     GIR_EraseRootFromParent_Done,
     /* 213728 */   // Label 4220: @213728
     /* 213728 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(213775), // Rule ID 11796 //
     /* 213733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 213741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213754 */     // MIs[0] Op3
     /* 213754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 213765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213773 */     GIR_RootConstrainSelectedInstOperands,
     /* 213774 */     // GIR_Coverage, 11796,
     /* 213774 */     GIR_EraseRootFromParent_Done,
     /* 213775 */   // Label 4221: @213775
     /* 213775 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(213822), // Rule ID 11797 //
     /* 213780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 213788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213801 */     // MIs[0] Op3
     /* 213801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 213812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213820 */     GIR_RootConstrainSelectedInstOperands,
     /* 213821 */     // GIR_Coverage, 11797,
     /* 213821 */     GIR_EraseRootFromParent_Done,
     /* 213822 */   // Label 4222: @213822
     /* 213822 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(213869), // Rule ID 11798 //
     /* 213827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 213835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213848 */     // MIs[0] Op3
     /* 213848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1719:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 213859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213867 */     GIR_RootConstrainSelectedInstOperands,
     /* 213868 */     // GIR_Coverage, 11798,
     /* 213868 */     GIR_EraseRootFromParent_Done,
     /* 213869 */   // Label 4223: @213869
     /* 213869 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(213916), // Rule ID 11799 //
     /* 213874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 213882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213895 */     // MIs[0] Op3
     /* 213895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213903 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 213906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213914 */     GIR_RootConstrainSelectedInstOperands,
     /* 213915 */     // GIR_Coverage, 11799,
     /* 213915 */     GIR_EraseRootFromParent_Done,
     /* 213916 */   // Label 4224: @213916
     /* 213916 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(213963), // Rule ID 11800 //
     /* 213921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 213929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213942 */     // MIs[0] Op3
     /* 213942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 213953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213961 */     GIR_RootConstrainSelectedInstOperands,
     /* 213962 */     // GIR_Coverage, 11800,
     /* 213962 */     GIR_EraseRootFromParent_Done,
     /* 213963 */   // Label 4225: @213963
     /* 213963 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214010), // Rule ID 11801 //
     /* 213968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 213976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213989 */     // MIs[0] Op3
     /* 213989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213997 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1677:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 214000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214008 */     GIR_RootConstrainSelectedInstOperands,
     /* 214009 */     // GIR_Coverage, 11801,
     /* 214009 */     GIR_EraseRootFromParent_Done,
     /* 214010 */   // Label 4226: @214010
     /* 214010 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214057), // Rule ID 11802 //
     /* 214015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 214023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214036 */     // MIs[0] Op3
     /* 214036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1677:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 214047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214055 */     GIR_RootConstrainSelectedInstOperands,
     /* 214056 */     // GIR_Coverage, 11802,
     /* 214056 */     GIR_EraseRootFromParent_Done,
     /* 214057 */   // Label 4227: @214057
     /* 214057 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214104), // Rule ID 11803 //
     /* 214062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 214070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214083 */     // MIs[0] Op3
     /* 214083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1677:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 214094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214102 */     GIR_RootConstrainSelectedInstOperands,
     /* 214103 */     // GIR_Coverage, 11803,
     /* 214103 */     GIR_EraseRootFromParent_Done,
     /* 214104 */   // Label 4228: @214104
     /* 214104 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214151), // Rule ID 11804 //
     /* 214109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 214117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214130 */     // MIs[0] Op3
     /* 214130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 214141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214149 */     GIR_RootConstrainSelectedInstOperands,
     /* 214150 */     // GIR_Coverage, 11804,
     /* 214150 */     GIR_EraseRootFromParent_Done,
     /* 214151 */   // Label 4229: @214151
     /* 214151 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214198), // Rule ID 11805 //
     /* 214156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 214164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214177 */     // MIs[0] Op3
     /* 214177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214185 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 214188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214196 */     GIR_RootConstrainSelectedInstOperands,
     /* 214197 */     // GIR_Coverage, 11805,
     /* 214197 */     GIR_EraseRootFromParent_Done,
     /* 214198 */   // Label 4230: @214198
     /* 214198 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214245), // Rule ID 11806 //
     /* 214203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 214211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214224 */     // MIs[0] Op3
     /* 214224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 214235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214243 */     GIR_RootConstrainSelectedInstOperands,
     /* 214244 */     // GIR_Coverage, 11806,
     /* 214244 */     GIR_EraseRootFromParent_Done,
     /* 214245 */   // Label 4231: @214245
     /* 214245 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214292), // Rule ID 11807 //
     /* 214250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 214258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214271 */     // MIs[0] Op3
     /* 214271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214279 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 214282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214290 */     GIR_RootConstrainSelectedInstOperands,
     /* 214291 */     // GIR_Coverage, 11807,
     /* 214291 */     GIR_EraseRootFromParent_Done,
     /* 214292 */   // Label 4232: @214292
     /* 214292 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214339), // Rule ID 11808 //
     /* 214297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 214305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214318 */     // MIs[0] Op3
     /* 214318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 214329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214337 */     GIR_RootConstrainSelectedInstOperands,
     /* 214338 */     // GIR_Coverage, 11808,
     /* 214338 */     GIR_EraseRootFromParent_Done,
     /* 214339 */   // Label 4233: @214339
     /* 214339 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214386), // Rule ID 11809 //
     /* 214344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 214352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214365 */     // MIs[0] Op3
     /* 214365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 214376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214384 */     GIR_RootConstrainSelectedInstOperands,
     /* 214385 */     // GIR_Coverage, 11809,
     /* 214385 */     GIR_EraseRootFromParent_Done,
     /* 214386 */   // Label 4234: @214386
     /* 214386 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214433), // Rule ID 11810 //
     /* 214391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 214399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214412 */     // MIs[0] Op3
     /* 214412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214420 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 214423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214431 */     GIR_RootConstrainSelectedInstOperands,
     /* 214432 */     // GIR_Coverage, 11810,
     /* 214432 */     GIR_EraseRootFromParent_Done,
     /* 214433 */   // Label 4235: @214433
     /* 214433 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(214480), // Rule ID 11811 //
     /* 214438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 214446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214459 */     // MIs[0] Op3
     /* 214459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214467 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 214470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214478 */     GIR_RootConstrainSelectedInstOperands,
     /* 214479 */     // GIR_Coverage, 11811,
     /* 214479 */     GIR_EraseRootFromParent_Done,
     /* 214480 */   // Label 4236: @214480
     /* 214480 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(214527), // Rule ID 11812 //
     /* 214485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 214493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214506 */     // MIs[0] Op3
     /* 214506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 214517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214525 */     GIR_RootConstrainSelectedInstOperands,
     /* 214526 */     // GIR_Coverage, 11812,
     /* 214526 */     GIR_EraseRootFromParent_Done,
     /* 214527 */   // Label 4237: @214527
     /* 214527 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(214574), // Rule ID 11813 //
     /* 214532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 214540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214553 */     // MIs[0] Op3
     /* 214553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 214561 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2036:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 214561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 214564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214572 */     GIR_RootConstrainSelectedInstOperands,
     /* 214573 */     // GIR_Coverage, 11813,
     /* 214573 */     GIR_EraseRootFromParent_Done,
     /* 214574 */   // Label 4238: @214574
     /* 214574 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(214621), // Rule ID 11814 //
     /* 214579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 214587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214600 */     // MIs[0] Op3
     /* 214600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 214608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2036:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 214608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 214611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214619 */     GIR_RootConstrainSelectedInstOperands,
     /* 214620 */     // GIR_Coverage, 11814,
     /* 214620 */     GIR_EraseRootFromParent_Done,
     /* 214621 */   // Label 4239: @214621
     /* 214621 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(214668), // Rule ID 11815 //
     /* 214626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 214634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214647 */     // MIs[0] Op3
     /* 214647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 214650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 214655 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2036:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 214655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 214658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214666 */     GIR_RootConstrainSelectedInstOperands,
     /* 214667 */     // GIR_Coverage, 11815,
     /* 214667 */     GIR_EraseRootFromParent_Done,
     /* 214668 */   // Label 4240: @214668
     /* 214668 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(214735), // Rule ID 2604 //
     /* 214673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 214681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214707 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 214724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214733 */     GIR_RootConstrainSelectedInstOperands,
     /* 214734 */     // GIR_Coverage, 2604,
     /* 214734 */     GIR_EraseRootFromParent_Done,
     /* 214735 */   // Label 4241: @214735
     /* 214735 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(214802), // Rule ID 7726 //
     /* 214740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214774 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 214791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214800 */     GIR_RootConstrainSelectedInstOperands,
     /* 214801 */     // GIR_Coverage, 7726,
     /* 214801 */     GIR_EraseRootFromParent_Done,
     /* 214802 */   // Label 4242: @214802
     /* 214802 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(214869), // Rule ID 7728 //
     /* 214807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 214858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214867 */     GIR_RootConstrainSelectedInstOperands,
     /* 214868 */     // GIR_Coverage, 7728,
     /* 214868 */     GIR_EraseRootFromParent_Done,
     /* 214869 */   // Label 4243: @214869
     /* 214869 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(214936), // Rule ID 7730 //
     /* 214874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 214925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214934 */     GIR_RootConstrainSelectedInstOperands,
     /* 214935 */     // GIR_Coverage, 7730,
     /* 214935 */     GIR_EraseRootFromParent_Done,
     /* 214936 */   // Label 4244: @214936
     /* 214936 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(215003), // Rule ID 7732 //
     /* 214941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 214992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215001 */     GIR_RootConstrainSelectedInstOperands,
     /* 215002 */     // GIR_Coverage, 7732,
     /* 215002 */     GIR_EraseRootFromParent_Done,
     /* 215003 */   // Label 4245: @215003
     /* 215003 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(215070), // Rule ID 7762 //
     /* 215008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 215016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215042 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 215059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215068 */     GIR_RootConstrainSelectedInstOperands,
     /* 215069 */     // GIR_Coverage, 7762,
     /* 215069 */     GIR_EraseRootFromParent_Done,
     /* 215070 */   // Label 4246: @215070
     /* 215070 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(215137), // Rule ID 7764 //
     /* 215075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 215083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 215126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215135 */     GIR_RootConstrainSelectedInstOperands,
     /* 215136 */     // GIR_Coverage, 7764,
     /* 215136 */     GIR_EraseRootFromParent_Done,
     /* 215137 */   // Label 4247: @215137
     /* 215137 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(215204), // Rule ID 7766 //
     /* 215142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 215150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 215193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215202 */     GIR_RootConstrainSelectedInstOperands,
     /* 215203 */     // GIR_Coverage, 7766,
     /* 215203 */     GIR_EraseRootFromParent_Done,
     /* 215204 */   // Label 4248: @215204
     /* 215204 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215271), // Rule ID 7768 //
     /* 215209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 215217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 215260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215269 */     GIR_RootConstrainSelectedInstOperands,
     /* 215270 */     // GIR_Coverage, 7768,
     /* 215270 */     GIR_EraseRootFromParent_Done,
     /* 215271 */   // Label 4249: @215271
     /* 215271 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215338), // Rule ID 7774 //
     /* 215276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 215284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215310 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 215327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215336 */     GIR_RootConstrainSelectedInstOperands,
     /* 215337 */     // GIR_Coverage, 7774,
     /* 215337 */     GIR_EraseRootFromParent_Done,
     /* 215338 */   // Label 4250: @215338
     /* 215338 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215405), // Rule ID 7776 //
     /* 215343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 215351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 215394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215403 */     GIR_RootConstrainSelectedInstOperands,
     /* 215404 */     // GIR_Coverage, 7776,
     /* 215404 */     GIR_EraseRootFromParent_Done,
     /* 215405 */   // Label 4251: @215405
     /* 215405 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215472), // Rule ID 7778 //
     /* 215410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 215418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 215461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215470 */     GIR_RootConstrainSelectedInstOperands,
     /* 215471 */     // GIR_Coverage, 7778,
     /* 215471 */     GIR_EraseRootFromParent_Done,
     /* 215472 */   // Label 4252: @215472
     /* 215472 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(215539), // Rule ID 7780 //
     /* 215477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 215485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 215528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215537 */     GIR_RootConstrainSelectedInstOperands,
     /* 215538 */     // GIR_Coverage, 7780,
     /* 215538 */     GIR_EraseRootFromParent_Done,
     /* 215539 */   // Label 4253: @215539
     /* 215539 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(215606), // Rule ID 11508 //
     /* 215544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 215552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 215595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215604 */     GIR_RootConstrainSelectedInstOperands,
     /* 215605 */     // GIR_Coverage, 11508,
     /* 215605 */     GIR_EraseRootFromParent_Done,
     /* 215606 */   // Label 4254: @215606
     /* 215606 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(215673), // Rule ID 11510 //
     /* 215611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 215619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215645 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 215662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215671 */     GIR_RootConstrainSelectedInstOperands,
     /* 215672 */     // GIR_Coverage, 11510,
     /* 215672 */     GIR_EraseRootFromParent_Done,
     /* 215673 */   // Label 4255: @215673
     /* 215673 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(215740), // Rule ID 11512 //
     /* 215678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 215686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 215729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215738 */     GIR_RootConstrainSelectedInstOperands,
     /* 215739 */     // GIR_Coverage, 11512,
     /* 215739 */     GIR_EraseRootFromParent_Done,
     /* 215740 */   // Label 4256: @215740
     /* 215740 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(215807), // Rule ID 11514 //
     /* 215745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 215753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 215796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215805 */     GIR_RootConstrainSelectedInstOperands,
     /* 215806 */     // GIR_Coverage, 11514,
     /* 215806 */     GIR_EraseRootFromParent_Done,
     /* 215807 */   // Label 4257: @215807
     /* 215807 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(215874), // Rule ID 11516 //
     /* 215812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 215820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 215863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215872 */     GIR_RootConstrainSelectedInstOperands,
     /* 215873 */     // GIR_Coverage, 11516,
     /* 215873 */     GIR_EraseRootFromParent_Done,
     /* 215874 */   // Label 4258: @215874
     /* 215874 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(215941), // Rule ID 11522 //
     /* 215879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 215887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215913 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 215930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 215935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215939 */     GIR_RootConstrainSelectedInstOperands,
     /* 215940 */     // GIR_Coverage, 11522,
     /* 215940 */     GIR_EraseRootFromParent_Done,
     /* 215941 */   // Label 4259: @215941
     /* 215941 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(216008), // Rule ID 11524 //
     /* 215946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 215954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 215978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215980 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 215983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 215987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 215992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 215994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 215997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 216002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 216004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 216006 */     GIR_RootConstrainSelectedInstOperands,
     /* 216007 */     // GIR_Coverage, 11524,
     /* 216007 */     GIR_EraseRootFromParent_Done,
     /* 216008 */   // Label 4260: @216008
     /* 216008 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(216075), // Rule ID 11526 //
     /* 216013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 216021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 216030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 216045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216047 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 216050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 216054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 216059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 216061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 216064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 216069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 216071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 216073 */     GIR_RootConstrainSelectedInstOperands,
     /* 216074 */     // GIR_Coverage, 11526,
     /* 216074 */     GIR_EraseRootFromParent_Done,
     /* 216075 */   // Label 4261: @216075
     /* 216075 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(216142), // Rule ID 11528 //
     /* 216080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 216088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 216097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 216112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 216117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 216121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 216126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 216128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 216131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 216136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 216138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 216140 */     GIR_RootConstrainSelectedInstOperands,
     /* 216141 */     // GIR_Coverage, 11528,
     /* 216141 */     GIR_EraseRootFromParent_Done,
     /* 216142 */   // Label 4262: @216142
     /* 216142 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(216196), // Rule ID 30 //
     /* 216147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 216150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 216155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216183 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 216183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 216186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216194 */     GIR_RootConstrainSelectedInstOperands,
     /* 216195 */     // GIR_Coverage, 30,
     /* 216195 */     GIR_EraseRootFromParent_Done,
     /* 216196 */   // Label 4263: @216196
     /* 216196 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(216250), // Rule ID 31 //
     /* 216201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 216204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 216209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216237 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 216237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 216240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216248 */     GIR_RootConstrainSelectedInstOperands,
     /* 216249 */     // GIR_Coverage, 31,
     /* 216249 */     GIR_EraseRootFromParent_Done,
     /* 216250 */   // Label 4264: @216250
     /* 216250 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(216304), // Rule ID 32 //
     /* 216255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 216258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 216263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216291 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 216291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 216294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216302 */     GIR_RootConstrainSelectedInstOperands,
     /* 216303 */     // GIR_Coverage, 32,
     /* 216303 */     GIR_EraseRootFromParent_Done,
     /* 216304 */   // Label 4265: @216304
     /* 216304 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(216358), // Rule ID 39 //
     /* 216309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 216317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216345 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 216345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 216348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216356 */     GIR_RootConstrainSelectedInstOperands,
     /* 216357 */     // GIR_Coverage, 39,
     /* 216357 */     GIR_EraseRootFromParent_Done,
     /* 216358 */   // Label 4266: @216358
     /* 216358 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(216412), // Rule ID 40 //
     /* 216363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 216371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216399 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 216399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 216402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216410 */     GIR_RootConstrainSelectedInstOperands,
     /* 216411 */     // GIR_Coverage, 40,
     /* 216411 */     GIR_EraseRootFromParent_Done,
     /* 216412 */   // Label 4267: @216412
     /* 216412 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(216466), // Rule ID 41 //
     /* 216417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 216425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216453 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 216453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 216456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216464 */     GIR_RootConstrainSelectedInstOperands,
     /* 216465 */     // GIR_Coverage, 41,
     /* 216465 */     GIR_EraseRootFromParent_Done,
     /* 216466 */   // Label 4268: @216466
     /* 216466 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(216520), // Rule ID 42 //
     /* 216471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 216479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216507 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 216507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 216510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216518 */     GIR_RootConstrainSelectedInstOperands,
     /* 216519 */     // GIR_Coverage, 42,
     /* 216519 */     GIR_EraseRootFromParent_Done,
     /* 216520 */   // Label 4269: @216520
     /* 216520 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(216574), // Rule ID 43 //
     /* 216525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 216533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216561 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 216561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 216564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216572 */     GIR_RootConstrainSelectedInstOperands,
     /* 216573 */     // GIR_Coverage, 43,
     /* 216573 */     GIR_EraseRootFromParent_Done,
     /* 216574 */   // Label 4270: @216574
     /* 216574 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(216628), // Rule ID 44 //
     /* 216579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 216587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216615 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 216615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 216618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216626 */     GIR_RootConstrainSelectedInstOperands,
     /* 216627 */     // GIR_Coverage, 44,
     /* 216627 */     GIR_EraseRootFromParent_Done,
     /* 216628 */   // Label 4271: @216628
     /* 216628 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(216682), // Rule ID 45 //
     /* 216633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 216641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216669 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 216669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 216672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216680 */     GIR_RootConstrainSelectedInstOperands,
     /* 216681 */     // GIR_Coverage, 45,
     /* 216681 */     GIR_EraseRootFromParent_Done,
     /* 216682 */   // Label 4272: @216682
     /* 216682 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(216736), // Rule ID 46 //
     /* 216687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 216690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 216695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216723 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 216723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 216726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216734 */     GIR_RootConstrainSelectedInstOperands,
     /* 216735 */     // GIR_Coverage, 46,
     /* 216735 */     GIR_EraseRootFromParent_Done,
     /* 216736 */   // Label 4273: @216736
     /* 216736 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(216790), // Rule ID 1587 //
     /* 216741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216777 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 216777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 216780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216788 */     GIR_RootConstrainSelectedInstOperands,
     /* 216789 */     // GIR_Coverage, 1587,
     /* 216789 */     GIR_EraseRootFromParent_Done,
     /* 216790 */   // Label 4274: @216790
     /* 216790 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(216844), // Rule ID 1588 //
     /* 216795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216831 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 216831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 216834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216842 */     GIR_RootConstrainSelectedInstOperands,
     /* 216843 */     // GIR_Coverage, 1588,
     /* 216843 */     GIR_EraseRootFromParent_Done,
     /* 216844 */   // Label 4275: @216844
     /* 216844 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(216898), // Rule ID 1589 //
     /* 216849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 216866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 216869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216885 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 216885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 216888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216896 */     GIR_RootConstrainSelectedInstOperands,
     /* 216897 */     // GIR_Coverage, 1589,
     /* 216897 */     GIR_EraseRootFromParent_Done,
     /* 216898 */   // Label 4276: @216898
     /* 216898 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(216952), // Rule ID 1590 //
     /* 216903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216939 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 216939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 216942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216950 */     GIR_RootConstrainSelectedInstOperands,
     /* 216951 */     // GIR_Coverage, 1590,
     /* 216951 */     GIR_EraseRootFromParent_Done,
     /* 216952 */   // Label 4277: @216952
     /* 216952 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(217006), // Rule ID 1591 //
     /* 216957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 216965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216993 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 216993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 216996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217004 */     GIR_RootConstrainSelectedInstOperands,
     /* 217005 */     // GIR_Coverage, 1591,
     /* 217005 */     GIR_EraseRootFromParent_Done,
     /* 217006 */   // Label 4278: @217006
     /* 217006 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(217060), // Rule ID 1592 //
     /* 217011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217047 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 217047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 217050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217058 */     GIR_RootConstrainSelectedInstOperands,
     /* 217059 */     // GIR_Coverage, 1592,
     /* 217059 */     GIR_EraseRootFromParent_Done,
     /* 217060 */   // Label 4279: @217060
     /* 217060 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(217114), // Rule ID 1593 //
     /* 217065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217101 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 217101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 217104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217112 */     GIR_RootConstrainSelectedInstOperands,
     /* 217113 */     // GIR_Coverage, 1593,
     /* 217113 */     GIR_EraseRootFromParent_Done,
     /* 217114 */   // Label 4280: @217114
     /* 217114 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(217168), // Rule ID 1594 //
     /* 217119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217155 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 217158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217166 */     GIR_RootConstrainSelectedInstOperands,
     /* 217167 */     // GIR_Coverage, 1594,
     /* 217167 */     GIR_EraseRootFromParent_Done,
     /* 217168 */   // Label 4281: @217168
     /* 217168 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(217222), // Rule ID 2307 //
     /* 217173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 217181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217209 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 217212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217220 */     GIR_RootConstrainSelectedInstOperands,
     /* 217221 */     // GIR_Coverage, 2307,
     /* 217221 */     GIR_EraseRootFromParent_Done,
     /* 217222 */   // Label 4282: @217222
     /* 217222 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(217276), // Rule ID 2308 //
     /* 217227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 217235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217263 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 217266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217274 */     GIR_RootConstrainSelectedInstOperands,
     /* 217275 */     // GIR_Coverage, 2308,
     /* 217275 */     GIR_EraseRootFromParent_Done,
     /* 217276 */   // Label 4283: @217276
     /* 217276 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(217330), // Rule ID 2309 //
     /* 217281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 217289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217317 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 217320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217328 */     GIR_RootConstrainSelectedInstOperands,
     /* 217329 */     // GIR_Coverage, 2309,
     /* 217329 */     GIR_EraseRootFromParent_Done,
     /* 217330 */   // Label 4284: @217330
     /* 217330 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(217384), // Rule ID 2310 //
     /* 217335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 217343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217371 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 217374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217382 */     GIR_RootConstrainSelectedInstOperands,
     /* 217383 */     // GIR_Coverage, 2310,
     /* 217383 */     GIR_EraseRootFromParent_Done,
     /* 217384 */   // Label 4285: @217384
     /* 217384 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(217438), // Rule ID 2311 //
     /* 217389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 217397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217425 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 217428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217436 */     GIR_RootConstrainSelectedInstOperands,
     /* 217437 */     // GIR_Coverage, 2311,
     /* 217437 */     GIR_EraseRootFromParent_Done,
     /* 217438 */   // Label 4286: @217438
     /* 217438 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(217492), // Rule ID 2312 //
     /* 217443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 217451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 217482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217490 */     GIR_RootConstrainSelectedInstOperands,
     /* 217491 */     // GIR_Coverage, 2312,
     /* 217491 */     GIR_EraseRootFromParent_Done,
     /* 217492 */   // Label 4287: @217492
     /* 217492 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(217546), // Rule ID 2313 //
     /* 217497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 217500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 217505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217533 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 217533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 217536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217544 */     GIR_RootConstrainSelectedInstOperands,
     /* 217545 */     // GIR_Coverage, 2313,
     /* 217545 */     GIR_EraseRootFromParent_Done,
     /* 217546 */   // Label 4288: @217546
     /* 217546 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(217603), // Rule ID 3640 //
     /* 217551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 217559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 217568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 217587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 217587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 217590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 217594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 217596 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 217598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217601 */     GIR_RootConstrainSelectedInstOperands,
     /* 217602 */     // GIR_Coverage, 3640,
     /* 217602 */     GIR_EraseRootFromParent_Done,
     /* 217603 */   // Label 4289: @217603
     /* 217603 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(217660), // Rule ID 3641 //
     /* 217608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 217616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 217625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 217644 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 217644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 217647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 217651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 217653 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 217655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217658 */     GIR_RootConstrainSelectedInstOperands,
     /* 217659 */     // GIR_Coverage, 3641,
     /* 217659 */     GIR_EraseRootFromParent_Done,
     /* 217660 */   // Label 4290: @217660
     /* 217660 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(217717), // Rule ID 3642 //
     /* 217665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 217673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 217701 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 217701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 217704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 217708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 217710 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 217712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217715 */     GIR_RootConstrainSelectedInstOperands,
     /* 217716 */     // GIR_Coverage, 3642,
     /* 217716 */     GIR_EraseRootFromParent_Done,
     /* 217717 */   // Label 4291: @217717
     /* 217717 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(217774), // Rule ID 3643 //
     /* 217722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 217730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 217739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 217758 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 217758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 217761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 217765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 217767 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 217769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217772 */     GIR_RootConstrainSelectedInstOperands,
     /* 217773 */     // GIR_Coverage, 3643,
     /* 217773 */     GIR_EraseRootFromParent_Done,
     /* 217774 */   // Label 4292: @217774
     /* 217774 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(217828), // Rule ID 3816 //
     /* 217779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 217787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217815 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 217815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 217818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217826 */     GIR_RootConstrainSelectedInstOperands,
     /* 217827 */     // GIR_Coverage, 3816,
     /* 217827 */     GIR_EraseRootFromParent_Done,
     /* 217828 */   // Label 4293: @217828
     /* 217828 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(217882), // Rule ID 3817 //
     /* 217833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 217841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217869 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 217869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 217872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217880 */     GIR_RootConstrainSelectedInstOperands,
     /* 217881 */     // GIR_Coverage, 3817,
     /* 217881 */     GIR_EraseRootFromParent_Done,
     /* 217882 */   // Label 4294: @217882
     /* 217882 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(217936), // Rule ID 3818 //
     /* 217887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 217895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217923 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 217923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 217926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217934 */     GIR_RootConstrainSelectedInstOperands,
     /* 217935 */     // GIR_Coverage, 3818,
     /* 217935 */     GIR_EraseRootFromParent_Done,
     /* 217936 */   // Label 4295: @217936
     /* 217936 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(217990), // Rule ID 3819 //
     /* 217941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 217949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 217952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 217955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 217961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217977 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 217977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 217980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217988 */     GIR_RootConstrainSelectedInstOperands,
     /* 217989 */     // GIR_Coverage, 3819,
     /* 217989 */     GIR_EraseRootFromParent_Done,
     /* 217990 */   // Label 4296: @217990
     /* 217990 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(218044), // Rule ID 3820 //
     /* 217995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 218003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218031 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 218031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218042 */     GIR_RootConstrainSelectedInstOperands,
     /* 218043 */     // GIR_Coverage, 3820,
     /* 218043 */     GIR_EraseRootFromParent_Done,
     /* 218044 */   // Label 4297: @218044
     /* 218044 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(218098), // Rule ID 3821 //
     /* 218049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 218057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218085 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218096 */     GIR_RootConstrainSelectedInstOperands,
     /* 218097 */     // GIR_Coverage, 3821,
     /* 218097 */     GIR_EraseRootFromParent_Done,
     /* 218098 */   // Label 4298: @218098
     /* 218098 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(218152), // Rule ID 3822 //
     /* 218103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 218111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 218139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218150 */     GIR_RootConstrainSelectedInstOperands,
     /* 218151 */     // GIR_Coverage, 3822,
     /* 218151 */     GIR_EraseRootFromParent_Done,
     /* 218152 */   // Label 4299: @218152
     /* 218152 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(218206), // Rule ID 3831 //
     /* 218157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 218165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 218168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 218171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 218177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218193 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 218193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218204 */     GIR_RootConstrainSelectedInstOperands,
     /* 218205 */     // GIR_Coverage, 3831,
     /* 218205 */     GIR_EraseRootFromParent_Done,
     /* 218206 */   // Label 4300: @218206
     /* 218206 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(218260), // Rule ID 3832 //
     /* 218211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 218219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218247 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 218247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218258 */     GIR_RootConstrainSelectedInstOperands,
     /* 218259 */     // GIR_Coverage, 3832,
     /* 218259 */     GIR_EraseRootFromParent_Done,
     /* 218260 */   // Label 4301: @218260
     /* 218260 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(218314), // Rule ID 3833 //
     /* 218265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 218273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218301 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218312 */     GIR_RootConstrainSelectedInstOperands,
     /* 218313 */     // GIR_Coverage, 3833,
     /* 218313 */     GIR_EraseRootFromParent_Done,
     /* 218314 */   // Label 4302: @218314
     /* 218314 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(218368), // Rule ID 3834 //
     /* 218319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 218327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218355 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 218355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218366 */     GIR_RootConstrainSelectedInstOperands,
     /* 218367 */     // GIR_Coverage, 3834,
     /* 218367 */     GIR_EraseRootFromParent_Done,
     /* 218368 */   // Label 4303: @218368
     /* 218368 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(218422), // Rule ID 3835 //
     /* 218373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 218381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 218384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 218387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 218393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218409 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 218409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218420 */     GIR_RootConstrainSelectedInstOperands,
     /* 218421 */     // GIR_Coverage, 3835,
     /* 218421 */     GIR_EraseRootFromParent_Done,
     /* 218422 */   // Label 4304: @218422
     /* 218422 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(218476), // Rule ID 3836 //
     /* 218427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 218435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218463 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 218463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218474 */     GIR_RootConstrainSelectedInstOperands,
     /* 218475 */     // GIR_Coverage, 3836,
     /* 218475 */     GIR_EraseRootFromParent_Done,
     /* 218476 */   // Label 4305: @218476
     /* 218476 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(218530), // Rule ID 3837 //
     /* 218481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 218489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218517 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218528 */     GIR_RootConstrainSelectedInstOperands,
     /* 218529 */     // GIR_Coverage, 3837,
     /* 218529 */     GIR_EraseRootFromParent_Done,
     /* 218530 */   // Label 4306: @218530
     /* 218530 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(218584), // Rule ID 3838 //
     /* 218535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 218543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218571 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 218571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 218574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218582 */     GIR_RootConstrainSelectedInstOperands,
     /* 218583 */     // GIR_Coverage, 3838,
     /* 218583 */     GIR_EraseRootFromParent_Done,
     /* 218584 */   // Label 4307: @218584
     /* 218584 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(218638), // Rule ID 3839 //
     /* 218589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 218597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 218600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 218603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 218609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218625 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 218625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218636 */     GIR_RootConstrainSelectedInstOperands,
     /* 218637 */     // GIR_Coverage, 3839,
     /* 218637 */     GIR_EraseRootFromParent_Done,
     /* 218638 */   // Label 4308: @218638
     /* 218638 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(218692), // Rule ID 3840 //
     /* 218643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 218651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218679 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 218679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218690 */     GIR_RootConstrainSelectedInstOperands,
     /* 218691 */     // GIR_Coverage, 3840,
     /* 218691 */     GIR_EraseRootFromParent_Done,
     /* 218692 */   // Label 4309: @218692
     /* 218692 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(218746), // Rule ID 3841 //
     /* 218697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 218705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218733 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218744 */     GIR_RootConstrainSelectedInstOperands,
     /* 218745 */     // GIR_Coverage, 3841,
     /* 218745 */     GIR_EraseRootFromParent_Done,
     /* 218746 */   // Label 4310: @218746
     /* 218746 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(218800), // Rule ID 3842 //
     /* 218751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 218754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 218759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218787 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 218787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 218790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218798 */     GIR_RootConstrainSelectedInstOperands,
     /* 218799 */     // GIR_Coverage, 3842,
     /* 218799 */     GIR_EraseRootFromParent_Done,
     /* 218800 */   // Label 4311: @218800
     /* 218800 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(218854), // Rule ID 3846 //
     /* 218805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 218808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 218813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218841 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 218841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 218844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 218846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 218848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 218850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 218852 */     GIR_RootConstrainSelectedInstOperands,
     /* 218853 */     // GIR_Coverage, 3846,
     /* 218853 */     GIR_EraseRootFromParent_Done,
     /* 218854 */   // Label 4312: @218854
     /* 218854 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(218908), // Rule ID 3847 //
     /* 218859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 218862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 218867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218895 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 218898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 218900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218906 */     GIR_RootConstrainSelectedInstOperands,
     /* 218907 */     // GIR_Coverage, 3847,
     /* 218907 */     GIR_EraseRootFromParent_Done,
     /* 218908 */   // Label 4313: @218908
     /* 218908 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(218962), // Rule ID 3848 //
     /* 218913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 218916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 218921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218949 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 218949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 218952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 218954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 218956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 218958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 218960 */     GIR_RootConstrainSelectedInstOperands,
     /* 218961 */     // GIR_Coverage, 3848,
     /* 218961 */     GIR_EraseRootFromParent_Done,
     /* 218962 */   // Label 4314: @218962
     /* 218962 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(219019), // Rule ID 3865 //
     /* 218967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219003 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 219003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 219006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219017 */     GIR_RootConstrainSelectedInstOperands,
     /* 219018 */     // GIR_Coverage, 3865,
     /* 219018 */     GIR_EraseRootFromParent_Done,
     /* 219019 */   // Label 4315: @219019
     /* 219019 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(219076), // Rule ID 3866 //
     /* 219024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 219035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 219038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219060 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 219060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 219063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219074 */     GIR_RootConstrainSelectedInstOperands,
     /* 219075 */     // GIR_Coverage, 3866,
     /* 219075 */     GIR_EraseRootFromParent_Done,
     /* 219076 */   // Label 4316: @219076
     /* 219076 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(219133), // Rule ID 3867 //
     /* 219081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 219092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 219095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219117 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 219117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 219120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219131 */     GIR_RootConstrainSelectedInstOperands,
     /* 219132 */     // GIR_Coverage, 3867,
     /* 219132 */     GIR_EraseRootFromParent_Done,
     /* 219133 */   // Label 4317: @219133
     /* 219133 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(219190), // Rule ID 3868 //
     /* 219138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 219149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 219152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219174 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 219174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 219177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219188 */     GIR_RootConstrainSelectedInstOperands,
     /* 219189 */     // GIR_Coverage, 3868,
     /* 219189 */     GIR_EraseRootFromParent_Done,
     /* 219190 */   // Label 4318: @219190
     /* 219190 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(219247), // Rule ID 3873 //
     /* 219195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219231 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 219231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 219234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219245 */     GIR_RootConstrainSelectedInstOperands,
     /* 219246 */     // GIR_Coverage, 3873,
     /* 219246 */     GIR_EraseRootFromParent_Done,
     /* 219247 */   // Label 4319: @219247
     /* 219247 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(219304), // Rule ID 3874 //
     /* 219252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219288 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 219288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 219291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219302 */     GIR_RootConstrainSelectedInstOperands,
     /* 219303 */     // GIR_Coverage, 3874,
     /* 219303 */     GIR_EraseRootFromParent_Done,
     /* 219304 */   // Label 4320: @219304
     /* 219304 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(219361), // Rule ID 3875 //
     /* 219309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219345 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 219345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 219348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219359 */     GIR_RootConstrainSelectedInstOperands,
     /* 219360 */     // GIR_Coverage, 3875,
     /* 219360 */     GIR_EraseRootFromParent_Done,
     /* 219361 */   // Label 4321: @219361
     /* 219361 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(219418), // Rule ID 3876 //
     /* 219366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219402 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 219402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 219405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219416 */     GIR_RootConstrainSelectedInstOperands,
     /* 219417 */     // GIR_Coverage, 3876,
     /* 219417 */     GIR_EraseRootFromParent_Done,
     /* 219418 */   // Label 4322: @219418
     /* 219418 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(219475), // Rule ID 3881 //
     /* 219423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219459 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 219459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 219462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219473 */     GIR_RootConstrainSelectedInstOperands,
     /* 219474 */     // GIR_Coverage, 3881,
     /* 219474 */     GIR_EraseRootFromParent_Done,
     /* 219475 */   // Label 4323: @219475
     /* 219475 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(219532), // Rule ID 3882 //
     /* 219480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219516 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 219516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 219519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219530 */     GIR_RootConstrainSelectedInstOperands,
     /* 219531 */     // GIR_Coverage, 3882,
     /* 219531 */     GIR_EraseRootFromParent_Done,
     /* 219532 */   // Label 4324: @219532
     /* 219532 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(219589), // Rule ID 3883 //
     /* 219537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219573 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 219573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 219576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219587 */     GIR_RootConstrainSelectedInstOperands,
     /* 219588 */     // GIR_Coverage, 3883,
     /* 219588 */     GIR_EraseRootFromParent_Done,
     /* 219589 */   // Label 4325: @219589
     /* 219589 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(219646), // Rule ID 3884 //
     /* 219594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219630 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 219630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 219633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219644 */     GIR_RootConstrainSelectedInstOperands,
     /* 219645 */     // GIR_Coverage, 3884,
     /* 219645 */     GIR_EraseRootFromParent_Done,
     /* 219646 */   // Label 4326: @219646
     /* 219646 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(219703), // Rule ID 3885 //
     /* 219651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219687 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 219687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 219690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219701 */     GIR_RootConstrainSelectedInstOperands,
     /* 219702 */     // GIR_Coverage, 3885,
     /* 219702 */     GIR_EraseRootFromParent_Done,
     /* 219703 */   // Label 4327: @219703
     /* 219703 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(219760), // Rule ID 3886 //
     /* 219708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219744 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 219744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 219747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219758 */     GIR_RootConstrainSelectedInstOperands,
     /* 219759 */     // GIR_Coverage, 3886,
     /* 219759 */     GIR_EraseRootFromParent_Done,
     /* 219760 */   // Label 4328: @219760
     /* 219760 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(219817), // Rule ID 3887 //
     /* 219765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219801 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 219801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 219804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219815 */     GIR_RootConstrainSelectedInstOperands,
     /* 219816 */     // GIR_Coverage, 3887,
     /* 219816 */     GIR_EraseRootFromParent_Done,
     /* 219817 */   // Label 4329: @219817
     /* 219817 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(219874), // Rule ID 3888 //
     /* 219822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219858 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 219858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 219861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219872 */     GIR_RootConstrainSelectedInstOperands,
     /* 219873 */     // GIR_Coverage, 3888,
     /* 219873 */     GIR_EraseRootFromParent_Done,
     /* 219874 */   // Label 4330: @219874
     /* 219874 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(219931), // Rule ID 3889 //
     /* 219879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 219890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 219893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 219896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 219899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219915 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 219915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 219918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219929 */     GIR_RootConstrainSelectedInstOperands,
     /* 219930 */     // GIR_Coverage, 3889,
     /* 219930 */     GIR_EraseRootFromParent_Done,
     /* 219931 */   // Label 4331: @219931
     /* 219931 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(219988), // Rule ID 3890 //
     /* 219936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 219947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 219950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 219953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 219956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219972 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 219972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 219975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 219983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219986 */     GIR_RootConstrainSelectedInstOperands,
     /* 219987 */     // GIR_Coverage, 3890,
     /* 219987 */     GIR_EraseRootFromParent_Done,
     /* 219988 */   // Label 4332: @219988
     /* 219988 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(220045), // Rule ID 3891 //
     /* 219993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 220001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 220004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 220007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 220010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 220013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220029 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 220029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 220032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 220040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 220043 */     GIR_RootConstrainSelectedInstOperands,
     /* 220044 */     // GIR_Coverage, 3891,
     /* 220044 */     GIR_EraseRootFromParent_Done,
     /* 220045 */   // Label 4333: @220045
     /* 220045 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(220102), // Rule ID 3892 //
     /* 220050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 220053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 220058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 220061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 220064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 220067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 220070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220086 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 220086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 220089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 220097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 220100 */     GIR_RootConstrainSelectedInstOperands,
     /* 220101 */     // GIR_Coverage, 3892,
     /* 220101 */     GIR_EraseRootFromParent_Done,
     /* 220102 */   // Label 4334: @220102
     /* 220102 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(220156), // Rule ID 5232 //
     /* 220107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 220110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 220127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220143 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 220143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 220146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 220154 */     GIR_RootConstrainSelectedInstOperands,
     /* 220155 */     // GIR_Coverage, 5232,
     /* 220155 */     GIR_EraseRootFromParent_Done,
     /* 220156 */   // Label 4335: @220156
     /* 220156 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(220210), // Rule ID 5233 //
     /* 220161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 220164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 220181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220197 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 220197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 220200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 220208 */     GIR_RootConstrainSelectedInstOperands,
     /* 220209 */     // GIR_Coverage, 5233,
     /* 220209 */     GIR_EraseRootFromParent_Done,
     /* 220210 */   // Label 4336: @220210
     /* 220210 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(220261), // Rule ID 5586 //
     /* 220215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 220220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 220223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 220226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 220229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 220232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220248 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 220248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 220251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 220259 */     GIR_RootConstrainSelectedInstOperands,
     /* 220260 */     // GIR_Coverage, 5586,
     /* 220260 */     GIR_EraseRootFromParent_Done,
     /* 220261 */   // Label 4337: @220261
     /* 220261 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(220312), // Rule ID 5587 //
     /* 220266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 220271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 220274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 220277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 220280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 220283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220299 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 220299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 220302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 220308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 220310 */     GIR_RootConstrainSelectedInstOperands,
     /* 220311 */     // GIR_Coverage, 5587,
     /* 220311 */     GIR_EraseRootFromParent_Done,
     /* 220312 */   // Label 4338: @220312
     /* 220312 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(220354), // Rule ID 2699 //
     /* 220317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220341 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 220344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220352 */     GIR_RootConstrainSelectedInstOperands,
     /* 220353 */     // GIR_Coverage, 2699,
     /* 220353 */     GIR_EraseRootFromParent_Done,
     /* 220354 */   // Label 4339: @220354
     /* 220354 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(220396), // Rule ID 2700 //
     /* 220359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 220386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220394 */     GIR_RootConstrainSelectedInstOperands,
     /* 220395 */     // GIR_Coverage, 2700,
     /* 220395 */     GIR_EraseRootFromParent_Done,
     /* 220396 */   // Label 4340: @220396
     /* 220396 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(220438), // Rule ID 2701 //
     /* 220401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 220428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220436 */     GIR_RootConstrainSelectedInstOperands,
     /* 220437 */     // GIR_Coverage, 2701,
     /* 220437 */     GIR_EraseRootFromParent_Done,
     /* 220438 */   // Label 4341: @220438
     /* 220438 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(220480), // Rule ID 2702 //
     /* 220443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220467 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 220470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220478 */     GIR_RootConstrainSelectedInstOperands,
     /* 220479 */     // GIR_Coverage, 2702,
     /* 220479 */     GIR_EraseRootFromParent_Done,
     /* 220480 */   // Label 4342: @220480
     /* 220480 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(220522), // Rule ID 2703 //
     /* 220485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220509 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1918:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 220512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220520 */     GIR_RootConstrainSelectedInstOperands,
     /* 220521 */     // GIR_Coverage, 2703,
     /* 220521 */     GIR_EraseRootFromParent_Done,
     /* 220522 */   // Label 4343: @220522
     /* 220522 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(220564), // Rule ID 2704 //
     /* 220527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220551 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1918:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 220554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220562 */     GIR_RootConstrainSelectedInstOperands,
     /* 220563 */     // GIR_Coverage, 2704,
     /* 220563 */     GIR_EraseRootFromParent_Done,
     /* 220564 */   // Label 4344: @220564
     /* 220564 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(220606), // Rule ID 2705 //
     /* 220569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 220577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220593 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1918:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 220596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220604 */     GIR_RootConstrainSelectedInstOperands,
     /* 220605 */     // GIR_Coverage, 2705,
     /* 220605 */     GIR_EraseRootFromParent_Done,
     /* 220606 */   // Label 4345: @220606
     /* 220606 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(220648), // Rule ID 2744 //
     /* 220611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220635 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1264:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220646 */     GIR_RootConstrainSelectedInstOperands,
     /* 220647 */     // GIR_Coverage, 2744,
     /* 220647 */     GIR_EraseRootFromParent_Done,
     /* 220648 */   // Label 4346: @220648
     /* 220648 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(220690), // Rule ID 2745 //
     /* 220653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220677 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220688 */     GIR_RootConstrainSelectedInstOperands,
     /* 220689 */     // GIR_Coverage, 2745,
     /* 220689 */     GIR_EraseRootFromParent_Done,
     /* 220690 */   // Label 4347: @220690
     /* 220690 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(220732), // Rule ID 2746 //
     /* 220695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220719 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220730 */     GIR_RootConstrainSelectedInstOperands,
     /* 220731 */     // GIR_Coverage, 2746,
     /* 220731 */     GIR_EraseRootFromParent_Done,
     /* 220732 */   // Label 4348: @220732
     /* 220732 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(220774), // Rule ID 2747 //
     /* 220737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220761 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220772 */     GIR_RootConstrainSelectedInstOperands,
     /* 220773 */     // GIR_Coverage, 2747,
     /* 220773 */     GIR_EraseRootFromParent_Done,
     /* 220774 */   // Label 4349: @220774
     /* 220774 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(220816), // Rule ID 2748 //
     /* 220779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 220787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220803 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1264:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 220806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220814 */     GIR_RootConstrainSelectedInstOperands,
     /* 220815 */     // GIR_Coverage, 2748,
     /* 220815 */     GIR_EraseRootFromParent_Done,
     /* 220816 */   // Label 4350: @220816
     /* 220816 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(220858), // Rule ID 2787 //
     /* 220821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 220829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220845 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 220845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 220848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220856 */     GIR_RootConstrainSelectedInstOperands,
     /* 220857 */     // GIR_Coverage, 2787,
     /* 220857 */     GIR_EraseRootFromParent_Done,
     /* 220858 */   // Label 4351: @220858
     /* 220858 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(220900), // Rule ID 2789 //
     /* 220863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 220871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220887 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 220887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 220890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220898 */     GIR_RootConstrainSelectedInstOperands,
     /* 220899 */     // GIR_Coverage, 2789,
     /* 220899 */     GIR_EraseRootFromParent_Done,
     /* 220900 */   // Label 4352: @220900
     /* 220900 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(220942), // Rule ID 2791 //
     /* 220905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 220913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220929 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 220929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 220932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220940 */     GIR_RootConstrainSelectedInstOperands,
     /* 220941 */     // GIR_Coverage, 2791,
     /* 220941 */     GIR_EraseRootFromParent_Done,
     /* 220942 */   // Label 4353: @220942
     /* 220942 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(220984), // Rule ID 2793 //
     /* 220947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 220955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220971 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1537:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 220974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220982 */     GIR_RootConstrainSelectedInstOperands,
     /* 220983 */     // GIR_Coverage, 2793,
     /* 220983 */     GIR_EraseRootFromParent_Done,
     /* 220984 */   // Label 4354: @220984
     /* 220984 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(221026), // Rule ID 2794 //
     /* 220989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 220997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221013 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1537:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 221016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221024 */     GIR_RootConstrainSelectedInstOperands,
     /* 221025 */     // GIR_Coverage, 2794,
     /* 221025 */     GIR_EraseRootFromParent_Done,
     /* 221026 */   // Label 4355: @221026
     /* 221026 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(221068), // Rule ID 2795 //
     /* 221031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 221039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221055 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1537:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 221058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221066 */     GIR_RootConstrainSelectedInstOperands,
     /* 221067 */     // GIR_Coverage, 2795,
     /* 221067 */     GIR_EraseRootFromParent_Done,
     /* 221068 */   // Label 4356: @221068
     /* 221068 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(221110), // Rule ID 2864 //
     /* 221073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 221081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221097 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 221100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221108 */     GIR_RootConstrainSelectedInstOperands,
     /* 221109 */     // GIR_Coverage, 2864,
     /* 221109 */     GIR_EraseRootFromParent_Done,
     /* 221110 */   // Label 4357: @221110
     /* 221110 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(221152), // Rule ID 2865 //
     /* 221115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 221123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221139 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1400:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 221142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221150 */     GIR_RootConstrainSelectedInstOperands,
     /* 221151 */     // GIR_Coverage, 2865,
     /* 221151 */     GIR_EraseRootFromParent_Done,
     /* 221152 */   // Label 4358: @221152
     /* 221152 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(221194), // Rule ID 2866 //
     /* 221157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 221165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221181 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1395:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 221184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221192 */     GIR_RootConstrainSelectedInstOperands,
     /* 221193 */     // GIR_Coverage, 2866,
     /* 221193 */     GIR_EraseRootFromParent_Done,
     /* 221194 */   // Label 4359: @221194
     /* 221194 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(221236), // Rule ID 2867 //
     /* 221199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 221207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221223 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1396:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 221226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221234 */     GIR_RootConstrainSelectedInstOperands,
     /* 221235 */     // GIR_Coverage, 2867,
     /* 221235 */     GIR_EraseRootFromParent_Done,
     /* 221236 */   // Label 4360: @221236
     /* 221236 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(221278), // Rule ID 2868 //
     /* 221241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 221249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221265 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 221268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221276 */     GIR_RootConstrainSelectedInstOperands,
     /* 221277 */     // GIR_Coverage, 2868,
     /* 221277 */     GIR_EraseRootFromParent_Done,
     /* 221278 */   // Label 4361: @221278
     /* 221278 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(221320), // Rule ID 2869 //
     /* 221283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 221291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221307 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 221310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221318 */     GIR_RootConstrainSelectedInstOperands,
     /* 221319 */     // GIR_Coverage, 2869,
     /* 221319 */     GIR_EraseRootFromParent_Done,
     /* 221320 */   // Label 4362: @221320
     /* 221320 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(221362), // Rule ID 2870 //
     /* 221325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 221333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221349 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 221352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221360 */     GIR_RootConstrainSelectedInstOperands,
     /* 221361 */     // GIR_Coverage, 2870,
     /* 221361 */     GIR_EraseRootFromParent_Done,
     /* 221362 */   // Label 4363: @221362
     /* 221362 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(221404), // Rule ID 2871 //
     /* 221367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 221375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221391 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 221394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221402 */     GIR_RootConstrainSelectedInstOperands,
     /* 221403 */     // GIR_Coverage, 2871,
     /* 221403 */     GIR_EraseRootFromParent_Done,
     /* 221404 */   // Label 4364: @221404
     /* 221404 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(221446), // Rule ID 2882 //
     /* 221409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 221417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221433 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 221436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221444 */     GIR_RootConstrainSelectedInstOperands,
     /* 221445 */     // GIR_Coverage, 2882,
     /* 221445 */     GIR_EraseRootFromParent_Done,
     /* 221446 */   // Label 4365: @221446
     /* 221446 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(221488), // Rule ID 2884 //
     /* 221451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 221459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221475 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 221478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221486 */     GIR_RootConstrainSelectedInstOperands,
     /* 221487 */     // GIR_Coverage, 2884,
     /* 221487 */     GIR_EraseRootFromParent_Done,
     /* 221488 */   // Label 4366: @221488
     /* 221488 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(221530), // Rule ID 2892 //
     /* 221493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 221501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 221510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1423:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 221520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221528 */     GIR_RootConstrainSelectedInstOperands,
     /* 221529 */     // GIR_Coverage, 2892,
     /* 221529 */     GIR_EraseRootFromParent_Done,
     /* 221530 */   // Label 4367: @221530
     /* 221530 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(221572), // Rule ID 2893 //
     /* 221535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 221543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1423:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 221562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221570 */     GIR_RootConstrainSelectedInstOperands,
     /* 221571 */     // GIR_Coverage, 2893,
     /* 221571 */     GIR_EraseRootFromParent_Done,
     /* 221572 */   // Label 4368: @221572
     /* 221572 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(221614), // Rule ID 2894 //
     /* 221577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 221585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221601 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 221604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221612 */     GIR_RootConstrainSelectedInstOperands,
     /* 221613 */     // GIR_Coverage, 2894,
     /* 221613 */     GIR_EraseRootFromParent_Done,
     /* 221614 */   // Label 4369: @221614
     /* 221614 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(221656), // Rule ID 2898 //
     /* 221619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 221627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221643 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1401:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 221646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221654 */     GIR_RootConstrainSelectedInstOperands,
     /* 221655 */     // GIR_Coverage, 2898,
     /* 221655 */     GIR_EraseRootFromParent_Done,
     /* 221656 */   // Label 4370: @221656
     /* 221656 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(221698), // Rule ID 2943 //
     /* 221661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 221669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221685 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 221688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221696 */     GIR_RootConstrainSelectedInstOperands,
     /* 221697 */     // GIR_Coverage, 2943,
     /* 221697 */     GIR_EraseRootFromParent_Done,
     /* 221698 */   // Label 4371: @221698
     /* 221698 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(221740), // Rule ID 2944 //
     /* 221703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 221711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221727 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 221730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221738 */     GIR_RootConstrainSelectedInstOperands,
     /* 221739 */     // GIR_Coverage, 2944,
     /* 221739 */     GIR_EraseRootFromParent_Done,
     /* 221740 */   // Label 4372: @221740
     /* 221740 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(221782), // Rule ID 2973 //
     /* 221745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 221753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221769 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1822:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 221772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221780 */     GIR_RootConstrainSelectedInstOperands,
     /* 221781 */     // GIR_Coverage, 2973,
     /* 221781 */     GIR_EraseRootFromParent_Done,
     /* 221782 */   // Label 4373: @221782
     /* 221782 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(221824), // Rule ID 2974 //
     /* 221787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 221795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221811 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1822:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 221814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221822 */     GIR_RootConstrainSelectedInstOperands,
     /* 221823 */     // GIR_Coverage, 2974,
     /* 221823 */     GIR_EraseRootFromParent_Done,
     /* 221824 */   // Label 4374: @221824
     /* 221824 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(221866), // Rule ID 2975 //
     /* 221829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 221837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1822:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 221856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221864 */     GIR_RootConstrainSelectedInstOperands,
     /* 221865 */     // GIR_Coverage, 2975,
     /* 221865 */     GIR_EraseRootFromParent_Done,
     /* 221866 */   // Label 4375: @221866
     /* 221866 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(221908), // Rule ID 2976 //
     /* 221871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 221879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221895 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1822:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 221898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221906 */     GIR_RootConstrainSelectedInstOperands,
     /* 221907 */     // GIR_Coverage, 2976,
     /* 221907 */     GIR_EraseRootFromParent_Done,
     /* 221908 */   // Label 4376: @221908
     /* 221908 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(221950), // Rule ID 2977 //
     /* 221913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 221921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221937 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 221940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221948 */     GIR_RootConstrainSelectedInstOperands,
     /* 221949 */     // GIR_Coverage, 2977,
     /* 221949 */     GIR_EraseRootFromParent_Done,
     /* 221950 */   // Label 4377: @221950
     /* 221950 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(221992), // Rule ID 2978 //
     /* 221955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 221963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 221982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221990 */     GIR_RootConstrainSelectedInstOperands,
     /* 221991 */     // GIR_Coverage, 2978,
     /* 221991 */     GIR_EraseRootFromParent_Done,
     /* 221992 */   // Label 4378: @221992
     /* 221992 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(222034), // Rule ID 2979 //
     /* 221997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 222005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 222024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222032 */     GIR_RootConstrainSelectedInstOperands,
     /* 222033 */     // GIR_Coverage, 2979,
     /* 222033 */     GIR_EraseRootFromParent_Done,
     /* 222034 */   // Label 4379: @222034
     /* 222034 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(222076), // Rule ID 3009 //
     /* 222039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 222047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222063 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1717:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 222066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222074 */     GIR_RootConstrainSelectedInstOperands,
     /* 222075 */     // GIR_Coverage, 3009,
     /* 222075 */     GIR_EraseRootFromParent_Done,
     /* 222076 */   // Label 4380: @222076
     /* 222076 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(222118), // Rule ID 3011 //
     /* 222081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 222089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222105 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1717:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 222108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222116 */     GIR_RootConstrainSelectedInstOperands,
     /* 222117 */     // GIR_Coverage, 3011,
     /* 222117 */     GIR_EraseRootFromParent_Done,
     /* 222118 */   // Label 4381: @222118
     /* 222118 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(222160), // Rule ID 3013 //
     /* 222123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 222131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222147 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 222150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222158 */     GIR_RootConstrainSelectedInstOperands,
     /* 222159 */     // GIR_Coverage, 3013,
     /* 222159 */     GIR_EraseRootFromParent_Done,
     /* 222160 */   // Label 4382: @222160
     /* 222160 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(222202), // Rule ID 3015 //
     /* 222165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 222173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 222192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222200 */     GIR_RootConstrainSelectedInstOperands,
     /* 222201 */     // GIR_Coverage, 3015,
     /* 222201 */     GIR_EraseRootFromParent_Done,
     /* 222202 */   // Label 4383: @222202
     /* 222202 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(222244), // Rule ID 3017 //
     /* 222207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 222215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222231 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 222234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222242 */     GIR_RootConstrainSelectedInstOperands,
     /* 222243 */     // GIR_Coverage, 3017,
     /* 222243 */     GIR_EraseRootFromParent_Done,
     /* 222244 */   // Label 4384: @222244
     /* 222244 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(222286), // Rule ID 3018 //
     /* 222249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 222257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 222276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222284 */     GIR_RootConstrainSelectedInstOperands,
     /* 222285 */     // GIR_Coverage, 3018,
     /* 222285 */     GIR_EraseRootFromParent_Done,
     /* 222286 */   // Label 4385: @222286
     /* 222286 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(222328), // Rule ID 3019 //
     /* 222291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 222299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 222318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222326 */     GIR_RootConstrainSelectedInstOperands,
     /* 222327 */     // GIR_Coverage, 3019,
     /* 222327 */     GIR_EraseRootFromParent_Done,
     /* 222328 */   // Label 4386: @222328
     /* 222328 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(222370), // Rule ID 3020 //
     /* 222333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 222341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 222350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 222360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222368 */     GIR_RootConstrainSelectedInstOperands,
     /* 222369 */     // GIR_Coverage, 3020,
     /* 222369 */     GIR_EraseRootFromParent_Done,
     /* 222370 */   // Label 4387: @222370
     /* 222370 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(222412), // Rule ID 3021 //
     /* 222375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 222383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222399 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 222402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222410 */     GIR_RootConstrainSelectedInstOperands,
     /* 222411 */     // GIR_Coverage, 3021,
     /* 222411 */     GIR_EraseRootFromParent_Done,
     /* 222412 */   // Label 4388: @222412
     /* 222412 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(222454), // Rule ID 3022 //
     /* 222417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 222425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 222434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222441 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 222444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222452 */     GIR_RootConstrainSelectedInstOperands,
     /* 222453 */     // GIR_Coverage, 3022,
     /* 222453 */     GIR_EraseRootFromParent_Done,
     /* 222454 */   // Label 4389: @222454
     /* 222454 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(222496), // Rule ID 3023 //
     /* 222459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 222467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 222476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222483 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 222486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222494 */     GIR_RootConstrainSelectedInstOperands,
     /* 222495 */     // GIR_Coverage, 3023,
     /* 222495 */     GIR_EraseRootFromParent_Done,
     /* 222496 */   // Label 4390: @222496
     /* 222496 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(222538), // Rule ID 3024 //
     /* 222501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 222509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 222518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222525 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 222528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222536 */     GIR_RootConstrainSelectedInstOperands,
     /* 222537 */     // GIR_Coverage, 3024,
     /* 222537 */     GIR_EraseRootFromParent_Done,
     /* 222538 */   // Label 4391: @222538
     /* 222538 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(222580), // Rule ID 3041 //
     /* 222543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 222551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222567 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 222570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222578 */     GIR_RootConstrainSelectedInstOperands,
     /* 222579 */     // GIR_Coverage, 3041,
     /* 222579 */     GIR_EraseRootFromParent_Done,
     /* 222580 */   // Label 4392: @222580
     /* 222580 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(222622), // Rule ID 3042 //
     /* 222585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 222593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222609 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 222612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222620 */     GIR_RootConstrainSelectedInstOperands,
     /* 222621 */     // GIR_Coverage, 3042,
     /* 222621 */     GIR_EraseRootFromParent_Done,
     /* 222622 */   // Label 4393: @222622
     /* 222622 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(222664), // Rule ID 3043 //
     /* 222627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 222635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222651 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 222654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222662 */     GIR_RootConstrainSelectedInstOperands,
     /* 222663 */     // GIR_Coverage, 3043,
     /* 222663 */     GIR_EraseRootFromParent_Done,
     /* 222664 */   // Label 4394: @222664
     /* 222664 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(222706), // Rule ID 3044 //
     /* 222669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 222677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 222696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222704 */     GIR_RootConstrainSelectedInstOperands,
     /* 222705 */     // GIR_Coverage, 3044,
     /* 222705 */     GIR_EraseRootFromParent_Done,
     /* 222706 */   // Label 4395: @222706
     /* 222706 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(222748), // Rule ID 3068 //
     /* 222711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 222719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222735 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1680:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 222738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222746 */     GIR_RootConstrainSelectedInstOperands,
     /* 222747 */     // GIR_Coverage, 3068,
     /* 222747 */     GIR_EraseRootFromParent_Done,
     /* 222748 */   // Label 4396: @222748
     /* 222748 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(222790), // Rule ID 3070 //
     /* 222753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 222761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1680:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 222780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222788 */     GIR_RootConstrainSelectedInstOperands,
     /* 222789 */     // GIR_Coverage, 3070,
     /* 222789 */     GIR_EraseRootFromParent_Done,
     /* 222790 */   // Label 4397: @222790
     /* 222790 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(222832), // Rule ID 3072 //
     /* 222795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 222803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 222822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222830 */     GIR_RootConstrainSelectedInstOperands,
     /* 222831 */     // GIR_Coverage, 3072,
     /* 222831 */     GIR_EraseRootFromParent_Done,
     /* 222832 */   // Label 4398: @222832
     /* 222832 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(222874), // Rule ID 3074 //
     /* 222837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 222845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222861 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 222864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222872 */     GIR_RootConstrainSelectedInstOperands,
     /* 222873 */     // GIR_Coverage, 3074,
     /* 222873 */     GIR_EraseRootFromParent_Done,
     /* 222874 */   // Label 4399: @222874
     /* 222874 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(222916), // Rule ID 3076 //
     /* 222879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 222887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222903 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1681:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 222906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222914 */     GIR_RootConstrainSelectedInstOperands,
     /* 222915 */     // GIR_Coverage, 3076,
     /* 222915 */     GIR_EraseRootFromParent_Done,
     /* 222916 */   // Label 4400: @222916
     /* 222916 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222958), // Rule ID 3077 //
     /* 222921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 222929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 222948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222956 */     GIR_RootConstrainSelectedInstOperands,
     /* 222957 */     // GIR_Coverage, 3077,
     /* 222957 */     GIR_EraseRootFromParent_Done,
     /* 222958 */   // Label 4401: @222958
     /* 222958 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(223000), // Rule ID 3078 //
     /* 222963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 222966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 222971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222987 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 222990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222998 */     GIR_RootConstrainSelectedInstOperands,
     /* 222999 */     // GIR_Coverage, 3078,
     /* 222999 */     GIR_EraseRootFromParent_Done,
     /* 223000 */   // Label 4402: @223000
     /* 223000 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(223042), // Rule ID 3079 //
     /* 223005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 223013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1244:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 223032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223040 */     GIR_RootConstrainSelectedInstOperands,
     /* 223041 */     // GIR_Coverage, 3079,
     /* 223041 */     GIR_EraseRootFromParent_Done,
     /* 223042 */   // Label 4403: @223042
     /* 223042 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(223084), // Rule ID 3080 //
     /* 223047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 223055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1244:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 223074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223082 */     GIR_RootConstrainSelectedInstOperands,
     /* 223083 */     // GIR_Coverage, 3080,
     /* 223083 */     GIR_EraseRootFromParent_Done,
     /* 223084 */   // Label 4404: @223084
     /* 223084 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(223126), // Rule ID 3090 //
     /* 223089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 223097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223113 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 223116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223124 */     GIR_RootConstrainSelectedInstOperands,
     /* 223125 */     // GIR_Coverage, 3090,
     /* 223125 */     GIR_EraseRootFromParent_Done,
     /* 223126 */   // Label 4405: @223126
     /* 223126 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(223168), // Rule ID 3091 //
     /* 223131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 223139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223155 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 223158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223166 */     GIR_RootConstrainSelectedInstOperands,
     /* 223167 */     // GIR_Coverage, 3091,
     /* 223167 */     GIR_EraseRootFromParent_Done,
     /* 223168 */   // Label 4406: @223168
     /* 223168 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(223210), // Rule ID 3092 //
     /* 223173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 223181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 223200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223208 */     GIR_RootConstrainSelectedInstOperands,
     /* 223209 */     // GIR_Coverage, 3092,
     /* 223209 */     GIR_EraseRootFromParent_Done,
     /* 223210 */   // Label 4407: @223210
     /* 223210 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(223252), // Rule ID 3109 //
     /* 223215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 223223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 223242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223250 */     GIR_RootConstrainSelectedInstOperands,
     /* 223251 */     // GIR_Coverage, 3109,
     /* 223251 */     GIR_EraseRootFromParent_Done,
     /* 223252 */   // Label 4408: @223252
     /* 223252 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(223294), // Rule ID 3110 //
     /* 223257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 223265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223281 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 223281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 223284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223292 */     GIR_RootConstrainSelectedInstOperands,
     /* 223293 */     // GIR_Coverage, 3110,
     /* 223293 */     GIR_EraseRootFromParent_Done,
     /* 223294 */   // Label 4409: @223294
     /* 223294 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(223336), // Rule ID 3111 //
     /* 223299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 223307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 223323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 223326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223334 */     GIR_RootConstrainSelectedInstOperands,
     /* 223335 */     // GIR_Coverage, 3111,
     /* 223335 */     GIR_EraseRootFromParent_Done,
     /* 223336 */   // Label 4410: @223336
     /* 223336 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(223378), // Rule ID 3112 //
     /* 223341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 223349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 223365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 223368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223376 */     GIR_RootConstrainSelectedInstOperands,
     /* 223377 */     // GIR_Coverage, 3112,
     /* 223377 */     GIR_EraseRootFromParent_Done,
     /* 223378 */   // Label 4411: @223378
     /* 223378 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(223420), // Rule ID 3147 //
     /* 223383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 223391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223407 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1351:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 223410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223418 */     GIR_RootConstrainSelectedInstOperands,
     /* 223419 */     // GIR_Coverage, 3147,
     /* 223419 */     GIR_EraseRootFromParent_Done,
     /* 223420 */   // Label 4412: @223420
     /* 223420 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(223462), // Rule ID 3149 //
     /* 223425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 223433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1351:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 223452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223460 */     GIR_RootConstrainSelectedInstOperands,
     /* 223461 */     // GIR_Coverage, 3149,
     /* 223461 */     GIR_EraseRootFromParent_Done,
     /* 223462 */   // Label 4413: @223462
     /* 223462 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223504), // Rule ID 3151 //
     /* 223467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 223475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1351:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 223494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223502 */     GIR_RootConstrainSelectedInstOperands,
     /* 223503 */     // GIR_Coverage, 3151,
     /* 223503 */     GIR_EraseRootFromParent_Done,
     /* 223504 */   // Label 4414: @223504
     /* 223504 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223546), // Rule ID 3153 //
     /* 223509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 223512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 223517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223533 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1351:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 223536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223544 */     GIR_RootConstrainSelectedInstOperands,
     /* 223545 */     // GIR_Coverage, 3153,
     /* 223545 */     GIR_EraseRootFromParent_Done,
     /* 223546 */   // Label 4415: @223546
     /* 223546 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(223591), // Rule ID 3192 //
     /* 223551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 223559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223575 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 223578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223589 */     GIR_RootConstrainSelectedInstOperands,
     /* 223590 */     // GIR_Coverage, 3192,
     /* 223590 */     GIR_EraseRootFromParent_Done,
     /* 223591 */   // Label 4416: @223591
     /* 223591 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223636), // Rule ID 3193 //
     /* 223596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 223604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 223623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223634 */     GIR_RootConstrainSelectedInstOperands,
     /* 223635 */     // GIR_Coverage, 3193,
     /* 223635 */     GIR_EraseRootFromParent_Done,
     /* 223636 */   // Label 4417: @223636
     /* 223636 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223681), // Rule ID 3194 //
     /* 223641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 223649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223665 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 223668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223679 */     GIR_RootConstrainSelectedInstOperands,
     /* 223680 */     // GIR_Coverage, 3194,
     /* 223680 */     GIR_EraseRootFromParent_Done,
     /* 223681 */   // Label 4418: @223681
     /* 223681 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223726), // Rule ID 3195 //
     /* 223686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 223694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223710 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1317:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 223713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223724 */     GIR_RootConstrainSelectedInstOperands,
     /* 223725 */     // GIR_Coverage, 3195,
     /* 223725 */     GIR_EraseRootFromParent_Done,
     /* 223726 */   // Label 4419: @223726
     /* 223726 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223771), // Rule ID 3196 //
     /* 223731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 223739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223755 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 223758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223769 */     GIR_RootConstrainSelectedInstOperands,
     /* 223770 */     // GIR_Coverage, 3196,
     /* 223770 */     GIR_EraseRootFromParent_Done,
     /* 223771 */   // Label 4420: @223771
     /* 223771 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223816), // Rule ID 3197 //
     /* 223776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 223784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 223803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223814 */     GIR_RootConstrainSelectedInstOperands,
     /* 223815 */     // GIR_Coverage, 3197,
     /* 223815 */     GIR_EraseRootFromParent_Done,
     /* 223816 */   // Label 4421: @223816
     /* 223816 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223858), // Rule ID 3252 //
     /* 223821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 223829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223845 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 223848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223856 */     GIR_RootConstrainSelectedInstOperands,
     /* 223857 */     // GIR_Coverage, 3252,
     /* 223857 */     GIR_EraseRootFromParent_Done,
     /* 223858 */   // Label 4422: @223858
     /* 223858 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223900), // Rule ID 3253 //
     /* 223863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 223871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223887 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 223890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223898 */     GIR_RootConstrainSelectedInstOperands,
     /* 223899 */     // GIR_Coverage, 3253,
     /* 223899 */     GIR_EraseRootFromParent_Done,
     /* 223900 */   // Label 4423: @223900
     /* 223900 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223942), // Rule ID 3254 //
     /* 223905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 223913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 223916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223929 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 223932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223940 */     GIR_RootConstrainSelectedInstOperands,
     /* 223941 */     // GIR_Coverage, 3254,
     /* 223941 */     GIR_EraseRootFromParent_Done,
     /* 223942 */   // Label 4424: @223942
     /* 223942 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223984), // Rule ID 3306 //
     /* 223947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 223955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1267:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 223974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223982 */     GIR_RootConstrainSelectedInstOperands,
     /* 223983 */     // GIR_Coverage, 3306,
     /* 223983 */     GIR_EraseRootFromParent_Done,
     /* 223984 */   // Label 4425: @223984
     /* 223984 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(224026), // Rule ID 3307 //
     /* 223989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 223997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224013 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 224016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224024 */     GIR_RootConstrainSelectedInstOperands,
     /* 224025 */     // GIR_Coverage, 3307,
     /* 224025 */     GIR_EraseRootFromParent_Done,
     /* 224026 */   // Label 4426: @224026
     /* 224026 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(224068), // Rule ID 3308 //
     /* 224031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 224039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 224058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224066 */     GIR_RootConstrainSelectedInstOperands,
     /* 224067 */     // GIR_Coverage, 3308,
     /* 224067 */     GIR_EraseRootFromParent_Done,
     /* 224068 */   // Label 4427: @224068
     /* 224068 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(224110), // Rule ID 3309 //
     /* 224073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 224081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224097 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 224100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224108 */     GIR_RootConstrainSelectedInstOperands,
     /* 224109 */     // GIR_Coverage, 3309,
     /* 224109 */     GIR_EraseRootFromParent_Done,
     /* 224110 */   // Label 4428: @224110
     /* 224110 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(224152), // Rule ID 3318 //
     /* 224115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 224123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224139 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1269:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 224142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224150 */     GIR_RootConstrainSelectedInstOperands,
     /* 224151 */     // GIR_Coverage, 3318,
     /* 224151 */     GIR_EraseRootFromParent_Done,
     /* 224152 */   // Label 4429: @224152
     /* 224152 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224194), // Rule ID 3319 //
     /* 224157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 224165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224181 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 224184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224192 */     GIR_RootConstrainSelectedInstOperands,
     /* 224193 */     // GIR_Coverage, 3319,
     /* 224193 */     GIR_EraseRootFromParent_Done,
     /* 224194 */   // Label 4430: @224194
     /* 224194 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224236), // Rule ID 3320 //
     /* 224199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 224207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 224226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224234 */     GIR_RootConstrainSelectedInstOperands,
     /* 224235 */     // GIR_Coverage, 3320,
     /* 224235 */     GIR_EraseRootFromParent_Done,
     /* 224236 */   // Label 4431: @224236
     /* 224236 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224278), // Rule ID 3359 //
     /* 224241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224265 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 224268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224276 */     GIR_RootConstrainSelectedInstOperands,
     /* 224277 */     // GIR_Coverage, 3359,
     /* 224277 */     GIR_EraseRootFromParent_Done,
     /* 224278 */   // Label 4432: @224278
     /* 224278 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224320), // Rule ID 3360 //
     /* 224283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224307 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 224310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224318 */     GIR_RootConstrainSelectedInstOperands,
     /* 224319 */     // GIR_Coverage, 3360,
     /* 224319 */     GIR_EraseRootFromParent_Done,
     /* 224320 */   // Label 4433: @224320
     /* 224320 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224362), // Rule ID 3361 //
     /* 224325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 224352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224360 */     GIR_RootConstrainSelectedInstOperands,
     /* 224361 */     // GIR_Coverage, 3361,
     /* 224361 */     GIR_EraseRootFromParent_Done,
     /* 224362 */   // Label 4434: @224362
     /* 224362 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224404), // Rule ID 3362 //
     /* 224367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224391 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 224394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224402 */     GIR_RootConstrainSelectedInstOperands,
     /* 224403 */     // GIR_Coverage, 3362,
     /* 224403 */     GIR_EraseRootFromParent_Done,
     /* 224404 */   // Label 4435: @224404
     /* 224404 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224446), // Rule ID 3363 //
     /* 224409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224433 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 224436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224444 */     GIR_RootConstrainSelectedInstOperands,
     /* 224445 */     // GIR_Coverage, 3363,
     /* 224445 */     GIR_EraseRootFromParent_Done,
     /* 224446 */   // Label 4436: @224446
     /* 224446 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224488), // Rule ID 3364 //
     /* 224451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224475 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 224478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224486 */     GIR_RootConstrainSelectedInstOperands,
     /* 224487 */     // GIR_Coverage, 3364,
     /* 224487 */     GIR_EraseRootFromParent_Done,
     /* 224488 */   // Label 4437: @224488
     /* 224488 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224530), // Rule ID 3365 //
     /* 224493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 224501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224517 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 224520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224528 */     GIR_RootConstrainSelectedInstOperands,
     /* 224529 */     // GIR_Coverage, 3365,
     /* 224529 */     GIR_EraseRootFromParent_Done,
     /* 224530 */   // Label 4438: @224530
     /* 224530 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224572), // Rule ID 3448 //
     /* 224535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 224543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 224555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224559 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1298:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 224559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 224562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224570 */     GIR_RootConstrainSelectedInstOperands,
     /* 224571 */     // GIR_Coverage, 3448,
     /* 224571 */     GIR_EraseRootFromParent_Done,
     /* 224572 */   // Label 4439: @224572
     /* 224572 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224614), // Rule ID 3449 //
     /* 224577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 224585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 224597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224601 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 224601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 224604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 224606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224612 */     GIR_RootConstrainSelectedInstOperands,
     /* 224613 */     // GIR_Coverage, 3449,
     /* 224613 */     GIR_EraseRootFromParent_Done,
     /* 224614 */   // Label 4440: @224614
     /* 224614 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224656), // Rule ID 3450 //
     /* 224619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 224627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 224639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1293:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 224643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 224646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224654 */     GIR_RootConstrainSelectedInstOperands,
     /* 224655 */     // GIR_Coverage, 3450,
     /* 224655 */     GIR_EraseRootFromParent_Done,
     /* 224656 */   // Label 4441: @224656
     /* 224656 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224701), // Rule ID 3452 //
     /* 224661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 224664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 224669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224685 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 224688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224699 */     GIR_RootConstrainSelectedInstOperands,
     /* 224700 */     // GIR_Coverage, 3452,
     /* 224700 */     GIR_EraseRootFromParent_Done,
     /* 224701 */   // Label 4442: @224701
     /* 224701 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224746), // Rule ID 3453 //
     /* 224706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 224709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 224714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224730 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 224733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224744 */     GIR_RootConstrainSelectedInstOperands,
     /* 224745 */     // GIR_Coverage, 3453,
     /* 224745 */     GIR_EraseRootFromParent_Done,
     /* 224746 */   // Label 4443: @224746
     /* 224746 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(224788), // Rule ID 3454 //
     /* 224751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 224754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 224759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1545:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 224778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224786 */     GIR_RootConstrainSelectedInstOperands,
     /* 224787 */     // GIR_Coverage, 3454,
     /* 224787 */     GIR_EraseRootFromParent_Done,
     /* 224788 */   // Label 4444: @224788
     /* 224788 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(224830), // Rule ID 3455 //
     /* 224793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 224796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 224801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224817 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1545:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 224820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224828 */     GIR_RootConstrainSelectedInstOperands,
     /* 224829 */     // GIR_Coverage, 3455,
     /* 224829 */     GIR_EraseRootFromParent_Done,
     /* 224830 */   // Label 4445: @224830
     /* 224830 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(224872), // Rule ID 3460 //
     /* 224835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 224838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 224843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 224862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224870 */     GIR_RootConstrainSelectedInstOperands,
     /* 224871 */     // GIR_Coverage, 3460,
     /* 224871 */     GIR_EraseRootFromParent_Done,
     /* 224872 */   // Label 4446: @224872
     /* 224872 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(224914), // Rule ID 3499 //
     /* 224877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 224880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 224885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224901 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 224904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224912 */     GIR_RootConstrainSelectedInstOperands,
     /* 224913 */     // GIR_Coverage, 3499,
     /* 224913 */     GIR_EraseRootFromParent_Done,
     /* 224914 */   // Label 4447: @224914
     /* 224914 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(224956), // Rule ID 3501 //
     /* 224919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 224922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 224927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224943 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 224946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224954 */     GIR_RootConstrainSelectedInstOperands,
     /* 224955 */     // GIR_Coverage, 3501,
     /* 224955 */     GIR_EraseRootFromParent_Done,
     /* 224956 */   // Label 4448: @224956
     /* 224956 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(224998), // Rule ID 3503 //
     /* 224961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 224964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 224969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224985 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 224988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224996 */     GIR_RootConstrainSelectedInstOperands,
     /* 224997 */     // GIR_Coverage, 3503,
     /* 224997 */     GIR_EraseRootFromParent_Done,
     /* 224998 */   // Label 4449: @224998
     /* 224998 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(225040), // Rule ID 3505 //
     /* 225003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 225006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 225011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1712:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 225030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225038 */     GIR_RootConstrainSelectedInstOperands,
     /* 225039 */     // GIR_Coverage, 3505,
     /* 225039 */     GIR_EraseRootFromParent_Done,
     /* 225040 */   // Label 4450: @225040
     /* 225040 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(225082), // Rule ID 3632 //
     /* 225045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 225048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 225053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 225072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225080 */     GIR_RootConstrainSelectedInstOperands,
     /* 225081 */     // GIR_Coverage, 3632,
     /* 225081 */     GIR_EraseRootFromParent_Done,
     /* 225082 */   // Label 4451: @225082
     /* 225082 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(225124), // Rule ID 3634 //
     /* 225087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 225090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 225095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 225114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225122 */     GIR_RootConstrainSelectedInstOperands,
     /* 225123 */     // GIR_Coverage, 3634,
     /* 225123 */     GIR_EraseRootFromParent_Done,
     /* 225124 */   // Label 4452: @225124
     /* 225124 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225166), // Rule ID 3636 //
     /* 225129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 225132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 225137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 225156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225164 */     GIR_RootConstrainSelectedInstOperands,
     /* 225165 */     // GIR_Coverage, 3636,
     /* 225165 */     GIR_EraseRootFromParent_Done,
     /* 225166 */   // Label 4453: @225166
     /* 225166 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225208), // Rule ID 3638 //
     /* 225171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 225174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 225179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 225198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225206 */     GIR_RootConstrainSelectedInstOperands,
     /* 225207 */     // GIR_Coverage, 3638,
     /* 225207 */     GIR_EraseRootFromParent_Done,
     /* 225208 */   // Label 4454: @225208
     /* 225208 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(225250), // Rule ID 7508 //
     /* 225213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 225221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225237 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 225240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225248 */     GIR_RootConstrainSelectedInstOperands,
     /* 225249 */     // GIR_Coverage, 7508,
     /* 225249 */     GIR_EraseRootFromParent_Done,
     /* 225250 */   // Label 4455: @225250
     /* 225250 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(225292), // Rule ID 7510 //
     /* 225255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 225263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 225282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225290 */     GIR_RootConstrainSelectedInstOperands,
     /* 225291 */     // GIR_Coverage, 7510,
     /* 225291 */     GIR_EraseRootFromParent_Done,
     /* 225292 */   // Label 4456: @225292
     /* 225292 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(225334), // Rule ID 7512 //
     /* 225297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 225305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225321 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 225324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225332 */     GIR_RootConstrainSelectedInstOperands,
     /* 225333 */     // GIR_Coverage, 7512,
     /* 225333 */     GIR_EraseRootFromParent_Done,
     /* 225334 */   // Label 4457: @225334
     /* 225334 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(225376), // Rule ID 7514 //
     /* 225339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 225347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1905:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 225366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225374 */     GIR_RootConstrainSelectedInstOperands,
     /* 225375 */     // GIR_Coverage, 7514,
     /* 225375 */     GIR_EraseRootFromParent_Done,
     /* 225376 */   // Label 4458: @225376
     /* 225376 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(225418), // Rule ID 7532 //
     /* 225381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 225389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225405 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1290:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 225408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225416 */     GIR_RootConstrainSelectedInstOperands,
     /* 225417 */     // GIR_Coverage, 7532,
     /* 225417 */     GIR_EraseRootFromParent_Done,
     /* 225418 */   // Label 4459: @225418
     /* 225418 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(225460), // Rule ID 7533 //
     /* 225423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 225431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225447 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1290:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 225450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225458 */     GIR_RootConstrainSelectedInstOperands,
     /* 225459 */     // GIR_Coverage, 7533,
     /* 225459 */     GIR_EraseRootFromParent_Done,
     /* 225460 */   // Label 4460: @225460
     /* 225460 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(225502), // Rule ID 7534 //
     /* 225465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 225473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1290:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 225492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225500 */     GIR_RootConstrainSelectedInstOperands,
     /* 225501 */     // GIR_Coverage, 7534,
     /* 225501 */     GIR_EraseRootFromParent_Done,
     /* 225502 */   // Label 4461: @225502
     /* 225502 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(225544), // Rule ID 7535 //
     /* 225507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 225515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1290:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 225534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225542 */     GIR_RootConstrainSelectedInstOperands,
     /* 225543 */     // GIR_Coverage, 7535,
     /* 225543 */     GIR_EraseRootFromParent_Done,
     /* 225544 */   // Label 4462: @225544
     /* 225544 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(225586), // Rule ID 7648 //
     /* 225549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 225557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225573 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 225576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225584 */     GIR_RootConstrainSelectedInstOperands,
     /* 225585 */     // GIR_Coverage, 7648,
     /* 225585 */     GIR_EraseRootFromParent_Done,
     /* 225586 */   // Label 4463: @225586
     /* 225586 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(225628), // Rule ID 7649 //
     /* 225591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 225599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225615 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 225618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225626 */     GIR_RootConstrainSelectedInstOperands,
     /* 225627 */     // GIR_Coverage, 7649,
     /* 225627 */     GIR_EraseRootFromParent_Done,
     /* 225628 */   // Label 4464: @225628
     /* 225628 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(225670), // Rule ID 7650 //
     /* 225633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 225641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 225660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225668 */     GIR_RootConstrainSelectedInstOperands,
     /* 225669 */     // GIR_Coverage, 7650,
     /* 225669 */     GIR_EraseRootFromParent_Done,
     /* 225670 */   // Label 4465: @225670
     /* 225670 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(225712), // Rule ID 7651 //
     /* 225675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 225683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 225702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225710 */     GIR_RootConstrainSelectedInstOperands,
     /* 225711 */     // GIR_Coverage, 7651,
     /* 225711 */     GIR_EraseRootFromParent_Done,
     /* 225712 */   // Label 4466: @225712
     /* 225712 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225754), // Rule ID 7652 //
     /* 225717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 225725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225741 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 225744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225752 */     GIR_RootConstrainSelectedInstOperands,
     /* 225753 */     // GIR_Coverage, 7652,
     /* 225753 */     GIR_EraseRootFromParent_Done,
     /* 225754 */   // Label 4467: @225754
     /* 225754 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225796), // Rule ID 7653 //
     /* 225759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 225767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225783 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1990:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 225786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225794 */     GIR_RootConstrainSelectedInstOperands,
     /* 225795 */     // GIR_Coverage, 7653,
     /* 225795 */     GIR_EraseRootFromParent_Done,
     /* 225796 */   // Label 4468: @225796
     /* 225796 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225838), // Rule ID 7654 //
     /* 225801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 225809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225825 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 225828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225836 */     GIR_RootConstrainSelectedInstOperands,
     /* 225837 */     // GIR_Coverage, 7654,
     /* 225837 */     GIR_EraseRootFromParent_Done,
     /* 225838 */   // Label 4469: @225838
     /* 225838 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225880), // Rule ID 7655 //
     /* 225843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 225851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 225870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225878 */     GIR_RootConstrainSelectedInstOperands,
     /* 225879 */     // GIR_Coverage, 7655,
     /* 225879 */     GIR_EraseRootFromParent_Done,
     /* 225880 */   // Label 4470: @225880
     /* 225880 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225922), // Rule ID 7664 //
     /* 225885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 225893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 225912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225920 */     GIR_RootConstrainSelectedInstOperands,
     /* 225921 */     // GIR_Coverage, 7664,
     /* 225921 */     GIR_EraseRootFromParent_Done,
     /* 225922 */   // Label 4471: @225922
     /* 225922 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225964), // Rule ID 7665 //
     /* 225927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 225935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 225954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225962 */     GIR_RootConstrainSelectedInstOperands,
     /* 225963 */     // GIR_Coverage, 7665,
     /* 225963 */     GIR_EraseRootFromParent_Done,
     /* 225964 */   // Label 4472: @225964
     /* 225964 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(226006), // Rule ID 7666 //
     /* 225969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 225977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225993 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 225996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226004 */     GIR_RootConstrainSelectedInstOperands,
     /* 226005 */     // GIR_Coverage, 7666,
     /* 226005 */     GIR_EraseRootFromParent_Done,
     /* 226006 */   // Label 4473: @226006
     /* 226006 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(226048), // Rule ID 7667 //
     /* 226011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 226019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 226038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226046 */     GIR_RootConstrainSelectedInstOperands,
     /* 226047 */     // GIR_Coverage, 7667,
     /* 226047 */     GIR_EraseRootFromParent_Done,
     /* 226048 */   // Label 4474: @226048
     /* 226048 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(226090), // Rule ID 7668 //
     /* 226053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 226061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1955:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 226080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226088 */     GIR_RootConstrainSelectedInstOperands,
     /* 226089 */     // GIR_Coverage, 7668,
     /* 226089 */     GIR_EraseRootFromParent_Done,
     /* 226090 */   // Label 4475: @226090
     /* 226090 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(226132), // Rule ID 7669 //
     /* 226095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 226103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226119 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1955:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 226122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226130 */     GIR_RootConstrainSelectedInstOperands,
     /* 226131 */     // GIR_Coverage, 7669,
     /* 226131 */     GIR_EraseRootFromParent_Done,
     /* 226132 */   // Label 4476: @226132
     /* 226132 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(226174), // Rule ID 7758 //
     /* 226137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 226145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226161 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 226161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 226164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226172 */     GIR_RootConstrainSelectedInstOperands,
     /* 226173 */     // GIR_Coverage, 7758,
     /* 226173 */     GIR_EraseRootFromParent_Done,
     /* 226174 */   // Label 4477: @226174
     /* 226174 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(226216), // Rule ID 7759 //
     /* 226179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 226187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226203 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 226203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 226206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226214 */     GIR_RootConstrainSelectedInstOperands,
     /* 226215 */     // GIR_Coverage, 7759,
     /* 226215 */     GIR_EraseRootFromParent_Done,
     /* 226216 */   // Label 4478: @226216
     /* 226216 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(226258), // Rule ID 7760 //
     /* 226221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 226229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 226245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 226248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226256 */     GIR_RootConstrainSelectedInstOperands,
     /* 226257 */     // GIR_Coverage, 7760,
     /* 226257 */     GIR_EraseRootFromParent_Done,
     /* 226258 */   // Label 4479: @226258
     /* 226258 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(226300), // Rule ID 7761 //
     /* 226263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 226271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226287 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 226287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 226290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226298 */     GIR_RootConstrainSelectedInstOperands,
     /* 226299 */     // GIR_Coverage, 7761,
     /* 226299 */     GIR_EraseRootFromParent_Done,
     /* 226300 */   // Label 4480: @226300
     /* 226300 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226342), // Rule ID 7770 //
     /* 226305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 226313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226329 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 226329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 226332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226340 */     GIR_RootConstrainSelectedInstOperands,
     /* 226341 */     // GIR_Coverage, 7770,
     /* 226341 */     GIR_EraseRootFromParent_Done,
     /* 226342 */   // Label 4481: @226342
     /* 226342 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226384), // Rule ID 7771 //
     /* 226347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 226355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 226371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 226374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226382 */     GIR_RootConstrainSelectedInstOperands,
     /* 226383 */     // GIR_Coverage, 7771,
     /* 226383 */     GIR_EraseRootFromParent_Done,
     /* 226384 */   // Label 4482: @226384
     /* 226384 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226426), // Rule ID 7772 //
     /* 226389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 226397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 226413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 226416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226424 */     GIR_RootConstrainSelectedInstOperands,
     /* 226425 */     // GIR_Coverage, 7772,
     /* 226425 */     GIR_EraseRootFromParent_Done,
     /* 226426 */   // Label 4483: @226426
     /* 226426 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226468), // Rule ID 7773 //
     /* 226431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 226439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 226455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 226458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 226462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 226464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 226466 */     GIR_RootConstrainSelectedInstOperands,
     /* 226467 */     // GIR_Coverage, 7773,
     /* 226467 */     GIR_EraseRootFromParent_Done,
     /* 226468 */   // Label 4484: @226468
     /* 226468 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226510), // Rule ID 7852 //
     /* 226473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 226481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226497 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 226500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226508 */     GIR_RootConstrainSelectedInstOperands,
     /* 226509 */     // GIR_Coverage, 7852,
     /* 226509 */     GIR_EraseRootFromParent_Done,
     /* 226510 */   // Label 4485: @226510
     /* 226510 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226552), // Rule ID 7853 //
     /* 226515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 226523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 226542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226550 */     GIR_RootConstrainSelectedInstOperands,
     /* 226551 */     // GIR_Coverage, 7853,
     /* 226551 */     GIR_EraseRootFromParent_Done,
     /* 226552 */   // Label 4486: @226552
     /* 226552 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226594), // Rule ID 7854 //
     /* 226557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 226565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 226584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226592 */     GIR_RootConstrainSelectedInstOperands,
     /* 226593 */     // GIR_Coverage, 7854,
     /* 226593 */     GIR_EraseRootFromParent_Done,
     /* 226594 */   // Label 4487: @226594
     /* 226594 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226636), // Rule ID 7855 //
     /* 226599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 226607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1683:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 226626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226634 */     GIR_RootConstrainSelectedInstOperands,
     /* 226635 */     // GIR_Coverage, 7855,
     /* 226635 */     GIR_EraseRootFromParent_Done,
     /* 226636 */   // Label 4488: @226636
     /* 226636 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226678), // Rule ID 7856 //
     /* 226641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 226649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 226668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226676 */     GIR_RootConstrainSelectedInstOperands,
     /* 226677 */     // GIR_Coverage, 7856,
     /* 226677 */     GIR_EraseRootFromParent_Done,
     /* 226678 */   // Label 4489: @226678
     /* 226678 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226720), // Rule ID 7857 //
     /* 226683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 226691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1933:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 226710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226718 */     GIR_RootConstrainSelectedInstOperands,
     /* 226719 */     // GIR_Coverage, 7857,
     /* 226719 */     GIR_EraseRootFromParent_Done,
     /* 226720 */   // Label 4490: @226720
     /* 226720 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226762), // Rule ID 7858 //
     /* 226725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 226733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 226752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226760 */     GIR_RootConstrainSelectedInstOperands,
     /* 226761 */     // GIR_Coverage, 7858,
     /* 226761 */     GIR_EraseRootFromParent_Done,
     /* 226762 */   // Label 4491: @226762
     /* 226762 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226804), // Rule ID 7859 //
     /* 226767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 226775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1933:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 226794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226802 */     GIR_RootConstrainSelectedInstOperands,
     /* 226803 */     // GIR_Coverage, 7859,
     /* 226803 */     GIR_EraseRootFromParent_Done,
     /* 226804 */   // Label 4492: @226804
     /* 226804 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226846), // Rule ID 8055 //
     /* 226809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 226817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226833 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 226836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226844 */     GIR_RootConstrainSelectedInstOperands,
     /* 226845 */     // GIR_Coverage, 8055,
     /* 226845 */     GIR_EraseRootFromParent_Done,
     /* 226846 */   // Label 4493: @226846
     /* 226846 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226888), // Rule ID 8057 //
     /* 226851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 226859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226875 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 226878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226886 */     GIR_RootConstrainSelectedInstOperands,
     /* 226887 */     // GIR_Coverage, 8057,
     /* 226887 */     GIR_EraseRootFromParent_Done,
     /* 226888 */   // Label 4494: @226888
     /* 226888 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(226930), // Rule ID 8059 //
     /* 226893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 226901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226917 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 226920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226928 */     GIR_RootConstrainSelectedInstOperands,
     /* 226929 */     // GIR_Coverage, 8059,
     /* 226929 */     GIR_EraseRootFromParent_Done,
     /* 226930 */   // Label 4495: @226930
     /* 226930 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(226972), // Rule ID 8067 //
     /* 226935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 226943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226959 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 226962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226970 */     GIR_RootConstrainSelectedInstOperands,
     /* 226971 */     // GIR_Coverage, 8067,
     /* 226971 */     GIR_EraseRootFromParent_Done,
     /* 226972 */   // Label 4496: @226972
     /* 226972 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(227014), // Rule ID 8069 //
     /* 226977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 226985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227001 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 227004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227012 */     GIR_RootConstrainSelectedInstOperands,
     /* 227013 */     // GIR_Coverage, 8069,
     /* 227013 */     GIR_EraseRootFromParent_Done,
     /* 227014 */   // Label 4497: @227014
     /* 227014 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(227056), // Rule ID 8071 //
     /* 227019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 227027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 227046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227054 */     GIR_RootConstrainSelectedInstOperands,
     /* 227055 */     // GIR_Coverage, 8071,
     /* 227055 */     GIR_EraseRootFromParent_Done,
     /* 227056 */   // Label 4498: @227056
     /* 227056 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227098), // Rule ID 8109 //
     /* 227061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 227069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227085 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 227088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227096 */     GIR_RootConstrainSelectedInstOperands,
     /* 227097 */     // GIR_Coverage, 8109,
     /* 227097 */     GIR_EraseRootFromParent_Done,
     /* 227098 */   // Label 4499: @227098
     /* 227098 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227140), // Rule ID 8110 //
     /* 227103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 227111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227127 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 227130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227138 */     GIR_RootConstrainSelectedInstOperands,
     /* 227139 */     // GIR_Coverage, 8110,
     /* 227139 */     GIR_EraseRootFromParent_Done,
     /* 227140 */   // Label 4500: @227140
     /* 227140 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227182), // Rule ID 8111 //
     /* 227145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 227153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227169 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 227172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227180 */     GIR_RootConstrainSelectedInstOperands,
     /* 227181 */     // GIR_Coverage, 8111,
     /* 227181 */     GIR_EraseRootFromParent_Done,
     /* 227182 */   // Label 4501: @227182
     /* 227182 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227224), // Rule ID 8112 //
     /* 227187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 227195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227211 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 227214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227222 */     GIR_RootConstrainSelectedInstOperands,
     /* 227223 */     // GIR_Coverage, 8112,
     /* 227223 */     GIR_EraseRootFromParent_Done,
     /* 227224 */   // Label 4502: @227224
     /* 227224 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227266), // Rule ID 8113 //
     /* 227229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 227237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227253 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 227256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227264 */     GIR_RootConstrainSelectedInstOperands,
     /* 227265 */     // GIR_Coverage, 8113,
     /* 227265 */     GIR_EraseRootFromParent_Done,
     /* 227266 */   // Label 4503: @227266
     /* 227266 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227308), // Rule ID 8114 //
     /* 227271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 227279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227295 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 227298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227306 */     GIR_RootConstrainSelectedInstOperands,
     /* 227307 */     // GIR_Coverage, 8114,
     /* 227307 */     GIR_EraseRootFromParent_Done,
     /* 227308 */   // Label 4504: @227308
     /* 227308 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227350), // Rule ID 8115 //
     /* 227313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 227321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227337 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1419:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 227340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227348 */     GIR_RootConstrainSelectedInstOperands,
     /* 227349 */     // GIR_Coverage, 8115,
     /* 227349 */     GIR_EraseRootFromParent_Done,
     /* 227350 */   // Label 4505: @227350
     /* 227350 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227392), // Rule ID 8116 //
     /* 227355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 227363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227379 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 227382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227390 */     GIR_RootConstrainSelectedInstOperands,
     /* 227391 */     // GIR_Coverage, 8116,
     /* 227391 */     GIR_EraseRootFromParent_Done,
     /* 227392 */   // Label 4506: @227392
     /* 227392 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227434), // Rule ID 8117 //
     /* 227397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 227405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227421 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1419:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 227424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227432 */     GIR_RootConstrainSelectedInstOperands,
     /* 227433 */     // GIR_Coverage, 8117,
     /* 227433 */     GIR_EraseRootFromParent_Done,
     /* 227434 */   // Label 4507: @227434
     /* 227434 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(227476), // Rule ID 8118 //
     /* 227439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 227447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227463 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 227466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227474 */     GIR_RootConstrainSelectedInstOperands,
     /* 227475 */     // GIR_Coverage, 8118,
     /* 227475 */     GIR_EraseRootFromParent_Done,
     /* 227476 */   // Label 4508: @227476
     /* 227476 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(227518), // Rule ID 8119 //
     /* 227481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 227489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227505 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 227508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227516 */     GIR_RootConstrainSelectedInstOperands,
     /* 227517 */     // GIR_Coverage, 8119,
     /* 227517 */     GIR_EraseRootFromParent_Done,
     /* 227518 */   // Label 4509: @227518
     /* 227518 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(227560), // Rule ID 8120 //
     /* 227523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 227531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227547 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 227550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227558 */     GIR_RootConstrainSelectedInstOperands,
     /* 227559 */     // GIR_Coverage, 8120,
     /* 227559 */     GIR_EraseRootFromParent_Done,
     /* 227560 */   // Label 4510: @227560
     /* 227560 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(227602), // Rule ID 8157 //
     /* 227565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227589 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1359:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 227592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227600 */     GIR_RootConstrainSelectedInstOperands,
     /* 227601 */     // GIR_Coverage, 8157,
     /* 227601 */     GIR_EraseRootFromParent_Done,
     /* 227602 */   // Label 4511: @227602
     /* 227602 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(227644), // Rule ID 8159 //
     /* 227607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 227618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 227624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 227627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227631 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 227631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 227634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227642 */     GIR_RootConstrainSelectedInstOperands,
     /* 227643 */     // GIR_Coverage, 8159,
     /* 227643 */     GIR_EraseRootFromParent_Done,
     /* 227644 */   // Label 4512: @227644
     /* 227644 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(227686), // Rule ID 8161 //
     /* 227649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 227660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 227666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 227669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227673 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 227673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 227676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227684 */     GIR_RootConstrainSelectedInstOperands,
     /* 227685 */     // GIR_Coverage, 8161,
     /* 227685 */     GIR_EraseRootFromParent_Done,
     /* 227686 */   // Label 4513: @227686
     /* 227686 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(227728), // Rule ID 8163 //
     /* 227691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227715 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 227718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227726 */     GIR_RootConstrainSelectedInstOperands,
     /* 227727 */     // GIR_Coverage, 8163,
     /* 227727 */     GIR_EraseRootFromParent_Done,
     /* 227728 */   // Label 4514: @227728
     /* 227728 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(227770), // Rule ID 8165 //
     /* 227733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 227744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 227750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 227753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227757 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 227757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 227760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227768 */     GIR_RootConstrainSelectedInstOperands,
     /* 227769 */     // GIR_Coverage, 8165,
     /* 227769 */     GIR_EraseRootFromParent_Done,
     /* 227770 */   // Label 4515: @227770
     /* 227770 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(227812), // Rule ID 8167 //
     /* 227775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 227783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227799 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 227802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227810 */     GIR_RootConstrainSelectedInstOperands,
     /* 227811 */     // GIR_Coverage, 8167,
     /* 227811 */     GIR_EraseRootFromParent_Done,
     /* 227812 */   // Label 4516: @227812
     /* 227812 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(227854), // Rule ID 8169 //
     /* 227817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227841 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1481:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 227844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227852 */     GIR_RootConstrainSelectedInstOperands,
     /* 227853 */     // GIR_Coverage, 8169,
     /* 227853 */     GIR_EraseRootFromParent_Done,
     /* 227854 */   // Label 4517: @227854
     /* 227854 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(227896), // Rule ID 8170 //
     /* 227859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 227870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 227876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 227879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227883 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 227883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 227886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227894 */     GIR_RootConstrainSelectedInstOperands,
     /* 227895 */     // GIR_Coverage, 8170,
     /* 227895 */     GIR_EraseRootFromParent_Done,
     /* 227896 */   // Label 4518: @227896
     /* 227896 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(227938), // Rule ID 8171 //
     /* 227901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 227912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 227918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 227921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227925 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 227925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 227928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227936 */     GIR_RootConstrainSelectedInstOperands,
     /* 227937 */     // GIR_Coverage, 8171,
     /* 227937 */     GIR_EraseRootFromParent_Done,
     /* 227938 */   // Label 4519: @227938
     /* 227938 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(227980), // Rule ID 8172 //
     /* 227943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227967 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 227970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227978 */     GIR_RootConstrainSelectedInstOperands,
     /* 227979 */     // GIR_Coverage, 8172,
     /* 227979 */     GIR_EraseRootFromParent_Done,
     /* 227980 */   // Label 4520: @227980
     /* 227980 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(228022), // Rule ID 8173 //
     /* 227985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 227993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 227996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 228002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 228005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228009 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 228009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 228012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228020 */     GIR_RootConstrainSelectedInstOperands,
     /* 228021 */     // GIR_Coverage, 8173,
     /* 228021 */     GIR_EraseRootFromParent_Done,
     /* 228022 */   // Label 4521: @228022
     /* 228022 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(228064), // Rule ID 8174 //
     /* 228027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 228035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228051 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 228054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228062 */     GIR_RootConstrainSelectedInstOperands,
     /* 228063 */     // GIR_Coverage, 8174,
     /* 228063 */     GIR_EraseRootFromParent_Done,
     /* 228064 */   // Label 4522: @228064
     /* 228064 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(228106), // Rule ID 8427 //
     /* 228069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 228077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228093 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 228096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228104 */     GIR_RootConstrainSelectedInstOperands,
     /* 228105 */     // GIR_Coverage, 8427,
     /* 228105 */     GIR_EraseRootFromParent_Done,
     /* 228106 */   // Label 4523: @228106
     /* 228106 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(228148), // Rule ID 8429 //
     /* 228111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 228119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228135 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1295:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 228138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228146 */     GIR_RootConstrainSelectedInstOperands,
     /* 228147 */     // GIR_Coverage, 8429,
     /* 228147 */     GIR_EraseRootFromParent_Done,
     /* 228148 */   // Label 4524: @228148
     /* 228148 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(228190), // Rule ID 8430 //
     /* 228153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228177 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1292:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228188 */     GIR_RootConstrainSelectedInstOperands,
     /* 228189 */     // GIR_Coverage, 8430,
     /* 228189 */     GIR_EraseRootFromParent_Done,
     /* 228190 */   // Label 4525: @228190
     /* 228190 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(228232), // Rule ID 8431 //
     /* 228195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 228215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 228219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228230 */     GIR_RootConstrainSelectedInstOperands,
     /* 228231 */     // GIR_Coverage, 8431,
     /* 228231 */     GIR_EraseRootFromParent_Done,
     /* 228232 */   // Label 4526: @228232
     /* 228232 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(228274), // Rule ID 8432 //
     /* 228237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 228257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228261 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 228261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228272 */     GIR_RootConstrainSelectedInstOperands,
     /* 228273 */     // GIR_Coverage, 8432,
     /* 228273 */     GIR_EraseRootFromParent_Done,
     /* 228274 */   // Label 4527: @228274
     /* 228274 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(228316), // Rule ID 8433 //
     /* 228279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 228299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228303 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 228303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228314 */     GIR_RootConstrainSelectedInstOperands,
     /* 228315 */     // GIR_Coverage, 8433,
     /* 228315 */     GIR_EraseRootFromParent_Done,
     /* 228316 */   // Label 4528: @228316
     /* 228316 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(228358), // Rule ID 8434 //
     /* 228321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 228329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 228332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 228335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 228338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 228341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228345 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1292:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 228345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 228348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228356 */     GIR_RootConstrainSelectedInstOperands,
     /* 228357 */     // GIR_Coverage, 8434,
     /* 228357 */     GIR_EraseRootFromParent_Done,
     /* 228358 */   // Label 4529: @228358
     /* 228358 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(228400), // Rule ID 8455 //
     /* 228363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228387 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1350:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228398 */     GIR_RootConstrainSelectedInstOperands,
     /* 228399 */     // GIR_Coverage, 8455,
     /* 228399 */     GIR_EraseRootFromParent_Done,
     /* 228400 */   // Label 4530: @228400
     /* 228400 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(228442), // Rule ID 8456 //
     /* 228405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 228425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228429 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1350:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 228429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228440 */     GIR_RootConstrainSelectedInstOperands,
     /* 228441 */     // GIR_Coverage, 8456,
     /* 228441 */     GIR_EraseRootFromParent_Done,
     /* 228442 */   // Label 4531: @228442
     /* 228442 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(228484), // Rule ID 8457 //
     /* 228447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 228467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228471 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 228471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228482 */     GIR_RootConstrainSelectedInstOperands,
     /* 228483 */     // GIR_Coverage, 8457,
     /* 228483 */     GIR_EraseRootFromParent_Done,
     /* 228484 */   // Label 4532: @228484
     /* 228484 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(228526), // Rule ID 8458 //
     /* 228489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 228509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228513 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 228513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228524 */     GIR_RootConstrainSelectedInstOperands,
     /* 228525 */     // GIR_Coverage, 8458,
     /* 228525 */     GIR_EraseRootFromParent_Done,
     /* 228526 */   // Label 4533: @228526
     /* 228526 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(228568), // Rule ID 8459 //
     /* 228531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 228539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 228542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 228545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 228548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 228551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228555 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1350:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 228555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 228558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228566 */     GIR_RootConstrainSelectedInstOperands,
     /* 228567 */     // GIR_Coverage, 8459,
     /* 228567 */     GIR_EraseRootFromParent_Done,
     /* 228568 */   // Label 4534: @228568
     /* 228568 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(228610), // Rule ID 8475 //
     /* 228573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228597 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228608 */     GIR_RootConstrainSelectedInstOperands,
     /* 228609 */     // GIR_Coverage, 8475,
     /* 228609 */     GIR_EraseRootFromParent_Done,
     /* 228610 */   // Label 4535: @228610
     /* 228610 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(228652), // Rule ID 8476 //
     /* 228615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 228635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228639 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 228639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228650 */     GIR_RootConstrainSelectedInstOperands,
     /* 228651 */     // GIR_Coverage, 8476,
     /* 228651 */     GIR_EraseRootFromParent_Done,
     /* 228652 */   // Label 4536: @228652
     /* 228652 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(228694), // Rule ID 8477 //
     /* 228657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 228677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228681 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 228681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228692 */     GIR_RootConstrainSelectedInstOperands,
     /* 228693 */     // GIR_Coverage, 8477,
     /* 228693 */     GIR_EraseRootFromParent_Done,
     /* 228694 */   // Label 4537: @228694
     /* 228694 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(228736), // Rule ID 8478 //
     /* 228699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 228719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228723 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 228723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228734 */     GIR_RootConstrainSelectedInstOperands,
     /* 228735 */     // GIR_Coverage, 8478,
     /* 228735 */     GIR_EraseRootFromParent_Done,
     /* 228736 */   // Label 4538: @228736
     /* 228736 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(228778), // Rule ID 8479 //
     /* 228741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 228749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 228752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 228755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 228758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 228761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228765 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1621:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 228765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 228768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228776 */     GIR_RootConstrainSelectedInstOperands,
     /* 228777 */     // GIR_Coverage, 8479,
     /* 228777 */     GIR_EraseRootFromParent_Done,
     /* 228778 */   // Label 4539: @228778
     /* 228778 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(228820), // Rule ID 8480 //
     /* 228783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 228803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 228807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228818 */     GIR_RootConstrainSelectedInstOperands,
     /* 228819 */     // GIR_Coverage, 8480,
     /* 228819 */     GIR_EraseRootFromParent_Done,
     /* 228820 */   // Label 4540: @228820
     /* 228820 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(228862), // Rule ID 8481 //
     /* 228825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 228845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228849 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1617:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 228849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228860 */     GIR_RootConstrainSelectedInstOperands,
     /* 228861 */     // GIR_Coverage, 8481,
     /* 228861 */     GIR_EraseRootFromParent_Done,
     /* 228862 */   // Label 4541: @228862
     /* 228862 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(228904), // Rule ID 8482 //
     /* 228867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 228887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228891 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1617:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 228891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228902 */     GIR_RootConstrainSelectedInstOperands,
     /* 228903 */     // GIR_Coverage, 8482,
     /* 228903 */     GIR_EraseRootFromParent_Done,
     /* 228904 */   // Label 4542: @228904
     /* 228904 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(228946), // Rule ID 8483 //
     /* 228909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 228929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228933 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1617:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 228933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228944 */     GIR_RootConstrainSelectedInstOperands,
     /* 228945 */     // GIR_Coverage, 8483,
     /* 228945 */     GIR_EraseRootFromParent_Done,
     /* 228946 */   // Label 4543: @228946
     /* 228946 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(228988), // Rule ID 8484 //
     /* 228951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 228959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 228962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 228965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 228968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 228971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 228975 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1617:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 228975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 228978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228986 */     GIR_RootConstrainSelectedInstOperands,
     /* 228987 */     // GIR_Coverage, 8484,
     /* 228987 */     GIR_EraseRootFromParent_Done,
     /* 228988 */   // Label 4544: @228988
     /* 228988 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(229030), // Rule ID 8485 //
     /* 228993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 229013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229017 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1615:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 229017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229028 */     GIR_RootConstrainSelectedInstOperands,
     /* 229029 */     // GIR_Coverage, 8485,
     /* 229029 */     GIR_EraseRootFromParent_Done,
     /* 229030 */   // Label 4545: @229030
     /* 229030 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(229072), // Rule ID 8486 //
     /* 229035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 229055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229059 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1615:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 229059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229070 */     GIR_RootConstrainSelectedInstOperands,
     /* 229071 */     // GIR_Coverage, 8486,
     /* 229071 */     GIR_EraseRootFromParent_Done,
     /* 229072 */   // Label 4546: @229072
     /* 229072 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(229114), // Rule ID 8487 //
     /* 229077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 229097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229101 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1615:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 229101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229112 */     GIR_RootConstrainSelectedInstOperands,
     /* 229113 */     // GIR_Coverage, 8487,
     /* 229113 */     GIR_EraseRootFromParent_Done,
     /* 229114 */   // Label 4547: @229114
     /* 229114 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(229156), // Rule ID 8488 //
     /* 229119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 229130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 229139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229143 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1615:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 229143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229154 */     GIR_RootConstrainSelectedInstOperands,
     /* 229155 */     // GIR_Coverage, 8488,
     /* 229155 */     GIR_EraseRootFromParent_Done,
     /* 229156 */   // Label 4548: @229156
     /* 229156 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(229198), // Rule ID 8489 //
     /* 229161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 229169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 229172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 229175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 229178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 229181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229185 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1615:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 229185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 229188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229196 */     GIR_RootConstrainSelectedInstOperands,
     /* 229197 */     // GIR_Coverage, 8489,
     /* 229197 */     GIR_EraseRootFromParent_Done,
     /* 229198 */   // Label 4549: @229198
     /* 229198 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(229240), // Rule ID 8490 //
     /* 229203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 229223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229227 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 229227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229238 */     GIR_RootConstrainSelectedInstOperands,
     /* 229239 */     // GIR_Coverage, 8490,
     /* 229239 */     GIR_EraseRootFromParent_Done,
     /* 229240 */   // Label 4550: @229240
     /* 229240 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(229282), // Rule ID 8491 //
     /* 229245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 229265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229269 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 229269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229280 */     GIR_RootConstrainSelectedInstOperands,
     /* 229281 */     // GIR_Coverage, 8491,
     /* 229281 */     GIR_EraseRootFromParent_Done,
     /* 229282 */   // Label 4551: @229282
     /* 229282 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(229324), // Rule ID 8492 //
     /* 229287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 229307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229311 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 229311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229322 */     GIR_RootConstrainSelectedInstOperands,
     /* 229323 */     // GIR_Coverage, 8492,
     /* 229323 */     GIR_EraseRootFromParent_Done,
     /* 229324 */   // Label 4552: @229324
     /* 229324 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(229366), // Rule ID 8493 //
     /* 229329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 229340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 229349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229353 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 229353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229364 */     GIR_RootConstrainSelectedInstOperands,
     /* 229365 */     // GIR_Coverage, 8493,
     /* 229365 */     GIR_EraseRootFromParent_Done,
     /* 229366 */   // Label 4553: @229366
     /* 229366 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(229408), // Rule ID 8494 //
     /* 229371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 229379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 229382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 229385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 229388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 229391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 229395 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1611:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 229395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 229398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229406 */     GIR_RootConstrainSelectedInstOperands,
     /* 229407 */     // GIR_Coverage, 8494,
     /* 229407 */     GIR_EraseRootFromParent_Done,
     /* 229408 */   // Label 4554: @229408
     /* 229408 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(229450), // Rule ID 8502 //
     /* 229413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1308:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 229440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229448 */     GIR_RootConstrainSelectedInstOperands,
     /* 229449 */     // GIR_Coverage, 8502,
     /* 229449 */     GIR_EraseRootFromParent_Done,
     /* 229450 */   // Label 4555: @229450
     /* 229450 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(229492), // Rule ID 8503 //
     /* 229455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 229482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229490 */     GIR_RootConstrainSelectedInstOperands,
     /* 229491 */     // GIR_Coverage, 8503,
     /* 229491 */     GIR_EraseRootFromParent_Done,
     /* 229492 */   // Label 4556: @229492
     /* 229492 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(229534), // Rule ID 8504 //
     /* 229497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 229524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229532 */     GIR_RootConstrainSelectedInstOperands,
     /* 229533 */     // GIR_Coverage, 8504,
     /* 229533 */     GIR_EraseRootFromParent_Done,
     /* 229534 */   // Label 4557: @229534
     /* 229534 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(229576), // Rule ID 8505 //
     /* 229539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229563 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 229566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229574 */     GIR_RootConstrainSelectedInstOperands,
     /* 229575 */     // GIR_Coverage, 8505,
     /* 229575 */     GIR_EraseRootFromParent_Done,
     /* 229576 */   // Label 4558: @229576
     /* 229576 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(229618), // Rule ID 8506 //
     /* 229581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229605 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 229608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229616 */     GIR_RootConstrainSelectedInstOperands,
     /* 229617 */     // GIR_Coverage, 8506,
     /* 229617 */     GIR_EraseRootFromParent_Done,
     /* 229618 */   // Label 4559: @229618
     /* 229618 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(229660), // Rule ID 8507 //
     /* 229623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229647 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 229650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229658 */     GIR_RootConstrainSelectedInstOperands,
     /* 229659 */     // GIR_Coverage, 8507,
     /* 229659 */     GIR_EraseRootFromParent_Done,
     /* 229660 */   // Label 4560: @229660
     /* 229660 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(229702), // Rule ID 8508 //
     /* 229665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 229673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229689 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 229692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229700 */     GIR_RootConstrainSelectedInstOperands,
     /* 229701 */     // GIR_Coverage, 8508,
     /* 229701 */     GIR_EraseRootFromParent_Done,
     /* 229702 */   // Label 4561: @229702
     /* 229702 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(229747), // Rule ID 9204 //
     /* 229707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 229715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229731 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1329:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 229734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229745 */     GIR_RootConstrainSelectedInstOperands,
     /* 229746 */     // GIR_Coverage, 9204,
     /* 229746 */     GIR_EraseRootFromParent_Done,
     /* 229747 */   // Label 4562: @229747
     /* 229747 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(229792), // Rule ID 9205 //
     /* 229752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 229760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229776 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 229779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229790 */     GIR_RootConstrainSelectedInstOperands,
     /* 229791 */     // GIR_Coverage, 9205,
     /* 229791 */     GIR_EraseRootFromParent_Done,
     /* 229792 */   // Label 4563: @229792
     /* 229792 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(229837), // Rule ID 9206 //
     /* 229797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 229805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229821 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1329:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 229824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229835 */     GIR_RootConstrainSelectedInstOperands,
     /* 229836 */     // GIR_Coverage, 9206,
     /* 229836 */     GIR_EraseRootFromParent_Done,
     /* 229837 */   // Label 4564: @229837
     /* 229837 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(229882), // Rule ID 9207 //
     /* 229842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 229850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229866 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1319:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 229869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229880 */     GIR_RootConstrainSelectedInstOperands,
     /* 229881 */     // GIR_Coverage, 9207,
     /* 229881 */     GIR_EraseRootFromParent_Done,
     /* 229882 */   // Label 4565: @229882
     /* 229882 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(229927), // Rule ID 9208 //
     /* 229887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 229895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229911 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1319:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 229914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229925 */     GIR_RootConstrainSelectedInstOperands,
     /* 229926 */     // GIR_Coverage, 9208,
     /* 229926 */     GIR_EraseRootFromParent_Done,
     /* 229927 */   // Label 4566: @229927
     /* 229927 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(229972), // Rule ID 9209 //
     /* 229932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 229940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229956 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1319:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 229959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229970 */     GIR_RootConstrainSelectedInstOperands,
     /* 229971 */     // GIR_Coverage, 9209,
     /* 229971 */     GIR_EraseRootFromParent_Done,
     /* 229972 */   // Label 4567: @229972
     /* 229972 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(230017), // Rule ID 9210 //
     /* 229977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 229985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230001 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 230004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230015 */     GIR_RootConstrainSelectedInstOperands,
     /* 230016 */     // GIR_Coverage, 9210,
     /* 230016 */     GIR_EraseRootFromParent_Done,
     /* 230017 */   // Label 4568: @230017
     /* 230017 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(230062), // Rule ID 9211 //
     /* 230022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 230030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 230049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230060 */     GIR_RootConstrainSelectedInstOperands,
     /* 230061 */     // GIR_Coverage, 9211,
     /* 230061 */     GIR_EraseRootFromParent_Done,
     /* 230062 */   // Label 4569: @230062
     /* 230062 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(230107), // Rule ID 9212 //
     /* 230067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 230075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230091 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 230094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230105 */     GIR_RootConstrainSelectedInstOperands,
     /* 230106 */     // GIR_Coverage, 9212,
     /* 230106 */     GIR_EraseRootFromParent_Done,
     /* 230107 */   // Label 4570: @230107
     /* 230107 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(230152), // Rule ID 9213 //
     /* 230112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 230120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230136 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 230139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230150 */     GIR_RootConstrainSelectedInstOperands,
     /* 230151 */     // GIR_Coverage, 9213,
     /* 230151 */     GIR_EraseRootFromParent_Done,
     /* 230152 */   // Label 4571: @230152
     /* 230152 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(230197), // Rule ID 9214 //
     /* 230157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 230165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230181 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 230184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230195 */     GIR_RootConstrainSelectedInstOperands,
     /* 230196 */     // GIR_Coverage, 9214,
     /* 230196 */     GIR_EraseRootFromParent_Done,
     /* 230197 */   // Label 4572: @230197
     /* 230197 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(230242), // Rule ID 9215 //
     /* 230202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 230210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230226 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 230229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230240 */     GIR_RootConstrainSelectedInstOperands,
     /* 230241 */     // GIR_Coverage, 9215,
     /* 230241 */     GIR_EraseRootFromParent_Done,
     /* 230242 */   // Label 4573: @230242
     /* 230242 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(230287), // Rule ID 9216 //
     /* 230247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 230255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230271 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1323:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 230274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230285 */     GIR_RootConstrainSelectedInstOperands,
     /* 230286 */     // GIR_Coverage, 9216,
     /* 230286 */     GIR_EraseRootFromParent_Done,
     /* 230287 */   // Label 4574: @230287
     /* 230287 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(230332), // Rule ID 9217 //
     /* 230292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 230300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 230319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230330 */     GIR_RootConstrainSelectedInstOperands,
     /* 230331 */     // GIR_Coverage, 9217,
     /* 230331 */     GIR_EraseRootFromParent_Done,
     /* 230332 */   // Label 4575: @230332
     /* 230332 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(230377), // Rule ID 9218 //
     /* 230337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 230345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230361 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 230364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230375 */     GIR_RootConstrainSelectedInstOperands,
     /* 230376 */     // GIR_Coverage, 9218,
     /* 230376 */     GIR_EraseRootFromParent_Done,
     /* 230377 */   // Label 4576: @230377
     /* 230377 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(230422), // Rule ID 9219 //
     /* 230382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 230390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230406 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 230409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230420 */     GIR_RootConstrainSelectedInstOperands,
     /* 230421 */     // GIR_Coverage, 9219,
     /* 230421 */     GIR_EraseRootFromParent_Done,
     /* 230422 */   // Label 4577: @230422
     /* 230422 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(230467), // Rule ID 9220 //
     /* 230427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 230435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230451 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 230454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230465 */     GIR_RootConstrainSelectedInstOperands,
     /* 230466 */     // GIR_Coverage, 9220,
     /* 230466 */     GIR_EraseRootFromParent_Done,
     /* 230467 */   // Label 4578: @230467
     /* 230467 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(230512), // Rule ID 9221 //
     /* 230472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 230480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 230499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230510 */     GIR_RootConstrainSelectedInstOperands,
     /* 230511 */     // GIR_Coverage, 9221,
     /* 230511 */     GIR_EraseRootFromParent_Done,
     /* 230512 */   // Label 4579: @230512
     /* 230512 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(230557), // Rule ID 9222 //
     /* 230517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 230525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230541 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 230544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230555 */     GIR_RootConstrainSelectedInstOperands,
     /* 230556 */     // GIR_Coverage, 9222,
     /* 230556 */     GIR_EraseRootFromParent_Done,
     /* 230557 */   // Label 4580: @230557
     /* 230557 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(230602), // Rule ID 9223 //
     /* 230562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 230570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230586 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 230589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230600 */     GIR_RootConstrainSelectedInstOperands,
     /* 230601 */     // GIR_Coverage, 9223,
     /* 230601 */     GIR_EraseRootFromParent_Done,
     /* 230602 */   // Label 4581: @230602
     /* 230602 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(230647), // Rule ID 9224 //
     /* 230607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 230615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230631 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 230634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230645 */     GIR_RootConstrainSelectedInstOperands,
     /* 230646 */     // GIR_Coverage, 9224,
     /* 230646 */     GIR_EraseRootFromParent_Done,
     /* 230647 */   // Label 4582: @230647
     /* 230647 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(230692), // Rule ID 9225 //
     /* 230652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 230660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230676 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 230679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230690 */     GIR_RootConstrainSelectedInstOperands,
     /* 230691 */     // GIR_Coverage, 9225,
     /* 230691 */     GIR_EraseRootFromParent_Done,
     /* 230692 */   // Label 4583: @230692
     /* 230692 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(230737), // Rule ID 9226 //
     /* 230697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 230705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230721 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 230724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230735 */     GIR_RootConstrainSelectedInstOperands,
     /* 230736 */     // GIR_Coverage, 9226,
     /* 230736 */     GIR_EraseRootFromParent_Done,
     /* 230737 */   // Label 4584: @230737
     /* 230737 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(230782), // Rule ID 9227 //
     /* 230742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 230750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 230769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 230780 */     GIR_RootConstrainSelectedInstOperands,
     /* 230781 */     // GIR_Coverage, 9227,
     /* 230781 */     GIR_EraseRootFromParent_Done,
     /* 230782 */   // Label 4585: @230782
     /* 230782 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(230824), // Rule ID 9624 //
     /* 230787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 230795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 230798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230811 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 230814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230822 */     GIR_RootConstrainSelectedInstOperands,
     /* 230823 */     // GIR_Coverage, 9624,
     /* 230823 */     GIR_EraseRootFromParent_Done,
     /* 230824 */   // Label 4586: @230824
     /* 230824 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(230866), // Rule ID 9625 //
     /* 230829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 230837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 230840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230853 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 230856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230864 */     GIR_RootConstrainSelectedInstOperands,
     /* 230865 */     // GIR_Coverage, 9625,
     /* 230865 */     GIR_EraseRootFromParent_Done,
     /* 230866 */   // Label 4587: @230866
     /* 230866 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(230908), // Rule ID 9626 //
     /* 230871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 230879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 230882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230895 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 230898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230906 */     GIR_RootConstrainSelectedInstOperands,
     /* 230907 */     // GIR_Coverage, 9626,
     /* 230907 */     GIR_EraseRootFromParent_Done,
     /* 230908 */   // Label 4588: @230908
     /* 230908 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(230950), // Rule ID 10164 //
     /* 230913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 230921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230937 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 230940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230948 */     GIR_RootConstrainSelectedInstOperands,
     /* 230949 */     // GIR_Coverage, 10164,
     /* 230949 */     GIR_EraseRootFromParent_Done,
     /* 230950 */   // Label 4589: @230950
     /* 230950 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(230992), // Rule ID 10165 //
     /* 230955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 230963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230979 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 230982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230990 */     GIR_RootConstrainSelectedInstOperands,
     /* 230991 */     // GIR_Coverage, 10165,
     /* 230991 */     GIR_EraseRootFromParent_Done,
     /* 230992 */   // Label 4590: @230992
     /* 230992 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(231034), // Rule ID 10166 //
     /* 230997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 231005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 231024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231032 */     GIR_RootConstrainSelectedInstOperands,
     /* 231033 */     // GIR_Coverage, 10166,
     /* 231033 */     GIR_EraseRootFromParent_Done,
     /* 231034 */   // Label 4591: @231034
     /* 231034 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(231076), // Rule ID 10167 //
     /* 231039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 231047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231063 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 231066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231074 */     GIR_RootConstrainSelectedInstOperands,
     /* 231075 */     // GIR_Coverage, 10167,
     /* 231075 */     GIR_EraseRootFromParent_Done,
     /* 231076 */   // Label 4592: @231076
     /* 231076 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(231118), // Rule ID 10168 //
     /* 231081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 231089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231105 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1590:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 231108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231116 */     GIR_RootConstrainSelectedInstOperands,
     /* 231117 */     // GIR_Coverage, 10168,
     /* 231117 */     GIR_EraseRootFromParent_Done,
     /* 231118 */   // Label 4593: @231118
     /* 231118 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(231160), // Rule ID 10169 //
     /* 231123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 231131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231147 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1590:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 231150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231158 */     GIR_RootConstrainSelectedInstOperands,
     /* 231159 */     // GIR_Coverage, 10169,
     /* 231159 */     GIR_EraseRootFromParent_Done,
     /* 231160 */   // Label 4594: @231160
     /* 231160 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(231202), // Rule ID 10170 //
     /* 231165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 231173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231189 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 231192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231200 */     GIR_RootConstrainSelectedInstOperands,
     /* 231201 */     // GIR_Coverage, 10170,
     /* 231201 */     GIR_EraseRootFromParent_Done,
     /* 231202 */   // Label 4595: @231202
     /* 231202 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(231244), // Rule ID 10171 //
     /* 231207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 231215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231231 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 231234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231242 */     GIR_RootConstrainSelectedInstOperands,
     /* 231243 */     // GIR_Coverage, 10171,
     /* 231243 */     GIR_EraseRootFromParent_Done,
     /* 231244 */   // Label 4596: @231244
     /* 231244 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(231286), // Rule ID 10184 //
     /* 231249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 231257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231273 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1595:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 231276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231284 */     GIR_RootConstrainSelectedInstOperands,
     /* 231285 */     // GIR_Coverage, 10184,
     /* 231285 */     GIR_EraseRootFromParent_Done,
     /* 231286 */   // Label 4597: @231286
     /* 231286 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(231328), // Rule ID 10185 //
     /* 231291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 231299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231315 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 231318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231326 */     GIR_RootConstrainSelectedInstOperands,
     /* 231327 */     // GIR_Coverage, 10185,
     /* 231327 */     GIR_EraseRootFromParent_Done,
     /* 231328 */   // Label 4598: @231328
     /* 231328 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(231370), // Rule ID 10186 //
     /* 231333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 231341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 231360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231368 */     GIR_RootConstrainSelectedInstOperands,
     /* 231369 */     // GIR_Coverage, 10186,
     /* 231369 */     GIR_EraseRootFromParent_Done,
     /* 231370 */   // Label 4599: @231370
     /* 231370 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(231412), // Rule ID 10187 //
     /* 231375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 231383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231399 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 231402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231410 */     GIR_RootConstrainSelectedInstOperands,
     /* 231411 */     // GIR_Coverage, 10187,
     /* 231411 */     GIR_EraseRootFromParent_Done,
     /* 231412 */   // Label 4600: @231412
     /* 231412 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(231454), // Rule ID 10188 //
     /* 231417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 231425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231441 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 231444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231452 */     GIR_RootConstrainSelectedInstOperands,
     /* 231453 */     // GIR_Coverage, 10188,
     /* 231453 */     GIR_EraseRootFromParent_Done,
     /* 231454 */   // Label 4601: @231454
     /* 231454 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(231496), // Rule ID 10189 //
     /* 231459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 231467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231483 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 231486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231494 */     GIR_RootConstrainSelectedInstOperands,
     /* 231495 */     // GIR_Coverage, 10189,
     /* 231495 */     GIR_EraseRootFromParent_Done,
     /* 231496 */   // Label 4602: @231496
     /* 231496 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(231538), // Rule ID 10216 //
     /* 231501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 231509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231525 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 231525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 231528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231536 */     GIR_RootConstrainSelectedInstOperands,
     /* 231537 */     // GIR_Coverage, 10216,
     /* 231537 */     GIR_EraseRootFromParent_Done,
     /* 231538 */   // Label 4603: @231538
     /* 231538 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(231580), // Rule ID 10220 //
     /* 231543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 231551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231567 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 231567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 231570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231578 */     GIR_RootConstrainSelectedInstOperands,
     /* 231579 */     // GIR_Coverage, 10220,
     /* 231579 */     GIR_EraseRootFromParent_Done,
     /* 231580 */   // Label 4604: @231580
     /* 231580 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(231622), // Rule ID 10224 //
     /* 231585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 231593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231609 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 231609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 231612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231620 */     GIR_RootConstrainSelectedInstOperands,
     /* 231621 */     // GIR_Coverage, 10224,
     /* 231621 */     GIR_EraseRootFromParent_Done,
     /* 231622 */   // Label 4605: @231622
     /* 231622 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(231664), // Rule ID 10228 //
     /* 231627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 231635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231651 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 231651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 231654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231662 */     GIR_RootConstrainSelectedInstOperands,
     /* 231663 */     // GIR_Coverage, 10228,
     /* 231663 */     GIR_EraseRootFromParent_Done,
     /* 231664 */   // Label 4606: @231664
     /* 231664 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(231706), // Rule ID 10232 //
     /* 231669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 231677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231693 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1703:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 231696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231704 */     GIR_RootConstrainSelectedInstOperands,
     /* 231705 */     // GIR_Coverage, 10232,
     /* 231705 */     GIR_EraseRootFromParent_Done,
     /* 231706 */   // Label 4607: @231706
     /* 231706 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(231748), // Rule ID 10233 //
     /* 231711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 231719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231735 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1950:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 231738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231746 */     GIR_RootConstrainSelectedInstOperands,
     /* 231747 */     // GIR_Coverage, 10233,
     /* 231747 */     GIR_EraseRootFromParent_Done,
     /* 231748 */   // Label 4608: @231748
     /* 231748 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(231790), // Rule ID 10234 //
     /* 231753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 231761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231777 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1947:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 231780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231788 */     GIR_RootConstrainSelectedInstOperands,
     /* 231789 */     // GIR_Coverage, 10234,
     /* 231789 */     GIR_EraseRootFromParent_Done,
     /* 231790 */   // Label 4609: @231790
     /* 231790 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(231832), // Rule ID 10238 //
     /* 231795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 231803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231819 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1702:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 231822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231830 */     GIR_RootConstrainSelectedInstOperands,
     /* 231831 */     // GIR_Coverage, 10238,
     /* 231831 */     GIR_EraseRootFromParent_Done,
     /* 231832 */   // Label 4610: @231832
     /* 231832 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(231874), // Rule ID 10242 //
     /* 231837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 231845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231861 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1700:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 231864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231872 */     GIR_RootConstrainSelectedInstOperands,
     /* 231873 */     // GIR_Coverage, 10242,
     /* 231873 */     GIR_EraseRootFromParent_Done,
     /* 231874 */   // Label 4611: @231874
     /* 231874 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(231916), // Rule ID 10246 //
     /* 231879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 231887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231903 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1701:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 231906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231914 */     GIR_RootConstrainSelectedInstOperands,
     /* 231915 */     // GIR_Coverage, 10246,
     /* 231915 */     GIR_EraseRootFromParent_Done,
     /* 231916 */   // Label 4612: @231916
     /* 231916 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(231958), // Rule ID 10250 //
     /* 231921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 231929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231945 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1949:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 231948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231956 */     GIR_RootConstrainSelectedInstOperands,
     /* 231957 */     // GIR_Coverage, 10250,
     /* 231957 */     GIR_EraseRootFromParent_Done,
     /* 231958 */   // Label 4613: @231958
     /* 231958 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(232000), // Rule ID 10254 //
     /* 231963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 231971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231987 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1948:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 231990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231998 */     GIR_RootConstrainSelectedInstOperands,
     /* 231999 */     // GIR_Coverage, 10254,
     /* 231999 */     GIR_EraseRootFromParent_Done,
     /* 232000 */   // Label 4614: @232000
     /* 232000 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(232042), // Rule ID 10264 //
     /* 232005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 232013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1405:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 232032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232040 */     GIR_RootConstrainSelectedInstOperands,
     /* 232041 */     // GIR_Coverage, 10264,
     /* 232041 */     GIR_EraseRootFromParent_Done,
     /* 232042 */   // Label 4615: @232042
     /* 232042 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(232084), // Rule ID 10265 //
     /* 232047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 232055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 232074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232082 */     GIR_RootConstrainSelectedInstOperands,
     /* 232083 */     // GIR_Coverage, 10265,
     /* 232083 */     GIR_EraseRootFromParent_Done,
     /* 232084 */   // Label 4616: @232084
     /* 232084 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(232126), // Rule ID 10266 //
     /* 232089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 232097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232113 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1407:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 232116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232124 */     GIR_RootConstrainSelectedInstOperands,
     /* 232125 */     // GIR_Coverage, 10266,
     /* 232125 */     GIR_EraseRootFromParent_Done,
     /* 232126 */   // Label 4617: @232126
     /* 232126 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(232168), // Rule ID 10270 //
     /* 232131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 232139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1404:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 232158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232166 */     GIR_RootConstrainSelectedInstOperands,
     /* 232167 */     // GIR_Coverage, 10270,
     /* 232167 */     GIR_EraseRootFromParent_Done,
     /* 232168 */   // Label 4618: @232168
     /* 232168 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(232210), // Rule ID 10274 //
     /* 232173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 232181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232197 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1406:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 232200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232208 */     GIR_RootConstrainSelectedInstOperands,
     /* 232209 */     // GIR_Coverage, 10274,
     /* 232209 */     GIR_EraseRootFromParent_Done,
     /* 232210 */   // Label 4619: @232210
     /* 232210 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(232252), // Rule ID 10278 //
     /* 232215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 232223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 232242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232250 */     GIR_RootConstrainSelectedInstOperands,
     /* 232251 */     // GIR_Coverage, 10278,
     /* 232251 */     GIR_EraseRootFromParent_Done,
     /* 232252 */   // Label 4620: @232252
     /* 232252 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(232294), // Rule ID 10282 //
     /* 232257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 232265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232281 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1413:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 232284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232292 */     GIR_RootConstrainSelectedInstOperands,
     /* 232293 */     // GIR_Coverage, 10282,
     /* 232293 */     GIR_EraseRootFromParent_Done,
     /* 232294 */   // Label 4621: @232294
     /* 232294 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(232336), // Rule ID 10286 //
     /* 232299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 232307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 232326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232334 */     GIR_RootConstrainSelectedInstOperands,
     /* 232335 */     // GIR_Coverage, 10286,
     /* 232335 */     GIR_EraseRootFromParent_Done,
     /* 232336 */   // Label 4622: @232336
     /* 232336 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(232378), // Rule ID 11283 //
     /* 232341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 232344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 232349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 232368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232376 */     GIR_RootConstrainSelectedInstOperands,
     /* 232377 */     // GIR_Coverage, 11283,
     /* 232377 */     GIR_EraseRootFromParent_Done,
     /* 232378 */   // Label 4623: @232378
     /* 232378 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(232420), // Rule ID 11284 //
     /* 232383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 232386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 232391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 232410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232418 */     GIR_RootConstrainSelectedInstOperands,
     /* 232419 */     // GIR_Coverage, 11284,
     /* 232419 */     GIR_EraseRootFromParent_Done,
     /* 232420 */   // Label 4624: @232420
     /* 232420 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(232462), // Rule ID 11286 //
     /* 232425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 232428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 232433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232449 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 232452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232460 */     GIR_RootConstrainSelectedInstOperands,
     /* 232461 */     // GIR_Coverage, 11286,
     /* 232461 */     GIR_EraseRootFromParent_Done,
     /* 232462 */   // Label 4625: @232462
     /* 232462 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(232504), // Rule ID 11287 //
     /* 232467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 232470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 232475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232491 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 232494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232502 */     GIR_RootConstrainSelectedInstOperands,
     /* 232503 */     // GIR_Coverage, 11287,
     /* 232503 */     GIR_EraseRootFromParent_Done,
     /* 232504 */   // Label 4626: @232504
     /* 232504 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(232546), // Rule ID 11341 //
     /* 232509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 232517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232533 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 232536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232544 */     GIR_RootConstrainSelectedInstOperands,
     /* 232545 */     // GIR_Coverage, 11341,
     /* 232545 */     GIR_EraseRootFromParent_Done,
     /* 232546 */   // Label 4627: @232546
     /* 232546 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(232588), // Rule ID 11342 //
     /* 232551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 232559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 232578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232586 */     GIR_RootConstrainSelectedInstOperands,
     /* 232587 */     // GIR_Coverage, 11342,
     /* 232587 */     GIR_EraseRootFromParent_Done,
     /* 232588 */   // Label 4628: @232588
     /* 232588 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(232630), // Rule ID 11343 //
     /* 232593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 232601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 232620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232628 */     GIR_RootConstrainSelectedInstOperands,
     /* 232629 */     // GIR_Coverage, 11343,
     /* 232629 */     GIR_EraseRootFromParent_Done,
     /* 232630 */   // Label 4629: @232630
     /* 232630 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(232672), // Rule ID 11344 //
     /* 232635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 232643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232659 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 232662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232670 */     GIR_RootConstrainSelectedInstOperands,
     /* 232671 */     // GIR_Coverage, 11344,
     /* 232671 */     GIR_EraseRootFromParent_Done,
     /* 232672 */   // Label 4630: @232672
     /* 232672 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(232714), // Rule ID 11397 //
     /* 232677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 232685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232701 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 232704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232712 */     GIR_RootConstrainSelectedInstOperands,
     /* 232713 */     // GIR_Coverage, 11397,
     /* 232713 */     GIR_EraseRootFromParent_Done,
     /* 232714 */   // Label 4631: @232714
     /* 232714 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(232756), // Rule ID 11398 //
     /* 232719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 232727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232743 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 232746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232754 */     GIR_RootConstrainSelectedInstOperands,
     /* 232755 */     // GIR_Coverage, 11398,
     /* 232755 */     GIR_EraseRootFromParent_Done,
     /* 232756 */   // Label 4632: @232756
     /* 232756 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(232798), // Rule ID 11399 //
     /* 232761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 232769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232785 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 232788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232796 */     GIR_RootConstrainSelectedInstOperands,
     /* 232797 */     // GIR_Coverage, 11399,
     /* 232797 */     GIR_EraseRootFromParent_Done,
     /* 232798 */   // Label 4633: @232798
     /* 232798 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(232840), // Rule ID 11400 //
     /* 232803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 232811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1981:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 232830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232838 */     GIR_RootConstrainSelectedInstOperands,
     /* 232839 */     // GIR_Coverage, 11400,
     /* 232839 */     GIR_EraseRootFromParent_Done,
     /* 232840 */   // Label 4634: @232840
     /* 232840 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(232882), // Rule ID 11401 //
     /* 232845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 232853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 232872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232880 */     GIR_RootConstrainSelectedInstOperands,
     /* 232881 */     // GIR_Coverage, 11401,
     /* 232881 */     GIR_EraseRootFromParent_Done,
     /* 232882 */   // Label 4635: @232882
     /* 232882 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(232924), // Rule ID 11402 //
     /* 232887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 232895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1981:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 232914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232922 */     GIR_RootConstrainSelectedInstOperands,
     /* 232923 */     // GIR_Coverage, 11402,
     /* 232923 */     GIR_EraseRootFromParent_Done,
     /* 232924 */   // Label 4636: @232924
     /* 232924 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(232966), // Rule ID 11403 //
     /* 232929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 232937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1983:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 232956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232964 */     GIR_RootConstrainSelectedInstOperands,
     /* 232965 */     // GIR_Coverage, 11403,
     /* 232965 */     GIR_EraseRootFromParent_Done,
     /* 232966 */   // Label 4637: @232966
     /* 232966 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(233008), // Rule ID 11404 //
     /* 232971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 232979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232995 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1983:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 232998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233006 */     GIR_RootConstrainSelectedInstOperands,
     /* 233007 */     // GIR_Coverage, 11404,
     /* 233007 */     GIR_EraseRootFromParent_Done,
     /* 233008 */   // Label 4638: @233008
     /* 233008 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(233050), // Rule ID 11405 //
     /* 233013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 233021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233037 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1983:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 233040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233048 */     GIR_RootConstrainSelectedInstOperands,
     /* 233049 */     // GIR_Coverage, 11405,
     /* 233049 */     GIR_EraseRootFromParent_Done,
     /* 233050 */   // Label 4639: @233050
     /* 233050 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(233092), // Rule ID 11406 //
     /* 233055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 233063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233079 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 233082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233090 */     GIR_RootConstrainSelectedInstOperands,
     /* 233091 */     // GIR_Coverage, 11406,
     /* 233091 */     GIR_EraseRootFromParent_Done,
     /* 233092 */   // Label 4640: @233092
     /* 233092 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(233134), // Rule ID 11407 //
     /* 233097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 233105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233121 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 233124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233132 */     GIR_RootConstrainSelectedInstOperands,
     /* 233133 */     // GIR_Coverage, 11407,
     /* 233133 */     GIR_EraseRootFromParent_Done,
     /* 233134 */   // Label 4641: @233134
     /* 233134 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(233176), // Rule ID 11408 //
     /* 233139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 233147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233163 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 233166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233174 */     GIR_RootConstrainSelectedInstOperands,
     /* 233175 */     // GIR_Coverage, 11408,
     /* 233175 */     GIR_EraseRootFromParent_Done,
     /* 233176 */   // Label 4642: @233176
     /* 233176 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(233218), // Rule ID 11409 //
     /* 233181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 233189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 233208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233216 */     GIR_RootConstrainSelectedInstOperands,
     /* 233217 */     // GIR_Coverage, 11409,
     /* 233217 */     GIR_EraseRootFromParent_Done,
     /* 233218 */   // Label 4643: @233218
     /* 233218 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(233260), // Rule ID 11410 //
     /* 233223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 233231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 233250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233258 */     GIR_RootConstrainSelectedInstOperands,
     /* 233259 */     // GIR_Coverage, 11410,
     /* 233259 */     GIR_EraseRootFromParent_Done,
     /* 233260 */   // Label 4644: @233260
     /* 233260 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(233302), // Rule ID 11411 //
     /* 233265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 233273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 233292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233300 */     GIR_RootConstrainSelectedInstOperands,
     /* 233301 */     // GIR_Coverage, 11411,
     /* 233301 */     GIR_EraseRootFromParent_Done,
     /* 233302 */   // Label 4645: @233302
     /* 233302 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(233344), // Rule ID 11412 //
     /* 233307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 233315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1985:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 233334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233342 */     GIR_RootConstrainSelectedInstOperands,
     /* 233343 */     // GIR_Coverage, 11412,
     /* 233343 */     GIR_EraseRootFromParent_Done,
     /* 233344 */   // Label 4646: @233344
     /* 233344 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(233386), // Rule ID 11413 //
     /* 233349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 233357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 233376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233384 */     GIR_RootConstrainSelectedInstOperands,
     /* 233385 */     // GIR_Coverage, 11413,
     /* 233385 */     GIR_EraseRootFromParent_Done,
     /* 233386 */   // Label 4647: @233386
     /* 233386 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(233428), // Rule ID 11414 //
     /* 233391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 233399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 233418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233426 */     GIR_RootConstrainSelectedInstOperands,
     /* 233427 */     // GIR_Coverage, 11414,
     /* 233427 */     GIR_EraseRootFromParent_Done,
     /* 233428 */   // Label 4648: @233428
     /* 233428 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(233470), // Rule ID 11415 //
     /* 233433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 233441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233457 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1987:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 233460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233468 */     GIR_RootConstrainSelectedInstOperands,
     /* 233469 */     // GIR_Coverage, 11415,
     /* 233469 */     GIR_EraseRootFromParent_Done,
     /* 233470 */   // Label 4649: @233470
     /* 233470 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(233512), // Rule ID 11416 //
     /* 233475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 233483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1987:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 233502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233510 */     GIR_RootConstrainSelectedInstOperands,
     /* 233511 */     // GIR_Coverage, 11416,
     /* 233511 */     GIR_EraseRootFromParent_Done,
     /* 233512 */   // Label 4650: @233512
     /* 233512 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(233554), // Rule ID 11417 //
     /* 233517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 233525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1987:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 233544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233552 */     GIR_RootConstrainSelectedInstOperands,
     /* 233553 */     // GIR_Coverage, 11417,
     /* 233553 */     GIR_EraseRootFromParent_Done,
     /* 233554 */   // Label 4651: @233554
     /* 233554 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(233596), // Rule ID 11426 //
     /* 233559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 233567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233583 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1785:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 233586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233594 */     GIR_RootConstrainSelectedInstOperands,
     /* 233595 */     // GIR_Coverage, 11426,
     /* 233595 */     GIR_EraseRootFromParent_Done,
     /* 233596 */   // Label 4652: @233596
     /* 233596 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(233638), // Rule ID 11427 //
     /* 233601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 233609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233625 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1785:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 233628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233636 */     GIR_RootConstrainSelectedInstOperands,
     /* 233637 */     // GIR_Coverage, 11427,
     /* 233637 */     GIR_EraseRootFromParent_Done,
     /* 233638 */   // Label 4653: @233638
     /* 233638 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(233680), // Rule ID 11428 //
     /* 233643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 233651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233667 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1785:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 233670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233678 */     GIR_RootConstrainSelectedInstOperands,
     /* 233679 */     // GIR_Coverage, 11428,
     /* 233679 */     GIR_EraseRootFromParent_Done,
     /* 233680 */   // Label 4654: @233680
     /* 233680 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(233722), // Rule ID 11429 //
     /* 233685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 233693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 233712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233720 */     GIR_RootConstrainSelectedInstOperands,
     /* 233721 */     // GIR_Coverage, 11429,
     /* 233721 */     GIR_EraseRootFromParent_Done,
     /* 233722 */   // Label 4655: @233722
     /* 233722 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(233764), // Rule ID 11430 //
     /* 233727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 233735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233751 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 233754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233762 */     GIR_RootConstrainSelectedInstOperands,
     /* 233763 */     // GIR_Coverage, 11430,
     /* 233763 */     GIR_EraseRootFromParent_Done,
     /* 233764 */   // Label 4656: @233764
     /* 233764 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(233806), // Rule ID 11431 //
     /* 233769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 233777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 233796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233804 */     GIR_RootConstrainSelectedInstOperands,
     /* 233805 */     // GIR_Coverage, 11431,
     /* 233805 */     GIR_EraseRootFromParent_Done,
     /* 233806 */   // Label 4657: @233806
     /* 233806 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(233848), // Rule ID 11432 //
     /* 233811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 233819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1790:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 233838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233846 */     GIR_RootConstrainSelectedInstOperands,
     /* 233847 */     // GIR_Coverage, 11432,
     /* 233847 */     GIR_EraseRootFromParent_Done,
     /* 233848 */   // Label 4658: @233848
     /* 233848 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(233890), // Rule ID 11433 //
     /* 233853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 233861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 233880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233888 */     GIR_RootConstrainSelectedInstOperands,
     /* 233889 */     // GIR_Coverage, 11433,
     /* 233889 */     GIR_EraseRootFromParent_Done,
     /* 233890 */   // Label 4659: @233890
     /* 233890 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(233932), // Rule ID 11434 //
     /* 233895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 233903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 233922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233930 */     GIR_RootConstrainSelectedInstOperands,
     /* 233931 */     // GIR_Coverage, 11434,
     /* 233931 */     GIR_EraseRootFromParent_Done,
     /* 233932 */   // Label 4660: @233932
     /* 233932 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(233974), // Rule ID 11435 //
     /* 233937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 233945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1793:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 233964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233972 */     GIR_RootConstrainSelectedInstOperands,
     /* 233973 */     // GIR_Coverage, 11435,
     /* 233973 */     GIR_EraseRootFromParent_Done,
     /* 233974 */   // Label 4661: @233974
     /* 233974 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(234016), // Rule ID 11436 //
     /* 233979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 233987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234003 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 234006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234014 */     GIR_RootConstrainSelectedInstOperands,
     /* 234015 */     // GIR_Coverage, 11436,
     /* 234015 */     GIR_EraseRootFromParent_Done,
     /* 234016 */   // Label 4662: @234016
     /* 234016 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(234058), // Rule ID 11437 //
     /* 234021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 234029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234045 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 234048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234056 */     GIR_RootConstrainSelectedInstOperands,
     /* 234057 */     // GIR_Coverage, 11437,
     /* 234057 */     GIR_EraseRootFromParent_Done,
     /* 234058 */   // Label 4663: @234058
     /* 234058 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(234100), // Rule ID 11438 //
     /* 234063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 234071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 234090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234098 */     GIR_RootConstrainSelectedInstOperands,
     /* 234099 */     // GIR_Coverage, 11438,
     /* 234099 */     GIR_EraseRootFromParent_Done,
     /* 234100 */   // Label 4664: @234100
     /* 234100 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(234142), // Rule ID 11439 //
     /* 234105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 234113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 234132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234140 */     GIR_RootConstrainSelectedInstOperands,
     /* 234141 */     // GIR_Coverage, 11439,
     /* 234141 */     GIR_EraseRootFromParent_Done,
     /* 234142 */   // Label 4665: @234142
     /* 234142 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(234184), // Rule ID 11440 //
     /* 234147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 234155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234171 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 234174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234182 */     GIR_RootConstrainSelectedInstOperands,
     /* 234183 */     // GIR_Coverage, 11440,
     /* 234183 */     GIR_EraseRootFromParent_Done,
     /* 234184 */   // Label 4666: @234184
     /* 234184 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(234226), // Rule ID 11441 //
     /* 234189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 234197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234213 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1792:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 234216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234224 */     GIR_RootConstrainSelectedInstOperands,
     /* 234225 */     // GIR_Coverage, 11441,
     /* 234225 */     GIR_EraseRootFromParent_Done,
     /* 234226 */   // Label 4667: @234226
     /* 234226 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(234268), // Rule ID 11442 //
     /* 234231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 234239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 234258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234266 */     GIR_RootConstrainSelectedInstOperands,
     /* 234267 */     // GIR_Coverage, 11442,
     /* 234267 */     GIR_EraseRootFromParent_Done,
     /* 234268 */   // Label 4668: @234268
     /* 234268 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(234310), // Rule ID 11443 //
     /* 234273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 234281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 234300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234308 */     GIR_RootConstrainSelectedInstOperands,
     /* 234309 */     // GIR_Coverage, 11443,
     /* 234309 */     GIR_EraseRootFromParent_Done,
     /* 234310 */   // Label 4669: @234310
     /* 234310 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(234352), // Rule ID 11444 //
     /* 234315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 234323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234339 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1960:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 234342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234350 */     GIR_RootConstrainSelectedInstOperands,
     /* 234351 */     // GIR_Coverage, 11444,
     /* 234351 */     GIR_EraseRootFromParent_Done,
     /* 234352 */   // Label 4670: @234352
     /* 234352 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(234394), // Rule ID 11446 //
     /* 234357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 234365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234381 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1960:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 234384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234392 */     GIR_RootConstrainSelectedInstOperands,
     /* 234393 */     // GIR_Coverage, 11446,
     /* 234393 */     GIR_EraseRootFromParent_Done,
     /* 234394 */   // Label 4671: @234394
     /* 234394 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(234436), // Rule ID 11448 //
     /* 234399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 234407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 234426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234434 */     GIR_RootConstrainSelectedInstOperands,
     /* 234435 */     // GIR_Coverage, 11448,
     /* 234435 */     GIR_EraseRootFromParent_Done,
     /* 234436 */   // Label 4672: @234436
     /* 234436 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(234478), // Rule ID 11450 //
     /* 234441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 234449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 234468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234476 */     GIR_RootConstrainSelectedInstOperands,
     /* 234477 */     // GIR_Coverage, 11450,
     /* 234477 */     GIR_EraseRootFromParent_Done,
     /* 234478 */   // Label 4673: @234478
     /* 234478 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(234520), // Rule ID 11452 //
     /* 234483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 234491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234507 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1720:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 234510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234518 */     GIR_RootConstrainSelectedInstOperands,
     /* 234519 */     // GIR_Coverage, 11452,
     /* 234519 */     GIR_EraseRootFromParent_Done,
     /* 234520 */   // Label 4674: @234520
     /* 234520 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(234562), // Rule ID 11453 //
     /* 234525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 234533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234549 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1720:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 234552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234560 */     GIR_RootConstrainSelectedInstOperands,
     /* 234561 */     // GIR_Coverage, 11453,
     /* 234561 */     GIR_EraseRootFromParent_Done,
     /* 234562 */   // Label 4675: @234562
     /* 234562 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(234604), // Rule ID 11454 //
     /* 234567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 234575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234591 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 234594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234602 */     GIR_RootConstrainSelectedInstOperands,
     /* 234603 */     // GIR_Coverage, 11454,
     /* 234603 */     GIR_EraseRootFromParent_Done,
     /* 234604 */   // Label 4676: @234604
     /* 234604 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(234646), // Rule ID 11455 //
     /* 234609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 234617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234633 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1720:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 234636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234644 */     GIR_RootConstrainSelectedInstOperands,
     /* 234645 */     // GIR_Coverage, 11455,
     /* 234645 */     GIR_EraseRootFromParent_Done,
     /* 234646 */   // Label 4677: @234646
     /* 234646 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(234688), // Rule ID 11456 //
     /* 234651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 234659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234675 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 234678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234686 */     GIR_RootConstrainSelectedInstOperands,
     /* 234687 */     // GIR_Coverage, 11456,
     /* 234687 */     GIR_EraseRootFromParent_Done,
     /* 234688 */   // Label 4678: @234688
     /* 234688 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(234730), // Rule ID 11457 //
     /* 234693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 234701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 234720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234728 */     GIR_RootConstrainSelectedInstOperands,
     /* 234729 */     // GIR_Coverage, 11457,
     /* 234729 */     GIR_EraseRootFromParent_Done,
     /* 234730 */   // Label 4679: @234730
     /* 234730 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(234772), // Rule ID 11458 //
     /* 234735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 234743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 234762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234770 */     GIR_RootConstrainSelectedInstOperands,
     /* 234771 */     // GIR_Coverage, 11458,
     /* 234771 */     GIR_EraseRootFromParent_Done,
     /* 234772 */   // Label 4680: @234772
     /* 234772 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(234814), // Rule ID 11459 //
     /* 234777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 234785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234801 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 234804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234812 */     GIR_RootConstrainSelectedInstOperands,
     /* 234813 */     // GIR_Coverage, 11459,
     /* 234813 */     GIR_EraseRootFromParent_Done,
     /* 234814 */   // Label 4681: @234814
     /* 234814 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(234856), // Rule ID 11460 //
     /* 234819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 234827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234843 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 234846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234854 */     GIR_RootConstrainSelectedInstOperands,
     /* 234855 */     // GIR_Coverage, 11460,
     /* 234855 */     GIR_EraseRootFromParent_Done,
     /* 234856 */   // Label 4682: @234856
     /* 234856 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(234898), // Rule ID 11462 //
     /* 234861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 234869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234885 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 234888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234896 */     GIR_RootConstrainSelectedInstOperands,
     /* 234897 */     // GIR_Coverage, 11462,
     /* 234897 */     GIR_EraseRootFromParent_Done,
     /* 234898 */   // Label 4683: @234898
     /* 234898 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(234940), // Rule ID 11464 //
     /* 234903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 234911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 234930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234938 */     GIR_RootConstrainSelectedInstOperands,
     /* 234939 */     // GIR_Coverage, 11464,
     /* 234939 */     GIR_EraseRootFromParent_Done,
     /* 234940 */   // Label 4684: @234940
     /* 234940 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(234982), // Rule ID 11466 //
     /* 234945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 234953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 234972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234980 */     GIR_RootConstrainSelectedInstOperands,
     /* 234981 */     // GIR_Coverage, 11466,
     /* 234981 */     GIR_EraseRootFromParent_Done,
     /* 234982 */   // Label 4685: @234982
     /* 234982 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(235024), // Rule ID 11468 //
     /* 234987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 234995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235011 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 235014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235022 */     GIR_RootConstrainSelectedInstOperands,
     /* 235023 */     // GIR_Coverage, 11468,
     /* 235023 */     GIR_EraseRootFromParent_Done,
     /* 235024 */   // Label 4686: @235024
     /* 235024 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(235066), // Rule ID 11470 //
     /* 235029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 235037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235053 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 235056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235064 */     GIR_RootConstrainSelectedInstOperands,
     /* 235065 */     // GIR_Coverage, 11470,
     /* 235065 */     GIR_EraseRootFromParent_Done,
     /* 235066 */   // Label 4687: @235066
     /* 235066 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(235108), // Rule ID 11472 //
     /* 235071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 235079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 235098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235106 */     GIR_RootConstrainSelectedInstOperands,
     /* 235107 */     // GIR_Coverage, 11472,
     /* 235107 */     GIR_EraseRootFromParent_Done,
     /* 235108 */   // Label 4688: @235108
     /* 235108 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(235150), // Rule ID 11474 //
     /* 235113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 235121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235137 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 235140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235148 */     GIR_RootConstrainSelectedInstOperands,
     /* 235149 */     // GIR_Coverage, 11474,
     /* 235149 */     GIR_EraseRootFromParent_Done,
     /* 235150 */   // Label 4689: @235150
     /* 235150 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(235192), // Rule ID 11476 //
     /* 235155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 235163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235179 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1721:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 235182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235190 */     GIR_RootConstrainSelectedInstOperands,
     /* 235191 */     // GIR_Coverage, 11476,
     /* 235191 */     GIR_EraseRootFromParent_Done,
     /* 235192 */   // Label 4690: @235192
     /* 235192 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(235234), // Rule ID 11477 //
     /* 235197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 235205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1721:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 235224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235232 */     GIR_RootConstrainSelectedInstOperands,
     /* 235233 */     // GIR_Coverage, 11477,
     /* 235233 */     GIR_EraseRootFromParent_Done,
     /* 235234 */   // Label 4691: @235234
     /* 235234 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(235276), // Rule ID 11478 //
     /* 235239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 235247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 235266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235274 */     GIR_RootConstrainSelectedInstOperands,
     /* 235275 */     // GIR_Coverage, 11478,
     /* 235275 */     GIR_EraseRootFromParent_Done,
     /* 235276 */   // Label 4692: @235276
     /* 235276 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(235318), // Rule ID 11479 //
     /* 235281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 235289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1721:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 235308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235316 */     GIR_RootConstrainSelectedInstOperands,
     /* 235317 */     // GIR_Coverage, 11479,
     /* 235317 */     GIR_EraseRootFromParent_Done,
     /* 235318 */   // Label 4693: @235318
     /* 235318 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(235360), // Rule ID 11480 //
     /* 235323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 235331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235347 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1962:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 235350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235358 */     GIR_RootConstrainSelectedInstOperands,
     /* 235359 */     // GIR_Coverage, 11480,
     /* 235359 */     GIR_EraseRootFromParent_Done,
     /* 235360 */   // Label 4694: @235360
     /* 235360 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(235402), // Rule ID 11481 //
     /* 235365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 235373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1962:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 235392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235400 */     GIR_RootConstrainSelectedInstOperands,
     /* 235401 */     // GIR_Coverage, 11481,
     /* 235401 */     GIR_EraseRootFromParent_Done,
     /* 235402 */   // Label 4695: @235402
     /* 235402 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(235444), // Rule ID 11482 //
     /* 235407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 235415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 235434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235442 */     GIR_RootConstrainSelectedInstOperands,
     /* 235443 */     // GIR_Coverage, 11482,
     /* 235443 */     GIR_EraseRootFromParent_Done,
     /* 235444 */   // Label 4696: @235444
     /* 235444 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(235486), // Rule ID 11483 //
     /* 235449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 235457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 235476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235484 */     GIR_RootConstrainSelectedInstOperands,
     /* 235485 */     // GIR_Coverage, 11483,
     /* 235485 */     GIR_EraseRootFromParent_Done,
     /* 235486 */   // Label 4697: @235486
     /* 235486 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(235528), // Rule ID 11484 //
     /* 235491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 235499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 235518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235526 */     GIR_RootConstrainSelectedInstOperands,
     /* 235527 */     // GIR_Coverage, 11484,
     /* 235527 */     GIR_EraseRootFromParent_Done,
     /* 235528 */   // Label 4698: @235528
     /* 235528 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(235570), // Rule ID 11485 //
     /* 235533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 235541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 235560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235568 */     GIR_RootConstrainSelectedInstOperands,
     /* 235569 */     // GIR_Coverage, 11485,
     /* 235569 */     GIR_EraseRootFromParent_Done,
     /* 235570 */   // Label 4699: @235570
     /* 235570 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(235612), // Rule ID 11486 //
     /* 235575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 235583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235599 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 235602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235610 */     GIR_RootConstrainSelectedInstOperands,
     /* 235611 */     // GIR_Coverage, 11486,
     /* 235611 */     GIR_EraseRootFromParent_Done,
     /* 235612 */   // Label 4700: @235612
     /* 235612 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(235654), // Rule ID 11487 //
     /* 235617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 235625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1252:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 235644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235652 */     GIR_RootConstrainSelectedInstOperands,
     /* 235653 */     // GIR_Coverage, 11487,
     /* 235653 */     GIR_EraseRootFromParent_Done,
     /* 235654 */   // Label 4701: @235654
     /* 235654 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(235696), // Rule ID 11488 //
     /* 235659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 235667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235683 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1252:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 235686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235694 */     GIR_RootConstrainSelectedInstOperands,
     /* 235695 */     // GIR_Coverage, 11488,
     /* 235695 */     GIR_EraseRootFromParent_Done,
     /* 235696 */   // Label 4702: @235696
     /* 235696 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(235738), // Rule ID 11489 //
     /* 235701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 235709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235725 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 235728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235736 */     GIR_RootConstrainSelectedInstOperands,
     /* 235737 */     // GIR_Coverage, 11489,
     /* 235737 */     GIR_EraseRootFromParent_Done,
     /* 235738 */   // Label 4703: @235738
     /* 235738 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(235780), // Rule ID 11490 //
     /* 235743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 235751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235767 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1252:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 235770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235778 */     GIR_RootConstrainSelectedInstOperands,
     /* 235779 */     // GIR_Coverage, 11490,
     /* 235779 */     GIR_EraseRootFromParent_Done,
     /* 235780 */   // Label 4704: @235780
     /* 235780 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(235822), // Rule ID 11491 //
     /* 235785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 235793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235809 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 235812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235820 */     GIR_RootConstrainSelectedInstOperands,
     /* 235821 */     // GIR_Coverage, 11491,
     /* 235821 */     GIR_EraseRootFromParent_Done,
     /* 235822 */   // Label 4705: @235822
     /* 235822 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(235864), // Rule ID 11492 //
     /* 235827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 235835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 235854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235862 */     GIR_RootConstrainSelectedInstOperands,
     /* 235863 */     // GIR_Coverage, 11492,
     /* 235863 */     GIR_EraseRootFromParent_Done,
     /* 235864 */   // Label 4706: @235864
     /* 235864 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(235906), // Rule ID 11493 //
     /* 235869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 235877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 235896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235904 */     GIR_RootConstrainSelectedInstOperands,
     /* 235905 */     // GIR_Coverage, 11493,
     /* 235905 */     GIR_EraseRootFromParent_Done,
     /* 235906 */   // Label 4707: @235906
     /* 235906 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(235948), // Rule ID 11494 //
     /* 235911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 235919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235935 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 235938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235946 */     GIR_RootConstrainSelectedInstOperands,
     /* 235947 */     // GIR_Coverage, 11494,
     /* 235947 */     GIR_EraseRootFromParent_Done,
     /* 235948 */   // Label 4708: @235948
     /* 235948 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(235990), // Rule ID 11495 //
     /* 235953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 235961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235977 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 235980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235988 */     GIR_RootConstrainSelectedInstOperands,
     /* 235989 */     // GIR_Coverage, 11495,
     /* 235989 */     GIR_EraseRootFromParent_Done,
     /* 235990 */   // Label 4709: @235990
     /* 235990 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(236032), // Rule ID 11496 //
     /* 235995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 236003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 236022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236030 */     GIR_RootConstrainSelectedInstOperands,
     /* 236031 */     // GIR_Coverage, 11496,
     /* 236031 */     GIR_EraseRootFromParent_Done,
     /* 236032 */   // Label 4710: @236032
     /* 236032 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(236074), // Rule ID 11497 //
     /* 236037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 236045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 236064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236072 */     GIR_RootConstrainSelectedInstOperands,
     /* 236073 */     // GIR_Coverage, 11497,
     /* 236073 */     GIR_EraseRootFromParent_Done,
     /* 236074 */   // Label 4711: @236074
     /* 236074 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(236116), // Rule ID 11498 //
     /* 236079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 236087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236103 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 236106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236114 */     GIR_RootConstrainSelectedInstOperands,
     /* 236115 */     // GIR_Coverage, 11498,
     /* 236115 */     GIR_EraseRootFromParent_Done,
     /* 236116 */   // Label 4712: @236116
     /* 236116 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(236158), // Rule ID 11499 //
     /* 236121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 236129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236145 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 236148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236156 */     GIR_RootConstrainSelectedInstOperands,
     /* 236157 */     // GIR_Coverage, 11499,
     /* 236157 */     GIR_EraseRootFromParent_Done,
     /* 236158 */   // Label 4713: @236158
     /* 236158 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(236200), // Rule ID 11500 //
     /* 236163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 236171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 236190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236198 */     GIR_RootConstrainSelectedInstOperands,
     /* 236199 */     // GIR_Coverage, 11500,
     /* 236199 */     GIR_EraseRootFromParent_Done,
     /* 236200 */   // Label 4714: @236200
     /* 236200 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(236242), // Rule ID 11501 //
     /* 236205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 236213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236229 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 236232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236240 */     GIR_RootConstrainSelectedInstOperands,
     /* 236241 */     // GIR_Coverage, 11501,
     /* 236241 */     GIR_EraseRootFromParent_Done,
     /* 236242 */   // Label 4715: @236242
     /* 236242 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(236284), // Rule ID 11502 //
     /* 236247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 236255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236271 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 236274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236282 */     GIR_RootConstrainSelectedInstOperands,
     /* 236283 */     // GIR_Coverage, 11502,
     /* 236283 */     GIR_EraseRootFromParent_Done,
     /* 236284 */   // Label 4716: @236284
     /* 236284 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(236326), // Rule ID 11503 //
     /* 236289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 236297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236313 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1978:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 236316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236324 */     GIR_RootConstrainSelectedInstOperands,
     /* 236325 */     // GIR_Coverage, 11503,
     /* 236325 */     GIR_EraseRootFromParent_Done,
     /* 236326 */   // Label 4717: @236326
     /* 236326 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(236368), // Rule ID 11504 //
     /* 236331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 236339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1978:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 236358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236366 */     GIR_RootConstrainSelectedInstOperands,
     /* 236367 */     // GIR_Coverage, 11504,
     /* 236367 */     GIR_EraseRootFromParent_Done,
     /* 236368 */   // Label 4718: @236368
     /* 236368 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(236410), // Rule ID 11505 //
     /* 236373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 236381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 236400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236408 */     GIR_RootConstrainSelectedInstOperands,
     /* 236409 */     // GIR_Coverage, 11505,
     /* 236409 */     GIR_EraseRootFromParent_Done,
     /* 236410 */   // Label 4719: @236410
     /* 236410 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(236452), // Rule ID 11506 //
     /* 236415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 236423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236439 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 236442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236450 */     GIR_RootConstrainSelectedInstOperands,
     /* 236451 */     // GIR_Coverage, 11506,
     /* 236451 */     GIR_EraseRootFromParent_Done,
     /* 236452 */   // Label 4720: @236452
     /* 236452 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(236494), // Rule ID 11507 //
     /* 236457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 236465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 236484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236492 */     GIR_RootConstrainSelectedInstOperands,
     /* 236493 */     // GIR_Coverage, 11507,
     /* 236493 */     GIR_EraseRootFromParent_Done,
     /* 236494 */   // Label 4721: @236494
     /* 236494 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(236536), // Rule ID 11518 //
     /* 236499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 236507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 236516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236523 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 236526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236534 */     GIR_RootConstrainSelectedInstOperands,
     /* 236535 */     // GIR_Coverage, 11518,
     /* 236535 */     GIR_EraseRootFromParent_Done,
     /* 236536 */   // Label 4722: @236536
     /* 236536 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(236578), // Rule ID 11519 //
     /* 236541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 236549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 236558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236565 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 236568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236576 */     GIR_RootConstrainSelectedInstOperands,
     /* 236577 */     // GIR_Coverage, 11519,
     /* 236577 */     GIR_EraseRootFromParent_Done,
     /* 236578 */   // Label 4723: @236578
     /* 236578 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(236620), // Rule ID 11520 //
     /* 236583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 236591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236607 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 236610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236618 */     GIR_RootConstrainSelectedInstOperands,
     /* 236619 */     // GIR_Coverage, 11520,
     /* 236619 */     GIR_EraseRootFromParent_Done,
     /* 236620 */   // Label 4724: @236620
     /* 236620 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(236662), // Rule ID 11521 //
     /* 236625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 236633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 236652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236660 */     GIR_RootConstrainSelectedInstOperands,
     /* 236661 */     // GIR_Coverage, 11521,
     /* 236661 */     GIR_EraseRootFromParent_Done,
     /* 236662 */   // Label 4725: @236662
     /* 236662 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(236704), // Rule ID 11530 //
     /* 236667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 236675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236691 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 236694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236702 */     GIR_RootConstrainSelectedInstOperands,
     /* 236703 */     // GIR_Coverage, 11530,
     /* 236703 */     GIR_EraseRootFromParent_Done,
     /* 236704 */   // Label 4726: @236704
     /* 236704 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(236746), // Rule ID 11531 //
     /* 236709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 236717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236733 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 236736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236744 */     GIR_RootConstrainSelectedInstOperands,
     /* 236745 */     // GIR_Coverage, 11531,
     /* 236745 */     GIR_EraseRootFromParent_Done,
     /* 236746 */   // Label 4727: @236746
     /* 236746 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(236788), // Rule ID 11532 //
     /* 236751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 236759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 236778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236786 */     GIR_RootConstrainSelectedInstOperands,
     /* 236787 */     // GIR_Coverage, 11532,
     /* 236787 */     GIR_EraseRootFromParent_Done,
     /* 236788 */   // Label 4728: @236788
     /* 236788 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(236830), // Rule ID 11533 //
     /* 236793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 236801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236817 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 236820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236828 */     GIR_RootConstrainSelectedInstOperands,
     /* 236829 */     // GIR_Coverage, 11533,
     /* 236829 */     GIR_EraseRootFromParent_Done,
     /* 236830 */   // Label 4729: @236830
     /* 236830 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(236872), // Rule ID 11534 //
     /* 236835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 236843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1996:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 236862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236870 */     GIR_RootConstrainSelectedInstOperands,
     /* 236871 */     // GIR_Coverage, 11534,
     /* 236871 */     GIR_EraseRootFromParent_Done,
     /* 236872 */   // Label 4730: @236872
     /* 236872 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(236914), // Rule ID 11535 //
     /* 236877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 236885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1996:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 236904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236912 */     GIR_RootConstrainSelectedInstOperands,
     /* 236913 */     // GIR_Coverage, 11535,
     /* 236913 */     GIR_EraseRootFromParent_Done,
     /* 236914 */   // Label 4731: @236914
     /* 236914 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(236956), // Rule ID 11536 //
     /* 236919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 236927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 236946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236954 */     GIR_RootConstrainSelectedInstOperands,
     /* 236955 */     // GIR_Coverage, 11536,
     /* 236955 */     GIR_EraseRootFromParent_Done,
     /* 236956 */   // Label 4732: @236956
     /* 236956 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(236998), // Rule ID 11537 //
     /* 236961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 236969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236985 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 236988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236996 */     GIR_RootConstrainSelectedInstOperands,
     /* 236997 */     // GIR_Coverage, 11537,
     /* 236997 */     GIR_EraseRootFromParent_Done,
     /* 236998 */   // Label 4733: @236998
     /* 236998 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(237040), // Rule ID 11538 //
     /* 237003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 237011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 237030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237038 */     GIR_RootConstrainSelectedInstOperands,
     /* 237039 */     // GIR_Coverage, 11538,
     /* 237039 */     GIR_EraseRootFromParent_Done,
     /* 237040 */   // Label 4734: @237040
     /* 237040 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(237082), // Rule ID 11539 //
     /* 237045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 237053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 237072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237080 */     GIR_RootConstrainSelectedInstOperands,
     /* 237081 */     // GIR_Coverage, 11539,
     /* 237081 */     GIR_EraseRootFromParent_Done,
     /* 237082 */   // Label 4735: @237082
     /* 237082 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(237124), // Rule ID 11540 //
     /* 237087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 237095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 237114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237122 */     GIR_RootConstrainSelectedInstOperands,
     /* 237123 */     // GIR_Coverage, 11540,
     /* 237123 */     GIR_EraseRootFromParent_Done,
     /* 237124 */   // Label 4736: @237124
     /* 237124 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(237166), // Rule ID 11541 //
     /* 237129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 237137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237153 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1847:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 237156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237164 */     GIR_RootConstrainSelectedInstOperands,
     /* 237165 */     // GIR_Coverage, 11541,
     /* 237165 */     GIR_EraseRootFromParent_Done,
     /* 237166 */   // Label 4737: @237166
     /* 237166 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(237208), // Rule ID 11542 //
     /* 237171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 237179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237195 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 237198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237206 */     GIR_RootConstrainSelectedInstOperands,
     /* 237207 */     // GIR_Coverage, 11542,
     /* 237207 */     GIR_EraseRootFromParent_Done,
     /* 237208 */   // Label 4738: @237208
     /* 237208 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(237250), // Rule ID 11543 //
     /* 237213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 237221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237237 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 237240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237248 */     GIR_RootConstrainSelectedInstOperands,
     /* 237249 */     // GIR_Coverage, 11543,
     /* 237249 */     GIR_EraseRootFromParent_Done,
     /* 237250 */   // Label 4739: @237250
     /* 237250 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(237292), // Rule ID 11544 //
     /* 237255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 237263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 237282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237290 */     GIR_RootConstrainSelectedInstOperands,
     /* 237291 */     // GIR_Coverage, 11544,
     /* 237291 */     GIR_EraseRootFromParent_Done,
     /* 237292 */   // Label 4740: @237292
     /* 237292 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(237334), // Rule ID 11545 //
     /* 237297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 237305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 237324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237332 */     GIR_RootConstrainSelectedInstOperands,
     /* 237333 */     // GIR_Coverage, 11545,
     /* 237333 */     GIR_EraseRootFromParent_Done,
     /* 237334 */   // Label 4741: @237334
     /* 237334 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(237376), // Rule ID 11546 //
     /* 237339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 237347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 237366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237374 */     GIR_RootConstrainSelectedInstOperands,
     /* 237375 */     // GIR_Coverage, 11546,
     /* 237375 */     GIR_EraseRootFromParent_Done,
     /* 237376 */   // Label 4742: @237376
     /* 237376 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(237418), // Rule ID 11547 //
     /* 237381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 237389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237405 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 237408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237416 */     GIR_RootConstrainSelectedInstOperands,
     /* 237417 */     // GIR_Coverage, 11547,
     /* 237417 */     GIR_EraseRootFromParent_Done,
     /* 237418 */   // Label 4743: @237418
     /* 237418 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(237460), // Rule ID 11548 //
     /* 237423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 237431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 237450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237458 */     GIR_RootConstrainSelectedInstOperands,
     /* 237459 */     // GIR_Coverage, 11548,
     /* 237459 */     GIR_EraseRootFromParent_Done,
     /* 237460 */   // Label 4744: @237460
     /* 237460 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(237502), // Rule ID 11549 //
     /* 237465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 237473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1911:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 237492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237500 */     GIR_RootConstrainSelectedInstOperands,
     /* 237501 */     // GIR_Coverage, 11549,
     /* 237501 */     GIR_EraseRootFromParent_Done,
     /* 237502 */   // Label 4745: @237502
     /* 237502 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(237544), // Rule ID 11550 //
     /* 237507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 237515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237531 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2061:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 237534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237542 */     GIR_RootConstrainSelectedInstOperands,
     /* 237543 */     // GIR_Coverage, 11550,
     /* 237543 */     GIR_EraseRootFromParent_Done,
     /* 237544 */   // Label 4746: @237544
     /* 237544 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(237586), // Rule ID 11551 //
     /* 237549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 237557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2061:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 237576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237584 */     GIR_RootConstrainSelectedInstOperands,
     /* 237585 */     // GIR_Coverage, 11551,
     /* 237585 */     GIR_EraseRootFromParent_Done,
     /* 237586 */   // Label 4747: @237586
     /* 237586 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(237628), // Rule ID 11552 //
     /* 237591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 237599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237615 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 237618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237626 */     GIR_RootConstrainSelectedInstOperands,
     /* 237627 */     // GIR_Coverage, 11552,
     /* 237627 */     GIR_EraseRootFromParent_Done,
     /* 237628 */   // Label 4748: @237628
     /* 237628 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(237670), // Rule ID 11553 //
     /* 237633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 237641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2061:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 237660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237668 */     GIR_RootConstrainSelectedInstOperands,
     /* 237669 */     // GIR_Coverage, 11553,
     /* 237669 */     GIR_EraseRootFromParent_Done,
     /* 237670 */   // Label 4749: @237670
     /* 237670 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237712), // Rule ID 11554 //
     /* 237675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 237683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 237702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237710 */     GIR_RootConstrainSelectedInstOperands,
     /* 237711 */     // GIR_Coverage, 11554,
     /* 237711 */     GIR_EraseRootFromParent_Done,
     /* 237712 */   // Label 4750: @237712
     /* 237712 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237754), // Rule ID 11555 //
     /* 237717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 237725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 237744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237752 */     GIR_RootConstrainSelectedInstOperands,
     /* 237753 */     // GIR_Coverage, 11555,
     /* 237753 */     GIR_EraseRootFromParent_Done,
     /* 237754 */   // Label 4751: @237754
     /* 237754 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237796), // Rule ID 11556 //
     /* 237759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 237767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 237786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237794 */     GIR_RootConstrainSelectedInstOperands,
     /* 237795 */     // GIR_Coverage, 11556,
     /* 237795 */     GIR_EraseRootFromParent_Done,
     /* 237796 */   // Label 4752: @237796
     /* 237796 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237838), // Rule ID 11557 //
     /* 237801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 237809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237825 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1850:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 237828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237836 */     GIR_RootConstrainSelectedInstOperands,
     /* 237837 */     // GIR_Coverage, 11557,
     /* 237837 */     GIR_EraseRootFromParent_Done,
     /* 237838 */   // Label 4753: @237838
     /* 237838 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237880), // Rule ID 11558 //
     /* 237843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 237851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 237870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237878 */     GIR_RootConstrainSelectedInstOperands,
     /* 237879 */     // GIR_Coverage, 11558,
     /* 237879 */     GIR_EraseRootFromParent_Done,
     /* 237880 */   // Label 4754: @237880
     /* 237880 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237922), // Rule ID 11559 //
     /* 237885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 237893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 237912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237920 */     GIR_RootConstrainSelectedInstOperands,
     /* 237921 */     // GIR_Coverage, 11559,
     /* 237921 */     GIR_EraseRootFromParent_Done,
     /* 237922 */   // Label 4755: @237922
     /* 237922 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237964), // Rule ID 11560 //
     /* 237927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 237935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 237954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237962 */     GIR_RootConstrainSelectedInstOperands,
     /* 237963 */     // GIR_Coverage, 11560,
     /* 237963 */     GIR_EraseRootFromParent_Done,
     /* 237964 */   // Label 4756: @237964
     /* 237964 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(238006), // Rule ID 11561 //
     /* 237969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 237977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2043:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 237996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238004 */     GIR_RootConstrainSelectedInstOperands,
     /* 238005 */     // GIR_Coverage, 11561,
     /* 238005 */     GIR_EraseRootFromParent_Done,
     /* 238006 */   // Label 4757: @238006
     /* 238006 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(238048), // Rule ID 11562 //
     /* 238011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 238019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 238038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238046 */     GIR_RootConstrainSelectedInstOperands,
     /* 238047 */     // GIR_Coverage, 11562,
     /* 238047 */     GIR_EraseRootFromParent_Done,
     /* 238048 */   // Label 4758: @238048
     /* 238048 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(238090), // Rule ID 11563 //
     /* 238053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 238061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 238080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238088 */     GIR_RootConstrainSelectedInstOperands,
     /* 238089 */     // GIR_Coverage, 11563,
     /* 238089 */     GIR_EraseRootFromParent_Done,
     /* 238090 */   // Label 4759: @238090
     /* 238090 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(238132), // Rule ID 11564 //
     /* 238095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 238103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 238122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238130 */     GIR_RootConstrainSelectedInstOperands,
     /* 238131 */     // GIR_Coverage, 11564,
     /* 238131 */     GIR_EraseRootFromParent_Done,
     /* 238132 */   // Label 4760: @238132
     /* 238132 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(238174), // Rule ID 11565 //
     /* 238137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 238145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 238164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238172 */     GIR_RootConstrainSelectedInstOperands,
     /* 238173 */     // GIR_Coverage, 11565,
     /* 238173 */     GIR_EraseRootFromParent_Done,
     /* 238174 */   // Label 4761: @238174
     /* 238174 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(238216), // Rule ID 11566 //
     /* 238179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 238187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238203 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 238206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238214 */     GIR_RootConstrainSelectedInstOperands,
     /* 238215 */     // GIR_Coverage, 11566,
     /* 238215 */     GIR_EraseRootFromParent_Done,
     /* 238216 */   // Label 4762: @238216
     /* 238216 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(238258), // Rule ID 11567 //
     /* 238221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 238229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 238248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238256 */     GIR_RootConstrainSelectedInstOperands,
     /* 238257 */     // GIR_Coverage, 11567,
     /* 238257 */     GIR_EraseRootFromParent_Done,
     /* 238258 */   // Label 4763: @238258
     /* 238258 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(238300), // Rule ID 11568 //
     /* 238263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 238271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 238290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238298 */     GIR_RootConstrainSelectedInstOperands,
     /* 238299 */     // GIR_Coverage, 11568,
     /* 238299 */     GIR_EraseRootFromParent_Done,
     /* 238300 */   // Label 4764: @238300
     /* 238300 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(238342), // Rule ID 11569 //
     /* 238305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 238313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 238332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238340 */     GIR_RootConstrainSelectedInstOperands,
     /* 238341 */     // GIR_Coverage, 11569,
     /* 238341 */     GIR_EraseRootFromParent_Done,
     /* 238342 */   // Label 4765: @238342
     /* 238342 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(238384), // Rule ID 11570 //
     /* 238347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 238355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 238374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238382 */     GIR_RootConstrainSelectedInstOperands,
     /* 238383 */     // GIR_Coverage, 11570,
     /* 238383 */     GIR_EraseRootFromParent_Done,
     /* 238384 */   // Label 4766: @238384
     /* 238384 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(238426), // Rule ID 11571 //
     /* 238389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 238397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238413 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 238416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238424 */     GIR_RootConstrainSelectedInstOperands,
     /* 238425 */     // GIR_Coverage, 11571,
     /* 238425 */     GIR_EraseRootFromParent_Done,
     /* 238426 */   // Label 4767: @238426
     /* 238426 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238468), // Rule ID 11572 //
     /* 238431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 238439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238455 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 238458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238466 */     GIR_RootConstrainSelectedInstOperands,
     /* 238467 */     // GIR_Coverage, 11572,
     /* 238467 */     GIR_EraseRootFromParent_Done,
     /* 238468 */   // Label 4768: @238468
     /* 238468 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238510), // Rule ID 11573 //
     /* 238473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 238481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 238500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238508 */     GIR_RootConstrainSelectedInstOperands,
     /* 238509 */     // GIR_Coverage, 11573,
     /* 238509 */     GIR_EraseRootFromParent_Done,
     /* 238510 */   // Label 4769: @238510
     /* 238510 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238552), // Rule ID 11574 //
     /* 238515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 238523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 238542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238550 */     GIR_RootConstrainSelectedInstOperands,
     /* 238551 */     // GIR_Coverage, 11574,
     /* 238551 */     GIR_EraseRootFromParent_Done,
     /* 238552 */   // Label 4770: @238552
     /* 238552 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238594), // Rule ID 11575 //
     /* 238557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 238565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 238584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238592 */     GIR_RootConstrainSelectedInstOperands,
     /* 238593 */     // GIR_Coverage, 11575,
     /* 238593 */     GIR_EraseRootFromParent_Done,
     /* 238594 */   // Label 4771: @238594
     /* 238594 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238636), // Rule ID 11576 //
     /* 238599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 238607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 238626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238634 */     GIR_RootConstrainSelectedInstOperands,
     /* 238635 */     // GIR_Coverage, 11576,
     /* 238635 */     GIR_EraseRootFromParent_Done,
     /* 238636 */   // Label 4772: @238636
     /* 238636 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238678), // Rule ID 11577 //
     /* 238641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 238649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2037:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 238668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238676 */     GIR_RootConstrainSelectedInstOperands,
     /* 238677 */     // GIR_Coverage, 11577,
     /* 238677 */     GIR_EraseRootFromParent_Done,
     /* 238678 */   // Label 4773: @238678
     /* 238678 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238720), // Rule ID 11578 //
     /* 238683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 238691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 238710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238718 */     GIR_RootConstrainSelectedInstOperands,
     /* 238719 */     // GIR_Coverage, 11578,
     /* 238719 */     GIR_EraseRootFromParent_Done,
     /* 238720 */   // Label 4774: @238720
     /* 238720 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238762), // Rule ID 11579 //
     /* 238725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 238733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238749 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 238752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238760 */     GIR_RootConstrainSelectedInstOperands,
     /* 238761 */     // GIR_Coverage, 11579,
     /* 238761 */     GIR_EraseRootFromParent_Done,
     /* 238762 */   // Label 4775: @238762
     /* 238762 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238804), // Rule ID 11580 //
     /* 238767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 238775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 238794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238802 */     GIR_RootConstrainSelectedInstOperands,
     /* 238803 */     // GIR_Coverage, 11580,
     /* 238803 */     GIR_EraseRootFromParent_Done,
     /* 238804 */   // Label 4776: @238804
     /* 238804 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238846), // Rule ID 11581 //
     /* 238809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 238817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238833 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 238836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238844 */     GIR_RootConstrainSelectedInstOperands,
     /* 238845 */     // GIR_Coverage, 11581,
     /* 238845 */     GIR_EraseRootFromParent_Done,
     /* 238846 */   // Label 4777: @238846
     /* 238846 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238888), // Rule ID 11582 //
     /* 238851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 238859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238875 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 238878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238886 */     GIR_RootConstrainSelectedInstOperands,
     /* 238887 */     // GIR_Coverage, 11582,
     /* 238887 */     GIR_EraseRootFromParent_Done,
     /* 238888 */   // Label 4778: @238888
     /* 238888 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238930), // Rule ID 11583 //
     /* 238893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 238901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 238920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238928 */     GIR_RootConstrainSelectedInstOperands,
     /* 238929 */     // GIR_Coverage, 11583,
     /* 238929 */     GIR_EraseRootFromParent_Done,
     /* 238930 */   // Label 4779: @238930
     /* 238930 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238972), // Rule ID 11584 //
     /* 238935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 238943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 238962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238970 */     GIR_RootConstrainSelectedInstOperands,
     /* 238971 */     // GIR_Coverage, 11584,
     /* 238971 */     GIR_EraseRootFromParent_Done,
     /* 238972 */   // Label 4780: @238972
     /* 238972 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(239014), // Rule ID 11585 //
     /* 238977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 238985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239001 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2030:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 239004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239012 */     GIR_RootConstrainSelectedInstOperands,
     /* 239013 */     // GIR_Coverage, 11585,
     /* 239013 */     GIR_EraseRootFromParent_Done,
     /* 239014 */   // Label 4781: @239014
     /* 239014 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(239056), // Rule ID 11748 //
     /* 239019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 239027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1930:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 239046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239054 */     GIR_RootConstrainSelectedInstOperands,
     /* 239055 */     // GIR_Coverage, 11748,
     /* 239055 */     GIR_EraseRootFromParent_Done,
     /* 239056 */   // Label 4782: @239056
     /* 239056 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(239098), // Rule ID 11750 //
     /* 239061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 239069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 239088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239096 */     GIR_RootConstrainSelectedInstOperands,
     /* 239097 */     // GIR_Coverage, 11750,
     /* 239097 */     GIR_EraseRootFromParent_Done,
     /* 239098 */   // Label 4783: @239098
     /* 239098 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(239140), // Rule ID 11752 //
     /* 239103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 239111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 239130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239138 */     GIR_RootConstrainSelectedInstOperands,
     /* 239139 */     // GIR_Coverage, 11752,
     /* 239139 */     GIR_EraseRootFromParent_Done,
     /* 239140 */   // Label 4784: @239140
     /* 239140 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(239182), // Rule ID 11754 //
     /* 239145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 239153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 239172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239180 */     GIR_RootConstrainSelectedInstOperands,
     /* 239181 */     // GIR_Coverage, 11754,
     /* 239181 */     GIR_EraseRootFromParent_Done,
     /* 239182 */   // Label 4785: @239182
     /* 239182 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(239224), // Rule ID 11756 //
     /* 239187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 239195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 239214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239222 */     GIR_RootConstrainSelectedInstOperands,
     /* 239223 */     // GIR_Coverage, 11756,
     /* 239223 */     GIR_EraseRootFromParent_Done,
     /* 239224 */   // Label 4786: @239224
     /* 239224 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(239266), // Rule ID 11757 //
     /* 239229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 239237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 239256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239264 */     GIR_RootConstrainSelectedInstOperands,
     /* 239265 */     // GIR_Coverage, 11757,
     /* 239265 */     GIR_EraseRootFromParent_Done,
     /* 239266 */   // Label 4787: @239266
     /* 239266 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239308), // Rule ID 11758 //
     /* 239271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 239279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239295 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 239298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239306 */     GIR_RootConstrainSelectedInstOperands,
     /* 239307 */     // GIR_Coverage, 11758,
     /* 239307 */     GIR_EraseRootFromParent_Done,
     /* 239308 */   // Label 4788: @239308
     /* 239308 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239350), // Rule ID 11759 //
     /* 239313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 239321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 239340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239348 */     GIR_RootConstrainSelectedInstOperands,
     /* 239349 */     // GIR_Coverage, 11759,
     /* 239349 */     GIR_EraseRootFromParent_Done,
     /* 239350 */   // Label 4789: @239350
     /* 239350 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239392), // Rule ID 11760 //
     /* 239355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 239363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 239382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239390 */     GIR_RootConstrainSelectedInstOperands,
     /* 239391 */     // GIR_Coverage, 11760,
     /* 239391 */     GIR_EraseRootFromParent_Done,
     /* 239392 */   // Label 4790: @239392
     /* 239392 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239434), // Rule ID 11761 //
     /* 239397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 239405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 239424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239432 */     GIR_RootConstrainSelectedInstOperands,
     /* 239433 */     // GIR_Coverage, 11761,
     /* 239433 */     GIR_EraseRootFromParent_Done,
     /* 239434 */   // Label 4791: @239434
     /* 239434 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239476), // Rule ID 11762 //
     /* 239439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 239447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1932:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 239466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239474 */     GIR_RootConstrainSelectedInstOperands,
     /* 239475 */     // GIR_Coverage, 11762,
     /* 239475 */     GIR_EraseRootFromParent_Done,
     /* 239476 */   // Label 4792: @239476
     /* 239476 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239518), // Rule ID 11763 //
     /* 239481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 239489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1932:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 239508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239516 */     GIR_RootConstrainSelectedInstOperands,
     /* 239517 */     // GIR_Coverage, 11763,
     /* 239517 */     GIR_EraseRootFromParent_Done,
     /* 239518 */   // Label 4793: @239518
     /* 239518 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239560), // Rule ID 11764 //
     /* 239523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 239531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239547 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1932:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 239550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239558 */     GIR_RootConstrainSelectedInstOperands,
     /* 239559 */     // GIR_Coverage, 11764,
     /* 239559 */     GIR_EraseRootFromParent_Done,
     /* 239560 */   // Label 4794: @239560
     /* 239560 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239602), // Rule ID 11765 //
     /* 239565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 239573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1245:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 239592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239600 */     GIR_RootConstrainSelectedInstOperands,
     /* 239601 */     // GIR_Coverage, 11765,
     /* 239601 */     GIR_EraseRootFromParent_Done,
     /* 239602 */   // Label 4795: @239602
     /* 239602 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239644), // Rule ID 11766 //
     /* 239607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 239615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1245:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 239634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239642 */     GIR_RootConstrainSelectedInstOperands,
     /* 239643 */     // GIR_Coverage, 11766,
     /* 239643 */     GIR_EraseRootFromParent_Done,
     /* 239644 */   // Label 4796: @239644
     /* 239644 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239686), // Rule ID 11767 //
     /* 239649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 239657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 239676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239684 */     GIR_RootConstrainSelectedInstOperands,
     /* 239685 */     // GIR_Coverage, 11767,
     /* 239685 */     GIR_EraseRootFromParent_Done,
     /* 239686 */   // Label 4797: @239686
     /* 239686 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239728), // Rule ID 11768 //
     /* 239691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 239699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239715 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 239718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239726 */     GIR_RootConstrainSelectedInstOperands,
     /* 239727 */     // GIR_Coverage, 11768,
     /* 239727 */     GIR_EraseRootFromParent_Done,
     /* 239728 */   // Label 4798: @239728
     /* 239728 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239770), // Rule ID 11769 //
     /* 239733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 239741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 239760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239768 */     GIR_RootConstrainSelectedInstOperands,
     /* 239769 */     // GIR_Coverage, 11769,
     /* 239769 */     GIR_EraseRootFromParent_Done,
     /* 239770 */   // Label 4799: @239770
     /* 239770 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239812), // Rule ID 11770 //
     /* 239775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 239783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 239802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239810 */     GIR_RootConstrainSelectedInstOperands,
     /* 239811 */     // GIR_Coverage, 11770,
     /* 239811 */     GIR_EraseRootFromParent_Done,
     /* 239812 */   // Label 4800: @239812
     /* 239812 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239854), // Rule ID 11825 //
     /* 239817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 239825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239841 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 239844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239852 */     GIR_RootConstrainSelectedInstOperands,
     /* 239853 */     // GIR_Coverage, 11825,
     /* 239853 */     GIR_EraseRootFromParent_Done,
     /* 239854 */   // Label 4801: @239854
     /* 239854 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239896), // Rule ID 11826 //
     /* 239859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 239867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239883 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 239886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239894 */     GIR_RootConstrainSelectedInstOperands,
     /* 239895 */     // GIR_Coverage, 11826,
     /* 239895 */     GIR_EraseRootFromParent_Done,
     /* 239896 */   // Label 4802: @239896
     /* 239896 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239938), // Rule ID 11827 //
     /* 239901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 239909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 239928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239936 */     GIR_RootConstrainSelectedInstOperands,
     /* 239937 */     // GIR_Coverage, 11827,
     /* 239937 */     GIR_EraseRootFromParent_Done,
     /* 239938 */   // Label 4803: @239938
     /* 239938 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239980), // Rule ID 11828 //
     /* 239943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 239951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 239970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239978 */     GIR_RootConstrainSelectedInstOperands,
     /* 239979 */     // GIR_Coverage, 11828,
     /* 239979 */     GIR_EraseRootFromParent_Done,
     /* 239980 */   // Label 4804: @239980
     /* 239980 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(240022), // Rule ID 11829 //
     /* 239985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 239993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 240012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240020 */     GIR_RootConstrainSelectedInstOperands,
     /* 240021 */     // GIR_Coverage, 11829,
     /* 240021 */     GIR_EraseRootFromParent_Done,
     /* 240022 */   // Label 4805: @240022
     /* 240022 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(240064), // Rule ID 11830 //
     /* 240027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 240035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 240054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240062 */     GIR_RootConstrainSelectedInstOperands,
     /* 240063 */     // GIR_Coverage, 11830,
     /* 240063 */     GIR_EraseRootFromParent_Done,
     /* 240064 */   // Label 4806: @240064
     /* 240064 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(240106), // Rule ID 11831 //
     /* 240069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 240077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1679:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 240096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240104 */     GIR_RootConstrainSelectedInstOperands,
     /* 240105 */     // GIR_Coverage, 11831,
     /* 240105 */     GIR_EraseRootFromParent_Done,
     /* 240106 */   // Label 4807: @240106
     /* 240106 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(240148), // Rule ID 11832 //
     /* 240111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 240119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240135 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1679:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 240138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240146 */     GIR_RootConstrainSelectedInstOperands,
     /* 240147 */     // GIR_Coverage, 11832,
     /* 240147 */     GIR_EraseRootFromParent_Done,
     /* 240148 */   // Label 4808: @240148
     /* 240148 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(240190), // Rule ID 11833 //
     /* 240153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 240161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1679:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 240180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240188 */     GIR_RootConstrainSelectedInstOperands,
     /* 240189 */     // GIR_Coverage, 11833,
     /* 240189 */     GIR_EraseRootFromParent_Done,
     /* 240190 */   // Label 4809: @240190
     /* 240190 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(240235), // Rule ID 11846 //
     /* 240195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 240198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 240203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 240206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240219 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 240222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240233 */     GIR_RootConstrainSelectedInstOperands,
     /* 240234 */     // GIR_Coverage, 11846,
     /* 240234 */     GIR_EraseRootFromParent_Done,
     /* 240235 */   // Label 4810: @240235
     /* 240235 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(240280), // Rule ID 11847 //
     /* 240240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 240243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 240248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 240251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 240267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240278 */     GIR_RootConstrainSelectedInstOperands,
     /* 240279 */     // GIR_Coverage, 11847,
     /* 240279 */     GIR_EraseRootFromParent_Done,
     /* 240280 */   // Label 4811: @240280
     /* 240280 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240322), // Rule ID 11848 //
     /* 240285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 240293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240309 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1354:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 240312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240320 */     GIR_RootConstrainSelectedInstOperands,
     /* 240321 */     // GIR_Coverage, 11848,
     /* 240321 */     GIR_EraseRootFromParent_Done,
     /* 240322 */   // Label 4812: @240322
     /* 240322 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240364), // Rule ID 11849 //
     /* 240327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 240335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1354:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 240354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240362 */     GIR_RootConstrainSelectedInstOperands,
     /* 240363 */     // GIR_Coverage, 11849,
     /* 240363 */     GIR_EraseRootFromParent_Done,
     /* 240364 */   // Label 4813: @240364
     /* 240364 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240406), // Rule ID 11850 //
     /* 240369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 240377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1354:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 240396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240404 */     GIR_RootConstrainSelectedInstOperands,
     /* 240405 */     // GIR_Coverage, 11850,
     /* 240405 */     GIR_EraseRootFromParent_Done,
     /* 240406 */   // Label 4814: @240406
     /* 240406 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240448), // Rule ID 11851 //
     /* 240411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 240419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1354:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 240438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240446 */     GIR_RootConstrainSelectedInstOperands,
     /* 240447 */     // GIR_Coverage, 11851,
     /* 240447 */     GIR_EraseRootFromParent_Done,
     /* 240448 */   // Label 4815: @240448
     /* 240448 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240490), // Rule ID 11867 //
     /* 240453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 240461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240477 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1437:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 240480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240488 */     GIR_RootConstrainSelectedInstOperands,
     /* 240489 */     // GIR_Coverage, 11867,
     /* 240489 */     GIR_EraseRootFromParent_Done,
     /* 240490 */   // Label 4816: @240490
     /* 240490 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240532), // Rule ID 11868 //
     /* 240495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 240503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240519 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1437:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 240522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240530 */     GIR_RootConstrainSelectedInstOperands,
     /* 240531 */     // GIR_Coverage, 11868,
     /* 240531 */     GIR_EraseRootFromParent_Done,
     /* 240532 */   // Label 4817: @240532
     /* 240532 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240574), // Rule ID 11869 //
     /* 240537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 240545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240561 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1437:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 240564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240572 */     GIR_RootConstrainSelectedInstOperands,
     /* 240573 */     // GIR_Coverage, 11869,
     /* 240573 */     GIR_EraseRootFromParent_Done,
     /* 240574 */   // Label 4818: @240574
     /* 240574 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240616), // Rule ID 11870 //
     /* 240579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 240587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240603 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1455:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 240606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240614 */     GIR_RootConstrainSelectedInstOperands,
     /* 240615 */     // GIR_Coverage, 11870,
     /* 240615 */     GIR_EraseRootFromParent_Done,
     /* 240616 */   // Label 4819: @240616
     /* 240616 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240658), // Rule ID 11871 //
     /* 240621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 240629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240645 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1455:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 240648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240656 */     GIR_RootConstrainSelectedInstOperands,
     /* 240657 */     // GIR_Coverage, 11871,
     /* 240657 */     GIR_EraseRootFromParent_Done,
     /* 240658 */   // Label 4820: @240658
     /* 240658 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240700), // Rule ID 11872 //
     /* 240663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 240671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240687 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1455:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 240690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240698 */     GIR_RootConstrainSelectedInstOperands,
     /* 240699 */     // GIR_Coverage, 11872,
     /* 240699 */     GIR_EraseRootFromParent_Done,
     /* 240700 */   // Label 4821: @240700
     /* 240700 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240742), // Rule ID 11873 //
     /* 240705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 240713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240729 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1440:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 240732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240740 */     GIR_RootConstrainSelectedInstOperands,
     /* 240741 */     // GIR_Coverage, 11873,
     /* 240741 */     GIR_EraseRootFromParent_Done,
     /* 240742 */   // Label 4822: @240742
     /* 240742 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240784), // Rule ID 11874 //
     /* 240747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 240755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240771 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1440:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 240774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240782 */     GIR_RootConstrainSelectedInstOperands,
     /* 240783 */     // GIR_Coverage, 11874,
     /* 240783 */     GIR_EraseRootFromParent_Done,
     /* 240784 */   // Label 4823: @240784
     /* 240784 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240826), // Rule ID 11875 //
     /* 240789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 240797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240813 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1440:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 240816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240824 */     GIR_RootConstrainSelectedInstOperands,
     /* 240825 */     // GIR_Coverage, 11875,
     /* 240825 */     GIR_EraseRootFromParent_Done,
     /* 240826 */   // Label 4824: @240826
     /* 240826 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240868), // Rule ID 11876 //
     /* 240831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 240839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240855 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1458:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 240858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240866 */     GIR_RootConstrainSelectedInstOperands,
     /* 240867 */     // GIR_Coverage, 11876,
     /* 240867 */     GIR_EraseRootFromParent_Done,
     /* 240868 */   // Label 4825: @240868
     /* 240868 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240910), // Rule ID 11877 //
     /* 240873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 240881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240897 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 240900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240908 */     GIR_RootConstrainSelectedInstOperands,
     /* 240909 */     // GIR_Coverage, 11877,
     /* 240909 */     GIR_EraseRootFromParent_Done,
     /* 240910 */   // Label 4826: @240910
     /* 240910 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240952), // Rule ID 11878 //
     /* 240915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 240923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240939 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1458:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 240942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240950 */     GIR_RootConstrainSelectedInstOperands,
     /* 240951 */     // GIR_Coverage, 11878,
     /* 240951 */     GIR_EraseRootFromParent_Done,
     /* 240952 */   // Label 4827: @240952
     /* 240952 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240994), // Rule ID 11883 //
     /* 240957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 240965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240981 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 240984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240992 */     GIR_RootConstrainSelectedInstOperands,
     /* 240993 */     // GIR_Coverage, 11883,
     /* 240993 */     GIR_EraseRootFromParent_Done,
     /* 240994 */   // Label 4828: @240994
     /* 240994 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(241036), // Rule ID 11884 //
     /* 240999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 241007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241023 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 241026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241034 */     GIR_RootConstrainSelectedInstOperands,
     /* 241035 */     // GIR_Coverage, 11884,
     /* 241035 */     GIR_EraseRootFromParent_Done,
     /* 241036 */   // Label 4829: @241036
     /* 241036 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(241078), // Rule ID 11885 //
     /* 241041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 241049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241065 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 241068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241076 */     GIR_RootConstrainSelectedInstOperands,
     /* 241077 */     // GIR_Coverage, 11885,
     /* 241077 */     GIR_EraseRootFromParent_Done,
     /* 241078 */   // Label 4830: @241078
     /* 241078 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(241120), // Rule ID 11886 //
     /* 241083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 241091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241107 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 241110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241118 */     GIR_RootConstrainSelectedInstOperands,
     /* 241119 */     // GIR_Coverage, 11886,
     /* 241119 */     GIR_EraseRootFromParent_Done,
     /* 241120 */   // Label 4831: @241120
     /* 241120 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(241162), // Rule ID 11887 //
     /* 241125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 241133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241149 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1271:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 241152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241160 */     GIR_RootConstrainSelectedInstOperands,
     /* 241161 */     // GIR_Coverage, 11887,
     /* 241161 */     GIR_EraseRootFromParent_Done,
     /* 241162 */   // Label 4832: @241162
     /* 241162 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(241204), // Rule ID 11889 //
     /* 241167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 241175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241191 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1271:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 241194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241202 */     GIR_RootConstrainSelectedInstOperands,
     /* 241203 */     // GIR_Coverage, 11889,
     /* 241203 */     GIR_EraseRootFromParent_Done,
     /* 241204 */   // Label 4833: @241204
     /* 241204 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241246), // Rule ID 11891 //
     /* 241209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 241217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1271:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 241236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241244 */     GIR_RootConstrainSelectedInstOperands,
     /* 241245 */     // GIR_Coverage, 11891,
     /* 241245 */     GIR_EraseRootFromParent_Done,
     /* 241246 */   // Label 4834: @241246
     /* 241246 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241288), // Rule ID 11893 //
     /* 241251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 241259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1271:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 241278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241286 */     GIR_RootConstrainSelectedInstOperands,
     /* 241287 */     // GIR_Coverage, 11893,
     /* 241287 */     GIR_EraseRootFromParent_Done,
     /* 241288 */   // Label 4835: @241288
     /* 241288 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241330), // Rule ID 11895 //
     /* 241293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 241301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241317 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1300:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 241320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241328 */     GIR_RootConstrainSelectedInstOperands,
     /* 241329 */     // GIR_Coverage, 11895,
     /* 241329 */     GIR_EraseRootFromParent_Done,
     /* 241330 */   // Label 4836: @241330
     /* 241330 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241372), // Rule ID 11897 //
     /* 241335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 241343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241359 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1300:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 241362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241370 */     GIR_RootConstrainSelectedInstOperands,
     /* 241371 */     // GIR_Coverage, 11897,
     /* 241371 */     GIR_EraseRootFromParent_Done,
     /* 241372 */   // Label 4837: @241372
     /* 241372 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241414), // Rule ID 11899 //
     /* 241377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 241385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1300:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 241404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241412 */     GIR_RootConstrainSelectedInstOperands,
     /* 241413 */     // GIR_Coverage, 11899,
     /* 241413 */     GIR_EraseRootFromParent_Done,
     /* 241414 */   // Label 4838: @241414
     /* 241414 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241456), // Rule ID 11901 //
     /* 241419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 241427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1300:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 241446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241454 */     GIR_RootConstrainSelectedInstOperands,
     /* 241455 */     // GIR_Coverage, 11901,
     /* 241455 */     GIR_EraseRootFromParent_Done,
     /* 241456 */   // Label 4839: @241456
     /* 241456 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241498), // Rule ID 11903 //
     /* 241461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 241469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241485 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1301:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 241488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241496 */     GIR_RootConstrainSelectedInstOperands,
     /* 241497 */     // GIR_Coverage, 11903,
     /* 241497 */     GIR_EraseRootFromParent_Done,
     /* 241498 */   // Label 4840: @241498
     /* 241498 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241540), // Rule ID 11904 //
     /* 241503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 241511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241527 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1301:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 241530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241538 */     GIR_RootConstrainSelectedInstOperands,
     /* 241539 */     // GIR_Coverage, 11904,
     /* 241539 */     GIR_EraseRootFromParent_Done,
     /* 241540 */   // Label 4841: @241540
     /* 241540 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241582), // Rule ID 11905 //
     /* 241545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 241553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241569 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1301:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 241572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241580 */     GIR_RootConstrainSelectedInstOperands,
     /* 241581 */     // GIR_Coverage, 11905,
     /* 241581 */     GIR_EraseRootFromParent_Done,
     /* 241582 */   // Label 4842: @241582
     /* 241582 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241624), // Rule ID 11906 //
     /* 241587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 241595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241611 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1301:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 241614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241622 */     GIR_RootConstrainSelectedInstOperands,
     /* 241623 */     // GIR_Coverage, 11906,
     /* 241623 */     GIR_EraseRootFromParent_Done,
     /* 241624 */   // Label 4843: @241624
     /* 241624 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241666), // Rule ID 11907 //
     /* 241629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 241637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241653 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1302:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 241656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241664 */     GIR_RootConstrainSelectedInstOperands,
     /* 241665 */     // GIR_Coverage, 11907,
     /* 241665 */     GIR_EraseRootFromParent_Done,
     /* 241666 */   // Label 4844: @241666
     /* 241666 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241708), // Rule ID 11908 //
     /* 241671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 241679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241695 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1302:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 241698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241706 */     GIR_RootConstrainSelectedInstOperands,
     /* 241707 */     // GIR_Coverage, 11908,
     /* 241707 */     GIR_EraseRootFromParent_Done,
     /* 241708 */   // Label 4845: @241708
     /* 241708 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(241750), // Rule ID 11909 //
     /* 241713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 241721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241737 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1302:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 241740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241748 */     GIR_RootConstrainSelectedInstOperands,
     /* 241749 */     // GIR_Coverage, 11909,
     /* 241749 */     GIR_EraseRootFromParent_Done,
     /* 241750 */   // Label 4846: @241750
     /* 241750 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(241792), // Rule ID 11910 //
     /* 241755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 241763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241779 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1302:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 241782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241790 */     GIR_RootConstrainSelectedInstOperands,
     /* 241791 */     // GIR_Coverage, 11910,
     /* 241791 */     GIR_EraseRootFromParent_Done,
     /* 241792 */   // Label 4847: @241792
     /* 241792 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(241834), // Rule ID 11911 //
     /* 241797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 241805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241821 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1612:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 241824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241832 */     GIR_RootConstrainSelectedInstOperands,
     /* 241833 */     // GIR_Coverage, 11911,
     /* 241833 */     GIR_EraseRootFromParent_Done,
     /* 241834 */   // Label 4848: @241834
     /* 241834 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(241876), // Rule ID 11913 //
     /* 241839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 241847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241863 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 241866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241872 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241874 */     GIR_RootConstrainSelectedInstOperands,
     /* 241875 */     // GIR_Coverage, 11913,
     /* 241875 */     GIR_EraseRootFromParent_Done,
     /* 241876 */   // Label 4849: @241876
     /* 241876 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(241918), // Rule ID 11915 //
     /* 241881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 241889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241905 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 241908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241916 */     GIR_RootConstrainSelectedInstOperands,
     /* 241917 */     // GIR_Coverage, 11915,
     /* 241917 */     GIR_EraseRootFromParent_Done,
     /* 241918 */   // Label 4850: @241918
     /* 241918 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(241960), // Rule ID 11917 //
     /* 241923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 241931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241947 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 241950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241958 */     GIR_RootConstrainSelectedInstOperands,
     /* 241959 */     // GIR_Coverage, 11917,
     /* 241959 */     GIR_EraseRootFromParent_Done,
     /* 241960 */   // Label 4851: @241960
     /* 241960 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242002), // Rule ID 12006 //
     /* 241965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 241968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 241973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241989 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 241992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242000 */     GIR_RootConstrainSelectedInstOperands,
     /* 242001 */     // GIR_Coverage, 12006,
     /* 242001 */     GIR_EraseRootFromParent_Done,
     /* 242002 */   // Label 4852: @242002
     /* 242002 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242044), // Rule ID 12008 //
     /* 242007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 242015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 242034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242042 */     GIR_RootConstrainSelectedInstOperands,
     /* 242043 */     // GIR_Coverage, 12008,
     /* 242043 */     GIR_EraseRootFromParent_Done,
     /* 242044 */   // Label 4853: @242044
     /* 242044 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242086), // Rule ID 12010 //
     /* 242049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 242057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242073 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 242076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242084 */     GIR_RootConstrainSelectedInstOperands,
     /* 242085 */     // GIR_Coverage, 12010,
     /* 242085 */     GIR_EraseRootFromParent_Done,
     /* 242086 */   // Label 4854: @242086
     /* 242086 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242128), // Rule ID 12012 //
     /* 242091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 242099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242115 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 242118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242126 */     GIR_RootConstrainSelectedInstOperands,
     /* 242127 */     // GIR_Coverage, 12012,
     /* 242127 */     GIR_EraseRootFromParent_Done,
     /* 242128 */   // Label 4855: @242128
     /* 242128 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242170), // Rule ID 12014 //
     /* 242133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 242141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242157 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 242160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242168 */     GIR_RootConstrainSelectedInstOperands,
     /* 242169 */     // GIR_Coverage, 12014,
     /* 242169 */     GIR_EraseRootFromParent_Done,
     /* 242170 */   // Label 4856: @242170
     /* 242170 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242212), // Rule ID 12016 //
     /* 242175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 242183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 242202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242210 */     GIR_RootConstrainSelectedInstOperands,
     /* 242211 */     // GIR_Coverage, 12016,
     /* 242211 */     GIR_EraseRootFromParent_Done,
     /* 242212 */   // Label 4857: @242212
     /* 242212 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242254), // Rule ID 12179 //
     /* 242217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 242231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242241 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 242244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242252 */     GIR_RootConstrainSelectedInstOperands,
     /* 242253 */     // GIR_Coverage, 12179,
     /* 242253 */     GIR_EraseRootFromParent_Done,
     /* 242254 */   // Label 4858: @242254
     /* 242254 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242296), // Rule ID 12180 //
     /* 242259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 242286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242294 */     GIR_RootConstrainSelectedInstOperands,
     /* 242295 */     // GIR_Coverage, 12180,
     /* 242295 */     GIR_EraseRootFromParent_Done,
     /* 242296 */   // Label 4859: @242296
     /* 242296 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242338), // Rule ID 12181 //
     /* 242301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 242328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242336 */     GIR_RootConstrainSelectedInstOperands,
     /* 242337 */     // GIR_Coverage, 12181,
     /* 242337 */     GIR_EraseRootFromParent_Done,
     /* 242338 */   // Label 4860: @242338
     /* 242338 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242380), // Rule ID 12182 //
     /* 242343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242367 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 242370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242378 */     GIR_RootConstrainSelectedInstOperands,
     /* 242379 */     // GIR_Coverage, 12182,
     /* 242379 */     GIR_EraseRootFromParent_Done,
     /* 242380 */   // Label 4861: @242380
     /* 242380 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242422), // Rule ID 12183 //
     /* 242385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242409 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1919:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 242412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242420 */     GIR_RootConstrainSelectedInstOperands,
     /* 242421 */     // GIR_Coverage, 12183,
     /* 242421 */     GIR_EraseRootFromParent_Done,
     /* 242422 */   // Label 4862: @242422
     /* 242422 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242464), // Rule ID 12184 //
     /* 242427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242451 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1919:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 242454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242462 */     GIR_RootConstrainSelectedInstOperands,
     /* 242463 */     // GIR_Coverage, 12184,
     /* 242463 */     GIR_EraseRootFromParent_Done,
     /* 242464 */   // Label 4863: @242464
     /* 242464 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(242506), // Rule ID 12185 //
     /* 242469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 242472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 242477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242493 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1919:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 242496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242504 */     GIR_RootConstrainSelectedInstOperands,
     /* 242505 */     // GIR_Coverage, 12185,
     /* 242505 */     GIR_EraseRootFromParent_Done,
     /* 242506 */   // Label 4864: @242506
     /* 242506 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(242548), // Rule ID 12530 //
     /* 242511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 242519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242535 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 242538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242546 */     GIR_RootConstrainSelectedInstOperands,
     /* 242547 */     // GIR_Coverage, 12530,
     /* 242547 */     GIR_EraseRootFromParent_Done,
     /* 242548 */   // Label 4865: @242548
     /* 242548 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(242590), // Rule ID 12531 //
     /* 242553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 242561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 242580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242588 */     GIR_RootConstrainSelectedInstOperands,
     /* 242589 */     // GIR_Coverage, 12531,
     /* 242589 */     GIR_EraseRootFromParent_Done,
     /* 242590 */   // Label 4866: @242590
     /* 242590 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(242632), // Rule ID 12532 //
     /* 242595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 242603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 242622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242630 */     GIR_RootConstrainSelectedInstOperands,
     /* 242631 */     // GIR_Coverage, 12532,
     /* 242631 */     GIR_EraseRootFromParent_Done,
     /* 242632 */   // Label 4867: @242632
     /* 242632 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(242674), // Rule ID 12533 //
     /* 242637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 242645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242661 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 242664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242672 */     GIR_RootConstrainSelectedInstOperands,
     /* 242673 */     // GIR_Coverage, 12533,
     /* 242673 */     GIR_EraseRootFromParent_Done,
     /* 242674 */   // Label 4868: @242674
     /* 242674 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(242716), // Rule ID 12534 //
     /* 242679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 242687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242703 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 242706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242714 */     GIR_RootConstrainSelectedInstOperands,
     /* 242715 */     // GIR_Coverage, 12534,
     /* 242715 */     GIR_EraseRootFromParent_Done,
     /* 242716 */   // Label 4869: @242716
     /* 242716 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(242758), // Rule ID 12535 //
     /* 242721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 242729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242745 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 242748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242756 */     GIR_RootConstrainSelectedInstOperands,
     /* 242757 */     // GIR_Coverage, 12535,
     /* 242757 */     GIR_EraseRootFromParent_Done,
     /* 242758 */   // Label 4870: @242758
     /* 242758 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(242800), // Rule ID 12536 //
     /* 242763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242787 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 242790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242798 */     GIR_RootConstrainSelectedInstOperands,
     /* 242799 */     // GIR_Coverage, 12536,
     /* 242799 */     GIR_EraseRootFromParent_Done,
     /* 242800 */   // Label 4871: @242800
     /* 242800 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(242842), // Rule ID 12539 //
     /* 242805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242829 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 242832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242840 */     GIR_RootConstrainSelectedInstOperands,
     /* 242841 */     // GIR_Coverage, 12539,
     /* 242841 */     GIR_EraseRootFromParent_Done,
     /* 242842 */   // Label 4872: @242842
     /* 242842 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(242884), // Rule ID 12542 //
     /* 242847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242871 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 242874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242882 */     GIR_RootConstrainSelectedInstOperands,
     /* 242883 */     // GIR_Coverage, 12542,
     /* 242883 */     GIR_EraseRootFromParent_Done,
     /* 242884 */   // Label 4873: @242884
     /* 242884 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(242926), // Rule ID 12545 //
     /* 242889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242913 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 242916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242924 */     GIR_RootConstrainSelectedInstOperands,
     /* 242925 */     // GIR_Coverage, 12545,
     /* 242925 */     GIR_EraseRootFromParent_Done,
     /* 242926 */   // Label 4874: @242926
     /* 242926 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(242968), // Rule ID 12548 //
     /* 242931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242955 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 242958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242966 */     GIR_RootConstrainSelectedInstOperands,
     /* 242967 */     // GIR_Coverage, 12548,
     /* 242967 */     GIR_EraseRootFromParent_Done,
     /* 242968 */   // Label 4875: @242968
     /* 242968 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243010), // Rule ID 12551 //
     /* 242973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 242976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 242981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242997 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 243000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243008 */     GIR_RootConstrainSelectedInstOperands,
     /* 243009 */     // GIR_Coverage, 12551,
     /* 243009 */     GIR_EraseRootFromParent_Done,
     /* 243010 */   // Label 4876: @243010
     /* 243010 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243052), // Rule ID 12554 //
     /* 243015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243039 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 243039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 243042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243050 */     GIR_RootConstrainSelectedInstOperands,
     /* 243051 */     // GIR_Coverage, 12554,
     /* 243051 */     GIR_EraseRootFromParent_Done,
     /* 243052 */   // Label 4877: @243052
     /* 243052 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243094), // Rule ID 12557 //
     /* 243057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 243068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 243074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 243077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243081 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 243081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 243084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243092 */     GIR_RootConstrainSelectedInstOperands,
     /* 243093 */     // GIR_Coverage, 12557,
     /* 243093 */     GIR_EraseRootFromParent_Done,
     /* 243094 */   // Label 4878: @243094
     /* 243094 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243136), // Rule ID 12560 //
     /* 243099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 243110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 243116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 243119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243123 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 243123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 243126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243134 */     GIR_RootConstrainSelectedInstOperands,
     /* 243135 */     // GIR_Coverage, 12560,
     /* 243135 */     GIR_EraseRootFromParent_Done,
     /* 243136 */   // Label 4879: @243136
     /* 243136 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243178), // Rule ID 12563 //
     /* 243141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243165 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 243165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 243168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243176 */     GIR_RootConstrainSelectedInstOperands,
     /* 243177 */     // GIR_Coverage, 12563,
     /* 243177 */     GIR_EraseRootFromParent_Done,
     /* 243178 */   // Label 4880: @243178
     /* 243178 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243220), // Rule ID 12566 //
     /* 243183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 243194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 243200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 243203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243207 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 243207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 243210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243218 */     GIR_RootConstrainSelectedInstOperands,
     /* 243219 */     // GIR_Coverage, 12566,
     /* 243219 */     GIR_EraseRootFromParent_Done,
     /* 243220 */   // Label 4881: @243220
     /* 243220 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(243262), // Rule ID 12569 //
     /* 243225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 243228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 243233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243249 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 243249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 243252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243260 */     GIR_RootConstrainSelectedInstOperands,
     /* 243261 */     // GIR_Coverage, 12569,
     /* 243261 */     GIR_EraseRootFromParent_Done,
     /* 243262 */   // Label 4882: @243262
     /* 243262 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(243405), // Rule ID 5588 //
     /* 243267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 243275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 243281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 243284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243288 */     // MIs[0] idx
     /* 243288 */     // No operand predicates
     /* 243288 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243288 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 243291 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243295 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 243302 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 243305 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243309 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243314 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 243317 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 243321 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 243324 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243329 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243334 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 243372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 243393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 243401 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243403 */     GIR_RootConstrainSelectedInstOperands,
     /* 243404 */     // GIR_Coverage, 5588,
     /* 243404 */     GIR_EraseRootFromParent_Done,
     /* 243405 */   // Label 4883: @243405
     /* 243405 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(243496), // Rule ID 5589 //
     /* 243410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 243418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 243424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 243427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243431 */     // MIs[0] idx
     /* 243431 */     // No operand predicates
     /* 243431 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243457 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243460 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 243464 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 243485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 243492 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243494 */     GIR_RootConstrainSelectedInstOperands,
     /* 243495 */     // GIR_Coverage, 5589,
     /* 243495 */     GIR_EraseRootFromParent_Done,
     /* 243496 */   // Label 4884: @243496
     /* 243496 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(243587), // Rule ID 5590 //
     /* 243501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 243509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 243515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 243518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243522 */     // MIs[0] idx
     /* 243522 */     // No operand predicates
     /* 243522 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 243555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 243576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 243580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243583 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243585 */     GIR_RootConstrainSelectedInstOperands,
     /* 243586 */     // GIR_Coverage, 5590,
     /* 243586 */     GIR_EraseRootFromParent_Done,
     /* 243587 */   // Label 4885: @243587
     /* 243587 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(243626), // Rule ID 5591 //
     /* 243592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 243600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 243606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 243609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243613 */     // MIs[0] idx
     /* 243613 */     // No operand predicates
     /* 243613 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 243616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 243620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 243622 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243624 */     GIR_RootConstrainSelectedInstOperands,
     /* 243625 */     // GIR_Coverage, 5591,
     /* 243625 */     GIR_EraseRootFromParent_Done,
     /* 243626 */   // Label 4886: @243626
     /* 243626 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(243769), // Rule ID 5592 //
     /* 243631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 243639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 243645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 243648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243652 */     // MIs[0] idx
     /* 243652 */     // No operand predicates
     /* 243652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243652 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 243655 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243659 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 243666 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 243669 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243673 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243678 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 243681 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 243685 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 243688 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243693 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243698 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243703 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243706 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243710 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 243736 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 243757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 243765 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243767 */     GIR_RootConstrainSelectedInstOperands,
     /* 243768 */     // GIR_Coverage, 5592,
     /* 243768 */     GIR_EraseRootFromParent_Done,
     /* 243769 */   // Label 4887: @243769
     /* 243769 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(243860), // Rule ID 5593 //
     /* 243774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 243782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 243788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 243791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243795 */     // MIs[0] idx
     /* 243795 */     // No operand predicates
     /* 243795 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243821 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 243828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 243849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 243856 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243858 */     GIR_RootConstrainSelectedInstOperands,
     /* 243859 */     // GIR_Coverage, 5593,
     /* 243859 */     GIR_EraseRootFromParent_Done,
     /* 243860 */   // Label 4888: @243860
     /* 243860 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(243951), // Rule ID 5594 //
     /* 243865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 243873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 243879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 243882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243886 */     // MIs[0] idx
     /* 243886 */     // No operand predicates
     /* 243886 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243886 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 243889 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 243893 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 243900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 243903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 243907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243912 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 243915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 243919 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 243922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 243937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 243940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 243944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243947 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243949 */     GIR_RootConstrainSelectedInstOperands,
     /* 243950 */     // GIR_Coverage, 5594,
     /* 243950 */     GIR_EraseRootFromParent_Done,
     /* 243951 */   // Label 4889: @243951
     /* 243951 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(243990), // Rule ID 5595 //
     /* 243956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 243964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 243970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 243973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243977 */     // MIs[0] idx
     /* 243977 */     // No operand predicates
     /* 243977 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 243980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 243982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 243984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 243986 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 243988 */     GIR_RootConstrainSelectedInstOperands,
     /* 243989 */     // GIR_Coverage, 5595,
     /* 243989 */     GIR_EraseRootFromParent_Done,
     /* 243990 */   // Label 4890: @243990
     /* 243990 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(244133), // Rule ID 5596 //
     /* 243995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 243998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 244003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 244009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 244012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244016 */     // MIs[0] idx
     /* 244016 */     // No operand predicates
     /* 244016 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244016 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 244019 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244023 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 244030 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 244033 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244037 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244042 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 244045 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 244049 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 244052 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244057 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244062 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 244070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 244081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 244084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244093 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 244096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 244100 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 244103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 244121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 244129 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244131 */     GIR_RootConstrainSelectedInstOperands,
     /* 244132 */     // GIR_Coverage, 5596,
     /* 244132 */     GIR_EraseRootFromParent_Done,
     /* 244133 */   // Label 4891: @244133
     /* 244133 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(244224), // Rule ID 5597 //
     /* 244138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 244146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 244152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 244155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244159 */     // MIs[0] idx
     /* 244159 */     // No operand predicates
     /* 244159 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 244162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 244173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 244176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244185 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 244188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 244192 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 244195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 244213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 244220 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244222 */     GIR_RootConstrainSelectedInstOperands,
     /* 244223 */     // GIR_Coverage, 5597,
     /* 244223 */     GIR_EraseRootFromParent_Done,
     /* 244224 */   // Label 4892: @244224
     /* 244224 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(244315), // Rule ID 5598 //
     /* 244229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 244237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 244243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 244246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244250 */     // MIs[0] idx
     /* 244250 */     // No operand predicates
     /* 244250 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244250 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 244253 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244257 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 244264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 244267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244276 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 244279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 244283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 244286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 244304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244311 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244313 */     GIR_RootConstrainSelectedInstOperands,
     /* 244314 */     // GIR_Coverage, 5598,
     /* 244314 */     GIR_EraseRootFromParent_Done,
     /* 244315 */   // Label 4893: @244315
     /* 244315 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244354), // Rule ID 5599 //
     /* 244320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 244328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 244334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 244337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244341 */     // MIs[0] idx
     /* 244341 */     // No operand predicates
     /* 244341 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 244344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 244350 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244352 */     GIR_RootConstrainSelectedInstOperands,
     /* 244353 */     // GIR_Coverage, 5599,
     /* 244353 */     GIR_EraseRootFromParent_Done,
     /* 244354 */   // Label 4894: @244354
     /* 244354 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(244393), // Rule ID 5600 //
     /* 244359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 244367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 244370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 244376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244380 */     // MIs[0] idx
     /* 244380 */     // No operand predicates
     /* 244380 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 244380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 244383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 244389 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244391 */     GIR_RootConstrainSelectedInstOperands,
     /* 244392 */     // GIR_Coverage, 5600,
     /* 244392 */     GIR_EraseRootFromParent_Done,
     /* 244393 */   // Label 4895: @244393
     /* 244393 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(244484), // Rule ID 5601 //
     /* 244398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 244401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 244406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 244409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 244415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244419 */     // MIs[0] idx
     /* 244419 */     // No operand predicates
     /* 244419 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 244419 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 244422 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 244426 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 244433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 244436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 244440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 244448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 244452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 244455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 244473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244480 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 244482 */     GIR_RootConstrainSelectedInstOperands,
     /* 244483 */     // GIR_Coverage, 5601,
     /* 244483 */     GIR_EraseRootFromParent_Done,
     /* 244484 */   // Label 4896: @244484
     /* 244484 */   GIM_Reject,
     /* 244485 */ // Label 4020: @244485
     /* 244485 */ GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(251596),
     /* 244490 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 244493 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244540), // Rule ID 2965 //
     /* 244498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 244506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 244521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244525 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 244525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 244528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244536 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244538 */     GIR_RootConstrainSelectedInstOperands,
     /* 244539 */     // GIR_Coverage, 2965,
     /* 244539 */     GIR_EraseRootFromParent_Done,
     /* 244540 */   // Label 4898: @244540
     /* 244540 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(244587), // Rule ID 2967 //
     /* 244545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 244553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 244572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 244575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244583 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244585 */     GIR_RootConstrainSelectedInstOperands,
     /* 244586 */     // GIR_Coverage, 2967,
     /* 244586 */     GIR_EraseRootFromParent_Done,
     /* 244587 */   // Label 4899: @244587
     /* 244587 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(244634), // Rule ID 2969 //
     /* 244592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 244600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 244619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 244622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244630 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244632 */     GIR_RootConstrainSelectedInstOperands,
     /* 244633 */     // GIR_Coverage, 2969,
     /* 244633 */     GIR_EraseRootFromParent_Done,
     /* 244634 */   // Label 4900: @244634
     /* 244634 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(244681), // Rule ID 2971 //
     /* 244639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 244647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 244666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 244669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244677 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244679 */     GIR_RootConstrainSelectedInstOperands,
     /* 244680 */     // GIR_Coverage, 2971,
     /* 244680 */     GIR_EraseRootFromParent_Done,
     /* 244681 */   // Label 4901: @244681
     /* 244681 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(244728), // Rule ID 7604 //
     /* 244686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 244694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 244709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244713 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 244713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 244716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244724 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244726 */     GIR_RootConstrainSelectedInstOperands,
     /* 244727 */     // GIR_Coverage, 7604,
     /* 244727 */     GIR_EraseRootFromParent_Done,
     /* 244728 */   // Label 4902: @244728
     /* 244728 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(244775), // Rule ID 7606 //
     /* 244733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 244741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 244760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 244763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244771 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244773 */     GIR_RootConstrainSelectedInstOperands,
     /* 244774 */     // GIR_Coverage, 7606,
     /* 244774 */     GIR_EraseRootFromParent_Done,
     /* 244775 */   // Label 4903: @244775
     /* 244775 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(244822), // Rule ID 7608 //
     /* 244780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 244788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 244807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 244810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244818 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244820 */     GIR_RootConstrainSelectedInstOperands,
     /* 244821 */     // GIR_Coverage, 7608,
     /* 244821 */     GIR_EraseRootFromParent_Done,
     /* 244822 */   // Label 4904: @244822
     /* 244822 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(244869), // Rule ID 7610 //
     /* 244827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 244835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 244854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 244857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244865 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244867 */     GIR_RootConstrainSelectedInstOperands,
     /* 244868 */     // GIR_Coverage, 7610,
     /* 244868 */     GIR_EraseRootFromParent_Done,
     /* 244869 */   // Label 4905: @244869
     /* 244869 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(244949), // Rule ID 5708 //
     /* 244874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 244879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 244882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 244888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 244891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 244894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 244906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 244910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 244914 */     // MIs[1] Operand 1
     /* 244914 */     // No operand predicates
     /* 244914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 244922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 244926 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 244930 */     // MIs[2] Operand 1
     /* 244930 */     // No operand predicates
     /* 244930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 244932 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 244932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 244935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 244939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 244942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 244944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 244947 */     GIR_RootConstrainSelectedInstOperands,
     /* 244948 */     // GIR_Coverage, 5708,
     /* 244948 */     GIR_EraseRootFromParent_Done,
     /* 244949 */   // Label 4906: @244949
     /* 244949 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(245029), // Rule ID 5709 //
     /* 244954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 244959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 244965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 244968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 244971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 244974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 244986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 244990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 244994 */     // MIs[1] Operand 1
     /* 244994 */     // No operand predicates
     /* 244994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 245002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 245010 */     // MIs[2] Operand 1
     /* 245010 */     // No operand predicates
     /* 245010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 245012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 245015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 245017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 245022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 245024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 245027 */     GIR_RootConstrainSelectedInstOperands,
     /* 245028 */     // GIR_Coverage, 5709,
     /* 245028 */     GIR_EraseRootFromParent_Done,
     /* 245029 */   // Label 4907: @245029
     /* 245029 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(245109), // Rule ID 5710 //
     /* 245034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 245039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 245048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 245054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 245066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 245074 */     // MIs[1] Operand 1
     /* 245074 */     // No operand predicates
     /* 245074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 245082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245086 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 245090 */     // MIs[2] Operand 1
     /* 245090 */     // No operand predicates
     /* 245090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 245092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 245095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 245097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 245102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 245104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 245107 */     GIR_RootConstrainSelectedInstOperands,
     /* 245108 */     // GIR_Coverage, 5710,
     /* 245108 */     GIR_EraseRootFromParent_Done,
     /* 245109 */   // Label 4908: @245109
     /* 245109 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(245189), // Rule ID 5711 //
     /* 245114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 245119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 245122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 245125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 245128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 245131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 245134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 245146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 245154 */     // MIs[1] Operand 1
     /* 245154 */     // No operand predicates
     /* 245154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 245162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245166 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 245170 */     // MIs[2] Operand 1
     /* 245170 */     // No operand predicates
     /* 245170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245172 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 245172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 245175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 245177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 245182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 245184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 245187 */     GIR_RootConstrainSelectedInstOperands,
     /* 245188 */     // GIR_Coverage, 5711,
     /* 245188 */     GIR_EraseRootFromParent_Done,
     /* 245189 */   // Label 4909: @245189
     /* 245189 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(245253), // Rule ID 3849 //
     /* 245194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 245197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 245202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 245211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245230 */     // MIs[0] imm
     /* 245230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 245238 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 245238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 245241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 245243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 245247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 245249 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 245251 */     GIR_RootConstrainSelectedInstOperands,
     /* 245252 */     // GIR_Coverage, 3849,
     /* 245252 */     GIR_EraseRootFromParent_Done,
     /* 245253 */   // Label 4910: @245253
     /* 245253 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(245317), // Rule ID 3850 //
     /* 245258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 245261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 245266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 245275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245294 */     // MIs[0] imm
     /* 245294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 245302 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 245302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 245305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 245307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 245311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 245313 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 245315 */     GIR_RootConstrainSelectedInstOperands,
     /* 245316 */     // GIR_Coverage, 3850,
     /* 245316 */     GIR_EraseRootFromParent_Done,
     /* 245317 */   // Label 4911: @245317
     /* 245317 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(245381), // Rule ID 3851 //
     /* 245322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 245325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 245330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 245339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245358 */     // MIs[0] imm
     /* 245358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 245366 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 245366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 245369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 245371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 245375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 245377 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 245379 */     GIR_RootConstrainSelectedInstOperands,
     /* 245380 */     // GIR_Coverage, 3851,
     /* 245380 */     GIR_EraseRootFromParent_Done,
     /* 245381 */   // Label 4912: @245381
     /* 245381 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(245445), // Rule ID 3852 //
     /* 245386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 245389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 245394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 245397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 245400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 245403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 245406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 245422 */     // MIs[0] imm
     /* 245422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245425 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 245430 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 245430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 245433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 245435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 245437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 245439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 245441 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 245443 */     GIR_RootConstrainSelectedInstOperands,
     /* 245444 */     // GIR_Coverage, 3852,
     /* 245444 */     GIR_EraseRootFromParent_Done,
     /* 245445 */   // Label 4913: @245445
     /* 245445 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245497), // Rule ID 2850 //
     /* 245450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 245458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245474 */     // MIs[0] idx
     /* 245474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245482 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 245482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 245485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245493 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 245495 */     GIR_RootConstrainSelectedInstOperands,
     /* 245496 */     // GIR_Coverage, 2850,
     /* 245496 */     GIR_EraseRootFromParent_Done,
     /* 245497 */   // Label 4914: @245497
     /* 245497 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(245549), // Rule ID 2851 //
     /* 245502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 245510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245526 */     // MIs[0] idx
     /* 245526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245529 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245534 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 245534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 245537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245545 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 245547 */     GIR_RootConstrainSelectedInstOperands,
     /* 245548 */     // GIR_Coverage, 2851,
     /* 245548 */     GIR_EraseRootFromParent_Done,
     /* 245549 */   // Label 4915: @245549
     /* 245549 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(245601), // Rule ID 2852 //
     /* 245554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 245562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245578 */     // MIs[0] idx
     /* 245578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245586 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 245586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 245589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245597 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 245599 */     GIR_RootConstrainSelectedInstOperands,
     /* 245600 */     // GIR_Coverage, 2852,
     /* 245600 */     GIR_EraseRootFromParent_Done,
     /* 245601 */   // Label 4916: @245601
     /* 245601 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(245653), // Rule ID 2980 //
     /* 245606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 245614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245630 */     // MIs[0] Op4
     /* 245630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 245641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245649 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245651 */     GIR_RootConstrainSelectedInstOperands,
     /* 245652 */     // GIR_Coverage, 2980,
     /* 245652 */     GIR_EraseRootFromParent_Done,
     /* 245653 */   // Label 4917: @245653
     /* 245653 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(245705), // Rule ID 2981 //
     /* 245658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 245666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245682 */     // MIs[0] Op4
     /* 245682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 245693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245701 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245703 */     GIR_RootConstrainSelectedInstOperands,
     /* 245704 */     // GIR_Coverage, 2981,
     /* 245704 */     GIR_EraseRootFromParent_Done,
     /* 245705 */   // Label 4918: @245705
     /* 245705 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(245757), // Rule ID 2982 //
     /* 245710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 245718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245734 */     // MIs[0] Op4
     /* 245734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 245742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 245745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245753 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245755 */     GIR_RootConstrainSelectedInstOperands,
     /* 245756 */     // GIR_Coverage, 2982,
     /* 245756 */     GIR_EraseRootFromParent_Done,
     /* 245757 */   // Label 4919: @245757
     /* 245757 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(245809), // Rule ID 2983 //
     /* 245762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 245770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245786 */     // MIs[0] Op4
     /* 245786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1744:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 245797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245805 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245807 */     GIR_RootConstrainSelectedInstOperands,
     /* 245808 */     // GIR_Coverage, 2983,
     /* 245808 */     GIR_EraseRootFromParent_Done,
     /* 245809 */   // Label 4920: @245809
     /* 245809 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(245861), // Rule ID 2984 //
     /* 245814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 245822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245838 */     // MIs[0] Op4
     /* 245838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1744:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 245849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245857 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245859 */     GIR_RootConstrainSelectedInstOperands,
     /* 245860 */     // GIR_Coverage, 2984,
     /* 245860 */     GIR_EraseRootFromParent_Done,
     /* 245861 */   // Label 4921: @245861
     /* 245861 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(245913), // Rule ID 2987 //
     /* 245866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 245874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245890 */     // MIs[0] Op4
     /* 245890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 245901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245909 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245911 */     GIR_RootConstrainSelectedInstOperands,
     /* 245912 */     // GIR_Coverage, 2987,
     /* 245912 */     GIR_EraseRootFromParent_Done,
     /* 245913 */   // Label 4922: @245913
     /* 245913 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(245965), // Rule ID 2988 //
     /* 245918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 245926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245942 */     // MIs[0] Op4
     /* 245942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 245950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 245953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245961 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245963 */     GIR_RootConstrainSelectedInstOperands,
     /* 245964 */     // GIR_Coverage, 2988,
     /* 245964 */     GIR_EraseRootFromParent_Done,
     /* 245965 */   // Label 4923: @245965
     /* 245965 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(246017), // Rule ID 3462 //
     /* 245970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 245973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 245978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245994 */     // MIs[0] Op4
     /* 245994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 246005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246013 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246015 */     GIR_RootConstrainSelectedInstOperands,
     /* 246016 */     // GIR_Coverage, 3462,
     /* 246016 */     GIR_EraseRootFromParent_Done,
     /* 246017 */   // Label 4924: @246017
     /* 246017 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(246069), // Rule ID 3506 //
     /* 246022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 246025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 246030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246046 */     // MIs[0] Op4
     /* 246046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1711:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 246057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246065 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246067 */     GIR_RootConstrainSelectedInstOperands,
     /* 246068 */     // GIR_Coverage, 3506,
     /* 246068 */     GIR_EraseRootFromParent_Done,
     /* 246069 */   // Label 4925: @246069
     /* 246069 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(246121), // Rule ID 7678 //
     /* 246074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 246082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246098 */     // MIs[0] Op4
     /* 246098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1957:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 246109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246117 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246119 */     GIR_RootConstrainSelectedInstOperands,
     /* 246120 */     // GIR_Coverage, 7678,
     /* 246120 */     GIR_EraseRootFromParent_Done,
     /* 246121 */   // Label 4926: @246121
     /* 246121 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(246173), // Rule ID 7679 //
     /* 246126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 246134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246150 */     // MIs[0] Op4
     /* 246150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1957:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 246158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 246161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246169 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246171 */     GIR_RootConstrainSelectedInstOperands,
     /* 246172 */     // GIR_Coverage, 7679,
     /* 246172 */     GIR_EraseRootFromParent_Done,
     /* 246173 */   // Label 4927: @246173
     /* 246173 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(246225), // Rule ID 8319 //
     /* 246178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 246186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246202 */     // MIs[0] idx
     /* 246202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246210 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 246210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 246213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246221 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 246223 */     GIR_RootConstrainSelectedInstOperands,
     /* 246224 */     // GIR_Coverage, 8319,
     /* 246224 */     GIR_EraseRootFromParent_Done,
     /* 246225 */   // Label 4928: @246225
     /* 246225 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(246277), // Rule ID 8320 //
     /* 246230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 246238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246254 */     // MIs[0] idx
     /* 246254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246262 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 246262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 246265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246273 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 246275 */     GIR_RootConstrainSelectedInstOperands,
     /* 246276 */     // GIR_Coverage, 8320,
     /* 246276 */     GIR_EraseRootFromParent_Done,
     /* 246277 */   // Label 4929: @246277
     /* 246277 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(246329), // Rule ID 8321 //
     /* 246282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 246290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246306 */     // MIs[0] idx
     /* 246306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246314 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 246314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 246317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246325 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 246327 */     GIR_RootConstrainSelectedInstOperands,
     /* 246328 */     // GIR_Coverage, 8321,
     /* 246328 */     GIR_EraseRootFromParent_Done,
     /* 246329 */   // Label 4930: @246329
     /* 246329 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(246381), // Rule ID 11285 //
     /* 246334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 246337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 246342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246358 */     // MIs[0] Op4
     /* 246358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1906:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 246369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246377 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246379 */     GIR_RootConstrainSelectedInstOperands,
     /* 246380 */     // GIR_Coverage, 11285,
     /* 246380 */     GIR_EraseRootFromParent_Done,
     /* 246381 */   // Label 4931: @246381
     /* 246381 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246433), // Rule ID 11332 //
     /* 246386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 246394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246410 */     // MIs[0] Op4
     /* 246410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 246421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246429 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246431 */     GIR_RootConstrainSelectedInstOperands,
     /* 246432 */     // GIR_Coverage, 11332,
     /* 246432 */     GIR_EraseRootFromParent_Done,
     /* 246433 */   // Label 4932: @246433
     /* 246433 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246485), // Rule ID 11333 //
     /* 246438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 246446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246462 */     // MIs[0] Op4
     /* 246462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246470 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 246473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246481 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246483 */     GIR_RootConstrainSelectedInstOperands,
     /* 246484 */     // GIR_Coverage, 11333,
     /* 246484 */     GIR_EraseRootFromParent_Done,
     /* 246485 */   // Label 4933: @246485
     /* 246485 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246537), // Rule ID 11334 //
     /* 246490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 246498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246514 */     // MIs[0] Op4
     /* 246514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1605:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 246522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 246525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246533 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246535 */     GIR_RootConstrainSelectedInstOperands,
     /* 246536 */     // GIR_Coverage, 11334,
     /* 246536 */     GIR_EraseRootFromParent_Done,
     /* 246537 */   // Label 4934: @246537
     /* 246537 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246589), // Rule ID 11335 //
     /* 246542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 246550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246566 */     // MIs[0] Op4
     /* 246566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 246577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246585 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246587 */     GIR_RootConstrainSelectedInstOperands,
     /* 246588 */     // GIR_Coverage, 11335,
     /* 246588 */     GIR_EraseRootFromParent_Done,
     /* 246589 */   // Label 4935: @246589
     /* 246589 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246641), // Rule ID 11336 //
     /* 246594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 246602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246618 */     // MIs[0] Op4
     /* 246618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 246629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246637 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246639 */     GIR_RootConstrainSelectedInstOperands,
     /* 246640 */     // GIR_Coverage, 11336,
     /* 246640 */     GIR_EraseRootFromParent_Done,
     /* 246641 */   // Label 4936: @246641
     /* 246641 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246693), // Rule ID 11337 //
     /* 246646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 246654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246670 */     // MIs[0] Op4
     /* 246670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 246678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 246681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246689 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246691 */     GIR_RootConstrainSelectedInstOperands,
     /* 246692 */     // GIR_Coverage, 11337,
     /* 246692 */     GIR_EraseRootFromParent_Done,
     /* 246693 */   // Label 4937: @246693
     /* 246693 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246745), // Rule ID 11338 //
     /* 246698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 246706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246722 */     // MIs[0] Op4
     /* 246722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 246733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246741 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246743 */     GIR_RootConstrainSelectedInstOperands,
     /* 246744 */     // GIR_Coverage, 11338,
     /* 246744 */     GIR_EraseRootFromParent_Done,
     /* 246745 */   // Label 4938: @246745
     /* 246745 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(246797), // Rule ID 11339 //
     /* 246750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 246758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246774 */     // MIs[0] Op4
     /* 246774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 246785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246791 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246793 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246795 */     GIR_RootConstrainSelectedInstOperands,
     /* 246796 */     // GIR_Coverage, 11339,
     /* 246796 */     GIR_EraseRootFromParent_Done,
     /* 246797 */   // Label 4939: @246797
     /* 246797 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(246849), // Rule ID 11340 //
     /* 246802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 246810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246826 */     // MIs[0] Op4
     /* 246826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246829 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 246834 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 246834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 246837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246845 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246847 */     GIR_RootConstrainSelectedInstOperands,
     /* 246848 */     // GIR_Coverage, 11340,
     /* 246848 */     GIR_EraseRootFromParent_Done,
     /* 246849 */   // Label 4940: @246849
     /* 246849 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(246901), // Rule ID 11383 //
     /* 246854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 246862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246878 */     // MIs[0] Op4
     /* 246878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 246889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246897 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246899 */     GIR_RootConstrainSelectedInstOperands,
     /* 246900 */     // GIR_Coverage, 11383,
     /* 246900 */     GIR_EraseRootFromParent_Done,
     /* 246901 */   // Label 4941: @246901
     /* 246901 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(246953), // Rule ID 11384 //
     /* 246906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 246914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246930 */     // MIs[0] Op4
     /* 246930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 246941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246949 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246951 */     GIR_RootConstrainSelectedInstOperands,
     /* 246952 */     // GIR_Coverage, 11384,
     /* 246952 */     GIR_EraseRootFromParent_Done,
     /* 246953 */   // Label 4942: @246953
     /* 246953 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(247005), // Rule ID 11385 //
     /* 246958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 246966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246982 */     // MIs[0] Op4
     /* 246982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 246993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247001 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247003 */     GIR_RootConstrainSelectedInstOperands,
     /* 247004 */     // GIR_Coverage, 11385,
     /* 247004 */     GIR_EraseRootFromParent_Done,
     /* 247005 */   // Label 4943: @247005
     /* 247005 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(247057), // Rule ID 11386 //
     /* 247010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 247018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247034 */     // MIs[0] Op4
     /* 247034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 247045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247053 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247055 */     GIR_RootConstrainSelectedInstOperands,
     /* 247056 */     // GIR_Coverage, 11386,
     /* 247056 */     GIR_EraseRootFromParent_Done,
     /* 247057 */   // Label 4944: @247057
     /* 247057 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(247109), // Rule ID 11387 //
     /* 247062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 247070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247086 */     // MIs[0] Op4
     /* 247086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1984:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 247097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247105 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247107 */     GIR_RootConstrainSelectedInstOperands,
     /* 247108 */     // GIR_Coverage, 11387,
     /* 247108 */     GIR_EraseRootFromParent_Done,
     /* 247109 */   // Label 4945: @247109
     /* 247109 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247161), // Rule ID 11388 //
     /* 247114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 247122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247138 */     // MIs[0] Op4
     /* 247138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1984:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 247149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247157 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247159 */     GIR_RootConstrainSelectedInstOperands,
     /* 247160 */     // GIR_Coverage, 11388,
     /* 247160 */     GIR_EraseRootFromParent_Done,
     /* 247161 */   // Label 4946: @247161
     /* 247161 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247213), // Rule ID 11389 //
     /* 247166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 247174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247190 */     // MIs[0] Op4
     /* 247190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 247201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247209 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247211 */     GIR_RootConstrainSelectedInstOperands,
     /* 247212 */     // GIR_Coverage, 11389,
     /* 247212 */     GIR_EraseRootFromParent_Done,
     /* 247213 */   // Label 4947: @247213
     /* 247213 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247265), // Rule ID 11390 //
     /* 247218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 247226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247242 */     // MIs[0] Op4
     /* 247242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 247253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247261 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247263 */     GIR_RootConstrainSelectedInstOperands,
     /* 247264 */     // GIR_Coverage, 11390,
     /* 247264 */     GIR_EraseRootFromParent_Done,
     /* 247265 */   // Label 4948: @247265
     /* 247265 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247317), // Rule ID 11391 //
     /* 247270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 247278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247294 */     // MIs[0] Op4
     /* 247294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 247305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247313 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247315 */     GIR_RootConstrainSelectedInstOperands,
     /* 247316 */     // GIR_Coverage, 11391,
     /* 247316 */     GIR_EraseRootFromParent_Done,
     /* 247317 */   // Label 4949: @247317
     /* 247317 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247369), // Rule ID 11392 //
     /* 247322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 247330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247346 */     // MIs[0] Op4
     /* 247346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 247357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247365 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247367 */     GIR_RootConstrainSelectedInstOperands,
     /* 247368 */     // GIR_Coverage, 11392,
     /* 247368 */     GIR_EraseRootFromParent_Done,
     /* 247369 */   // Label 4950: @247369
     /* 247369 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247421), // Rule ID 11393 //
     /* 247374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 247382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247398 */     // MIs[0] Op4
     /* 247398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 247409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247417 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247419 */     GIR_RootConstrainSelectedInstOperands,
     /* 247420 */     // GIR_Coverage, 11393,
     /* 247420 */     GIR_EraseRootFromParent_Done,
     /* 247421 */   // Label 4951: @247421
     /* 247421 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247473), // Rule ID 11394 //
     /* 247426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 247434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247450 */     // MIs[0] Op4
     /* 247450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 247461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247469 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247471 */     GIR_RootConstrainSelectedInstOperands,
     /* 247472 */     // GIR_Coverage, 11394,
     /* 247472 */     GIR_EraseRootFromParent_Done,
     /* 247473 */   // Label 4952: @247473
     /* 247473 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247525), // Rule ID 11395 //
     /* 247478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 247486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247502 */     // MIs[0] Op4
     /* 247502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 247513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247521 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247523 */     GIR_RootConstrainSelectedInstOperands,
     /* 247524 */     // GIR_Coverage, 11395,
     /* 247524 */     GIR_EraseRootFromParent_Done,
     /* 247525 */   // Label 4953: @247525
     /* 247525 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247577), // Rule ID 11396 //
     /* 247530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 247538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247554 */     // MIs[0] Op4
     /* 247554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 247565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247575 */     GIR_RootConstrainSelectedInstOperands,
     /* 247576 */     // GIR_Coverage, 11396,
     /* 247576 */     GIR_EraseRootFromParent_Done,
     /* 247577 */   // Label 4954: @247577
     /* 247577 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247629), // Rule ID 11418 //
     /* 247582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 247590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247606 */     // MIs[0] Op4
     /* 247606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 247617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247625 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247627 */     GIR_RootConstrainSelectedInstOperands,
     /* 247628 */     // GIR_Coverage, 11418,
     /* 247628 */     GIR_EraseRootFromParent_Done,
     /* 247629 */   // Label 4955: @247629
     /* 247629 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247681), // Rule ID 11419 //
     /* 247634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 247642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247658 */     // MIs[0] Op4
     /* 247658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 247669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247677 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247679 */     GIR_RootConstrainSelectedInstOperands,
     /* 247680 */     // GIR_Coverage, 11419,
     /* 247680 */     GIR_EraseRootFromParent_Done,
     /* 247681 */   // Label 4956: @247681
     /* 247681 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247733), // Rule ID 11420 //
     /* 247686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 247694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247710 */     // MIs[0] Op4
     /* 247710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 247721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247729 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247731 */     GIR_RootConstrainSelectedInstOperands,
     /* 247732 */     // GIR_Coverage, 11420,
     /* 247732 */     GIR_EraseRootFromParent_Done,
     /* 247733 */   // Label 4957: @247733
     /* 247733 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247785), // Rule ID 11421 //
     /* 247738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 247746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247762 */     // MIs[0] Op4
     /* 247762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 247773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247781 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247783 */     GIR_RootConstrainSelectedInstOperands,
     /* 247784 */     // GIR_Coverage, 11421,
     /* 247784 */     GIR_EraseRootFromParent_Done,
     /* 247785 */   // Label 4958: @247785
     /* 247785 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247837), // Rule ID 11422 //
     /* 247790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 247798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247814 */     // MIs[0] Op4
     /* 247814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1791:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 247825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247833 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247835 */     GIR_RootConstrainSelectedInstOperands,
     /* 247836 */     // GIR_Coverage, 11422,
     /* 247836 */     GIR_EraseRootFromParent_Done,
     /* 247837 */   // Label 4959: @247837
     /* 247837 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(247889), // Rule ID 11423 //
     /* 247842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 247850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247866 */     // MIs[0] Op4
     /* 247866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1791:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 247877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247885 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247887 */     GIR_RootConstrainSelectedInstOperands,
     /* 247888 */     // GIR_Coverage, 11423,
     /* 247888 */     GIR_EraseRootFromParent_Done,
     /* 247889 */   // Label 4960: @247889
     /* 247889 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(247941), // Rule ID 11424 //
     /* 247894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 247902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247918 */     // MIs[0] Op4
     /* 247918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 247926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 247926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 247929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247937 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247939 */     GIR_RootConstrainSelectedInstOperands,
     /* 247940 */     // GIR_Coverage, 11424,
     /* 247940 */     GIR_EraseRootFromParent_Done,
     /* 247941 */   // Label 4961: @247941
     /* 247941 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(247993), // Rule ID 11425 //
     /* 247946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 247954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247970 */     // MIs[0] Op4
     /* 247970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 247978 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 247978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 247981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247989 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247991 */     GIR_RootConstrainSelectedInstOperands,
     /* 247992 */     // GIR_Coverage, 11425,
     /* 247992 */     GIR_EraseRootFromParent_Done,
     /* 247993 */   // Label 4962: @247993
     /* 247993 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(248045), // Rule ID 11879 //
     /* 247998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 248006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248022 */     // MIs[0] Op4
     /* 248022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248025 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 248030 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 248030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 248033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248041 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248043 */     GIR_RootConstrainSelectedInstOperands,
     /* 248044 */     // GIR_Coverage, 11879,
     /* 248044 */     GIR_EraseRootFromParent_Done,
     /* 248045 */   // Label 4963: @248045
     /* 248045 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(248097), // Rule ID 11880 //
     /* 248050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 248058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248074 */     // MIs[0] Op4
     /* 248074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 248082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 248082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 248085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248093 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248095 */     GIR_RootConstrainSelectedInstOperands,
     /* 248096 */     // GIR_Coverage, 11880,
     /* 248096 */     GIR_EraseRootFromParent_Done,
     /* 248097 */   // Label 4964: @248097
     /* 248097 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(248149), // Rule ID 11881 //
     /* 248102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 248110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248126 */     // MIs[0] Op4
     /* 248126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 248134 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 248134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 248137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248145 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248147 */     GIR_RootConstrainSelectedInstOperands,
     /* 248148 */     // GIR_Coverage, 11881,
     /* 248148 */     GIR_EraseRootFromParent_Done,
     /* 248149 */   // Label 4965: @248149
     /* 248149 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248201), // Rule ID 11882 //
     /* 248154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 248162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248178 */     // MIs[0] Op4
     /* 248178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 248186 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 248186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 248189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248197 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248199 */     GIR_RootConstrainSelectedInstOperands,
     /* 248200 */     // GIR_Coverage, 11882,
     /* 248200 */     GIR_EraseRootFromParent_Done,
     /* 248201 */   // Label 4966: @248201
     /* 248201 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248253), // Rule ID 12015 //
     /* 248206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 248209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 248214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248230 */     // MIs[0] Op4
     /* 248230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 248238 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 248238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 248241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248249 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248251 */     GIR_RootConstrainSelectedInstOperands,
     /* 248252 */     // GIR_Coverage, 12015,
     /* 248252 */     GIR_EraseRootFromParent_Done,
     /* 248253 */   // Label 4967: @248253
     /* 248253 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248305), // Rule ID 12017 //
     /* 248258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 248261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 248266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248282 */     // MIs[0] Op4
     /* 248282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 248290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1958:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 248290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 248293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248301 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248303 */     GIR_RootConstrainSelectedInstOperands,
     /* 248304 */     // GIR_Coverage, 12017,
     /* 248304 */     GIR_EraseRootFromParent_Done,
     /* 248305 */   // Label 4968: @248305
     /* 248305 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248352), // Rule ID 2829 //
     /* 248310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248337 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1461:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 248340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248348 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248350 */     GIR_RootConstrainSelectedInstOperands,
     /* 248351 */     // GIR_Coverage, 2829,
     /* 248351 */     GIR_EraseRootFromParent_Done,
     /* 248352 */   // Label 4969: @248352
     /* 248352 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248399), // Rule ID 2832 //
     /* 248357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248384 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 248387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248395 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248397 */     GIR_RootConstrainSelectedInstOperands,
     /* 248398 */     // GIR_Coverage, 2832,
     /* 248398 */     GIR_EraseRootFromParent_Done,
     /* 248399 */   // Label 4970: @248399
     /* 248399 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248446), // Rule ID 2835 //
     /* 248404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248431 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 248434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248442 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248444 */     GIR_RootConstrainSelectedInstOperands,
     /* 248445 */     // GIR_Coverage, 2835,
     /* 248445 */     GIR_EraseRootFromParent_Done,
     /* 248446 */   // Label 4971: @248446
     /* 248446 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248493), // Rule ID 2838 //
     /* 248451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248478 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 248481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248489 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248491 */     GIR_RootConstrainSelectedInstOperands,
     /* 248492 */     // GIR_Coverage, 2838,
     /* 248492 */     GIR_EraseRootFromParent_Done,
     /* 248493 */   // Label 4972: @248493
     /* 248493 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248540), // Rule ID 2841 //
     /* 248498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248525 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 248528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248536 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248538 */     GIR_RootConstrainSelectedInstOperands,
     /* 248539 */     // GIR_Coverage, 2841,
     /* 248539 */     GIR_EraseRootFromParent_Done,
     /* 248540 */   // Label 4973: @248540
     /* 248540 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248587), // Rule ID 2844 //
     /* 248545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 248553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248572 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 248575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248583 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248585 */     GIR_RootConstrainSelectedInstOperands,
     /* 248586 */     // GIR_Coverage, 2844,
     /* 248586 */     GIR_EraseRootFromParent_Done,
     /* 248587 */   // Label 4974: @248587
     /* 248587 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248634), // Rule ID 2847 //
     /* 248592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 248600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248619 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 248622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248630 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248632 */     GIR_RootConstrainSelectedInstOperands,
     /* 248633 */     // GIR_Coverage, 2847,
     /* 248633 */     GIR_EraseRootFromParent_Done,
     /* 248634 */   // Label 4975: @248634
     /* 248634 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248681), // Rule ID 2848 //
     /* 248639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 248647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248666 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 248669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248677 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248679 */     GIR_RootConstrainSelectedInstOperands,
     /* 248680 */     // GIR_Coverage, 2848,
     /* 248680 */     GIR_EraseRootFromParent_Done,
     /* 248681 */   // Label 4976: @248681
     /* 248681 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248728), // Rule ID 2849 //
     /* 248686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 248694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248713 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 248716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248724 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248726 */     GIR_RootConstrainSelectedInstOperands,
     /* 248727 */     // GIR_Coverage, 2849,
     /* 248727 */     GIR_EraseRootFromParent_Done,
     /* 248728 */   // Label 4977: @248728
     /* 248728 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248775), // Rule ID 2945 //
     /* 248733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 248741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 248756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 248760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 248763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248771 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248773 */     GIR_RootConstrainSelectedInstOperands,
     /* 248774 */     // GIR_Coverage, 2945,
     /* 248774 */     GIR_EraseRootFromParent_Done,
     /* 248775 */   // Label 4978: @248775
     /* 248775 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248822), // Rule ID 2948 //
     /* 248780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 248788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 248807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 248810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248818 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248820 */     GIR_RootConstrainSelectedInstOperands,
     /* 248821 */     // GIR_Coverage, 2948,
     /* 248821 */     GIR_EraseRootFromParent_Done,
     /* 248822 */   // Label 4979: @248822
     /* 248822 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248869), // Rule ID 2951 //
     /* 248827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 248835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 248854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 248857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248865 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248867 */     GIR_RootConstrainSelectedInstOperands,
     /* 248868 */     // GIR_Coverage, 2951,
     /* 248868 */     GIR_EraseRootFromParent_Done,
     /* 248869 */   // Label 4980: @248869
     /* 248869 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248916), // Rule ID 2954 //
     /* 248874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 248882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248901 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1599:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 248901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 248904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248912 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248914 */     GIR_RootConstrainSelectedInstOperands,
     /* 248915 */     // GIR_Coverage, 2954,
     /* 248915 */     GIR_EraseRootFromParent_Done,
     /* 248916 */   // Label 4981: @248916
     /* 248916 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(248963), // Rule ID 2957 //
     /* 248921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 248929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 248944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 248948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 248951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248959 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248961 */     GIR_RootConstrainSelectedInstOperands,
     /* 248962 */     // GIR_Coverage, 2957,
     /* 248962 */     GIR_EraseRootFromParent_Done,
     /* 248963 */   // Label 4982: @248963
     /* 248963 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(249010), // Rule ID 2959 //
     /* 248968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 248976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248995 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 248995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 248998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249006 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249008 */     GIR_RootConstrainSelectedInstOperands,
     /* 249009 */     // GIR_Coverage, 2959,
     /* 249009 */     GIR_EraseRootFromParent_Done,
     /* 249010 */   // Label 4983: @249010
     /* 249010 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(249057), // Rule ID 2961 //
     /* 249015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 249023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 249042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 249045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249053 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249055 */     GIR_RootConstrainSelectedInstOperands,
     /* 249056 */     // GIR_Coverage, 2961,
     /* 249056 */     GIR_EraseRootFromParent_Done,
     /* 249057 */   // Label 4984: @249057
     /* 249057 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249104), // Rule ID 2963 //
     /* 249062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 249070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 249089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 249092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249100 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249102 */     GIR_RootConstrainSelectedInstOperands,
     /* 249103 */     // GIR_Coverage, 2963,
     /* 249103 */     GIR_EraseRootFromParent_Done,
     /* 249104 */   // Label 4985: @249104
     /* 249104 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249151), // Rule ID 7584 //
     /* 249109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 249117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 249132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 249136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 249139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249147 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249149 */     GIR_RootConstrainSelectedInstOperands,
     /* 249150 */     // GIR_Coverage, 7584,
     /* 249150 */     GIR_EraseRootFromParent_Done,
     /* 249151 */   // Label 4986: @249151
     /* 249151 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249198), // Rule ID 7587 //
     /* 249156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 249164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249183 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 249183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 249186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249194 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249196 */     GIR_RootConstrainSelectedInstOperands,
     /* 249197 */     // GIR_Coverage, 7587,
     /* 249197 */     GIR_EraseRootFromParent_Done,
     /* 249198 */   // Label 4987: @249198
     /* 249198 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249245), // Rule ID 7590 //
     /* 249203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 249211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 249230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 249233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249241 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249243 */     GIR_RootConstrainSelectedInstOperands,
     /* 249244 */     // GIR_Coverage, 7590,
     /* 249244 */     GIR_EraseRootFromParent_Done,
     /* 249245 */   // Label 4988: @249245
     /* 249245 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249292), // Rule ID 7593 //
     /* 249250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 249258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 249277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 249280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249288 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249290 */     GIR_RootConstrainSelectedInstOperands,
     /* 249291 */     // GIR_Coverage, 7593,
     /* 249291 */     GIR_EraseRootFromParent_Done,
     /* 249292 */   // Label 4989: @249292
     /* 249292 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249339), // Rule ID 7596 //
     /* 249297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 249305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 249320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249324 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 249324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 249327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249335 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249337 */     GIR_RootConstrainSelectedInstOperands,
     /* 249338 */     // GIR_Coverage, 7596,
     /* 249338 */     GIR_EraseRootFromParent_Done,
     /* 249339 */   // Label 4990: @249339
     /* 249339 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249386), // Rule ID 7598 //
     /* 249344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 249352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 249371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 249374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249382 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249384 */     GIR_RootConstrainSelectedInstOperands,
     /* 249385 */     // GIR_Coverage, 7598,
     /* 249385 */     GIR_EraseRootFromParent_Done,
     /* 249386 */   // Label 4991: @249386
     /* 249386 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249433), // Rule ID 7600 //
     /* 249391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 249399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 249418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 249421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249429 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249431 */     GIR_RootConstrainSelectedInstOperands,
     /* 249432 */     // GIR_Coverage, 7600,
     /* 249432 */     GIR_EraseRootFromParent_Done,
     /* 249433 */   // Label 4992: @249433
     /* 249433 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249480), // Rule ID 7602 //
     /* 249438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 249446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 249465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 249468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249476 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249478 */     GIR_RootConstrainSelectedInstOperands,
     /* 249479 */     // GIR_Coverage, 7602,
     /* 249479 */     GIR_EraseRootFromParent_Done,
     /* 249480 */   // Label 4993: @249480
     /* 249480 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249527), // Rule ID 8232 //
     /* 249485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249512 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 249515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249523 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249525 */     GIR_RootConstrainSelectedInstOperands,
     /* 249526 */     // GIR_Coverage, 8232,
     /* 249526 */     GIR_EraseRootFromParent_Done,
     /* 249527 */   // Label 4994: @249527
     /* 249527 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249574), // Rule ID 8235 //
     /* 249532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249559 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 249562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249570 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249572 */     GIR_RootConstrainSelectedInstOperands,
     /* 249573 */     // GIR_Coverage, 8235,
     /* 249573 */     GIR_EraseRootFromParent_Done,
     /* 249574 */   // Label 4995: @249574
     /* 249574 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249621), // Rule ID 8238 //
     /* 249579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249606 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 249609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249617 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249619 */     GIR_RootConstrainSelectedInstOperands,
     /* 249620 */     // GIR_Coverage, 8238,
     /* 249620 */     GIR_EraseRootFromParent_Done,
     /* 249621 */   // Label 4996: @249621
     /* 249621 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249668), // Rule ID 8241 //
     /* 249626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249653 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 249656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249664 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249666 */     GIR_RootConstrainSelectedInstOperands,
     /* 249667 */     // GIR_Coverage, 8241,
     /* 249667 */     GIR_EraseRootFromParent_Done,
     /* 249668 */   // Label 4997: @249668
     /* 249668 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249715), // Rule ID 8244 //
     /* 249673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249700 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 249703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249711 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249713 */     GIR_RootConstrainSelectedInstOperands,
     /* 249714 */     // GIR_Coverage, 8244,
     /* 249714 */     GIR_EraseRootFromParent_Done,
     /* 249715 */   // Label 4998: @249715
     /* 249715 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249762), // Rule ID 8247 //
     /* 249720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 249728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249747 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 249750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249758 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249760 */     GIR_RootConstrainSelectedInstOperands,
     /* 249761 */     // GIR_Coverage, 8247,
     /* 249761 */     GIR_EraseRootFromParent_Done,
     /* 249762 */   // Label 4999: @249762
     /* 249762 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(249809), // Rule ID 8250 //
     /* 249767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249794 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 249797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249805 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249807 */     GIR_RootConstrainSelectedInstOperands,
     /* 249808 */     // GIR_Coverage, 8250,
     /* 249808 */     GIR_EraseRootFromParent_Done,
     /* 249809 */   // Label 5000: @249809
     /* 249809 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(249856), // Rule ID 8251 //
     /* 249814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249841 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 249844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249852 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249854 */     GIR_RootConstrainSelectedInstOperands,
     /* 249855 */     // GIR_Coverage, 8251,
     /* 249855 */     GIR_EraseRootFromParent_Done,
     /* 249856 */   // Label 5001: @249856
     /* 249856 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(249903), // Rule ID 8252 //
     /* 249861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249888 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 249891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249899 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249901 */     GIR_RootConstrainSelectedInstOperands,
     /* 249902 */     // GIR_Coverage, 8252,
     /* 249902 */     GIR_EraseRootFromParent_Done,
     /* 249903 */   // Label 5002: @249903
     /* 249903 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(249950), // Rule ID 8253 //
     /* 249908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249935 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 249938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249946 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249948 */     GIR_RootConstrainSelectedInstOperands,
     /* 249949 */     // GIR_Coverage, 8253,
     /* 249949 */     GIR_EraseRootFromParent_Done,
     /* 249950 */   // Label 5003: @249950
     /* 249950 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(249997), // Rule ID 8254 //
     /* 249955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 249963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 249985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249993 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249995 */     GIR_RootConstrainSelectedInstOperands,
     /* 249996 */     // GIR_Coverage, 8254,
     /* 249996 */     GIR_EraseRootFromParent_Done,
     /* 249997 */   // Label 5004: @249997
     /* 249997 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(250044), // Rule ID 8255 //
     /* 250002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 250010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250029 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 250032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250040 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250042 */     GIR_RootConstrainSelectedInstOperands,
     /* 250043 */     // GIR_Coverage, 8255,
     /* 250043 */     GIR_EraseRootFromParent_Done,
     /* 250044 */   // Label 5005: @250044
     /* 250044 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(250091), // Rule ID 8256 //
     /* 250049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250076 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 250079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250087 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250089 */     GIR_RootConstrainSelectedInstOperands,
     /* 250090 */     // GIR_Coverage, 8256,
     /* 250090 */     GIR_EraseRootFromParent_Done,
     /* 250091 */   // Label 5006: @250091
     /* 250091 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(250138), // Rule ID 8257 //
     /* 250096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 250107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 250113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 250116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 250119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250123 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 250123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 250126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250134 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250136 */     GIR_RootConstrainSelectedInstOperands,
     /* 250137 */     // GIR_Coverage, 8257,
     /* 250137 */     GIR_EraseRootFromParent_Done,
     /* 250138 */   // Label 5007: @250138
     /* 250138 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(250185), // Rule ID 8258 //
     /* 250143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 250154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 250160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 250163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 250166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250170 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 250170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 250173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250181 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250183 */     GIR_RootConstrainSelectedInstOperands,
     /* 250184 */     // GIR_Coverage, 8258,
     /* 250184 */     GIR_EraseRootFromParent_Done,
     /* 250185 */   // Label 5008: @250185
     /* 250185 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250232), // Rule ID 8259 //
     /* 250190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250217 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 250220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250228 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250230 */     GIR_RootConstrainSelectedInstOperands,
     /* 250231 */     // GIR_Coverage, 8259,
     /* 250231 */     GIR_EraseRootFromParent_Done,
     /* 250232 */   // Label 5009: @250232
     /* 250232 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250279), // Rule ID 8260 //
     /* 250237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 250248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 250254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 250257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 250260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 250264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 250267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250275 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250277 */     GIR_RootConstrainSelectedInstOperands,
     /* 250278 */     // GIR_Coverage, 8260,
     /* 250278 */     GIR_EraseRootFromParent_Done,
     /* 250279 */   // Label 5010: @250279
     /* 250279 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250326), // Rule ID 8261 //
     /* 250284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 250292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250311 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 250314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250322 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250324 */     GIR_RootConstrainSelectedInstOperands,
     /* 250325 */     // GIR_Coverage, 8261,
     /* 250325 */     GIR_EraseRootFromParent_Done,
     /* 250326 */   // Label 5011: @250326
     /* 250326 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250373), // Rule ID 8262 //
     /* 250331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 250339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250358 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 250361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250369 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250371 */     GIR_RootConstrainSelectedInstOperands,
     /* 250372 */     // GIR_Coverage, 8262,
     /* 250372 */     GIR_EraseRootFromParent_Done,
     /* 250373 */   // Label 5012: @250373
     /* 250373 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250420), // Rule ID 8263 //
     /* 250378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 250386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250405 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 250408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250416 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250418 */     GIR_RootConstrainSelectedInstOperands,
     /* 250419 */     // GIR_Coverage, 8263,
     /* 250419 */     GIR_EraseRootFromParent_Done,
     /* 250420 */   // Label 5013: @250420
     /* 250420 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250467), // Rule ID 8264 //
     /* 250425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 250433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 250455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250463 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250465 */     GIR_RootConstrainSelectedInstOperands,
     /* 250466 */     // GIR_Coverage, 8264,
     /* 250466 */     GIR_EraseRootFromParent_Done,
     /* 250467 */   // Label 5014: @250467
     /* 250467 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250514), // Rule ID 8265 //
     /* 250472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 250480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250499 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 250502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250510 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250512 */     GIR_RootConstrainSelectedInstOperands,
     /* 250513 */     // GIR_Coverage, 8265,
     /* 250513 */     GIR_EraseRootFromParent_Done,
     /* 250514 */   // Label 5015: @250514
     /* 250514 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250561), // Rule ID 8266 //
     /* 250519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 250527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250546 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 250549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250557 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250559 */     GIR_RootConstrainSelectedInstOperands,
     /* 250560 */     // GIR_Coverage, 8266,
     /* 250560 */     GIR_EraseRootFromParent_Done,
     /* 250561 */   // Label 5016: @250561
     /* 250561 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250608), // Rule ID 8267 //
     /* 250566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 250574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250593 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 250596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250604 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250606 */     GIR_RootConstrainSelectedInstOperands,
     /* 250607 */     // GIR_Coverage, 8267,
     /* 250607 */     GIR_EraseRootFromParent_Done,
     /* 250608 */   // Label 5017: @250608
     /* 250608 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250655), // Rule ID 8268 //
     /* 250613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 250621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250640 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 250643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250651 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250653 */     GIR_RootConstrainSelectedInstOperands,
     /* 250654 */     // GIR_Coverage, 8268,
     /* 250654 */     GIR_EraseRootFromParent_Done,
     /* 250655 */   // Label 5018: @250655
     /* 250655 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250702), // Rule ID 8269 //
     /* 250660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 250668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250687 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 250690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250698 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250700 */     GIR_RootConstrainSelectedInstOperands,
     /* 250701 */     // GIR_Coverage, 8269,
     /* 250701 */     GIR_EraseRootFromParent_Done,
     /* 250702 */   // Label 5019: @250702
     /* 250702 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250749), // Rule ID 8270 //
     /* 250707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 250715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250734 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 250737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250745 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250747 */     GIR_RootConstrainSelectedInstOperands,
     /* 250748 */     // GIR_Coverage, 8270,
     /* 250748 */     GIR_EraseRootFromParent_Done,
     /* 250749 */   // Label 5020: @250749
     /* 250749 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(250796), // Rule ID 8271 //
     /* 250754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 250777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250781 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 250781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 250784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250792 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250794 */     GIR_RootConstrainSelectedInstOperands,
     /* 250795 */     // GIR_Coverage, 8271,
     /* 250795 */     GIR_EraseRootFromParent_Done,
     /* 250796 */   // Label 5021: @250796
     /* 250796 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(250843), // Rule ID 8274 //
     /* 250801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 250812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 250818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 250821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 250824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250828 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 250828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 250831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250839 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250841 */     GIR_RootConstrainSelectedInstOperands,
     /* 250842 */     // GIR_Coverage, 8274,
     /* 250842 */     GIR_EraseRootFromParent_Done,
     /* 250843 */   // Label 5022: @250843
     /* 250843 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(250890), // Rule ID 8277 //
     /* 250848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 250859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 250865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 250868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 250871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250875 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 250875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 250878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250886 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250888 */     GIR_RootConstrainSelectedInstOperands,
     /* 250889 */     // GIR_Coverage, 8277,
     /* 250889 */     GIR_EraseRootFromParent_Done,
     /* 250890 */   // Label 5023: @250890
     /* 250890 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(250937), // Rule ID 8280 //
     /* 250895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 250918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250922 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 250922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 250925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250933 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250935 */     GIR_RootConstrainSelectedInstOperands,
     /* 250936 */     // GIR_Coverage, 8280,
     /* 250936 */     GIR_EraseRootFromParent_Done,
     /* 250937 */   // Label 5024: @250937
     /* 250937 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(250984), // Rule ID 8283 //
     /* 250942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 250953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 250959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 250962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 250965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250969 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 250969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 250972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250980 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250982 */     GIR_RootConstrainSelectedInstOperands,
     /* 250983 */     // GIR_Coverage, 8283,
     /* 250983 */     GIR_EraseRootFromParent_Done,
     /* 250984 */   // Label 5025: @250984
     /* 250984 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(251031), // Rule ID 8286 //
     /* 250989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 250997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 251016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 251019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251027 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251029 */     GIR_RootConstrainSelectedInstOperands,
     /* 251030 */     // GIR_Coverage, 8286,
     /* 251030 */     GIR_EraseRootFromParent_Done,
     /* 251031 */   // Label 5026: @251031
     /* 251031 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(251078), // Rule ID 8289 //
     /* 251036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251063 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 251063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 251066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251074 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251076 */     GIR_RootConstrainSelectedInstOperands,
     /* 251077 */     // GIR_Coverage, 8289,
     /* 251077 */     GIR_EraseRootFromParent_Done,
     /* 251078 */   // Label 5027: @251078
     /* 251078 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(251125), // Rule ID 8292 //
     /* 251083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 251094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 251100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 251103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 251106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251110 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 251110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 251113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251121 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251123 */     GIR_RootConstrainSelectedInstOperands,
     /* 251124 */     // GIR_Coverage, 8292,
     /* 251124 */     GIR_EraseRootFromParent_Done,
     /* 251125 */   // Label 5028: @251125
     /* 251125 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(251172), // Rule ID 8295 //
     /* 251130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 251141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 251147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 251150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 251153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251157 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 251157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 251160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251168 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251170 */     GIR_RootConstrainSelectedInstOperands,
     /* 251171 */     // GIR_Coverage, 8295,
     /* 251171 */     GIR_EraseRootFromParent_Done,
     /* 251172 */   // Label 5029: @251172
     /* 251172 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(251219), // Rule ID 8298 //
     /* 251177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251204 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 251204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 251207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251215 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251217 */     GIR_RootConstrainSelectedInstOperands,
     /* 251218 */     // GIR_Coverage, 8298,
     /* 251218 */     GIR_EraseRootFromParent_Done,
     /* 251219 */   // Label 5030: @251219
     /* 251219 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251266), // Rule ID 8301 //
     /* 251224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 251235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 251241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 251244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 251247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251251 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 251251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 251254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251262 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251264 */     GIR_RootConstrainSelectedInstOperands,
     /* 251265 */     // GIR_Coverage, 8301,
     /* 251265 */     GIR_EraseRootFromParent_Done,
     /* 251266 */   // Label 5031: @251266
     /* 251266 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251313), // Rule ID 8304 //
     /* 251271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 251279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251298 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 251298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 251301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251309 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251311 */     GIR_RootConstrainSelectedInstOperands,
     /* 251312 */     // GIR_Coverage, 8304,
     /* 251312 */     GIR_EraseRootFromParent_Done,
     /* 251313 */   // Label 5032: @251313
     /* 251313 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251360), // Rule ID 8307 //
     /* 251318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251345 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 251345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 251348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251356 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251358 */     GIR_RootConstrainSelectedInstOperands,
     /* 251359 */     // GIR_Coverage, 8307,
     /* 251359 */     GIR_EraseRootFromParent_Done,
     /* 251360 */   // Label 5033: @251360
     /* 251360 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(251407), // Rule ID 8309 //
     /* 251365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 251376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 251382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 251385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 251388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251392 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 251392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 251395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251403 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251405 */     GIR_RootConstrainSelectedInstOperands,
     /* 251406 */     // GIR_Coverage, 8309,
     /* 251406 */     GIR_EraseRootFromParent_Done,
     /* 251407 */   // Label 5034: @251407
     /* 251407 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(251454), // Rule ID 8311 //
     /* 251412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 251423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 251429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 251432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 251435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251439 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 251439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 251442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251450 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251452 */     GIR_RootConstrainSelectedInstOperands,
     /* 251453 */     // GIR_Coverage, 8311,
     /* 251453 */     GIR_EraseRootFromParent_Done,
     /* 251454 */   // Label 5035: @251454
     /* 251454 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251501), // Rule ID 8313 //
     /* 251459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251486 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 251486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 251489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251497 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251499 */     GIR_RootConstrainSelectedInstOperands,
     /* 251500 */     // GIR_Coverage, 8313,
     /* 251500 */     GIR_EraseRootFromParent_Done,
     /* 251501 */   // Label 5036: @251501
     /* 251501 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251548), // Rule ID 8315 //
     /* 251506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 251517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 251523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 251526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 251529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251533 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 251533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 251536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251544 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251546 */     GIR_RootConstrainSelectedInstOperands,
     /* 251547 */     // GIR_Coverage, 8315,
     /* 251547 */     GIR_EraseRootFromParent_Done,
     /* 251548 */   // Label 5037: @251548
     /* 251548 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251595), // Rule ID 8317 //
     /* 251553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 251556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 251561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251580 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 251580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 251583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251591 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 251593 */     GIR_RootConstrainSelectedInstOperands,
     /* 251594 */     // GIR_Coverage, 8317,
     /* 251594 */     GIR_EraseRootFromParent_Done,
     /* 251595 */   // Label 5038: @251595
     /* 251595 */   GIM_Reject,
     /* 251596 */ // Label 4897: @251596
     /* 251596 */ GIM_Reject,
     /* 251597 */ // Label 38: @251597
     /* 251597 */ GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251675),
     /* 251602 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 251605 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(251627), // Rule ID 78 //
     /* 251610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 251613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 251618 */     // (intrinsic_void 2166:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 251618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 251621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251625 */     GIR_RootConstrainSelectedInstOperands,
     /* 251626 */     // GIR_Coverage, 78,
     /* 251626 */     GIR_EraseRootFromParent_Done,
     /* 251627 */   // Label 5040: @251627
     /* 251627 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(251652), // Rule ID 2386 //
     /* 251632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 251640 */     // (intrinsic_void 1716:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 251640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 251643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 251646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251650 */     GIR_RootConstrainSelectedInstOperands,
     /* 251651 */     // GIR_Coverage, 2386,
     /* 251651 */     GIR_EraseRootFromParent_Done,
     /* 251652 */   // Label 5041: @251652
     /* 251652 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(251674), // Rule ID 7138 //
     /* 251657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 251662 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 251662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 251665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 251668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251672 */     GIR_RootConstrainSelectedInstOperands,
     /* 251673 */     // GIR_Coverage, 7138,
     /* 251673 */     GIR_EraseRootFromParent_Done,
     /* 251674 */   // Label 5042: @251674
     /* 251674 */   GIM_Reject,
     /* 251675 */ // Label 5039: @251675
     /* 251675 */ GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(252275),
     /* 251680 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 251683 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(251715), // Rule ID 79 //
     /* 251688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 251691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 251696 */     // MIs[0] imm
     /* 251696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 251704 */     // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 251704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 251707 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 251709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251713 */     GIR_RootConstrainSelectedInstOperands,
     /* 251714 */     // GIR_Coverage, 79,
     /* 251714 */     GIR_EraseRootFromParent_Done,
     /* 251715 */   // Label 5044: @251715
     /* 251715 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(251740), // Rule ID 227 //
     /* 251720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 251725 */     // MIs[0] imm
     /* 251725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 251733 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 251733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 251736 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 251738 */     GIR_RootConstrainSelectedInstOperands,
     /* 251739 */     // GIR_Coverage, 227,
     /* 251739 */     GIR_EraseRootFromParent_Done,
     /* 251740 */   // Label 5045: @251740
     /* 251740 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(251765), // Rule ID 228 //
     /* 251745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 251750 */     // MIs[0] imm
     /* 251750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 251758 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 251758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 251761 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 251763 */     GIR_RootConstrainSelectedInstOperands,
     /* 251764 */     // GIR_Coverage, 228,
     /* 251764 */     GIR_EraseRootFromParent_Done,
     /* 251765 */   // Label 5046: @251765
     /* 251765 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(251797), // Rule ID 3624 //
     /* 251770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 251773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 251778 */     // MIs[0] imm
     /* 251778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 251786 */     // (intrinsic_void 1222:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 251786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 251789 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 251791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251795 */     GIR_RootConstrainSelectedInstOperands,
     /* 251796 */     // GIR_Coverage, 3624,
     /* 251796 */     GIR_EraseRootFromParent_Done,
     /* 251797 */   // Label 5047: @251797
     /* 251797 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(251837), // Rule ID 16 //
     /* 251802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 251807 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 251810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 251814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 251818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 251822 */     // MIs[1] Operand 1
     /* 251822 */     // No operand predicates
     /* 251822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251824 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 251824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 251827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 251830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251835 */     GIR_RootConstrainSelectedInstOperands,
     /* 251836 */     // GIR_Coverage, 16,
     /* 251836 */     GIR_EraseRootFromParent_Done,
     /* 251837 */   // Label 5048: @251837
     /* 251837 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(251877), // Rule ID 17 //
     /* 251842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 251847 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 251850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 251854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 251858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 251862 */     // MIs[1] Operand 1
     /* 251862 */     // No operand predicates
     /* 251862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251864 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 251864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 251867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 251870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251875 */     GIR_RootConstrainSelectedInstOperands,
     /* 251876 */     // GIR_Coverage, 17,
     /* 251876 */     GIR_EraseRootFromParent_Done,
     /* 251877 */   // Label 5049: @251877
     /* 251877 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(251917), // Rule ID 18 //
     /* 251882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 251887 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 251890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 251894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 251898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 251902 */     // MIs[1] Operand 1
     /* 251902 */     // No operand predicates
     /* 251902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251904 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 251904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 251907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 251910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251915 */     GIR_RootConstrainSelectedInstOperands,
     /* 251916 */     // GIR_Coverage, 18,
     /* 251916 */     GIR_EraseRootFromParent_Done,
     /* 251917 */   // Label 5050: @251917
     /* 251917 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(251957), // Rule ID 19 //
     /* 251922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 251927 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 251930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 251934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 251938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 251942 */     // MIs[1] Operand 1
     /* 251942 */     // No operand predicates
     /* 251942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251944 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 251944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 251947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 251950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251955 */     GIR_RootConstrainSelectedInstOperands,
     /* 251956 */     // GIR_Coverage, 19,
     /* 251956 */     GIR_EraseRootFromParent_Done,
     /* 251957 */   // Label 5051: @251957
     /* 251957 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(251981), // Rule ID 72 //
     /* 251962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 251967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251974 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 251974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 251977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251979 */     GIR_RootConstrainSelectedInstOperands,
     /* 251980 */     // GIR_Coverage, 72,
     /* 251980 */     GIR_EraseRootFromParent_Done,
     /* 251981 */   // Label 5052: @251981
     /* 251981 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(252005), // Rule ID 74 //
     /* 251986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 251991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251998 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 251998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 252001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252003 */     GIR_RootConstrainSelectedInstOperands,
     /* 252004 */     // GIR_Coverage, 74,
     /* 252004 */     GIR_EraseRootFromParent_Done,
     /* 252005 */   // Label 5053: @252005
     /* 252005 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(252036), // Rule ID 77 //
     /* 252010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 252013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 252018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252025 */     // (intrinsic_w_chain:{ *:[i64] } 2167:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 252025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 252028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252034 */     GIR_RootConstrainSelectedInstOperands,
     /* 252035 */     // GIR_Coverage, 77,
     /* 252035 */     GIR_EraseRootFromParent_Done,
     /* 252036 */   // Label 5054: @252036
     /* 252036 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(252063), // Rule ID 80 //
     /* 252041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 252044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 252049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252056 */     // (intrinsic_w_chain:{ *:[i64] } 2168:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 252056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 252059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252061 */     GIR_RootConstrainSelectedInstOperands,
     /* 252062 */     // GIR_Coverage, 80,
     /* 252062 */     GIR_EraseRootFromParent_Done,
     /* 252063 */   // Label 5055: @252063
     /* 252063 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252094), // Rule ID 2385 //
     /* 252068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 252071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 252076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 252079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 252083 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1666:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 252083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 252086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 252088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252092 */     GIR_RootConstrainSelectedInstOperands,
     /* 252093 */     // GIR_Coverage, 2385,
     /* 252093 */     GIR_EraseRootFromParent_Done,
     /* 252094 */   // Label 5056: @252094
     /* 252094 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252134), // Rule ID 12801 //
     /* 252099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 252102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 252107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252114 */     // (intrinsic_w_chain:{ *:[i64] } 891:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 252114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 252117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252119 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 252129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 252132 */     GIR_RootConstrainSelectedInstOperands,
     /* 252133 */     // GIR_Coverage, 12801,
     /* 252133 */     GIR_EraseRootFromParent_Done,
     /* 252134 */   // Label 5057: @252134
     /* 252134 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252168), // Rule ID 2387 //
     /* 252139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 252142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 252147 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 252150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 252154 */     // (intrinsic_void 2146:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 252154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 252157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 252159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 252162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252166 */     GIR_RootConstrainSelectedInstOperands,
     /* 252167 */     // GIR_Coverage, 2387,
     /* 252167 */     GIR_EraseRootFromParent_Done,
     /* 252168 */   // Label 5058: @252168
     /* 252168 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252191), // Rule ID 73 //
     /* 252173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 252178 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 252181 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 252181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 252184 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 252186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 252189 */     GIR_RootConstrainSelectedInstOperands,
     /* 252190 */     // GIR_Coverage, 73,
     /* 252190 */     GIR_EraseRootFromParent_Done,
     /* 252191 */   // Label 5059: @252191
     /* 252191 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(252214), // Rule ID 75 //
     /* 252196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 252201 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 252204 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 252204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 252207 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 252209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 252212 */     GIR_RootConstrainSelectedInstOperands,
     /* 252213 */     // GIR_Coverage, 75,
     /* 252213 */     GIR_EraseRootFromParent_Done,
     /* 252214 */   // Label 5060: @252214
     /* 252214 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(252241), // Rule ID 76 //
     /* 252219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 252224 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 252227 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 252227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 252230 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 252232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 252235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252239 */     GIR_RootConstrainSelectedInstOperands,
     /* 252240 */     // GIR_Coverage, 76,
     /* 252240 */     GIR_EraseRootFromParent_Done,
     /* 252241 */   // Label 5061: @252241
     /* 252241 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(252274), // Rule ID 12800 //
     /* 252246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 252249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 252254 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 252257 */     // (intrinsic_void 966:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 252257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 252260 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 252270 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 252272 */     GIR_RootConstrainSelectedInstOperands,
     /* 252273 */     // GIR_Coverage, 12800,
     /* 252273 */     GIR_EraseRootFromParent_Done,
     /* 252274 */   // Label 5062: @252274
     /* 252274 */   GIM_Reject,
     /* 252275 */ // Label 5043: @252275
     /* 252275 */ GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(253246),
     /* 252280 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 252283 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(252359), // Rule ID 7104 //
     /* 252288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 252293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252300 */     // MIs[0] addr
     /* 252300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 252312 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 252319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252328 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252358 */     // GIR_Coverage, 7104,
     /* 252358 */     GIR_EraseRootFromParent_Done,
     /* 252359 */   // Label 5064: @252359
     /* 252359 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(252435), // Rule ID 7105 //
     /* 252364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 252369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252376 */     // MIs[0] addr
     /* 252376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 252388 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 252395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252404 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252434 */     // GIR_Coverage, 7105,
     /* 252434 */     GIR_EraseRootFromParent_Done,
     /* 252435 */   // Label 5065: @252435
     /* 252435 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(252511), // Rule ID 7106 //
     /* 252440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 252445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252452 */     // MIs[0] addr
     /* 252452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 252464 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 252471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252480 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252510 */     // GIR_Coverage, 7106,
     /* 252510 */     GIR_EraseRootFromParent_Done,
     /* 252511 */   // Label 5066: @252511
     /* 252511 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(252553), // Rule ID 7107 //
     /* 252516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 252521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252528 */     // MIs[0] addr
     /* 252528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 252540 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 252540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 252543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252545 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 252547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252551 */     GIR_RootConstrainSelectedInstOperands,
     /* 252552 */     // GIR_Coverage, 7107,
     /* 252552 */     GIR_EraseRootFromParent_Done,
     /* 252553 */   // Label 5067: @252553
     /* 252553 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(252629), // Rule ID 7111 //
     /* 252558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 252563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252570 */     // MIs[0] addr
     /* 252570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 252582 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 252589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252598 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252628 */     // GIR_Coverage, 7111,
     /* 252628 */     GIR_EraseRootFromParent_Done,
     /* 252629 */   // Label 5068: @252629
     /* 252629 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(252705), // Rule ID 7112 //
     /* 252634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 252639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252646 */     // MIs[0] addr
     /* 252646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 252658 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 252665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252674 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252704 */     // GIR_Coverage, 7112,
     /* 252704 */     GIR_EraseRootFromParent_Done,
     /* 252705 */   // Label 5069: @252705
     /* 252705 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(252781), // Rule ID 7113 //
     /* 252710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 252715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252722 */     // MIs[0] addr
     /* 252722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252730 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 252734 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 252734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 252741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 252750 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 252759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 252770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 252775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252780 */     // GIR_Coverage, 7113,
     /* 252780 */     GIR_EraseRootFromParent_Done,
     /* 252781 */   // Label 5070: @252781
     /* 252781 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(252823), // Rule ID 7114 //
     /* 252786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 252791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252798 */     // MIs[0] addr
     /* 252798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 252810 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 252810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 252813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252815 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 252817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252821 */     GIR_RootConstrainSelectedInstOperands,
     /* 252822 */     // GIR_Coverage, 7114,
     /* 252822 */     GIR_EraseRootFromParent_Done,
     /* 252823 */   // Label 5071: @252823
     /* 252823 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(252863), // Rule ID 20 //
     /* 252828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 252831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 252836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252850 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 252850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 252853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 252855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 252857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252861 */     GIR_RootConstrainSelectedInstOperands,
     /* 252862 */     // GIR_Coverage, 20,
     /* 252862 */     GIR_EraseRootFromParent_Done,
     /* 252863 */   // Label 5072: @252863
     /* 252863 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(252903), // Rule ID 2384 //
     /* 252868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 252871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 252876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 252879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 252886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 252890 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1667:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 252890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 252893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 252895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 252897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252901 */     GIR_RootConstrainSelectedInstOperands,
     /* 252902 */     // GIR_Coverage, 2384,
     /* 252902 */     GIR_EraseRootFromParent_Done,
     /* 252903 */   // Label 5073: @252903
     /* 252903 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(252943), // Rule ID 2495 //
     /* 252908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 252911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 252916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 252919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 252922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252930 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 252930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 252933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 252935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 252937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252941 */     GIR_RootConstrainSelectedInstOperands,
     /* 252942 */     // GIR_Coverage, 2495,
     /* 252942 */     GIR_EraseRootFromParent_Done,
     /* 252943 */   // Label 5074: @252943
     /* 252943 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(252983), // Rule ID 2496 //
     /* 252948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 252951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 252956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 252959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 252962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252970 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 252970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 252973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 252975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 252977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252981 */     GIR_RootConstrainSelectedInstOperands,
     /* 252982 */     // GIR_Coverage, 2496,
     /* 252982 */     GIR_EraseRootFromParent_Done,
     /* 252983 */   // Label 5075: @252983
     /* 252983 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(253023), // Rule ID 6991 //
     /* 252988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 252991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 252996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 252999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 253002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253010 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 253010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 253013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 253017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253021 */     GIR_RootConstrainSelectedInstOperands,
     /* 253022 */     // GIR_Coverage, 6991,
     /* 253022 */     GIR_EraseRootFromParent_Done,
     /* 253023 */   // Label 5076: @253023
     /* 253023 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(253063), // Rule ID 6992 //
     /* 253028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 253031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 253036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 253039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 253042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253050 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 253050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 253053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 253057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253061 */     GIR_RootConstrainSelectedInstOperands,
     /* 253062 */     // GIR_Coverage, 6992,
     /* 253062 */     GIR_EraseRootFromParent_Done,
     /* 253063 */   // Label 5077: @253063
     /* 253063 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(253099), // Rule ID 3577 //
     /* 253068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 253071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 253076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253086 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 253086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 253089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253097 */     GIR_RootConstrainSelectedInstOperands,
     /* 253098 */     // GIR_Coverage, 3577,
     /* 253098 */     GIR_EraseRootFromParent_Done,
     /* 253099 */   // Label 5078: @253099
     /* 253099 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253137), // Rule ID 4001 //
     /* 253104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 253107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 253112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253122 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 253122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 253125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 253133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 253135 */     GIR_RootConstrainSelectedInstOperands,
     /* 253136 */     // GIR_Coverage, 4001,
     /* 253136 */     GIR_EraseRootFromParent_Done,
     /* 253137 */   // Label 5079: @253137
     /* 253137 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253173), // Rule ID 12526 //
     /* 253142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 253145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 253150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253160 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 253160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 253163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253171 */     GIR_RootConstrainSelectedInstOperands,
     /* 253172 */     // GIR_Coverage, 12526,
     /* 253172 */     GIR_EraseRootFromParent_Done,
     /* 253173 */   // Label 5080: @253173
     /* 253173 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253209), // Rule ID 12527 //
     /* 253178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 253181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 253186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253196 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 253196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 253199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253207 */     GIR_RootConstrainSelectedInstOperands,
     /* 253208 */     // GIR_Coverage, 12527,
     /* 253208 */     GIR_EraseRootFromParent_Done,
     /* 253209 */   // Label 5081: @253209
     /* 253209 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253245), // Rule ID 12528 //
     /* 253214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 253217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 253222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253232 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 253232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 253235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253243 */     GIR_RootConstrainSelectedInstOperands,
     /* 253244 */     // GIR_Coverage, 12528,
     /* 253244 */     GIR_EraseRootFromParent_Done,
     /* 253245 */   // Label 5082: @253245
     /* 253245 */   GIM_Reject,
     /* 253246 */ // Label 5063: @253246
     /* 253246 */ GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(257414),
     /* 253251 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 253254 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(253351), // Rule ID 7122 //
     /* 253259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 253282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 253286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 253298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 253302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253307 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 253318 */     // MIs[0] addr
     /* 253318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 253330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253332 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 253335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 253341 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 253349 */     GIR_RootConstrainSelectedInstOperands,
     /* 253350 */     // GIR_Coverage, 7122,
     /* 253350 */     GIR_EraseRootFromParent_Done,
     /* 253351 */   // Label 5084: @253351
     /* 253351 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(253448), // Rule ID 7123 //
     /* 253356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 253379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 253383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 253395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 253399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253404 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 253415 */     // MIs[0] addr
     /* 253415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 253427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253429 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 253432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 253438 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 253446 */     GIR_RootConstrainSelectedInstOperands,
     /* 253447 */     // GIR_Coverage, 7123,
     /* 253447 */     GIR_EraseRootFromParent_Done,
     /* 253448 */   // Label 5085: @253448
     /* 253448 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(253545), // Rule ID 7132 //
     /* 253453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 253476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 253480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 253492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 253496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253501 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 253512 */     // MIs[0] addr
     /* 253512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 253524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253526 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 253529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 253535 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 253543 */     GIR_RootConstrainSelectedInstOperands,
     /* 253544 */     // GIR_Coverage, 7132,
     /* 253544 */     GIR_EraseRootFromParent_Done,
     /* 253545 */   // Label 5086: @253545
     /* 253545 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(253642), // Rule ID 7133 //
     /* 253550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 253573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 253577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 253589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 253593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253598 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 253609 */     // MIs[0] addr
     /* 253609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 253621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253623 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 253626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 253632 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 253640 */     GIR_RootConstrainSelectedInstOperands,
     /* 253641 */     // GIR_Coverage, 7133,
     /* 253641 */     GIR_EraseRootFromParent_Done,
     /* 253642 */   // Label 5087: @253642
     /* 253642 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(253753), // Rule ID 7125 //
     /* 253647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 253674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 253678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253683 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 253694 */     // MIs[0] addr
     /* 253694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 253706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253708 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 253739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253744 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253751 */     GIR_RootConstrainSelectedInstOperands,
     /* 253752 */     // GIR_Coverage, 7125,
     /* 253752 */     GIR_EraseRootFromParent_Done,
     /* 253753 */   // Label 5088: @253753
     /* 253753 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(253864), // Rule ID 7126 //
     /* 253758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 253785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 253789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253794 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 253805 */     // MIs[0] addr
     /* 253805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 253817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253819 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253831 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 253850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253855 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253862 */     GIR_RootConstrainSelectedInstOperands,
     /* 253863 */     // GIR_Coverage, 7126,
     /* 253863 */     GIR_EraseRootFromParent_Done,
     /* 253864 */   // Label 5089: @253864
     /* 253864 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(253975), // Rule ID 7127 //
     /* 253869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 253892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 253896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 253900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253905 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 253916 */     // MIs[0] addr
     /* 253916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 253928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253930 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253942 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 253961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253966 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253973 */     GIR_RootConstrainSelectedInstOperands,
     /* 253974 */     // GIR_Coverage, 7127,
     /* 253974 */     GIR_EraseRootFromParent_Done,
     /* 253975 */   // Label 5090: @253975
     /* 253975 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254086), // Rule ID 7135 //
     /* 253980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 254003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 254007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 254011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254016 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 254027 */     // MIs[0] addr
     /* 254027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 254039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254041 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254053 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 254072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254077 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254084 */     GIR_RootConstrainSelectedInstOperands,
     /* 254085 */     // GIR_Coverage, 7135,
     /* 254085 */     GIR_EraseRootFromParent_Done,
     /* 254086 */   // Label 5091: @254086
     /* 254086 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254197), // Rule ID 7136 //
     /* 254091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 254114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 254118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 254122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254127 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 254138 */     // MIs[0] addr
     /* 254138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 254150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254152 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254164 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 254183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254188 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254195 */     GIR_RootConstrainSelectedInstOperands,
     /* 254196 */     // GIR_Coverage, 7136,
     /* 254196 */     GIR_EraseRootFromParent_Done,
     /* 254197 */   // Label 5092: @254197
     /* 254197 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254308), // Rule ID 7137 //
     /* 254202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 254225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 254229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 254233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254238 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 254249 */     // MIs[0] addr
     /* 254249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 254261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254263 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254275 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 254294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254299 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254306 */     GIR_RootConstrainSelectedInstOperands,
     /* 254307 */     // GIR_Coverage, 7137,
     /* 254307 */     GIR_EraseRootFromParent_Done,
     /* 254308 */   // Label 5093: @254308
     /* 254308 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254359), // Rule ID 70 //
     /* 254313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 254318 */     // MIs[0] ptr
     /* 254318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 254322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 254326 */     // MIs[0] accessinfo
     /* 254326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 254329 */     // MIs[0] fixed_shadow
     /* 254329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254332 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 254332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 254335 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 254337 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 254339 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 254341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 254344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 254347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 254350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 254353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254357 */     GIR_RootConstrainSelectedInstOperands,
     /* 254358 */     // GIR_Coverage, 70,
     /* 254358 */     GIR_EraseRootFromParent_Done,
     /* 254359 */   // Label 5094: @254359
     /* 254359 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254410), // Rule ID 71 //
     /* 254364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 254369 */     // MIs[0] ptr
     /* 254369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 254373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 254377 */     // MIs[0] accessinfo
     /* 254377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 254380 */     // MIs[0] fixed_shadow
     /* 254380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254383 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 254383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 254386 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 254388 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 254390 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 254392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 254395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 254398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 254401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 254404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254408 */     GIR_RootConstrainSelectedInstOperands,
     /* 254409 */     // GIR_Coverage, 71,
     /* 254409 */     GIR_EraseRootFromParent_Done,
     /* 254410 */   // Label 5095: @254410
     /* 254410 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254479), // Rule ID 7124 //
     /* 254415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 254438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 254442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254447 */     // MIs[0] addr
     /* 254447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254455 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 254459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254461 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 254464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 254470 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254477 */     GIR_RootConstrainSelectedInstOperands,
     /* 254478 */     // GIR_Coverage, 7124,
     /* 254478 */     GIR_EraseRootFromParent_Done,
     /* 254479 */   // Label 5096: @254479
     /* 254479 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254548), // Rule ID 7134 //
     /* 254484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 254507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 254511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254516 */     // MIs[0] addr
     /* 254516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 254528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254530 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 254533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 254539 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254546 */     GIR_RootConstrainSelectedInstOperands,
     /* 254547 */     // GIR_Coverage, 7134,
     /* 254547 */     GIR_EraseRootFromParent_Done,
     /* 254548 */   // Label 5097: @254548
     /* 254548 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254590), // Rule ID 3601 //
     /* 254553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 254561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254567 */     // MIs[0] tile
     /* 254567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254575 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 254578 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254588 */     GIR_RootConstrainSelectedInstOperands,
     /* 254589 */     // GIR_Coverage, 3601,
     /* 254589 */     GIR_EraseRootFromParent_Done,
     /* 254590 */   // Label 5098: @254590
     /* 254590 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254632), // Rule ID 3605 //
     /* 254595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 254603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254609 */     // MIs[0] tile
     /* 254609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254617 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 254620 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254630 */     GIR_RootConstrainSelectedInstOperands,
     /* 254631 */     // GIR_Coverage, 3605,
     /* 254631 */     GIR_EraseRootFromParent_Done,
     /* 254632 */   // Label 5099: @254632
     /* 254632 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254674), // Rule ID 3609 //
     /* 254637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 254640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 254645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254651 */     // MIs[0] tile
     /* 254651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254654 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254659 */     // (intrinsic_void 1019:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 254662 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254672 */     GIR_RootConstrainSelectedInstOperands,
     /* 254673 */     // GIR_Coverage, 3609,
     /* 254673 */     GIR_EraseRootFromParent_Done,
     /* 254674 */   // Label 5100: @254674
     /* 254674 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254716), // Rule ID 3779 //
     /* 254679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 254682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 254687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254693 */     // MIs[0] tile
     /* 254693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 254701 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 254701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 254704 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254714 */     GIR_RootConstrainSelectedInstOperands,
     /* 254715 */     // GIR_Coverage, 3779,
     /* 254715 */     GIR_EraseRootFromParent_Done,
     /* 254716 */   // Label 5101: @254716
     /* 254716 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(254758), // Rule ID 3783 //
     /* 254721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 254724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 254729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254735 */     // MIs[0] tile
     /* 254735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254743 */     // (intrinsic_void 875:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 254746 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254756 */     GIR_RootConstrainSelectedInstOperands,
     /* 254757 */     // GIR_Coverage, 3783,
     /* 254757 */     GIR_EraseRootFromParent_Done,
     /* 254758 */   // Label 5102: @254758
     /* 254758 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(254800), // Rule ID 3787 //
     /* 254763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 254771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254777 */     // MIs[0] tile
     /* 254777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254785 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 254785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 254788 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254798 */     GIR_RootConstrainSelectedInstOperands,
     /* 254799 */     // GIR_Coverage, 3787,
     /* 254799 */     GIR_EraseRootFromParent_Done,
     /* 254800 */   // Label 5103: @254800
     /* 254800 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(254842), // Rule ID 3791 //
     /* 254805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 254808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 254813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254819 */     // MIs[0] tile
     /* 254819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254827 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 254827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 254830 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254840 */     GIR_RootConstrainSelectedInstOperands,
     /* 254841 */     // GIR_Coverage, 3791,
     /* 254841 */     GIR_EraseRootFromParent_Done,
     /* 254842 */   // Label 5104: @254842
     /* 254842 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(254884), // Rule ID 3795 //
     /* 254847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 254855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254861 */     // MIs[0] tile
     /* 254861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254869 */     // (intrinsic_void 916:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 254869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 254872 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254882 */     GIR_RootConstrainSelectedInstOperands,
     /* 254883 */     // GIR_Coverage, 3795,
     /* 254883 */     GIR_EraseRootFromParent_Done,
     /* 254884 */   // Label 5105: @254884
     /* 254884 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(254926), // Rule ID 3799 //
     /* 254889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 254892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 254897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254903 */     // MIs[0] tile
     /* 254903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 254911 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 254914 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254924 */     GIR_RootConstrainSelectedInstOperands,
     /* 254925 */     // GIR_Coverage, 3799,
     /* 254925 */     GIR_EraseRootFromParent_Done,
     /* 254926 */   // Label 5106: @254926
     /* 254926 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(254968), // Rule ID 12605 //
     /* 254931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 254939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254945 */     // MIs[0] tile
     /* 254945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254953 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 254956 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254966 */     GIR_RootConstrainSelectedInstOperands,
     /* 254967 */     // GIR_Coverage, 12605,
     /* 254967 */     GIR_EraseRootFromParent_Done,
     /* 254968 */   // Label 5107: @254968
     /* 254968 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255010), // Rule ID 12609 //
     /* 254973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 254981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254987 */     // MIs[0] tile
     /* 254987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254995 */     // (intrinsic_void 1067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 254998 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255008 */     GIR_RootConstrainSelectedInstOperands,
     /* 255009 */     // GIR_Coverage, 12609,
     /* 255009 */     GIR_EraseRootFromParent_Done,
     /* 255010 */   // Label 5108: @255010
     /* 255010 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255052), // Rule ID 12613 //
     /* 255015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 255023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255029 */     // MIs[0] tile
     /* 255029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255037 */     // (intrinsic_void 1075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 255040 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255050 */     GIR_RootConstrainSelectedInstOperands,
     /* 255051 */     // GIR_Coverage, 12613,
     /* 255051 */     GIR_EraseRootFromParent_Done,
     /* 255052 */   // Label 5109: @255052
     /* 255052 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255094), // Rule ID 12617 //
     /* 255057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 255065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255071 */     // MIs[0] tile
     /* 255071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255079 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 255082 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255092 */     GIR_RootConstrainSelectedInstOperands,
     /* 255093 */     // GIR_Coverage, 12617,
     /* 255093 */     GIR_EraseRootFromParent_Done,
     /* 255094 */   // Label 5110: @255094
     /* 255094 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(255136), // Rule ID 12621 //
     /* 255099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 255107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255113 */     // MIs[0] tile
     /* 255113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255121 */     // (intrinsic_void 1192:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 255124 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255134 */     GIR_RootConstrainSelectedInstOperands,
     /* 255135 */     // GIR_Coverage, 12621,
     /* 255135 */     GIR_EraseRootFromParent_Done,
     /* 255136 */   // Label 5111: @255136
     /* 255136 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(255178), // Rule ID 12625 //
     /* 255141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 255149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255155 */     // MIs[0] tile
     /* 255155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255163 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 255166 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255176 */     GIR_RootConstrainSelectedInstOperands,
     /* 255177 */     // GIR_Coverage, 12625,
     /* 255177 */     GIR_EraseRootFromParent_Done,
     /* 255178 */   // Label 5112: @255178
     /* 255178 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255220), // Rule ID 12629 //
     /* 255183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 255191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255197 */     // MIs[0] tile
     /* 255197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255205 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 255205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 255208 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255218 */     GIR_RootConstrainSelectedInstOperands,
     /* 255219 */     // GIR_Coverage, 12629,
     /* 255219 */     GIR_EraseRootFromParent_Done,
     /* 255220 */   // Label 5113: @255220
     /* 255220 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255262), // Rule ID 12633 //
     /* 255225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 255233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255239 */     // MIs[0] tile
     /* 255239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255247 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 255250 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255260 */     GIR_RootConstrainSelectedInstOperands,
     /* 255261 */     // GIR_Coverage, 12633,
     /* 255261 */     GIR_EraseRootFromParent_Done,
     /* 255262 */   // Label 5114: @255262
     /* 255262 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255304), // Rule ID 12637 //
     /* 255267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 255275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255281 */     // MIs[0] tile
     /* 255281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255289 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 255292 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255302 */     GIR_RootConstrainSelectedInstOperands,
     /* 255303 */     // GIR_Coverage, 12637,
     /* 255303 */     GIR_EraseRootFromParent_Done,
     /* 255304 */   // Label 5115: @255304
     /* 255304 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255346), // Rule ID 12641 //
     /* 255309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 255317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255323 */     // MIs[0] tile
     /* 255323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255331 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 255334 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255344 */     GIR_RootConstrainSelectedInstOperands,
     /* 255345 */     // GIR_Coverage, 12641,
     /* 255345 */     GIR_EraseRootFromParent_Done,
     /* 255346 */   // Label 5116: @255346
     /* 255346 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255388), // Rule ID 12645 //
     /* 255351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 255359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255365 */     // MIs[0] tile
     /* 255365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255373 */     // (intrinsic_void 1027:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 255376 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255386 */     GIR_RootConstrainSelectedInstOperands,
     /* 255387 */     // GIR_Coverage, 12645,
     /* 255387 */     GIR_EraseRootFromParent_Done,
     /* 255388 */   // Label 5117: @255388
     /* 255388 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255430), // Rule ID 12649 //
     /* 255393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 255401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255407 */     // MIs[0] tile
     /* 255407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255415 */     // (intrinsic_void 1071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 255418 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255428 */     GIR_RootConstrainSelectedInstOperands,
     /* 255429 */     // GIR_Coverage, 12649,
     /* 255429 */     GIR_EraseRootFromParent_Done,
     /* 255430 */   // Label 5118: @255430
     /* 255430 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255472), // Rule ID 12653 //
     /* 255435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 255443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255449 */     // MIs[0] tile
     /* 255449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255457 */     // (intrinsic_void 1079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 255460 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255470 */     GIR_RootConstrainSelectedInstOperands,
     /* 255471 */     // GIR_Coverage, 12653,
     /* 255471 */     GIR_EraseRootFromParent_Done,
     /* 255472 */   // Label 5119: @255472
     /* 255472 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255514), // Rule ID 12657 //
     /* 255477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 255485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255491 */     // MIs[0] tile
     /* 255491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255499 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 255502 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255512 */     GIR_RootConstrainSelectedInstOperands,
     /* 255513 */     // GIR_Coverage, 12657,
     /* 255513 */     GIR_EraseRootFromParent_Done,
     /* 255514 */   // Label 5120: @255514
     /* 255514 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255556), // Rule ID 12661 //
     /* 255519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 255527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255533 */     // MIs[0] tile
     /* 255533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255541 */     // (intrinsic_void 1162:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 255544 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255554 */     GIR_RootConstrainSelectedInstOperands,
     /* 255555 */     // GIR_Coverage, 12661,
     /* 255555 */     GIR_EraseRootFromParent_Done,
     /* 255556 */   // Label 5121: @255556
     /* 255556 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(255598), // Rule ID 12665 //
     /* 255561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 255569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255575 */     // MIs[0] tile
     /* 255575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255583 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 255586 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255596 */     GIR_RootConstrainSelectedInstOperands,
     /* 255597 */     // GIR_Coverage, 12665,
     /* 255597 */     GIR_EraseRootFromParent_Done,
     /* 255598 */   // Label 5122: @255598
     /* 255598 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(255640), // Rule ID 12669 //
     /* 255603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 255606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 255611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255617 */     // MIs[0] tile
     /* 255617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255625 */     // (intrinsic_void 1196:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 255628 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255638 */     GIR_RootConstrainSelectedInstOperands,
     /* 255639 */     // GIR_Coverage, 12669,
     /* 255639 */     GIR_EraseRootFromParent_Done,
     /* 255640 */   // Label 5123: @255640
     /* 255640 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(255682), // Rule ID 13124 //
     /* 255645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 255653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255659 */     // MIs[0] tile
     /* 255659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255667 */     // (intrinsic_void 924:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 255667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 255670 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255680 */     GIR_RootConstrainSelectedInstOperands,
     /* 255681 */     // GIR_Coverage, 13124,
     /* 255681 */     GIR_EraseRootFromParent_Done,
     /* 255682 */   // Label 5124: @255682
     /* 255682 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(255724), // Rule ID 13128 //
     /* 255687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 255690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 255695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255701 */     // MIs[0] tile
     /* 255701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255709 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 255709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 255712 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255722 */     GIR_RootConstrainSelectedInstOperands,
     /* 255723 */     // GIR_Coverage, 13128,
     /* 255723 */     GIR_EraseRootFromParent_Done,
     /* 255724 */   // Label 5125: @255724
     /* 255724 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(255766), // Rule ID 13132 //
     /* 255729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 255732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 255737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255743 */     // MIs[0] tile
     /* 255743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 255751 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 255751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 255754 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255764 */     GIR_RootConstrainSelectedInstOperands,
     /* 255765 */     // GIR_Coverage, 13132,
     /* 255765 */     GIR_EraseRootFromParent_Done,
     /* 255766 */   // Label 5126: @255766
     /* 255766 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(255808), // Rule ID 13136 //
     /* 255771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 255774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 255779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255785 */     // MIs[0] tile
     /* 255785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255793 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 255793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 255796 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255806 */     GIR_RootConstrainSelectedInstOperands,
     /* 255807 */     // GIR_Coverage, 13136,
     /* 255807 */     GIR_EraseRootFromParent_Done,
     /* 255808 */   // Label 5127: @255808
     /* 255808 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(255862), // Rule ID 8871 //
     /* 255813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 255821 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 255824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255828 */     // MIs[0] base
     /* 255828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255836 */     // MIs[0] prfop
     /* 255836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255844 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 255847 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 255849 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 255851 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 255853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255860 */     GIR_RootConstrainSelectedInstOperands,
     /* 255861 */     // GIR_Coverage, 8871,
     /* 255861 */     GIR_EraseRootFromParent_Done,
     /* 255862 */   // Label 5128: @255862
     /* 255862 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(255916), // Rule ID 8874 //
     /* 255867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 255875 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 255878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255882 */     // MIs[0] base
     /* 255882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255890 */     // MIs[0] prfop
     /* 255890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255898 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 255901 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 255903 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 255905 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 255907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255914 */     GIR_RootConstrainSelectedInstOperands,
     /* 255915 */     // GIR_Coverage, 8874,
     /* 255915 */     GIR_EraseRootFromParent_Done,
     /* 255916 */   // Label 5129: @255916
     /* 255916 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(255970), // Rule ID 8877 //
     /* 255921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 255929 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255936 */     // MIs[0] base
     /* 255936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255944 */     // MIs[0] prfop
     /* 255944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255952 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 255955 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 255957 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 255959 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 255961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255968 */     GIR_RootConstrainSelectedInstOperands,
     /* 255969 */     // GIR_Coverage, 8877,
     /* 255969 */     GIR_EraseRootFromParent_Done,
     /* 255970 */   // Label 5130: @255970
     /* 255970 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(256024), // Rule ID 8880 //
     /* 255975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 255983 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255990 */     // MIs[0] base
     /* 255990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255998 */     // MIs[0] prfop
     /* 255998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256006 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 256006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 256009 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 256011 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 256013 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 256015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256022 */     GIR_RootConstrainSelectedInstOperands,
     /* 256023 */     // GIR_Coverage, 8880,
     /* 256023 */     GIR_EraseRootFromParent_Done,
     /* 256024 */   // Label 5131: @256024
     /* 256024 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256078), // Rule ID 15 //
     /* 256029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 256034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 256037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 256043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 256051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 256055 */     // MIs[1] Operand 1
     /* 256055 */     // No operand predicates
     /* 256055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256061 */     // (intrinsic_w_chain:{ *:[i64] } 1232:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 256061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 256064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 256069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 256076 */     GIR_RootConstrainSelectedInstOperands,
     /* 256077 */     // GIR_Coverage, 15,
     /* 256077 */     GIR_EraseRootFromParent_Done,
     /* 256078 */   // Label 5132: @256078
     /* 256078 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256146), // Rule ID 68 //
     /* 256083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 256088 */     // MIs[0] Operand 1
     /* 256088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 256092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 256096 */     // MIs[0] ptr
     /* 256096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 256104 */     // MIs[0] accessinfo
     /* 256104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256107 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 256107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256111 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 256121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 256124 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 256126 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 256128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 256131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 256134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 256137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 256140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256144 */     GIR_RootConstrainSelectedInstOperands,
     /* 256145 */     // GIR_Coverage, 68,
     /* 256145 */     GIR_EraseRootFromParent_Done,
     /* 256146 */   // Label 5133: @256146
     /* 256146 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256214), // Rule ID 69 //
     /* 256151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 256156 */     // MIs[0] Operand 1
     /* 256156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 256160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 256164 */     // MIs[0] ptr
     /* 256164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 256172 */     // MIs[0] accessinfo
     /* 256172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256175 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 256175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256179 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 256189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 256192 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 256194 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 256196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 256199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 256202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 256205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 256208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256212 */     GIR_RootConstrainSelectedInstOperands,
     /* 256213 */     // GIR_Coverage, 69,
     /* 256213 */     GIR_EraseRootFromParent_Done,
     /* 256214 */   // Label 5134: @256214
     /* 256214 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256294), // Rule ID 7118 //
     /* 256219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 256224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256238 */     // MIs[0] addr
     /* 256238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 256250 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256262 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 256281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256286 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256292 */     GIR_RootConstrainSelectedInstOperands,
     /* 256293 */     // GIR_Coverage, 7118,
     /* 256293 */     GIR_EraseRootFromParent_Done,
     /* 256294 */   // Label 5135: @256294
     /* 256294 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256374), // Rule ID 7119 //
     /* 256299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 256304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256318 */     // MIs[0] addr
     /* 256318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 256330 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256342 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 256361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256366 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256372 */     GIR_RootConstrainSelectedInstOperands,
     /* 256373 */     // GIR_Coverage, 7119,
     /* 256373 */     GIR_EraseRootFromParent_Done,
     /* 256374 */   // Label 5136: @256374
     /* 256374 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256454), // Rule ID 7120 //
     /* 256379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 256384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256398 */     // MIs[0] addr
     /* 256398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 256410 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256422 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 256441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256446 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256452 */     GIR_RootConstrainSelectedInstOperands,
     /* 256453 */     // GIR_Coverage, 7120,
     /* 256453 */     GIR_EraseRootFromParent_Done,
     /* 256454 */   // Label 5137: @256454
     /* 256454 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256505), // Rule ID 7121 //
     /* 256459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 256464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256478 */     // MIs[0] addr
     /* 256478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 256490 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 256490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 256493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256495 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 256497 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256503 */     GIR_RootConstrainSelectedInstOperands,
     /* 256504 */     // GIR_Coverage, 7121,
     /* 256504 */     GIR_EraseRootFromParent_Done,
     /* 256505 */   // Label 5138: @256505
     /* 256505 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(256585), // Rule ID 7128 //
     /* 256510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 256515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256529 */     // MIs[0] addr
     /* 256529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 256541 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256553 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 256572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256577 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256583 */     GIR_RootConstrainSelectedInstOperands,
     /* 256584 */     // GIR_Coverage, 7128,
     /* 256584 */     GIR_EraseRootFromParent_Done,
     /* 256585 */   // Label 5139: @256585
     /* 256585 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(256665), // Rule ID 7129 //
     /* 256590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 256595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256609 */     // MIs[0] addr
     /* 256609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 256621 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256633 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 256652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256657 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256663 */     GIR_RootConstrainSelectedInstOperands,
     /* 256664 */     // GIR_Coverage, 7129,
     /* 256664 */     GIR_EraseRootFromParent_Done,
     /* 256665 */   // Label 5140: @256665
     /* 256665 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(256745), // Rule ID 7130 //
     /* 256670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 256675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256689 */     // MIs[0] addr
     /* 256689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 256701 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 256701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 256704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256713 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 256719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 256732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256737 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256743 */     GIR_RootConstrainSelectedInstOperands,
     /* 256744 */     // GIR_Coverage, 7130,
     /* 256744 */     GIR_EraseRootFromParent_Done,
     /* 256745 */   // Label 5141: @256745
     /* 256745 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(256796), // Rule ID 7131 //
     /* 256750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 256755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256769 */     // MIs[0] addr
     /* 256769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256777 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 256781 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 256781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 256784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256786 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 256788 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 256790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256794 */     GIR_RootConstrainSelectedInstOperands,
     /* 256795 */     // GIR_Coverage, 7131,
     /* 256795 */     GIR_EraseRootFromParent_Done,
     /* 256796 */   // Label 5142: @256796
     /* 256796 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(256845), // Rule ID 2488 //
     /* 256801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 256804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 256809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 256812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 256818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256830 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 256830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 256833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256843 */     GIR_RootConstrainSelectedInstOperands,
     /* 256844 */     // GIR_Coverage, 2488,
     /* 256844 */     GIR_EraseRootFromParent_Done,
     /* 256845 */   // Label 5143: @256845
     /* 256845 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(256894), // Rule ID 2489 //
     /* 256850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 256853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 256858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 256867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256879 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 256879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 256882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256892 */     GIR_RootConstrainSelectedInstOperands,
     /* 256893 */     // GIR_Coverage, 2489,
     /* 256893 */     GIR_EraseRootFromParent_Done,
     /* 256894 */   // Label 5144: @256894
     /* 256894 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(256943), // Rule ID 2490 //
     /* 256899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 256902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 256907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 256910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 256916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256928 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 256928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 256931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256941 */     GIR_RootConstrainSelectedInstOperands,
     /* 256942 */     // GIR_Coverage, 2490,
     /* 256942 */     GIR_EraseRootFromParent_Done,
     /* 256943 */   // Label 5145: @256943
     /* 256943 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(256996), // Rule ID 8757 //
     /* 256948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 256951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 256956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 256962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256970 */     // MIs[0] base
     /* 256970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 256974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256978 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 256978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 256981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 256983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 256985 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 256987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256994 */     GIR_RootConstrainSelectedInstOperands,
     /* 256995 */     // GIR_Coverage, 8757,
     /* 256995 */     GIR_EraseRootFromParent_Done,
     /* 256996 */   // Label 5146: @256996
     /* 256996 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257049), // Rule ID 8760 //
     /* 257001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 257009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257023 */     // MIs[0] base
     /* 257023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257031 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 257034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 257036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257038 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257047 */     GIR_RootConstrainSelectedInstOperands,
     /* 257048 */     // GIR_Coverage, 8760,
     /* 257048 */     GIR_EraseRootFromParent_Done,
     /* 257049 */   // Label 5147: @257049
     /* 257049 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257102), // Rule ID 8769 //
     /* 257054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 257062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257076 */     // MIs[0] base
     /* 257076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257084 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 257087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 257089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257091 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257100 */     GIR_RootConstrainSelectedInstOperands,
     /* 257101 */     // GIR_Coverage, 8769,
     /* 257101 */     GIR_EraseRootFromParent_Done,
     /* 257102 */   // Label 5148: @257102
     /* 257102 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257155), // Rule ID 8772 //
     /* 257107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 257115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257129 */     // MIs[0] base
     /* 257129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257137 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 257140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 257142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257144 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257153 */     GIR_RootConstrainSelectedInstOperands,
     /* 257154 */     // GIR_Coverage, 8772,
     /* 257154 */     GIR_EraseRootFromParent_Done,
     /* 257155 */   // Label 5149: @257155
     /* 257155 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257201), // Rule ID 137 //
     /* 257160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 257163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 257168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 257171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257178 */     // MIs[0] Rn
     /* 257178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257190 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 257190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 257193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257199 */     GIR_RootConstrainSelectedInstOperands,
     /* 257200 */     // GIR_Coverage, 137,
     /* 257200 */     GIR_EraseRootFromParent_Done,
     /* 257201 */   // Label 5150: @257201
     /* 257201 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257254), // Rule ID 8763 //
     /* 257206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 257214 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 257217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257228 */     // MIs[0] base
     /* 257228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257236 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 257239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 257241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257243 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257252 */     GIR_RootConstrainSelectedInstOperands,
     /* 257253 */     // GIR_Coverage, 8763,
     /* 257253 */     GIR_EraseRootFromParent_Done,
     /* 257254 */   // Label 5151: @257254
     /* 257254 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257307), // Rule ID 8766 //
     /* 257259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 257267 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 257270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257281 */     // MIs[0] base
     /* 257281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257289 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 257292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 257294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257296 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257305 */     GIR_RootConstrainSelectedInstOperands,
     /* 257306 */     // GIR_Coverage, 8766,
     /* 257306 */     GIR_EraseRootFromParent_Done,
     /* 257307 */   // Label 5152: @257307
     /* 257307 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(257360), // Rule ID 8775 //
     /* 257312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 257320 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 257323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257334 */     // MIs[0] base
     /* 257334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257342 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 257345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 257347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257349 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257358 */     GIR_RootConstrainSelectedInstOperands,
     /* 257359 */     // GIR_Coverage, 8775,
     /* 257359 */     GIR_EraseRootFromParent_Done,
     /* 257360 */   // Label 5153: @257360
     /* 257360 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(257413), // Rule ID 8778 //
     /* 257365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 257373 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 257376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 257379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257387 */     // MIs[0] base
     /* 257387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 257391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257395 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 257395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 257398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 257400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 257402 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 257404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257411 */     GIR_RootConstrainSelectedInstOperands,
     /* 257412 */     // GIR_Coverage, 8778,
     /* 257412 */     GIR_EraseRootFromParent_Done,
     /* 257413 */   // Label 5154: @257413
     /* 257413 */   GIM_Reject,
     /* 257414 */ // Label 5083: @257414
     /* 257414 */ GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(260119),
     /* 257419 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 257422 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(257493), // Rule ID 3413 //
     /* 257427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 257435 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 257438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 257464 */     // MIs[1] Operand 1
     /* 257464 */     // No operand predicates
     /* 257464 */     // MIs[0] prfop
     /* 257464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257474 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 257474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 257477 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 257483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 257486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 257491 */     GIR_RootConstrainSelectedInstOperands,
     /* 257492 */     // GIR_Coverage, 3413,
     /* 257492 */     GIR_EraseRootFromParent_Done,
     /* 257493 */   // Label 5156: @257493
     /* 257493 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(257564), // Rule ID 3426 //
     /* 257498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 257506 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 257512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 257535 */     // MIs[1] Operand 1
     /* 257535 */     // No operand predicates
     /* 257535 */     // MIs[0] prfop
     /* 257535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257545 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 257545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 257548 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 257554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 257557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 257562 */     GIR_RootConstrainSelectedInstOperands,
     /* 257563 */     // GIR_Coverage, 3426,
     /* 257563 */     GIR_EraseRootFromParent_Done,
     /* 257564 */   // Label 5157: @257564
     /* 257564 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(257623), // Rule ID 3613 //
     /* 257569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 257572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 257577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 257583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257586 */     // MIs[0] tile
     /* 257586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 257594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257606 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 257606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 257609 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257611 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 257613 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 257615 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 257617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257621 */     GIR_RootConstrainSelectedInstOperands,
     /* 257622 */     // GIR_Coverage, 3613,
     /* 257622 */     GIR_EraseRootFromParent_Done,
     /* 257623 */   // Label 5158: @257623
     /* 257623 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(257682), // Rule ID 3614 //
     /* 257628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 257631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 257636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 257642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257645 */     // MIs[0] tile
     /* 257645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 257653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257665 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 257665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 257668 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257670 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 257672 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 257674 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 257676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257680 */     GIR_RootConstrainSelectedInstOperands,
     /* 257681 */     // GIR_Coverage, 3614,
     /* 257681 */     GIR_EraseRootFromParent_Done,
     /* 257682 */   // Label 5159: @257682
     /* 257682 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(257741), // Rule ID 12586 //
     /* 257687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 257690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 257695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 257701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257704 */     // MIs[0] tile
     /* 257704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 257712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257724 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 257724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 257727 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257729 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 257731 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 257733 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 257735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257739 */     GIR_RootConstrainSelectedInstOperands,
     /* 257740 */     // GIR_Coverage, 12586,
     /* 257740 */     GIR_EraseRootFromParent_Done,
     /* 257741 */   // Label 5160: @257741
     /* 257741 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(257800), // Rule ID 12587 //
     /* 257746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 257749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 257754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 257760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257763 */     // MIs[0] tile
     /* 257763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 257771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257783 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 257783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 257786 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257788 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 257790 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 257792 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 257794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257798 */     GIR_RootConstrainSelectedInstOperands,
     /* 257799 */     // GIR_Coverage, 12587,
     /* 257799 */     GIR_EraseRootFromParent_Done,
     /* 257800 */   // Label 5161: @257800
     /* 257800 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(257860), // Rule ID 3411 //
     /* 257805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 257813 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 257816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257823 */     // MIs[0] Rn
     /* 257823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257835 */     // MIs[0] prfop
     /* 257835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257843 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 257843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 257846 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257858 */     GIR_RootConstrainSelectedInstOperands,
     /* 257859 */     // GIR_Coverage, 3411,
     /* 257859 */     GIR_EraseRootFromParent_Done,
     /* 257860 */   // Label 5162: @257860
     /* 257860 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(257920), // Rule ID 3412 //
     /* 257865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 257873 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 257876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257883 */     // MIs[0] Rn
     /* 257883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257895 */     // MIs[0] prfop
     /* 257895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257903 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 257903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 257906 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257918 */     GIR_RootConstrainSelectedInstOperands,
     /* 257919 */     // GIR_Coverage, 3412,
     /* 257919 */     GIR_EraseRootFromParent_Done,
     /* 257920 */   // Label 5163: @257920
     /* 257920 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(257980), // Rule ID 3423 //
     /* 257925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 257933 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257943 */     // MIs[0] Rn
     /* 257943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257955 */     // MIs[0] prfop
     /* 257955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257963 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 257963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 257966 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257978 */     GIR_RootConstrainSelectedInstOperands,
     /* 257979 */     // GIR_Coverage, 3423,
     /* 257979 */     GIR_EraseRootFromParent_Done,
     /* 257980 */   // Label 5164: @257980
     /* 257980 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(258040), // Rule ID 3424 //
     /* 257985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 257993 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258003 */     // MIs[0] Rn
     /* 258003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258015 */     // MIs[0] prfop
     /* 258015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258023 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 258023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 258026 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258038 */     GIR_RootConstrainSelectedInstOperands,
     /* 258039 */     // GIR_Coverage, 3424,
     /* 258039 */     GIR_EraseRootFromParent_Done,
     /* 258040 */   // Label 5165: @258040
     /* 258040 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(258100), // Rule ID 3425 //
     /* 258045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 258053 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258063 */     // MIs[0] Rn
     /* 258063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258075 */     // MIs[0] prfop
     /* 258075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258083 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 258083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 258086 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258098 */     GIR_RootConstrainSelectedInstOperands,
     /* 258099 */     // GIR_Coverage, 3425,
     /* 258099 */     GIR_EraseRootFromParent_Done,
     /* 258100 */   // Label 5166: @258100
     /* 258100 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(258160), // Rule ID 8883 //
     /* 258105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 258113 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258123 */     // MIs[0] Rn
     /* 258123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258135 */     // MIs[0] prfop
     /* 258135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258143 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 258143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 258146 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258158 */     GIR_RootConstrainSelectedInstOperands,
     /* 258159 */     // GIR_Coverage, 8883,
     /* 258159 */     GIR_EraseRootFromParent_Done,
     /* 258160 */   // Label 5167: @258160
     /* 258160 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258220), // Rule ID 8884 //
     /* 258165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 258173 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258183 */     // MIs[0] Rn
     /* 258183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258195 */     // MIs[0] prfop
     /* 258195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258203 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 258203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 258206 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258218 */     GIR_RootConstrainSelectedInstOperands,
     /* 258219 */     // GIR_Coverage, 8884,
     /* 258219 */     GIR_EraseRootFromParent_Done,
     /* 258220 */   // Label 5168: @258220
     /* 258220 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258280), // Rule ID 8885 //
     /* 258225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 258233 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258243 */     // MIs[0] Rn
     /* 258243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258255 */     // MIs[0] prfop
     /* 258255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258263 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 258263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 258266 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258278 */     GIR_RootConstrainSelectedInstOperands,
     /* 258279 */     // GIR_Coverage, 8885,
     /* 258279 */     GIR_EraseRootFromParent_Done,
     /* 258280 */   // Label 5169: @258280
     /* 258280 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258340), // Rule ID 8886 //
     /* 258285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 258293 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258303 */     // MIs[0] Rn
     /* 258303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258315 */     // MIs[0] prfop
     /* 258315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258323 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 258323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 258326 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258338 */     GIR_RootConstrainSelectedInstOperands,
     /* 258339 */     // GIR_Coverage, 8886,
     /* 258339 */     GIR_EraseRootFromParent_Done,
     /* 258340 */   // Label 5170: @258340
     /* 258340 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258400), // Rule ID 8887 //
     /* 258345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 258353 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258363 */     // MIs[0] Rn
     /* 258363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258375 */     // MIs[0] prfop
     /* 258375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258383 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 258383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 258386 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258398 */     GIR_RootConstrainSelectedInstOperands,
     /* 258399 */     // GIR_Coverage, 8887,
     /* 258399 */     GIR_EraseRootFromParent_Done,
     /* 258400 */   // Label 5171: @258400
     /* 258400 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258460), // Rule ID 8888 //
     /* 258405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 258413 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 258416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258423 */     // MIs[0] Rn
     /* 258423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258435 */     // MIs[0] prfop
     /* 258435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258443 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 258443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 258446 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258458 */     GIR_RootConstrainSelectedInstOperands,
     /* 258459 */     // GIR_Coverage, 8888,
     /* 258459 */     GIR_EraseRootFromParent_Done,
     /* 258460 */   // Label 5172: @258460
     /* 258460 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258520), // Rule ID 8889 //
     /* 258465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 258473 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258483 */     // MIs[0] Rn
     /* 258483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258495 */     // MIs[0] prfop
     /* 258495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258503 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 258503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 258506 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258518 */     GIR_RootConstrainSelectedInstOperands,
     /* 258519 */     // GIR_Coverage, 8889,
     /* 258519 */     GIR_EraseRootFromParent_Done,
     /* 258520 */   // Label 5173: @258520
     /* 258520 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(258580), // Rule ID 8890 //
     /* 258525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 258533 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258543 */     // MIs[0] Rn
     /* 258543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258555 */     // MIs[0] prfop
     /* 258555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258563 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 258563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 258566 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258578 */     GIR_RootConstrainSelectedInstOperands,
     /* 258579 */     // GIR_Coverage, 8890,
     /* 258579 */     GIR_EraseRootFromParent_Done,
     /* 258580 */   // Label 5174: @258580
     /* 258580 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(258640), // Rule ID 8891 //
     /* 258585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 258593 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258603 */     // MIs[0] Rn
     /* 258603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258615 */     // MIs[0] prfop
     /* 258615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258623 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 258623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 258626 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258638 */     GIR_RootConstrainSelectedInstOperands,
     /* 258639 */     // GIR_Coverage, 8891,
     /* 258639 */     GIR_EraseRootFromParent_Done,
     /* 258640 */   // Label 5175: @258640
     /* 258640 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(258700), // Rule ID 8892 //
     /* 258645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 258653 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258663 */     // MIs[0] Rn
     /* 258663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258675 */     // MIs[0] prfop
     /* 258675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258683 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 258683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 258686 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258698 */     GIR_RootConstrainSelectedInstOperands,
     /* 258699 */     // GIR_Coverage, 8892,
     /* 258699 */     GIR_EraseRootFromParent_Done,
     /* 258700 */   // Label 5176: @258700
     /* 258700 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(258760), // Rule ID 8893 //
     /* 258705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 258713 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258723 */     // MIs[0] Rn
     /* 258723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258735 */     // MIs[0] prfop
     /* 258735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258743 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 258743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 258746 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258758 */     GIR_RootConstrainSelectedInstOperands,
     /* 258759 */     // GIR_Coverage, 8893,
     /* 258759 */     GIR_EraseRootFromParent_Done,
     /* 258760 */   // Label 5177: @258760
     /* 258760 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(258820), // Rule ID 8894 //
     /* 258765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 258773 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258783 */     // MIs[0] Rn
     /* 258783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258795 */     // MIs[0] prfop
     /* 258795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258803 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 258803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 258806 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258818 */     GIR_RootConstrainSelectedInstOperands,
     /* 258819 */     // GIR_Coverage, 8894,
     /* 258819 */     GIR_EraseRootFromParent_Done,
     /* 258820 */   // Label 5178: @258820
     /* 258820 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(258880), // Rule ID 8895 //
     /* 258825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 258833 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258843 */     // MIs[0] Rn
     /* 258843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258855 */     // MIs[0] prfop
     /* 258855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258863 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 258863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 258866 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258878 */     GIR_RootConstrainSelectedInstOperands,
     /* 258879 */     // GIR_Coverage, 8895,
     /* 258879 */     GIR_EraseRootFromParent_Done,
     /* 258880 */   // Label 5179: @258880
     /* 258880 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(258940), // Rule ID 8896 //
     /* 258885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 258893 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258903 */     // MIs[0] Rn
     /* 258903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258915 */     // MIs[0] prfop
     /* 258915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258923 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 258923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 258926 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258938 */     GIR_RootConstrainSelectedInstOperands,
     /* 258939 */     // GIR_Coverage, 8896,
     /* 258939 */     GIR_EraseRootFromParent_Done,
     /* 258940 */   // Label 5180: @258940
     /* 258940 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(259000), // Rule ID 8897 //
     /* 258945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 258948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 258953 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 258956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258963 */     // MIs[0] Rn
     /* 258963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 258967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 258971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258975 */     // MIs[0] prfop
     /* 258975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 258983 */     // (intrinsic_void 1639:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 258983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 258986 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 258988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 258990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 258994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258998 */     GIR_RootConstrainSelectedInstOperands,
     /* 258999 */     // GIR_Coverage, 8897,
     /* 258999 */     GIR_EraseRootFromParent_Done,
     /* 259000 */   // Label 5181: @259000
     /* 259000 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(259058), // Rule ID 2374 //
     /* 259005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 259013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259041 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 259044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259056 */     GIR_RootConstrainSelectedInstOperands,
     /* 259057 */     // GIR_Coverage, 2374,
     /* 259057 */     GIR_EraseRootFromParent_Done,
     /* 259058 */   // Label 5182: @259058
     /* 259058 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(259116), // Rule ID 2375 //
     /* 259063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 259071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259099 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 259102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259114 */     GIR_RootConstrainSelectedInstOperands,
     /* 259115 */     // GIR_Coverage, 2375,
     /* 259115 */     GIR_EraseRootFromParent_Done,
     /* 259116 */   // Label 5183: @259116
     /* 259116 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259174), // Rule ID 2376 //
     /* 259121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 259129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259157 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 259160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259172 */     GIR_RootConstrainSelectedInstOperands,
     /* 259173 */     // GIR_Coverage, 2376,
     /* 259173 */     GIR_EraseRootFromParent_Done,
     /* 259174 */   // Label 5184: @259174
     /* 259174 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(259232), // Rule ID 2377 //
     /* 259179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 259187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259215 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 259218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259230 */     GIR_RootConstrainSelectedInstOperands,
     /* 259231 */     // GIR_Coverage, 2377,
     /* 259231 */     GIR_EraseRootFromParent_Done,
     /* 259232 */   // Label 5185: @259232
     /* 259232 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(259290), // Rule ID 2378 //
     /* 259237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 259245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259273 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 259276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259288 */     GIR_RootConstrainSelectedInstOperands,
     /* 259289 */     // GIR_Coverage, 2378,
     /* 259289 */     GIR_EraseRootFromParent_Done,
     /* 259290 */   // Label 5186: @259290
     /* 259290 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(259348), // Rule ID 2379 //
     /* 259295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 259303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259331 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 259334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259346 */     GIR_RootConstrainSelectedInstOperands,
     /* 259347 */     // GIR_Coverage, 2379,
     /* 259347 */     GIR_EraseRootFromParent_Done,
     /* 259348 */   // Label 5187: @259348
     /* 259348 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(259406), // Rule ID 2380 //
     /* 259353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 259356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 259361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 259373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259389 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 259389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 259392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259404 */     GIR_RootConstrainSelectedInstOperands,
     /* 259405 */     // GIR_Coverage, 2380,
     /* 259405 */     GIR_EraseRootFromParent_Done,
     /* 259406 */   // Label 5188: @259406
     /* 259406 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(259464), // Rule ID 2381 //
     /* 259411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 259414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 259419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259447 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 259450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259462 */     GIR_RootConstrainSelectedInstOperands,
     /* 259463 */     // GIR_Coverage, 2381,
     /* 259463 */     GIR_EraseRootFromParent_Done,
     /* 259464 */   // Label 5189: @259464
     /* 259464 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(259522), // Rule ID 2382 //
     /* 259469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 259472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 259477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 259480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 259483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 259489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259505 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 259505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 259508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259520 */     GIR_RootConstrainSelectedInstOperands,
     /* 259521 */     // GIR_Coverage, 2382,
     /* 259521 */     GIR_EraseRootFromParent_Done,
     /* 259522 */   // Label 5190: @259522
     /* 259522 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(259580), // Rule ID 2383 //
     /* 259527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 259530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 259535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259563 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 259563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 259566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259578 */     GIR_RootConstrainSelectedInstOperands,
     /* 259579 */     // GIR_Coverage, 2383,
     /* 259579 */     GIR_EraseRootFromParent_Done,
     /* 259580 */   // Label 5191: @259580
     /* 259580 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(259638), // Rule ID 2491 //
     /* 259585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 259588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 259593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259621 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 259621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 259624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259626 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 259628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259636 */     GIR_RootConstrainSelectedInstOperands,
     /* 259637 */     // GIR_Coverage, 2491,
     /* 259637 */     GIR_EraseRootFromParent_Done,
     /* 259638 */   // Label 5192: @259638
     /* 259638 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(259694), // Rule ID 13145 //
     /* 259643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 259648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 259654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259669 */     // MIs[0] addr
     /* 259669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 259673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259677 */     // (intrinsic_w_chain:{ *:[i32] } 1238:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 259677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 259680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 259682 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 259684 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 259686 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 259688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259692 */     GIR_RootConstrainSelectedInstOperands,
     /* 259693 */     // GIR_Coverage, 13145,
     /* 259693 */     GIR_EraseRootFromParent_Done,
     /* 259694 */   // Label 5193: @259694
     /* 259694 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(259750), // Rule ID 13146 //
     /* 259699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 259704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 259710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259725 */     // MIs[0] addr
     /* 259725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 259729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259733 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 259733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 259736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 259738 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 259740 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 259742 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 259744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259748 */     GIR_RootConstrainSelectedInstOperands,
     /* 259749 */     // GIR_Coverage, 13146,
     /* 259749 */     GIR_EraseRootFromParent_Done,
     /* 259750 */   // Label 5194: @259750
     /* 259750 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(259796), // Rule ID 3459 //
     /* 259755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 259758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 259763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259779 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 259782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259794 */     GIR_RootConstrainSelectedInstOperands,
     /* 259795 */     // GIR_Coverage, 3459,
     /* 259795 */     GIR_EraseRootFromParent_Done,
     /* 259796 */   // Label 5195: @259796
     /* 259796 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(259842), // Rule ID 3581 //
     /* 259801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 259809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259825 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 259828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259840 */     GIR_RootConstrainSelectedInstOperands,
     /* 259841 */     // GIR_Coverage, 3581,
     /* 259841 */     GIR_EraseRootFromParent_Done,
     /* 259842 */   // Label 5196: @259842
     /* 259842 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(259888), // Rule ID 12573 //
     /* 259847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 259855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259871 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1515:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 259874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259886 */     GIR_RootConstrainSelectedInstOperands,
     /* 259887 */     // GIR_Coverage, 12573,
     /* 259887 */     GIR_EraseRootFromParent_Done,
     /* 259888 */   // Label 5197: @259888
     /* 259888 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(259934), // Rule ID 12577 //
     /* 259893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 259901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259917 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1507:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 259920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259932 */     GIR_RootConstrainSelectedInstOperands,
     /* 259933 */     // GIR_Coverage, 12577,
     /* 259933 */     GIR_EraseRootFromParent_Done,
     /* 259934 */   // Label 5198: @259934
     /* 259934 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(259980), // Rule ID 12578 //
     /* 259939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 259947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259963 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1509:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 259963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 259966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259978 */     GIR_RootConstrainSelectedInstOperands,
     /* 259979 */     // GIR_Coverage, 12578,
     /* 259979 */     GIR_EraseRootFromParent_Done,
     /* 259980 */   // Label 5199: @259980
     /* 259980 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(260026), // Rule ID 12579 //
     /* 259985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 259993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260009 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 260009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 260012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260024 */     GIR_RootConstrainSelectedInstOperands,
     /* 260025 */     // GIR_Coverage, 12579,
     /* 260025 */     GIR_EraseRootFromParent_Done,
     /* 260026 */   // Label 5200: @260026
     /* 260026 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(260072), // Rule ID 12580 //
     /* 260031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 260039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260055 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 260055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 260058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260070 */     GIR_RootConstrainSelectedInstOperands,
     /* 260071 */     // GIR_Coverage, 12580,
     /* 260071 */     GIR_EraseRootFromParent_Done,
     /* 260072 */   // Label 5201: @260072
     /* 260072 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(260118), // Rule ID 12581 //
     /* 260077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 260080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 260085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260101 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1503:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 260101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 260104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260116 */     GIR_RootConstrainSelectedInstOperands,
     /* 260117 */     // GIR_Coverage, 12581,
     /* 260117 */     GIR_EraseRootFromParent_Done,
     /* 260118 */   // Label 5202: @260118
     /* 260118 */   GIM_Reject,
     /* 260119 */ // Label 5155: @260119
     /* 260119 */ GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(263112),
     /* 260124 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 260127 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(260195), // Rule ID 2518 //
     /* 260132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 260140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260168 */     // MIs[0] Idx
     /* 260168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260176 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 260179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260187 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260193 */     GIR_RootConstrainSelectedInstOperands,
     /* 260194 */     // GIR_Coverage, 2518,
     /* 260194 */     GIR_EraseRootFromParent_Done,
     /* 260195 */   // Label 5204: @260195
     /* 260195 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(260263), // Rule ID 2519 //
     /* 260200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 260208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260236 */     // MIs[0] Idx
     /* 260236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260244 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 260247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260255 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260261 */     GIR_RootConstrainSelectedInstOperands,
     /* 260262 */     // GIR_Coverage, 2519,
     /* 260262 */     GIR_EraseRootFromParent_Done,
     /* 260263 */   // Label 5205: @260263
     /* 260263 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(260331), // Rule ID 2520 //
     /* 260268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 260271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 260276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 260279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 260282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260304 */     // MIs[0] Idx
     /* 260304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260312 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 260315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260323 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260329 */     GIR_RootConstrainSelectedInstOperands,
     /* 260330 */     // GIR_Coverage, 2520,
     /* 260330 */     GIR_EraseRootFromParent_Done,
     /* 260331 */   // Label 5206: @260331
     /* 260331 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(260399), // Rule ID 2521 //
     /* 260336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 260339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 260344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260372 */     // MIs[0] Idx
     /* 260372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260380 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 260383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260391 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260397 */     GIR_RootConstrainSelectedInstOperands,
     /* 260398 */     // GIR_Coverage, 2521,
     /* 260398 */     GIR_EraseRootFromParent_Done,
     /* 260399 */   // Label 5207: @260399
     /* 260399 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(260467), // Rule ID 2522 //
     /* 260404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 260407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 260412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 260415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 260440 */     // MIs[0] Idx
     /* 260440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260448 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 260451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260459 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260465 */     GIR_RootConstrainSelectedInstOperands,
     /* 260466 */     // GIR_Coverage, 2522,
     /* 260466 */     GIR_EraseRootFromParent_Done,
     /* 260467 */   // Label 5208: @260467
     /* 260467 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(260535), // Rule ID 2523 //
     /* 260472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 260475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 260480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 260508 */     // MIs[0] Idx
     /* 260508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260516 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 260519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260527 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260533 */     GIR_RootConstrainSelectedInstOperands,
     /* 260534 */     // GIR_Coverage, 2523,
     /* 260534 */     GIR_EraseRootFromParent_Done,
     /* 260535 */   // Label 5209: @260535
     /* 260535 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(260603), // Rule ID 6993 //
     /* 260540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 260548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260576 */     // MIs[0] Idx
     /* 260576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260584 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 260587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260595 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260601 */     GIR_RootConstrainSelectedInstOperands,
     /* 260602 */     // GIR_Coverage, 6993,
     /* 260602 */     GIR_EraseRootFromParent_Done,
     /* 260603 */   // Label 5210: @260603
     /* 260603 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(260671), // Rule ID 6994 //
     /* 260608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 260616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260644 */     // MIs[0] Idx
     /* 260644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260652 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 260655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260663 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260669 */     GIR_RootConstrainSelectedInstOperands,
     /* 260670 */     // GIR_Coverage, 6994,
     /* 260670 */     GIR_EraseRootFromParent_Done,
     /* 260671 */   // Label 5211: @260671
     /* 260671 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(260739), // Rule ID 6995 //
     /* 260676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 260684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260712 */     // MIs[0] Idx
     /* 260712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260720 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 260723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260731 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260737 */     GIR_RootConstrainSelectedInstOperands,
     /* 260738 */     // GIR_Coverage, 6995,
     /* 260738 */     GIR_EraseRootFromParent_Done,
     /* 260739 */   // Label 5212: @260739
     /* 260739 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(260807), // Rule ID 6996 //
     /* 260744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 260747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 260752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 260764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 260780 */     // MIs[0] Idx
     /* 260780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 260788 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 260788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 260791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 260795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 260797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 260799 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 260801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260805 */     GIR_RootConstrainSelectedInstOperands,
     /* 260806 */     // GIR_Coverage, 6996,
     /* 260806 */     GIR_EraseRootFromParent_Done,
     /* 260807 */   // Label 5213: @260807
     /* 260807 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(260867), // Rule ID 3593 //
     /* 260812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 260820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 260823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 260826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 260832 */     // MIs[0] tile
     /* 260832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260848 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 260848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 260851 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260859 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260865 */     GIR_RootConstrainSelectedInstOperands,
     /* 260866 */     // GIR_Coverage, 3593,
     /* 260866 */     GIR_EraseRootFromParent_Done,
     /* 260867 */   // Label 5214: @260867
     /* 260867 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(260927), // Rule ID 3594 //
     /* 260872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 260875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 260880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260892 */     // MIs[0] tile
     /* 260892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260908 */     // (intrinsic_void 880:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 260911 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260919 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260925 */     GIR_RootConstrainSelectedInstOperands,
     /* 260926 */     // GIR_Coverage, 3594,
     /* 260926 */     GIR_EraseRootFromParent_Done,
     /* 260927 */   // Label 5215: @260927
     /* 260927 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(260987), // Rule ID 3595 //
     /* 260932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 260935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 260940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 260943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 260946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 260952 */     // MIs[0] tile
     /* 260952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260968 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 260968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 260971 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260979 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260985 */     GIR_RootConstrainSelectedInstOperands,
     /* 260986 */     // GIR_Coverage, 3595,
     /* 260986 */     GIR_EraseRootFromParent_Done,
     /* 260987 */   // Label 5216: @260987
     /* 260987 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(261047), // Rule ID 3596 //
     /* 260992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 260995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 261000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261012 */     // MIs[0] tile
     /* 261012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 261020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261028 */     // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 261031 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261039 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261045 */     GIR_RootConstrainSelectedInstOperands,
     /* 261046 */     // GIR_Coverage, 3596,
     /* 261046 */     GIR_EraseRootFromParent_Done,
     /* 261047 */   // Label 5217: @261047
     /* 261047 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(261107), // Rule ID 3597 //
     /* 261052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 261055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 261060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261072 */     // MIs[0] tile
     /* 261072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 261080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261088 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 261088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 261091 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261105 */     GIR_RootConstrainSelectedInstOperands,
     /* 261106 */     // GIR_Coverage, 3597,
     /* 261106 */     GIR_EraseRootFromParent_Done,
     /* 261107 */   // Label 5218: @261107
     /* 261107 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(261167), // Rule ID 3598 //
     /* 261112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 261120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261132 */     // MIs[0] tile
     /* 261132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261148 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 261151 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261159 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261165 */     GIR_RootConstrainSelectedInstOperands,
     /* 261166 */     // GIR_Coverage, 3598,
     /* 261166 */     GIR_EraseRootFromParent_Done,
     /* 261167 */   // Label 5219: @261167
     /* 261167 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261227), // Rule ID 3599 //
     /* 261172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 261175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 261180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261192 */     // MIs[0] tile
     /* 261192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 261200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261208 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 261208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 261211 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261219 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261225 */     GIR_RootConstrainSelectedInstOperands,
     /* 261226 */     // GIR_Coverage, 3599,
     /* 261226 */     GIR_EraseRootFromParent_Done,
     /* 261227 */   // Label 5220: @261227
     /* 261227 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261287), // Rule ID 3600 //
     /* 261232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 261240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261252 */     // MIs[0] tile
     /* 261252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261268 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 261268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 261271 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261279 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261285 */     GIR_RootConstrainSelectedInstOperands,
     /* 261286 */     // GIR_Coverage, 3600,
     /* 261286 */     GIR_EraseRootFromParent_Done,
     /* 261287 */   // Label 5221: @261287
     /* 261287 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261347), // Rule ID 3694 //
     /* 261292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 261295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 261300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261312 */     // MIs[0] tile
     /* 261312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261328 */     // (intrinsic_void 1032:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 261328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 261331 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261339 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261345 */     GIR_RootConstrainSelectedInstOperands,
     /* 261346 */     // GIR_Coverage, 3694,
     /* 261346 */     GIR_EraseRootFromParent_Done,
     /* 261347 */   // Label 5222: @261347
     /* 261347 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(261407), // Rule ID 3695 //
     /* 261352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 261355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 261360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 261366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261372 */     // MIs[0] tile
     /* 261372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261388 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 261388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 261391 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261399 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261405 */     GIR_RootConstrainSelectedInstOperands,
     /* 261406 */     // GIR_Coverage, 3695,
     /* 261406 */     GIR_EraseRootFromParent_Done,
     /* 261407 */   // Label 5223: @261407
     /* 261407 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261467), // Rule ID 12588 //
     /* 261412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 261420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 261426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261432 */     // MIs[0] tile
     /* 261432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261448 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 261448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 261451 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261459 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261465 */     GIR_RootConstrainSelectedInstOperands,
     /* 261466 */     // GIR_Coverage, 12588,
     /* 261466 */     GIR_EraseRootFromParent_Done,
     /* 261467 */   // Label 5224: @261467
     /* 261467 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(261527), // Rule ID 12589 //
     /* 261472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 261475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 261480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 261486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261492 */     // MIs[0] tile
     /* 261492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261495 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 261500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261508 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 261508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 261511 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261519 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261525 */     GIR_RootConstrainSelectedInstOperands,
     /* 261526 */     // GIR_Coverage, 12589,
     /* 261526 */     GIR_EraseRootFromParent_Done,
     /* 261527 */   // Label 5225: @261527
     /* 261527 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(261587), // Rule ID 12590 //
     /* 261532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 261540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261552 */     // MIs[0] tile
     /* 261552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261568 */     // (intrinsic_void 933:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 261568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 261571 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261579 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261585 */     GIR_RootConstrainSelectedInstOperands,
     /* 261586 */     // GIR_Coverage, 12590,
     /* 261586 */     GIR_EraseRootFromParent_Done,
     /* 261587 */   // Label 5226: @261587
     /* 261587 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(261647), // Rule ID 12591 //
     /* 261592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 261600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261612 */     // MIs[0] tile
     /* 261612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261628 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 261631 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261639 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261645 */     GIR_RootConstrainSelectedInstOperands,
     /* 261646 */     // GIR_Coverage, 12591,
     /* 261646 */     GIR_EraseRootFromParent_Done,
     /* 261647 */   // Label 5227: @261647
     /* 261647 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(261707), // Rule ID 12592 //
     /* 261652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 261660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261672 */     // MIs[0] tile
     /* 261672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261688 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 261691 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261699 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261705 */     GIR_RootConstrainSelectedInstOperands,
     /* 261706 */     // GIR_Coverage, 12592,
     /* 261706 */     GIR_EraseRootFromParent_Done,
     /* 261707 */   // Label 5228: @261707
     /* 261707 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(261767), // Rule ID 12593 //
     /* 261712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 261720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261732 */     // MIs[0] tile
     /* 261732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261748 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 261751 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261759 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261765 */     GIR_RootConstrainSelectedInstOperands,
     /* 261766 */     // GIR_Coverage, 12593,
     /* 261766 */     GIR_EraseRootFromParent_Done,
     /* 261767 */   // Label 5229: @261767
     /* 261767 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(261827), // Rule ID 12594 //
     /* 261772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 261780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261792 */     // MIs[0] tile
     /* 261792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261808 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 261811 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261819 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261825 */     GIR_RootConstrainSelectedInstOperands,
     /* 261826 */     // GIR_Coverage, 12594,
     /* 261826 */     GIR_EraseRootFromParent_Done,
     /* 261827 */   // Label 5230: @261827
     /* 261827 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261887), // Rule ID 12595 //
     /* 261832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 261840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261852 */     // MIs[0] tile
     /* 261852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261868 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 261871 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261879 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261885 */     GIR_RootConstrainSelectedInstOperands,
     /* 261886 */     // GIR_Coverage, 12595,
     /* 261886 */     GIR_EraseRootFromParent_Done,
     /* 261887 */   // Label 5231: @261887
     /* 261887 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261947), // Rule ID 12596 //
     /* 261892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 261900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261912 */     // MIs[0] tile
     /* 261912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261928 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 261931 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261939 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261945 */     GIR_RootConstrainSelectedInstOperands,
     /* 261946 */     // GIR_Coverage, 12596,
     /* 261946 */     GIR_EraseRootFromParent_Done,
     /* 261947 */   // Label 5232: @261947
     /* 261947 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(262007), // Rule ID 12597 //
     /* 261952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 261955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 261960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 261966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261972 */     // MIs[0] tile
     /* 261972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261988 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 261988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 261991 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261999 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262005 */     GIR_RootConstrainSelectedInstOperands,
     /* 262006 */     // GIR_Coverage, 12597,
     /* 262006 */     GIR_EraseRootFromParent_Done,
     /* 262007 */   // Label 5233: @262007
     /* 262007 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(262067), // Rule ID 12598 //
     /* 262012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 262020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262032 */     // MIs[0] tile
     /* 262032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262048 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 262051 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262059 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262065 */     GIR_RootConstrainSelectedInstOperands,
     /* 262066 */     // GIR_Coverage, 12598,
     /* 262066 */     GIR_EraseRootFromParent_Done,
     /* 262067 */   // Label 5234: @262067
     /* 262067 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(262127), // Rule ID 12599 //
     /* 262072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 262080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262092 */     // MIs[0] tile
     /* 262092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262108 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 262111 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262119 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262125 */     GIR_RootConstrainSelectedInstOperands,
     /* 262126 */     // GIR_Coverage, 12599,
     /* 262126 */     GIR_EraseRootFromParent_Done,
     /* 262127 */   // Label 5235: @262127
     /* 262127 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(262187), // Rule ID 12600 //
     /* 262132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 262140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262152 */     // MIs[0] tile
     /* 262152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262168 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 262171 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262179 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262185 */     GIR_RootConstrainSelectedInstOperands,
     /* 262186 */     // GIR_Coverage, 12600,
     /* 262186 */     GIR_EraseRootFromParent_Done,
     /* 262187 */   // Label 5236: @262187
     /* 262187 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(262247), // Rule ID 12601 //
     /* 262192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 262200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262212 */     // MIs[0] tile
     /* 262212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262228 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 262231 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262239 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262245 */     GIR_RootConstrainSelectedInstOperands,
     /* 262246 */     // GIR_Coverage, 12601,
     /* 262246 */     GIR_EraseRootFromParent_Done,
     /* 262247 */   // Label 5237: @262247
     /* 262247 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(262307), // Rule ID 12602 //
     /* 262252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 262260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262272 */     // MIs[0] tile
     /* 262272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262288 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 262291 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262299 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262305 */     GIR_RootConstrainSelectedInstOperands,
     /* 262306 */     // GIR_Coverage, 12602,
     /* 262306 */     GIR_EraseRootFromParent_Done,
     /* 262307 */   // Label 5238: @262307
     /* 262307 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(262367), // Rule ID 12603 //
     /* 262312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 262320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262332 */     // MIs[0] tile
     /* 262332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262348 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 262351 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262365 */     GIR_RootConstrainSelectedInstOperands,
     /* 262366 */     // GIR_Coverage, 12603,
     /* 262366 */     GIR_EraseRootFromParent_Done,
     /* 262367 */   // Label 5239: @262367
     /* 262367 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262427), // Rule ID 12604 //
     /* 262372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 262375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 262380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262392 */     // MIs[0] tile
     /* 262392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 262400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262408 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 262411 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262419 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262425 */     GIR_RootConstrainSelectedInstOperands,
     /* 262426 */     // GIR_Coverage, 12604,
     /* 262426 */     GIR_EraseRootFromParent_Done,
     /* 262427 */   // Label 5240: @262427
     /* 262427 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(262487), // Rule ID 12978 //
     /* 262432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 262435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 262440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 262446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262452 */     // MIs[0] tile
     /* 262452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 262460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262468 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 262468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 262471 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262479 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262485 */     GIR_RootConstrainSelectedInstOperands,
     /* 262486 */     // GIR_Coverage, 12978,
     /* 262486 */     GIR_EraseRootFromParent_Done,
     /* 262487 */   // Label 5241: @262487
     /* 262487 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(262547), // Rule ID 12979 //
     /* 262492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 262495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 262500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262512 */     // MIs[0] tile
     /* 262512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 262520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262528 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 262531 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262545 */     GIR_RootConstrainSelectedInstOperands,
     /* 262546 */     // GIR_Coverage, 12979,
     /* 262546 */     GIR_EraseRootFromParent_Done,
     /* 262547 */   // Label 5242: @262547
     /* 262547 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(262607), // Rule ID 12980 //
     /* 262552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 262555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 262560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262572 */     // MIs[0] tile
     /* 262572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 262580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262588 */     // (intrinsic_void 1167:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 262591 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262599 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262605 */     GIR_RootConstrainSelectedInstOperands,
     /* 262606 */     // GIR_Coverage, 12980,
     /* 262606 */     GIR_EraseRootFromParent_Done,
     /* 262607 */   // Label 5243: @262607
     /* 262607 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262667), // Rule ID 12981 //
     /* 262612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 262615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 262620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262632 */     // MIs[0] tile
     /* 262632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 262640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262648 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 262648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 262651 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262659 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262665 */     GIR_RootConstrainSelectedInstOperands,
     /* 262666 */     // GIR_Coverage, 12981,
     /* 262666 */     GIR_EraseRootFromParent_Done,
     /* 262667 */   // Label 5244: @262667
     /* 262667 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262727), // Rule ID 13092 //
     /* 262672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 262675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 262680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 262686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262692 */     // MIs[0] tile
     /* 262692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 262695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 262700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 262708 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 262708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 262711 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 262713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 262715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 262717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 262719 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 262721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262725 */     GIR_RootConstrainSelectedInstOperands,
     /* 262726 */     // GIR_Coverage, 13092,
     /* 262726 */     GIR_EraseRootFromParent_Done,
     /* 262727 */   // Label 5245: @262727
     /* 262727 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262775), // Rule ID 3580 //
     /* 262732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 262735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 262740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262756 */     // MIs[0] Op4
     /* 262756 */     // No operand predicates
     /* 262756 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1506:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 262759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262767 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262773 */     GIR_RootConstrainSelectedInstOperands,
     /* 262774 */     // GIR_Coverage, 3580,
     /* 262774 */     GIR_EraseRootFromParent_Done,
     /* 262775 */   // Label 5246: @262775
     /* 262775 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262823), // Rule ID 3582 //
     /* 262780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 262783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 262788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262804 */     // MIs[0] Op4
     /* 262804 */     // No operand predicates
     /* 262804 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1508:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 262807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262815 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262821 */     GIR_RootConstrainSelectedInstOperands,
     /* 262822 */     // GIR_Coverage, 3582,
     /* 262822 */     GIR_EraseRootFromParent_Done,
     /* 262823 */   // Label 5247: @262823
     /* 262823 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(262871), // Rule ID 3583 //
     /* 262828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 262831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 262836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262852 */     // MIs[0] Op4
     /* 262852 */     // No operand predicates
     /* 262852 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 262855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262863 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262869 */     GIR_RootConstrainSelectedInstOperands,
     /* 262870 */     // GIR_Coverage, 3583,
     /* 262870 */     GIR_EraseRootFromParent_Done,
     /* 262871 */   // Label 5248: @262871
     /* 262871 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(262919), // Rule ID 3584 //
     /* 262876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 262879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 262884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262900 */     // MIs[0] Op4
     /* 262900 */     // No operand predicates
     /* 262900 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1504:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 262903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262917 */     GIR_RootConstrainSelectedInstOperands,
     /* 262918 */     // GIR_Coverage, 3584,
     /* 262918 */     GIR_EraseRootFromParent_Done,
     /* 262919 */   // Label 5249: @262919
     /* 262919 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(262967), // Rule ID 12572 //
     /* 262924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 262927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 262932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262948 */     // MIs[0] Op4
     /* 262948 */     // No operand predicates
     /* 262948 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 262951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262959 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 262965 */     GIR_RootConstrainSelectedInstOperands,
     /* 262966 */     // GIR_Coverage, 12572,
     /* 262966 */     GIR_EraseRootFromParent_Done,
     /* 262967 */   // Label 5250: @262967
     /* 262967 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(263015), // Rule ID 12574 //
     /* 262972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 262975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 262980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262996 */     // MIs[0] Op4
     /* 262996 */     // No operand predicates
     /* 262996 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 262996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 262999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263007 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 263013 */     GIR_RootConstrainSelectedInstOperands,
     /* 263014 */     // GIR_Coverage, 12574,
     /* 263014 */     GIR_EraseRootFromParent_Done,
     /* 263015 */   // Label 5251: @263015
     /* 263015 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(263063), // Rule ID 12575 //
     /* 263020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 263023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 263028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263044 */     // MIs[0] Op4
     /* 263044 */     // No operand predicates
     /* 263044 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1512:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 263044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 263047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263055 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 263061 */     GIR_RootConstrainSelectedInstOperands,
     /* 263062 */     // GIR_Coverage, 12575,
     /* 263062 */     GIR_EraseRootFromParent_Done,
     /* 263063 */   // Label 5252: @263063
     /* 263063 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(263111), // Rule ID 12576 //
     /* 263068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 263071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 263076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263092 */     // MIs[0] Op4
     /* 263092 */     // No operand predicates
     /* 263092 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 263092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 263095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263103 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 263109 */     GIR_RootConstrainSelectedInstOperands,
     /* 263110 */     // GIR_Coverage, 12576,
     /* 263110 */     GIR_EraseRootFromParent_Done,
     /* 263111 */   // Label 5253: @263111
     /* 263111 */   GIM_Reject,
     /* 263112 */ // Label 5203: @263112
     /* 263112 */ GIM_Reject,
     /* 263113 */ // Label 39: @263113
     /* 263113 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5258*/ GIMT_Encode4(263402),
     /* 263124 */ /*GILLT_s64*//*Label 5254*/ GIMT_Encode4(263156), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 263136 */ /*GILLT_v2s64*//*Label 5255*/ GIMT_Encode4(263216), GIMT_Encode4(0),
     /* 263144 */ /*GILLT_v4s32*//*Label 5256*/ GIMT_Encode4(263278), GIMT_Encode4(0),
     /* 263152 */ /*GILLT_v8s16*//*Label 5257*/ GIMT_Encode4(263340),
     /* 263156 */ // Label 5254: @263156
     /* 263156 */ GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(263215), // Rule ID 6505 //
     /* 263161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263172 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 263172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 263186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263194 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 263196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 263199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263209 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263214 */   // GIR_Coverage, 6505,
     /* 263214 */   GIR_EraseRootFromParent_Done,
     /* 263215 */ // Label 5259: @263215
     /* 263215 */ GIM_Reject,
     /* 263216 */ // Label 5255: @263216
     /* 263216 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(263277),
     /* 263221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 263224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263228 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(263255), // Rule ID 6377 //
     /* 263233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 263240 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 263240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 263243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263253 */     GIR_RootConstrainSelectedInstOperands,
     /* 263254 */     // GIR_Coverage, 6377,
     /* 263254 */     GIR_EraseRootFromParent_Done,
     /* 263255 */   // Label 5261: @263255
     /* 263255 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(263276), // Rule ID 6370 //
     /* 263260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263264 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 263264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 263267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263274 */     GIR_RootConstrainSelectedInstOperands,
     /* 263275 */     // GIR_Coverage, 6370,
     /* 263275 */     GIR_EraseRootFromParent_Done,
     /* 263276 */   // Label 5262: @263276
     /* 263276 */   GIM_Reject,
     /* 263277 */ // Label 5260: @263277
     /* 263277 */ GIM_Reject,
     /* 263278 */ // Label 5256: @263278
     /* 263278 */ GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(263339),
     /* 263283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 263286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263290 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(263317), // Rule ID 6374 //
     /* 263295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 263302 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 263302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 263305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263315 */     GIR_RootConstrainSelectedInstOperands,
     /* 263316 */     // GIR_Coverage, 6374,
     /* 263316 */     GIR_EraseRootFromParent_Done,
     /* 263317 */   // Label 5264: @263317
     /* 263317 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(263338), // Rule ID 6367 //
     /* 263322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263326 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 263326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 263329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263336 */     GIR_RootConstrainSelectedInstOperands,
     /* 263337 */     // GIR_Coverage, 6367,
     /* 263337 */     GIR_EraseRootFromParent_Done,
     /* 263338 */   // Label 5265: @263338
     /* 263338 */   GIM_Reject,
     /* 263339 */ // Label 5263: @263339
     /* 263339 */ GIM_Reject,
     /* 263340 */ // Label 5257: @263340
     /* 263340 */ GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(263401),
     /* 263345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 263348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263352 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(263379), // Rule ID 6371 //
     /* 263357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 263364 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 263364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 263367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263377 */     GIR_RootConstrainSelectedInstOperands,
     /* 263378 */     // GIR_Coverage, 6371,
     /* 263378 */     GIR_EraseRootFromParent_Done,
     /* 263379 */   // Label 5267: @263379
     /* 263379 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(263400), // Rule ID 6364 //
     /* 263384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263388 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 263388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 263391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263398 */     GIR_RootConstrainSelectedInstOperands,
     /* 263399 */     // GIR_Coverage, 6364,
     /* 263399 */     GIR_EraseRootFromParent_Done,
     /* 263400 */   // Label 5268: @263400
     /* 263400 */   GIM_Reject,
     /* 263401 */ // Label 5266: @263401
     /* 263401 */ GIM_Reject,
     /* 263402 */ // Label 5258: @263402
     /* 263402 */ GIM_Reject,
     /* 263403 */ // Label 40: @263403
     /* 263403 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5273*/ GIMT_Encode4(264839),
     /* 263414 */ /*GILLT_s32*//*Label 5269*/ GIMT_Encode4(263446), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 263426 */ /*GILLT_v2s32*//*Label 5270*/ GIMT_Encode4(263485), GIMT_Encode4(0),
     /* 263434 */ /*GILLT_v4s16*//*Label 5271*/ GIMT_Encode4(263841), GIMT_Encode4(0),
     /* 263442 */ /*GILLT_v8s8*//*Label 5272*/ GIMT_Encode4(264340),
     /* 263446 */ // Label 5269: @263446
     /* 263446 */ GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263484), // Rule ID 6526 //
     /* 263451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 263454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 263458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 263462 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 263462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263467 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 263473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 263478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 263483 */   // GIR_Coverage, 6526,
     /* 263483 */   GIR_EraseRootFromParent_Done,
     /* 263484 */ // Label 5274: @263484
     /* 263484 */ GIM_Reject,
     /* 263485 */ // Label 5270: @263485
     /* 263485 */ GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263840),
     /* 263490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263497 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263575), // Rule ID 5430 //
     /* 263502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 263522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 263530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 263539 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 263545 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 263547 */     // MIs[1] Operand 2
     /* 263547 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 263558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 263560 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 263560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 263563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263573 */     GIR_RootConstrainSelectedInstOperands,
     /* 263574 */     // GIR_Coverage, 5430,
     /* 263574 */     GIR_EraseRootFromParent_Done,
     /* 263575 */   // Label 5276: @263575
     /* 263575 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263646), // Rule ID 5426 //
     /* 263580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 263600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 263608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263618 */     // MIs[1] Operand 2
     /* 263618 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 263629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263631 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 263631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 263634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263644 */     GIR_RootConstrainSelectedInstOperands,
     /* 263645 */     // GIR_Coverage, 5426,
     /* 263645 */     GIR_EraseRootFromParent_Done,
     /* 263646 */   // Label 5277: @263646
     /* 263646 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263717), // Rule ID 5428 //
     /* 263651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 263671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 263679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263689 */     // MIs[1] Operand 2
     /* 263689 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 263700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263702 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 263702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 263705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263715 */     GIR_RootConstrainSelectedInstOperands,
     /* 263716 */     // GIR_Coverage, 5428,
     /* 263716 */     GIR_EraseRootFromParent_Done,
     /* 263717 */   // Label 5278: @263717
     /* 263717 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(263770), // Rule ID 2162 //
     /* 263722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 263733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263742 */     // MIs[1] imm
     /* 263742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263750 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 263754 */     // MIs[2] Operand 1
     /* 263754 */     // No operand predicates
     /* 263754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263756 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 263756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 263759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263768 */     GIR_RootConstrainSelectedInstOperands,
     /* 263769 */     // GIR_Coverage, 2162,
     /* 263769 */     GIR_EraseRootFromParent_Done,
     /* 263770 */   // Label 5279: @263770
     /* 263770 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(263820), // Rule ID 6352 //
     /* 263775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 263787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263792 */     // MIs[1] imm
     /* 263792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263800 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 263804 */     // MIs[2] Operand 1
     /* 263804 */     // No operand predicates
     /* 263804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263806 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 263806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 263809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263818 */     GIR_RootConstrainSelectedInstOperands,
     /* 263819 */     // GIR_Coverage, 6352,
     /* 263819 */     GIR_EraseRootFromParent_Done,
     /* 263820 */   // Label 5280: @263820
     /* 263820 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(263839), // Rule ID 1099 //
     /* 263825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263832 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 263832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 263837 */     GIR_RootConstrainSelectedInstOperands,
     /* 263838 */     // GIR_Coverage, 1099,
     /* 263838 */     GIR_Done,
     /* 263839 */   // Label 5281: @263839
     /* 263839 */   GIM_Reject,
     /* 263840 */ // Label 5275: @263840
     /* 263840 */ GIM_Reject,
     /* 263841 */ // Label 5271: @263841
     /* 263841 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(264339),
     /* 263846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263853 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(263931), // Rule ID 5424 //
     /* 263858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 263878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 263895 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 263901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 263903 */     // MIs[1] Operand 2
     /* 263903 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 263916 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 263916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 263919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263929 */     GIR_RootConstrainSelectedInstOperands,
     /* 263930 */     // GIR_Coverage, 5424,
     /* 263930 */     GIR_EraseRootFromParent_Done,
     /* 263931 */   // Label 5283: @263931
     /* 263931 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(264002), // Rule ID 5420 //
     /* 263936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 263956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263974 */     // MIs[1] Operand 2
     /* 263974 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263987 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 263987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 263990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264000 */     GIR_RootConstrainSelectedInstOperands,
     /* 264001 */     // GIR_Coverage, 5420,
     /* 264001 */     GIR_EraseRootFromParent_Done,
     /* 264002 */   // Label 5284: @264002
     /* 264002 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(264073), // Rule ID 5422 //
     /* 264007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 264027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 264035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264045 */     // MIs[1] Operand 2
     /* 264045 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 264056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264058 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 264058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 264061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264071 */     GIR_RootConstrainSelectedInstOperands,
     /* 264072 */     // GIR_Coverage, 5422,
     /* 264072 */     GIR_EraseRootFromParent_Done,
     /* 264073 */   // Label 5285: @264073
     /* 264073 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(264165), // Rule ID 5546 //
     /* 264078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 264086 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 264105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 264109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 264118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 264122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 264126 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264133 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 264133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 264136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 264140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 264149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 264153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 264155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 264158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264163 */     GIR_RootConstrainSelectedInstOperands,
     /* 264164 */     // GIR_Coverage, 5546,
     /* 264164 */     GIR_EraseRootFromParent_Done,
     /* 264165 */   // Label 5286: @264165
     /* 264165 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264218), // Rule ID 2161 //
     /* 264170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 264181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264190 */     // MIs[1] imm
     /* 264190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 264202 */     // MIs[2] Operand 1
     /* 264202 */     // No operand predicates
     /* 264202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264204 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 264204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 264207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 264216 */     GIR_RootConstrainSelectedInstOperands,
     /* 264217 */     // GIR_Coverage, 2161,
     /* 264217 */     GIR_EraseRootFromParent_Done,
     /* 264218 */   // Label 5287: @264218
     /* 264218 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(264268), // Rule ID 6351 //
     /* 264223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264240 */     // MIs[1] imm
     /* 264240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 264252 */     // MIs[2] Operand 1
     /* 264252 */     // No operand predicates
     /* 264252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264254 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 264254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 264257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 264266 */     GIR_RootConstrainSelectedInstOperands,
     /* 264267 */     // GIR_Coverage, 6351,
     /* 264267 */     GIR_EraseRootFromParent_Done,
     /* 264268 */   // Label 5288: @264268
     /* 264268 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(264319), // Rule ID 5574 //
     /* 264273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 264281 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264304 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 264304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 264307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 264313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 264317 */     GIR_RootConstrainSelectedInstOperands,
     /* 264318 */     // GIR_Coverage, 5574,
     /* 264318 */     GIR_EraseRootFromParent_Done,
     /* 264319 */   // Label 5289: @264319
     /* 264319 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(264338), // Rule ID 1098 //
     /* 264324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264331 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 264331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 264336 */     GIR_RootConstrainSelectedInstOperands,
     /* 264337 */     // GIR_Coverage, 1098,
     /* 264337 */     GIR_Done,
     /* 264338 */   // Label 5290: @264338
     /* 264338 */   GIM_Reject,
     /* 264339 */ // Label 5282: @264339
     /* 264339 */ GIM_Reject,
     /* 264340 */ // Label 5272: @264340
     /* 264340 */ GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(264838),
     /* 264345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264352 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264430), // Rule ID 5418 //
     /* 264357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 264377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 264394 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 264402 */     // MIs[1] Operand 2
     /* 264402 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 264413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264415 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 264415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 264418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264428 */     GIR_RootConstrainSelectedInstOperands,
     /* 264429 */     // GIR_Coverage, 5418,
     /* 264429 */     GIR_EraseRootFromParent_Done,
     /* 264430 */   // Label 5292: @264430
     /* 264430 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264501), // Rule ID 5414 //
     /* 264435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 264455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264473 */     // MIs[1] Operand 2
     /* 264473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 264484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264486 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 264486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 264489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264499 */     GIR_RootConstrainSelectedInstOperands,
     /* 264500 */     // GIR_Coverage, 5414,
     /* 264500 */     GIR_EraseRootFromParent_Done,
     /* 264501 */   // Label 5293: @264501
     /* 264501 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264572), // Rule ID 5416 //
     /* 264506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 264526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264544 */     // MIs[1] Operand 2
     /* 264544 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 264555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264557 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 264557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 264560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 264570 */     GIR_RootConstrainSelectedInstOperands,
     /* 264571 */     // GIR_Coverage, 5416,
     /* 264571 */     GIR_EraseRootFromParent_Done,
     /* 264572 */   // Label 5294: @264572
     /* 264572 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(264664), // Rule ID 5519 //
     /* 264577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 264585 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 264604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 264617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 264621 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264625 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264632 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 264632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 264635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 264639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 264648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 264652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 264654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 264657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264662 */     GIR_RootConstrainSelectedInstOperands,
     /* 264663 */     // GIR_Coverage, 5519,
     /* 264663 */     GIR_EraseRootFromParent_Done,
     /* 264664 */   // Label 5295: @264664
     /* 264664 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264717), // Rule ID 2160 //
     /* 264669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 264680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264689 */     // MIs[1] imm
     /* 264689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264697 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 264701 */     // MIs[2] Operand 1
     /* 264701 */     // No operand predicates
     /* 264701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264703 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 264703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 264706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 264715 */     GIR_RootConstrainSelectedInstOperands,
     /* 264716 */     // GIR_Coverage, 2160,
     /* 264716 */     GIR_EraseRootFromParent_Done,
     /* 264717 */   // Label 5296: @264717
     /* 264717 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(264767), // Rule ID 6350 //
     /* 264722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 264730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264739 */     // MIs[1] imm
     /* 264739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264747 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 264751 */     // MIs[2] Operand 1
     /* 264751 */     // No operand predicates
     /* 264751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264753 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 264753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 264756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 264765 */     GIR_RootConstrainSelectedInstOperands,
     /* 264766 */     // GIR_Coverage, 6350,
     /* 264766 */     GIR_EraseRootFromParent_Done,
     /* 264767 */   // Label 5297: @264767
     /* 264767 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(264818), // Rule ID 5573 //
     /* 264772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 264780 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264803 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 264803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 264806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 264812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 264816 */     GIR_RootConstrainSelectedInstOperands,
     /* 264817 */     // GIR_Coverage, 5573,
     /* 264817 */     GIR_EraseRootFromParent_Done,
     /* 264818 */   // Label 5298: @264818
     /* 264818 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(264837), // Rule ID 1097 //
     /* 264823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264830 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 264830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 264835 */     GIR_RootConstrainSelectedInstOperands,
     /* 264836 */     // GIR_Coverage, 1097,
     /* 264836 */     GIR_Done,
     /* 264837 */   // Label 5299: @264837
     /* 264837 */   GIM_Reject,
     /* 264838 */ // Label 5291: @264838
     /* 264838 */ GIM_Reject,
     /* 264839 */ // Label 5273: @264839
     /* 264839 */ GIM_Reject,
     /* 264840 */ // Label 41: @264840
     /* 264840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5302*/ GIMT_Encode4(264959),
     /* 264851 */ /*GILLT_s32*//*Label 5300*/ GIMT_Encode4(264859),
     /* 264855 */ /*GILLT_s64*//*Label 5301*/ GIMT_Encode4(264879),
     /* 264859 */ // Label 5300: @264859
     /* 264859 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(264878), // Rule ID 81 //
     /* 264864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264868 */   // MIs[0] Operand 1
     /* 264868 */   // No operand predicates
     /* 264868 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 264868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 264871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264873 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 264876 */   GIR_RootConstrainSelectedInstOperands,
     /* 264877 */   // GIR_Coverage, 81,
     /* 264877 */   GIR_EraseRootFromParent_Done,
     /* 264878 */ // Label 5303: @264878
     /* 264878 */ GIM_Reject,
     /* 264879 */ // Label 5301: @264879
     /* 264879 */ GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(264939), // Rule ID 3905 //
     /* 264884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 264887 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 264891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264895 */   // MIs[0] Operand 1
     /* 264895 */   // No operand predicates
     /* 264895 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 264895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 264898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 264902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264907 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 264912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 264914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 264928 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264938 */   // GIR_Coverage, 3905,
     /* 264938 */   GIR_EraseRootFromParent_Done,
     /* 264939 */ // Label 5304: @264939
     /* 264939 */ GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(264958), // Rule ID 82 //
     /* 264944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264948 */   // MIs[0] Operand 1
     /* 264948 */   // No operand predicates
     /* 264948 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 264948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 264951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264953 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 264956 */   GIR_RootConstrainSelectedInstOperands,
     /* 264957 */   // GIR_Coverage, 82,
     /* 264957 */   GIR_EraseRootFromParent_Done,
     /* 264958 */ // Label 5305: @264958
     /* 264958 */ GIM_Reject,
     /* 264959 */ // Label 5302: @264959
     /* 264959 */ GIM_Reject,
     /* 264960 */ // Label 42: @264960
     /* 264960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5309*/ GIMT_Encode4(265200),
     /* 264971 */ /*GILLT_s16*//*Label 5306*/ GIMT_Encode4(264983),
     /* 264975 */ /*GILLT_s32*//*Label 5307*/ GIMT_Encode4(265035),
     /* 264979 */ /*GILLT_s64*//*Label 5308*/ GIMT_Encode4(265148),
     /* 264983 */ // Label 5306: @264983
     /* 264983 */ GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(265006), // Rule ID 506 //
     /* 264988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 264991 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 264995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264999 */   // MIs[0] Operand 1
     /* 264999 */   // No operand predicates
     /* 264999 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 264999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 265002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265004 */   GIR_RootConstrainSelectedInstOperands,
     /* 265005 */   // GIR_Coverage, 506,
     /* 265005 */   GIR_EraseRootFromParent_Done,
     /* 265006 */ // Label 5310: @265006
     /* 265006 */ GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(265034), // Rule ID 688 //
     /* 265011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 265014 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 265018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265022 */   // MIs[0] Operand 1
     /* 265022 */   // No operand predicates
     /* 265022 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 265022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 265025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265027 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 265032 */   GIR_RootConstrainSelectedInstOperands,
     /* 265033 */   // GIR_Coverage, 688,
     /* 265033 */   GIR_EraseRootFromParent_Done,
     /* 265034 */ // Label 5311: @265034
     /* 265034 */ GIM_Reject,
     /* 265035 */ // Label 5307: @265035
     /* 265035 */ GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(265058), // Rule ID 507 //
     /* 265040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 265043 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 265047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265051 */   // MIs[0] Operand 1
     /* 265051 */   // No operand predicates
     /* 265051 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 265051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 265054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265056 */   GIR_RootConstrainSelectedInstOperands,
     /* 265057 */   // GIR_Coverage, 507,
     /* 265057 */   GIR_EraseRootFromParent_Done,
     /* 265058 */ // Label 5312: @265058
     /* 265058 */ GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(265086), // Rule ID 689 //
     /* 265063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 265066 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 265070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265074 */   // MIs[0] Operand 1
     /* 265074 */   // No operand predicates
     /* 265074 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 265074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 265077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265079 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 265084 */   GIR_RootConstrainSelectedInstOperands,
     /* 265085 */   // GIR_Coverage, 689,
     /* 265085 */   GIR_EraseRootFromParent_Done,
     /* 265086 */ // Label 5313: @265086
     /* 265086 */ GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(265147), // Rule ID 6039 //
     /* 265091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265094 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 265098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265102 */   // MIs[0] Operand 1
     /* 265102 */   // No operand predicates
     /* 265102 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 265102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 265105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 265109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265114 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 265119 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 265122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265129 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 265136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265146 */   // GIR_Coverage, 6039,
     /* 265146 */   GIR_EraseRootFromParent_Done,
     /* 265147 */ // Label 5314: @265147
     /* 265147 */ GIM_Reject,
     /* 265148 */ // Label 5308: @265148
     /* 265148 */ GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(265171), // Rule ID 508 //
     /* 265153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 265156 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 265160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265164 */   // MIs[0] Operand 1
     /* 265164 */   // No operand predicates
     /* 265164 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 265164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 265167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265169 */   GIR_RootConstrainSelectedInstOperands,
     /* 265170 */   // GIR_Coverage, 508,
     /* 265170 */   GIR_EraseRootFromParent_Done,
     /* 265171 */ // Label 5315: @265171
     /* 265171 */ GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(265199), // Rule ID 690 //
     /* 265176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 265179 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 265183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265187 */   // MIs[0] Operand 1
     /* 265187 */   // No operand predicates
     /* 265187 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 265187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 265190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265192 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 265197 */   GIR_RootConstrainSelectedInstOperands,
     /* 265198 */   // GIR_Coverage, 690,
     /* 265198 */   GIR_EraseRootFromParent_Done,
     /* 265199 */ // Label 5316: @265199
     /* 265199 */ GIM_Reject,
     /* 265200 */ // Label 5309: @265200
     /* 265200 */ GIM_Reject,
     /* 265201 */ // Label 43: @265201
     /* 265201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5322*/ GIMT_Encode4(267098),
     /* 265212 */ /*GILLT_s32*//*Label 5317*/ GIMT_Encode4(265248),
     /* 265216 */ /*GILLT_s64*//*Label 5318*/ GIMT_Encode4(266689), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 265228 */ /*GILLT_v2s64*//*Label 5319*/ GIMT_Encode4(266912), GIMT_Encode4(0),
     /* 265236 */ /*GILLT_v4s32*//*Label 5320*/ GIMT_Encode4(266974), GIMT_Encode4(0),
     /* 265244 */ /*GILLT_v8s16*//*Label 5321*/ GIMT_Encode4(267036),
     /* 265248 */ // Label 5317: @265248
     /* 265248 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(265368), // Rule ID 13147 //
     /* 265253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265260 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265268 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265271 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 265276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265280 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265287 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265287 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 265290 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 265294 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265299 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265305 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265308 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265312 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265331 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265334 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265337 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 265340 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265350 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265366 */   GIR_RootConstrainSelectedInstOperands,
     /* 265367 */   // GIR_Coverage, 13147,
     /* 265367 */   GIR_EraseRootFromParent_Done,
     /* 265368 */ // Label 5323: @265368
     /* 265368 */ GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(265488), // Rule ID 13149 //
     /* 265373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265380 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265384 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265388 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265391 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 265396 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265400 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265407 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265407 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 265410 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 265414 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265419 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265425 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265428 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265432 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265439 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265446 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265451 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265454 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265457 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 265460 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265465 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265480 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265486 */   GIR_RootConstrainSelectedInstOperands,
     /* 265487 */   // GIR_Coverage, 13149,
     /* 265487 */   GIR_EraseRootFromParent_Done,
     /* 265488 */ // Label 5324: @265488
     /* 265488 */ GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(265608), // Rule ID 13151 //
     /* 265493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265500 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265508 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265511 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 265516 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265520 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265525 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265527 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265527 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 265530 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 265534 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265539 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265545 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265548 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265552 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265571 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265574 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265577 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 265580 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265585 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265590 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265606 */   GIR_RootConstrainSelectedInstOperands,
     /* 265607 */   // GIR_Coverage, 13151,
     /* 265607 */   GIR_EraseRootFromParent_Done,
     /* 265608 */ // Label 5325: @265608
     /* 265608 */ GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(265728), // Rule ID 13153 //
     /* 265613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265620 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265628 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265631 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 265636 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 265640 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265645 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265647 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265647 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 265650 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 265654 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265659 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265665 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265668 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265672 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265691 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265694 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265697 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 265700 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265710 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265726 */   GIR_RootConstrainSelectedInstOperands,
     /* 265727 */   // GIR_Coverage, 13153,
     /* 265727 */   GIR_EraseRootFromParent_Done,
     /* 265728 */ // Label 5326: @265728
     /* 265728 */ GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(265848), // Rule ID 13169 //
     /* 265733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265740 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265748 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265751 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 265756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265760 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265765 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265767 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265767 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 265770 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 265774 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265779 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265785 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265788 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265792 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265811 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265814 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265817 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 265820 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265825 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265846 */   GIR_RootConstrainSelectedInstOperands,
     /* 265847 */   // GIR_Coverage, 13169,
     /* 265847 */   GIR_EraseRootFromParent_Done,
     /* 265848 */ // Label 5327: @265848
     /* 265848 */ GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(265968), // Rule ID 13171 //
     /* 265853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265860 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265868 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265871 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 265876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265880 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265885 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265887 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265887 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 265890 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 265894 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265899 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265905 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265908 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265912 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265931 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265934 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265937 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 265940 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265950 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265966 */   GIR_RootConstrainSelectedInstOperands,
     /* 265967 */   // GIR_Coverage, 13171,
     /* 265967 */   GIR_EraseRootFromParent_Done,
     /* 265968 */ // Label 5328: @265968
     /* 265968 */ GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(266088), // Rule ID 13173 //
     /* 265973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265980 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265988 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265991 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 265996 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266000 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266007 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266007 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 266010 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 266014 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266019 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266025 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266028 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266032 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266057 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 266060 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266086 */   GIR_RootConstrainSelectedInstOperands,
     /* 266087 */   // GIR_Coverage, 13173,
     /* 266087 */   GIR_EraseRootFromParent_Done,
     /* 266088 */ // Label 5329: @266088
     /* 266088 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(266208), // Rule ID 13175 //
     /* 266093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266100 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266104 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266108 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266111 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 266116 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266120 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266127 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266127 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 266130 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 266134 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266139 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266145 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266148 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266152 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266171 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266174 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266177 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 266180 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266185 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266190 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266206 */   GIR_RootConstrainSelectedInstOperands,
     /* 266207 */   // GIR_Coverage, 13175,
     /* 266207 */   GIR_EraseRootFromParent_Done,
     /* 266208 */ // Label 5330: @266208
     /* 266208 */ GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(266328), // Rule ID 13179 //
     /* 266213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266220 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266228 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266231 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 266236 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266240 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266245 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266247 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266247 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 266250 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 266254 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266259 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266265 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266268 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266272 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266291 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266294 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266297 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 266300 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266305 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266310 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 266318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266326 */   GIR_RootConstrainSelectedInstOperands,
     /* 266327 */   // GIR_Coverage, 13179,
     /* 266327 */   GIR_EraseRootFromParent_Done,
     /* 266328 */ // Label 5331: @266328
     /* 266328 */ GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(266448), // Rule ID 13181 //
     /* 266333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266340 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266348 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266351 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 266356 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266360 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266365 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266367 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266367 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 266370 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 266374 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266379 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266385 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266388 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266392 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266411 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266414 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266417 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 266420 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266425 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266430 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 266438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266446 */   GIR_RootConstrainSelectedInstOperands,
     /* 266447 */   // GIR_Coverage, 13181,
     /* 266447 */   GIR_EraseRootFromParent_Done,
     /* 266448 */ // Label 5332: @266448
     /* 266448 */ GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(266568), // Rule ID 13183 //
     /* 266453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266460 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266468 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266471 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 266476 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266480 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266487 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266487 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 266490 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 266494 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266499 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266505 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266508 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266512 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266531 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266534 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266537 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 266540 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266545 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266566 */   GIR_RootConstrainSelectedInstOperands,
     /* 266567 */   // GIR_Coverage, 13183,
     /* 266567 */   GIR_EraseRootFromParent_Done,
     /* 266568 */ // Label 5333: @266568
     /* 266568 */ GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(266688), // Rule ID 13185 //
     /* 266573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266580 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266584 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266588 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266591 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 266596 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266600 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266607 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 266607 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 266610 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 266614 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266619 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266625 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266628 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266632 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266651 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266654 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 266657 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 266660 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266665 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266670 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266686 */   GIR_RootConstrainSelectedInstOperands,
     /* 266687 */   // GIR_Coverage, 13185,
     /* 266687 */   GIR_EraseRootFromParent_Done,
     /* 266688 */ // Label 5334: @266688
     /* 266688 */ GIM_Reject,
     /* 266689 */ // Label 5318: @266689
     /* 266689 */ GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(266911),
     /* 266694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266701 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(266755), // Rule ID 5657 //
     /* 266706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 266718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 266739 */     // MIs[2] Operand 1
     /* 266739 */     // No operand predicates
     /* 266739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266741 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 266741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 266744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 266753 */     GIR_RootConstrainSelectedInstOperands,
     /* 266754 */     // GIR_Coverage, 5657,
     /* 266754 */     GIR_EraseRootFromParent_Done,
     /* 266755 */   // Label 5336: @266755
     /* 266755 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(266834), // Rule ID 11252 //
     /* 266760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 266763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 266775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266787 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 266791 */     // MIs[2] Operand 1
     /* 266791 */     // No operand predicates
     /* 266791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266793 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 266793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 266796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266805 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 266811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 266824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 266832 */     GIR_RootConstrainSelectedInstOperands,
     /* 266833 */     // GIR_Coverage, 11252,
     /* 266833 */     GIR_EraseRootFromParent_Done,
     /* 266834 */   // Label 5337: @266834
     /* 266834 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(266910), // Rule ID 6507 //
     /* 266839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266843 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 266843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 266846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 266860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266869 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 266876 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 266879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 266908 */     GIR_RootConstrainSelectedInstOperands,
     /* 266909 */     // GIR_Coverage, 6507,
     /* 266909 */     GIR_EraseRootFromParent_Done,
     /* 266910 */   // Label 5338: @266910
     /* 266910 */   GIM_Reject,
     /* 266911 */ // Label 5335: @266911
     /* 266911 */ GIM_Reject,
     /* 266912 */ // Label 5319: @266912
     /* 266912 */ GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(266973),
     /* 266917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 266920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266924 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(266951), // Rule ID 6379 //
     /* 266929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 266936 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 266936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 266939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 266946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266949 */     GIR_RootConstrainSelectedInstOperands,
     /* 266950 */     // GIR_Coverage, 6379,
     /* 266950 */     GIR_EraseRootFromParent_Done,
     /* 266951 */   // Label 5340: @266951
     /* 266951 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(266972), // Rule ID 6368 //
     /* 266956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266960 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 266960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 266963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266970 */     GIR_RootConstrainSelectedInstOperands,
     /* 266971 */     // GIR_Coverage, 6368,
     /* 266971 */     GIR_EraseRootFromParent_Done,
     /* 266972 */   // Label 5341: @266972
     /* 266972 */   GIM_Reject,
     /* 266973 */ // Label 5339: @266973
     /* 266973 */ GIM_Reject,
     /* 266974 */ // Label 5320: @266974
     /* 266974 */ GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(267035),
     /* 266979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 266982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266986 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(267013), // Rule ID 6376 //
     /* 266991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 266998 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 266998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 267001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267011 */     GIR_RootConstrainSelectedInstOperands,
     /* 267012 */     // GIR_Coverage, 6376,
     /* 267012 */     GIR_EraseRootFromParent_Done,
     /* 267013 */   // Label 5343: @267013
     /* 267013 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(267034), // Rule ID 6365 //
     /* 267018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267022 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 267022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 267025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 267029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267032 */     GIR_RootConstrainSelectedInstOperands,
     /* 267033 */     // GIR_Coverage, 6365,
     /* 267033 */     GIR_EraseRootFromParent_Done,
     /* 267034 */   // Label 5344: @267034
     /* 267034 */   GIM_Reject,
     /* 267035 */ // Label 5342: @267035
     /* 267035 */ GIM_Reject,
     /* 267036 */ // Label 5321: @267036
     /* 267036 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(267097),
     /* 267041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 267044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267048 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(267075), // Rule ID 6373 //
     /* 267053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 267060 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 267060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 267063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267073 */     GIR_RootConstrainSelectedInstOperands,
     /* 267074 */     // GIR_Coverage, 6373,
     /* 267074 */     GIR_EraseRootFromParent_Done,
     /* 267075 */   // Label 5346: @267075
     /* 267075 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(267096), // Rule ID 6362 //
     /* 267080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267084 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 267084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 267087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 267091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267094 */     GIR_RootConstrainSelectedInstOperands,
     /* 267095 */     // GIR_Coverage, 6362,
     /* 267095 */     GIR_EraseRootFromParent_Done,
     /* 267096 */   // Label 5347: @267096
     /* 267096 */   GIM_Reject,
     /* 267097 */ // Label 5345: @267097
     /* 267097 */ GIM_Reject,
     /* 267098 */ // Label 5322: @267098
     /* 267098 */ GIM_Reject,
     /* 267099 */ // Label 44: @267099
     /* 267099 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5353*/ GIMT_Encode4(268752),
     /* 267110 */ /*GILLT_s32*//*Label 5348*/ GIMT_Encode4(267190),
     /* 267114 */ /*GILLT_s64*//*Label 5349*/ GIMT_Encode4(267684), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 267166 */ /*GILLT_nxv2s64*//*Label 5350*/ GIMT_Encode4(268326), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 267178 */ /*GILLT_nxv4s32*//*Label 5351*/ GIMT_Encode4(268535), GIMT_Encode4(0),
     /* 267186 */ /*GILLT_nxv8s16*//*Label 5352*/ GIMT_Encode4(268679),
     /* 267190 */ // Label 5348: @267190
     /* 267190 */ GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(267683),
     /* 267195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 267198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267202 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(267267), // Rule ID 5652 //
     /* 267207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 267219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267236 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 267240 */     // MIs[2] Operand 1
     /* 267240 */     // No operand predicates
     /* 267240 */     // MIs[0] Operand 2
     /* 267240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267253 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 267253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 267256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 267262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 267265 */     GIR_RootConstrainSelectedInstOperands,
     /* 267266 */     // GIR_Coverage, 5652,
     /* 267266 */     GIR_EraseRootFromParent_Done,
     /* 267267 */   // Label 5355: @267267
     /* 267267 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(267332), // Rule ID 5654 //
     /* 267272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 267284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 267305 */     // MIs[2] Operand 1
     /* 267305 */     // No operand predicates
     /* 267305 */     // MIs[0] Operand 2
     /* 267305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267318 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 267318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 267321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 267327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 267330 */     GIR_RootConstrainSelectedInstOperands,
     /* 267331 */     // GIR_Coverage, 5654,
     /* 267331 */     GIR_EraseRootFromParent_Done,
     /* 267332 */   // Label 5356: @267332
     /* 267332 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(267397), // Rule ID 5656 //
     /* 267337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 267349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267366 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 267370 */     // MIs[2] Operand 1
     /* 267370 */     // No operand predicates
     /* 267370 */     // MIs[0] Operand 2
     /* 267370 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267383 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 267383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 267386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 267392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 267395 */     GIR_RootConstrainSelectedInstOperands,
     /* 267396 */     // GIR_Coverage, 5656,
     /* 267396 */     GIR_EraseRootFromParent_Done,
     /* 267397 */   // Label 5357: @267397
     /* 267397 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(267487), // Rule ID 11248 //
     /* 267402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 267417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 267433 */     // MIs[2] Operand 1
     /* 267433 */     // No operand predicates
     /* 267433 */     // MIs[0] Operand 2
     /* 267433 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267446 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 267446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 267449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267458 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 267464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 267477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 267485 */     GIR_RootConstrainSelectedInstOperands,
     /* 267486 */     // GIR_Coverage, 11248,
     /* 267486 */     GIR_EraseRootFromParent_Done,
     /* 267487 */   // Label 5358: @267487
     /* 267487 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(267577), // Rule ID 11250 //
     /* 267492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 267507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 267515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267519 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 267523 */     // MIs[2] Operand 1
     /* 267523 */     // No operand predicates
     /* 267523 */     // MIs[0] Operand 2
     /* 267523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267536 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 267536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 267539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267548 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 267554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 267567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 267575 */     GIR_RootConstrainSelectedInstOperands,
     /* 267576 */     // GIR_Coverage, 11250,
     /* 267576 */     GIR_EraseRootFromParent_Done,
     /* 267577 */   // Label 5359: @267577
     /* 267577 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(267612), // Rule ID 6512 //
     /* 267582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267586 */     // MIs[0] Operand 2
     /* 267586 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267597 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 267597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 267600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 267604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 267610 */     GIR_RootConstrainSelectedInstOperands,
     /* 267611 */     // GIR_Coverage, 6512,
     /* 267611 */     GIR_EraseRootFromParent_Done,
     /* 267612 */   // Label 5360: @267612
     /* 267612 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(267647), // Rule ID 6513 //
     /* 267617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267621 */     // MIs[0] Operand 2
     /* 267621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267632 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 267632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 267635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267637 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 267639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 267645 */     GIR_RootConstrainSelectedInstOperands,
     /* 267646 */     // GIR_Coverage, 6513,
     /* 267646 */     GIR_EraseRootFromParent_Done,
     /* 267647 */   // Label 5361: @267647
     /* 267647 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(267682), // Rule ID 6514 //
     /* 267652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267656 */     // MIs[0] Operand 2
     /* 267656 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 267667 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 267667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 267670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 267674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267680 */     GIR_RootConstrainSelectedInstOperands,
     /* 267681 */     // GIR_Coverage, 6514,
     /* 267681 */     GIR_EraseRootFromParent_Done,
     /* 267682 */   // Label 5362: @267682
     /* 267682 */   GIM_Reject,
     /* 267683 */ // Label 5354: @267683
     /* 267683 */ GIM_Reject,
     /* 267684 */ // Label 5349: @267684
     /* 267684 */ GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(268325),
     /* 267689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 267692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267696 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(267773), // Rule ID 5658 //
     /* 267701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 267709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 267725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 267729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 267738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 267746 */     // MIs[3] Operand 1
     /* 267746 */     // No operand predicates
     /* 267746 */     // MIs[0] Operand 2
     /* 267746 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 267759 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 267759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 267762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 267768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 267771 */     GIR_RootConstrainSelectedInstOperands,
     /* 267772 */     // GIR_Coverage, 5658,
     /* 267772 */     GIR_EraseRootFromParent_Done,
     /* 267773 */   // Label 5364: @267773
     /* 267773 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(267850), // Rule ID 5659 //
     /* 267778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 267786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 267802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 267806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 267815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267819 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 267823 */     // MIs[3] Operand 1
     /* 267823 */     // No operand predicates
     /* 267823 */     // MIs[0] Operand 2
     /* 267823 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 267836 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 267836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 267839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 267845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 267848 */     GIR_RootConstrainSelectedInstOperands,
     /* 267849 */     // GIR_Coverage, 5659,
     /* 267849 */     GIR_EraseRootFromParent_Done,
     /* 267850 */   // Label 5365: @267850
     /* 267850 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(267952), // Rule ID 11249 //
     /* 267855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 267866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 267882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 267886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 267890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267894 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 267898 */     // MIs[3] Operand 1
     /* 267898 */     // No operand predicates
     /* 267898 */     // MIs[0] Operand 2
     /* 267898 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 267911 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 267911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 267914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267923 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 267929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 267942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 267950 */     GIR_RootConstrainSelectedInstOperands,
     /* 267951 */     // GIR_Coverage, 11249,
     /* 267951 */     GIR_EraseRootFromParent_Done,
     /* 267952 */   // Label 5366: @267952
     /* 267952 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(268054), // Rule ID 11251 //
     /* 267957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 267968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 267980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 267984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 267988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 267992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 267996 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 268000 */     // MIs[3] Operand 1
     /* 268000 */     // No operand predicates
     /* 268000 */     // MIs[0] Operand 2
     /* 268000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 268013 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 268013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 268016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268025 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 268031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 268044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 268052 */     GIR_RootConstrainSelectedInstOperands,
     /* 268053 */     // GIR_Coverage, 11251,
     /* 268053 */     GIR_EraseRootFromParent_Done,
     /* 268054 */   // Label 5367: @268054
     /* 268054 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(268119), // Rule ID 5653 //
     /* 268059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 268067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 268071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 268084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 268092 */     // MIs[2] Operand 1
     /* 268092 */     // No operand predicates
     /* 268092 */     // MIs[0] Operand 2
     /* 268092 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 268105 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 268105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 268108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 268114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 268117 */     GIR_RootConstrainSelectedInstOperands,
     /* 268118 */     // GIR_Coverage, 5653,
     /* 268118 */     GIR_EraseRootFromParent_Done,
     /* 268119 */   // Label 5368: @268119
     /* 268119 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(268184), // Rule ID 5655 //
     /* 268124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 268132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 268136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 268149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 268157 */     // MIs[2] Operand 1
     /* 268157 */     // No operand predicates
     /* 268157 */     // MIs[0] Operand 2
     /* 268157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 268170 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 268170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 268173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 268179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 268182 */     GIR_RootConstrainSelectedInstOperands,
     /* 268183 */     // GIR_Coverage, 5655,
     /* 268183 */     GIR_EraseRootFromParent_Done,
     /* 268184 */   // Label 5369: @268184
     /* 268184 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(268219), // Rule ID 6508 //
     /* 268189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268193 */     // MIs[0] Operand 2
     /* 268193 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 268204 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 268204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 268207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268209 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 268211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 268217 */     GIR_RootConstrainSelectedInstOperands,
     /* 268218 */     // GIR_Coverage, 6508,
     /* 268218 */     GIR_EraseRootFromParent_Done,
     /* 268219 */   // Label 5370: @268219
     /* 268219 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(268254), // Rule ID 6509 //
     /* 268224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268228 */     // MIs[0] Operand 2
     /* 268228 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268239 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 268239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 268242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268244 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 268246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 268252 */     GIR_RootConstrainSelectedInstOperands,
     /* 268253 */     // GIR_Coverage, 6509,
     /* 268253 */     GIR_EraseRootFromParent_Done,
     /* 268254 */   // Label 5371: @268254
     /* 268254 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(268289), // Rule ID 6510 //
     /* 268259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268263 */     // MIs[0] Operand 2
     /* 268263 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268274 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 268274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 268277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268279 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 268281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 268287 */     GIR_RootConstrainSelectedInstOperands,
     /* 268288 */     // GIR_Coverage, 6510,
     /* 268288 */     GIR_EraseRootFromParent_Done,
     /* 268289 */   // Label 5372: @268289
     /* 268289 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(268324), // Rule ID 6511 //
     /* 268294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268298 */     // MIs[0] Operand 2
     /* 268298 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 268309 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 268309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 268312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 268316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268322 */     GIR_RootConstrainSelectedInstOperands,
     /* 268323 */     // GIR_Coverage, 6511,
     /* 268323 */     GIR_EraseRootFromParent_Done,
     /* 268324 */   // Label 5373: @268324
     /* 268324 */   GIM_Reject,
     /* 268325 */ // Label 5363: @268325
     /* 268325 */ GIM_Reject,
     /* 268326 */ // Label 5350: @268326
     /* 268326 */ GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(268534),
     /* 268331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 268334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268338 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(268403), // Rule ID 10520 //
     /* 268343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268346 */     // MIs[0] Operand 2
     /* 268346 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 268357 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 268357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 268364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268369 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 268391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268401 */     GIR_RootConstrainSelectedInstOperands,
     /* 268402 */     // GIR_Coverage, 10520,
     /* 268402 */     GIR_EraseRootFromParent_Done,
     /* 268403 */   // Label 5375: @268403
     /* 268403 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(268468), // Rule ID 10521 //
     /* 268408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268411 */     // MIs[0] Operand 2
     /* 268411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268422 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 268422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 268429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268434 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 268456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268466 */     GIR_RootConstrainSelectedInstOperands,
     /* 268467 */     // GIR_Coverage, 10521,
     /* 268467 */     GIR_EraseRootFromParent_Done,
     /* 268468 */   // Label 5376: @268468
     /* 268468 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(268533), // Rule ID 10522 //
     /* 268473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268476 */     // MIs[0] Operand 2
     /* 268476 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268487 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 268487 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268490 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 268494 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268499 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 268521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268531 */     GIR_RootConstrainSelectedInstOperands,
     /* 268532 */     // GIR_Coverage, 10522,
     /* 268532 */     GIR_EraseRootFromParent_Done,
     /* 268533 */   // Label 5377: @268533
     /* 268533 */   GIM_Reject,
     /* 268534 */ // Label 5374: @268534
     /* 268534 */ GIM_Reject,
     /* 268535 */ // Label 5351: @268535
     /* 268535 */ GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(268678),
     /* 268540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 268543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268547 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(268612), // Rule ID 10523 //
     /* 268552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268555 */     // MIs[0] Operand 2
     /* 268555 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 268566 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 268566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 268573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 268600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268610 */     GIR_RootConstrainSelectedInstOperands,
     /* 268611 */     // GIR_Coverage, 10523,
     /* 268611 */     GIR_EraseRootFromParent_Done,
     /* 268612 */   // Label 5379: @268612
     /* 268612 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(268677), // Rule ID 10524 //
     /* 268617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268620 */     // MIs[0] Operand 2
     /* 268620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268631 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 268631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 268638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268643 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 268665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268675 */     GIR_RootConstrainSelectedInstOperands,
     /* 268676 */     // GIR_Coverage, 10524,
     /* 268676 */     GIR_EraseRootFromParent_Done,
     /* 268677 */   // Label 5380: @268677
     /* 268677 */   GIM_Reject,
     /* 268678 */ // Label 5378: @268678
     /* 268678 */ GIM_Reject,
     /* 268679 */ // Label 5352: @268679
     /* 268679 */ GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(268751), // Rule ID 10525 //
     /* 268684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 268690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268694 */   // MIs[0] Operand 2
     /* 268694 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 268705 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 268705 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 268708 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 268712 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268717 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 268720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 268722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 268725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 268739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 268747 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 268749 */   GIR_RootConstrainSelectedInstOperands,
     /* 268750 */   // GIR_Coverage, 10525,
     /* 268750 */   GIR_EraseRootFromParent_Done,
     /* 268751 */ // Label 5381: @268751
     /* 268751 */ GIM_Reject,
     /* 268752 */ // Label 5353: @268752
     /* 268752 */ GIM_Reject,
     /* 268753 */ // Label 45: @268753
     /* 268753 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5386*/ GIMT_Encode4(271531),
     /* 268764 */ /*GILLT_s32*//*Label 5382*/ GIMT_Encode4(268800), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 268780 */ /*GILLT_v2s64*//*Label 5383*/ GIMT_Encode4(270601), GIMT_Encode4(0),
     /* 268788 */ /*GILLT_v4s32*//*Label 5384*/ GIMT_Encode4(270911), GIMT_Encode4(0),
     /* 268796 */ /*GILLT_v8s16*//*Label 5385*/ GIMT_Encode4(271221),
     /* 268800 */ // Label 5382: @268800
     /* 268800 */ GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(268950), // Rule ID 13156 //
     /* 268805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 268808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268812 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268820 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268823 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 268828 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268832 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268837 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268839 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268839 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 268842 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 268846 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268851 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268857 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268860 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268864 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268871 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268874 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268878 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268883 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268886 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268889 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 268892 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268897 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268902 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 268907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268919 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268926 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268949 */   // GIR_Coverage, 13156,
     /* 268949 */   GIR_EraseRootFromParent_Done,
     /* 268950 */ // Label 5387: @268950
     /* 268950 */ GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(269100), // Rule ID 13158 //
     /* 268955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 268958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268962 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268966 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268970 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268973 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 268978 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 268982 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268987 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268989 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268989 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 268992 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 268996 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269001 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269007 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269010 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269014 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269033 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269036 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269039 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 269042 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269047 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269052 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 269057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269069 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269094 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269099 */   // GIR_Coverage, 13158,
     /* 269099 */   GIR_EraseRootFromParent_Done,
     /* 269100 */ // Label 5388: @269100
     /* 269100 */ GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(269250), // Rule ID 13160 //
     /* 269105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 269108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269112 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269120 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269123 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 269128 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269132 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269137 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269139 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269139 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 269142 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 269146 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269151 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269157 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269160 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269164 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269171 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269174 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269178 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269183 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269186 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269189 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269192 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269197 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269202 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269219 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269226 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269249 */   // GIR_Coverage, 13160,
     /* 269249 */   GIR_EraseRootFromParent_Done,
     /* 269250 */ // Label 5389: @269250
     /* 269250 */ GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(269400), // Rule ID 13162 //
     /* 269255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 269258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269262 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269270 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269273 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 269278 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269282 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269287 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269289 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269289 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 269292 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 269296 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269301 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269307 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269310 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269314 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269321 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269324 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269328 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269333 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269336 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269339 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269342 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269347 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269352 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269369 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269376 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269381 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269399 */   // GIR_Coverage, 13162,
     /* 269399 */   GIR_EraseRootFromParent_Done,
     /* 269400 */ // Label 5390: @269400
     /* 269400 */ GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(269550), // Rule ID 13189 //
     /* 269405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 269408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269412 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269420 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269423 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 269428 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269432 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269437 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269439 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269439 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 269442 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 269446 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269451 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269457 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269460 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269464 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269471 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269474 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269478 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269483 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269486 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269489 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 269492 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269497 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269502 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 269507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269519 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269526 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269531 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269549 */   // GIR_Coverage, 13189,
     /* 269549 */   GIR_EraseRootFromParent_Done,
     /* 269550 */ // Label 5391: @269550
     /* 269550 */ GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(269700), // Rule ID 13191 //
     /* 269555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 269558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269562 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269570 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269573 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 269578 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 269582 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269587 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269589 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269589 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 269592 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 269596 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269601 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269607 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269610 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269614 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269621 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269624 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269628 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269633 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269636 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269639 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 269642 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269647 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269652 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 269657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269669 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269681 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269699 */   // GIR_Coverage, 13191,
     /* 269699 */   GIR_EraseRootFromParent_Done,
     /* 269700 */ // Label 5392: @269700
     /* 269700 */ GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(269850), // Rule ID 13193 //
     /* 269705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 269708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269712 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269716 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269720 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269723 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 269728 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269732 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269739 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269739 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 269742 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 269746 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269751 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269757 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269760 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269764 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269771 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269774 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269778 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269783 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269786 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269789 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269792 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269797 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269802 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269819 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269826 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269844 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269849 */   // GIR_Coverage, 13193,
     /* 269849 */   GIR_EraseRootFromParent_Done,
     /* 269850 */ // Label 5393: @269850
     /* 269850 */ GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(270000), // Rule ID 13195 //
     /* 269855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 269858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269862 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269870 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 269873 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 269878 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269882 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269889 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 269889 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 269892 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 269896 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269901 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269907 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 269910 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269914 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269921 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269924 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269928 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269933 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269936 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269939 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269942 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269947 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269952 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269969 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269976 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269981 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269999 */   // GIR_Coverage, 13195,
     /* 269999 */   GIR_EraseRootFromParent_Done,
     /* 270000 */ // Label 5394: @270000
     /* 270000 */ GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(270150), // Rule ID 13199 //
     /* 270005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 270008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270012 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270016 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270020 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 270023 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 270028 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 270032 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270037 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270039 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 270039 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 270042 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 270046 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270051 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270057 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 270060 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270064 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 270071 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 270074 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270078 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270083 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 270086 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 270089 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 270092 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270097 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270102 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 270107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270119 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 270126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 270131 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 270141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270149 */   // GIR_Coverage, 13199,
     /* 270149 */   GIR_EraseRootFromParent_Done,
     /* 270150 */ // Label 5395: @270150
     /* 270150 */ GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(270300), // Rule ID 13201 //
     /* 270155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 270158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270162 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270170 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 270173 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 270178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270182 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270189 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 270189 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 270192 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 270196 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270201 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270207 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 270210 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270214 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 270221 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 270224 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270228 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270233 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 270236 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 270239 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 270242 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270247 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270252 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 270257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270269 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 270276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 270281 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 270291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270294 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270299 */   // GIR_Coverage, 13201,
     /* 270299 */   GIR_EraseRootFromParent_Done,
     /* 270300 */ // Label 5396: @270300
     /* 270300 */ GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(270450), // Rule ID 13203 //
     /* 270305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 270308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270312 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270320 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 270323 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 270328 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270332 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270337 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270339 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 270339 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 270342 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 270346 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270351 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270357 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 270360 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270364 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 270371 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 270374 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270378 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270383 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 270386 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 270389 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 270392 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270397 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270402 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 270407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270419 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 270426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 270431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 270441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270449 */   // GIR_Coverage, 13203,
     /* 270449 */   GIR_EraseRootFromParent_Done,
     /* 270450 */ // Label 5397: @270450
     /* 270450 */ GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(270600), // Rule ID 13205 //
     /* 270455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 270458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270462 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270466 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270470 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 270473 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 270478 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270482 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270489 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 270489 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 270492 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 270496 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270501 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270507 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 270510 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270514 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 270521 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 270524 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270528 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270533 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 270536 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 270539 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 270542 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270547 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270552 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 270557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270569 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 270576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 270581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 270591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270599 */   // GIR_Coverage, 13205,
     /* 270599 */   GIR_EraseRootFromParent_Done,
     /* 270600 */ // Label 5398: @270600
     /* 270600 */ GIM_Reject,
     /* 270601 */ // Label 5383: @270601
     /* 270601 */ GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(270910),
     /* 270606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 270609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270613 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(270678), // Rule ID 702 //
     /* 270618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270629 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270632 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 270637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270641 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270661 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 270661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 270664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 270671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 270676 */     GIR_RootConstrainSelectedInstOperands,
     /* 270677 */     // GIR_Coverage, 702,
     /* 270677 */     GIR_EraseRootFromParent_Done,
     /* 270678 */   // Label 5400: @270678
     /* 270678 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(270743), // Rule ID 1711 //
     /* 270683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270694 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270697 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 270702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270706 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270726 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 270726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 270729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 270736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 270741 */     GIR_RootConstrainSelectedInstOperands,
     /* 270742 */     // GIR_Coverage, 1711,
     /* 270742 */     GIR_EraseRootFromParent_Done,
     /* 270743 */   // Label 5401: @270743
     /* 270743 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(270802), // Rule ID 700 //
     /* 270748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270759 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270762 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 270767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270771 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270787 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 270787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 270790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 270800 */     GIR_RootConstrainSelectedInstOperands,
     /* 270801 */     // GIR_Coverage, 700,
     /* 270801 */     GIR_EraseRootFromParent_Done,
     /* 270802 */   // Label 5402: @270802
     /* 270802 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(270861), // Rule ID 1709 //
     /* 270807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270818 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270821 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 270826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270830 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270846 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 270846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 270849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 270855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 270859 */     GIR_RootConstrainSelectedInstOperands,
     /* 270860 */     // GIR_Coverage, 1709,
     /* 270860 */     GIR_EraseRootFromParent_Done,
     /* 270861 */   // Label 5403: @270861
     /* 270861 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(270888), // Rule ID 6378 //
     /* 270866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 270873 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 270873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 270876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 270883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270886 */     GIR_RootConstrainSelectedInstOperands,
     /* 270887 */     // GIR_Coverage, 6378,
     /* 270887 */     GIR_EraseRootFromParent_Done,
     /* 270888 */   // Label 5404: @270888
     /* 270888 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(270909), // Rule ID 6369 //
     /* 270893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270897 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 270897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 270900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270907 */     GIR_RootConstrainSelectedInstOperands,
     /* 270908 */     // GIR_Coverage, 6369,
     /* 270908 */     GIR_EraseRootFromParent_Done,
     /* 270909 */   // Label 5405: @270909
     /* 270909 */   GIM_Reject,
     /* 270910 */ // Label 5399: @270910
     /* 270910 */ GIM_Reject,
     /* 270911 */ // Label 5384: @270911
     /* 270911 */ GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(271220),
     /* 270916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 270919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270923 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(270988), // Rule ID 698 //
     /* 270928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 270939 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 270942 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 270947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270951 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 270955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 270964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 270971 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 270971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 270974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 270981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 270986 */     GIR_RootConstrainSelectedInstOperands,
     /* 270987 */     // GIR_Coverage, 698,
     /* 270987 */     GIR_EraseRootFromParent_Done,
     /* 270988 */   // Label 5407: @270988
     /* 270988 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(271053), // Rule ID 1707 //
     /* 270993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271004 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271007 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 271012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 271020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 271029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 271036 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 271036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 271039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 271051 */     GIR_RootConstrainSelectedInstOperands,
     /* 271052 */     // GIR_Coverage, 1707,
     /* 271052 */     GIR_EraseRootFromParent_Done,
     /* 271053 */   // Label 5408: @271053
     /* 271053 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(271112), // Rule ID 696 //
     /* 271058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271069 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271072 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 271077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271081 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 271085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271097 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 271097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 271100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 271106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 271110 */     GIR_RootConstrainSelectedInstOperands,
     /* 271111 */     // GIR_Coverage, 696,
     /* 271111 */     GIR_EraseRootFromParent_Done,
     /* 271112 */   // Label 5409: @271112
     /* 271112 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(271171), // Rule ID 1705 //
     /* 271117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271128 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271131 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 271136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271140 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 271144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271156 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 271156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 271159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 271165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 271169 */     GIR_RootConstrainSelectedInstOperands,
     /* 271170 */     // GIR_Coverage, 1705,
     /* 271170 */     GIR_EraseRootFromParent_Done,
     /* 271171 */   // Label 5410: @271171
     /* 271171 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(271198), // Rule ID 6375 //
     /* 271176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 271183 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 271183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 271186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271196 */     GIR_RootConstrainSelectedInstOperands,
     /* 271197 */     // GIR_Coverage, 6375,
     /* 271197 */     GIR_EraseRootFromParent_Done,
     /* 271198 */   // Label 5411: @271198
     /* 271198 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(271219), // Rule ID 6366 //
     /* 271203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271207 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 271207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 271210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271217 */     GIR_RootConstrainSelectedInstOperands,
     /* 271218 */     // GIR_Coverage, 6366,
     /* 271218 */     GIR_EraseRootFromParent_Done,
     /* 271219 */   // Label 5412: @271219
     /* 271219 */   GIM_Reject,
     /* 271220 */ // Label 5406: @271220
     /* 271220 */ GIM_Reject,
     /* 271221 */ // Label 5385: @271221
     /* 271221 */ GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(271530),
     /* 271226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 271229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271233 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(271298), // Rule ID 694 //
     /* 271238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271249 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271252 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 271257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271261 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271281 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 271284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 271296 */     GIR_RootConstrainSelectedInstOperands,
     /* 271297 */     // GIR_Coverage, 694,
     /* 271297 */     GIR_EraseRootFromParent_Done,
     /* 271298 */   // Label 5414: @271298
     /* 271298 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(271363), // Rule ID 1703 //
     /* 271303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271314 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271317 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 271322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271326 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271346 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 271349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 271361 */     GIR_RootConstrainSelectedInstOperands,
     /* 271362 */     // GIR_Coverage, 1703,
     /* 271362 */     GIR_EraseRootFromParent_Done,
     /* 271363 */   // Label 5415: @271363
     /* 271363 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(271422), // Rule ID 692 //
     /* 271368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271379 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271382 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 271387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271391 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271407 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 271407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 271410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 271416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 271420 */     GIR_RootConstrainSelectedInstOperands,
     /* 271421 */     // GIR_Coverage, 692,
     /* 271421 */     GIR_EraseRootFromParent_Done,
     /* 271422 */   // Label 5416: @271422
     /* 271422 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(271481), // Rule ID 1701 //
     /* 271427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 271438 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 271441 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 271446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271450 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 271454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271466 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 271466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 271469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 271475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 271479 */     GIR_RootConstrainSelectedInstOperands,
     /* 271480 */     // GIR_Coverage, 1701,
     /* 271480 */     GIR_EraseRootFromParent_Done,
     /* 271481 */   // Label 5417: @271481
     /* 271481 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(271508), // Rule ID 6372 //
     /* 271486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 271493 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 271493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 271496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 271503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271506 */     GIR_RootConstrainSelectedInstOperands,
     /* 271507 */     // GIR_Coverage, 6372,
     /* 271507 */     GIR_EraseRootFromParent_Done,
     /* 271508 */   // Label 5418: @271508
     /* 271508 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(271529), // Rule ID 6363 //
     /* 271513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271517 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 271517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 271520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271527 */     GIR_RootConstrainSelectedInstOperands,
     /* 271528 */     // GIR_Coverage, 6363,
     /* 271528 */     GIR_EraseRootFromParent_Done,
     /* 271529 */   // Label 5419: @271529
     /* 271529 */   GIM_Reject,
     /* 271530 */ // Label 5413: @271530
     /* 271530 */ GIM_Reject,
     /* 271531 */ // Label 5386: @271531
     /* 271531 */ GIM_Reject,
     /* 271532 */ // Label 46: @271532
     /* 271532 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5425*/ GIMT_Encode4(272356),
     /* 271543 */ /*GILLT_s32*//*Label 5420*/ GIMT_Encode4(271579),
     /* 271547 */ /*GILLT_s64*//*Label 5421*/ GIMT_Encode4(271756), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271559 */ /*GILLT_v2s64*//*Label 5422*/ GIMT_Encode4(271929), GIMT_Encode4(0),
     /* 271567 */ /*GILLT_v4s32*//*Label 5423*/ GIMT_Encode4(272074), GIMT_Encode4(0),
     /* 271575 */ /*GILLT_v8s16*//*Label 5424*/ GIMT_Encode4(272215),
     /* 271579 */ // Label 5420: @271579
     /* 271579 */ GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(271755),
     /* 271584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271598 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(271635), // Rule ID 3935 //
     /* 271603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 271611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271622 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 271625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271633 */     GIR_RootConstrainSelectedInstOperands,
     /* 271634 */     // GIR_Coverage, 3935,
     /* 271634 */     GIR_EraseRootFromParent_Done,
     /* 271635 */   // Label 5427: @271635
     /* 271635 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(271672), // Rule ID 3936 //
     /* 271640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271659 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 271662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271670 */     GIR_RootConstrainSelectedInstOperands,
     /* 271671 */     // GIR_Coverage, 3936,
     /* 271671 */     GIR_EraseRootFromParent_Done,
     /* 271672 */   // Label 5428: @271672
     /* 271672 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(271709), // Rule ID 3934 //
     /* 271677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271696 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 271699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271707 */     GIR_RootConstrainSelectedInstOperands,
     /* 271708 */     // GIR_Coverage, 3934,
     /* 271708 */     GIR_EraseRootFromParent_Done,
     /* 271709 */   // Label 5429: @271709
     /* 271709 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(271754), // Rule ID 3933 //
     /* 271714 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 271714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 271717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 271721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271726 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 271732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 271745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271752 */     GIR_RootConstrainSelectedInstOperands,
     /* 271753 */     // GIR_Coverage, 3933,
     /* 271753 */     GIR_EraseRootFromParent_Done,
     /* 271754 */   // Label 5430: @271754
     /* 271754 */   GIM_Reject,
     /* 271755 */ // Label 5426: @271755
     /* 271755 */ GIM_Reject,
     /* 271756 */ // Label 5421: @271756
     /* 271756 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(271928),
     /* 271761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271775 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(271843), // Rule ID 3937 //
     /* 271780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271799 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271811 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271818 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 271834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271841 */     GIR_RootConstrainSelectedInstOperands,
     /* 271842 */     // GIR_Coverage, 3937,
     /* 271842 */     GIR_EraseRootFromParent_Done,
     /* 271843 */   // Label 5432: @271843
     /* 271843 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(271911), // Rule ID 3938 //
     /* 271848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271867 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271879 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271886 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 271902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271909 */     GIR_RootConstrainSelectedInstOperands,
     /* 271910 */     // GIR_Coverage, 3938,
     /* 271910 */     GIR_EraseRootFromParent_Done,
     /* 271911 */   // Label 5433: @271911
     /* 271911 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271927), // Rule ID 120 //
     /* 271916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271920 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 271925 */     GIR_RootConstrainSelectedInstOperands,
     /* 271926 */     // GIR_Coverage, 120,
     /* 271926 */     GIR_Done,
     /* 271927 */   // Label 5434: @271927
     /* 271927 */   GIM_Reject,
     /* 271928 */ // Label 5431: @271928
     /* 271928 */ GIM_Reject,
     /* 271929 */ // Label 5422: @271929
     /* 271929 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(272073),
     /* 271934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 271937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271944 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(272008), // Rule ID 6361 //
     /* 271949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 271974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 271978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 271982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271986 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271990 */     // MIs[3] Operand 1
     /* 271990 */     // No operand predicates
     /* 271990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 271992 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 271992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 271995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272001 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 272006 */     GIR_RootConstrainSelectedInstOperands,
     /* 272007 */     // GIR_Coverage, 6361,
     /* 272007 */     GIR_EraseRootFromParent_Done,
     /* 272008 */   // Label 5436: @272008
     /* 272008 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(272072), // Rule ID 6358 //
     /* 272013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 272025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 272042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272050 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272054 */     // MIs[3] Operand 1
     /* 272054 */     // No operand predicates
     /* 272054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272056 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 272056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 272059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272065 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 272070 */     GIR_RootConstrainSelectedInstOperands,
     /* 272071 */     // GIR_Coverage, 6358,
     /* 272071 */     GIR_EraseRootFromParent_Done,
     /* 272072 */   // Label 5437: @272072
     /* 272072 */   GIM_Reject,
     /* 272073 */ // Label 5435: @272073
     /* 272073 */ GIM_Reject,
     /* 272074 */ // Label 5423: @272074
     /* 272074 */ GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(272214),
     /* 272079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272089 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(272151), // Rule ID 6360 //
     /* 272094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 272106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 272123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272131 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 272135 */     // MIs[3] Operand 1
     /* 272135 */     // No operand predicates
     /* 272135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272137 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 272137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 272140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 272149 */     GIR_RootConstrainSelectedInstOperands,
     /* 272150 */     // GIR_Coverage, 6360,
     /* 272150 */     GIR_EraseRootFromParent_Done,
     /* 272151 */   // Label 5439: @272151
     /* 272151 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(272213), // Rule ID 6357 //
     /* 272156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 272168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 272185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272193 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 272197 */     // MIs[3] Operand 1
     /* 272197 */     // No operand predicates
     /* 272197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272199 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 272199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 272202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 272211 */     GIR_RootConstrainSelectedInstOperands,
     /* 272212 */     // GIR_Coverage, 6357,
     /* 272212 */     GIR_EraseRootFromParent_Done,
     /* 272213 */   // Label 5440: @272213
     /* 272213 */   GIM_Reject,
     /* 272214 */ // Label 5438: @272214
     /* 272214 */ GIM_Reject,
     /* 272215 */ // Label 5424: @272215
     /* 272215 */ GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(272355),
     /* 272220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272230 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(272292), // Rule ID 6359 //
     /* 272235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 272247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 272264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272272 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 272276 */     // MIs[3] Operand 1
     /* 272276 */     // No operand predicates
     /* 272276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272278 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 272278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 272281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 272290 */     GIR_RootConstrainSelectedInstOperands,
     /* 272291 */     // GIR_Coverage, 6359,
     /* 272291 */     GIR_EraseRootFromParent_Done,
     /* 272292 */   // Label 5442: @272292
     /* 272292 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(272354), // Rule ID 6356 //
     /* 272297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 272309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 272322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 272326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 272330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 272338 */     // MIs[3] Operand 1
     /* 272338 */     // No operand predicates
     /* 272338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 272340 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 272340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 272343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 272352 */     GIR_RootConstrainSelectedInstOperands,
     /* 272353 */     // GIR_Coverage, 6356,
     /* 272353 */     GIR_EraseRootFromParent_Done,
     /* 272354 */   // Label 5443: @272354
     /* 272354 */   GIM_Reject,
     /* 272355 */ // Label 5441: @272355
     /* 272355 */ GIM_Reject,
     /* 272356 */ // Label 5425: @272356
     /* 272356 */ GIM_Reject,
     /* 272357 */ // Label 47: @272357
     /* 272357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5446*/ GIMT_Encode4(272794),
     /* 272368 */ /*GILLT_s32*//*Label 5444*/ GIMT_Encode4(272376),
     /* 272372 */ /*GILLT_s64*//*Label 5445*/ GIMT_Encode4(272587),
     /* 272376 */ // Label 5444: @272376
     /* 272376 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(272586),
     /* 272381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 272384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272395 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(272429), // Rule ID 4024 //
     /* 272400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272412 */     // MIs[1] Operand 1
     /* 272412 */     // No operand predicates
     /* 272412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272414 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 272414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 272417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 272427 */     GIR_RootConstrainSelectedInstOperands,
     /* 272428 */     // GIR_Coverage, 4024,
     /* 272428 */     GIR_EraseRootFromParent_Done,
     /* 272429 */   // Label 5448: @272429
     /* 272429 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(272466), // Rule ID 3941 //
     /* 272434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 272442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272453 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 272456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272464 */     GIR_RootConstrainSelectedInstOperands,
     /* 272465 */     // GIR_Coverage, 3941,
     /* 272465 */     GIR_EraseRootFromParent_Done,
     /* 272466 */   // Label 5449: @272466
     /* 272466 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(272503), // Rule ID 3942 //
     /* 272471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272490 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 272493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272501 */     GIR_RootConstrainSelectedInstOperands,
     /* 272502 */     // GIR_Coverage, 3942,
     /* 272502 */     GIR_EraseRootFromParent_Done,
     /* 272503 */   // Label 5450: @272503
     /* 272503 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(272540), // Rule ID 3940 //
     /* 272508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272527 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 272530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272538 */     GIR_RootConstrainSelectedInstOperands,
     /* 272539 */     // GIR_Coverage, 3940,
     /* 272539 */     GIR_EraseRootFromParent_Done,
     /* 272540 */   // Label 5451: @272540
     /* 272540 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(272585), // Rule ID 3939 //
     /* 272545 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 272545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272557 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 272563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 272576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272583 */     GIR_RootConstrainSelectedInstOperands,
     /* 272584 */     // GIR_Coverage, 3939,
     /* 272584 */     GIR_EraseRootFromParent_Done,
     /* 272585 */   // Label 5452: @272585
     /* 272585 */   GIM_Reject,
     /* 272586 */ // Label 5447: @272586
     /* 272586 */ GIM_Reject,
     /* 272587 */ // Label 5445: @272587
     /* 272587 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(272793),
     /* 272592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 272595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272606 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(272640), // Rule ID 4025 //
     /* 272611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 272623 */     // MIs[1] Operand 1
     /* 272623 */     // No operand predicates
     /* 272623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272625 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 272625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 272628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 272638 */     GIR_RootConstrainSelectedInstOperands,
     /* 272639 */     // GIR_Coverage, 4025,
     /* 272639 */     GIR_EraseRootFromParent_Done,
     /* 272640 */   // Label 5454: @272640
     /* 272640 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(272708), // Rule ID 3943 //
     /* 272645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272664 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 272664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 272671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272676 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 272679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272683 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 272686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 272691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 272699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272706 */     GIR_RootConstrainSelectedInstOperands,
     /* 272707 */     // GIR_Coverage, 3943,
     /* 272707 */     GIR_EraseRootFromParent_Done,
     /* 272708 */   // Label 5455: @272708
     /* 272708 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(272776), // Rule ID 3944 //
     /* 272713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272732 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 272732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 272739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 272747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 272754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 272759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 272767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272774 */     GIR_RootConstrainSelectedInstOperands,
     /* 272775 */     // GIR_Coverage, 3944,
     /* 272775 */     GIR_EraseRootFromParent_Done,
     /* 272776 */   // Label 5456: @272776
     /* 272776 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(272792), // Rule ID 121 //
     /* 272781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272785 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 272785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 272790 */     GIR_RootConstrainSelectedInstOperands,
     /* 272791 */     // GIR_Coverage, 121,
     /* 272791 */     GIR_Done,
     /* 272792 */   // Label 5457: @272792
     /* 272792 */   GIM_Reject,
     /* 272793 */ // Label 5453: @272793
     /* 272793 */ GIM_Reject,
     /* 272794 */ // Label 5446: @272794
     /* 272794 */ GIM_Reject,
     /* 272795 */ // Label 48: @272795
     /* 272795 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5460*/ GIMT_Encode4(273619),
     /* 272806 */ /*GILLT_s32*//*Label 5458*/ GIMT_Encode4(272814),
     /* 272810 */ /*GILLT_s64*//*Label 5459*/ GIMT_Encode4(273169),
     /* 272814 */ // Label 5458: @272814
     /* 272814 */ GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(273168),
     /* 272819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 272822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272829 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(272893), // Rule ID 6521 //
     /* 272834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 272842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272851 */     // MIs[1] Operand 2
     /* 272851 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 272862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 272874 */     // MIs[2] Operand 1
     /* 272874 */     // No operand predicates
     /* 272874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272876 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 272876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 272879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 272888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 272891 */     GIR_RootConstrainSelectedInstOperands,
     /* 272892 */     // GIR_Coverage, 6521,
     /* 272892 */     GIR_EraseRootFromParent_Done,
     /* 272893 */   // Label 5462: @272893
     /* 272893 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(272957), // Rule ID 6523 //
     /* 272898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 272906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272915 */     // MIs[1] Operand 2
     /* 272915 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 272926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272934 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 272938 */     // MIs[2] Operand 1
     /* 272938 */     // No operand predicates
     /* 272938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272940 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 272940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 272943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 272952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 272955 */     GIR_RootConstrainSelectedInstOperands,
     /* 272956 */     // GIR_Coverage, 6523,
     /* 272956 */     GIR_EraseRootFromParent_Done,
     /* 272957 */   // Label 5463: @272957
     /* 272957 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(272995), // Rule ID 4022 //
     /* 272962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272978 */     // MIs[1] Operand 1
     /* 272978 */     // No operand predicates
     /* 272978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272980 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 272980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 272983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 272993 */     GIR_RootConstrainSelectedInstOperands,
     /* 272994 */     // GIR_Coverage, 4022,
     /* 272994 */     GIR_EraseRootFromParent_Done,
     /* 272995 */   // Label 5464: @272995
     /* 272995 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(273036), // Rule ID 2435 //
     /* 273000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 273012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273023 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 273026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273034 */     GIR_RootConstrainSelectedInstOperands,
     /* 273035 */     // GIR_Coverage, 2435,
     /* 273035 */     GIR_EraseRootFromParent_Done,
     /* 273036 */   // Label 5465: @273036
     /* 273036 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(273077), // Rule ID 2436 //
     /* 273041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 273053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273064 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 273067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273075 */     GIR_RootConstrainSelectedInstOperands,
     /* 273076 */     // GIR_Coverage, 2436,
     /* 273076 */     GIR_EraseRootFromParent_Done,
     /* 273077 */   // Label 5466: @273077
     /* 273077 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(273118), // Rule ID 2434 //
     /* 273082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 273094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273105 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 273108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273116 */     GIR_RootConstrainSelectedInstOperands,
     /* 273117 */     // GIR_Coverage, 2434,
     /* 273117 */     GIR_EraseRootFromParent_Done,
     /* 273118 */   // Label 5467: @273118
     /* 273118 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(273167), // Rule ID 2433 //
     /* 273123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273127 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 273127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 273130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273139 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 273145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 273158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273165 */     GIR_RootConstrainSelectedInstOperands,
     /* 273166 */     // GIR_Coverage, 2433,
     /* 273166 */     GIR_EraseRootFromParent_Done,
     /* 273167 */   // Label 5468: @273167
     /* 273167 */   GIM_Reject,
     /* 273168 */ // Label 5461: @273168
     /* 273168 */ GIM_Reject,
     /* 273169 */ // Label 5459: @273169
     /* 273169 */ GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(273618),
     /* 273174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 273177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273184 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(273248), // Rule ID 6522 //
     /* 273189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 273197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 273201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273206 */     // MIs[1] Operand 2
     /* 273206 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 273217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 273229 */     // MIs[2] Operand 1
     /* 273229 */     // No operand predicates
     /* 273229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273231 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 273231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 273234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 273243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 273246 */     GIR_RootConstrainSelectedInstOperands,
     /* 273247 */     // GIR_Coverage, 6522,
     /* 273247 */     GIR_EraseRootFromParent_Done,
     /* 273248 */   // Label 5470: @273248
     /* 273248 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(273312), // Rule ID 6524 //
     /* 273253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 273261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 273265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273270 */     // MIs[1] Operand 2
     /* 273270 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 273281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 273293 */     // MIs[2] Operand 1
     /* 273293 */     // No operand predicates
     /* 273293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273295 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 273295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 273298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 273307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 273310 */     GIR_RootConstrainSelectedInstOperands,
     /* 273311 */     // GIR_Coverage, 6524,
     /* 273311 */     GIR_EraseRootFromParent_Done,
     /* 273312 */   // Label 5471: @273312
     /* 273312 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(273415), // Rule ID 6525 //
     /* 273317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 273325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273346 */     // MIs[2] Operand 1
     /* 273346 */     // No operand predicates
     /* 273346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273348 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 273348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 273351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 273355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 273362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 273369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273374 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 273377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 273384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 273389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 273394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 273402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 273410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 273413 */     GIR_RootConstrainSelectedInstOperands,
     /* 273414 */     // GIR_Coverage, 6525,
     /* 273414 */     GIR_EraseRootFromParent_Done,
     /* 273415 */   // Label 5472: @273415
     /* 273415 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(273453), // Rule ID 4023 //
     /* 273420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 273436 */     // MIs[1] Operand 1
     /* 273436 */     // No operand predicates
     /* 273436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273438 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 273438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 273441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 273451 */     GIR_RootConstrainSelectedInstOperands,
     /* 273452 */     // GIR_Coverage, 4023,
     /* 273452 */     GIR_EraseRootFromParent_Done,
     /* 273453 */   // Label 5473: @273453
     /* 273453 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(273525), // Rule ID 2437 //
     /* 273458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 273470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273481 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 273481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 273488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273493 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 273496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 273503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 273508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 273516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273523 */     GIR_RootConstrainSelectedInstOperands,
     /* 273524 */     // GIR_Coverage, 2437,
     /* 273524 */     GIR_EraseRootFromParent_Done,
     /* 273525 */   // Label 5474: @273525
     /* 273525 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(273597), // Rule ID 2438 //
     /* 273530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 273542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273553 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 273553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 273560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 273568 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273572 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 273575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 273580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 273588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273595 */     GIR_RootConstrainSelectedInstOperands,
     /* 273596 */     // GIR_Coverage, 2438,
     /* 273596 */     GIR_EraseRootFromParent_Done,
     /* 273597 */   // Label 5475: @273597
     /* 273597 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(273617), // Rule ID 119 //
     /* 273602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273610 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 273610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 273615 */     GIR_RootConstrainSelectedInstOperands,
     /* 273616 */     // GIR_Coverage, 119,
     /* 273616 */     GIR_Done,
     /* 273617 */   // Label 5476: @273617
     /* 273617 */   GIM_Reject,
     /* 273618 */ // Label 5469: @273618
     /* 273618 */ GIM_Reject,
     /* 273619 */ // Label 5460: @273619
     /* 273619 */ GIM_Reject,
     /* 273620 */ // Label 49: @273620
     /* 273620 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5479*/ GIMT_Encode4(273749),
     /* 273631 */ /*GILLT_s32*//*Label 5477*/ GIMT_Encode4(273639),
     /* 273635 */ /*GILLT_s64*//*Label 5478*/ GIMT_Encode4(273694),
     /* 273639 */ // Label 5477: @273639
     /* 273639 */ GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(273693), // Rule ID 188 //
     /* 273644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 273647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 273650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273665 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273669 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273673 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273677 */   // MIs[1] Operand 1
     /* 273677 */   // No operand predicates
     /* 273677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273679 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 273679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 273682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273684 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273686 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 273688 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273691 */   GIR_RootConstrainSelectedInstOperands,
     /* 273692 */   // GIR_Coverage, 188,
     /* 273692 */   GIR_EraseRootFromParent_Done,
     /* 273693 */ // Label 5480: @273693
     /* 273693 */ GIM_Reject,
     /* 273694 */ // Label 5478: @273694
     /* 273694 */ GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(273748), // Rule ID 189 //
     /* 273699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 273702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273728 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 273732 */   // MIs[1] Operand 1
     /* 273732 */   // No operand predicates
     /* 273732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273734 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 273734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 273737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273739 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273741 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 273743 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273746 */   GIR_RootConstrainSelectedInstOperands,
     /* 273747 */   // GIR_Coverage, 189,
     /* 273747 */   GIR_EraseRootFromParent_Done,
     /* 273748 */ // Label 5481: @273748
     /* 273748 */ GIM_Reject,
     /* 273749 */ // Label 5479: @273749
     /* 273749 */ GIM_Reject,
     /* 273750 */ // Label 50: @273750
     /* 273750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5484*/ GIMT_Encode4(274291),
     /* 273761 */ /*GILLT_s32*//*Label 5482*/ GIMT_Encode4(273769),
     /* 273765 */ /*GILLT_s64*//*Label 5483*/ GIMT_Encode4(274034),
     /* 273769 */ // Label 5482: @273769
     /* 273769 */ GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(274033),
     /* 273774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 273777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273784 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(273823), // Rule ID 184 //
     /* 273789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 273797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 273810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273812 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 273812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 273815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273821 */     GIR_RootConstrainSelectedInstOperands,
     /* 273822 */     // GIR_Coverage, 184,
     /* 273822 */     GIR_EraseRootFromParent_Done,
     /* 273823 */   // Label 5486: @273823
     /* 273823 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(273860), // Rule ID 4018 //
     /* 273828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273844 */     // MIs[1] Operand 1
     /* 273844 */     // No operand predicates
     /* 273844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273846 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 273846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 273849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273858 */     GIR_RootConstrainSelectedInstOperands,
     /* 273859 */     // GIR_Coverage, 4018,
     /* 273859 */     GIR_EraseRootFromParent_Done,
     /* 273860 */   // Label 5487: @273860
     /* 273860 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(273901), // Rule ID 3947 //
     /* 273865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 273877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273888 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 273891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273899 */     GIR_RootConstrainSelectedInstOperands,
     /* 273900 */     // GIR_Coverage, 3947,
     /* 273900 */     GIR_EraseRootFromParent_Done,
     /* 273901 */   // Label 5488: @273901
     /* 273901 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(273942), // Rule ID 3948 //
     /* 273906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 273918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273929 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 273932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273940 */     GIR_RootConstrainSelectedInstOperands,
     /* 273941 */     // GIR_Coverage, 3948,
     /* 273941 */     GIR_EraseRootFromParent_Done,
     /* 273942 */   // Label 5489: @273942
     /* 273942 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(273983), // Rule ID 3946 //
     /* 273947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 273959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 273963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273970 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 273970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 273973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 273977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 273981 */     GIR_RootConstrainSelectedInstOperands,
     /* 273982 */     // GIR_Coverage, 3946,
     /* 273982 */     GIR_EraseRootFromParent_Done,
     /* 273983 */   // Label 5490: @273983
     /* 273983 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(274032), // Rule ID 3945 //
     /* 273988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273992 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 273992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 273995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274004 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 274010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 274023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274030 */     GIR_RootConstrainSelectedInstOperands,
     /* 274031 */     // GIR_Coverage, 3945,
     /* 274031 */     GIR_EraseRootFromParent_Done,
     /* 274032 */   // Label 5491: @274032
     /* 274032 */   GIM_Reject,
     /* 274033 */ // Label 5485: @274033
     /* 274033 */ GIM_Reject,
     /* 274034 */ // Label 5483: @274034
     /* 274034 */ GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(274290),
     /* 274039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 274042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274049 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(274088), // Rule ID 187 //
     /* 274054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 274058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 274062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 274066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 274075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274077 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 274077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 274080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 274086 */     GIR_RootConstrainSelectedInstOperands,
     /* 274087 */     // GIR_Coverage, 187,
     /* 274087 */     GIR_EraseRootFromParent_Done,
     /* 274088 */   // Label 5493: @274088
     /* 274088 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(274125), // Rule ID 4019 //
     /* 274093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 274105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 274109 */     // MIs[1] Operand 1
     /* 274109 */     // No operand predicates
     /* 274109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274111 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 274111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 274114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 274123 */     GIR_RootConstrainSelectedInstOperands,
     /* 274124 */     // GIR_Coverage, 4019,
     /* 274124 */     GIR_EraseRootFromParent_Done,
     /* 274125 */   // Label 5494: @274125
     /* 274125 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(274197), // Rule ID 3949 //
     /* 274130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 274142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 274146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274153 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 274153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 274156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 274160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274165 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 274168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 274172 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 274175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 274180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 274188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274195 */     GIR_RootConstrainSelectedInstOperands,
     /* 274196 */     // GIR_Coverage, 3949,
     /* 274196 */     GIR_EraseRootFromParent_Done,
     /* 274197 */   // Label 5495: @274197
     /* 274197 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(274269), // Rule ID 3950 //
     /* 274202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 274214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 274218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274225 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 274225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 274228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 274232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 274240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 274244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 274247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 274252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 274260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 274264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274267 */     GIR_RootConstrainSelectedInstOperands,
     /* 274268 */     // GIR_Coverage, 3950,
     /* 274268 */     GIR_EraseRootFromParent_Done,
     /* 274269 */   // Label 5496: @274269
     /* 274269 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(274289), // Rule ID 122 //
     /* 274274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274282 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 274282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 274287 */     GIR_RootConstrainSelectedInstOperands,
     /* 274288 */     // GIR_Coverage, 122,
     /* 274288 */     GIR_Done,
     /* 274289 */   // Label 5497: @274289
     /* 274289 */   GIM_Reject,
     /* 274290 */ // Label 5492: @274290
     /* 274290 */ GIM_Reject,
     /* 274291 */ // Label 5484: @274291
     /* 274291 */ GIM_Reject,
     /* 274292 */ // Label 51: @274292
     /* 274292 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5506*/ GIMT_Encode4(282068),
     /* 274303 */ /*GILLT_s64*//*Label 5498*/ GIMT_Encode4(274339), GIMT_Encode4(0),
     /* 274311 */ /*GILLT_v2s32*//*Label 5499*/ GIMT_Encode4(274732),
     /* 274315 */ /*GILLT_v2s64*//*Label 5500*/ GIMT_Encode4(275780),
     /* 274319 */ /*GILLT_v4s16*//*Label 5501*/ GIMT_Encode4(276828),
     /* 274323 */ /*GILLT_v4s32*//*Label 5502*/ GIMT_Encode4(277876),
     /* 274327 */ /*GILLT_v8s8*//*Label 5503*/ GIMT_Encode4(278924),
     /* 274331 */ /*GILLT_v8s16*//*Label 5504*/ GIMT_Encode4(279972),
     /* 274335 */ /*GILLT_v16s8*//*Label 5505*/ GIMT_Encode4(281020),
     /* 274339 */ // Label 5498: @274339
     /* 274339 */ GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(274731),
     /* 274344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 274350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274354 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(274390), // Rule ID 5242 //
     /* 274359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274362 */     // MIs[0] Operand 1
     /* 274362 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274381 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 274384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274388 */     GIR_RootConstrainSelectedInstOperands,
     /* 274389 */     // GIR_Coverage, 5242,
     /* 274389 */     GIR_EraseRootFromParent_Done,
     /* 274390 */   // Label 5508: @274390
     /* 274390 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(274426), // Rule ID 5243 //
     /* 274395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274398 */     // MIs[0] Operand 1
     /* 274398 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274413 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274417 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 274420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274424 */     GIR_RootConstrainSelectedInstOperands,
     /* 274425 */     // GIR_Coverage, 5243,
     /* 274425 */     GIR_EraseRootFromParent_Done,
     /* 274426 */   // Label 5509: @274426
     /* 274426 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(274462), // Rule ID 2512 //
     /* 274431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274434 */     // MIs[0] Operand 1
     /* 274434 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274443 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274449 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274453 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 274456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274460 */     GIR_RootConstrainSelectedInstOperands,
     /* 274461 */     // GIR_Coverage, 2512,
     /* 274461 */     GIR_EraseRootFromParent_Done,
     /* 274462 */   // Label 5510: @274462
     /* 274462 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(274498), // Rule ID 5239 //
     /* 274467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274470 */     // MIs[0] Operand 1
     /* 274470 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274479 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274485 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274489 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 274492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274496 */     GIR_RootConstrainSelectedInstOperands,
     /* 274497 */     // GIR_Coverage, 5239,
     /* 274497 */     GIR_EraseRootFromParent_Done,
     /* 274498 */   // Label 5511: @274498
     /* 274498 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(274534), // Rule ID 5240 //
     /* 274503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274506 */     // MIs[0] Operand 1
     /* 274506 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274515 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274521 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 274523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274525 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 274528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274532 */     GIR_RootConstrainSelectedInstOperands,
     /* 274533 */     // GIR_Coverage, 5240,
     /* 274533 */     GIR_EraseRootFromParent_Done,
     /* 274534 */   // Label 5512: @274534
     /* 274534 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(274570), // Rule ID 5241 //
     /* 274539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274542 */     // MIs[0] Operand 1
     /* 274542 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274551 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274557 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274561 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 274561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 274564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274568 */     GIR_RootConstrainSelectedInstOperands,
     /* 274569 */     // GIR_Coverage, 5241,
     /* 274569 */     GIR_EraseRootFromParent_Done,
     /* 274570 */   // Label 5513: @274570
     /* 274570 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(274602), // Rule ID 1608 //
     /* 274575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274578 */     // MIs[0] Operand 1
     /* 274578 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274591 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 274594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274600 */     GIR_RootConstrainSelectedInstOperands,
     /* 274601 */     // GIR_Coverage, 1608,
     /* 274601 */     GIR_EraseRootFromParent_Done,
     /* 274602 */   // Label 5514: @274602
     /* 274602 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(274634), // Rule ID 1609 //
     /* 274607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274610 */     // MIs[0] Operand 1
     /* 274610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274623 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 274626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274632 */     GIR_RootConstrainSelectedInstOperands,
     /* 274633 */     // GIR_Coverage, 1609,
     /* 274633 */     GIR_EraseRootFromParent_Done,
     /* 274634 */   // Label 5515: @274634
     /* 274634 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(274666), // Rule ID 1610 //
     /* 274639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274642 */     // MIs[0] Operand 1
     /* 274642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274655 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 274658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274664 */     GIR_RootConstrainSelectedInstOperands,
     /* 274665 */     // GIR_Coverage, 1610,
     /* 274665 */     GIR_EraseRootFromParent_Done,
     /* 274666 */   // Label 5516: @274666
     /* 274666 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(274698), // Rule ID 1611 //
     /* 274671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274674 */     // MIs[0] Operand 1
     /* 274674 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274687 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 274690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274696 */     GIR_RootConstrainSelectedInstOperands,
     /* 274697 */     // GIR_Coverage, 1611,
     /* 274697 */     GIR_EraseRootFromParent_Done,
     /* 274698 */   // Label 5517: @274698
     /* 274698 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(274730), // Rule ID 1612 //
     /* 274703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274706 */     // MIs[0] Operand 1
     /* 274706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274719 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 274719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 274722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274728 */     GIR_RootConstrainSelectedInstOperands,
     /* 274729 */     // GIR_Coverage, 1612,
     /* 274729 */     GIR_EraseRootFromParent_Done,
     /* 274730 */   // Label 5518: @274730
     /* 274730 */   GIM_Reject,
     /* 274731 */ // Label 5507: @274731
     /* 274731 */ GIM_Reject,
     /* 274732 */ // Label 5499: @274732
     /* 274732 */ GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(275779),
     /* 274737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 274743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274747 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(274787), // Rule ID 754 //
     /* 274752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274755 */     // MIs[0] Operand 1
     /* 274755 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274778 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 274781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274785 */     GIR_RootConstrainSelectedInstOperands,
     /* 274786 */     // GIR_Coverage, 754,
     /* 274786 */     GIR_EraseRootFromParent_Done,
     /* 274787 */   // Label 5520: @274787
     /* 274787 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(274827), // Rule ID 761 //
     /* 274792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274795 */     // MIs[0] Operand 1
     /* 274795 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274804 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274810 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274818 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 274821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274825 */     GIR_RootConstrainSelectedInstOperands,
     /* 274826 */     // GIR_Coverage, 761,
     /* 274826 */     GIR_EraseRootFromParent_Done,
     /* 274827 */   // Label 5521: @274827
     /* 274827 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(274864), // Rule ID 5176 //
     /* 274832 */     // MIs[0] Operand 1
     /* 274832 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274841 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274847 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274855 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 274858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274862 */     GIR_RootConstrainSelectedInstOperands,
     /* 274863 */     // GIR_Coverage, 5176,
     /* 274863 */     GIR_EraseRootFromParent_Done,
     /* 274864 */   // Label 5522: @274864
     /* 274864 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(274901), // Rule ID 5183 //
     /* 274869 */     // MIs[0] Operand 1
     /* 274869 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274878 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274884 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274892 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 274895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274899 */     GIR_RootConstrainSelectedInstOperands,
     /* 274900 */     // GIR_Coverage, 5183,
     /* 274900 */     GIR_EraseRootFromParent_Done,
     /* 274901 */   // Label 5523: @274901
     /* 274901 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(274938), // Rule ID 5190 //
     /* 274906 */     // MIs[0] Operand 1
     /* 274906 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274921 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274929 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 274932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274936 */     GIR_RootConstrainSelectedInstOperands,
     /* 274937 */     // GIR_Coverage, 5190,
     /* 274937 */     GIR_EraseRootFromParent_Done,
     /* 274938 */   // Label 5524: @274938
     /* 274938 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(274975), // Rule ID 5197 //
     /* 274943 */     // MIs[0] Operand 1
     /* 274943 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274952 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274958 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274966 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 274966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 274969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274973 */     GIR_RootConstrainSelectedInstOperands,
     /* 274974 */     // GIR_Coverage, 5197,
     /* 274974 */     GIR_EraseRootFromParent_Done,
     /* 274975 */   // Label 5525: @274975
     /* 274975 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(275012), // Rule ID 5204 //
     /* 274980 */     // MIs[0] Operand 1
     /* 274980 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274989 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274995 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275003 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 275006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275010 */     GIR_RootConstrainSelectedInstOperands,
     /* 275011 */     // GIR_Coverage, 5204,
     /* 275011 */     GIR_EraseRootFromParent_Done,
     /* 275012 */   // Label 5526: @275012
     /* 275012 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(275052), // Rule ID 726 //
     /* 275017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275020 */     // MIs[0] Operand 1
     /* 275020 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275033 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275039 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275043 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 275046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275050 */     GIR_RootConstrainSelectedInstOperands,
     /* 275051 */     // GIR_Coverage, 726,
     /* 275051 */     GIR_EraseRootFromParent_Done,
     /* 275052 */   // Label 5527: @275052
     /* 275052 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(275092), // Rule ID 737 //
     /* 275057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275060 */     // MIs[0] Operand 1
     /* 275060 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275073 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275079 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275083 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 275086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275090 */     GIR_RootConstrainSelectedInstOperands,
     /* 275091 */     // GIR_Coverage, 737,
     /* 275091 */     GIR_EraseRootFromParent_Done,
     /* 275092 */   // Label 5528: @275092
     /* 275092 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(275132), // Rule ID 738 //
     /* 275097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275100 */     // MIs[0] Operand 1
     /* 275100 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275113 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 275121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275123 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 275126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275130 */     GIR_RootConstrainSelectedInstOperands,
     /* 275131 */     // GIR_Coverage, 738,
     /* 275131 */     GIR_EraseRootFromParent_Done,
     /* 275132 */   // Label 5529: @275132
     /* 275132 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(275172), // Rule ID 747 //
     /* 275137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275140 */     // MIs[0] Operand 1
     /* 275140 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275153 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275159 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275163 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 275166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275170 */     GIR_RootConstrainSelectedInstOperands,
     /* 275171 */     // GIR_Coverage, 747,
     /* 275171 */     GIR_EraseRootFromParent_Done,
     /* 275172 */   // Label 5530: @275172
     /* 275172 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(275209), // Rule ID 5141 //
     /* 275177 */     // MIs[0] Operand 1
     /* 275177 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275190 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275196 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275200 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 275203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275207 */     GIR_RootConstrainSelectedInstOperands,
     /* 275208 */     // GIR_Coverage, 5141,
     /* 275208 */     GIR_EraseRootFromParent_Done,
     /* 275209 */   // Label 5531: @275209
     /* 275209 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(275246), // Rule ID 5148 //
     /* 275214 */     // MIs[0] Operand 1
     /* 275214 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275227 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275233 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275237 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 275240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275244 */     GIR_RootConstrainSelectedInstOperands,
     /* 275245 */     // GIR_Coverage, 5148,
     /* 275245 */     GIR_EraseRootFromParent_Done,
     /* 275246 */   // Label 5532: @275246
     /* 275246 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(275283), // Rule ID 5155 //
     /* 275251 */     // MIs[0] Operand 1
     /* 275251 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275264 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275270 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275274 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 275277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275281 */     GIR_RootConstrainSelectedInstOperands,
     /* 275282 */     // GIR_Coverage, 5155,
     /* 275282 */     GIR_EraseRootFromParent_Done,
     /* 275283 */   // Label 5533: @275283
     /* 275283 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(275320), // Rule ID 5162 //
     /* 275288 */     // MIs[0] Operand 1
     /* 275288 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275301 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275307 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275311 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 275314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275318 */     GIR_RootConstrainSelectedInstOperands,
     /* 275319 */     // GIR_Coverage, 5162,
     /* 275319 */     GIR_EraseRootFromParent_Done,
     /* 275320 */   // Label 5534: @275320
     /* 275320 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(275357), // Rule ID 5169 //
     /* 275325 */     // MIs[0] Operand 1
     /* 275325 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275338 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275344 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275348 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 275348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 275351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275355 */     GIR_RootConstrainSelectedInstOperands,
     /* 275356 */     // GIR_Coverage, 5169,
     /* 275356 */     GIR_EraseRootFromParent_Done,
     /* 275357 */   // Label 5535: @275357
     /* 275357 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(275389), // Rule ID 1125 //
     /* 275362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275365 */     // MIs[0] Operand 1
     /* 275365 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275378 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 275381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275387 */     GIR_RootConstrainSelectedInstOperands,
     /* 275388 */     // GIR_Coverage, 1125,
     /* 275388 */     GIR_EraseRootFromParent_Done,
     /* 275389 */   // Label 5536: @275389
     /* 275389 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(275421), // Rule ID 1132 //
     /* 275394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275397 */     // MIs[0] Operand 1
     /* 275397 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275410 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 275413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275419 */     GIR_RootConstrainSelectedInstOperands,
     /* 275420 */     // GIR_Coverage, 1132,
     /* 275420 */     GIR_EraseRootFromParent_Done,
     /* 275421 */   // Label 5537: @275421
     /* 275421 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(275453), // Rule ID 1139 //
     /* 275426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275429 */     // MIs[0] Operand 1
     /* 275429 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275442 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 275445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275451 */     GIR_RootConstrainSelectedInstOperands,
     /* 275452 */     // GIR_Coverage, 1139,
     /* 275452 */     GIR_EraseRootFromParent_Done,
     /* 275453 */   // Label 5538: @275453
     /* 275453 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(275485), // Rule ID 1146 //
     /* 275458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275461 */     // MIs[0] Operand 1
     /* 275461 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275474 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 275477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275483 */     GIR_RootConstrainSelectedInstOperands,
     /* 275484 */     // GIR_Coverage, 1146,
     /* 275484 */     GIR_EraseRootFromParent_Done,
     /* 275485 */   // Label 5539: @275485
     /* 275485 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(275517), // Rule ID 1153 //
     /* 275490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275493 */     // MIs[0] Operand 1
     /* 275493 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275506 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 275509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275515 */     GIR_RootConstrainSelectedInstOperands,
     /* 275516 */     // GIR_Coverage, 1153,
     /* 275516 */     GIR_EraseRootFromParent_Done,
     /* 275517 */   // Label 5540: @275517
     /* 275517 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(275546), // Rule ID 5078 //
     /* 275522 */     // MIs[0] Operand 1
     /* 275522 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275535 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 275538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275544 */     GIR_RootConstrainSelectedInstOperands,
     /* 275545 */     // GIR_Coverage, 5078,
     /* 275545 */     GIR_EraseRootFromParent_Done,
     /* 275546 */   // Label 5541: @275546
     /* 275546 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(275575), // Rule ID 5085 //
     /* 275551 */     // MIs[0] Operand 1
     /* 275551 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275564 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 275567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275573 */     GIR_RootConstrainSelectedInstOperands,
     /* 275574 */     // GIR_Coverage, 5085,
     /* 275574 */     GIR_EraseRootFromParent_Done,
     /* 275575 */   // Label 5542: @275575
     /* 275575 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(275604), // Rule ID 5092 //
     /* 275580 */     // MIs[0] Operand 1
     /* 275580 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275593 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 275596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275602 */     GIR_RootConstrainSelectedInstOperands,
     /* 275603 */     // GIR_Coverage, 5092,
     /* 275603 */     GIR_EraseRootFromParent_Done,
     /* 275604 */   // Label 5543: @275604
     /* 275604 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(275633), // Rule ID 5099 //
     /* 275609 */     // MIs[0] Operand 1
     /* 275609 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275622 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 275625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275631 */     GIR_RootConstrainSelectedInstOperands,
     /* 275632 */     // GIR_Coverage, 5099,
     /* 275632 */     GIR_EraseRootFromParent_Done,
     /* 275633 */   // Label 5544: @275633
     /* 275633 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(275662), // Rule ID 5106 //
     /* 275638 */     // MIs[0] Operand 1
     /* 275638 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275651 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 275651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 275654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275660 */     GIR_RootConstrainSelectedInstOperands,
     /* 275661 */     // GIR_Coverage, 5106,
     /* 275661 */     GIR_EraseRootFromParent_Done,
     /* 275662 */   // Label 5545: @275662
     /* 275662 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(275691), // Rule ID 5113 //
     /* 275667 */     // MIs[0] Operand 1
     /* 275667 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275680 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 275680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 275683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275689 */     GIR_RootConstrainSelectedInstOperands,
     /* 275690 */     // GIR_Coverage, 5113,
     /* 275690 */     GIR_EraseRootFromParent_Done,
     /* 275691 */   // Label 5546: @275691
     /* 275691 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(275720), // Rule ID 5120 //
     /* 275696 */     // MIs[0] Operand 1
     /* 275696 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275709 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 275709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 275712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275718 */     GIR_RootConstrainSelectedInstOperands,
     /* 275719 */     // GIR_Coverage, 5120,
     /* 275719 */     GIR_EraseRootFromParent_Done,
     /* 275720 */   // Label 5547: @275720
     /* 275720 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(275749), // Rule ID 5127 //
     /* 275725 */     // MIs[0] Operand 1
     /* 275725 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 275730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275738 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 275738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 275741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275747 */     GIR_RootConstrainSelectedInstOperands,
     /* 275748 */     // GIR_Coverage, 5127,
     /* 275748 */     GIR_EraseRootFromParent_Done,
     /* 275749 */   // Label 5548: @275749
     /* 275749 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(275778), // Rule ID 5134 //
     /* 275754 */     // MIs[0] Operand 1
     /* 275754 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 275759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275767 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 275767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 275770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275776 */     GIR_RootConstrainSelectedInstOperands,
     /* 275777 */     // GIR_Coverage, 5134,
     /* 275777 */     GIR_EraseRootFromParent_Done,
     /* 275778 */   // Label 5549: @275778
     /* 275778 */   GIM_Reject,
     /* 275779 */ // Label 5519: @275779
     /* 275779 */ GIM_Reject,
     /* 275780 */ // Label 5500: @275780
     /* 275780 */ GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(276827),
     /* 275785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 275788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 275791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275795 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(275835), // Rule ID 756 //
     /* 275800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275803 */     // MIs[0] Operand 1
     /* 275803 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275812 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275818 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275826 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 275829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275833 */     GIR_RootConstrainSelectedInstOperands,
     /* 275834 */     // GIR_Coverage, 756,
     /* 275834 */     GIR_EraseRootFromParent_Done,
     /* 275835 */   // Label 5551: @275835
     /* 275835 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(275875), // Rule ID 763 //
     /* 275840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275843 */     // MIs[0] Operand 1
     /* 275843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275866 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 275869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275873 */     GIR_RootConstrainSelectedInstOperands,
     /* 275874 */     // GIR_Coverage, 763,
     /* 275874 */     GIR_EraseRootFromParent_Done,
     /* 275875 */   // Label 5552: @275875
     /* 275875 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(275912), // Rule ID 5178 //
     /* 275880 */     // MIs[0] Operand 1
     /* 275880 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275889 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275895 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275903 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 275906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275910 */     GIR_RootConstrainSelectedInstOperands,
     /* 275911 */     // GIR_Coverage, 5178,
     /* 275911 */     GIR_EraseRootFromParent_Done,
     /* 275912 */   // Label 5553: @275912
     /* 275912 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(275949), // Rule ID 5185 //
     /* 275917 */     // MIs[0] Operand 1
     /* 275917 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275926 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275932 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275940 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 275943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275947 */     GIR_RootConstrainSelectedInstOperands,
     /* 275948 */     // GIR_Coverage, 5185,
     /* 275948 */     GIR_EraseRootFromParent_Done,
     /* 275949 */   // Label 5554: @275949
     /* 275949 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(275986), // Rule ID 5192 //
     /* 275954 */     // MIs[0] Operand 1
     /* 275954 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275963 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275969 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275977 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 275977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 275980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275984 */     GIR_RootConstrainSelectedInstOperands,
     /* 275985 */     // GIR_Coverage, 5192,
     /* 275985 */     GIR_EraseRootFromParent_Done,
     /* 275986 */   // Label 5555: @275986
     /* 275986 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(276023), // Rule ID 5199 //
     /* 275991 */     // MIs[0] Operand 1
     /* 275991 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276000 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276006 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276014 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 276017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276021 */     GIR_RootConstrainSelectedInstOperands,
     /* 276022 */     // GIR_Coverage, 5199,
     /* 276022 */     GIR_EraseRootFromParent_Done,
     /* 276023 */   // Label 5556: @276023
     /* 276023 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(276060), // Rule ID 5206 //
     /* 276028 */     // MIs[0] Operand 1
     /* 276028 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276037 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276043 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276051 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 276054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276058 */     GIR_RootConstrainSelectedInstOperands,
     /* 276059 */     // GIR_Coverage, 5206,
     /* 276059 */     GIR_EraseRootFromParent_Done,
     /* 276060 */   // Label 5557: @276060
     /* 276060 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(276100), // Rule ID 728 //
     /* 276065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276068 */     // MIs[0] Operand 1
     /* 276068 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276087 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276091 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 276094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276098 */     GIR_RootConstrainSelectedInstOperands,
     /* 276099 */     // GIR_Coverage, 728,
     /* 276099 */     GIR_EraseRootFromParent_Done,
     /* 276100 */   // Label 5558: @276100
     /* 276100 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(276140), // Rule ID 741 //
     /* 276105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276108 */     // MIs[0] Operand 1
     /* 276108 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276121 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276127 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276131 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 276134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276138 */     GIR_RootConstrainSelectedInstOperands,
     /* 276139 */     // GIR_Coverage, 741,
     /* 276139 */     GIR_EraseRootFromParent_Done,
     /* 276140 */   // Label 5559: @276140
     /* 276140 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(276180), // Rule ID 742 //
     /* 276145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276148 */     // MIs[0] Operand 1
     /* 276148 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276161 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 276169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276171 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 276174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276178 */     GIR_RootConstrainSelectedInstOperands,
     /* 276179 */     // GIR_Coverage, 742,
     /* 276179 */     GIR_EraseRootFromParent_Done,
     /* 276180 */   // Label 5560: @276180
     /* 276180 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(276220), // Rule ID 749 //
     /* 276185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276188 */     // MIs[0] Operand 1
     /* 276188 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276201 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276207 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276211 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 276214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276218 */     GIR_RootConstrainSelectedInstOperands,
     /* 276219 */     // GIR_Coverage, 749,
     /* 276219 */     GIR_EraseRootFromParent_Done,
     /* 276220 */   // Label 5561: @276220
     /* 276220 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(276257), // Rule ID 5143 //
     /* 276225 */     // MIs[0] Operand 1
     /* 276225 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276238 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276244 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276248 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 276251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276255 */     GIR_RootConstrainSelectedInstOperands,
     /* 276256 */     // GIR_Coverage, 5143,
     /* 276256 */     GIR_EraseRootFromParent_Done,
     /* 276257 */   // Label 5562: @276257
     /* 276257 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(276294), // Rule ID 5150 //
     /* 276262 */     // MIs[0] Operand 1
     /* 276262 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276275 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276281 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276285 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 276288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276292 */     GIR_RootConstrainSelectedInstOperands,
     /* 276293 */     // GIR_Coverage, 5150,
     /* 276293 */     GIR_EraseRootFromParent_Done,
     /* 276294 */   // Label 5563: @276294
     /* 276294 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(276331), // Rule ID 5157 //
     /* 276299 */     // MIs[0] Operand 1
     /* 276299 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276312 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276318 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276322 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 276325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276329 */     GIR_RootConstrainSelectedInstOperands,
     /* 276330 */     // GIR_Coverage, 5157,
     /* 276330 */     GIR_EraseRootFromParent_Done,
     /* 276331 */   // Label 5564: @276331
     /* 276331 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(276368), // Rule ID 5164 //
     /* 276336 */     // MIs[0] Operand 1
     /* 276336 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276349 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276355 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276359 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 276362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276366 */     GIR_RootConstrainSelectedInstOperands,
     /* 276367 */     // GIR_Coverage, 5164,
     /* 276367 */     GIR_EraseRootFromParent_Done,
     /* 276368 */   // Label 5565: @276368
     /* 276368 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(276405), // Rule ID 5171 //
     /* 276373 */     // MIs[0] Operand 1
     /* 276373 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276392 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276396 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 276396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 276399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276403 */     GIR_RootConstrainSelectedInstOperands,
     /* 276404 */     // GIR_Coverage, 5171,
     /* 276404 */     GIR_EraseRootFromParent_Done,
     /* 276405 */   // Label 5566: @276405
     /* 276405 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(276437), // Rule ID 1127 //
     /* 276410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276413 */     // MIs[0] Operand 1
     /* 276413 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276426 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 276429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276435 */     GIR_RootConstrainSelectedInstOperands,
     /* 276436 */     // GIR_Coverage, 1127,
     /* 276436 */     GIR_EraseRootFromParent_Done,
     /* 276437 */   // Label 5567: @276437
     /* 276437 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(276469), // Rule ID 1134 //
     /* 276442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276445 */     // MIs[0] Operand 1
     /* 276445 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276458 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 276461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276467 */     GIR_RootConstrainSelectedInstOperands,
     /* 276468 */     // GIR_Coverage, 1134,
     /* 276468 */     GIR_EraseRootFromParent_Done,
     /* 276469 */   // Label 5568: @276469
     /* 276469 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(276501), // Rule ID 1141 //
     /* 276474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276477 */     // MIs[0] Operand 1
     /* 276477 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276490 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 276493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276499 */     GIR_RootConstrainSelectedInstOperands,
     /* 276500 */     // GIR_Coverage, 1141,
     /* 276500 */     GIR_EraseRootFromParent_Done,
     /* 276501 */   // Label 5569: @276501
     /* 276501 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(276533), // Rule ID 1148 //
     /* 276506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276509 */     // MIs[0] Operand 1
     /* 276509 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276522 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 276525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276531 */     GIR_RootConstrainSelectedInstOperands,
     /* 276532 */     // GIR_Coverage, 1148,
     /* 276532 */     GIR_EraseRootFromParent_Done,
     /* 276533 */   // Label 5570: @276533
     /* 276533 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(276565), // Rule ID 1155 //
     /* 276538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276541 */     // MIs[0] Operand 1
     /* 276541 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276554 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 276557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276563 */     GIR_RootConstrainSelectedInstOperands,
     /* 276564 */     // GIR_Coverage, 1155,
     /* 276564 */     GIR_EraseRootFromParent_Done,
     /* 276565 */   // Label 5571: @276565
     /* 276565 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(276594), // Rule ID 5080 //
     /* 276570 */     // MIs[0] Operand 1
     /* 276570 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276583 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 276586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276592 */     GIR_RootConstrainSelectedInstOperands,
     /* 276593 */     // GIR_Coverage, 5080,
     /* 276593 */     GIR_EraseRootFromParent_Done,
     /* 276594 */   // Label 5572: @276594
     /* 276594 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(276623), // Rule ID 5087 //
     /* 276599 */     // MIs[0] Operand 1
     /* 276599 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276612 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 276615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276621 */     GIR_RootConstrainSelectedInstOperands,
     /* 276622 */     // GIR_Coverage, 5087,
     /* 276622 */     GIR_EraseRootFromParent_Done,
     /* 276623 */   // Label 5573: @276623
     /* 276623 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(276652), // Rule ID 5094 //
     /* 276628 */     // MIs[0] Operand 1
     /* 276628 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276641 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 276644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276650 */     GIR_RootConstrainSelectedInstOperands,
     /* 276651 */     // GIR_Coverage, 5094,
     /* 276651 */     GIR_EraseRootFromParent_Done,
     /* 276652 */   // Label 5574: @276652
     /* 276652 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(276681), // Rule ID 5101 //
     /* 276657 */     // MIs[0] Operand 1
     /* 276657 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276670 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 276673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276679 */     GIR_RootConstrainSelectedInstOperands,
     /* 276680 */     // GIR_Coverage, 5101,
     /* 276680 */     GIR_EraseRootFromParent_Done,
     /* 276681 */   // Label 5575: @276681
     /* 276681 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(276710), // Rule ID 5108 //
     /* 276686 */     // MIs[0] Operand 1
     /* 276686 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276699 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 276702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276708 */     GIR_RootConstrainSelectedInstOperands,
     /* 276709 */     // GIR_Coverage, 5108,
     /* 276709 */     GIR_EraseRootFromParent_Done,
     /* 276710 */   // Label 5576: @276710
     /* 276710 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(276739), // Rule ID 5115 //
     /* 276715 */     // MIs[0] Operand 1
     /* 276715 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276728 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 276731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276737 */     GIR_RootConstrainSelectedInstOperands,
     /* 276738 */     // GIR_Coverage, 5115,
     /* 276738 */     GIR_EraseRootFromParent_Done,
     /* 276739 */   // Label 5577: @276739
     /* 276739 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(276768), // Rule ID 5122 //
     /* 276744 */     // MIs[0] Operand 1
     /* 276744 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276757 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 276760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276766 */     GIR_RootConstrainSelectedInstOperands,
     /* 276767 */     // GIR_Coverage, 5122,
     /* 276767 */     GIR_EraseRootFromParent_Done,
     /* 276768 */   // Label 5578: @276768
     /* 276768 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(276797), // Rule ID 5129 //
     /* 276773 */     // MIs[0] Operand 1
     /* 276773 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 276778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276786 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 276789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276795 */     GIR_RootConstrainSelectedInstOperands,
     /* 276796 */     // GIR_Coverage, 5129,
     /* 276796 */     GIR_EraseRootFromParent_Done,
     /* 276797 */   // Label 5579: @276797
     /* 276797 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(276826), // Rule ID 5136 //
     /* 276802 */     // MIs[0] Operand 1
     /* 276802 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 276807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276815 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 276818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276824 */     GIR_RootConstrainSelectedInstOperands,
     /* 276825 */     // GIR_Coverage, 5136,
     /* 276825 */     GIR_EraseRootFromParent_Done,
     /* 276826 */   // Label 5580: @276826
     /* 276826 */   GIM_Reject,
     /* 276827 */ // Label 5550: @276827
     /* 276827 */ GIM_Reject,
     /* 276828 */ // Label 5501: @276828
     /* 276828 */ GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(277875),
     /* 276833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 276836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 276839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276843 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(276883), // Rule ID 752 //
     /* 276848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276851 */     // MIs[0] Operand 1
     /* 276851 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276866 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276874 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 276874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 276877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276881 */     GIR_RootConstrainSelectedInstOperands,
     /* 276882 */     // GIR_Coverage, 752,
     /* 276882 */     GIR_EraseRootFromParent_Done,
     /* 276883 */   // Label 5582: @276883
     /* 276883 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(276923), // Rule ID 759 //
     /* 276888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276891 */     // MIs[0] Operand 1
     /* 276891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276900 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276906 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276914 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 276914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 276917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276921 */     GIR_RootConstrainSelectedInstOperands,
     /* 276922 */     // GIR_Coverage, 759,
     /* 276922 */     GIR_EraseRootFromParent_Done,
     /* 276923 */   // Label 5583: @276923
     /* 276923 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(276960), // Rule ID 5174 //
     /* 276928 */     // MIs[0] Operand 1
     /* 276928 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276937 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276943 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276951 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 276951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 276954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276958 */     GIR_RootConstrainSelectedInstOperands,
     /* 276959 */     // GIR_Coverage, 5174,
     /* 276959 */     GIR_EraseRootFromParent_Done,
     /* 276960 */   // Label 5584: @276960
     /* 276960 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(276997), // Rule ID 5181 //
     /* 276965 */     // MIs[0] Operand 1
     /* 276965 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276974 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276980 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276988 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 276988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 276991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276995 */     GIR_RootConstrainSelectedInstOperands,
     /* 276996 */     // GIR_Coverage, 5181,
     /* 276996 */     GIR_EraseRootFromParent_Done,
     /* 276997 */   // Label 5585: @276997
     /* 276997 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(277034), // Rule ID 5188 //
     /* 277002 */     // MIs[0] Operand 1
     /* 277002 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277011 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277017 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277025 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 277028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277032 */     GIR_RootConstrainSelectedInstOperands,
     /* 277033 */     // GIR_Coverage, 5188,
     /* 277033 */     GIR_EraseRootFromParent_Done,
     /* 277034 */   // Label 5586: @277034
     /* 277034 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(277071), // Rule ID 5195 //
     /* 277039 */     // MIs[0] Operand 1
     /* 277039 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277054 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277062 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 277065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277069 */     GIR_RootConstrainSelectedInstOperands,
     /* 277070 */     // GIR_Coverage, 5195,
     /* 277070 */     GIR_EraseRootFromParent_Done,
     /* 277071 */   // Label 5587: @277071
     /* 277071 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(277108), // Rule ID 5202 //
     /* 277076 */     // MIs[0] Operand 1
     /* 277076 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277085 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277091 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277099 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 277102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277106 */     GIR_RootConstrainSelectedInstOperands,
     /* 277107 */     // GIR_Coverage, 5202,
     /* 277107 */     GIR_EraseRootFromParent_Done,
     /* 277108 */   // Label 5588: @277108
     /* 277108 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(277148), // Rule ID 724 //
     /* 277113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277116 */     // MIs[0] Operand 1
     /* 277116 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277129 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277135 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277139 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 277142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277146 */     GIR_RootConstrainSelectedInstOperands,
     /* 277147 */     // GIR_Coverage, 724,
     /* 277147 */     GIR_EraseRootFromParent_Done,
     /* 277148 */   // Label 5589: @277148
     /* 277148 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(277188), // Rule ID 733 //
     /* 277153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277156 */     // MIs[0] Operand 1
     /* 277156 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277169 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277175 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277179 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 277182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277186 */     GIR_RootConstrainSelectedInstOperands,
     /* 277187 */     // GIR_Coverage, 733,
     /* 277187 */     GIR_EraseRootFromParent_Done,
     /* 277188 */   // Label 5590: @277188
     /* 277188 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(277228), // Rule ID 734 //
     /* 277193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277196 */     // MIs[0] Operand 1
     /* 277196 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 277217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277219 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 277222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277226 */     GIR_RootConstrainSelectedInstOperands,
     /* 277227 */     // GIR_Coverage, 734,
     /* 277227 */     GIR_EraseRootFromParent_Done,
     /* 277228 */   // Label 5591: @277228
     /* 277228 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(277268), // Rule ID 745 //
     /* 277233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277236 */     // MIs[0] Operand 1
     /* 277236 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277249 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277255 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277259 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 277262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277266 */     GIR_RootConstrainSelectedInstOperands,
     /* 277267 */     // GIR_Coverage, 745,
     /* 277267 */     GIR_EraseRootFromParent_Done,
     /* 277268 */   // Label 5592: @277268
     /* 277268 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(277305), // Rule ID 5139 //
     /* 277273 */     // MIs[0] Operand 1
     /* 277273 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277286 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277292 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277296 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 277299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277303 */     GIR_RootConstrainSelectedInstOperands,
     /* 277304 */     // GIR_Coverage, 5139,
     /* 277304 */     GIR_EraseRootFromParent_Done,
     /* 277305 */   // Label 5593: @277305
     /* 277305 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(277342), // Rule ID 5146 //
     /* 277310 */     // MIs[0] Operand 1
     /* 277310 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277329 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277333 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 277336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277340 */     GIR_RootConstrainSelectedInstOperands,
     /* 277341 */     // GIR_Coverage, 5146,
     /* 277341 */     GIR_EraseRootFromParent_Done,
     /* 277342 */   // Label 5594: @277342
     /* 277342 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(277379), // Rule ID 5153 //
     /* 277347 */     // MIs[0] Operand 1
     /* 277347 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277360 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277366 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277370 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 277373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277377 */     GIR_RootConstrainSelectedInstOperands,
     /* 277378 */     // GIR_Coverage, 5153,
     /* 277378 */     GIR_EraseRootFromParent_Done,
     /* 277379 */   // Label 5595: @277379
     /* 277379 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(277416), // Rule ID 5160 //
     /* 277384 */     // MIs[0] Operand 1
     /* 277384 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277397 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277403 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277407 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 277410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277414 */     GIR_RootConstrainSelectedInstOperands,
     /* 277415 */     // GIR_Coverage, 5160,
     /* 277415 */     GIR_EraseRootFromParent_Done,
     /* 277416 */   // Label 5596: @277416
     /* 277416 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(277453), // Rule ID 5167 //
     /* 277421 */     // MIs[0] Operand 1
     /* 277421 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277434 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277440 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277444 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 277444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 277447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277451 */     GIR_RootConstrainSelectedInstOperands,
     /* 277452 */     // GIR_Coverage, 5167,
     /* 277452 */     GIR_EraseRootFromParent_Done,
     /* 277453 */   // Label 5597: @277453
     /* 277453 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(277485), // Rule ID 1123 //
     /* 277458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277461 */     // MIs[0] Operand 1
     /* 277461 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277474 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 277477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277483 */     GIR_RootConstrainSelectedInstOperands,
     /* 277484 */     // GIR_Coverage, 1123,
     /* 277484 */     GIR_EraseRootFromParent_Done,
     /* 277485 */   // Label 5598: @277485
     /* 277485 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(277517), // Rule ID 1130 //
     /* 277490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277493 */     // MIs[0] Operand 1
     /* 277493 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277506 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 277509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277515 */     GIR_RootConstrainSelectedInstOperands,
     /* 277516 */     // GIR_Coverage, 1130,
     /* 277516 */     GIR_EraseRootFromParent_Done,
     /* 277517 */   // Label 5599: @277517
     /* 277517 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(277549), // Rule ID 1137 //
     /* 277522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277525 */     // MIs[0] Operand 1
     /* 277525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277538 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 277541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277547 */     GIR_RootConstrainSelectedInstOperands,
     /* 277548 */     // GIR_Coverage, 1137,
     /* 277548 */     GIR_EraseRootFromParent_Done,
     /* 277549 */   // Label 5600: @277549
     /* 277549 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(277581), // Rule ID 1144 //
     /* 277554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277557 */     // MIs[0] Operand 1
     /* 277557 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277570 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 277573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277579 */     GIR_RootConstrainSelectedInstOperands,
     /* 277580 */     // GIR_Coverage, 1144,
     /* 277580 */     GIR_EraseRootFromParent_Done,
     /* 277581 */   // Label 5601: @277581
     /* 277581 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(277613), // Rule ID 1151 //
     /* 277586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277589 */     // MIs[0] Operand 1
     /* 277589 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277602 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 277605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277611 */     GIR_RootConstrainSelectedInstOperands,
     /* 277612 */     // GIR_Coverage, 1151,
     /* 277612 */     GIR_EraseRootFromParent_Done,
     /* 277613 */   // Label 5602: @277613
     /* 277613 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(277642), // Rule ID 5076 //
     /* 277618 */     // MIs[0] Operand 1
     /* 277618 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277631 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 277634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277640 */     GIR_RootConstrainSelectedInstOperands,
     /* 277641 */     // GIR_Coverage, 5076,
     /* 277641 */     GIR_EraseRootFromParent_Done,
     /* 277642 */   // Label 5603: @277642
     /* 277642 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(277671), // Rule ID 5083 //
     /* 277647 */     // MIs[0] Operand 1
     /* 277647 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277660 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 277663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277669 */     GIR_RootConstrainSelectedInstOperands,
     /* 277670 */     // GIR_Coverage, 5083,
     /* 277670 */     GIR_EraseRootFromParent_Done,
     /* 277671 */   // Label 5604: @277671
     /* 277671 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(277700), // Rule ID 5090 //
     /* 277676 */     // MIs[0] Operand 1
     /* 277676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277689 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 277692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277698 */     GIR_RootConstrainSelectedInstOperands,
     /* 277699 */     // GIR_Coverage, 5090,
     /* 277699 */     GIR_EraseRootFromParent_Done,
     /* 277700 */   // Label 5605: @277700
     /* 277700 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(277729), // Rule ID 5097 //
     /* 277705 */     // MIs[0] Operand 1
     /* 277705 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277718 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 277721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277727 */     GIR_RootConstrainSelectedInstOperands,
     /* 277728 */     // GIR_Coverage, 5097,
     /* 277728 */     GIR_EraseRootFromParent_Done,
     /* 277729 */   // Label 5606: @277729
     /* 277729 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(277758), // Rule ID 5104 //
     /* 277734 */     // MIs[0] Operand 1
     /* 277734 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277747 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 277747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 277750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277756 */     GIR_RootConstrainSelectedInstOperands,
     /* 277757 */     // GIR_Coverage, 5104,
     /* 277757 */     GIR_EraseRootFromParent_Done,
     /* 277758 */   // Label 5607: @277758
     /* 277758 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(277787), // Rule ID 5111 //
     /* 277763 */     // MIs[0] Operand 1
     /* 277763 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277776 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 277776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 277779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277785 */     GIR_RootConstrainSelectedInstOperands,
     /* 277786 */     // GIR_Coverage, 5111,
     /* 277786 */     GIR_EraseRootFromParent_Done,
     /* 277787 */   // Label 5608: @277787
     /* 277787 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(277816), // Rule ID 5118 //
     /* 277792 */     // MIs[0] Operand 1
     /* 277792 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277805 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 277805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 277808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277814 */     GIR_RootConstrainSelectedInstOperands,
     /* 277815 */     // GIR_Coverage, 5118,
     /* 277815 */     GIR_EraseRootFromParent_Done,
     /* 277816 */   // Label 5609: @277816
     /* 277816 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(277845), // Rule ID 5125 //
     /* 277821 */     // MIs[0] Operand 1
     /* 277821 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 277826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277834 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 277834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 277837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277843 */     GIR_RootConstrainSelectedInstOperands,
     /* 277844 */     // GIR_Coverage, 5125,
     /* 277844 */     GIR_EraseRootFromParent_Done,
     /* 277845 */   // Label 5610: @277845
     /* 277845 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(277874), // Rule ID 5132 //
     /* 277850 */     // MIs[0] Operand 1
     /* 277850 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 277855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277863 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 277863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 277866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277872 */     GIR_RootConstrainSelectedInstOperands,
     /* 277873 */     // GIR_Coverage, 5132,
     /* 277873 */     GIR_EraseRootFromParent_Done,
     /* 277874 */   // Label 5611: @277874
     /* 277874 */   GIM_Reject,
     /* 277875 */ // Label 5581: @277875
     /* 277875 */ GIM_Reject,
     /* 277876 */ // Label 5502: @277876
     /* 277876 */ GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(278923),
     /* 277881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 277887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277891 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(277931), // Rule ID 755 //
     /* 277896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277899 */     // MIs[0] Operand 1
     /* 277899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277908 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277914 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277922 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 277922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 277925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277929 */     GIR_RootConstrainSelectedInstOperands,
     /* 277930 */     // GIR_Coverage, 755,
     /* 277930 */     GIR_EraseRootFromParent_Done,
     /* 277931 */   // Label 5613: @277931
     /* 277931 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(277971), // Rule ID 762 //
     /* 277936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277939 */     // MIs[0] Operand 1
     /* 277939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277948 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277954 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277962 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 277962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 277965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277969 */     GIR_RootConstrainSelectedInstOperands,
     /* 277970 */     // GIR_Coverage, 762,
     /* 277970 */     GIR_EraseRootFromParent_Done,
     /* 277971 */   // Label 5614: @277971
     /* 277971 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(278008), // Rule ID 5177 //
     /* 277976 */     // MIs[0] Operand 1
     /* 277976 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277985 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277991 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277999 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 277999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 278002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278006 */     GIR_RootConstrainSelectedInstOperands,
     /* 278007 */     // GIR_Coverage, 5177,
     /* 278007 */     GIR_EraseRootFromParent_Done,
     /* 278008 */   // Label 5615: @278008
     /* 278008 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(278045), // Rule ID 5184 //
     /* 278013 */     // MIs[0] Operand 1
     /* 278013 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278022 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278028 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278036 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 278039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278043 */     GIR_RootConstrainSelectedInstOperands,
     /* 278044 */     // GIR_Coverage, 5184,
     /* 278044 */     GIR_EraseRootFromParent_Done,
     /* 278045 */   // Label 5616: @278045
     /* 278045 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(278082), // Rule ID 5191 //
     /* 278050 */     // MIs[0] Operand 1
     /* 278050 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278059 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278065 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278073 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 278076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278080 */     GIR_RootConstrainSelectedInstOperands,
     /* 278081 */     // GIR_Coverage, 5191,
     /* 278081 */     GIR_EraseRootFromParent_Done,
     /* 278082 */   // Label 5617: @278082
     /* 278082 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(278119), // Rule ID 5198 //
     /* 278087 */     // MIs[0] Operand 1
     /* 278087 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278096 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278102 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278110 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 278113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278117 */     GIR_RootConstrainSelectedInstOperands,
     /* 278118 */     // GIR_Coverage, 5198,
     /* 278118 */     GIR_EraseRootFromParent_Done,
     /* 278119 */   // Label 5618: @278119
     /* 278119 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(278156), // Rule ID 5205 //
     /* 278124 */     // MIs[0] Operand 1
     /* 278124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278133 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278139 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278147 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 278150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278154 */     GIR_RootConstrainSelectedInstOperands,
     /* 278155 */     // GIR_Coverage, 5205,
     /* 278155 */     GIR_EraseRootFromParent_Done,
     /* 278156 */   // Label 5619: @278156
     /* 278156 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(278196), // Rule ID 727 //
     /* 278161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278164 */     // MIs[0] Operand 1
     /* 278164 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278187 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 278190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278194 */     GIR_RootConstrainSelectedInstOperands,
     /* 278195 */     // GIR_Coverage, 727,
     /* 278195 */     GIR_EraseRootFromParent_Done,
     /* 278196 */   // Label 5620: @278196
     /* 278196 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(278236), // Rule ID 739 //
     /* 278201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278204 */     // MIs[0] Operand 1
     /* 278204 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278217 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278223 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278227 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 278230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278234 */     GIR_RootConstrainSelectedInstOperands,
     /* 278235 */     // GIR_Coverage, 739,
     /* 278235 */     GIR_EraseRootFromParent_Done,
     /* 278236 */   // Label 5621: @278236
     /* 278236 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(278276), // Rule ID 740 //
     /* 278241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278244 */     // MIs[0] Operand 1
     /* 278244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278257 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278263 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 278265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278267 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 278270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278274 */     GIR_RootConstrainSelectedInstOperands,
     /* 278275 */     // GIR_Coverage, 740,
     /* 278275 */     GIR_EraseRootFromParent_Done,
     /* 278276 */   // Label 5622: @278276
     /* 278276 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(278316), // Rule ID 748 //
     /* 278281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278284 */     // MIs[0] Operand 1
     /* 278284 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278297 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278303 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278307 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 278310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278314 */     GIR_RootConstrainSelectedInstOperands,
     /* 278315 */     // GIR_Coverage, 748,
     /* 278315 */     GIR_EraseRootFromParent_Done,
     /* 278316 */   // Label 5623: @278316
     /* 278316 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(278353), // Rule ID 5142 //
     /* 278321 */     // MIs[0] Operand 1
     /* 278321 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278334 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278340 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278344 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 278347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278351 */     GIR_RootConstrainSelectedInstOperands,
     /* 278352 */     // GIR_Coverage, 5142,
     /* 278352 */     GIR_EraseRootFromParent_Done,
     /* 278353 */   // Label 5624: @278353
     /* 278353 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(278390), // Rule ID 5149 //
     /* 278358 */     // MIs[0] Operand 1
     /* 278358 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278381 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 278384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278388 */     GIR_RootConstrainSelectedInstOperands,
     /* 278389 */     // GIR_Coverage, 5149,
     /* 278389 */     GIR_EraseRootFromParent_Done,
     /* 278390 */   // Label 5625: @278390
     /* 278390 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(278427), // Rule ID 5156 //
     /* 278395 */     // MIs[0] Operand 1
     /* 278395 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278408 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278414 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278418 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 278421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278425 */     GIR_RootConstrainSelectedInstOperands,
     /* 278426 */     // GIR_Coverage, 5156,
     /* 278426 */     GIR_EraseRootFromParent_Done,
     /* 278427 */   // Label 5626: @278427
     /* 278427 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(278464), // Rule ID 5163 //
     /* 278432 */     // MIs[0] Operand 1
     /* 278432 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278445 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278451 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278455 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 278458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278462 */     GIR_RootConstrainSelectedInstOperands,
     /* 278463 */     // GIR_Coverage, 5163,
     /* 278463 */     GIR_EraseRootFromParent_Done,
     /* 278464 */   // Label 5627: @278464
     /* 278464 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(278501), // Rule ID 5170 //
     /* 278469 */     // MIs[0] Operand 1
     /* 278469 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278482 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278488 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278492 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 278492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 278495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278499 */     GIR_RootConstrainSelectedInstOperands,
     /* 278500 */     // GIR_Coverage, 5170,
     /* 278500 */     GIR_EraseRootFromParent_Done,
     /* 278501 */   // Label 5628: @278501
     /* 278501 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(278533), // Rule ID 1126 //
     /* 278506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278509 */     // MIs[0] Operand 1
     /* 278509 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278522 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 278525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278531 */     GIR_RootConstrainSelectedInstOperands,
     /* 278532 */     // GIR_Coverage, 1126,
     /* 278532 */     GIR_EraseRootFromParent_Done,
     /* 278533 */   // Label 5629: @278533
     /* 278533 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(278565), // Rule ID 1133 //
     /* 278538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278541 */     // MIs[0] Operand 1
     /* 278541 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278554 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 278557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278563 */     GIR_RootConstrainSelectedInstOperands,
     /* 278564 */     // GIR_Coverage, 1133,
     /* 278564 */     GIR_EraseRootFromParent_Done,
     /* 278565 */   // Label 5630: @278565
     /* 278565 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(278597), // Rule ID 1140 //
     /* 278570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278573 */     // MIs[0] Operand 1
     /* 278573 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278586 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 278589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278595 */     GIR_RootConstrainSelectedInstOperands,
     /* 278596 */     // GIR_Coverage, 1140,
     /* 278596 */     GIR_EraseRootFromParent_Done,
     /* 278597 */   // Label 5631: @278597
     /* 278597 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(278629), // Rule ID 1147 //
     /* 278602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278605 */     // MIs[0] Operand 1
     /* 278605 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278618 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 278621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278627 */     GIR_RootConstrainSelectedInstOperands,
     /* 278628 */     // GIR_Coverage, 1147,
     /* 278628 */     GIR_EraseRootFromParent_Done,
     /* 278629 */   // Label 5632: @278629
     /* 278629 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(278661), // Rule ID 1154 //
     /* 278634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278637 */     // MIs[0] Operand 1
     /* 278637 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278650 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 278653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278659 */     GIR_RootConstrainSelectedInstOperands,
     /* 278660 */     // GIR_Coverage, 1154,
     /* 278660 */     GIR_EraseRootFromParent_Done,
     /* 278661 */   // Label 5633: @278661
     /* 278661 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(278690), // Rule ID 5079 //
     /* 278666 */     // MIs[0] Operand 1
     /* 278666 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278679 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 278682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278688 */     GIR_RootConstrainSelectedInstOperands,
     /* 278689 */     // GIR_Coverage, 5079,
     /* 278689 */     GIR_EraseRootFromParent_Done,
     /* 278690 */   // Label 5634: @278690
     /* 278690 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(278719), // Rule ID 5086 //
     /* 278695 */     // MIs[0] Operand 1
     /* 278695 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278708 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 278711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278717 */     GIR_RootConstrainSelectedInstOperands,
     /* 278718 */     // GIR_Coverage, 5086,
     /* 278718 */     GIR_EraseRootFromParent_Done,
     /* 278719 */   // Label 5635: @278719
     /* 278719 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(278748), // Rule ID 5093 //
     /* 278724 */     // MIs[0] Operand 1
     /* 278724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278737 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 278740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278746 */     GIR_RootConstrainSelectedInstOperands,
     /* 278747 */     // GIR_Coverage, 5093,
     /* 278747 */     GIR_EraseRootFromParent_Done,
     /* 278748 */   // Label 5636: @278748
     /* 278748 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(278777), // Rule ID 5100 //
     /* 278753 */     // MIs[0] Operand 1
     /* 278753 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278766 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 278769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278775 */     GIR_RootConstrainSelectedInstOperands,
     /* 278776 */     // GIR_Coverage, 5100,
     /* 278776 */     GIR_EraseRootFromParent_Done,
     /* 278777 */   // Label 5637: @278777
     /* 278777 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(278806), // Rule ID 5107 //
     /* 278782 */     // MIs[0] Operand 1
     /* 278782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278795 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 278798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278804 */     GIR_RootConstrainSelectedInstOperands,
     /* 278805 */     // GIR_Coverage, 5107,
     /* 278805 */     GIR_EraseRootFromParent_Done,
     /* 278806 */   // Label 5638: @278806
     /* 278806 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(278835), // Rule ID 5114 //
     /* 278811 */     // MIs[0] Operand 1
     /* 278811 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278824 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 278827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278833 */     GIR_RootConstrainSelectedInstOperands,
     /* 278834 */     // GIR_Coverage, 5114,
     /* 278834 */     GIR_EraseRootFromParent_Done,
     /* 278835 */   // Label 5639: @278835
     /* 278835 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(278864), // Rule ID 5121 //
     /* 278840 */     // MIs[0] Operand 1
     /* 278840 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278853 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 278856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278862 */     GIR_RootConstrainSelectedInstOperands,
     /* 278863 */     // GIR_Coverage, 5121,
     /* 278863 */     GIR_EraseRootFromParent_Done,
     /* 278864 */   // Label 5640: @278864
     /* 278864 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(278893), // Rule ID 5128 //
     /* 278869 */     // MIs[0] Operand 1
     /* 278869 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 278874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278882 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 278885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278891 */     GIR_RootConstrainSelectedInstOperands,
     /* 278892 */     // GIR_Coverage, 5128,
     /* 278892 */     GIR_EraseRootFromParent_Done,
     /* 278893 */   // Label 5641: @278893
     /* 278893 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(278922), // Rule ID 5135 //
     /* 278898 */     // MIs[0] Operand 1
     /* 278898 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 278903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278911 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 278914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278920 */     GIR_RootConstrainSelectedInstOperands,
     /* 278921 */     // GIR_Coverage, 5135,
     /* 278921 */     GIR_EraseRootFromParent_Done,
     /* 278922 */   // Label 5642: @278922
     /* 278922 */   GIM_Reject,
     /* 278923 */ // Label 5612: @278923
     /* 278923 */ GIM_Reject,
     /* 278924 */ // Label 5503: @278924
     /* 278924 */ GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(279971),
     /* 278929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 278935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278939 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(278979), // Rule ID 750 //
     /* 278944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278947 */     // MIs[0] Operand 1
     /* 278947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278956 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278962 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278970 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 278970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 278973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278977 */     GIR_RootConstrainSelectedInstOperands,
     /* 278978 */     // GIR_Coverage, 750,
     /* 278978 */     GIR_EraseRootFromParent_Done,
     /* 278979 */   // Label 5644: @278979
     /* 278979 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(279019), // Rule ID 757 //
     /* 278984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278987 */     // MIs[0] Operand 1
     /* 278987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278996 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279002 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279010 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 279013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279017 */     GIR_RootConstrainSelectedInstOperands,
     /* 279018 */     // GIR_Coverage, 757,
     /* 279018 */     GIR_EraseRootFromParent_Done,
     /* 279019 */   // Label 5645: @279019
     /* 279019 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(279056), // Rule ID 5172 //
     /* 279024 */     // MIs[0] Operand 1
     /* 279024 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279033 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279039 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279047 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 279050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279054 */     GIR_RootConstrainSelectedInstOperands,
     /* 279055 */     // GIR_Coverage, 5172,
     /* 279055 */     GIR_EraseRootFromParent_Done,
     /* 279056 */   // Label 5646: @279056
     /* 279056 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(279093), // Rule ID 5179 //
     /* 279061 */     // MIs[0] Operand 1
     /* 279061 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279070 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279076 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279084 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 279087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279091 */     GIR_RootConstrainSelectedInstOperands,
     /* 279092 */     // GIR_Coverage, 5179,
     /* 279092 */     GIR_EraseRootFromParent_Done,
     /* 279093 */   // Label 5647: @279093
     /* 279093 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(279130), // Rule ID 5186 //
     /* 279098 */     // MIs[0] Operand 1
     /* 279098 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279107 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279113 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279121 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 279124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279128 */     GIR_RootConstrainSelectedInstOperands,
     /* 279129 */     // GIR_Coverage, 5186,
     /* 279129 */     GIR_EraseRootFromParent_Done,
     /* 279130 */   // Label 5648: @279130
     /* 279130 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(279167), // Rule ID 5193 //
     /* 279135 */     // MIs[0] Operand 1
     /* 279135 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279144 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279158 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 279161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279165 */     GIR_RootConstrainSelectedInstOperands,
     /* 279166 */     // GIR_Coverage, 5193,
     /* 279166 */     GIR_EraseRootFromParent_Done,
     /* 279167 */   // Label 5649: @279167
     /* 279167 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(279204), // Rule ID 5200 //
     /* 279172 */     // MIs[0] Operand 1
     /* 279172 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279181 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279187 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279195 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 279198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279202 */     GIR_RootConstrainSelectedInstOperands,
     /* 279203 */     // GIR_Coverage, 5200,
     /* 279203 */     GIR_EraseRootFromParent_Done,
     /* 279204 */   // Label 5650: @279204
     /* 279204 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(279244), // Rule ID 722 //
     /* 279209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279212 */     // MIs[0] Operand 1
     /* 279212 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279225 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279231 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279235 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 279238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279242 */     GIR_RootConstrainSelectedInstOperands,
     /* 279243 */     // GIR_Coverage, 722,
     /* 279243 */     GIR_EraseRootFromParent_Done,
     /* 279244 */   // Label 5651: @279244
     /* 279244 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(279284), // Rule ID 729 //
     /* 279249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279252 */     // MIs[0] Operand 1
     /* 279252 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279265 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279271 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279275 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 279278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279282 */     GIR_RootConstrainSelectedInstOperands,
     /* 279283 */     // GIR_Coverage, 729,
     /* 279283 */     GIR_EraseRootFromParent_Done,
     /* 279284 */   // Label 5652: @279284
     /* 279284 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(279324), // Rule ID 730 //
     /* 279289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279292 */     // MIs[0] Operand 1
     /* 279292 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279311 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 279313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279315 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 279318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279322 */     GIR_RootConstrainSelectedInstOperands,
     /* 279323 */     // GIR_Coverage, 730,
     /* 279323 */     GIR_EraseRootFromParent_Done,
     /* 279324 */   // Label 5653: @279324
     /* 279324 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(279364), // Rule ID 743 //
     /* 279329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279332 */     // MIs[0] Operand 1
     /* 279332 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279345 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279351 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279355 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 279358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279362 */     GIR_RootConstrainSelectedInstOperands,
     /* 279363 */     // GIR_Coverage, 743,
     /* 279363 */     GIR_EraseRootFromParent_Done,
     /* 279364 */   // Label 5654: @279364
     /* 279364 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(279401), // Rule ID 5137 //
     /* 279369 */     // MIs[0] Operand 1
     /* 279369 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279382 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279388 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279392 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 279395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279399 */     GIR_RootConstrainSelectedInstOperands,
     /* 279400 */     // GIR_Coverage, 5137,
     /* 279400 */     GIR_EraseRootFromParent_Done,
     /* 279401 */   // Label 5655: @279401
     /* 279401 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(279438), // Rule ID 5144 //
     /* 279406 */     // MIs[0] Operand 1
     /* 279406 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279419 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279425 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279429 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 279432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279436 */     GIR_RootConstrainSelectedInstOperands,
     /* 279437 */     // GIR_Coverage, 5144,
     /* 279437 */     GIR_EraseRootFromParent_Done,
     /* 279438 */   // Label 5656: @279438
     /* 279438 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(279475), // Rule ID 5151 //
     /* 279443 */     // MIs[0] Operand 1
     /* 279443 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279456 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279462 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279466 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 279469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279473 */     GIR_RootConstrainSelectedInstOperands,
     /* 279474 */     // GIR_Coverage, 5151,
     /* 279474 */     GIR_EraseRootFromParent_Done,
     /* 279475 */   // Label 5657: @279475
     /* 279475 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(279512), // Rule ID 5158 //
     /* 279480 */     // MIs[0] Operand 1
     /* 279480 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279493 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279499 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279503 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 279506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279510 */     GIR_RootConstrainSelectedInstOperands,
     /* 279511 */     // GIR_Coverage, 5158,
     /* 279511 */     GIR_EraseRootFromParent_Done,
     /* 279512 */   // Label 5658: @279512
     /* 279512 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(279549), // Rule ID 5165 //
     /* 279517 */     // MIs[0] Operand 1
     /* 279517 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279530 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279536 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279540 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 279540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 279543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279547 */     GIR_RootConstrainSelectedInstOperands,
     /* 279548 */     // GIR_Coverage, 5165,
     /* 279548 */     GIR_EraseRootFromParent_Done,
     /* 279549 */   // Label 5659: @279549
     /* 279549 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(279581), // Rule ID 1121 //
     /* 279554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279557 */     // MIs[0] Operand 1
     /* 279557 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279570 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 279573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279579 */     GIR_RootConstrainSelectedInstOperands,
     /* 279580 */     // GIR_Coverage, 1121,
     /* 279580 */     GIR_EraseRootFromParent_Done,
     /* 279581 */   // Label 5660: @279581
     /* 279581 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(279613), // Rule ID 1128 //
     /* 279586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279589 */     // MIs[0] Operand 1
     /* 279589 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279602 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 279605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279611 */     GIR_RootConstrainSelectedInstOperands,
     /* 279612 */     // GIR_Coverage, 1128,
     /* 279612 */     GIR_EraseRootFromParent_Done,
     /* 279613 */   // Label 5661: @279613
     /* 279613 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(279645), // Rule ID 1135 //
     /* 279618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279621 */     // MIs[0] Operand 1
     /* 279621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279634 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 279637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279643 */     GIR_RootConstrainSelectedInstOperands,
     /* 279644 */     // GIR_Coverage, 1135,
     /* 279644 */     GIR_EraseRootFromParent_Done,
     /* 279645 */   // Label 5662: @279645
     /* 279645 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(279677), // Rule ID 1142 //
     /* 279650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279653 */     // MIs[0] Operand 1
     /* 279653 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279666 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 279669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279675 */     GIR_RootConstrainSelectedInstOperands,
     /* 279676 */     // GIR_Coverage, 1142,
     /* 279676 */     GIR_EraseRootFromParent_Done,
     /* 279677 */   // Label 5663: @279677
     /* 279677 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(279709), // Rule ID 1149 //
     /* 279682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279685 */     // MIs[0] Operand 1
     /* 279685 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279698 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 279701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279707 */     GIR_RootConstrainSelectedInstOperands,
     /* 279708 */     // GIR_Coverage, 1149,
     /* 279708 */     GIR_EraseRootFromParent_Done,
     /* 279709 */   // Label 5664: @279709
     /* 279709 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(279738), // Rule ID 5074 //
     /* 279714 */     // MIs[0] Operand 1
     /* 279714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279727 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 279730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279736 */     GIR_RootConstrainSelectedInstOperands,
     /* 279737 */     // GIR_Coverage, 5074,
     /* 279737 */     GIR_EraseRootFromParent_Done,
     /* 279738 */   // Label 5665: @279738
     /* 279738 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(279767), // Rule ID 5081 //
     /* 279743 */     // MIs[0] Operand 1
     /* 279743 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279756 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 279759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279765 */     GIR_RootConstrainSelectedInstOperands,
     /* 279766 */     // GIR_Coverage, 5081,
     /* 279766 */     GIR_EraseRootFromParent_Done,
     /* 279767 */   // Label 5666: @279767
     /* 279767 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(279796), // Rule ID 5088 //
     /* 279772 */     // MIs[0] Operand 1
     /* 279772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279785 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 279788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279794 */     GIR_RootConstrainSelectedInstOperands,
     /* 279795 */     // GIR_Coverage, 5088,
     /* 279795 */     GIR_EraseRootFromParent_Done,
     /* 279796 */   // Label 5667: @279796
     /* 279796 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(279825), // Rule ID 5095 //
     /* 279801 */     // MIs[0] Operand 1
     /* 279801 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279814 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 279817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279823 */     GIR_RootConstrainSelectedInstOperands,
     /* 279824 */     // GIR_Coverage, 5095,
     /* 279824 */     GIR_EraseRootFromParent_Done,
     /* 279825 */   // Label 5668: @279825
     /* 279825 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(279854), // Rule ID 5102 //
     /* 279830 */     // MIs[0] Operand 1
     /* 279830 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279843 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 279843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 279846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279852 */     GIR_RootConstrainSelectedInstOperands,
     /* 279853 */     // GIR_Coverage, 5102,
     /* 279853 */     GIR_EraseRootFromParent_Done,
     /* 279854 */   // Label 5669: @279854
     /* 279854 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(279883), // Rule ID 5109 //
     /* 279859 */     // MIs[0] Operand 1
     /* 279859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279872 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 279872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 279875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279881 */     GIR_RootConstrainSelectedInstOperands,
     /* 279882 */     // GIR_Coverage, 5109,
     /* 279882 */     GIR_EraseRootFromParent_Done,
     /* 279883 */   // Label 5670: @279883
     /* 279883 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(279912), // Rule ID 5116 //
     /* 279888 */     // MIs[0] Operand 1
     /* 279888 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279901 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 279901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 279904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279910 */     GIR_RootConstrainSelectedInstOperands,
     /* 279911 */     // GIR_Coverage, 5116,
     /* 279911 */     GIR_EraseRootFromParent_Done,
     /* 279912 */   // Label 5671: @279912
     /* 279912 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(279941), // Rule ID 5123 //
     /* 279917 */     // MIs[0] Operand 1
     /* 279917 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 279922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279930 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 279930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 279933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279939 */     GIR_RootConstrainSelectedInstOperands,
     /* 279940 */     // GIR_Coverage, 5123,
     /* 279940 */     GIR_EraseRootFromParent_Done,
     /* 279941 */   // Label 5672: @279941
     /* 279941 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(279970), // Rule ID 5130 //
     /* 279946 */     // MIs[0] Operand 1
     /* 279946 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 279951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279959 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 279959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 279962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279968 */     GIR_RootConstrainSelectedInstOperands,
     /* 279969 */     // GIR_Coverage, 5130,
     /* 279969 */     GIR_EraseRootFromParent_Done,
     /* 279970 */   // Label 5673: @279970
     /* 279970 */   GIM_Reject,
     /* 279971 */ // Label 5643: @279971
     /* 279971 */ GIM_Reject,
     /* 279972 */ // Label 5504: @279972
     /* 279972 */ GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(281019),
     /* 279977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 279983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279987 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(280027), // Rule ID 753 //
     /* 279992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279995 */     // MIs[0] Operand 1
     /* 279995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280004 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280010 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280018 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 280021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280025 */     GIR_RootConstrainSelectedInstOperands,
     /* 280026 */     // GIR_Coverage, 753,
     /* 280026 */     GIR_EraseRootFromParent_Done,
     /* 280027 */   // Label 5675: @280027
     /* 280027 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(280067), // Rule ID 760 //
     /* 280032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280035 */     // MIs[0] Operand 1
     /* 280035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280044 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280050 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280058 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 280061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280065 */     GIR_RootConstrainSelectedInstOperands,
     /* 280066 */     // GIR_Coverage, 760,
     /* 280066 */     GIR_EraseRootFromParent_Done,
     /* 280067 */   // Label 5676: @280067
     /* 280067 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(280104), // Rule ID 5175 //
     /* 280072 */     // MIs[0] Operand 1
     /* 280072 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280087 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280095 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 280098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280102 */     GIR_RootConstrainSelectedInstOperands,
     /* 280103 */     // GIR_Coverage, 5175,
     /* 280103 */     GIR_EraseRootFromParent_Done,
     /* 280104 */   // Label 5677: @280104
     /* 280104 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(280141), // Rule ID 5182 //
     /* 280109 */     // MIs[0] Operand 1
     /* 280109 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280118 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280124 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280132 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 280135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280139 */     GIR_RootConstrainSelectedInstOperands,
     /* 280140 */     // GIR_Coverage, 5182,
     /* 280140 */     GIR_EraseRootFromParent_Done,
     /* 280141 */   // Label 5678: @280141
     /* 280141 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(280178), // Rule ID 5189 //
     /* 280146 */     // MIs[0] Operand 1
     /* 280146 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280155 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280161 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280169 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 280172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280176 */     GIR_RootConstrainSelectedInstOperands,
     /* 280177 */     // GIR_Coverage, 5189,
     /* 280177 */     GIR_EraseRootFromParent_Done,
     /* 280178 */   // Label 5679: @280178
     /* 280178 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(280215), // Rule ID 5196 //
     /* 280183 */     // MIs[0] Operand 1
     /* 280183 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 280188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280192 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280198 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280206 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 280209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280213 */     GIR_RootConstrainSelectedInstOperands,
     /* 280214 */     // GIR_Coverage, 5196,
     /* 280214 */     GIR_EraseRootFromParent_Done,
     /* 280215 */   // Label 5680: @280215
     /* 280215 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(280252), // Rule ID 5203 //
     /* 280220 */     // MIs[0] Operand 1
     /* 280220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 280225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280229 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280235 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280243 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 280246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 280250 */     GIR_RootConstrainSelectedInstOperands,
     /* 280251 */     // GIR_Coverage, 5203,
     /* 280251 */     GIR_EraseRootFromParent_Done,
     /* 280252 */   // Label 5681: @280252
     /* 280252 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(280292), // Rule ID 725 //
     /* 280257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280260 */     // MIs[0] Operand 1
     /* 280260 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280273 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280279 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280283 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 280286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280290 */     GIR_RootConstrainSelectedInstOperands,
     /* 280291 */     // GIR_Coverage, 725,
     /* 280291 */     GIR_EraseRootFromParent_Done,
     /* 280292 */   // Label 5682: @280292
     /* 280292 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(280332), // Rule ID 735 //
     /* 280297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280300 */     // MIs[0] Operand 1
     /* 280300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280313 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280319 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280323 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 280326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280330 */     GIR_RootConstrainSelectedInstOperands,
     /* 280331 */     // GIR_Coverage, 735,
     /* 280331 */     GIR_EraseRootFromParent_Done,
     /* 280332 */   // Label 5683: @280332
     /* 280332 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(280372), // Rule ID 736 //
     /* 280337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280340 */     // MIs[0] Operand 1
     /* 280340 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280353 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280359 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 280361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280363 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 280366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280370 */     GIR_RootConstrainSelectedInstOperands,
     /* 280371 */     // GIR_Coverage, 736,
     /* 280371 */     GIR_EraseRootFromParent_Done,
     /* 280372 */   // Label 5684: @280372
     /* 280372 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(280412), // Rule ID 746 //
     /* 280377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280380 */     // MIs[0] Operand 1
     /* 280380 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280393 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280399 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280403 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 280406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280410 */     GIR_RootConstrainSelectedInstOperands,
     /* 280411 */     // GIR_Coverage, 746,
     /* 280411 */     GIR_EraseRootFromParent_Done,
     /* 280412 */   // Label 5685: @280412
     /* 280412 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(280449), // Rule ID 5140 //
     /* 280417 */     // MIs[0] Operand 1
     /* 280417 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280430 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280436 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280440 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 280443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280447 */     GIR_RootConstrainSelectedInstOperands,
     /* 280448 */     // GIR_Coverage, 5140,
     /* 280448 */     GIR_EraseRootFromParent_Done,
     /* 280449 */   // Label 5686: @280449
     /* 280449 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(280486), // Rule ID 5147 //
     /* 280454 */     // MIs[0] Operand 1
     /* 280454 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280467 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280473 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280477 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 280480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280484 */     GIR_RootConstrainSelectedInstOperands,
     /* 280485 */     // GIR_Coverage, 5147,
     /* 280485 */     GIR_EraseRootFromParent_Done,
     /* 280486 */   // Label 5687: @280486
     /* 280486 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(280523), // Rule ID 5154 //
     /* 280491 */     // MIs[0] Operand 1
     /* 280491 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280504 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280510 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280514 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 280517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280521 */     GIR_RootConstrainSelectedInstOperands,
     /* 280522 */     // GIR_Coverage, 5154,
     /* 280522 */     GIR_EraseRootFromParent_Done,
     /* 280523 */   // Label 5688: @280523
     /* 280523 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(280560), // Rule ID 5161 //
     /* 280528 */     // MIs[0] Operand 1
     /* 280528 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 280533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280541 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280547 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280551 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 280554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280558 */     GIR_RootConstrainSelectedInstOperands,
     /* 280559 */     // GIR_Coverage, 5161,
     /* 280559 */     GIR_EraseRootFromParent_Done,
     /* 280560 */   // Label 5689: @280560
     /* 280560 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(280597), // Rule ID 5168 //
     /* 280565 */     // MIs[0] Operand 1
     /* 280565 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 280570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280578 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280584 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280588 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 280588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 280591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280595 */     GIR_RootConstrainSelectedInstOperands,
     /* 280596 */     // GIR_Coverage, 5168,
     /* 280596 */     GIR_EraseRootFromParent_Done,
     /* 280597 */   // Label 5690: @280597
     /* 280597 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(280629), // Rule ID 1124 //
     /* 280602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280605 */     // MIs[0] Operand 1
     /* 280605 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280618 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 280621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280627 */     GIR_RootConstrainSelectedInstOperands,
     /* 280628 */     // GIR_Coverage, 1124,
     /* 280628 */     GIR_EraseRootFromParent_Done,
     /* 280629 */   // Label 5691: @280629
     /* 280629 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(280661), // Rule ID 1131 //
     /* 280634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280637 */     // MIs[0] Operand 1
     /* 280637 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280650 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 280653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280659 */     GIR_RootConstrainSelectedInstOperands,
     /* 280660 */     // GIR_Coverage, 1131,
     /* 280660 */     GIR_EraseRootFromParent_Done,
     /* 280661 */   // Label 5692: @280661
     /* 280661 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(280693), // Rule ID 1138 //
     /* 280666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280669 */     // MIs[0] Operand 1
     /* 280669 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280682 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 280685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280691 */     GIR_RootConstrainSelectedInstOperands,
     /* 280692 */     // GIR_Coverage, 1138,
     /* 280692 */     GIR_EraseRootFromParent_Done,
     /* 280693 */   // Label 5693: @280693
     /* 280693 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(280725), // Rule ID 1145 //
     /* 280698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280701 */     // MIs[0] Operand 1
     /* 280701 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 280706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280714 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 280717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280723 */     GIR_RootConstrainSelectedInstOperands,
     /* 280724 */     // GIR_Coverage, 1145,
     /* 280724 */     GIR_EraseRootFromParent_Done,
     /* 280725 */   // Label 5694: @280725
     /* 280725 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(280757), // Rule ID 1152 //
     /* 280730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280733 */     // MIs[0] Operand 1
     /* 280733 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 280738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280746 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 280749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280755 */     GIR_RootConstrainSelectedInstOperands,
     /* 280756 */     // GIR_Coverage, 1152,
     /* 280756 */     GIR_EraseRootFromParent_Done,
     /* 280757 */   // Label 5695: @280757
     /* 280757 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(280786), // Rule ID 5077 //
     /* 280762 */     // MIs[0] Operand 1
     /* 280762 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280775 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 280778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280784 */     GIR_RootConstrainSelectedInstOperands,
     /* 280785 */     // GIR_Coverage, 5077,
     /* 280785 */     GIR_EraseRootFromParent_Done,
     /* 280786 */   // Label 5696: @280786
     /* 280786 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(280815), // Rule ID 5084 //
     /* 280791 */     // MIs[0] Operand 1
     /* 280791 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280804 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 280807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280813 */     GIR_RootConstrainSelectedInstOperands,
     /* 280814 */     // GIR_Coverage, 5084,
     /* 280814 */     GIR_EraseRootFromParent_Done,
     /* 280815 */   // Label 5697: @280815
     /* 280815 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(280844), // Rule ID 5091 //
     /* 280820 */     // MIs[0] Operand 1
     /* 280820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280833 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 280836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280842 */     GIR_RootConstrainSelectedInstOperands,
     /* 280843 */     // GIR_Coverage, 5091,
     /* 280843 */     GIR_EraseRootFromParent_Done,
     /* 280844 */   // Label 5698: @280844
     /* 280844 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(280873), // Rule ID 5098 //
     /* 280849 */     // MIs[0] Operand 1
     /* 280849 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 280854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280862 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 280865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280871 */     GIR_RootConstrainSelectedInstOperands,
     /* 280872 */     // GIR_Coverage, 5098,
     /* 280872 */     GIR_EraseRootFromParent_Done,
     /* 280873 */   // Label 5699: @280873
     /* 280873 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(280902), // Rule ID 5105 //
     /* 280878 */     // MIs[0] Operand 1
     /* 280878 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 280883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280891 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 280894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280900 */     GIR_RootConstrainSelectedInstOperands,
     /* 280901 */     // GIR_Coverage, 5105,
     /* 280901 */     GIR_EraseRootFromParent_Done,
     /* 280902 */   // Label 5700: @280902
     /* 280902 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(280931), // Rule ID 5112 //
     /* 280907 */     // MIs[0] Operand 1
     /* 280907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 280912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280920 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 280920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 280923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280929 */     GIR_RootConstrainSelectedInstOperands,
     /* 280930 */     // GIR_Coverage, 5112,
     /* 280930 */     GIR_EraseRootFromParent_Done,
     /* 280931 */   // Label 5701: @280931
     /* 280931 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(280960), // Rule ID 5119 //
     /* 280936 */     // MIs[0] Operand 1
     /* 280936 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 280941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280949 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 280949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 280952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280958 */     GIR_RootConstrainSelectedInstOperands,
     /* 280959 */     // GIR_Coverage, 5119,
     /* 280959 */     GIR_EraseRootFromParent_Done,
     /* 280960 */   // Label 5702: @280960
     /* 280960 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(280989), // Rule ID 5126 //
     /* 280965 */     // MIs[0] Operand 1
     /* 280965 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 280970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280978 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 280978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 280981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280987 */     GIR_RootConstrainSelectedInstOperands,
     /* 280988 */     // GIR_Coverage, 5126,
     /* 280988 */     GIR_EraseRootFromParent_Done,
     /* 280989 */   // Label 5703: @280989
     /* 280989 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(281018), // Rule ID 5133 //
     /* 280994 */     // MIs[0] Operand 1
     /* 280994 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 280999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281007 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 281007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 281010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281016 */     GIR_RootConstrainSelectedInstOperands,
     /* 281017 */     // GIR_Coverage, 5133,
     /* 281017 */     GIR_EraseRootFromParent_Done,
     /* 281018 */   // Label 5704: @281018
     /* 281018 */   GIM_Reject,
     /* 281019 */ // Label 5674: @281019
     /* 281019 */ GIM_Reject,
     /* 281020 */ // Label 5505: @281020
     /* 281020 */ GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(282067),
     /* 281025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 281031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281035 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(281075), // Rule ID 751 //
     /* 281040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281043 */     // MIs[0] Operand 1
     /* 281043 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281052 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281058 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281066 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 281069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281073 */     GIR_RootConstrainSelectedInstOperands,
     /* 281074 */     // GIR_Coverage, 751,
     /* 281074 */     GIR_EraseRootFromParent_Done,
     /* 281075 */   // Label 5706: @281075
     /* 281075 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(281115), // Rule ID 758 //
     /* 281080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281083 */     // MIs[0] Operand 1
     /* 281083 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281092 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281098 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281106 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 281109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281113 */     GIR_RootConstrainSelectedInstOperands,
     /* 281114 */     // GIR_Coverage, 758,
     /* 281114 */     GIR_EraseRootFromParent_Done,
     /* 281115 */   // Label 5707: @281115
     /* 281115 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(281152), // Rule ID 5173 //
     /* 281120 */     // MIs[0] Operand 1
     /* 281120 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281129 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281135 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281143 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 281146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281150 */     GIR_RootConstrainSelectedInstOperands,
     /* 281151 */     // GIR_Coverage, 5173,
     /* 281151 */     GIR_EraseRootFromParent_Done,
     /* 281152 */   // Label 5708: @281152
     /* 281152 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(281189), // Rule ID 5180 //
     /* 281157 */     // MIs[0] Operand 1
     /* 281157 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281166 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281172 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281180 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 281183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281187 */     GIR_RootConstrainSelectedInstOperands,
     /* 281188 */     // GIR_Coverage, 5180,
     /* 281188 */     GIR_EraseRootFromParent_Done,
     /* 281189 */   // Label 5709: @281189
     /* 281189 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(281226), // Rule ID 5187 //
     /* 281194 */     // MIs[0] Operand 1
     /* 281194 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281203 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281209 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281217 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 281220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281224 */     GIR_RootConstrainSelectedInstOperands,
     /* 281225 */     // GIR_Coverage, 5187,
     /* 281225 */     GIR_EraseRootFromParent_Done,
     /* 281226 */   // Label 5710: @281226
     /* 281226 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(281263), // Rule ID 5194 //
     /* 281231 */     // MIs[0] Operand 1
     /* 281231 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 281236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281240 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281246 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281254 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 281257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281261 */     GIR_RootConstrainSelectedInstOperands,
     /* 281262 */     // GIR_Coverage, 5194,
     /* 281262 */     GIR_EraseRootFromParent_Done,
     /* 281263 */   // Label 5711: @281263
     /* 281263 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(281300), // Rule ID 5201 //
     /* 281268 */     // MIs[0] Operand 1
     /* 281268 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 281273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281277 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281283 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281291 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 281294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 281298 */     GIR_RootConstrainSelectedInstOperands,
     /* 281299 */     // GIR_Coverage, 5201,
     /* 281299 */     GIR_EraseRootFromParent_Done,
     /* 281300 */   // Label 5712: @281300
     /* 281300 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(281340), // Rule ID 723 //
     /* 281305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281308 */     // MIs[0] Operand 1
     /* 281308 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281321 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281327 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281331 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 281334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281338 */     GIR_RootConstrainSelectedInstOperands,
     /* 281339 */     // GIR_Coverage, 723,
     /* 281339 */     GIR_EraseRootFromParent_Done,
     /* 281340 */   // Label 5713: @281340
     /* 281340 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(281380), // Rule ID 731 //
     /* 281345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281348 */     // MIs[0] Operand 1
     /* 281348 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281361 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281367 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281371 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 281374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281378 */     GIR_RootConstrainSelectedInstOperands,
     /* 281379 */     // GIR_Coverage, 731,
     /* 281379 */     GIR_EraseRootFromParent_Done,
     /* 281380 */   // Label 5714: @281380
     /* 281380 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(281420), // Rule ID 732 //
     /* 281385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281388 */     // MIs[0] Operand 1
     /* 281388 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281401 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281407 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 281409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281411 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 281414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281418 */     GIR_RootConstrainSelectedInstOperands,
     /* 281419 */     // GIR_Coverage, 732,
     /* 281419 */     GIR_EraseRootFromParent_Done,
     /* 281420 */   // Label 5715: @281420
     /* 281420 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(281460), // Rule ID 744 //
     /* 281425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281428 */     // MIs[0] Operand 1
     /* 281428 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281441 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281447 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281451 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 281454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281458 */     GIR_RootConstrainSelectedInstOperands,
     /* 281459 */     // GIR_Coverage, 744,
     /* 281459 */     GIR_EraseRootFromParent_Done,
     /* 281460 */   // Label 5716: @281460
     /* 281460 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(281497), // Rule ID 5138 //
     /* 281465 */     // MIs[0] Operand 1
     /* 281465 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281478 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281484 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281488 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 281491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281495 */     GIR_RootConstrainSelectedInstOperands,
     /* 281496 */     // GIR_Coverage, 5138,
     /* 281496 */     GIR_EraseRootFromParent_Done,
     /* 281497 */   // Label 5717: @281497
     /* 281497 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(281534), // Rule ID 5145 //
     /* 281502 */     // MIs[0] Operand 1
     /* 281502 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281515 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281521 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281525 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 281528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281532 */     GIR_RootConstrainSelectedInstOperands,
     /* 281533 */     // GIR_Coverage, 5145,
     /* 281533 */     GIR_EraseRootFromParent_Done,
     /* 281534 */   // Label 5718: @281534
     /* 281534 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(281571), // Rule ID 5152 //
     /* 281539 */     // MIs[0] Operand 1
     /* 281539 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281552 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281558 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281562 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 281565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281569 */     GIR_RootConstrainSelectedInstOperands,
     /* 281570 */     // GIR_Coverage, 5152,
     /* 281570 */     GIR_EraseRootFromParent_Done,
     /* 281571 */   // Label 5719: @281571
     /* 281571 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(281608), // Rule ID 5159 //
     /* 281576 */     // MIs[0] Operand 1
     /* 281576 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 281581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281589 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281595 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281599 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 281602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281606 */     GIR_RootConstrainSelectedInstOperands,
     /* 281607 */     // GIR_Coverage, 5159,
     /* 281607 */     GIR_EraseRootFromParent_Done,
     /* 281608 */   // Label 5720: @281608
     /* 281608 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(281645), // Rule ID 5166 //
     /* 281613 */     // MIs[0] Operand 1
     /* 281613 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 281618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281626 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 281632 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 281634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281636 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 281636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 281639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281643 */     GIR_RootConstrainSelectedInstOperands,
     /* 281644 */     // GIR_Coverage, 5166,
     /* 281644 */     GIR_EraseRootFromParent_Done,
     /* 281645 */   // Label 5721: @281645
     /* 281645 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(281677), // Rule ID 1122 //
     /* 281650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281653 */     // MIs[0] Operand 1
     /* 281653 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281666 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 281669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281675 */     GIR_RootConstrainSelectedInstOperands,
     /* 281676 */     // GIR_Coverage, 1122,
     /* 281676 */     GIR_EraseRootFromParent_Done,
     /* 281677 */   // Label 5722: @281677
     /* 281677 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(281709), // Rule ID 1129 //
     /* 281682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281685 */     // MIs[0] Operand 1
     /* 281685 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281698 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 281701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281707 */     GIR_RootConstrainSelectedInstOperands,
     /* 281708 */     // GIR_Coverage, 1129,
     /* 281708 */     GIR_EraseRootFromParent_Done,
     /* 281709 */   // Label 5723: @281709
     /* 281709 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(281741), // Rule ID 1136 //
     /* 281714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281717 */     // MIs[0] Operand 1
     /* 281717 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281730 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 281733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281739 */     GIR_RootConstrainSelectedInstOperands,
     /* 281740 */     // GIR_Coverage, 1136,
     /* 281740 */     GIR_EraseRootFromParent_Done,
     /* 281741 */   // Label 5724: @281741
     /* 281741 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(281773), // Rule ID 1143 //
     /* 281746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281749 */     // MIs[0] Operand 1
     /* 281749 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 281754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281762 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 281765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281771 */     GIR_RootConstrainSelectedInstOperands,
     /* 281772 */     // GIR_Coverage, 1143,
     /* 281772 */     GIR_EraseRootFromParent_Done,
     /* 281773 */   // Label 5725: @281773
     /* 281773 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(281805), // Rule ID 1150 //
     /* 281778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281781 */     // MIs[0] Operand 1
     /* 281781 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 281786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281794 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 281797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281803 */     GIR_RootConstrainSelectedInstOperands,
     /* 281804 */     // GIR_Coverage, 1150,
     /* 281804 */     GIR_EraseRootFromParent_Done,
     /* 281805 */   // Label 5726: @281805
     /* 281805 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(281834), // Rule ID 5075 //
     /* 281810 */     // MIs[0] Operand 1
     /* 281810 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 281815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281823 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 281826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281832 */     GIR_RootConstrainSelectedInstOperands,
     /* 281833 */     // GIR_Coverage, 5075,
     /* 281833 */     GIR_EraseRootFromParent_Done,
     /* 281834 */   // Label 5727: @281834
     /* 281834 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(281863), // Rule ID 5082 //
     /* 281839 */     // MIs[0] Operand 1
     /* 281839 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 281844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281852 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 281855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281861 */     GIR_RootConstrainSelectedInstOperands,
     /* 281862 */     // GIR_Coverage, 5082,
     /* 281862 */     GIR_EraseRootFromParent_Done,
     /* 281863 */   // Label 5728: @281863
     /* 281863 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(281892), // Rule ID 5089 //
     /* 281868 */     // MIs[0] Operand 1
     /* 281868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 281873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281881 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 281884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281890 */     GIR_RootConstrainSelectedInstOperands,
     /* 281891 */     // GIR_Coverage, 5089,
     /* 281891 */     GIR_EraseRootFromParent_Done,
     /* 281892 */   // Label 5729: @281892
     /* 281892 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(281921), // Rule ID 5096 //
     /* 281897 */     // MIs[0] Operand 1
     /* 281897 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 281902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281910 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 281913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281919 */     GIR_RootConstrainSelectedInstOperands,
     /* 281920 */     // GIR_Coverage, 5096,
     /* 281920 */     GIR_EraseRootFromParent_Done,
     /* 281921 */   // Label 5730: @281921
     /* 281921 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(281950), // Rule ID 5103 //
     /* 281926 */     // MIs[0] Operand 1
     /* 281926 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 281931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281939 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 281939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 281942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281948 */     GIR_RootConstrainSelectedInstOperands,
     /* 281949 */     // GIR_Coverage, 5103,
     /* 281949 */     GIR_EraseRootFromParent_Done,
     /* 281950 */   // Label 5731: @281950
     /* 281950 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(281979), // Rule ID 5110 //
     /* 281955 */     // MIs[0] Operand 1
     /* 281955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 281960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281968 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 281968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 281971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 281975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281977 */     GIR_RootConstrainSelectedInstOperands,
     /* 281978 */     // GIR_Coverage, 5110,
     /* 281978 */     GIR_EraseRootFromParent_Done,
     /* 281979 */   // Label 5732: @281979
     /* 281979 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(282008), // Rule ID 5117 //
     /* 281984 */     // MIs[0] Operand 1
     /* 281984 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 281989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281997 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 281997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 282000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 282004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282006 */     GIR_RootConstrainSelectedInstOperands,
     /* 282007 */     // GIR_Coverage, 5117,
     /* 282007 */     GIR_EraseRootFromParent_Done,
     /* 282008 */   // Label 5733: @282008
     /* 282008 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(282037), // Rule ID 5124 //
     /* 282013 */     // MIs[0] Operand 1
     /* 282013 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 282018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282026 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 282026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 282029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 282033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282035 */     GIR_RootConstrainSelectedInstOperands,
     /* 282036 */     // GIR_Coverage, 5124,
     /* 282036 */     GIR_EraseRootFromParent_Done,
     /* 282037 */   // Label 5734: @282037
     /* 282037 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(282066), // Rule ID 5131 //
     /* 282042 */     // MIs[0] Operand 1
     /* 282042 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 282047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282055 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 282055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 282058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 282062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282064 */     GIR_RootConstrainSelectedInstOperands,
     /* 282065 */     // GIR_Coverage, 5131,
     /* 282065 */     GIR_EraseRootFromParent_Done,
     /* 282066 */   // Label 5735: @282066
     /* 282066 */   GIM_Reject,
     /* 282067 */ // Label 5705: @282067
     /* 282067 */ GIM_Reject,
     /* 282068 */ // Label 5506: @282068
     /* 282068 */ GIM_Reject,
     /* 282069 */ // Label 52: @282069
     /* 282069 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5748*/ GIMT_Encode4(283113),
     /* 282080 */ /*GILLT_nxv1s1*//*Label 5736*/ GIMT_Encode4(282128),
     /* 282084 */ /*GILLT_nxv2s1*//*Label 5737*/ GIMT_Encode4(282157),
     /* 282088 */ /*GILLT_nxv2s16*//*Label 5738*/ GIMT_Encode4(282186),
     /* 282092 */ /*GILLT_nxv2s32*//*Label 5739*/ GIMT_Encode4(282271),
     /* 282096 */ /*GILLT_nxv2s64*//*Label 5740*/ GIMT_Encode4(282356),
     /* 282100 */ /*GILLT_nxv4s1*//*Label 5741*/ GIMT_Encode4(282522),
     /* 282104 */ /*GILLT_nxv4s16*//*Label 5742*/ GIMT_Encode4(282551),
     /* 282108 */ /*GILLT_nxv4s32*//*Label 5743*/ GIMT_Encode4(282636),
     /* 282112 */ /*GILLT_nxv8s1*//*Label 5744*/ GIMT_Encode4(282802),
     /* 282116 */ /*GILLT_nxv8s16*//*Label 5745*/ GIMT_Encode4(282831),
     /* 282120 */ /*GILLT_nxv16s1*//*Label 5746*/ GIMT_Encode4(282997),
     /* 282124 */ /*GILLT_nxv16s8*//*Label 5747*/ GIMT_Encode4(283026),
     /* 282128 */ // Label 5736: @282128
     /* 282128 */ GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(282156), // Rule ID 8469 //
     /* 282133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 282139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 282142 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 282145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 282149 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 282149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 282154 */   GIR_RootConstrainSelectedInstOperands,
     /* 282155 */   // GIR_Coverage, 8469,
     /* 282155 */   GIR_Done,
     /* 282156 */ // Label 5749: @282156
     /* 282156 */ GIM_Reject,
     /* 282157 */ // Label 5737: @282157
     /* 282157 */ GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(282185), // Rule ID 8468 //
     /* 282162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 282168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 282171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 282174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 282178 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 282178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 282183 */   GIR_RootConstrainSelectedInstOperands,
     /* 282184 */   // GIR_Coverage, 8468,
     /* 282184 */   GIR_Done,
     /* 282185 */ // Label 5750: @282185
     /* 282185 */ GIM_Reject,
     /* 282186 */ // Label 5738: @282186
     /* 282186 */ GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(282270),
     /* 282191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 282194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 282197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 282200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282204 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(282254), // Rule ID 3161 //
     /* 282209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282232 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 282236 */     // MIs[2] Operand 1
     /* 282236 */     // No operand predicates
     /* 282236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282238 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 282238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 282241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282243 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282245 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282247 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 282252 */     GIR_RootConstrainSelectedInstOperands,
     /* 282253 */     // GIR_Coverage, 3161,
     /* 282253 */     GIR_EraseRootFromParent_Done,
     /* 282254 */   // Label 5752: @282254
     /* 282254 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(282269), // Rule ID 2741 //
     /* 282259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282262 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 282262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 282267 */     GIR_RootConstrainSelectedInstOperands,
     /* 282268 */     // GIR_Coverage, 2741,
     /* 282268 */     GIR_Done,
     /* 282269 */   // Label 5753: @282269
     /* 282269 */   GIM_Reject,
     /* 282270 */ // Label 5751: @282270
     /* 282270 */ GIM_Reject,
     /* 282271 */ // Label 5739: @282271
     /* 282271 */ GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(282355),
     /* 282276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 282279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 282282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 282285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282289 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(282339), // Rule ID 3163 //
     /* 282294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282317 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 282321 */     // MIs[2] Operand 1
     /* 282321 */     // No operand predicates
     /* 282321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282323 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 282323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 282326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282328 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282330 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282332 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 282337 */     GIR_RootConstrainSelectedInstOperands,
     /* 282338 */     // GIR_Coverage, 3163,
     /* 282338 */     GIR_EraseRootFromParent_Done,
     /* 282339 */   // Label 5755: @282339
     /* 282339 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(282354), // Rule ID 2742 //
     /* 282344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282347 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 282347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 282352 */     GIR_RootConstrainSelectedInstOperands,
     /* 282353 */     // GIR_Coverage, 2742,
     /* 282353 */     GIR_Done,
     /* 282354 */   // Label 5756: @282354
     /* 282354 */   GIM_Reject,
     /* 282355 */ // Label 5754: @282355
     /* 282355 */ GIM_Reject,
     /* 282356 */ // Label 5740: @282356
     /* 282356 */ GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(282521),
     /* 282361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 282364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282367 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(282424), // Rule ID 3164 //
     /* 282372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 282378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 282394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282402 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 282406 */     // MIs[2] Operand 1
     /* 282406 */     // No operand predicates
     /* 282406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282408 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 282408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 282411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282413 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282415 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282417 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 282422 */     GIR_RootConstrainSelectedInstOperands,
     /* 282423 */     // GIR_Coverage, 3164,
     /* 282423 */     GIR_EraseRootFromParent_Done,
     /* 282424 */   // Label 5758: @282424
     /* 282424 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(282476), // Rule ID 7515 //
     /* 282429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 282444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282452 */     // MIs[0] Op2
     /* 282452 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 282457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282459 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 282459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 282462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 282464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 282466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 282470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 282474 */     GIR_RootConstrainSelectedInstOperands,
     /* 282475 */     // GIR_Coverage, 7515,
     /* 282475 */     GIR_EraseRootFromParent_Done,
     /* 282476 */   // Label 5759: @282476
     /* 282476 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(282498), // Rule ID 2737 //
     /* 282481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 282487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282491 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 282491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 282496 */     GIR_RootConstrainSelectedInstOperands,
     /* 282497 */     // GIR_Coverage, 2737,
     /* 282497 */     GIR_Done,
     /* 282498 */   // Label 5760: @282498
     /* 282498 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(282520), // Rule ID 2743 //
     /* 282503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 282509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282513 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 282513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 282518 */     GIR_RootConstrainSelectedInstOperands,
     /* 282519 */     // GIR_Coverage, 2743,
     /* 282519 */     GIR_Done,
     /* 282520 */   // Label 5761: @282520
     /* 282520 */   GIM_Reject,
     /* 282521 */ // Label 5757: @282521
     /* 282521 */ GIM_Reject,
     /* 282522 */ // Label 5741: @282522
     /* 282522 */ GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(282550), // Rule ID 8467 //
     /* 282527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 282533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 282536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 282539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 282543 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 282543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 282548 */   GIR_RootConstrainSelectedInstOperands,
     /* 282549 */   // GIR_Coverage, 8467,
     /* 282549 */   GIR_Done,
     /* 282550 */ // Label 5762: @282550
     /* 282550 */ GIM_Reject,
     /* 282551 */ // Label 5742: @282551
     /* 282551 */ GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(282635),
     /* 282556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 282559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 282562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 282565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282569 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(282619), // Rule ID 3160 //
     /* 282574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282597 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 282601 */     // MIs[2] Operand 1
     /* 282601 */     // No operand predicates
     /* 282601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282603 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 282603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 282606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282608 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282610 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282612 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 282617 */     GIR_RootConstrainSelectedInstOperands,
     /* 282618 */     // GIR_Coverage, 3160,
     /* 282618 */     GIR_EraseRootFromParent_Done,
     /* 282619 */   // Label 5764: @282619
     /* 282619 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(282634), // Rule ID 2739 //
     /* 282624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282627 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 282627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 282632 */     GIR_RootConstrainSelectedInstOperands,
     /* 282633 */     // GIR_Coverage, 2739,
     /* 282633 */     GIR_Done,
     /* 282634 */   // Label 5765: @282634
     /* 282634 */   GIM_Reject,
     /* 282635 */ // Label 5763: @282635
     /* 282635 */ GIM_Reject,
     /* 282636 */ // Label 5743: @282636
     /* 282636 */ GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(282801),
     /* 282641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 282644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282647 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(282704), // Rule ID 3162 //
     /* 282652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 282658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282682 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 282686 */     // MIs[2] Operand 1
     /* 282686 */     // No operand predicates
     /* 282686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282688 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 282688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 282691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282693 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282695 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282697 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 282702 */     GIR_RootConstrainSelectedInstOperands,
     /* 282703 */     // GIR_Coverage, 3162,
     /* 282703 */     GIR_EraseRootFromParent_Done,
     /* 282704 */   // Label 5767: @282704
     /* 282704 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(282756), // Rule ID 7513 //
     /* 282709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 282724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282732 */     // MIs[0] Op2
     /* 282732 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 282737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282739 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 282739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 282742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 282744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 282746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 282750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 282754 */     GIR_RootConstrainSelectedInstOperands,
     /* 282755 */     // GIR_Coverage, 7513,
     /* 282755 */     GIR_EraseRootFromParent_Done,
     /* 282756 */   // Label 5768: @282756
     /* 282756 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(282778), // Rule ID 2736 //
     /* 282761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 282767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282771 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 282771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 282776 */     GIR_RootConstrainSelectedInstOperands,
     /* 282777 */     // GIR_Coverage, 2736,
     /* 282777 */     GIR_Done,
     /* 282778 */   // Label 5769: @282778
     /* 282778 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(282800), // Rule ID 2740 //
     /* 282783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 282789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282793 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 282793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 282798 */     GIR_RootConstrainSelectedInstOperands,
     /* 282799 */     // GIR_Coverage, 2740,
     /* 282799 */     GIR_Done,
     /* 282800 */   // Label 5770: @282800
     /* 282800 */   GIM_Reject,
     /* 282801 */ // Label 5766: @282801
     /* 282801 */ GIM_Reject,
     /* 282802 */ // Label 5744: @282802
     /* 282802 */ GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(282830), // Rule ID 8466 //
     /* 282807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 282813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 282816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 282819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 282823 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 282823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 282828 */   GIR_RootConstrainSelectedInstOperands,
     /* 282829 */   // GIR_Coverage, 8466,
     /* 282829 */   GIR_Done,
     /* 282830 */ // Label 5771: @282830
     /* 282830 */ GIM_Reject,
     /* 282831 */ // Label 5745: @282831
     /* 282831 */ GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(282996),
     /* 282836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 282839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282842 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(282899), // Rule ID 3159 //
     /* 282847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 282853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 282865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 282877 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 282881 */     // MIs[2] Operand 1
     /* 282881 */     // No operand predicates
     /* 282881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282883 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 282883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 282886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282888 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 282890 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 282892 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 282897 */     GIR_RootConstrainSelectedInstOperands,
     /* 282898 */     // GIR_Coverage, 3159,
     /* 282898 */     GIR_EraseRootFromParent_Done,
     /* 282899 */   // Label 5773: @282899
     /* 282899 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(282951), // Rule ID 7511 //
     /* 282904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 282919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282927 */     // MIs[0] Op2
     /* 282927 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 282932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282934 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 282934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 282937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 282939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 282941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 282945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 282949 */     GIR_RootConstrainSelectedInstOperands,
     /* 282950 */     // GIR_Coverage, 7511,
     /* 282950 */     GIR_EraseRootFromParent_Done,
     /* 282951 */   // Label 5774: @282951
     /* 282951 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(282973), // Rule ID 2735 //
     /* 282956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 282962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282966 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 282966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 282971 */     GIR_RootConstrainSelectedInstOperands,
     /* 282972 */     // GIR_Coverage, 2735,
     /* 282972 */     GIR_Done,
     /* 282973 */   // Label 5775: @282973
     /* 282973 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(282995), // Rule ID 2738 //
     /* 282978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 282984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282988 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 282988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 282993 */     GIR_RootConstrainSelectedInstOperands,
     /* 282994 */     // GIR_Coverage, 2738,
     /* 282994 */     GIR_Done,
     /* 282995 */   // Label 5776: @282995
     /* 282995 */   GIM_Reject,
     /* 282996 */ // Label 5772: @282996
     /* 282996 */ GIM_Reject,
     /* 282997 */ // Label 5746: @282997
     /* 282997 */ GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(283025), // Rule ID 8465 //
     /* 283002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 283008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 283011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 283014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 283018 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 283018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 283023 */   GIR_RootConstrainSelectedInstOperands,
     /* 283024 */   // GIR_Coverage, 8465,
     /* 283024 */   GIR_Done,
     /* 283025 */ // Label 5777: @283025
     /* 283025 */ GIM_Reject,
     /* 283026 */ // Label 5747: @283026
     /* 283026 */ GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(283112),
     /* 283031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 283034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283037 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(283089), // Rule ID 7509 //
     /* 283042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 283057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283065 */     // MIs[0] Op2
     /* 283065 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 283070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283072 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 283072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 283075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 283077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 283079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 283083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 283087 */     GIR_RootConstrainSelectedInstOperands,
     /* 283088 */     // GIR_Coverage, 7509,
     /* 283088 */     GIR_EraseRootFromParent_Done,
     /* 283089 */   // Label 5779: @283089
     /* 283089 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(283111), // Rule ID 2734 //
     /* 283094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 283100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283104 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 283104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 283109 */     GIR_RootConstrainSelectedInstOperands,
     /* 283110 */     // GIR_Coverage, 2734,
     /* 283110 */     GIR_Done,
     /* 283111 */   // Label 5780: @283111
     /* 283111 */   GIM_Reject,
     /* 283112 */ // Label 5778: @283112
     /* 283112 */ GIM_Reject,
     /* 283113 */ // Label 5748: @283113
     /* 283113 */ GIM_Reject,
     /* 283114 */ // Label 53: @283114
     /* 283114 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5785*/ GIMT_Encode4(283597),
     /* 283125 */ /*GILLT_s64*//*Label 5781*/ GIMT_Encode4(283161), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283145 */ /*GILLT_v4s32*//*Label 5782*/ GIMT_Encode4(283192), GIMT_Encode4(0),
     /* 283153 */ /*GILLT_v8s16*//*Label 5783*/ GIMT_Encode4(283327),
     /* 283157 */ /*GILLT_v16s8*//*Label 5784*/ GIMT_Encode4(283462),
     /* 283161 */ // Label 5781: @283161
     /* 283161 */ GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(283191), // Rule ID 128 //
     /* 283166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 283172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283184 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 283184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 283189 */   GIR_RootConstrainSelectedInstOperands,
     /* 283190 */   // GIR_Coverage, 128,
     /* 283190 */   GIR_Done,
     /* 283191 */ // Label 5786: @283191
     /* 283191 */ GIM_Reject,
     /* 283192 */ // Label 5782: @283192
     /* 283192 */ GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(283326), // Rule ID 6535 //
     /* 283197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 283203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283215 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 283215 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283218 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 283222 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283227 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283231 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283237 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283240 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283244 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283249 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283255 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283260 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283265 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283268 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283272 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283277 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283283 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283288 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 283300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283305 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283308 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 283316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283324 */   GIR_RootConstrainSelectedInstOperands,
     /* 283325 */   // GIR_Coverage, 6535,
     /* 283325 */   GIR_EraseRootFromParent_Done,
     /* 283326 */ // Label 5787: @283326
     /* 283326 */ GIM_Reject,
     /* 283327 */ // Label 5783: @283327
     /* 283327 */ GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(283461), // Rule ID 6534 //
     /* 283332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283350 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 283350 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283353 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 283357 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283362 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283366 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283372 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283375 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283379 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283384 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283390 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283395 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283400 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283403 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283407 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283412 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283418 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283423 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283428 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283431 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 283435 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283440 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283443 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 283451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283459 */   GIR_RootConstrainSelectedInstOperands,
     /* 283460 */   // GIR_Coverage, 6534,
     /* 283460 */   GIR_EraseRootFromParent_Done,
     /* 283461 */ // Label 5788: @283461
     /* 283461 */ GIM_Reject,
     /* 283462 */ // Label 5784: @283462
     /* 283462 */ GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(283596), // Rule ID 6533 //
     /* 283467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283485 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 283485 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283488 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 283492 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283497 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283501 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283507 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283510 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283514 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283519 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283525 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283530 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283535 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283538 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283542 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283547 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283553 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283558 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 283570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283575 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283578 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 283586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283594 */   GIR_RootConstrainSelectedInstOperands,
     /* 283595 */   // GIR_Coverage, 6533,
     /* 283595 */   GIR_EraseRootFromParent_Done,
     /* 283596 */ // Label 5789: @283596
     /* 283596 */ GIM_Reject,
     /* 283597 */ // Label 5785: @283597
     /* 283597 */ GIM_Reject,
     /* 283598 */ // Label 54: @283598
     /* 283598 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5794*/ GIMT_Encode4(284081),
     /* 283609 */ /*GILLT_s64*//*Label 5790*/ GIMT_Encode4(283645), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283629 */ /*GILLT_v4s32*//*Label 5791*/ GIMT_Encode4(283676), GIMT_Encode4(0),
     /* 283637 */ /*GILLT_v8s16*//*Label 5792*/ GIMT_Encode4(283811),
     /* 283641 */ /*GILLT_v16s8*//*Label 5793*/ GIMT_Encode4(283946),
     /* 283645 */ // Label 5790: @283645
     /* 283645 */ GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(283675), // Rule ID 127 //
     /* 283650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 283656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283668 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 283668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 283673 */   GIR_RootConstrainSelectedInstOperands,
     /* 283674 */   // GIR_Coverage, 127,
     /* 283674 */   GIR_Done,
     /* 283675 */ // Label 5795: @283675
     /* 283675 */ GIM_Reject,
     /* 283676 */ // Label 5791: @283676
     /* 283676 */ GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(283810), // Rule ID 6532 //
     /* 283681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 283687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283699 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 283699 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283702 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 283706 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283711 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283715 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283733 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283739 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283744 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283749 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283752 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283756 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283761 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283767 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283772 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 283784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283789 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283792 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 283800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283808 */   GIR_RootConstrainSelectedInstOperands,
     /* 283809 */   // GIR_Coverage, 6532,
     /* 283809 */   GIR_EraseRootFromParent_Done,
     /* 283810 */ // Label 5796: @283810
     /* 283810 */ GIM_Reject,
     /* 283811 */ // Label 5792: @283811
     /* 283811 */ GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(283945), // Rule ID 6531 //
     /* 283816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283834 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 283834 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283837 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 283841 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283846 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283850 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283856 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283859 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283863 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283868 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283874 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283879 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283884 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283887 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283891 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283896 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283902 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283907 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 283915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 283919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283924 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283927 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 283935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283937 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 283943 */   GIR_RootConstrainSelectedInstOperands,
     /* 283944 */   // GIR_Coverage, 6531,
     /* 283944 */   GIR_EraseRootFromParent_Done,
     /* 283945 */ // Label 5797: @283945
     /* 283945 */ GIM_Reject,
     /* 283946 */ // Label 5793: @283946
     /* 283946 */ GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(284080), // Rule ID 6530 //
     /* 283951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283969 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 283969 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 283972 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 283976 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283981 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 283985 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 283989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283991 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 283994 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283998 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284003 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 284009 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284014 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284019 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 284022 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284026 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284031 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284042 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 284050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 284054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284059 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284062 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 284065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 284070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 284078 */   GIR_RootConstrainSelectedInstOperands,
     /* 284079 */   // GIR_Coverage, 6530,
     /* 284079 */   GIR_EraseRootFromParent_Done,
     /* 284080 */ // Label 5798: @284080
     /* 284080 */ GIM_Reject,
     /* 284081 */ // Label 5794: @284081
     /* 284081 */ GIM_Reject,
     /* 284082 */ // Label 55: @284082
     /* 284082 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5810*/ GIMT_Encode4(284511),
     /* 284093 */ /*GILLT_v2s32*//*Label 5799*/ GIMT_Encode4(284169),
     /* 284097 */ /*GILLT_v2s64*//*Label 5800*/ GIMT_Encode4(284203),
     /* 284101 */ /*GILLT_v4s16*//*Label 5801*/ GIMT_Encode4(284237),
     /* 284105 */ /*GILLT_v4s32*//*Label 5802*/ GIMT_Encode4(284271),
     /* 284109 */ /*GILLT_v8s8*//*Label 5803*/ GIMT_Encode4(284305),
     /* 284113 */ /*GILLT_v8s16*//*Label 5804*/ GIMT_Encode4(284339),
     /* 284117 */ /*GILLT_v16s8*//*Label 5805*/ GIMT_Encode4(284373), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284137 */ /*GILLT_nxv2s64*//*Label 5806*/ GIMT_Encode4(284407), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284149 */ /*GILLT_nxv4s32*//*Label 5807*/ GIMT_Encode4(284433), GIMT_Encode4(0),
     /* 284157 */ /*GILLT_nxv8s16*//*Label 5808*/ GIMT_Encode4(284459), GIMT_Encode4(0),
     /* 284165 */ /*GILLT_nxv16s8*//*Label 5809*/ GIMT_Encode4(284485),
     /* 284169 */ // Label 5799: @284169
     /* 284169 */ GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(284202), // Rule ID 5023 //
     /* 284174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284195 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 284195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 284200 */   GIR_RootConstrainSelectedInstOperands,
     /* 284201 */   // GIR_Coverage, 5023,
     /* 284201 */   GIR_Done,
     /* 284202 */ // Label 5811: @284202
     /* 284202 */ GIM_Reject,
     /* 284203 */ // Label 5800: @284203
     /* 284203 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(284236), // Rule ID 5027 //
     /* 284208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284229 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 284229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 284234 */   GIR_RootConstrainSelectedInstOperands,
     /* 284235 */   // GIR_Coverage, 5027,
     /* 284235 */   GIR_Done,
     /* 284236 */ // Label 5812: @284236
     /* 284236 */ GIM_Reject,
     /* 284237 */ // Label 5801: @284237
     /* 284237 */ GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(284270), // Rule ID 5022 //
     /* 284242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284263 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 284263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 284268 */   GIR_RootConstrainSelectedInstOperands,
     /* 284269 */   // GIR_Coverage, 5022,
     /* 284269 */   GIR_Done,
     /* 284270 */ // Label 5813: @284270
     /* 284270 */ GIM_Reject,
     /* 284271 */ // Label 5802: @284271
     /* 284271 */ GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(284304), // Rule ID 5026 //
     /* 284276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284297 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 284297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 284302 */   GIR_RootConstrainSelectedInstOperands,
     /* 284303 */   // GIR_Coverage, 5026,
     /* 284303 */   GIR_Done,
     /* 284304 */ // Label 5814: @284304
     /* 284304 */ GIM_Reject,
     /* 284305 */ // Label 5803: @284305
     /* 284305 */ GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(284338), // Rule ID 5021 //
     /* 284310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 284316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284331 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 284331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 284336 */   GIR_RootConstrainSelectedInstOperands,
     /* 284337 */   // GIR_Coverage, 5021,
     /* 284337 */   GIR_Done,
     /* 284338 */ // Label 5815: @284338
     /* 284338 */ GIM_Reject,
     /* 284339 */ // Label 5804: @284339
     /* 284339 */ GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(284372), // Rule ID 5025 //
     /* 284344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284365 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 284365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 284370 */   GIR_RootConstrainSelectedInstOperands,
     /* 284371 */   // GIR_Coverage, 5025,
     /* 284371 */   GIR_Done,
     /* 284372 */ // Label 5816: @284372
     /* 284372 */ GIM_Reject,
     /* 284373 */ // Label 5805: @284373
     /* 284373 */ GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(284406), // Rule ID 5024 //
     /* 284378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 284384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284399 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 284399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 284404 */   GIR_RootConstrainSelectedInstOperands,
     /* 284405 */   // GIR_Coverage, 5024,
     /* 284405 */   GIR_Done,
     /* 284406 */ // Label 5817: @284406
     /* 284406 */ GIM_Reject,
     /* 284407 */ // Label 5806: @284407
     /* 284407 */ GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(284432), // Rule ID 7467 //
     /* 284412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 284421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284425 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 284425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 284430 */   GIR_RootConstrainSelectedInstOperands,
     /* 284431 */   // GIR_Coverage, 7467,
     /* 284431 */   GIR_Done,
     /* 284432 */ // Label 5818: @284432
     /* 284432 */ GIM_Reject,
     /* 284433 */ // Label 5807: @284433
     /* 284433 */ GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(284458), // Rule ID 7466 //
     /* 284438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 284447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284451 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 284451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 284456 */   GIR_RootConstrainSelectedInstOperands,
     /* 284457 */   // GIR_Coverage, 7466,
     /* 284457 */   GIR_Done,
     /* 284458 */ // Label 5819: @284458
     /* 284458 */ GIM_Reject,
     /* 284459 */ // Label 5808: @284459
     /* 284459 */ GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(284484), // Rule ID 7465 //
     /* 284464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 284473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284477 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 284477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 284482 */   GIR_RootConstrainSelectedInstOperands,
     /* 284483 */   // GIR_Coverage, 7465,
     /* 284483 */   GIR_Done,
     /* 284484 */ // Label 5820: @284484
     /* 284484 */ GIM_Reject,
     /* 284485 */ // Label 5809: @284485
     /* 284485 */ GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(284510), // Rule ID 7464 //
     /* 284490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 284496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 284499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284503 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 284503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 284508 */   GIR_RootConstrainSelectedInstOperands,
     /* 284509 */   // GIR_Coverage, 7464,
     /* 284509 */   GIR_Done,
     /* 284510 */ // Label 5821: @284510
     /* 284510 */ GIM_Reject,
     /* 284511 */ // Label 5810: @284511
     /* 284511 */ GIM_Reject,
     /* 284512 */ // Label 56: @284512
     /* 284512 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5833*/ GIMT_Encode4(284941),
     /* 284523 */ /*GILLT_v2s32*//*Label 5822*/ GIMT_Encode4(284599),
     /* 284527 */ /*GILLT_v2s64*//*Label 5823*/ GIMT_Encode4(284633),
     /* 284531 */ /*GILLT_v4s16*//*Label 5824*/ GIMT_Encode4(284667),
     /* 284535 */ /*GILLT_v4s32*//*Label 5825*/ GIMT_Encode4(284701),
     /* 284539 */ /*GILLT_v8s8*//*Label 5826*/ GIMT_Encode4(284735),
     /* 284543 */ /*GILLT_v8s16*//*Label 5827*/ GIMT_Encode4(284769),
     /* 284547 */ /*GILLT_v16s8*//*Label 5828*/ GIMT_Encode4(284803), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284567 */ /*GILLT_nxv2s64*//*Label 5829*/ GIMT_Encode4(284837), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284579 */ /*GILLT_nxv4s32*//*Label 5830*/ GIMT_Encode4(284863), GIMT_Encode4(0),
     /* 284587 */ /*GILLT_nxv8s16*//*Label 5831*/ GIMT_Encode4(284889), GIMT_Encode4(0),
     /* 284595 */ /*GILLT_nxv16s8*//*Label 5832*/ GIMT_Encode4(284915),
     /* 284599 */ // Label 5822: @284599
     /* 284599 */ GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(284632), // Rule ID 2477 //
     /* 284604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284625 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 284625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 284630 */   GIR_RootConstrainSelectedInstOperands,
     /* 284631 */   // GIR_Coverage, 2477,
     /* 284631 */   GIR_Done,
     /* 284632 */ // Label 5834: @284632
     /* 284632 */ GIM_Reject,
     /* 284633 */ // Label 5823: @284633
     /* 284633 */ GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(284666), // Rule ID 2481 //
     /* 284638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284659 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 284659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 284664 */   GIR_RootConstrainSelectedInstOperands,
     /* 284665 */   // GIR_Coverage, 2481,
     /* 284665 */   GIR_Done,
     /* 284666 */ // Label 5835: @284666
     /* 284666 */ GIM_Reject,
     /* 284667 */ // Label 5824: @284667
     /* 284667 */ GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(284700), // Rule ID 2476 //
     /* 284672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284693 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 284693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 284698 */   GIR_RootConstrainSelectedInstOperands,
     /* 284699 */   // GIR_Coverage, 2476,
     /* 284699 */   GIR_Done,
     /* 284700 */ // Label 5836: @284700
     /* 284700 */ GIM_Reject,
     /* 284701 */ // Label 5825: @284701
     /* 284701 */ GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(284734), // Rule ID 2480 //
     /* 284706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284727 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 284727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 284732 */   GIR_RootConstrainSelectedInstOperands,
     /* 284733 */   // GIR_Coverage, 2480,
     /* 284733 */   GIR_Done,
     /* 284734 */ // Label 5837: @284734
     /* 284734 */ GIM_Reject,
     /* 284735 */ // Label 5826: @284735
     /* 284735 */ GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(284768), // Rule ID 2475 //
     /* 284740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 284746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284761 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 284761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 284766 */   GIR_RootConstrainSelectedInstOperands,
     /* 284767 */   // GIR_Coverage, 2475,
     /* 284767 */   GIR_Done,
     /* 284768 */ // Label 5838: @284768
     /* 284768 */ GIM_Reject,
     /* 284769 */ // Label 5827: @284769
     /* 284769 */ GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(284802), // Rule ID 2479 //
     /* 284774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284795 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 284795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 284800 */   GIR_RootConstrainSelectedInstOperands,
     /* 284801 */   // GIR_Coverage, 2479,
     /* 284801 */   GIR_Done,
     /* 284802 */ // Label 5839: @284802
     /* 284802 */ GIM_Reject,
     /* 284803 */ // Label 5828: @284803
     /* 284803 */ GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(284836), // Rule ID 2478 //
     /* 284808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 284814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284829 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 284829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 284834 */   GIR_RootConstrainSelectedInstOperands,
     /* 284835 */   // GIR_Coverage, 2478,
     /* 284835 */   GIR_Done,
     /* 284836 */ // Label 5840: @284836
     /* 284836 */ GIM_Reject,
     /* 284837 */ // Label 5829: @284837
     /* 284837 */ GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(284862), // Rule ID 7463 //
     /* 284842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 284851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284855 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 284855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 284860 */   GIR_RootConstrainSelectedInstOperands,
     /* 284861 */   // GIR_Coverage, 7463,
     /* 284861 */   GIR_Done,
     /* 284862 */ // Label 5841: @284862
     /* 284862 */ GIM_Reject,
     /* 284863 */ // Label 5830: @284863
     /* 284863 */ GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(284888), // Rule ID 7462 //
     /* 284868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 284877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284881 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 284881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 284886 */   GIR_RootConstrainSelectedInstOperands,
     /* 284887 */   // GIR_Coverage, 7462,
     /* 284887 */   GIR_Done,
     /* 284888 */ // Label 5842: @284888
     /* 284888 */ GIM_Reject,
     /* 284889 */ // Label 5831: @284889
     /* 284889 */ GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(284914), // Rule ID 7461 //
     /* 284894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 284903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284907 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 284907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 284912 */   GIR_RootConstrainSelectedInstOperands,
     /* 284913 */   // GIR_Coverage, 7461,
     /* 284913 */   GIR_Done,
     /* 284914 */ // Label 5843: @284914
     /* 284914 */ GIM_Reject,
     /* 284915 */ // Label 5832: @284915
     /* 284915 */ GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(284940), // Rule ID 7460 //
     /* 284920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 284926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 284929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284933 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 284933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 284938 */   GIR_RootConstrainSelectedInstOperands,
     /* 284939 */   // GIR_Coverage, 7460,
     /* 284939 */   GIR_Done,
     /* 284940 */ // Label 5844: @284940
     /* 284940 */ GIM_Reject,
     /* 284941 */ // Label 5833: @284941
     /* 284941 */ GIM_Reject,
     /* 284942 */ // Label 57: @284942
     /* 284942 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5856*/ GIMT_Encode4(285371),
     /* 284953 */ /*GILLT_v2s32*//*Label 5845*/ GIMT_Encode4(285029),
     /* 284957 */ /*GILLT_v2s64*//*Label 5846*/ GIMT_Encode4(285063),
     /* 284961 */ /*GILLT_v4s16*//*Label 5847*/ GIMT_Encode4(285097),
     /* 284965 */ /*GILLT_v4s32*//*Label 5848*/ GIMT_Encode4(285131),
     /* 284969 */ /*GILLT_v8s8*//*Label 5849*/ GIMT_Encode4(285165),
     /* 284973 */ /*GILLT_v8s16*//*Label 5850*/ GIMT_Encode4(285199),
     /* 284977 */ /*GILLT_v16s8*//*Label 5851*/ GIMT_Encode4(285233), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284997 */ /*GILLT_nxv2s64*//*Label 5852*/ GIMT_Encode4(285267), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285009 */ /*GILLT_nxv4s32*//*Label 5853*/ GIMT_Encode4(285293), GIMT_Encode4(0),
     /* 285017 */ /*GILLT_nxv8s16*//*Label 5854*/ GIMT_Encode4(285319), GIMT_Encode4(0),
     /* 285025 */ /*GILLT_nxv16s8*//*Label 5855*/ GIMT_Encode4(285345),
     /* 285029 */ // Label 5845: @285029
     /* 285029 */ GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(285062), // Rule ID 5037 //
     /* 285034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285055 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 285055 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 285060 */   GIR_RootConstrainSelectedInstOperands,
     /* 285061 */   // GIR_Coverage, 5037,
     /* 285061 */   GIR_Done,
     /* 285062 */ // Label 5857: @285062
     /* 285062 */ GIM_Reject,
     /* 285063 */ // Label 5846: @285063
     /* 285063 */ GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(285096), // Rule ID 5041 //
     /* 285068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285089 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 285089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 285094 */   GIR_RootConstrainSelectedInstOperands,
     /* 285095 */   // GIR_Coverage, 5041,
     /* 285095 */   GIR_Done,
     /* 285096 */ // Label 5858: @285096
     /* 285096 */ GIM_Reject,
     /* 285097 */ // Label 5847: @285097
     /* 285097 */ GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(285130), // Rule ID 5036 //
     /* 285102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285123 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 285123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 285128 */   GIR_RootConstrainSelectedInstOperands,
     /* 285129 */   // GIR_Coverage, 5036,
     /* 285129 */   GIR_Done,
     /* 285130 */ // Label 5859: @285130
     /* 285130 */ GIM_Reject,
     /* 285131 */ // Label 5848: @285131
     /* 285131 */ GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(285164), // Rule ID 5040 //
     /* 285136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285157 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 285157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 285162 */   GIR_RootConstrainSelectedInstOperands,
     /* 285163 */   // GIR_Coverage, 5040,
     /* 285163 */   GIR_Done,
     /* 285164 */ // Label 5860: @285164
     /* 285164 */ GIM_Reject,
     /* 285165 */ // Label 5849: @285165
     /* 285165 */ GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(285198), // Rule ID 5035 //
     /* 285170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285191 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 285191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 285196 */   GIR_RootConstrainSelectedInstOperands,
     /* 285197 */   // GIR_Coverage, 5035,
     /* 285197 */   GIR_Done,
     /* 285198 */ // Label 5861: @285198
     /* 285198 */ GIM_Reject,
     /* 285199 */ // Label 5850: @285199
     /* 285199 */ GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(285232), // Rule ID 5039 //
     /* 285204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285225 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 285225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 285230 */   GIR_RootConstrainSelectedInstOperands,
     /* 285231 */   // GIR_Coverage, 5039,
     /* 285231 */   GIR_Done,
     /* 285232 */ // Label 5862: @285232
     /* 285232 */ GIM_Reject,
     /* 285233 */ // Label 5851: @285233
     /* 285233 */ GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(285266), // Rule ID 5038 //
     /* 285238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 285244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 285247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285259 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 285259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 285264 */   GIR_RootConstrainSelectedInstOperands,
     /* 285265 */   // GIR_Coverage, 5038,
     /* 285265 */   GIR_Done,
     /* 285266 */ // Label 5863: @285266
     /* 285266 */ GIM_Reject,
     /* 285267 */ // Label 5852: @285267
     /* 285267 */ GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(285292), // Rule ID 7475 //
     /* 285272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285285 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 285285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 285290 */   GIR_RootConstrainSelectedInstOperands,
     /* 285291 */   // GIR_Coverage, 7475,
     /* 285291 */   GIR_Done,
     /* 285292 */ // Label 5864: @285292
     /* 285292 */ GIM_Reject,
     /* 285293 */ // Label 5853: @285293
     /* 285293 */ GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(285318), // Rule ID 7474 //
     /* 285298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285311 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 285311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 285316 */   GIR_RootConstrainSelectedInstOperands,
     /* 285317 */   // GIR_Coverage, 7474,
     /* 285317 */   GIR_Done,
     /* 285318 */ // Label 5865: @285318
     /* 285318 */ GIM_Reject,
     /* 285319 */ // Label 5854: @285319
     /* 285319 */ GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(285344), // Rule ID 7473 //
     /* 285324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285337 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 285337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 285342 */   GIR_RootConstrainSelectedInstOperands,
     /* 285343 */   // GIR_Coverage, 7473,
     /* 285343 */   GIR_Done,
     /* 285344 */ // Label 5866: @285344
     /* 285344 */ GIM_Reject,
     /* 285345 */ // Label 5855: @285345
     /* 285345 */ GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(285370), // Rule ID 7472 //
     /* 285350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 285356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 285359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285363 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 285363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 285368 */   GIR_RootConstrainSelectedInstOperands,
     /* 285369 */   // GIR_Coverage, 7472,
     /* 285369 */   GIR_Done,
     /* 285370 */ // Label 5867: @285370
     /* 285370 */ GIM_Reject,
     /* 285371 */ // Label 5856: @285371
     /* 285371 */ GIM_Reject,
     /* 285372 */ // Label 58: @285372
     /* 285372 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5879*/ GIMT_Encode4(285801),
     /* 285383 */ /*GILLT_v2s32*//*Label 5868*/ GIMT_Encode4(285459),
     /* 285387 */ /*GILLT_v2s64*//*Label 5869*/ GIMT_Encode4(285493),
     /* 285391 */ /*GILLT_v4s16*//*Label 5870*/ GIMT_Encode4(285527),
     /* 285395 */ /*GILLT_v4s32*//*Label 5871*/ GIMT_Encode4(285561),
     /* 285399 */ /*GILLT_v8s8*//*Label 5872*/ GIMT_Encode4(285595),
     /* 285403 */ /*GILLT_v8s16*//*Label 5873*/ GIMT_Encode4(285629),
     /* 285407 */ /*GILLT_v16s8*//*Label 5874*/ GIMT_Encode4(285663), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285427 */ /*GILLT_nxv2s64*//*Label 5875*/ GIMT_Encode4(285697), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285439 */ /*GILLT_nxv4s32*//*Label 5876*/ GIMT_Encode4(285723), GIMT_Encode4(0),
     /* 285447 */ /*GILLT_nxv8s16*//*Label 5877*/ GIMT_Encode4(285749), GIMT_Encode4(0),
     /* 285455 */ /*GILLT_nxv16s8*//*Label 5878*/ GIMT_Encode4(285775),
     /* 285459 */ // Label 5868: @285459
     /* 285459 */ GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(285492), // Rule ID 5030 //
     /* 285464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285485 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 285485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 285490 */   GIR_RootConstrainSelectedInstOperands,
     /* 285491 */   // GIR_Coverage, 5030,
     /* 285491 */   GIR_Done,
     /* 285492 */ // Label 5880: @285492
     /* 285492 */ GIM_Reject,
     /* 285493 */ // Label 5869: @285493
     /* 285493 */ GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(285526), // Rule ID 5034 //
     /* 285498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285519 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 285519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 285524 */   GIR_RootConstrainSelectedInstOperands,
     /* 285525 */   // GIR_Coverage, 5034,
     /* 285525 */   GIR_Done,
     /* 285526 */ // Label 5881: @285526
     /* 285526 */ GIM_Reject,
     /* 285527 */ // Label 5870: @285527
     /* 285527 */ GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(285560), // Rule ID 5029 //
     /* 285532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285553 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 285553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 285558 */   GIR_RootConstrainSelectedInstOperands,
     /* 285559 */   // GIR_Coverage, 5029,
     /* 285559 */   GIR_Done,
     /* 285560 */ // Label 5882: @285560
     /* 285560 */ GIM_Reject,
     /* 285561 */ // Label 5871: @285561
     /* 285561 */ GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(285594), // Rule ID 5033 //
     /* 285566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285587 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 285587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 285592 */   GIR_RootConstrainSelectedInstOperands,
     /* 285593 */   // GIR_Coverage, 5033,
     /* 285593 */   GIR_Done,
     /* 285594 */ // Label 5883: @285594
     /* 285594 */ GIM_Reject,
     /* 285595 */ // Label 5872: @285595
     /* 285595 */ GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(285628), // Rule ID 5028 //
     /* 285600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285621 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 285621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 285626 */   GIR_RootConstrainSelectedInstOperands,
     /* 285627 */   // GIR_Coverage, 5028,
     /* 285627 */   GIR_Done,
     /* 285628 */ // Label 5884: @285628
     /* 285628 */ GIM_Reject,
     /* 285629 */ // Label 5873: @285629
     /* 285629 */ GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(285662), // Rule ID 5032 //
     /* 285634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285655 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 285655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 285660 */   GIR_RootConstrainSelectedInstOperands,
     /* 285661 */   // GIR_Coverage, 5032,
     /* 285661 */   GIR_Done,
     /* 285662 */ // Label 5885: @285662
     /* 285662 */ GIM_Reject,
     /* 285663 */ // Label 5874: @285663
     /* 285663 */ GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(285696), // Rule ID 5031 //
     /* 285668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 285674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 285677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285689 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 285689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 285694 */   GIR_RootConstrainSelectedInstOperands,
     /* 285695 */   // GIR_Coverage, 5031,
     /* 285695 */   GIR_Done,
     /* 285696 */ // Label 5886: @285696
     /* 285696 */ GIM_Reject,
     /* 285697 */ // Label 5875: @285697
     /* 285697 */ GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(285722), // Rule ID 7471 //
     /* 285702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285715 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 285715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 285720 */   GIR_RootConstrainSelectedInstOperands,
     /* 285721 */   // GIR_Coverage, 7471,
     /* 285721 */   GIR_Done,
     /* 285722 */ // Label 5887: @285722
     /* 285722 */ GIM_Reject,
     /* 285723 */ // Label 5876: @285723
     /* 285723 */ GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(285748), // Rule ID 7470 //
     /* 285728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285741 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 285741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 285746 */   GIR_RootConstrainSelectedInstOperands,
     /* 285747 */   // GIR_Coverage, 7470,
     /* 285747 */   GIR_Done,
     /* 285748 */ // Label 5888: @285748
     /* 285748 */ GIM_Reject,
     /* 285749 */ // Label 5877: @285749
     /* 285749 */ GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(285774), // Rule ID 7469 //
     /* 285754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285767 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 285767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 285772 */   GIR_RootConstrainSelectedInstOperands,
     /* 285773 */   // GIR_Coverage, 7469,
     /* 285773 */   GIR_Done,
     /* 285774 */ // Label 5889: @285774
     /* 285774 */ GIM_Reject,
     /* 285775 */ // Label 5878: @285775
     /* 285775 */ GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(285800), // Rule ID 7468 //
     /* 285780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 285786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 285789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285793 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 285793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 285798 */   GIR_RootConstrainSelectedInstOperands,
     /* 285799 */   // GIR_Coverage, 7468,
     /* 285799 */   GIR_Done,
     /* 285800 */ // Label 5890: @285800
     /* 285800 */ GIM_Reject,
     /* 285801 */ // Label 5879: @285801
     /* 285801 */ GIM_Reject,
     /* 285802 */ // Label 59: @285802
     /* 285802 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5902*/ GIMT_Encode4(287599),
     /* 285813 */ /*GILLT_s16*//*Label 5891*/ GIMT_Encode4(285897),
     /* 285817 */ /*GILLT_s32*//*Label 5892*/ GIMT_Encode4(286123),
     /* 285821 */ /*GILLT_s64*//*Label 5893*/ GIMT_Encode4(286477), GIMT_Encode4(0),
     /* 285829 */ /*GILLT_v2s32*//*Label 5894*/ GIMT_Encode4(286649),
     /* 285833 */ /*GILLT_v2s64*//*Label 5895*/ GIMT_Encode4(286687),
     /* 285837 */ /*GILLT_v4s16*//*Label 5896*/ GIMT_Encode4(286863),
     /* 285841 */ /*GILLT_v4s32*//*Label 5897*/ GIMT_Encode4(286901), GIMT_Encode4(0),
     /* 285849 */ /*GILLT_v8s16*//*Label 5898*/ GIMT_Encode4(287077), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285873 */ /*GILLT_nxv2s64*//*Label 5899*/ GIMT_Encode4(287521), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285885 */ /*GILLT_nxv4s32*//*Label 5900*/ GIMT_Encode4(287547), GIMT_Encode4(0),
     /* 285893 */ /*GILLT_nxv8s16*//*Label 5901*/ GIMT_Encode4(287573),
     /* 285897 */ // Label 5891: @285897
     /* 285897 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(286122),
     /* 285902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285912 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(286003), // Rule ID 6923 //
     /* 285917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285938 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285954 */     // MIs[2] Rn
     /* 285954 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285959 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 285963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285965 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 285965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285977 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 285996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286001 */     GIR_RootConstrainSelectedInstOperands,
     /* 286002 */     // GIR_Coverage, 6923,
     /* 286002 */     GIR_EraseRootFromParent_Done,
     /* 286003 */   // Label 5904: @286003
     /* 286003 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(286094), // Rule ID 13958 //
     /* 286008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286029 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 286033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286045 */     // MIs[2] Rn
     /* 286045 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286050 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286056 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 286056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286068 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 286087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286092 */     GIR_RootConstrainSelectedInstOperands,
     /* 286093 */     // GIR_Coverage, 13958,
     /* 286093 */     GIR_EraseRootFromParent_Done,
     /* 286094 */   // Label 5905: @286094
     /* 286094 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(286121), // Rule ID 584 //
     /* 286099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286110 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 286110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 286115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286119 */     GIR_RootConstrainSelectedInstOperands,
     /* 286120 */     // GIR_Coverage, 584,
     /* 286120 */     GIR_Done,
     /* 286121 */   // Label 5906: @286121
     /* 286121 */   GIM_Reject,
     /* 286122 */ // Label 5903: @286122
     /* 286122 */ GIM_Reject,
     /* 286123 */ // Label 5892: @286123
     /* 286123 */ GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(286476),
     /* 286128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286138 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(286229), // Rule ID 6921 //
     /* 286143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286164 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286180 */     // MIs[2] Rn
     /* 286180 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286185 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 286189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286191 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 286191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286203 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 286222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286227 */     GIR_RootConstrainSelectedInstOperands,
     /* 286228 */     // GIR_Coverage, 6921,
     /* 286228 */     GIR_EraseRootFromParent_Done,
     /* 286229 */   // Label 5908: @286229
     /* 286229 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(286293), // Rule ID 13140 //
     /* 286234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286255 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286271 */     // MIs[2] Rn
     /* 286271 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286276 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 286280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286282 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 286282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 286285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286291 */     GIR_RootConstrainSelectedInstOperands,
     /* 286292 */     // GIR_Coverage, 13140,
     /* 286292 */     GIR_EraseRootFromParent_Done,
     /* 286293 */   // Label 5909: @286293
     /* 286293 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(286384), // Rule ID 13956 //
     /* 286298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 286323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286335 */     // MIs[2] Rn
     /* 286335 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286340 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286346 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 286346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286358 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 286377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286382 */     GIR_RootConstrainSelectedInstOperands,
     /* 286383 */     // GIR_Coverage, 13956,
     /* 286383 */     GIR_EraseRootFromParent_Done,
     /* 286384 */   // Label 5910: @286384
     /* 286384 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(286448), // Rule ID 15643 //
     /* 286389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 286414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286426 */     // MIs[2] Rn
     /* 286426 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286431 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286437 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 286437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 286440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286446 */     GIR_RootConstrainSelectedInstOperands,
     /* 286447 */     // GIR_Coverage, 15643,
     /* 286447 */     GIR_EraseRootFromParent_Done,
     /* 286448 */   // Label 5911: @286448
     /* 286448 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(286475), // Rule ID 586 //
     /* 286453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286464 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 286464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 286469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286473 */     GIR_RootConstrainSelectedInstOperands,
     /* 286474 */     // GIR_Coverage, 586,
     /* 286474 */     GIR_Done,
     /* 286475 */   // Label 5912: @286475
     /* 286475 */   GIM_Reject,
     /* 286476 */ // Label 5907: @286476
     /* 286476 */ GIM_Reject,
     /* 286477 */ // Label 5893: @286477
     /* 286477 */ GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(286648),
     /* 286482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286492 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(286556), // Rule ID 6919 //
     /* 286497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286518 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286534 */     // MIs[2] Rn
     /* 286534 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286539 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 286543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286545 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 286545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 286548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286554 */     GIR_RootConstrainSelectedInstOperands,
     /* 286555 */     // GIR_Coverage, 6919,
     /* 286555 */     GIR_EraseRootFromParent_Done,
     /* 286556 */   // Label 5914: @286556
     /* 286556 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(286620), // Rule ID 13954 //
     /* 286561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286582 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 286586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286598 */     // MIs[2] Rn
     /* 286598 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286603 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286609 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 286609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 286612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286618 */     GIR_RootConstrainSelectedInstOperands,
     /* 286619 */     // GIR_Coverage, 13954,
     /* 286619 */     GIR_EraseRootFromParent_Done,
     /* 286620 */   // Label 5915: @286620
     /* 286620 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(286647), // Rule ID 588 //
     /* 286625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286636 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 286636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 286641 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286645 */     GIR_RootConstrainSelectedInstOperands,
     /* 286646 */     // GIR_Coverage, 588,
     /* 286646 */     GIR_Done,
     /* 286647 */   // Label 5916: @286647
     /* 286647 */   GIM_Reject,
     /* 286648 */ // Label 5913: @286648
     /* 286648 */ GIM_Reject,
     /* 286649 */ // Label 5894: @286649
     /* 286649 */ GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(286686), // Rule ID 1203 //
     /* 286654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 286663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286675 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 286675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 286680 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286684 */   GIR_RootConstrainSelectedInstOperands,
     /* 286685 */   // GIR_Coverage, 1203,
     /* 286685 */   GIR_Done,
     /* 286686 */ // Label 5917: @286686
     /* 286686 */ GIM_Reject,
     /* 286687 */ // Label 5895: @286687
     /* 286687 */ GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(286862),
     /* 286692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286702 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(286768), // Rule ID 6941 //
     /* 286707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 286715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 286741 */     // MIs[2] Rn
     /* 286741 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286746 */     // MIs[2] Rm
     /* 286746 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 286751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286753 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 286753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 286756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 286766 */     GIR_RootConstrainSelectedInstOperands,
     /* 286767 */     // GIR_Coverage, 6941,
     /* 286767 */     GIR_EraseRootFromParent_Done,
     /* 286768 */   // Label 5919: @286768
     /* 286768 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(286834), // Rule ID 13966 //
     /* 286773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 286781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 286807 */     // MIs[2] Rn
     /* 286807 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286812 */     // MIs[2] Rm
     /* 286812 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 286817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286819 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 286819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 286822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 286832 */     GIR_RootConstrainSelectedInstOperands,
     /* 286833 */     // GIR_Coverage, 13966,
     /* 286833 */     GIR_EraseRootFromParent_Done,
     /* 286834 */   // Label 5920: @286834
     /* 286834 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(286861), // Rule ID 1207 //
     /* 286839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286850 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 286850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 286855 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286859 */     GIR_RootConstrainSelectedInstOperands,
     /* 286860 */     // GIR_Coverage, 1207,
     /* 286860 */     GIR_Done,
     /* 286861 */   // Label 5921: @286861
     /* 286861 */   GIM_Reject,
     /* 286862 */ // Label 5918: @286862
     /* 286862 */ GIM_Reject,
     /* 286863 */ // Label 5896: @286863
     /* 286863 */ GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(286900), // Rule ID 1199 //
     /* 286868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 286877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286889 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 286889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 286894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286898 */   GIR_RootConstrainSelectedInstOperands,
     /* 286899 */   // GIR_Coverage, 1199,
     /* 286899 */   GIR_Done,
     /* 286900 */ // Label 5922: @286900
     /* 286900 */ GIM_Reject,
     /* 286901 */ // Label 5897: @286901
     /* 286901 */ GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(287076),
     /* 286906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286916 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(286982), // Rule ID 6942 //
     /* 286921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 286929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 286955 */     // MIs[2] Rn
     /* 286955 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 286960 */     // MIs[2] Rm
     /* 286960 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 286965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286967 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 286967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 286970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 286980 */     GIR_RootConstrainSelectedInstOperands,
     /* 286981 */     // GIR_Coverage, 6942,
     /* 286981 */     GIR_EraseRootFromParent_Done,
     /* 286982 */   // Label 5924: @286982
     /* 286982 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(287048), // Rule ID 13967 //
     /* 286987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 286995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 287003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 287021 */     // MIs[2] Rn
     /* 287021 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 287026 */     // MIs[2] Rm
     /* 287026 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 287031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287033 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 287033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 287036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 287046 */     GIR_RootConstrainSelectedInstOperands,
     /* 287047 */     // GIR_Coverage, 13967,
     /* 287047 */     GIR_EraseRootFromParent_Done,
     /* 287048 */   // Label 5925: @287048
     /* 287048 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(287075), // Rule ID 1205 //
     /* 287053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287064 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 287064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 287069 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287073 */     GIR_RootConstrainSelectedInstOperands,
     /* 287074 */     // GIR_Coverage, 1205,
     /* 287074 */     GIR_Done,
     /* 287075 */   // Label 5926: @287075
     /* 287075 */   GIM_Reject,
     /* 287076 */ // Label 5923: @287076
     /* 287076 */ GIM_Reject,
     /* 287077 */ // Label 5898: @287077
     /* 287077 */ GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(287520),
     /* 287082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 287088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287092 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(287161), // Rule ID 6943 //
     /* 287097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 287108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 287116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 287134 */     // MIs[2] Rn
     /* 287134 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 287139 */     // MIs[2] Rm
     /* 287139 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 287144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287146 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 287146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 287149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 287159 */     GIR_RootConstrainSelectedInstOperands,
     /* 287160 */     // GIR_Coverage, 6943,
     /* 287160 */     GIR_EraseRootFromParent_Done,
     /* 287161 */   // Label 5928: @287161
     /* 287161 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(287230), // Rule ID 13968 //
     /* 287166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 287177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 287185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 287203 */     // MIs[2] Rn
     /* 287203 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 287208 */     // MIs[2] Rm
     /* 287208 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 287213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287215 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 287215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 287218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 287228 */     GIR_RootConstrainSelectedInstOperands,
     /* 287229 */     // GIR_Coverage, 13968,
     /* 287229 */     GIR_EraseRootFromParent_Done,
     /* 287230 */   // Label 5929: @287230
     /* 287230 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(287257), // Rule ID 1201 //
     /* 287235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287246 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 287246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 287251 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287255 */     GIR_RootConstrainSelectedInstOperands,
     /* 287256 */     // GIR_Coverage, 1201,
     /* 287256 */     GIR_Done,
     /* 287257 */   // Label 5930: @287257
     /* 287257 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(287519), // Rule ID 7012 //
     /* 287262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 287265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287273 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 287273 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 287276 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 287280 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287285 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 287289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 287291 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 287294 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 287298 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287303 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 287307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 287309 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 287312 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 287316 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287321 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 287324 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 287327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 287329 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 287332 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287336 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287341 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287347 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287352 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287357 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 287360 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 287364 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287369 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 287372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 287374 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 287377 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287381 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287386 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287392 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287397 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287402 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 287405 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 287409 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287414 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 287417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 287419 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 287422 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 287426 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287431 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 287434 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 287437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 287439 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 287442 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 287446 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287451 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 287454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 287456 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 287459 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 287463 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 287470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 287473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 287477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 287485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 287488 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 287491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 287509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 287517 */     GIR_RootConstrainSelectedInstOperands,
     /* 287518 */     // GIR_Coverage, 7012,
     /* 287518 */     GIR_EraseRootFromParent_Done,
     /* 287519 */   // Label 5931: @287519
     /* 287519 */   GIM_Reject,
     /* 287520 */ // Label 5927: @287520
     /* 287520 */ GIM_Reject,
     /* 287521 */ // Label 5899: @287521
     /* 287521 */ GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(287546), // Rule ID 2824 //
     /* 287526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 287529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 287532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 287535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 287539 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 287539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 287544 */   GIR_RootConstrainSelectedInstOperands,
     /* 287545 */   // GIR_Coverage, 2824,
     /* 287545 */   GIR_Done,
     /* 287546 */ // Label 5932: @287546
     /* 287546 */ GIM_Reject,
     /* 287547 */ // Label 5900: @287547
     /* 287547 */ GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(287572), // Rule ID 2822 //
     /* 287552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 287555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 287558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 287561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 287565 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 287565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 287570 */   GIR_RootConstrainSelectedInstOperands,
     /* 287571 */   // GIR_Coverage, 2822,
     /* 287571 */   GIR_Done,
     /* 287572 */ // Label 5933: @287572
     /* 287572 */ GIM_Reject,
     /* 287573 */ // Label 5901: @287573
     /* 287573 */ GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(287598), // Rule ID 2820 //
     /* 287578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 287581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 287584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 287587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 287591 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 287591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 287596 */   GIR_RootConstrainSelectedInstOperands,
     /* 287597 */   // GIR_Coverage, 2820,
     /* 287597 */   GIR_Done,
     /* 287598 */ // Label 5934: @287598
     /* 287598 */ GIM_Reject,
     /* 287599 */ // Label 5902: @287599
     /* 287599 */ GIM_Reject,
     /* 287600 */ // Label 60: @287600
     /* 287600 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5946*/ GIMT_Encode4(288337),
     /* 287611 */ /*GILLT_s16*//*Label 5935*/ GIMT_Encode4(287695),
     /* 287615 */ /*GILLT_s32*//*Label 5936*/ GIMT_Encode4(287733),
     /* 287619 */ /*GILLT_s64*//*Label 5937*/ GIMT_Encode4(287771), GIMT_Encode4(0),
     /* 287627 */ /*GILLT_v2s32*//*Label 5938*/ GIMT_Encode4(287809),
     /* 287631 */ /*GILLT_v2s64*//*Label 5939*/ GIMT_Encode4(287847),
     /* 287635 */ /*GILLT_v4s16*//*Label 5940*/ GIMT_Encode4(287885),
     /* 287639 */ /*GILLT_v4s32*//*Label 5941*/ GIMT_Encode4(287923), GIMT_Encode4(0),
     /* 287647 */ /*GILLT_v8s16*//*Label 5942*/ GIMT_Encode4(287961), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 287671 */ /*GILLT_nxv2s64*//*Label 5943*/ GIMT_Encode4(288259), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 287683 */ /*GILLT_nxv4s32*//*Label 5944*/ GIMT_Encode4(288285), GIMT_Encode4(0),
     /* 287691 */ /*GILLT_nxv8s16*//*Label 5945*/ GIMT_Encode4(288311),
     /* 287695 */ // Label 5935: @287695
     /* 287695 */ GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(287732), // Rule ID 632 //
     /* 287700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 287706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 287709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287721 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 287721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 287726 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287730 */   GIR_RootConstrainSelectedInstOperands,
     /* 287731 */   // GIR_Coverage, 632,
     /* 287731 */   GIR_Done,
     /* 287732 */ // Label 5947: @287732
     /* 287732 */ GIM_Reject,
     /* 287733 */ // Label 5936: @287733
     /* 287733 */ GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(287770), // Rule ID 634 //
     /* 287738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 287747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287759 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 287759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 287764 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287768 */   GIR_RootConstrainSelectedInstOperands,
     /* 287769 */   // GIR_Coverage, 634,
     /* 287769 */   GIR_Done,
     /* 287770 */ // Label 5948: @287770
     /* 287770 */ GIM_Reject,
     /* 287771 */ // Label 5937: @287771
     /* 287771 */ GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(287808), // Rule ID 636 //
     /* 287776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287797 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 287797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 287802 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287806 */   GIR_RootConstrainSelectedInstOperands,
     /* 287807 */   // GIR_Coverage, 636,
     /* 287807 */   GIR_Done,
     /* 287808 */ // Label 5949: @287808
     /* 287808 */ GIM_Reject,
     /* 287809 */ // Label 5938: @287809
     /* 287809 */ GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(287846), // Rule ID 1343 //
     /* 287814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 287820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287835 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 287835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 287840 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287844 */   GIR_RootConstrainSelectedInstOperands,
     /* 287845 */   // GIR_Coverage, 1343,
     /* 287845 */   GIR_Done,
     /* 287846 */ // Label 5950: @287846
     /* 287846 */ GIM_Reject,
     /* 287847 */ // Label 5939: @287847
     /* 287847 */ GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(287884), // Rule ID 1347 //
     /* 287852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 287861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287873 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 287873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 287878 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287882 */   GIR_RootConstrainSelectedInstOperands,
     /* 287883 */   // GIR_Coverage, 1347,
     /* 287883 */   GIR_Done,
     /* 287884 */ // Label 5951: @287884
     /* 287884 */ GIM_Reject,
     /* 287885 */ // Label 5940: @287885
     /* 287885 */ GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(287922), // Rule ID 1339 //
     /* 287890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 287896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287911 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 287911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 287916 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287920 */   GIR_RootConstrainSelectedInstOperands,
     /* 287921 */   // GIR_Coverage, 1339,
     /* 287921 */   GIR_Done,
     /* 287922 */ // Label 5952: @287922
     /* 287922 */ GIM_Reject,
     /* 287923 */ // Label 5941: @287923
     /* 287923 */ GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(287960), // Rule ID 1345 //
     /* 287928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 287937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287949 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 287949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 287954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287958 */   GIR_RootConstrainSelectedInstOperands,
     /* 287959 */   // GIR_Coverage, 1345,
     /* 287959 */   GIR_Done,
     /* 287960 */ // Label 5953: @287960
     /* 287960 */ GIM_Reject,
     /* 287961 */ // Label 5942: @287961
     /* 287961 */ GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(288258),
     /* 287966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 287972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287984 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(288003), // Rule ID 1341 //
     /* 287989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287992 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 287992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 287997 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288001 */     GIR_RootConstrainSelectedInstOperands,
     /* 288002 */     // GIR_Coverage, 1341,
     /* 288002 */     GIR_Done,
     /* 288003 */   // Label 5955: @288003
     /* 288003 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(288257), // Rule ID 7018 //
     /* 288008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 288011 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 288011 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 288014 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 288018 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288023 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 288027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 288029 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 288032 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 288036 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288041 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 288045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 288047 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 288050 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 288054 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288059 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 288062 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 288065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 288067 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 288070 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288074 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288079 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 288085 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288090 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288095 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 288098 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 288102 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288107 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 288110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 288112 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 288115 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288119 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288124 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288130 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288135 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288140 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 288143 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 288147 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288152 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 288155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 288157 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 288160 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 288164 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288169 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 288172 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 288175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 288177 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 288180 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 288184 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288189 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 288192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 288194 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 288197 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288201 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 288211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288220 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 288226 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 288247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 288255 */     GIR_RootConstrainSelectedInstOperands,
     /* 288256 */     // GIR_Coverage, 7018,
     /* 288256 */     GIR_EraseRootFromParent_Done,
     /* 288257 */   // Label 5956: @288257
     /* 288257 */   GIM_Reject,
     /* 288258 */ // Label 5954: @288258
     /* 288258 */ GIM_Reject,
     /* 288259 */ // Label 5943: @288259
     /* 288259 */ GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(288284), // Rule ID 8218 //
     /* 288264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 288267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 288270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 288273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 288277 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 288277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 288282 */   GIR_RootConstrainSelectedInstOperands,
     /* 288283 */   // GIR_Coverage, 8218,
     /* 288283 */   GIR_Done,
     /* 288284 */ // Label 5957: @288284
     /* 288284 */ GIM_Reject,
     /* 288285 */ // Label 5944: @288285
     /* 288285 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(288310), // Rule ID 8216 //
     /* 288290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 288293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 288296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 288299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 288303 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 288303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 288308 */   GIR_RootConstrainSelectedInstOperands,
     /* 288309 */   // GIR_Coverage, 8216,
     /* 288309 */   GIR_Done,
     /* 288310 */ // Label 5958: @288310
     /* 288310 */ GIM_Reject,
     /* 288311 */ // Label 5945: @288311
     /* 288311 */ GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(288336), // Rule ID 8214 //
     /* 288316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 288319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 288322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 288325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 288329 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 288329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 288334 */   GIR_RootConstrainSelectedInstOperands,
     /* 288335 */   // GIR_Coverage, 8214,
     /* 288335 */   GIR_Done,
     /* 288336 */ // Label 5959: @288336
     /* 288336 */ GIM_Reject,
     /* 288337 */ // Label 5946: @288337
     /* 288337 */ GIM_Reject,
     /* 288338 */ // Label 61: @288338
     /* 288338 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5971*/ GIMT_Encode4(292433),
     /* 288349 */ /*GILLT_s16*//*Label 5960*/ GIMT_Encode4(288433),
     /* 288353 */ /*GILLT_s32*//*Label 5961*/ GIMT_Encode4(289075),
     /* 288357 */ /*GILLT_s64*//*Label 5962*/ GIMT_Encode4(289705), GIMT_Encode4(0),
     /* 288365 */ /*GILLT_v2s32*//*Label 5963*/ GIMT_Encode4(290335),
     /* 288369 */ /*GILLT_v2s64*//*Label 5964*/ GIMT_Encode4(290865),
     /* 288373 */ /*GILLT_v4s16*//*Label 5965*/ GIMT_Encode4(291223),
     /* 288377 */ /*GILLT_v4s32*//*Label 5966*/ GIMT_Encode4(291565), GIMT_Encode4(0),
     /* 288385 */ /*GILLT_v8s16*//*Label 5967*/ GIMT_Encode4(291923), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 288409 */ /*GILLT_nxv2s64*//*Label 5968*/ GIMT_Encode4(292355), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 288421 */ /*GILLT_nxv4s32*//*Label 5969*/ GIMT_Encode4(292381), GIMT_Encode4(0),
     /* 288429 */ /*GILLT_nxv8s16*//*Label 5970*/ GIMT_Encode4(292407),
     /* 288433 */ // Label 5960: @288433
     /* 288433 */ GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(289074),
     /* 288438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 288441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 288444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288448 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(288561), // Rule ID 6253 //
     /* 288453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288477 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288510 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288514 */     // MIs[3] Operand 1
     /* 288514 */     // No operand predicates
     /* 288514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288516 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 288516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288528 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 288534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 288547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288559 */     GIR_RootConstrainSelectedInstOperands,
     /* 288560 */     // GIR_Coverage, 6253,
     /* 288560 */     GIR_EraseRootFromParent_Done,
     /* 288561 */   // Label 5973: @288561
     /* 288561 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(288674), // Rule ID 13935 //
     /* 288566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288602 */     // MIs[2] Operand 1
     /* 288602 */     // No operand predicates
     /* 288602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288610 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288614 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 288618 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288623 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 288627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288629 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 288629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288641 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 288647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 288660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288672 */     GIR_RootConstrainSelectedInstOperands,
     /* 288673 */     // GIR_Coverage, 13935,
     /* 288673 */     GIR_EraseRootFromParent_Done,
     /* 288674 */   // Label 5974: @288674
     /* 288674 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(288753), // Rule ID 13869 //
     /* 288679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288703 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288713 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 288713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288725 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 288731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 288744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288751 */     GIR_RootConstrainSelectedInstOperands,
     /* 288752 */     // GIR_Coverage, 13869,
     /* 288752 */     GIR_EraseRootFromParent_Done,
     /* 288753 */   // Label 5975: @288753
     /* 288753 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(288832), // Rule ID 4803 //
     /* 288758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288786 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288792 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 288792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288804 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 288810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 288823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288830 */     GIR_RootConstrainSelectedInstOperands,
     /* 288831 */     // GIR_Coverage, 4803,
     /* 288831 */     GIR_EraseRootFromParent_Done,
     /* 288832 */   // Label 5976: @288832
     /* 288832 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(288895), // Rule ID 13484 //
     /* 288837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288869 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288873 */     // MIs[2] Operand 1
     /* 288873 */     // No operand predicates
     /* 288873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288879 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 288882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288893 */     GIR_RootConstrainSelectedInstOperands,
     /* 288894 */     // GIR_Coverage, 13484,
     /* 288894 */     GIR_EraseRootFromParent_Done,
     /* 288895 */   // Label 5977: @288895
     /* 288895 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(288958), // Rule ID 2012 //
     /* 288900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288936 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288940 */     // MIs[2] Operand 1
     /* 288940 */     // No operand predicates
     /* 288940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288942 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 288945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288956 */     GIR_RootConstrainSelectedInstOperands,
     /* 288957 */     // GIR_Coverage, 2012,
     /* 288957 */     GIR_EraseRootFromParent_Done,
     /* 288958 */   // Label 5978: @288958
     /* 288958 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(289002), // Rule ID 4808 //
     /* 288963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288989 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 288989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 288992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 288998 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 289000 */     GIR_RootConstrainSelectedInstOperands,
     /* 289001 */     // GIR_Coverage, 4808,
     /* 289001 */     GIR_EraseRootFromParent_Done,
     /* 289002 */   // Label 5979: @289002
     /* 289002 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(289046), // Rule ID 13874 //
     /* 289007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 289026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289033 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 289033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 289036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 289042 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 289044 */     GIR_RootConstrainSelectedInstOperands,
     /* 289045 */     // GIR_Coverage, 13874,
     /* 289045 */     GIR_EraseRootFromParent_Done,
     /* 289046 */   // Label 5980: @289046
     /* 289046 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(289073), // Rule ID 620 //
     /* 289051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289062 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 289062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 289067 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289071 */     GIR_RootConstrainSelectedInstOperands,
     /* 289072 */     // GIR_Coverage, 620,
     /* 289072 */     GIR_Done,
     /* 289073 */   // Label 5981: @289073
     /* 289073 */   GIM_Reject,
     /* 289074 */ // Label 5972: @289074
     /* 289074 */ GIM_Reject,
     /* 289075 */ // Label 5961: @289075
     /* 289075 */ GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(289704),
     /* 289080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 289083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 289086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289090 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(289203), // Rule ID 6255 //
     /* 289095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289152 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289156 */     // MIs[3] Operand 1
     /* 289156 */     // No operand predicates
     /* 289156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289158 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289170 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 289189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289201 */     GIR_RootConstrainSelectedInstOperands,
     /* 289202 */     // GIR_Coverage, 6255,
     /* 289202 */     GIR_EraseRootFromParent_Done,
     /* 289203 */   // Label 5983: @289203
     /* 289203 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(289316), // Rule ID 13937 //
     /* 289208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289244 */     // MIs[2] Operand 1
     /* 289244 */     // No operand predicates
     /* 289244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289256 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289260 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289265 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289271 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289283 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 289302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289314 */     GIR_RootConstrainSelectedInstOperands,
     /* 289315 */     // GIR_Coverage, 13937,
     /* 289315 */     GIR_EraseRootFromParent_Done,
     /* 289316 */   // Label 5984: @289316
     /* 289316 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(289392), // Rule ID 13871 //
     /* 289321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289352 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 289352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289364 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 289370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 289383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289390 */     GIR_RootConstrainSelectedInstOperands,
     /* 289391 */     // GIR_Coverage, 13871,
     /* 289391 */     GIR_EraseRootFromParent_Done,
     /* 289392 */   // Label 5985: @289392
     /* 289392 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(289468), // Rule ID 4805 //
     /* 289397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289422 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289428 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 289428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289440 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 289446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 289459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289466 */     GIR_RootConstrainSelectedInstOperands,
     /* 289467 */     // GIR_Coverage, 4805,
     /* 289467 */     GIR_EraseRootFromParent_Done,
     /* 289468 */   // Label 5986: @289468
     /* 289468 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(289531), // Rule ID 13486 //
     /* 289473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289509 */     // MIs[2] Operand 1
     /* 289509 */     // No operand predicates
     /* 289509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289515 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 289518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289529 */     GIR_RootConstrainSelectedInstOperands,
     /* 289530 */     // GIR_Coverage, 13486,
     /* 289530 */     GIR_EraseRootFromParent_Done,
     /* 289531 */   // Label 5987: @289531
     /* 289531 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(289594), // Rule ID 2014 //
     /* 289536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289576 */     // MIs[2] Operand 1
     /* 289576 */     // No operand predicates
     /* 289576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289578 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 289581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289592 */     GIR_RootConstrainSelectedInstOperands,
     /* 289593 */     // GIR_Coverage, 2014,
     /* 289593 */     GIR_EraseRootFromParent_Done,
     /* 289594 */   // Label 5988: @289594
     /* 289594 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(289635), // Rule ID 4809 //
     /* 289599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289622 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 289622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 289625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 289631 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 289633 */     GIR_RootConstrainSelectedInstOperands,
     /* 289634 */     // GIR_Coverage, 4809,
     /* 289634 */     GIR_EraseRootFromParent_Done,
     /* 289635 */   // Label 5989: @289635
     /* 289635 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(289676), // Rule ID 13875 //
     /* 289640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289663 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 289663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 289666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 289672 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 289674 */     GIR_RootConstrainSelectedInstOperands,
     /* 289675 */     // GIR_Coverage, 13875,
     /* 289675 */     GIR_EraseRootFromParent_Done,
     /* 289676 */   // Label 5990: @289676
     /* 289676 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(289703), // Rule ID 622 //
     /* 289681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289692 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 289692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 289697 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289701 */     GIR_RootConstrainSelectedInstOperands,
     /* 289702 */     // GIR_Coverage, 622,
     /* 289702 */     GIR_Done,
     /* 289703 */   // Label 5991: @289703
     /* 289703 */   GIM_Reject,
     /* 289704 */ // Label 5982: @289704
     /* 289704 */ GIM_Reject,
     /* 289705 */ // Label 5962: @289705
     /* 289705 */ GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(290334),
     /* 289710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 289713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 289716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289720 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(289833), // Rule ID 6257 //
     /* 289725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289749 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289786 */     // MIs[3] Operand 1
     /* 289786 */     // No operand predicates
     /* 289786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289788 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 289788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289800 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 289819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289831 */     GIR_RootConstrainSelectedInstOperands,
     /* 289832 */     // GIR_Coverage, 6257,
     /* 289832 */     GIR_EraseRootFromParent_Done,
     /* 289833 */   // Label 5993: @289833
     /* 289833 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(289946), // Rule ID 13939 //
     /* 289838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289874 */     // MIs[2] Operand 1
     /* 289874 */     // No operand predicates
     /* 289874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289886 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289890 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289895 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289901 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 289901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289913 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 289932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289944 */     GIR_RootConstrainSelectedInstOperands,
     /* 289945 */     // GIR_Coverage, 13939,
     /* 289945 */     GIR_EraseRootFromParent_Done,
     /* 289946 */   // Label 5994: @289946
     /* 289946 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(290022), // Rule ID 13873 //
     /* 289951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289982 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 289982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289994 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 290000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 290013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290020 */     GIR_RootConstrainSelectedInstOperands,
     /* 290021 */     // GIR_Coverage, 13873,
     /* 290021 */     GIR_EraseRootFromParent_Done,
     /* 290022 */   // Label 5995: @290022
     /* 290022 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(290098), // Rule ID 4807 //
     /* 290027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290058 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 290058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 290076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 290089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290096 */     GIR_RootConstrainSelectedInstOperands,
     /* 290097 */     // GIR_Coverage, 4807,
     /* 290097 */     GIR_EraseRootFromParent_Done,
     /* 290098 */   // Label 5996: @290098
     /* 290098 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(290161), // Rule ID 13488 //
     /* 290103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290139 */     // MIs[2] Operand 1
     /* 290139 */     // No operand predicates
     /* 290139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290145 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 290148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290159 */     GIR_RootConstrainSelectedInstOperands,
     /* 290160 */     // GIR_Coverage, 13488,
     /* 290160 */     GIR_EraseRootFromParent_Done,
     /* 290161 */   // Label 5997: @290161
     /* 290161 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(290224), // Rule ID 2016 //
     /* 290166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290202 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290206 */     // MIs[2] Operand 1
     /* 290206 */     // No operand predicates
     /* 290206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290208 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 290211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290222 */     GIR_RootConstrainSelectedInstOperands,
     /* 290223 */     // GIR_Coverage, 2016,
     /* 290223 */     GIR_EraseRootFromParent_Done,
     /* 290224 */   // Label 5998: @290224
     /* 290224 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(290265), // Rule ID 4810 //
     /* 290229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290252 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 290252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 290255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 290261 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 290263 */     GIR_RootConstrainSelectedInstOperands,
     /* 290264 */     // GIR_Coverage, 4810,
     /* 290264 */     GIR_EraseRootFromParent_Done,
     /* 290265 */   // Label 5999: @290265
     /* 290265 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(290306), // Rule ID 13876 //
     /* 290270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290293 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 290293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 290296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 290302 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 290304 */     GIR_RootConstrainSelectedInstOperands,
     /* 290305 */     // GIR_Coverage, 13876,
     /* 290305 */     GIR_EraseRootFromParent_Done,
     /* 290306 */   // Label 6000: @290306
     /* 290306 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(290333), // Rule ID 624 //
     /* 290311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290322 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 290322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 290327 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 290331 */     GIR_RootConstrainSelectedInstOperands,
     /* 290332 */     // GIR_Coverage, 624,
     /* 290332 */     GIR_Done,
     /* 290333 */   // Label 6001: @290333
     /* 290333 */   GIM_Reject,
     /* 290334 */ // Label 5992: @290334
     /* 290334 */ GIM_Reject,
     /* 290335 */ // Label 5963: @290335
     /* 290335 */ GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(290864),
     /* 290340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 290343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 290346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290350 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(290436), // Rule ID 13477 //
     /* 290355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 290366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290399 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290403 */     // MIs[3] Operand 1
     /* 290403 */     // No operand predicates
     /* 290403 */     // MIs[1] Operand 2
     /* 290403 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 290414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290420 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290434 */     GIR_RootConstrainSelectedInstOperands,
     /* 290435 */     // GIR_Coverage, 13477,
     /* 290435 */     GIR_EraseRootFromParent_Done,
     /* 290436 */   // Label 6003: @290436
     /* 290436 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(290522), // Rule ID 2005 //
     /* 290441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 290456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290493 */     // MIs[3] Operand 1
     /* 290493 */     // No operand predicates
     /* 290493 */     // MIs[1] Operand 2
     /* 290493 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 290504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290506 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290520 */     GIR_RootConstrainSelectedInstOperands,
     /* 290521 */     // GIR_Coverage, 2005,
     /* 290521 */     GIR_EraseRootFromParent_Done,
     /* 290522 */   // Label 6004: @290522
     /* 290522 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(290585), // Rule ID 13478 //
     /* 290527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290559 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290563 */     // MIs[2] Operand 1
     /* 290563 */     // No operand predicates
     /* 290563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290569 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290583 */     GIR_RootConstrainSelectedInstOperands,
     /* 290584 */     // GIR_Coverage, 13478,
     /* 290584 */     GIR_EraseRootFromParent_Done,
     /* 290585 */   // Label 6005: @290585
     /* 290585 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(290648), // Rule ID 2006 //
     /* 290590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290626 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290630 */     // MIs[2] Operand 1
     /* 290630 */     // No operand predicates
     /* 290630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290632 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290646 */     GIR_RootConstrainSelectedInstOperands,
     /* 290647 */     // GIR_Coverage, 2006,
     /* 290647 */     GIR_EraseRootFromParent_Done,
     /* 290648 */   // Label 6006: @290648
     /* 290648 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(290742), // Rule ID 13941 //
     /* 290653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290676 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290676 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 290679 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 290683 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 290690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 290693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 290697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290702 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 290705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290709 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 290712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290740 */     GIR_RootConstrainSelectedInstOperands,
     /* 290741 */     // GIR_Coverage, 13941,
     /* 290741 */     GIR_EraseRootFromParent_Done,
     /* 290742 */   // Label 6007: @290742
     /* 290742 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(290836), // Rule ID 6259 //
     /* 290747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290770 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 290773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 290777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 290784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 290787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 290791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290796 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 290799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 290806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 290824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290834 */     GIR_RootConstrainSelectedInstOperands,
     /* 290835 */     // GIR_Coverage, 6259,
     /* 290835 */     GIR_EraseRootFromParent_Done,
     /* 290836 */   // Label 6008: @290836
     /* 290836 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(290863), // Rule ID 1323 //
     /* 290841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290852 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 290852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 290857 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 290861 */     GIR_RootConstrainSelectedInstOperands,
     /* 290862 */     // GIR_Coverage, 1323,
     /* 290862 */     GIR_Done,
     /* 290863 */   // Label 6009: @290863
     /* 290863 */   GIM_Reject,
     /* 290864 */ // Label 6002: @290864
     /* 290864 */ GIM_Reject,
     /* 290865 */ // Label 5964: @290865
     /* 290865 */ GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(291222),
     /* 290870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 290876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290880 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(290943), // Rule ID 13482 //
     /* 290885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290921 */     // MIs[2] Operand 1
     /* 290921 */     // No operand predicates
     /* 290921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290927 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 290930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290941 */     GIR_RootConstrainSelectedInstOperands,
     /* 290942 */     // GIR_Coverage, 13482,
     /* 290942 */     GIR_EraseRootFromParent_Done,
     /* 290943 */   // Label 6011: @290943
     /* 290943 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(291006), // Rule ID 2010 //
     /* 290948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290988 */     // MIs[2] Operand 1
     /* 290988 */     // No operand predicates
     /* 290988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290990 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 290993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291004 */     GIR_RootConstrainSelectedInstOperands,
     /* 291005 */     // GIR_Coverage, 2010,
     /* 291005 */     GIR_EraseRootFromParent_Done,
     /* 291006 */   // Label 6012: @291006
     /* 291006 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(291100), // Rule ID 13945 //
     /* 291011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291034 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 291037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 291041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 291048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 291051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 291055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 291063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 291088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291098 */     GIR_RootConstrainSelectedInstOperands,
     /* 291099 */     // GIR_Coverage, 13945,
     /* 291099 */     GIR_EraseRootFromParent_Done,
     /* 291100 */   // Label 6013: @291100
     /* 291100 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(291194), // Rule ID 6263 //
     /* 291105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291128 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291128 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 291131 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 291135 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 291142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 291145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 291149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291154 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 291157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291161 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 291182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291192 */     GIR_RootConstrainSelectedInstOperands,
     /* 291193 */     // GIR_Coverage, 6263,
     /* 291193 */     GIR_EraseRootFromParent_Done,
     /* 291194 */   // Label 6014: @291194
     /* 291194 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(291221), // Rule ID 1327 //
     /* 291199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291210 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 291215 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 291219 */     GIR_RootConstrainSelectedInstOperands,
     /* 291220 */     // GIR_Coverage, 1327,
     /* 291220 */     GIR_Done,
     /* 291221 */   // Label 6015: @291221
     /* 291221 */   GIM_Reject,
     /* 291222 */ // Label 6010: @291222
     /* 291222 */ GIM_Reject,
     /* 291223 */ // Label 5965: @291223
     /* 291223 */ GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(291564),
     /* 291228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 291234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291238 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(291324), // Rule ID 13471 //
     /* 291243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 291254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291287 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291291 */     // MIs[3] Operand 1
     /* 291291 */     // No operand predicates
     /* 291291 */     // MIs[1] Operand 2
     /* 291291 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 291302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291308 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 291311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291322 */     GIR_RootConstrainSelectedInstOperands,
     /* 291323 */     // GIR_Coverage, 13471,
     /* 291323 */     GIR_EraseRootFromParent_Done,
     /* 291324 */   // Label 6017: @291324
     /* 291324 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(291410), // Rule ID 1999 //
     /* 291329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 291344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291377 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291381 */     // MIs[3] Operand 1
     /* 291381 */     // No operand predicates
     /* 291381 */     // MIs[1] Operand 2
     /* 291381 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 291392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291394 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 291397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291408 */     GIR_RootConstrainSelectedInstOperands,
     /* 291409 */     // GIR_Coverage, 1999,
     /* 291409 */     GIR_EraseRootFromParent_Done,
     /* 291410 */   // Label 6018: @291410
     /* 291410 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(291473), // Rule ID 13472 //
     /* 291415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291451 */     // MIs[2] Operand 1
     /* 291451 */     // No operand predicates
     /* 291451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291457 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 291460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291471 */     GIR_RootConstrainSelectedInstOperands,
     /* 291472 */     // GIR_Coverage, 13472,
     /* 291472 */     GIR_EraseRootFromParent_Done,
     /* 291473 */   // Label 6019: @291473
     /* 291473 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(291536), // Rule ID 2000 //
     /* 291478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291518 */     // MIs[2] Operand 1
     /* 291518 */     // No operand predicates
     /* 291518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291520 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 291523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291534 */     GIR_RootConstrainSelectedInstOperands,
     /* 291535 */     // GIR_Coverage, 2000,
     /* 291535 */     GIR_EraseRootFromParent_Done,
     /* 291536 */   // Label 6020: @291536
     /* 291536 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(291563), // Rule ID 1319 //
     /* 291541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291552 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 291552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 291557 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 291561 */     GIR_RootConstrainSelectedInstOperands,
     /* 291562 */     // GIR_Coverage, 1319,
     /* 291562 */     GIR_Done,
     /* 291563 */   // Label 6021: @291563
     /* 291563 */   GIM_Reject,
     /* 291564 */ // Label 6016: @291564
     /* 291564 */ GIM_Reject,
     /* 291565 */ // Label 5966: @291565
     /* 291565 */ GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(291922),
     /* 291570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 291576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291580 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(291643), // Rule ID 13480 //
     /* 291585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291617 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291621 */     // MIs[2] Operand 1
     /* 291621 */     // No operand predicates
     /* 291621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291627 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 291630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291641 */     GIR_RootConstrainSelectedInstOperands,
     /* 291642 */     // GIR_Coverage, 13480,
     /* 291642 */     GIR_EraseRootFromParent_Done,
     /* 291643 */   // Label 6023: @291643
     /* 291643 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(291706), // Rule ID 2008 //
     /* 291648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291684 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291688 */     // MIs[2] Operand 1
     /* 291688 */     // No operand predicates
     /* 291688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291690 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 291693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291704 */     GIR_RootConstrainSelectedInstOperands,
     /* 291705 */     // GIR_Coverage, 2008,
     /* 291705 */     GIR_EraseRootFromParent_Done,
     /* 291706 */   // Label 6024: @291706
     /* 291706 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(291800), // Rule ID 13943 //
     /* 291711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291734 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291734 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 291737 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 291741 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 291748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 291751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 291755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291760 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 291763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291767 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 291770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 291788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291798 */     GIR_RootConstrainSelectedInstOperands,
     /* 291799 */     // GIR_Coverage, 13943,
     /* 291799 */     GIR_EraseRootFromParent_Done,
     /* 291800 */   // Label 6025: @291800
     /* 291800 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(291894), // Rule ID 6261 //
     /* 291805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291828 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291828 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 291831 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 291835 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 291842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 291845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 291849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291854 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 291857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291861 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 291864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 291882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291892 */     GIR_RootConstrainSelectedInstOperands,
     /* 291893 */     // GIR_Coverage, 6261,
     /* 291893 */     GIR_EraseRootFromParent_Done,
     /* 291894 */   // Label 6026: @291894
     /* 291894 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(291921), // Rule ID 1325 //
     /* 291899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291910 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 291910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 291915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 291919 */     GIR_RootConstrainSelectedInstOperands,
     /* 291920 */     // GIR_Coverage, 1325,
     /* 291920 */     GIR_Done,
     /* 291921 */   // Label 6027: @291921
     /* 291921 */   GIM_Reject,
     /* 291922 */ // Label 6022: @291922
     /* 291922 */ GIM_Reject,
     /* 291923 */ // Label 5967: @291923
     /* 291923 */ GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(292354),
     /* 291928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 291934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291938 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(292001), // Rule ID 13474 //
     /* 291943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291975 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291979 */     // MIs[2] Operand 1
     /* 291979 */     // No operand predicates
     /* 291979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291985 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 291985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 291988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291999 */     GIR_RootConstrainSelectedInstOperands,
     /* 292000 */     // GIR_Coverage, 13474,
     /* 292000 */     GIR_EraseRootFromParent_Done,
     /* 292001 */   // Label 6029: @292001
     /* 292001 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(292064), // Rule ID 2002 //
     /* 292006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 292021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292042 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292046 */     // MIs[2] Operand 1
     /* 292046 */     // No operand predicates
     /* 292046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292048 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 292048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 292051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292062 */     GIR_RootConstrainSelectedInstOperands,
     /* 292063 */     // GIR_Coverage, 2002,
     /* 292063 */     GIR_EraseRootFromParent_Done,
     /* 292064 */   // Label 6030: @292064
     /* 292064 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(292091), // Rule ID 1321 //
     /* 292069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292080 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 292080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 292085 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 292089 */     GIR_RootConstrainSelectedInstOperands,
     /* 292090 */     // GIR_Coverage, 1321,
     /* 292090 */     GIR_Done,
     /* 292091 */   // Label 6031: @292091
     /* 292091 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(292353), // Rule ID 7016 //
     /* 292096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 292099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292107 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 292107 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 292110 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 292114 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292119 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 292123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 292125 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 292128 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 292132 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292137 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 292141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 292143 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 292146 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 292150 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292155 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 292158 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 292161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 292163 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 292166 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292170 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292175 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 292181 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292186 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292191 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 292194 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 292198 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292203 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 292206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 292208 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 292211 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292215 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292220 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292226 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292231 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292236 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 292239 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 292243 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292248 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 292251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 292253 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 292256 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 292260 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292265 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 292268 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 292271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 292273 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 292276 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 292280 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292285 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 292288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 292290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 292293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 292297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 292304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 292307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 292311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 292319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 292322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 292325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 292343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 292351 */     GIR_RootConstrainSelectedInstOperands,
     /* 292352 */     // GIR_Coverage, 7016,
     /* 292352 */     GIR_EraseRootFromParent_Done,
     /* 292353 */   // Label 6032: @292353
     /* 292353 */   GIM_Reject,
     /* 292354 */ // Label 6028: @292354
     /* 292354 */ GIM_Reject,
     /* 292355 */ // Label 5968: @292355
     /* 292355 */ GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(292380), // Rule ID 8224 //
     /* 292360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 292363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 292366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 292369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 292373 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 292373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 292378 */   GIR_RootConstrainSelectedInstOperands,
     /* 292379 */   // GIR_Coverage, 8224,
     /* 292379 */   GIR_Done,
     /* 292380 */ // Label 6033: @292380
     /* 292380 */ GIM_Reject,
     /* 292381 */ // Label 5969: @292381
     /* 292381 */ GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(292406), // Rule ID 8222 //
     /* 292386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 292389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 292392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 292395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 292399 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 292399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 292404 */   GIR_RootConstrainSelectedInstOperands,
     /* 292405 */   // GIR_Coverage, 8222,
     /* 292405 */   GIR_Done,
     /* 292406 */ // Label 6034: @292406
     /* 292406 */ GIM_Reject,
     /* 292407 */ // Label 5970: @292407
     /* 292407 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(292432), // Rule ID 8220 //
     /* 292412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 292415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 292418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 292421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 292425 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 292425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 292430 */   GIR_RootConstrainSelectedInstOperands,
     /* 292431 */   // GIR_Coverage, 8220,
     /* 292431 */   GIR_Done,
     /* 292432 */ // Label 6035: @292432
     /* 292432 */ GIM_Reject,
     /* 292433 */ // Label 5971: @292433
     /* 292433 */ GIM_Reject,
     /* 292434 */ // Label 62: @292434
     /* 292434 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6044*/ GIMT_Encode4(308706),
     /* 292445 */ /*GILLT_s16*//*Label 6036*/ GIMT_Encode4(292485),
     /* 292449 */ /*GILLT_s32*//*Label 6037*/ GIMT_Encode4(295489),
     /* 292453 */ /*GILLT_s64*//*Label 6038*/ GIMT_Encode4(298637), GIMT_Encode4(0),
     /* 292461 */ /*GILLT_v2s32*//*Label 6039*/ GIMT_Encode4(301785),
     /* 292465 */ /*GILLT_v2s64*//*Label 6040*/ GIMT_Encode4(303306),
     /* 292469 */ /*GILLT_v4s16*//*Label 6041*/ GIMT_Encode4(304827),
     /* 292473 */ /*GILLT_v4s32*//*Label 6042*/ GIMT_Encode4(306006), GIMT_Encode4(0),
     /* 292481 */ /*GILLT_v8s16*//*Label 6043*/ GIMT_Encode4(307527),
     /* 292485 */ // Label 6036: @292485
     /* 292485 */ GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(295488),
     /* 292490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 292493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 292496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 292499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292503 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(292653), // Rule ID 4865 //
     /* 292508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292557 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 292565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292569 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 292573 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292580 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 292583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292592 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292603 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292620 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 292639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 292651 */     GIR_RootConstrainSelectedInstOperands,
     /* 292652 */     // GIR_Coverage, 4865,
     /* 292652 */     GIR_EraseRootFromParent_Done,
     /* 292653 */   // Label 6046: @292653
     /* 292653 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(292800), // Rule ID 4829 //
     /* 292658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292682 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 292702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292706 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292710 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292714 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292719 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292729 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292729 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 292732 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292736 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292741 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292752 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292769 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292798 */     GIR_RootConstrainSelectedInstOperands,
     /* 292799 */     // GIR_Coverage, 4829,
     /* 292799 */     GIR_EraseRootFromParent_Done,
     /* 292800 */   // Label 6047: @292800
     /* 292800 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(292947), // Rule ID 13882 //
     /* 292805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292841 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292853 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292857 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292861 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292866 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292876 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292876 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 292879 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292883 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292888 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292916 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292945 */     GIR_RootConstrainSelectedInstOperands,
     /* 292946 */     // GIR_Coverage, 13882,
     /* 292946 */     GIR_EraseRootFromParent_Done,
     /* 292947 */   // Label 6048: @292947
     /* 292947 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(293078), // Rule ID 6091 //
     /* 292952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292976 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 292996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293000 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293004 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293008 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293013 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293017 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293021 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293025 */     // MIs[4] Operand 1
     /* 293025 */     // No operand predicates
     /* 293025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293029 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293031 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293043 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293076 */     GIR_RootConstrainSelectedInstOperands,
     /* 293077 */     // GIR_Coverage, 6091,
     /* 293077 */     GIR_EraseRootFromParent_Done,
     /* 293078 */   // Label 6049: @293078
     /* 293078 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(293209), // Rule ID 6123 //
     /* 293083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293115 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293119 */     // MIs[2] Operand 1
     /* 293119 */     // No operand predicates
     /* 293119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 293131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 293135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293139 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293143 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293147 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293152 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293160 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293162 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293207 */     GIR_RootConstrainSelectedInstOperands,
     /* 293208 */     // GIR_Coverage, 6123,
     /* 293208 */     GIR_EraseRootFromParent_Done,
     /* 293209 */   // Label 6050: @293209
     /* 293209 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(293340), // Rule ID 6187 //
     /* 293214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293250 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293270 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293275 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293279 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293283 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293287 */     // MIs[4] Operand 1
     /* 293287 */     // No operand predicates
     /* 293287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293291 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293293 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293305 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293338 */     GIR_RootConstrainSelectedInstOperands,
     /* 293339 */     // GIR_Coverage, 6187,
     /* 293339 */     GIR_EraseRootFromParent_Done,
     /* 293340 */   // Label 6051: @293340
     /* 293340 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(293471), // Rule ID 6155 //
     /* 293345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293389 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293393 */     // MIs[3] Operand 1
     /* 293393 */     // No operand predicates
     /* 293393 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 293397 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293401 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293405 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293409 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293414 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293422 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293424 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293436 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293469 */     GIR_RootConstrainSelectedInstOperands,
     /* 293470 */     // GIR_Coverage, 6155,
     /* 293470 */     GIR_EraseRootFromParent_Done,
     /* 293471 */   // Label 6052: @293471
     /* 293471 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(293606), // Rule ID 2456 //
     /* 293476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293500 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293525 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293535 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 293535 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 293538 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293542 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293547 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 293553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293575 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 293594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293604 */     GIR_RootConstrainSelectedInstOperands,
     /* 293605 */     // GIR_Coverage, 2456,
     /* 293605 */     GIR_EraseRootFromParent_Done,
     /* 293606 */   // Label 6053: @293606
     /* 293606 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(293725), // Rule ID 6059 //
     /* 293611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293635 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293668 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293672 */     // MIs[3] Operand 1
     /* 293672 */     // No operand predicates
     /* 293672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293678 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293690 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 293709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293723 */     GIR_RootConstrainSelectedInstOperands,
     /* 293724 */     // GIR_Coverage, 6059,
     /* 293724 */     GIR_EraseRootFromParent_Done,
     /* 293725 */   // Label 6054: @293725
     /* 293725 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(293844), // Rule ID 2538 //
     /* 293730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293762 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293766 */     // MIs[2] Operand 1
     /* 293766 */     // No operand predicates
     /* 293766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293778 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293782 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293787 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293797 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293809 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 293828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293842 */     GIR_RootConstrainSelectedInstOperands,
     /* 293843 */     // GIR_Coverage, 2538,
     /* 293843 */     GIR_EraseRootFromParent_Done,
     /* 293844 */   // Label 6055: @293844
     /* 293844 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(293944), // Rule ID 4827 //
     /* 293849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293873 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 293889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293900 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293912 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293942 */     GIR_RootConstrainSelectedInstOperands,
     /* 293943 */     // GIR_Coverage, 4827,
     /* 293943 */     GIR_EraseRootFromParent_Done,
     /* 293944 */   // Label 6056: @293944
     /* 293944 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(294044), // Rule ID 4863 //
     /* 293949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293973 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 293985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 293993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294000 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 294000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294012 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 294018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 294031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294042 */     GIR_RootConstrainSelectedInstOperands,
     /* 294043 */     // GIR_Coverage, 4863,
     /* 294043 */     GIR_EraseRootFromParent_Done,
     /* 294044 */   // Label 6057: @294044
     /* 294044 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(294141), // Rule ID 13878 //
     /* 294049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294085 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294099 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 294099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294111 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 294117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 294130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294139 */     GIR_RootConstrainSelectedInstOperands,
     /* 294140 */     // GIR_Coverage, 13878,
     /* 294140 */     GIR_EraseRootFromParent_Done,
     /* 294141 */   // Label 6058: @294141
     /* 294141 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(294241), // Rule ID 13880 //
     /* 294146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294187 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294197 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 294197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294209 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 294215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 294228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294239 */     GIR_RootConstrainSelectedInstOperands,
     /* 294240 */     // GIR_Coverage, 13880,
     /* 294240 */     GIR_EraseRootFromParent_Done,
     /* 294241 */   // Label 6059: @294241
     /* 294241 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(294341), // Rule ID 4861 //
     /* 294246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294274 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294297 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 294297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294309 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 294315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 294328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294339 */     GIR_RootConstrainSelectedInstOperands,
     /* 294340 */     // GIR_Coverage, 4861,
     /* 294340 */     GIR_EraseRootFromParent_Done,
     /* 294341 */   // Label 6060: @294341
     /* 294341 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(294438), // Rule ID 4825 //
     /* 294346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294396 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 294396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294408 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 294414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 294427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294436 */     GIR_RootConstrainSelectedInstOperands,
     /* 294437 */     // GIR_Coverage, 4825,
     /* 294437 */     GIR_EraseRootFromParent_Done,
     /* 294438 */   // Label 6061: @294438
     /* 294438 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(294522), // Rule ID 6121 //
     /* 294443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294479 */     // MIs[2] Operand 1
     /* 294479 */     // No operand predicates
     /* 294479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294487 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 294491 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294502 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 294505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294520 */     GIR_RootConstrainSelectedInstOperands,
     /* 294521 */     // GIR_Coverage, 6121,
     /* 294521 */     GIR_EraseRootFromParent_Done,
     /* 294522 */   // Label 6062: @294522
     /* 294522 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(294603), // Rule ID 6153 //
     /* 294527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294571 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294575 */     // MIs[3] Operand 1
     /* 294575 */     // No operand predicates
     /* 294575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294585 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 294588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294601 */     GIR_RootConstrainSelectedInstOperands,
     /* 294602 */     // GIR_Coverage, 6153,
     /* 294602 */     GIR_EraseRootFromParent_Done,
     /* 294603 */   // Label 6063: @294603
     /* 294603 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(294687), // Rule ID 6185 //
     /* 294608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294657 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294661 */     // MIs[3] Operand 1
     /* 294661 */     // No operand predicates
     /* 294661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294667 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 294670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294685 */     GIR_RootConstrainSelectedInstOperands,
     /* 294686 */     // GIR_Coverage, 6185,
     /* 294686 */     GIR_EraseRootFromParent_Done,
     /* 294687 */   // Label 6064: @294687
     /* 294687 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(294768), // Rule ID 6089 //
     /* 294692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294740 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294744 */     // MIs[3] Operand 1
     /* 294744 */     // No operand predicates
     /* 294744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294750 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 294753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294766 */     GIR_RootConstrainSelectedInstOperands,
     /* 294767 */     // GIR_Coverage, 6089,
     /* 294767 */     GIR_EraseRootFromParent_Done,
     /* 294768 */   // Label 6065: @294768
     /* 294768 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(294853), // Rule ID 2454 //
     /* 294773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294797 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294811 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 294811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294823 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 294829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 294842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294851 */     GIR_RootConstrainSelectedInstOperands,
     /* 294852 */     // GIR_Coverage, 2454,
     /* 294852 */     GIR_EraseRootFromParent_Done,
     /* 294853 */   // Label 6066: @294853
     /* 294853 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(294938), // Rule ID 2452 //
     /* 294858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 294861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294896 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 294896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294908 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 294914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 294927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294936 */     GIR_RootConstrainSelectedInstOperands,
     /* 294937 */     // GIR_Coverage, 2452,
     /* 294937 */     GIR_EraseRootFromParent_Done,
     /* 294938 */   // Label 6067: @294938
     /* 294938 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(295007), // Rule ID 2536 //
     /* 294943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294975 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294979 */     // MIs[2] Operand 1
     /* 294979 */     // No operand predicates
     /* 294979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 294987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294989 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 294992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295005 */     GIR_RootConstrainSelectedInstOperands,
     /* 295006 */     // GIR_Coverage, 2536,
     /* 295006 */     GIR_EraseRootFromParent_Done,
     /* 295007 */   // Label 6068: @295007
     /* 295007 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(295076), // Rule ID 6057 //
     /* 295012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 295040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295048 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 295052 */     // MIs[2] Operand 1
     /* 295052 */     // No operand predicates
     /* 295052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295058 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 295058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 295061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295074 */     GIR_RootConstrainSelectedInstOperands,
     /* 295075 */     // GIR_Coverage, 6057,
     /* 295075 */     GIR_EraseRootFromParent_Done,
     /* 295076 */   // Label 6069: @295076
     /* 295076 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(295141), // Rule ID 4881 //
     /* 295081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 295117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295124 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 295127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295139 */     GIR_RootConstrainSelectedInstOperands,
     /* 295140 */     // GIR_Coverage, 4881,
     /* 295140 */     GIR_EraseRootFromParent_Done,
     /* 295141 */   // Label 6070: @295141
     /* 295141 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(295206), // Rule ID 13898 //
     /* 295146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 295182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295189 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 295192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295204 */     GIR_RootConstrainSelectedInstOperands,
     /* 295205 */     // GIR_Coverage, 13898,
     /* 295205 */     GIR_EraseRootFromParent_Done,
     /* 295206 */   // Label 6071: @295206
     /* 295206 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(295256), // Rule ID 4878 //
     /* 295211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295241 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 295244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295254 */     GIR_RootConstrainSelectedInstOperands,
     /* 295255 */     // GIR_Coverage, 4878,
     /* 295255 */     GIR_EraseRootFromParent_Done,
     /* 295256 */   // Label 6072: @295256
     /* 295256 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(295306), // Rule ID 13324 //
     /* 295261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295291 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 295294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295304 */     GIR_RootConstrainSelectedInstOperands,
     /* 295305 */     // GIR_Coverage, 13324,
     /* 295305 */     GIR_EraseRootFromParent_Done,
     /* 295306 */   // Label 6073: @295306
     /* 295306 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(295356), // Rule ID 644 //
     /* 295311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295341 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 295344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295354 */     GIR_RootConstrainSelectedInstOperands,
     /* 295355 */     // GIR_Coverage, 644,
     /* 295355 */     GIR_EraseRootFromParent_Done,
     /* 295356 */   // Label 6074: @295356
     /* 295356 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(295406), // Rule ID 13895 //
     /* 295361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295391 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 295394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295404 */     GIR_RootConstrainSelectedInstOperands,
     /* 295405 */     // GIR_Coverage, 13895,
     /* 295405 */     GIR_EraseRootFromParent_Done,
     /* 295406 */   // Label 6075: @295406
     /* 295406 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(295456), // Rule ID 656 //
     /* 295411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295441 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 295444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 295454 */     GIR_RootConstrainSelectedInstOperands,
     /* 295455 */     // GIR_Coverage, 656,
     /* 295455 */     GIR_EraseRootFromParent_Done,
     /* 295456 */   // Label 6076: @295456
     /* 295456 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(295487), // Rule ID 638 //
     /* 295461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295476 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 295476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 295481 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295485 */     GIR_RootConstrainSelectedInstOperands,
     /* 295486 */     // GIR_Coverage, 638,
     /* 295486 */     GIR_Done,
     /* 295487 */   // Label 6077: @295487
     /* 295487 */   GIM_Reject,
     /* 295488 */ // Label 6045: @295488
     /* 295488 */ GIM_Reject,
     /* 295489 */ // Label 6037: @295489
     /* 295489 */ GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(298636),
     /* 295494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 295497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 295503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295507 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(295657), // Rule ID 4871 //
     /* 295512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295536 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295561 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 295569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 295577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295584 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 295587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295596 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295624 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 295643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 295651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 295655 */     GIR_RootConstrainSelectedInstOperands,
     /* 295656 */     // GIR_Coverage, 4871,
     /* 295656 */     GIR_EraseRootFromParent_Done,
     /* 295657 */   // Label 6079: @295657
     /* 295657 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(295804), // Rule ID 4835 //
     /* 295662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 295706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295714 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 295718 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295723 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 295727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295733 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 295736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295745 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295773 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 295800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295802 */     GIR_RootConstrainSelectedInstOperands,
     /* 295803 */     // GIR_Coverage, 4835,
     /* 295803 */     GIR_EraseRootFromParent_Done,
     /* 295804 */   // Label 6080: @295804
     /* 295804 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(295951), // Rule ID 13888 //
     /* 295809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295845 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 295853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295857 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295861 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 295865 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295870 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 295874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295880 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295880 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 295883 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295887 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295892 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295920 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 295947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295949 */     GIR_RootConstrainSelectedInstOperands,
     /* 295950 */     // GIR_Coverage, 13888,
     /* 295950 */     GIR_EraseRootFromParent_Done,
     /* 295951 */   // Label 6081: @295951
     /* 295951 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(296082), // Rule ID 6107 //
     /* 295956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295980 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296004 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296008 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296012 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296017 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296021 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296025 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296029 */     // MIs[4] Operand 1
     /* 296029 */     // No operand predicates
     /* 296029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296033 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296035 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296047 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296080 */     GIR_RootConstrainSelectedInstOperands,
     /* 296081 */     // GIR_Coverage, 6107,
     /* 296081 */     GIR_EraseRootFromParent_Done,
     /* 296082 */   // Label 6082: @296082
     /* 296082 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(296213), // Rule ID 6139 //
     /* 296087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296123 */     // MIs[2] Operand 1
     /* 296123 */     // No operand predicates
     /* 296123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 296135 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 296139 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296143 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296147 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296151 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296156 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296164 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296166 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296211 */     GIR_RootConstrainSelectedInstOperands,
     /* 296212 */     // GIR_Coverage, 6139,
     /* 296212 */     GIR_EraseRootFromParent_Done,
     /* 296213 */   // Label 6083: @296213
     /* 296213 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(296344), // Rule ID 6203 //
     /* 296218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296254 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296291 */     // MIs[4] Operand 1
     /* 296291 */     // No operand predicates
     /* 296291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296295 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296297 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296309 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296342 */     GIR_RootConstrainSelectedInstOperands,
     /* 296343 */     // GIR_Coverage, 6203,
     /* 296343 */     GIR_EraseRootFromParent_Done,
     /* 296344 */   // Label 6084: @296344
     /* 296344 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(296475), // Rule ID 6171 //
     /* 296349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296393 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296397 */     // MIs[3] Operand 1
     /* 296397 */     // No operand predicates
     /* 296397 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 296401 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296405 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296409 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296413 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296418 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296426 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296428 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296440 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296473 */     GIR_RootConstrainSelectedInstOperands,
     /* 296474 */     // GIR_Coverage, 6171,
     /* 296474 */     GIR_EraseRootFromParent_Done,
     /* 296475 */   // Label 6085: @296475
     /* 296475 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(296610), // Rule ID 2462 //
     /* 296480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296529 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296539 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 296539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 296542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296551 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 296557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296562 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 296598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296608 */     GIR_RootConstrainSelectedInstOperands,
     /* 296609 */     // GIR_Coverage, 2462,
     /* 296609 */     GIR_EraseRootFromParent_Done,
     /* 296610 */   // Label 6086: @296610
     /* 296610 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(296729), // Rule ID 6075 //
     /* 296615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296639 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296672 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296676 */     // MIs[3] Operand 1
     /* 296676 */     // No operand predicates
     /* 296676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296682 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296694 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 296713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296727 */     GIR_RootConstrainSelectedInstOperands,
     /* 296728 */     // GIR_Coverage, 6075,
     /* 296728 */     GIR_EraseRootFromParent_Done,
     /* 296729 */   // Label 6087: @296729
     /* 296729 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(296848), // Rule ID 2554 //
     /* 296734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296766 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296770 */     // MIs[2] Operand 1
     /* 296770 */     // No operand predicates
     /* 296770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296782 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296786 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296791 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296801 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296813 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 296832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296846 */     GIR_RootConstrainSelectedInstOperands,
     /* 296847 */     // GIR_Coverage, 2554,
     /* 296847 */     GIR_EraseRootFromParent_Done,
     /* 296848 */   // Label 6088: @296848
     /* 296848 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(296948), // Rule ID 4833 //
     /* 296853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296877 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296904 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296916 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296946 */     GIR_RootConstrainSelectedInstOperands,
     /* 296947 */     // GIR_Coverage, 4833,
     /* 296947 */     GIR_EraseRootFromParent_Done,
     /* 296948 */   // Label 6089: @296948
     /* 296948 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(297048), // Rule ID 4869 //
     /* 296953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296977 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 296989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297004 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297016 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 297035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 297042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297046 */     GIR_RootConstrainSelectedInstOperands,
     /* 297047 */     // GIR_Coverage, 4869,
     /* 297047 */     GIR_EraseRootFromParent_Done,
     /* 297048 */   // Label 6090: @297048
     /* 297048 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(297145), // Rule ID 13884 //
     /* 297053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297103 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297115 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 297134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297143 */     GIR_RootConstrainSelectedInstOperands,
     /* 297144 */     // GIR_Coverage, 13884,
     /* 297144 */     GIR_EraseRootFromParent_Done,
     /* 297145 */   // Label 6091: @297145
     /* 297145 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(297245), // Rule ID 13886 //
     /* 297150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297191 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297201 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297213 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 297232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297243 */     GIR_RootConstrainSelectedInstOperands,
     /* 297244 */     // GIR_Coverage, 13886,
     /* 297244 */     GIR_EraseRootFromParent_Done,
     /* 297245 */   // Label 6092: @297245
     /* 297245 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(297345), // Rule ID 4867 //
     /* 297250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297278 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 297294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297301 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297313 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 297332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297343 */     GIR_RootConstrainSelectedInstOperands,
     /* 297344 */     // GIR_Coverage, 4867,
     /* 297344 */     GIR_EraseRootFromParent_Done,
     /* 297345 */   // Label 6093: @297345
     /* 297345 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(297442), // Rule ID 4831 //
     /* 297350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297390 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297400 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297412 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 297431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297440 */     GIR_RootConstrainSelectedInstOperands,
     /* 297441 */     // GIR_Coverage, 4831,
     /* 297441 */     GIR_EraseRootFromParent_Done,
     /* 297442 */   // Label 6094: @297442
     /* 297442 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(297520), // Rule ID 6225 //
     /* 297447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297488 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297492 */     // MIs[3] Operand 1
     /* 297492 */     // No operand predicates
     /* 297492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297502 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297518 */     GIR_RootConstrainSelectedInstOperands,
     /* 297519 */     // GIR_Coverage, 6225,
     /* 297519 */     GIR_EraseRootFromParent_Done,
     /* 297520 */   // Label 6095: @297520
     /* 297520 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(297604), // Rule ID 6137 //
     /* 297525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297561 */     // MIs[2] Operand 1
     /* 297561 */     // No operand predicates
     /* 297561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297569 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 297573 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297584 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 297595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297602 */     GIR_RootConstrainSelectedInstOperands,
     /* 297603 */     // GIR_Coverage, 6137,
     /* 297603 */     GIR_EraseRootFromParent_Done,
     /* 297604 */   // Label 6096: @297604
     /* 297604 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(297685), // Rule ID 6169 //
     /* 297609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297653 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297657 */     // MIs[3] Operand 1
     /* 297657 */     // No operand predicates
     /* 297657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297667 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297683 */     GIR_RootConstrainSelectedInstOperands,
     /* 297684 */     // GIR_Coverage, 6169,
     /* 297684 */     GIR_EraseRootFromParent_Done,
     /* 297685 */   // Label 6097: @297685
     /* 297685 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(297769), // Rule ID 6201 //
     /* 297690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297739 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297743 */     // MIs[3] Operand 1
     /* 297743 */     // No operand predicates
     /* 297743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297749 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297767 */     GIR_RootConstrainSelectedInstOperands,
     /* 297768 */     // GIR_Coverage, 6201,
     /* 297768 */     GIR_EraseRootFromParent_Done,
     /* 297769 */   // Label 6098: @297769
     /* 297769 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(297847), // Rule ID 6247 //
     /* 297774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297819 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297823 */     // MIs[3] Operand 1
     /* 297823 */     // No operand predicates
     /* 297823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297829 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297845 */     GIR_RootConstrainSelectedInstOperands,
     /* 297846 */     // GIR_Coverage, 6247,
     /* 297846 */     GIR_EraseRootFromParent_Done,
     /* 297847 */   // Label 6099: @297847
     /* 297847 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(297928), // Rule ID 6105 //
     /* 297852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297900 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297904 */     // MIs[3] Operand 1
     /* 297904 */     // No operand predicates
     /* 297904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297910 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 297913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297926 */     GIR_RootConstrainSelectedInstOperands,
     /* 297927 */     // GIR_Coverage, 6105,
     /* 297927 */     GIR_EraseRootFromParent_Done,
     /* 297928 */   // Label 6100: @297928
     /* 297928 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(298013), // Rule ID 2460 //
     /* 297933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297957 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297971 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297983 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 298002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298011 */     GIR_RootConstrainSelectedInstOperands,
     /* 298012 */     // GIR_Coverage, 2460,
     /* 298012 */     GIR_EraseRootFromParent_Done,
     /* 298013 */   // Label 6101: @298013
     /* 298013 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(298098), // Rule ID 2458 //
     /* 298018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298046 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298056 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 298056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 298059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298068 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 298074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 298087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298096 */     GIR_RootConstrainSelectedInstOperands,
     /* 298097 */     // GIR_Coverage, 2458,
     /* 298097 */     GIR_EraseRootFromParent_Done,
     /* 298098 */   // Label 6102: @298098
     /* 298098 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(298167), // Rule ID 2552 //
     /* 298103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298139 */     // MIs[2] Operand 1
     /* 298139 */     // No operand predicates
     /* 298139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298149 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 298152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298165 */     GIR_RootConstrainSelectedInstOperands,
     /* 298166 */     // GIR_Coverage, 2552,
     /* 298166 */     GIR_EraseRootFromParent_Done,
     /* 298167 */   // Label 6103: @298167
     /* 298167 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(298236), // Rule ID 6073 //
     /* 298172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298208 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298212 */     // MIs[2] Operand 1
     /* 298212 */     // No operand predicates
     /* 298212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298218 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 298221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298234 */     GIR_RootConstrainSelectedInstOperands,
     /* 298235 */     // GIR_Coverage, 6073,
     /* 298235 */     GIR_EraseRootFromParent_Done,
     /* 298236 */   // Label 6104: @298236
     /* 298236 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(298298), // Rule ID 4882 //
     /* 298241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 298274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298281 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298296 */     GIR_RootConstrainSelectedInstOperands,
     /* 298297 */     // GIR_Coverage, 4882,
     /* 298297 */     GIR_EraseRootFromParent_Done,
     /* 298298 */   // Label 6105: @298298
     /* 298298 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(298360), // Rule ID 13899 //
     /* 298303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 298336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298343 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298358 */     GIR_RootConstrainSelectedInstOperands,
     /* 298359 */     // GIR_Coverage, 13899,
     /* 298359 */     GIR_EraseRootFromParent_Done,
     /* 298360 */   // Label 6106: @298360
     /* 298360 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(298407), // Rule ID 4879 //
     /* 298365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298392 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 298395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298405 */     GIR_RootConstrainSelectedInstOperands,
     /* 298406 */     // GIR_Coverage, 4879,
     /* 298406 */     GIR_EraseRootFromParent_Done,
     /* 298407 */   // Label 6107: @298407
     /* 298407 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(298457), // Rule ID 13326 //
     /* 298412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298442 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 298445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298455 */     GIR_RootConstrainSelectedInstOperands,
     /* 298456 */     // GIR_Coverage, 13326,
     /* 298456 */     GIR_EraseRootFromParent_Done,
     /* 298457 */   // Label 6108: @298457
     /* 298457 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(298507), // Rule ID 646 //
     /* 298462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298492 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 298495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298505 */     GIR_RootConstrainSelectedInstOperands,
     /* 298506 */     // GIR_Coverage, 646,
     /* 298506 */     GIR_EraseRootFromParent_Done,
     /* 298507 */   // Label 6109: @298507
     /* 298507 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(298554), // Rule ID 13896 //
     /* 298512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298539 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 298542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298552 */     GIR_RootConstrainSelectedInstOperands,
     /* 298553 */     // GIR_Coverage, 13896,
     /* 298553 */     GIR_EraseRootFromParent_Done,
     /* 298554 */   // Label 6110: @298554
     /* 298554 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(298604), // Rule ID 658 //
     /* 298559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 298574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298589 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 298592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 298602 */     GIR_RootConstrainSelectedInstOperands,
     /* 298603 */     // GIR_Coverage, 658,
     /* 298603 */     GIR_EraseRootFromParent_Done,
     /* 298604 */   // Label 6111: @298604
     /* 298604 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(298635), // Rule ID 640 //
     /* 298609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298624 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 298629 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298633 */     GIR_RootConstrainSelectedInstOperands,
     /* 298634 */     // GIR_Coverage, 640,
     /* 298634 */     GIR_Done,
     /* 298635 */   // Label 6112: @298635
     /* 298635 */   GIM_Reject,
     /* 298636 */ // Label 6078: @298636
     /* 298636 */ GIM_Reject,
     /* 298637 */ // Label 6038: @298637
     /* 298637 */ GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(301784),
     /* 298642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 298651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298655 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(298805), // Rule ID 4877 //
     /* 298660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298684 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298709 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 298717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298721 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 298725 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298732 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298744 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298755 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298772 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 298791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 298803 */     GIR_RootConstrainSelectedInstOperands,
     /* 298804 */     // GIR_Coverage, 4877,
     /* 298804 */     GIR_EraseRootFromParent_Done,
     /* 298805 */   // Label 6114: @298805
     /* 298805 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(298952), // Rule ID 4841 //
     /* 298810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298834 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298858 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298862 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298866 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298871 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298881 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298893 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298921 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298950 */     GIR_RootConstrainSelectedInstOperands,
     /* 298951 */     // GIR_Coverage, 4841,
     /* 298951 */     GIR_EraseRootFromParent_Done,
     /* 298952 */   // Label 6115: @298952
     /* 298952 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(299099), // Rule ID 13894 //
     /* 298957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298993 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299005 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299009 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299013 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299018 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 299022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299028 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 299028 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299031 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299035 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299040 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299068 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 299095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299097 */     GIR_RootConstrainSelectedInstOperands,
     /* 299098 */     // GIR_Coverage, 13894,
     /* 299098 */     GIR_EraseRootFromParent_Done,
     /* 299099 */   // Label 6116: @299099
     /* 299099 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(299230), // Rule ID 6111 //
     /* 299104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299128 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 299132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 299144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299156 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299160 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299173 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299177 */     // MIs[4] Operand 1
     /* 299177 */     // No operand predicates
     /* 299177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299181 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299183 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299195 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299228 */     GIR_RootConstrainSelectedInstOperands,
     /* 299229 */     // GIR_Coverage, 6111,
     /* 299229 */     GIR_EraseRootFromParent_Done,
     /* 299230 */   // Label 6117: @299230
     /* 299230 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(299361), // Rule ID 6143 //
     /* 299235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299267 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299271 */     // MIs[2] Operand 1
     /* 299271 */     // No operand predicates
     /* 299271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299279 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 299283 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 299287 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299291 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299295 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 299299 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299304 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 299308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299312 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299314 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299326 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299359 */     GIR_RootConstrainSelectedInstOperands,
     /* 299360 */     // GIR_Coverage, 6143,
     /* 299360 */     GIR_EraseRootFromParent_Done,
     /* 299361 */   // Label 6118: @299361
     /* 299361 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(299492), // Rule ID 6207 //
     /* 299366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299402 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299422 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299431 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299435 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299439 */     // MIs[4] Operand 1
     /* 299439 */     // No operand predicates
     /* 299439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299443 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299445 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299457 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299490 */     GIR_RootConstrainSelectedInstOperands,
     /* 299491 */     // GIR_Coverage, 6207,
     /* 299491 */     GIR_EraseRootFromParent_Done,
     /* 299492 */   // Label 6119: @299492
     /* 299492 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(299623), // Rule ID 6175 //
     /* 299497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299545 */     // MIs[3] Operand 1
     /* 299545 */     // No operand predicates
     /* 299545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 299549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299553 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299557 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 299561 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299566 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 299570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299574 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299576 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299588 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299621 */     GIR_RootConstrainSelectedInstOperands,
     /* 299622 */     // GIR_Coverage, 6175,
     /* 299622 */     GIR_EraseRootFromParent_Done,
     /* 299623 */   // Label 6120: @299623
     /* 299623 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(299758), // Rule ID 2468 //
     /* 299628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299652 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 299656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299677 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299687 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 299687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299699 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299727 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 299746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 299754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299756 */     GIR_RootConstrainSelectedInstOperands,
     /* 299757 */     // GIR_Coverage, 2468,
     /* 299757 */     GIR_EraseRootFromParent_Done,
     /* 299758 */   // Label 6121: @299758
     /* 299758 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(299877), // Rule ID 6079 //
     /* 299763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299787 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 299791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299820 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299824 */     // MIs[3] Operand 1
     /* 299824 */     // No operand predicates
     /* 299824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299830 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299842 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 299861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299875 */     GIR_RootConstrainSelectedInstOperands,
     /* 299876 */     // GIR_Coverage, 6079,
     /* 299876 */     GIR_EraseRootFromParent_Done,
     /* 299877 */   // Label 6122: @299877
     /* 299877 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(299996), // Rule ID 2558 //
     /* 299882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299918 */     // MIs[2] Operand 1
     /* 299918 */     // No operand predicates
     /* 299918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299926 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299930 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299939 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 299943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299949 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299961 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 299980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299994 */     GIR_RootConstrainSelectedInstOperands,
     /* 299995 */     // GIR_Coverage, 2558,
     /* 299995 */     GIR_EraseRootFromParent_Done,
     /* 299996 */   // Label 6123: @299996
     /* 299996 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(300096), // Rule ID 4839 //
     /* 300001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 300029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 300041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300052 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300064 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300094 */     GIR_RootConstrainSelectedInstOperands,
     /* 300095 */     // GIR_Coverage, 4839,
     /* 300095 */     GIR_EraseRootFromParent_Done,
     /* 300096 */   // Label 6124: @300096
     /* 300096 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(300196), // Rule ID 4875 //
     /* 300101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300125 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 300129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 300137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 300145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300152 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300164 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 300183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 300190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 300194 */     GIR_RootConstrainSelectedInstOperands,
     /* 300195 */     // GIR_Coverage, 4875,
     /* 300195 */     GIR_EraseRootFromParent_Done,
     /* 300196 */   // Label 6125: @300196
     /* 300196 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(300293), // Rule ID 13890 //
     /* 300201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300237 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300251 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 300251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300263 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300291 */     GIR_RootConstrainSelectedInstOperands,
     /* 300292 */     // GIR_Coverage, 13890,
     /* 300292 */     GIR_EraseRootFromParent_Done,
     /* 300293 */   // Label 6126: @300293
     /* 300293 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(300393), // Rule ID 13892 //
     /* 300298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300339 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300349 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300361 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300391 */     GIR_RootConstrainSelectedInstOperands,
     /* 300392 */     // GIR_Coverage, 13892,
     /* 300392 */     GIR_EraseRootFromParent_Done,
     /* 300393 */   // Label 6127: @300393
     /* 300393 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(300493), // Rule ID 4873 //
     /* 300398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300426 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 300430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 300434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 300442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300449 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 300449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300461 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 300480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 300491 */     GIR_RootConstrainSelectedInstOperands,
     /* 300492 */     // GIR_Coverage, 4873,
     /* 300492 */     GIR_EraseRootFromParent_Done,
     /* 300493 */   // Label 6128: @300493
     /* 300493 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(300590), // Rule ID 4837 //
     /* 300498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300538 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300548 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 300548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 300551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300560 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300588 */     GIR_RootConstrainSelectedInstOperands,
     /* 300589 */     // GIR_Coverage, 4837,
     /* 300589 */     GIR_EraseRootFromParent_Done,
     /* 300590 */   // Label 6129: @300590
     /* 300590 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(300668), // Rule ID 6229 //
     /* 300595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300636 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300640 */     // MIs[3] Operand 1
     /* 300640 */     // No operand predicates
     /* 300640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300650 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300666 */     GIR_RootConstrainSelectedInstOperands,
     /* 300667 */     // GIR_Coverage, 6229,
     /* 300667 */     GIR_EraseRootFromParent_Done,
     /* 300668 */   // Label 6130: @300668
     /* 300668 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(300752), // Rule ID 6141 //
     /* 300673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300705 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300709 */     // MIs[2] Operand 1
     /* 300709 */     // No operand predicates
     /* 300709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 300713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300717 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 300721 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300732 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 300732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 300743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300750 */     GIR_RootConstrainSelectedInstOperands,
     /* 300751 */     // GIR_Coverage, 6141,
     /* 300751 */     GIR_EraseRootFromParent_Done,
     /* 300752 */   // Label 6131: @300752
     /* 300752 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(300833), // Rule ID 6173 //
     /* 300757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300801 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300805 */     // MIs[3] Operand 1
     /* 300805 */     // No operand predicates
     /* 300805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300815 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 300815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300831 */     GIR_RootConstrainSelectedInstOperands,
     /* 300832 */     // GIR_Coverage, 6173,
     /* 300832 */     GIR_EraseRootFromParent_Done,
     /* 300833 */   // Label 6132: @300833
     /* 300833 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(300917), // Rule ID 6205 //
     /* 300838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300887 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300891 */     // MIs[3] Operand 1
     /* 300891 */     // No operand predicates
     /* 300891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300897 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 300897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300915 */     GIR_RootConstrainSelectedInstOperands,
     /* 300916 */     // GIR_Coverage, 6205,
     /* 300916 */     GIR_EraseRootFromParent_Done,
     /* 300917 */   // Label 6133: @300917
     /* 300917 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(300995), // Rule ID 6251 //
     /* 300922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300967 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300971 */     // MIs[3] Operand 1
     /* 300971 */     // No operand predicates
     /* 300971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300977 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 300980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300993 */     GIR_RootConstrainSelectedInstOperands,
     /* 300994 */     // GIR_Coverage, 6251,
     /* 300994 */     GIR_EraseRootFromParent_Done,
     /* 300995 */   // Label 6134: @300995
     /* 300995 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(301076), // Rule ID 6109 //
     /* 301000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301048 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301052 */     // MIs[3] Operand 1
     /* 301052 */     // No operand predicates
     /* 301052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301058 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 301058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 301061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301074 */     GIR_RootConstrainSelectedInstOperands,
     /* 301075 */     // GIR_Coverage, 6109,
     /* 301075 */     GIR_EraseRootFromParent_Done,
     /* 301076 */   // Label 6135: @301076
     /* 301076 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(301161), // Rule ID 2466 //
     /* 301081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301105 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301119 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 301150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 301157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301159 */     GIR_RootConstrainSelectedInstOperands,
     /* 301160 */     // GIR_Coverage, 2466,
     /* 301160 */     GIR_EraseRootFromParent_Done,
     /* 301161 */   // Label 6136: @301161
     /* 301161 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(301246), // Rule ID 2464 //
     /* 301166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301194 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301204 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 301204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301216 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 301222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 301235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301244 */     GIR_RootConstrainSelectedInstOperands,
     /* 301245 */     // GIR_Coverage, 2464,
     /* 301245 */     GIR_EraseRootFromParent_Done,
     /* 301246 */   // Label 6137: @301246
     /* 301246 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(301315), // Rule ID 2556 //
     /* 301251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301283 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301287 */     // MIs[2] Operand 1
     /* 301287 */     // No operand predicates
     /* 301287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301297 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 301297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 301300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301313 */     GIR_RootConstrainSelectedInstOperands,
     /* 301314 */     // GIR_Coverage, 2556,
     /* 301314 */     GIR_EraseRootFromParent_Done,
     /* 301315 */   // Label 6138: @301315
     /* 301315 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(301384), // Rule ID 6077 //
     /* 301320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301360 */     // MIs[2] Operand 1
     /* 301360 */     // No operand predicates
     /* 301360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301366 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 301366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 301369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301382 */     GIR_RootConstrainSelectedInstOperands,
     /* 301383 */     // GIR_Coverage, 6077,
     /* 301383 */     GIR_EraseRootFromParent_Done,
     /* 301384 */   // Label 6139: @301384
     /* 301384 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(301446), // Rule ID 4883 //
     /* 301389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 301414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301429 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 301440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 301444 */     GIR_RootConstrainSelectedInstOperands,
     /* 301445 */     // GIR_Coverage, 4883,
     /* 301445 */     GIR_EraseRootFromParent_Done,
     /* 301446 */   // Label 6140: @301446
     /* 301446 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(301508), // Rule ID 13900 //
     /* 301451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 301476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301491 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 301502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 301506 */     GIR_RootConstrainSelectedInstOperands,
     /* 301507 */     // GIR_Coverage, 13900,
     /* 301507 */     GIR_EraseRootFromParent_Done,
     /* 301508 */   // Label 6141: @301508
     /* 301508 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(301555), // Rule ID 4880 //
     /* 301513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301540 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 301543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 301551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301553 */     GIR_RootConstrainSelectedInstOperands,
     /* 301554 */     // GIR_Coverage, 4880,
     /* 301554 */     GIR_EraseRootFromParent_Done,
     /* 301555 */   // Label 6142: @301555
     /* 301555 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(301605), // Rule ID 13328 //
     /* 301560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301590 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 301593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301603 */     GIR_RootConstrainSelectedInstOperands,
     /* 301604 */     // GIR_Coverage, 13328,
     /* 301604 */     GIR_EraseRootFromParent_Done,
     /* 301605 */   // Label 6143: @301605
     /* 301605 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(301655), // Rule ID 648 //
     /* 301610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301640 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 301643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301653 */     GIR_RootConstrainSelectedInstOperands,
     /* 301654 */     // GIR_Coverage, 648,
     /* 301654 */     GIR_EraseRootFromParent_Done,
     /* 301655 */   // Label 6144: @301655
     /* 301655 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(301702), // Rule ID 13897 //
     /* 301660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301687 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 301690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 301698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 301700 */     GIR_RootConstrainSelectedInstOperands,
     /* 301701 */     // GIR_Coverage, 13897,
     /* 301701 */     GIR_EraseRootFromParent_Done,
     /* 301702 */   // Label 6145: @301702
     /* 301702 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(301752), // Rule ID 660 //
     /* 301707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 301722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301737 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 301740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 301746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 301750 */     GIR_RootConstrainSelectedInstOperands,
     /* 301751 */     // GIR_Coverage, 660,
     /* 301751 */     GIR_EraseRootFromParent_Done,
     /* 301752 */   // Label 6146: @301752
     /* 301752 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(301783), // Rule ID 642 //
     /* 301757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301772 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 301777 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301781 */     GIR_RootConstrainSelectedInstOperands,
     /* 301782 */     // GIR_Coverage, 642,
     /* 301782 */     GIR_Done,
     /* 301783 */   // Label 6147: @301783
     /* 301783 */   GIM_Reject,
     /* 301784 */ // Label 6113: @301784
     /* 301784 */ GIM_Reject,
     /* 301785 */ // Label 6039: @301785
     /* 301785 */ GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(303305),
     /* 301790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301803 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(301881), // Rule ID 6209 //
     /* 301808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 301845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301849 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 301853 */     // MIs[3] Operand 1
     /* 301853 */     // No operand predicates
     /* 301853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301863 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301879 */     GIR_RootConstrainSelectedInstOperands,
     /* 301880 */     // GIR_Coverage, 6209,
     /* 301880 */     GIR_EraseRootFromParent_Done,
     /* 301881 */   // Label 6149: @301881
     /* 301881 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(301965), // Rule ID 6125 //
     /* 301886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301918 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 301922 */     // MIs[2] Operand 1
     /* 301922 */     // No operand predicates
     /* 301922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 301926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301945 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 301956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301963 */     GIR_RootConstrainSelectedInstOperands,
     /* 301964 */     // GIR_Coverage, 6125,
     /* 301964 */     GIR_EraseRootFromParent_Done,
     /* 301965 */   // Label 6150: @301965
     /* 301965 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(302046), // Rule ID 6157 //
     /* 301970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302018 */     // MIs[3] Operand 1
     /* 302018 */     // No operand predicates
     /* 302018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302028 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302044 */     GIR_RootConstrainSelectedInstOperands,
     /* 302045 */     // GIR_Coverage, 6157,
     /* 302045 */     GIR_EraseRootFromParent_Done,
     /* 302046 */   // Label 6151: @302046
     /* 302046 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(302130), // Rule ID 6189 //
     /* 302051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302100 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302104 */     // MIs[3] Operand 1
     /* 302104 */     // No operand predicates
     /* 302104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302110 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302128 */     GIR_RootConstrainSelectedInstOperands,
     /* 302129 */     // GIR_Coverage, 6189,
     /* 302129 */     GIR_EraseRootFromParent_Done,
     /* 302130 */   // Label 6152: @302130
     /* 302130 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(302208), // Rule ID 6231 //
     /* 302135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 302176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302184 */     // MIs[3] Operand 1
     /* 302184 */     // No operand predicates
     /* 302184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302190 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302206 */     GIR_RootConstrainSelectedInstOperands,
     /* 302207 */     // GIR_Coverage, 6231,
     /* 302207 */     GIR_EraseRootFromParent_Done,
     /* 302208 */   // Label 6153: @302208
     /* 302208 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(302289), // Rule ID 6093 //
     /* 302213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302261 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302265 */     // MIs[3] Operand 1
     /* 302265 */     // No operand predicates
     /* 302265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302271 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302287 */     GIR_RootConstrainSelectedInstOperands,
     /* 302288 */     // GIR_Coverage, 6093,
     /* 302288 */     GIR_EraseRootFromParent_Done,
     /* 302289 */   // Label 6154: @302289
     /* 302289 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(302358), // Rule ID 2540 //
     /* 302294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302326 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302330 */     // MIs[2] Operand 1
     /* 302330 */     // No operand predicates
     /* 302330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302340 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 302343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302356 */     GIR_RootConstrainSelectedInstOperands,
     /* 302357 */     // GIR_Coverage, 2540,
     /* 302357 */     GIR_EraseRootFromParent_Done,
     /* 302358 */   // Label 6155: @302358
     /* 302358 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(302427), // Rule ID 6061 //
     /* 302363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302399 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302403 */     // MIs[2] Operand 1
     /* 302403 */     // No operand predicates
     /* 302403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302409 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 302412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302425 */     GIR_RootConstrainSelectedInstOperands,
     /* 302426 */     // GIR_Coverage, 6061,
     /* 302426 */     GIR_EraseRootFromParent_Done,
     /* 302427 */   // Label 6156: @302427
     /* 302427 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(302520), // Rule ID 6213 //
     /* 302432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302471 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302483 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302490 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302518 */     GIR_RootConstrainSelectedInstOperands,
     /* 302519 */     // GIR_Coverage, 6213,
     /* 302519 */     GIR_EraseRootFromParent_Done,
     /* 302520 */   // Label 6157: @302520
     /* 302520 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(302619), // Rule ID 6127 //
     /* 302525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302568 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 302611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302617 */     GIR_RootConstrainSelectedInstOperands,
     /* 302618 */     // GIR_Coverage, 6127,
     /* 302618 */     GIR_EraseRootFromParent_Done,
     /* 302619 */   // Label 6158: @302619
     /* 302619 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(302715), // Rule ID 6159 //
     /* 302624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302666 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302713 */     GIR_RootConstrainSelectedInstOperands,
     /* 302714 */     // GIR_Coverage, 6159,
     /* 302714 */     GIR_EraseRootFromParent_Done,
     /* 302715 */   // Label 6159: @302715
     /* 302715 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(302814), // Rule ID 6191 //
     /* 302720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302763 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302812 */     GIR_RootConstrainSelectedInstOperands,
     /* 302813 */     // GIR_Coverage, 6191,
     /* 302813 */     GIR_EraseRootFromParent_Done,
     /* 302814 */   // Label 6160: @302814
     /* 302814 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(302907), // Rule ID 6235 //
     /* 302819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302858 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302905 */     GIR_RootConstrainSelectedInstOperands,
     /* 302906 */     // GIR_Coverage, 6235,
     /* 302906 */     GIR_EraseRootFromParent_Done,
     /* 302907 */   // Label 6161: @302907
     /* 302907 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(303003), // Rule ID 6095 //
     /* 302912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 302943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302954 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302966 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 302976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 302989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303001 */     GIR_RootConstrainSelectedInstOperands,
     /* 303002 */     // GIR_Coverage, 6095,
     /* 303002 */     GIR_EraseRootFromParent_Done,
     /* 303003 */   // Label 6162: @303003
     /* 303003 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(303087), // Rule ID 2542 //
     /* 303008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303038 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303050 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303057 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 303060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 303073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303085 */     GIR_RootConstrainSelectedInstOperands,
     /* 303086 */     // GIR_Coverage, 2542,
     /* 303086 */     GIR_EraseRootFromParent_Done,
     /* 303087 */   // Label 6163: @303087
     /* 303087 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(303137), // Rule ID 13358 //
     /* 303092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303122 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 303125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303135 */     GIR_RootConstrainSelectedInstOperands,
     /* 303136 */     // GIR_Coverage, 13358,
     /* 303136 */     GIR_EraseRootFromParent_Done,
     /* 303137 */   // Label 6164: @303137
     /* 303137 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(303221), // Rule ID 6063 //
     /* 303142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303172 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303191 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 303194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 303207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303219 */     GIR_RootConstrainSelectedInstOperands,
     /* 303220 */     // GIR_Coverage, 6063,
     /* 303220 */     GIR_EraseRootFromParent_Done,
     /* 303221 */   // Label 6165: @303221
     /* 303221 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(303271), // Rule ID 1308 //
     /* 303226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303256 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 303259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303269 */     GIR_RootConstrainSelectedInstOperands,
     /* 303270 */     // GIR_Coverage, 1308,
     /* 303270 */     GIR_EraseRootFromParent_Done,
     /* 303271 */   // Label 6166: @303271
     /* 303271 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(303304), // Rule ID 1298 //
     /* 303276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303291 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 303294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 303302 */     GIR_RootConstrainSelectedInstOperands,
     /* 303303 */     // GIR_Coverage, 1298,
     /* 303303 */     GIR_EraseRootFromParent_Done,
     /* 303304 */   // Label 6167: @303304
     /* 303304 */   GIM_Reject,
     /* 303305 */ // Label 6148: @303305
     /* 303305 */ GIM_Reject,
     /* 303306 */ // Label 6040: @303306
     /* 303306 */ GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(304826),
     /* 303311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 303320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303324 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(303402), // Rule ID 6221 //
     /* 303329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303370 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303374 */     // MIs[3] Operand 1
     /* 303374 */     // No operand predicates
     /* 303374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303384 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303400 */     GIR_RootConstrainSelectedInstOperands,
     /* 303401 */     // GIR_Coverage, 6221,
     /* 303401 */     GIR_EraseRootFromParent_Done,
     /* 303402 */   // Label 6169: @303402
     /* 303402 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(303486), // Rule ID 6133 //
     /* 303407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303439 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303443 */     // MIs[2] Operand 1
     /* 303443 */     // No operand predicates
     /* 303443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 303447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303451 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303455 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303466 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 303477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303484 */     GIR_RootConstrainSelectedInstOperands,
     /* 303485 */     // GIR_Coverage, 6133,
     /* 303485 */     GIR_EraseRootFromParent_Done,
     /* 303486 */   // Label 6170: @303486
     /* 303486 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(303567), // Rule ID 6165 //
     /* 303491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303535 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303539 */     // MIs[3] Operand 1
     /* 303539 */     // No operand predicates
     /* 303539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303549 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303565 */     GIR_RootConstrainSelectedInstOperands,
     /* 303566 */     // GIR_Coverage, 6165,
     /* 303566 */     GIR_EraseRootFromParent_Done,
     /* 303567 */   // Label 6171: @303567
     /* 303567 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(303651), // Rule ID 6197 //
     /* 303572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303621 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303625 */     // MIs[3] Operand 1
     /* 303625 */     // No operand predicates
     /* 303625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303631 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303649 */     GIR_RootConstrainSelectedInstOperands,
     /* 303650 */     // GIR_Coverage, 6197,
     /* 303650 */     GIR_EraseRootFromParent_Done,
     /* 303651 */   // Label 6172: @303651
     /* 303651 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(303729), // Rule ID 6243 //
     /* 303656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303701 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303705 */     // MIs[3] Operand 1
     /* 303705 */     // No operand predicates
     /* 303705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303711 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303727 */     GIR_RootConstrainSelectedInstOperands,
     /* 303728 */     // GIR_Coverage, 6243,
     /* 303728 */     GIR_EraseRootFromParent_Done,
     /* 303729 */   // Label 6173: @303729
     /* 303729 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(303810), // Rule ID 6101 //
     /* 303734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303786 */     // MIs[3] Operand 1
     /* 303786 */     // No operand predicates
     /* 303786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303792 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 303795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303808 */     GIR_RootConstrainSelectedInstOperands,
     /* 303809 */     // GIR_Coverage, 6101,
     /* 303809 */     GIR_EraseRootFromParent_Done,
     /* 303810 */   // Label 6174: @303810
     /* 303810 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(303879), // Rule ID 2548 //
     /* 303815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303847 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303851 */     // MIs[2] Operand 1
     /* 303851 */     // No operand predicates
     /* 303851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303861 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 303864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303877 */     GIR_RootConstrainSelectedInstOperands,
     /* 303878 */     // GIR_Coverage, 2548,
     /* 303878 */     GIR_EraseRootFromParent_Done,
     /* 303879 */   // Label 6175: @303879
     /* 303879 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(303948), // Rule ID 6069 //
     /* 303884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 303899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 303924 */     // MIs[2] Operand 1
     /* 303924 */     // No operand predicates
     /* 303924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303930 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 303933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303946 */     GIR_RootConstrainSelectedInstOperands,
     /* 303947 */     // GIR_Coverage, 6069,
     /* 303947 */     GIR_EraseRootFromParent_Done,
     /* 303948 */   // Label 6176: @303948
     /* 303948 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(304041), // Rule ID 6223 //
     /* 303953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 303977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303992 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304004 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304011 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304039 */     GIR_RootConstrainSelectedInstOperands,
     /* 304040 */     // GIR_Coverage, 6223,
     /* 304040 */     GIR_EraseRootFromParent_Done,
     /* 304041 */   // Label 6177: @304041
     /* 304041 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(304140), // Rule ID 6135 //
     /* 304046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304089 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304101 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304108 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 304132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304138 */     GIR_RootConstrainSelectedInstOperands,
     /* 304139 */     // GIR_Coverage, 6135,
     /* 304139 */     GIR_EraseRootFromParent_Done,
     /* 304140 */   // Label 6178: @304140
     /* 304140 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(304236), // Rule ID 6167 //
     /* 304145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 304172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304187 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304234 */     GIR_RootConstrainSelectedInstOperands,
     /* 304235 */     // GIR_Coverage, 6167,
     /* 304235 */     GIR_EraseRootFromParent_Done,
     /* 304236 */   // Label 6179: @304236
     /* 304236 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(304335), // Rule ID 6199 //
     /* 304241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 304273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304284 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304296 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304333 */     GIR_RootConstrainSelectedInstOperands,
     /* 304334 */     // GIR_Coverage, 6199,
     /* 304334 */     GIR_EraseRootFromParent_Done,
     /* 304335 */   // Label 6180: @304335
     /* 304335 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(304428), // Rule ID 6245 //
     /* 304340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 304368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304379 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304391 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304398 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304426 */     GIR_RootConstrainSelectedInstOperands,
     /* 304427 */     // GIR_Coverage, 6245,
     /* 304427 */     GIR_EraseRootFromParent_Done,
     /* 304428 */   // Label 6181: @304428
     /* 304428 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(304524), // Rule ID 6103 //
     /* 304433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 304464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304475 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 304510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304522 */     GIR_RootConstrainSelectedInstOperands,
     /* 304523 */     // GIR_Coverage, 6103,
     /* 304523 */     GIR_EraseRootFromParent_Done,
     /* 304524 */   // Label 6182: @304524
     /* 304524 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(304608), // Rule ID 2550 //
     /* 304529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304559 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304578 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 304594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304606 */     GIR_RootConstrainSelectedInstOperands,
     /* 304607 */     // GIR_Coverage, 2550,
     /* 304607 */     GIR_EraseRootFromParent_Done,
     /* 304608 */   // Label 6183: @304608
     /* 304608 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(304658), // Rule ID 13362 //
     /* 304613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304643 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 304646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304656 */     GIR_RootConstrainSelectedInstOperands,
     /* 304657 */     // GIR_Coverage, 13362,
     /* 304657 */     GIR_EraseRootFromParent_Done,
     /* 304658 */   // Label 6184: @304658
     /* 304658 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(304742), // Rule ID 6071 //
     /* 304663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304693 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 304728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304740 */     GIR_RootConstrainSelectedInstOperands,
     /* 304741 */     // GIR_Coverage, 6071,
     /* 304741 */     GIR_EraseRootFromParent_Done,
     /* 304742 */   // Label 6185: @304742
     /* 304742 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(304792), // Rule ID 1312 //
     /* 304747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304777 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 304780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304790 */     GIR_RootConstrainSelectedInstOperands,
     /* 304791 */     // GIR_Coverage, 1312,
     /* 304791 */     GIR_EraseRootFromParent_Done,
     /* 304792 */   // Label 6186: @304792
     /* 304792 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(304825), // Rule ID 1302 //
     /* 304797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304812 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 304815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 304823 */     GIR_RootConstrainSelectedInstOperands,
     /* 304824 */     // GIR_Coverage, 1302,
     /* 304824 */     GIR_EraseRootFromParent_Done,
     /* 304825 */   // Label 6187: @304825
     /* 304825 */   GIM_Reject,
     /* 304826 */ // Label 6168: @304826
     /* 304826 */ GIM_Reject,
     /* 304827 */ // Label 6041: @304827
     /* 304827 */ GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(306005),
     /* 304832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 304838 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 304841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304845 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(304929), // Rule ID 6117 //
     /* 304850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304886 */     // MIs[2] Operand 1
     /* 304886 */     // No operand predicates
     /* 304886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304894 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304898 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304909 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 304912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 304920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304927 */     GIR_RootConstrainSelectedInstOperands,
     /* 304928 */     // GIR_Coverage, 6117,
     /* 304928 */     GIR_EraseRootFromParent_Done,
     /* 304929 */   // Label 6189: @304929
     /* 304929 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(305010), // Rule ID 6149 //
     /* 304934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304978 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304982 */     // MIs[3] Operand 1
     /* 304982 */     // No operand predicates
     /* 304982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304992 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 304995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305008 */     GIR_RootConstrainSelectedInstOperands,
     /* 305009 */     // GIR_Coverage, 6149,
     /* 305009 */     GIR_EraseRootFromParent_Done,
     /* 305010 */   // Label 6190: @305010
     /* 305010 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(305094), // Rule ID 6181 //
     /* 305015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305064 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305068 */     // MIs[3] Operand 1
     /* 305068 */     // No operand predicates
     /* 305068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305074 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305092 */     GIR_RootConstrainSelectedInstOperands,
     /* 305093 */     // GIR_Coverage, 6181,
     /* 305093 */     GIR_EraseRootFromParent_Done,
     /* 305094 */   // Label 6191: @305094
     /* 305094 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(305175), // Rule ID 6085 //
     /* 305099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305147 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305151 */     // MIs[3] Operand 1
     /* 305151 */     // No operand predicates
     /* 305151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305157 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305173 */     GIR_RootConstrainSelectedInstOperands,
     /* 305174 */     // GIR_Coverage, 6085,
     /* 305174 */     GIR_EraseRootFromParent_Done,
     /* 305175 */   // Label 6192: @305175
     /* 305175 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(305244), // Rule ID 2532 //
     /* 305180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305212 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305216 */     // MIs[2] Operand 1
     /* 305216 */     // No operand predicates
     /* 305216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305226 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 305229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305242 */     GIR_RootConstrainSelectedInstOperands,
     /* 305243 */     // GIR_Coverage, 2532,
     /* 305243 */     GIR_EraseRootFromParent_Done,
     /* 305244 */   // Label 6193: @305244
     /* 305244 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(305313), // Rule ID 6053 //
     /* 305249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305289 */     // MIs[2] Operand 1
     /* 305289 */     // No operand predicates
     /* 305289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305295 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 305298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305311 */     GIR_RootConstrainSelectedInstOperands,
     /* 305312 */     // GIR_Coverage, 6053,
     /* 305312 */     GIR_EraseRootFromParent_Done,
     /* 305313 */   // Label 6194: @305313
     /* 305313 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(305412), // Rule ID 6119 //
     /* 305318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305361 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 305404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305410 */     GIR_RootConstrainSelectedInstOperands,
     /* 305411 */     // GIR_Coverage, 6119,
     /* 305411 */     GIR_EraseRootFromParent_Done,
     /* 305412 */   // Label 6195: @305412
     /* 305412 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(305508), // Rule ID 6151 //
     /* 305417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305459 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305506 */     GIR_RootConstrainSelectedInstOperands,
     /* 305507 */     // GIR_Coverage, 6151,
     /* 305507 */     GIR_EraseRootFromParent_Done,
     /* 305508 */   // Label 6196: @305508
     /* 305508 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(305607), // Rule ID 6183 //
     /* 305513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305556 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305605 */     GIR_RootConstrainSelectedInstOperands,
     /* 305606 */     // GIR_Coverage, 6183,
     /* 305606 */     GIR_EraseRootFromParent_Done,
     /* 305607 */   // Label 6197: @305607
     /* 305607 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(305703), // Rule ID 6087 //
     /* 305612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305654 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305666 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305669 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305673 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 305689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305701 */     GIR_RootConstrainSelectedInstOperands,
     /* 305702 */     // GIR_Coverage, 6087,
     /* 305702 */     GIR_EraseRootFromParent_Done,
     /* 305703 */   // Label 6198: @305703
     /* 305703 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(305787), // Rule ID 2534 //
     /* 305708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305738 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305757 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 305773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305785 */     GIR_RootConstrainSelectedInstOperands,
     /* 305786 */     // GIR_Coverage, 2534,
     /* 305786 */     GIR_EraseRootFromParent_Done,
     /* 305787 */   // Label 6199: @305787
     /* 305787 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(305837), // Rule ID 13354 //
     /* 305792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305822 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 305825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305835 */     GIR_RootConstrainSelectedInstOperands,
     /* 305836 */     // GIR_Coverage, 13354,
     /* 305836 */     GIR_EraseRootFromParent_Done,
     /* 305837 */   // Label 6200: @305837
     /* 305837 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(305921), // Rule ID 6055 //
     /* 305842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305872 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305891 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 305907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305919 */     GIR_RootConstrainSelectedInstOperands,
     /* 305920 */     // GIR_Coverage, 6055,
     /* 305920 */     GIR_EraseRootFromParent_Done,
     /* 305921 */   // Label 6201: @305921
     /* 305921 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(305971), // Rule ID 1304 //
     /* 305926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305956 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 305959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305969 */     GIR_RootConstrainSelectedInstOperands,
     /* 305970 */     // GIR_Coverage, 1304,
     /* 305970 */     GIR_EraseRootFromParent_Done,
     /* 305971 */   // Label 6202: @305971
     /* 305971 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(306004), // Rule ID 1294 //
     /* 305976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305991 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 305994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 306002 */     GIR_RootConstrainSelectedInstOperands,
     /* 306003 */     // GIR_Coverage, 1294,
     /* 306003 */     GIR_EraseRootFromParent_Done,
     /* 306004 */   // Label 6203: @306004
     /* 306004 */   GIM_Reject,
     /* 306005 */ // Label 6188: @306005
     /* 306005 */ GIM_Reject,
     /* 306006 */ // Label 6042: @306006
     /* 306006 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(307526),
     /* 306011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 306017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 306020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306024 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(306102), // Rule ID 6215 //
     /* 306029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306074 */     // MIs[3] Operand 1
     /* 306074 */     // No operand predicates
     /* 306074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306084 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306100 */     GIR_RootConstrainSelectedInstOperands,
     /* 306101 */     // GIR_Coverage, 6215,
     /* 306101 */     GIR_EraseRootFromParent_Done,
     /* 306102 */   // Label 6205: @306102
     /* 306102 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(306186), // Rule ID 6129 //
     /* 306107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306143 */     // MIs[2] Operand 1
     /* 306143 */     // No operand predicates
     /* 306143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306151 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306155 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306166 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 306177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306184 */     GIR_RootConstrainSelectedInstOperands,
     /* 306185 */     // GIR_Coverage, 6129,
     /* 306185 */     GIR_EraseRootFromParent_Done,
     /* 306186 */   // Label 6206: @306186
     /* 306186 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(306267), // Rule ID 6161 //
     /* 306191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306235 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306239 */     // MIs[3] Operand 1
     /* 306239 */     // No operand predicates
     /* 306239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306249 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306265 */     GIR_RootConstrainSelectedInstOperands,
     /* 306266 */     // GIR_Coverage, 6161,
     /* 306266 */     GIR_EraseRootFromParent_Done,
     /* 306267 */   // Label 6207: @306267
     /* 306267 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(306351), // Rule ID 6193 //
     /* 306272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306321 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306325 */     // MIs[3] Operand 1
     /* 306325 */     // No operand predicates
     /* 306325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306331 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306349 */     GIR_RootConstrainSelectedInstOperands,
     /* 306350 */     // GIR_Coverage, 6193,
     /* 306350 */     GIR_EraseRootFromParent_Done,
     /* 306351 */   // Label 6208: @306351
     /* 306351 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(306429), // Rule ID 6237 //
     /* 306356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306401 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306405 */     // MIs[3] Operand 1
     /* 306405 */     // No operand predicates
     /* 306405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306411 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306427 */     GIR_RootConstrainSelectedInstOperands,
     /* 306428 */     // GIR_Coverage, 6237,
     /* 306428 */     GIR_EraseRootFromParent_Done,
     /* 306429 */   // Label 6209: @306429
     /* 306429 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(306510), // Rule ID 6097 //
     /* 306434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306482 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306486 */     // MIs[3] Operand 1
     /* 306486 */     // No operand predicates
     /* 306486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306492 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306508 */     GIR_RootConstrainSelectedInstOperands,
     /* 306509 */     // GIR_Coverage, 6097,
     /* 306509 */     GIR_EraseRootFromParent_Done,
     /* 306510 */   // Label 6210: @306510
     /* 306510 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(306579), // Rule ID 2544 //
     /* 306515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306551 */     // MIs[2] Operand 1
     /* 306551 */     // No operand predicates
     /* 306551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306561 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 306564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306577 */     GIR_RootConstrainSelectedInstOperands,
     /* 306578 */     // GIR_Coverage, 2544,
     /* 306578 */     GIR_EraseRootFromParent_Done,
     /* 306579 */   // Label 6211: @306579
     /* 306579 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(306648), // Rule ID 6065 //
     /* 306584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306620 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306624 */     // MIs[2] Operand 1
     /* 306624 */     // No operand predicates
     /* 306624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306630 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 306633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306646 */     GIR_RootConstrainSelectedInstOperands,
     /* 306647 */     // GIR_Coverage, 6065,
     /* 306647 */     GIR_EraseRootFromParent_Done,
     /* 306648 */   // Label 6212: @306648
     /* 306648 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(306741), // Rule ID 6219 //
     /* 306653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 306677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306692 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306739 */     GIR_RootConstrainSelectedInstOperands,
     /* 306740 */     // GIR_Coverage, 6219,
     /* 306740 */     GIR_EraseRootFromParent_Done,
     /* 306741 */   // Label 6213: @306741
     /* 306741 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(306840), // Rule ID 6131 //
     /* 306746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306789 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306808 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 306832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306838 */     GIR_RootConstrainSelectedInstOperands,
     /* 306839 */     // GIR_Coverage, 6131,
     /* 306839 */     GIR_EraseRootFromParent_Done,
     /* 306840 */   // Label 6214: @306840
     /* 306840 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(306936), // Rule ID 6163 //
     /* 306845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 306872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306887 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306906 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 306922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306934 */     GIR_RootConstrainSelectedInstOperands,
     /* 306935 */     // GIR_Coverage, 6163,
     /* 306935 */     GIR_EraseRootFromParent_Done,
     /* 306936 */   // Label 6215: @306936
     /* 306936 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(307035), // Rule ID 6195 //
     /* 306941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 306973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306984 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306996 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 307019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307033 */     GIR_RootConstrainSelectedInstOperands,
     /* 307034 */     // GIR_Coverage, 6195,
     /* 307034 */     GIR_EraseRootFromParent_Done,
     /* 307035 */   // Label 6216: @307035
     /* 307035 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(307128), // Rule ID 6241 //
     /* 307040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 307068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307079 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307091 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 307114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307126 */     GIR_RootConstrainSelectedInstOperands,
     /* 307127 */     // GIR_Coverage, 6241,
     /* 307127 */     GIR_EraseRootFromParent_Done,
     /* 307128 */   // Label 6217: @307128
     /* 307128 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(307224), // Rule ID 6099 //
     /* 307133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 307160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 307164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307175 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307187 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307194 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 307210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307222 */     GIR_RootConstrainSelectedInstOperands,
     /* 307223 */     // GIR_Coverage, 6099,
     /* 307223 */     GIR_EraseRootFromParent_Done,
     /* 307224 */   // Label 6218: @307224
     /* 307224 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(307308), // Rule ID 2546 //
     /* 307229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307259 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 307294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307306 */     GIR_RootConstrainSelectedInstOperands,
     /* 307307 */     // GIR_Coverage, 2546,
     /* 307307 */     GIR_EraseRootFromParent_Done,
     /* 307308 */   // Label 6219: @307308
     /* 307308 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(307358), // Rule ID 13360 //
     /* 307313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307343 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 307346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307356 */     GIR_RootConstrainSelectedInstOperands,
     /* 307357 */     // GIR_Coverage, 13360,
     /* 307357 */     GIR_EraseRootFromParent_Done,
     /* 307358 */   // Label 6220: @307358
     /* 307358 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(307442), // Rule ID 6067 //
     /* 307363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307393 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307412 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 307428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307440 */     GIR_RootConstrainSelectedInstOperands,
     /* 307441 */     // GIR_Coverage, 6067,
     /* 307441 */     GIR_EraseRootFromParent_Done,
     /* 307442 */   // Label 6221: @307442
     /* 307442 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(307492), // Rule ID 1310 //
     /* 307447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307477 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 307480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307490 */     GIR_RootConstrainSelectedInstOperands,
     /* 307491 */     // GIR_Coverage, 1310,
     /* 307491 */     GIR_EraseRootFromParent_Done,
     /* 307492 */   // Label 6222: @307492
     /* 307492 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(307525), // Rule ID 1300 //
     /* 307497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307512 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 307515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 307523 */     GIR_RootConstrainSelectedInstOperands,
     /* 307524 */     // GIR_Coverage, 1300,
     /* 307524 */     GIR_EraseRootFromParent_Done,
     /* 307525 */   // Label 6223: @307525
     /* 307525 */   GIM_Reject,
     /* 307526 */ // Label 6204: @307526
     /* 307526 */ GIM_Reject,
     /* 307527 */ // Label 6043: @307527
     /* 307527 */ GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(308705),
     /* 307532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 307538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 307541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307545 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(307629), // Rule ID 6113 //
     /* 307550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307582 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307586 */     // MIs[2] Operand 1
     /* 307586 */     // No operand predicates
     /* 307586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 307590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307598 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307609 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 307612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 307620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307627 */     GIR_RootConstrainSelectedInstOperands,
     /* 307628 */     // GIR_Coverage, 6113,
     /* 307628 */     GIR_EraseRootFromParent_Done,
     /* 307629 */   // Label 6225: @307629
     /* 307629 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(307710), // Rule ID 6145 //
     /* 307634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307678 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307682 */     // MIs[3] Operand 1
     /* 307682 */     // No operand predicates
     /* 307682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307692 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 307695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307708 */     GIR_RootConstrainSelectedInstOperands,
     /* 307709 */     // GIR_Coverage, 6145,
     /* 307709 */     GIR_EraseRootFromParent_Done,
     /* 307710 */   // Label 6226: @307710
     /* 307710 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(307794), // Rule ID 6177 //
     /* 307715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 307739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307764 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307768 */     // MIs[3] Operand 1
     /* 307768 */     // No operand predicates
     /* 307768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307774 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 307777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307792 */     GIR_RootConstrainSelectedInstOperands,
     /* 307793 */     // GIR_Coverage, 6177,
     /* 307793 */     GIR_EraseRootFromParent_Done,
     /* 307794 */   // Label 6227: @307794
     /* 307794 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(307875), // Rule ID 6081 //
     /* 307799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307847 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307851 */     // MIs[3] Operand 1
     /* 307851 */     // No operand predicates
     /* 307851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307857 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 307860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307873 */     GIR_RootConstrainSelectedInstOperands,
     /* 307874 */     // GIR_Coverage, 6081,
     /* 307874 */     GIR_EraseRootFromParent_Done,
     /* 307875 */   // Label 6228: @307875
     /* 307875 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(307944), // Rule ID 2528 //
     /* 307880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307912 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307916 */     // MIs[2] Operand 1
     /* 307916 */     // No operand predicates
     /* 307916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307926 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 307929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307942 */     GIR_RootConstrainSelectedInstOperands,
     /* 307943 */     // GIR_Coverage, 2528,
     /* 307943 */     GIR_EraseRootFromParent_Done,
     /* 307944 */   // Label 6229: @307944
     /* 307944 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(308013), // Rule ID 6049 //
     /* 307949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307985 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307989 */     // MIs[2] Operand 1
     /* 307989 */     // No operand predicates
     /* 307989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307995 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 307995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 307998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308011 */     GIR_RootConstrainSelectedInstOperands,
     /* 308012 */     // GIR_Coverage, 6049,
     /* 308012 */     GIR_EraseRootFromParent_Done,
     /* 308013 */   // Label 6230: @308013
     /* 308013 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(308112), // Rule ID 6115 //
     /* 308018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308061 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308073 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 308096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 308104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308110 */     GIR_RootConstrainSelectedInstOperands,
     /* 308111 */     // GIR_Coverage, 6115,
     /* 308111 */     GIR_EraseRootFromParent_Done,
     /* 308112 */   // Label 6231: @308112
     /* 308112 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(308208), // Rule ID 6147 //
     /* 308117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 308140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308159 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308178 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 308194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308206 */     GIR_RootConstrainSelectedInstOperands,
     /* 308207 */     // GIR_Coverage, 6147,
     /* 308207 */     GIR_EraseRootFromParent_Done,
     /* 308208 */   // Label 6232: @308208
     /* 308208 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(308307), // Rule ID 6179 //
     /* 308213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 308241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308256 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308268 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308271 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308275 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 308291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308305 */     GIR_RootConstrainSelectedInstOperands,
     /* 308306 */     // GIR_Coverage, 6179,
     /* 308306 */     GIR_EraseRootFromParent_Done,
     /* 308307 */   // Label 6233: @308307
     /* 308307 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(308403), // Rule ID 6083 //
     /* 308312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 308339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308354 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308366 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308369 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 308389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308401 */     GIR_RootConstrainSelectedInstOperands,
     /* 308402 */     // GIR_Coverage, 6083,
     /* 308402 */     GIR_EraseRootFromParent_Done,
     /* 308403 */   // Label 6234: @308403
     /* 308403 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(308487), // Rule ID 2530 //
     /* 308408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308438 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308450 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308457 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 308473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308485 */     GIR_RootConstrainSelectedInstOperands,
     /* 308486 */     // GIR_Coverage, 2530,
     /* 308486 */     GIR_EraseRootFromParent_Done,
     /* 308487 */   // Label 6235: @308487
     /* 308487 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(308537), // Rule ID 13356 //
     /* 308492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308522 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 308522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 308525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308535 */     GIR_RootConstrainSelectedInstOperands,
     /* 308536 */     // GIR_Coverage, 13356,
     /* 308536 */     GIR_EraseRootFromParent_Done,
     /* 308537 */   // Label 6236: @308537
     /* 308537 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(308621), // Rule ID 6051 //
     /* 308542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308572 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 308575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 308579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 308604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 308607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308619 */     GIR_RootConstrainSelectedInstOperands,
     /* 308620 */     // GIR_Coverage, 6051,
     /* 308620 */     GIR_EraseRootFromParent_Done,
     /* 308621 */   // Label 6237: @308621
     /* 308621 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(308671), // Rule ID 1306 //
     /* 308626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308656 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 308656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 308659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308669 */     GIR_RootConstrainSelectedInstOperands,
     /* 308670 */     // GIR_Coverage, 1306,
     /* 308670 */     GIR_EraseRootFromParent_Done,
     /* 308671 */   // Label 6238: @308671
     /* 308671 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(308704), // Rule ID 1296 //
     /* 308676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308691 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 308691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 308694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 308702 */     GIR_RootConstrainSelectedInstOperands,
     /* 308703 */     // GIR_Coverage, 1296,
     /* 308703 */     GIR_EraseRootFromParent_Done,
     /* 308704 */   // Label 6239: @308704
     /* 308704 */   GIM_Reject,
     /* 308705 */ // Label 6224: @308705
     /* 308705 */ GIM_Reject,
     /* 308706 */ // Label 6044: @308706
     /* 308706 */ GIM_Reject,
     /* 308707 */ // Label 63: @308707
     /* 308707 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6248*/ GIMT_Encode4(309322),
     /* 308718 */ /*GILLT_s16*//*Label 6240*/ GIMT_Encode4(308758),
     /* 308722 */ /*GILLT_s32*//*Label 6241*/ GIMT_Encode4(308796),
     /* 308726 */ /*GILLT_s64*//*Label 6242*/ GIMT_Encode4(308834), GIMT_Encode4(0),
     /* 308734 */ /*GILLT_v2s32*//*Label 6243*/ GIMT_Encode4(308872),
     /* 308738 */ /*GILLT_v2s64*//*Label 6244*/ GIMT_Encode4(308910),
     /* 308742 */ /*GILLT_v4s16*//*Label 6245*/ GIMT_Encode4(308948),
     /* 308746 */ /*GILLT_v4s32*//*Label 6246*/ GIMT_Encode4(308986), GIMT_Encode4(0),
     /* 308754 */ /*GILLT_v8s16*//*Label 6247*/ GIMT_Encode4(309024),
     /* 308758 */ // Label 6240: @308758
     /* 308758 */ GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(308795), // Rule ID 590 //
     /* 308763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 308772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308784 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 308784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 308789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308793 */   GIR_RootConstrainSelectedInstOperands,
     /* 308794 */   // GIR_Coverage, 590,
     /* 308794 */   GIR_Done,
     /* 308795 */ // Label 6249: @308795
     /* 308795 */ GIM_Reject,
     /* 308796 */ // Label 6241: @308796
     /* 308796 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(308833), // Rule ID 592 //
     /* 308801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 308810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308822 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 308822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 308827 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308831 */   GIR_RootConstrainSelectedInstOperands,
     /* 308832 */   // GIR_Coverage, 592,
     /* 308832 */   GIR_Done,
     /* 308833 */ // Label 6250: @308833
     /* 308833 */ GIM_Reject,
     /* 308834 */ // Label 6242: @308834
     /* 308834 */ GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(308871), // Rule ID 594 //
     /* 308839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 308848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308860 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 308860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 308865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308869 */   GIR_RootConstrainSelectedInstOperands,
     /* 308870 */   // GIR_Coverage, 594,
     /* 308870 */   GIR_Done,
     /* 308871 */ // Label 6251: @308871
     /* 308871 */ GIM_Reject,
     /* 308872 */ // Label 6243: @308872
     /* 308872 */ GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(308909), // Rule ID 1228 //
     /* 308877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 308883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 308886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308898 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 308898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 308903 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308907 */   GIR_RootConstrainSelectedInstOperands,
     /* 308908 */   // GIR_Coverage, 1228,
     /* 308908 */   GIR_Done,
     /* 308909 */ // Label 6252: @308909
     /* 308909 */ GIM_Reject,
     /* 308910 */ // Label 6244: @308910
     /* 308910 */ GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(308947), // Rule ID 1232 //
     /* 308915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 308924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308936 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 308936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 308941 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308945 */   GIR_RootConstrainSelectedInstOperands,
     /* 308946 */   // GIR_Coverage, 1232,
     /* 308946 */   GIR_Done,
     /* 308947 */ // Label 6253: @308947
     /* 308947 */ GIM_Reject,
     /* 308948 */ // Label 6245: @308948
     /* 308948 */ GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(308985), // Rule ID 1224 //
     /* 308953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 308959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 308962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308974 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 308974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 308979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308983 */   GIR_RootConstrainSelectedInstOperands,
     /* 308984 */   // GIR_Coverage, 1224,
     /* 308984 */   GIR_Done,
     /* 308985 */ // Label 6254: @308985
     /* 308985 */ GIM_Reject,
     /* 308986 */ // Label 6246: @308986
     /* 308986 */ GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(309023), // Rule ID 1230 //
     /* 308991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 309000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309012 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 309012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 309017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309021 */   GIR_RootConstrainSelectedInstOperands,
     /* 309022 */   // GIR_Coverage, 1230,
     /* 309022 */   GIR_Done,
     /* 309023 */ // Label 6255: @309023
     /* 309023 */ GIM_Reject,
     /* 309024 */ // Label 6247: @309024
     /* 309024 */ GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(309321),
     /* 309029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 309035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309047 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(309066), // Rule ID 1226 //
     /* 309052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309055 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 309055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 309060 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309064 */     GIR_RootConstrainSelectedInstOperands,
     /* 309065 */     // GIR_Coverage, 1226,
     /* 309065 */     GIR_Done,
     /* 309066 */   // Label 6257: @309066
     /* 309066 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(309320), // Rule ID 7014 //
     /* 309071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 309074 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 309074 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 309077 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309081 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309086 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 309090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 309092 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 309095 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309099 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309104 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 309108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 309110 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 309113 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 309117 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309122 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 309125 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 309128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 309130 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 309133 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309137 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309142 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309148 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309153 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309158 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 309161 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309165 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309170 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 309173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309175 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 309178 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309182 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309187 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309193 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309198 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309203 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 309206 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309210 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309215 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 309220 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 309223 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 309227 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309232 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 309235 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 309238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309240 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 309243 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 309247 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309252 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 309255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309257 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309260 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309264 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309286 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 309292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 309310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 309318 */     GIR_RootConstrainSelectedInstOperands,
     /* 309319 */     // GIR_Coverage, 7014,
     /* 309319 */     GIR_EraseRootFromParent_Done,
     /* 309320 */   // Label 6258: @309320
     /* 309320 */   GIM_Reject,
     /* 309321 */ // Label 6256: @309321
     /* 309321 */ GIM_Reject,
     /* 309322 */ // Label 6248: @309322
     /* 309322 */ GIM_Reject,
     /* 309323 */ // Label 64: @309323
     /* 309323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6267*/ GIMT_Encode4(312829),
     /* 309334 */ /*GILLT_s16*//*Label 6259*/ GIMT_Encode4(309374),
     /* 309338 */ /*GILLT_s32*//*Label 6260*/ GIMT_Encode4(310542),
     /* 309342 */ /*GILLT_s64*//*Label 6261*/ GIMT_Encode4(311565), GIMT_Encode4(0),
     /* 309350 */ /*GILLT_v2s32*//*Label 6262*/ GIMT_Encode4(312588),
     /* 309354 */ /*GILLT_v2s64*//*Label 6263*/ GIMT_Encode4(312615),
     /* 309358 */ /*GILLT_v4s16*//*Label 6264*/ GIMT_Encode4(312642),
     /* 309362 */ /*GILLT_v4s32*//*Label 6265*/ GIMT_Encode4(312722), GIMT_Encode4(0),
     /* 309370 */ /*GILLT_v8s16*//*Label 6266*/ GIMT_Encode4(312749),
     /* 309374 */ // Label 6259: @309374
     /* 309374 */ GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(310541),
     /* 309379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 309382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309386 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(309544), // Rule ID 4847 //
     /* 309391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309410 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309435 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309447 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309451 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309455 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309460 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309471 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309483 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309511 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 309530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309542 */     GIR_RootConstrainSelectedInstOperands,
     /* 309543 */     // GIR_Coverage, 4847,
     /* 309543 */     GIR_EraseRootFromParent_Done,
     /* 309544 */   // Label 6269: @309544
     /* 309544 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(309702), // Rule ID 4846 //
     /* 309549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309593 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309605 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309613 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309618 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309629 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309629 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309632 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309636 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309641 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309669 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 309688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309700 */     GIR_RootConstrainSelectedInstOperands,
     /* 309701 */     // GIR_Coverage, 4846,
     /* 309701 */     GIR_EraseRootFromParent_Done,
     /* 309702 */   // Label 6270: @309702
     /* 309702 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(309813), // Rule ID 4845 //
     /* 309707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309726 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309751 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309767 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309779 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 309798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309811 */     GIR_RootConstrainSelectedInstOperands,
     /* 309812 */     // GIR_Coverage, 4845,
     /* 309812 */     GIR_EraseRootFromParent_Done,
     /* 309813 */   // Label 6271: @309813
     /* 309813 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(309924), // Rule ID 4843 //
     /* 309818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309837 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309867 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309878 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309890 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 309909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309922 */     GIR_RootConstrainSelectedInstOperands,
     /* 309923 */     // GIR_Coverage, 4843,
     /* 309923 */     GIR_EraseRootFromParent_Done,
     /* 309924 */   // Label 6272: @309924
     /* 309924 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(310035), // Rule ID 4844 //
     /* 309929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 309952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309973 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309989 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310001 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310033 */     GIR_RootConstrainSelectedInstOperands,
     /* 310034 */     // GIR_Coverage, 4844,
     /* 310034 */     GIR_EraseRootFromParent_Done,
     /* 310035 */   // Label 6273: @310035
     /* 310035 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(310146), // Rule ID 4842 //
     /* 310040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310059 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 310063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310100 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310112 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310144 */     GIR_RootConstrainSelectedInstOperands,
     /* 310145 */     // GIR_Coverage, 4842,
     /* 310145 */     GIR_EraseRootFromParent_Done,
     /* 310146 */   // Label 6274: @310146
     /* 310146 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(310210), // Rule ID 650 //
     /* 310151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310170 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 310174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310191 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310208 */     GIR_RootConstrainSelectedInstOperands,
     /* 310209 */     // GIR_Coverage, 650,
     /* 310209 */     GIR_EraseRootFromParent_Done,
     /* 310210 */   // Label 6275: @310210
     /* 310210 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(310274), // Rule ID 649 //
     /* 310215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310234 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 310238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310255 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310272 */     GIR_RootConstrainSelectedInstOperands,
     /* 310273 */     // GIR_Coverage, 649,
     /* 310273 */     GIR_EraseRootFromParent_Done,
     /* 310274 */   // Label 6276: @310274
     /* 310274 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(310325), // Rule ID 626 //
     /* 310279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 310290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310310 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 310310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 310313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310323 */     GIR_RootConstrainSelectedInstOperands,
     /* 310324 */     // GIR_Coverage, 626,
     /* 310324 */     GIR_EraseRootFromParent_Done,
     /* 310325 */   // Label 6277: @310325
     /* 310325 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(310376), // Rule ID 625 //
     /* 310330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 310341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310361 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 310361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 310364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310374 */     GIR_RootConstrainSelectedInstOperands,
     /* 310375 */     // GIR_Coverage, 625,
     /* 310375 */     GIR_EraseRootFromParent_Done,
     /* 310376 */   // Label 6278: @310376
     /* 310376 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(310395), // Rule ID 524 //
     /* 310381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310388 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 310388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 310393 */     GIR_RootConstrainSelectedInstOperands,
     /* 310394 */     // GIR_Coverage, 524,
     /* 310394 */     GIR_Done,
     /* 310395 */   // Label 6279: @310395
     /* 310395 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(310540), // Rule ID 6381 //
     /* 310400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310404 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 310404 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 310407 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310411 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 310418 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 310421 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310425 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310430 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 310433 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 310437 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 310440 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310445 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310450 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310455 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 310458 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310462 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310467 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 310470 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 310482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310487 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310490 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 310495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310509 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310522 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 310529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310539 */     // GIR_Coverage, 6381,
     /* 310539 */     GIR_EraseRootFromParent_Done,
     /* 310540 */   // Label 6280: @310540
     /* 310540 */   GIM_Reject,
     /* 310541 */ // Label 6268: @310541
     /* 310541 */ GIM_Reject,
     /* 310542 */ // Label 6260: @310542
     /* 310542 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(311564),
     /* 310547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310554 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(310712), // Rule ID 4853 //
     /* 310559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 310578 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 310582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310603 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 310611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310615 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310619 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310623 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310628 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310639 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 310639 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310642 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310646 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310651 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 310657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310679 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 310685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 310698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310710 */     GIR_RootConstrainSelectedInstOperands,
     /* 310711 */     // GIR_Coverage, 4853,
     /* 310711 */     GIR_EraseRootFromParent_Done,
     /* 310712 */   // Label 6282: @310712
     /* 310712 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(310870), // Rule ID 4852 //
     /* 310717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 310736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 310740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310761 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 310769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310786 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310797 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 310797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310809 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 310815 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310820 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310837 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 310843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 310856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310868 */     GIR_RootConstrainSelectedInstOperands,
     /* 310869 */     // GIR_Coverage, 4852,
     /* 310869 */     GIR_EraseRootFromParent_Done,
     /* 310870 */   // Label 6283: @310870
     /* 310870 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(310981), // Rule ID 4851 //
     /* 310875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 310894 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 310898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310919 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310935 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 310935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 310953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 310966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310979 */     GIR_RootConstrainSelectedInstOperands,
     /* 310980 */     // GIR_Coverage, 4851,
     /* 310980 */     GIR_EraseRootFromParent_Done,
     /* 310981 */   // Label 6284: @310981
     /* 310981 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(311092), // Rule ID 4849 //
     /* 310986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311005 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311035 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311046 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311058 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311090 */     GIR_RootConstrainSelectedInstOperands,
     /* 311091 */     // GIR_Coverage, 4849,
     /* 311091 */     GIR_EraseRootFromParent_Done,
     /* 311092 */   // Label 6285: @311092
     /* 311092 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(311203), // Rule ID 4850 //
     /* 311097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 311108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311116 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311141 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311157 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 311157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311169 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311201 */     GIR_RootConstrainSelectedInstOperands,
     /* 311202 */     // GIR_Coverage, 4850,
     /* 311202 */     GIR_EraseRootFromParent_Done,
     /* 311203 */   // Label 6286: @311203
     /* 311203 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(311314), // Rule ID 4848 //
     /* 311208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 311219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311227 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311257 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311268 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311280 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311312 */     GIR_RootConstrainSelectedInstOperands,
     /* 311313 */     // GIR_Coverage, 4848,
     /* 311313 */     GIR_EraseRootFromParent_Done,
     /* 311314 */   // Label 6287: @311314
     /* 311314 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(311378), // Rule ID 652 //
     /* 311319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 311330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311338 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311359 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 311359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311376 */     GIR_RootConstrainSelectedInstOperands,
     /* 311377 */     // GIR_Coverage, 652,
     /* 311377 */     GIR_EraseRootFromParent_Done,
     /* 311378 */   // Label 6288: @311378
     /* 311378 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(311442), // Rule ID 651 //
     /* 311383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 311394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 311406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311423 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 311423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 311426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311440 */     GIR_RootConstrainSelectedInstOperands,
     /* 311441 */     // GIR_Coverage, 651,
     /* 311441 */     GIR_EraseRootFromParent_Done,
     /* 311442 */   // Label 6289: @311442
     /* 311442 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(311493), // Rule ID 628 //
     /* 311447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 311458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311478 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 311478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 311481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311491 */     GIR_RootConstrainSelectedInstOperands,
     /* 311492 */     // GIR_Coverage, 628,
     /* 311492 */     GIR_EraseRootFromParent_Done,
     /* 311493 */   // Label 6290: @311493
     /* 311493 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(311544), // Rule ID 627 //
     /* 311498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 311509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311529 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 311529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 311532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311542 */     GIR_RootConstrainSelectedInstOperands,
     /* 311543 */     // GIR_Coverage, 627,
     /* 311543 */     GIR_EraseRootFromParent_Done,
     /* 311544 */   // Label 6291: @311544
     /* 311544 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(311563), // Rule ID 525 //
     /* 311549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311556 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 311556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 311561 */     GIR_RootConstrainSelectedInstOperands,
     /* 311562 */     // GIR_Coverage, 525,
     /* 311562 */     GIR_Done,
     /* 311563 */   // Label 6292: @311563
     /* 311563 */   GIM_Reject,
     /* 311564 */ // Label 6281: @311564
     /* 311564 */ GIM_Reject,
     /* 311565 */ // Label 6261: @311565
     /* 311565 */ GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(312587),
     /* 311570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311577 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(311735), // Rule ID 4859 //
     /* 311582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 311593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311601 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 311605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311626 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 311634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311642 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311646 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311651 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311662 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 311662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311674 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 311680 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311702 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 311708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 311721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311733 */     GIR_RootConstrainSelectedInstOperands,
     /* 311734 */     // GIR_Coverage, 4859,
     /* 311734 */     GIR_EraseRootFromParent_Done,
     /* 311735 */   // Label 6294: @311735
     /* 311735 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(311893), // Rule ID 4858 //
     /* 311740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 311751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 311763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311784 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 311792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311804 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311809 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311820 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 311820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311832 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 311838 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311860 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 311866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 311879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 311891 */     GIR_RootConstrainSelectedInstOperands,
     /* 311892 */     // GIR_Coverage, 4858,
     /* 311892 */     GIR_EraseRootFromParent_Done,
     /* 311893 */   // Label 6295: @311893
     /* 311893 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(312004), // Rule ID 4857 //
     /* 311898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 311909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311917 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 311921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311942 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311958 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 311958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311970 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 311976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 311989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312002 */     GIR_RootConstrainSelectedInstOperands,
     /* 312003 */     // GIR_Coverage, 4857,
     /* 312003 */     GIR_EraseRootFromParent_Done,
     /* 312004 */   // Label 6296: @312004
     /* 312004 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(312115), // Rule ID 4855 //
     /* 312009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 312020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312028 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312069 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 312069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312081 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 312087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312113 */     GIR_RootConstrainSelectedInstOperands,
     /* 312114 */     // GIR_Coverage, 4855,
     /* 312114 */     GIR_EraseRootFromParent_Done,
     /* 312115 */   // Label 6297: @312115
     /* 312115 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(312226), // Rule ID 4856 //
     /* 312120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 312131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312139 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312164 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312180 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 312180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312192 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 312198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312224 */     GIR_RootConstrainSelectedInstOperands,
     /* 312225 */     // GIR_Coverage, 4856,
     /* 312225 */     GIR_EraseRootFromParent_Done,
     /* 312226 */   // Label 6298: @312226
     /* 312226 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(312337), // Rule ID 4854 //
     /* 312231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 312242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312250 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312280 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312291 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 312291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312303 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 312309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312335 */     GIR_RootConstrainSelectedInstOperands,
     /* 312336 */     // GIR_Coverage, 4854,
     /* 312336 */     GIR_EraseRootFromParent_Done,
     /* 312337 */   // Label 6299: @312337
     /* 312337 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(312401), // Rule ID 654 //
     /* 312342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 312353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312361 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312382 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 312382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312399 */     GIR_RootConstrainSelectedInstOperands,
     /* 312400 */     // GIR_Coverage, 654,
     /* 312400 */     GIR_EraseRootFromParent_Done,
     /* 312401 */   // Label 6300: @312401
     /* 312401 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(312465), // Rule ID 653 //
     /* 312406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 312417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312425 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 312429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312446 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 312446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 312449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 312463 */     GIR_RootConstrainSelectedInstOperands,
     /* 312464 */     // GIR_Coverage, 653,
     /* 312464 */     GIR_EraseRootFromParent_Done,
     /* 312465 */   // Label 6301: @312465
     /* 312465 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(312516), // Rule ID 630 //
     /* 312470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 312481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312501 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 312504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312514 */     GIR_RootConstrainSelectedInstOperands,
     /* 312515 */     // GIR_Coverage, 630,
     /* 312515 */     GIR_EraseRootFromParent_Done,
     /* 312516 */   // Label 6302: @312516
     /* 312516 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(312567), // Rule ID 629 //
     /* 312521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 312532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312552 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 312555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 312565 */     GIR_RootConstrainSelectedInstOperands,
     /* 312566 */     // GIR_Coverage, 629,
     /* 312566 */     GIR_EraseRootFromParent_Done,
     /* 312567 */   // Label 6303: @312567
     /* 312567 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(312586), // Rule ID 526 //
     /* 312572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312579 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 312579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 312584 */     GIR_RootConstrainSelectedInstOperands,
     /* 312585 */     // GIR_Coverage, 526,
     /* 312585 */     GIR_Done,
     /* 312586 */   // Label 6304: @312586
     /* 312586 */   GIM_Reject,
     /* 312587 */ // Label 6293: @312587
     /* 312587 */ GIM_Reject,
     /* 312588 */ // Label 6262: @312588
     /* 312588 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(312614), // Rule ID 860 //
     /* 312593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312607 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 312607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 312612 */   GIR_RootConstrainSelectedInstOperands,
     /* 312613 */   // GIR_Coverage, 860,
     /* 312613 */   GIR_Done,
     /* 312614 */ // Label 6305: @312614
     /* 312614 */ GIM_Reject,
     /* 312615 */ // Label 6263: @312615
     /* 312615 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(312641), // Rule ID 862 //
     /* 312620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312634 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 312634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 312639 */   GIR_RootConstrainSelectedInstOperands,
     /* 312640 */   // GIR_Coverage, 862,
     /* 312640 */   GIR_Done,
     /* 312641 */ // Label 6306: @312641
     /* 312641 */ GIM_Reject,
     /* 312642 */ // Label 6264: @312642
     /* 312642 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(312721),
     /* 312647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312658 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(312673), // Rule ID 858 //
     /* 312663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312666 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 312666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 312671 */     GIR_RootConstrainSelectedInstOperands,
     /* 312672 */     // GIR_Coverage, 858,
     /* 312672 */     GIR_Done,
     /* 312673 */   // Label 6308: @312673
     /* 312673 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(312720), // Rule ID 6384 //
     /* 312678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312681 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 312681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 312688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312693 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 312703 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 312706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 312711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312718 */     GIR_RootConstrainSelectedInstOperands,
     /* 312719 */     // GIR_Coverage, 6384,
     /* 312719 */     GIR_EraseRootFromParent_Done,
     /* 312720 */   // Label 6309: @312720
     /* 312720 */   GIM_Reject,
     /* 312721 */ // Label 6307: @312721
     /* 312721 */ GIM_Reject,
     /* 312722 */ // Label 6265: @312722
     /* 312722 */ GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(312748), // Rule ID 861 //
     /* 312727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312741 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 312741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 312746 */   GIR_RootConstrainSelectedInstOperands,
     /* 312747 */   // GIR_Coverage, 861,
     /* 312747 */   GIR_Done,
     /* 312748 */ // Label 6310: @312748
     /* 312748 */ GIM_Reject,
     /* 312749 */ // Label 6266: @312749
     /* 312749 */ GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(312828),
     /* 312754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312765 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(312780), // Rule ID 859 //
     /* 312770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312773 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 312773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 312778 */     GIR_RootConstrainSelectedInstOperands,
     /* 312779 */     // GIR_Coverage, 859,
     /* 312779 */     GIR_Done,
     /* 312780 */   // Label 6312: @312780
     /* 312780 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(312827), // Rule ID 6385 //
     /* 312785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312788 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 312788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 312795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312800 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 312810 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 312813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 312818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312825 */     GIR_RootConstrainSelectedInstOperands,
     /* 312826 */     // GIR_Coverage, 6385,
     /* 312826 */     GIR_EraseRootFromParent_Done,
     /* 312827 */   // Label 6313: @312827
     /* 312827 */   GIM_Reject,
     /* 312828 */ // Label 6311: @312828
     /* 312828 */ GIM_Reject,
     /* 312829 */ // Label 6267: @312829
     /* 312829 */ GIM_Reject,
     /* 312830 */ // Label 65: @312830
     /* 312830 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6318*/ GIMT_Encode4(313077),
     /* 312841 */ /*GILLT_s32*//*Label 6314*/ GIMT_Encode4(312869),
     /* 312845 */ /*GILLT_s64*//*Label 6315*/ GIMT_Encode4(312900), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 312857 */ /*GILLT_v2s64*//*Label 6316*/ GIMT_Encode4(312961), GIMT_Encode4(0),
     /* 312865 */ /*GILLT_v4s32*//*Label 6317*/ GIMT_Encode4(313019),
     /* 312869 */ // Label 6314: @312869
     /* 312869 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(312899), // Rule ID 516 //
     /* 312874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312888 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 312888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 312893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312897 */   GIR_RootConstrainSelectedInstOperands,
     /* 312898 */   // GIR_Coverage, 516,
     /* 312898 */   GIR_Done,
     /* 312899 */ // Label 6319: @312899
     /* 312899 */ GIM_Reject,
     /* 312900 */ // Label 6315: @312900
     /* 312900 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(312930), // Rule ID 514 //
     /* 312905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312919 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 312919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 312924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312928 */   GIR_RootConstrainSelectedInstOperands,
     /* 312929 */   // GIR_Coverage, 514,
     /* 312929 */   GIR_Done,
     /* 312930 */ // Label 6320: @312930
     /* 312930 */ GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(312960), // Rule ID 518 //
     /* 312935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312949 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 312949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 312954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312958 */   GIR_RootConstrainSelectedInstOperands,
     /* 312959 */   // GIR_Coverage, 518,
     /* 312959 */   GIR_Done,
     /* 312960 */ // Label 6321: @312960
     /* 312960 */ GIM_Reject,
     /* 312961 */ // Label 6316: @312961
     /* 312961 */ GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(313018),
     /* 312966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312973 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(312997), // Rule ID 4902 //
     /* 312978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 312985 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 312985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 312988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312995 */     GIR_RootConstrainSelectedInstOperands,
     /* 312996 */     // GIR_Coverage, 4902,
     /* 312996 */     GIR_EraseRootFromParent_Done,
     /* 312997 */   // Label 6323: @312997
     /* 312997 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(313017), // Rule ID 4900 //
     /* 313002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313006 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 313006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 313011 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313015 */     GIR_RootConstrainSelectedInstOperands,
     /* 313016 */     // GIR_Coverage, 4900,
     /* 313016 */     GIR_Done,
     /* 313017 */   // Label 6324: @313017
     /* 313017 */   GIM_Reject,
     /* 313018 */ // Label 6322: @313018
     /* 313018 */ GIM_Reject,
     /* 313019 */ // Label 6317: @313019
     /* 313019 */ GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(313076),
     /* 313024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313031 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(313055), // Rule ID 4906 //
     /* 313036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 313043 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 313043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 313046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313053 */     GIR_RootConstrainSelectedInstOperands,
     /* 313054 */     // GIR_Coverage, 4906,
     /* 313054 */     GIR_EraseRootFromParent_Done,
     /* 313055 */   // Label 6326: @313055
     /* 313055 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(313075), // Rule ID 4904 //
     /* 313060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313064 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 313064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 313069 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313073 */     GIR_RootConstrainSelectedInstOperands,
     /* 313074 */     // GIR_Coverage, 4904,
     /* 313074 */     GIR_Done,
     /* 313075 */   // Label 6327: @313075
     /* 313075 */   GIM_Reject,
     /* 313076 */ // Label 6325: @313076
     /* 313076 */ GIM_Reject,
     /* 313077 */ // Label 6318: @313077
     /* 313077 */ GIM_Reject,
     /* 313078 */ // Label 66: @313078
     /* 313078 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6332*/ GIMT_Encode4(313265),
     /* 313089 */ /*GILLT_s16*//*Label 6328*/ GIMT_Encode4(313117),
     /* 313093 */ /*GILLT_s32*//*Label 6329*/ GIMT_Encode4(313178), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 313105 */ /*GILLT_v2s32*//*Label 6330*/ GIMT_Encode4(313209), GIMT_Encode4(0),
     /* 313113 */ /*GILLT_v4s16*//*Label 6331*/ GIMT_Encode4(313237),
     /* 313117 */ // Label 6328: @313117
     /* 313117 */ GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(313147), // Rule ID 510 //
     /* 313122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313136 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 313136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 313141 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313145 */   GIR_RootConstrainSelectedInstOperands,
     /* 313146 */   // GIR_Coverage, 510,
     /* 313146 */   GIR_Done,
     /* 313147 */ // Label 6333: @313147
     /* 313147 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(313177), // Rule ID 520 //
     /* 313152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313166 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 313166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 313171 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313175 */   GIR_RootConstrainSelectedInstOperands,
     /* 313176 */   // GIR_Coverage, 520,
     /* 313176 */   GIR_Done,
     /* 313177 */ // Label 6334: @313177
     /* 313177 */ GIM_Reject,
     /* 313178 */ // Label 6329: @313178
     /* 313178 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(313208), // Rule ID 512 //
     /* 313183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313197 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 313197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 313202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313206 */   GIR_RootConstrainSelectedInstOperands,
     /* 313207 */   // GIR_Coverage, 512,
     /* 313207 */   GIR_Done,
     /* 313208 */ // Label 6335: @313208
     /* 313208 */ GIM_Reject,
     /* 313209 */ // Label 6330: @313209
     /* 313209 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(313236), // Rule ID 4910 //
     /* 313214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313225 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 313225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 313230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313234 */   GIR_RootConstrainSelectedInstOperands,
     /* 313235 */   // GIR_Coverage, 4910,
     /* 313235 */   GIR_Done,
     /* 313236 */ // Label 6336: @313236
     /* 313236 */ GIM_Reject,
     /* 313237 */ // Label 6331: @313237
     /* 313237 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(313264), // Rule ID 4912 //
     /* 313242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313253 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 313253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 313258 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313262 */   GIR_RootConstrainSelectedInstOperands,
     /* 313263 */   // GIR_Coverage, 4912,
     /* 313263 */   GIR_Done,
     /* 313264 */ // Label 6337: @313264
     /* 313264 */ GIM_Reject,
     /* 313265 */ // Label 6332: @313265
     /* 313265 */ GIM_Reject,
     /* 313266 */ // Label 67: @313266
     /* 313266 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6345*/ GIMT_Encode4(314242),
     /* 313277 */ /*GILLT_s32*//*Label 6338*/ GIMT_Encode4(313313),
     /* 313281 */ /*GILLT_s64*//*Label 6339*/ GIMT_Encode4(313700), GIMT_Encode4(0),
     /* 313289 */ /*GILLT_v2s32*//*Label 6340*/ GIMT_Encode4(314087),
     /* 313293 */ /*GILLT_v2s64*//*Label 6341*/ GIMT_Encode4(314118),
     /* 313297 */ /*GILLT_v4s16*//*Label 6342*/ GIMT_Encode4(314149),
     /* 313301 */ /*GILLT_v4s32*//*Label 6343*/ GIMT_Encode4(314180), GIMT_Encode4(0),
     /* 313309 */ /*GILLT_v8s16*//*Label 6344*/ GIMT_Encode4(314211),
     /* 313313 */ // Label 6338: @313313
     /* 313313 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(313350), // Rule ID 4649 //
     /* 313318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313325 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313329 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313333 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313337 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313339 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 313342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313344 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313348 */   GIR_RootConstrainSelectedInstOperands,
     /* 313349 */   // GIR_Coverage, 4649,
     /* 313349 */   GIR_EraseRootFromParent_Done,
     /* 313350 */ // Label 6346: @313350
     /* 313350 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(313387), // Rule ID 4651 //
     /* 313355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313370 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313376 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 313379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313381 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313385 */   GIR_RootConstrainSelectedInstOperands,
     /* 313386 */   // GIR_Coverage, 4651,
     /* 313386 */   GIR_EraseRootFromParent_Done,
     /* 313387 */ // Label 6347: @313387
     /* 313387 */ GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(313424), // Rule ID 4669 //
     /* 313392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313399 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313407 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313411 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313413 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 313416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313418 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313422 */   GIR_RootConstrainSelectedInstOperands,
     /* 313423 */   // GIR_Coverage, 4669,
     /* 313423 */   GIR_EraseRootFromParent_Done,
     /* 313424 */ // Label 6348: @313424
     /* 313424 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(313461), // Rule ID 4671 //
     /* 313429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313444 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313450 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 313453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313455 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313459 */   GIR_RootConstrainSelectedInstOperands,
     /* 313460 */   // GIR_Coverage, 4671,
     /* 313460 */   GIR_EraseRootFromParent_Done,
     /* 313461 */ // Label 6349: @313461
     /* 313461 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(313498), // Rule ID 4709 //
     /* 313466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313473 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313477 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313481 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313487 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 313490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313492 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313496 */   GIR_RootConstrainSelectedInstOperands,
     /* 313497 */   // GIR_Coverage, 4709,
     /* 313497 */   GIR_EraseRootFromParent_Done,
     /* 313498 */ // Label 6350: @313498
     /* 313498 */ GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(313535), // Rule ID 4711 //
     /* 313503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313518 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313524 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 313527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313529 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313533 */   GIR_RootConstrainSelectedInstOperands,
     /* 313534 */   // GIR_Coverage, 4711,
     /* 313534 */   GIR_EraseRootFromParent_Done,
     /* 313535 */ // Label 6351: @313535
     /* 313535 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(313572), // Rule ID 4689 //
     /* 313540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313547 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313551 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313555 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313559 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313561 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 313564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313566 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313570 */   GIR_RootConstrainSelectedInstOperands,
     /* 313571 */   // GIR_Coverage, 4689,
     /* 313571 */   GIR_EraseRootFromParent_Done,
     /* 313572 */ // Label 6352: @313572
     /* 313572 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(313609), // Rule ID 4691 //
     /* 313577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313592 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313596 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313598 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 313601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313603 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313607 */   GIR_RootConstrainSelectedInstOperands,
     /* 313608 */   // GIR_Coverage, 4691,
     /* 313608 */   GIR_EraseRootFromParent_Done,
     /* 313609 */ // Label 6353: @313609
     /* 313609 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(313639), // Rule ID 395 //
     /* 313614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313628 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 313628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 313633 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313637 */   GIR_RootConstrainSelectedInstOperands,
     /* 313638 */   // GIR_Coverage, 395,
     /* 313638 */   GIR_Done,
     /* 313639 */ // Label 6354: @313639
     /* 313639 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(313669), // Rule ID 399 //
     /* 313644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313658 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 313658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 313663 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313667 */   GIR_RootConstrainSelectedInstOperands,
     /* 313668 */   // GIR_Coverage, 399,
     /* 313668 */   GIR_Done,
     /* 313669 */ // Label 6355: @313669
     /* 313669 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(313699), // Rule ID 403 //
     /* 313674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313688 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 313688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 313693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313697 */   GIR_RootConstrainSelectedInstOperands,
     /* 313698 */   // GIR_Coverage, 403,
     /* 313698 */   GIR_Done,
     /* 313699 */ // Label 6356: @313699
     /* 313699 */ GIM_Reject,
     /* 313700 */ // Label 6339: @313700
     /* 313700 */ GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(313737), // Rule ID 4650 //
     /* 313705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313712 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313716 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313720 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313724 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313726 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 313729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313731 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313735 */   GIR_RootConstrainSelectedInstOperands,
     /* 313736 */   // GIR_Coverage, 4650,
     /* 313736 */   GIR_EraseRootFromParent_Done,
     /* 313737 */ // Label 6357: @313737
     /* 313737 */ GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(313774), // Rule ID 4652 //
     /* 313742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313749 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313753 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313757 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313763 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 313766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313768 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313772 */   GIR_RootConstrainSelectedInstOperands,
     /* 313773 */   // GIR_Coverage, 4652,
     /* 313773 */   GIR_EraseRootFromParent_Done,
     /* 313774 */ // Label 6358: @313774
     /* 313774 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(313811), // Rule ID 4670 //
     /* 313779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313786 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313794 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313798 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313800 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 313803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313805 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313809 */   GIR_RootConstrainSelectedInstOperands,
     /* 313810 */   // GIR_Coverage, 4670,
     /* 313810 */   GIR_EraseRootFromParent_Done,
     /* 313811 */ // Label 6359: @313811
     /* 313811 */ GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(313848), // Rule ID 4672 //
     /* 313816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313823 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313827 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313831 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313835 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313837 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 313840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313842 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313846 */   GIR_RootConstrainSelectedInstOperands,
     /* 313847 */   // GIR_Coverage, 4672,
     /* 313847 */   GIR_EraseRootFromParent_Done,
     /* 313848 */ // Label 6360: @313848
     /* 313848 */ GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(313885), // Rule ID 4710 //
     /* 313853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313860 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313868 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313874 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 313877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313879 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313883 */   GIR_RootConstrainSelectedInstOperands,
     /* 313884 */   // GIR_Coverage, 4710,
     /* 313884 */   GIR_EraseRootFromParent_Done,
     /* 313885 */ // Label 6361: @313885
     /* 313885 */ GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(313922), // Rule ID 4712 //
     /* 313890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313897 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313905 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313911 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 313914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313916 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313920 */   GIR_RootConstrainSelectedInstOperands,
     /* 313921 */   // GIR_Coverage, 4712,
     /* 313921 */   GIR_EraseRootFromParent_Done,
     /* 313922 */ // Label 6362: @313922
     /* 313922 */ GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(313959), // Rule ID 4690 //
     /* 313927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313948 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 313951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313953 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313957 */   GIR_RootConstrainSelectedInstOperands,
     /* 313958 */   // GIR_Coverage, 4690,
     /* 313958 */   GIR_EraseRootFromParent_Done,
     /* 313959 */ // Label 6363: @313959
     /* 313959 */ GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(313996), // Rule ID 4692 //
     /* 313964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313971 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313979 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313983 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313985 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 313988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313990 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313994 */   GIR_RootConstrainSelectedInstOperands,
     /* 313995 */   // GIR_Coverage, 4692,
     /* 313995 */   GIR_EraseRootFromParent_Done,
     /* 313996 */ // Label 6364: @313996
     /* 313996 */ GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(314026), // Rule ID 397 //
     /* 314001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314015 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 314015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 314020 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314024 */   GIR_RootConstrainSelectedInstOperands,
     /* 314025 */   // GIR_Coverage, 397,
     /* 314025 */   GIR_Done,
     /* 314026 */ // Label 6365: @314026
     /* 314026 */ GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(314056), // Rule ID 401 //
     /* 314031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314045 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 314045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 314050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314054 */   GIR_RootConstrainSelectedInstOperands,
     /* 314055 */   // GIR_Coverage, 401,
     /* 314055 */   GIR_Done,
     /* 314056 */ // Label 6366: @314056
     /* 314056 */ GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(314086), // Rule ID 405 //
     /* 314061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314075 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 314075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 314080 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314084 */   GIR_RootConstrainSelectedInstOperands,
     /* 314085 */   // GIR_Coverage, 405,
     /* 314085 */   GIR_Done,
     /* 314086 */ // Label 6367: @314086
     /* 314086 */ GIM_Reject,
     /* 314087 */ // Label 6340: @314087
     /* 314087 */ GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(314117), // Rule ID 843 //
     /* 314092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314106 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 314106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 314111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314115 */   GIR_RootConstrainSelectedInstOperands,
     /* 314116 */   // GIR_Coverage, 843,
     /* 314116 */   GIR_Done,
     /* 314117 */ // Label 6368: @314117
     /* 314117 */ GIM_Reject,
     /* 314118 */ // Label 6341: @314118
     /* 314118 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(314148), // Rule ID 847 //
     /* 314123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314137 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 314137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 314142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314146 */   GIR_RootConstrainSelectedInstOperands,
     /* 314147 */   // GIR_Coverage, 847,
     /* 314147 */   GIR_Done,
     /* 314148 */ // Label 6369: @314148
     /* 314148 */ GIM_Reject,
     /* 314149 */ // Label 6342: @314149
     /* 314149 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(314179), // Rule ID 839 //
     /* 314154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314168 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 314168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 314173 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314177 */   GIR_RootConstrainSelectedInstOperands,
     /* 314178 */   // GIR_Coverage, 839,
     /* 314178 */   GIR_Done,
     /* 314179 */ // Label 6370: @314179
     /* 314179 */ GIM_Reject,
     /* 314180 */ // Label 6343: @314180
     /* 314180 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(314210), // Rule ID 845 //
     /* 314185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314199 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 314199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 314204 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314208 */   GIR_RootConstrainSelectedInstOperands,
     /* 314209 */   // GIR_Coverage, 845,
     /* 314209 */   GIR_Done,
     /* 314210 */ // Label 6371: @314210
     /* 314210 */ GIM_Reject,
     /* 314211 */ // Label 6344: @314211
     /* 314211 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(314241), // Rule ID 841 //
     /* 314216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314230 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 314230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 314235 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314239 */   GIR_RootConstrainSelectedInstOperands,
     /* 314240 */   // GIR_Coverage, 841,
     /* 314240 */   GIR_Done,
     /* 314241 */ // Label 6372: @314241
     /* 314241 */ GIM_Reject,
     /* 314242 */ // Label 6345: @314242
     /* 314242 */ GIM_Reject,
     /* 314243 */ // Label 68: @314243
     /* 314243 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6380*/ GIMT_Encode4(315219),
     /* 314254 */ /*GILLT_s32*//*Label 6373*/ GIMT_Encode4(314290),
     /* 314258 */ /*GILLT_s64*//*Label 6374*/ GIMT_Encode4(314677), GIMT_Encode4(0),
     /* 314266 */ /*GILLT_v2s32*//*Label 6375*/ GIMT_Encode4(315064),
     /* 314270 */ /*GILLT_v2s64*//*Label 6376*/ GIMT_Encode4(315095),
     /* 314274 */ /*GILLT_v4s16*//*Label 6377*/ GIMT_Encode4(315126),
     /* 314278 */ /*GILLT_v4s32*//*Label 6378*/ GIMT_Encode4(315157), GIMT_Encode4(0),
     /* 314286 */ /*GILLT_v8s16*//*Label 6379*/ GIMT_Encode4(315188),
     /* 314290 */ // Label 6373: @314290
     /* 314290 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(314327), // Rule ID 4659 //
     /* 314295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 314310 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314316 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 314316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 314319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314321 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314325 */   GIR_RootConstrainSelectedInstOperands,
     /* 314326 */   // GIR_Coverage, 4659,
     /* 314326 */   GIR_EraseRootFromParent_Done,
     /* 314327 */ // Label 6381: @314327
     /* 314327 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(314364), // Rule ID 4661 //
     /* 314332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 314347 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314353 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 314353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 314356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314358 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314362 */   GIR_RootConstrainSelectedInstOperands,
     /* 314363 */   // GIR_Coverage, 4661,
     /* 314363 */   GIR_EraseRootFromParent_Done,
     /* 314364 */ // Label 6382: @314364
     /* 314364 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(314401), // Rule ID 4679 //
     /* 314369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 314384 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314390 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 314390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 314393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314399 */   GIR_RootConstrainSelectedInstOperands,
     /* 314400 */   // GIR_Coverage, 4679,
     /* 314400 */   GIR_EraseRootFromParent_Done,
     /* 314401 */ // Label 6383: @314401
     /* 314401 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(314438), // Rule ID 4681 //
     /* 314406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 314421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314425 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314427 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 314427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 314430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314432 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314436 */   GIR_RootConstrainSelectedInstOperands,
     /* 314437 */   // GIR_Coverage, 4681,
     /* 314437 */   GIR_EraseRootFromParent_Done,
     /* 314438 */ // Label 6384: @314438
     /* 314438 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(314475), // Rule ID 4719 //
     /* 314443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314450 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 314458 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314464 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 314464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 314467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314469 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314473 */   GIR_RootConstrainSelectedInstOperands,
     /* 314474 */   // GIR_Coverage, 4719,
     /* 314474 */   GIR_EraseRootFromParent_Done,
     /* 314475 */ // Label 6385: @314475
     /* 314475 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(314512), // Rule ID 4721 //
     /* 314480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 314495 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314501 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 314501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 314504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314506 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314510 */   GIR_RootConstrainSelectedInstOperands,
     /* 314511 */   // GIR_Coverage, 4721,
     /* 314511 */   GIR_EraseRootFromParent_Done,
     /* 314512 */ // Label 6386: @314512
     /* 314512 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(314549), // Rule ID 4699 //
     /* 314517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314524 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314528 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 314532 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314536 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314538 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 314538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 314541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314543 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314547 */   GIR_RootConstrainSelectedInstOperands,
     /* 314548 */   // GIR_Coverage, 4699,
     /* 314548 */   GIR_EraseRootFromParent_Done,
     /* 314549 */ // Label 6387: @314549
     /* 314549 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(314586), // Rule ID 4701 //
     /* 314554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314561 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314565 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 314569 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314575 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 314575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 314578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314580 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314584 */   GIR_RootConstrainSelectedInstOperands,
     /* 314585 */   // GIR_Coverage, 4701,
     /* 314585 */   GIR_EraseRootFromParent_Done,
     /* 314586 */ // Label 6388: @314586
     /* 314586 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(314616), // Rule ID 407 //
     /* 314591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314605 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 314605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 314610 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314614 */   GIR_RootConstrainSelectedInstOperands,
     /* 314615 */   // GIR_Coverage, 407,
     /* 314615 */   GIR_Done,
     /* 314616 */ // Label 6389: @314616
     /* 314616 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(314646), // Rule ID 411 //
     /* 314621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314635 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 314635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 314640 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314644 */   GIR_RootConstrainSelectedInstOperands,
     /* 314645 */   // GIR_Coverage, 411,
     /* 314645 */   GIR_Done,
     /* 314646 */ // Label 6390: @314646
     /* 314646 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(314676), // Rule ID 415 //
     /* 314651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314665 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 314665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 314670 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314674 */   GIR_RootConstrainSelectedInstOperands,
     /* 314675 */   // GIR_Coverage, 415,
     /* 314675 */   GIR_Done,
     /* 314676 */ // Label 6391: @314676
     /* 314676 */ GIM_Reject,
     /* 314677 */ // Label 6374: @314677
     /* 314677 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(314714), // Rule ID 4660 //
     /* 314682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 314697 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314703 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 314703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 314706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314708 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314712 */   GIR_RootConstrainSelectedInstOperands,
     /* 314713 */   // GIR_Coverage, 4660,
     /* 314713 */   GIR_EraseRootFromParent_Done,
     /* 314714 */ // Label 6392: @314714
     /* 314714 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(314751), // Rule ID 4662 //
     /* 314719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 314734 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314738 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314740 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 314740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 314743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314745 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314749 */   GIR_RootConstrainSelectedInstOperands,
     /* 314750 */   // GIR_Coverage, 4662,
     /* 314750 */   GIR_EraseRootFromParent_Done,
     /* 314751 */ // Label 6393: @314751
     /* 314751 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(314788), // Rule ID 4680 //
     /* 314756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 314771 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314777 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 314777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 314780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314782 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314786 */   GIR_RootConstrainSelectedInstOperands,
     /* 314787 */   // GIR_Coverage, 4680,
     /* 314787 */   GIR_EraseRootFromParent_Done,
     /* 314788 */ // Label 6394: @314788
     /* 314788 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(314825), // Rule ID 4682 //
     /* 314793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 314808 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314814 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 314814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 314817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314819 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314823 */   GIR_RootConstrainSelectedInstOperands,
     /* 314824 */   // GIR_Coverage, 4682,
     /* 314824 */   GIR_EraseRootFromParent_Done,
     /* 314825 */ // Label 6395: @314825
     /* 314825 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(314862), // Rule ID 4720 //
     /* 314830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 314845 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314849 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314851 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 314851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 314854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314856 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314860 */   GIR_RootConstrainSelectedInstOperands,
     /* 314861 */   // GIR_Coverage, 4720,
     /* 314861 */   GIR_EraseRootFromParent_Done,
     /* 314862 */ // Label 6396: @314862
     /* 314862 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(314899), // Rule ID 4722 //
     /* 314867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 314882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314886 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314888 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 314888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 314891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314893 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314897 */   GIR_RootConstrainSelectedInstOperands,
     /* 314898 */   // GIR_Coverage, 4722,
     /* 314898 */   GIR_EraseRootFromParent_Done,
     /* 314899 */ // Label 6397: @314899
     /* 314899 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(314936), // Rule ID 4700 //
     /* 314904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 314919 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314925 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 314925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 314928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314930 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314934 */   GIR_RootConstrainSelectedInstOperands,
     /* 314935 */   // GIR_Coverage, 4700,
     /* 314935 */   GIR_EraseRootFromParent_Done,
     /* 314936 */ // Label 6398: @314936
     /* 314936 */ GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(314973), // Rule ID 4702 //
     /* 314941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314948 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 314956 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314960 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314962 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 314962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 314965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314967 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314971 */   GIR_RootConstrainSelectedInstOperands,
     /* 314972 */   // GIR_Coverage, 4702,
     /* 314972 */   GIR_EraseRootFromParent_Done,
     /* 314973 */ // Label 6399: @314973
     /* 314973 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(315003), // Rule ID 409 //
     /* 314978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314992 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 314992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 314997 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315001 */   GIR_RootConstrainSelectedInstOperands,
     /* 315002 */   // GIR_Coverage, 409,
     /* 315002 */   GIR_Done,
     /* 315003 */ // Label 6400: @315003
     /* 315003 */ GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(315033), // Rule ID 413 //
     /* 315008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315022 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 315022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 315027 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315031 */   GIR_RootConstrainSelectedInstOperands,
     /* 315032 */   // GIR_Coverage, 413,
     /* 315032 */   GIR_Done,
     /* 315033 */ // Label 6401: @315033
     /* 315033 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(315063), // Rule ID 417 //
     /* 315038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315052 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 315052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 315057 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315061 */   GIR_RootConstrainSelectedInstOperands,
     /* 315062 */   // GIR_Coverage, 417,
     /* 315062 */   GIR_Done,
     /* 315063 */ // Label 6402: @315063
     /* 315063 */ GIM_Reject,
     /* 315064 */ // Label 6375: @315064
     /* 315064 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(315094), // Rule ID 853 //
     /* 315069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315083 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 315083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 315088 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315092 */   GIR_RootConstrainSelectedInstOperands,
     /* 315093 */   // GIR_Coverage, 853,
     /* 315093 */   GIR_Done,
     /* 315094 */ // Label 6403: @315094
     /* 315094 */ GIM_Reject,
     /* 315095 */ // Label 6376: @315095
     /* 315095 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(315125), // Rule ID 857 //
     /* 315100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315114 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 315114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 315119 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315123 */   GIR_RootConstrainSelectedInstOperands,
     /* 315124 */   // GIR_Coverage, 857,
     /* 315124 */   GIR_Done,
     /* 315125 */ // Label 6404: @315125
     /* 315125 */ GIM_Reject,
     /* 315126 */ // Label 6377: @315126
     /* 315126 */ GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(315156), // Rule ID 849 //
     /* 315131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315145 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 315145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 315150 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315154 */   GIR_RootConstrainSelectedInstOperands,
     /* 315155 */   // GIR_Coverage, 849,
     /* 315155 */   GIR_Done,
     /* 315156 */ // Label 6405: @315156
     /* 315156 */ GIM_Reject,
     /* 315157 */ // Label 6378: @315157
     /* 315157 */ GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(315187), // Rule ID 855 //
     /* 315162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315176 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 315176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 315181 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315185 */   GIR_RootConstrainSelectedInstOperands,
     /* 315186 */   // GIR_Coverage, 855,
     /* 315186 */   GIR_Done,
     /* 315187 */ // Label 6406: @315187
     /* 315187 */ GIM_Reject,
     /* 315188 */ // Label 6379: @315188
     /* 315188 */ GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(315218), // Rule ID 851 //
     /* 315193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315207 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 315207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 315212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315216 */   GIR_RootConstrainSelectedInstOperands,
     /* 315217 */   // GIR_Coverage, 851,
     /* 315217 */   GIR_Done,
     /* 315218 */ // Label 6407: @315218
     /* 315218 */ GIM_Reject,
     /* 315219 */ // Label 6380: @315219
     /* 315219 */ GIM_Reject,
     /* 315220 */ // Label 69: @315220
     /* 315220 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6416*/ GIMT_Encode4(319847),
     /* 315231 */ /*GILLT_s16*//*Label 6408*/ GIMT_Encode4(315271),
     /* 315235 */ /*GILLT_s32*//*Label 6409*/ GIMT_Encode4(315712),
     /* 315239 */ /*GILLT_s64*//*Label 6410*/ GIMT_Encode4(317708), GIMT_Encode4(0),
     /* 315247 */ /*GILLT_v2s32*//*Label 6411*/ GIMT_Encode4(319692),
     /* 315251 */ /*GILLT_v2s64*//*Label 6412*/ GIMT_Encode4(319723),
     /* 315255 */ /*GILLT_v4s16*//*Label 6413*/ GIMT_Encode4(319754),
     /* 315259 */ /*GILLT_v4s32*//*Label 6414*/ GIMT_Encode4(319785), GIMT_Encode4(0),
     /* 315267 */ /*GILLT_v8s16*//*Label 6415*/ GIMT_Encode4(319816),
     /* 315271 */ // Label 6408: @315271
     /* 315271 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(315374), // Rule ID 5323 //
     /* 315276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 315279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 315294 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315298 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315302 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315306 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315310 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315314 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315319 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315323 */   // MIs[1] Operand 2
     /* 315323 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 315334 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315336 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 315336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 315339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315348 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 315354 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315359 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 315367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315372 */   GIR_RootConstrainSelectedInstOperands,
     /* 315373 */   // GIR_Coverage, 5323,
     /* 315373 */   GIR_EraseRootFromParent_Done,
     /* 315374 */ // Label 6417: @315374
     /* 315374 */ GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(315454), // Rule ID 2444 //
     /* 315379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315397 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315401 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315405 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315410 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315416 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 315416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315428 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315439 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 315447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315452 */   GIR_RootConstrainSelectedInstOperands,
     /* 315453 */   // GIR_Coverage, 2444,
     /* 315453 */   GIR_EraseRootFromParent_Done,
     /* 315454 */ // Label 6418: @315454
     /* 315454 */ GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(315534), // Rule ID 2448 //
     /* 315459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315477 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315481 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315485 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315490 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315496 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 315496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315508 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 315527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315532 */   GIR_RootConstrainSelectedInstOperands,
     /* 315533 */   // GIR_Coverage, 2448,
     /* 315533 */   GIR_EraseRootFromParent_Done,
     /* 315534 */ // Label 6419: @315534
     /* 315534 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(315591), // Rule ID 5314 //
     /* 315539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 315542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 315557 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315561 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315563 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 315563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 315566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 315570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315575 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 315581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 315584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315589 */   GIR_RootConstrainSelectedInstOperands,
     /* 315590 */   // GIR_Coverage, 5314,
     /* 315590 */   GIR_EraseRootFromParent_Done,
     /* 315591 */ // Label 6420: @315591
     /* 315591 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(315621), // Rule ID 443 //
     /* 315596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 315599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315610 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 315610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 315615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315619 */   GIR_RootConstrainSelectedInstOperands,
     /* 315620 */   // GIR_Coverage, 443,
     /* 315620 */   GIR_Done,
     /* 315621 */ // Label 6421: @315621
     /* 315621 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(315651), // Rule ID 449 //
     /* 315626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 315629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315640 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 315640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 315645 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315649 */   GIR_RootConstrainSelectedInstOperands,
     /* 315650 */   // GIR_Coverage, 449,
     /* 315650 */   GIR_Done,
     /* 315651 */ // Label 6422: @315651
     /* 315651 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(315681), // Rule ID 491 //
     /* 315656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315670 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 315670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 315675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315679 */   GIR_RootConstrainSelectedInstOperands,
     /* 315680 */   // GIR_Coverage, 491,
     /* 315680 */   GIR_Done,
     /* 315681 */ // Label 6423: @315681
     /* 315681 */ GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(315711), // Rule ID 495 //
     /* 315686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315700 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 315700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 315705 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315709 */   GIR_RootConstrainSelectedInstOperands,
     /* 315710 */   // GIR_Coverage, 495,
     /* 315710 */   GIR_Done,
     /* 315711 */ // Label 6424: @315711
     /* 315711 */ GIM_Reject,
     /* 315712 */ // Label 6409: @315712
     /* 315712 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(315950), // Rule ID 6386 //
     /* 315717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315735 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315738 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315745 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315751 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 315758 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 315758 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 315761 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 315765 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315785 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315792 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315795 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315799 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315806 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315809 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315813 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315818 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315821 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315824 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 315827 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315832 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315837 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 315842 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315845 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 315849 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315854 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315857 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315862 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315865 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315869 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315874 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315881 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315886 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315891 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315894 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315898 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315903 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315906 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315923 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 315930 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315935 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315948 */   GIR_RootConstrainSelectedInstOperands,
     /* 315949 */   // GIR_Coverage, 6386,
     /* 315949 */   GIR_EraseRootFromParent_Done,
     /* 315950 */ // Label 6425: @315950
     /* 315950 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(316188), // Rule ID 6387 //
     /* 315955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315973 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315976 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315983 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315987 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315989 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 315996 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 315996 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 315999 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 316003 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316023 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316030 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316033 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316037 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316044 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316047 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316051 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316056 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316059 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316062 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 316065 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316070 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316075 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 316080 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316083 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 316087 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316092 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316095 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316100 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316103 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316107 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316112 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316119 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316124 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316129 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316132 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316136 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316141 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316144 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316161 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 316168 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316173 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316186 */   GIR_RootConstrainSelectedInstOperands,
     /* 316187 */   // GIR_Coverage, 6387,
     /* 316187 */   GIR_EraseRootFromParent_Done,
     /* 316188 */ // Label 6426: @316188
     /* 316188 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(316377), // Rule ID 6390 //
     /* 316193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316211 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316214 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316221 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316225 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316227 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 316234 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316234 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 316237 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 316241 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316261 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316268 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316271 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316275 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316282 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316285 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316289 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316294 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316297 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316300 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 316303 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316308 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316313 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316318 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316321 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316325 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316330 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316333 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316350 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 316357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316375 */   GIR_RootConstrainSelectedInstOperands,
     /* 316376 */   // GIR_Coverage, 6390,
     /* 316376 */   GIR_EraseRootFromParent_Done,
     /* 316377 */ // Label 6427: @316377
     /* 316377 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(316566), // Rule ID 6391 //
     /* 316382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316400 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316403 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316410 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316416 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 316423 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316423 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 316426 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 316430 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316450 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316457 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316460 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316464 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316471 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316474 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316478 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316483 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316486 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316489 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 316492 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316497 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316502 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316519 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316522 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316539 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 316546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316564 */   GIR_RootConstrainSelectedInstOperands,
     /* 316565 */   // GIR_Coverage, 6391,
     /* 316565 */   GIR_EraseRootFromParent_Done,
     /* 316566 */ // Label 6428: @316566
     /* 316566 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(316799), // Rule ID 6388 //
     /* 316571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316589 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316592 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 316599 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316605 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 316612 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316612 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 316615 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 316619 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316634 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316641 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316644 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316648 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316655 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316658 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316662 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316667 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316670 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316673 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 316676 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316681 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316686 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 316691 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316694 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 316698 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316703 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316706 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316711 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316714 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316718 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316723 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316730 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316735 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316740 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316743 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316747 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316752 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316755 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316772 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 316779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316797 */   GIR_RootConstrainSelectedInstOperands,
     /* 316798 */   // GIR_Coverage, 6388,
     /* 316798 */   GIR_EraseRootFromParent_Done,
     /* 316799 */ // Label 6429: @316799
     /* 316799 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(317032), // Rule ID 6389 //
     /* 316804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316822 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316825 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 316832 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316838 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 316845 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 316845 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 316848 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 316852 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316867 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316874 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316877 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316881 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316888 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316891 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316895 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316900 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316903 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316906 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 316909 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316914 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316919 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 316924 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316927 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 316931 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316936 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316939 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316944 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316947 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316951 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316956 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316963 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316968 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316973 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316976 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316980 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316985 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316988 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317005 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 317012 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317017 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317030 */   GIR_RootConstrainSelectedInstOperands,
     /* 317031 */   // GIR_Coverage, 6389,
     /* 317031 */   GIR_EraseRootFromParent_Done,
     /* 317032 */ // Label 6430: @317032
     /* 317032 */ GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(317216), // Rule ID 6392 //
     /* 317037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 317055 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317058 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317065 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317071 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 317078 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 317078 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 317081 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 317085 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317100 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317107 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317110 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317114 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317121 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317124 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317128 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317133 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317136 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 317139 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 317142 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317147 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317152 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317157 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317160 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 317164 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317169 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317172 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317189 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 317196 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317214 */   GIR_RootConstrainSelectedInstOperands,
     /* 317215 */   // GIR_Coverage, 6392,
     /* 317215 */   GIR_EraseRootFromParent_Done,
     /* 317216 */ // Label 6431: @317216
     /* 317216 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(317400), // Rule ID 6393 //
     /* 317221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 317239 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317242 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317249 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317255 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 317262 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 317262 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 317265 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 317269 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317284 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317291 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317294 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317298 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317305 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317308 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317312 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317317 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317320 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 317323 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 317326 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317331 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317336 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317341 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317344 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 317348 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317353 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317356 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317373 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 317380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317385 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317398 */   GIR_RootConstrainSelectedInstOperands,
     /* 317399 */   // GIR_Coverage, 6393,
     /* 317399 */   GIR_EraseRootFromParent_Done,
     /* 317400 */ // Label 6432: @317400
     /* 317400 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(317480), // Rule ID 2450 //
     /* 317405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317423 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317427 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317431 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317436 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317440 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317442 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 317442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317454 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317460 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317465 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 317473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317478 */   GIR_RootConstrainSelectedInstOperands,
     /* 317479 */   // GIR_Coverage, 2450,
     /* 317479 */   GIR_EraseRootFromParent_Done,
     /* 317480 */ // Label 6433: @317480
     /* 317480 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(317560), // Rule ID 5319 //
     /* 317485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317503 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317507 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317511 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317516 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317522 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 317522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317534 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 317540 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317545 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317555 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317558 */   GIR_RootConstrainSelectedInstOperands,
     /* 317559 */   // GIR_Coverage, 5319,
     /* 317559 */   GIR_EraseRootFromParent_Done,
     /* 317560 */ // Label 6434: @317560
     /* 317560 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(317617), // Rule ID 5302 //
     /* 317565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317575 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317579 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 317583 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 317587 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317589 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 317589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 317596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317601 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 317610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317615 */   GIR_RootConstrainSelectedInstOperands,
     /* 317616 */   // GIR_Coverage, 5302,
     /* 317616 */   GIR_EraseRootFromParent_Done,
     /* 317617 */ // Label 6435: @317617
     /* 317617 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(317647), // Rule ID 445 //
     /* 317622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317636 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 317636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 317641 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317645 */   GIR_RootConstrainSelectedInstOperands,
     /* 317646 */   // GIR_Coverage, 445,
     /* 317646 */   GIR_Done,
     /* 317647 */ // Label 6436: @317647
     /* 317647 */ GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(317677), // Rule ID 451 //
     /* 317652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317666 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 317666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 317671 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317675 */   GIR_RootConstrainSelectedInstOperands,
     /* 317676 */   // GIR_Coverage, 451,
     /* 317676 */   GIR_Done,
     /* 317677 */ // Label 6437: @317677
     /* 317677 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(317707), // Rule ID 497 //
     /* 317682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317696 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 317696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 317701 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317705 */   GIR_RootConstrainSelectedInstOperands,
     /* 317706 */   // GIR_Coverage, 497,
     /* 317706 */   GIR_Done,
     /* 317707 */ // Label 6438: @317707
     /* 317707 */ GIM_Reject,
     /* 317708 */ // Label 6410: @317708
     /* 317708 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(317894), // Rule ID 6398 //
     /* 317713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 317731 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 317738 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317744 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 317751 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 317751 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 317754 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 317758 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 317778 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317785 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317788 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317792 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317799 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317802 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317806 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317811 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317814 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 317817 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 317820 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317825 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317830 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317835 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317838 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 317842 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317847 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317850 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317867 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317892 */   GIR_RootConstrainSelectedInstOperands,
     /* 317893 */   // GIR_Coverage, 6398,
     /* 317893 */   GIR_EraseRootFromParent_Done,
     /* 317894 */ // Label 6439: @317894
     /* 317894 */ GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(318080), // Rule ID 6399 //
     /* 317899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 317917 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 317924 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317930 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 317937 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 317937 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 317940 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 317944 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 317964 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317971 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317974 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317978 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317985 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317988 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317992 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317997 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 318000 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 318003 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 318006 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318011 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318033 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318036 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318041 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318044 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318048 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318053 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318060 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318078 */   GIR_RootConstrainSelectedInstOperands,
     /* 318079 */   // GIR_Coverage, 6399,
     /* 318079 */   GIR_EraseRootFromParent_Done,
     /* 318080 */ // Label 6440: @318080
     /* 318080 */ GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(318318), // Rule ID 6394 //
     /* 318085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 318103 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318106 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318113 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318119 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 318126 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318126 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 318129 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 318133 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 318153 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 318160 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 318163 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318167 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 318174 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 318177 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318181 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318186 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 318189 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 318192 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 318195 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318200 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318205 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318210 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 318213 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 318217 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318222 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 318225 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 318228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 318230 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 318233 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318237 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318242 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318249 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318254 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318259 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318262 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318266 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318271 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318274 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318291 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318316 */   GIR_RootConstrainSelectedInstOperands,
     /* 318317 */   // GIR_Coverage, 6394,
     /* 318317 */   GIR_EraseRootFromParent_Done,
     /* 318318 */ // Label 6441: @318318
     /* 318318 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(318556), // Rule ID 6395 //
     /* 318323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 318341 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318344 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318351 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318355 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318357 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 318364 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318364 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 318367 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 318371 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 318391 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 318398 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 318401 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318405 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 318412 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 318415 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318419 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318424 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 318427 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 318430 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 318433 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318438 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318443 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318448 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 318451 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 318455 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318460 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 318463 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 318466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 318468 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 318471 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318475 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318480 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318487 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318492 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318497 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318500 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318504 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318509 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318512 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318529 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318536 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318541 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318554 */   GIR_RootConstrainSelectedInstOperands,
     /* 318555 */   // GIR_Coverage, 6395,
     /* 318555 */   GIR_EraseRootFromParent_Done,
     /* 318556 */ // Label 6442: @318556
     /* 318556 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(318737), // Rule ID 6400 //
     /* 318561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318579 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318582 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318586 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318592 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 318599 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318599 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 318602 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 318606 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318621 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 318628 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 318631 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318635 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 318642 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 318645 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318649 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318654 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 318657 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 318660 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 318663 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318668 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318673 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318678 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318681 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318685 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318690 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318693 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318710 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318735 */   GIR_RootConstrainSelectedInstOperands,
     /* 318736 */   // GIR_Coverage, 6400,
     /* 318736 */   GIR_EraseRootFromParent_Done,
     /* 318737 */ // Label 6443: @318737
     /* 318737 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(318918), // Rule ID 6401 //
     /* 318742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318760 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318763 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318767 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318773 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 318780 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318780 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 318783 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 318787 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318802 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 318809 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 318812 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318816 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 318823 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 318826 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318830 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318835 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 318838 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 318841 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 318844 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318849 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318854 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318859 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 318862 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 318866 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318871 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 318874 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 318877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318891 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318898 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318916 */   GIR_RootConstrainSelectedInstOperands,
     /* 318917 */   // GIR_Coverage, 6401,
     /* 318917 */   GIR_EraseRootFromParent_Done,
     /* 318918 */ // Label 6444: @318918
     /* 318918 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(319151), // Rule ID 6396 //
     /* 318923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 318926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318933 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318937 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 318941 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318944 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318951 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318957 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 318964 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 318964 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 318967 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 318971 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318986 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 318993 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 318996 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319000 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 319007 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 319010 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319014 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319019 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 319022 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 319025 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 319028 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319033 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319038 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319043 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 319046 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 319050 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319055 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 319058 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 319061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 319063 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 319066 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319070 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319075 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 319082 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319087 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319092 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 319095 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 319099 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319104 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319107 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 319110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319124 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 319131 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319136 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 319144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319149 */   GIR_RootConstrainSelectedInstOperands,
     /* 319150 */   // GIR_Coverage, 6396,
     /* 319150 */   GIR_EraseRootFromParent_Done,
     /* 319151 */ // Label 6445: @319151
     /* 319151 */ GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(319384), // Rule ID 6397 //
     /* 319156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 319159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319166 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 319174 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319177 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319184 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319190 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 319197 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 319197 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 319200 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 319204 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319219 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 319226 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 319229 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319233 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 319240 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 319243 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319247 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319252 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 319255 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 319258 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 319261 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319266 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319271 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319276 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 319279 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 319283 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319288 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 319291 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 319294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 319296 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 319299 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319303 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319308 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 319315 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319320 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319325 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 319328 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 319332 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319337 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319340 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 319343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319357 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 319364 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319369 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 319377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319382 */   GIR_RootConstrainSelectedInstOperands,
     /* 319383 */   // GIR_Coverage, 6397,
     /* 319383 */   GIR_EraseRootFromParent_Done,
     /* 319384 */ // Label 6446: @319384
     /* 319384 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(319464), // Rule ID 2446 //
     /* 319389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 319392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319399 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319407 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319411 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319415 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319420 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 319424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319426 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 319426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319438 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 319444 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319449 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 319457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319462 */   GIR_RootConstrainSelectedInstOperands,
     /* 319463 */   // GIR_Coverage, 2446,
     /* 319463 */   GIR_EraseRootFromParent_Done,
     /* 319464 */ // Label 6447: @319464
     /* 319464 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(319544), // Rule ID 5321 //
     /* 319469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319487 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319491 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319495 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319500 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 319504 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319506 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 319506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319518 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 319524 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319529 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 319537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319542 */   GIR_RootConstrainSelectedInstOperands,
     /* 319543 */   // GIR_Coverage, 5321,
     /* 319543 */   GIR_EraseRootFromParent_Done,
     /* 319544 */ // Label 6448: @319544
     /* 319544 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(319601), // Rule ID 5298 //
     /* 319549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 319567 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319573 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 319573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 319580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319585 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 319594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319599 */   GIR_RootConstrainSelectedInstOperands,
     /* 319600 */   // GIR_Coverage, 5298,
     /* 319600 */   GIR_EraseRootFromParent_Done,
     /* 319601 */ // Label 6449: @319601
     /* 319601 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(319631), // Rule ID 447 //
     /* 319606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 319620 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 319620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 319625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319629 */   GIR_RootConstrainSelectedInstOperands,
     /* 319630 */   // GIR_Coverage, 447,
     /* 319630 */   GIR_Done,
     /* 319631 */ // Label 6450: @319631
     /* 319631 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(319661), // Rule ID 453 //
     /* 319636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 319650 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 319650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 319655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319659 */   GIR_RootConstrainSelectedInstOperands,
     /* 319660 */   // GIR_Coverage, 453,
     /* 319660 */   GIR_Done,
     /* 319661 */ // Label 6451: @319661
     /* 319661 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(319691), // Rule ID 493 //
     /* 319666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 319669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319680 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 319680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 319685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319689 */   GIR_RootConstrainSelectedInstOperands,
     /* 319690 */   // GIR_Coverage, 493,
     /* 319690 */   GIR_Done,
     /* 319691 */ // Label 6452: @319691
     /* 319691 */ GIM_Reject,
     /* 319692 */ // Label 6411: @319692
     /* 319692 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(319722), // Rule ID 1017 //
     /* 319697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319711 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 319711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 319716 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319720 */   GIR_RootConstrainSelectedInstOperands,
     /* 319721 */   // GIR_Coverage, 1017,
     /* 319721 */   GIR_Done,
     /* 319722 */ // Label 6453: @319722
     /* 319722 */ GIM_Reject,
     /* 319723 */ // Label 6412: @319723
     /* 319723 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(319753), // Rule ID 1021 //
     /* 319728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319742 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 319742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 319747 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319751 */   GIR_RootConstrainSelectedInstOperands,
     /* 319752 */   // GIR_Coverage, 1021,
     /* 319752 */   GIR_Done,
     /* 319753 */ // Label 6454: @319753
     /* 319753 */ GIM_Reject,
     /* 319754 */ // Label 6413: @319754
     /* 319754 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(319784), // Rule ID 1013 //
     /* 319759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319773 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 319773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 319778 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319782 */   GIR_RootConstrainSelectedInstOperands,
     /* 319783 */   // GIR_Coverage, 1013,
     /* 319783 */   GIR_Done,
     /* 319784 */ // Label 6455: @319784
     /* 319784 */ GIM_Reject,
     /* 319785 */ // Label 6414: @319785
     /* 319785 */ GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(319815), // Rule ID 1019 //
     /* 319790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319804 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 319804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 319809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319813 */   GIR_RootConstrainSelectedInstOperands,
     /* 319814 */   // GIR_Coverage, 1019,
     /* 319814 */   GIR_Done,
     /* 319815 */ // Label 6456: @319815
     /* 319815 */ GIM_Reject,
     /* 319816 */ // Label 6415: @319816
     /* 319816 */ GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(319846), // Rule ID 1015 //
     /* 319821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319835 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 319835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 319840 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319844 */   GIR_RootConstrainSelectedInstOperands,
     /* 319845 */   // GIR_Coverage, 1015,
     /* 319845 */   GIR_Done,
     /* 319846 */ // Label 6457: @319846
     /* 319846 */ GIM_Reject,
     /* 319847 */ // Label 6416: @319847
     /* 319847 */ GIM_Reject,
     /* 319848 */ // Label 70: @319848
     /* 319848 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6466*/ GIMT_Encode4(323853),
     /* 319859 */ /*GILLT_s16*//*Label 6458*/ GIMT_Encode4(319899),
     /* 319863 */ /*GILLT_s32*//*Label 6459*/ GIMT_Encode4(320344),
     /* 319867 */ /*GILLT_s64*//*Label 6460*/ GIMT_Encode4(321752), GIMT_Encode4(0),
     /* 319875 */ /*GILLT_v2s32*//*Label 6461*/ GIMT_Encode4(323698),
     /* 319879 */ /*GILLT_v2s64*//*Label 6462*/ GIMT_Encode4(323729),
     /* 319883 */ /*GILLT_v4s16*//*Label 6463*/ GIMT_Encode4(323760),
     /* 319887 */ /*GILLT_v4s32*//*Label 6464*/ GIMT_Encode4(323791), GIMT_Encode4(0),
     /* 319895 */ /*GILLT_v8s16*//*Label 6465*/ GIMT_Encode4(323822),
     /* 319899 */ // Label 6458: @319899
     /* 319899 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(320006), // Rule ID 5324 //
     /* 319904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 319907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 319922 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 319930 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319934 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319938 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319942 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319946 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319951 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 319955 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 319966 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319968 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 319968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 319971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319980 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 319986 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319991 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 319999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320004 */   GIR_RootConstrainSelectedInstOperands,
     /* 320005 */   // GIR_Coverage, 5324,
     /* 320005 */   GIR_EraseRootFromParent_Done,
     /* 320006 */ // Label 6467: @320006
     /* 320006 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(320086), // Rule ID 4748 //
     /* 320011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320021 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320025 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320029 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320037 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320042 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320046 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320048 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 320048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320060 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 320066 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320071 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 320079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320084 */   GIR_RootConstrainSelectedInstOperands,
     /* 320085 */   // GIR_Coverage, 4748,
     /* 320085 */   GIR_EraseRootFromParent_Done,
     /* 320086 */ // Label 6468: @320086
     /* 320086 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(320166), // Rule ID 4752 //
     /* 320091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320101 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320105 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320109 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320113 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320117 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320122 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320126 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320128 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 320128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320140 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320146 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 320159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320164 */   GIR_RootConstrainSelectedInstOperands,
     /* 320165 */   // GIR_Coverage, 4752,
     /* 320165 */   GIR_EraseRootFromParent_Done,
     /* 320166 */ // Label 6469: @320166
     /* 320166 */ GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(320223), // Rule ID 5318 //
     /* 320171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 320174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 320189 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320195 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 320195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 320198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 320202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 320216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320221 */   GIR_RootConstrainSelectedInstOperands,
     /* 320222 */   // GIR_Coverage, 5318,
     /* 320222 */   GIR_EraseRootFromParent_Done,
     /* 320223 */ // Label 6470: @320223
     /* 320223 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(320253), // Rule ID 467 //
     /* 320228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320242 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 320242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 320247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320251 */   GIR_RootConstrainSelectedInstOperands,
     /* 320252 */   // GIR_Coverage, 467,
     /* 320252 */   GIR_Done,
     /* 320253 */ // Label 6471: @320253
     /* 320253 */ GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(320283), // Rule ID 473 //
     /* 320258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320272 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 320272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 320277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320281 */   GIR_RootConstrainSelectedInstOperands,
     /* 320282 */   // GIR_Coverage, 473,
     /* 320282 */   GIR_Done,
     /* 320283 */ // Label 6472: @320283
     /* 320283 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(320313), // Rule ID 499 //
     /* 320288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320302 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 320302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 320307 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320311 */   GIR_RootConstrainSelectedInstOperands,
     /* 320312 */   // GIR_Coverage, 499,
     /* 320312 */   GIR_Done,
     /* 320313 */ // Label 6473: @320313
     /* 320313 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(320343), // Rule ID 503 //
     /* 320318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320332 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 320332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 320337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320341 */   GIR_RootConstrainSelectedInstOperands,
     /* 320342 */   // GIR_Coverage, 503,
     /* 320342 */   GIR_Done,
     /* 320343 */ // Label 6474: @320343
     /* 320343 */ GIM_Reject,
     /* 320344 */ // Label 6459: @320344
     /* 320344 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(320484), // Rule ID 5325 //
     /* 320349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320367 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320370 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320377 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320383 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 320390 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 320390 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320393 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 320397 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320417 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320424 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320427 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320431 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320450 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320453 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320456 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320459 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320464 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320469 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320482 */   GIR_RootConstrainSelectedInstOperands,
     /* 320483 */   // GIR_Coverage, 5325,
     /* 320483 */   GIR_EraseRootFromParent_Done,
     /* 320484 */ // Label 6475: @320484
     /* 320484 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(320624), // Rule ID 5326 //
     /* 320489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320507 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320510 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320517 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320521 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320523 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 320530 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 320530 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320533 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 320537 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320557 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320564 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320567 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320571 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320590 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320593 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320596 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320599 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320604 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320622 */   GIR_RootConstrainSelectedInstOperands,
     /* 320623 */   // GIR_Coverage, 5326,
     /* 320623 */   GIR_EraseRootFromParent_Done,
     /* 320624 */ // Label 6476: @320624
     /* 320624 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(320764), // Rule ID 5329 //
     /* 320629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320647 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320650 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320657 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320661 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320663 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 320670 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 320670 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320673 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 320677 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320697 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320704 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320707 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320711 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320730 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320733 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320736 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320749 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320762 */   GIR_RootConstrainSelectedInstOperands,
     /* 320763 */   // GIR_Coverage, 5329,
     /* 320763 */   GIR_EraseRootFromParent_Done,
     /* 320764 */ // Label 6477: @320764
     /* 320764 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(320904), // Rule ID 5330 //
     /* 320769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320779 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320783 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320787 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320790 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320797 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320803 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 320810 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 320810 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320813 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 320817 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320837 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320844 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320847 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320851 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320870 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320873 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320876 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320902 */   GIR_RootConstrainSelectedInstOperands,
     /* 320903 */   // GIR_Coverage, 5330,
     /* 320903 */   GIR_EraseRootFromParent_Done,
     /* 320904 */ // Label 6478: @320904
     /* 320904 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(321039), // Rule ID 5327 //
     /* 320909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320927 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320930 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320937 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320941 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320943 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 320950 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 320950 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320953 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 320957 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320972 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320979 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 320982 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320986 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321005 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321008 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321011 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 321014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321019 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321024 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 321029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321037 */   GIR_RootConstrainSelectedInstOperands,
     /* 321038 */   // GIR_Coverage, 5327,
     /* 321038 */   GIR_EraseRootFromParent_Done,
     /* 321039 */ // Label 6479: @321039
     /* 321039 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(321174), // Rule ID 5328 //
     /* 321044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321062 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321065 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 321072 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321078 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 321085 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 321085 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 321088 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 321092 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321107 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321114 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321117 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321121 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321143 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321146 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 321149 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321154 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 321164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321172 */   GIR_RootConstrainSelectedInstOperands,
     /* 321173 */   // GIR_Coverage, 5328,
     /* 321173 */   GIR_EraseRootFromParent_Done,
     /* 321174 */ // Label 6480: @321174
     /* 321174 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(321309), // Rule ID 5331 //
     /* 321179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321197 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321200 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 321207 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321213 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 321220 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 321220 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 321223 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 321227 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321242 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321249 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321252 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321256 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321275 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321278 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321281 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321289 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321294 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321307 */   GIR_RootConstrainSelectedInstOperands,
     /* 321308 */   // GIR_Coverage, 5331,
     /* 321308 */   GIR_EraseRootFromParent_Done,
     /* 321309 */ // Label 6481: @321309
     /* 321309 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(321444), // Rule ID 5332 //
     /* 321314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321332 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321335 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 321342 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321346 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321348 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 321355 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 321355 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 321358 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 321362 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321377 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321384 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321387 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321391 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321410 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321413 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321416 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321442 */   GIR_RootConstrainSelectedInstOperands,
     /* 321443 */   // GIR_Coverage, 5332,
     /* 321443 */   GIR_EraseRootFromParent_Done,
     /* 321444 */ // Label 6482: @321444
     /* 321444 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(321524), // Rule ID 4754 //
     /* 321449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 321452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 321467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 321484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321486 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 321486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321498 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 321504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 321517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321522 */   GIR_RootConstrainSelectedInstOperands,
     /* 321523 */   // GIR_Coverage, 4754,
     /* 321523 */   GIR_EraseRootFromParent_Done,
     /* 321524 */ // Label 6483: @321524
     /* 321524 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(321604), // Rule ID 5320 //
     /* 321529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 321547 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321551 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321555 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321560 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 321564 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321566 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 321566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321578 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 321584 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321602 */   GIR_RootConstrainSelectedInstOperands,
     /* 321603 */   // GIR_Coverage, 5320,
     /* 321603 */   GIR_EraseRootFromParent_Done,
     /* 321604 */ // Label 6484: @321604
     /* 321604 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(321661), // Rule ID 5310 //
     /* 321609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 321627 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 321631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321633 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 321633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 321640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321645 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 321654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321659 */   GIR_RootConstrainSelectedInstOperands,
     /* 321660 */   // GIR_Coverage, 5310,
     /* 321660 */   GIR_EraseRootFromParent_Done,
     /* 321661 */ // Label 6485: @321661
     /* 321661 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(321691), // Rule ID 469 //
     /* 321666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321680 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 321680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 321685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321689 */   GIR_RootConstrainSelectedInstOperands,
     /* 321690 */   // GIR_Coverage, 469,
     /* 321690 */   GIR_Done,
     /* 321691 */ // Label 6486: @321691
     /* 321691 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(321721), // Rule ID 475 //
     /* 321696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321710 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 321710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 321715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321719 */   GIR_RootConstrainSelectedInstOperands,
     /* 321720 */   // GIR_Coverage, 475,
     /* 321720 */   GIR_Done,
     /* 321721 */ // Label 6487: @321721
     /* 321721 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(321751), // Rule ID 505 //
     /* 321726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 321729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321740 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 321740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 321745 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321749 */   GIR_RootConstrainSelectedInstOperands,
     /* 321750 */   // GIR_Coverage, 505,
     /* 321750 */   GIR_Done,
     /* 321751 */ // Label 6488: @321751
     /* 321751 */ GIM_Reject,
     /* 321752 */ // Label 6460: @321752
     /* 321752 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(321889), // Rule ID 5341 //
     /* 321757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 321775 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321778 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 321782 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321788 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 321795 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 321795 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321798 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 321802 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 321817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 321822 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321829 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321832 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321836 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321855 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321858 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321861 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 321864 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321869 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321887 */   GIR_RootConstrainSelectedInstOperands,
     /* 321888 */   // GIR_Coverage, 5341,
     /* 321888 */   GIR_EraseRootFromParent_Done,
     /* 321889 */ // Label 6489: @321889
     /* 321889 */ GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(322026), // Rule ID 5342 //
     /* 321894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321904 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 321912 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321915 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 321919 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321925 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 321932 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 321932 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321935 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 321939 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 321954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 321959 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321966 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321969 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321973 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321992 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321995 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321998 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322001 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322011 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322024 */   GIR_RootConstrainSelectedInstOperands,
     /* 322025 */   // GIR_Coverage, 5342,
     /* 322025 */   GIR_EraseRootFromParent_Done,
     /* 322026 */ // Label 6490: @322026
     /* 322026 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(322166), // Rule ID 5333 //
     /* 322031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322041 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322045 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322049 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322052 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 322059 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322063 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322065 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 322072 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 322072 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 322075 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 322079 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 322094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 322099 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322106 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322109 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322113 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322132 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322135 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322138 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 322141 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322146 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 322156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322164 */   GIR_RootConstrainSelectedInstOperands,
     /* 322165 */   // GIR_Coverage, 5333,
     /* 322165 */   GIR_EraseRootFromParent_Done,
     /* 322166 */ // Label 6491: @322166
     /* 322166 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(322306), // Rule ID 5334 //
     /* 322171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322189 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322192 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 322199 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322205 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 322212 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 322212 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 322215 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 322219 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 322234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 322239 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322246 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322249 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322253 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322272 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322275 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322278 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 322281 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322286 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322291 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 322296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322304 */   GIR_RootConstrainSelectedInstOperands,
     /* 322305 */   // GIR_Coverage, 5334,
     /* 322305 */   GIR_EraseRootFromParent_Done,
     /* 322306 */ // Label 6492: @322306
     /* 322306 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(322446), // Rule ID 5337 //
     /* 322311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322321 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322325 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322329 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322332 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 322339 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322343 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322345 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 322352 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 322352 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 322355 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 322359 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 322374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 322379 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322386 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322389 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322393 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322412 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322415 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322418 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322421 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322444 */   GIR_RootConstrainSelectedInstOperands,
     /* 322445 */   // GIR_Coverage, 5337,
     /* 322445 */   GIR_EraseRootFromParent_Done,
     /* 322446 */ // Label 6493: @322446
     /* 322446 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(322586), // Rule ID 5338 //
     /* 322451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322461 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322469 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322472 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 322479 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322485 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 322492 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 322492 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 322495 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 322499 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 322514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 322519 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322526 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322529 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322533 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322552 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322555 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322558 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322561 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322566 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322571 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322584 */   GIR_RootConstrainSelectedInstOperands,
     /* 322585 */   // GIR_Coverage, 5338,
     /* 322585 */   GIR_EraseRootFromParent_Done,
     /* 322586 */ // Label 6494: @322586
     /* 322586 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(322718), // Rule ID 5343 //
     /* 322591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 322609 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322612 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 322616 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322622 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 322629 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 322629 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 322632 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 322636 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 322651 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322658 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322661 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322665 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322684 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322690 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322693 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322698 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322716 */   GIR_RootConstrainSelectedInstOperands,
     /* 322717 */   // GIR_Coverage, 5343,
     /* 322717 */   GIR_EraseRootFromParent_Done,
     /* 322718 */ // Label 6495: @322718
     /* 322718 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(322850), // Rule ID 5344 //
     /* 322723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322733 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322737 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 322741 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322744 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 322748 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322754 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 322761 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 322761 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 322764 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 322768 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 322783 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322790 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322793 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322797 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322816 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322822 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322825 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322848 */   GIR_RootConstrainSelectedInstOperands,
     /* 322849 */   // GIR_Coverage, 5344,
     /* 322849 */   GIR_EraseRootFromParent_Done,
     /* 322850 */ // Label 6496: @322850
     /* 322850 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(322985), // Rule ID 5335 //
     /* 322855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 322873 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 322876 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 322883 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 322887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322889 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 322896 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 322896 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 322899 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 322903 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 322913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 322918 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 322923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322925 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 322928 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322932 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322951 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322954 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322957 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 322960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322970 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 322975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322983 */   GIR_RootConstrainSelectedInstOperands,
     /* 322984 */   // GIR_Coverage, 5335,
     /* 322984 */   GIR_EraseRootFromParent_Done,
     /* 322985 */ // Label 6497: @322985
     /* 322985 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(323120), // Rule ID 5336 //
     /* 322990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323000 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323004 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 323008 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323011 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 323018 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 323022 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323024 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 323031 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 323031 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 323034 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 323038 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 323053 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 323058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323060 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 323063 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 323067 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 323081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323086 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323089 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323092 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 323095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323100 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323105 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 323110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323118 */   GIR_RootConstrainSelectedInstOperands,
     /* 323119 */   // GIR_Coverage, 5336,
     /* 323119 */   GIR_EraseRootFromParent_Done,
     /* 323120 */ // Label 6498: @323120
     /* 323120 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(323255), // Rule ID 5339 //
     /* 323125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 323143 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323146 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 323153 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 323157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323159 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 323166 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 323166 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 323169 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 323173 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 323188 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 323193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323195 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 323198 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 323202 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 323216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323221 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323224 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323227 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323230 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323240 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323253 */   GIR_RootConstrainSelectedInstOperands,
     /* 323254 */   // GIR_Coverage, 5339,
     /* 323254 */   GIR_EraseRootFromParent_Done,
     /* 323255 */ // Label 6499: @323255
     /* 323255 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(323390), // Rule ID 5340 //
     /* 323260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323270 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 323278 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323281 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 323288 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 323292 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323294 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 323301 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 323301 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 323304 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 323308 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 323323 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 323328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323330 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 323333 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 323337 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 323351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323356 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323359 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323362 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323375 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323388 */   GIR_RootConstrainSelectedInstOperands,
     /* 323389 */   // GIR_Coverage, 5340,
     /* 323389 */   GIR_EraseRootFromParent_Done,
     /* 323390 */ // Label 6500: @323390
     /* 323390 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(323470), // Rule ID 4750 //
     /* 323395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 323398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323413 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323421 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323426 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 323430 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323432 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 323432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323444 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 323450 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323455 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 323463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323465 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323468 */   GIR_RootConstrainSelectedInstOperands,
     /* 323469 */   // GIR_Coverage, 4750,
     /* 323469 */   GIR_EraseRootFromParent_Done,
     /* 323470 */ // Label 6501: @323470
     /* 323470 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(323550), // Rule ID 5322 //
     /* 323475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323485 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323489 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323493 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323497 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323501 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323506 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 323510 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323512 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 323512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323524 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 323530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323548 */   GIR_RootConstrainSelectedInstOperands,
     /* 323549 */   // GIR_Coverage, 5322,
     /* 323549 */   GIR_EraseRootFromParent_Done,
     /* 323550 */ // Label 6502: @323550
     /* 323550 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(323607), // Rule ID 5306 //
     /* 323555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 323558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 323573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 323577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323579 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 323579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 323582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 323586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323591 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 323600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323605 */   GIR_RootConstrainSelectedInstOperands,
     /* 323606 */   // GIR_Coverage, 5306,
     /* 323606 */   GIR_EraseRootFromParent_Done,
     /* 323607 */ // Label 6503: @323607
     /* 323607 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(323637), // Rule ID 471 //
     /* 323612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323626 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 323626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 323631 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323635 */   GIR_RootConstrainSelectedInstOperands,
     /* 323636 */   // GIR_Coverage, 471,
     /* 323636 */   GIR_Done,
     /* 323637 */ // Label 6504: @323637
     /* 323637 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(323667), // Rule ID 477 //
     /* 323642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323656 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 323656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 323661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323665 */   GIR_RootConstrainSelectedInstOperands,
     /* 323666 */   // GIR_Coverage, 477,
     /* 323666 */   GIR_Done,
     /* 323667 */ // Label 6505: @323667
     /* 323667 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(323697), // Rule ID 501 //
     /* 323672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 323675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323686 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 323686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 323691 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323695 */   GIR_RootConstrainSelectedInstOperands,
     /* 323696 */   // GIR_Coverage, 501,
     /* 323696 */   GIR_Done,
     /* 323697 */ // Label 6506: @323697
     /* 323697 */ GIM_Reject,
     /* 323698 */ // Label 6461: @323698
     /* 323698 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(323728), // Rule ID 1078 //
     /* 323703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323717 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 323717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 323722 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323726 */   GIR_RootConstrainSelectedInstOperands,
     /* 323727 */   // GIR_Coverage, 1078,
     /* 323727 */   GIR_Done,
     /* 323728 */ // Label 6507: @323728
     /* 323728 */ GIM_Reject,
     /* 323729 */ // Label 6462: @323729
     /* 323729 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(323759), // Rule ID 1082 //
     /* 323734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323748 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 323748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 323753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323757 */   GIR_RootConstrainSelectedInstOperands,
     /* 323758 */   // GIR_Coverage, 1082,
     /* 323758 */   GIR_Done,
     /* 323759 */ // Label 6508: @323759
     /* 323759 */ GIM_Reject,
     /* 323760 */ // Label 6463: @323760
     /* 323760 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(323790), // Rule ID 1074 //
     /* 323765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323779 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 323779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 323784 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323788 */   GIR_RootConstrainSelectedInstOperands,
     /* 323789 */   // GIR_Coverage, 1074,
     /* 323789 */   GIR_Done,
     /* 323790 */ // Label 6509: @323790
     /* 323790 */ GIM_Reject,
     /* 323791 */ // Label 6464: @323791
     /* 323791 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(323821), // Rule ID 1080 //
     /* 323796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323810 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 323810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 323815 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323819 */   GIR_RootConstrainSelectedInstOperands,
     /* 323820 */   // GIR_Coverage, 1080,
     /* 323820 */   GIR_Done,
     /* 323821 */ // Label 6510: @323821
     /* 323821 */ GIM_Reject,
     /* 323822 */ // Label 6465: @323822
     /* 323822 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(323852), // Rule ID 1076 //
     /* 323827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323841 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 323841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 323846 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323850 */   GIR_RootConstrainSelectedInstOperands,
     /* 323851 */   // GIR_Coverage, 1076,
     /* 323851 */   GIR_Done,
     /* 323852 */ // Label 6511: @323852
     /* 323852 */ GIM_Reject,
     /* 323853 */ // Label 6466: @323853
     /* 323853 */ GIM_Reject,
     /* 323854 */ // Label 71: @323854
     /* 323854 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6519*/ GIMT_Encode4(324173),
     /* 323865 */ /*GILLT_s32*//*Label 6512*/ GIMT_Encode4(323901),
     /* 323869 */ /*GILLT_s64*//*Label 6513*/ GIMT_Encode4(323974), GIMT_Encode4(0),
     /* 323877 */ /*GILLT_v2s32*//*Label 6514*/ GIMT_Encode4(324047),
     /* 323881 */ /*GILLT_v2s64*//*Label 6515*/ GIMT_Encode4(324071),
     /* 323885 */ /*GILLT_v4s16*//*Label 6516*/ GIMT_Encode4(324095),
     /* 323889 */ /*GILLT_v4s32*//*Label 6517*/ GIMT_Encode4(324122), GIMT_Encode4(0),
     /* 323897 */ /*GILLT_v8s16*//*Label 6518*/ GIMT_Encode4(324146),
     /* 323901 */ // Label 6512: @323901
     /* 323901 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(323927), // Rule ID 4583 //
     /* 323906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323916 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 323916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 323921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323925 */   GIR_RootConstrainSelectedInstOperands,
     /* 323926 */   // GIR_Coverage, 4583,
     /* 323926 */   GIR_Done,
     /* 323927 */ // Label 6520: @323927
     /* 323927 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(323950), // Rule ID 4585 //
     /* 323932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323939 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 323939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 323944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323948 */   GIR_RootConstrainSelectedInstOperands,
     /* 323949 */   // GIR_Coverage, 4585,
     /* 323949 */   GIR_Done,
     /* 323950 */ // Label 6521: @323950
     /* 323950 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(323973), // Rule ID 4587 //
     /* 323955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323962 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 323962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 323967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323971 */   GIR_RootConstrainSelectedInstOperands,
     /* 323972 */   // GIR_Coverage, 4587,
     /* 323972 */   GIR_Done,
     /* 323973 */ // Label 6522: @323973
     /* 323973 */ GIM_Reject,
     /* 323974 */ // Label 6513: @323974
     /* 323974 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(324000), // Rule ID 4584 //
     /* 323979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323989 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 323989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 323994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323998 */   GIR_RootConstrainSelectedInstOperands,
     /* 323999 */   // GIR_Coverage, 4584,
     /* 323999 */   GIR_Done,
     /* 324000 */ // Label 6523: @324000
     /* 324000 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(324023), // Rule ID 4586 //
     /* 324005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324012 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 324012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 324017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324021 */   GIR_RootConstrainSelectedInstOperands,
     /* 324022 */   // GIR_Coverage, 4586,
     /* 324022 */   GIR_Done,
     /* 324023 */ // Label 6524: @324023
     /* 324023 */ GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(324046), // Rule ID 4588 //
     /* 324028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324035 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 324035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 324040 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324044 */   GIR_RootConstrainSelectedInstOperands,
     /* 324045 */   // GIR_Coverage, 4588,
     /* 324045 */   GIR_Done,
     /* 324046 */ // Label 6525: @324046
     /* 324046 */ GIM_Reject,
     /* 324047 */ // Label 6514: @324047
     /* 324047 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(324070), // Rule ID 4924 //
     /* 324052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324059 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 324059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 324064 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324068 */   GIR_RootConstrainSelectedInstOperands,
     /* 324069 */   // GIR_Coverage, 4924,
     /* 324069 */   GIR_Done,
     /* 324070 */ // Label 6526: @324070
     /* 324070 */ GIM_Reject,
     /* 324071 */ // Label 6515: @324071
     /* 324071 */ GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(324094), // Rule ID 4926 //
     /* 324076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324083 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 324083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 324088 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324092 */   GIR_RootConstrainSelectedInstOperands,
     /* 324093 */   // GIR_Coverage, 4926,
     /* 324093 */   GIR_Done,
     /* 324094 */ // Label 6527: @324094
     /* 324094 */ GIM_Reject,
     /* 324095 */ // Label 6516: @324095
     /* 324095 */ GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(324121), // Rule ID 4919 //
     /* 324100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324110 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 324110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 324115 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324119 */   GIR_RootConstrainSelectedInstOperands,
     /* 324120 */   // GIR_Coverage, 4919,
     /* 324120 */   GIR_Done,
     /* 324121 */ // Label 6528: @324121
     /* 324121 */ GIM_Reject,
     /* 324122 */ // Label 6517: @324122
     /* 324122 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(324145), // Rule ID 4925 //
     /* 324127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324134 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 324134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 324139 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324143 */   GIR_RootConstrainSelectedInstOperands,
     /* 324144 */   // GIR_Coverage, 4925,
     /* 324144 */   GIR_Done,
     /* 324145 */ // Label 6529: @324145
     /* 324145 */ GIM_Reject,
     /* 324146 */ // Label 6518: @324146
     /* 324146 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(324172), // Rule ID 4920 //
     /* 324151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324161 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 324161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 324166 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324170 */   GIR_RootConstrainSelectedInstOperands,
     /* 324171 */   // GIR_Coverage, 4920,
     /* 324171 */   GIR_Done,
     /* 324172 */ // Label 6530: @324172
     /* 324172 */ GIM_Reject,
     /* 324173 */ // Label 6519: @324173
     /* 324173 */ GIM_Reject,
     /* 324174 */ // Label 72: @324174
     /* 324174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6538*/ GIMT_Encode4(324493),
     /* 324185 */ /*GILLT_s32*//*Label 6531*/ GIMT_Encode4(324221),
     /* 324189 */ /*GILLT_s64*//*Label 6532*/ GIMT_Encode4(324294), GIMT_Encode4(0),
     /* 324197 */ /*GILLT_v2s32*//*Label 6533*/ GIMT_Encode4(324367),
     /* 324201 */ /*GILLT_v2s64*//*Label 6534*/ GIMT_Encode4(324391),
     /* 324205 */ /*GILLT_v4s16*//*Label 6535*/ GIMT_Encode4(324415),
     /* 324209 */ /*GILLT_v4s32*//*Label 6536*/ GIMT_Encode4(324442), GIMT_Encode4(0),
     /* 324217 */ /*GILLT_v8s16*//*Label 6537*/ GIMT_Encode4(324466),
     /* 324221 */ // Label 6531: @324221
     /* 324221 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(324247), // Rule ID 4607 //
     /* 324226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324236 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 324236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 324241 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324245 */   GIR_RootConstrainSelectedInstOperands,
     /* 324246 */   // GIR_Coverage, 4607,
     /* 324246 */   GIR_Done,
     /* 324247 */ // Label 6539: @324247
     /* 324247 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(324270), // Rule ID 4609 //
     /* 324252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324259 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 324259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 324264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324268 */   GIR_RootConstrainSelectedInstOperands,
     /* 324269 */   // GIR_Coverage, 4609,
     /* 324269 */   GIR_Done,
     /* 324270 */ // Label 6540: @324270
     /* 324270 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(324293), // Rule ID 4611 //
     /* 324275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324282 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 324282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 324287 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324291 */   GIR_RootConstrainSelectedInstOperands,
     /* 324292 */   // GIR_Coverage, 4611,
     /* 324292 */   GIR_Done,
     /* 324293 */ // Label 6541: @324293
     /* 324293 */ GIM_Reject,
     /* 324294 */ // Label 6532: @324294
     /* 324294 */ GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(324320), // Rule ID 4608 //
     /* 324299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324309 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 324309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 324314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324318 */   GIR_RootConstrainSelectedInstOperands,
     /* 324319 */   // GIR_Coverage, 4608,
     /* 324319 */   GIR_Done,
     /* 324320 */ // Label 6542: @324320
     /* 324320 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(324343), // Rule ID 4610 //
     /* 324325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324332 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 324332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 324337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324341 */   GIR_RootConstrainSelectedInstOperands,
     /* 324342 */   // GIR_Coverage, 4610,
     /* 324342 */   GIR_Done,
     /* 324343 */ // Label 6543: @324343
     /* 324343 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(324366), // Rule ID 4612 //
     /* 324348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324355 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 324355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 324360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324364 */   GIR_RootConstrainSelectedInstOperands,
     /* 324365 */   // GIR_Coverage, 4612,
     /* 324365 */   GIR_Done,
     /* 324366 */ // Label 6544: @324366
     /* 324366 */ GIM_Reject,
     /* 324367 */ // Label 6533: @324367
     /* 324367 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(324390), // Rule ID 4934 //
     /* 324372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324379 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 324379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 324384 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324388 */   GIR_RootConstrainSelectedInstOperands,
     /* 324389 */   // GIR_Coverage, 4934,
     /* 324389 */   GIR_Done,
     /* 324390 */ // Label 6545: @324390
     /* 324390 */ GIM_Reject,
     /* 324391 */ // Label 6534: @324391
     /* 324391 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(324414), // Rule ID 4936 //
     /* 324396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324403 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 324403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 324408 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324412 */   GIR_RootConstrainSelectedInstOperands,
     /* 324413 */   // GIR_Coverage, 4936,
     /* 324413 */   GIR_Done,
     /* 324414 */ // Label 6546: @324414
     /* 324414 */ GIM_Reject,
     /* 324415 */ // Label 6535: @324415
     /* 324415 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(324441), // Rule ID 4929 //
     /* 324420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324430 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 324430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 324435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324439 */   GIR_RootConstrainSelectedInstOperands,
     /* 324440 */   // GIR_Coverage, 4929,
     /* 324440 */   GIR_Done,
     /* 324441 */ // Label 6547: @324441
     /* 324441 */ GIM_Reject,
     /* 324442 */ // Label 6536: @324442
     /* 324442 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(324465), // Rule ID 4935 //
     /* 324447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324454 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 324454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 324459 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324463 */   GIR_RootConstrainSelectedInstOperands,
     /* 324464 */   // GIR_Coverage, 4935,
     /* 324464 */   GIR_Done,
     /* 324465 */ // Label 6548: @324465
     /* 324465 */ GIM_Reject,
     /* 324466 */ // Label 6537: @324466
     /* 324466 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(324492), // Rule ID 4930 //
     /* 324471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324481 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 324481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 324486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324490 */   GIR_RootConstrainSelectedInstOperands,
     /* 324491 */   // GIR_Coverage, 4930,
     /* 324491 */   GIR_Done,
     /* 324492 */ // Label 6549: @324492
     /* 324492 */ GIM_Reject,
     /* 324493 */ // Label 6538: @324493
     /* 324493 */ GIM_Reject,
     /* 324494 */ // Label 73: @324494
     /* 324494 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6558*/ GIMT_Encode4(325350),
     /* 324505 */ /*GILLT_s16*//*Label 6550*/ GIMT_Encode4(324545),
     /* 324509 */ /*GILLT_s32*//*Label 6551*/ GIMT_Encode4(324764),
     /* 324513 */ /*GILLT_s64*//*Label 6552*/ GIMT_Encode4(324838), GIMT_Encode4(0),
     /* 324521 */ /*GILLT_v2s32*//*Label 6553*/ GIMT_Encode4(324912),
     /* 324525 */ /*GILLT_v2s64*//*Label 6554*/ GIMT_Encode4(324986),
     /* 324529 */ /*GILLT_v4s16*//*Label 6555*/ GIMT_Encode4(325060),
     /* 324533 */ /*GILLT_v4s32*//*Label 6556*/ GIMT_Encode4(325168), GIMT_Encode4(0),
     /* 324541 */ /*GILLT_v8s16*//*Label 6557*/ GIMT_Encode4(325242),
     /* 324545 */ // Label 6550: @324545
     /* 324545 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(324763),
     /* 324550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324557 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(324598), // Rule ID 5208 //
     /* 324562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 324573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324583 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 324583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 324586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 324596 */     GIR_RootConstrainSelectedInstOperands,
     /* 324597 */     // GIR_Coverage, 5208,
     /* 324597 */     GIR_EraseRootFromParent_Done,
     /* 324598 */   // Label 6560: @324598
     /* 324598 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(324617), // Rule ID 521 //
     /* 324603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324610 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 324610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 324615 */     GIR_RootConstrainSelectedInstOperands,
     /* 324616 */     // GIR_Coverage, 521,
     /* 324616 */     GIR_Done,
     /* 324617 */   // Label 6561: @324617
     /* 324617 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(324762), // Rule ID 6380 //
     /* 324622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324626 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 324626 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 324629 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 324633 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 324640 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 324643 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 324647 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324652 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 324655 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324659 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 324662 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324667 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324672 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 324680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324689 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 324692 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 324700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 324704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 324712 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 324717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324744 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 324751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324761 */     // GIR_Coverage, 6380,
     /* 324761 */     GIR_EraseRootFromParent_Done,
     /* 324762 */   // Label 6562: @324762
     /* 324762 */   GIM_Reject,
     /* 324763 */ // Label 6559: @324763
     /* 324763 */ GIM_Reject,
     /* 324764 */ // Label 6551: @324764
     /* 324764 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(324837),
     /* 324769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324776 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(324817), // Rule ID 5209 //
     /* 324781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 324792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 324800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324802 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 324802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 324805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 324815 */     GIR_RootConstrainSelectedInstOperands,
     /* 324816 */     // GIR_Coverage, 5209,
     /* 324816 */     GIR_EraseRootFromParent_Done,
     /* 324817 */   // Label 6564: @324817
     /* 324817 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(324836), // Rule ID 522 //
     /* 324822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324829 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 324829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 324834 */     GIR_RootConstrainSelectedInstOperands,
     /* 324835 */     // GIR_Coverage, 522,
     /* 324835 */     GIR_Done,
     /* 324836 */   // Label 6565: @324836
     /* 324836 */   GIM_Reject,
     /* 324837 */ // Label 6563: @324837
     /* 324837 */ GIM_Reject,
     /* 324838 */ // Label 6552: @324838
     /* 324838 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(324911),
     /* 324843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324850 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(324891), // Rule ID 5210 //
     /* 324855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 324866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 324870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324876 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 324876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 324879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 324889 */     GIR_RootConstrainSelectedInstOperands,
     /* 324890 */     // GIR_Coverage, 5210,
     /* 324890 */     GIR_EraseRootFromParent_Done,
     /* 324891 */   // Label 6567: @324891
     /* 324891 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(324910), // Rule ID 523 //
     /* 324896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324903 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 324903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 324908 */     GIR_RootConstrainSelectedInstOperands,
     /* 324909 */     // GIR_Coverage, 523,
     /* 324909 */     GIR_Done,
     /* 324910 */   // Label 6568: @324910
     /* 324910 */   GIM_Reject,
     /* 324911 */ // Label 6566: @324911
     /* 324911 */ GIM_Reject,
     /* 324912 */ // Label 6553: @324912
     /* 324912 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(324985),
     /* 324917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324924 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(324965), // Rule ID 5001 //
     /* 324929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 324940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324950 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 324950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 324953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 324963 */     GIR_RootConstrainSelectedInstOperands,
     /* 324964 */     // GIR_Coverage, 5001,
     /* 324964 */     GIR_EraseRootFromParent_Done,
     /* 324965 */   // Label 6570: @324965
     /* 324965 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(324984), // Rule ID 768 //
     /* 324970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324977 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 324977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 324982 */     GIR_RootConstrainSelectedInstOperands,
     /* 324983 */     // GIR_Coverage, 768,
     /* 324983 */     GIR_Done,
     /* 324984 */   // Label 6571: @324984
     /* 324984 */   GIM_Reject,
     /* 324985 */ // Label 6569: @324985
     /* 324985 */ GIM_Reject,
     /* 324986 */ // Label 6554: @324986
     /* 324986 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(325059),
     /* 324991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324998 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(325039), // Rule ID 5003 //
     /* 325003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 325014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325024 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 325024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 325027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325037 */     GIR_RootConstrainSelectedInstOperands,
     /* 325038 */     // GIR_Coverage, 5003,
     /* 325038 */     GIR_EraseRootFromParent_Done,
     /* 325039 */   // Label 6573: @325039
     /* 325039 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(325058), // Rule ID 770 //
     /* 325044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325051 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 325051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 325056 */     GIR_RootConstrainSelectedInstOperands,
     /* 325057 */     // GIR_Coverage, 770,
     /* 325057 */     GIR_Done,
     /* 325058 */   // Label 6574: @325058
     /* 325058 */   GIM_Reject,
     /* 325059 */ // Label 6572: @325059
     /* 325059 */ GIM_Reject,
     /* 325060 */ // Label 6555: @325060
     /* 325060 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(325167),
     /* 325065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325072 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(325113), // Rule ID 5004 //
     /* 325077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 325088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325098 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 325098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 325101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325111 */     GIR_RootConstrainSelectedInstOperands,
     /* 325112 */     // GIR_Coverage, 5004,
     /* 325112 */     GIR_EraseRootFromParent_Done,
     /* 325113 */   // Label 6576: @325113
     /* 325113 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(325132), // Rule ID 766 //
     /* 325118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325125 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 325125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 325130 */     GIR_RootConstrainSelectedInstOperands,
     /* 325131 */     // GIR_Coverage, 766,
     /* 325131 */     GIR_Done,
     /* 325132 */   // Label 6577: @325132
     /* 325132 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(325166), // Rule ID 6382 //
     /* 325137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325144 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 325144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 325147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325151 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 325161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 325164 */     GIR_RootConstrainSelectedInstOperands,
     /* 325165 */     // GIR_Coverage, 6382,
     /* 325165 */     GIR_EraseRootFromParent_Done,
     /* 325166 */   // Label 6578: @325166
     /* 325166 */   GIM_Reject,
     /* 325167 */ // Label 6575: @325167
     /* 325167 */ GIM_Reject,
     /* 325168 */ // Label 6556: @325168
     /* 325168 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(325241),
     /* 325173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325180 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(325221), // Rule ID 5002 //
     /* 325185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 325196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325206 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 325206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 325209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325219 */     GIR_RootConstrainSelectedInstOperands,
     /* 325220 */     // GIR_Coverage, 5002,
     /* 325220 */     GIR_EraseRootFromParent_Done,
     /* 325221 */   // Label 6580: @325221
     /* 325221 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(325240), // Rule ID 769 //
     /* 325226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325233 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 325233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 325238 */     GIR_RootConstrainSelectedInstOperands,
     /* 325239 */     // GIR_Coverage, 769,
     /* 325239 */     GIR_Done,
     /* 325240 */   // Label 6581: @325240
     /* 325240 */   GIM_Reject,
     /* 325241 */ // Label 6579: @325241
     /* 325241 */ GIM_Reject,
     /* 325242 */ // Label 6557: @325242
     /* 325242 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(325349),
     /* 325247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325254 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(325295), // Rule ID 5005 //
     /* 325259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 325270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325280 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 325280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 325283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325293 */     GIR_RootConstrainSelectedInstOperands,
     /* 325294 */     // GIR_Coverage, 5005,
     /* 325294 */     GIR_EraseRootFromParent_Done,
     /* 325295 */   // Label 6583: @325295
     /* 325295 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(325314), // Rule ID 767 //
     /* 325300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325307 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 325307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 325312 */     GIR_RootConstrainSelectedInstOperands,
     /* 325313 */     // GIR_Coverage, 767,
     /* 325313 */     GIR_Done,
     /* 325314 */   // Label 6584: @325314
     /* 325314 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(325348), // Rule ID 6383 //
     /* 325319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325326 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 325326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 325329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325333 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 325343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 325346 */     GIR_RootConstrainSelectedInstOperands,
     /* 325347 */     // GIR_Coverage, 6383,
     /* 325347 */     GIR_EraseRootFromParent_Done,
     /* 325348 */   // Label 6585: @325348
     /* 325348 */   GIM_Reject,
     /* 325349 */ // Label 6582: @325349
     /* 325349 */ GIM_Reject,
     /* 325350 */ // Label 6558: @325350
     /* 325350 */ GIM_Reject,
     /* 325351 */ // Label 74: @325351
     /* 325351 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6594*/ GIMT_Encode4(325632),
     /* 325362 */ /*GILLT_s16*//*Label 6586*/ GIMT_Encode4(325402),
     /* 325366 */ /*GILLT_s32*//*Label 6587*/ GIMT_Encode4(325429),
     /* 325370 */ /*GILLT_s64*//*Label 6588*/ GIMT_Encode4(325453), GIMT_Encode4(0),
     /* 325378 */ /*GILLT_v2s32*//*Label 6589*/ GIMT_Encode4(325477),
     /* 325382 */ /*GILLT_v2s64*//*Label 6590*/ GIMT_Encode4(325508),
     /* 325386 */ /*GILLT_v4s16*//*Label 6591*/ GIMT_Encode4(325539),
     /* 325390 */ /*GILLT_v4s32*//*Label 6592*/ GIMT_Encode4(325570), GIMT_Encode4(0),
     /* 325398 */ /*GILLT_v8s16*//*Label 6593*/ GIMT_Encode4(325601),
     /* 325402 */ // Label 6586: @325402
     /* 325402 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(325428), // Rule ID 4823 //
     /* 325407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325417 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 325417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 325420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325422 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325424 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325426 */   GIR_RootConstrainSelectedInstOperands,
     /* 325427 */   // GIR_Coverage, 4823,
     /* 325427 */   GIR_EraseRootFromParent_Done,
     /* 325428 */ // Label 6595: @325428
     /* 325428 */ GIM_Reject,
     /* 325429 */ // Label 6587: @325429
     /* 325429 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(325452), // Rule ID 4820 //
     /* 325434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325441 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 325441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 325444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325446 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325448 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325450 */   GIR_RootConstrainSelectedInstOperands,
     /* 325451 */   // GIR_Coverage, 4820,
     /* 325451 */   GIR_EraseRootFromParent_Done,
     /* 325452 */ // Label 6596: @325452
     /* 325452 */ GIM_Reject,
     /* 325453 */ // Label 6588: @325453
     /* 325453 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(325476), // Rule ID 4817 //
     /* 325458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325465 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 325465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 325468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325470 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325472 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 325474 */   GIR_RootConstrainSelectedInstOperands,
     /* 325475 */   // GIR_Coverage, 4817,
     /* 325475 */   GIR_EraseRootFromParent_Done,
     /* 325476 */ // Label 6597: @325476
     /* 325476 */ GIM_Reject,
     /* 325477 */ // Label 6589: @325477
     /* 325477 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(325507), // Rule ID 5014 //
     /* 325482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325496 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 325496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 325499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325501 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325503 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325505 */   GIR_RootConstrainSelectedInstOperands,
     /* 325506 */   // GIR_Coverage, 5014,
     /* 325506 */   GIR_EraseRootFromParent_Done,
     /* 325507 */ // Label 6598: @325507
     /* 325507 */ GIM_Reject,
     /* 325508 */ // Label 6590: @325508
     /* 325508 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(325538), // Rule ID 5008 //
     /* 325513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325527 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 325527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 325530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325532 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325534 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325536 */   GIR_RootConstrainSelectedInstOperands,
     /* 325537 */   // GIR_Coverage, 5008,
     /* 325537 */   GIR_EraseRootFromParent_Done,
     /* 325538 */ // Label 6599: @325538
     /* 325538 */ GIM_Reject,
     /* 325539 */ // Label 6591: @325539
     /* 325539 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(325569), // Rule ID 5020 //
     /* 325544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325558 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 325558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 325561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325563 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325567 */   GIR_RootConstrainSelectedInstOperands,
     /* 325568 */   // GIR_Coverage, 5020,
     /* 325568 */   GIR_EraseRootFromParent_Done,
     /* 325569 */ // Label 6600: @325569
     /* 325569 */ GIM_Reject,
     /* 325570 */ // Label 6592: @325570
     /* 325570 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(325600), // Rule ID 5011 //
     /* 325575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325589 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 325589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 325592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325594 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325596 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325598 */   GIR_RootConstrainSelectedInstOperands,
     /* 325599 */   // GIR_Coverage, 5011,
     /* 325599 */   GIR_EraseRootFromParent_Done,
     /* 325600 */ // Label 6601: @325600
     /* 325600 */ GIM_Reject,
     /* 325601 */ // Label 6593: @325601
     /* 325601 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(325631), // Rule ID 5017 //
     /* 325606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325620 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 325620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 325623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325625 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325627 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325629 */   GIR_RootConstrainSelectedInstOperands,
     /* 325630 */   // GIR_Coverage, 5017,
     /* 325630 */   GIR_EraseRootFromParent_Done,
     /* 325631 */ // Label 6602: @325631
     /* 325631 */ GIM_Reject,
     /* 325632 */ // Label 6594: @325632
     /* 325632 */ GIM_Reject,
     /* 325633 */ // Label 75: @325633
     /* 325633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6611*/ GIMT_Encode4(326010),
     /* 325644 */ /*GILLT_s16*//*Label 6603*/ GIMT_Encode4(325684),
     /* 325648 */ /*GILLT_s32*//*Label 6604*/ GIMT_Encode4(325722),
     /* 325652 */ /*GILLT_s64*//*Label 6605*/ GIMT_Encode4(325760), GIMT_Encode4(0),
     /* 325660 */ /*GILLT_v2s32*//*Label 6606*/ GIMT_Encode4(325820),
     /* 325664 */ /*GILLT_v2s64*//*Label 6607*/ GIMT_Encode4(325858),
     /* 325668 */ /*GILLT_v4s16*//*Label 6608*/ GIMT_Encode4(325896),
     /* 325672 */ /*GILLT_v4s32*//*Label 6609*/ GIMT_Encode4(325934), GIMT_Encode4(0),
     /* 325680 */ /*GILLT_v8s16*//*Label 6610*/ GIMT_Encode4(325972),
     /* 325684 */ // Label 6603: @325684
     /* 325684 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(325721), // Rule ID 608 //
     /* 325689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 325698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325710 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 325715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325719 */   GIR_RootConstrainSelectedInstOperands,
     /* 325720 */   // GIR_Coverage, 608,
     /* 325720 */   GIR_Done,
     /* 325721 */ // Label 6612: @325721
     /* 325721 */ GIM_Reject,
     /* 325722 */ // Label 6604: @325722
     /* 325722 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(325759), // Rule ID 610 //
     /* 325727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325748 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 325748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 325753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325757 */   GIR_RootConstrainSelectedInstOperands,
     /* 325758 */   // GIR_Coverage, 610,
     /* 325758 */   GIR_Done,
     /* 325759 */ // Label 6613: @325759
     /* 325759 */ GIM_Reject,
     /* 325760 */ // Label 6605: @325760
     /* 325760 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(325819),
     /* 325765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325783 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(325802), // Rule ID 612 //
     /* 325788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325791 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 325791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 325796 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325800 */     GIR_RootConstrainSelectedInstOperands,
     /* 325801 */     // GIR_Coverage, 612,
     /* 325801 */     GIR_Done,
     /* 325802 */   // Label 6615: @325802
     /* 325802 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(325818), // Rule ID 4814 //
     /* 325807 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 325807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 325812 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325816 */     GIR_RootConstrainSelectedInstOperands,
     /* 325817 */     // GIR_Coverage, 4814,
     /* 325817 */     GIR_Done,
     /* 325818 */   // Label 6616: @325818
     /* 325818 */   GIM_Reject,
     /* 325819 */ // Label 6614: @325819
     /* 325819 */ GIM_Reject,
     /* 325820 */ // Label 6606: @325820
     /* 325820 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(325857), // Rule ID 1273 //
     /* 325825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325846 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 325851 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325855 */   GIR_RootConstrainSelectedInstOperands,
     /* 325856 */   // GIR_Coverage, 1273,
     /* 325856 */   GIR_Done,
     /* 325857 */ // Label 6617: @325857
     /* 325857 */ GIM_Reject,
     /* 325858 */ // Label 6607: @325858
     /* 325858 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(325895), // Rule ID 1277 //
     /* 325863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325884 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 325889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325893 */   GIR_RootConstrainSelectedInstOperands,
     /* 325894 */   // GIR_Coverage, 1277,
     /* 325894 */   GIR_Done,
     /* 325895 */ // Label 6618: @325895
     /* 325895 */ GIM_Reject,
     /* 325896 */ // Label 6608: @325896
     /* 325896 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(325933), // Rule ID 1269 //
     /* 325901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325922 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 325927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325931 */   GIR_RootConstrainSelectedInstOperands,
     /* 325932 */   // GIR_Coverage, 1269,
     /* 325932 */   GIR_Done,
     /* 325933 */ // Label 6619: @325933
     /* 325933 */ GIM_Reject,
     /* 325934 */ // Label 6609: @325934
     /* 325934 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(325971), // Rule ID 1275 //
     /* 325939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325960 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 325965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325969 */   GIR_RootConstrainSelectedInstOperands,
     /* 325970 */   // GIR_Coverage, 1275,
     /* 325970 */   GIR_Done,
     /* 325971 */ // Label 6620: @325971
     /* 325971 */ GIM_Reject,
     /* 325972 */ // Label 6610: @325972
     /* 325972 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(326009), // Rule ID 1271 //
     /* 325977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325998 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 326003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326007 */   GIR_RootConstrainSelectedInstOperands,
     /* 326008 */   // GIR_Coverage, 1271,
     /* 326008 */   GIR_Done,
     /* 326009 */ // Label 6621: @326009
     /* 326009 */ GIM_Reject,
     /* 326010 */ // Label 6611: @326010
     /* 326010 */ GIM_Reject,
     /* 326011 */ // Label 76: @326011
     /* 326011 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6630*/ GIMT_Encode4(326388),
     /* 326022 */ /*GILLT_s16*//*Label 6622*/ GIMT_Encode4(326062),
     /* 326026 */ /*GILLT_s32*//*Label 6623*/ GIMT_Encode4(326100),
     /* 326030 */ /*GILLT_s64*//*Label 6624*/ GIMT_Encode4(326138), GIMT_Encode4(0),
     /* 326038 */ /*GILLT_v2s32*//*Label 6625*/ GIMT_Encode4(326198),
     /* 326042 */ /*GILLT_v2s64*//*Label 6626*/ GIMT_Encode4(326236),
     /* 326046 */ /*GILLT_v4s16*//*Label 6627*/ GIMT_Encode4(326274),
     /* 326050 */ /*GILLT_v4s32*//*Label 6628*/ GIMT_Encode4(326312), GIMT_Encode4(0),
     /* 326058 */ /*GILLT_v8s16*//*Label 6629*/ GIMT_Encode4(326350),
     /* 326062 */ // Label 6622: @326062
     /* 326062 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(326099), // Rule ID 596 //
     /* 326067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326088 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 326093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326097 */   GIR_RootConstrainSelectedInstOperands,
     /* 326098 */   // GIR_Coverage, 596,
     /* 326098 */   GIR_Done,
     /* 326099 */ // Label 6631: @326099
     /* 326099 */ GIM_Reject,
     /* 326100 */ // Label 6623: @326100
     /* 326100 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(326137), // Rule ID 598 //
     /* 326105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326126 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 326126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 326131 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326135 */   GIR_RootConstrainSelectedInstOperands,
     /* 326136 */   // GIR_Coverage, 598,
     /* 326136 */   GIR_Done,
     /* 326137 */ // Label 6632: @326137
     /* 326137 */ GIM_Reject,
     /* 326138 */ // Label 6624: @326138
     /* 326138 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(326197),
     /* 326143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326161 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(326180), // Rule ID 600 //
     /* 326166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326169 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 326169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 326174 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326178 */     GIR_RootConstrainSelectedInstOperands,
     /* 326179 */     // GIR_Coverage, 600,
     /* 326179 */     GIR_Done,
     /* 326180 */   // Label 6634: @326180
     /* 326180 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(326196), // Rule ID 4813 //
     /* 326185 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 326185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 326190 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326194 */     GIR_RootConstrainSelectedInstOperands,
     /* 326195 */     // GIR_Coverage, 4813,
     /* 326195 */     GIR_Done,
     /* 326196 */   // Label 6635: @326196
     /* 326196 */   GIM_Reject,
     /* 326197 */ // Label 6633: @326197
     /* 326197 */ GIM_Reject,
     /* 326198 */ // Label 6625: @326198
     /* 326198 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(326235), // Rule ID 1243 //
     /* 326203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326224 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 326229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326233 */   GIR_RootConstrainSelectedInstOperands,
     /* 326234 */   // GIR_Coverage, 1243,
     /* 326234 */   GIR_Done,
     /* 326235 */ // Label 6636: @326235
     /* 326235 */ GIM_Reject,
     /* 326236 */ // Label 6626: @326236
     /* 326236 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(326273), // Rule ID 1247 //
     /* 326241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326262 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 326267 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326271 */   GIR_RootConstrainSelectedInstOperands,
     /* 326272 */   // GIR_Coverage, 1247,
     /* 326272 */   GIR_Done,
     /* 326273 */ // Label 6637: @326273
     /* 326273 */ GIM_Reject,
     /* 326274 */ // Label 6627: @326274
     /* 326274 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(326311), // Rule ID 1239 //
     /* 326279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326300 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 326305 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326309 */   GIR_RootConstrainSelectedInstOperands,
     /* 326310 */   // GIR_Coverage, 1239,
     /* 326310 */   GIR_Done,
     /* 326311 */ // Label 6638: @326311
     /* 326311 */ GIM_Reject,
     /* 326312 */ // Label 6628: @326312
     /* 326312 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(326349), // Rule ID 1245 //
     /* 326317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326338 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 326343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326347 */   GIR_RootConstrainSelectedInstOperands,
     /* 326348 */   // GIR_Coverage, 1245,
     /* 326348 */   GIR_Done,
     /* 326349 */ // Label 6639: @326349
     /* 326349 */ GIM_Reject,
     /* 326350 */ // Label 6629: @326350
     /* 326350 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(326387), // Rule ID 1241 //
     /* 326355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326376 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 326381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326385 */   GIR_RootConstrainSelectedInstOperands,
     /* 326386 */   // GIR_Coverage, 1241,
     /* 326386 */   GIR_Done,
     /* 326387 */ // Label 6640: @326387
     /* 326387 */ GIM_Reject,
     /* 326388 */ // Label 6630: @326388
     /* 326388 */ GIM_Reject,
     /* 326389 */ // Label 77: @326389
     /* 326389 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6649*/ GIMT_Encode4(326738),
     /* 326400 */ /*GILLT_s16*//*Label 6641*/ GIMT_Encode4(326440),
     /* 326404 */ /*GILLT_s32*//*Label 6642*/ GIMT_Encode4(326478),
     /* 326408 */ /*GILLT_s64*//*Label 6643*/ GIMT_Encode4(326513), GIMT_Encode4(0),
     /* 326416 */ /*GILLT_v2s32*//*Label 6644*/ GIMT_Encode4(326548),
     /* 326420 */ /*GILLT_v2s64*//*Label 6645*/ GIMT_Encode4(326586),
     /* 326424 */ /*GILLT_v4s16*//*Label 6646*/ GIMT_Encode4(326624),
     /* 326428 */ /*GILLT_v4s32*//*Label 6647*/ GIMT_Encode4(326662), GIMT_Encode4(0),
     /* 326436 */ /*GILLT_v8s16*//*Label 6648*/ GIMT_Encode4(326700),
     /* 326440 */ // Label 6641: @326440
     /* 326440 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(326477), // Rule ID 4821 //
     /* 326445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326466 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 326466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 326471 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326475 */   GIR_RootConstrainSelectedInstOperands,
     /* 326476 */   // GIR_Coverage, 4821,
     /* 326476 */   GIR_Done,
     /* 326477 */ // Label 6650: @326477
     /* 326477 */ GIM_Reject,
     /* 326478 */ // Label 6642: @326478
     /* 326478 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(326512), // Rule ID 4818 //
     /* 326483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326501 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 326501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 326506 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326510 */   GIR_RootConstrainSelectedInstOperands,
     /* 326511 */   // GIR_Coverage, 4818,
     /* 326511 */   GIR_Done,
     /* 326512 */ // Label 6651: @326512
     /* 326512 */ GIM_Reject,
     /* 326513 */ // Label 6643: @326513
     /* 326513 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(326547), // Rule ID 4815 //
     /* 326518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326536 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 326536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 326541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326545 */   GIR_RootConstrainSelectedInstOperands,
     /* 326546 */   // GIR_Coverage, 4815,
     /* 326546 */   GIR_Done,
     /* 326547 */ // Label 6652: @326547
     /* 326547 */ GIM_Reject,
     /* 326548 */ // Label 6644: @326548
     /* 326548 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(326585), // Rule ID 5012 //
     /* 326553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326574 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 326579 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326583 */   GIR_RootConstrainSelectedInstOperands,
     /* 326584 */   // GIR_Coverage, 5012,
     /* 326584 */   GIR_Done,
     /* 326585 */ // Label 6653: @326585
     /* 326585 */ GIM_Reject,
     /* 326586 */ // Label 6645: @326586
     /* 326586 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(326623), // Rule ID 5006 //
     /* 326591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326612 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 326617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326621 */   GIR_RootConstrainSelectedInstOperands,
     /* 326622 */   // GIR_Coverage, 5006,
     /* 326622 */   GIR_Done,
     /* 326623 */ // Label 6654: @326623
     /* 326623 */ GIM_Reject,
     /* 326624 */ // Label 6646: @326624
     /* 326624 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(326661), // Rule ID 5018 //
     /* 326629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326650 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 326655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326659 */   GIR_RootConstrainSelectedInstOperands,
     /* 326660 */   // GIR_Coverage, 5018,
     /* 326660 */   GIR_Done,
     /* 326661 */ // Label 6655: @326661
     /* 326661 */ GIM_Reject,
     /* 326662 */ // Label 6647: @326662
     /* 326662 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(326699), // Rule ID 5009 //
     /* 326667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326688 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 326693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326697 */   GIR_RootConstrainSelectedInstOperands,
     /* 326698 */   // GIR_Coverage, 5009,
     /* 326698 */   GIR_Done,
     /* 326699 */ // Label 6656: @326699
     /* 326699 */ GIM_Reject,
     /* 326700 */ // Label 6648: @326700
     /* 326700 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(326737), // Rule ID 5015 //
     /* 326705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326726 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 326731 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326735 */   GIR_RootConstrainSelectedInstOperands,
     /* 326736 */   // GIR_Coverage, 5015,
     /* 326736 */   GIR_Done,
     /* 326737 */ // Label 6657: @326737
     /* 326737 */ GIM_Reject,
     /* 326738 */ // Label 6649: @326738
     /* 326738 */ GIM_Reject,
     /* 326739 */ // Label 78: @326739
     /* 326739 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6666*/ GIMT_Encode4(327088),
     /* 326750 */ /*GILLT_s16*//*Label 6658*/ GIMT_Encode4(326790),
     /* 326754 */ /*GILLT_s32*//*Label 6659*/ GIMT_Encode4(326828),
     /* 326758 */ /*GILLT_s64*//*Label 6660*/ GIMT_Encode4(326863), GIMT_Encode4(0),
     /* 326766 */ /*GILLT_v2s32*//*Label 6661*/ GIMT_Encode4(326898),
     /* 326770 */ /*GILLT_v2s64*//*Label 6662*/ GIMT_Encode4(326936),
     /* 326774 */ /*GILLT_v4s16*//*Label 6663*/ GIMT_Encode4(326974),
     /* 326778 */ /*GILLT_v4s32*//*Label 6664*/ GIMT_Encode4(327012), GIMT_Encode4(0),
     /* 326786 */ /*GILLT_v8s16*//*Label 6665*/ GIMT_Encode4(327050),
     /* 326790 */ // Label 6658: @326790
     /* 326790 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(326827), // Rule ID 4822 //
     /* 326795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326816 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 326816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 326821 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326825 */   GIR_RootConstrainSelectedInstOperands,
     /* 326826 */   // GIR_Coverage, 4822,
     /* 326826 */   GIR_Done,
     /* 326827 */ // Label 6667: @326827
     /* 326827 */ GIM_Reject,
     /* 326828 */ // Label 6659: @326828
     /* 326828 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(326862), // Rule ID 4819 //
     /* 326833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326851 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 326851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 326856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326860 */   GIR_RootConstrainSelectedInstOperands,
     /* 326861 */   // GIR_Coverage, 4819,
     /* 326861 */   GIR_Done,
     /* 326862 */ // Label 6668: @326862
     /* 326862 */ GIM_Reject,
     /* 326863 */ // Label 6660: @326863
     /* 326863 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(326897), // Rule ID 4816 //
     /* 326868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326886 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 326886 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 326891 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326895 */   GIR_RootConstrainSelectedInstOperands,
     /* 326896 */   // GIR_Coverage, 4816,
     /* 326896 */   GIR_Done,
     /* 326897 */ // Label 6669: @326897
     /* 326897 */ GIM_Reject,
     /* 326898 */ // Label 6661: @326898
     /* 326898 */ GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(326935), // Rule ID 5013 //
     /* 326903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326924 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 326929 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326933 */   GIR_RootConstrainSelectedInstOperands,
     /* 326934 */   // GIR_Coverage, 5013,
     /* 326934 */   GIR_Done,
     /* 326935 */ // Label 6670: @326935
     /* 326935 */ GIM_Reject,
     /* 326936 */ // Label 6662: @326936
     /* 326936 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(326973), // Rule ID 5007 //
     /* 326941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326962 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 326967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326971 */   GIR_RootConstrainSelectedInstOperands,
     /* 326972 */   // GIR_Coverage, 5007,
     /* 326972 */   GIR_Done,
     /* 326973 */ // Label 6671: @326973
     /* 326973 */ GIM_Reject,
     /* 326974 */ // Label 6663: @326974
     /* 326974 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(327011), // Rule ID 5019 //
     /* 326979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327000 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 327000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 327005 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327009 */   GIR_RootConstrainSelectedInstOperands,
     /* 327010 */   // GIR_Coverage, 5019,
     /* 327010 */   GIR_Done,
     /* 327011 */ // Label 6672: @327011
     /* 327011 */ GIM_Reject,
     /* 327012 */ // Label 6664: @327012
     /* 327012 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(327049), // Rule ID 5010 //
     /* 327017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327038 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 327038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 327043 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327047 */   GIR_RootConstrainSelectedInstOperands,
     /* 327048 */   // GIR_Coverage, 5010,
     /* 327048 */   GIR_Done,
     /* 327049 */ // Label 6673: @327049
     /* 327049 */ GIM_Reject,
     /* 327050 */ // Label 6665: @327050
     /* 327050 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(327087), // Rule ID 5016 //
     /* 327055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 327058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327076 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 327076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 327081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327085 */   GIR_RootConstrainSelectedInstOperands,
     /* 327086 */   // GIR_Coverage, 5016,
     /* 327086 */   GIR_Done,
     /* 327087 */ // Label 6674: @327087
     /* 327087 */ GIM_Reject,
     /* 327088 */ // Label 6666: @327088
     /* 327088 */ GIM_Reject,
     /* 327089 */ // Label 79: @327089
     /* 327089 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6683*/ GIMT_Encode4(327791),
     /* 327100 */ /*GILLT_s16*//*Label 6675*/ GIMT_Encode4(327140),
     /* 327104 */ /*GILLT_s32*//*Label 6676*/ GIMT_Encode4(327178),
     /* 327108 */ /*GILLT_s64*//*Label 6677*/ GIMT_Encode4(327216), GIMT_Encode4(0),
     /* 327116 */ /*GILLT_v2s32*//*Label 6678*/ GIMT_Encode4(327276),
     /* 327120 */ /*GILLT_v2s64*//*Label 6679*/ GIMT_Encode4(327379),
     /* 327124 */ /*GILLT_v4s16*//*Label 6680*/ GIMT_Encode4(327482),
     /* 327128 */ /*GILLT_v4s32*//*Label 6681*/ GIMT_Encode4(327585), GIMT_Encode4(0),
     /* 327136 */ /*GILLT_v8s16*//*Label 6682*/ GIMT_Encode4(327688),
     /* 327140 */ // Label 6675: @327140
     /* 327140 */ GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(327177), // Rule ID 614 //
     /* 327145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 327154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327166 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 327166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 327171 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327175 */   GIR_RootConstrainSelectedInstOperands,
     /* 327176 */   // GIR_Coverage, 614,
     /* 327176 */   GIR_Done,
     /* 327177 */ // Label 6684: @327177
     /* 327177 */ GIM_Reject,
     /* 327178 */ // Label 6676: @327178
     /* 327178 */ GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(327215), // Rule ID 616 //
     /* 327183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 327192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327204 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 327209 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327213 */   GIR_RootConstrainSelectedInstOperands,
     /* 327214 */   // GIR_Coverage, 616,
     /* 327214 */   GIR_Done,
     /* 327215 */ // Label 6685: @327215
     /* 327215 */ GIM_Reject,
     /* 327216 */ // Label 6677: @327216
     /* 327216 */ GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(327275),
     /* 327221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327239 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(327258), // Rule ID 618 //
     /* 327244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327247 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 327247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 327252 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327256 */     GIR_RootConstrainSelectedInstOperands,
     /* 327257 */     // GIR_Coverage, 618,
     /* 327257 */     GIR_Done,
     /* 327258 */   // Label 6687: @327258
     /* 327258 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(327274), // Rule ID 4812 //
     /* 327263 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 327263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 327268 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327272 */     GIR_RootConstrainSelectedInstOperands,
     /* 327273 */     // GIR_Coverage, 4812,
     /* 327273 */     GIR_Done,
     /* 327274 */   // Label 6688: @327274
     /* 327274 */   GIM_Reject,
     /* 327275 */ // Label 6686: @327275
     /* 327275 */ GIM_Reject,
     /* 327276 */ // Label 6678: @327276
     /* 327276 */ GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(327378),
     /* 327281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 327287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327291 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(327350), // Rule ID 2366 //
     /* 327296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327335 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 327335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 327338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327348 */     GIR_RootConstrainSelectedInstOperands,
     /* 327349 */     // GIR_Coverage, 2366,
     /* 327349 */     GIR_EraseRootFromParent_Done,
     /* 327350 */   // Label 6690: @327350
     /* 327350 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(327377), // Rule ID 1288 //
     /* 327355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327366 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 327366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 327371 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327375 */     GIR_RootConstrainSelectedInstOperands,
     /* 327376 */     // GIR_Coverage, 1288,
     /* 327376 */     GIR_Done,
     /* 327377 */   // Label 6691: @327377
     /* 327377 */   GIM_Reject,
     /* 327378 */ // Label 6689: @327378
     /* 327378 */ GIM_Reject,
     /* 327379 */ // Label 6679: @327379
     /* 327379 */ GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(327481),
     /* 327384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327394 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(327453), // Rule ID 2372 //
     /* 327399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327438 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 327438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 327441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327451 */     GIR_RootConstrainSelectedInstOperands,
     /* 327452 */     // GIR_Coverage, 2372,
     /* 327452 */     GIR_EraseRootFromParent_Done,
     /* 327453 */   // Label 6693: @327453
     /* 327453 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(327480), // Rule ID 1292 //
     /* 327458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327469 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 327469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 327474 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327478 */     GIR_RootConstrainSelectedInstOperands,
     /* 327479 */     // GIR_Coverage, 1292,
     /* 327479 */     GIR_Done,
     /* 327480 */   // Label 6694: @327480
     /* 327480 */   GIM_Reject,
     /* 327481 */ // Label 6692: @327481
     /* 327481 */ GIM_Reject,
     /* 327482 */ // Label 6680: @327482
     /* 327482 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(327584),
     /* 327487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 327493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327497 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(327556), // Rule ID 2360 //
     /* 327502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327541 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 327541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 327544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327554 */     GIR_RootConstrainSelectedInstOperands,
     /* 327555 */     // GIR_Coverage, 2360,
     /* 327555 */     GIR_EraseRootFromParent_Done,
     /* 327556 */   // Label 6696: @327556
     /* 327556 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(327583), // Rule ID 1284 //
     /* 327561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 327564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327572 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 327572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 327577 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327581 */     GIR_RootConstrainSelectedInstOperands,
     /* 327582 */     // GIR_Coverage, 1284,
     /* 327582 */     GIR_Done,
     /* 327583 */   // Label 6697: @327583
     /* 327583 */   GIM_Reject,
     /* 327584 */ // Label 6695: @327584
     /* 327584 */ GIM_Reject,
     /* 327585 */ // Label 6681: @327585
     /* 327585 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(327687),
     /* 327590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327600 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(327659), // Rule ID 2369 //
     /* 327605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327644 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 327644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 327647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327657 */     GIR_RootConstrainSelectedInstOperands,
     /* 327658 */     // GIR_Coverage, 2369,
     /* 327658 */     GIR_EraseRootFromParent_Done,
     /* 327659 */   // Label 6699: @327659
     /* 327659 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(327686), // Rule ID 1290 //
     /* 327664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327675 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 327675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 327680 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327684 */     GIR_RootConstrainSelectedInstOperands,
     /* 327685 */     // GIR_Coverage, 1290,
     /* 327685 */     GIR_Done,
     /* 327686 */   // Label 6700: @327686
     /* 327686 */   GIM_Reject,
     /* 327687 */ // Label 6698: @327687
     /* 327687 */ GIM_Reject,
     /* 327688 */ // Label 6682: @327688
     /* 327688 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(327790),
     /* 327693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327703 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(327762), // Rule ID 2363 //
     /* 327708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 327711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 327736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327747 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 327747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 327750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 327760 */     GIR_RootConstrainSelectedInstOperands,
     /* 327761 */     // GIR_Coverage, 2363,
     /* 327761 */     GIR_EraseRootFromParent_Done,
     /* 327762 */   // Label 6702: @327762
     /* 327762 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(327789), // Rule ID 1286 //
     /* 327767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 327770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327778 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 327778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 327783 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327787 */     GIR_RootConstrainSelectedInstOperands,
     /* 327788 */     // GIR_Coverage, 1286,
     /* 327788 */     GIR_Done,
     /* 327789 */   // Label 6703: @327789
     /* 327789 */   GIM_Reject,
     /* 327790 */ // Label 6701: @327790
     /* 327790 */ GIM_Reject,
     /* 327791 */ // Label 6683: @327791
     /* 327791 */ GIM_Reject,
     /* 327792 */ // Label 80: @327792
     /* 327792 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6712*/ GIMT_Encode4(328494),
     /* 327803 */ /*GILLT_s16*//*Label 6704*/ GIMT_Encode4(327843),
     /* 327807 */ /*GILLT_s32*//*Label 6705*/ GIMT_Encode4(327881),
     /* 327811 */ /*GILLT_s64*//*Label 6706*/ GIMT_Encode4(327919), GIMT_Encode4(0),
     /* 327819 */ /*GILLT_v2s32*//*Label 6707*/ GIMT_Encode4(327979),
     /* 327823 */ /*GILLT_v2s64*//*Label 6708*/ GIMT_Encode4(328082),
     /* 327827 */ /*GILLT_v4s16*//*Label 6709*/ GIMT_Encode4(328185),
     /* 327831 */ /*GILLT_v4s32*//*Label 6710*/ GIMT_Encode4(328288), GIMT_Encode4(0),
     /* 327839 */ /*GILLT_v8s16*//*Label 6711*/ GIMT_Encode4(328391),
     /* 327843 */ // Label 6704: @327843
     /* 327843 */ GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(327880), // Rule ID 602 //
     /* 327848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 327857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327869 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 327869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 327874 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327878 */   GIR_RootConstrainSelectedInstOperands,
     /* 327879 */   // GIR_Coverage, 602,
     /* 327879 */   GIR_Done,
     /* 327880 */ // Label 6713: @327880
     /* 327880 */ GIM_Reject,
     /* 327881 */ // Label 6705: @327881
     /* 327881 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(327918), // Rule ID 604 //
     /* 327886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 327895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327907 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 327912 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327916 */   GIR_RootConstrainSelectedInstOperands,
     /* 327917 */   // GIR_Coverage, 604,
     /* 327917 */   GIR_Done,
     /* 327918 */ // Label 6714: @327918
     /* 327918 */ GIM_Reject,
     /* 327919 */ // Label 6706: @327919
     /* 327919 */ GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(327978),
     /* 327924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327942 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(327961), // Rule ID 606 //
     /* 327947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327950 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 327950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 327955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327959 */     GIR_RootConstrainSelectedInstOperands,
     /* 327960 */     // GIR_Coverage, 606,
     /* 327960 */     GIR_Done,
     /* 327961 */   // Label 6716: @327961
     /* 327961 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(327977), // Rule ID 4811 //
     /* 327966 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 327966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 327971 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327975 */     GIR_RootConstrainSelectedInstOperands,
     /* 327976 */     // GIR_Coverage, 4811,
     /* 327976 */     GIR_Done,
     /* 327977 */   // Label 6717: @327977
     /* 327977 */   GIM_Reject,
     /* 327978 */ // Label 6715: @327978
     /* 327978 */ GIM_Reject,
     /* 327979 */ // Label 6707: @327979
     /* 327979 */ GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(328081),
     /* 327984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 327990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327994 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(328053), // Rule ID 2351 //
     /* 327999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328038 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 328038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 328041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328051 */     GIR_RootConstrainSelectedInstOperands,
     /* 328052 */     // GIR_Coverage, 2351,
     /* 328052 */     GIR_EraseRootFromParent_Done,
     /* 328053 */   // Label 6719: @328053
     /* 328053 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(328080), // Rule ID 1258 //
     /* 328058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328069 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 328069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 328074 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328078 */     GIR_RootConstrainSelectedInstOperands,
     /* 328079 */     // GIR_Coverage, 1258,
     /* 328079 */     GIR_Done,
     /* 328080 */   // Label 6720: @328080
     /* 328080 */   GIM_Reject,
     /* 328081 */ // Label 6718: @328081
     /* 328081 */ GIM_Reject,
     /* 328082 */ // Label 6708: @328082
     /* 328082 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(328184),
     /* 328087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 328093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328097 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(328156), // Rule ID 2357 //
     /* 328102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328141 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 328141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 328144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328154 */     GIR_RootConstrainSelectedInstOperands,
     /* 328155 */     // GIR_Coverage, 2357,
     /* 328155 */     GIR_EraseRootFromParent_Done,
     /* 328156 */   // Label 6722: @328156
     /* 328156 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(328183), // Rule ID 1262 //
     /* 328161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328172 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 328172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 328177 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328181 */     GIR_RootConstrainSelectedInstOperands,
     /* 328182 */     // GIR_Coverage, 1262,
     /* 328182 */     GIR_Done,
     /* 328183 */   // Label 6723: @328183
     /* 328183 */   GIM_Reject,
     /* 328184 */ // Label 6721: @328184
     /* 328184 */ GIM_Reject,
     /* 328185 */ // Label 6709: @328185
     /* 328185 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(328287),
     /* 328190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 328196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328200 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(328259), // Rule ID 2345 //
     /* 328205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328244 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 328244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 328247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328257 */     GIR_RootConstrainSelectedInstOperands,
     /* 328258 */     // GIR_Coverage, 2345,
     /* 328258 */     GIR_EraseRootFromParent_Done,
     /* 328259 */   // Label 6725: @328259
     /* 328259 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(328286), // Rule ID 1254 //
     /* 328264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328275 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 328275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 328280 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328284 */     GIR_RootConstrainSelectedInstOperands,
     /* 328285 */     // GIR_Coverage, 1254,
     /* 328285 */     GIR_Done,
     /* 328286 */   // Label 6726: @328286
     /* 328286 */   GIM_Reject,
     /* 328287 */ // Label 6724: @328287
     /* 328287 */ GIM_Reject,
     /* 328288 */ // Label 6710: @328288
     /* 328288 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(328390),
     /* 328293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 328299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328303 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(328362), // Rule ID 2354 //
     /* 328308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328347 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 328347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 328350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328360 */     GIR_RootConstrainSelectedInstOperands,
     /* 328361 */     // GIR_Coverage, 2354,
     /* 328361 */     GIR_EraseRootFromParent_Done,
     /* 328362 */   // Label 6728: @328362
     /* 328362 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(328389), // Rule ID 1260 //
     /* 328367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328378 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 328378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 328383 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328387 */     GIR_RootConstrainSelectedInstOperands,
     /* 328388 */     // GIR_Coverage, 1260,
     /* 328388 */     GIR_Done,
     /* 328389 */   // Label 6729: @328389
     /* 328389 */   GIM_Reject,
     /* 328390 */ // Label 6727: @328390
     /* 328390 */ GIM_Reject,
     /* 328391 */ // Label 6711: @328391
     /* 328391 */ GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(328493),
     /* 328396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 328402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328406 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(328465), // Rule ID 2348 //
     /* 328411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 328414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 328439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328450 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 328450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 328453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 328463 */     GIR_RootConstrainSelectedInstOperands,
     /* 328464 */     // GIR_Coverage, 2348,
     /* 328464 */     GIR_EraseRootFromParent_Done,
     /* 328465 */   // Label 6731: @328465
     /* 328465 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(328492), // Rule ID 1256 //
     /* 328470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328481 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 328481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 328486 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328490 */     GIR_RootConstrainSelectedInstOperands,
     /* 328491 */     // GIR_Coverage, 1256,
     /* 328491 */     GIR_Done,
     /* 328492 */   // Label 6732: @328492
     /* 328492 */   GIM_Reject,
     /* 328493 */ // Label 6730: @328493
     /* 328493 */ GIM_Reject,
     /* 328494 */ // Label 6712: @328494
     /* 328494 */ GIM_Reject,
     /* 328495 */ // Label 81: @328495
     /* 328495 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6741*/ GIMT_Encode4(328898),
     /* 328506 */ /*GILLT_s32*//*Label 6733*/ GIMT_Encode4(328546),
     /* 328510 */ /*GILLT_s64*//*Label 6734*/ GIMT_Encode4(328620), GIMT_Encode4(0),
     /* 328518 */ /*GILLT_v2s32*//*Label 6735*/ GIMT_Encode4(328694), GIMT_Encode4(0),
     /* 328526 */ /*GILLT_v4s16*//*Label 6736*/ GIMT_Encode4(328728),
     /* 328530 */ /*GILLT_v4s32*//*Label 6737*/ GIMT_Encode4(328762),
     /* 328534 */ /*GILLT_v8s8*//*Label 6738*/ GIMT_Encode4(328796),
     /* 328538 */ /*GILLT_v8s16*//*Label 6739*/ GIMT_Encode4(328830),
     /* 328542 */ /*GILLT_v16s8*//*Label 6740*/ GIMT_Encode4(328864),
     /* 328546 */ // Label 6733: @328546
     /* 328546 */ GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(328619),
     /* 328551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 328557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328565 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(328599), // Rule ID 2328 //
     /* 328570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 328585 */     // MIs[1] Operand 1
     /* 328585 */     // No operand predicates
     /* 328585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328587 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 328587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 328590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 328597 */     GIR_RootConstrainSelectedInstOperands,
     /* 328598 */     // GIR_Coverage, 2328,
     /* 328598 */     GIR_EraseRootFromParent_Done,
     /* 328599 */   // Label 6743: @328599
     /* 328599 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(328618), // Rule ID 2327 //
     /* 328604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328611 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 328611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 328616 */     GIR_RootConstrainSelectedInstOperands,
     /* 328617 */     // GIR_Coverage, 2327,
     /* 328617 */     GIR_Done,
     /* 328618 */   // Label 6744: @328618
     /* 328618 */   GIM_Reject,
     /* 328619 */ // Label 6742: @328619
     /* 328619 */ GIM_Reject,
     /* 328620 */ // Label 6734: @328620
     /* 328620 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(328693),
     /* 328625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 328631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328639 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(328673), // Rule ID 2330 //
     /* 328644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 328659 */     // MIs[1] Operand 1
     /* 328659 */     // No operand predicates
     /* 328659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328661 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 328661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 328664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 328671 */     GIR_RootConstrainSelectedInstOperands,
     /* 328672 */     // GIR_Coverage, 2330,
     /* 328672 */     GIR_EraseRootFromParent_Done,
     /* 328673 */   // Label 6746: @328673
     /* 328673 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(328692), // Rule ID 2329 //
     /* 328678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328685 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 328685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 328690 */     GIR_RootConstrainSelectedInstOperands,
     /* 328691 */     // GIR_Coverage, 2329,
     /* 328691 */     GIR_Done,
     /* 328692 */   // Label 6747: @328692
     /* 328692 */   GIM_Reject,
     /* 328693 */ // Label 6745: @328693
     /* 328693 */ GIM_Reject,
     /* 328694 */ // Label 6735: @328694
     /* 328694 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(328727), // Rule ID 1414 //
     /* 328699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 328708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328720 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 328720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 328725 */   GIR_RootConstrainSelectedInstOperands,
     /* 328726 */   // GIR_Coverage, 1414,
     /* 328726 */   GIR_Done,
     /* 328727 */ // Label 6748: @328727
     /* 328727 */ GIM_Reject,
     /* 328728 */ // Label 6736: @328728
     /* 328728 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(328761), // Rule ID 1412 //
     /* 328733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 328742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328754 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 328754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 328759 */   GIR_RootConstrainSelectedInstOperands,
     /* 328760 */   // GIR_Coverage, 1412,
     /* 328760 */   GIR_Done,
     /* 328761 */ // Label 6749: @328761
     /* 328761 */ GIM_Reject,
     /* 328762 */ // Label 6737: @328762
     /* 328762 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(328795), // Rule ID 1415 //
     /* 328767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 328776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328788 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 328788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 328793 */   GIR_RootConstrainSelectedInstOperands,
     /* 328794 */   // GIR_Coverage, 1415,
     /* 328794 */   GIR_Done,
     /* 328795 */ // Label 6750: @328795
     /* 328795 */ GIM_Reject,
     /* 328796 */ // Label 6738: @328796
     /* 328796 */ GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(328829), // Rule ID 1410 //
     /* 328801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 328810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328822 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 328822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 328827 */   GIR_RootConstrainSelectedInstOperands,
     /* 328828 */   // GIR_Coverage, 1410,
     /* 328828 */   GIR_Done,
     /* 328829 */ // Label 6751: @328829
     /* 328829 */ GIM_Reject,
     /* 328830 */ // Label 6739: @328830
     /* 328830 */ GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(328863), // Rule ID 1413 //
     /* 328835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 328844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328856 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 328856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 328861 */   GIR_RootConstrainSelectedInstOperands,
     /* 328862 */   // GIR_Coverage, 1413,
     /* 328862 */   GIR_Done,
     /* 328863 */ // Label 6752: @328863
     /* 328863 */ GIM_Reject,
     /* 328864 */ // Label 6740: @328864
     /* 328864 */ GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(328897), // Rule ID 1411 //
     /* 328869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 328875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 328878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328890 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 328890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 328895 */   GIR_RootConstrainSelectedInstOperands,
     /* 328896 */   // GIR_Coverage, 1411,
     /* 328896 */   GIR_Done,
     /* 328897 */ // Label 6753: @328897
     /* 328897 */ GIM_Reject,
     /* 328898 */ // Label 6741: @328898
     /* 328898 */ GIM_Reject,
     /* 328899 */ // Label 82: @328899
     /* 328899 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6762*/ GIMT_Encode4(329302),
     /* 328910 */ /*GILLT_s32*//*Label 6754*/ GIMT_Encode4(328950),
     /* 328914 */ /*GILLT_s64*//*Label 6755*/ GIMT_Encode4(329024), GIMT_Encode4(0),
     /* 328922 */ /*GILLT_v2s32*//*Label 6756*/ GIMT_Encode4(329098), GIMT_Encode4(0),
     /* 328930 */ /*GILLT_v4s16*//*Label 6757*/ GIMT_Encode4(329132),
     /* 328934 */ /*GILLT_v4s32*//*Label 6758*/ GIMT_Encode4(329166),
     /* 328938 */ /*GILLT_v8s8*//*Label 6759*/ GIMT_Encode4(329200),
     /* 328942 */ /*GILLT_v8s16*//*Label 6760*/ GIMT_Encode4(329234),
     /* 328946 */ /*GILLT_v16s8*//*Label 6761*/ GIMT_Encode4(329268),
     /* 328950 */ // Label 6754: @328950
     /* 328950 */ GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(329023),
     /* 328955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 328961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328969 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(329003), // Rule ID 2324 //
     /* 328974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 328989 */     // MIs[1] Operand 1
     /* 328989 */     // No operand predicates
     /* 328989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328991 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 328991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 328994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329001 */     GIR_RootConstrainSelectedInstOperands,
     /* 329002 */     // GIR_Coverage, 2324,
     /* 329002 */     GIR_EraseRootFromParent_Done,
     /* 329003 */   // Label 6764: @329003
     /* 329003 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(329022), // Rule ID 2323 //
     /* 329008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329015 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 329015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 329020 */     GIR_RootConstrainSelectedInstOperands,
     /* 329021 */     // GIR_Coverage, 2323,
     /* 329021 */     GIR_Done,
     /* 329022 */   // Label 6765: @329022
     /* 329022 */   GIM_Reject,
     /* 329023 */ // Label 6763: @329023
     /* 329023 */ GIM_Reject,
     /* 329024 */ // Label 6755: @329024
     /* 329024 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(329097),
     /* 329029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 329035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329043 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(329077), // Rule ID 2326 //
     /* 329048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 329063 */     // MIs[1] Operand 1
     /* 329063 */     // No operand predicates
     /* 329063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329065 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 329065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 329068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329075 */     GIR_RootConstrainSelectedInstOperands,
     /* 329076 */     // GIR_Coverage, 2326,
     /* 329076 */     GIR_EraseRootFromParent_Done,
     /* 329077 */   // Label 6767: @329077
     /* 329077 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(329096), // Rule ID 2325 //
     /* 329082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329089 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 329089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 329094 */     GIR_RootConstrainSelectedInstOperands,
     /* 329095 */     // GIR_Coverage, 2325,
     /* 329095 */     GIR_Done,
     /* 329096 */   // Label 6768: @329096
     /* 329096 */   GIM_Reject,
     /* 329097 */ // Label 6766: @329097
     /* 329097 */ GIM_Reject,
     /* 329098 */ // Label 6756: @329098
     /* 329098 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(329131), // Rule ID 1402 //
     /* 329103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 329112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329124 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 329124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 329129 */   GIR_RootConstrainSelectedInstOperands,
     /* 329130 */   // GIR_Coverage, 1402,
     /* 329130 */   GIR_Done,
     /* 329131 */ // Label 6769: @329131
     /* 329131 */ GIM_Reject,
     /* 329132 */ // Label 6757: @329132
     /* 329132 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(329165), // Rule ID 1400 //
     /* 329137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 329146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329158 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 329158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 329163 */   GIR_RootConstrainSelectedInstOperands,
     /* 329164 */   // GIR_Coverage, 1400,
     /* 329164 */   GIR_Done,
     /* 329165 */ // Label 6770: @329165
     /* 329165 */ GIM_Reject,
     /* 329166 */ // Label 6758: @329166
     /* 329166 */ GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(329199), // Rule ID 1403 //
     /* 329171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 329180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329192 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 329192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 329197 */   GIR_RootConstrainSelectedInstOperands,
     /* 329198 */   // GIR_Coverage, 1403,
     /* 329198 */   GIR_Done,
     /* 329199 */ // Label 6771: @329199
     /* 329199 */ GIM_Reject,
     /* 329200 */ // Label 6759: @329200
     /* 329200 */ GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(329233), // Rule ID 1398 //
     /* 329205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 329214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329226 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 329226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 329231 */   GIR_RootConstrainSelectedInstOperands,
     /* 329232 */   // GIR_Coverage, 1398,
     /* 329232 */   GIR_Done,
     /* 329233 */ // Label 6772: @329233
     /* 329233 */ GIM_Reject,
     /* 329234 */ // Label 6760: @329234
     /* 329234 */ GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(329267), // Rule ID 1401 //
     /* 329239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 329248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329260 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 329260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 329265 */   GIR_RootConstrainSelectedInstOperands,
     /* 329266 */   // GIR_Coverage, 1401,
     /* 329266 */   GIR_Done,
     /* 329267 */ // Label 6773: @329267
     /* 329267 */ GIM_Reject,
     /* 329268 */ // Label 6761: @329268
     /* 329268 */ GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(329301), // Rule ID 1399 //
     /* 329273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 329282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329294 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 329294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 329299 */   GIR_RootConstrainSelectedInstOperands,
     /* 329300 */   // GIR_Coverage, 1399,
     /* 329300 */   GIR_Done,
     /* 329301 */ // Label 6774: @329301
     /* 329301 */ GIM_Reject,
     /* 329302 */ // Label 6762: @329302
     /* 329302 */ GIM_Reject,
     /* 329303 */ // Label 83: @329303
     /* 329303 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6783*/ GIMT_Encode4(329706),
     /* 329314 */ /*GILLT_s32*//*Label 6775*/ GIMT_Encode4(329354),
     /* 329318 */ /*GILLT_s64*//*Label 6776*/ GIMT_Encode4(329428), GIMT_Encode4(0),
     /* 329326 */ /*GILLT_v2s32*//*Label 6777*/ GIMT_Encode4(329502), GIMT_Encode4(0),
     /* 329334 */ /*GILLT_v4s16*//*Label 6778*/ GIMT_Encode4(329536),
     /* 329338 */ /*GILLT_v4s32*//*Label 6779*/ GIMT_Encode4(329570),
     /* 329342 */ /*GILLT_v8s8*//*Label 6780*/ GIMT_Encode4(329604),
     /* 329346 */ /*GILLT_v8s16*//*Label 6781*/ GIMT_Encode4(329638),
     /* 329350 */ /*GILLT_v16s8*//*Label 6782*/ GIMT_Encode4(329672),
     /* 329354 */ // Label 6775: @329354
     /* 329354 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(329427),
     /* 329359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 329365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329373 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(329407), // Rule ID 2336 //
     /* 329378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 329393 */     // MIs[1] Operand 1
     /* 329393 */     // No operand predicates
     /* 329393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329395 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 329395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 329398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329405 */     GIR_RootConstrainSelectedInstOperands,
     /* 329406 */     // GIR_Coverage, 2336,
     /* 329406 */     GIR_EraseRootFromParent_Done,
     /* 329407 */   // Label 6785: @329407
     /* 329407 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(329426), // Rule ID 2335 //
     /* 329412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329419 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 329419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 329424 */     GIR_RootConstrainSelectedInstOperands,
     /* 329425 */     // GIR_Coverage, 2335,
     /* 329425 */     GIR_Done,
     /* 329426 */   // Label 6786: @329426
     /* 329426 */   GIM_Reject,
     /* 329427 */ // Label 6784: @329427
     /* 329427 */ GIM_Reject,
     /* 329428 */ // Label 6776: @329428
     /* 329428 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(329501),
     /* 329433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 329439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329447 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(329481), // Rule ID 2338 //
     /* 329452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 329467 */     // MIs[1] Operand 1
     /* 329467 */     // No operand predicates
     /* 329467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329469 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 329469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 329472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329479 */     GIR_RootConstrainSelectedInstOperands,
     /* 329480 */     // GIR_Coverage, 2338,
     /* 329480 */     GIR_EraseRootFromParent_Done,
     /* 329481 */   // Label 6788: @329481
     /* 329481 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(329500), // Rule ID 2337 //
     /* 329486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329493 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 329493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 329498 */     GIR_RootConstrainSelectedInstOperands,
     /* 329499 */     // GIR_Coverage, 2337,
     /* 329499 */     GIR_Done,
     /* 329500 */   // Label 6789: @329500
     /* 329500 */   GIM_Reject,
     /* 329501 */ // Label 6787: @329501
     /* 329501 */ GIM_Reject,
     /* 329502 */ // Label 6777: @329502
     /* 329502 */ GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(329535), // Rule ID 1537 //
     /* 329507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 329516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329528 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 329528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 329533 */   GIR_RootConstrainSelectedInstOperands,
     /* 329534 */   // GIR_Coverage, 1537,
     /* 329534 */   GIR_Done,
     /* 329535 */ // Label 6790: @329535
     /* 329535 */ GIM_Reject,
     /* 329536 */ // Label 6778: @329536
     /* 329536 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(329569), // Rule ID 1535 //
     /* 329541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 329550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329562 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 329562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 329567 */   GIR_RootConstrainSelectedInstOperands,
     /* 329568 */   // GIR_Coverage, 1535,
     /* 329568 */   GIR_Done,
     /* 329569 */ // Label 6791: @329569
     /* 329569 */ GIM_Reject,
     /* 329570 */ // Label 6779: @329570
     /* 329570 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(329603), // Rule ID 1538 //
     /* 329575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 329584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329596 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 329596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 329601 */   GIR_RootConstrainSelectedInstOperands,
     /* 329602 */   // GIR_Coverage, 1538,
     /* 329602 */   GIR_Done,
     /* 329603 */ // Label 6792: @329603
     /* 329603 */ GIM_Reject,
     /* 329604 */ // Label 6780: @329604
     /* 329604 */ GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(329637), // Rule ID 1533 //
     /* 329609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 329618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329630 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 329630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 329635 */   GIR_RootConstrainSelectedInstOperands,
     /* 329636 */   // GIR_Coverage, 1533,
     /* 329636 */   GIR_Done,
     /* 329637 */ // Label 6793: @329637
     /* 329637 */ GIM_Reject,
     /* 329638 */ // Label 6781: @329638
     /* 329638 */ GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(329671), // Rule ID 1536 //
     /* 329643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 329652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329664 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 329664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 329669 */   GIR_RootConstrainSelectedInstOperands,
     /* 329670 */   // GIR_Coverage, 1536,
     /* 329670 */   GIR_Done,
     /* 329671 */ // Label 6794: @329671
     /* 329671 */ GIM_Reject,
     /* 329672 */ // Label 6782: @329672
     /* 329672 */ GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(329705), // Rule ID 1534 //
     /* 329677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 329686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329698 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 329698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 329703 */   GIR_RootConstrainSelectedInstOperands,
     /* 329704 */   // GIR_Coverage, 1534,
     /* 329704 */   GIR_Done,
     /* 329705 */ // Label 6795: @329705
     /* 329705 */ GIM_Reject,
     /* 329706 */ // Label 6783: @329706
     /* 329706 */ GIM_Reject,
     /* 329707 */ // Label 84: @329707
     /* 329707 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6804*/ GIMT_Encode4(330110),
     /* 329718 */ /*GILLT_s32*//*Label 6796*/ GIMT_Encode4(329758),
     /* 329722 */ /*GILLT_s64*//*Label 6797*/ GIMT_Encode4(329832), GIMT_Encode4(0),
     /* 329730 */ /*GILLT_v2s32*//*Label 6798*/ GIMT_Encode4(329906), GIMT_Encode4(0),
     /* 329738 */ /*GILLT_v4s16*//*Label 6799*/ GIMT_Encode4(329940),
     /* 329742 */ /*GILLT_v4s32*//*Label 6800*/ GIMT_Encode4(329974),
     /* 329746 */ /*GILLT_v8s8*//*Label 6801*/ GIMT_Encode4(330008),
     /* 329750 */ /*GILLT_v8s16*//*Label 6802*/ GIMT_Encode4(330042),
     /* 329754 */ /*GILLT_v16s8*//*Label 6803*/ GIMT_Encode4(330076),
     /* 329758 */ // Label 6796: @329758
     /* 329758 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(329831),
     /* 329763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 329769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329777 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(329811), // Rule ID 2332 //
     /* 329782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 329797 */     // MIs[1] Operand 1
     /* 329797 */     // No operand predicates
     /* 329797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329799 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 329799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 329802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329809 */     GIR_RootConstrainSelectedInstOperands,
     /* 329810 */     // GIR_Coverage, 2332,
     /* 329810 */     GIR_EraseRootFromParent_Done,
     /* 329811 */   // Label 6806: @329811
     /* 329811 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(329830), // Rule ID 2331 //
     /* 329816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329823 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 329823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 329828 */     GIR_RootConstrainSelectedInstOperands,
     /* 329829 */     // GIR_Coverage, 2331,
     /* 329829 */     GIR_Done,
     /* 329830 */   // Label 6807: @329830
     /* 329830 */   GIM_Reject,
     /* 329831 */ // Label 6805: @329831
     /* 329831 */ GIM_Reject,
     /* 329832 */ // Label 6797: @329832
     /* 329832 */ GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(329905),
     /* 329837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 329843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329851 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(329885), // Rule ID 2334 //
     /* 329856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 329871 */     // MIs[1] Operand 1
     /* 329871 */     // No operand predicates
     /* 329871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329873 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 329873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 329876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329883 */     GIR_RootConstrainSelectedInstOperands,
     /* 329884 */     // GIR_Coverage, 2334,
     /* 329884 */     GIR_EraseRootFromParent_Done,
     /* 329885 */   // Label 6809: @329885
     /* 329885 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(329904), // Rule ID 2333 //
     /* 329890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 329893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329897 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 329897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 329902 */     GIR_RootConstrainSelectedInstOperands,
     /* 329903 */     // GIR_Coverage, 2333,
     /* 329903 */     GIR_Done,
     /* 329904 */   // Label 6810: @329904
     /* 329904 */   GIM_Reject,
     /* 329905 */ // Label 6808: @329905
     /* 329905 */ GIM_Reject,
     /* 329906 */ // Label 6798: @329906
     /* 329906 */ GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(329939), // Rule ID 1525 //
     /* 329911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 329920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329932 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 329932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 329937 */   GIR_RootConstrainSelectedInstOperands,
     /* 329938 */   // GIR_Coverage, 1525,
     /* 329938 */   GIR_Done,
     /* 329939 */ // Label 6811: @329939
     /* 329939 */ GIM_Reject,
     /* 329940 */ // Label 6799: @329940
     /* 329940 */ GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(329973), // Rule ID 1523 //
     /* 329945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 329954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329966 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 329966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 329971 */   GIR_RootConstrainSelectedInstOperands,
     /* 329972 */   // GIR_Coverage, 1523,
     /* 329972 */   GIR_Done,
     /* 329973 */ // Label 6812: @329973
     /* 329973 */ GIM_Reject,
     /* 329974 */ // Label 6800: @329974
     /* 329974 */ GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(330007), // Rule ID 1526 //
     /* 329979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 329988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330000 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 330000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 330005 */   GIR_RootConstrainSelectedInstOperands,
     /* 330006 */   // GIR_Coverage, 1526,
     /* 330006 */   GIR_Done,
     /* 330007 */ // Label 6813: @330007
     /* 330007 */ GIM_Reject,
     /* 330008 */ // Label 6801: @330008
     /* 330008 */ GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(330041), // Rule ID 1521 //
     /* 330013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 330022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330034 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 330034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 330039 */   GIR_RootConstrainSelectedInstOperands,
     /* 330040 */   // GIR_Coverage, 1521,
     /* 330040 */   GIR_Done,
     /* 330041 */ // Label 6814: @330041
     /* 330041 */ GIM_Reject,
     /* 330042 */ // Label 6802: @330042
     /* 330042 */ GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(330075), // Rule ID 1524 //
     /* 330047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 330056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330068 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 330068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 330073 */   GIR_RootConstrainSelectedInstOperands,
     /* 330074 */   // GIR_Coverage, 1524,
     /* 330074 */   GIR_Done,
     /* 330075 */ // Label 6815: @330075
     /* 330075 */ GIM_Reject,
     /* 330076 */ // Label 6803: @330076
     /* 330076 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(330109), // Rule ID 1522 //
     /* 330081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 330087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 330090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330102 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 330102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 330107 */   GIR_RootConstrainSelectedInstOperands,
     /* 330108 */   // GIR_Coverage, 1522,
     /* 330108 */   GIR_Done,
     /* 330109 */ // Label 6816: @330109
     /* 330109 */ GIM_Reject,
     /* 330110 */ // Label 6804: @330110
     /* 330110 */ GIM_Reject,
     /* 330111 */ // Label 85: @330111
     /* 330111 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6826*/ GIMT_Encode4(330925),
     /* 330122 */ /*GILLT_s32*//*Label 6817*/ GIMT_Encode4(330162),
     /* 330126 */ /*GILLT_s64*//*Label 6818*/ GIMT_Encode4(330189), GIMT_Encode4(0),
     /* 330134 */ /*GILLT_v2s32*//*Label 6819*/ GIMT_Encode4(330268),
     /* 330138 */ /*GILLT_v2s64*//*Label 6820*/ GIMT_Encode4(330295),
     /* 330142 */ /*GILLT_v4s16*//*Label 6821*/ GIMT_Encode4(330478),
     /* 330146 */ /*GILLT_v4s32*//*Label 6822*/ GIMT_Encode4(330505),
     /* 330150 */ /*GILLT_v8s8*//*Label 6823*/ GIMT_Encode4(330688),
     /* 330154 */ /*GILLT_v8s16*//*Label 6824*/ GIMT_Encode4(330715),
     /* 330158 */ /*GILLT_v16s8*//*Label 6825*/ GIMT_Encode4(330898),
     /* 330162 */ // Label 6817: @330162
     /* 330162 */ GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(330188), // Rule ID 2317 //
     /* 330167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 330170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330181 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 330181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 330186 */   GIR_RootConstrainSelectedInstOperands,
     /* 330187 */   // GIR_Coverage, 2317,
     /* 330187 */   GIR_Done,
     /* 330188 */ // Label 6827: @330188
     /* 330188 */ GIM_Reject,
     /* 330189 */ // Label 6818: @330189
     /* 330189 */ GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(330267),
     /* 330194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330197 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(330220), // Rule ID 1652 //
     /* 330202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330213 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 330213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 330218 */     GIR_RootConstrainSelectedInstOperands,
     /* 330219 */     // GIR_Coverage, 1652,
     /* 330219 */     GIR_Done,
     /* 330220 */   // Label 6829: @330220
     /* 330220 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(330243), // Rule ID 2318 //
     /* 330225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 330228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330236 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 330236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 330241 */     GIR_RootConstrainSelectedInstOperands,
     /* 330242 */     // GIR_Coverage, 2318,
     /* 330242 */     GIR_Done,
     /* 330243 */   // Label 6830: @330243
     /* 330243 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(330266), // Rule ID 2514 //
     /* 330248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 330251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330259 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 330259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 330264 */     GIR_RootConstrainSelectedInstOperands,
     /* 330265 */     // GIR_Coverage, 2514,
     /* 330265 */     GIR_Done,
     /* 330266 */   // Label 6831: @330266
     /* 330266 */   GIM_Reject,
     /* 330267 */ // Label 6828: @330267
     /* 330267 */ GIM_Reject,
     /* 330268 */ // Label 6819: @330268
     /* 330268 */ GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(330294), // Rule ID 707 //
     /* 330273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330287 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 330287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 330292 */   GIR_RootConstrainSelectedInstOperands,
     /* 330293 */   // GIR_Coverage, 707,
     /* 330293 */   GIR_Done,
     /* 330294 */ // Label 6832: @330294
     /* 330294 */ GIM_Reject,
     /* 330295 */ // Label 6820: @330295
     /* 330295 */ GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(330477),
     /* 330300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330307 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(330385), // Rule ID 4889 //
     /* 330312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 330328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330348 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 330361 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 330368 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 330368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 330371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 330378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 330383 */     GIR_RootConstrainSelectedInstOperands,
     /* 330384 */     // GIR_Coverage, 4889,
     /* 330384 */     GIR_EraseRootFromParent_Done,
     /* 330385 */   // Label 6834: @330385
     /* 330385 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(330457), // Rule ID 4888 //
     /* 330390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 330406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330435 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330442 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 330442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 330445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 330451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 330455 */     GIR_RootConstrainSelectedInstOperands,
     /* 330456 */     // GIR_Coverage, 4888,
     /* 330456 */     GIR_EraseRootFromParent_Done,
     /* 330457 */   // Label 6835: @330457
     /* 330457 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(330476), // Rule ID 709 //
     /* 330462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330469 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 330469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 330474 */     GIR_RootConstrainSelectedInstOperands,
     /* 330475 */     // GIR_Coverage, 709,
     /* 330475 */     GIR_Done,
     /* 330476 */   // Label 6836: @330476
     /* 330476 */   GIM_Reject,
     /* 330477 */ // Label 6833: @330477
     /* 330477 */ GIM_Reject,
     /* 330478 */ // Label 6821: @330478
     /* 330478 */ GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(330504), // Rule ID 705 //
     /* 330483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330497 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 330497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 330502 */   GIR_RootConstrainSelectedInstOperands,
     /* 330503 */   // GIR_Coverage, 705,
     /* 330503 */   GIR_Done,
     /* 330504 */ // Label 6837: @330504
     /* 330504 */ GIM_Reject,
     /* 330505 */ // Label 6822: @330505
     /* 330505 */ GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(330687),
     /* 330510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330517 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(330595), // Rule ID 4887 //
     /* 330522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 330538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330558 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 330571 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 330578 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 330578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 330581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 330588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 330593 */     GIR_RootConstrainSelectedInstOperands,
     /* 330594 */     // GIR_Coverage, 4887,
     /* 330594 */     GIR_EraseRootFromParent_Done,
     /* 330595 */   // Label 6839: @330595
     /* 330595 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(330667), // Rule ID 4886 //
     /* 330600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 330616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330641 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330652 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 330652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 330655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 330661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 330665 */     GIR_RootConstrainSelectedInstOperands,
     /* 330666 */     // GIR_Coverage, 4886,
     /* 330666 */     GIR_EraseRootFromParent_Done,
     /* 330667 */   // Label 6840: @330667
     /* 330667 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(330686), // Rule ID 708 //
     /* 330672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330679 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 330679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 330684 */     GIR_RootConstrainSelectedInstOperands,
     /* 330685 */     // GIR_Coverage, 708,
     /* 330685 */     GIR_Done,
     /* 330686 */   // Label 6841: @330686
     /* 330686 */   GIM_Reject,
     /* 330687 */ // Label 6838: @330687
     /* 330687 */ GIM_Reject,
     /* 330688 */ // Label 6823: @330688
     /* 330688 */ GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(330714), // Rule ID 703 //
     /* 330693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330707 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 330707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 330712 */   GIR_RootConstrainSelectedInstOperands,
     /* 330713 */   // GIR_Coverage, 703,
     /* 330713 */   GIR_Done,
     /* 330714 */ // Label 6842: @330714
     /* 330714 */ GIM_Reject,
     /* 330715 */ // Label 6824: @330715
     /* 330715 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(330897),
     /* 330720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330727 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(330805), // Rule ID 4885 //
     /* 330732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 330748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330768 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 330781 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 330788 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 330788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 330791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 330798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 330803 */     GIR_RootConstrainSelectedInstOperands,
     /* 330804 */     // GIR_Coverage, 4885,
     /* 330804 */     GIR_EraseRootFromParent_Done,
     /* 330805 */   // Label 6844: @330805
     /* 330805 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(330877), // Rule ID 4884 //
     /* 330810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 330818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 330826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 330847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 330851 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330855 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330862 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 330862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 330865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 330871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 330875 */     GIR_RootConstrainSelectedInstOperands,
     /* 330876 */     // GIR_Coverage, 4884,
     /* 330876 */     GIR_EraseRootFromParent_Done,
     /* 330877 */   // Label 6845: @330877
     /* 330877 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(330896), // Rule ID 706 //
     /* 330882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330889 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 330889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 330894 */     GIR_RootConstrainSelectedInstOperands,
     /* 330895 */     // GIR_Coverage, 706,
     /* 330895 */     GIR_Done,
     /* 330896 */   // Label 6846: @330896
     /* 330896 */   GIM_Reject,
     /* 330897 */ // Label 6843: @330897
     /* 330897 */ GIM_Reject,
     /* 330898 */ // Label 6825: @330898
     /* 330898 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(330924), // Rule ID 704 //
     /* 330903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 330909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330917 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 330917 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 330922 */   GIR_RootConstrainSelectedInstOperands,
     /* 330923 */   // GIR_Coverage, 704,
     /* 330923 */   GIR_Done,
     /* 330924 */ // Label 6847: @330924
     /* 330924 */ GIM_Reject,
     /* 330925 */ // Label 6826: @330925
     /* 330925 */ GIM_Reject,
     /* 330926 */ // Label 86: @330926
     /* 330926 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6850*/ GIMT_Encode4(331091),
     /* 330937 */ /*GILLT_s32*//*Label 6848*/ GIMT_Encode4(330945),
     /* 330941 */ /*GILLT_s64*//*Label 6849*/ GIMT_Encode4(331018),
     /* 330945 */ // Label 6848: @330945
     /* 330945 */ GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(330971), // Rule ID 4730 //
     /* 330950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330960 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 330960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 330965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330969 */   GIR_RootConstrainSelectedInstOperands,
     /* 330970 */   // GIR_Coverage, 4730,
     /* 330970 */   GIR_Done,
     /* 330971 */ // Label 6851: @330971
     /* 330971 */ GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(330994), // Rule ID 4736 //
     /* 330976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330983 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 330988 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330992 */   GIR_RootConstrainSelectedInstOperands,
     /* 330993 */   // GIR_Coverage, 4736,
     /* 330993 */   GIR_Done,
     /* 330994 */ // Label 6852: @330994
     /* 330994 */ GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(331017), // Rule ID 4738 //
     /* 330999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331006 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 331011 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331015 */   GIR_RootConstrainSelectedInstOperands,
     /* 331016 */   // GIR_Coverage, 4738,
     /* 331016 */   GIR_Done,
     /* 331017 */ // Label 6853: @331017
     /* 331017 */ GIM_Reject,
     /* 331018 */ // Label 6849: @331018
     /* 331018 */ GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(331044), // Rule ID 4732 //
     /* 331023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331033 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 331033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 331038 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331042 */   GIR_RootConstrainSelectedInstOperands,
     /* 331043 */   // GIR_Coverage, 4732,
     /* 331043 */   GIR_Done,
     /* 331044 */ // Label 6854: @331044
     /* 331044 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(331067), // Rule ID 4740 //
     /* 331049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331056 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 331061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331065 */   GIR_RootConstrainSelectedInstOperands,
     /* 331066 */   // GIR_Coverage, 4740,
     /* 331066 */   GIR_Done,
     /* 331067 */ // Label 6855: @331067
     /* 331067 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(331090), // Rule ID 4742 //
     /* 331072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331079 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 331084 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331088 */   GIR_RootConstrainSelectedInstOperands,
     /* 331089 */   // GIR_Coverage, 4742,
     /* 331089 */   GIR_Done,
     /* 331090 */ // Label 6856: @331090
     /* 331090 */ GIM_Reject,
     /* 331091 */ // Label 6850: @331091
     /* 331091 */ GIM_Reject,
     /* 331092 */ // Label 87: @331092
     /* 331092 */ GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(331190),
     /* 331097 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 331100 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6861*/ GIMT_Encode4(331189),
     /* 331111 */   /*GILLT_s16*//*Label 6858*/ GIMT_Encode4(331123),
     /* 331115 */   /*GILLT_s32*//*Label 6859*/ GIMT_Encode4(331147),
     /* 331119 */   /*GILLT_s64*//*Label 6860*/ GIMT_Encode4(331168),
     /* 331123 */   // Label 6858: @331123
     /* 331123 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(331146), // Rule ID 4734 //
     /* 331128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331135 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 331135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 331140 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331144 */     GIR_RootConstrainSelectedInstOperands,
     /* 331145 */     // GIR_Coverage, 4734,
     /* 331145 */     GIR_Done,
     /* 331146 */   // Label 6862: @331146
     /* 331146 */   GIM_Reject,
     /* 331147 */   // Label 6859: @331147
     /* 331147 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(331167), // Rule ID 4744 //
     /* 331152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331156 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 331161 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331165 */     GIR_RootConstrainSelectedInstOperands,
     /* 331166 */     // GIR_Coverage, 4744,
     /* 331166 */     GIR_Done,
     /* 331167 */   // Label 6863: @331167
     /* 331167 */   GIM_Reject,
     /* 331168 */   // Label 6860: @331168
     /* 331168 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(331188), // Rule ID 4746 //
     /* 331173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331177 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 331182 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331186 */     GIR_RootConstrainSelectedInstOperands,
     /* 331187 */     // GIR_Coverage, 4746,
     /* 331187 */     GIR_Done,
     /* 331188 */   // Label 6864: @331188
     /* 331188 */   GIM_Reject,
     /* 331189 */   // Label 6861: @331189
     /* 331189 */   GIM_Reject,
     /* 331190 */ // Label 6857: @331190
     /* 331190 */ GIM_Reject,
     /* 331191 */ // Label 88: @331191
     /* 331191 */ GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(331206), // Rule ID 225 //
     /* 331196 */   // MIs[0] addr
     /* 331196 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 331199 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 331199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 331204 */   GIR_RootConstrainSelectedInstOperands,
     /* 331205 */   // GIR_Coverage, 225,
     /* 331205 */   GIR_Done,
     /* 331206 */ // Label 6865: @331206
     /* 331206 */ GIM_Reject,
     /* 331207 */ // Label 89: @331207
     /* 331207 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6877*/ GIMT_Encode4(336578),
     /* 331218 */ /*GILLT_s64*//*Label 6866*/ GIMT_Encode4(331290), GIMT_Encode4(0),
     /* 331226 */ /*GILLT_v2s32*//*Label 6867*/ GIMT_Encode4(331692), GIMT_Encode4(0),
     /* 331234 */ /*GILLT_v4s16*//*Label 6868*/ GIMT_Encode4(332094), GIMT_Encode4(0),
     /* 331242 */ /*GILLT_v8s8*//*Label 6869*/ GIMT_Encode4(332496), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 331254 */ /*GILLT_nxv1s1*//*Label 6870*/ GIMT_Encode4(332676),
     /* 331258 */ /*GILLT_nxv2s1*//*Label 6871*/ GIMT_Encode4(334939),
     /* 331262 */ /*GILLT_nxv2s16*//*Label 6872*/ GIMT_Encode4(335794),
     /* 331266 */ /*GILLT_nxv2s32*//*Label 6873*/ GIMT_Encode4(336081), GIMT_Encode4(0),
     /* 331274 */ /*GILLT_nxv4s1*//*Label 6874*/ GIMT_Encode4(336151),
     /* 331278 */ /*GILLT_nxv4s16*//*Label 6875*/ GIMT_Encode4(336438), GIMT_Encode4(0),
     /* 331286 */ /*GILLT_nxv8s1*//*Label 6876*/ GIMT_Encode4(336508),
     /* 331290 */ // Label 6866: @331290
     /* 331290 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(331691),
     /* 331295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331302 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(331354), // Rule ID 5580 //
     /* 331307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 331315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331319 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 331321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331326 */     // MIs[0] Operand 2
     /* 331326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331339 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 331339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 331342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331352 */     GIR_RootConstrainSelectedInstOperands,
     /* 331353 */     // GIR_Coverage, 5580,
     /* 331353 */     GIR_EraseRootFromParent_Done,
     /* 331354 */   // Label 6879: @331354
     /* 331354 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(331406), // Rule ID 5583 //
     /* 331359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 331367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331371 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 331373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331378 */     // MIs[0] Operand 2
     /* 331378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331391 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 331391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 331394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331404 */     GIR_RootConstrainSelectedInstOperands,
     /* 331405 */     // GIR_Coverage, 5583,
     /* 331405 */     GIR_EraseRootFromParent_Done,
     /* 331406 */   // Label 6880: @331406
     /* 331406 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(331474), // Rule ID 5459 //
     /* 331411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331415 */     // MIs[0] Operand 2
     /* 331415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331426 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331446 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331456 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331473 */     // GIR_Coverage, 5459,
     /* 331473 */     GIR_EraseRootFromParent_Done,
     /* 331474 */   // Label 6881: @331474
     /* 331474 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(331542), // Rule ID 5464 //
     /* 331479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331483 */     // MIs[0] Operand 2
     /* 331483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331494 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331514 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331524 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331541 */     // GIR_Coverage, 5464,
     /* 331541 */     GIR_EraseRootFromParent_Done,
     /* 331542 */   // Label 6882: @331542
     /* 331542 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(331584), // Rule ID 6897 //
     /* 331547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331551 */     // MIs[0] Operand 2
     /* 331551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331562 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 331562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331567 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331583 */     // GIR_Coverage, 6897,
     /* 331583 */     GIR_EraseRootFromParent_Done,
     /* 331584 */   // Label 6883: @331584
     /* 331584 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(331626), // Rule ID 6898 //
     /* 331589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331593 */     // MIs[0] Operand 2
     /* 331593 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331604 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 331604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331609 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331625 */     // GIR_Coverage, 6898,
     /* 331625 */     GIR_EraseRootFromParent_Done,
     /* 331626 */   // Label 6884: @331626
     /* 331626 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(331690), // Rule ID 6902 //
     /* 331631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331635 */     // MIs[0] Operand 2
     /* 331635 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331646 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 331646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 331653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331662 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 331665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331672 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331689 */     // GIR_Coverage, 6902,
     /* 331689 */     GIR_EraseRootFromParent_Done,
     /* 331690 */   // Label 6885: @331690
     /* 331690 */   GIM_Reject,
     /* 331691 */ // Label 6878: @331691
     /* 331691 */ GIM_Reject,
     /* 331692 */ // Label 6867: @331692
     /* 331692 */ GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(332093),
     /* 331697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331704 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(331756), // Rule ID 5579 //
     /* 331709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 331717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331721 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 331723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331728 */     // MIs[0] Operand 2
     /* 331728 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331741 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 331741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 331744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331754 */     GIR_RootConstrainSelectedInstOperands,
     /* 331755 */     // GIR_Coverage, 5579,
     /* 331755 */     GIR_EraseRootFromParent_Done,
     /* 331756 */   // Label 6887: @331756
     /* 331756 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(331808), // Rule ID 5582 //
     /* 331761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 331769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331773 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 331775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331780 */     // MIs[0] Operand 2
     /* 331780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331793 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 331793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 331796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 331806 */     GIR_RootConstrainSelectedInstOperands,
     /* 331807 */     // GIR_Coverage, 5582,
     /* 331807 */     GIR_EraseRootFromParent_Done,
     /* 331808 */   // Label 6888: @331808
     /* 331808 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(331876), // Rule ID 5449 //
     /* 331813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331817 */     // MIs[0] Operand 2
     /* 331817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331828 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331848 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331858 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331875 */     // GIR_Coverage, 5449,
     /* 331875 */     GIR_EraseRootFromParent_Done,
     /* 331876 */   // Label 6889: @331876
     /* 331876 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(331944), // Rule ID 5454 //
     /* 331881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331885 */     // MIs[0] Operand 2
     /* 331885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331896 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331916 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331926 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331943 */     // GIR_Coverage, 5454,
     /* 331943 */     GIR_EraseRootFromParent_Done,
     /* 331944 */   // Label 6890: @331944
     /* 331944 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(331986), // Rule ID 6894 //
     /* 331949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331953 */     // MIs[0] Operand 2
     /* 331953 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331964 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 331964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331969 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331985 */     // GIR_Coverage, 6894,
     /* 331985 */     GIR_EraseRootFromParent_Done,
     /* 331986 */   // Label 6891: @331986
     /* 331986 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(332028), // Rule ID 6896 //
     /* 331991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331995 */     // MIs[0] Operand 2
     /* 331995 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332006 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 332006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332011 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332027 */     // GIR_Coverage, 6896,
     /* 332027 */     GIR_EraseRootFromParent_Done,
     /* 332028 */   // Label 6892: @332028
     /* 332028 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(332092), // Rule ID 6901 //
     /* 332033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332037 */     // MIs[0] Operand 2
     /* 332037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332048 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 332048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 332055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332064 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 332067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332074 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332091 */     // GIR_Coverage, 6901,
     /* 332091 */     GIR_EraseRootFromParent_Done,
     /* 332092 */   // Label 6893: @332092
     /* 332092 */   GIM_Reject,
     /* 332093 */ // Label 6886: @332093
     /* 332093 */ GIM_Reject,
     /* 332094 */ // Label 6868: @332094
     /* 332094 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(332495),
     /* 332099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332106 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(332158), // Rule ID 5578 //
     /* 332111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 332119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 332123 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 332125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332130 */     // MIs[0] Operand 2
     /* 332130 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332143 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 332143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 332146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 332152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 332156 */     GIR_RootConstrainSelectedInstOperands,
     /* 332157 */     // GIR_Coverage, 5578,
     /* 332157 */     GIR_EraseRootFromParent_Done,
     /* 332158 */   // Label 6895: @332158
     /* 332158 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(332210), // Rule ID 5581 //
     /* 332163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 332171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 332175 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 332177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332182 */     // MIs[0] Operand 2
     /* 332182 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332195 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 332195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 332198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 332204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 332208 */     GIR_RootConstrainSelectedInstOperands,
     /* 332209 */     // GIR_Coverage, 5581,
     /* 332209 */     GIR_EraseRootFromParent_Done,
     /* 332210 */   // Label 6896: @332210
     /* 332210 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(332278), // Rule ID 5439 //
     /* 332215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332219 */     // MIs[0] Operand 2
     /* 332219 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332230 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 332237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 332253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332260 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332277 */     // GIR_Coverage, 5439,
     /* 332277 */     GIR_EraseRootFromParent_Done,
     /* 332278 */   // Label 6897: @332278
     /* 332278 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(332346), // Rule ID 5444 //
     /* 332283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332287 */     // MIs[0] Operand 2
     /* 332287 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332298 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 332305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 332321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332345 */     // GIR_Coverage, 5444,
     /* 332345 */     GIR_EraseRootFromParent_Done,
     /* 332346 */   // Label 6898: @332346
     /* 332346 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(332388), // Rule ID 6892 //
     /* 332351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332355 */     // MIs[0] Operand 2
     /* 332355 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332366 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 332366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332371 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332387 */     // GIR_Coverage, 6892,
     /* 332387 */     GIR_EraseRootFromParent_Done,
     /* 332388 */   // Label 6899: @332388
     /* 332388 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(332430), // Rule ID 6895 //
     /* 332393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332397 */     // MIs[0] Operand 2
     /* 332397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332408 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 332408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332413 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332429 */     // GIR_Coverage, 6895,
     /* 332429 */     GIR_EraseRootFromParent_Done,
     /* 332430 */   // Label 6900: @332430
     /* 332430 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(332494), // Rule ID 6900 //
     /* 332435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332439 */     // MIs[0] Operand 2
     /* 332439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332450 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 332450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 332457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 332469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332476 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332493 */     // GIR_Coverage, 6900,
     /* 332493 */     GIR_EraseRootFromParent_Done,
     /* 332494 */   // Label 6901: @332494
     /* 332494 */   GIM_Reject,
     /* 332495 */ // Label 6894: @332495
     /* 332495 */ GIM_Reject,
     /* 332496 */ // Label 6869: @332496
     /* 332496 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(332675),
     /* 332501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 332504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332512 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(332576), // Rule ID 5434 //
     /* 332517 */     // MIs[0] Operand 2
     /* 332517 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 332528 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 332535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 332551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332558 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332575 */     // GIR_Coverage, 5434,
     /* 332575 */     GIR_EraseRootFromParent_Done,
     /* 332576 */   // Label 6903: @332576
     /* 332576 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(332614), // Rule ID 6893 //
     /* 332581 */     // MIs[0] Operand 2
     /* 332581 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332592 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 332592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332597 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332613 */     // GIR_Coverage, 6893,
     /* 332613 */     GIR_EraseRootFromParent_Done,
     /* 332614 */   // Label 6904: @332614
     /* 332614 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(332674), // Rule ID 6899 //
     /* 332619 */     // MIs[0] Operand 2
     /* 332619 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332630 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 332630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 332637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 332649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332656 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332673 */     // GIR_Coverage, 6899,
     /* 332673 */     GIR_EraseRootFromParent_Done,
     /* 332674 */   // Label 6905: @332674
     /* 332674 */   GIM_Reject,
     /* 332675 */ // Label 6902: @332675
     /* 332675 */ GIM_Reject,
     /* 332676 */ // Label 6870: @332676
     /* 332676 */ GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(332711), // Rule ID 8991 //
     /* 332681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 332687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332691 */   // MIs[0] Operand 2
     /* 332691 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332702 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 332702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332707 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 332709 */   GIR_RootConstrainSelectedInstOperands,
     /* 332710 */   // GIR_Coverage, 8991,
     /* 332710 */   GIR_EraseRootFromParent_Done,
     /* 332711 */ // Label 6906: @332711
     /* 332711 */ GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(332746), // Rule ID 8992 //
     /* 332716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 332722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332726 */   // MIs[0] Operand 2
     /* 332726 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332737 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 332737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332742 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 332744 */   GIR_RootConstrainSelectedInstOperands,
     /* 332745 */   // GIR_Coverage, 8992,
     /* 332745 */   GIR_EraseRootFromParent_Done,
     /* 332746 */ // Label 6907: @332746
     /* 332746 */ GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(332800), // Rule ID 8999 //
     /* 332751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332761 */   // MIs[0] Operand 2
     /* 332761 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332772 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 332772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332784 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332798 */   GIR_RootConstrainSelectedInstOperands,
     /* 332799 */   // GIR_Coverage, 8999,
     /* 332799 */   GIR_EraseRootFromParent_Done,
     /* 332800 */ // Label 6908: @332800
     /* 332800 */ GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(332854), // Rule ID 9000 //
     /* 332805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332815 */   // MIs[0] Operand 2
     /* 332815 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332826 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 332826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332852 */   GIR_RootConstrainSelectedInstOperands,
     /* 332853 */   // GIR_Coverage, 9000,
     /* 332853 */   GIR_EraseRootFromParent_Done,
     /* 332854 */ // Label 6909: @332854
     /* 332854 */ GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(332908), // Rule ID 9001 //
     /* 332859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332869 */   // MIs[0] Operand 2
     /* 332869 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332880 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 332880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332892 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332906 */   GIR_RootConstrainSelectedInstOperands,
     /* 332907 */   // GIR_Coverage, 9001,
     /* 332907 */   GIR_EraseRootFromParent_Done,
     /* 332908 */ // Label 6910: @332908
     /* 332908 */ GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(332962), // Rule ID 9002 //
     /* 332913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332923 */   // MIs[0] Operand 2
     /* 332923 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 332934 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 332934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332946 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332960 */   GIR_RootConstrainSelectedInstOperands,
     /* 332961 */   // GIR_Coverage, 9002,
     /* 332961 */   GIR_EraseRootFromParent_Done,
     /* 332962 */ // Label 6911: @332962
     /* 332962 */ GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(333033), // Rule ID 9011 //
     /* 332967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332977 */   // MIs[0] Operand 2
     /* 332977 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332988 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 332988 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332991 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332995 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333000 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333018 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333031 */   GIR_RootConstrainSelectedInstOperands,
     /* 333032 */   // GIR_Coverage, 9011,
     /* 333032 */   GIR_EraseRootFromParent_Done,
     /* 333033 */ // Label 6912: @333033
     /* 333033 */ GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(333104), // Rule ID 9012 //
     /* 333038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333048 */   // MIs[0] Operand 2
     /* 333048 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 333059 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333059 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333062 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333066 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333071 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333089 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333102 */   GIR_RootConstrainSelectedInstOperands,
     /* 333103 */   // GIR_Coverage, 9012,
     /* 333103 */   GIR_EraseRootFromParent_Done,
     /* 333104 */ // Label 6913: @333104
     /* 333104 */ GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(333175), // Rule ID 9013 //
     /* 333109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333119 */   // MIs[0] Operand 2
     /* 333119 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333130 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333130 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333133 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333137 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333142 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333160 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333173 */   GIR_RootConstrainSelectedInstOperands,
     /* 333174 */   // GIR_Coverage, 9013,
     /* 333174 */   GIR_EraseRootFromParent_Done,
     /* 333175 */ // Label 6914: @333175
     /* 333175 */ GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(333246), // Rule ID 9014 //
     /* 333180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333190 */   // MIs[0] Operand 2
     /* 333190 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 333201 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333201 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333204 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333208 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333213 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333231 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333244 */   GIR_RootConstrainSelectedInstOperands,
     /* 333245 */   // GIR_Coverage, 9014,
     /* 333245 */   GIR_EraseRootFromParent_Done,
     /* 333246 */ // Label 6915: @333246
     /* 333246 */ GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(333317), // Rule ID 9015 //
     /* 333251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333261 */   // MIs[0] Operand 2
     /* 333261 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333272 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333272 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333275 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333279 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333284 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333302 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333315 */   GIR_RootConstrainSelectedInstOperands,
     /* 333316 */   // GIR_Coverage, 9015,
     /* 333316 */   GIR_EraseRootFromParent_Done,
     /* 333317 */ // Label 6916: @333317
     /* 333317 */ GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(333388), // Rule ID 9016 //
     /* 333322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333332 */   // MIs[0] Operand 2
     /* 333332 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 333343 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333355 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333373 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333386 */   GIR_RootConstrainSelectedInstOperands,
     /* 333387 */   // GIR_Coverage, 9016,
     /* 333387 */   GIR_EraseRootFromParent_Done,
     /* 333388 */ // Label 6917: @333388
     /* 333388 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(333459), // Rule ID 9017 //
     /* 333393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333403 */   // MIs[0] Operand 2
     /* 333403 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 333414 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333414 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333417 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333421 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333426 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333444 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333457 */   GIR_RootConstrainSelectedInstOperands,
     /* 333458 */   // GIR_Coverage, 9017,
     /* 333458 */   GIR_EraseRootFromParent_Done,
     /* 333459 */ // Label 6918: @333459
     /* 333459 */ GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(333530), // Rule ID 9018 //
     /* 333464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333474 */   // MIs[0] Operand 2
     /* 333474 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 333485 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 333485 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333488 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333492 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333497 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333515 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333528 */   GIR_RootConstrainSelectedInstOperands,
     /* 333529 */   // GIR_Coverage, 9018,
     /* 333529 */   GIR_EraseRootFromParent_Done,
     /* 333530 */ // Label 6919: @333530
     /* 333530 */ GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(333618), // Rule ID 9027 //
     /* 333535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333545 */   // MIs[0] Operand 2
     /* 333545 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333556 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333556 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333559 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333563 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333568 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333574 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333577 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333581 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333586 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333603 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333616 */   GIR_RootConstrainSelectedInstOperands,
     /* 333617 */   // GIR_Coverage, 9027,
     /* 333617 */   GIR_EraseRootFromParent_Done,
     /* 333618 */ // Label 6920: @333618
     /* 333618 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(333706), // Rule ID 9028 //
     /* 333623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333633 */   // MIs[0] Operand 2
     /* 333633 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 333644 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333644 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333647 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333651 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333656 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333662 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333665 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333669 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333674 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333691 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333704 */   GIR_RootConstrainSelectedInstOperands,
     /* 333705 */   // GIR_Coverage, 9028,
     /* 333705 */   GIR_EraseRootFromParent_Done,
     /* 333706 */ // Label 6921: @333706
     /* 333706 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(333794), // Rule ID 9029 //
     /* 333711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333721 */   // MIs[0] Operand 2
     /* 333721 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333732 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333732 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333735 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333739 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333744 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333750 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333753 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333757 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333762 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333779 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333792 */   GIR_RootConstrainSelectedInstOperands,
     /* 333793 */   // GIR_Coverage, 9029,
     /* 333793 */   GIR_EraseRootFromParent_Done,
     /* 333794 */ // Label 6922: @333794
     /* 333794 */ GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(333882), // Rule ID 9030 //
     /* 333799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333809 */   // MIs[0] Operand 2
     /* 333809 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 333820 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333820 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333823 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333827 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333832 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333838 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333841 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333845 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333850 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333867 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333880 */   GIR_RootConstrainSelectedInstOperands,
     /* 333881 */   // GIR_Coverage, 9030,
     /* 333881 */   GIR_EraseRootFromParent_Done,
     /* 333882 */ // Label 6923: @333882
     /* 333882 */ GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(333970), // Rule ID 9031 //
     /* 333887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333897 */   // MIs[0] Operand 2
     /* 333897 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333908 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333908 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333911 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333915 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333920 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333926 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333929 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333933 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333938 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333955 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333968 */   GIR_RootConstrainSelectedInstOperands,
     /* 333969 */   // GIR_Coverage, 9031,
     /* 333969 */   GIR_EraseRootFromParent_Done,
     /* 333970 */ // Label 6924: @333970
     /* 333970 */ GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(334058), // Rule ID 9032 //
     /* 333975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333985 */   // MIs[0] Operand 2
     /* 333985 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 333996 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333996 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333999 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334003 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334008 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334014 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334017 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334021 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334026 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334043 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334053 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334056 */   GIR_RootConstrainSelectedInstOperands,
     /* 334057 */   // GIR_Coverage, 9032,
     /* 334057 */   GIR_EraseRootFromParent_Done,
     /* 334058 */ // Label 6925: @334058
     /* 334058 */ GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(334146), // Rule ID 9033 //
     /* 334063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334073 */   // MIs[0] Operand 2
     /* 334073 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 334084 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334084 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334087 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334091 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334096 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334102 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334105 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334109 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334114 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334131 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334144 */   GIR_RootConstrainSelectedInstOperands,
     /* 334145 */   // GIR_Coverage, 9033,
     /* 334145 */   GIR_EraseRootFromParent_Done,
     /* 334146 */ // Label 6926: @334146
     /* 334146 */ GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(334234), // Rule ID 9034 //
     /* 334151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334161 */   // MIs[0] Operand 2
     /* 334161 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 334172 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334172 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334175 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334179 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334184 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334190 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334193 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334197 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334202 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334219 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334232 */   GIR_RootConstrainSelectedInstOperands,
     /* 334233 */   // GIR_Coverage, 9034,
     /* 334233 */   GIR_EraseRootFromParent_Done,
     /* 334234 */ // Label 6927: @334234
     /* 334234 */ GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(334322), // Rule ID 9035 //
     /* 334239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334249 */   // MIs[0] Operand 2
     /* 334249 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 334260 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334260 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334263 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334267 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334272 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334278 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334281 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334285 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334290 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334307 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334320 */   GIR_RootConstrainSelectedInstOperands,
     /* 334321 */   // GIR_Coverage, 9035,
     /* 334321 */   GIR_EraseRootFromParent_Done,
     /* 334322 */ // Label 6928: @334322
     /* 334322 */ GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(334410), // Rule ID 9036 //
     /* 334327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334337 */   // MIs[0] Operand 2
     /* 334337 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 334348 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334348 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334351 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334355 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334360 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334366 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334369 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334373 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334378 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334395 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334408 */   GIR_RootConstrainSelectedInstOperands,
     /* 334409 */   // GIR_Coverage, 9036,
     /* 334409 */   GIR_EraseRootFromParent_Done,
     /* 334410 */ // Label 6929: @334410
     /* 334410 */ GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(334498), // Rule ID 9037 //
     /* 334415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334425 */   // MIs[0] Operand 2
     /* 334425 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 334436 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334436 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334439 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334443 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334448 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334454 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334457 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334461 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334466 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334483 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334496 */   GIR_RootConstrainSelectedInstOperands,
     /* 334497 */   // GIR_Coverage, 9037,
     /* 334497 */   GIR_EraseRootFromParent_Done,
     /* 334498 */ // Label 6930: @334498
     /* 334498 */ GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(334586), // Rule ID 9038 //
     /* 334503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334513 */   // MIs[0] Operand 2
     /* 334513 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 334524 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334524 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334527 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334531 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334536 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334542 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334545 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334549 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334554 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334571 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334584 */   GIR_RootConstrainSelectedInstOperands,
     /* 334585 */   // GIR_Coverage, 9038,
     /* 334585 */   GIR_EraseRootFromParent_Done,
     /* 334586 */ // Label 6931: @334586
     /* 334586 */ GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(334674), // Rule ID 9039 //
     /* 334591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334601 */   // MIs[0] Operand 2
     /* 334601 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 334612 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334612 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334615 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334619 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334624 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334630 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334633 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334637 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334642 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334647 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334650 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334654 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334659 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334672 */   GIR_RootConstrainSelectedInstOperands,
     /* 334673 */   // GIR_Coverage, 9039,
     /* 334673 */   GIR_EraseRootFromParent_Done,
     /* 334674 */ // Label 6932: @334674
     /* 334674 */ GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(334762), // Rule ID 9040 //
     /* 334679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334689 */   // MIs[0] Operand 2
     /* 334689 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 334700 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334700 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334703 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334707 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334712 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334718 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334721 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334725 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334730 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334747 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334760 */   GIR_RootConstrainSelectedInstOperands,
     /* 334761 */   // GIR_Coverage, 9040,
     /* 334761 */   GIR_EraseRootFromParent_Done,
     /* 334762 */ // Label 6933: @334762
     /* 334762 */ GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(334850), // Rule ID 9041 //
     /* 334767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334777 */   // MIs[0] Operand 2
     /* 334777 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 334788 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334788 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334791 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334795 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334800 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334806 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334809 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334813 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334818 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334835 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334848 */   GIR_RootConstrainSelectedInstOperands,
     /* 334849 */   // GIR_Coverage, 9041,
     /* 334849 */   GIR_EraseRootFromParent_Done,
     /* 334850 */ // Label 6934: @334850
     /* 334850 */ GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(334938), // Rule ID 9042 //
     /* 334855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334865 */   // MIs[0] Operand 2
     /* 334865 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 334876 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 334876 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 334879 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334883 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334888 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 334894 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334897 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334901 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334906 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334923 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334936 */   GIR_RootConstrainSelectedInstOperands,
     /* 334937 */   // GIR_Coverage, 9042,
     /* 334937 */   GIR_EraseRootFromParent_Done,
     /* 334938 */ // Label 6935: @334938
     /* 334938 */ GIM_Reject,
     /* 334939 */ // Label 6871: @334939
     /* 334939 */ GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(334974), // Rule ID 8993 //
     /* 334944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 334950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334954 */   // MIs[0] Operand 2
     /* 334954 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334965 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 334965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334970 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 334972 */   GIR_RootConstrainSelectedInstOperands,
     /* 334973 */   // GIR_Coverage, 8993,
     /* 334973 */   GIR_EraseRootFromParent_Done,
     /* 334974 */ // Label 6936: @334974
     /* 334974 */ GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(335009), // Rule ID 8994 //
     /* 334979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 334985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334989 */   // MIs[0] Operand 2
     /* 334989 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335000 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 335000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335005 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 335007 */   GIR_RootConstrainSelectedInstOperands,
     /* 335008 */   // GIR_Coverage, 8994,
     /* 335008 */   GIR_EraseRootFromParent_Done,
     /* 335009 */ // Label 6937: @335009
     /* 335009 */ GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(335063), // Rule ID 9003 //
     /* 335014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 335020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335024 */   // MIs[0] Operand 2
     /* 335024 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335035 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 335035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335047 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335061 */   GIR_RootConstrainSelectedInstOperands,
     /* 335062 */   // GIR_Coverage, 9003,
     /* 335062 */   GIR_EraseRootFromParent_Done,
     /* 335063 */ // Label 6938: @335063
     /* 335063 */ GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(335117), // Rule ID 9004 //
     /* 335068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 335074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335078 */   // MIs[0] Operand 2
     /* 335078 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335089 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 335089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335115 */   GIR_RootConstrainSelectedInstOperands,
     /* 335116 */   // GIR_Coverage, 9004,
     /* 335116 */   GIR_EraseRootFromParent_Done,
     /* 335117 */ // Label 6939: @335117
     /* 335117 */ GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(335171), // Rule ID 9005 //
     /* 335122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 335128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335132 */   // MIs[0] Operand 2
     /* 335132 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 335143 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 335143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335155 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335169 */   GIR_RootConstrainSelectedInstOperands,
     /* 335170 */   // GIR_Coverage, 9005,
     /* 335170 */   GIR_EraseRootFromParent_Done,
     /* 335171 */ // Label 6940: @335171
     /* 335171 */ GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(335225), // Rule ID 9006 //
     /* 335176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 335182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335186 */   // MIs[0] Operand 2
     /* 335186 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 335197 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 335197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335209 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335223 */   GIR_RootConstrainSelectedInstOperands,
     /* 335224 */   // GIR_Coverage, 9006,
     /* 335224 */   GIR_EraseRootFromParent_Done,
     /* 335225 */ // Label 6941: @335225
     /* 335225 */ GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(335296), // Rule ID 9019 //
     /* 335230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335240 */   // MIs[0] Operand 2
     /* 335240 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335251 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335251 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335254 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335258 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335263 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335281 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335294 */   GIR_RootConstrainSelectedInstOperands,
     /* 335295 */   // GIR_Coverage, 9019,
     /* 335295 */   GIR_EraseRootFromParent_Done,
     /* 335296 */ // Label 6942: @335296
     /* 335296 */ GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(335367), // Rule ID 9020 //
     /* 335301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335311 */   // MIs[0] Operand 2
     /* 335311 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335322 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335322 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335325 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335329 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335334 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335352 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335365 */   GIR_RootConstrainSelectedInstOperands,
     /* 335366 */   // GIR_Coverage, 9020,
     /* 335366 */   GIR_EraseRootFromParent_Done,
     /* 335367 */ // Label 6943: @335367
     /* 335367 */ GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(335438), // Rule ID 9021 //
     /* 335372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335382 */   // MIs[0] Operand 2
     /* 335382 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 335393 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335393 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335396 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335400 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335405 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335423 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335436 */   GIR_RootConstrainSelectedInstOperands,
     /* 335437 */   // GIR_Coverage, 9021,
     /* 335437 */   GIR_EraseRootFromParent_Done,
     /* 335438 */ // Label 6944: @335438
     /* 335438 */ GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(335509), // Rule ID 9022 //
     /* 335443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335453 */   // MIs[0] Operand 2
     /* 335453 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 335464 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335464 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335467 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335471 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335476 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335494 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335507 */   GIR_RootConstrainSelectedInstOperands,
     /* 335508 */   // GIR_Coverage, 9022,
     /* 335508 */   GIR_EraseRootFromParent_Done,
     /* 335509 */ // Label 6945: @335509
     /* 335509 */ GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(335580), // Rule ID 9023 //
     /* 335514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335524 */   // MIs[0] Operand 2
     /* 335524 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 335535 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335535 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335538 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335542 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335547 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335565 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335578 */   GIR_RootConstrainSelectedInstOperands,
     /* 335579 */   // GIR_Coverage, 9023,
     /* 335579 */   GIR_EraseRootFromParent_Done,
     /* 335580 */ // Label 6946: @335580
     /* 335580 */ GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(335651), // Rule ID 9024 //
     /* 335585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335595 */   // MIs[0] Operand 2
     /* 335595 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 335606 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335606 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335609 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335613 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335618 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335636 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335649 */   GIR_RootConstrainSelectedInstOperands,
     /* 335650 */   // GIR_Coverage, 9024,
     /* 335650 */   GIR_EraseRootFromParent_Done,
     /* 335651 */ // Label 6947: @335651
     /* 335651 */ GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(335722), // Rule ID 9025 //
     /* 335656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335666 */   // MIs[0] Operand 2
     /* 335666 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 335677 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335677 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335680 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335684 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335689 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335707 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335720 */   GIR_RootConstrainSelectedInstOperands,
     /* 335721 */   // GIR_Coverage, 9025,
     /* 335721 */   GIR_EraseRootFromParent_Done,
     /* 335722 */ // Label 6948: @335722
     /* 335722 */ GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(335793), // Rule ID 9026 //
     /* 335727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335737 */   // MIs[0] Operand 2
     /* 335737 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 335748 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 335748 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 335751 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335755 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335760 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 335764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 335769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335791 */   GIR_RootConstrainSelectedInstOperands,
     /* 335792 */   // GIR_Coverage, 9026,
     /* 335792 */   GIR_EraseRootFromParent_Done,
     /* 335793 */ // Label 6949: @335793
     /* 335793 */ GIM_Reject,
     /* 335794 */ // Label 6872: @335794
     /* 335794 */ GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(335829), // Rule ID 9043 //
     /* 335799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 335805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335809 */   // MIs[0] Operand 2
     /* 335809 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335820 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 335820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 335823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 335825 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 335827 */   GIR_RootConstrainSelectedInstOperands,
     /* 335828 */   // GIR_Coverage, 9043,
     /* 335828 */   GIR_EraseRootFromParent_Done,
     /* 335829 */ // Label 6950: @335829
     /* 335829 */ GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(335864), // Rule ID 9044 //
     /* 335834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 335840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335844 */   // MIs[0] Operand 2
     /* 335844 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335855 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 335855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 335858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 335860 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 335862 */   GIR_RootConstrainSelectedInstOperands,
     /* 335863 */   // GIR_Coverage, 9044,
     /* 335863 */   GIR_EraseRootFromParent_Done,
     /* 335864 */ // Label 6951: @335864
     /* 335864 */ GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(335918), // Rule ID 9049 //
     /* 335869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 335875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335879 */   // MIs[0] Operand 2
     /* 335879 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335890 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 335890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 335893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 335897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 335906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 335911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 335913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335916 */   GIR_RootConstrainSelectedInstOperands,
     /* 335917 */   // GIR_Coverage, 9049,
     /* 335917 */   GIR_EraseRootFromParent_Done,
     /* 335918 */ // Label 6952: @335918
     /* 335918 */ GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(335972), // Rule ID 9050 //
     /* 335923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 335929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335933 */   // MIs[0] Operand 2
     /* 335933 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 335944 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 335944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 335947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 335951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335956 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 335960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 335965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 335967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335970 */   GIR_RootConstrainSelectedInstOperands,
     /* 335971 */   // GIR_Coverage, 9050,
     /* 335971 */   GIR_EraseRootFromParent_Done,
     /* 335972 */ // Label 6953: @335972
     /* 335972 */ GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(336026), // Rule ID 9051 //
     /* 335977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 335983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 335987 */   // MIs[0] Operand 2
     /* 335987 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 335998 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 335998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 336001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 336005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336010 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 336014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 336019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336024 */   GIR_RootConstrainSelectedInstOperands,
     /* 336025 */   // GIR_Coverage, 9051,
     /* 336025 */   GIR_EraseRootFromParent_Done,
     /* 336026 */ // Label 6954: @336026
     /* 336026 */ GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(336080), // Rule ID 9052 //
     /* 336031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 336037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 336041 */   // MIs[0] Operand 2
     /* 336041 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 336052 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 336052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 336055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 336059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336064 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 336068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 336073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336078 */   GIR_RootConstrainSelectedInstOperands,
     /* 336079 */   // GIR_Coverage, 9052,
     /* 336079 */   GIR_EraseRootFromParent_Done,
     /* 336080 */ // Label 6955: @336080
     /* 336080 */ GIM_Reject,
     /* 336081 */ // Label 6873: @336081
     /* 336081 */ GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(336150),
     /* 336086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 336089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 336093 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(336121), // Rule ID 9047 //
     /* 336098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336101 */     // MIs[0] Operand 2
     /* 336101 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336112 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 336112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 336115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 336119 */     GIR_RootConstrainSelectedInstOperands,
     /* 336120 */     // GIR_Coverage, 9047,
     /* 336120 */     GIR_EraseRootFromParent_Done,
     /* 336121 */   // Label 6957: @336121
     /* 336121 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(336149), // Rule ID 9048 //
     /* 336126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336129 */     // MIs[0] Operand 2
     /* 336129 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 336140 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 336140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 336143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 336147 */     GIR_RootConstrainSelectedInstOperands,
     /* 336148 */     // GIR_Coverage, 9048,
     /* 336148 */     GIR_EraseRootFromParent_Done,
     /* 336149 */   // Label 6958: @336149
     /* 336149 */   GIM_Reject,
     /* 336150 */ // Label 6956: @336150
     /* 336150 */ GIM_Reject,
     /* 336151 */ // Label 6874: @336151
     /* 336151 */ GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(336186), // Rule ID 8995 //
     /* 336156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 336162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336166 */   // MIs[0] Operand 2
     /* 336166 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336177 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 336177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336182 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 336184 */   GIR_RootConstrainSelectedInstOperands,
     /* 336185 */   // GIR_Coverage, 8995,
     /* 336185 */   GIR_EraseRootFromParent_Done,
     /* 336186 */ // Label 6959: @336186
     /* 336186 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(336221), // Rule ID 8996 //
     /* 336191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 336197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336201 */   // MIs[0] Operand 2
     /* 336201 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 336212 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 336212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336217 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 336219 */   GIR_RootConstrainSelectedInstOperands,
     /* 336220 */   // GIR_Coverage, 8996,
     /* 336220 */   GIR_EraseRootFromParent_Done,
     /* 336221 */ // Label 6960: @336221
     /* 336221 */ GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(336275), // Rule ID 9007 //
     /* 336226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336236 */   // MIs[0] Operand 2
     /* 336236 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336247 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 336247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 336250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336259 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 336263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336273 */   GIR_RootConstrainSelectedInstOperands,
     /* 336274 */   // GIR_Coverage, 9007,
     /* 336274 */   GIR_EraseRootFromParent_Done,
     /* 336275 */ // Label 6961: @336275
     /* 336275 */ GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(336329), // Rule ID 9008 //
     /* 336280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336290 */   // MIs[0] Operand 2
     /* 336290 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 336301 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 336301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 336304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336313 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 336317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336324 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336327 */   GIR_RootConstrainSelectedInstOperands,
     /* 336328 */   // GIR_Coverage, 9008,
     /* 336328 */   GIR_EraseRootFromParent_Done,
     /* 336329 */ // Label 6962: @336329
     /* 336329 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(336383), // Rule ID 9009 //
     /* 336334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336344 */   // MIs[0] Operand 2
     /* 336344 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 336355 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 336355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 336358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336367 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 336371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336381 */   GIR_RootConstrainSelectedInstOperands,
     /* 336382 */   // GIR_Coverage, 9009,
     /* 336382 */   GIR_EraseRootFromParent_Done,
     /* 336383 */ // Label 6963: @336383
     /* 336383 */ GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(336437), // Rule ID 9010 //
     /* 336388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336398 */   // MIs[0] Operand 2
     /* 336398 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 336409 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 336409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 336412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336421 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 336425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336435 */   GIR_RootConstrainSelectedInstOperands,
     /* 336436 */   // GIR_Coverage, 9010,
     /* 336436 */   GIR_EraseRootFromParent_Done,
     /* 336437 */ // Label 6964: @336437
     /* 336437 */ GIM_Reject,
     /* 336438 */ // Label 6875: @336438
     /* 336438 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(336507),
     /* 336443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 336446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 336450 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(336478), // Rule ID 9045 //
     /* 336455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336458 */     // MIs[0] Operand 2
     /* 336458 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336469 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 336469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 336472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 336476 */     GIR_RootConstrainSelectedInstOperands,
     /* 336477 */     // GIR_Coverage, 9045,
     /* 336477 */     GIR_EraseRootFromParent_Done,
     /* 336478 */   // Label 6966: @336478
     /* 336478 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(336506), // Rule ID 9046 //
     /* 336483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336486 */     // MIs[0] Operand 2
     /* 336486 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 336497 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 336497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 336500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 336502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 336504 */     GIR_RootConstrainSelectedInstOperands,
     /* 336505 */     // GIR_Coverage, 9046,
     /* 336505 */     GIR_EraseRootFromParent_Done,
     /* 336506 */   // Label 6967: @336506
     /* 336506 */   GIM_Reject,
     /* 336507 */ // Label 6965: @336507
     /* 336507 */ GIM_Reject,
     /* 336508 */ // Label 6876: @336508
     /* 336508 */ GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(336577),
     /* 336513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 336516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 336520 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(336548), // Rule ID 8997 //
     /* 336525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336528 */     // MIs[0] Operand 2
     /* 336528 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 336539 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 336539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 336542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 336546 */     GIR_RootConstrainSelectedInstOperands,
     /* 336547 */     // GIR_Coverage, 8997,
     /* 336547 */     GIR_EraseRootFromParent_Done,
     /* 336548 */   // Label 6969: @336548
     /* 336548 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(336576), // Rule ID 8998 //
     /* 336553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 336556 */     // MIs[0] Operand 2
     /* 336556 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 336567 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 336567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 336570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 336572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 336574 */     GIR_RootConstrainSelectedInstOperands,
     /* 336575 */     // GIR_Coverage, 8998,
     /* 336575 */     GIR_EraseRootFromParent_Done,
     /* 336576 */   // Label 6970: @336576
     /* 336576 */   GIM_Reject,
     /* 336577 */ // Label 6968: @336577
     /* 336577 */ GIM_Reject,
     /* 336578 */ // Label 6877: @336578
     /* 336578 */ GIM_Reject,
     /* 336579 */ // Label 90: @336579
     /* 336579 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6986*/ GIMT_Encode4(365723),
     /* 336590 */ /*GILLT_s64*//*Label 6971*/ GIMT_Encode4(336674), GIMT_Encode4(0),
     /* 336598 */ /*GILLT_v2s32*//*Label 6972*/ GIMT_Encode4(337384),
     /* 336602 */ /*GILLT_v2s64*//*Label 6973*/ GIMT_Encode4(340915),
     /* 336606 */ /*GILLT_v4s16*//*Label 6974*/ GIMT_Encode4(344156),
     /* 336610 */ /*GILLT_v4s32*//*Label 6975*/ GIMT_Encode4(347796),
     /* 336614 */ /*GILLT_v8s8*//*Label 6976*/ GIMT_Encode4(350864),
     /* 336618 */ /*GILLT_v8s16*//*Label 6977*/ GIMT_Encode4(352708),
     /* 336622 */ /*GILLT_v16s8*//*Label 6978*/ GIMT_Encode4(356127), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 336634 */ /*GILLT_nxv2s16*//*Label 6979*/ GIMT_Encode4(357929),
     /* 336638 */ /*GILLT_nxv2s32*//*Label 6980*/ GIMT_Encode4(358054),
     /* 336642 */ /*GILLT_nxv2s64*//*Label 6981*/ GIMT_Encode4(358179), GIMT_Encode4(0),
     /* 336650 */ /*GILLT_nxv4s16*//*Label 6982*/ GIMT_Encode4(360157),
     /* 336654 */ /*GILLT_nxv4s32*//*Label 6983*/ GIMT_Encode4(360309), GIMT_Encode4(0),
     /* 336662 */ /*GILLT_nxv8s16*//*Label 6984*/ GIMT_Encode4(362341), GIMT_Encode4(0),
     /* 336670 */ /*GILLT_nxv16s8*//*Label 6985*/ GIMT_Encode4(364609),
     /* 336674 */ // Label 6971: @336674
     /* 336674 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(337383),
     /* 336679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 336685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336692 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(336822), // Rule ID 5734 //
     /* 336697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336730 */     // MIs[2] Operand 1
     /* 336730 */     // No operand predicates
     /* 336730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336738 */     // MIs[3] Operand 1
     /* 336738 */     // No operand predicates
     /* 336738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336740 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336740 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336743 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336747 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336752 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336755 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336759 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 336779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336804 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336821 */     // GIR_Coverage, 5734,
     /* 336821 */     GIR_EraseRootFromParent_Done,
     /* 336822 */   // Label 6988: @336822
     /* 336822 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(336983), // Rule ID 5735 //
     /* 336827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 336843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336860 */     // MIs[2] Operand 1
     /* 336860 */     // No operand predicates
     /* 336860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336868 */     // MIs[3] Operand 1
     /* 336868 */     // No operand predicates
     /* 336868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336870 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336870 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336873 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336877 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336882 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336885 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336889 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336892 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336897 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336914 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336917 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336921 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336924 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 336941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336946 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336965 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336982 */     // GIR_Coverage, 5735,
     /* 336982 */     GIR_EraseRootFromParent_Done,
     /* 336983 */   // Label 6989: @336983
     /* 336983 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(337113), // Rule ID 5766 //
     /* 336988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337021 */     // MIs[2] Operand 1
     /* 337021 */     // No operand predicates
     /* 337021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337029 */     // MIs[3] Operand 1
     /* 337029 */     // No operand predicates
     /* 337029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337031 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337043 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337046 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337050 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337058 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 337070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337075 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337081 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337095 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337112 */     // GIR_Coverage, 5766,
     /* 337112 */     GIR_EraseRootFromParent_Done,
     /* 337113 */   // Label 6990: @337113
     /* 337113 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(337274), // Rule ID 5767 //
     /* 337118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 337134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337151 */     // MIs[2] Operand 1
     /* 337151 */     // No operand predicates
     /* 337151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337159 */     // MIs[3] Operand 1
     /* 337159 */     // No operand predicates
     /* 337159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337161 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337161 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 337164 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337168 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337173 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 337176 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337180 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 337183 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337188 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337205 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337212 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 337232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337256 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337273 */     // GIR_Coverage, 5767,
     /* 337273 */     GIR_EraseRootFromParent_Done,
     /* 337274 */   // Label 6991: @337274
     /* 337274 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(337310), // Rule ID 6673 //
     /* 337279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337297 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 337297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 337304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337309 */     // GIR_Coverage, 6673,
     /* 337309 */     GIR_EraseRootFromParent_Done,
     /* 337310 */   // Label 6992: @337310
     /* 337310 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(337346), // Rule ID 6675 //
     /* 337315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337333 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 337333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 337340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337345 */     // GIR_Coverage, 6675,
     /* 337345 */     GIR_EraseRootFromParent_Done,
     /* 337346 */   // Label 6993: @337346
     /* 337346 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(337382), // Rule ID 6677 //
     /* 337351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337369 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 337369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337372 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 337374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 337376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337381 */     // GIR_Coverage, 6677,
     /* 337381 */     GIR_EraseRootFromParent_Done,
     /* 337382 */   // Label 6994: @337382
     /* 337382 */   GIM_Reject,
     /* 337383 */ // Label 6987: @337383
     /* 337383 */ GIM_Reject,
     /* 337384 */ // Label 6972: @337384
     /* 337384 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(340914),
     /* 337389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 337392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337402 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(337511), // Rule ID 4272 //
     /* 337407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337427 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 337451 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 337458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337478 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337510 */     // GIR_Coverage, 4272,
     /* 337510 */     GIR_EraseRootFromParent_Done,
     /* 337511 */   // Label 6996: @337511
     /* 337511 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(337620), // Rule ID 4273 //
     /* 337516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337520 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337526 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337536 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337543 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 337560 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 337567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337587 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337619 */     // GIR_Coverage, 4273,
     /* 337619 */     GIR_EraseRootFromParent_Done,
     /* 337620 */   // Label 6997: @337620
     /* 337620 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(337729), // Rule ID 4380 //
     /* 337625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337629 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337635 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337645 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337652 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 337669 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 337676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337696 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337728 */     // GIR_Coverage, 4380,
     /* 337728 */     GIR_EraseRootFromParent_Done,
     /* 337729 */   // Label 6998: @337729
     /* 337729 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(337838), // Rule ID 4381 //
     /* 337734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337738 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337744 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337754 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337761 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 337778 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 337785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337805 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337837 */     // GIR_Coverage, 4381,
     /* 337837 */     GIR_EraseRootFromParent_Done,
     /* 337838 */   // Label 6999: @337838
     /* 337838 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(337943), // Rule ID 4278 //
     /* 337843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337859 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337866 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 337883 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 337890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337910 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337942 */     // GIR_Coverage, 4278,
     /* 337942 */     GIR_EraseRootFromParent_Done,
     /* 337943 */   // Label 7000: @337943
     /* 337943 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(338048), // Rule ID 4280 //
     /* 337948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337964 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337971 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 337988 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 337988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 337995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338015 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338047 */     // GIR_Coverage, 4280,
     /* 338047 */     GIR_EraseRootFromParent_Done,
     /* 338048 */   // Label 7001: @338048
     /* 338048 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(338153), // Rule ID 4386 //
     /* 338053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338069 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338076 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 338093 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 338093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 338100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338120 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338152 */     // GIR_Coverage, 4386,
     /* 338152 */     GIR_EraseRootFromParent_Done,
     /* 338153 */   // Label 7002: @338153
     /* 338153 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(338258), // Rule ID 4388 //
     /* 338158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338174 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338181 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 338198 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 338198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 338205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338225 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338257 */     // GIR_Coverage, 4388,
     /* 338257 */     GIR_EraseRootFromParent_Done,
     /* 338258 */   // Label 7003: @338258
     /* 338258 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(338362), // Rule ID 4270 //
     /* 338263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338267 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338273 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338283 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338286 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338290 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338307 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 338307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338361 */     // GIR_Coverage, 4270,
     /* 338361 */     GIR_EraseRootFromParent_Done,
     /* 338362 */   // Label 7004: @338362
     /* 338362 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(338466), // Rule ID 4271 //
     /* 338367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338387 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338394 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338411 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 338411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 338418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338433 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338465 */     // GIR_Coverage, 4271,
     /* 338465 */     GIR_EraseRootFromParent_Done,
     /* 338466 */   // Label 7005: @338466
     /* 338466 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(338570), // Rule ID 4378 //
     /* 338471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338475 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338481 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338491 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338498 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338515 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 338515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338537 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338569 */     // GIR_Coverage, 4378,
     /* 338569 */     GIR_EraseRootFromParent_Done,
     /* 338570 */   // Label 7006: @338570
     /* 338570 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(338674), // Rule ID 4379 //
     /* 338575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338595 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338602 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338619 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 338619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 338626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338641 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338673 */     // GIR_Coverage, 4379,
     /* 338673 */     GIR_EraseRootFromParent_Done,
     /* 338674 */   // Label 7007: @338674
     /* 338674 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(338774), // Rule ID 4274 //
     /* 338679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338695 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338702 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338719 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 338719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338741 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338773 */     // GIR_Coverage, 4274,
     /* 338773 */     GIR_EraseRootFromParent_Done,
     /* 338774 */   // Label 7008: @338774
     /* 338774 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(338874), // Rule ID 4276 //
     /* 338779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338795 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338802 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338819 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 338819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 338826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338841 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338873 */     // GIR_Coverage, 4276,
     /* 338873 */     GIR_EraseRootFromParent_Done,
     /* 338874 */   // Label 7009: @338874
     /* 338874 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(338974), // Rule ID 4382 //
     /* 338879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338895 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338902 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338919 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 338919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338941 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338973 */     // GIR_Coverage, 4382,
     /* 338973 */     GIR_EraseRootFromParent_Done,
     /* 338974 */   // Label 7010: @338974
     /* 338974 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(339074), // Rule ID 4384 //
     /* 338979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338995 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339002 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 339019 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 339019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 339026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339041 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 339063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339073 */     // GIR_Coverage, 4384,
     /* 339073 */     GIR_EraseRootFromParent_Done,
     /* 339074 */   // Label 7011: @339074
     /* 339074 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(339194), // Rule ID 6452 //
     /* 339079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339098 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339101 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339105 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339112 */     // MIs[2] Rn
     /* 339112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 339116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339127 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 339127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 339130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 339148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339153 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339156 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339163 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339176 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339193 */     // GIR_Coverage, 6452,
     /* 339193 */     GIR_EraseRootFromParent_Done,
     /* 339194 */   // Label 7012: @339194
     /* 339194 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(339314), // Rule ID 6454 //
     /* 339199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339218 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339221 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339225 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339232 */     // MIs[2] Rn
     /* 339232 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 339236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339247 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 339247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 339250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 339268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339273 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339283 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339296 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339313 */     // GIR_Coverage, 6454,
     /* 339313 */     GIR_EraseRootFromParent_Done,
     /* 339314 */   // Label 7013: @339314
     /* 339314 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(339444), // Rule ID 5726 //
     /* 339319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339352 */     // MIs[2] Operand 1
     /* 339352 */     // No operand predicates
     /* 339352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339360 */     // MIs[3] Operand 1
     /* 339360 */     // No operand predicates
     /* 339360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339362 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339374 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339377 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339381 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339406 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339426 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339443 */     // GIR_Coverage, 5726,
     /* 339443 */     GIR_EraseRootFromParent_Done,
     /* 339444 */   // Label 7014: @339444
     /* 339444 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(339605), // Rule ID 5727 //
     /* 339449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339482 */     // MIs[2] Operand 1
     /* 339482 */     // No operand predicates
     /* 339482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339490 */     // MIs[3] Operand 1
     /* 339490 */     // No operand predicates
     /* 339490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339492 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 339495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339504 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 339507 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339511 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 339514 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339519 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339524 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339527 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339531 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339536 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339543 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339568 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339587 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339604 */     // GIR_Coverage, 5727,
     /* 339604 */     GIR_EraseRootFromParent_Done,
     /* 339605 */   // Label 7015: @339605
     /* 339605 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(339735), // Rule ID 5758 //
     /* 339610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339643 */     // MIs[2] Operand 1
     /* 339643 */     // No operand predicates
     /* 339643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339651 */     // MIs[3] Operand 1
     /* 339651 */     // No operand predicates
     /* 339651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339653 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339665 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339668 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339672 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339675 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339680 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339717 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339734 */     // GIR_Coverage, 5758,
     /* 339734 */     GIR_EraseRootFromParent_Done,
     /* 339735 */   // Label 7016: @339735
     /* 339735 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(339896), // Rule ID 5759 //
     /* 339740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339773 */     // MIs[2] Operand 1
     /* 339773 */     // No operand predicates
     /* 339773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339781 */     // MIs[3] Operand 1
     /* 339781 */     // No operand predicates
     /* 339781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339783 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339783 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 339786 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339790 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339795 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 339798 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339802 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 339805 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339810 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339827 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339830 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339834 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339865 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339878 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339895 */     // GIR_Coverage, 5759,
     /* 339895 */     GIR_EraseRootFromParent_Done,
     /* 339896 */   // Label 7017: @339896
     /* 339896 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(339962), // Rule ID 5677 //
     /* 339901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339919 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 339919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 339922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 339943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 339946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339961 */     // GIR_Coverage, 5677,
     /* 339961 */     GIR_EraseRootFromParent_Done,
     /* 339962 */   // Label 7018: @339962
     /* 339962 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(340028), // Rule ID 5689 //
     /* 339967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339985 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 339985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 339988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340027 */     // GIR_Coverage, 5689,
     /* 340027 */     GIR_EraseRootFromParent_Done,
     /* 340028 */   // Label 7019: @340028
     /* 340028 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(340163), // Rule ID 5697 //
     /* 340033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340045 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340049 */     // MIs[1] Operand 1
     /* 340049 */     // No operand predicates
     /* 340049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340057 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340061 */     // MIs[2] Operand 1
     /* 340061 */     // No operand predicates
     /* 340061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340063 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 340063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 340066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 340080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 340121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 340132 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340145 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340162 */     // GIR_Coverage, 5697,
     /* 340162 */     GIR_EraseRootFromParent_Done,
     /* 340163 */   // Label 7020: @340163
     /* 340163 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(340295), // Rule ID 6460 //
     /* 340168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340187 */     // MIs[1] Rn
     /* 340187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340204 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340208 */     // MIs[2] Operand 1
     /* 340208 */     // No operand predicates
     /* 340208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340210 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 340210 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340213 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340217 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340222 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 340225 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 340229 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340232 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340237 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 340249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340254 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 340260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340264 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340294 */     // GIR_Coverage, 6460,
     /* 340294 */     GIR_EraseRootFromParent_Done,
     /* 340295 */   // Label 7021: @340295
     /* 340295 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(340427), // Rule ID 6461 //
     /* 340300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340312 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340319 */     // MIs[1] Rn
     /* 340319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340336 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340340 */     // MIs[2] Operand 1
     /* 340340 */     // No operand predicates
     /* 340340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340342 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 340342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340354 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 340357 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 340361 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340364 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 340381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 340392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340396 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340426 */     // GIR_Coverage, 6461,
     /* 340426 */     GIR_EraseRootFromParent_Done,
     /* 340427 */   // Label 7022: @340427
     /* 340427 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(340610), // Rule ID 5769 //
     /* 340432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 340440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 340444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340457 */     // MIs[2] Operand 1
     /* 340457 */     // No operand predicates
     /* 340457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340459 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 340459 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 340462 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340466 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340473 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 340476 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340480 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340485 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340488 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 340492 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 340495 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340500 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340505 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340510 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 340513 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340517 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340524 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 340527 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340531 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340536 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 340543 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 340568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 340579 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 340582 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340592 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340609 */     // GIR_Coverage, 5769,
     /* 340609 */     GIR_EraseRootFromParent_Done,
     /* 340610 */   // Label 7023: @340610
     /* 340610 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(340788), // Rule ID 5700 //
     /* 340615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340635 */     // MIs[1] Operand 1
     /* 340635 */     // No operand predicates
     /* 340635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340637 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 340637 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 340640 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340644 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340651 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 340654 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340658 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340663 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340666 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340670 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 340673 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340678 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340683 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 340691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 340705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340714 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340721 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 340746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 340757 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 340760 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340770 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340787 */     // GIR_Coverage, 5700,
     /* 340787 */     GIR_EraseRootFromParent_Done,
     /* 340788 */   // Label 7024: @340788
     /* 340788 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(340913), // Rule ID 5703 //
     /* 340793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340813 */     // MIs[1] Operand 1
     /* 340813 */     // No operand predicates
     /* 340813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340815 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 340815 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 340818 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340822 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 340832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340841 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340848 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 340873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 340884 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340912 */     // GIR_Coverage, 5703,
     /* 340912 */     GIR_EraseRootFromParent_Done,
     /* 340913 */   // Label 7025: @340913
     /* 340913 */   GIM_Reject,
     /* 340914 */ // Label 6995: @340914
     /* 340914 */ GIM_Reject,
     /* 340915 */ // Label 6973: @340915
     /* 340915 */ GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(344155),
     /* 340920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 340926 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340933 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(341042), // Rule ID 4296 //
     /* 340938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340942 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340948 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340958 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340965 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 340982 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 340982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 340989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341009 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341041 */     // GIR_Coverage, 4296,
     /* 341041 */     GIR_EraseRootFromParent_Done,
     /* 341042 */   // Label 7027: @341042
     /* 341042 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(341151), // Rule ID 4297 //
     /* 341047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341051 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341057 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341067 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341074 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 341091 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 341098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341118 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341150 */     // GIR_Coverage, 4297,
     /* 341150 */     GIR_EraseRootFromParent_Done,
     /* 341151 */   // Label 7028: @341151
     /* 341151 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(341260), // Rule ID 4404 //
     /* 341156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341160 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341166 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341176 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341183 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 341200 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 341207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341227 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341259 */     // GIR_Coverage, 4404,
     /* 341259 */     GIR_EraseRootFromParent_Done,
     /* 341260 */   // Label 7029: @341260
     /* 341260 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(341369), // Rule ID 4405 //
     /* 341265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341269 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341275 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341285 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341288 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341292 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 341309 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 341316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341336 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341368 */     // GIR_Coverage, 4405,
     /* 341368 */     GIR_EraseRootFromParent_Done,
     /* 341369 */   // Label 7030: @341369
     /* 341369 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(341474), // Rule ID 4302 //
     /* 341374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341390 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341397 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 341414 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 341421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341441 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341473 */     // GIR_Coverage, 4302,
     /* 341473 */     GIR_EraseRootFromParent_Done,
     /* 341474 */   // Label 7031: @341474
     /* 341474 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(341579), // Rule ID 4304 //
     /* 341479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341495 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341502 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 341519 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 341526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341546 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341578 */     // GIR_Coverage, 4304,
     /* 341578 */     GIR_EraseRootFromParent_Done,
     /* 341579 */   // Label 7032: @341579
     /* 341579 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(341684), // Rule ID 4410 //
     /* 341584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341600 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341607 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 341624 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 341631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341651 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341683 */     // GIR_Coverage, 4410,
     /* 341683 */     GIR_EraseRootFromParent_Done,
     /* 341684 */   // Label 7033: @341684
     /* 341684 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(341789), // Rule ID 4412 //
     /* 341689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341705 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341712 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 341729 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 341729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 341736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341756 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341788 */     // GIR_Coverage, 4412,
     /* 341788 */     GIR_EraseRootFromParent_Done,
     /* 341789 */   // Label 7034: @341789
     /* 341789 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(341893), // Rule ID 4294 //
     /* 341794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341798 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341804 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341814 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341821 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 341838 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 341838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 341845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341860 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341892 */     // GIR_Coverage, 4294,
     /* 341892 */     GIR_EraseRootFromParent_Done,
     /* 341893 */   // Label 7035: @341893
     /* 341893 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(341997), // Rule ID 4295 //
     /* 341898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341902 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341908 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341918 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341925 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 341942 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 341942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 341949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341964 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341996 */     // GIR_Coverage, 4295,
     /* 341996 */     GIR_EraseRootFromParent_Done,
     /* 341997 */   // Label 7036: @341997
     /* 341997 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(342101), // Rule ID 4402 //
     /* 342002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342006 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342012 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342022 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342029 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 342046 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 342046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 342053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342068 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342100 */     // GIR_Coverage, 4402,
     /* 342100 */     GIR_EraseRootFromParent_Done,
     /* 342101 */   // Label 7037: @342101
     /* 342101 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(342205), // Rule ID 4403 //
     /* 342106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342110 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342116 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342126 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342133 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 342150 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 342150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 342157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342172 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342204 */     // GIR_Coverage, 4403,
     /* 342204 */     GIR_EraseRootFromParent_Done,
     /* 342205 */   // Label 7038: @342205
     /* 342205 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(342305), // Rule ID 4298 //
     /* 342210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342226 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342233 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 342250 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 342250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 342257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342272 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342304 */     // GIR_Coverage, 4298,
     /* 342304 */     GIR_EraseRootFromParent_Done,
     /* 342305 */   // Label 7039: @342305
     /* 342305 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(342405), // Rule ID 4300 //
     /* 342310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342326 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342333 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 342350 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 342350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 342357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342372 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342404 */     // GIR_Coverage, 4300,
     /* 342404 */     GIR_EraseRootFromParent_Done,
     /* 342405 */   // Label 7040: @342405
     /* 342405 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(342505), // Rule ID 4406 //
     /* 342410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342426 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342433 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 342450 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 342450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 342457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342472 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342504 */     // GIR_Coverage, 4406,
     /* 342504 */     GIR_EraseRootFromParent_Done,
     /* 342505 */   // Label 7041: @342505
     /* 342505 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(342605), // Rule ID 4408 //
     /* 342510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342526 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342529 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342533 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 342550 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 342550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 342557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342572 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342604 */     // GIR_Coverage, 4408,
     /* 342604 */     GIR_EraseRootFromParent_Done,
     /* 342605 */   // Label 7042: @342605
     /* 342605 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(342718), // Rule ID 5732 //
     /* 342610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 342634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342647 */     // MIs[3] Operand 1
     /* 342647 */     // No operand predicates
     /* 342647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342653 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 342656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 342660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342665 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 342669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 342672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 342677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 342699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342717 */     // GIR_Coverage, 5732,
     /* 342717 */     GIR_EraseRootFromParent_Done,
     /* 342718 */   // Label 7043: @342718
     /* 342718 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(342831), // Rule ID 5764 //
     /* 342723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 342747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342760 */     // MIs[3] Operand 1
     /* 342760 */     // No operand predicates
     /* 342760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342766 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 342769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 342773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342778 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 342782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 342785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 342790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 342812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342830 */     // GIR_Coverage, 5764,
     /* 342830 */     GIR_EraseRootFromParent_Done,
     /* 342831 */   // Label 7044: @342831
     /* 342831 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(342909), // Rule ID 1941 //
     /* 342836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342876 */     // MIs[2] Operand 1
     /* 342876 */     // No operand predicates
     /* 342876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342884 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342888 */     // MIs[3] Operand 1
     /* 342888 */     // No operand predicates
     /* 342888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342890 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 342890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 342893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 342900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 342907 */     GIR_RootConstrainSelectedInstOperands,
     /* 342908 */     // GIR_Coverage, 1941,
     /* 342908 */     GIR_EraseRootFromParent_Done,
     /* 342909 */   // Label 7045: @342909
     /* 342909 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(343004), // Rule ID 7440 //
     /* 342914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 342917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 342929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 342933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 342937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342941 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 342944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342948 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 342955 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 342958 */     // MIs[2] Rn
     /* 342958 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 342962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342975 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342979 */     // MIs[3] Operand 1
     /* 342979 */     // No operand predicates
     /* 342979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342981 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15862>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 342984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 342991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 342995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 343002 */     GIR_RootConstrainSelectedInstOperands,
     /* 343003 */     // GIR_Coverage, 7440,
     /* 343003 */     GIR_EraseRootFromParent_Done,
     /* 343004 */   // Label 7046: @343004
     /* 343004 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(343093), // Rule ID 5729 //
     /* 343009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 343021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343033 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343037 */     // MIs[2] Operand 1
     /* 343037 */     // No operand predicates
     /* 343037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343045 */     // MIs[3] Operand 1
     /* 343045 */     // No operand predicates
     /* 343045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343047 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 343047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 343050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343059 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 343065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343091 */     GIR_RootConstrainSelectedInstOperands,
     /* 343092 */     // GIR_Coverage, 5729,
     /* 343092 */     GIR_EraseRootFromParent_Done,
     /* 343093 */   // Label 7047: @343093
     /* 343093 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(343182), // Rule ID 5761 //
     /* 343098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 343110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343126 */     // MIs[2] Operand 1
     /* 343126 */     // No operand predicates
     /* 343126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343134 */     // MIs[3] Operand 1
     /* 343134 */     // No operand predicates
     /* 343134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343136 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 343136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 343139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343148 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 343154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343180 */     GIR_RootConstrainSelectedInstOperands,
     /* 343181 */     // GIR_Coverage, 5761,
     /* 343181 */     GIR_EraseRootFromParent_Done,
     /* 343182 */   // Label 7048: @343182
     /* 343182 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(343249), // Rule ID 5731 //
     /* 343187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343220 */     // MIs[2] Operand 1
     /* 343220 */     // No operand predicates
     /* 343220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343228 */     // MIs[3] Operand 1
     /* 343228 */     // No operand predicates
     /* 343228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343230 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 343230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 343237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343247 */     GIR_RootConstrainSelectedInstOperands,
     /* 343248 */     // GIR_Coverage, 5731,
     /* 343248 */     GIR_EraseRootFromParent_Done,
     /* 343249 */   // Label 7049: @343249
     /* 343249 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(343347), // Rule ID 5733 //
     /* 343254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 343270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343287 */     // MIs[2] Operand 1
     /* 343287 */     // No operand predicates
     /* 343287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343295 */     // MIs[3] Operand 1
     /* 343295 */     // No operand predicates
     /* 343295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343297 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 343297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 343312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 343319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343334 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 343336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343345 */     GIR_RootConstrainSelectedInstOperands,
     /* 343346 */     // GIR_Coverage, 5733,
     /* 343346 */     GIR_EraseRootFromParent_Done,
     /* 343347 */   // Label 7050: @343347
     /* 343347 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(343414), // Rule ID 5763 //
     /* 343352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343385 */     // MIs[2] Operand 1
     /* 343385 */     // No operand predicates
     /* 343385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343393 */     // MIs[3] Operand 1
     /* 343393 */     // No operand predicates
     /* 343393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343395 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 343395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 343402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343412 */     GIR_RootConstrainSelectedInstOperands,
     /* 343413 */     // GIR_Coverage, 5763,
     /* 343413 */     GIR_EraseRootFromParent_Done,
     /* 343414 */   // Label 7051: @343414
     /* 343414 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(343512), // Rule ID 5765 //
     /* 343419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 343435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343452 */     // MIs[2] Operand 1
     /* 343452 */     // No operand predicates
     /* 343452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343460 */     // MIs[3] Operand 1
     /* 343460 */     // No operand predicates
     /* 343460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343462 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 343462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343474 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 343477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343481 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 343484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 343501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 343504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343510 */     GIR_RootConstrainSelectedInstOperands,
     /* 343511 */     // GIR_Coverage, 5765,
     /* 343511 */     GIR_EraseRootFromParent_Done,
     /* 343512 */   // Label 7052: @343512
     /* 343512 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(343578), // Rule ID 5681 //
     /* 343517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343535 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 343535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 343538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343562 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343577 */     // GIR_Coverage, 5681,
     /* 343577 */     GIR_EraseRootFromParent_Done,
     /* 343578 */   // Label 7053: @343578
     /* 343578 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(343644), // Rule ID 5691 //
     /* 343583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343601 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 343601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 343604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343643 */     // GIR_Coverage, 5691,
     /* 343643 */     GIR_EraseRootFromParent_Done,
     /* 343644 */   // Label 7054: @343644
     /* 343644 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(343713), // Rule ID 6443 //
     /* 343649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343668 */     // MIs[1] Rn
     /* 343668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343685 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343689 */     // MIs[2] Operand 1
     /* 343689 */     // No operand predicates
     /* 343689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343691 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 343691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 343694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 343701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343711 */     GIR_RootConstrainSelectedInstOperands,
     /* 343712 */     // GIR_Coverage, 6443,
     /* 343712 */     GIR_EraseRootFromParent_Done,
     /* 343713 */   // Label 7055: @343713
     /* 343713 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(343782), // Rule ID 6444 //
     /* 343718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343737 */     // MIs[1] Rn
     /* 343737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343754 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343758 */     // MIs[2] Operand 1
     /* 343758 */     // No operand predicates
     /* 343758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343760 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 343760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 343763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 343770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343780 */     GIR_RootConstrainSelectedInstOperands,
     /* 343781 */     // GIR_Coverage, 6444,
     /* 343781 */     GIR_EraseRootFromParent_Done,
     /* 343782 */   // Label 7056: @343782
     /* 343782 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(343864), // Rule ID 7439 //
     /* 343787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 343790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343802 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 343805 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343809 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 343816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 343819 */     // MIs[1] Rn
     /* 343819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343836 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343840 */     // MIs[2] Operand 1
     /* 343840 */     // No operand predicates
     /* 343840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343842 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15862>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 343842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 343845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 343852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343862 */     GIR_RootConstrainSelectedInstOperands,
     /* 343863 */     // GIR_Coverage, 7439,
     /* 343863 */     GIR_EraseRootFromParent_Done,
     /* 343864 */   // Label 7057: @343864
     /* 343864 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(343913), // Rule ID 5698 //
     /* 343869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 343877 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 343881 */     // MIs[1] Operand 1
     /* 343881 */     // No operand predicates
     /* 343881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 343893 */     // MIs[2] Operand 1
     /* 343893 */     // No operand predicates
     /* 343893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343895 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 343895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 343898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 343905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 343911 */     GIR_RootConstrainSelectedInstOperands,
     /* 343912 */     // GIR_Coverage, 5698,
     /* 343912 */     GIR_EraseRootFromParent_Done,
     /* 343913 */   // Label 7058: @343913
     /* 343913 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(344014), // Rule ID 5770 //
     /* 343918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 343926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 343930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343943 */     // MIs[2] Operand 1
     /* 343943 */     // No operand predicates
     /* 343943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343945 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 343945 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343948 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343952 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 343959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343971 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 343978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 343981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 343999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344001 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 344003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 344006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344012 */     GIR_RootConstrainSelectedInstOperands,
     /* 344013 */     // GIR_Coverage, 5770,
     /* 344013 */     GIR_EraseRootFromParent_Done,
     /* 344014 */   // Label 7059: @344014
     /* 344014 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(344058), // Rule ID 1937 //
     /* 344019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 344042 */     // MIs[1] Operand 1
     /* 344042 */     // No operand predicates
     /* 344042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344044 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 344044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 344047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 344051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 344054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 344056 */     GIR_RootConstrainSelectedInstOperands,
     /* 344057 */     // GIR_Coverage, 1937,
     /* 344057 */     GIR_EraseRootFromParent_Done,
     /* 344058 */   // Label 7060: @344058
     /* 344058 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(344154), // Rule ID 5702 //
     /* 344063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 344083 */     // MIs[1] Operand 1
     /* 344083 */     // No operand predicates
     /* 344083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344085 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 344085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 344088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 344102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344118 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 344121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 344139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344152 */     GIR_RootConstrainSelectedInstOperands,
     /* 344153 */     // GIR_Coverage, 5702,
     /* 344153 */     GIR_EraseRootFromParent_Done,
     /* 344154 */   // Label 7061: @344154
     /* 344154 */   GIM_Reject,
     /* 344155 */ // Label 7026: @344155
     /* 344155 */ GIM_Reject,
     /* 344156 */ // Label 6974: @344156
     /* 344156 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(347795),
     /* 344161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344164 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(344290), // Rule ID 4236 //
     /* 344169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344183 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344189 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344199 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344202 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344206 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344213 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344230 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344257 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344289 */     // GIR_Coverage, 4236,
     /* 344289 */     GIR_EraseRootFromParent_Done,
     /* 344290 */   // Label 7063: @344290
     /* 344290 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(344416), // Rule ID 4237 //
     /* 344295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344309 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344315 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344325 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344328 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344332 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344339 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 344356 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 344363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344383 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344415 */     // GIR_Coverage, 4237,
     /* 344415 */     GIR_EraseRootFromParent_Done,
     /* 344416 */   // Label 7064: @344416
     /* 344416 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(344535), // Rule ID 4344 //
     /* 344421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344441 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344451 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344458 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344475 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344502 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344534 */     // GIR_Coverage, 4344,
     /* 344534 */     GIR_EraseRootFromParent_Done,
     /* 344535 */   // Label 7065: @344535
     /* 344535 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(344654), // Rule ID 4345 //
     /* 344540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344554 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344560 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344570 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344577 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 344594 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 344601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344621 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344653 */     // GIR_Coverage, 4345,
     /* 344653 */     GIR_EraseRootFromParent_Done,
     /* 344654 */   // Label 7066: @344654
     /* 344654 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(344776), // Rule ID 4242 //
     /* 344659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344685 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344688 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344692 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344699 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344716 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344743 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344775 */     // GIR_Coverage, 4242,
     /* 344775 */     GIR_EraseRootFromParent_Done,
     /* 344776 */   // Label 7067: @344776
     /* 344776 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(344898), // Rule ID 4244 //
     /* 344781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344807 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344810 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344814 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344821 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 344838 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 344845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344865 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344897 */     // GIR_Coverage, 4244,
     /* 344897 */     GIR_EraseRootFromParent_Done,
     /* 344898 */   // Label 7068: @344898
     /* 344898 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(345013), // Rule ID 4350 //
     /* 344903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344929 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344936 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344953 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344980 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345012 */     // GIR_Coverage, 4350,
     /* 345012 */     GIR_EraseRootFromParent_Done,
     /* 345013 */   // Label 7069: @345013
     /* 345013 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(345128), // Rule ID 4352 //
     /* 345018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345044 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345051 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 345068 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 345075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345095 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345127 */     // GIR_Coverage, 4352,
     /* 345127 */     GIR_EraseRootFromParent_Done,
     /* 345128 */   // Label 7070: @345128
     /* 345128 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(345249), // Rule ID 4234 //
     /* 345133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345147 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345153 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345163 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345166 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345170 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345177 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345194 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345216 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345248 */     // GIR_Coverage, 4234,
     /* 345248 */     GIR_EraseRootFromParent_Done,
     /* 345249 */   // Label 7071: @345249
     /* 345249 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(345370), // Rule ID 4235 //
     /* 345254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345268 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345274 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345284 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345287 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345291 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345298 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 345315 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 345315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 345322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345337 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345369 */     // GIR_Coverage, 4235,
     /* 345369 */     GIR_EraseRootFromParent_Done,
     /* 345370 */   // Label 7072: @345370
     /* 345370 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(345484), // Rule ID 4342 //
     /* 345375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345389 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345395 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345405 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345408 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345412 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345429 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345451 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345483 */     // GIR_Coverage, 4342,
     /* 345483 */     GIR_EraseRootFromParent_Done,
     /* 345484 */   // Label 7073: @345484
     /* 345484 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(345598), // Rule ID 4343 //
     /* 345489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345519 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345526 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 345543 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 345543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 345550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345565 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345597 */     // GIR_Coverage, 4343,
     /* 345597 */     GIR_EraseRootFromParent_Done,
     /* 345598 */   // Label 7074: @345598
     /* 345598 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(345715), // Rule ID 4238 //
     /* 345603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345629 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345632 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345636 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345643 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345660 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345682 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345714 */     // GIR_Coverage, 4238,
     /* 345714 */     GIR_EraseRootFromParent_Done,
     /* 345715 */   // Label 7075: @345715
     /* 345715 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(345832), // Rule ID 4240 //
     /* 345720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345746 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345749 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345753 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345760 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 345777 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 345777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 345784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345799 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345831 */     // GIR_Coverage, 4240,
     /* 345831 */     GIR_EraseRootFromParent_Done,
     /* 345832 */   // Label 7076: @345832
     /* 345832 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(345942), // Rule ID 4346 //
     /* 345837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345863 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345870 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345887 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345909 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345941 */     // GIR_Coverage, 4346,
     /* 345941 */     GIR_EraseRootFromParent_Done,
     /* 345942 */   // Label 7077: @345942
     /* 345942 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(346052), // Rule ID 4348 //
     /* 345947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345973 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345980 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 345997 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 345997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 346004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346019 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346051 */     // GIR_Coverage, 4348,
     /* 346051 */     GIR_EraseRootFromParent_Done,
     /* 346052 */   // Label 7078: @346052
     /* 346052 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(346182), // Rule ID 6456 //
     /* 346057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346086 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346089 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346093 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 346100 */     // MIs[2] Rn
     /* 346100 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 346104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346115 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 346115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 346118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 346136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346144 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346147 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 346151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346164 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346181 */     // GIR_Coverage, 6456,
     /* 346181 */     GIR_EraseRootFromParent_Done,
     /* 346182 */   // Label 7079: @346182
     /* 346182 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(346322), // Rule ID 5718 //
     /* 346187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346230 */     // MIs[2] Operand 1
     /* 346230 */     // No operand predicates
     /* 346230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346238 */     // MIs[3] Operand 1
     /* 346238 */     // No operand predicates
     /* 346238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346240 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 346240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346252 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 346255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 346259 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 346290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 346297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346304 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346321 */     // GIR_Coverage, 5718,
     /* 346321 */     GIR_EraseRootFromParent_Done,
     /* 346322 */   // Label 7080: @346322
     /* 346322 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(346493), // Rule ID 5719 //
     /* 346327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346370 */     // MIs[2] Operand 1
     /* 346370 */     // No operand predicates
     /* 346370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346378 */     // MIs[3] Operand 1
     /* 346378 */     // No operand predicates
     /* 346378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346380 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 346380 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 346383 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346387 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346392 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346395 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346399 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 346402 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346407 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346424 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 346427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 346431 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346456 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 346462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 346468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346475 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346492 */     // GIR_Coverage, 5719,
     /* 346492 */     GIR_EraseRootFromParent_Done,
     /* 346493 */   // Label 7081: @346493
     /* 346493 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(346633), // Rule ID 5750 //
     /* 346498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346541 */     // MIs[2] Operand 1
     /* 346541 */     // No operand predicates
     /* 346541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346549 */     // MIs[3] Operand 1
     /* 346549 */     // No operand predicates
     /* 346549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346551 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 346551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346563 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 346566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 346570 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 346601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 346608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346615 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346632 */     // GIR_Coverage, 5750,
     /* 346632 */     GIR_EraseRootFromParent_Done,
     /* 346633 */   // Label 7082: @346633
     /* 346633 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(346804), // Rule ID 5751 //
     /* 346638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346681 */     // MIs[2] Operand 1
     /* 346681 */     // No operand predicates
     /* 346681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346689 */     // MIs[3] Operand 1
     /* 346689 */     // No operand predicates
     /* 346689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346691 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 346691 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 346694 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346698 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346703 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346706 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346710 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 346713 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346718 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346735 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 346738 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 346742 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 346773 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 346779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346786 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346803 */     // GIR_Coverage, 5751,
     /* 346803 */     GIR_EraseRootFromParent_Done,
     /* 346804 */   // Label 7083: @346804
     /* 346804 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(346883), // Rule ID 5671 //
     /* 346809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346837 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 346837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 346853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346882 */     // GIR_Coverage, 5671,
     /* 346882 */     GIR_EraseRootFromParent_Done,
     /* 346883 */   // Label 7084: @346883
     /* 346883 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(346959), // Rule ID 5673 //
     /* 346888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346916 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 346916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 346919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346958 */     // GIR_Coverage, 5673,
     /* 346958 */     GIR_EraseRootFromParent_Done,
     /* 346959 */   // Label 7085: @346959
     /* 346959 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(347035), // Rule ID 5683 //
     /* 346964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346992 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 346992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 346995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 347016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347034 */     // GIR_Coverage, 5683,
     /* 347034 */     GIR_EraseRootFromParent_Done,
     /* 347035 */   // Label 7086: @347035
     /* 347035 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(347180), // Rule ID 5695 //
     /* 347040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 347062 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 347066 */     // MIs[1] Operand 1
     /* 347066 */     // No operand predicates
     /* 347066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347074 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347078 */     // MIs[2] Operand 1
     /* 347078 */     // No operand predicates
     /* 347078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347080 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347080 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 347083 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347087 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 347097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347106 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 347109 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347113 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347116 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 347138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 347149 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 347155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347162 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347179 */     // GIR_Coverage, 5695,
     /* 347179 */     GIR_EraseRootFromParent_Done,
     /* 347180 */   // Label 7087: @347180
     /* 347180 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(347329), // Rule ID 6459 //
     /* 347185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347207 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347210 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347214 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347221 */     // MIs[1] Rn
     /* 347221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347242 */     // MIs[2] Operand 1
     /* 347242 */     // No operand predicates
     /* 347242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347244 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 347244 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 347247 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347251 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347256 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 347259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 347263 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347266 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347271 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 347283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347288 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 347294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347298 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347311 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347328 */     // GIR_Coverage, 6459,
     /* 347328 */     GIR_EraseRootFromParent_Done,
     /* 347329 */   // Label 7088: @347329
     /* 347329 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(347471), // Rule ID 6462 //
     /* 347334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347363 */     // MIs[1] Rn
     /* 347363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347384 */     // MIs[2] Operand 1
     /* 347384 */     // No operand predicates
     /* 347384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347386 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 347386 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 347389 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347393 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347398 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 347401 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 347405 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347408 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 347425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 347436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347470 */     // GIR_Coverage, 6462,
     /* 347470 */     GIR_EraseRootFromParent_Done,
     /* 347471 */   // Label 7089: @347471
     /* 347471 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(347659), // Rule ID 5693 //
     /* 347476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347506 */     // MIs[1] Operand 1
     /* 347506 */     // No operand predicates
     /* 347506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347508 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347508 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 347511 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347515 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 347522 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 347525 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347529 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347534 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 347537 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 347541 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 347544 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347549 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347554 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347559 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 347562 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347566 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347573 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 347576 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347580 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347585 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 347588 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347592 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347595 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347600 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 347617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 347628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 347631 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 347634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347641 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347658 */     // GIR_Coverage, 5693,
     /* 347658 */     GIR_EraseRootFromParent_Done,
     /* 347659 */   // Label 7090: @347659
     /* 347659 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(347794), // Rule ID 5704 //
     /* 347664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347694 */     // MIs[1] Operand 1
     /* 347694 */     // No operand predicates
     /* 347694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347696 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 347696 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 347699 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347703 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 347713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347722 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 347725 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347729 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 347732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347742 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 347754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 347765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 347769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347776 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347793 */     // GIR_Coverage, 5704,
     /* 347793 */     GIR_EraseRootFromParent_Done,
     /* 347794 */   // Label 7091: @347794
     /* 347794 */   GIM_Reject,
     /* 347795 */ // Label 7062: @347795
     /* 347795 */ GIM_Reject,
     /* 347796 */ // Label 6975: @347796
     /* 347796 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(350863),
     /* 347801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347814 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(347923), // Rule ID 4260 //
     /* 347819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347823 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347829 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347839 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347846 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 347863 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 347870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347890 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347922 */     // GIR_Coverage, 4260,
     /* 347922 */     GIR_EraseRootFromParent_Done,
     /* 347923 */   // Label 7093: @347923
     /* 347923 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(348032), // Rule ID 4261 //
     /* 347928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347932 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347938 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347948 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347955 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 347972 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 347979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347999 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348031 */     // GIR_Coverage, 4261,
     /* 348031 */     GIR_EraseRootFromParent_Done,
     /* 348032 */   // Label 7094: @348032
     /* 348032 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(348141), // Rule ID 4368 //
     /* 348037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348041 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348047 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348057 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348064 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 348081 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 348088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348108 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348140 */     // GIR_Coverage, 4368,
     /* 348140 */     GIR_EraseRootFromParent_Done,
     /* 348141 */   // Label 7095: @348141
     /* 348141 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(348250), // Rule ID 4369 //
     /* 348146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348150 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348156 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348166 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348173 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 348190 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 348197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348217 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348249 */     // GIR_Coverage, 4369,
     /* 348249 */     GIR_EraseRootFromParent_Done,
     /* 348250 */   // Label 7096: @348250
     /* 348250 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(348355), // Rule ID 4266 //
     /* 348255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348271 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348274 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348278 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 348295 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 348302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348322 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348354 */     // GIR_Coverage, 4266,
     /* 348354 */     GIR_EraseRootFromParent_Done,
     /* 348355 */   // Label 7097: @348355
     /* 348355 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(348460), // Rule ID 4268 //
     /* 348360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348376 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348383 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348393 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 348400 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 348407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348427 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348459 */     // GIR_Coverage, 4268,
     /* 348459 */     GIR_EraseRootFromParent_Done,
     /* 348460 */   // Label 7098: @348460
     /* 348460 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(348565), // Rule ID 4374 //
     /* 348465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348481 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348488 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 348505 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 348512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348532 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348564 */     // GIR_Coverage, 4374,
     /* 348564 */     GIR_EraseRootFromParent_Done,
     /* 348565 */   // Label 7099: @348565
     /* 348565 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(348670), // Rule ID 4376 //
     /* 348570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348586 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348593 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 348610 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 348617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348637 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348669 */     // GIR_Coverage, 4376,
     /* 348669 */     GIR_EraseRootFromParent_Done,
     /* 348670 */   // Label 7100: @348670
     /* 348670 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(348774), // Rule ID 4258 //
     /* 348675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348679 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348685 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348695 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348702 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 348719 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 348719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 348726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348741 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348773 */     // GIR_Coverage, 4258,
     /* 348773 */     GIR_EraseRootFromParent_Done,
     /* 348774 */   // Label 7101: @348774
     /* 348774 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(348878), // Rule ID 4259 //
     /* 348779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348783 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348789 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348799 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348806 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 348823 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 348823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 348830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348845 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348877 */     // GIR_Coverage, 4259,
     /* 348877 */     GIR_EraseRootFromParent_Done,
     /* 348878 */   // Label 7102: @348878
     /* 348878 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(348982), // Rule ID 4366 //
     /* 348883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348887 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348893 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348903 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348910 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 348927 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 348927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 348934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348949 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348981 */     // GIR_Coverage, 4366,
     /* 348981 */     GIR_EraseRootFromParent_Done,
     /* 348982 */   // Label 7103: @348982
     /* 348982 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(349086), // Rule ID 4367 //
     /* 348987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348991 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348997 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349007 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349014 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 349031 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 349031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 349038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349053 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349085 */     // GIR_Coverage, 4367,
     /* 349085 */     GIR_EraseRootFromParent_Done,
     /* 349086 */   // Label 7104: @349086
     /* 349086 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(349186), // Rule ID 4262 //
     /* 349091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349114 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 349131 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 349131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 349138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349153 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349185 */     // GIR_Coverage, 4262,
     /* 349185 */     GIR_EraseRootFromParent_Done,
     /* 349186 */   // Label 7105: @349186
     /* 349186 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(349286), // Rule ID 4264 //
     /* 349191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349207 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349214 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 349231 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 349231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 349238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349253 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349285 */     // GIR_Coverage, 4264,
     /* 349285 */     GIR_EraseRootFromParent_Done,
     /* 349286 */   // Label 7106: @349286
     /* 349286 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(349386), // Rule ID 4370 //
     /* 349291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349307 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349314 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 349331 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 349331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 349338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349353 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349385 */     // GIR_Coverage, 4370,
     /* 349385 */     GIR_EraseRootFromParent_Done,
     /* 349386 */   // Label 7107: @349386
     /* 349386 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(349486), // Rule ID 4372 //
     /* 349391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349407 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349414 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 349431 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 349431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 349438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349453 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349485 */     // GIR_Coverage, 4372,
     /* 349485 */     GIR_EraseRootFromParent_Done,
     /* 349486 */   // Label 7108: @349486
     /* 349486 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(349599), // Rule ID 5724 //
     /* 349491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 349515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 349524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349528 */     // MIs[3] Operand 1
     /* 349528 */     // No operand predicates
     /* 349528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349534 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 349534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 349537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 349541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349546 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 349550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 349553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 349580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349598 */     // GIR_Coverage, 5724,
     /* 349598 */     GIR_EraseRootFromParent_Done,
     /* 349599 */   // Label 7109: @349599
     /* 349599 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(349712), // Rule ID 5756 //
     /* 349604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 349628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 349637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349641 */     // MIs[3] Operand 1
     /* 349641 */     // No operand predicates
     /* 349641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349647 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 349647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 349650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 349654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 349663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 349666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 349693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349711 */     // GIR_Coverage, 5756,
     /* 349711 */     GIR_EraseRootFromParent_Done,
     /* 349712 */   // Label 7110: @349712
     /* 349712 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(349790), // Rule ID 1940 //
     /* 349717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 349740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349757 */     // MIs[2] Operand 1
     /* 349757 */     // No operand predicates
     /* 349757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 349761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349765 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349769 */     // MIs[3] Operand 1
     /* 349769 */     // No operand predicates
     /* 349769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349771 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 349771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 349774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 349778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 349781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 349785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 349788 */     GIR_RootConstrainSelectedInstOperands,
     /* 349789 */     // GIR_Coverage, 1940,
     /* 349789 */     GIR_EraseRootFromParent_Done,
     /* 349790 */   // Label 7111: @349790
     /* 349790 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(349879), // Rule ID 5721 //
     /* 349795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 349807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 349811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349823 */     // MIs[2] Operand 1
     /* 349823 */     // No operand predicates
     /* 349823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 349827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349831 */     // MIs[3] Operand 1
     /* 349831 */     // No operand predicates
     /* 349831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349833 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 349833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349845 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 349851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 349864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 349868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 349871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 349877 */     GIR_RootConstrainSelectedInstOperands,
     /* 349878 */     // GIR_Coverage, 5721,
     /* 349878 */     GIR_EraseRootFromParent_Done,
     /* 349879 */   // Label 7112: @349879
     /* 349879 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(349968), // Rule ID 5753 //
     /* 349884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 349896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 349900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349912 */     // MIs[2] Operand 1
     /* 349912 */     // No operand predicates
     /* 349912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 349916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349920 */     // MIs[3] Operand 1
     /* 349920 */     // No operand predicates
     /* 349920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349922 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 349922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349934 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 349940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 349953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 349957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 349960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 349966 */     GIR_RootConstrainSelectedInstOperands,
     /* 349967 */     // GIR_Coverage, 5753,
     /* 349967 */     GIR_EraseRootFromParent_Done,
     /* 349968 */   // Label 7113: @349968
     /* 349968 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(350035), // Rule ID 5723 //
     /* 349973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 349993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350006 */     // MIs[2] Operand 1
     /* 350006 */     // No operand predicates
     /* 350006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350014 */     // MIs[3] Operand 1
     /* 350014 */     // No operand predicates
     /* 350014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350016 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 350016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350033 */     GIR_RootConstrainSelectedInstOperands,
     /* 350034 */     // GIR_Coverage, 5723,
     /* 350034 */     GIR_EraseRootFromParent_Done,
     /* 350035 */   // Label 7114: @350035
     /* 350035 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(350133), // Rule ID 5725 //
     /* 350040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 350056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350073 */     // MIs[2] Operand 1
     /* 350073 */     // No operand predicates
     /* 350073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350081 */     // MIs[3] Operand 1
     /* 350081 */     // No operand predicates
     /* 350081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350083 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 350083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 350098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350102 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 350105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350131 */     GIR_RootConstrainSelectedInstOperands,
     /* 350132 */     // GIR_Coverage, 5725,
     /* 350132 */     GIR_EraseRootFromParent_Done,
     /* 350133 */   // Label 7115: @350133
     /* 350133 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(350200), // Rule ID 5755 //
     /* 350138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 350154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350171 */     // MIs[2] Operand 1
     /* 350171 */     // No operand predicates
     /* 350171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350179 */     // MIs[3] Operand 1
     /* 350179 */     // No operand predicates
     /* 350179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350181 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 350181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350186 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350198 */     GIR_RootConstrainSelectedInstOperands,
     /* 350199 */     // GIR_Coverage, 5755,
     /* 350199 */     GIR_EraseRootFromParent_Done,
     /* 350200 */   // Label 7116: @350200
     /* 350200 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(350298), // Rule ID 5757 //
     /* 350205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 350221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350238 */     // MIs[2] Operand 1
     /* 350238 */     // No operand predicates
     /* 350238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350246 */     // MIs[3] Operand 1
     /* 350246 */     // No operand predicates
     /* 350246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350248 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 350248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350260 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 350263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 350270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350296 */     GIR_RootConstrainSelectedInstOperands,
     /* 350297 */     // GIR_Coverage, 5757,
     /* 350297 */     GIR_EraseRootFromParent_Done,
     /* 350298 */   // Label 7117: @350298
     /* 350298 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(350364), // Rule ID 5679 //
     /* 350303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350321 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 350321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 350324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 350345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 350348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350363 */     // GIR_Coverage, 5679,
     /* 350363 */     GIR_EraseRootFromParent_Done,
     /* 350364 */   // Label 7118: @350364
     /* 350364 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(350430), // Rule ID 5687 //
     /* 350369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350387 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 350387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 350390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 350411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 350414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350429 */     // GIR_Coverage, 5687,
     /* 350429 */     GIR_EraseRootFromParent_Done,
     /* 350430 */   // Label 7119: @350430
     /* 350430 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(350483), // Rule ID 5696 //
     /* 350435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 350447 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 350451 */     // MIs[1] Operand 1
     /* 350451 */     // No operand predicates
     /* 350451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350463 */     // MIs[2] Operand 1
     /* 350463 */     // No operand predicates
     /* 350463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350465 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 350465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 350468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 350472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 350475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350481 */     GIR_RootConstrainSelectedInstOperands,
     /* 350482 */     // GIR_Coverage, 5696,
     /* 350482 */     GIR_EraseRootFromParent_Done,
     /* 350483 */   // Label 7120: @350483
     /* 350483 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(350552), // Rule ID 6441 //
     /* 350488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 350507 */     // MIs[1] Rn
     /* 350507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 350511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 350516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350524 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350528 */     // MIs[2] Operand 1
     /* 350528 */     // No operand predicates
     /* 350528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350530 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 350530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 350533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 350537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 350540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350550 */     GIR_RootConstrainSelectedInstOperands,
     /* 350551 */     // GIR_Coverage, 6441,
     /* 350551 */     GIR_EraseRootFromParent_Done,
     /* 350552 */   // Label 7121: @350552
     /* 350552 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(350621), // Rule ID 6442 //
     /* 350557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 350576 */     // MIs[1] Rn
     /* 350576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 350580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 350585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350593 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350597 */     // MIs[2] Operand 1
     /* 350597 */     // No operand predicates
     /* 350597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350599 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 350599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 350602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 350606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 350609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350619 */     GIR_RootConstrainSelectedInstOperands,
     /* 350620 */     // GIR_Coverage, 6442,
     /* 350620 */     GIR_EraseRootFromParent_Done,
     /* 350621 */   // Label 7122: @350621
     /* 350621 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(350722), // Rule ID 5768 //
     /* 350626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 350634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 350638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350651 */     // MIs[2] Operand 1
     /* 350651 */     // No operand predicates
     /* 350651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350653 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 350653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 350656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350679 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 350686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 350689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350709 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 350714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350720 */     GIR_RootConstrainSelectedInstOperands,
     /* 350721 */     // GIR_Coverage, 5768,
     /* 350721 */     GIR_EraseRootFromParent_Done,
     /* 350722 */   // Label 7123: @350722
     /* 350722 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(350766), // Rule ID 1936 //
     /* 350727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 350730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 350742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350750 */     // MIs[1] Operand 1
     /* 350750 */     // No operand predicates
     /* 350750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350752 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 350752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 350755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 350759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 350762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 350764 */     GIR_RootConstrainSelectedInstOperands,
     /* 350765 */     // GIR_Coverage, 1936,
     /* 350765 */     GIR_EraseRootFromParent_Done,
     /* 350766 */   // Label 7124: @350766
     /* 350766 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(350862), // Rule ID 5701 //
     /* 350771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 350783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 350791 */     // MIs[1] Operand 1
     /* 350791 */     // No operand predicates
     /* 350791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350793 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 350793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 350796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 350810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 350826 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 350829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 350847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 350851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 350854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350860 */     GIR_RootConstrainSelectedInstOperands,
     /* 350861 */     // GIR_Coverage, 5701,
     /* 350861 */     GIR_EraseRootFromParent_Done,
     /* 350862 */   // Label 7125: @350862
     /* 350862 */   GIM_Reject,
     /* 350863 */ // Label 7092: @350863
     /* 350863 */ GIM_Reject,
     /* 350864 */ // Label 6976: @350864
     /* 350864 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(352707),
     /* 350869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 350872 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(350998), // Rule ID 4200 //
     /* 350877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350891 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350897 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350907 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350910 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350914 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 350921 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 350938 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 350938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 350941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 350945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350965 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 350987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 350997 */     // GIR_Coverage, 4200,
     /* 350997 */     GIR_EraseRootFromParent_Done,
     /* 350998 */   // Label 7127: @350998
     /* 350998 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(351124), // Rule ID 4201 //
     /* 351003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351017 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351023 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351033 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351036 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351040 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351047 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 351064 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 351071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351091 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351123 */     // GIR_Coverage, 4201,
     /* 351123 */     GIR_EraseRootFromParent_Done,
     /* 351124 */   // Label 7128: @351124
     /* 351124 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(351246), // Rule ID 4206 //
     /* 351129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351155 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351158 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351162 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351169 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 351186 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 351193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351213 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351245 */     // GIR_Coverage, 4206,
     /* 351245 */     GIR_EraseRootFromParent_Done,
     /* 351246 */   // Label 7129: @351246
     /* 351246 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(351368), // Rule ID 4208 //
     /* 351251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351277 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351280 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351284 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351291 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 351308 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 351315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351335 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351367 */     // GIR_Coverage, 4208,
     /* 351367 */     GIR_EraseRootFromParent_Done,
     /* 351368 */   // Label 7130: @351368
     /* 351368 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(351489), // Rule ID 4198 //
     /* 351373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351387 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351393 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351406 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351410 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351417 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 351434 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 351434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 351441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351456 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351488 */     // GIR_Coverage, 4198,
     /* 351488 */     GIR_EraseRootFromParent_Done,
     /* 351489 */   // Label 7131: @351489
     /* 351489 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(351610), // Rule ID 4199 //
     /* 351494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351508 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351514 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351524 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351527 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351531 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351538 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 351555 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 351555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 351562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351577 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351609 */     // GIR_Coverage, 4199,
     /* 351609 */     GIR_EraseRootFromParent_Done,
     /* 351610 */   // Label 7132: @351610
     /* 351610 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(351727), // Rule ID 4202 //
     /* 351615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351641 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351644 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351648 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351655 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 351672 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 351672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 351679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351694 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351726 */     // GIR_Coverage, 4202,
     /* 351726 */     GIR_EraseRootFromParent_Done,
     /* 351727 */   // Label 7133: @351727
     /* 351727 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(351844), // Rule ID 4204 //
     /* 351732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351758 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351761 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351765 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351772 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 351789 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 351789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 351796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351811 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351843 */     // GIR_Coverage, 4204,
     /* 351843 */     GIR_EraseRootFromParent_Done,
     /* 351844 */   // Label 7134: @351844
     /* 351844 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(351984), // Rule ID 5742 //
     /* 351849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351892 */     // MIs[2] Operand 1
     /* 351892 */     // No operand predicates
     /* 351892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351900 */     // MIs[3] Operand 1
     /* 351900 */     // No operand predicates
     /* 351900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351902 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 351902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 351905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351914 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 351917 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 351921 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 351924 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 351941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351946 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 351952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 351959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351966 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 351973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351983 */     // GIR_Coverage, 5742,
     /* 351983 */     GIR_EraseRootFromParent_Done,
     /* 351984 */   // Label 7135: @351984
     /* 351984 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(352155), // Rule ID 5743 //
     /* 351989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 352015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352032 */     // MIs[2] Operand 1
     /* 352032 */     // No operand predicates
     /* 352032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352040 */     // MIs[3] Operand 1
     /* 352040 */     // No operand predicates
     /* 352040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352042 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352042 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 352045 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352049 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352054 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 352057 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352061 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 352064 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352069 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 352077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352086 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352093 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352101 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352124 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 352127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352137 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352154 */     // GIR_Coverage, 5743,
     /* 352154 */     GIR_EraseRootFromParent_Done,
     /* 352155 */   // Label 7136: @352155
     /* 352155 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(352234), // Rule ID 5666 //
     /* 352160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352188 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 352188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 352204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352233 */     // GIR_Coverage, 5666,
     /* 352233 */     GIR_EraseRootFromParent_Done,
     /* 352234 */   // Label 7137: @352234
     /* 352234 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(352383), // Rule ID 6458 //
     /* 352239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352264 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 352268 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352275 */     // MIs[1] Rn
     /* 352275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 352279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 352284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 352288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352292 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352296 */     // MIs[2] Operand 1
     /* 352296 */     // No operand predicates
     /* 352296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352298 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 352298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 352301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352310 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352313 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 352317 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 352337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 352348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352352 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352365 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352382 */     // GIR_Coverage, 6458,
     /* 352382 */     GIR_EraseRootFromParent_Done,
     /* 352383 */   // Label 7138: @352383
     /* 352383 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(352518), // Rule ID 5705 //
     /* 352388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352418 */     // MIs[1] Operand 1
     /* 352418 */     // No operand predicates
     /* 352418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352420 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 352420 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 352423 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352427 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352434 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 352437 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 352441 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352446 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352449 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 352453 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352456 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352461 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352466 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 352478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352483 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 352489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 352493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352500 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352517 */     // GIR_Coverage, 5705,
     /* 352517 */     GIR_EraseRootFromParent_Done,
     /* 352518 */   // Label 7139: @352518
     /* 352518 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(352706), // Rule ID 5706 //
     /* 352523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 352526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352553 */     // MIs[1] Operand 1
     /* 352553 */     // No operand predicates
     /* 352553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352555 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 352555 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 352558 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352562 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 352569 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 352572 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 352576 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352581 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 352584 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 352588 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 352591 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352596 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352601 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352606 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 352609 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352613 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 352623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 352627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352632 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 352639 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 352675 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 352678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 352681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352688 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352705 */     // GIR_Coverage, 5706,
     /* 352705 */     GIR_EraseRootFromParent_Done,
     /* 352706 */   // Label 7140: @352706
     /* 352706 */   GIM_Reject,
     /* 352707 */ // Label 7126: @352707
     /* 352707 */ GIM_Reject,
     /* 352708 */ // Label 6977: @352708
     /* 352708 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(356126),
     /* 352713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 352716 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(352842), // Rule ID 4224 //
     /* 352721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352735 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352741 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352751 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352754 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352758 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352765 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 352782 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 352782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 352789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352809 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352841 */     // GIR_Coverage, 4224,
     /* 352841 */     GIR_EraseRootFromParent_Done,
     /* 352842 */   // Label 7142: @352842
     /* 352842 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(352968), // Rule ID 4225 //
     /* 352847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352861 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352867 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352877 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352880 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352884 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352891 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 352908 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 352908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 352915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352935 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352967 */     // GIR_Coverage, 4225,
     /* 352967 */     GIR_EraseRootFromParent_Done,
     /* 352968 */   // Label 7143: @352968
     /* 352968 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(353087), // Rule ID 4332 //
     /* 352973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352987 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352993 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353003 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353010 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 353027 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 353034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353054 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353086 */     // GIR_Coverage, 4332,
     /* 353086 */     GIR_EraseRootFromParent_Done,
     /* 353087 */   // Label 7144: @353087
     /* 353087 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(353206), // Rule ID 4333 //
     /* 353092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353106 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353112 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353122 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353129 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 353146 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 353153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353173 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353205 */     // GIR_Coverage, 4333,
     /* 353205 */     GIR_EraseRootFromParent_Done,
     /* 353206 */   // Label 7145: @353206
     /* 353206 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(353328), // Rule ID 4230 //
     /* 353211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353237 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353240 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353244 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353251 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 353268 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 353275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353295 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353327 */     // GIR_Coverage, 4230,
     /* 353327 */     GIR_EraseRootFromParent_Done,
     /* 353328 */   // Label 7146: @353328
     /* 353328 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(353450), // Rule ID 4232 //
     /* 353333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353359 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353362 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353366 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353373 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 353390 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 353397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353417 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353449 */     // GIR_Coverage, 4232,
     /* 353449 */     GIR_EraseRootFromParent_Done,
     /* 353450 */   // Label 7147: @353450
     /* 353450 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(353565), // Rule ID 4338 //
     /* 353455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353481 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353488 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 353505 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 353512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353532 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353564 */     // GIR_Coverage, 4338,
     /* 353564 */     GIR_EraseRootFromParent_Done,
     /* 353565 */   // Label 7148: @353565
     /* 353565 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(353680), // Rule ID 4340 //
     /* 353570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353596 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353599 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353603 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 353620 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 353627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353647 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353679 */     // GIR_Coverage, 4340,
     /* 353679 */     GIR_EraseRootFromParent_Done,
     /* 353680 */   // Label 7149: @353680
     /* 353680 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(353801), // Rule ID 4222 //
     /* 353685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353699 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353705 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353715 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353718 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353722 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353729 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 353746 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 353746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 353753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353768 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353800 */     // GIR_Coverage, 4222,
     /* 353800 */     GIR_EraseRootFromParent_Done,
     /* 353801 */   // Label 7150: @353801
     /* 353801 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(353922), // Rule ID 4223 //
     /* 353806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353820 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353826 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353836 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353839 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353843 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353850 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 353867 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 353867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 353874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353889 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353921 */     // GIR_Coverage, 4223,
     /* 353921 */     GIR_EraseRootFromParent_Done,
     /* 353922 */   // Label 7151: @353922
     /* 353922 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(354036), // Rule ID 4330 //
     /* 353927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353941 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353947 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353957 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353964 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 353981 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 353981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 353988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354003 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354035 */     // GIR_Coverage, 4330,
     /* 354035 */     GIR_EraseRootFromParent_Done,
     /* 354036 */   // Label 7152: @354036
     /* 354036 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(354150), // Rule ID 4331 //
     /* 354041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354055 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354061 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354071 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354078 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 354095 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 354095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 354102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354117 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354149 */     // GIR_Coverage, 4331,
     /* 354149 */     GIR_EraseRootFromParent_Done,
     /* 354150 */   // Label 7153: @354150
     /* 354150 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(354267), // Rule ID 4226 //
     /* 354155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354181 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354184 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354188 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354195 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 354212 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 354212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 354219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354234 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354266 */     // GIR_Coverage, 4226,
     /* 354266 */     GIR_EraseRootFromParent_Done,
     /* 354267 */   // Label 7154: @354267
     /* 354267 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(354384), // Rule ID 4228 //
     /* 354272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354301 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354305 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354312 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 354329 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 354329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 354336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354351 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354383 */     // GIR_Coverage, 4228,
     /* 354383 */     GIR_EraseRootFromParent_Done,
     /* 354384 */   // Label 7155: @354384
     /* 354384 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(354494), // Rule ID 4334 //
     /* 354389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354415 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354422 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 354439 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 354439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 354446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354461 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354493 */     // GIR_Coverage, 4334,
     /* 354493 */     GIR_EraseRootFromParent_Done,
     /* 354494 */   // Label 7156: @354494
     /* 354494 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(354604), // Rule ID 4336 //
     /* 354499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354525 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354528 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354532 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 354549 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 354549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 354556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354571 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354603 */     // GIR_Coverage, 4336,
     /* 354603 */     GIR_EraseRootFromParent_Done,
     /* 354604 */   // Label 7157: @354604
     /* 354604 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(354727), // Rule ID 5716 //
     /* 354609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 354639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 354652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354656 */     // MIs[3] Operand 1
     /* 354656 */     // No operand predicates
     /* 354656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354662 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 354662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 354665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 354669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 354678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 354681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 354686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 354708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354726 */     // GIR_Coverage, 5716,
     /* 354726 */     GIR_EraseRootFromParent_Done,
     /* 354727 */   // Label 7158: @354727
     /* 354727 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(354850), // Rule ID 5748 //
     /* 354732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 354762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 354775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354779 */     // MIs[3] Operand 1
     /* 354779 */     // No operand predicates
     /* 354779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354785 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 354785 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 354788 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 354792 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354797 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 354801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 354804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 354809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 354831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354849 */     // GIR_Coverage, 5748,
     /* 354849 */     GIR_EraseRootFromParent_Done,
     /* 354850 */   // Label 7159: @354850
     /* 354850 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(354938), // Rule ID 1939 //
     /* 354855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 354884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354901 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354905 */     // MIs[2] Operand 1
     /* 354905 */     // No operand predicates
     /* 354905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354913 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354917 */     // MIs[3] Operand 1
     /* 354917 */     // No operand predicates
     /* 354917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354919 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 354919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 354922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 354926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 354929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 354936 */     GIR_RootConstrainSelectedInstOperands,
     /* 354937 */     // GIR_Coverage, 1939,
     /* 354937 */     GIR_EraseRootFromParent_Done,
     /* 354938 */   // Label 7160: @354938
     /* 354938 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(355037), // Rule ID 5713 //
     /* 354943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354981 */     // MIs[2] Operand 1
     /* 354981 */     // No operand predicates
     /* 354981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354989 */     // MIs[3] Operand 1
     /* 354989 */     // No operand predicates
     /* 354989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354991 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 354991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 354994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355003 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 355009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355035 */     GIR_RootConstrainSelectedInstOperands,
     /* 355036 */     // GIR_Coverage, 5713,
     /* 355036 */     GIR_EraseRootFromParent_Done,
     /* 355037 */   // Label 7161: @355037
     /* 355037 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(355136), // Rule ID 5745 //
     /* 355042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 355064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355076 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 355080 */     // MIs[2] Operand 1
     /* 355080 */     // No operand predicates
     /* 355080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355088 */     // MIs[3] Operand 1
     /* 355088 */     // No operand predicates
     /* 355088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355090 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 355090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 355093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355102 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 355108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355134 */     GIR_RootConstrainSelectedInstOperands,
     /* 355135 */     // GIR_Coverage, 5745,
     /* 355135 */     GIR_EraseRootFromParent_Done,
     /* 355136 */   // Label 7162: @355136
     /* 355136 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(355213), // Rule ID 5715 //
     /* 355141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355184 */     // MIs[2] Operand 1
     /* 355184 */     // No operand predicates
     /* 355184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355192 */     // MIs[3] Operand 1
     /* 355192 */     // No operand predicates
     /* 355192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355194 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 355194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355211 */     GIR_RootConstrainSelectedInstOperands,
     /* 355212 */     // GIR_Coverage, 5715,
     /* 355212 */     GIR_EraseRootFromParent_Done,
     /* 355213 */   // Label 7163: @355213
     /* 355213 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(355321), // Rule ID 5717 //
     /* 355218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355261 */     // MIs[2] Operand 1
     /* 355261 */     // No operand predicates
     /* 355261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355269 */     // MIs[3] Operand 1
     /* 355269 */     // No operand predicates
     /* 355269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355271 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 355271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 355286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 355293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355308 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355319 */     GIR_RootConstrainSelectedInstOperands,
     /* 355320 */     // GIR_Coverage, 5717,
     /* 355320 */     GIR_EraseRootFromParent_Done,
     /* 355321 */   // Label 7164: @355321
     /* 355321 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(355398), // Rule ID 5747 //
     /* 355326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355369 */     // MIs[2] Operand 1
     /* 355369 */     // No operand predicates
     /* 355369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355377 */     // MIs[3] Operand 1
     /* 355377 */     // No operand predicates
     /* 355377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355379 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 355379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355396 */     GIR_RootConstrainSelectedInstOperands,
     /* 355397 */     // GIR_Coverage, 5747,
     /* 355397 */     GIR_EraseRootFromParent_Done,
     /* 355398 */   // Label 7165: @355398
     /* 355398 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(355506), // Rule ID 5749 //
     /* 355403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355446 */     // MIs[2] Operand 1
     /* 355446 */     // No operand predicates
     /* 355446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355454 */     // MIs[3] Operand 1
     /* 355454 */     // No operand predicates
     /* 355454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355456 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 355456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355468 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 355471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355475 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 355478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 355491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355504 */     GIR_RootConstrainSelectedInstOperands,
     /* 355505 */     // GIR_Coverage, 5749,
     /* 355505 */     GIR_EraseRootFromParent_Done,
     /* 355506 */   // Label 7166: @355506
     /* 355506 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(355585), // Rule ID 5669 //
     /* 355511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355539 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 355539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 355555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355584 */     // GIR_Coverage, 5669,
     /* 355584 */     GIR_EraseRootFromParent_Done,
     /* 355585 */   // Label 7167: @355585
     /* 355585 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(355661), // Rule ID 5675 //
     /* 355590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355618 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 355618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 355621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 355642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355660 */     // GIR_Coverage, 5675,
     /* 355660 */     GIR_EraseRootFromParent_Done,
     /* 355661 */   // Label 7168: @355661
     /* 355661 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(355737), // Rule ID 5685 //
     /* 355666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355694 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 355694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 355697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 355718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355736 */     // GIR_Coverage, 5685,
     /* 355736 */     GIR_EraseRootFromParent_Done,
     /* 355737 */   // Label 7169: @355737
     /* 355737 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(355800), // Rule ID 5694 //
     /* 355742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 355764 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 355768 */     // MIs[1] Operand 1
     /* 355768 */     // No operand predicates
     /* 355768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355776 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 355780 */     // MIs[2] Operand 1
     /* 355780 */     // No operand predicates
     /* 355780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355782 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 355782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 355785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 355792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 355798 */     GIR_RootConstrainSelectedInstOperands,
     /* 355799 */     // GIR_Coverage, 5694,
     /* 355799 */     GIR_EraseRootFromParent_Done,
     /* 355800 */   // Label 7170: @355800
     /* 355800 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(355886), // Rule ID 6440 //
     /* 355805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355830 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 355834 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 355841 */     // MIs[1] Rn
     /* 355841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 355845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355858 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 355862 */     // MIs[2] Operand 1
     /* 355862 */     // No operand predicates
     /* 355862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355864 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 355864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 355867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 355871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 355874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355884 */     GIR_RootConstrainSelectedInstOperands,
     /* 355885 */     // GIR_Coverage, 6440,
     /* 355885 */     GIR_EraseRootFromParent_Done,
     /* 355886 */   // Label 7171: @355886
     /* 355886 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(355965), // Rule ID 6445 //
     /* 355891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 355920 */     // MIs[1] Rn
     /* 355920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 355924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 355941 */     // MIs[2] Operand 1
     /* 355941 */     // No operand predicates
     /* 355941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355943 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 355943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 355946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 355950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 355953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355963 */     GIR_RootConstrainSelectedInstOperands,
     /* 355964 */     // GIR_Coverage, 6445,
     /* 355964 */     GIR_EraseRootFromParent_Done,
     /* 355965 */   // Label 7172: @355965
     /* 355965 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(356019), // Rule ID 1935 //
     /* 355970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 355995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 356003 */     // MIs[1] Operand 1
     /* 356003 */     // No operand predicates
     /* 356003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356005 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 356005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 356008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 356012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 356015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 356017 */     GIR_RootConstrainSelectedInstOperands,
     /* 356018 */     // GIR_Coverage, 1935,
     /* 356018 */     GIR_EraseRootFromParent_Done,
     /* 356019 */   // Label 7173: @356019
     /* 356019 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(356125), // Rule ID 5699 //
     /* 356024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 356027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 356054 */     // MIs[1] Operand 1
     /* 356054 */     // No operand predicates
     /* 356054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356056 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 356056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 356059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 356073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 356089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 356092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 356110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 356114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 356117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356123 */     GIR_RootConstrainSelectedInstOperands,
     /* 356124 */     // GIR_Coverage, 5699,
     /* 356124 */     GIR_EraseRootFromParent_Done,
     /* 356125 */   // Label 7174: @356125
     /* 356125 */   GIM_Reject,
     /* 356126 */ // Label 7141: @356126
     /* 356126 */ GIM_Reject,
     /* 356127 */ // Label 6978: @356127
     /* 356127 */ GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(357928),
     /* 356132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 356135 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(356261), // Rule ID 4188 //
     /* 356140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356154 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356160 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356170 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356173 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356177 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356184 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 356201 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 356208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356228 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356260 */     // GIR_Coverage, 4188,
     /* 356260 */     GIR_EraseRootFromParent_Done,
     /* 356261 */   // Label 7176: @356261
     /* 356261 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(356387), // Rule ID 4189 //
     /* 356266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356280 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356286 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356296 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356299 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356303 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356310 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 356327 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 356334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356354 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356386 */     // GIR_Coverage, 4189,
     /* 356386 */     GIR_EraseRootFromParent_Done,
     /* 356387 */   // Label 7177: @356387
     /* 356387 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(356509), // Rule ID 4194 //
     /* 356392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356418 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356421 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356425 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356432 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 356449 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 356456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356476 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356508 */     // GIR_Coverage, 4194,
     /* 356508 */     GIR_EraseRootFromParent_Done,
     /* 356509 */   // Label 7178: @356509
     /* 356509 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(356631), // Rule ID 4196 //
     /* 356514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356540 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356543 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356547 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356554 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 356571 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 356578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356598 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356630 */     // GIR_Coverage, 4196,
     /* 356630 */     GIR_EraseRootFromParent_Done,
     /* 356631 */   // Label 7179: @356631
     /* 356631 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(356752), // Rule ID 4186 //
     /* 356636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356650 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356656 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356666 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356669 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356673 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356680 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 356697 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 356697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 356704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356719 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356751 */     // GIR_Coverage, 4186,
     /* 356751 */     GIR_EraseRootFromParent_Done,
     /* 356752 */   // Label 7180: @356752
     /* 356752 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(356873), // Rule ID 4187 //
     /* 356757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356771 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356777 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356787 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356790 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356794 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356801 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 356818 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 356818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 356825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356840 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356872 */     // GIR_Coverage, 4187,
     /* 356872 */     GIR_EraseRootFromParent_Done,
     /* 356873 */   // Label 7181: @356873
     /* 356873 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(356990), // Rule ID 4190 //
     /* 356878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356904 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356907 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356911 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356918 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 356935 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 356935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 356942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356957 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356989 */     // GIR_Coverage, 4190,
     /* 356989 */     GIR_EraseRootFromParent_Done,
     /* 356990 */   // Label 7182: @356990
     /* 356990 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(357107), // Rule ID 4192 //
     /* 356995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357021 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357024 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357028 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 357035 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 357052 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 357052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 357055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 357059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357074 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 357096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 357106 */     // GIR_Coverage, 4192,
     /* 357106 */     GIR_EraseRootFromParent_Done,
     /* 357107 */   // Label 7183: @357107
     /* 357107 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(357230), // Rule ID 5740 //
     /* 357112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 357142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 357146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 357155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357159 */     // MIs[3] Operand 1
     /* 357159 */     // No operand predicates
     /* 357159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357165 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 357165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 357168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 357172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357177 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 357181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 357184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 357189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 357211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 357214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 357229 */     // GIR_Coverage, 5740,
     /* 357229 */     GIR_EraseRootFromParent_Done,
     /* 357230 */   // Label 7184: @357230
     /* 357230 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(357318), // Rule ID 1938 //
     /* 357235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 357264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357281 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357285 */     // MIs[2] Operand 1
     /* 357285 */     // No operand predicates
     /* 357285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357297 */     // MIs[3] Operand 1
     /* 357297 */     // No operand predicates
     /* 357297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357299 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 357299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 357306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 357309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 357316 */     GIR_RootConstrainSelectedInstOperands,
     /* 357317 */     // GIR_Coverage, 1938,
     /* 357317 */     GIR_EraseRootFromParent_Done,
     /* 357318 */   // Label 7185: @357318
     /* 357318 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(357417), // Rule ID 5737 //
     /* 357323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 357345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357361 */     // MIs[2] Operand 1
     /* 357361 */     // No operand predicates
     /* 357361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357369 */     // MIs[3] Operand 1
     /* 357369 */     // No operand predicates
     /* 357369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357371 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 357371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 357374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357383 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 357389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 357406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 357409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 357415 */     GIR_RootConstrainSelectedInstOperands,
     /* 357416 */     // GIR_Coverage, 5737,
     /* 357416 */     GIR_EraseRootFromParent_Done,
     /* 357417 */   // Label 7186: @357417
     /* 357417 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(357494), // Rule ID 5739 //
     /* 357422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 357448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357465 */     // MIs[2] Operand 1
     /* 357465 */     // No operand predicates
     /* 357465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357473 */     // MIs[3] Operand 1
     /* 357473 */     // No operand predicates
     /* 357473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357475 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 357475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 357482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 357485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 357492 */     GIR_RootConstrainSelectedInstOperands,
     /* 357493 */     // GIR_Coverage, 5739,
     /* 357493 */     GIR_EraseRootFromParent_Done,
     /* 357494 */   // Label 7187: @357494
     /* 357494 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(357602), // Rule ID 5741 //
     /* 357499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 357525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357542 */     // MIs[2] Operand 1
     /* 357542 */     // No operand predicates
     /* 357542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357550 */     // MIs[3] Operand 1
     /* 357550 */     // No operand predicates
     /* 357550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357552 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 357552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357564 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 357574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 357591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 357594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 357600 */     GIR_RootConstrainSelectedInstOperands,
     /* 357601 */     // GIR_Coverage, 5741,
     /* 357601 */     GIR_EraseRootFromParent_Done,
     /* 357602 */   // Label 7188: @357602
     /* 357602 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(357681), // Rule ID 5664 //
     /* 357607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357635 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 357635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357647 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 357651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357680 */     // GIR_Coverage, 5664,
     /* 357680 */     GIR_EraseRootFromParent_Done,
     /* 357681 */   // Label 7189: @357681
     /* 357681 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(357767), // Rule ID 6439 //
     /* 357686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357711 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 357715 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 357722 */     // MIs[1] Rn
     /* 357722 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 357726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357743 */     // MIs[2] Operand 1
     /* 357743 */     // No operand predicates
     /* 357743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357745 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 357745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 357748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 357752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 357755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357765 */     GIR_RootConstrainSelectedInstOperands,
     /* 357766 */     // GIR_Coverage, 6439,
     /* 357766 */     GIR_EraseRootFromParent_Done,
     /* 357767 */   // Label 7190: @357767
     /* 357767 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(357821), // Rule ID 1934 //
     /* 357772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357805 */     // MIs[1] Operand 1
     /* 357805 */     // No operand predicates
     /* 357805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357807 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 357807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 357810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 357814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 357817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 357819 */     GIR_RootConstrainSelectedInstOperands,
     /* 357820 */     // GIR_Coverage, 1934,
     /* 357820 */     GIR_EraseRootFromParent_Done,
     /* 357821 */   // Label 7191: @357821
     /* 357821 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(357927), // Rule ID 5707 //
     /* 357826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 357829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 357844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 357856 */     // MIs[1] Operand 1
     /* 357856 */     // No operand predicates
     /* 357856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357858 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 357858 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 357861 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357865 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 357875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 357891 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 357894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 357909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 357912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 357916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 357919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357925 */     GIR_RootConstrainSelectedInstOperands,
     /* 357926 */     // GIR_Coverage, 5707,
     /* 357926 */     GIR_EraseRootFromParent_Done,
     /* 357927 */   // Label 7192: @357927
     /* 357927 */   GIM_Reject,
     /* 357928 */ // Label 7175: @357928
     /* 357928 */ GIM_Reject,
     /* 357929 */ // Label 6979: @357929
     /* 357929 */ GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(358053), // Rule ID 11212 //
     /* 357934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 357940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 357943 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357954 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357958 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 357958 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 357961 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 357965 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357970 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 357974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357976 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 357979 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 357983 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357988 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357991 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 357994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357996 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 357999 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 358003 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358008 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358016 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 358020 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358025 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358034 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 358042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358044 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358049 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358051 */   GIR_RootConstrainSelectedInstOperands,
     /* 358052 */   // GIR_Coverage, 11212,
     /* 358052 */   GIR_EraseRootFromParent_Done,
     /* 358053 */ // Label 7193: @358053
     /* 358053 */ GIM_Reject,
     /* 358054 */ // Label 6980: @358054
     /* 358054 */ GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(358178), // Rule ID 11215 //
     /* 358059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 358065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358083 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 358083 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 358086 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 358090 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358095 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 358099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358101 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 358104 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 358108 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358113 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358116 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358121 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358124 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 358128 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358133 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 358145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358150 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358153 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358156 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358159 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 358167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358169 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358174 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358176 */   GIR_RootConstrainSelectedInstOperands,
     /* 358177 */   // GIR_Coverage, 11215,
     /* 358177 */   GIR_EraseRootFromParent_Done,
     /* 358178 */ // Label 7194: @358178
     /* 358178 */ GIM_Reject,
     /* 358179 */ // Label 6981: @358179
     /* 358179 */ GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(360156),
     /* 358184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 358187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358190 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358197 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(358306), // Rule ID 4320 //
     /* 358202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358206 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358212 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358222 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358229 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358246 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358273 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358305 */     // GIR_Coverage, 4320,
     /* 358305 */     GIR_EraseRootFromParent_Done,
     /* 358306 */   // Label 7196: @358306
     /* 358306 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(358415), // Rule ID 4321 //
     /* 358311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358331 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358338 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358355 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358382 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358414 */     // GIR_Coverage, 4321,
     /* 358414 */     GIR_EraseRootFromParent_Done,
     /* 358415 */   // Label 7197: @358415
     /* 358415 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(358524), // Rule ID 4428 //
     /* 358420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358430 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358440 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358447 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358464 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358491 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358523 */     // GIR_Coverage, 4428,
     /* 358523 */     GIR_EraseRootFromParent_Done,
     /* 358524 */   // Label 7198: @358524
     /* 358524 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(358633), // Rule ID 4429 //
     /* 358529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358533 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358539 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358549 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358556 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358573 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358632 */     // GIR_Coverage, 4429,
     /* 358632 */     GIR_EraseRootFromParent_Done,
     /* 358633 */   // Label 7199: @358633
     /* 358633 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(358738), // Rule ID 4326 //
     /* 358638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358654 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358661 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358678 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358705 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358737 */     // GIR_Coverage, 4326,
     /* 358737 */     GIR_EraseRootFromParent_Done,
     /* 358738 */   // Label 7200: @358738
     /* 358738 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(358843), // Rule ID 4328 //
     /* 358743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358759 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358766 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358783 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358842 */     // GIR_Coverage, 4328,
     /* 358842 */     GIR_EraseRootFromParent_Done,
     /* 358843 */   // Label 7201: @358843
     /* 358843 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(358948), // Rule ID 4434 //
     /* 358848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358864 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358871 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358888 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358947 */     // GIR_Coverage, 4434,
     /* 358947 */     GIR_EraseRootFromParent_Done,
     /* 358948 */   // Label 7202: @358948
     /* 358948 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(359053), // Rule ID 4436 //
     /* 358953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358969 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358972 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358976 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358993 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 359000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359020 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359052 */     // GIR_Coverage, 4436,
     /* 359052 */     GIR_EraseRootFromParent_Done,
     /* 359053 */   // Label 7203: @359053
     /* 359053 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(359157), // Rule ID 4318 //
     /* 359058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359062 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359068 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359078 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359085 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359102 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359124 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359156 */     // GIR_Coverage, 4318,
     /* 359156 */     GIR_EraseRootFromParent_Done,
     /* 359157 */   // Label 7204: @359157
     /* 359157 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(359261), // Rule ID 4319 //
     /* 359162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359166 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359172 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359182 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359189 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359206 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359228 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359260 */     // GIR_Coverage, 4319,
     /* 359260 */     GIR_EraseRootFromParent_Done,
     /* 359261 */   // Label 7205: @359261
     /* 359261 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(359365), // Rule ID 4426 //
     /* 359266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359270 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359276 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359286 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359293 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359310 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359332 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359364 */     // GIR_Coverage, 4426,
     /* 359364 */     GIR_EraseRootFromParent_Done,
     /* 359365 */   // Label 7206: @359365
     /* 359365 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(359469), // Rule ID 4427 //
     /* 359370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359374 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359380 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359390 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359397 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359414 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359436 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359468 */     // GIR_Coverage, 4427,
     /* 359468 */     GIR_EraseRootFromParent_Done,
     /* 359469 */   // Label 7207: @359469
     /* 359469 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(359569), // Rule ID 4322 //
     /* 359474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359490 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359497 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359514 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359536 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359568 */     // GIR_Coverage, 4322,
     /* 359568 */     GIR_EraseRootFromParent_Done,
     /* 359569 */   // Label 7208: @359569
     /* 359569 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(359669), // Rule ID 4324 //
     /* 359574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359590 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359597 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359614 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359636 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359668 */     // GIR_Coverage, 4324,
     /* 359668 */     GIR_EraseRootFromParent_Done,
     /* 359669 */   // Label 7209: @359669
     /* 359669 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(359769), // Rule ID 4430 //
     /* 359674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359690 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359693 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359697 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359714 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359736 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359768 */     // GIR_Coverage, 4430,
     /* 359768 */     GIR_EraseRootFromParent_Done,
     /* 359769 */   // Label 7210: @359769
     /* 359769 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(359869), // Rule ID 4432 //
     /* 359774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359790 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359797 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359814 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359836 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359868 */     // GIR_Coverage, 4432,
     /* 359868 */     GIR_EraseRootFromParent_Done,
     /* 359869 */   // Label 7211: @359869
     /* 359869 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(359933), // Rule ID 11270 //
     /* 359874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 359905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359909 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 359913 */     // MIs[3] Operand 1
     /* 359913 */     // No operand predicates
     /* 359913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359919 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 359919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 359922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 359924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 359928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 359931 */     GIR_RootConstrainSelectedInstOperands,
     /* 359932 */     // GIR_Coverage, 11270,
     /* 359932 */     GIR_EraseRootFromParent_Done,
     /* 359933 */   // Label 7212: @359933
     /* 359933 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(360044), // Rule ID 11211 //
     /* 359938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359949 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 359949 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 359952 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 359956 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359961 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 359965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359967 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 359970 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 359974 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359979 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 359982 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 359985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 359990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 359994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359999 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 360011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360019 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360025 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 360033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360035 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360042 */     GIR_RootConstrainSelectedInstOperands,
     /* 360043 */     // GIR_Coverage, 11211,
     /* 360043 */     GIR_EraseRootFromParent_Done,
     /* 360044 */   // Label 7213: @360044
     /* 360044 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(360155), // Rule ID 11217 //
     /* 360049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360060 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 360060 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360063 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 360067 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360072 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 360076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 360085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360090 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360093 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 360105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360110 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 360122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360130 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360136 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 360144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360146 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360151 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360153 */     GIR_RootConstrainSelectedInstOperands,
     /* 360154 */     // GIR_Coverage, 11217,
     /* 360154 */     GIR_EraseRootFromParent_Done,
     /* 360155 */   // Label 7214: @360155
     /* 360155 */   GIM_Reject,
     /* 360156 */ // Label 7195: @360156
     /* 360156 */ GIM_Reject,
     /* 360157 */ // Label 6982: @360157
     /* 360157 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(360308), // Rule ID 11213 //
     /* 360162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 360168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360182 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360186 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 360186 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360189 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360193 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360198 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360204 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360209 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360214 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360217 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 360221 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360226 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360231 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360234 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 360238 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360243 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360246 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360251 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360254 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 360258 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360263 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 360275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360280 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360283 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360286 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360289 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 360297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360299 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360304 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360306 */   GIR_RootConstrainSelectedInstOperands,
     /* 360307 */   // GIR_Coverage, 11213,
     /* 360307 */   GIR_EraseRootFromParent_Done,
     /* 360308 */ // Label 7215: @360308
     /* 360308 */ GIM_Reject,
     /* 360309 */ // Label 6983: @360309
     /* 360309 */ GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(362340),
     /* 360314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 360317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360327 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(360436), // Rule ID 4284 //
     /* 360332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360352 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360359 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 360376 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 360383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360403 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360435 */     // GIR_Coverage, 4284,
     /* 360435 */     GIR_EraseRootFromParent_Done,
     /* 360436 */   // Label 7217: @360436
     /* 360436 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(360545), // Rule ID 4285 //
     /* 360441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360445 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360451 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360461 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360468 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 360485 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 360492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360544 */     // GIR_Coverage, 4285,
     /* 360544 */     GIR_EraseRootFromParent_Done,
     /* 360545 */   // Label 7218: @360545
     /* 360545 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(360654), // Rule ID 4392 //
     /* 360550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360554 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360560 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360570 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360577 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 360594 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 360601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360621 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360653 */     // GIR_Coverage, 4392,
     /* 360653 */     GIR_EraseRootFromParent_Done,
     /* 360654 */   // Label 7219: @360654
     /* 360654 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(360763), // Rule ID 4393 //
     /* 360659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360663 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360669 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360679 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360682 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360686 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 360703 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 360710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360730 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360762 */     // GIR_Coverage, 4393,
     /* 360762 */     GIR_EraseRootFromParent_Done,
     /* 360763 */   // Label 7220: @360763
     /* 360763 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(360868), // Rule ID 4290 //
     /* 360768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360784 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360791 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 360808 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 360815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360835 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360867 */     // GIR_Coverage, 4290,
     /* 360867 */     GIR_EraseRootFromParent_Done,
     /* 360868 */   // Label 7221: @360868
     /* 360868 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(360973), // Rule ID 4292 //
     /* 360873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360889 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360896 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 360913 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 360913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 360920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360940 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360972 */     // GIR_Coverage, 4292,
     /* 360972 */     GIR_EraseRootFromParent_Done,
     /* 360973 */   // Label 7222: @360973
     /* 360973 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(361078), // Rule ID 4398 //
     /* 360978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360994 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361001 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 361018 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 361018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 361025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361045 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361077 */     // GIR_Coverage, 4398,
     /* 361077 */     GIR_EraseRootFromParent_Done,
     /* 361078 */   // Label 7223: @361078
     /* 361078 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(361183), // Rule ID 4400 //
     /* 361083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361099 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361106 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 361123 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 361123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 361130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361150 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361182 */     // GIR_Coverage, 4400,
     /* 361182 */     GIR_EraseRootFromParent_Done,
     /* 361183 */   // Label 7224: @361183
     /* 361183 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(361287), // Rule ID 4282 //
     /* 361188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361192 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361198 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361208 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361211 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361215 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 361232 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 361232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 361239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361254 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361286 */     // GIR_Coverage, 4282,
     /* 361286 */     GIR_EraseRootFromParent_Done,
     /* 361287 */   // Label 7225: @361287
     /* 361287 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(361391), // Rule ID 4283 //
     /* 361292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361296 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361302 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361312 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361319 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 361336 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 361336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 361343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361358 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361390 */     // GIR_Coverage, 4283,
     /* 361390 */     GIR_EraseRootFromParent_Done,
     /* 361391 */   // Label 7226: @361391
     /* 361391 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(361495), // Rule ID 4390 //
     /* 361396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361400 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361406 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361416 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361423 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361427 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 361440 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 361440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 361447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361462 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361494 */     // GIR_Coverage, 4390,
     /* 361494 */     GIR_EraseRootFromParent_Done,
     /* 361495 */   // Label 7227: @361495
     /* 361495 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(361599), // Rule ID 4391 //
     /* 361500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361504 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361510 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361520 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361523 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361527 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 361544 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 361544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 361551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361566 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361598 */     // GIR_Coverage, 4391,
     /* 361598 */     GIR_EraseRootFromParent_Done,
     /* 361599 */   // Label 7228: @361599
     /* 361599 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(361699), // Rule ID 4286 //
     /* 361604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361620 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361627 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 361644 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 361644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 361651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361666 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361698 */     // GIR_Coverage, 4286,
     /* 361698 */     GIR_EraseRootFromParent_Done,
     /* 361699 */   // Label 7229: @361699
     /* 361699 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(361799), // Rule ID 4288 //
     /* 361704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361720 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361727 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 361744 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 361744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 361751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361766 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361798 */     // GIR_Coverage, 4288,
     /* 361798 */     GIR_EraseRootFromParent_Done,
     /* 361799 */   // Label 7230: @361799
     /* 361799 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(361899), // Rule ID 4394 //
     /* 361804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361820 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361827 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 361844 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 361844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 361851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361866 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361898 */     // GIR_Coverage, 4394,
     /* 361898 */     GIR_EraseRootFromParent_Done,
     /* 361899 */   // Label 7231: @361899
     /* 361899 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(361999), // Rule ID 4396 //
     /* 361904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361920 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361927 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 361944 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 361944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 361951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361966 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 361988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361998 */     // GIR_Coverage, 4396,
     /* 361998 */     GIR_EraseRootFromParent_Done,
     /* 361999 */   // Label 7232: @361999
     /* 361999 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(362063), // Rule ID 11268 //
     /* 362004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362039 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 362043 */     // MIs[3] Operand 1
     /* 362043 */     // No operand predicates
     /* 362043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362049 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 362049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 362052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 362054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 362058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 362061 */     GIR_RootConstrainSelectedInstOperands,
     /* 362062 */     // GIR_Coverage, 11268,
     /* 362062 */     GIR_EraseRootFromParent_Done,
     /* 362063 */   // Label 7233: @362063
     /* 362063 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(362201), // Rule ID 11210 //
     /* 362068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362079 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 362079 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 362082 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362086 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362091 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 362097 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362102 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362107 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 362110 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 362114 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362119 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 362122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 362124 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 362127 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 362131 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362136 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362139 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 362142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362144 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 362147 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 362151 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362156 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 362159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 362168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362173 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 362182 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 362190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 362192 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 362199 */     GIR_RootConstrainSelectedInstOperands,
     /* 362200 */     // GIR_Coverage, 11210,
     /* 362200 */     GIR_EraseRootFromParent_Done,
     /* 362201 */   // Label 7234: @362201
     /* 362201 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(362339), // Rule ID 11216 //
     /* 362206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362217 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 362217 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 362220 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362224 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362229 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 362235 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362240 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362245 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 362248 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 362252 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362257 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 362260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 362262 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 362265 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 362269 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362274 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362277 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 362280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 362285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 362289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362294 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 362297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 362306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 362320 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 362328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 362330 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 362337 */     GIR_RootConstrainSelectedInstOperands,
     /* 362338 */     // GIR_Coverage, 11216,
     /* 362338 */     GIR_EraseRootFromParent_Done,
     /* 362339 */   // Label 7235: @362339
     /* 362339 */   GIM_Reject,
     /* 362340 */ // Label 7216: @362340
     /* 362340 */ GIM_Reject,
     /* 362341 */ // Label 6984: @362341
     /* 362341 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(364608),
     /* 362346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362349 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(362475), // Rule ID 4248 //
     /* 362354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362368 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362374 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362384 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362387 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362391 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362398 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362415 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362442 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362474 */     // GIR_Coverage, 4248,
     /* 362474 */     GIR_EraseRootFromParent_Done,
     /* 362475 */   // Label 7237: @362475
     /* 362475 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(362601), // Rule ID 4249 //
     /* 362480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362494 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362500 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362510 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362513 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362517 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362541 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362568 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362600 */     // GIR_Coverage, 4249,
     /* 362600 */     GIR_EraseRootFromParent_Done,
     /* 362601 */   // Label 7238: @362601
     /* 362601 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(362720), // Rule ID 4356 //
     /* 362606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362620 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362626 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362636 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362643 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362660 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362687 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362719 */     // GIR_Coverage, 4356,
     /* 362719 */     GIR_EraseRootFromParent_Done,
     /* 362720 */   // Label 7239: @362720
     /* 362720 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(362839), // Rule ID 4357 //
     /* 362725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362739 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362745 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362755 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362762 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362779 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362806 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362838 */     // GIR_Coverage, 4357,
     /* 362838 */     GIR_EraseRootFromParent_Done,
     /* 362839 */   // Label 7240: @362839
     /* 362839 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(362961), // Rule ID 4254 //
     /* 362844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362870 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362873 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362877 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362884 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362901 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362928 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362960 */     // GIR_Coverage, 4254,
     /* 362960 */     GIR_EraseRootFromParent_Done,
     /* 362961 */   // Label 7241: @362961
     /* 362961 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(363083), // Rule ID 4256 //
     /* 362966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362992 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362995 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362999 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363006 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363023 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363050 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363082 */     // GIR_Coverage, 4256,
     /* 363082 */     GIR_EraseRootFromParent_Done,
     /* 363083 */   // Label 7242: @363083
     /* 363083 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(363198), // Rule ID 4362 //
     /* 363088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363114 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363121 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 363138 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 363145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363165 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363197 */     // GIR_Coverage, 4362,
     /* 363197 */     GIR_EraseRootFromParent_Done,
     /* 363198 */   // Label 7243: @363198
     /* 363198 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(363313), // Rule ID 4364 //
     /* 363203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363229 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363236 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363253 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363280 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363312 */     // GIR_Coverage, 4364,
     /* 363312 */     GIR_EraseRootFromParent_Done,
     /* 363313 */   // Label 7244: @363313
     /* 363313 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(363434), // Rule ID 4246 //
     /* 363318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363332 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363338 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363348 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363351 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363355 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363362 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363379 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363401 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363433 */     // GIR_Coverage, 4246,
     /* 363433 */     GIR_EraseRootFromParent_Done,
     /* 363434 */   // Label 7245: @363434
     /* 363434 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(363555), // Rule ID 4247 //
     /* 363439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363469 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363472 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363476 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363483 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363500 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363522 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363554 */     // GIR_Coverage, 4247,
     /* 363554 */     GIR_EraseRootFromParent_Done,
     /* 363555 */   // Label 7246: @363555
     /* 363555 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(363669), // Rule ID 4354 //
     /* 363560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363574 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363580 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363590 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363597 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363614 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363636 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363668 */     // GIR_Coverage, 4354,
     /* 363668 */     GIR_EraseRootFromParent_Done,
     /* 363669 */   // Label 7247: @363669
     /* 363669 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(363783), // Rule ID 4355 //
     /* 363674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363688 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363694 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363704 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363711 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363728 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363750 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363782 */     // GIR_Coverage, 4355,
     /* 363782 */     GIR_EraseRootFromParent_Done,
     /* 363783 */   // Label 7248: @363783
     /* 363783 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(363900), // Rule ID 4250 //
     /* 363788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363814 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363817 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363821 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363828 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363845 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363867 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363899 */     // GIR_Coverage, 4250,
     /* 363899 */     GIR_EraseRootFromParent_Done,
     /* 363900 */   // Label 7249: @363900
     /* 363900 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(364017), // Rule ID 4252 //
     /* 363905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363931 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363934 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363938 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363945 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363962 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363984 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364016 */     // GIR_Coverage, 4252,
     /* 364016 */     GIR_EraseRootFromParent_Done,
     /* 364017 */   // Label 7250: @364017
     /* 364017 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(364127), // Rule ID 4358 //
     /* 364022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 364072 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 364072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 364079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364094 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364126 */     // GIR_Coverage, 4358,
     /* 364126 */     GIR_EraseRootFromParent_Done,
     /* 364127 */   // Label 7251: @364127
     /* 364127 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(364237), // Rule ID 4360 //
     /* 364132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364158 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364165 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 364182 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 364182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 364189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364204 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364236 */     // GIR_Coverage, 4360,
     /* 364236 */     GIR_EraseRootFromParent_Done,
     /* 364237 */   // Label 7252: @364237
     /* 364237 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(364311), // Rule ID 11266 //
     /* 364242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 364275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364287 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 364291 */     // MIs[3] Operand 1
     /* 364291 */     // No operand predicates
     /* 364291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364297 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 364297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 364306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 364309 */     GIR_RootConstrainSelectedInstOperands,
     /* 364310 */     // GIR_Coverage, 11266,
     /* 364310 */     GIR_EraseRootFromParent_Done,
     /* 364311 */   // Label 7253: @364311
     /* 364311 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(364459), // Rule ID 11209 //
     /* 364316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364337 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 364337 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 364340 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364344 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364349 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 364355 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364360 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364365 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 364368 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 364372 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364377 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364382 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 364385 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 364389 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364394 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 364397 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 364400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 364405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 364409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364414 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 364417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 364426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364431 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364434 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 364440 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 364448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364450 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364455 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 364457 */     GIR_RootConstrainSelectedInstOperands,
     /* 364458 */     // GIR_Coverage, 11209,
     /* 364458 */     GIR_EraseRootFromParent_Done,
     /* 364459 */   // Label 7254: @364459
     /* 364459 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(364607), // Rule ID 11214 //
     /* 364464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364485 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 364485 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 364488 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364492 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364497 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 364503 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364508 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364513 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 364516 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 364520 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364525 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364530 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 364533 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 364537 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364542 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 364545 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 364548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364550 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 364553 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 364557 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364562 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 364565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 364574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364579 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364582 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 364588 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 364596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364598 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364603 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 364605 */     GIR_RootConstrainSelectedInstOperands,
     /* 364606 */     // GIR_Coverage, 11214,
     /* 364606 */     GIR_EraseRootFromParent_Done,
     /* 364607 */   // Label 7255: @364607
     /* 364607 */   GIM_Reject,
     /* 364608 */ // Label 7236: @364608
     /* 364608 */ GIM_Reject,
     /* 364609 */ // Label 6985: @364609
     /* 364609 */ GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(365722),
     /* 364614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 364617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364627 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(364743), // Rule ID 4212 //
     /* 364632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364652 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364655 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364659 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 364666 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 364683 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 364683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 364686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 364690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 364732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 364742 */     // GIR_Coverage, 4212,
     /* 364742 */     GIR_EraseRootFromParent_Done,
     /* 364743 */   // Label 7257: @364743
     /* 364743 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(364859), // Rule ID 4213 //
     /* 364748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364752 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364758 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364768 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364771 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364775 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 364782 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 364799 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 364799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 364802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 364806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364826 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 364848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 364858 */     // GIR_Coverage, 4213,
     /* 364858 */     GIR_EraseRootFromParent_Done,
     /* 364859 */   // Label 7258: @364859
     /* 364859 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(364971), // Rule ID 4218 //
     /* 364864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364880 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364883 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364887 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 364894 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 364911 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 364911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 364914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 364918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364938 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 364960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 364970 */     // GIR_Coverage, 4218,
     /* 364970 */     GIR_EraseRootFromParent_Done,
     /* 364971 */   // Label 7259: @364971
     /* 364971 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(365083), // Rule ID 4220 //
     /* 364976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364992 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364995 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364999 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365006 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 365023 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 365023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 365030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365050 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365082 */     // GIR_Coverage, 4220,
     /* 365082 */     GIR_EraseRootFromParent_Done,
     /* 365083 */   // Label 7260: @365083
     /* 365083 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(365194), // Rule ID 4210 //
     /* 365088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365092 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365098 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365108 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365111 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365115 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365122 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 365139 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 365139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 365146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365161 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365193 */     // GIR_Coverage, 4210,
     /* 365193 */     GIR_EraseRootFromParent_Done,
     /* 365194 */   // Label 7261: @365194
     /* 365194 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(365305), // Rule ID 4211 //
     /* 365199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365203 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365209 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365219 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365222 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365226 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365233 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 365250 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 365250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 365257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365272 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365304 */     // GIR_Coverage, 4211,
     /* 365304 */     GIR_EraseRootFromParent_Done,
     /* 365305 */   // Label 7262: @365305
     /* 365305 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(365412), // Rule ID 4214 //
     /* 365310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365326 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365329 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365333 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365340 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 365357 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 365357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 365364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365379 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365411 */     // GIR_Coverage, 4214,
     /* 365411 */     GIR_EraseRootFromParent_Done,
     /* 365412 */   // Label 7263: @365412
     /* 365412 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(365519), // Rule ID 4216 //
     /* 365417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365433 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365436 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365440 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 365447 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 365464 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 365464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 365467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 365471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365486 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 365508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 365518 */     // GIR_Coverage, 4216,
     /* 365518 */     GIR_EraseRootFromParent_Done,
     /* 365519 */   // Label 7264: @365519
     /* 365519 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(365583), // Rule ID 11264 //
     /* 365524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 365547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365559 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 365563 */     // MIs[3] Operand 1
     /* 365563 */     // No operand predicates
     /* 365563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365569 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 365569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 365572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 365578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 365581 */     GIR_RootConstrainSelectedInstOperands,
     /* 365582 */     // GIR_Coverage, 11264,
     /* 365582 */     GIR_EraseRootFromParent_Done,
     /* 365583 */   // Label 7265: @365583
     /* 365583 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(365721), // Rule ID 11208 //
     /* 365588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 365599 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 365599 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 365602 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365606 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365611 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 365617 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365622 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 365627 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 365630 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 365634 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365639 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 365642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 365644 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 365647 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 365651 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365656 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 365659 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 365662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 365664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 365667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 365671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365676 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 365679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 365684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 365688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365693 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365696 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 365699 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 365702 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 365705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 365710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365712 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 365714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365717 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 365719 */     GIR_RootConstrainSelectedInstOperands,
     /* 365720 */     // GIR_Coverage, 11208,
     /* 365720 */     GIR_EraseRootFromParent_Done,
     /* 365721 */   // Label 7266: @365721
     /* 365721 */   GIM_Reject,
     /* 365722 */ // Label 7256: @365722
     /* 365722 */ GIM_Reject,
     /* 365723 */ // Label 6986: @365723
     /* 365723 */ GIM_Reject,
     /* 365724 */ // Label 91: @365724
     /* 365724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7270*/ GIMT_Encode4(368641),
     /* 365735 */ /*GILLT_s16*//*Label 7267*/ GIMT_Encode4(365747),
     /* 365739 */ /*GILLT_s32*//*Label 7268*/ GIMT_Encode4(366381),
     /* 365743 */ /*GILLT_s64*//*Label 7269*/ GIMT_Encode4(367974),
     /* 365747 */ // Label 7267: @365747
     /* 365747 */ GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(365791), // Rule ID 11257 //
     /* 365752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365765 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365769 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 365769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365774 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 365780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365790 */   // GIR_Coverage, 11257,
     /* 365790 */   GIR_EraseRootFromParent_Done,
     /* 365791 */ // Label 7271: @365791
     /* 365791 */ GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(365835), // Rule ID 11258 //
     /* 365796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 365802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365809 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365813 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 365813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365818 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 365824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365834 */   // GIR_Coverage, 11258,
     /* 365834 */   GIR_EraseRootFromParent_Done,
     /* 365835 */ // Label 7272: @365835
     /* 365835 */ GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(365879), // Rule ID 11259 //
     /* 365840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 365846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365853 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365857 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 365857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365862 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 365868 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365873 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365878 */   // GIR_Coverage, 11259,
     /* 365878 */   GIR_EraseRootFromParent_Done,
     /* 365879 */ // Label 7273: @365879
     /* 365879 */ GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(365924), // Rule ID 5789 //
     /* 365884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365898 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365902 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 365902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365907 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365923 */   // GIR_Coverage, 5789,
     /* 365923 */   GIR_EraseRootFromParent_Done,
     /* 365924 */ // Label 7274: @365924
     /* 365924 */ GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(365969), // Rule ID 5792 //
     /* 365929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365951 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365955 */   // MIs[1] Operand 1
     /* 365955 */   // No operand predicates
     /* 365955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365957 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 365960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365962 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365964 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365967 */   GIR_RootConstrainSelectedInstOperands,
     /* 365968 */   // GIR_Coverage, 5792,
     /* 365968 */   GIR_EraseRootFromParent_Done,
     /* 365969 */ // Label 7275: @365969
     /* 365969 */ GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(366045), // Rule ID 11232 //
     /* 365974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365987 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365991 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365995 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365999 */   // MIs[1] Operand 1
     /* 365999 */   // No operand predicates
     /* 365999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366001 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 366001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366013 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366017 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366027 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 366034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366044 */   // GIR_Coverage, 11232,
     /* 366044 */   GIR_EraseRootFromParent_Done,
     /* 366045 */ // Label 7276: @366045
     /* 366045 */ GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(366121), // Rule ID 11233 //
     /* 366050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 366056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366071 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 366075 */   // MIs[1] Operand 1
     /* 366075 */   // No operand predicates
     /* 366075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366077 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 366077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 366084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366089 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366093 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366103 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 366110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366120 */   // GIR_Coverage, 11233,
     /* 366120 */   GIR_EraseRootFromParent_Done,
     /* 366121 */ // Label 7277: @366121
     /* 366121 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(366197), // Rule ID 11234 //
     /* 366126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 366132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366139 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366143 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366147 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 366151 */   // MIs[1] Operand 1
     /* 366151 */   // No operand predicates
     /* 366151 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366153 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 366153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 366160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366165 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366169 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366179 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 366186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366196 */   // GIR_Coverage, 11234,
     /* 366196 */   GIR_EraseRootFromParent_Done,
     /* 366197 */ // Label 7278: @366197
     /* 366197 */ GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(366258), // Rule ID 11222 //
     /* 366202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366219 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 366219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 366226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366231 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366237 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366241 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 366249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 366251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366254 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366256 */   GIR_RootConstrainSelectedInstOperands,
     /* 366257 */   // GIR_Coverage, 11222,
     /* 366257 */   GIR_EraseRootFromParent_Done,
     /* 366258 */ // Label 7279: @366258
     /* 366258 */ GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(366319), // Rule ID 11223 //
     /* 366263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 366269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366280 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 366280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 366287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366292 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366298 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366302 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 366310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 366312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366315 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366317 */   GIR_RootConstrainSelectedInstOperands,
     /* 366318 */   // GIR_Coverage, 11223,
     /* 366318 */   GIR_EraseRootFromParent_Done,
     /* 366319 */ // Label 7280: @366319
     /* 366319 */ GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(366380), // Rule ID 11224 //
     /* 366324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 366330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366341 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 366341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 366348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366353 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366359 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366363 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 366371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 366373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366376 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366378 */   GIR_RootConstrainSelectedInstOperands,
     /* 366379 */   // GIR_Coverage, 11224,
     /* 366379 */   GIR_EraseRootFromParent_Done,
     /* 366380 */ // Label 7281: @366380
     /* 366380 */ GIM_Reject,
     /* 366381 */ // Label 7268: @366381
     /* 366381 */ GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(366426), // Rule ID 6966 //
     /* 366386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366400 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366404 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 366404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366409 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 366415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366425 */   // GIR_Coverage, 6966,
     /* 366425 */   GIR_EraseRootFromParent_Done,
     /* 366426 */ // Label 7282: @366426
     /* 366426 */ GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(366471), // Rule ID 6967 //
     /* 366431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366445 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366449 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 366449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366454 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 366460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366465 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366470 */   // GIR_Coverage, 6967,
     /* 366470 */   GIR_EraseRootFromParent_Done,
     /* 366471 */ // Label 7283: @366471
     /* 366471 */ GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(366515), // Rule ID 11253 //
     /* 366476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 366482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366489 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366493 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 366493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366498 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366509 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366514 */   // GIR_Coverage, 11253,
     /* 366514 */   GIR_EraseRootFromParent_Done,
     /* 366515 */ // Label 7284: @366515
     /* 366515 */ GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(366559), // Rule ID 11254 //
     /* 366520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366533 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366537 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 366537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366542 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366558 */   // GIR_Coverage, 11254,
     /* 366558 */   GIR_EraseRootFromParent_Done,
     /* 366559 */ // Label 7285: @366559
     /* 366559 */ GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(366603), // Rule ID 11255 //
     /* 366564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366577 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366581 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 366581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366586 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366602 */   // GIR_Coverage, 11255,
     /* 366602 */   GIR_EraseRootFromParent_Done,
     /* 366603 */ // Label 7286: @366603
     /* 366603 */ GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(366647), // Rule ID 11260 //
     /* 366608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366621 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366625 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 366625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366630 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366646 */   // GIR_Coverage, 11260,
     /* 366646 */   GIR_EraseRootFromParent_Done,
     /* 366647 */ // Label 7287: @366647
     /* 366647 */ GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(366691), // Rule ID 11261 //
     /* 366652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 366658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366665 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366669 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 366669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366674 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 366680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366690 */   // GIR_Coverage, 11261,
     /* 366690 */   GIR_EraseRootFromParent_Done,
     /* 366691 */ // Label 7288: @366691
     /* 366691 */ GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(366736), // Rule ID 5788 //
     /* 366696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366710 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366714 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 366714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366719 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 366725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366735 */   // GIR_Coverage, 5788,
     /* 366735 */   GIR_EraseRootFromParent_Done,
     /* 366736 */ // Label 7289: @366736
     /* 366736 */ GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(366809), // Rule ID 11238 //
     /* 366741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 366747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366754 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366762 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 366766 */   // MIs[1] Operand 1
     /* 366766 */   // No operand predicates
     /* 366766 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366768 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 366768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 366771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366780 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 366786 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366791 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 366799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366804 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 366807 */   GIR_RootConstrainSelectedInstOperands,
     /* 366808 */   // GIR_Coverage, 11238,
     /* 366808 */   GIR_EraseRootFromParent_Done,
     /* 366809 */ // Label 7290: @366809
     /* 366809 */ GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(366882), // Rule ID 11239 //
     /* 366814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366835 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366839 */   // MIs[1] Operand 1
     /* 366839 */   // No operand predicates
     /* 366839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366841 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 366841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 366844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366853 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 366859 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366864 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 366872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366877 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 366880 */   GIR_RootConstrainSelectedInstOperands,
     /* 366881 */   // GIR_Coverage, 11239,
     /* 366881 */   GIR_EraseRootFromParent_Done,
     /* 366882 */ // Label 7291: @366882
     /* 366882 */ GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(366955), // Rule ID 11240 //
     /* 366887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366908 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366912 */   // MIs[1] Operand 1
     /* 366912 */   // No operand predicates
     /* 366912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366914 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 366914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366926 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 366932 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366937 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 366945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366950 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 366953 */   GIR_RootConstrainSelectedInstOperands,
     /* 366954 */   // GIR_Coverage, 11240,
     /* 366954 */   GIR_EraseRootFromParent_Done,
     /* 366955 */ // Label 7292: @366955
     /* 366955 */ GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(367003), // Rule ID 1926 //
     /* 366960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 366963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 366966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366985 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 366989 */   // MIs[1] Operand 1
     /* 366989 */   // No operand predicates
     /* 366989 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366991 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 366991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 366994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366996 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366998 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367001 */   GIR_RootConstrainSelectedInstOperands,
     /* 367002 */   // GIR_Coverage, 1926,
     /* 367002 */   GIR_EraseRootFromParent_Done,
     /* 367003 */ // Label 7293: @367003
     /* 367003 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(367051), // Rule ID 1927 //
     /* 367008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 367011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367033 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 367037 */   // MIs[1] Operand 1
     /* 367037 */   // No operand predicates
     /* 367037 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367039 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 367042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367044 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367046 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367049 */   GIR_RootConstrainSelectedInstOperands,
     /* 367050 */   // GIR_Coverage, 1927,
     /* 367050 */   GIR_EraseRootFromParent_Done,
     /* 367051 */ // Label 7294: @367051
     /* 367051 */ GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(367099), // Rule ID 1928 //
     /* 367056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 367059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367081 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 367085 */   // MIs[1] Operand 1
     /* 367085 */   // No operand predicates
     /* 367085 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367087 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 367090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367092 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367094 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367097 */   GIR_RootConstrainSelectedInstOperands,
     /* 367098 */   // GIR_Coverage, 1928,
     /* 367098 */   GIR_EraseRootFromParent_Done,
     /* 367099 */ // Label 7295: @367099
     /* 367099 */ GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(367147), // Rule ID 1930 //
     /* 367104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 367110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367121 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367129 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 367133 */   // MIs[1] Operand 1
     /* 367133 */   // No operand predicates
     /* 367133 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367135 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 367138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367140 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367142 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367145 */   GIR_RootConstrainSelectedInstOperands,
     /* 367146 */   // GIR_Coverage, 1930,
     /* 367146 */   GIR_EraseRootFromParent_Done,
     /* 367147 */ // Label 7296: @367147
     /* 367147 */ GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(367195), // Rule ID 1931 //
     /* 367152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367177 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367181 */   // MIs[1] Operand 1
     /* 367181 */   // No operand predicates
     /* 367181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367183 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 367186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367188 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367190 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367193 */   GIR_RootConstrainSelectedInstOperands,
     /* 367194 */   // GIR_Coverage, 1931,
     /* 367194 */   GIR_EraseRootFromParent_Done,
     /* 367195 */ // Label 7297: @367195
     /* 367195 */ GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(367243), // Rule ID 1932 //
     /* 367200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367225 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367229 */   // MIs[1] Operand 1
     /* 367229 */   // No operand predicates
     /* 367229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367231 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 367231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 367234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367236 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367238 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367241 */   GIR_RootConstrainSelectedInstOperands,
     /* 367242 */   // GIR_Coverage, 1932,
     /* 367242 */   GIR_EraseRootFromParent_Done,
     /* 367243 */ // Label 7298: @367243
     /* 367243 */ GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(367288), // Rule ID 5791 //
     /* 367248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367270 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367274 */   // MIs[1] Operand 1
     /* 367274 */   // No operand predicates
     /* 367274 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367276 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 367279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367281 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367283 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367286 */   GIR_RootConstrainSelectedInstOperands,
     /* 367287 */   // GIR_Coverage, 5791,
     /* 367287 */   GIR_EraseRootFromParent_Done,
     /* 367288 */ // Label 7299: @367288
     /* 367288 */ GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(367364), // Rule ID 11228 //
     /* 367293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 367299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367314 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 367318 */   // MIs[1] Operand 1
     /* 367318 */   // No operand predicates
     /* 367318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367320 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 367320 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367323 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 367327 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367332 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367336 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367346 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367353 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367363 */   // GIR_Coverage, 11228,
     /* 367363 */   GIR_EraseRootFromParent_Done,
     /* 367364 */ // Label 7300: @367364
     /* 367364 */ GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(367440), // Rule ID 11229 //
     /* 367369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 367375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367390 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 367394 */   // MIs[1] Operand 1
     /* 367394 */   // No operand predicates
     /* 367394 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367396 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 367396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 367403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367408 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367412 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367422 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367434 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367439 */   // GIR_Coverage, 11229,
     /* 367439 */   GIR_EraseRootFromParent_Done,
     /* 367440 */ // Label 7301: @367440
     /* 367440 */ GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(367516), // Rule ID 11230 //
     /* 367445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367458 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367462 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367466 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 367470 */   // MIs[1] Operand 1
     /* 367470 */   // No operand predicates
     /* 367470 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367472 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 367472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 367479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367484 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367488 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367498 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367510 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367515 */   // GIR_Coverage, 11230,
     /* 367515 */   GIR_EraseRootFromParent_Done,
     /* 367516 */ // Label 7302: @367516
     /* 367516 */ GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(367592), // Rule ID 11235 //
     /* 367521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367542 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 367546 */   // MIs[1] Operand 1
     /* 367546 */   // No operand predicates
     /* 367546 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367548 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 367548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 367555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367560 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367564 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367574 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367586 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367591 */   // GIR_Coverage, 11235,
     /* 367591 */   GIR_EraseRootFromParent_Done,
     /* 367592 */ // Label 7303: @367592
     /* 367592 */ GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(367668), // Rule ID 11236 //
     /* 367597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 367603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367618 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 367622 */   // MIs[1] Operand 1
     /* 367622 */   // No operand predicates
     /* 367622 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367624 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 367624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 367631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367636 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 367640 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 367643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367650 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 367657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367667 */   // GIR_Coverage, 11236,
     /* 367667 */   GIR_EraseRootFromParent_Done,
     /* 367668 */ // Label 7304: @367668
     /* 367668 */ GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(367729), // Rule ID 11218 //
     /* 367673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 367679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367690 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 367690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 367697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367708 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367712 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 367720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367725 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367727 */   GIR_RootConstrainSelectedInstOperands,
     /* 367728 */   // GIR_Coverage, 11218,
     /* 367728 */   GIR_EraseRootFromParent_Done,
     /* 367729 */ // Label 7305: @367729
     /* 367729 */ GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(367790), // Rule ID 11219 //
     /* 367734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 367740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367751 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 367751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 367758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367763 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367769 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367773 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 367781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367786 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367788 */   GIR_RootConstrainSelectedInstOperands,
     /* 367789 */   // GIR_Coverage, 11219,
     /* 367789 */   GIR_EraseRootFromParent_Done,
     /* 367790 */ // Label 7306: @367790
     /* 367790 */ GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(367851), // Rule ID 11220 //
     /* 367795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367812 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 367812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 367819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367824 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367830 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367834 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 367842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367847 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367849 */   GIR_RootConstrainSelectedInstOperands,
     /* 367850 */   // GIR_Coverage, 11220,
     /* 367850 */   GIR_EraseRootFromParent_Done,
     /* 367851 */ // Label 7307: @367851
     /* 367851 */ GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(367912), // Rule ID 11225 //
     /* 367856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367873 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 367873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 367880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367885 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367891 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367895 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 367903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 367905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367908 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367910 */   GIR_RootConstrainSelectedInstOperands,
     /* 367911 */   // GIR_Coverage, 11225,
     /* 367911 */   GIR_EraseRootFromParent_Done,
     /* 367912 */ // Label 7308: @367912
     /* 367912 */ GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(367973), // Rule ID 11226 //
     /* 367917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 367923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367934 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 367934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 367941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367946 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367952 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367956 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 367964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 367966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367969 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367971 */   GIR_RootConstrainSelectedInstOperands,
     /* 367972 */   // GIR_Coverage, 11226,
     /* 367972 */   GIR_EraseRootFromParent_Done,
     /* 367973 */ // Label 7309: @367973
     /* 367973 */ GIM_Reject,
     /* 367974 */ // Label 7269: @367974
     /* 367974 */ GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(368019), // Rule ID 6965 //
     /* 367979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 367982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367993 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 367997 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 367997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368002 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 368008 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368013 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368018 */   // GIR_Coverage, 6965,
     /* 368018 */   GIR_EraseRootFromParent_Done,
     /* 368019 */ // Label 7310: @368019
     /* 368019 */ GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(368063), // Rule ID 11256 //
     /* 368024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368037 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 368041 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 368041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368046 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 368052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368057 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368062 */   // GIR_Coverage, 11256,
     /* 368062 */   GIR_EraseRootFromParent_Done,
     /* 368063 */ // Label 7311: @368063
     /* 368063 */ GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(368107), // Rule ID 11262 //
     /* 368068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368081 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 368085 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 368085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368090 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 368096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368106 */   // GIR_Coverage, 11262,
     /* 368106 */   GIR_EraseRootFromParent_Done,
     /* 368107 */ // Label 7312: @368107
     /* 368107 */ GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(368152), // Rule ID 5787 //
     /* 368112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368126 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 368130 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 368130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368135 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368146 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368151 */   // GIR_Coverage, 5787,
     /* 368151 */   GIR_EraseRootFromParent_Done,
     /* 368152 */ // Label 7313: @368152
     /* 368152 */ GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(368225), // Rule ID 11241 //
     /* 368157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368178 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368182 */   // MIs[1] Operand 1
     /* 368182 */   // No operand predicates
     /* 368182 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368184 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 368184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 368187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368196 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 368202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 368215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368220 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 368223 */   GIR_RootConstrainSelectedInstOperands,
     /* 368224 */   // GIR_Coverage, 11241,
     /* 368224 */   GIR_EraseRootFromParent_Done,
     /* 368225 */ // Label 7314: @368225
     /* 368225 */ GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(368273), // Rule ID 1929 //
     /* 368230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 368233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368247 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368251 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368255 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 368259 */   // MIs[1] Operand 1
     /* 368259 */   // No operand predicates
     /* 368259 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368261 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 368261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 368264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368266 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368268 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 368271 */   GIR_RootConstrainSelectedInstOperands,
     /* 368272 */   // GIR_Coverage, 1929,
     /* 368272 */   GIR_EraseRootFromParent_Done,
     /* 368273 */ // Label 7315: @368273
     /* 368273 */ GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(368321), // Rule ID 1933 //
     /* 368278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368303 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368307 */   // MIs[1] Operand 1
     /* 368307 */   // No operand predicates
     /* 368307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368309 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 368309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 368312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368314 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368316 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 368319 */   GIR_RootConstrainSelectedInstOperands,
     /* 368320 */   // GIR_Coverage, 1933,
     /* 368320 */   GIR_EraseRootFromParent_Done,
     /* 368321 */ // Label 7316: @368321
     /* 368321 */ GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(368366), // Rule ID 5790 //
     /* 368326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368348 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368352 */   // MIs[1] Operand 1
     /* 368352 */   // No operand predicates
     /* 368352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368354 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 368354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 368357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368359 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368361 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 368364 */   GIR_RootConstrainSelectedInstOperands,
     /* 368365 */   // GIR_Coverage, 5790,
     /* 368365 */   GIR_EraseRootFromParent_Done,
     /* 368366 */ // Label 7317: @368366
     /* 368366 */ GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(368442), // Rule ID 11231 //
     /* 368371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368384 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368392 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 368396 */   // MIs[1] Operand 1
     /* 368396 */   // No operand predicates
     /* 368396 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368398 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 368398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 368401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368410 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 368414 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 368417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368424 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368436 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368441 */   // GIR_Coverage, 11231,
     /* 368441 */   GIR_EraseRootFromParent_Done,
     /* 368442 */ // Label 7318: @368442
     /* 368442 */ GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(368518), // Rule ID 11237 //
     /* 368447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368468 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 368472 */   // MIs[1] Operand 1
     /* 368472 */   // No operand predicates
     /* 368472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368474 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 368474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 368477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368486 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 368490 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 368493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368500 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368517 */   // GIR_Coverage, 11237,
     /* 368517 */   GIR_EraseRootFromParent_Done,
     /* 368518 */ // Label 7319: @368518
     /* 368518 */ GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(368579), // Rule ID 11221 //
     /* 368523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368540 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 368540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 368543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 368547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368552 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 368558 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 368562 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 368565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 368570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368575 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 368577 */   GIR_RootConstrainSelectedInstOperands,
     /* 368578 */   // GIR_Coverage, 11221,
     /* 368578 */   GIR_EraseRootFromParent_Done,
     /* 368579 */ // Label 7320: @368579
     /* 368579 */ GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(368640), // Rule ID 11227 //
     /* 368584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368601 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 368601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 368604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 368608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368613 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 368619 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 368623 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 368626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 368631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 368633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368636 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 368638 */   GIR_RootConstrainSelectedInstOperands,
     /* 368639 */   // GIR_Coverage, 11227,
     /* 368639 */   GIR_EraseRootFromParent_Done,
     /* 368640 */ // Label 7321: @368640
     /* 368640 */ GIM_Reject,
     /* 368641 */ // Label 7270: @368641
     /* 368641 */ GIM_Reject,
     /* 368642 */ // Label 92: @368642
     /* 368642 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7329*/ GIMT_Encode4(370961),
     /* 368653 */ /*GILLT_nxv2s16*//*Label 7322*/ GIMT_Encode4(368693),
     /* 368657 */ /*GILLT_nxv2s32*//*Label 7323*/ GIMT_Encode4(369052),
     /* 368661 */ /*GILLT_nxv2s64*//*Label 7324*/ GIMT_Encode4(369354), GIMT_Encode4(0),
     /* 368669 */ /*GILLT_nxv4s16*//*Label 7325*/ GIMT_Encode4(369729),
     /* 368673 */ /*GILLT_nxv4s32*//*Label 7326*/ GIMT_Encode4(370031), GIMT_Encode4(0),
     /* 368681 */ /*GILLT_nxv8s16*//*Label 7327*/ GIMT_Encode4(370406), GIMT_Encode4(0),
     /* 368689 */ /*GILLT_nxv16s8*//*Label 7328*/ GIMT_Encode4(370817),
     /* 368693 */ // Label 7322: @368693
     /* 368693 */ GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(369051),
     /* 368698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368705 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(368769), // Rule ID 6021 //
     /* 368710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368721 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 368725 */     // MIs[1] Operand 1
     /* 368725 */     // No operand predicates
     /* 368725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368727 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 368727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 368734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368739 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 368758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368768 */     // GIR_Coverage, 6021,
     /* 368768 */     GIR_EraseRootFromParent_Done,
     /* 368769 */   // Label 7331: @368769
     /* 368769 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(368826), // Rule ID 2675 //
     /* 368774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 368789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368806 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 368810 */     // MIs[2] Operand 1
     /* 368810 */     // No operand predicates
     /* 368810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368812 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 368812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 368815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368824 */     GIR_RootConstrainSelectedInstOperands,
     /* 368825 */     // GIR_Coverage, 2675,
     /* 368825 */     GIR_EraseRootFromParent_Done,
     /* 368826 */   // Label 7332: @368826
     /* 368826 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(368883), // Rule ID 2677 //
     /* 368831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 368846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368863 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 368867 */     // MIs[2] Operand 1
     /* 368867 */     // No operand predicates
     /* 368867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368869 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 368869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368881 */     GIR_RootConstrainSelectedInstOperands,
     /* 368882 */     // GIR_Coverage, 2677,
     /* 368882 */     GIR_EraseRootFromParent_Done,
     /* 368883 */   // Label 7333: @368883
     /* 368883 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(368940), // Rule ID 8361 //
     /* 368888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 368903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 368924 */     // MIs[2] Operand 1
     /* 368924 */     // No operand predicates
     /* 368924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368926 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 368926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 368929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368938 */     GIR_RootConstrainSelectedInstOperands,
     /* 368939 */     // GIR_Coverage, 8361,
     /* 368939 */     GIR_EraseRootFromParent_Done,
     /* 368940 */   // Label 7334: @368940
     /* 368940 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(368974), // Rule ID 8404 //
     /* 368945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368956 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 368960 */     // MIs[1] Operand 1
     /* 368960 */     // No operand predicates
     /* 368960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368962 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 368962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 368965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368967 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 368972 */     GIR_RootConstrainSelectedInstOperands,
     /* 368973 */     // GIR_Coverage, 8404,
     /* 368973 */     GIR_EraseRootFromParent_Done,
     /* 368974 */   // Label 7335: @368974
     /* 368974 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(369050), // Rule ID 8382 //
     /* 368979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368986 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 368986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 368989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369015 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 369022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 369040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369048 */     GIR_RootConstrainSelectedInstOperands,
     /* 369049 */     // GIR_Coverage, 8382,
     /* 369049 */     GIR_EraseRootFromParent_Done,
     /* 369050 */   // Label 7336: @369050
     /* 369050 */   GIM_Reject,
     /* 369051 */ // Label 7330: @369051
     /* 369051 */ GIM_Reject,
     /* 369052 */ // Label 7323: @369052
     /* 369052 */ GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(369353),
     /* 369057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369064 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(369128), // Rule ID 6019 //
     /* 369069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369080 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 369084 */     // MIs[1] Operand 1
     /* 369084 */     // No operand predicates
     /* 369084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369086 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369127 */     // GIR_Coverage, 6019,
     /* 369127 */     GIR_EraseRootFromParent_Done,
     /* 369128 */   // Label 7338: @369128
     /* 369128 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(369185), // Rule ID 8370 //
     /* 369133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 369148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369165 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 369169 */     // MIs[2] Operand 1
     /* 369169 */     // No operand predicates
     /* 369169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369171 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 369171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 369174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369183 */     GIR_RootConstrainSelectedInstOperands,
     /* 369184 */     // GIR_Coverage, 8370,
     /* 369184 */     GIR_EraseRootFromParent_Done,
     /* 369185 */   // Label 7339: @369185
     /* 369185 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(369242), // Rule ID 8379 //
     /* 369190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 369205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 369226 */     // MIs[2] Operand 1
     /* 369226 */     // No operand predicates
     /* 369226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369228 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 369228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 369231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369240 */     GIR_RootConstrainSelectedInstOperands,
     /* 369241 */     // GIR_Coverage, 8379,
     /* 369241 */     GIR_EraseRootFromParent_Done,
     /* 369242 */   // Label 7340: @369242
     /* 369242 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(369276), // Rule ID 8406 //
     /* 369247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369258 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 369262 */     // MIs[1] Operand 1
     /* 369262 */     // No operand predicates
     /* 369262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369264 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 369264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 369267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369269 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 369274 */     GIR_RootConstrainSelectedInstOperands,
     /* 369275 */     // GIR_Coverage, 8406,
     /* 369275 */     GIR_EraseRootFromParent_Done,
     /* 369276 */   // Label 7341: @369276
     /* 369276 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(369352), // Rule ID 8384 //
     /* 369281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369288 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369288 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 369291 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369295 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369321 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 369324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 369342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369350 */     GIR_RootConstrainSelectedInstOperands,
     /* 369351 */     // GIR_Coverage, 8384,
     /* 369351 */     GIR_EraseRootFromParent_Done,
     /* 369352 */   // Label 7342: @369352
     /* 369352 */   GIM_Reject,
     /* 369353 */ // Label 7337: @369353
     /* 369353 */ GIM_Reject,
     /* 369354 */ // Label 7324: @369354
     /* 369354 */ GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(369728),
     /* 369359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369366 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(369420), // Rule ID 6014 //
     /* 369371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 369378 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369390 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369419 */     // GIR_Coverage, 6014,
     /* 369419 */     GIR_EraseRootFromParent_Done,
     /* 369420 */   // Label 7344: @369420
     /* 369420 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(369484), // Rule ID 6018 //
     /* 369425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369436 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 369440 */     // MIs[1] Operand 1
     /* 369440 */     // No operand predicates
     /* 369440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369442 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369483 */     // GIR_Coverage, 6018,
     /* 369483 */     GIR_EraseRootFromParent_Done,
     /* 369484 */   // Label 7345: @369484
     /* 369484 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(369541), // Rule ID 2672 //
     /* 369489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 369504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369521 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 369525 */     // MIs[2] Operand 1
     /* 369525 */     // No operand predicates
     /* 369525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369527 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 369527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 369530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369539 */     GIR_RootConstrainSelectedInstOperands,
     /* 369540 */     // GIR_Coverage, 2672,
     /* 369540 */     GIR_EraseRootFromParent_Done,
     /* 369541 */   // Label 7346: @369541
     /* 369541 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(369598), // Rule ID 8376 //
     /* 369546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 369561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369578 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 369582 */     // MIs[2] Operand 1
     /* 369582 */     // No operand predicates
     /* 369582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369584 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 369584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 369587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369596 */     GIR_RootConstrainSelectedInstOperands,
     /* 369597 */     // GIR_Coverage, 8376,
     /* 369597 */     GIR_EraseRootFromParent_Done,
     /* 369598 */   // Label 7347: @369598
     /* 369598 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(369632), // Rule ID 8407 //
     /* 369603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369614 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 369618 */     // MIs[1] Operand 1
     /* 369618 */     // No operand predicates
     /* 369618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369620 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 369620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 369623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369625 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 369630 */     GIR_RootConstrainSelectedInstOperands,
     /* 369631 */     // GIR_Coverage, 8407,
     /* 369631 */     GIR_EraseRootFromParent_Done,
     /* 369632 */   // Label 7348: @369632
     /* 369632 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(369651), // Rule ID 2391 //
     /* 369637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369644 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 369644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 369649 */     GIR_RootConstrainSelectedInstOperands,
     /* 369650 */     // GIR_Coverage, 2391,
     /* 369650 */     GIR_Done,
     /* 369651 */   // Label 7349: @369651
     /* 369651 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(369727), // Rule ID 8385 //
     /* 369656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369663 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 369666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369689 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 369717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369725 */     GIR_RootConstrainSelectedInstOperands,
     /* 369726 */     // GIR_Coverage, 8385,
     /* 369726 */     GIR_EraseRootFromParent_Done,
     /* 369727 */   // Label 7350: @369727
     /* 369727 */   GIM_Reject,
     /* 369728 */ // Label 7343: @369728
     /* 369728 */ GIM_Reject,
     /* 369729 */ // Label 7325: @369729
     /* 369729 */ GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(370030),
     /* 369734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369741 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(369805), // Rule ID 6022 //
     /* 369746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369757 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 369761 */     // MIs[1] Operand 1
     /* 369761 */     // No operand predicates
     /* 369761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369763 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369804 */     // GIR_Coverage, 6022,
     /* 369804 */     GIR_EraseRootFromParent_Done,
     /* 369805 */   // Label 7352: @369805
     /* 369805 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(369862), // Rule ID 2676 //
     /* 369810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 369825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369842 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 369846 */     // MIs[2] Operand 1
     /* 369846 */     // No operand predicates
     /* 369846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369848 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 369848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 369851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369860 */     GIR_RootConstrainSelectedInstOperands,
     /* 369861 */     // GIR_Coverage, 2676,
     /* 369861 */     GIR_EraseRootFromParent_Done,
     /* 369862 */   // Label 7353: @369862
     /* 369862 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(369919), // Rule ID 8364 //
     /* 369867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 369882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369899 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 369903 */     // MIs[2] Operand 1
     /* 369903 */     // No operand predicates
     /* 369903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369905 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 369905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 369908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369917 */     GIR_RootConstrainSelectedInstOperands,
     /* 369918 */     // GIR_Coverage, 8364,
     /* 369918 */     GIR_EraseRootFromParent_Done,
     /* 369919 */   // Label 7354: @369919
     /* 369919 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(369953), // Rule ID 8403 //
     /* 369924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369935 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 369939 */     // MIs[1] Operand 1
     /* 369939 */     // No operand predicates
     /* 369939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369941 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 369941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 369944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369946 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 369951 */     GIR_RootConstrainSelectedInstOperands,
     /* 369952 */     // GIR_Coverage, 8403,
     /* 369952 */     GIR_EraseRootFromParent_Done,
     /* 369953 */   // Label 7355: @369953
     /* 369953 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(370029), // Rule ID 8381 //
     /* 369958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369965 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369965 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 369968 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369972 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 370001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 370019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370027 */     GIR_RootConstrainSelectedInstOperands,
     /* 370028 */     // GIR_Coverage, 8381,
     /* 370028 */     GIR_EraseRootFromParent_Done,
     /* 370029 */   // Label 7356: @370029
     /* 370029 */   GIM_Reject,
     /* 370030 */ // Label 7351: @370030
     /* 370030 */ GIM_Reject,
     /* 370031 */ // Label 7326: @370031
     /* 370031 */ GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(370405),
     /* 370036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370043 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(370097), // Rule ID 6015 //
     /* 370048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 370055 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370096 */     // GIR_Coverage, 6015,
     /* 370096 */     GIR_EraseRootFromParent_Done,
     /* 370097 */   // Label 7358: @370097
     /* 370097 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(370161), // Rule ID 6020 //
     /* 370102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 370113 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 370117 */     // MIs[1] Operand 1
     /* 370117 */     // No operand predicates
     /* 370117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370119 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370160 */     // GIR_Coverage, 6020,
     /* 370160 */     GIR_EraseRootFromParent_Done,
     /* 370161 */   // Label 7359: @370161
     /* 370161 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(370218), // Rule ID 2669 //
     /* 370166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 370181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 370202 */     // MIs[2] Operand 1
     /* 370202 */     // No operand predicates
     /* 370202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370204 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 370204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 370207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370216 */     GIR_RootConstrainSelectedInstOperands,
     /* 370217 */     // GIR_Coverage, 2669,
     /* 370217 */     GIR_EraseRootFromParent_Done,
     /* 370218 */   // Label 7360: @370218
     /* 370218 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(370275), // Rule ID 8373 //
     /* 370223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 370238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370255 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 370259 */     // MIs[2] Operand 1
     /* 370259 */     // No operand predicates
     /* 370259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370261 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 370261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 370264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370273 */     GIR_RootConstrainSelectedInstOperands,
     /* 370274 */     // GIR_Coverage, 8373,
     /* 370274 */     GIR_EraseRootFromParent_Done,
     /* 370275 */   // Label 7361: @370275
     /* 370275 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(370309), // Rule ID 8405 //
     /* 370280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 370291 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 370295 */     // MIs[1] Operand 1
     /* 370295 */     // No operand predicates
     /* 370295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370297 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 370297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 370300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370302 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 370307 */     GIR_RootConstrainSelectedInstOperands,
     /* 370308 */     // GIR_Coverage, 8405,
     /* 370308 */     GIR_EraseRootFromParent_Done,
     /* 370309 */   // Label 7362: @370309
     /* 370309 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(370328), // Rule ID 2390 //
     /* 370314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 370321 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 370321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 370326 */     GIR_RootConstrainSelectedInstOperands,
     /* 370327 */     // GIR_Coverage, 2390,
     /* 370327 */     GIR_Done,
     /* 370328 */   // Label 7363: @370328
     /* 370328 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(370404), // Rule ID 8383 //
     /* 370333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370340 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 370340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 370343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 370357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370366 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370369 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 370376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 370394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370402 */     GIR_RootConstrainSelectedInstOperands,
     /* 370403 */     // GIR_Coverage, 8383,
     /* 370403 */     GIR_EraseRootFromParent_Done,
     /* 370404 */   // Label 7364: @370404
     /* 370404 */   GIM_Reject,
     /* 370405 */ // Label 7357: @370405
     /* 370405 */ GIM_Reject,
     /* 370406 */ // Label 7327: @370406
     /* 370406 */ GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(370467), // Rule ID 6016 //
     /* 370411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370421 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 370425 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370437 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370466 */   // GIR_Coverage, 6016,
     /* 370466 */   GIR_EraseRootFromParent_Done,
     /* 370467 */ // Label 7365: @370467
     /* 370467 */ GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(370538), // Rule ID 6023 //
     /* 370472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 370490 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 370494 */   // MIs[1] Operand 1
     /* 370494 */   // No operand predicates
     /* 370494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370496 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370508 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370537 */   // GIR_Coverage, 6023,
     /* 370537 */   GIR_EraseRootFromParent_Done,
     /* 370538 */ // Label 7366: @370538
     /* 370538 */ GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(370602), // Rule ID 2666 //
     /* 370543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370561 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 370565 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370569 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370574 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370578 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370582 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 370586 */   // MIs[2] Operand 1
     /* 370586 */   // No operand predicates
     /* 370586 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370588 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 370588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 370591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370593 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370597 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370600 */   GIR_RootConstrainSelectedInstOperands,
     /* 370601 */   // GIR_Coverage, 2666,
     /* 370601 */   GIR_EraseRootFromParent_Done,
     /* 370602 */ // Label 7367: @370602
     /* 370602 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(370666), // Rule ID 8367 //
     /* 370607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370625 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 370629 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370633 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370638 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370642 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370646 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 370650 */   // MIs[2] Operand 1
     /* 370650 */   // No operand predicates
     /* 370650 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370652 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 370652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 370655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370657 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370661 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370664 */   GIR_RootConstrainSelectedInstOperands,
     /* 370665 */   // GIR_Coverage, 8367,
     /* 370665 */   GIR_EraseRootFromParent_Done,
     /* 370666 */ // Label 7368: @370666
     /* 370666 */ GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(370707), // Rule ID 8402 //
     /* 370671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 370689 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 370693 */   // MIs[1] Operand 1
     /* 370693 */   // No operand predicates
     /* 370693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370695 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 370695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 370698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370700 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 370705 */   GIR_RootConstrainSelectedInstOperands,
     /* 370706 */   // GIR_Coverage, 8402,
     /* 370706 */   GIR_EraseRootFromParent_Done,
     /* 370707 */ // Label 7369: @370707
     /* 370707 */ GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(370733), // Rule ID 2389 //
     /* 370712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 370726 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 370726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 370731 */   GIR_RootConstrainSelectedInstOperands,
     /* 370732 */   // GIR_Coverage, 2389,
     /* 370732 */   GIR_Done,
     /* 370733 */ // Label 7370: @370733
     /* 370733 */ GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(370816), // Rule ID 8380 //
     /* 370738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370752 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 370752 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 370755 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370759 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 370769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370785 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 370788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 370806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370814 */   GIR_RootConstrainSelectedInstOperands,
     /* 370815 */   // GIR_Coverage, 8380,
     /* 370815 */   GIR_EraseRootFromParent_Done,
     /* 370816 */ // Label 7371: @370816
     /* 370816 */ GIM_Reject,
     /* 370817 */ // Label 7328: @370817
     /* 370817 */ GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(370960),
     /* 370822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370829 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(370883), // Rule ID 6017 //
     /* 370834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 370841 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 370841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 370848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 370872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370882 */     // GIR_Coverage, 6017,
     /* 370882 */     GIR_EraseRootFromParent_Done,
     /* 370883 */   // Label 7373: @370883
     /* 370883 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(370940), // Rule ID 2663 //
     /* 370888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 370903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 370912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 370924 */     // MIs[2] Operand 1
     /* 370924 */     // No operand predicates
     /* 370924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370926 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 370926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 370929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 370931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 370935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 370938 */     GIR_RootConstrainSelectedInstOperands,
     /* 370939 */     // GIR_Coverage, 2663,
     /* 370939 */     GIR_EraseRootFromParent_Done,
     /* 370940 */   // Label 7374: @370940
     /* 370940 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(370959), // Rule ID 2388 //
     /* 370945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 370948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 370952 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 370952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 370957 */     GIR_RootConstrainSelectedInstOperands,
     /* 370958 */     // GIR_Coverage, 2388,
     /* 370958 */     GIR_Done,
     /* 370959 */   // Label 7375: @370959
     /* 370959 */   GIM_Reject,
     /* 370960 */ // Label 7372: @370960
     /* 370960 */ GIM_Reject,
     /* 370961 */ // Label 7329: @370961
     /* 370961 */ GIM_Reject,
     /* 370962 */ // Label 93: @370962
     /* 370962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7378*/ GIMT_Encode4(371113),
     /* 370973 */ /*GILLT_s32*//*Label 7376*/ GIMT_Encode4(370981),
     /* 370977 */ /*GILLT_s64*//*Label 7377*/ GIMT_Encode4(371047),
     /* 370981 */ // Label 7376: @370981
     /* 370981 */ GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(371046),
     /* 370986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370997 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(371012), // Rule ID 2321 //
     /* 371002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 371005 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 371010 */     GIR_RootConstrainSelectedInstOperands,
     /* 371011 */     // GIR_Coverage, 2321,
     /* 371011 */     GIR_Done,
     /* 371012 */   // Label 7380: @371012
     /* 371012 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(371045), // Rule ID 4005 //
     /* 371017 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 371017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 371024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 371038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371043 */     GIR_RootConstrainSelectedInstOperands,
     /* 371044 */     // GIR_Coverage, 4005,
     /* 371044 */     GIR_EraseRootFromParent_Done,
     /* 371045 */   // Label 7381: @371045
     /* 371045 */   GIM_Reject,
     /* 371046 */ // Label 7379: @371046
     /* 371046 */ GIM_Reject,
     /* 371047 */ // Label 7377: @371047
     /* 371047 */ GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(371112),
     /* 371052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371063 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(371078), // Rule ID 2322 //
     /* 371068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 371071 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 371076 */     GIR_RootConstrainSelectedInstOperands,
     /* 371077 */     // GIR_Coverage, 2322,
     /* 371077 */     GIR_Done,
     /* 371078 */   // Label 7383: @371078
     /* 371078 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(371111), // Rule ID 4006 //
     /* 371083 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 371083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 371090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 371104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371109 */     GIR_RootConstrainSelectedInstOperands,
     /* 371110 */     // GIR_Coverage, 4006,
     /* 371110 */     GIR_EraseRootFromParent_Done,
     /* 371111 */   // Label 7384: @371111
     /* 371111 */   GIM_Reject,
     /* 371112 */ // Label 7382: @371112
     /* 371112 */ GIM_Reject,
     /* 371113 */ // Label 7378: @371113
     /* 371113 */ GIM_Reject,
     /* 371114 */ // Label 94: @371114
     /* 371114 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7393*/ GIMT_Encode4(371787),
     /* 371125 */ /*GILLT_s32*//*Label 7385*/ GIMT_Encode4(371165),
     /* 371129 */ /*GILLT_s64*//*Label 7386*/ GIMT_Encode4(371395), GIMT_Encode4(0),
     /* 371137 */ /*GILLT_v2s32*//*Label 7387*/ GIMT_Encode4(371625), GIMT_Encode4(0),
     /* 371145 */ /*GILLT_v4s16*//*Label 7388*/ GIMT_Encode4(371652),
     /* 371149 */ /*GILLT_v4s32*//*Label 7389*/ GIMT_Encode4(371679),
     /* 371153 */ /*GILLT_v8s8*//*Label 7390*/ GIMT_Encode4(371706),
     /* 371157 */ /*GILLT_v8s16*//*Label 7391*/ GIMT_Encode4(371733),
     /* 371161 */ /*GILLT_v16s8*//*Label 7392*/ GIMT_Encode4(371760),
     /* 371165 */ // Label 7385: @371165
     /* 371165 */ GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(371394),
     /* 371170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371177 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(371277), // Rule ID 4007 //
     /* 371182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 371190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 371206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 371222 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 371226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 371230 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 371234 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 371238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371242 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371247 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 371251 */     // MIs[3] Rn
     /* 371251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 371256 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371264 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371266 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 371269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 371275 */     GIR_RootConstrainSelectedInstOperands,
     /* 371276 */     // GIR_Coverage, 4007,
     /* 371276 */     GIR_EraseRootFromParent_Done,
     /* 371277 */   // Label 7395: @371277
     /* 371277 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(371377), // Rule ID 13819 //
     /* 371282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 371290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 371306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 371322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 371326 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 371330 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371335 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 371339 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 371343 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371347 */     // MIs[4] Rn
     /* 371347 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 371352 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 371356 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371360 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371366 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 371369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 371375 */     GIR_RootConstrainSelectedInstOperands,
     /* 371376 */     // GIR_Coverage, 13819,
     /* 371376 */     GIR_EraseRootFromParent_Done,
     /* 371377 */   // Label 7396: @371377
     /* 371377 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(371393), // Rule ID 180 //
     /* 371382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371386 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 371391 */     GIR_RootConstrainSelectedInstOperands,
     /* 371392 */     // GIR_Coverage, 180,
     /* 371392 */     GIR_Done,
     /* 371393 */   // Label 7397: @371393
     /* 371393 */   GIM_Reject,
     /* 371394 */ // Label 7394: @371394
     /* 371394 */ GIM_Reject,
     /* 371395 */ // Label 7386: @371395
     /* 371395 */ GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(371624),
     /* 371400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371407 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(371507), // Rule ID 4008 //
     /* 371412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 371420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 371436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 371452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 371456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 371460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 371464 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 371468 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371472 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371477 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 371481 */     // MIs[3] Rn
     /* 371481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 371486 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371490 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371496 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 371499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 371505 */     GIR_RootConstrainSelectedInstOperands,
     /* 371506 */     // GIR_Coverage, 4008,
     /* 371506 */     GIR_EraseRootFromParent_Done,
     /* 371507 */   // Label 7399: @371507
     /* 371507 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(371607), // Rule ID 13820 //
     /* 371512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 371520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 371536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 371552 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 371556 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371560 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371565 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 371569 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 371573 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371577 */     // MIs[4] Rn
     /* 371577 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 371582 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 371586 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371590 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371594 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371596 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 371599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 371605 */     GIR_RootConstrainSelectedInstOperands,
     /* 371606 */     // GIR_Coverage, 13820,
     /* 371606 */     GIR_EraseRootFromParent_Done,
     /* 371607 */   // Label 7400: @371607
     /* 371607 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(371623), // Rule ID 181 //
     /* 371612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371616 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 371621 */     GIR_RootConstrainSelectedInstOperands,
     /* 371622 */     // GIR_Coverage, 181,
     /* 371622 */     GIR_Done,
     /* 371623 */   // Label 7401: @371623
     /* 371623 */   GIM_Reject,
     /* 371624 */ // Label 7398: @371624
     /* 371624 */ GIM_Reject,
     /* 371625 */ // Label 7387: @371625
     /* 371625 */ GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(371651), // Rule ID 720 //
     /* 371630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371644 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 371644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 371649 */   GIR_RootConstrainSelectedInstOperands,
     /* 371650 */   // GIR_Coverage, 720,
     /* 371650 */   GIR_Done,
     /* 371651 */ // Label 7402: @371651
     /* 371651 */ GIM_Reject,
     /* 371652 */ // Label 7388: @371652
     /* 371652 */ GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(371678), // Rule ID 718 //
     /* 371657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371671 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 371671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 371676 */   GIR_RootConstrainSelectedInstOperands,
     /* 371677 */   // GIR_Coverage, 718,
     /* 371677 */   GIR_Done,
     /* 371678 */ // Label 7403: @371678
     /* 371678 */ GIM_Reject,
     /* 371679 */ // Label 7389: @371679
     /* 371679 */ GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(371705), // Rule ID 721 //
     /* 371684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371698 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 371698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 371703 */   GIR_RootConstrainSelectedInstOperands,
     /* 371704 */   // GIR_Coverage, 721,
     /* 371704 */   GIR_Done,
     /* 371705 */ // Label 7404: @371705
     /* 371705 */ GIM_Reject,
     /* 371706 */ // Label 7390: @371706
     /* 371706 */ GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(371732), // Rule ID 716 //
     /* 371711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 371717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371725 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 371725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 371730 */   GIR_RootConstrainSelectedInstOperands,
     /* 371731 */   // GIR_Coverage, 716,
     /* 371731 */   GIR_Done,
     /* 371732 */ // Label 7405: @371732
     /* 371732 */ GIM_Reject,
     /* 371733 */ // Label 7391: @371733
     /* 371733 */ GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(371759), // Rule ID 719 //
     /* 371738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371752 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 371752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 371757 */   GIR_RootConstrainSelectedInstOperands,
     /* 371758 */   // GIR_Coverage, 719,
     /* 371758 */   GIR_Done,
     /* 371759 */ // Label 7406: @371759
     /* 371759 */ GIM_Reject,
     /* 371760 */ // Label 7392: @371760
     /* 371760 */ GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(371786), // Rule ID 717 //
     /* 371765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 371771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371779 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 371779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 371784 */   GIR_RootConstrainSelectedInstOperands,
     /* 371785 */   // GIR_Coverage, 717,
     /* 371785 */   GIR_Done,
     /* 371786 */ // Label 7407: @371786
     /* 371786 */ GIM_Reject,
     /* 371787 */ // Label 7393: @371787
     /* 371787 */ GIM_Reject,
     /* 371788 */ // Label 95: @371788
     /* 371788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7412*/ GIMT_Encode4(371947),
     /* 371799 */ /*GILLT_s32*//*Label 7408*/ GIMT_Encode4(371839),
     /* 371803 */ /*GILLT_s64*//*Label 7409*/ GIMT_Encode4(371866), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 371827 */ /*GILLT_v8s8*//*Label 7410*/ GIMT_Encode4(371893), GIMT_Encode4(0),
     /* 371835 */ /*GILLT_v16s8*//*Label 7411*/ GIMT_Encode4(371920),
     /* 371839 */ // Label 7408: @371839
     /* 371839 */ GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(371865), // Rule ID 2319 //
     /* 371844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 371847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371858 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 371858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 371863 */   GIR_RootConstrainSelectedInstOperands,
     /* 371864 */   // GIR_Coverage, 2319,
     /* 371864 */   GIR_Done,
     /* 371865 */ // Label 7413: @371865
     /* 371865 */ GIM_Reject,
     /* 371866 */ // Label 7409: @371866
     /* 371866 */ GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(371892), // Rule ID 2320 //
     /* 371871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 371874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 371885 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 371885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 371890 */   GIR_RootConstrainSelectedInstOperands,
     /* 371891 */   // GIR_Coverage, 2320,
     /* 371891 */   GIR_Done,
     /* 371892 */ // Label 7414: @371892
     /* 371892 */ GIM_Reject,
     /* 371893 */ // Label 7410: @371893
     /* 371893 */ GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(371919), // Rule ID 764 //
     /* 371898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 371904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371912 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 371912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 371917 */   GIR_RootConstrainSelectedInstOperands,
     /* 371918 */   // GIR_Coverage, 764,
     /* 371918 */   GIR_Done,
     /* 371919 */ // Label 7415: @371919
     /* 371919 */ GIM_Reject,
     /* 371920 */ // Label 7411: @371920
     /* 371920 */ GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(371946), // Rule ID 765 //
     /* 371925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 371931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371939 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 371939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 371944 */   GIR_RootConstrainSelectedInstOperands,
     /* 371945 */   // GIR_Coverage, 765,
     /* 371945 */   GIR_Done,
     /* 371946 */ // Label 7416: @371946
     /* 371946 */ GIM_Reject,
     /* 371947 */ // Label 7412: @371947
     /* 371947 */ GIM_Reject,
     /* 371948 */ // Label 96: @371948
     /* 371948 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7424*/ GIMT_Encode4(372261),
     /* 371959 */ /*GILLT_s32*//*Label 7417*/ GIMT_Encode4(371995),
     /* 371963 */ /*GILLT_s64*//*Label 7418*/ GIMT_Encode4(372068), GIMT_Encode4(0),
     /* 371971 */ /*GILLT_v2s32*//*Label 7419*/ GIMT_Encode4(372141),
     /* 371975 */ /*GILLT_v2s64*//*Label 7420*/ GIMT_Encode4(372165),
     /* 371979 */ /*GILLT_v4s16*//*Label 7421*/ GIMT_Encode4(372189),
     /* 371983 */ /*GILLT_v4s32*//*Label 7422*/ GIMT_Encode4(372213), GIMT_Encode4(0),
     /* 371991 */ /*GILLT_v8s16*//*Label 7423*/ GIMT_Encode4(372237),
     /* 371995 */ // Label 7417: @371995
     /* 371995 */ GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(372067),
     /* 372000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372007 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(372050), // Rule ID 4011 //
     /* 372012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 372020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 372037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372039 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 372039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 372042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372048 */     GIR_RootConstrainSelectedInstOperands,
     /* 372049 */     // GIR_Coverage, 4011,
     /* 372049 */     GIR_EraseRootFromParent_Done,
     /* 372050 */   // Label 7426: @372050
     /* 372050 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(372066), // Rule ID 185 //
     /* 372055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372059 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 372059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 372064 */     GIR_RootConstrainSelectedInstOperands,
     /* 372065 */     // GIR_Coverage, 185,
     /* 372065 */     GIR_Done,
     /* 372066 */   // Label 7427: @372066
     /* 372066 */   GIM_Reject,
     /* 372067 */ // Label 7425: @372067
     /* 372067 */ GIM_Reject,
     /* 372068 */ // Label 7418: @372068
     /* 372068 */ GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(372140),
     /* 372073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372080 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(372123), // Rule ID 4012 //
     /* 372085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 372093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372106 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 372110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372112 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 372112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 372115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372121 */     GIR_RootConstrainSelectedInstOperands,
     /* 372122 */     // GIR_Coverage, 4012,
     /* 372122 */     GIR_EraseRootFromParent_Done,
     /* 372123 */   // Label 7429: @372123
     /* 372123 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(372139), // Rule ID 186 //
     /* 372128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372132 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 372132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 372137 */     GIR_RootConstrainSelectedInstOperands,
     /* 372138 */     // GIR_Coverage, 186,
     /* 372138 */     GIR_Done,
     /* 372139 */   // Label 7430: @372139
     /* 372139 */   GIM_Reject,
     /* 372140 */ // Label 7428: @372140
     /* 372140 */ GIM_Reject,
     /* 372141 */ // Label 7419: @372141
     /* 372141 */ GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(372164), // Rule ID 4988 //
     /* 372146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372157 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 372157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 372162 */   GIR_RootConstrainSelectedInstOperands,
     /* 372163 */   // GIR_Coverage, 4988,
     /* 372163 */   GIR_Done,
     /* 372164 */ // Label 7431: @372164
     /* 372164 */ GIM_Reject,
     /* 372165 */ // Label 7420: @372165
     /* 372165 */ GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(372188), // Rule ID 4990 //
     /* 372170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372181 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 372181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 372186 */   GIR_RootConstrainSelectedInstOperands,
     /* 372187 */   // GIR_Coverage, 4990,
     /* 372187 */   GIR_Done,
     /* 372188 */ // Label 7432: @372188
     /* 372188 */ GIM_Reject,
     /* 372189 */ // Label 7421: @372189
     /* 372189 */ GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(372212), // Rule ID 4986 //
     /* 372194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372205 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 372205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 372210 */   GIR_RootConstrainSelectedInstOperands,
     /* 372211 */   // GIR_Coverage, 4986,
     /* 372211 */   GIR_Done,
     /* 372212 */ // Label 7433: @372212
     /* 372212 */ GIM_Reject,
     /* 372213 */ // Label 7422: @372213
     /* 372213 */ GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(372236), // Rule ID 4989 //
     /* 372218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372229 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 372229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 372234 */   GIR_RootConstrainSelectedInstOperands,
     /* 372235 */   // GIR_Coverage, 4989,
     /* 372235 */   GIR_Done,
     /* 372236 */ // Label 7434: @372236
     /* 372236 */ GIM_Reject,
     /* 372237 */ // Label 7423: @372237
     /* 372237 */ GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(372260), // Rule ID 4987 //
     /* 372242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372253 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 372253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 372258 */   GIR_RootConstrainSelectedInstOperands,
     /* 372259 */   // GIR_Coverage, 4987,
     /* 372259 */   GIR_Done,
     /* 372260 */ // Label 7435: @372260
     /* 372260 */ GIM_Reject,
     /* 372261 */ // Label 7424: @372261
     /* 372261 */ GIM_Reject,
     /* 372262 */ // Label 97: @372262
     /* 372262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7440*/ GIMT_Encode4(372415),
     /* 372273 */ /*GILLT_s32*//*Label 7436*/ GIMT_Encode4(372313),
     /* 372277 */ /*GILLT_s64*//*Label 7437*/ GIMT_Encode4(372337), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 372301 */ /*GILLT_v8s8*//*Label 7438*/ GIMT_Encode4(372361), GIMT_Encode4(0),
     /* 372309 */ /*GILLT_v16s8*//*Label 7439*/ GIMT_Encode4(372388),
     /* 372313 */ // Label 7436: @372313
     /* 372313 */ GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(372336), // Rule ID 182 //
     /* 372318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372329 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 372329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 372334 */   GIR_RootConstrainSelectedInstOperands,
     /* 372335 */   // GIR_Coverage, 182,
     /* 372335 */   GIR_Done,
     /* 372336 */ // Label 7441: @372336
     /* 372336 */ GIM_Reject,
     /* 372337 */ // Label 7437: @372337
     /* 372337 */ GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(372360), // Rule ID 183 //
     /* 372342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 372353 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 372353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 372358 */   GIR_RootConstrainSelectedInstOperands,
     /* 372359 */   // GIR_Coverage, 183,
     /* 372359 */   GIR_Done,
     /* 372360 */ // Label 7442: @372360
     /* 372360 */ GIM_Reject,
     /* 372361 */ // Label 7438: @372361
     /* 372361 */ GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(372387), // Rule ID 974 //
     /* 372366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 372372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372380 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 372380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 372385 */   GIR_RootConstrainSelectedInstOperands,
     /* 372386 */   // GIR_Coverage, 974,
     /* 372386 */   GIR_Done,
     /* 372387 */ // Label 7443: @372387
     /* 372387 */ GIM_Reject,
     /* 372388 */ // Label 7439: @372388
     /* 372388 */ GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(372414), // Rule ID 975 //
     /* 372393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 372399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372407 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 372407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 372412 */   GIR_RootConstrainSelectedInstOperands,
     /* 372413 */   // GIR_Coverage, 975,
     /* 372413 */   GIR_Done,
     /* 372414 */ // Label 7444: @372414
     /* 372414 */ GIM_Reject,
     /* 372415 */ // Label 7440: @372415
     /* 372415 */ GIM_Reject,
     /* 372416 */ // Label 98: @372416
     /* 372416 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7453*/ GIMT_Encode4(372906),
     /* 372427 */ /*GILLT_s16*//*Label 7445*/ GIMT_Encode4(372467),
     /* 372431 */ /*GILLT_s32*//*Label 7446*/ GIMT_Encode4(372498),
     /* 372435 */ /*GILLT_s64*//*Label 7447*/ GIMT_Encode4(372529), GIMT_Encode4(0),
     /* 372443 */ /*GILLT_v2s32*//*Label 7448*/ GIMT_Encode4(372560),
     /* 372447 */ /*GILLT_v2s64*//*Label 7449*/ GIMT_Encode4(372591),
     /* 372451 */ /*GILLT_v4s16*//*Label 7450*/ GIMT_Encode4(372622),
     /* 372455 */ /*GILLT_v4s32*//*Label 7451*/ GIMT_Encode4(372653), GIMT_Encode4(0),
     /* 372463 */ /*GILLT_v8s16*//*Label 7452*/ GIMT_Encode4(372684),
     /* 372467 */ // Label 7445: @372467
     /* 372467 */ GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(372497), // Rule ID 552 //
     /* 372472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372486 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 372486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 372491 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372495 */   GIR_RootConstrainSelectedInstOperands,
     /* 372496 */   // GIR_Coverage, 552,
     /* 372496 */   GIR_Done,
     /* 372497 */ // Label 7454: @372497
     /* 372497 */ GIM_Reject,
     /* 372498 */ // Label 7446: @372498
     /* 372498 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(372528), // Rule ID 554 //
     /* 372503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372517 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 372517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 372522 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372526 */   GIR_RootConstrainSelectedInstOperands,
     /* 372527 */   // GIR_Coverage, 554,
     /* 372527 */   GIR_Done,
     /* 372528 */ // Label 7455: @372528
     /* 372528 */ GIM_Reject,
     /* 372529 */ // Label 7447: @372529
     /* 372529 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(372559), // Rule ID 556 //
     /* 372534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372548 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 372548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 372553 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372557 */   GIR_RootConstrainSelectedInstOperands,
     /* 372558 */   // GIR_Coverage, 556,
     /* 372558 */   GIR_Done,
     /* 372559 */ // Label 7456: @372559
     /* 372559 */ GIM_Reject,
     /* 372560 */ // Label 7448: @372560
     /* 372560 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(372590), // Rule ID 913 //
     /* 372565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372579 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 372579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 372584 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372588 */   GIR_RootConstrainSelectedInstOperands,
     /* 372589 */   // GIR_Coverage, 913,
     /* 372589 */   GIR_Done,
     /* 372590 */ // Label 7457: @372590
     /* 372590 */ GIM_Reject,
     /* 372591 */ // Label 7449: @372591
     /* 372591 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(372621), // Rule ID 917 //
     /* 372596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372610 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 372610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 372615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372619 */   GIR_RootConstrainSelectedInstOperands,
     /* 372620 */   // GIR_Coverage, 917,
     /* 372620 */   GIR_Done,
     /* 372621 */ // Label 7458: @372621
     /* 372621 */ GIM_Reject,
     /* 372622 */ // Label 7450: @372622
     /* 372622 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(372652), // Rule ID 909 //
     /* 372627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372641 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 372641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 372646 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372650 */   GIR_RootConstrainSelectedInstOperands,
     /* 372651 */   // GIR_Coverage, 909,
     /* 372651 */   GIR_Done,
     /* 372652 */ // Label 7459: @372652
     /* 372652 */ GIM_Reject,
     /* 372653 */ // Label 7451: @372653
     /* 372653 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(372683), // Rule ID 915 //
     /* 372658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372672 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 372672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 372677 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372681 */   GIR_RootConstrainSelectedInstOperands,
     /* 372682 */   // GIR_Coverage, 915,
     /* 372682 */   GIR_Done,
     /* 372683 */ // Label 7460: @372683
     /* 372683 */ GIM_Reject,
     /* 372684 */ // Label 7452: @372684
     /* 372684 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(372905),
     /* 372689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372700 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(372719), // Rule ID 911 //
     /* 372705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372708 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 372708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 372713 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372717 */     GIR_RootConstrainSelectedInstOperands,
     /* 372718 */     // GIR_Coverage, 911,
     /* 372718 */     GIR_Done,
     /* 372719 */   // Label 7462: @372719
     /* 372719 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(372904), // Rule ID 6998 //
     /* 372724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 372727 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 372727 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 372730 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 372734 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372739 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 372745 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 372748 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 372752 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372757 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 372760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 372762 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 372765 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372769 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372774 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372780 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372785 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372790 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 372793 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 372797 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372802 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 372805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 372807 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 372810 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 372814 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372819 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 372822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 372824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 372827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 372831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372836 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 372839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372841 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 372844 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372848 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372867 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372870 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 372873 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 372894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 372902 */     GIR_RootConstrainSelectedInstOperands,
     /* 372903 */     // GIR_Coverage, 6998,
     /* 372903 */     GIR_EraseRootFromParent_Done,
     /* 372904 */   // Label 7463: @372904
     /* 372904 */   GIM_Reject,
     /* 372905 */ // Label 7461: @372905
     /* 372905 */ GIM_Reject,
     /* 372906 */ // Label 7453: @372906
     /* 372906 */ GIM_Reject,
     /* 372907 */ // Label 99: @372907
     /* 372907 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7472*/ GIMT_Encode4(373206),
     /* 372918 */ /*GILLT_s16*//*Label 7464*/ GIMT_Encode4(372958),
     /* 372922 */ /*GILLT_s32*//*Label 7465*/ GIMT_Encode4(372989),
     /* 372926 */ /*GILLT_s64*//*Label 7466*/ GIMT_Encode4(373020), GIMT_Encode4(0),
     /* 372934 */ /*GILLT_v2s32*//*Label 7467*/ GIMT_Encode4(373051),
     /* 372938 */ /*GILLT_v2s64*//*Label 7468*/ GIMT_Encode4(373082),
     /* 372942 */ /*GILLT_v4s16*//*Label 7469*/ GIMT_Encode4(373113),
     /* 372946 */ /*GILLT_v4s32*//*Label 7470*/ GIMT_Encode4(373144), GIMT_Encode4(0),
     /* 372954 */ /*GILLT_v8s16*//*Label 7471*/ GIMT_Encode4(373175),
     /* 372958 */ // Label 7464: @372958
     /* 372958 */ GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(372988), // Rule ID 570 //
     /* 372963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372977 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 372977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 372982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372986 */   GIR_RootConstrainSelectedInstOperands,
     /* 372987 */   // GIR_Coverage, 570,
     /* 372987 */   GIR_Done,
     /* 372988 */ // Label 7473: @372988
     /* 372988 */ GIM_Reject,
     /* 372989 */ // Label 7465: @372989
     /* 372989 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(373019), // Rule ID 572 //
     /* 372994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 373000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373008 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 373008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 373013 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373017 */   GIR_RootConstrainSelectedInstOperands,
     /* 373018 */   // GIR_Coverage, 572,
     /* 373018 */   GIR_Done,
     /* 373019 */ // Label 7474: @373019
     /* 373019 */ GIM_Reject,
     /* 373020 */ // Label 7466: @373020
     /* 373020 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(373050), // Rule ID 574 //
     /* 373025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373039 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 373039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 373044 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373048 */   GIR_RootConstrainSelectedInstOperands,
     /* 373049 */   // GIR_Coverage, 574,
     /* 373049 */   GIR_Done,
     /* 373050 */ // Label 7475: @373050
     /* 373050 */ GIM_Reject,
     /* 373051 */ // Label 7467: @373051
     /* 373051 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(373081), // Rule ID 960 //
     /* 373056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373070 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 373070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 373075 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373079 */   GIR_RootConstrainSelectedInstOperands,
     /* 373080 */   // GIR_Coverage, 960,
     /* 373080 */   GIR_Done,
     /* 373081 */ // Label 7476: @373081
     /* 373081 */ GIM_Reject,
     /* 373082 */ // Label 7468: @373082
     /* 373082 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(373112), // Rule ID 964 //
     /* 373087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373101 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 373101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 373106 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373110 */   GIR_RootConstrainSelectedInstOperands,
     /* 373111 */   // GIR_Coverage, 964,
     /* 373111 */   GIR_Done,
     /* 373112 */ // Label 7477: @373112
     /* 373112 */ GIM_Reject,
     /* 373113 */ // Label 7469: @373113
     /* 373113 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(373143), // Rule ID 956 //
     /* 373118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373132 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 373132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 373137 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373141 */   GIR_RootConstrainSelectedInstOperands,
     /* 373142 */   // GIR_Coverage, 956,
     /* 373142 */   GIR_Done,
     /* 373143 */ // Label 7478: @373143
     /* 373143 */ GIM_Reject,
     /* 373144 */ // Label 7470: @373144
     /* 373144 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(373174), // Rule ID 962 //
     /* 373149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373163 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 373163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 373168 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373172 */   GIR_RootConstrainSelectedInstOperands,
     /* 373173 */   // GIR_Coverage, 962,
     /* 373173 */   GIR_Done,
     /* 373174 */ // Label 7479: @373174
     /* 373174 */ GIM_Reject,
     /* 373175 */ // Label 7471: @373175
     /* 373175 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(373205), // Rule ID 958 //
     /* 373180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373194 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 373194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 373199 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373203 */   GIR_RootConstrainSelectedInstOperands,
     /* 373204 */   // GIR_Coverage, 958,
     /* 373204 */   GIR_Done,
     /* 373205 */ // Label 7480: @373205
     /* 373205 */ GIM_Reject,
     /* 373206 */ // Label 7472: @373206
     /* 373206 */ GIM_Reject,
     /* 373207 */ // Label 100: @373207
     /* 373207 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7489*/ GIMT_Encode4(373697),
     /* 373218 */ /*GILLT_s16*//*Label 7481*/ GIMT_Encode4(373258),
     /* 373222 */ /*GILLT_s32*//*Label 7482*/ GIMT_Encode4(373289),
     /* 373226 */ /*GILLT_s64*//*Label 7483*/ GIMT_Encode4(373320), GIMT_Encode4(0),
     /* 373234 */ /*GILLT_v2s32*//*Label 7484*/ GIMT_Encode4(373351),
     /* 373238 */ /*GILLT_v2s64*//*Label 7485*/ GIMT_Encode4(373382),
     /* 373242 */ /*GILLT_v4s16*//*Label 7486*/ GIMT_Encode4(373413),
     /* 373246 */ /*GILLT_v4s32*//*Label 7487*/ GIMT_Encode4(373444), GIMT_Encode4(0),
     /* 373254 */ /*GILLT_v8s16*//*Label 7488*/ GIMT_Encode4(373475),
     /* 373258 */ // Label 7481: @373258
     /* 373258 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(373288), // Rule ID 540 //
     /* 373263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 373269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373277 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 373277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 373282 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373286 */   GIR_RootConstrainSelectedInstOperands,
     /* 373287 */   // GIR_Coverage, 540,
     /* 373287 */   GIR_Done,
     /* 373288 */ // Label 7490: @373288
     /* 373288 */ GIM_Reject,
     /* 373289 */ // Label 7482: @373289
     /* 373289 */ GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(373319), // Rule ID 542 //
     /* 373294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 373300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373308 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 373308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 373313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373317 */   GIR_RootConstrainSelectedInstOperands,
     /* 373318 */   // GIR_Coverage, 542,
     /* 373318 */   GIR_Done,
     /* 373319 */ // Label 7491: @373319
     /* 373319 */ GIM_Reject,
     /* 373320 */ // Label 7483: @373320
     /* 373320 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(373350), // Rule ID 544 //
     /* 373325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373339 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 373339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 373344 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373348 */   GIR_RootConstrainSelectedInstOperands,
     /* 373349 */   // GIR_Coverage, 544,
     /* 373349 */   GIR_Done,
     /* 373350 */ // Label 7492: @373350
     /* 373350 */ GIM_Reject,
     /* 373351 */ // Label 7484: @373351
     /* 373351 */ GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(373381), // Rule ID 893 //
     /* 373356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373370 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 373370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 373375 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373379 */   GIR_RootConstrainSelectedInstOperands,
     /* 373380 */   // GIR_Coverage, 893,
     /* 373380 */   GIR_Done,
     /* 373381 */ // Label 7493: @373381
     /* 373381 */ GIM_Reject,
     /* 373382 */ // Label 7485: @373382
     /* 373382 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(373412), // Rule ID 897 //
     /* 373387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373401 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 373401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 373406 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373410 */   GIR_RootConstrainSelectedInstOperands,
     /* 373411 */   // GIR_Coverage, 897,
     /* 373411 */   GIR_Done,
     /* 373412 */ // Label 7494: @373412
     /* 373412 */ GIM_Reject,
     /* 373413 */ // Label 7486: @373413
     /* 373413 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(373443), // Rule ID 889 //
     /* 373418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373432 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 373432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 373437 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373441 */   GIR_RootConstrainSelectedInstOperands,
     /* 373442 */   // GIR_Coverage, 889,
     /* 373442 */   GIR_Done,
     /* 373443 */ // Label 7495: @373443
     /* 373443 */ GIM_Reject,
     /* 373444 */ // Label 7487: @373444
     /* 373444 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(373474), // Rule ID 895 //
     /* 373449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373463 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 373463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 373468 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373472 */   GIR_RootConstrainSelectedInstOperands,
     /* 373473 */   // GIR_Coverage, 895,
     /* 373473 */   GIR_Done,
     /* 373474 */ // Label 7496: @373474
     /* 373474 */ GIM_Reject,
     /* 373475 */ // Label 7488: @373475
     /* 373475 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(373696),
     /* 373480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373491 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(373510), // Rule ID 891 //
     /* 373496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373499 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 373499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 373504 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373508 */     GIR_RootConstrainSelectedInstOperands,
     /* 373509 */     // GIR_Coverage, 891,
     /* 373509 */     GIR_Done,
     /* 373510 */   // Label 7498: @373510
     /* 373510 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(373695), // Rule ID 7000 //
     /* 373515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 373518 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 373518 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 373521 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 373525 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373530 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 373534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 373536 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 373539 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 373543 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373548 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 373551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 373553 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 373556 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373560 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373565 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373571 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373576 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373581 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 373584 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 373588 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373593 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 373596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 373598 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 373601 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 373605 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373610 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 373613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 373615 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 373618 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 373622 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373627 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 373630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 373632 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 373635 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373639 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373658 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373661 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 373664 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 373685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 373693 */     GIR_RootConstrainSelectedInstOperands,
     /* 373694 */     // GIR_Coverage, 7000,
     /* 373694 */     GIR_EraseRootFromParent_Done,
     /* 373695 */   // Label 7499: @373695
     /* 373695 */   GIM_Reject,
     /* 373696 */ // Label 7497: @373696
     /* 373696 */ GIM_Reject,
     /* 373697 */ // Label 7489: @373697
     /* 373697 */ GIM_Reject,
     /* 373698 */ // Label 101: @373698
     /* 373698 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7508*/ GIMT_Encode4(374188),
     /* 373709 */ /*GILLT_s16*//*Label 7500*/ GIMT_Encode4(373749),
     /* 373713 */ /*GILLT_s32*//*Label 7501*/ GIMT_Encode4(373780),
     /* 373717 */ /*GILLT_s64*//*Label 7502*/ GIMT_Encode4(373811), GIMT_Encode4(0),
     /* 373725 */ /*GILLT_v2s32*//*Label 7503*/ GIMT_Encode4(373842),
     /* 373729 */ /*GILLT_v2s64*//*Label 7504*/ GIMT_Encode4(373873),
     /* 373733 */ /*GILLT_v4s16*//*Label 7505*/ GIMT_Encode4(373904),
     /* 373737 */ /*GILLT_v4s32*//*Label 7506*/ GIMT_Encode4(373935), GIMT_Encode4(0),
     /* 373745 */ /*GILLT_v8s16*//*Label 7507*/ GIMT_Encode4(373966),
     /* 373749 */ // Label 7500: @373749
     /* 373749 */ GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(373779), // Rule ID 558 //
     /* 373754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 373760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373768 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 373768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 373773 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373777 */   GIR_RootConstrainSelectedInstOperands,
     /* 373778 */   // GIR_Coverage, 558,
     /* 373778 */   GIR_Done,
     /* 373779 */ // Label 7509: @373779
     /* 373779 */ GIM_Reject,
     /* 373780 */ // Label 7501: @373780
     /* 373780 */ GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(373810), // Rule ID 560 //
     /* 373785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 373791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373799 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 373799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 373804 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373808 */   GIR_RootConstrainSelectedInstOperands,
     /* 373809 */   // GIR_Coverage, 560,
     /* 373809 */   GIR_Done,
     /* 373810 */ // Label 7510: @373810
     /* 373810 */ GIM_Reject,
     /* 373811 */ // Label 7502: @373811
     /* 373811 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(373841), // Rule ID 562 //
     /* 373816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373830 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 373830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 373835 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373839 */   GIR_RootConstrainSelectedInstOperands,
     /* 373840 */   // GIR_Coverage, 562,
     /* 373840 */   GIR_Done,
     /* 373841 */ // Label 7511: @373841
     /* 373841 */ GIM_Reject,
     /* 373842 */ // Label 7503: @373842
     /* 373842 */ GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(373872), // Rule ID 923 //
     /* 373847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373861 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 373861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 373866 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373870 */   GIR_RootConstrainSelectedInstOperands,
     /* 373871 */   // GIR_Coverage, 923,
     /* 373871 */   GIR_Done,
     /* 373872 */ // Label 7512: @373872
     /* 373872 */ GIM_Reject,
     /* 373873 */ // Label 7504: @373873
     /* 373873 */ GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(373903), // Rule ID 927 //
     /* 373878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373892 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 373892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 373897 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373901 */   GIR_RootConstrainSelectedInstOperands,
     /* 373902 */   // GIR_Coverage, 927,
     /* 373902 */   GIR_Done,
     /* 373903 */ // Label 7513: @373903
     /* 373903 */ GIM_Reject,
     /* 373904 */ // Label 7505: @373904
     /* 373904 */ GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(373934), // Rule ID 919 //
     /* 373909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373923 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 373923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 373928 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373932 */   GIR_RootConstrainSelectedInstOperands,
     /* 373933 */   // GIR_Coverage, 919,
     /* 373933 */   GIR_Done,
     /* 373934 */ // Label 7514: @373934
     /* 373934 */ GIM_Reject,
     /* 373935 */ // Label 7506: @373935
     /* 373935 */ GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(373965), // Rule ID 925 //
     /* 373940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373954 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 373954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 373959 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373963 */   GIR_RootConstrainSelectedInstOperands,
     /* 373964 */   // GIR_Coverage, 925,
     /* 373964 */   GIR_Done,
     /* 373965 */ // Label 7515: @373965
     /* 373965 */ GIM_Reject,
     /* 373966 */ // Label 7507: @373966
     /* 373966 */ GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(374187),
     /* 373971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373982 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(374001), // Rule ID 921 //
     /* 373987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373990 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 373990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 373995 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373999 */     GIR_RootConstrainSelectedInstOperands,
     /* 374000 */     // GIR_Coverage, 921,
     /* 374000 */     GIR_Done,
     /* 374001 */   // Label 7517: @374001
     /* 374001 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(374186), // Rule ID 7008 //
     /* 374006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 374009 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 374009 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 374012 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374016 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374021 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 374025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 374027 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 374030 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 374034 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374039 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 374042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 374044 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 374047 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374051 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374056 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374062 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374067 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374072 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 374075 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374079 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374084 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 374087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 374089 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 374092 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 374096 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374101 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 374104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 374106 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 374109 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 374113 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374118 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 374121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 374123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 374126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374152 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 374155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 374176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 374184 */     GIR_RootConstrainSelectedInstOperands,
     /* 374185 */     // GIR_Coverage, 7008,
     /* 374185 */     GIR_EraseRootFromParent_Done,
     /* 374186 */   // Label 7518: @374186
     /* 374186 */   GIM_Reject,
     /* 374187 */ // Label 7516: @374187
     /* 374187 */ GIM_Reject,
     /* 374188 */ // Label 7508: @374188
     /* 374188 */ GIM_Reject,
     /* 374189 */ // Label 102: @374189
     /* 374189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7527*/ GIMT_Encode4(374679),
     /* 374200 */ /*GILLT_s16*//*Label 7519*/ GIMT_Encode4(374240),
     /* 374204 */ /*GILLT_s32*//*Label 7520*/ GIMT_Encode4(374271),
     /* 374208 */ /*GILLT_s64*//*Label 7521*/ GIMT_Encode4(374302), GIMT_Encode4(0),
     /* 374216 */ /*GILLT_v2s32*//*Label 7522*/ GIMT_Encode4(374333),
     /* 374220 */ /*GILLT_v2s64*//*Label 7523*/ GIMT_Encode4(374364),
     /* 374224 */ /*GILLT_v4s16*//*Label 7524*/ GIMT_Encode4(374395),
     /* 374228 */ /*GILLT_v4s32*//*Label 7525*/ GIMT_Encode4(374426), GIMT_Encode4(0),
     /* 374236 */ /*GILLT_v8s16*//*Label 7526*/ GIMT_Encode4(374457),
     /* 374240 */ // Label 7519: @374240
     /* 374240 */ GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(374270), // Rule ID 534 //
     /* 374245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 374251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374259 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 374259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 374264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374268 */   GIR_RootConstrainSelectedInstOperands,
     /* 374269 */   // GIR_Coverage, 534,
     /* 374269 */   GIR_Done,
     /* 374270 */ // Label 7528: @374270
     /* 374270 */ GIM_Reject,
     /* 374271 */ // Label 7520: @374271
     /* 374271 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(374301), // Rule ID 536 //
     /* 374276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 374282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374290 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 374290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 374295 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374299 */   GIR_RootConstrainSelectedInstOperands,
     /* 374300 */   // GIR_Coverage, 536,
     /* 374300 */   GIR_Done,
     /* 374301 */ // Label 7529: @374301
     /* 374301 */ GIM_Reject,
     /* 374302 */ // Label 7521: @374302
     /* 374302 */ GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(374332), // Rule ID 538 //
     /* 374307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 374313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374321 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 374321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 374326 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374330 */   GIR_RootConstrainSelectedInstOperands,
     /* 374331 */   // GIR_Coverage, 538,
     /* 374331 */   GIR_Done,
     /* 374332 */ // Label 7530: @374332
     /* 374332 */ GIM_Reject,
     /* 374333 */ // Label 7522: @374333
     /* 374333 */ GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(374363), // Rule ID 883 //
     /* 374338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374352 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 374352 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 374357 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374361 */   GIR_RootConstrainSelectedInstOperands,
     /* 374362 */   // GIR_Coverage, 883,
     /* 374362 */   GIR_Done,
     /* 374363 */ // Label 7531: @374363
     /* 374363 */ GIM_Reject,
     /* 374364 */ // Label 7523: @374364
     /* 374364 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(374394), // Rule ID 887 //
     /* 374369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374383 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 374383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 374388 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374392 */   GIR_RootConstrainSelectedInstOperands,
     /* 374393 */   // GIR_Coverage, 887,
     /* 374393 */   GIR_Done,
     /* 374394 */ // Label 7532: @374394
     /* 374394 */ GIM_Reject,
     /* 374395 */ // Label 7524: @374395
     /* 374395 */ GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(374425), // Rule ID 879 //
     /* 374400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 374406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374414 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 374414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 374419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374423 */   GIR_RootConstrainSelectedInstOperands,
     /* 374424 */   // GIR_Coverage, 879,
     /* 374424 */   GIR_Done,
     /* 374425 */ // Label 7533: @374425
     /* 374425 */ GIM_Reject,
     /* 374426 */ // Label 7525: @374426
     /* 374426 */ GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(374456), // Rule ID 885 //
     /* 374431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374445 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 374445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 374450 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374454 */   GIR_RootConstrainSelectedInstOperands,
     /* 374455 */   // GIR_Coverage, 885,
     /* 374455 */   GIR_Done,
     /* 374456 */ // Label 7534: @374456
     /* 374456 */ GIM_Reject,
     /* 374457 */ // Label 7526: @374457
     /* 374457 */ GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(374678),
     /* 374462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374473 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(374492), // Rule ID 881 //
     /* 374478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374481 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 374481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 374486 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374490 */     GIR_RootConstrainSelectedInstOperands,
     /* 374491 */     // GIR_Coverage, 881,
     /* 374491 */     GIR_Done,
     /* 374492 */   // Label 7536: @374492
     /* 374492 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(374677), // Rule ID 7002 //
     /* 374497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 374500 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 374500 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 374503 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374507 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374512 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 374516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 374518 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 374521 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 374525 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374530 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 374533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 374535 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 374538 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374542 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374547 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374553 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374558 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374563 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 374566 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374570 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374575 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 374578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 374580 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 374583 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 374587 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374592 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 374595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 374597 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 374600 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 374604 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374609 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 374612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 374614 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 374617 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374621 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374640 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 374646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 374667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 374675 */     GIR_RootConstrainSelectedInstOperands,
     /* 374676 */     // GIR_Coverage, 7002,
     /* 374676 */     GIR_EraseRootFromParent_Done,
     /* 374677 */   // Label 7537: @374677
     /* 374677 */   GIM_Reject,
     /* 374678 */ // Label 7535: @374678
     /* 374678 */ GIM_Reject,
     /* 374679 */ // Label 7527: @374679
     /* 374679 */ GIM_Reject,
     /* 374680 */ // Label 103: @374680
     /* 374680 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7546*/ GIMT_Encode4(375805),
     /* 374691 */ /*GILLT_s16*//*Label 7538*/ GIMT_Encode4(374731),
     /* 374695 */ /*GILLT_s32*//*Label 7539*/ GIMT_Encode4(374957),
     /* 374699 */ /*GILLT_s64*//*Label 7540*/ GIMT_Encode4(375183), GIMT_Encode4(0),
     /* 374707 */ /*GILLT_v2s32*//*Label 7541*/ GIMT_Encode4(375355),
     /* 374711 */ /*GILLT_v2s64*//*Label 7542*/ GIMT_Encode4(375393),
     /* 374715 */ /*GILLT_v4s16*//*Label 7543*/ GIMT_Encode4(375431),
     /* 374719 */ /*GILLT_v4s32*//*Label 7544*/ GIMT_Encode4(375469), GIMT_Encode4(0),
     /* 374727 */ /*GILLT_v8s16*//*Label 7545*/ GIMT_Encode4(375507),
     /* 374731 */ // Label 7538: @374731
     /* 374731 */ GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(374956),
     /* 374736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 374739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374746 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(374837), // Rule ID 6922 //
     /* 374751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374788 */     // MIs[2] Rn
     /* 374788 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374793 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 374797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374799 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 374799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374811 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 374830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374835 */     GIR_RootConstrainSelectedInstOperands,
     /* 374836 */     // GIR_Coverage, 6922,
     /* 374836 */     GIR_EraseRootFromParent_Done,
     /* 374837 */   // Label 7548: @374837
     /* 374837 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(374928), // Rule ID 13957 //
     /* 374842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374863 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 374867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374879 */     // MIs[2] Rn
     /* 374879 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374884 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 374888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374890 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 374890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374902 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 374921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374926 */     GIR_RootConstrainSelectedInstOperands,
     /* 374927 */     // GIR_Coverage, 13957,
     /* 374927 */     GIR_EraseRootFromParent_Done,
     /* 374928 */   // Label 7549: @374928
     /* 374928 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(374955), // Rule ID 583 //
     /* 374933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374944 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 374944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 374949 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374953 */     GIR_RootConstrainSelectedInstOperands,
     /* 374954 */     // GIR_Coverage, 583,
     /* 374954 */     GIR_Done,
     /* 374955 */   // Label 7550: @374955
     /* 374955 */   GIM_Reject,
     /* 374956 */ // Label 7547: @374956
     /* 374956 */ GIM_Reject,
     /* 374957 */ // Label 7539: @374957
     /* 374957 */ GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(375182),
     /* 374962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 374965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374972 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(375063), // Rule ID 6920 //
     /* 374977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374998 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375014 */     // MIs[2] Rn
     /* 375014 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375019 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 375023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375025 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 375025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 375028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375037 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 375056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375061 */     GIR_RootConstrainSelectedInstOperands,
     /* 375062 */     // GIR_Coverage, 6920,
     /* 375062 */     GIR_EraseRootFromParent_Done,
     /* 375063 */   // Label 7552: @375063
     /* 375063 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(375154), // Rule ID 13955 //
     /* 375068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 375093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375105 */     // MIs[2] Rn
     /* 375105 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375110 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375116 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 375116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 375119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375128 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 375147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375152 */     GIR_RootConstrainSelectedInstOperands,
     /* 375153 */     // GIR_Coverage, 13955,
     /* 375153 */     GIR_EraseRootFromParent_Done,
     /* 375154 */   // Label 7553: @375154
     /* 375154 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(375181), // Rule ID 585 //
     /* 375159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375170 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 375170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 375175 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375179 */     GIR_RootConstrainSelectedInstOperands,
     /* 375180 */     // GIR_Coverage, 585,
     /* 375180 */     GIR_Done,
     /* 375181 */   // Label 7554: @375181
     /* 375181 */   GIM_Reject,
     /* 375182 */ // Label 7551: @375182
     /* 375182 */ GIM_Reject,
     /* 375183 */ // Label 7540: @375183
     /* 375183 */ GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(375354),
     /* 375188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 375191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 375194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375198 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(375262), // Rule ID 6918 //
     /* 375203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375224 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375240 */     // MIs[2] Rn
     /* 375240 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375245 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 375249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375251 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 375251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 375254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375260 */     GIR_RootConstrainSelectedInstOperands,
     /* 375261 */     // GIR_Coverage, 6918,
     /* 375261 */     GIR_EraseRootFromParent_Done,
     /* 375262 */   // Label 7556: @375262
     /* 375262 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(375326), // Rule ID 13953 //
     /* 375267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375288 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 375292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375304 */     // MIs[2] Rn
     /* 375304 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375309 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375315 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 375315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 375318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375324 */     GIR_RootConstrainSelectedInstOperands,
     /* 375325 */     // GIR_Coverage, 13953,
     /* 375325 */     GIR_EraseRootFromParent_Done,
     /* 375326 */   // Label 7557: @375326
     /* 375326 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(375353), // Rule ID 587 //
     /* 375331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375342 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 375342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 375347 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375351 */     GIR_RootConstrainSelectedInstOperands,
     /* 375352 */     // GIR_Coverage, 587,
     /* 375352 */     GIR_Done,
     /* 375353 */   // Label 7558: @375353
     /* 375353 */   GIM_Reject,
     /* 375354 */ // Label 7555: @375354
     /* 375354 */ GIM_Reject,
     /* 375355 */ // Label 7541: @375355
     /* 375355 */ GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(375392), // Rule ID 1202 //
     /* 375360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 375366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 375369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375381 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 375381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 375386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375390 */   GIR_RootConstrainSelectedInstOperands,
     /* 375391 */   // GIR_Coverage, 1202,
     /* 375391 */   GIR_Done,
     /* 375392 */ // Label 7559: @375392
     /* 375392 */ GIM_Reject,
     /* 375393 */ // Label 7542: @375393
     /* 375393 */ GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(375430), // Rule ID 1206 //
     /* 375398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 375407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375419 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 375424 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375428 */   GIR_RootConstrainSelectedInstOperands,
     /* 375429 */   // GIR_Coverage, 1206,
     /* 375429 */   GIR_Done,
     /* 375430 */ // Label 7560: @375430
     /* 375430 */ GIM_Reject,
     /* 375431 */ // Label 7543: @375431
     /* 375431 */ GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(375468), // Rule ID 1198 //
     /* 375436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 375445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375457 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 375457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 375462 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375466 */   GIR_RootConstrainSelectedInstOperands,
     /* 375467 */   // GIR_Coverage, 1198,
     /* 375467 */   GIR_Done,
     /* 375468 */ // Label 7561: @375468
     /* 375468 */ GIM_Reject,
     /* 375469 */ // Label 7544: @375469
     /* 375469 */ GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(375506), // Rule ID 1204 //
     /* 375474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 375483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375495 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 375495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 375500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375504 */   GIR_RootConstrainSelectedInstOperands,
     /* 375505 */   // GIR_Coverage, 1204,
     /* 375505 */   GIR_Done,
     /* 375506 */ // Label 7562: @375506
     /* 375506 */ GIM_Reject,
     /* 375507 */ // Label 7545: @375507
     /* 375507 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(375804),
     /* 375512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 375518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375530 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(375549), // Rule ID 1200 //
     /* 375535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375538 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 375538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 375543 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375547 */     GIR_RootConstrainSelectedInstOperands,
     /* 375548 */     // GIR_Coverage, 1200,
     /* 375548 */     GIR_Done,
     /* 375549 */   // Label 7564: @375549
     /* 375549 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(375803), // Rule ID 7011 //
     /* 375554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 375557 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 375557 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 375560 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375564 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375569 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 375573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 375575 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 375578 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375582 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375587 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 375591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 375593 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 375596 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 375600 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375605 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 375608 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 375611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 375613 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 375616 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375620 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375625 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 375631 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375636 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375641 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 375644 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375648 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375653 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 375656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 375658 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 375661 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375665 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375670 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375676 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375681 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375686 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 375689 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375693 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375698 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 375701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 375703 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 375706 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 375710 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375715 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 375718 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 375721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 375723 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 375726 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 375730 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375735 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 375738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 375740 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 375743 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375747 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375766 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375769 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 375772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 375793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 375801 */     GIR_RootConstrainSelectedInstOperands,
     /* 375802 */     // GIR_Coverage, 7011,
     /* 375802 */     GIR_EraseRootFromParent_Done,
     /* 375803 */   // Label 7565: @375803
     /* 375803 */   GIM_Reject,
     /* 375804 */ // Label 7563: @375804
     /* 375804 */ GIM_Reject,
     /* 375805 */ // Label 7546: @375805
     /* 375805 */ GIM_Reject,
     /* 375806 */ // Label 104: @375806
     /* 375806 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7574*/ GIMT_Encode4(376421),
     /* 375817 */ /*GILLT_s16*//*Label 7566*/ GIMT_Encode4(375857),
     /* 375821 */ /*GILLT_s32*//*Label 7567*/ GIMT_Encode4(375895),
     /* 375825 */ /*GILLT_s64*//*Label 7568*/ GIMT_Encode4(375933), GIMT_Encode4(0),
     /* 375833 */ /*GILLT_v2s32*//*Label 7569*/ GIMT_Encode4(375971),
     /* 375837 */ /*GILLT_v2s64*//*Label 7570*/ GIMT_Encode4(376009),
     /* 375841 */ /*GILLT_v4s16*//*Label 7571*/ GIMT_Encode4(376047),
     /* 375845 */ /*GILLT_v4s32*//*Label 7572*/ GIMT_Encode4(376085), GIMT_Encode4(0),
     /* 375853 */ /*GILLT_v8s16*//*Label 7573*/ GIMT_Encode4(376123),
     /* 375857 */ // Label 7566: @375857
     /* 375857 */ GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(375894), // Rule ID 631 //
     /* 375862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 375868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375883 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 375883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 375888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375892 */   GIR_RootConstrainSelectedInstOperands,
     /* 375893 */   // GIR_Coverage, 631,
     /* 375893 */   GIR_Done,
     /* 375894 */ // Label 7575: @375894
     /* 375894 */ GIM_Reject,
     /* 375895 */ // Label 7567: @375895
     /* 375895 */ GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(375932), // Rule ID 633 //
     /* 375900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 375906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375921 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 375921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 375926 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375930 */   GIR_RootConstrainSelectedInstOperands,
     /* 375931 */   // GIR_Coverage, 633,
     /* 375931 */   GIR_Done,
     /* 375932 */ // Label 7576: @375932
     /* 375932 */ GIM_Reject,
     /* 375933 */ // Label 7568: @375933
     /* 375933 */ GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(375970), // Rule ID 635 //
     /* 375938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 375944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 375947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375959 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 375959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 375964 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375968 */   GIR_RootConstrainSelectedInstOperands,
     /* 375969 */   // GIR_Coverage, 635,
     /* 375969 */   GIR_Done,
     /* 375970 */ // Label 7577: @375970
     /* 375970 */ GIM_Reject,
     /* 375971 */ // Label 7569: @375971
     /* 375971 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(376008), // Rule ID 1342 //
     /* 375976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 375982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 375985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375997 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 375997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 376002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376006 */   GIR_RootConstrainSelectedInstOperands,
     /* 376007 */   // GIR_Coverage, 1342,
     /* 376007 */   GIR_Done,
     /* 376008 */ // Label 7578: @376008
     /* 376008 */ GIM_Reject,
     /* 376009 */ // Label 7570: @376009
     /* 376009 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(376046), // Rule ID 1346 //
     /* 376014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 376023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376035 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 376035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 376040 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376044 */   GIR_RootConstrainSelectedInstOperands,
     /* 376045 */   // GIR_Coverage, 1346,
     /* 376045 */   GIR_Done,
     /* 376046 */ // Label 7579: @376046
     /* 376046 */ GIM_Reject,
     /* 376047 */ // Label 7571: @376047
     /* 376047 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(376084), // Rule ID 1338 //
     /* 376052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 376061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376073 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 376073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 376078 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376082 */   GIR_RootConstrainSelectedInstOperands,
     /* 376083 */   // GIR_Coverage, 1338,
     /* 376083 */   GIR_Done,
     /* 376084 */ // Label 7580: @376084
     /* 376084 */ GIM_Reject,
     /* 376085 */ // Label 7572: @376085
     /* 376085 */ GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(376122), // Rule ID 1344 //
     /* 376090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 376099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376111 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 376111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 376116 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376120 */   GIR_RootConstrainSelectedInstOperands,
     /* 376121 */   // GIR_Coverage, 1344,
     /* 376121 */   GIR_Done,
     /* 376122 */ // Label 7581: @376122
     /* 376122 */ GIM_Reject,
     /* 376123 */ // Label 7573: @376123
     /* 376123 */ GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(376420),
     /* 376128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 376134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376146 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(376165), // Rule ID 1340 //
     /* 376151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376154 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 376154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 376159 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376163 */     GIR_RootConstrainSelectedInstOperands,
     /* 376164 */     // GIR_Coverage, 1340,
     /* 376164 */     GIR_Done,
     /* 376165 */   // Label 7583: @376165
     /* 376165 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(376419), // Rule ID 7017 //
     /* 376170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 376173 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 376173 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 376176 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376180 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376185 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 376191 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 376194 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376198 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376203 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 376207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 376209 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 376212 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 376216 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376221 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 376224 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 376227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 376229 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 376232 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376236 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376241 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 376247 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376252 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376257 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 376260 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376264 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376269 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 376272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 376274 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 376277 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376281 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376286 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 376292 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376297 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376302 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 376305 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376309 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376314 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 376317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 376319 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 376322 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 376326 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376331 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 376334 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 376337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376339 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 376342 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 376346 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376351 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 376354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 376359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376382 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376385 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 376409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 376417 */     GIR_RootConstrainSelectedInstOperands,
     /* 376418 */     // GIR_Coverage, 7017,
     /* 376418 */     GIR_EraseRootFromParent_Done,
     /* 376419 */   // Label 7584: @376419
     /* 376419 */   GIM_Reject,
     /* 376420 */ // Label 7582: @376420
     /* 376420 */ GIM_Reject,
     /* 376421 */ // Label 7574: @376421
     /* 376421 */ GIM_Reject,
     /* 376422 */ // Label 105: @376422
     /* 376422 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7593*/ GIMT_Encode4(380143),
     /* 376433 */ /*GILLT_s16*//*Label 7585*/ GIMT_Encode4(376473),
     /* 376437 */ /*GILLT_s32*//*Label 7586*/ GIMT_Encode4(377027),
     /* 376441 */ /*GILLT_s64*//*Label 7587*/ GIMT_Encode4(377575), GIMT_Encode4(0),
     /* 376449 */ /*GILLT_v2s32*//*Label 7588*/ GIMT_Encode4(378123),
     /* 376453 */ /*GILLT_v2s64*//*Label 7589*/ GIMT_Encode4(378653),
     /* 376457 */ /*GILLT_v4s16*//*Label 7590*/ GIMT_Encode4(379011),
     /* 376461 */ /*GILLT_v4s32*//*Label 7591*/ GIMT_Encode4(379353), GIMT_Encode4(0),
     /* 376469 */ /*GILLT_v8s16*//*Label 7592*/ GIMT_Encode4(379711),
     /* 376473 */ // Label 7585: @376473
     /* 376473 */ GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(377026),
     /* 376478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 376481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376488 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(376601), // Rule ID 6252 //
     /* 376493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376517 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376550 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376554 */     // MIs[3] Operand 1
     /* 376554 */     // No operand predicates
     /* 376554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376556 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376568 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 376587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376599 */     GIR_RootConstrainSelectedInstOperands,
     /* 376600 */     // GIR_Coverage, 6252,
     /* 376600 */     GIR_EraseRootFromParent_Done,
     /* 376601 */   // Label 7595: @376601
     /* 376601 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(376714), // Rule ID 13934 //
     /* 376606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376638 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376642 */     // MIs[2] Operand 1
     /* 376642 */     // No operand predicates
     /* 376642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376650 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376654 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376658 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376663 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376669 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376681 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 376700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376712 */     GIR_RootConstrainSelectedInstOperands,
     /* 376713 */     // GIR_Coverage, 13934,
     /* 376713 */     GIR_EraseRootFromParent_Done,
     /* 376714 */   // Label 7596: @376714
     /* 376714 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(376793), // Rule ID 13868 //
     /* 376719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376743 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376753 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 376753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376765 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 376784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376791 */     GIR_RootConstrainSelectedInstOperands,
     /* 376792 */     // GIR_Coverage, 13868,
     /* 376792 */     GIR_EraseRootFromParent_Done,
     /* 376793 */   // Label 7597: @376793
     /* 376793 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(376872), // Rule ID 4802 //
     /* 376798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376826 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376832 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 376832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376844 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 376863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376870 */     GIR_RootConstrainSelectedInstOperands,
     /* 376871 */     // GIR_Coverage, 4802,
     /* 376871 */     GIR_EraseRootFromParent_Done,
     /* 376872 */   // Label 7598: @376872
     /* 376872 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(376935), // Rule ID 13483 //
     /* 376877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376909 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376913 */     // MIs[2] Operand 1
     /* 376913 */     // No operand predicates
     /* 376913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376919 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 376922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376933 */     GIR_RootConstrainSelectedInstOperands,
     /* 376934 */     // GIR_Coverage, 13483,
     /* 376934 */     GIR_EraseRootFromParent_Done,
     /* 376935 */   // Label 7599: @376935
     /* 376935 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(376998), // Rule ID 2011 //
     /* 376940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376980 */     // MIs[2] Operand 1
     /* 376980 */     // No operand predicates
     /* 376980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376982 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 376985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376996 */     GIR_RootConstrainSelectedInstOperands,
     /* 376997 */     // GIR_Coverage, 2011,
     /* 376997 */     GIR_EraseRootFromParent_Done,
     /* 376998 */   // Label 7600: @376998
     /* 376998 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(377025), // Rule ID 619 //
     /* 377003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377014 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 377014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 377019 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 377023 */     GIR_RootConstrainSelectedInstOperands,
     /* 377024 */     // GIR_Coverage, 619,
     /* 377024 */     GIR_Done,
     /* 377025 */   // Label 7601: @377025
     /* 377025 */   GIM_Reject,
     /* 377026 */ // Label 7594: @377026
     /* 377026 */ GIM_Reject,
     /* 377027 */ // Label 7586: @377027
     /* 377027 */ GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(377574),
     /* 377032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 377035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377042 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(377155), // Rule ID 6254 //
     /* 377047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377071 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377104 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377108 */     // MIs[3] Operand 1
     /* 377108 */     // No operand predicates
     /* 377108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377110 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377122 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 377128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 377141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377153 */     GIR_RootConstrainSelectedInstOperands,
     /* 377154 */     // GIR_Coverage, 6254,
     /* 377154 */     GIR_EraseRootFromParent_Done,
     /* 377155 */   // Label 7603: @377155
     /* 377155 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(377268), // Rule ID 13936 //
     /* 377160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377196 */     // MIs[2] Operand 1
     /* 377196 */     // No operand predicates
     /* 377196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377208 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377212 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377217 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377223 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 377241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 377254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377266 */     GIR_RootConstrainSelectedInstOperands,
     /* 377267 */     // GIR_Coverage, 13936,
     /* 377267 */     GIR_EraseRootFromParent_Done,
     /* 377268 */   // Label 7604: @377268
     /* 377268 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(377344), // Rule ID 13870 //
     /* 377273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377294 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377304 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 377304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377316 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 377322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 377335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377342 */     GIR_RootConstrainSelectedInstOperands,
     /* 377343 */     // GIR_Coverage, 13870,
     /* 377343 */     GIR_EraseRootFromParent_Done,
     /* 377344 */   // Label 7605: @377344
     /* 377344 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(377420), // Rule ID 4804 //
     /* 377349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377380 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 377380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377392 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 377398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 377411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377418 */     GIR_RootConstrainSelectedInstOperands,
     /* 377419 */     // GIR_Coverage, 4804,
     /* 377419 */     GIR_EraseRootFromParent_Done,
     /* 377420 */   // Label 7606: @377420
     /* 377420 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(377483), // Rule ID 13485 //
     /* 377425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377457 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377461 */     // MIs[2] Operand 1
     /* 377461 */     // No operand predicates
     /* 377461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377467 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 377470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377481 */     GIR_RootConstrainSelectedInstOperands,
     /* 377482 */     // GIR_Coverage, 13485,
     /* 377482 */     GIR_EraseRootFromParent_Done,
     /* 377483 */   // Label 7607: @377483
     /* 377483 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(377546), // Rule ID 2013 //
     /* 377488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377524 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377528 */     // MIs[2] Operand 1
     /* 377528 */     // No operand predicates
     /* 377528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377530 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 377533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377544 */     GIR_RootConstrainSelectedInstOperands,
     /* 377545 */     // GIR_Coverage, 2013,
     /* 377545 */     GIR_EraseRootFromParent_Done,
     /* 377546 */   // Label 7608: @377546
     /* 377546 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(377573), // Rule ID 621 //
     /* 377551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 377554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377562 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 377562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 377567 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 377571 */     GIR_RootConstrainSelectedInstOperands,
     /* 377572 */     // GIR_Coverage, 621,
     /* 377572 */     GIR_Done,
     /* 377573 */   // Label 7609: @377573
     /* 377573 */   GIM_Reject,
     /* 377574 */ // Label 7602: @377574
     /* 377574 */ GIM_Reject,
     /* 377575 */ // Label 7587: @377575
     /* 377575 */ GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(378122),
     /* 377580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 377583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 377586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377590 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(377703), // Rule ID 6256 //
     /* 377595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377619 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377652 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377656 */     // MIs[3] Operand 1
     /* 377656 */     // No operand predicates
     /* 377656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377658 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 377658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377670 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 377689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377701 */     GIR_RootConstrainSelectedInstOperands,
     /* 377702 */     // GIR_Coverage, 6256,
     /* 377702 */     GIR_EraseRootFromParent_Done,
     /* 377703 */   // Label 7611: @377703
     /* 377703 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(377816), // Rule ID 13938 //
     /* 377708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377740 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377744 */     // MIs[2] Operand 1
     /* 377744 */     // No operand predicates
     /* 377744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377760 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377765 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377771 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 377771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377783 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 377802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377814 */     GIR_RootConstrainSelectedInstOperands,
     /* 377815 */     // GIR_Coverage, 13938,
     /* 377815 */     GIR_EraseRootFromParent_Done,
     /* 377816 */   // Label 7612: @377816
     /* 377816 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(377892), // Rule ID 13872 //
     /* 377821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377842 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377852 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 377852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377864 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 377870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 377883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377890 */     GIR_RootConstrainSelectedInstOperands,
     /* 377891 */     // GIR_Coverage, 13872,
     /* 377891 */     GIR_EraseRootFromParent_Done,
     /* 377892 */   // Label 7613: @377892
     /* 377892 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(377968), // Rule ID 4806 //
     /* 377897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377922 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377928 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 377928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377940 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 377946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 377959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377966 */     GIR_RootConstrainSelectedInstOperands,
     /* 377967 */     // GIR_Coverage, 4806,
     /* 377967 */     GIR_EraseRootFromParent_Done,
     /* 377968 */   // Label 7614: @377968
     /* 377968 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(378031), // Rule ID 13487 //
     /* 377973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378009 */     // MIs[2] Operand 1
     /* 378009 */     // No operand predicates
     /* 378009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378015 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 378018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378029 */     GIR_RootConstrainSelectedInstOperands,
     /* 378030 */     // GIR_Coverage, 13487,
     /* 378030 */     GIR_EraseRootFromParent_Done,
     /* 378031 */   // Label 7615: @378031
     /* 378031 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(378094), // Rule ID 2015 //
     /* 378036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378076 */     // MIs[2] Operand 1
     /* 378076 */     // No operand predicates
     /* 378076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378078 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 378081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378092 */     GIR_RootConstrainSelectedInstOperands,
     /* 378093 */     // GIR_Coverage, 2015,
     /* 378093 */     GIR_EraseRootFromParent_Done,
     /* 378094 */   // Label 7616: @378094
     /* 378094 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(378121), // Rule ID 623 //
     /* 378099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378110 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 378110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 378115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378119 */     GIR_RootConstrainSelectedInstOperands,
     /* 378120 */     // GIR_Coverage, 623,
     /* 378120 */     GIR_Done,
     /* 378121 */   // Label 7617: @378121
     /* 378121 */   GIM_Reject,
     /* 378122 */ // Label 7610: @378122
     /* 378122 */ GIM_Reject,
     /* 378123 */ // Label 7588: @378123
     /* 378123 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(378652),
     /* 378128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 378131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 378134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378138 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(378224), // Rule ID 13475 //
     /* 378143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 378154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378187 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378191 */     // MIs[3] Operand 1
     /* 378191 */     // No operand predicates
     /* 378191 */     // MIs[1] Operand 2
     /* 378191 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 378202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378208 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378222 */     GIR_RootConstrainSelectedInstOperands,
     /* 378223 */     // GIR_Coverage, 13475,
     /* 378223 */     GIR_EraseRootFromParent_Done,
     /* 378224 */   // Label 7619: @378224
     /* 378224 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(378310), // Rule ID 2003 //
     /* 378229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 378244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378277 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378281 */     // MIs[3] Operand 1
     /* 378281 */     // No operand predicates
     /* 378281 */     // MIs[1] Operand 2
     /* 378281 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 378292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378294 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378308 */     GIR_RootConstrainSelectedInstOperands,
     /* 378309 */     // GIR_Coverage, 2003,
     /* 378309 */     GIR_EraseRootFromParent_Done,
     /* 378310 */   // Label 7620: @378310
     /* 378310 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(378373), // Rule ID 13476 //
     /* 378315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378351 */     // MIs[2] Operand 1
     /* 378351 */     // No operand predicates
     /* 378351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378357 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378371 */     GIR_RootConstrainSelectedInstOperands,
     /* 378372 */     // GIR_Coverage, 13476,
     /* 378372 */     GIR_EraseRootFromParent_Done,
     /* 378373 */   // Label 7621: @378373
     /* 378373 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(378436), // Rule ID 2004 //
     /* 378378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378414 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378418 */     // MIs[2] Operand 1
     /* 378418 */     // No operand predicates
     /* 378418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378420 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378434 */     GIR_RootConstrainSelectedInstOperands,
     /* 378435 */     // GIR_Coverage, 2004,
     /* 378435 */     GIR_EraseRootFromParent_Done,
     /* 378436 */   // Label 7622: @378436
     /* 378436 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(378530), // Rule ID 13940 //
     /* 378441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378464 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378464 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378467 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378471 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378497 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378528 */     GIR_RootConstrainSelectedInstOperands,
     /* 378529 */     // GIR_Coverage, 13940,
     /* 378529 */     GIR_EraseRootFromParent_Done,
     /* 378530 */   // Label 7623: @378530
     /* 378530 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(378624), // Rule ID 6258 //
     /* 378535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378558 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378558 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378561 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378565 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 378612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378622 */     GIR_RootConstrainSelectedInstOperands,
     /* 378623 */     // GIR_Coverage, 6258,
     /* 378623 */     GIR_EraseRootFromParent_Done,
     /* 378624 */   // Label 7624: @378624
     /* 378624 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(378651), // Rule ID 1322 //
     /* 378629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378640 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 378640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 378645 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378649 */     GIR_RootConstrainSelectedInstOperands,
     /* 378650 */     // GIR_Coverage, 1322,
     /* 378650 */     GIR_Done,
     /* 378651 */   // Label 7625: @378651
     /* 378651 */   GIM_Reject,
     /* 378652 */ // Label 7618: @378652
     /* 378652 */ GIM_Reject,
     /* 378653 */ // Label 7589: @378653
     /* 378653 */ GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(379010),
     /* 378658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 378664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378668 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(378731), // Rule ID 13481 //
     /* 378673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 378684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378705 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378709 */     // MIs[2] Operand 1
     /* 378709 */     // No operand predicates
     /* 378709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378715 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 378718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378729 */     GIR_RootConstrainSelectedInstOperands,
     /* 378730 */     // GIR_Coverage, 13481,
     /* 378730 */     GIR_EraseRootFromParent_Done,
     /* 378731 */   // Label 7627: @378731
     /* 378731 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(378794), // Rule ID 2009 //
     /* 378736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 378751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378772 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378776 */     // MIs[2] Operand 1
     /* 378776 */     // No operand predicates
     /* 378776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378778 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 378781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378792 */     GIR_RootConstrainSelectedInstOperands,
     /* 378793 */     // GIR_Coverage, 2009,
     /* 378793 */     GIR_EraseRootFromParent_Done,
     /* 378794 */   // Label 7628: @378794
     /* 378794 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(378888), // Rule ID 13944 //
     /* 378799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378822 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378848 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378855 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 378876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378886 */     GIR_RootConstrainSelectedInstOperands,
     /* 378887 */     // GIR_Coverage, 13944,
     /* 378887 */     GIR_EraseRootFromParent_Done,
     /* 378888 */   // Label 7629: @378888
     /* 378888 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(378982), // Rule ID 6262 //
     /* 378893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378916 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378919 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378923 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378942 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378949 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 378970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378980 */     GIR_RootConstrainSelectedInstOperands,
     /* 378981 */     // GIR_Coverage, 6262,
     /* 378981 */     GIR_EraseRootFromParent_Done,
     /* 378982 */   // Label 7630: @378982
     /* 378982 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(379009), // Rule ID 1326 //
     /* 378987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378998 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 378998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 379003 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379007 */     GIR_RootConstrainSelectedInstOperands,
     /* 379008 */     // GIR_Coverage, 1326,
     /* 379008 */     GIR_Done,
     /* 379009 */   // Label 7631: @379009
     /* 379009 */   GIM_Reject,
     /* 379010 */ // Label 7626: @379010
     /* 379010 */ GIM_Reject,
     /* 379011 */ // Label 7590: @379011
     /* 379011 */ GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(379352),
     /* 379016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 379022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379026 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(379112), // Rule ID 13469 //
     /* 379031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 379042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379075 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379079 */     // MIs[3] Operand 1
     /* 379079 */     // No operand predicates
     /* 379079 */     // MIs[1] Operand 2
     /* 379079 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 379090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379096 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 379099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379110 */     GIR_RootConstrainSelectedInstOperands,
     /* 379111 */     // GIR_Coverage, 13469,
     /* 379111 */     GIR_EraseRootFromParent_Done,
     /* 379112 */   // Label 7633: @379112
     /* 379112 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(379198), // Rule ID 1997 //
     /* 379117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 379132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379165 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379169 */     // MIs[3] Operand 1
     /* 379169 */     // No operand predicates
     /* 379169 */     // MIs[1] Operand 2
     /* 379169 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 379180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379182 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 379185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379196 */     GIR_RootConstrainSelectedInstOperands,
     /* 379197 */     // GIR_Coverage, 1997,
     /* 379197 */     GIR_EraseRootFromParent_Done,
     /* 379198 */   // Label 7634: @379198
     /* 379198 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(379261), // Rule ID 13470 //
     /* 379203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379239 */     // MIs[2] Operand 1
     /* 379239 */     // No operand predicates
     /* 379239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379245 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 379248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379259 */     GIR_RootConstrainSelectedInstOperands,
     /* 379260 */     // GIR_Coverage, 13470,
     /* 379260 */     GIR_EraseRootFromParent_Done,
     /* 379261 */   // Label 7635: @379261
     /* 379261 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(379324), // Rule ID 1998 //
     /* 379266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379302 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379306 */     // MIs[2] Operand 1
     /* 379306 */     // No operand predicates
     /* 379306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379308 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 379311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379322 */     GIR_RootConstrainSelectedInstOperands,
     /* 379323 */     // GIR_Coverage, 1998,
     /* 379323 */     GIR_EraseRootFromParent_Done,
     /* 379324 */   // Label 7636: @379324
     /* 379324 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(379351), // Rule ID 1318 //
     /* 379329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379340 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 379340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 379345 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379349 */     GIR_RootConstrainSelectedInstOperands,
     /* 379350 */     // GIR_Coverage, 1318,
     /* 379350 */     GIR_Done,
     /* 379351 */   // Label 7637: @379351
     /* 379351 */   GIM_Reject,
     /* 379352 */ // Label 7632: @379352
     /* 379352 */ GIM_Reject,
     /* 379353 */ // Label 7591: @379353
     /* 379353 */ GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(379710),
     /* 379358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 379364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379368 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(379431), // Rule ID 13479 //
     /* 379373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 379384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379405 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379409 */     // MIs[2] Operand 1
     /* 379409 */     // No operand predicates
     /* 379409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379415 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 379418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379429 */     GIR_RootConstrainSelectedInstOperands,
     /* 379430 */     // GIR_Coverage, 13479,
     /* 379430 */     GIR_EraseRootFromParent_Done,
     /* 379431 */   // Label 7639: @379431
     /* 379431 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(379494), // Rule ID 2007 //
     /* 379436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 379451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379472 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379476 */     // MIs[2] Operand 1
     /* 379476 */     // No operand predicates
     /* 379476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379478 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 379481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379492 */     GIR_RootConstrainSelectedInstOperands,
     /* 379493 */     // GIR_Coverage, 2007,
     /* 379493 */     GIR_EraseRootFromParent_Done,
     /* 379494 */   // Label 7640: @379494
     /* 379494 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(379588), // Rule ID 13942 //
     /* 379499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379522 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 379525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 379529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 379539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 379543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 379558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 379576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379586 */     GIR_RootConstrainSelectedInstOperands,
     /* 379587 */     // GIR_Coverage, 13942,
     /* 379587 */     GIR_EraseRootFromParent_Done,
     /* 379588 */   // Label 7641: @379588
     /* 379588 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(379682), // Rule ID 6260 //
     /* 379593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379616 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 379619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 379623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 379633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 379637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379649 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 379652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 379670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379680 */     GIR_RootConstrainSelectedInstOperands,
     /* 379681 */     // GIR_Coverage, 6260,
     /* 379681 */     GIR_EraseRootFromParent_Done,
     /* 379682 */   // Label 7642: @379682
     /* 379682 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(379709), // Rule ID 1324 //
     /* 379687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379698 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 379698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 379703 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379707 */     GIR_RootConstrainSelectedInstOperands,
     /* 379708 */     // GIR_Coverage, 1324,
     /* 379708 */     GIR_Done,
     /* 379709 */   // Label 7643: @379709
     /* 379709 */   GIM_Reject,
     /* 379710 */ // Label 7638: @379710
     /* 379710 */ GIM_Reject,
     /* 379711 */ // Label 7592: @379711
     /* 379711 */ GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(380142),
     /* 379716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 379722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379726 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(379789), // Rule ID 13473 //
     /* 379731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379767 */     // MIs[2] Operand 1
     /* 379767 */     // No operand predicates
     /* 379767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379773 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 379776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379787 */     GIR_RootConstrainSelectedInstOperands,
     /* 379788 */     // GIR_Coverage, 13473,
     /* 379788 */     GIR_EraseRootFromParent_Done,
     /* 379789 */   // Label 7645: @379789
     /* 379789 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(379852), // Rule ID 2001 //
     /* 379794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379830 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379834 */     // MIs[2] Operand 1
     /* 379834 */     // No operand predicates
     /* 379834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379836 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 379836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 379839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379850 */     GIR_RootConstrainSelectedInstOperands,
     /* 379851 */     // GIR_Coverage, 2001,
     /* 379851 */     GIR_EraseRootFromParent_Done,
     /* 379852 */   // Label 7646: @379852
     /* 379852 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(379879), // Rule ID 1320 //
     /* 379857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379868 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 379868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 379873 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379877 */     GIR_RootConstrainSelectedInstOperands,
     /* 379878 */     // GIR_Coverage, 1320,
     /* 379878 */     GIR_Done,
     /* 379879 */   // Label 7647: @379879
     /* 379879 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(380141), // Rule ID 7015 //
     /* 379884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 379887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379895 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 379895 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 379898 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 379902 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379907 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 379911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 379913 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 379916 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 379920 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379925 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 379929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 379931 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 379934 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 379938 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379943 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 379946 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 379949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 379951 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 379954 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379958 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379963 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 379969 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379974 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379979 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 379982 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 379986 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379991 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 379994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 379996 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 379999 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380003 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380008 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 380014 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380019 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380024 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 380027 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 380031 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380036 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 380039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 380041 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 380044 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 380048 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380053 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380056 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 380059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380061 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 380064 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 380068 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380073 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 380076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 380085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 380099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380104 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 380113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 380131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 380139 */     GIR_RootConstrainSelectedInstOperands,
     /* 380140 */     // GIR_Coverage, 7015,
     /* 380140 */     GIR_EraseRootFromParent_Done,
     /* 380141 */   // Label 7648: @380141
     /* 380141 */   GIM_Reject,
     /* 380142 */ // Label 7644: @380142
     /* 380142 */ GIM_Reject,
     /* 380143 */ // Label 7593: @380143
     /* 380143 */ GIM_Reject,
     /* 380144 */ // Label 106: @380144
     /* 380144 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7657*/ GIMT_Encode4(380759),
     /* 380155 */ /*GILLT_s16*//*Label 7649*/ GIMT_Encode4(380195),
     /* 380159 */ /*GILLT_s32*//*Label 7650*/ GIMT_Encode4(380233),
     /* 380163 */ /*GILLT_s64*//*Label 7651*/ GIMT_Encode4(380271), GIMT_Encode4(0),
     /* 380171 */ /*GILLT_v2s32*//*Label 7652*/ GIMT_Encode4(380309),
     /* 380175 */ /*GILLT_v2s64*//*Label 7653*/ GIMT_Encode4(380347),
     /* 380179 */ /*GILLT_v4s16*//*Label 7654*/ GIMT_Encode4(380385),
     /* 380183 */ /*GILLT_v4s32*//*Label 7655*/ GIMT_Encode4(380423), GIMT_Encode4(0),
     /* 380191 */ /*GILLT_v8s16*//*Label 7656*/ GIMT_Encode4(380461),
     /* 380195 */ // Label 7649: @380195
     /* 380195 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(380232), // Rule ID 589 //
     /* 380200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 380206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380221 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 380221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 380226 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380230 */   GIR_RootConstrainSelectedInstOperands,
     /* 380231 */   // GIR_Coverage, 589,
     /* 380231 */   GIR_Done,
     /* 380232 */ // Label 7658: @380232
     /* 380232 */ GIM_Reject,
     /* 380233 */ // Label 7650: @380233
     /* 380233 */ GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(380270), // Rule ID 591 //
     /* 380238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 380244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 380247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380259 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 380259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 380264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380268 */   GIR_RootConstrainSelectedInstOperands,
     /* 380269 */   // GIR_Coverage, 591,
     /* 380269 */   GIR_Done,
     /* 380270 */ // Label 7659: @380270
     /* 380270 */ GIM_Reject,
     /* 380271 */ // Label 7651: @380271
     /* 380271 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(380308), // Rule ID 593 //
     /* 380276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 380282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 380285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380297 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 380297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 380302 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380306 */   GIR_RootConstrainSelectedInstOperands,
     /* 380307 */   // GIR_Coverage, 593,
     /* 380307 */   GIR_Done,
     /* 380308 */ // Label 7660: @380308
     /* 380308 */ GIM_Reject,
     /* 380309 */ // Label 7652: @380309
     /* 380309 */ GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(380346), // Rule ID 1227 //
     /* 380314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 380323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380335 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 380335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 380340 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380344 */   GIR_RootConstrainSelectedInstOperands,
     /* 380345 */   // GIR_Coverage, 1227,
     /* 380345 */   GIR_Done,
     /* 380346 */ // Label 7661: @380346
     /* 380346 */ GIM_Reject,
     /* 380347 */ // Label 7653: @380347
     /* 380347 */ GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(380384), // Rule ID 1231 //
     /* 380352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 380361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380373 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 380373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 380378 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380382 */   GIR_RootConstrainSelectedInstOperands,
     /* 380383 */   // GIR_Coverage, 1231,
     /* 380383 */   GIR_Done,
     /* 380384 */ // Label 7662: @380384
     /* 380384 */ GIM_Reject,
     /* 380385 */ // Label 7654: @380385
     /* 380385 */ GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(380422), // Rule ID 1223 //
     /* 380390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 380399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380411 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 380411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 380416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380420 */   GIR_RootConstrainSelectedInstOperands,
     /* 380421 */   // GIR_Coverage, 1223,
     /* 380421 */   GIR_Done,
     /* 380422 */ // Label 7663: @380422
     /* 380422 */ GIM_Reject,
     /* 380423 */ // Label 7655: @380423
     /* 380423 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(380460), // Rule ID 1229 //
     /* 380428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 380437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380449 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 380449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 380454 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380458 */   GIR_RootConstrainSelectedInstOperands,
     /* 380459 */   // GIR_Coverage, 1229,
     /* 380459 */   GIR_Done,
     /* 380460 */ // Label 7664: @380460
     /* 380460 */ GIM_Reject,
     /* 380461 */ // Label 7656: @380461
     /* 380461 */ GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(380758),
     /* 380466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 380472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380484 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(380503), // Rule ID 1225 //
     /* 380489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380492 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 380492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 380497 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380501 */     GIR_RootConstrainSelectedInstOperands,
     /* 380502 */     // GIR_Coverage, 1225,
     /* 380502 */     GIR_Done,
     /* 380503 */   // Label 7666: @380503
     /* 380503 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(380757), // Rule ID 7013 //
     /* 380508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 380511 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 380511 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 380514 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 380518 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380523 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 380527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 380529 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 380532 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 380536 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380541 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 380547 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 380550 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 380554 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380559 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 380562 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 380565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 380567 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 380570 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380574 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380579 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 380585 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380590 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380595 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 380598 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 380602 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380607 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 380610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 380612 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 380615 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380619 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380624 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 380630 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380635 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380640 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 380643 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 380647 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380652 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 380655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 380657 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 380660 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 380664 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380669 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380672 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 380675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 380680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 380684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380689 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 380692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380694 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380697 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 380701 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 380715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380723 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380726 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 380729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 380747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 380755 */     GIR_RootConstrainSelectedInstOperands,
     /* 380756 */     // GIR_Coverage, 7013,
     /* 380756 */     GIR_EraseRootFromParent_Done,
     /* 380757 */   // Label 7667: @380757
     /* 380757 */   GIM_Reject,
     /* 380758 */ // Label 7665: @380758
     /* 380758 */ GIM_Reject,
     /* 380759 */ // Label 7657: @380759
     /* 380759 */ GIM_Reject,
     /* 380760 */ // Label 107: @380760
     /* 380760 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7676*/ GIMT_Encode4(396366),
     /* 380771 */ /*GILLT_s16*//*Label 7668*/ GIMT_Encode4(380811),
     /* 380775 */ /*GILLT_s32*//*Label 7669*/ GIMT_Encode4(383585),
     /* 380779 */ /*GILLT_s64*//*Label 7670*/ GIMT_Encode4(386515), GIMT_Encode4(0),
     /* 380787 */ /*GILLT_v2s32*//*Label 7671*/ GIMT_Encode4(389445),
     /* 380791 */ /*GILLT_v2s64*//*Label 7672*/ GIMT_Encode4(390966),
     /* 380795 */ /*GILLT_v4s16*//*Label 7673*/ GIMT_Encode4(392487),
     /* 380799 */ /*GILLT_v4s32*//*Label 7674*/ GIMT_Encode4(393666), GIMT_Encode4(0),
     /* 380807 */ /*GILLT_v8s16*//*Label 7675*/ GIMT_Encode4(395187),
     /* 380811 */ // Label 7668: @380811
     /* 380811 */ GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(383584),
     /* 380816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 380819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 380825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380829 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(380979), // Rule ID 4864 //
     /* 380834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380858 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380883 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 380891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 380899 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380906 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 380906 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 380909 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380913 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380918 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 380924 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380946 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 380965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 380973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 380977 */     GIR_RootConstrainSelectedInstOperands,
     /* 380978 */     // GIR_Coverage, 4864,
     /* 380978 */     GIR_EraseRootFromParent_Done,
     /* 380979 */   // Label 7678: @380979
     /* 380979 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(381126), // Rule ID 4828 //
     /* 380984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 381028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381036 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381040 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381045 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 381049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381055 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 381058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381067 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381095 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 381114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381124 */     GIR_RootConstrainSelectedInstOperands,
     /* 381125 */     // GIR_Coverage, 4828,
     /* 381125 */     GIR_EraseRootFromParent_Done,
     /* 381126 */   // Label 7679: @381126
     /* 381126 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(381273), // Rule ID 13881 //
     /* 381131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381167 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381192 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 381196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381202 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381202 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 381205 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381209 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381214 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381242 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 381261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381271 */     GIR_RootConstrainSelectedInstOperands,
     /* 381272 */     // GIR_Coverage, 13881,
     /* 381272 */     GIR_EraseRootFromParent_Done,
     /* 381273 */   // Label 7680: @381273
     /* 381273 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(381404), // Rule ID 6090 //
     /* 381278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381302 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 381322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381330 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381334 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 381343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381347 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381351 */     // MIs[4] Operand 1
     /* 381351 */     // No operand predicates
     /* 381351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381355 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381357 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 381399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 381402 */     GIR_RootConstrainSelectedInstOperands,
     /* 381403 */     // GIR_Coverage, 6090,
     /* 381403 */     GIR_EraseRootFromParent_Done,
     /* 381404 */   // Label 7681: @381404
     /* 381404 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(381535), // Rule ID 6122 //
     /* 381409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381441 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381445 */     // MIs[2] Operand 1
     /* 381445 */     // No operand predicates
     /* 381445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 381457 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 381461 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381465 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381469 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 381473 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381478 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 381482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381488 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381533 */     GIR_RootConstrainSelectedInstOperands,
     /* 381534 */     // GIR_Coverage, 6122,
     /* 381534 */     GIR_EraseRootFromParent_Done,
     /* 381535 */   // Label 7682: @381535
     /* 381535 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(381666), // Rule ID 6186 //
     /* 381540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381576 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381592 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381596 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381601 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 381605 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381609 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381613 */     // MIs[4] Operand 1
     /* 381613 */     // No operand predicates
     /* 381613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381617 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381619 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381631 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 381661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 381664 */     GIR_RootConstrainSelectedInstOperands,
     /* 381665 */     // GIR_Coverage, 6186,
     /* 381665 */     GIR_EraseRootFromParent_Done,
     /* 381666 */   // Label 7683: @381666
     /* 381666 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(381797), // Rule ID 6154 //
     /* 381671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381715 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381719 */     // MIs[3] Operand 1
     /* 381719 */     // No operand predicates
     /* 381719 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 381723 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381727 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381731 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 381735 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381740 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 381744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 381750 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381762 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381795 */     GIR_RootConstrainSelectedInstOperands,
     /* 381796 */     // GIR_Coverage, 6154,
     /* 381796 */     GIR_EraseRootFromParent_Done,
     /* 381797 */   // Label 7684: @381797
     /* 381797 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(381932), // Rule ID 2455 //
     /* 381802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381826 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381851 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381861 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381861 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 381864 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381868 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381873 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381879 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381901 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 381920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381930 */     GIR_RootConstrainSelectedInstOperands,
     /* 381931 */     // GIR_Coverage, 2455,
     /* 381931 */     GIR_EraseRootFromParent_Done,
     /* 381932 */   // Label 7685: @381932
     /* 381932 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(382051), // Rule ID 6058 //
     /* 381937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381961 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381994 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381998 */     // MIs[3] Operand 1
     /* 381998 */     // No operand predicates
     /* 381998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382004 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382016 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 382035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382049 */     GIR_RootConstrainSelectedInstOperands,
     /* 382050 */     // GIR_Coverage, 6058,
     /* 382050 */     GIR_EraseRootFromParent_Done,
     /* 382051 */   // Label 7686: @382051
     /* 382051 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(382170), // Rule ID 2537 //
     /* 382056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382092 */     // MIs[2] Operand 1
     /* 382092 */     // No operand predicates
     /* 382092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382104 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382108 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382113 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382123 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382135 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 382154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382168 */     GIR_RootConstrainSelectedInstOperands,
     /* 382169 */     // GIR_Coverage, 2537,
     /* 382169 */     GIR_EraseRootFromParent_Done,
     /* 382170 */   // Label 7687: @382170
     /* 382170 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(382270), // Rule ID 4826 //
     /* 382175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382226 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 382226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382238 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 382257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382268 */     GIR_RootConstrainSelectedInstOperands,
     /* 382269 */     // GIR_Coverage, 4826,
     /* 382269 */     GIR_EraseRootFromParent_Done,
     /* 382270 */   // Label 7688: @382270
     /* 382270 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(382370), // Rule ID 4862 //
     /* 382275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382299 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 382311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382326 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 382326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 382357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 382364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 382368 */     GIR_RootConstrainSelectedInstOperands,
     /* 382369 */     // GIR_Coverage, 4862,
     /* 382369 */     GIR_EraseRootFromParent_Done,
     /* 382370 */   // Label 7689: @382370
     /* 382370 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(382467), // Rule ID 13877 //
     /* 382375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382411 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382425 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 382425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382437 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 382443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 382456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382465 */     GIR_RootConstrainSelectedInstOperands,
     /* 382466 */     // GIR_Coverage, 13877,
     /* 382466 */     GIR_EraseRootFromParent_Done,
     /* 382467 */   // Label 7690: @382467
     /* 382467 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(382567), // Rule ID 13879 //
     /* 382472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382513 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382523 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 382523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382535 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 382541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 382554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382565 */     GIR_RootConstrainSelectedInstOperands,
     /* 382566 */     // GIR_Coverage, 13879,
     /* 382566 */     GIR_EraseRootFromParent_Done,
     /* 382567 */   // Label 7691: @382567
     /* 382567 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(382667), // Rule ID 4860 //
     /* 382572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382600 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 382608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382623 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 382623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382635 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 382641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 382654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 382665 */     GIR_RootConstrainSelectedInstOperands,
     /* 382666 */     // GIR_Coverage, 4860,
     /* 382666 */     GIR_EraseRootFromParent_Done,
     /* 382667 */   // Label 7692: @382667
     /* 382667 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(382764), // Rule ID 4824 //
     /* 382672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382712 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382722 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 382722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382734 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 382740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 382753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382762 */     GIR_RootConstrainSelectedInstOperands,
     /* 382763 */     // GIR_Coverage, 4824,
     /* 382763 */     GIR_EraseRootFromParent_Done,
     /* 382764 */   // Label 7693: @382764
     /* 382764 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(382848), // Rule ID 6120 //
     /* 382769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382805 */     // MIs[2] Operand 1
     /* 382805 */     // No operand predicates
     /* 382805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382813 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 382817 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382828 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 382831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 382839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382846 */     GIR_RootConstrainSelectedInstOperands,
     /* 382847 */     // GIR_Coverage, 6120,
     /* 382847 */     GIR_EraseRootFromParent_Done,
     /* 382848 */   // Label 7694: @382848
     /* 382848 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(382929), // Rule ID 6152 //
     /* 382853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382897 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382901 */     // MIs[3] Operand 1
     /* 382901 */     // No operand predicates
     /* 382901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382911 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 382914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382927 */     GIR_RootConstrainSelectedInstOperands,
     /* 382928 */     // GIR_Coverage, 6152,
     /* 382928 */     GIR_EraseRootFromParent_Done,
     /* 382929 */   // Label 7695: @382929
     /* 382929 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(383013), // Rule ID 6184 //
     /* 382934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382987 */     // MIs[3] Operand 1
     /* 382987 */     // No operand predicates
     /* 382987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382993 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 382996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383011 */     GIR_RootConstrainSelectedInstOperands,
     /* 383012 */     // GIR_Coverage, 6184,
     /* 383012 */     GIR_EraseRootFromParent_Done,
     /* 383013 */   // Label 7696: @383013
     /* 383013 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(383094), // Rule ID 6088 //
     /* 383018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383066 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383070 */     // MIs[3] Operand 1
     /* 383070 */     // No operand predicates
     /* 383070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383076 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 383079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383092 */     GIR_RootConstrainSelectedInstOperands,
     /* 383093 */     // GIR_Coverage, 6088,
     /* 383093 */     GIR_EraseRootFromParent_Done,
     /* 383094 */   // Label 7697: @383094
     /* 383094 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(383179), // Rule ID 2453 //
     /* 383099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383123 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383137 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383149 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 383155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 383168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 383175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383177 */     GIR_RootConstrainSelectedInstOperands,
     /* 383178 */     // GIR_Coverage, 2453,
     /* 383178 */     GIR_EraseRootFromParent_Done,
     /* 383179 */   // Label 7698: @383179
     /* 383179 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(383264), // Rule ID 2451 //
     /* 383184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383212 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383222 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 383222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 383240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 383253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383262 */     GIR_RootConstrainSelectedInstOperands,
     /* 383263 */     // GIR_Coverage, 2451,
     /* 383263 */     GIR_EraseRootFromParent_Done,
     /* 383264 */   // Label 7699: @383264
     /* 383264 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(383333), // Rule ID 2535 //
     /* 383269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383305 */     // MIs[2] Operand 1
     /* 383305 */     // No operand predicates
     /* 383305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383315 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 383318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383331 */     GIR_RootConstrainSelectedInstOperands,
     /* 383332 */     // GIR_Coverage, 2535,
     /* 383332 */     GIR_EraseRootFromParent_Done,
     /* 383333 */   // Label 7700: @383333
     /* 383333 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(383402), // Rule ID 6056 //
     /* 383338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383374 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383378 */     // MIs[2] Operand 1
     /* 383378 */     // No operand predicates
     /* 383378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383384 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 383387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383400 */     GIR_RootConstrainSelectedInstOperands,
     /* 383401 */     // GIR_Coverage, 6056,
     /* 383401 */     GIR_EraseRootFromParent_Done,
     /* 383402 */   // Label 7701: @383402
     /* 383402 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(383452), // Rule ID 13323 //
     /* 383407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383437 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 383440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383450 */     GIR_RootConstrainSelectedInstOperands,
     /* 383451 */     // GIR_Coverage, 13323,
     /* 383451 */     GIR_EraseRootFromParent_Done,
     /* 383452 */   // Label 7702: @383452
     /* 383452 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(383502), // Rule ID 643 //
     /* 383457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383487 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 383490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383500 */     GIR_RootConstrainSelectedInstOperands,
     /* 383501 */     // GIR_Coverage, 643,
     /* 383501 */     GIR_EraseRootFromParent_Done,
     /* 383502 */   // Label 7703: @383502
     /* 383502 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(383552), // Rule ID 655 //
     /* 383507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 383522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383537 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 383540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 383546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 383550 */     GIR_RootConstrainSelectedInstOperands,
     /* 383551 */     // GIR_Coverage, 655,
     /* 383551 */     GIR_EraseRootFromParent_Done,
     /* 383552 */   // Label 7704: @383552
     /* 383552 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(383583), // Rule ID 637 //
     /* 383557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383572 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 383572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 383577 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383581 */     GIR_RootConstrainSelectedInstOperands,
     /* 383582 */     // GIR_Coverage, 637,
     /* 383582 */     GIR_Done,
     /* 383583 */   // Label 7705: @383583
     /* 383583 */   GIM_Reject,
     /* 383584 */ // Label 7677: @383584
     /* 383584 */ GIM_Reject,
     /* 383585 */ // Label 7669: @383585
     /* 383585 */ GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(386514),
     /* 383590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 383593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 383599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383603 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(383753), // Rule ID 4870 //
     /* 383608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383657 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 383665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 383673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383680 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383680 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 383683 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383687 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383692 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 383739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 383747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 383751 */     GIR_RootConstrainSelectedInstOperands,
     /* 383752 */     // GIR_Coverage, 4870,
     /* 383752 */     GIR_EraseRootFromParent_Done,
     /* 383753 */   // Label 7707: @383753
     /* 383753 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(383900), // Rule ID 4834 //
     /* 383758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 383802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383810 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383814 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383819 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383829 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 383832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383841 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383869 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 383888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 383896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383898 */     GIR_RootConstrainSelectedInstOperands,
     /* 383899 */     // GIR_Coverage, 4834,
     /* 383899 */     GIR_EraseRootFromParent_Done,
     /* 383900 */   // Label 7708: @383900
     /* 383900 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(384047), // Rule ID 13887 //
     /* 383905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383941 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383953 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383957 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383961 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383966 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383976 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 383979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383988 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383994 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384016 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 384035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 384043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384045 */     GIR_RootConstrainSelectedInstOperands,
     /* 384046 */     // GIR_Coverage, 13887,
     /* 384046 */     GIR_EraseRootFromParent_Done,
     /* 384047 */   // Label 7709: @384047
     /* 384047 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(384178), // Rule ID 6106 //
     /* 384052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384076 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 384092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384104 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 384108 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384113 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 384117 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384121 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384125 */     // MIs[4] Operand 1
     /* 384125 */     // No operand predicates
     /* 384125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384129 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 384131 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384143 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 384173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 384176 */     GIR_RootConstrainSelectedInstOperands,
     /* 384177 */     // GIR_Coverage, 6106,
     /* 384177 */     GIR_EraseRootFromParent_Done,
     /* 384178 */   // Label 7710: @384178
     /* 384178 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(384309), // Rule ID 6138 //
     /* 384183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384215 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384219 */     // MIs[2] Operand 1
     /* 384219 */     // No operand predicates
     /* 384219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384227 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 384231 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 384235 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384239 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384243 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 384247 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384252 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 384256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384260 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 384262 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384274 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384307 */     GIR_RootConstrainSelectedInstOperands,
     /* 384308 */     // GIR_Coverage, 6138,
     /* 384308 */     GIR_EraseRootFromParent_Done,
     /* 384309 */   // Label 7711: @384309
     /* 384309 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(384440), // Rule ID 6202 //
     /* 384314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384350 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 384354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384362 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384366 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 384370 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384375 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 384379 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384383 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384387 */     // MIs[4] Operand 1
     /* 384387 */     // No operand predicates
     /* 384387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384391 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 384393 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384405 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 384435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 384438 */     GIR_RootConstrainSelectedInstOperands,
     /* 384439 */     // GIR_Coverage, 6202,
     /* 384439 */     GIR_EraseRootFromParent_Done,
     /* 384440 */   // Label 7712: @384440
     /* 384440 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(384571), // Rule ID 6170 //
     /* 384445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384493 */     // MIs[3] Operand 1
     /* 384493 */     // No operand predicates
     /* 384493 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 384497 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384501 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384505 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 384509 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384514 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 384518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384522 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 384524 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384569 */     GIR_RootConstrainSelectedInstOperands,
     /* 384570 */     // GIR_Coverage, 6170,
     /* 384570 */     GIR_EraseRootFromParent_Done,
     /* 384571 */   // Label 7713: @384571
     /* 384571 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(384706), // Rule ID 2461 //
     /* 384576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384600 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384625 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 384629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384635 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 384635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 384638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384647 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 384653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 384694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 384702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384704 */     GIR_RootConstrainSelectedInstOperands,
     /* 384705 */     // GIR_Coverage, 2461,
     /* 384705 */     GIR_EraseRootFromParent_Done,
     /* 384706 */   // Label 7714: @384706
     /* 384706 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(384825), // Rule ID 6074 //
     /* 384711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384735 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384768 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384772 */     // MIs[3] Operand 1
     /* 384772 */     // No operand predicates
     /* 384772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384778 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384790 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 384809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384823 */     GIR_RootConstrainSelectedInstOperands,
     /* 384824 */     // GIR_Coverage, 6074,
     /* 384824 */     GIR_EraseRootFromParent_Done,
     /* 384825 */   // Label 7715: @384825
     /* 384825 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(384944), // Rule ID 2553 //
     /* 384830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384866 */     // MIs[2] Operand 1
     /* 384866 */     // No operand predicates
     /* 384866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384878 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 384882 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384887 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 384891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384897 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384909 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 384928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384942 */     GIR_RootConstrainSelectedInstOperands,
     /* 384943 */     // GIR_Coverage, 2553,
     /* 384943 */     GIR_EraseRootFromParent_Done,
     /* 384944 */   // Label 7716: @384944
     /* 384944 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(385044), // Rule ID 4832 //
     /* 384949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384973 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 384989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385000 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 385000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385012 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 385018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 385031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385042 */     GIR_RootConstrainSelectedInstOperands,
     /* 385043 */     // GIR_Coverage, 4832,
     /* 385043 */     GIR_EraseRootFromParent_Done,
     /* 385044 */   // Label 7717: @385044
     /* 385044 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(385144), // Rule ID 4868 //
     /* 385049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385073 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 385085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385100 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 385100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385112 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 385118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 385131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 385138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 385142 */     GIR_RootConstrainSelectedInstOperands,
     /* 385143 */     // GIR_Coverage, 4868,
     /* 385143 */     GIR_EraseRootFromParent_Done,
     /* 385144 */   // Label 7718: @385144
     /* 385144 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(385241), // Rule ID 13883 //
     /* 385149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385185 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385199 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 385199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385211 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 385217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 385230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385239 */     GIR_RootConstrainSelectedInstOperands,
     /* 385240 */     // GIR_Coverage, 13883,
     /* 385240 */     GIR_EraseRootFromParent_Done,
     /* 385241 */   // Label 7719: @385241
     /* 385241 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(385341), // Rule ID 13885 //
     /* 385246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385287 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385297 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 385297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385309 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 385315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 385328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385339 */     GIR_RootConstrainSelectedInstOperands,
     /* 385340 */     // GIR_Coverage, 13885,
     /* 385340 */     GIR_EraseRootFromParent_Done,
     /* 385341 */   // Label 7720: @385341
     /* 385341 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(385441), // Rule ID 4866 //
     /* 385346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 385382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385397 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 385397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385409 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 385415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 385428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 385439 */     GIR_RootConstrainSelectedInstOperands,
     /* 385440 */     // GIR_Coverage, 4866,
     /* 385440 */     GIR_EraseRootFromParent_Done,
     /* 385441 */   // Label 7721: @385441
     /* 385441 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(385538), // Rule ID 4830 //
     /* 385446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385486 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385496 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 385496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 385499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385508 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 385514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 385527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385536 */     GIR_RootConstrainSelectedInstOperands,
     /* 385537 */     // GIR_Coverage, 4830,
     /* 385537 */     GIR_EraseRootFromParent_Done,
     /* 385538 */   // Label 7722: @385538
     /* 385538 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(385616), // Rule ID 6224 //
     /* 385543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385584 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385588 */     // MIs[3] Operand 1
     /* 385588 */     // No operand predicates
     /* 385588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385598 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385614 */     GIR_RootConstrainSelectedInstOperands,
     /* 385615 */     // GIR_Coverage, 6224,
     /* 385615 */     GIR_EraseRootFromParent_Done,
     /* 385616 */   // Label 7723: @385616
     /* 385616 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(385700), // Rule ID 6136 //
     /* 385621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385653 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385657 */     // MIs[2] Operand 1
     /* 385657 */     // No operand predicates
     /* 385657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 385669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385680 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 385691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385698 */     GIR_RootConstrainSelectedInstOperands,
     /* 385699 */     // GIR_Coverage, 6136,
     /* 385699 */     GIR_EraseRootFromParent_Done,
     /* 385700 */   // Label 7724: @385700
     /* 385700 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(385781), // Rule ID 6168 //
     /* 385705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385749 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385753 */     // MIs[3] Operand 1
     /* 385753 */     // No operand predicates
     /* 385753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385763 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385779 */     GIR_RootConstrainSelectedInstOperands,
     /* 385780 */     // GIR_Coverage, 6168,
     /* 385780 */     GIR_EraseRootFromParent_Done,
     /* 385781 */   // Label 7725: @385781
     /* 385781 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(385865), // Rule ID 6200 //
     /* 385786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385835 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385839 */     // MIs[3] Operand 1
     /* 385839 */     // No operand predicates
     /* 385839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385845 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385863 */     GIR_RootConstrainSelectedInstOperands,
     /* 385864 */     // GIR_Coverage, 6200,
     /* 385864 */     GIR_EraseRootFromParent_Done,
     /* 385865 */   // Label 7726: @385865
     /* 385865 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(385943), // Rule ID 6246 //
     /* 385870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385915 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385919 */     // MIs[3] Operand 1
     /* 385919 */     // No operand predicates
     /* 385919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385925 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 385928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385941 */     GIR_RootConstrainSelectedInstOperands,
     /* 385942 */     // GIR_Coverage, 6246,
     /* 385942 */     GIR_EraseRootFromParent_Done,
     /* 385943 */   // Label 7727: @385943
     /* 385943 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(386024), // Rule ID 6104 //
     /* 385948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385996 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386000 */     // MIs[3] Operand 1
     /* 386000 */     // No operand predicates
     /* 386000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386006 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 386009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386022 */     GIR_RootConstrainSelectedInstOperands,
     /* 386023 */     // GIR_Coverage, 6104,
     /* 386023 */     GIR_EraseRootFromParent_Done,
     /* 386024 */   // Label 7728: @386024
     /* 386024 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(386109), // Rule ID 2459 //
     /* 386029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386053 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386067 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 386070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386079 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 386085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 386098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386107 */     GIR_RootConstrainSelectedInstOperands,
     /* 386108 */     // GIR_Coverage, 2459,
     /* 386108 */     GIR_EraseRootFromParent_Done,
     /* 386109 */   // Label 7729: @386109
     /* 386109 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(386194), // Rule ID 2457 //
     /* 386114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386142 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386152 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 386152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 386155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386164 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 386170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 386183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386192 */     GIR_RootConstrainSelectedInstOperands,
     /* 386193 */     // GIR_Coverage, 2457,
     /* 386193 */     GIR_EraseRootFromParent_Done,
     /* 386194 */   // Label 7730: @386194
     /* 386194 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(386263), // Rule ID 2551 //
     /* 386199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386231 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386235 */     // MIs[2] Operand 1
     /* 386235 */     // No operand predicates
     /* 386235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386245 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 386248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386261 */     GIR_RootConstrainSelectedInstOperands,
     /* 386262 */     // GIR_Coverage, 2551,
     /* 386262 */     GIR_EraseRootFromParent_Done,
     /* 386263 */   // Label 7731: @386263
     /* 386263 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(386332), // Rule ID 6072 //
     /* 386268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386304 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386308 */     // MIs[2] Operand 1
     /* 386308 */     // No operand predicates
     /* 386308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386314 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 386317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386330 */     GIR_RootConstrainSelectedInstOperands,
     /* 386331 */     // GIR_Coverage, 6072,
     /* 386331 */     GIR_EraseRootFromParent_Done,
     /* 386332 */   // Label 7732: @386332
     /* 386332 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(386382), // Rule ID 13325 //
     /* 386337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386367 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 386370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386380 */     GIR_RootConstrainSelectedInstOperands,
     /* 386381 */     // GIR_Coverage, 13325,
     /* 386381 */     GIR_EraseRootFromParent_Done,
     /* 386382 */   // Label 7733: @386382
     /* 386382 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(386432), // Rule ID 645 //
     /* 386387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386417 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 386420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386430 */     GIR_RootConstrainSelectedInstOperands,
     /* 386431 */     // GIR_Coverage, 645,
     /* 386431 */     GIR_EraseRootFromParent_Done,
     /* 386432 */   // Label 7734: @386432
     /* 386432 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(386482), // Rule ID 657 //
     /* 386437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 386452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386467 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 386470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 386480 */     GIR_RootConstrainSelectedInstOperands,
     /* 386481 */     // GIR_Coverage, 657,
     /* 386481 */     GIR_EraseRootFromParent_Done,
     /* 386482 */   // Label 7735: @386482
     /* 386482 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(386513), // Rule ID 639 //
     /* 386487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386502 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 386502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 386507 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 386511 */     GIR_RootConstrainSelectedInstOperands,
     /* 386512 */     // GIR_Coverage, 639,
     /* 386512 */     GIR_Done,
     /* 386513 */   // Label 7736: @386513
     /* 386513 */   GIM_Reject,
     /* 386514 */ // Label 7706: @386514
     /* 386514 */ GIM_Reject,
     /* 386515 */ // Label 7670: @386515
     /* 386515 */ GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(389444),
     /* 386520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 386523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386526 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386533 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(386683), // Rule ID 4876 //
     /* 386538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386562 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386587 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 386591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 386595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 386603 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386610 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 386613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386622 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386628 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386633 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386650 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 386669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 386677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 386681 */     GIR_RootConstrainSelectedInstOperands,
     /* 386682 */     // GIR_Coverage, 4876,
     /* 386682 */     GIR_EraseRootFromParent_Done,
     /* 386683 */   // Label 7738: @386683
     /* 386683 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(386830), // Rule ID 4840 //
     /* 386688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386712 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386740 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 386744 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386749 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 386753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386759 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386759 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 386762 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386766 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386771 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386777 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386782 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386799 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 386818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 386826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386828 */     GIR_RootConstrainSelectedInstOperands,
     /* 386829 */     // GIR_Coverage, 4840,
     /* 386829 */     GIR_EraseRootFromParent_Done,
     /* 386830 */   // Label 7739: @386830
     /* 386830 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(386977), // Rule ID 13893 //
     /* 386835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386871 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 386875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 386879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386883 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386887 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 386891 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386896 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 386900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386906 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386906 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 386909 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386913 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386918 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386924 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386946 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 386965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 386973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386975 */     GIR_RootConstrainSelectedInstOperands,
     /* 386976 */     // GIR_Coverage, 13893,
     /* 386976 */     GIR_EraseRootFromParent_Done,
     /* 386977 */   // Label 7740: @386977
     /* 386977 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(387108), // Rule ID 6110 //
     /* 386982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387006 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 387026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387030 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 387038 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 387047 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387051 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387055 */     // MIs[4] Operand 1
     /* 387055 */     // No operand predicates
     /* 387055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387059 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 387061 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387073 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 387103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 387106 */     GIR_RootConstrainSelectedInstOperands,
     /* 387107 */     // GIR_Coverage, 6110,
     /* 387107 */     GIR_EraseRootFromParent_Done,
     /* 387108 */   // Label 7741: @387108
     /* 387108 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(387239), // Rule ID 6142 //
     /* 387113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387149 */     // MIs[2] Operand 1
     /* 387149 */     // No operand predicates
     /* 387149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387157 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 387161 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 387165 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387169 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 387177 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 387186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387190 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 387192 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387204 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387237 */     GIR_RootConstrainSelectedInstOperands,
     /* 387238 */     // GIR_Coverage, 6142,
     /* 387238 */     GIR_EraseRootFromParent_Done,
     /* 387239 */   // Label 7742: @387239
     /* 387239 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(387370), // Rule ID 6206 //
     /* 387244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387280 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 387284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387296 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 387300 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387305 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 387309 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387313 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387317 */     // MIs[4] Operand 1
     /* 387317 */     // No operand predicates
     /* 387317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387321 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 387323 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 387365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 387368 */     GIR_RootConstrainSelectedInstOperands,
     /* 387369 */     // GIR_Coverage, 6206,
     /* 387369 */     GIR_EraseRootFromParent_Done,
     /* 387370 */   // Label 7743: @387370
     /* 387370 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(387501), // Rule ID 6174 //
     /* 387375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387419 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387423 */     // MIs[3] Operand 1
     /* 387423 */     // No operand predicates
     /* 387423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 387427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387435 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 387439 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387444 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 387448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387452 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 387454 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387466 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387499 */     GIR_RootConstrainSelectedInstOperands,
     /* 387500 */     // GIR_Coverage, 6174,
     /* 387500 */     GIR_EraseRootFromParent_Done,
     /* 387501 */   // Label 7744: @387501
     /* 387501 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(387636), // Rule ID 2467 //
     /* 387506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387530 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387555 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 387559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387565 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 387565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 387568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387577 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 387583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387605 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 387624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 387632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 387634 */     GIR_RootConstrainSelectedInstOperands,
     /* 387635 */     // GIR_Coverage, 2467,
     /* 387635 */     GIR_EraseRootFromParent_Done,
     /* 387636 */   // Label 7745: @387636
     /* 387636 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(387755), // Rule ID 6078 //
     /* 387641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387665 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387698 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387702 */     // MIs[3] Operand 1
     /* 387702 */     // No operand predicates
     /* 387702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387708 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 387739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387753 */     GIR_RootConstrainSelectedInstOperands,
     /* 387754 */     // GIR_Coverage, 6078,
     /* 387754 */     GIR_EraseRootFromParent_Done,
     /* 387755 */   // Label 7746: @387755
     /* 387755 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(387874), // Rule ID 2557 //
     /* 387760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387792 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387796 */     // MIs[2] Operand 1
     /* 387796 */     // No operand predicates
     /* 387796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387804 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387808 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 387812 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387817 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 387821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387827 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387839 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 387858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387872 */     GIR_RootConstrainSelectedInstOperands,
     /* 387873 */     // GIR_Coverage, 2557,
     /* 387873 */     GIR_EraseRootFromParent_Done,
     /* 387874 */   // Label 7747: @387874
     /* 387874 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(387974), // Rule ID 4838 //
     /* 387879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387903 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387930 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 387930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387942 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 387961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 387972 */     GIR_RootConstrainSelectedInstOperands,
     /* 387973 */     // GIR_Coverage, 4838,
     /* 387973 */     GIR_EraseRootFromParent_Done,
     /* 387974 */   // Label 7748: @387974
     /* 387974 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(388074), // Rule ID 4874 //
     /* 387979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 388007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 388015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 388023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388030 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 388030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388042 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 388048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 388061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 388072 */     GIR_RootConstrainSelectedInstOperands,
     /* 388073 */     // GIR_Coverage, 4874,
     /* 388073 */     GIR_EraseRootFromParent_Done,
     /* 388074 */   // Label 7749: @388074
     /* 388074 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(388171), // Rule ID 13889 //
     /* 388079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388115 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 388119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388129 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 388129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388141 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 388147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 388160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 388169 */     GIR_RootConstrainSelectedInstOperands,
     /* 388170 */     // GIR_Coverage, 13889,
     /* 388170 */     GIR_EraseRootFromParent_Done,
     /* 388171 */   // Label 7750: @388171
     /* 388171 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(388271), // Rule ID 13891 //
     /* 388176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388217 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 388221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388227 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 388227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388239 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 388245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 388258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 388269 */     GIR_RootConstrainSelectedInstOperands,
     /* 388270 */     // GIR_Coverage, 13891,
     /* 388270 */     GIR_EraseRootFromParent_Done,
     /* 388271 */   // Label 7751: @388271
     /* 388271 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(388371), // Rule ID 4872 //
     /* 388276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 388308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 388312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 388320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388327 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 388327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388339 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 388345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 388358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 388369 */     GIR_RootConstrainSelectedInstOperands,
     /* 388370 */     // GIR_Coverage, 4872,
     /* 388370 */     GIR_EraseRootFromParent_Done,
     /* 388371 */   // Label 7752: @388371
     /* 388371 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(388468), // Rule ID 4836 //
     /* 388376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388416 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 388420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388426 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 388426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 388429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388438 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 388444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 388457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 388466 */     GIR_RootConstrainSelectedInstOperands,
     /* 388467 */     // GIR_Coverage, 4836,
     /* 388467 */     GIR_EraseRootFromParent_Done,
     /* 388468 */   // Label 7753: @388468
     /* 388468 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(388546), // Rule ID 6228 //
     /* 388473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 388510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388514 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388518 */     // MIs[3] Operand 1
     /* 388518 */     // No operand predicates
     /* 388518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388528 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388544 */     GIR_RootConstrainSelectedInstOperands,
     /* 388545 */     // GIR_Coverage, 6228,
     /* 388545 */     GIR_EraseRootFromParent_Done,
     /* 388546 */   // Label 7754: @388546
     /* 388546 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(388630), // Rule ID 6140 //
     /* 388551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388587 */     // MIs[2] Operand 1
     /* 388587 */     // No operand predicates
     /* 388587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 388591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388595 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 388599 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388610 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 388621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388628 */     GIR_RootConstrainSelectedInstOperands,
     /* 388629 */     // GIR_Coverage, 6140,
     /* 388629 */     GIR_EraseRootFromParent_Done,
     /* 388630 */   // Label 7755: @388630
     /* 388630 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(388711), // Rule ID 6172 //
     /* 388635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388683 */     // MIs[3] Operand 1
     /* 388683 */     // No operand predicates
     /* 388683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388693 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388709 */     GIR_RootConstrainSelectedInstOperands,
     /* 388710 */     // GIR_Coverage, 6172,
     /* 388710 */     GIR_EraseRootFromParent_Done,
     /* 388711 */   // Label 7756: @388711
     /* 388711 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(388795), // Rule ID 6204 //
     /* 388716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388765 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388769 */     // MIs[3] Operand 1
     /* 388769 */     // No operand predicates
     /* 388769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388775 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388793 */     GIR_RootConstrainSelectedInstOperands,
     /* 388794 */     // GIR_Coverage, 6204,
     /* 388794 */     GIR_EraseRootFromParent_Done,
     /* 388795 */   // Label 7757: @388795
     /* 388795 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(388873), // Rule ID 6250 //
     /* 388800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 388841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388845 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388849 */     // MIs[3] Operand 1
     /* 388849 */     // No operand predicates
     /* 388849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388855 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388871 */     GIR_RootConstrainSelectedInstOperands,
     /* 388872 */     // GIR_Coverage, 6250,
     /* 388872 */     GIR_EraseRootFromParent_Done,
     /* 388873 */   // Label 7758: @388873
     /* 388873 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(388954), // Rule ID 6108 //
     /* 388878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388926 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388930 */     // MIs[3] Operand 1
     /* 388930 */     // No operand predicates
     /* 388930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388936 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 388939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388952 */     GIR_RootConstrainSelectedInstOperands,
     /* 388953 */     // GIR_Coverage, 6108,
     /* 388953 */     GIR_EraseRootFromParent_Done,
     /* 388954 */   // Label 7759: @388954
     /* 388954 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(389039), // Rule ID 2465 //
     /* 388959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 388962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 388987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388997 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 388997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 389000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389009 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 389015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 389028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 389035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 389037 */     GIR_RootConstrainSelectedInstOperands,
     /* 389038 */     // GIR_Coverage, 2465,
     /* 389038 */     GIR_EraseRootFromParent_Done,
     /* 389039 */   // Label 7760: @389039
     /* 389039 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(389124), // Rule ID 2463 //
     /* 389044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389072 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 389076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389082 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 389082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 389085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389094 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 389100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 389113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 389122 */     GIR_RootConstrainSelectedInstOperands,
     /* 389123 */     // GIR_Coverage, 2463,
     /* 389123 */     GIR_EraseRootFromParent_Done,
     /* 389124 */   // Label 7761: @389124
     /* 389124 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(389193), // Rule ID 2555 //
     /* 389129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389165 */     // MIs[2] Operand 1
     /* 389165 */     // No operand predicates
     /* 389165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389175 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 389175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 389178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389191 */     GIR_RootConstrainSelectedInstOperands,
     /* 389192 */     // GIR_Coverage, 2555,
     /* 389192 */     GIR_EraseRootFromParent_Done,
     /* 389193 */   // Label 7762: @389193
     /* 389193 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(389262), // Rule ID 6076 //
     /* 389198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389234 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389238 */     // MIs[2] Operand 1
     /* 389238 */     // No operand predicates
     /* 389238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389244 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 389244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 389247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389260 */     GIR_RootConstrainSelectedInstOperands,
     /* 389261 */     // GIR_Coverage, 6076,
     /* 389261 */     GIR_EraseRootFromParent_Done,
     /* 389262 */   // Label 7763: @389262
     /* 389262 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(389312), // Rule ID 13327 //
     /* 389267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 389282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389297 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 389300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 389310 */     GIR_RootConstrainSelectedInstOperands,
     /* 389311 */     // GIR_Coverage, 13327,
     /* 389311 */     GIR_EraseRootFromParent_Done,
     /* 389312 */   // Label 7764: @389312
     /* 389312 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(389362), // Rule ID 647 //
     /* 389317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 389336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389347 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 389350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 389360 */     GIR_RootConstrainSelectedInstOperands,
     /* 389361 */     // GIR_Coverage, 647,
     /* 389361 */     GIR_EraseRootFromParent_Done,
     /* 389362 */   // Label 7765: @389362
     /* 389362 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(389412), // Rule ID 659 //
     /* 389367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 389382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 389390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389397 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 389400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 389406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 389410 */     GIR_RootConstrainSelectedInstOperands,
     /* 389411 */     // GIR_Coverage, 659,
     /* 389411 */     GIR_EraseRootFromParent_Done,
     /* 389412 */   // Label 7766: @389412
     /* 389412 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(389443), // Rule ID 641 //
     /* 389417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 389420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389432 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 389432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 389437 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389441 */     GIR_RootConstrainSelectedInstOperands,
     /* 389442 */     // GIR_Coverage, 641,
     /* 389442 */     GIR_Done,
     /* 389443 */   // Label 7767: @389443
     /* 389443 */   GIM_Reject,
     /* 389444 */ // Label 7737: @389444
     /* 389444 */ GIM_Reject,
     /* 389445 */ // Label 7671: @389445
     /* 389445 */ GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(390965),
     /* 389450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 389456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 389459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389463 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(389541), // Rule ID 6208 //
     /* 389468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389509 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389513 */     // MIs[3] Operand 1
     /* 389513 */     // No operand predicates
     /* 389513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389523 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389539 */     GIR_RootConstrainSelectedInstOperands,
     /* 389540 */     // GIR_Coverage, 6208,
     /* 389540 */     GIR_EraseRootFromParent_Done,
     /* 389541 */   // Label 7769: @389541
     /* 389541 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(389625), // Rule ID 6124 //
     /* 389546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389578 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389582 */     // MIs[2] Operand 1
     /* 389582 */     // No operand predicates
     /* 389582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 389586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389594 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389605 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 389616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389623 */     GIR_RootConstrainSelectedInstOperands,
     /* 389624 */     // GIR_Coverage, 6124,
     /* 389624 */     GIR_EraseRootFromParent_Done,
     /* 389625 */   // Label 7770: @389625
     /* 389625 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(389706), // Rule ID 6156 //
     /* 389630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389678 */     // MIs[3] Operand 1
     /* 389678 */     // No operand predicates
     /* 389678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389688 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389704 */     GIR_RootConstrainSelectedInstOperands,
     /* 389705 */     // GIR_Coverage, 6156,
     /* 389705 */     GIR_EraseRootFromParent_Done,
     /* 389706 */   // Label 7771: @389706
     /* 389706 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(389790), // Rule ID 6188 //
     /* 389711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389760 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389764 */     // MIs[3] Operand 1
     /* 389764 */     // No operand predicates
     /* 389764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389770 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389788 */     GIR_RootConstrainSelectedInstOperands,
     /* 389789 */     // GIR_Coverage, 6188,
     /* 389789 */     GIR_EraseRootFromParent_Done,
     /* 389790 */   // Label 7772: @389790
     /* 389790 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(389868), // Rule ID 6230 //
     /* 389795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389840 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389844 */     // MIs[3] Operand 1
     /* 389844 */     // No operand predicates
     /* 389844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389850 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389866 */     GIR_RootConstrainSelectedInstOperands,
     /* 389867 */     // GIR_Coverage, 6230,
     /* 389867 */     GIR_EraseRootFromParent_Done,
     /* 389868 */   // Label 7773: @389868
     /* 389868 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(389949), // Rule ID 6092 //
     /* 389873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389921 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389925 */     // MIs[3] Operand 1
     /* 389925 */     // No operand predicates
     /* 389925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389931 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389947 */     GIR_RootConstrainSelectedInstOperands,
     /* 389948 */     // GIR_Coverage, 6092,
     /* 389948 */     GIR_EraseRootFromParent_Done,
     /* 389949 */   // Label 7774: @389949
     /* 389949 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(390018), // Rule ID 2539 //
     /* 389954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389986 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389990 */     // MIs[2] Operand 1
     /* 389990 */     // No operand predicates
     /* 389990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390000 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 390003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390016 */     GIR_RootConstrainSelectedInstOperands,
     /* 390017 */     // GIR_Coverage, 2539,
     /* 390017 */     GIR_EraseRootFromParent_Done,
     /* 390018 */   // Label 7775: @390018
     /* 390018 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(390087), // Rule ID 6060 //
     /* 390023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 390038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390059 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390063 */     // MIs[2] Operand 1
     /* 390063 */     // No operand predicates
     /* 390063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390069 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 390072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390085 */     GIR_RootConstrainSelectedInstOperands,
     /* 390086 */     // GIR_Coverage, 6060,
     /* 390086 */     GIR_EraseRootFromParent_Done,
     /* 390087 */   // Label 7776: @390087
     /* 390087 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(390180), // Rule ID 6212 //
     /* 390092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390131 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390143 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390150 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390178 */     GIR_RootConstrainSelectedInstOperands,
     /* 390179 */     // GIR_Coverage, 6212,
     /* 390179 */     GIR_EraseRootFromParent_Done,
     /* 390180 */   // Label 7777: @390180
     /* 390180 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(390279), // Rule ID 6126 //
     /* 390185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390228 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390240 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390247 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 390271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390277 */     GIR_RootConstrainSelectedInstOperands,
     /* 390278 */     // GIR_Coverage, 6126,
     /* 390278 */     GIR_EraseRootFromParent_Done,
     /* 390279 */   // Label 7778: @390279
     /* 390279 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(390375), // Rule ID 6158 //
     /* 390284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390326 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390338 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390341 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390373 */     GIR_RootConstrainSelectedInstOperands,
     /* 390374 */     // GIR_Coverage, 6158,
     /* 390374 */     GIR_EraseRootFromParent_Done,
     /* 390375 */   // Label 7779: @390375
     /* 390375 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(390474), // Rule ID 6190 //
     /* 390380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390423 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390442 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390472 */     GIR_RootConstrainSelectedInstOperands,
     /* 390473 */     // GIR_Coverage, 6190,
     /* 390473 */     GIR_EraseRootFromParent_Done,
     /* 390474 */   // Label 7780: @390474
     /* 390474 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(390567), // Rule ID 6234 //
     /* 390479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390518 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390537 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390565 */     GIR_RootConstrainSelectedInstOperands,
     /* 390566 */     // GIR_Coverage, 6234,
     /* 390566 */     GIR_EraseRootFromParent_Done,
     /* 390567 */   // Label 7781: @390567
     /* 390567 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(390663), // Rule ID 6094 //
     /* 390572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390614 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390626 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390629 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390633 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 390649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390661 */     GIR_RootConstrainSelectedInstOperands,
     /* 390662 */     // GIR_Coverage, 6094,
     /* 390662 */     GIR_EraseRootFromParent_Done,
     /* 390663 */   // Label 7782: @390663
     /* 390663 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(390747), // Rule ID 2541 //
     /* 390668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390698 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 390733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390745 */     GIR_RootConstrainSelectedInstOperands,
     /* 390746 */     // GIR_Coverage, 2541,
     /* 390746 */     GIR_EraseRootFromParent_Done,
     /* 390747 */   // Label 7783: @390747
     /* 390747 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(390797), // Rule ID 13357 //
     /* 390752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390782 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 390782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 390785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390795 */     GIR_RootConstrainSelectedInstOperands,
     /* 390796 */     // GIR_Coverage, 13357,
     /* 390796 */     GIR_EraseRootFromParent_Done,
     /* 390797 */   // Label 7784: @390797
     /* 390797 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(390881), // Rule ID 6062 //
     /* 390802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390832 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390844 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390851 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 390867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390879 */     GIR_RootConstrainSelectedInstOperands,
     /* 390880 */     // GIR_Coverage, 6062,
     /* 390880 */     GIR_EraseRootFromParent_Done,
     /* 390881 */   // Label 7785: @390881
     /* 390881 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(390931), // Rule ID 1307 //
     /* 390886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390916 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 390916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 390919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390929 */     GIR_RootConstrainSelectedInstOperands,
     /* 390930 */     // GIR_Coverage, 1307,
     /* 390930 */     GIR_EraseRootFromParent_Done,
     /* 390931 */   // Label 7786: @390931
     /* 390931 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(390964), // Rule ID 1297 //
     /* 390936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390951 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 390951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 390954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 390962 */     GIR_RootConstrainSelectedInstOperands,
     /* 390963 */     // GIR_Coverage, 1297,
     /* 390963 */     GIR_EraseRootFromParent_Done,
     /* 390964 */   // Label 7787: @390964
     /* 390964 */   GIM_Reject,
     /* 390965 */ // Label 7768: @390965
     /* 390965 */ GIM_Reject,
     /* 390966 */ // Label 7672: @390966
     /* 390966 */ GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(392486),
     /* 390971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 390977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 390980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390984 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(391062), // Rule ID 6220 //
     /* 390989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 390997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 391026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391030 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391034 */     // MIs[3] Operand 1
     /* 391034 */     // No operand predicates
     /* 391034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391044 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391060 */     GIR_RootConstrainSelectedInstOperands,
     /* 391061 */     // GIR_Coverage, 6220,
     /* 391061 */     GIR_EraseRootFromParent_Done,
     /* 391062 */   // Label 7789: @391062
     /* 391062 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(391146), // Rule ID 6132 //
     /* 391067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391103 */     // MIs[2] Operand 1
     /* 391103 */     // No operand predicates
     /* 391103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 391107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391115 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391126 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391144 */     GIR_RootConstrainSelectedInstOperands,
     /* 391145 */     // GIR_Coverage, 6132,
     /* 391145 */     GIR_EraseRootFromParent_Done,
     /* 391146 */   // Label 7790: @391146
     /* 391146 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(391227), // Rule ID 6164 //
     /* 391151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391195 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391199 */     // MIs[3] Operand 1
     /* 391199 */     // No operand predicates
     /* 391199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391209 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391225 */     GIR_RootConstrainSelectedInstOperands,
     /* 391226 */     // GIR_Coverage, 6164,
     /* 391226 */     GIR_EraseRootFromParent_Done,
     /* 391227 */   // Label 7791: @391227
     /* 391227 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(391311), // Rule ID 6196 //
     /* 391232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391281 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391285 */     // MIs[3] Operand 1
     /* 391285 */     // No operand predicates
     /* 391285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391291 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391309 */     GIR_RootConstrainSelectedInstOperands,
     /* 391310 */     // GIR_Coverage, 6196,
     /* 391310 */     GIR_EraseRootFromParent_Done,
     /* 391311 */   // Label 7792: @391311
     /* 391311 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(391389), // Rule ID 6242 //
     /* 391316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 391357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391361 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391365 */     // MIs[3] Operand 1
     /* 391365 */     // No operand predicates
     /* 391365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391371 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391387 */     GIR_RootConstrainSelectedInstOperands,
     /* 391388 */     // GIR_Coverage, 6242,
     /* 391388 */     GIR_EraseRootFromParent_Done,
     /* 391389 */   // Label 7793: @391389
     /* 391389 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(391470), // Rule ID 6100 //
     /* 391394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391442 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391446 */     // MIs[3] Operand 1
     /* 391446 */     // No operand predicates
     /* 391446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391452 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391468 */     GIR_RootConstrainSelectedInstOperands,
     /* 391469 */     // GIR_Coverage, 6100,
     /* 391469 */     GIR_EraseRootFromParent_Done,
     /* 391470 */   // Label 7794: @391470
     /* 391470 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(391539), // Rule ID 2547 //
     /* 391475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391511 */     // MIs[2] Operand 1
     /* 391511 */     // No operand predicates
     /* 391511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391521 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 391524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391537 */     GIR_RootConstrainSelectedInstOperands,
     /* 391538 */     // GIR_Coverage, 2547,
     /* 391538 */     GIR_EraseRootFromParent_Done,
     /* 391539 */   // Label 7795: @391539
     /* 391539 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(391608), // Rule ID 6068 //
     /* 391544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 391559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 391584 */     // MIs[2] Operand 1
     /* 391584 */     // No operand predicates
     /* 391584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391590 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 391590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 391593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391606 */     GIR_RootConstrainSelectedInstOperands,
     /* 391607 */     // GIR_Coverage, 6068,
     /* 391607 */     GIR_EraseRootFromParent_Done,
     /* 391608 */   // Label 7796: @391608
     /* 391608 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(391701), // Rule ID 6222 //
     /* 391613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391652 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391664 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391671 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391699 */     GIR_RootConstrainSelectedInstOperands,
     /* 391700 */     // GIR_Coverage, 6222,
     /* 391700 */     GIR_EraseRootFromParent_Done,
     /* 391701 */   // Label 7797: @391701
     /* 391701 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(391800), // Rule ID 6134 //
     /* 391706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391749 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391761 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391768 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 391792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391798 */     GIR_RootConstrainSelectedInstOperands,
     /* 391799 */     // GIR_Coverage, 6134,
     /* 391799 */     GIR_EraseRootFromParent_Done,
     /* 391800 */   // Label 7798: @391800
     /* 391800 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(391896), // Rule ID 6166 //
     /* 391805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391847 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391894 */     GIR_RootConstrainSelectedInstOperands,
     /* 391895 */     // GIR_Coverage, 6166,
     /* 391895 */     GIR_EraseRootFromParent_Done,
     /* 391896 */   // Label 7799: @391896
     /* 391896 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(391995), // Rule ID 6198 //
     /* 391901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391944 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391963 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 391979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391993 */     GIR_RootConstrainSelectedInstOperands,
     /* 391994 */     // GIR_Coverage, 6198,
     /* 391994 */     GIR_EraseRootFromParent_Done,
     /* 391995 */   // Label 7800: @391995
     /* 391995 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(392088), // Rule ID 6244 //
     /* 392000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 392028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392039 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 392074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392086 */     GIR_RootConstrainSelectedInstOperands,
     /* 392087 */     // GIR_Coverage, 6244,
     /* 392087 */     GIR_EraseRootFromParent_Done,
     /* 392088 */   // Label 7801: @392088
     /* 392088 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(392184), // Rule ID 6102 //
     /* 392093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 392120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 392124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392135 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 392170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392182 */     GIR_RootConstrainSelectedInstOperands,
     /* 392183 */     // GIR_Coverage, 6102,
     /* 392183 */     GIR_EraseRootFromParent_Done,
     /* 392184 */   // Label 7802: @392184
     /* 392184 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(392268), // Rule ID 2549 //
     /* 392189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392219 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392231 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392238 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 392254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392266 */     GIR_RootConstrainSelectedInstOperands,
     /* 392267 */     // GIR_Coverage, 2549,
     /* 392267 */     GIR_EraseRootFromParent_Done,
     /* 392268 */   // Label 7803: @392268
     /* 392268 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(392318), // Rule ID 13361 //
     /* 392273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392303 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 392303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 392306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392316 */     GIR_RootConstrainSelectedInstOperands,
     /* 392317 */     // GIR_Coverage, 13361,
     /* 392317 */     GIR_EraseRootFromParent_Done,
     /* 392318 */   // Label 7804: @392318
     /* 392318 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(392402), // Rule ID 6070 //
     /* 392323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392353 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392365 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 392388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392400 */     GIR_RootConstrainSelectedInstOperands,
     /* 392401 */     // GIR_Coverage, 6070,
     /* 392401 */     GIR_EraseRootFromParent_Done,
     /* 392402 */   // Label 7805: @392402
     /* 392402 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(392452), // Rule ID 1311 //
     /* 392407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392437 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 392437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 392440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392450 */     GIR_RootConstrainSelectedInstOperands,
     /* 392451 */     // GIR_Coverage, 1311,
     /* 392451 */     GIR_EraseRootFromParent_Done,
     /* 392452 */   // Label 7806: @392452
     /* 392452 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(392485), // Rule ID 1301 //
     /* 392457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392472 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 392472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 392475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 392483 */     GIR_RootConstrainSelectedInstOperands,
     /* 392484 */     // GIR_Coverage, 1301,
     /* 392484 */     GIR_EraseRootFromParent_Done,
     /* 392485 */   // Label 7807: @392485
     /* 392485 */   GIM_Reject,
     /* 392486 */ // Label 7788: @392486
     /* 392486 */ GIM_Reject,
     /* 392487 */ // Label 7673: @392487
     /* 392487 */ GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(393665),
     /* 392492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 392498 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 392501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392505 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(392589), // Rule ID 6116 //
     /* 392510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392542 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392546 */     // MIs[2] Operand 1
     /* 392546 */     // No operand predicates
     /* 392546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 392550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392558 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392569 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 392572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 392580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392587 */     GIR_RootConstrainSelectedInstOperands,
     /* 392588 */     // GIR_Coverage, 6116,
     /* 392588 */     GIR_EraseRootFromParent_Done,
     /* 392589 */   // Label 7809: @392589
     /* 392589 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(392670), // Rule ID 6148 //
     /* 392594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392638 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392642 */     // MIs[3] Operand 1
     /* 392642 */     // No operand predicates
     /* 392642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392652 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 392655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392668 */     GIR_RootConstrainSelectedInstOperands,
     /* 392669 */     // GIR_Coverage, 6148,
     /* 392669 */     GIR_EraseRootFromParent_Done,
     /* 392670 */   // Label 7810: @392670
     /* 392670 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(392754), // Rule ID 6180 //
     /* 392675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392724 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392728 */     // MIs[3] Operand 1
     /* 392728 */     // No operand predicates
     /* 392728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392734 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 392737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392752 */     GIR_RootConstrainSelectedInstOperands,
     /* 392753 */     // GIR_Coverage, 6180,
     /* 392753 */     GIR_EraseRootFromParent_Done,
     /* 392754 */   // Label 7811: @392754
     /* 392754 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(392835), // Rule ID 6084 //
     /* 392759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392807 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392811 */     // MIs[3] Operand 1
     /* 392811 */     // No operand predicates
     /* 392811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392817 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 392820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392833 */     GIR_RootConstrainSelectedInstOperands,
     /* 392834 */     // GIR_Coverage, 6084,
     /* 392834 */     GIR_EraseRootFromParent_Done,
     /* 392835 */   // Label 7812: @392835
     /* 392835 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(392904), // Rule ID 2531 //
     /* 392840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392876 */     // MIs[2] Operand 1
     /* 392876 */     // No operand predicates
     /* 392876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392886 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 392889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392902 */     GIR_RootConstrainSelectedInstOperands,
     /* 392903 */     // GIR_Coverage, 2531,
     /* 392903 */     GIR_EraseRootFromParent_Done,
     /* 392904 */   // Label 7813: @392904
     /* 392904 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(392973), // Rule ID 6052 //
     /* 392909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 392924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 392937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392945 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392949 */     // MIs[2] Operand 1
     /* 392949 */     // No operand predicates
     /* 392949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392955 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 392955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 392958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392971 */     GIR_RootConstrainSelectedInstOperands,
     /* 392972 */     // GIR_Coverage, 6052,
     /* 392972 */     GIR_EraseRootFromParent_Done,
     /* 392973 */   // Label 7814: @392973
     /* 392973 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(393072), // Rule ID 6118 //
     /* 392978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393021 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393040 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 393056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 393064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393070 */     GIR_RootConstrainSelectedInstOperands,
     /* 393071 */     // GIR_Coverage, 6118,
     /* 393071 */     GIR_EraseRootFromParent_Done,
     /* 393072 */   // Label 7815: @393072
     /* 393072 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(393168), // Rule ID 6150 //
     /* 393077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393119 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 393154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393166 */     GIR_RootConstrainSelectedInstOperands,
     /* 393167 */     // GIR_Coverage, 6150,
     /* 393167 */     GIR_EraseRootFromParent_Done,
     /* 393168 */   // Label 7816: @393168
     /* 393168 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(393267), // Rule ID 6182 //
     /* 393173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393216 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393228 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393235 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 393251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393265 */     GIR_RootConstrainSelectedInstOperands,
     /* 393266 */     // GIR_Coverage, 6182,
     /* 393266 */     GIR_EraseRootFromParent_Done,
     /* 393267 */   // Label 7817: @393267
     /* 393267 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(393363), // Rule ID 6086 //
     /* 393272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393314 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393326 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 393349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393361 */     GIR_RootConstrainSelectedInstOperands,
     /* 393362 */     // GIR_Coverage, 6086,
     /* 393362 */     GIR_EraseRootFromParent_Done,
     /* 393363 */   // Label 7818: @393363
     /* 393363 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(393447), // Rule ID 2533 //
     /* 393368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 393379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393398 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 393433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393445 */     GIR_RootConstrainSelectedInstOperands,
     /* 393446 */     // GIR_Coverage, 2533,
     /* 393446 */     GIR_EraseRootFromParent_Done,
     /* 393447 */   // Label 7819: @393447
     /* 393447 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(393497), // Rule ID 13353 //
     /* 393452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393482 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 393482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 393485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393495 */     GIR_RootConstrainSelectedInstOperands,
     /* 393496 */     // GIR_Coverage, 13353,
     /* 393496 */     GIR_EraseRootFromParent_Done,
     /* 393497 */   // Label 7820: @393497
     /* 393497 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(393581), // Rule ID 6054 //
     /* 393502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 393517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393532 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 393535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393544 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 393564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 393567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393579 */     GIR_RootConstrainSelectedInstOperands,
     /* 393580 */     // GIR_Coverage, 6054,
     /* 393580 */     GIR_EraseRootFromParent_Done,
     /* 393581 */   // Label 7821: @393581
     /* 393581 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(393631), // Rule ID 1303 //
     /* 393586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393616 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 393616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 393619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393629 */     GIR_RootConstrainSelectedInstOperands,
     /* 393630 */     // GIR_Coverage, 1303,
     /* 393630 */     GIR_EraseRootFromParent_Done,
     /* 393631 */   // Label 7822: @393631
     /* 393631 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(393664), // Rule ID 1293 //
     /* 393636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393651 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 393651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 393654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 393662 */     GIR_RootConstrainSelectedInstOperands,
     /* 393663 */     // GIR_Coverage, 1293,
     /* 393663 */     GIR_EraseRootFromParent_Done,
     /* 393664 */   // Label 7823: @393664
     /* 393664 */   GIM_Reject,
     /* 393665 */ // Label 7808: @393665
     /* 393665 */ GIM_Reject,
     /* 393666 */ // Label 7674: @393666
     /* 393666 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(395186),
     /* 393671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 393677 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 393680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393684 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(393762), // Rule ID 6214 //
     /* 393689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 393726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393734 */     // MIs[3] Operand 1
     /* 393734 */     // No operand predicates
     /* 393734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393744 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 393744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393760 */     GIR_RootConstrainSelectedInstOperands,
     /* 393761 */     // GIR_Coverage, 6214,
     /* 393761 */     GIR_EraseRootFromParent_Done,
     /* 393762 */   // Label 7825: @393762
     /* 393762 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(393846), // Rule ID 6128 //
     /* 393767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393803 */     // MIs[2] Operand 1
     /* 393803 */     // No operand predicates
     /* 393803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393811 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393815 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393826 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 393826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 393837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393844 */     GIR_RootConstrainSelectedInstOperands,
     /* 393845 */     // GIR_Coverage, 6128,
     /* 393845 */     GIR_EraseRootFromParent_Done,
     /* 393846 */   // Label 7826: @393846
     /* 393846 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(393927), // Rule ID 6160 //
     /* 393851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393895 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393899 */     // MIs[3] Operand 1
     /* 393899 */     // No operand predicates
     /* 393899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393909 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 393909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393925 */     GIR_RootConstrainSelectedInstOperands,
     /* 393926 */     // GIR_Coverage, 6160,
     /* 393926 */     GIR_EraseRootFromParent_Done,
     /* 393927 */   // Label 7827: @393927
     /* 393927 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(394011), // Rule ID 6192 //
     /* 393932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393981 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393985 */     // MIs[3] Operand 1
     /* 393985 */     // No operand predicates
     /* 393985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393991 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 393991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 394009 */     GIR_RootConstrainSelectedInstOperands,
     /* 394010 */     // GIR_Coverage, 6192,
     /* 394010 */     GIR_EraseRootFromParent_Done,
     /* 394011 */   // Label 7828: @394011
     /* 394011 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(394089), // Rule ID 6236 //
     /* 394016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 394028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 394057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394061 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 394065 */     // MIs[3] Operand 1
     /* 394065 */     // No operand predicates
     /* 394065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394071 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 394071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 394087 */     GIR_RootConstrainSelectedInstOperands,
     /* 394088 */     // GIR_Coverage, 6236,
     /* 394088 */     GIR_EraseRootFromParent_Done,
     /* 394089 */   // Label 7829: @394089
     /* 394089 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(394170), // Rule ID 6096 //
     /* 394094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 394121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 394138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394142 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 394146 */     // MIs[3] Operand 1
     /* 394146 */     // No operand predicates
     /* 394146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394152 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 394152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 394168 */     GIR_RootConstrainSelectedInstOperands,
     /* 394169 */     // GIR_Coverage, 6096,
     /* 394169 */     GIR_EraseRootFromParent_Done,
     /* 394170 */   // Label 7830: @394170
     /* 394170 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(394239), // Rule ID 2543 //
     /* 394175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 394186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394207 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 394211 */     // MIs[2] Operand 1
     /* 394211 */     // No operand predicates
     /* 394211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394221 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 394221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 394224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 394237 */     GIR_RootConstrainSelectedInstOperands,
     /* 394238 */     // GIR_Coverage, 2543,
     /* 394238 */     GIR_EraseRootFromParent_Done,
     /* 394239 */   // Label 7831: @394239
     /* 394239 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(394308), // Rule ID 6064 //
     /* 394244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 394259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 394284 */     // MIs[2] Operand 1
     /* 394284 */     // No operand predicates
     /* 394284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394290 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 394290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 394293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 394306 */     GIR_RootConstrainSelectedInstOperands,
     /* 394307 */     // GIR_Coverage, 6064,
     /* 394307 */     GIR_EraseRootFromParent_Done,
     /* 394308 */   // Label 7832: @394308
     /* 394308 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(394401), // Rule ID 6218 //
     /* 394313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394352 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394364 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394367 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394371 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394399 */     GIR_RootConstrainSelectedInstOperands,
     /* 394400 */     // GIR_Coverage, 6218,
     /* 394400 */     GIR_EraseRootFromParent_Done,
     /* 394401 */   // Label 7833: @394401
     /* 394401 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(394500), // Rule ID 6130 //
     /* 394406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394449 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394468 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 394492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394498 */     GIR_RootConstrainSelectedInstOperands,
     /* 394499 */     // GIR_Coverage, 6130,
     /* 394499 */     GIR_EraseRootFromParent_Done,
     /* 394500 */   // Label 7834: @394500
     /* 394500 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(394596), // Rule ID 6162 //
     /* 394505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394547 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394559 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394594 */     GIR_RootConstrainSelectedInstOperands,
     /* 394595 */     // GIR_Coverage, 6162,
     /* 394595 */     GIR_EraseRootFromParent_Done,
     /* 394596 */   // Label 7835: @394596
     /* 394596 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(394695), // Rule ID 6194 //
     /* 394601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394644 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394656 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394663 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394693 */     GIR_RootConstrainSelectedInstOperands,
     /* 394694 */     // GIR_Coverage, 6194,
     /* 394694 */     GIR_EraseRootFromParent_Done,
     /* 394695 */   // Label 7836: @394695
     /* 394695 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(394788), // Rule ID 6240 //
     /* 394700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394739 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394758 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394786 */     GIR_RootConstrainSelectedInstOperands,
     /* 394787 */     // GIR_Coverage, 6240,
     /* 394787 */     GIR_EraseRootFromParent_Done,
     /* 394788 */   // Label 7837: @394788
     /* 394788 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(394884), // Rule ID 6098 //
     /* 394793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 394824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394835 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394847 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394854 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 394870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394882 */     GIR_RootConstrainSelectedInstOperands,
     /* 394883 */     // GIR_Coverage, 6098,
     /* 394883 */     GIR_EraseRootFromParent_Done,
     /* 394884 */   // Label 7838: @394884
     /* 394884 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(394968), // Rule ID 2545 //
     /* 394889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394919 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 394941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 394954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394966 */     GIR_RootConstrainSelectedInstOperands,
     /* 394967 */     // GIR_Coverage, 2545,
     /* 394967 */     GIR_EraseRootFromParent_Done,
     /* 394968 */   // Label 7839: @394968
     /* 394968 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(395018), // Rule ID 13359 //
     /* 394973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395003 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 395006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395016 */     GIR_RootConstrainSelectedInstOperands,
     /* 395017 */     // GIR_Coverage, 13359,
     /* 395017 */     GIR_EraseRootFromParent_Done,
     /* 395018 */   // Label 7840: @395018
     /* 395018 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(395102), // Rule ID 6066 //
     /* 395023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 395038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 395042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395053 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395065 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 395068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395072 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 395075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 395088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395100 */     GIR_RootConstrainSelectedInstOperands,
     /* 395101 */     // GIR_Coverage, 6066,
     /* 395101 */     GIR_EraseRootFromParent_Done,
     /* 395102 */   // Label 7841: @395102
     /* 395102 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(395152), // Rule ID 1309 //
     /* 395107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395137 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 395140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395150 */     GIR_RootConstrainSelectedInstOperands,
     /* 395151 */     // GIR_Coverage, 1309,
     /* 395151 */     GIR_EraseRootFromParent_Done,
     /* 395152 */   // Label 7842: @395152
     /* 395152 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(395185), // Rule ID 1299 //
     /* 395157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395172 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 395175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 395183 */     GIR_RootConstrainSelectedInstOperands,
     /* 395184 */     // GIR_Coverage, 1299,
     /* 395184 */     GIR_EraseRootFromParent_Done,
     /* 395185 */   // Label 7843: @395185
     /* 395185 */   GIM_Reject,
     /* 395186 */ // Label 7824: @395186
     /* 395186 */ GIM_Reject,
     /* 395187 */ // Label 7675: @395187
     /* 395187 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(396365),
     /* 395192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395198 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 395201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395205 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(395289), // Rule ID 6112 //
     /* 395210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395242 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395246 */     // MIs[2] Operand 1
     /* 395246 */     // No operand predicates
     /* 395246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395258 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395269 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 395280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 395287 */     GIR_RootConstrainSelectedInstOperands,
     /* 395288 */     // GIR_Coverage, 6112,
     /* 395288 */     GIR_EraseRootFromParent_Done,
     /* 395289 */   // Label 7845: @395289
     /* 395289 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(395370), // Rule ID 6144 //
     /* 395294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395338 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395342 */     // MIs[3] Operand 1
     /* 395342 */     // No operand predicates
     /* 395342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395352 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395368 */     GIR_RootConstrainSelectedInstOperands,
     /* 395369 */     // GIR_Coverage, 6144,
     /* 395369 */     GIR_EraseRootFromParent_Done,
     /* 395370 */   // Label 7846: @395370
     /* 395370 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(395454), // Rule ID 6176 //
     /* 395375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395424 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395428 */     // MIs[3] Operand 1
     /* 395428 */     // No operand predicates
     /* 395428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395434 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395452 */     GIR_RootConstrainSelectedInstOperands,
     /* 395453 */     // GIR_Coverage, 6176,
     /* 395453 */     GIR_EraseRootFromParent_Done,
     /* 395454 */   // Label 7847: @395454
     /* 395454 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(395535), // Rule ID 6080 //
     /* 395459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395507 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395511 */     // MIs[3] Operand 1
     /* 395511 */     // No operand predicates
     /* 395511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395517 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395533 */     GIR_RootConstrainSelectedInstOperands,
     /* 395534 */     // GIR_Coverage, 6080,
     /* 395534 */     GIR_EraseRootFromParent_Done,
     /* 395535 */   // Label 7848: @395535
     /* 395535 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(395604), // Rule ID 2527 //
     /* 395540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395576 */     // MIs[2] Operand 1
     /* 395576 */     // No operand predicates
     /* 395576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395586 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 395589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 395602 */     GIR_RootConstrainSelectedInstOperands,
     /* 395603 */     // GIR_Coverage, 2527,
     /* 395603 */     GIR_EraseRootFromParent_Done,
     /* 395604 */   // Label 7849: @395604
     /* 395604 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(395673), // Rule ID 6048 //
     /* 395609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 395624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 395637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395649 */     // MIs[2] Operand 1
     /* 395649 */     // No operand predicates
     /* 395649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395655 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 395658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 395671 */     GIR_RootConstrainSelectedInstOperands,
     /* 395672 */     // GIR_Coverage, 6048,
     /* 395672 */     GIR_EraseRootFromParent_Done,
     /* 395673 */   // Label 7850: @395673
     /* 395673 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(395772), // Rule ID 6114 //
     /* 395678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 395689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395721 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 395724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 395736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 395740 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 395743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 395764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395770 */     GIR_RootConstrainSelectedInstOperands,
     /* 395771 */     // GIR_Coverage, 6114,
     /* 395771 */     GIR_EraseRootFromParent_Done,
     /* 395772 */   // Label 7851: @395772
     /* 395772 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(395868), // Rule ID 6146 //
     /* 395777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 395800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395819 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 395822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395831 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 395834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395838 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 395841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395866 */     GIR_RootConstrainSelectedInstOperands,
     /* 395867 */     // GIR_Coverage, 6146,
     /* 395867 */     GIR_EraseRootFromParent_Done,
     /* 395868 */   // Label 7852: @395868
     /* 395868 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(395967), // Rule ID 6178 //
     /* 395873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 395901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395916 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 395919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395928 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 395931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 395938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 395948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 395951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 395955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395965 */     GIR_RootConstrainSelectedInstOperands,
     /* 395966 */     // GIR_Coverage, 6178,
     /* 395966 */     GIR_EraseRootFromParent_Done,
     /* 395967 */   // Label 7853: @395967
     /* 395967 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(396063), // Rule ID 6082 //
     /* 395972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 395987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 395999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396014 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 396017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396026 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 396029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 396049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396061 */     GIR_RootConstrainSelectedInstOperands,
     /* 396062 */     // GIR_Coverage, 6082,
     /* 396062 */     GIR_EraseRootFromParent_Done,
     /* 396063 */   // Label 7854: @396063
     /* 396063 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(396147), // Rule ID 2529 //
     /* 396068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 396079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396098 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 396101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 396113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 396133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396145 */     GIR_RootConstrainSelectedInstOperands,
     /* 396146 */     // GIR_Coverage, 2529,
     /* 396146 */     GIR_EraseRootFromParent_Done,
     /* 396147 */   // Label 7855: @396147
     /* 396147 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(396197), // Rule ID 13355 //
     /* 396152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 396163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396182 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 396185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396195 */     GIR_RootConstrainSelectedInstOperands,
     /* 396196 */     // GIR_Coverage, 13355,
     /* 396196 */     GIR_EraseRootFromParent_Done,
     /* 396197 */   // Label 7856: @396197
     /* 396197 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(396281), // Rule ID 6050 //
     /* 396202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 396217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396232 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 396235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 396247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 396264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 396267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396279 */     GIR_RootConstrainSelectedInstOperands,
     /* 396280 */     // GIR_Coverage, 6050,
     /* 396280 */     GIR_EraseRootFromParent_Done,
     /* 396281 */   // Label 7857: @396281
     /* 396281 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(396331), // Rule ID 1305 //
     /* 396286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 396301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396316 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 396319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396329 */     GIR_RootConstrainSelectedInstOperands,
     /* 396330 */     // GIR_Coverage, 1305,
     /* 396330 */     GIR_EraseRootFromParent_Done,
     /* 396331 */   // Label 7858: @396331
     /* 396331 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(396364), // Rule ID 1295 //
     /* 396336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396351 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 396354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 396358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 396362 */     GIR_RootConstrainSelectedInstOperands,
     /* 396363 */     // GIR_Coverage, 1295,
     /* 396363 */     GIR_EraseRootFromParent_Done,
     /* 396364 */   // Label 7859: @396364
     /* 396364 */   GIM_Reject,
     /* 396365 */ // Label 7844: @396365
     /* 396365 */ GIM_Reject,
     /* 396366 */ // Label 7676: @396366
     /* 396366 */ GIM_Reject,
     /* 396367 */ // Label 108: @396367
     /* 396367 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7868*/ GIMT_Encode4(396666),
     /* 396378 */ /*GILLT_s16*//*Label 7860*/ GIMT_Encode4(396418),
     /* 396382 */ /*GILLT_s32*//*Label 7861*/ GIMT_Encode4(396449),
     /* 396386 */ /*GILLT_s64*//*Label 7862*/ GIMT_Encode4(396480), GIMT_Encode4(0),
     /* 396394 */ /*GILLT_v2s32*//*Label 7863*/ GIMT_Encode4(396511),
     /* 396398 */ /*GILLT_v2s64*//*Label 7864*/ GIMT_Encode4(396542),
     /* 396402 */ /*GILLT_v4s16*//*Label 7865*/ GIMT_Encode4(396573),
     /* 396406 */ /*GILLT_v4s32*//*Label 7866*/ GIMT_Encode4(396604), GIMT_Encode4(0),
     /* 396414 */ /*GILLT_v8s16*//*Label 7867*/ GIMT_Encode4(396635),
     /* 396418 */ // Label 7860: @396418
     /* 396418 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(396448), // Rule ID 569 //
     /* 396423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396437 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 396437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 396442 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396446 */   GIR_RootConstrainSelectedInstOperands,
     /* 396447 */   // GIR_Coverage, 569,
     /* 396447 */   GIR_Done,
     /* 396448 */ // Label 7869: @396448
     /* 396448 */ GIM_Reject,
     /* 396449 */ // Label 7861: @396449
     /* 396449 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(396479), // Rule ID 571 //
     /* 396454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396468 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 396468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 396473 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396477 */   GIR_RootConstrainSelectedInstOperands,
     /* 396478 */   // GIR_Coverage, 571,
     /* 396478 */   GIR_Done,
     /* 396479 */ // Label 7870: @396479
     /* 396479 */ GIM_Reject,
     /* 396480 */ // Label 7862: @396480
     /* 396480 */ GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(396510), // Rule ID 573 //
     /* 396485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396499 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 396499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 396504 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396508 */   GIR_RootConstrainSelectedInstOperands,
     /* 396509 */   // GIR_Coverage, 573,
     /* 396509 */   GIR_Done,
     /* 396510 */ // Label 7871: @396510
     /* 396510 */ GIM_Reject,
     /* 396511 */ // Label 7863: @396511
     /* 396511 */ GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(396541), // Rule ID 959 //
     /* 396516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396530 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 396530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 396535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396539 */   GIR_RootConstrainSelectedInstOperands,
     /* 396540 */   // GIR_Coverage, 959,
     /* 396540 */   GIR_Done,
     /* 396541 */ // Label 7872: @396541
     /* 396541 */ GIM_Reject,
     /* 396542 */ // Label 7864: @396542
     /* 396542 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(396572), // Rule ID 963 //
     /* 396547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396561 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 396561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 396566 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396570 */   GIR_RootConstrainSelectedInstOperands,
     /* 396571 */   // GIR_Coverage, 963,
     /* 396571 */   GIR_Done,
     /* 396572 */ // Label 7873: @396572
     /* 396572 */ GIM_Reject,
     /* 396573 */ // Label 7865: @396573
     /* 396573 */ GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(396603), // Rule ID 955 //
     /* 396578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396592 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 396592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 396597 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396601 */   GIR_RootConstrainSelectedInstOperands,
     /* 396602 */   // GIR_Coverage, 955,
     /* 396602 */   GIR_Done,
     /* 396603 */ // Label 7874: @396603
     /* 396603 */ GIM_Reject,
     /* 396604 */ // Label 7866: @396604
     /* 396604 */ GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(396634), // Rule ID 961 //
     /* 396609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396623 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 396623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 396628 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396632 */   GIR_RootConstrainSelectedInstOperands,
     /* 396633 */   // GIR_Coverage, 961,
     /* 396633 */   GIR_Done,
     /* 396634 */ // Label 7875: @396634
     /* 396634 */ GIM_Reject,
     /* 396635 */ // Label 7867: @396635
     /* 396635 */ GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(396665), // Rule ID 957 //
     /* 396640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396654 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 396654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 396659 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396663 */   GIR_RootConstrainSelectedInstOperands,
     /* 396664 */   // GIR_Coverage, 957,
     /* 396664 */   GIR_Done,
     /* 396665 */ // Label 7876: @396665
     /* 396665 */ GIM_Reject,
     /* 396666 */ // Label 7868: @396666
     /* 396666 */ GIM_Reject,
     /* 396667 */ // Label 109: @396667
     /* 396667 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(396680), // Rule ID 6527 //
     /* 396672 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 396672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 396675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 396678 */   GIR_RootConstrainSelectedInstOperands,
     /* 396679 */   // GIR_Coverage, 6527,
     /* 396679 */   GIR_EraseRootFromParent_Done,
     /* 396680 */ // Label 7877: @396680
     /* 396680 */ GIM_Reject,
     /* 396681 */ // Label 110: @396681
     /* 396681 */ GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(396701), // Rule ID 6528 //
     /* 396686 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 396686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 396689 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 396699 */   GIR_RootConstrainSelectedInstOperands,
     /* 396700 */   // GIR_Coverage, 6528,
     /* 396700 */   GIR_EraseRootFromParent_Done,
     /* 396701 */ // Label 7878: @396701
     /* 396701 */ GIM_Reject,
     /* 396702 */ // Label 111: @396702
     /* 396702 */ GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(396726), // Rule ID 6529 //
     /* 396707 */   // MIs[0] kind
     /* 396707 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 396710 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 396715 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 396715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 396718 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 396724 */   GIR_RootConstrainSelectedInstOperands,
     /* 396725 */   // GIR_Coverage, 6529,
     /* 396725 */   GIR_EraseRootFromParent_Done,
     /* 396726 */ // Label 7879: @396726
     /* 396726 */ GIM_Reject,
     /* 396727 */ // Label 112: @396727
     /* 396727 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7883*/ GIMT_Encode4(397036),
     /* 396738 */ /*GILLT_s16*//*Label 7880*/ GIMT_Encode4(396750),
     /* 396742 */ /*GILLT_s32*//*Label 7881*/ GIMT_Encode4(396903),
     /* 396746 */ /*GILLT_s64*//*Label 7882*/ GIMT_Encode4(397008),
     /* 396750 */ // Label 7880: @396750
     /* 396750 */ GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(396851), // Rule ID 5606 //
     /* 396755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396769 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 396769 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 396772 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 396776 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396781 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396785 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396791 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396794 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 396798 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396803 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 396806 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396824 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 396831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 396844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396849 */   GIR_RootConstrainSelectedInstOperands,
     /* 396850 */   // GIR_Coverage, 5606,
     /* 396850 */   GIR_EraseRootFromParent_Done,
     /* 396851 */ // Label 7884: @396851
     /* 396851 */ GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(396902), // Rule ID 5607 //
     /* 396856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396870 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 396870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 396877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 396895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396900 */   GIR_RootConstrainSelectedInstOperands,
     /* 396901 */   // GIR_Coverage, 5607,
     /* 396901 */   GIR_EraseRootFromParent_Done,
     /* 396902 */ // Label 7885: @396902
     /* 396902 */ GIM_Reject,
     /* 396903 */ // Label 7881: @396903
     /* 396903 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(396980), // Rule ID 5608 //
     /* 396908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396919 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 396919 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396922 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 396926 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396931 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396935 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396953 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 396960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 396973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396978 */   GIR_RootConstrainSelectedInstOperands,
     /* 396979 */   // GIR_Coverage, 5608,
     /* 396979 */   GIR_EraseRootFromParent_Done,
     /* 396980 */ // Label 7886: @396980
     /* 396980 */ GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(397007), // Rule ID 5609 //
     /* 396985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396996 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 396996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 397001 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397005 */   GIR_RootConstrainSelectedInstOperands,
     /* 397006 */   // GIR_Coverage, 5609,
     /* 397006 */   GIR_Done,
     /* 397007 */ // Label 7887: @397007
     /* 397007 */ GIM_Reject,
     /* 397008 */ // Label 7882: @397008
     /* 397008 */ GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(397035), // Rule ID 5610 //
     /* 397013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397024 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 397029 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397033 */   GIR_RootConstrainSelectedInstOperands,
     /* 397034 */   // GIR_Coverage, 5610,
     /* 397034 */   GIR_Done,
     /* 397035 */ // Label 7888: @397035
     /* 397035 */ GIM_Reject,
     /* 397036 */ // Label 7883: @397036
     /* 397036 */ GIM_Reject,
     /* 397037 */ // Label 113: @397037
     /* 397037 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7892*/ GIMT_Encode4(397207),
     /* 397048 */ /*GILLT_s16*//*Label 7889*/ GIMT_Encode4(397060),
     /* 397052 */ /*GILLT_s32*//*Label 7890*/ GIMT_Encode4(397121),
     /* 397056 */ /*GILLT_s64*//*Label 7891*/ GIMT_Encode4(397179),
     /* 397060 */ // Label 7889: @397060
     /* 397060 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(397090), // Rule ID 1942 //
     /* 397065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397079 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 397079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 397084 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397088 */   GIR_RootConstrainSelectedInstOperands,
     /* 397089 */   // GIR_Coverage, 1942,
     /* 397089 */   GIR_Done,
     /* 397090 */ // Label 7893: @397090
     /* 397090 */ GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(397120), // Rule ID 1944 //
     /* 397095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397109 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 397109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 397114 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397118 */   GIR_RootConstrainSelectedInstOperands,
     /* 397119 */   // GIR_Coverage, 1944,
     /* 397119 */   GIR_Done,
     /* 397120 */ // Label 7894: @397120
     /* 397120 */ GIM_Reject,
     /* 397121 */ // Label 7890: @397121
     /* 397121 */ GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(397151), // Rule ID 1946 //
     /* 397126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397140 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 397140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 397145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397149 */   GIR_RootConstrainSelectedInstOperands,
     /* 397150 */   // GIR_Coverage, 1946,
     /* 397150 */   GIR_Done,
     /* 397151 */ // Label 7895: @397151
     /* 397151 */ GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(397178), // Rule ID 5616 //
     /* 397156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397167 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 397172 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397176 */   GIR_RootConstrainSelectedInstOperands,
     /* 397177 */   // GIR_Coverage, 5616,
     /* 397177 */   GIR_Done,
     /* 397178 */ // Label 7896: @397178
     /* 397178 */ GIM_Reject,
     /* 397179 */ // Label 7891: @397179
     /* 397179 */ GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(397206), // Rule ID 5618 //
     /* 397184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397195 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 397200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397204 */   GIR_RootConstrainSelectedInstOperands,
     /* 397205 */   // GIR_Coverage, 5618,
     /* 397205 */   GIR_Done,
     /* 397206 */ // Label 7897: @397206
     /* 397206 */ GIM_Reject,
     /* 397207 */ // Label 7892: @397207
     /* 397207 */ GIM_Reject,
     /* 397208 */ // Label 114: @397208
     /* 397208 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7901*/ GIMT_Encode4(397378),
     /* 397219 */ /*GILLT_s16*//*Label 7898*/ GIMT_Encode4(397231),
     /* 397223 */ /*GILLT_s32*//*Label 7899*/ GIMT_Encode4(397292),
     /* 397227 */ /*GILLT_s64*//*Label 7900*/ GIMT_Encode4(397350),
     /* 397231 */ // Label 7898: @397231
     /* 397231 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(397261), // Rule ID 1954 //
     /* 397236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397250 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 397250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 397255 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397259 */   GIR_RootConstrainSelectedInstOperands,
     /* 397260 */   // GIR_Coverage, 1954,
     /* 397260 */   GIR_Done,
     /* 397261 */ // Label 7902: @397261
     /* 397261 */ GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(397291), // Rule ID 1956 //
     /* 397266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397280 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 397280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 397285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397289 */   GIR_RootConstrainSelectedInstOperands,
     /* 397290 */   // GIR_Coverage, 1956,
     /* 397290 */   GIR_Done,
     /* 397291 */ // Label 7903: @397291
     /* 397291 */ GIM_Reject,
     /* 397292 */ // Label 7899: @397292
     /* 397292 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(397322), // Rule ID 1958 //
     /* 397297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397311 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 397311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 397316 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397320 */   GIR_RootConstrainSelectedInstOperands,
     /* 397321 */   // GIR_Coverage, 1958,
     /* 397321 */   GIR_Done,
     /* 397322 */ // Label 7904: @397322
     /* 397322 */ GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(397349), // Rule ID 5624 //
     /* 397327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397338 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 397343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397347 */   GIR_RootConstrainSelectedInstOperands,
     /* 397348 */   // GIR_Coverage, 5624,
     /* 397348 */   GIR_Done,
     /* 397349 */ // Label 7905: @397349
     /* 397349 */ GIM_Reject,
     /* 397350 */ // Label 7900: @397350
     /* 397350 */ GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(397377), // Rule ID 5626 //
     /* 397355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397366 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 397371 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397375 */   GIR_RootConstrainSelectedInstOperands,
     /* 397376 */   // GIR_Coverage, 5626,
     /* 397376 */   GIR_Done,
     /* 397377 */ // Label 7906: @397377
     /* 397377 */ GIM_Reject,
     /* 397378 */ // Label 7901: @397378
     /* 397378 */ GIM_Reject,
     /* 397379 */ // Label 115: @397379
     /* 397379 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7910*/ GIMT_Encode4(397549),
     /* 397390 */ /*GILLT_s16*//*Label 7907*/ GIMT_Encode4(397402),
     /* 397394 */ /*GILLT_s32*//*Label 7908*/ GIMT_Encode4(397463),
     /* 397398 */ /*GILLT_s64*//*Label 7909*/ GIMT_Encode4(397521),
     /* 397402 */ // Label 7907: @397402
     /* 397402 */ GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(397432), // Rule ID 1948 //
     /* 397407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397421 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 397421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 397426 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397430 */   GIR_RootConstrainSelectedInstOperands,
     /* 397431 */   // GIR_Coverage, 1948,
     /* 397431 */   GIR_Done,
     /* 397432 */ // Label 7911: @397432
     /* 397432 */ GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(397462), // Rule ID 1950 //
     /* 397437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397451 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 397451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 397456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397460 */   GIR_RootConstrainSelectedInstOperands,
     /* 397461 */   // GIR_Coverage, 1950,
     /* 397461 */   GIR_Done,
     /* 397462 */ // Label 7912: @397462
     /* 397462 */ GIM_Reject,
     /* 397463 */ // Label 7908: @397463
     /* 397463 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(397493), // Rule ID 1952 //
     /* 397468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397482 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 397482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 397487 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397491 */   GIR_RootConstrainSelectedInstOperands,
     /* 397492 */   // GIR_Coverage, 1952,
     /* 397492 */   GIR_Done,
     /* 397493 */ // Label 7913: @397493
     /* 397493 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(397520), // Rule ID 5620 //
     /* 397498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397509 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 397514 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397518 */   GIR_RootConstrainSelectedInstOperands,
     /* 397519 */   // GIR_Coverage, 5620,
     /* 397519 */   GIR_Done,
     /* 397520 */ // Label 7914: @397520
     /* 397520 */ GIM_Reject,
     /* 397521 */ // Label 7909: @397521
     /* 397521 */ GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(397548), // Rule ID 5622 //
     /* 397526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397537 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 397542 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397546 */   GIR_RootConstrainSelectedInstOperands,
     /* 397547 */   // GIR_Coverage, 5622,
     /* 397547 */   GIR_Done,
     /* 397548 */ // Label 7915: @397548
     /* 397548 */ GIM_Reject,
     /* 397549 */ // Label 7910: @397549
     /* 397549 */ GIM_Reject,
     /* 397550 */ // Label 116: @397550
     /* 397550 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7919*/ GIMT_Encode4(397720),
     /* 397561 */ /*GILLT_s16*//*Label 7916*/ GIMT_Encode4(397573),
     /* 397565 */ /*GILLT_s32*//*Label 7917*/ GIMT_Encode4(397634),
     /* 397569 */ /*GILLT_s64*//*Label 7918*/ GIMT_Encode4(397692),
     /* 397573 */ // Label 7916: @397573
     /* 397573 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(397603), // Rule ID 1960 //
     /* 397578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397592 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 397592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 397597 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397601 */   GIR_RootConstrainSelectedInstOperands,
     /* 397602 */   // GIR_Coverage, 1960,
     /* 397602 */   GIR_Done,
     /* 397603 */ // Label 7920: @397603
     /* 397603 */ GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(397633), // Rule ID 1962 //
     /* 397608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397622 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 397622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 397627 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397631 */   GIR_RootConstrainSelectedInstOperands,
     /* 397632 */   // GIR_Coverage, 1962,
     /* 397632 */   GIR_Done,
     /* 397633 */ // Label 7921: @397633
     /* 397633 */ GIM_Reject,
     /* 397634 */ // Label 7917: @397634
     /* 397634 */ GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(397664), // Rule ID 1964 //
     /* 397639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397653 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 397653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 397658 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397662 */   GIR_RootConstrainSelectedInstOperands,
     /* 397663 */   // GIR_Coverage, 1964,
     /* 397663 */   GIR_Done,
     /* 397664 */ // Label 7922: @397664
     /* 397664 */ GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(397691), // Rule ID 5628 //
     /* 397669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397680 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 397680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 397685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397689 */   GIR_RootConstrainSelectedInstOperands,
     /* 397690 */   // GIR_Coverage, 5628,
     /* 397690 */   GIR_Done,
     /* 397691 */ // Label 7923: @397691
     /* 397691 */ GIM_Reject,
     /* 397692 */ // Label 7918: @397692
     /* 397692 */ GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(397719), // Rule ID 5630 //
     /* 397697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397708 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 397708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 397713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397717 */   GIR_RootConstrainSelectedInstOperands,
     /* 397718 */   // GIR_Coverage, 5630,
     /* 397718 */   GIR_Done,
     /* 397719 */ // Label 7924: @397719
     /* 397719 */ GIM_Reject,
     /* 397720 */ // Label 7919: @397720
     /* 397720 */ GIM_Reject,
     /* 397721 */ // Label 117: @397721
     /* 397721 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7929*/ GIMT_Encode4(398849),
     /* 397732 */ /*GILLT_s8*//*Label 7925*/ GIMT_Encode4(397748),
     /* 397736 */ /*GILLT_s16*//*Label 7926*/ GIMT_Encode4(397795),
     /* 397740 */ /*GILLT_s32*//*Label 7927*/ GIMT_Encode4(398210),
     /* 397744 */ /*GILLT_s64*//*Label 7928*/ GIMT_Encode4(398663),
     /* 397748 */ // Label 7925: @397748
     /* 397748 */ GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(397771), // Rule ID 5901 //
     /* 397753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 397756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397764 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 397764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 397769 */   GIR_RootConstrainSelectedInstOperands,
     /* 397770 */   // GIR_Coverage, 5901,
     /* 397770 */   GIR_Done,
     /* 397771 */ // Label 7930: @397771
     /* 397771 */ GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(397794), // Rule ID 5902 //
     /* 397776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397787 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 397787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 397792 */   GIR_RootConstrainSelectedInstOperands,
     /* 397793 */   // GIR_Coverage, 5902,
     /* 397793 */   GIR_Done,
     /* 397794 */ // Label 7931: @397794
     /* 397794 */ GIM_Reject,
     /* 397795 */ // Label 7926: @397795
     /* 397795 */ GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(397845), // Rule ID 5848 //
     /* 397800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397807 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397815 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397818 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 397823 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 397827 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397834 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 397834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 397837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397839 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397843 */   GIR_RootConstrainSelectedInstOperands,
     /* 397844 */   // GIR_Coverage, 5848,
     /* 397844 */   GIR_EraseRootFromParent_Done,
     /* 397845 */ // Label 7932: @397845
     /* 397845 */ GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(397895), // Rule ID 5850 //
     /* 397850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397865 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397868 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 397873 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 397877 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397882 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397884 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 397884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 397887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397889 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397893 */   GIR_RootConstrainSelectedInstOperands,
     /* 397894 */   // GIR_Coverage, 5850,
     /* 397894 */   GIR_EraseRootFromParent_Done,
     /* 397895 */ // Label 7933: @397895
     /* 397895 */ GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(397945), // Rule ID 5858 //
     /* 397900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397915 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397918 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 397923 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 397927 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397934 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 397934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 397937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397943 */   GIR_RootConstrainSelectedInstOperands,
     /* 397944 */   // GIR_Coverage, 5858,
     /* 397944 */   GIR_EraseRootFromParent_Done,
     /* 397945 */ // Label 7934: @397945
     /* 397945 */ GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(397995), // Rule ID 5860 //
     /* 397950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397965 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397968 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 397973 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 397977 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397982 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397984 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 397984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 397987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397989 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397993 */   GIR_RootConstrainSelectedInstOperands,
     /* 397994 */   // GIR_Coverage, 5860,
     /* 397994 */   GIR_EraseRootFromParent_Done,
     /* 397995 */ // Label 7935: @397995
     /* 397995 */ GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(398037), // Rule ID 5857 //
     /* 398000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398015 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398019 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398026 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 398026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 398029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398031 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398035 */   GIR_RootConstrainSelectedInstOperands,
     /* 398036 */   // GIR_Coverage, 5857,
     /* 398036 */   GIR_EraseRootFromParent_Done,
     /* 398037 */ // Label 7936: @398037
     /* 398037 */ GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(398079), // Rule ID 5859 //
     /* 398042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398049 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398053 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398057 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398061 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398068 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 398068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 398071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398073 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398077 */   GIR_RootConstrainSelectedInstOperands,
     /* 398078 */   // GIR_Coverage, 5859,
     /* 398078 */   GIR_EraseRootFromParent_Done,
     /* 398079 */ // Label 7937: @398079
     /* 398079 */ GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(398121), // Rule ID 5847 //
     /* 398084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398099 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398103 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398108 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398110 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 398110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 398113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398115 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398119 */   GIR_RootConstrainSelectedInstOperands,
     /* 398120 */   // GIR_Coverage, 5847,
     /* 398120 */   GIR_EraseRootFromParent_Done,
     /* 398121 */ // Label 7938: @398121
     /* 398121 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(398163), // Rule ID 5849 //
     /* 398126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398133 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398141 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398145 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398152 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 398152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 398155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398157 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398161 */   GIR_RootConstrainSelectedInstOperands,
     /* 398162 */   // GIR_Coverage, 5849,
     /* 398162 */   GIR_EraseRootFromParent_Done,
     /* 398163 */ // Label 7939: @398163
     /* 398163 */ GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(398186), // Rule ID 5903 //
     /* 398168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398179 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 398179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 398184 */   GIR_RootConstrainSelectedInstOperands,
     /* 398185 */   // GIR_Coverage, 5903,
     /* 398185 */   GIR_Done,
     /* 398186 */ // Label 7940: @398186
     /* 398186 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(398209), // Rule ID 5904 //
     /* 398191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398202 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 398202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 398207 */   GIR_RootConstrainSelectedInstOperands,
     /* 398208 */   // GIR_Coverage, 5904,
     /* 398208 */   GIR_Done,
     /* 398209 */ // Label 7941: @398209
     /* 398209 */ GIM_Reject,
     /* 398210 */ // Label 7927: @398210
     /* 398210 */ GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(398260), // Rule ID 5852 //
     /* 398215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398222 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398230 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398233 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398238 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398247 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398249 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 398252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398254 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398258 */   GIR_RootConstrainSelectedInstOperands,
     /* 398259 */   // GIR_Coverage, 5852,
     /* 398259 */   GIR_EraseRootFromParent_Done,
     /* 398260 */ // Label 7942: @398260
     /* 398260 */ GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(398310), // Rule ID 5854 //
     /* 398265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398272 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398276 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398280 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398283 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398288 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398292 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398297 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398299 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 398302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398304 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398308 */   GIR_RootConstrainSelectedInstOperands,
     /* 398309 */   // GIR_Coverage, 5854,
     /* 398309 */   GIR_EraseRootFromParent_Done,
     /* 398310 */ // Label 7943: @398310
     /* 398310 */ GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(398360), // Rule ID 5862 //
     /* 398315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398330 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398333 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 398338 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398342 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398349 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 398352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398354 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398358 */   GIR_RootConstrainSelectedInstOperands,
     /* 398359 */   // GIR_Coverage, 5862,
     /* 398359 */   GIR_EraseRootFromParent_Done,
     /* 398360 */ // Label 7944: @398360
     /* 398360 */ GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(398410), // Rule ID 5864 //
     /* 398365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398380 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398383 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 398388 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398392 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398399 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 398402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398404 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398408 */   GIR_RootConstrainSelectedInstOperands,
     /* 398409 */   // GIR_Coverage, 5864,
     /* 398409 */   GIR_EraseRootFromParent_Done,
     /* 398410 */ // Label 7945: @398410
     /* 398410 */ GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(398452), // Rule ID 5861 //
     /* 398415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398430 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398434 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398439 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398441 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 398444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398446 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398450 */   GIR_RootConstrainSelectedInstOperands,
     /* 398451 */   // GIR_Coverage, 5861,
     /* 398451 */   GIR_EraseRootFromParent_Done,
     /* 398452 */ // Label 7946: @398452
     /* 398452 */ GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(398494), // Rule ID 5863 //
     /* 398457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398464 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398472 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398476 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398483 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 398486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398488 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398492 */   GIR_RootConstrainSelectedInstOperands,
     /* 398493 */   // GIR_Coverage, 5863,
     /* 398493 */   GIR_EraseRootFromParent_Done,
     /* 398494 */ // Label 7947: @398494
     /* 398494 */ GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(398536), // Rule ID 5851 //
     /* 398499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398514 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398518 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398525 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 398528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398530 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398534 */   GIR_RootConstrainSelectedInstOperands,
     /* 398535 */   // GIR_Coverage, 5851,
     /* 398535 */   GIR_EraseRootFromParent_Done,
     /* 398536 */ // Label 7948: @398536
     /* 398536 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(398578), // Rule ID 5853 //
     /* 398541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398556 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398560 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398567 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 398570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398572 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398576 */   GIR_RootConstrainSelectedInstOperands,
     /* 398577 */   // GIR_Coverage, 5853,
     /* 398577 */   GIR_EraseRootFromParent_Done,
     /* 398578 */ // Label 7949: @398578
     /* 398578 */ GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(398639), // Rule ID 5905 //
     /* 398583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398594 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 398594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 398601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398606 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398610 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398621 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 398628 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398638 */   // GIR_Coverage, 5905,
     /* 398638 */   GIR_EraseRootFromParent_Done,
     /* 398639 */ // Label 7950: @398639
     /* 398639 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(398662), // Rule ID 5906 //
     /* 398644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398655 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 398655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 398660 */   GIR_RootConstrainSelectedInstOperands,
     /* 398661 */   // GIR_Coverage, 5906,
     /* 398661 */   GIR_Done,
     /* 398662 */ // Label 7951: @398662
     /* 398662 */ GIM_Reject,
     /* 398663 */ // Label 7928: @398663
     /* 398663 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(398848),
     /* 398668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398675 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(398718), // Rule ID 5856 //
     /* 398680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398688 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398691 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398707 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 398710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398716 */     GIR_RootConstrainSelectedInstOperands,
     /* 398717 */     // GIR_Coverage, 5856,
     /* 398717 */     GIR_EraseRootFromParent_Done,
     /* 398718 */   // Label 7953: @398718
     /* 398718 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(398761), // Rule ID 5866 //
     /* 398723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398731 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398734 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 398739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398750 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 398753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 398759 */     GIR_RootConstrainSelectedInstOperands,
     /* 398760 */     // GIR_Coverage, 5866,
     /* 398760 */     GIR_EraseRootFromParent_Done,
     /* 398761 */   // Label 7954: @398761
     /* 398761 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(398796), // Rule ID 5865 //
     /* 398766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 398774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398785 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 398788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398794 */     GIR_RootConstrainSelectedInstOperands,
     /* 398795 */     // GIR_Coverage, 5865,
     /* 398795 */     GIR_EraseRootFromParent_Done,
     /* 398796 */   // Label 7955: @398796
     /* 398796 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(398831), // Rule ID 5855 //
     /* 398801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398820 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 398823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398829 */     GIR_RootConstrainSelectedInstOperands,
     /* 398830 */     // GIR_Coverage, 5855,
     /* 398830 */     GIR_EraseRootFromParent_Done,
     /* 398831 */   // Label 7956: @398831
     /* 398831 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(398847), // Rule ID 5907 //
     /* 398836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398840 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 398840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 398845 */     GIR_RootConstrainSelectedInstOperands,
     /* 398846 */     // GIR_Coverage, 5907,
     /* 398846 */     GIR_Done,
     /* 398847 */   // Label 7957: @398847
     /* 398847 */   GIM_Reject,
     /* 398848 */ // Label 7952: @398848
     /* 398848 */ GIM_Reject,
     /* 398849 */ // Label 7929: @398849
     /* 398849 */ GIM_Reject,
     /* 398850 */ // Label 118: @398850
     /* 398850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7961*/ GIMT_Encode4(399052),
     /* 398861 */ /*GILLT_s8*//*Label 7958*/ GIMT_Encode4(398873),
     /* 398865 */ /*GILLT_s16*//*Label 7959*/ GIMT_Encode4(398920),
     /* 398869 */ /*GILLT_s32*//*Label 7960*/ GIMT_Encode4(398967),
     /* 398873 */ // Label 7958: @398873
     /* 398873 */ GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(398896), // Rule ID 5998 //
     /* 398878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 398885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398889 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 398889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 398894 */   GIR_RootConstrainSelectedInstOperands,
     /* 398895 */   // GIR_Coverage, 5998,
     /* 398895 */   GIR_Done,
     /* 398896 */ // Label 7962: @398896
     /* 398896 */ GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(398919), // Rule ID 5999 //
     /* 398901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 398908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398912 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 398912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 398917 */   GIR_RootConstrainSelectedInstOperands,
     /* 398918 */   // GIR_Coverage, 5999,
     /* 398918 */   GIR_Done,
     /* 398919 */ // Label 7963: @398919
     /* 398919 */ GIM_Reject,
     /* 398920 */ // Label 7959: @398920
     /* 398920 */ GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(398943), // Rule ID 6000 //
     /* 398925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398936 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 398936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 398941 */   GIR_RootConstrainSelectedInstOperands,
     /* 398942 */   // GIR_Coverage, 6000,
     /* 398942 */   GIR_Done,
     /* 398943 */ // Label 7964: @398943
     /* 398943 */ GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(398966), // Rule ID 6001 //
     /* 398948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398959 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 398959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 398964 */   GIR_RootConstrainSelectedInstOperands,
     /* 398965 */   // GIR_Coverage, 6001,
     /* 398965 */   GIR_Done,
     /* 398966 */ // Label 7965: @398966
     /* 398966 */ GIM_Reject,
     /* 398967 */ // Label 7960: @398967
     /* 398967 */ GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(398990), // Rule ID 6002 //
     /* 398972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398983 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 398983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 398988 */   GIR_RootConstrainSelectedInstOperands,
     /* 398989 */   // GIR_Coverage, 6002,
     /* 398989 */   GIR_Done,
     /* 398990 */ // Label 7966: @398990
     /* 398990 */ GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(399051), // Rule ID 6003 //
     /* 398995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399006 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 399006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 399013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399018 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399022 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399033 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 399040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399045 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399050 */   // GIR_Coverage, 6003,
     /* 399050 */   GIR_EraseRootFromParent_Done,
     /* 399051 */ // Label 7967: @399051
     /* 399051 */ GIM_Reject,
     /* 399052 */ // Label 7961: @399052
     /* 399052 */ GIM_Reject,
     /* 399053 */ // Label 119: @399053
     /* 399053 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7971*/ GIMT_Encode4(399255),
     /* 399064 */ /*GILLT_s8*//*Label 7968*/ GIMT_Encode4(399076),
     /* 399068 */ /*GILLT_s16*//*Label 7969*/ GIMT_Encode4(399123),
     /* 399072 */ /*GILLT_s32*//*Label 7970*/ GIMT_Encode4(399170),
     /* 399076 */ // Label 7968: @399076
     /* 399076 */ GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(399099), // Rule ID 5992 //
     /* 399081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399092 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 399092 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 399097 */   GIR_RootConstrainSelectedInstOperands,
     /* 399098 */   // GIR_Coverage, 5992,
     /* 399098 */   GIR_Done,
     /* 399099 */ // Label 7972: @399099
     /* 399099 */ GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(399122), // Rule ID 5993 //
     /* 399104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399115 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 399115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 399120 */   GIR_RootConstrainSelectedInstOperands,
     /* 399121 */   // GIR_Coverage, 5993,
     /* 399121 */   GIR_Done,
     /* 399122 */ // Label 7973: @399122
     /* 399122 */ GIM_Reject,
     /* 399123 */ // Label 7969: @399123
     /* 399123 */ GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(399146), // Rule ID 5994 //
     /* 399128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399139 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 399139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 399144 */   GIR_RootConstrainSelectedInstOperands,
     /* 399145 */   // GIR_Coverage, 5994,
     /* 399145 */   GIR_Done,
     /* 399146 */ // Label 7974: @399146
     /* 399146 */ GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(399169), // Rule ID 5995 //
     /* 399151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399162 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 399162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 399167 */   GIR_RootConstrainSelectedInstOperands,
     /* 399168 */   // GIR_Coverage, 5995,
     /* 399168 */   GIR_Done,
     /* 399169 */ // Label 7975: @399169
     /* 399169 */ GIM_Reject,
     /* 399170 */ // Label 7970: @399170
     /* 399170 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(399193), // Rule ID 5996 //
     /* 399175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399186 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 399186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 399191 */   GIR_RootConstrainSelectedInstOperands,
     /* 399192 */   // GIR_Coverage, 5996,
     /* 399192 */   GIR_Done,
     /* 399193 */ // Label 7976: @399193
     /* 399193 */ GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(399254), // Rule ID 5997 //
     /* 399198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399209 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 399209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 399216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399221 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399225 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399236 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 399243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399253 */   // GIR_Coverage, 5997,
     /* 399253 */   GIR_EraseRootFromParent_Done,
     /* 399254 */ // Label 7977: @399254
     /* 399254 */ GIM_Reject,
     /* 399255 */ // Label 7971: @399255
     /* 399255 */ GIM_Reject,
     /* 399256 */ // Label 120: @399256
     /* 399256 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7981*/ GIMT_Encode4(399458),
     /* 399267 */ /*GILLT_s8*//*Label 7978*/ GIMT_Encode4(399279),
     /* 399271 */ /*GILLT_s16*//*Label 7979*/ GIMT_Encode4(399326),
     /* 399275 */ /*GILLT_s32*//*Label 7980*/ GIMT_Encode4(399373),
     /* 399279 */ // Label 7978: @399279
     /* 399279 */ GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(399302), // Rule ID 5986 //
     /* 399284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399295 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 399295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 399300 */   GIR_RootConstrainSelectedInstOperands,
     /* 399301 */   // GIR_Coverage, 5986,
     /* 399301 */   GIR_Done,
     /* 399302 */ // Label 7982: @399302
     /* 399302 */ GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(399325), // Rule ID 5987 //
     /* 399307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399318 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 399318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 399323 */   GIR_RootConstrainSelectedInstOperands,
     /* 399324 */   // GIR_Coverage, 5987,
     /* 399324 */   GIR_Done,
     /* 399325 */ // Label 7983: @399325
     /* 399325 */ GIM_Reject,
     /* 399326 */ // Label 7979: @399326
     /* 399326 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(399349), // Rule ID 5988 //
     /* 399331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399342 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 399342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 399347 */   GIR_RootConstrainSelectedInstOperands,
     /* 399348 */   // GIR_Coverage, 5988,
     /* 399348 */   GIR_Done,
     /* 399349 */ // Label 7984: @399349
     /* 399349 */ GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(399372), // Rule ID 5989 //
     /* 399354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399365 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 399365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 399370 */   GIR_RootConstrainSelectedInstOperands,
     /* 399371 */   // GIR_Coverage, 5989,
     /* 399371 */   GIR_Done,
     /* 399372 */ // Label 7985: @399372
     /* 399372 */ GIM_Reject,
     /* 399373 */ // Label 7980: @399373
     /* 399373 */ GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(399396), // Rule ID 5990 //
     /* 399378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399389 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 399389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 399394 */   GIR_RootConstrainSelectedInstOperands,
     /* 399395 */   // GIR_Coverage, 5990,
     /* 399395 */   GIR_Done,
     /* 399396 */ // Label 7986: @399396
     /* 399396 */ GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(399457), // Rule ID 5991 //
     /* 399401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399412 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 399412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 399419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399424 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399428 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399439 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 399446 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399456 */   // GIR_Coverage, 5991,
     /* 399456 */   GIR_EraseRootFromParent_Done,
     /* 399457 */ // Label 7987: @399457
     /* 399457 */ GIM_Reject,
     /* 399458 */ // Label 7981: @399458
     /* 399458 */ GIM_Reject,
     /* 399459 */ // Label 121: @399459
     /* 399459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7991*/ GIMT_Encode4(399661),
     /* 399470 */ /*GILLT_s8*//*Label 7988*/ GIMT_Encode4(399482),
     /* 399474 */ /*GILLT_s16*//*Label 7989*/ GIMT_Encode4(399529),
     /* 399478 */ /*GILLT_s32*//*Label 7990*/ GIMT_Encode4(399576),
     /* 399482 */ // Label 7988: @399482
     /* 399482 */ GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(399505), // Rule ID 5980 //
     /* 399487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399498 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 399498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 399503 */   GIR_RootConstrainSelectedInstOperands,
     /* 399504 */   // GIR_Coverage, 5980,
     /* 399504 */   GIR_Done,
     /* 399505 */ // Label 7992: @399505
     /* 399505 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(399528), // Rule ID 5981 //
     /* 399510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 399517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399521 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 399521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 399526 */   GIR_RootConstrainSelectedInstOperands,
     /* 399527 */   // GIR_Coverage, 5981,
     /* 399527 */   GIR_Done,
     /* 399528 */ // Label 7993: @399528
     /* 399528 */ GIM_Reject,
     /* 399529 */ // Label 7989: @399529
     /* 399529 */ GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(399552), // Rule ID 5982 //
     /* 399534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399545 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 399545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 399550 */   GIR_RootConstrainSelectedInstOperands,
     /* 399551 */   // GIR_Coverage, 5982,
     /* 399551 */   GIR_Done,
     /* 399552 */ // Label 7994: @399552
     /* 399552 */ GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(399575), // Rule ID 5983 //
     /* 399557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399568 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 399568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 399573 */   GIR_RootConstrainSelectedInstOperands,
     /* 399574 */   // GIR_Coverage, 5983,
     /* 399574 */   GIR_Done,
     /* 399575 */ // Label 7995: @399575
     /* 399575 */ GIM_Reject,
     /* 399576 */ // Label 7990: @399576
     /* 399576 */ GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(399599), // Rule ID 5984 //
     /* 399581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399592 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 399592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 399597 */   GIR_RootConstrainSelectedInstOperands,
     /* 399598 */   // GIR_Coverage, 5984,
     /* 399598 */   GIR_Done,
     /* 399599 */ // Label 7996: @399599
     /* 399599 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(399660), // Rule ID 5985 //
     /* 399604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399615 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 399615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 399622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399627 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399631 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399642 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 399649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399654 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399659 */   // GIR_Coverage, 5985,
     /* 399659 */   GIR_EraseRootFromParent_Done,
     /* 399660 */ // Label 7997: @399660
     /* 399660 */ GIM_Reject,
     /* 399661 */ // Label 7991: @399661
     /* 399661 */ GIM_Reject,
     /* 399662 */ // Label 122: @399662
     /* 399662 */ GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(399801),
     /* 399667 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 399670 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 399674 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(399708), // Rule ID 257 //
     /* 399679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 399686 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 399686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 399689 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 399691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 399701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 399706 */     GIR_RootConstrainSelectedInstOperands,
     /* 399707 */     // GIR_Coverage, 257,
     /* 399707 */     GIR_EraseRootFromParent_Done,
     /* 399708 */   // Label 7999: @399708
     /* 399708 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(399742), // Rule ID 258 //
     /* 399713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 399720 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 399720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 399723 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 399725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 399735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 399740 */     GIR_RootConstrainSelectedInstOperands,
     /* 399741 */     // GIR_Coverage, 258,
     /* 399741 */     GIR_EraseRootFromParent_Done,
     /* 399742 */   // Label 8000: @399742
     /* 399742 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(399771), // Rule ID 273 //
     /* 399747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 399754 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 399754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 399757 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 399759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 399769 */     GIR_RootConstrainSelectedInstOperands,
     /* 399770 */     // GIR_Coverage, 273,
     /* 399770 */     GIR_EraseRootFromParent_Done,
     /* 399771 */   // Label 8001: @399771
     /* 399771 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(399800), // Rule ID 294 //
     /* 399776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 399783 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 399783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 399786 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 399788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 399798 */     GIR_RootConstrainSelectedInstOperands,
     /* 399799 */     // GIR_Coverage, 294,
     /* 399799 */     GIR_EraseRootFromParent_Done,
     /* 399800 */   // Label 8002: @399800
     /* 399800 */   GIM_Reject,
     /* 399801 */ // Label 7998: @399801
     /* 399801 */ GIM_Reject,
     /* 399802 */ // Label 123: @399802
     /* 399802 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8015*/ GIMT_Encode4(400341),
     /* 399813 */ /*GILLT_s64*//*Label 8003*/ GIMT_Encode4(399897), GIMT_Encode4(0),
     /* 399821 */ /*GILLT_v2s32*//*Label 8004*/ GIMT_Encode4(399935),
     /* 399825 */ /*GILLT_v2s64*//*Label 8005*/ GIMT_Encode4(399973),
     /* 399829 */ /*GILLT_v4s16*//*Label 8006*/ GIMT_Encode4(400011),
     /* 399833 */ /*GILLT_v4s32*//*Label 8007*/ GIMT_Encode4(400049),
     /* 399837 */ /*GILLT_v8s8*//*Label 8008*/ GIMT_Encode4(400087),
     /* 399841 */ /*GILLT_v8s16*//*Label 8009*/ GIMT_Encode4(400125),
     /* 399845 */ /*GILLT_v16s8*//*Label 8010*/ GIMT_Encode4(400163), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399865 */ /*GILLT_nxv2s64*//*Label 8011*/ GIMT_Encode4(400201), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399877 */ /*GILLT_nxv4s32*//*Label 8012*/ GIMT_Encode4(400236), GIMT_Encode4(0),
     /* 399885 */ /*GILLT_nxv8s16*//*Label 8013*/ GIMT_Encode4(400271), GIMT_Encode4(0),
     /* 399893 */ /*GILLT_nxv16s8*//*Label 8014*/ GIMT_Encode4(400306),
     /* 399897 */ // Label 8003: @399897
     /* 399897 */ GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(399934), // Rule ID 5069 //
     /* 399902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 399911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399923 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399927 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 399927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 399932 */   GIR_RootConstrainSelectedInstOperands,
     /* 399933 */   // GIR_Coverage, 5069,
     /* 399933 */   GIR_Done,
     /* 399934 */ // Label 8016: @399934
     /* 399934 */ GIM_Reject,
     /* 399935 */ // Label 8004: @399935
     /* 399935 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(399972), // Rule ID 5068 //
     /* 399940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 399949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399965 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 399965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 399970 */   GIR_RootConstrainSelectedInstOperands,
     /* 399971 */   // GIR_Coverage, 5068,
     /* 399971 */   GIR_Done,
     /* 399972 */ // Label 8017: @399972
     /* 399972 */ GIM_Reject,
     /* 399973 */ // Label 8005: @399973
     /* 399973 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(400010), // Rule ID 5073 //
     /* 399978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 399987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399999 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400003 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 400003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 400008 */   GIR_RootConstrainSelectedInstOperands,
     /* 400009 */   // GIR_Coverage, 5073,
     /* 400009 */   GIR_Done,
     /* 400010 */ // Label 8018: @400010
     /* 400010 */ GIM_Reject,
     /* 400011 */ // Label 8006: @400011
     /* 400011 */ GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(400048), // Rule ID 5067 //
     /* 400016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 400025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400037 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400041 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 400041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 400046 */   GIR_RootConstrainSelectedInstOperands,
     /* 400047 */   // GIR_Coverage, 5067,
     /* 400047 */   GIR_Done,
     /* 400048 */ // Label 8019: @400048
     /* 400048 */ GIM_Reject,
     /* 400049 */ // Label 8007: @400049
     /* 400049 */ GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(400086), // Rule ID 5072 //
     /* 400054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 400063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400079 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 400079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 400084 */   GIR_RootConstrainSelectedInstOperands,
     /* 400085 */   // GIR_Coverage, 5072,
     /* 400085 */   GIR_Done,
     /* 400086 */ // Label 8020: @400086
     /* 400086 */ GIM_Reject,
     /* 400087 */ // Label 8008: @400087
     /* 400087 */ GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(400124), // Rule ID 5066 //
     /* 400092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 400098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 400101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400113 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400117 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 400117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 400122 */   GIR_RootConstrainSelectedInstOperands,
     /* 400123 */   // GIR_Coverage, 5066,
     /* 400123 */   GIR_Done,
     /* 400124 */ // Label 8021: @400124
     /* 400124 */ GIM_Reject,
     /* 400125 */ // Label 8009: @400125
     /* 400125 */ GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(400162), // Rule ID 5071 //
     /* 400130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 400139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400151 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400155 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 400155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 400160 */   GIR_RootConstrainSelectedInstOperands,
     /* 400161 */   // GIR_Coverage, 5071,
     /* 400161 */   GIR_Done,
     /* 400162 */ // Label 8022: @400162
     /* 400162 */ GIM_Reject,
     /* 400163 */ // Label 8010: @400163
     /* 400163 */ GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(400200), // Rule ID 5070 //
     /* 400168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 400174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 400177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400189 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400193 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 400193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 400198 */   GIR_RootConstrainSelectedInstOperands,
     /* 400199 */   // GIR_Coverage, 5070,
     /* 400199 */   GIR_Done,
     /* 400200 */ // Label 8023: @400200
     /* 400200 */ GIM_Reject,
     /* 400201 */ // Label 8011: @400201
     /* 400201 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(400235), // Rule ID 11902 //
     /* 400206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 400209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 400212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 400215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 400218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400222 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 400222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 400225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400227 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 400229 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 400231 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 400233 */   GIR_RootConstrainSelectedInstOperands,
     /* 400234 */   // GIR_Coverage, 11902,
     /* 400234 */   GIR_EraseRootFromParent_Done,
     /* 400235 */ // Label 8024: @400235
     /* 400235 */ GIM_Reject,
     /* 400236 */ // Label 8012: @400236
     /* 400236 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(400270), // Rule ID 11900 //
     /* 400241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 400244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 400247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 400250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 400253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400257 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 400257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 400260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 400264 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 400266 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 400268 */   GIR_RootConstrainSelectedInstOperands,
     /* 400269 */   // GIR_Coverage, 11900,
     /* 400269 */   GIR_EraseRootFromParent_Done,
     /* 400270 */ // Label 8025: @400270
     /* 400270 */ GIM_Reject,
     /* 400271 */ // Label 8013: @400271
     /* 400271 */ GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(400305), // Rule ID 11898 //
     /* 400276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 400279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 400282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 400285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 400288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400292 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 400292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 400295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400297 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 400299 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 400301 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 400303 */   GIR_RootConstrainSelectedInstOperands,
     /* 400304 */   // GIR_Coverage, 11898,
     /* 400304 */   GIR_EraseRootFromParent_Done,
     /* 400305 */ // Label 8026: @400305
     /* 400305 */ GIM_Reject,
     /* 400306 */ // Label 8014: @400306
     /* 400306 */ GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(400340), // Rule ID 11896 //
     /* 400311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 400314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 400317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 400320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 400323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400327 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 400327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 400330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400332 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 400334 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 400336 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 400338 */   GIR_RootConstrainSelectedInstOperands,
     /* 400339 */   // GIR_Coverage, 11896,
     /* 400339 */   GIR_EraseRootFromParent_Done,
     /* 400340 */ // Label 8027: @400340
     /* 400340 */ GIM_Reject,
     /* 400341 */ // Label 8015: @400341
     /* 400341 */ GIM_Reject,
     /* 400342 */ // Label 124: @400342
     /* 400342 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8036*/ GIMT_Encode4(402164),
     /* 400353 */ /*GILLT_s64*//*Label 8028*/ GIMT_Encode4(400389), GIMT_Encode4(0),
     /* 400361 */ /*GILLT_v2s32*//*Label 8029*/ GIMT_Encode4(400584),
     /* 400365 */ /*GILLT_v2s64*//*Label 8030*/ GIMT_Encode4(400831),
     /* 400369 */ /*GILLT_v4s16*//*Label 8031*/ GIMT_Encode4(401078),
     /* 400373 */ /*GILLT_v4s32*//*Label 8032*/ GIMT_Encode4(401354),
     /* 400377 */ /*GILLT_v8s8*//*Label 8033*/ GIMT_Encode4(401601),
     /* 400381 */ /*GILLT_v8s16*//*Label 8034*/ GIMT_Encode4(401746),
     /* 400385 */ /*GILLT_v16s8*//*Label 8035*/ GIMT_Encode4(402022),
     /* 400389 */ // Label 8028: @400389
     /* 400389 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(400583),
     /* 400394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400401 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(400448), // Rule ID 6425 //
     /* 400406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400421 */     // MIs[1] Rn
     /* 400421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400432 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 400435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400446 */     GIR_RootConstrainSelectedInstOperands,
     /* 400447 */     // GIR_Coverage, 6425,
     /* 400447 */     GIR_EraseRootFromParent_Done,
     /* 400448 */   // Label 8038: @400448
     /* 400448 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(400495), // Rule ID 6436 //
     /* 400453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400461 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400468 */     // MIs[1] Rn
     /* 400468 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400479 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 400482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400493 */     GIR_RootConstrainSelectedInstOperands,
     /* 400494 */     // GIR_Coverage, 6436,
     /* 400494 */     GIR_EraseRootFromParent_Done,
     /* 400495 */   // Label 8039: @400495
     /* 400495 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(400542), // Rule ID 13226 //
     /* 400500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400515 */     // MIs[1] Rn
     /* 400515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400526 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 400529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400540 */     GIR_RootConstrainSelectedInstOperands,
     /* 400541 */     // GIR_Coverage, 13226,
     /* 400541 */     GIR_EraseRootFromParent_Done,
     /* 400542 */   // Label 8040: @400542
     /* 400542 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(400562), // Rule ID 5632 //
     /* 400547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 400551 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 400551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400561 */     // GIR_Coverage, 5632,
     /* 400561 */     GIR_Done,
     /* 400562 */   // Label 8041: @400562
     /* 400562 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(400582), // Rule ID 5633 //
     /* 400567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400571 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 400571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400581 */     // GIR_Coverage, 5633,
     /* 400581 */     GIR_Done,
     /* 400582 */   // Label 8042: @400582
     /* 400582 */   GIM_Reject,
     /* 400583 */ // Label 8037: @400583
     /* 400583 */ GIM_Reject,
     /* 400584 */ // Label 8029: @400584
     /* 400584 */ GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(400830),
     /* 400589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400596 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(400643), // Rule ID 6422 //
     /* 400601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400616 */     // MIs[1] Rn
     /* 400616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400627 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 400630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400641 */     GIR_RootConstrainSelectedInstOperands,
     /* 400642 */     // GIR_Coverage, 6422,
     /* 400642 */     GIR_EraseRootFromParent_Done,
     /* 400643 */   // Label 8044: @400643
     /* 400643 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(400690), // Rule ID 6433 //
     /* 400648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400663 */     // MIs[1] Rn
     /* 400663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400674 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 400677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400688 */     GIR_RootConstrainSelectedInstOperands,
     /* 400689 */     // GIR_Coverage, 6433,
     /* 400689 */     GIR_EraseRootFromParent_Done,
     /* 400690 */   // Label 8045: @400690
     /* 400690 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(400737), // Rule ID 13223 //
     /* 400695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400710 */     // MIs[1] Rn
     /* 400710 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400721 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 400724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400735 */     GIR_RootConstrainSelectedInstOperands,
     /* 400736 */     // GIR_Coverage, 13223,
     /* 400736 */     GIR_EraseRootFromParent_Done,
     /* 400737 */   // Label 8046: @400737
     /* 400737 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(400756), // Rule ID 1916 //
     /* 400742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 400749 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 400749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 400754 */     GIR_RootConstrainSelectedInstOperands,
     /* 400755 */     // GIR_Coverage, 1916,
     /* 400755 */     GIR_Done,
     /* 400756 */   // Label 8047: @400756
     /* 400756 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(400829), // Rule ID 5634 //
     /* 400761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400765 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 400819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400827 */     GIR_RootConstrainSelectedInstOperands,
     /* 400828 */     // GIR_Coverage, 5634,
     /* 400828 */     GIR_EraseRootFromParent_Done,
     /* 400829 */   // Label 8048: @400829
     /* 400829 */   GIM_Reject,
     /* 400830 */ // Label 8043: @400830
     /* 400830 */ GIM_Reject,
     /* 400831 */ // Label 8030: @400831
     /* 400831 */ GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(401077),
     /* 400836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400843 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(400890), // Rule ID 6424 //
     /* 400848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400863 */     // MIs[1] Rn
     /* 400863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400874 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 400877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400888 */     GIR_RootConstrainSelectedInstOperands,
     /* 400889 */     // GIR_Coverage, 6424,
     /* 400889 */     GIR_EraseRootFromParent_Done,
     /* 400890 */   // Label 8050: @400890
     /* 400890 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(400937), // Rule ID 6435 //
     /* 400895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400910 */     // MIs[1] Rn
     /* 400910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400921 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 400924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400935 */     GIR_RootConstrainSelectedInstOperands,
     /* 400936 */     // GIR_Coverage, 6435,
     /* 400936 */     GIR_EraseRootFromParent_Done,
     /* 400937 */   // Label 8051: @400937
     /* 400937 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(400984), // Rule ID 13225 //
     /* 400942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400957 */     // MIs[1] Rn
     /* 400957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400968 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 400971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400982 */     GIR_RootConstrainSelectedInstOperands,
     /* 400983 */     // GIR_Coverage, 13225,
     /* 400983 */     GIR_EraseRootFromParent_Done,
     /* 400984 */   // Label 8052: @400984
     /* 400984 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(401003), // Rule ID 1918 //
     /* 400989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 400996 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 400996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 401001 */     GIR_RootConstrainSelectedInstOperands,
     /* 401002 */     // GIR_Coverage, 1918,
     /* 401002 */     GIR_Done,
     /* 401003 */   // Label 8053: @401003
     /* 401003 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(401076), // Rule ID 5636 //
     /* 401008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401012 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401012 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401015 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401019 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401038 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 401066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401074 */     GIR_RootConstrainSelectedInstOperands,
     /* 401075 */     // GIR_Coverage, 5636,
     /* 401075 */     GIR_EraseRootFromParent_Done,
     /* 401076 */   // Label 8054: @401076
     /* 401076 */   GIM_Reject,
     /* 401077 */ // Label 8049: @401077
     /* 401077 */ GIM_Reject,
     /* 401078 */ // Label 8031: @401078
     /* 401078 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(401139), // Rule ID 6420 //
     /* 401083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401098 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401101 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401105 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 401112 */   // MIs[1] Rn
     /* 401112 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401116 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401123 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 401126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401128 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401137 */   GIR_RootConstrainSelectedInstOperands,
     /* 401138 */   // GIR_Coverage, 6420,
     /* 401138 */   GIR_EraseRootFromParent_Done,
     /* 401139 */ // Label 8055: @401139
     /* 401139 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(401193), // Rule ID 6437 //
     /* 401144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401159 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401162 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401166 */   // MIs[1] Rn
     /* 401166 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401170 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401177 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 401180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401182 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401191 */   GIR_RootConstrainSelectedInstOperands,
     /* 401192 */   // GIR_Coverage, 6437,
     /* 401192 */   GIR_EraseRootFromParent_Done,
     /* 401193 */ // Label 8056: @401193
     /* 401193 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(401247), // Rule ID 13221 //
     /* 401198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401205 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401209 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401213 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401216 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401220 */   // MIs[1] Rn
     /* 401220 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401224 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401231 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 401234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401236 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401245 */   GIR_RootConstrainSelectedInstOperands,
     /* 401246 */   // GIR_Coverage, 13221,
     /* 401246 */   GIR_EraseRootFromParent_Done,
     /* 401247 */ // Label 8057: @401247
     /* 401247 */ GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(401273), // Rule ID 1914 //
     /* 401252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 401266 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 401266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 401271 */   GIR_RootConstrainSelectedInstOperands,
     /* 401272 */   // GIR_Coverage, 1914,
     /* 401272 */   GIR_Done,
     /* 401273 */ // Label 8058: @401273
     /* 401273 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(401353), // Rule ID 5637 //
     /* 401278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401289 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401289 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 401292 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401296 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 401306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401315 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401318 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401322 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 401325 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401330 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401335 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 401343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401351 */   GIR_RootConstrainSelectedInstOperands,
     /* 401352 */   // GIR_Coverage, 5637,
     /* 401352 */   GIR_EraseRootFromParent_Done,
     /* 401353 */ // Label 8059: @401353
     /* 401353 */ GIM_Reject,
     /* 401354 */ // Label 8032: @401354
     /* 401354 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(401600),
     /* 401359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401366 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(401413), // Rule ID 6423 //
     /* 401371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401386 */     // MIs[1] Rn
     /* 401386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401397 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 401400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401411 */     GIR_RootConstrainSelectedInstOperands,
     /* 401412 */     // GIR_Coverage, 6423,
     /* 401412 */     GIR_EraseRootFromParent_Done,
     /* 401413 */   // Label 8061: @401413
     /* 401413 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(401460), // Rule ID 6434 //
     /* 401418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401426 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401433 */     // MIs[1] Rn
     /* 401433 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401444 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 401447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401458 */     GIR_RootConstrainSelectedInstOperands,
     /* 401459 */     // GIR_Coverage, 6434,
     /* 401459 */     GIR_EraseRootFromParent_Done,
     /* 401460 */   // Label 8062: @401460
     /* 401460 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(401507), // Rule ID 13224 //
     /* 401465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401480 */     // MIs[1] Rn
     /* 401480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401491 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 401494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401505 */     GIR_RootConstrainSelectedInstOperands,
     /* 401506 */     // GIR_Coverage, 13224,
     /* 401506 */     GIR_EraseRootFromParent_Done,
     /* 401507 */   // Label 8063: @401507
     /* 401507 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(401526), // Rule ID 1917 //
     /* 401512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 401519 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 401519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 401524 */     GIR_RootConstrainSelectedInstOperands,
     /* 401525 */     // GIR_Coverage, 1917,
     /* 401525 */     GIR_Done,
     /* 401526 */   // Label 8064: @401526
     /* 401526 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(401599), // Rule ID 5635 //
     /* 401531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401535 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401535 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401538 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401542 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401561 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 401571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 401589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401597 */     GIR_RootConstrainSelectedInstOperands,
     /* 401598 */     // GIR_Coverage, 5635,
     /* 401598 */     GIR_EraseRootFromParent_Done,
     /* 401599 */   // Label 8065: @401599
     /* 401599 */   GIM_Reject,
     /* 401600 */ // Label 8060: @401600
     /* 401600 */ GIM_Reject,
     /* 401601 */ // Label 8033: @401601
     /* 401601 */ GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(401658), // Rule ID 13219 //
     /* 401606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 401609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401621 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401624 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401628 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 401632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401634 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 401641 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 401644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 401651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401656 */   GIR_RootConstrainSelectedInstOperands,
     /* 401657 */   // GIR_Coverage, 13219,
     /* 401657 */   GIR_EraseRootFromParent_Done,
     /* 401658 */ // Label 8066: @401658
     /* 401658 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(401719), // Rule ID 6418 //
     /* 401663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401670 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401674 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401678 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401681 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401685 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 401692 */   // MIs[1] Rn
     /* 401692 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401696 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401703 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 401706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401708 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401717 */   GIR_RootConstrainSelectedInstOperands,
     /* 401718 */   // GIR_Coverage, 6418,
     /* 401718 */   GIR_EraseRootFromParent_Done,
     /* 401719 */ // Label 8067: @401719
     /* 401719 */ GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(401745), // Rule ID 1912 //
     /* 401724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 401738 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 401738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 401743 */   GIR_RootConstrainSelectedInstOperands,
     /* 401744 */   // GIR_Coverage, 1912,
     /* 401744 */   GIR_Done,
     /* 401745 */ // Label 8068: @401745
     /* 401745 */ GIM_Reject,
     /* 401746 */ // Label 8034: @401746
     /* 401746 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(401807), // Rule ID 6421 //
     /* 401751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401766 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401769 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401773 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 401780 */   // MIs[1] Rn
     /* 401780 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401784 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401791 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 401794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401796 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401800 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401805 */   GIR_RootConstrainSelectedInstOperands,
     /* 401806 */   // GIR_Coverage, 6421,
     /* 401806 */   GIR_EraseRootFromParent_Done,
     /* 401807 */ // Label 8069: @401807
     /* 401807 */ GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(401861), // Rule ID 6438 //
     /* 401812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401827 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401830 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401834 */   // MIs[1] Rn
     /* 401834 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401838 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401845 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 401848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401850 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401859 */   GIR_RootConstrainSelectedInstOperands,
     /* 401860 */   // GIR_Coverage, 6438,
     /* 401860 */   GIR_EraseRootFromParent_Done,
     /* 401861 */ // Label 8070: @401861
     /* 401861 */ GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(401915), // Rule ID 13222 //
     /* 401866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401873 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401881 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401884 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401888 */   // MIs[1] Rn
     /* 401888 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401892 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401899 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 401902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401904 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401913 */   GIR_RootConstrainSelectedInstOperands,
     /* 401914 */   // GIR_Coverage, 13222,
     /* 401914 */   GIR_EraseRootFromParent_Done,
     /* 401915 */ // Label 8071: @401915
     /* 401915 */ GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(401941), // Rule ID 1915 //
     /* 401920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 401934 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 401934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 401939 */   GIR_RootConstrainSelectedInstOperands,
     /* 401940 */   // GIR_Coverage, 1915,
     /* 401940 */   GIR_Done,
     /* 401941 */ // Label 8072: @401941
     /* 401941 */ GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(402021), // Rule ID 5638 //
     /* 401946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401957 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401957 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 401960 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401964 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 401974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401983 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401986 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401990 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 401993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401998 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402003 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 402011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402019 */   GIR_RootConstrainSelectedInstOperands,
     /* 402020 */   // GIR_Coverage, 5638,
     /* 402020 */   GIR_EraseRootFromParent_Done,
     /* 402021 */ // Label 8073: @402021
     /* 402021 */ GIM_Reject,
     /* 402022 */ // Label 8035: @402022
     /* 402022 */ GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(402083), // Rule ID 6419 //
     /* 402027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402042 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402045 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402049 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 402056 */   // MIs[1] Rn
     /* 402056 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402060 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402067 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 402070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402072 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402081 */   GIR_RootConstrainSelectedInstOperands,
     /* 402082 */   // GIR_Coverage, 6419,
     /* 402082 */   GIR_EraseRootFromParent_Done,
     /* 402083 */ // Label 8074: @402083
     /* 402083 */ GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(402137), // Rule ID 13220 //
     /* 402088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 402091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402103 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402110 */   // MIs[1] Rn
     /* 402110 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402114 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402121 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 402124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402126 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402135 */   GIR_RootConstrainSelectedInstOperands,
     /* 402136 */   // GIR_Coverage, 13220,
     /* 402136 */   GIR_EraseRootFromParent_Done,
     /* 402137 */ // Label 8075: @402137
     /* 402137 */ GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(402163), // Rule ID 1913 //
     /* 402142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 402156 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 402156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 402161 */   GIR_RootConstrainSelectedInstOperands,
     /* 402162 */   // GIR_Coverage, 1913,
     /* 402162 */   GIR_Done,
     /* 402163 */ // Label 8076: @402163
     /* 402163 */ GIM_Reject,
     /* 402164 */ // Label 8036: @402164
     /* 402164 */ GIM_Reject,
     /* 402165 */ // Label 125: @402165
     /* 402165 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8079*/ GIMT_Encode4(402419),
     /* 402176 */ /*GILLT_v4s16*//*Label 8077*/ GIMT_Encode4(402192), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 402188 */ /*GILLT_v8s16*//*Label 8078*/ GIMT_Encode4(402278),
     /* 402192 */ // Label 8077: @402192
     /* 402192 */ GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(402277),
     /* 402197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402211 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(402245), // Rule ID 1922 //
     /* 402216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402231 */     // MIs[1] Operand 1
     /* 402231 */     // No operand predicates
     /* 402231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402233 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 402236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402243 */     GIR_RootConstrainSelectedInstOperands,
     /* 402244 */     // GIR_Coverage, 1922,
     /* 402244 */     GIR_EraseRootFromParent_Done,
     /* 402245 */   // Label 8081: @402245
     /* 402245 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(402276), // Rule ID 5639 //
     /* 402250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402262 */     // MIs[1] Operand 1
     /* 402262 */     // No operand predicates
     /* 402262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402264 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 402264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 402267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402274 */     GIR_RootConstrainSelectedInstOperands,
     /* 402275 */     // GIR_Coverage, 5639,
     /* 402275 */     GIR_EraseRootFromParent_Done,
     /* 402276 */   // Label 8082: @402276
     /* 402276 */   GIM_Reject,
     /* 402277 */ // Label 8080: @402277
     /* 402277 */ GIM_Reject,
     /* 402278 */ // Label 8078: @402278
     /* 402278 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(402418),
     /* 402283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402293 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(402344), // Rule ID 6429 //
     /* 402298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402313 */     // MIs[1] Rn
     /* 402313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 402326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402328 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 402331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402342 */     GIR_RootConstrainSelectedInstOperands,
     /* 402343 */     // GIR_Coverage, 6429,
     /* 402343 */     GIR_EraseRootFromParent_Done,
     /* 402344 */   // Label 8084: @402344
     /* 402344 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(402382), // Rule ID 1923 //
     /* 402349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402368 */     // MIs[1] Operand 1
     /* 402368 */     // No operand predicates
     /* 402368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402370 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 402373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402380 */     GIR_RootConstrainSelectedInstOperands,
     /* 402381 */     // GIR_Coverage, 1923,
     /* 402381 */     GIR_EraseRootFromParent_Done,
     /* 402382 */   // Label 8085: @402382
     /* 402382 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(402417), // Rule ID 5640 //
     /* 402387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402403 */     // MIs[1] Operand 1
     /* 402403 */     // No operand predicates
     /* 402403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402405 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 402405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 402408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402415 */     GIR_RootConstrainSelectedInstOperands,
     /* 402416 */     // GIR_Coverage, 5640,
     /* 402416 */     GIR_EraseRootFromParent_Done,
     /* 402417 */   // Label 8086: @402417
     /* 402417 */   GIM_Reject,
     /* 402418 */ // Label 8083: @402418
     /* 402418 */ GIM_Reject,
     /* 402419 */ // Label 8079: @402419
     /* 402419 */ GIM_Reject,
     /* 402420 */ // Label 126: @402420
     /* 402420 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8089*/ GIMT_Encode4(402674),
     /* 402431 */ /*GILLT_v2s32*//*Label 8087*/ GIMT_Encode4(402447), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 402443 */ /*GILLT_v4s32*//*Label 8088*/ GIMT_Encode4(402533),
     /* 402447 */ // Label 8087: @402447
     /* 402447 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(402532),
     /* 402452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402466 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(402500), // Rule ID 1920 //
     /* 402471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 402486 */     // MIs[1] Operand 1
     /* 402486 */     // No operand predicates
     /* 402486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402488 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 402491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402498 */     GIR_RootConstrainSelectedInstOperands,
     /* 402499 */     // GIR_Coverage, 1920,
     /* 402499 */     GIR_EraseRootFromParent_Done,
     /* 402500 */   // Label 8091: @402500
     /* 402500 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(402531), // Rule ID 5641 //
     /* 402505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 402517 */     // MIs[1] Operand 1
     /* 402517 */     // No operand predicates
     /* 402517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402519 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 402519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 402522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402529 */     GIR_RootConstrainSelectedInstOperands,
     /* 402530 */     // GIR_Coverage, 5641,
     /* 402530 */     GIR_EraseRootFromParent_Done,
     /* 402531 */   // Label 8092: @402531
     /* 402531 */   GIM_Reject,
     /* 402532 */ // Label 8090: @402532
     /* 402532 */ GIM_Reject,
     /* 402533 */ // Label 8088: @402533
     /* 402533 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(402673),
     /* 402538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402548 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(402599), // Rule ID 6431 //
     /* 402553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402568 */     // MIs[1] Rn
     /* 402568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 402581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402583 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 402586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402597 */     GIR_RootConstrainSelectedInstOperands,
     /* 402598 */     // GIR_Coverage, 6431,
     /* 402598 */     GIR_EraseRootFromParent_Done,
     /* 402599 */   // Label 8094: @402599
     /* 402599 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(402637), // Rule ID 1921 //
     /* 402604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 402623 */     // MIs[1] Operand 1
     /* 402623 */     // No operand predicates
     /* 402623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402625 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 402628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402635 */     GIR_RootConstrainSelectedInstOperands,
     /* 402636 */     // GIR_Coverage, 1921,
     /* 402636 */     GIR_EraseRootFromParent_Done,
     /* 402637 */   // Label 8095: @402637
     /* 402637 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(402672), // Rule ID 5642 //
     /* 402642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 402658 */     // MIs[1] Operand 1
     /* 402658 */     // No operand predicates
     /* 402658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402660 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 402660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 402663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402670 */     GIR_RootConstrainSelectedInstOperands,
     /* 402671 */     // GIR_Coverage, 5642,
     /* 402671 */     GIR_EraseRootFromParent_Done,
     /* 402672 */   // Label 8096: @402672
     /* 402672 */   GIM_Reject,
     /* 402673 */ // Label 8093: @402673
     /* 402673 */ GIM_Reject,
     /* 402674 */ // Label 8089: @402674
     /* 402674 */ GIM_Reject,
     /* 402675 */ // Label 127: @402675
     /* 402675 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(402820),
     /* 402680 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 402683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402693 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(402744), // Rule ID 6432 //
     /* 402698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402713 */     // MIs[1] Rn
     /* 402713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 402726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402728 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 402731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402742 */     GIR_RootConstrainSelectedInstOperands,
     /* 402743 */     // GIR_Coverage, 6432,
     /* 402743 */     GIR_EraseRootFromParent_Done,
     /* 402744 */   // Label 8098: @402744
     /* 402744 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(402819),
     /* 402749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402753 */     GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(402787), // Rule ID 1919 //
     /* 402758 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402761 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402765 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402769 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 402773 */       // MIs[1] Operand 1
     /* 402773 */       // No operand predicates
     /* 402773 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402775 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402775 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 402778 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402780 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402782 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402785 */       GIR_RootConstrainSelectedInstOperands,
     /* 402786 */       // GIR_Coverage, 1919,
     /* 402786 */       GIR_EraseRootFromParent_Done,
     /* 402787 */     // Label 8100: @402787
     /* 402787 */     GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(402818), // Rule ID 5643 //
     /* 402792 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402796 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402800 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 402804 */       // MIs[1] Operand 1
     /* 402804 */       // No operand predicates
     /* 402804 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402806 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 402806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 402809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402811 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402813 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402816 */       GIR_RootConstrainSelectedInstOperands,
     /* 402817 */       // GIR_Coverage, 5643,
     /* 402817 */       GIR_EraseRootFromParent_Done,
     /* 402818 */     // Label 8101: @402818
     /* 402818 */     GIM_Reject,
     /* 402819 */   // Label 8099: @402819
     /* 402819 */   GIM_Reject,
     /* 402820 */ // Label 8097: @402820
     /* 402820 */ GIM_Reject,
     /* 402821 */ // Label 128: @402821
     /* 402821 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8104*/ GIMT_Encode4(402999),
     /* 402832 */ /*GILLT_v8s8*//*Label 8102*/ GIMT_Encode4(402844), GIMT_Encode4(0),
     /* 402840 */ /*GILLT_v16s8*//*Label 8103*/ GIMT_Encode4(402893),
     /* 402844 */ // Label 8102: @402844
     /* 402844 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(402892), // Rule ID 1924 //
     /* 402849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402874 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 402878 */   // MIs[1] Operand 1
     /* 402878 */   // No operand predicates
     /* 402878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402880 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 402883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402885 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402887 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402890 */   GIR_RootConstrainSelectedInstOperands,
     /* 402891 */   // GIR_Coverage, 1924,
     /* 402891 */   GIR_EraseRootFromParent_Done,
     /* 402892 */ // Label 8105: @402892
     /* 402892 */ GIM_Reject,
     /* 402893 */ // Label 8103: @402893
     /* 402893 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(402998),
     /* 402898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402908 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(402959), // Rule ID 6427 //
     /* 402913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 402921 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 402924 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 402928 */     // MIs[1] Rn
     /* 402928 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 402932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 402937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 402941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402943 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 402943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 402946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 402948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 402957 */     GIR_RootConstrainSelectedInstOperands,
     /* 402958 */     // GIR_Coverage, 6427,
     /* 402958 */     GIR_EraseRootFromParent_Done,
     /* 402959 */   // Label 8107: @402959
     /* 402959 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(402997), // Rule ID 1925 //
     /* 402964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 402983 */     // MIs[1] Operand 1
     /* 402983 */     // No operand predicates
     /* 402983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402985 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 402985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 402988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 402995 */     GIR_RootConstrainSelectedInstOperands,
     /* 402996 */     // GIR_Coverage, 1925,
     /* 402996 */     GIR_EraseRootFromParent_Done,
     /* 402997 */   // Label 8108: @402997
     /* 402997 */   GIM_Reject,
     /* 402998 */ // Label 8106: @402998
     /* 402998 */ GIM_Reject,
     /* 402999 */ // Label 8104: @402999
     /* 402999 */ GIM_Reject,
     /* 403000 */ // Label 129: @403000
     /* 403000 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8118*/ GIMT_Encode4(404649),
     /* 403011 */ /*GILLT_s64*//*Label 8109*/ GIMT_Encode4(403095), GIMT_Encode4(0),
     /* 403019 */ /*GILLT_v2s32*//*Label 8110*/ GIMT_Encode4(403416),
     /* 403023 */ /*GILLT_v2s64*//*Label 8111*/ GIMT_Encode4(403737),
     /* 403027 */ /*GILLT_v4s16*//*Label 8112*/ GIMT_Encode4(403820),
     /* 403031 */ /*GILLT_v4s32*//*Label 8113*/ GIMT_Encode4(404141),
     /* 403035 */ /*GILLT_v8s8*//*Label 8114*/ GIMT_Encode4(404224),
     /* 403039 */ /*GILLT_v8s16*//*Label 8115*/ GIMT_Encode4(404433),
     /* 403043 */ /*GILLT_v16s8*//*Label 8116*/ GIMT_Encode4(404516), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403091 */ /*GILLT_nxv16s8*//*Label 8117*/ GIMT_Encode4(404602),
     /* 403095 */ // Label 8109: @403095
     /* 403095 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(403415),
     /* 403100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 403103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 403106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403110 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(403225), // Rule ID 5460 //
     /* 403115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403132 */     // MIs[1] Operand 2
     /* 403132 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403151 */     // MIs[2] Rn
     /* 403151 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403156 */     // MIs[2] Operand 2
     /* 403156 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 403167 */     // MIs[0] imm
     /* 403167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403175 */     // MIs[3] Operand 1
     /* 403175 */     // No operand predicates
     /* 403175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403177 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403207 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403224 */     // GIR_Coverage, 5460,
     /* 403224 */     GIR_EraseRootFromParent_Done,
     /* 403225 */   // Label 8120: @403225
     /* 403225 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(403340), // Rule ID 5465 //
     /* 403230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403247 */     // MIs[1] Operand 2
     /* 403247 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403266 */     // MIs[2] Rn
     /* 403266 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403271 */     // MIs[2] Operand 2
     /* 403271 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 403282 */     // MIs[0] imm
     /* 403282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403290 */     // MIs[3] Operand 1
     /* 403290 */     // No operand predicates
     /* 403290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403292 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403322 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403339 */     // GIR_Coverage, 5465,
     /* 403339 */     GIR_EraseRootFromParent_Done,
     /* 403340 */   // Label 8121: @403340
     /* 403340 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(403377), // Rule ID 5457 //
     /* 403345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403353 */     // MIs[0] imm
     /* 403353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403361 */     // MIs[1] Operand 1
     /* 403361 */     // No operand predicates
     /* 403361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403363 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 403366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403375 */     GIR_RootConstrainSelectedInstOperands,
     /* 403376 */     // GIR_Coverage, 5457,
     /* 403376 */     GIR_EraseRootFromParent_Done,
     /* 403377 */   // Label 8122: @403377
     /* 403377 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(403414), // Rule ID 5462 //
     /* 403382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403390 */     // MIs[0] imm
     /* 403390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403398 */     // MIs[1] Operand 1
     /* 403398 */     // No operand predicates
     /* 403398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403400 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 403403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403412 */     GIR_RootConstrainSelectedInstOperands,
     /* 403413 */     // GIR_Coverage, 5462,
     /* 403413 */     GIR_EraseRootFromParent_Done,
     /* 403414 */   // Label 8123: @403414
     /* 403414 */   GIM_Reject,
     /* 403415 */ // Label 8119: @403415
     /* 403415 */ GIM_Reject,
     /* 403416 */ // Label 8110: @403416
     /* 403416 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(403736),
     /* 403421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 403427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403431 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(403546), // Rule ID 5450 //
     /* 403436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403453 */     // MIs[1] Operand 2
     /* 403453 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403472 */     // MIs[2] Rn
     /* 403472 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403477 */     // MIs[2] Operand 2
     /* 403477 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 403488 */     // MIs[0] imm
     /* 403488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403496 */     // MIs[3] Operand 1
     /* 403496 */     // No operand predicates
     /* 403496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403498 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403528 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403545 */     // GIR_Coverage, 5450,
     /* 403545 */     GIR_EraseRootFromParent_Done,
     /* 403546 */   // Label 8125: @403546
     /* 403546 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(403661), // Rule ID 5455 //
     /* 403551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403568 */     // MIs[1] Operand 2
     /* 403568 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403587 */     // MIs[2] Rn
     /* 403587 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403592 */     // MIs[2] Operand 2
     /* 403592 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 403603 */     // MIs[0] imm
     /* 403603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403611 */     // MIs[3] Operand 1
     /* 403611 */     // No operand predicates
     /* 403611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403613 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403629 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403643 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403660 */     // GIR_Coverage, 5455,
     /* 403660 */     GIR_EraseRootFromParent_Done,
     /* 403661 */   // Label 8126: @403661
     /* 403661 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(403698), // Rule ID 5447 //
     /* 403666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403674 */     // MIs[0] imm
     /* 403674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403682 */     // MIs[1] Operand 1
     /* 403682 */     // No operand predicates
     /* 403682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403684 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 403687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403696 */     GIR_RootConstrainSelectedInstOperands,
     /* 403697 */     // GIR_Coverage, 5447,
     /* 403697 */     GIR_EraseRootFromParent_Done,
     /* 403698 */   // Label 8127: @403698
     /* 403698 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(403735), // Rule ID 5452 //
     /* 403703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403711 */     // MIs[0] imm
     /* 403711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403719 */     // MIs[1] Operand 1
     /* 403719 */     // No operand predicates
     /* 403719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403721 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 403724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403733 */     GIR_RootConstrainSelectedInstOperands,
     /* 403734 */     // GIR_Coverage, 5452,
     /* 403734 */     GIR_EraseRootFromParent_Done,
     /* 403735 */   // Label 8128: @403735
     /* 403735 */   GIM_Reject,
     /* 403736 */ // Label 8124: @403736
     /* 403736 */ GIM_Reject,
     /* 403737 */ // Label 8111: @403737
     /* 403737 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(403819),
     /* 403742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 403748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403760 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(403789), // Rule ID 5458 //
     /* 403765 */     // MIs[0] imm
     /* 403765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403773 */     // MIs[1] Operand 1
     /* 403773 */     // No operand predicates
     /* 403773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403775 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403787 */     GIR_RootConstrainSelectedInstOperands,
     /* 403788 */     // GIR_Coverage, 5458,
     /* 403788 */     GIR_EraseRootFromParent_Done,
     /* 403789 */   // Label 8130: @403789
     /* 403789 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(403818), // Rule ID 5463 //
     /* 403794 */     // MIs[0] imm
     /* 403794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403802 */     // MIs[1] Operand 1
     /* 403802 */     // No operand predicates
     /* 403802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403804 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403816 */     GIR_RootConstrainSelectedInstOperands,
     /* 403817 */     // GIR_Coverage, 5463,
     /* 403817 */     GIR_EraseRootFromParent_Done,
     /* 403818 */   // Label 8131: @403818
     /* 403818 */   GIM_Reject,
     /* 403819 */ // Label 8129: @403819
     /* 403819 */ GIM_Reject,
     /* 403820 */ // Label 8112: @403820
     /* 403820 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(404140),
     /* 403825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 403831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403835 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(403950), // Rule ID 5440 //
     /* 403840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403857 */     // MIs[1] Operand 2
     /* 403857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403876 */     // MIs[2] Rn
     /* 403876 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403881 */     // MIs[2] Operand 2
     /* 403881 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 403892 */     // MIs[0] imm
     /* 403892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403900 */     // MIs[3] Operand 1
     /* 403900 */     // No operand predicates
     /* 403900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403902 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 403902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 403925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403932 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 403939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403949 */     // GIR_Coverage, 5440,
     /* 403949 */     GIR_EraseRootFromParent_Done,
     /* 403950 */   // Label 8133: @403950
     /* 403950 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(404065), // Rule ID 5445 //
     /* 403955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403972 */     // MIs[1] Operand 2
     /* 403972 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 403983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 403991 */     // MIs[2] Rn
     /* 403991 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 403996 */     // MIs[2] Operand 2
     /* 403996 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 404007 */     // MIs[0] imm
     /* 404007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 404011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404015 */     // MIs[3] Operand 1
     /* 404015 */     // No operand predicates
     /* 404015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404017 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 404017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 404020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404033 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 404040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404047 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 404054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404064 */     // GIR_Coverage, 5445,
     /* 404064 */     GIR_EraseRootFromParent_Done,
     /* 404065 */   // Label 8134: @404065
     /* 404065 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(404102), // Rule ID 5437 //
     /* 404070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404078 */     // MIs[0] imm
     /* 404078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404086 */     // MIs[1] Operand 1
     /* 404086 */     // No operand predicates
     /* 404086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404088 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 404091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404100 */     GIR_RootConstrainSelectedInstOperands,
     /* 404101 */     // GIR_Coverage, 5437,
     /* 404101 */     GIR_EraseRootFromParent_Done,
     /* 404102 */   // Label 8135: @404102
     /* 404102 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(404139), // Rule ID 5442 //
     /* 404107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404115 */     // MIs[0] imm
     /* 404115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404123 */     // MIs[1] Operand 1
     /* 404123 */     // No operand predicates
     /* 404123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404125 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 404128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404137 */     GIR_RootConstrainSelectedInstOperands,
     /* 404138 */     // GIR_Coverage, 5442,
     /* 404138 */     GIR_EraseRootFromParent_Done,
     /* 404139 */   // Label 8136: @404139
     /* 404139 */   GIM_Reject,
     /* 404140 */ // Label 8132: @404140
     /* 404140 */ GIM_Reject,
     /* 404141 */ // Label 8113: @404141
     /* 404141 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(404223),
     /* 404146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 404152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404164 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(404193), // Rule ID 5448 //
     /* 404169 */     // MIs[0] imm
     /* 404169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404177 */     // MIs[1] Operand 1
     /* 404177 */     // No operand predicates
     /* 404177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404179 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404191 */     GIR_RootConstrainSelectedInstOperands,
     /* 404192 */     // GIR_Coverage, 5448,
     /* 404192 */     GIR_EraseRootFromParent_Done,
     /* 404193 */   // Label 8138: @404193
     /* 404193 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(404222), // Rule ID 5453 //
     /* 404198 */     // MIs[0] imm
     /* 404198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404206 */     // MIs[1] Operand 1
     /* 404206 */     // No operand predicates
     /* 404206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404208 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404220 */     GIR_RootConstrainSelectedInstOperands,
     /* 404221 */     // GIR_Coverage, 5453,
     /* 404221 */     GIR_EraseRootFromParent_Done,
     /* 404222 */   // Label 8139: @404222
     /* 404222 */   GIM_Reject,
     /* 404223 */ // Label 8137: @404223
     /* 404223 */ GIM_Reject,
     /* 404224 */ // Label 8114: @404224
     /* 404224 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(404432),
     /* 404229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 404232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 404235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404239 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(404354), // Rule ID 5435 //
     /* 404244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404261 */     // MIs[1] Operand 2
     /* 404261 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404280 */     // MIs[2] Rn
     /* 404280 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 404285 */     // MIs[2] Operand 2
     /* 404285 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 404296 */     // MIs[0] imm
     /* 404296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 404300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404304 */     // MIs[3] Operand 1
     /* 404304 */     // No operand predicates
     /* 404304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404306 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 404306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 404309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 404329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404336 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 404343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404353 */     // GIR_Coverage, 5435,
     /* 404353 */     GIR_EraseRootFromParent_Done,
     /* 404354 */   // Label 8141: @404354
     /* 404354 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(404394), // Rule ID 1868 //
     /* 404359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404370 */     // MIs[0] imm
     /* 404370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404378 */     // MIs[1] Operand 1
     /* 404378 */     // No operand predicates
     /* 404378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404380 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 404383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404392 */     GIR_RootConstrainSelectedInstOperands,
     /* 404393 */     // GIR_Coverage, 1868,
     /* 404393 */     GIR_EraseRootFromParent_Done,
     /* 404394 */   // Label 8142: @404394
     /* 404394 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(404431), // Rule ID 5432 //
     /* 404399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404407 */     // MIs[0] imm
     /* 404407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404415 */     // MIs[1] Operand 1
     /* 404415 */     // No operand predicates
     /* 404415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404417 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 404420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404429 */     GIR_RootConstrainSelectedInstOperands,
     /* 404430 */     // GIR_Coverage, 5432,
     /* 404430 */     GIR_EraseRootFromParent_Done,
     /* 404431 */   // Label 8143: @404431
     /* 404431 */   GIM_Reject,
     /* 404432 */ // Label 8140: @404432
     /* 404432 */ GIM_Reject,
     /* 404433 */ // Label 8115: @404433
     /* 404433 */ GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(404515),
     /* 404438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 404444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404456 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(404485), // Rule ID 5438 //
     /* 404461 */     // MIs[0] imm
     /* 404461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404469 */     // MIs[1] Operand 1
     /* 404469 */     // No operand predicates
     /* 404469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404471 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404483 */     GIR_RootConstrainSelectedInstOperands,
     /* 404484 */     // GIR_Coverage, 5438,
     /* 404484 */     GIR_EraseRootFromParent_Done,
     /* 404485 */   // Label 8145: @404485
     /* 404485 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(404514), // Rule ID 5443 //
     /* 404490 */     // MIs[0] imm
     /* 404490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404498 */     // MIs[1] Operand 1
     /* 404498 */     // No operand predicates
     /* 404498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404500 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404512 */     GIR_RootConstrainSelectedInstOperands,
     /* 404513 */     // GIR_Coverage, 5443,
     /* 404513 */     GIR_EraseRootFromParent_Done,
     /* 404514 */   // Label 8146: @404514
     /* 404514 */   GIM_Reject,
     /* 404515 */ // Label 8144: @404515
     /* 404515 */ GIM_Reject,
     /* 404516 */ // Label 8116: @404516
     /* 404516 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(404601),
     /* 404521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 404527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404539 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(404571), // Rule ID 1869 //
     /* 404544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404547 */     // MIs[0] imm
     /* 404547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404555 */     // MIs[1] Operand 1
     /* 404555 */     // No operand predicates
     /* 404555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404557 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404569 */     GIR_RootConstrainSelectedInstOperands,
     /* 404570 */     // GIR_Coverage, 1869,
     /* 404570 */     GIR_EraseRootFromParent_Done,
     /* 404571 */   // Label 8148: @404571
     /* 404571 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(404600), // Rule ID 5433 //
     /* 404576 */     // MIs[0] imm
     /* 404576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404584 */     // MIs[1] Operand 1
     /* 404584 */     // No operand predicates
     /* 404584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404586 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 404586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 404589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 404598 */     GIR_RootConstrainSelectedInstOperands,
     /* 404599 */     // GIR_Coverage, 5433,
     /* 404599 */     GIR_EraseRootFromParent_Done,
     /* 404600 */   // Label 8149: @404600
     /* 404600 */   GIM_Reject,
     /* 404601 */ // Label 8147: @404601
     /* 404601 */ GIM_Reject,
     /* 404602 */ // Label 8117: @404602
     /* 404602 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(404648), // Rule ID 2733 //
     /* 404607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 404613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 404616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404620 */   // MIs[0] Op3
     /* 404620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404628 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 404632 */   // MIs[1] Operand 1
     /* 404632 */   // No operand predicates
     /* 404632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404634 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 404634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 404637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 404639 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 404641 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 404643 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 404646 */   GIR_RootConstrainSelectedInstOperands,
     /* 404647 */   // GIR_Coverage, 2733,
     /* 404647 */   GIR_EraseRootFromParent_Done,
     /* 404648 */ // Label 8150: @404648
     /* 404648 */ GIM_Reject,
     /* 404649 */ // Label 8118: @404649
     /* 404649 */ GIM_Reject,
     /* 404650 */ // Label 130: @404650
     /* 404650 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8158*/ GIMT_Encode4(405208),
     /* 404661 */ /*GILLT_s32*//*Label 8151*/ GIMT_Encode4(404697),
     /* 404665 */ /*GILLT_s64*//*Label 8152*/ GIMT_Encode4(404735), GIMT_Encode4(0),
     /* 404673 */ /*GILLT_v2s32*//*Label 8153*/ GIMT_Encode4(404833),
     /* 404677 */ /*GILLT_v2s64*//*Label 8154*/ GIMT_Encode4(404908),
     /* 404681 */ /*GILLT_v4s16*//*Label 8155*/ GIMT_Encode4(404983),
     /* 404685 */ /*GILLT_v4s32*//*Label 8156*/ GIMT_Encode4(405058), GIMT_Encode4(0),
     /* 404693 */ /*GILLT_v8s16*//*Label 8157*/ GIMT_Encode4(405133),
     /* 404697 */ // Label 8151: @404697
     /* 404697 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(404734), // Rule ID 1622 //
     /* 404702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 404708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 404711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404723 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 404723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 404728 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404732 */   GIR_RootConstrainSelectedInstOperands,
     /* 404733 */   // GIR_Coverage, 1622,
     /* 404733 */   GIR_Done,
     /* 404734 */ // Label 8159: @404734
     /* 404734 */ GIM_Reject,
     /* 404735 */ // Label 8152: @404735
     /* 404735 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(404832),
     /* 404740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 404743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 404746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404754 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(404785), // Rule ID 2513 //
     /* 404759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404766 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404772 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404776 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 404776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 404779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404783 */     GIR_RootConstrainSelectedInstOperands,
     /* 404784 */     // GIR_Coverage, 2513,
     /* 404784 */     GIR_EraseRootFromParent_Done,
     /* 404785 */   // Label 8161: @404785
     /* 404785 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(404808), // Rule ID 1621 //
     /* 404790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404797 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 404797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 404802 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404806 */     GIR_RootConstrainSelectedInstOperands,
     /* 404807 */     // GIR_Coverage, 1621,
     /* 404807 */     GIR_Done,
     /* 404808 */   // Label 8162: @404808
     /* 404808 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(404831), // Rule ID 5212 //
     /* 404813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404820 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 404820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 404825 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404829 */     GIR_RootConstrainSelectedInstOperands,
     /* 404830 */     // GIR_Coverage, 5212,
     /* 404830 */     GIR_Done,
     /* 404831 */   // Label 8163: @404831
     /* 404831 */   GIM_Reject,
     /* 404832 */ // Label 8160: @404832
     /* 404832 */ GIM_Reject,
     /* 404833 */ // Label 8153: @404833
     /* 404833 */ GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(404907),
     /* 404838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 404844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404852 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(404883), // Rule ID 773 //
     /* 404857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404864 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404870 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404874 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 404874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 404877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404881 */     GIR_RootConstrainSelectedInstOperands,
     /* 404882 */     // GIR_Coverage, 773,
     /* 404882 */     GIR_EraseRootFromParent_Done,
     /* 404883 */   // Label 8165: @404883
     /* 404883 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(404906), // Rule ID 1210 //
     /* 404888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404895 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 404895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 404900 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404904 */     GIR_RootConstrainSelectedInstOperands,
     /* 404905 */     // GIR_Coverage, 1210,
     /* 404905 */     GIR_Done,
     /* 404906 */   // Label 8166: @404906
     /* 404906 */   GIM_Reject,
     /* 404907 */ // Label 8164: @404907
     /* 404907 */ GIM_Reject,
     /* 404908 */ // Label 8154: @404908
     /* 404908 */ GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(404982),
     /* 404913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 404916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 404919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404927 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(404958), // Rule ID 775 //
     /* 404932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404939 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404945 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404949 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 404949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 404952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404956 */     GIR_RootConstrainSelectedInstOperands,
     /* 404957 */     // GIR_Coverage, 775,
     /* 404957 */     GIR_EraseRootFromParent_Done,
     /* 404958 */   // Label 8168: @404958
     /* 404958 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(404981), // Rule ID 1212 //
     /* 404963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404970 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 404970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 404975 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404979 */     GIR_RootConstrainSelectedInstOperands,
     /* 404980 */     // GIR_Coverage, 1212,
     /* 404980 */     GIR_Done,
     /* 404981 */   // Label 8169: @404981
     /* 404981 */   GIM_Reject,
     /* 404982 */ // Label 8167: @404982
     /* 404982 */ GIM_Reject,
     /* 404983 */ // Label 8155: @404983
     /* 404983 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(405057),
     /* 404988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 404994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405002 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(405033), // Rule ID 771 //
     /* 405007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405014 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405020 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405024 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 405024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 405027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405031 */     GIR_RootConstrainSelectedInstOperands,
     /* 405032 */     // GIR_Coverage, 771,
     /* 405032 */     GIR_EraseRootFromParent_Done,
     /* 405033 */   // Label 8171: @405033
     /* 405033 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(405056), // Rule ID 1208 //
     /* 405038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405045 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 405050 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405054 */     GIR_RootConstrainSelectedInstOperands,
     /* 405055 */     // GIR_Coverage, 1208,
     /* 405055 */     GIR_Done,
     /* 405056 */   // Label 8172: @405056
     /* 405056 */   GIM_Reject,
     /* 405057 */ // Label 8170: @405057
     /* 405057 */ GIM_Reject,
     /* 405058 */ // Label 8156: @405058
     /* 405058 */ GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(405132),
     /* 405063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 405069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405077 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(405108), // Rule ID 774 //
     /* 405082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405099 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 405099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 405102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405106 */     GIR_RootConstrainSelectedInstOperands,
     /* 405107 */     // GIR_Coverage, 774,
     /* 405107 */     GIR_EraseRootFromParent_Done,
     /* 405108 */   // Label 8174: @405108
     /* 405108 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(405131), // Rule ID 1211 //
     /* 405113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405120 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 405120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 405125 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405129 */     GIR_RootConstrainSelectedInstOperands,
     /* 405130 */     // GIR_Coverage, 1211,
     /* 405130 */     GIR_Done,
     /* 405131 */   // Label 8175: @405131
     /* 405131 */   GIM_Reject,
     /* 405132 */ // Label 8173: @405132
     /* 405132 */ GIM_Reject,
     /* 405133 */ // Label 8157: @405133
     /* 405133 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(405207),
     /* 405138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 405144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405152 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(405183), // Rule ID 772 //
     /* 405157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405164 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405170 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405174 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 405174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 405177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405181 */     GIR_RootConstrainSelectedInstOperands,
     /* 405182 */     // GIR_Coverage, 772,
     /* 405182 */     GIR_EraseRootFromParent_Done,
     /* 405183 */   // Label 8177: @405183
     /* 405183 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(405206), // Rule ID 1209 //
     /* 405188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405195 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 405195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 405200 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405204 */     GIR_RootConstrainSelectedInstOperands,
     /* 405205 */     // GIR_Coverage, 1209,
     /* 405205 */     GIR_Done,
     /* 405206 */   // Label 8178: @405206
     /* 405206 */   GIM_Reject,
     /* 405207 */ // Label 8176: @405207
     /* 405207 */ GIM_Reject,
     /* 405208 */ // Label 8158: @405208
     /* 405208 */ GIM_Reject,
     /* 405209 */ // Label 131: @405209
     /* 405209 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8186*/ GIMT_Encode4(406300),
     /* 405220 */ /*GILLT_s32*//*Label 8179*/ GIMT_Encode4(405256),
     /* 405224 */ /*GILLT_s64*//*Label 8180*/ GIMT_Encode4(405294), GIMT_Encode4(0),
     /* 405232 */ /*GILLT_v2s32*//*Label 8181*/ GIMT_Encode4(405435),
     /* 405236 */ /*GILLT_v2s64*//*Label 8182*/ GIMT_Encode4(405608),
     /* 405240 */ /*GILLT_v4s16*//*Label 8183*/ GIMT_Encode4(405781),
     /* 405244 */ /*GILLT_v4s32*//*Label 8184*/ GIMT_Encode4(405954), GIMT_Encode4(0),
     /* 405252 */ /*GILLT_v8s16*//*Label 8185*/ GIMT_Encode4(406127),
     /* 405256 */ // Label 8179: @405256
     /* 405256 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(405293), // Rule ID 1624 //
     /* 405261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 405267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 405270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405282 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 405282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 405287 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405291 */   GIR_RootConstrainSelectedInstOperands,
     /* 405292 */   // GIR_Coverage, 1624,
     /* 405292 */   GIR_Done,
     /* 405293 */ // Label 8187: @405293
     /* 405293 */ GIM_Reject,
     /* 405294 */ // Label 8180: @405294
     /* 405294 */ GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(405434),
     /* 405299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 405302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 405305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405309 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(405344), // Rule ID 5246 //
     /* 405314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405321 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405327 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405335 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 405335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 405338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405342 */     GIR_RootConstrainSelectedInstOperands,
     /* 405343 */     // GIR_Coverage, 5246,
     /* 405343 */     GIR_EraseRootFromParent_Done,
     /* 405344 */   // Label 8189: @405344
     /* 405344 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(405379), // Rule ID 5244 //
     /* 405349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405360 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405366 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405370 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 405370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 405373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405377 */     GIR_RootConstrainSelectedInstOperands,
     /* 405378 */     // GIR_Coverage, 5244,
     /* 405378 */     GIR_EraseRootFromParent_Done,
     /* 405379 */   // Label 8190: @405379
     /* 405379 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(405406), // Rule ID 1623 //
     /* 405384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405395 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 405395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 405400 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405404 */     GIR_RootConstrainSelectedInstOperands,
     /* 405405 */     // GIR_Coverage, 1623,
     /* 405405 */     GIR_Done,
     /* 405406 */   // Label 8191: @405406
     /* 405406 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(405433), // Rule ID 5213 //
     /* 405411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405422 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 405422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 405427 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405431 */     GIR_RootConstrainSelectedInstOperands,
     /* 405432 */     // GIR_Coverage, 5213,
     /* 405432 */     GIR_Done,
     /* 405433 */   // Label 8192: @405433
     /* 405433 */   GIM_Reject,
     /* 405434 */ // Label 8188: @405434
     /* 405434 */ GIM_Reject,
     /* 405435 */ // Label 8181: @405435
     /* 405435 */ GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(405607),
     /* 405440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 405446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405450 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(405509), // Rule ID 1172 //
     /* 405455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405494 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 405497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405507 */     GIR_RootConstrainSelectedInstOperands,
     /* 405508 */     // GIR_Coverage, 1172,
     /* 405508 */     GIR_EraseRootFromParent_Done,
     /* 405509 */   // Label 8194: @405509
     /* 405509 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(405544), // Rule ID 788 //
     /* 405514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405521 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405527 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405535 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 405535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 405538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405542 */     GIR_RootConstrainSelectedInstOperands,
     /* 405543 */     // GIR_Coverage, 788,
     /* 405543 */     GIR_EraseRootFromParent_Done,
     /* 405544 */   // Label 8195: @405544
     /* 405544 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(405579), // Rule ID 778 //
     /* 405549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405560 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405566 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405570 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 405570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 405573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405577 */     GIR_RootConstrainSelectedInstOperands,
     /* 405578 */     // GIR_Coverage, 778,
     /* 405578 */     GIR_EraseRootFromParent_Done,
     /* 405579 */   // Label 8196: @405579
     /* 405579 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(405606), // Rule ID 1215 //
     /* 405584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405595 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 405600 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405604 */     GIR_RootConstrainSelectedInstOperands,
     /* 405605 */     // GIR_Coverage, 1215,
     /* 405605 */     GIR_Done,
     /* 405606 */   // Label 8197: @405606
     /* 405606 */   GIM_Reject,
     /* 405607 */ // Label 8193: @405607
     /* 405607 */ GIM_Reject,
     /* 405608 */ // Label 8182: @405608
     /* 405608 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(405780),
     /* 405613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 405619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405623 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(405682), // Rule ID 1176 //
     /* 405628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405667 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 405670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405680 */     GIR_RootConstrainSelectedInstOperands,
     /* 405681 */     // GIR_Coverage, 1176,
     /* 405681 */     GIR_EraseRootFromParent_Done,
     /* 405682 */   // Label 8199: @405682
     /* 405682 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(405717), // Rule ID 790 //
     /* 405687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405694 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405700 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405708 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 405708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 405711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405715 */     GIR_RootConstrainSelectedInstOperands,
     /* 405716 */     // GIR_Coverage, 790,
     /* 405716 */     GIR_EraseRootFromParent_Done,
     /* 405717 */   // Label 8200: @405717
     /* 405717 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(405752), // Rule ID 780 //
     /* 405722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405733 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405739 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405743 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 405743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 405746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405750 */     GIR_RootConstrainSelectedInstOperands,
     /* 405751 */     // GIR_Coverage, 780,
     /* 405751 */     GIR_EraseRootFromParent_Done,
     /* 405752 */   // Label 8201: @405752
     /* 405752 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(405779), // Rule ID 1217 //
     /* 405757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405768 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 405773 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405777 */     GIR_RootConstrainSelectedInstOperands,
     /* 405778 */     // GIR_Coverage, 1217,
     /* 405778 */     GIR_Done,
     /* 405779 */   // Label 8202: @405779
     /* 405779 */   GIM_Reject,
     /* 405780 */ // Label 8198: @405780
     /* 405780 */ GIM_Reject,
     /* 405781 */ // Label 8183: @405781
     /* 405781 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(405953),
     /* 405786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405796 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(405855), // Rule ID 1168 //
     /* 405801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405840 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 405843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405853 */     GIR_RootConstrainSelectedInstOperands,
     /* 405854 */     // GIR_Coverage, 1168,
     /* 405854 */     GIR_EraseRootFromParent_Done,
     /* 405855 */   // Label 8204: @405855
     /* 405855 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(405890), // Rule ID 786 //
     /* 405860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405867 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405873 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405881 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 405881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 405884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405888 */     GIR_RootConstrainSelectedInstOperands,
     /* 405889 */     // GIR_Coverage, 786,
     /* 405889 */     GIR_EraseRootFromParent_Done,
     /* 405890 */   // Label 8205: @405890
     /* 405890 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(405925), // Rule ID 776 //
     /* 405895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405906 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405912 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405916 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 405916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 405919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405923 */     GIR_RootConstrainSelectedInstOperands,
     /* 405924 */     // GIR_Coverage, 776,
     /* 405924 */     GIR_EraseRootFromParent_Done,
     /* 405925 */   // Label 8206: @405925
     /* 405925 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(405952), // Rule ID 1213 //
     /* 405930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405941 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 405946 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405950 */     GIR_RootConstrainSelectedInstOperands,
     /* 405951 */     // GIR_Coverage, 1213,
     /* 405951 */     GIR_Done,
     /* 405952 */   // Label 8207: @405952
     /* 405952 */   GIM_Reject,
     /* 405953 */ // Label 8203: @405953
     /* 405953 */ GIM_Reject,
     /* 405954 */ // Label 8184: @405954
     /* 405954 */ GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(406126),
     /* 405959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 405965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405969 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(406028), // Rule ID 1174 //
     /* 405974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406013 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 406016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406026 */     GIR_RootConstrainSelectedInstOperands,
     /* 406027 */     // GIR_Coverage, 1174,
     /* 406027 */     GIR_EraseRootFromParent_Done,
     /* 406028 */   // Label 8209: @406028
     /* 406028 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(406063), // Rule ID 789 //
     /* 406033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406040 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406046 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406054 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 406054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 406057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406061 */     GIR_RootConstrainSelectedInstOperands,
     /* 406062 */     // GIR_Coverage, 789,
     /* 406062 */     GIR_EraseRootFromParent_Done,
     /* 406063 */   // Label 8210: @406063
     /* 406063 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(406098), // Rule ID 779 //
     /* 406068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406079 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406085 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406089 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 406089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 406092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406096 */     GIR_RootConstrainSelectedInstOperands,
     /* 406097 */     // GIR_Coverage, 779,
     /* 406097 */     GIR_EraseRootFromParent_Done,
     /* 406098 */   // Label 8211: @406098
     /* 406098 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(406125), // Rule ID 1216 //
     /* 406103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406114 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 406119 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406123 */     GIR_RootConstrainSelectedInstOperands,
     /* 406124 */     // GIR_Coverage, 1216,
     /* 406124 */     GIR_Done,
     /* 406125 */   // Label 8212: @406125
     /* 406125 */   GIM_Reject,
     /* 406126 */ // Label 8208: @406126
     /* 406126 */ GIM_Reject,
     /* 406127 */ // Label 8185: @406127
     /* 406127 */ GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(406299),
     /* 406132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 406138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406142 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(406201), // Rule ID 1170 //
     /* 406147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406186 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 406189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406199 */     GIR_RootConstrainSelectedInstOperands,
     /* 406200 */     // GIR_Coverage, 1170,
     /* 406200 */     GIR_EraseRootFromParent_Done,
     /* 406201 */   // Label 8214: @406201
     /* 406201 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(406236), // Rule ID 787 //
     /* 406206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406213 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406219 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406227 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 406227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 406230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406234 */     GIR_RootConstrainSelectedInstOperands,
     /* 406235 */     // GIR_Coverage, 787,
     /* 406235 */     GIR_EraseRootFromParent_Done,
     /* 406236 */   // Label 8215: @406236
     /* 406236 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(406271), // Rule ID 777 //
     /* 406241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406252 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406258 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406262 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 406262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 406265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406269 */     GIR_RootConstrainSelectedInstOperands,
     /* 406270 */     // GIR_Coverage, 777,
     /* 406270 */     GIR_EraseRootFromParent_Done,
     /* 406271 */   // Label 8216: @406271
     /* 406271 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(406298), // Rule ID 1214 //
     /* 406276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406287 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 406292 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406296 */     GIR_RootConstrainSelectedInstOperands,
     /* 406297 */     // GIR_Coverage, 1214,
     /* 406297 */     GIR_Done,
     /* 406298 */   // Label 8217: @406298
     /* 406298 */   GIM_Reject,
     /* 406299 */ // Label 8213: @406299
     /* 406299 */ GIM_Reject,
     /* 406300 */ // Label 8186: @406300
     /* 406300 */ GIM_Reject,
     /* 406301 */ // Label 132: @406301
     /* 406301 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8225*/ GIMT_Encode4(407392),
     /* 406312 */ /*GILLT_s32*//*Label 8218*/ GIMT_Encode4(406348),
     /* 406316 */ /*GILLT_s64*//*Label 8219*/ GIMT_Encode4(406386), GIMT_Encode4(0),
     /* 406324 */ /*GILLT_v2s32*//*Label 8220*/ GIMT_Encode4(406527),
     /* 406328 */ /*GILLT_v2s64*//*Label 8221*/ GIMT_Encode4(406700),
     /* 406332 */ /*GILLT_v4s16*//*Label 8222*/ GIMT_Encode4(406873),
     /* 406336 */ /*GILLT_v4s32*//*Label 8223*/ GIMT_Encode4(407046), GIMT_Encode4(0),
     /* 406344 */ /*GILLT_v8s16*//*Label 8224*/ GIMT_Encode4(407219),
     /* 406348 */ // Label 8218: @406348
     /* 406348 */ GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(406385), // Rule ID 1626 //
     /* 406353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 406359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 406362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406374 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 406374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 406379 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406383 */   GIR_RootConstrainSelectedInstOperands,
     /* 406384 */   // GIR_Coverage, 1626,
     /* 406384 */   GIR_Done,
     /* 406385 */ // Label 8226: @406385
     /* 406385 */ GIM_Reject,
     /* 406386 */ // Label 8219: @406386
     /* 406386 */ GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(406526),
     /* 406391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 406394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 406397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406401 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(406436), // Rule ID 5247 //
     /* 406406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406413 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406419 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406427 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 406427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 406430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406434 */     GIR_RootConstrainSelectedInstOperands,
     /* 406435 */     // GIR_Coverage, 5247,
     /* 406435 */     GIR_EraseRootFromParent_Done,
     /* 406436 */   // Label 8228: @406436
     /* 406436 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(406471), // Rule ID 5245 //
     /* 406441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406452 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406458 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406462 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 406462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 406465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406469 */     GIR_RootConstrainSelectedInstOperands,
     /* 406470 */     // GIR_Coverage, 5245,
     /* 406470 */     GIR_EraseRootFromParent_Done,
     /* 406471 */   // Label 8229: @406471
     /* 406471 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(406498), // Rule ID 1625 //
     /* 406476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406487 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 406487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 406492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406496 */     GIR_RootConstrainSelectedInstOperands,
     /* 406497 */     // GIR_Coverage, 1625,
     /* 406497 */     GIR_Done,
     /* 406498 */   // Label 8230: @406498
     /* 406498 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(406525), // Rule ID 5214 //
     /* 406503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406514 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 406514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 406519 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406523 */     GIR_RootConstrainSelectedInstOperands,
     /* 406524 */     // GIR_Coverage, 5214,
     /* 406524 */     GIR_Done,
     /* 406525 */   // Label 8231: @406525
     /* 406525 */   GIM_Reject,
     /* 406526 */ // Label 8227: @406526
     /* 406526 */ GIM_Reject,
     /* 406527 */ // Label 8220: @406527
     /* 406527 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(406699),
     /* 406532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 406538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406542 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(406601), // Rule ID 1182 //
     /* 406547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406586 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 406589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406599 */     GIR_RootConstrainSelectedInstOperands,
     /* 406600 */     // GIR_Coverage, 1182,
     /* 406600 */     GIR_EraseRootFromParent_Done,
     /* 406601 */   // Label 8233: @406601
     /* 406601 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(406636), // Rule ID 793 //
     /* 406606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406613 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406619 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406627 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 406627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 406630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406634 */     GIR_RootConstrainSelectedInstOperands,
     /* 406635 */     // GIR_Coverage, 793,
     /* 406635 */     GIR_EraseRootFromParent_Done,
     /* 406636 */   // Label 8234: @406636
     /* 406636 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(406671), // Rule ID 783 //
     /* 406641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406662 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 406662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 406665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406669 */     GIR_RootConstrainSelectedInstOperands,
     /* 406670 */     // GIR_Coverage, 783,
     /* 406670 */     GIR_EraseRootFromParent_Done,
     /* 406671 */   // Label 8235: @406671
     /* 406671 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(406698), // Rule ID 1220 //
     /* 406676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406687 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 406692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406696 */     GIR_RootConstrainSelectedInstOperands,
     /* 406697 */     // GIR_Coverage, 1220,
     /* 406697 */     GIR_Done,
     /* 406698 */   // Label 8236: @406698
     /* 406698 */   GIM_Reject,
     /* 406699 */ // Label 8232: @406699
     /* 406699 */ GIM_Reject,
     /* 406700 */ // Label 8221: @406700
     /* 406700 */ GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(406872),
     /* 406705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 406711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406715 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(406774), // Rule ID 1186 //
     /* 406720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406759 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 406762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406772 */     GIR_RootConstrainSelectedInstOperands,
     /* 406773 */     // GIR_Coverage, 1186,
     /* 406773 */     GIR_EraseRootFromParent_Done,
     /* 406774 */   // Label 8238: @406774
     /* 406774 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(406809), // Rule ID 795 //
     /* 406779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406786 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406792 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406800 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 406800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 406803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406807 */     GIR_RootConstrainSelectedInstOperands,
     /* 406808 */     // GIR_Coverage, 795,
     /* 406808 */     GIR_EraseRootFromParent_Done,
     /* 406809 */   // Label 8239: @406809
     /* 406809 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(406844), // Rule ID 785 //
     /* 406814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406825 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406831 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406835 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 406835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 406838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406842 */     GIR_RootConstrainSelectedInstOperands,
     /* 406843 */     // GIR_Coverage, 785,
     /* 406843 */     GIR_EraseRootFromParent_Done,
     /* 406844 */   // Label 8240: @406844
     /* 406844 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(406871), // Rule ID 1222 //
     /* 406849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406860 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 406865 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406869 */     GIR_RootConstrainSelectedInstOperands,
     /* 406870 */     // GIR_Coverage, 1222,
     /* 406870 */     GIR_Done,
     /* 406871 */   // Label 8241: @406871
     /* 406871 */   GIM_Reject,
     /* 406872 */ // Label 8237: @406872
     /* 406872 */ GIM_Reject,
     /* 406873 */ // Label 8222: @406873
     /* 406873 */ GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(407045),
     /* 406878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 406884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406888 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(406947), // Rule ID 1178 //
     /* 406893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 406921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406932 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 406932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 406935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406945 */     GIR_RootConstrainSelectedInstOperands,
     /* 406946 */     // GIR_Coverage, 1178,
     /* 406946 */     GIR_EraseRootFromParent_Done,
     /* 406947 */   // Label 8243: @406947
     /* 406947 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(406982), // Rule ID 791 //
     /* 406952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406959 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 406965 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 406967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406973 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 406973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 406976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406980 */     GIR_RootConstrainSelectedInstOperands,
     /* 406981 */     // GIR_Coverage, 791,
     /* 406981 */     GIR_EraseRootFromParent_Done,
     /* 406982 */   // Label 8244: @406982
     /* 406982 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(407017), // Rule ID 781 //
     /* 406987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 406990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406998 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407004 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407008 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 407008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 407011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407015 */     GIR_RootConstrainSelectedInstOperands,
     /* 407016 */     // GIR_Coverage, 781,
     /* 407016 */     GIR_EraseRootFromParent_Done,
     /* 407017 */   // Label 8245: @407017
     /* 407017 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(407044), // Rule ID 1218 //
     /* 407022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407033 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 407033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 407038 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407042 */     GIR_RootConstrainSelectedInstOperands,
     /* 407043 */     // GIR_Coverage, 1218,
     /* 407043 */     GIR_Done,
     /* 407044 */   // Label 8246: @407044
     /* 407044 */   GIM_Reject,
     /* 407045 */ // Label 8242: @407045
     /* 407045 */ GIM_Reject,
     /* 407046 */ // Label 8223: @407046
     /* 407046 */ GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(407218),
     /* 407051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 407057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407061 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(407120), // Rule ID 1184 //
     /* 407066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 407077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 407094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407105 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 407105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 407108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 407114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407118 */     GIR_RootConstrainSelectedInstOperands,
     /* 407119 */     // GIR_Coverage, 1184,
     /* 407119 */     GIR_EraseRootFromParent_Done,
     /* 407120 */   // Label 8248: @407120
     /* 407120 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(407155), // Rule ID 794 //
     /* 407125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407132 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407138 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407146 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 407146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 407149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407153 */     GIR_RootConstrainSelectedInstOperands,
     /* 407154 */     // GIR_Coverage, 794,
     /* 407154 */     GIR_EraseRootFromParent_Done,
     /* 407155 */   // Label 8249: @407155
     /* 407155 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(407190), // Rule ID 784 //
     /* 407160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407171 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407177 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407181 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 407181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 407184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407188 */     GIR_RootConstrainSelectedInstOperands,
     /* 407189 */     // GIR_Coverage, 784,
     /* 407189 */     GIR_EraseRootFromParent_Done,
     /* 407190 */   // Label 8250: @407190
     /* 407190 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(407217), // Rule ID 1221 //
     /* 407195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407206 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 407206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 407211 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407215 */     GIR_RootConstrainSelectedInstOperands,
     /* 407216 */     // GIR_Coverage, 1221,
     /* 407216 */     GIR_Done,
     /* 407217 */   // Label 8251: @407217
     /* 407217 */   GIM_Reject,
     /* 407218 */ // Label 8247: @407218
     /* 407218 */ GIM_Reject,
     /* 407219 */ // Label 8224: @407219
     /* 407219 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(407391),
     /* 407224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 407230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407234 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(407293), // Rule ID 1180 //
     /* 407239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 407250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 407267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407278 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 407278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 407281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 407287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407291 */     GIR_RootConstrainSelectedInstOperands,
     /* 407292 */     // GIR_Coverage, 1180,
     /* 407292 */     GIR_EraseRootFromParent_Done,
     /* 407293 */   // Label 8253: @407293
     /* 407293 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(407328), // Rule ID 792 //
     /* 407298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407311 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407319 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 407319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 407322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407326 */     GIR_RootConstrainSelectedInstOperands,
     /* 407327 */     // GIR_Coverage, 792,
     /* 407327 */     GIR_EraseRootFromParent_Done,
     /* 407328 */   // Label 8254: @407328
     /* 407328 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(407363), // Rule ID 782 //
     /* 407333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 407350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 407352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407354 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 407354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 407357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407361 */     GIR_RootConstrainSelectedInstOperands,
     /* 407362 */     // GIR_Coverage, 782,
     /* 407362 */     GIR_EraseRootFromParent_Done,
     /* 407363 */   // Label 8255: @407363
     /* 407363 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(407390), // Rule ID 1219 //
     /* 407368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 407371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407379 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 407379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 407384 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407388 */     GIR_RootConstrainSelectedInstOperands,
     /* 407389 */     // GIR_Coverage, 1219,
     /* 407389 */     GIR_Done,
     /* 407390 */   // Label 8256: @407390
     /* 407390 */   GIM_Reject,
     /* 407391 */ // Label 8252: @407391
     /* 407391 */ GIM_Reject,
     /* 407392 */ // Label 8225: @407392
     /* 407392 */ GIM_Reject,
     /* 407393 */ // Label 133: @407393
     /* 407393 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8261*/ GIMT_Encode4(407546),
     /* 407404 */ /*GILLT_s32*//*Label 8257*/ GIMT_Encode4(407444),
     /* 407408 */ /*GILLT_s64*//*Label 8258*/ GIMT_Encode4(407468), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 407432 */ /*GILLT_v8s8*//*Label 8259*/ GIMT_Encode4(407492), GIMT_Encode4(0),
     /* 407440 */ /*GILLT_v16s8*//*Label 8260*/ GIMT_Encode4(407519),
     /* 407444 */ // Label 8257: @407444
     /* 407444 */ GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(407467), // Rule ID 4015 //
     /* 407449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 407452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 407456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 407460 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 407460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 407465 */   GIR_RootConstrainSelectedInstOperands,
     /* 407466 */   // GIR_Coverage, 4015,
     /* 407466 */   GIR_Done,
     /* 407467 */ // Label 8262: @407467
     /* 407467 */ GIM_Reject,
     /* 407468 */ // Label 8258: @407468
     /* 407468 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(407491), // Rule ID 4016 //
     /* 407473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 407476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 407480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 407484 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 407484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 407489 */   GIR_RootConstrainSelectedInstOperands,
     /* 407490 */   // GIR_Coverage, 4016,
     /* 407490 */   GIR_Done,
     /* 407491 */ // Label 8263: @407491
     /* 407491 */ GIM_Reject,
     /* 407492 */ // Label 8259: @407492
     /* 407492 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(407518), // Rule ID 976 //
     /* 407497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407511 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 407511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 407516 */   GIR_RootConstrainSelectedInstOperands,
     /* 407517 */   // GIR_Coverage, 976,
     /* 407517 */   GIR_Done,
     /* 407518 */ // Label 8264: @407518
     /* 407518 */ GIM_Reject,
     /* 407519 */ // Label 8260: @407519
     /* 407519 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(407545), // Rule ID 977 //
     /* 407524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407538 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 407538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 407543 */   GIR_RootConstrainSelectedInstOperands,
     /* 407544 */   // GIR_Coverage, 977,
     /* 407544 */   GIR_Done,
     /* 407545 */ // Label 8265: @407545
     /* 407545 */ GIM_Reject,
     /* 407546 */ // Label 8261: @407546
     /* 407546 */ GIM_Reject,
     /* 407547 */ // Label 134: @407547
     /* 407547 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8270*/ GIMT_Encode4(407722),
     /* 407558 */ /*GILLT_v4s16*//*Label 8266*/ GIMT_Encode4(407578), GIMT_Encode4(0),
     /* 407566 */ /*GILLT_v8s8*//*Label 8267*/ GIMT_Encode4(407623),
     /* 407570 */ /*GILLT_v8s16*//*Label 8268*/ GIMT_Encode4(407650),
     /* 407574 */ /*GILLT_v16s8*//*Label 8269*/ GIMT_Encode4(407695),
     /* 407578 */ // Label 8266: @407578
     /* 407578 */ GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(407622),
     /* 407583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407594 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(407609), // Rule ID 980 //
     /* 407599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407602 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 407602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 407607 */     GIR_RootConstrainSelectedInstOperands,
     /* 407608 */     // GIR_Coverage, 980,
     /* 407608 */     GIR_Done,
     /* 407609 */   // Label 8272: @407609
     /* 407609 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(407621), // Rule ID 4962 //
     /* 407614 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 407614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 407619 */     GIR_RootConstrainSelectedInstOperands,
     /* 407620 */     // GIR_Coverage, 4962,
     /* 407620 */     GIR_Done,
     /* 407621 */   // Label 8273: @407621
     /* 407621 */   GIM_Reject,
     /* 407622 */ // Label 8271: @407622
     /* 407622 */ GIM_Reject,
     /* 407623 */ // Label 8267: @407623
     /* 407623 */ GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(407649), // Rule ID 978 //
     /* 407628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407642 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 407642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 407647 */   GIR_RootConstrainSelectedInstOperands,
     /* 407648 */   // GIR_Coverage, 978,
     /* 407648 */   GIR_Done,
     /* 407649 */ // Label 8274: @407649
     /* 407649 */ GIM_Reject,
     /* 407650 */ // Label 8268: @407650
     /* 407650 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(407694),
     /* 407655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407666 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(407681), // Rule ID 981 //
     /* 407671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407674 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 407674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 407679 */     GIR_RootConstrainSelectedInstOperands,
     /* 407680 */     // GIR_Coverage, 981,
     /* 407680 */     GIR_Done,
     /* 407681 */   // Label 8276: @407681
     /* 407681 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(407693), // Rule ID 4964 //
     /* 407686 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 407686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 407691 */     GIR_RootConstrainSelectedInstOperands,
     /* 407692 */     // GIR_Coverage, 4964,
     /* 407692 */     GIR_Done,
     /* 407693 */   // Label 8277: @407693
     /* 407693 */   GIM_Reject,
     /* 407694 */ // Label 8275: @407694
     /* 407694 */ GIM_Reject,
     /* 407695 */ // Label 8269: @407695
     /* 407695 */ GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(407721), // Rule ID 979 //
     /* 407700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407714 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 407714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 407719 */   GIR_RootConstrainSelectedInstOperands,
     /* 407720 */   // GIR_Coverage, 979,
     /* 407720 */   GIR_Done,
     /* 407721 */ // Label 8278: @407721
     /* 407721 */ GIM_Reject,
     /* 407722 */ // Label 8270: @407722
     /* 407722 */ GIM_Reject,
     /* 407723 */ // Label 135: @407723
     /* 407723 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8285*/ GIMT_Encode4(407996),
     /* 407734 */ /*GILLT_v2s32*//*Label 8279*/ GIMT_Encode4(407762), GIMT_Encode4(0),
     /* 407742 */ /*GILLT_v4s16*//*Label 8280*/ GIMT_Encode4(407807),
     /* 407746 */ /*GILLT_v4s32*//*Label 8281*/ GIMT_Encode4(407852),
     /* 407750 */ /*GILLT_v8s8*//*Label 8282*/ GIMT_Encode4(407897),
     /* 407754 */ /*GILLT_v8s16*//*Label 8283*/ GIMT_Encode4(407924),
     /* 407758 */ /*GILLT_v16s8*//*Label 8284*/ GIMT_Encode4(407969),
     /* 407762 */ // Label 8279: @407762
     /* 407762 */ GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(407806),
     /* 407767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407778 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(407793), // Rule ID 986 //
     /* 407783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407786 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 407786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 407791 */     GIR_RootConstrainSelectedInstOperands,
     /* 407792 */     // GIR_Coverage, 986,
     /* 407792 */     GIR_Done,
     /* 407793 */   // Label 8287: @407793
     /* 407793 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(407805), // Rule ID 4966 //
     /* 407798 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 407798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 407803 */     GIR_RootConstrainSelectedInstOperands,
     /* 407804 */     // GIR_Coverage, 4966,
     /* 407804 */     GIR_Done,
     /* 407805 */   // Label 8288: @407805
     /* 407805 */   GIM_Reject,
     /* 407806 */ // Label 8286: @407806
     /* 407806 */ GIM_Reject,
     /* 407807 */ // Label 8280: @407807
     /* 407807 */ GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(407851),
     /* 407812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407823 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(407838), // Rule ID 984 //
     /* 407828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407831 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 407831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 407836 */     GIR_RootConstrainSelectedInstOperands,
     /* 407837 */     // GIR_Coverage, 984,
     /* 407837 */     GIR_Done,
     /* 407838 */   // Label 8290: @407838
     /* 407838 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(407850), // Rule ID 4963 //
     /* 407843 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 407843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 407848 */     GIR_RootConstrainSelectedInstOperands,
     /* 407849 */     // GIR_Coverage, 4963,
     /* 407849 */     GIR_Done,
     /* 407850 */   // Label 8291: @407850
     /* 407850 */   GIM_Reject,
     /* 407851 */ // Label 8289: @407851
     /* 407851 */ GIM_Reject,
     /* 407852 */ // Label 8281: @407852
     /* 407852 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(407896),
     /* 407857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407868 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(407883), // Rule ID 987 //
     /* 407873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407876 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 407876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 407881 */     GIR_RootConstrainSelectedInstOperands,
     /* 407882 */     // GIR_Coverage, 987,
     /* 407882 */     GIR_Done,
     /* 407883 */   // Label 8293: @407883
     /* 407883 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(407895), // Rule ID 4967 //
     /* 407888 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 407888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 407893 */     GIR_RootConstrainSelectedInstOperands,
     /* 407894 */     // GIR_Coverage, 4967,
     /* 407894 */     GIR_Done,
     /* 407895 */   // Label 8294: @407895
     /* 407895 */   GIM_Reject,
     /* 407896 */ // Label 8292: @407896
     /* 407896 */ GIM_Reject,
     /* 407897 */ // Label 8282: @407897
     /* 407897 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(407923), // Rule ID 982 //
     /* 407902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407916 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 407916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 407921 */   GIR_RootConstrainSelectedInstOperands,
     /* 407922 */   // GIR_Coverage, 982,
     /* 407922 */   GIR_Done,
     /* 407923 */ // Label 8295: @407923
     /* 407923 */ GIM_Reject,
     /* 407924 */ // Label 8283: @407924
     /* 407924 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(407968),
     /* 407929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407940 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(407955), // Rule ID 985 //
     /* 407945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407948 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 407948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 407953 */     GIR_RootConstrainSelectedInstOperands,
     /* 407954 */     // GIR_Coverage, 985,
     /* 407954 */     GIR_Done,
     /* 407955 */   // Label 8297: @407955
     /* 407955 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(407967), // Rule ID 4965 //
     /* 407960 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 407960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 407965 */     GIR_RootConstrainSelectedInstOperands,
     /* 407966 */     // GIR_Coverage, 4965,
     /* 407966 */     GIR_Done,
     /* 407967 */   // Label 8298: @407967
     /* 407967 */   GIM_Reject,
     /* 407968 */ // Label 8296: @407968
     /* 407968 */ GIM_Reject,
     /* 407969 */ // Label 8284: @407969
     /* 407969 */ GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(407995), // Rule ID 983 //
     /* 407974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407988 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 407988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 407993 */   GIR_RootConstrainSelectedInstOperands,
     /* 407994 */   // GIR_Coverage, 983,
     /* 407994 */   GIR_Done,
     /* 407995 */ // Label 8299: @407995
     /* 407995 */ GIM_Reject,
     /* 407996 */ // Label 8285: @407996
     /* 407996 */ GIM_Reject,
     /* 407997 */ // Label 136: @407997
     /* 407997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8306*/ GIMT_Encode4(408202),
     /* 408008 */ /*GILLT_s64*//*Label 8300*/ GIMT_Encode4(408040), GIMT_Encode4(0),
     /* 408016 */ /*GILLT_v2s32*//*Label 8301*/ GIMT_Encode4(408067),
     /* 408020 */ /*GILLT_v2s64*//*Label 8302*/ GIMT_Encode4(408094),
     /* 408024 */ /*GILLT_v4s16*//*Label 8303*/ GIMT_Encode4(408121),
     /* 408028 */ /*GILLT_v4s32*//*Label 8304*/ GIMT_Encode4(408148), GIMT_Encode4(0),
     /* 408036 */ /*GILLT_v8s16*//*Label 8305*/ GIMT_Encode4(408175),
     /* 408040 */ // Label 8300: @408040
     /* 408040 */ GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(408066), // Rule ID 1008 //
     /* 408045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408059 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 408059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 408064 */   GIR_RootConstrainSelectedInstOperands,
     /* 408065 */   // GIR_Coverage, 1008,
     /* 408065 */   GIR_Done,
     /* 408066 */ // Label 8307: @408066
     /* 408066 */ GIM_Reject,
     /* 408067 */ // Label 8301: @408067
     /* 408067 */ GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(408093), // Rule ID 1004 //
     /* 408072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408086 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 408086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 408091 */   GIR_RootConstrainSelectedInstOperands,
     /* 408092 */   // GIR_Coverage, 1004,
     /* 408092 */   GIR_Done,
     /* 408093 */ // Label 8308: @408093
     /* 408093 */ GIM_Reject,
     /* 408094 */ // Label 8302: @408094
     /* 408094 */ GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(408120), // Rule ID 1010 //
     /* 408099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408113 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 408113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 408118 */   GIR_RootConstrainSelectedInstOperands,
     /* 408119 */   // GIR_Coverage, 1010,
     /* 408119 */   GIR_Done,
     /* 408120 */ // Label 8309: @408120
     /* 408120 */ GIM_Reject,
     /* 408121 */ // Label 8303: @408121
     /* 408121 */ GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(408147), // Rule ID 1000 //
     /* 408126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408140 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 408140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 408145 */   GIR_RootConstrainSelectedInstOperands,
     /* 408146 */   // GIR_Coverage, 1000,
     /* 408146 */   GIR_Done,
     /* 408147 */ // Label 8310: @408147
     /* 408147 */ GIM_Reject,
     /* 408148 */ // Label 8304: @408148
     /* 408148 */ GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(408174), // Rule ID 1006 //
     /* 408153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408167 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 408167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 408172 */   GIR_RootConstrainSelectedInstOperands,
     /* 408173 */   // GIR_Coverage, 1006,
     /* 408173 */   GIR_Done,
     /* 408174 */ // Label 8311: @408174
     /* 408174 */ GIM_Reject,
     /* 408175 */ // Label 8305: @408175
     /* 408175 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(408201), // Rule ID 1002 //
     /* 408180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408194 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 408194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 408199 */   GIR_RootConstrainSelectedInstOperands,
     /* 408200 */   // GIR_Coverage, 1002,
     /* 408200 */   GIR_Done,
     /* 408201 */ // Label 8312: @408201
     /* 408201 */ GIM_Reject,
     /* 408202 */ // Label 8306: @408202
     /* 408202 */ GIM_Reject,
     /* 408203 */ // Label 137: @408203
     /* 408203 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8315*/ GIMT_Encode4(408601),
     /* 408214 */ /*GILLT_v2s64*//*Label 8313*/ GIMT_Encode4(408226), GIMT_Encode4(0),
     /* 408222 */ /*GILLT_v4s32*//*Label 8314*/ GIMT_Encode4(408364),
     /* 408226 */ // Label 8313: @408226
     /* 408226 */ GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(408285), // Rule ID 5882 //
     /* 408231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408242 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 408242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 408249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408254 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 408274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408284 */   // GIR_Coverage, 5882,
     /* 408284 */   GIR_EraseRootFromParent_Done,
     /* 408285 */ // Label 8316: @408285
     /* 408285 */ GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(408363), // Rule ID 6004 //
     /* 408290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408301 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 408301 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408304 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 408308 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408313 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 408319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 408322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 408326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 408336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 408347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408357 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408362 */   // GIR_Coverage, 6004,
     /* 408362 */   GIR_EraseRootFromParent_Done,
     /* 408363 */ // Label 8317: @408363
     /* 408363 */ GIM_Reject,
     /* 408364 */ // Label 8314: @408364
     /* 408364 */ GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(408423), // Rule ID 5878 //
     /* 408369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408380 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 408380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 408387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408392 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408412 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408422 */   // GIR_Coverage, 5878,
     /* 408422 */   GIR_EraseRootFromParent_Done,
     /* 408423 */ // Label 8318: @408423
     /* 408423 */ GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(408482), // Rule ID 5879 //
     /* 408428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408439 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 408439 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 408446 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408451 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408465 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408481 */   // GIR_Coverage, 5879,
     /* 408481 */   GIR_EraseRootFromParent_Done,
     /* 408482 */ // Label 8319: @408482
     /* 408482 */ GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(408541), // Rule ID 5880 //
     /* 408487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408498 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 408498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 408505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408510 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408540 */   // GIR_Coverage, 5880,
     /* 408540 */   GIR_EraseRootFromParent_Done,
     /* 408541 */ // Label 8320: @408541
     /* 408541 */ GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(408600), // Rule ID 5881 //
     /* 408546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408557 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 408557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 408564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408569 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408599 */   // GIR_Coverage, 5881,
     /* 408599 */   GIR_EraseRootFromParent_Done,
     /* 408600 */ // Label 8321: @408600
     /* 408600 */ GIM_Reject,
     /* 408601 */ // Label 8315: @408601
     /* 408601 */ GIM_Reject,
     /* 408602 */ // Label 138: @408602
     /* 408602 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8326*/ GIMT_Encode4(408971),
     /* 408613 */ /*GILLT_v2s32*//*Label 8322*/ GIMT_Encode4(408673), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408625 */ /*GILLT_v4s32*//*Label 8323*/ GIMT_Encode4(408793), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408657 */ /*GILLT_nxv2s64*//*Label 8324*/ GIMT_Encode4(408913), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408669 */ /*GILLT_nxv4s32*//*Label 8325*/ GIMT_Encode4(408942),
     /* 408673 */ // Label 8322: @408673
     /* 408673 */ GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(408792),
     /* 408678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 408684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 408687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408699 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(408772), // Rule ID 26 //
     /* 408704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408748 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408752 */     // MIs[3] Operand 1
     /* 408752 */     // No operand predicates
     /* 408752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408754 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 408757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408770 */     GIR_RootConstrainSelectedInstOperands,
     /* 408771 */     // GIR_Coverage, 26,
     /* 408771 */     GIR_EraseRootFromParent_Done,
     /* 408772 */   // Label 8328: @408772
     /* 408772 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(408791), // Rule ID 22 //
     /* 408777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408784 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 408784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 408789 */     GIR_RootConstrainSelectedInstOperands,
     /* 408790 */     // GIR_Coverage, 22,
     /* 408790 */     GIR_Done,
     /* 408791 */   // Label 8329: @408791
     /* 408791 */   GIM_Reject,
     /* 408792 */ // Label 8327: @408792
     /* 408792 */ GIM_Reject,
     /* 408793 */ // Label 8323: @408793
     /* 408793 */ GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(408912),
     /* 408798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 408804 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 408807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408819 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(408892), // Rule ID 27 //
     /* 408824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408868 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408872 */     // MIs[3] Operand 1
     /* 408872 */     // No operand predicates
     /* 408872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408874 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 408877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408890 */     GIR_RootConstrainSelectedInstOperands,
     /* 408891 */     // GIR_Coverage, 27,
     /* 408891 */     GIR_EraseRootFromParent_Done,
     /* 408892 */   // Label 8331: @408892
     /* 408892 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(408911), // Rule ID 23 //
     /* 408897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408904 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 408904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 408909 */     GIR_RootConstrainSelectedInstOperands,
     /* 408910 */     // GIR_Coverage, 23,
     /* 408910 */     GIR_Done,
     /* 408911 */   // Label 8332: @408911
     /* 408911 */   GIM_Reject,
     /* 408912 */ // Label 8330: @408912
     /* 408912 */ GIM_Reject,
     /* 408913 */ // Label 8324: @408913
     /* 408913 */ GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(408941), // Rule ID 2986 //
     /* 408918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 408924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 408927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 408930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408934 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 408934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 408939 */   GIR_RootConstrainSelectedInstOperands,
     /* 408940 */   // GIR_Coverage, 2986,
     /* 408940 */   GIR_Done,
     /* 408941 */ // Label 8333: @408941
     /* 408941 */ GIM_Reject,
     /* 408942 */ // Label 8325: @408942
     /* 408942 */ GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(408970), // Rule ID 2985 //
     /* 408947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 408953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 408956 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 408959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408963 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 408963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 408968 */   GIR_RootConstrainSelectedInstOperands,
     /* 408969 */   // GIR_Coverage, 2985,
     /* 408969 */   GIR_Done,
     /* 408970 */ // Label 8334: @408970
     /* 408970 */ GIM_Reject,
     /* 408971 */ // Label 8326: @408971
     /* 408971 */ GIM_Reject,
     /* 408972 */ // Label 139: @408972
     /* 408972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8338*/ GIMT_Encode4(409088),
     /* 408983 */ /*GILLT_s16*//*Label 8335*/ GIMT_Encode4(408995),
     /* 408987 */ /*GILLT_s32*//*Label 8336*/ GIMT_Encode4(409026),
     /* 408991 */ /*GILLT_s64*//*Label 8337*/ GIMT_Encode4(409057),
     /* 408995 */ // Label 8335: @408995
     /* 408995 */ GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(409025), // Rule ID 1658 //
     /* 409000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 409003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 409006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409014 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 409014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 409019 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409023 */   GIR_RootConstrainSelectedInstOperands,
     /* 409024 */   // GIR_Coverage, 1658,
     /* 409024 */   GIR_Done,
     /* 409025 */ // Label 8339: @409025
     /* 409025 */ GIM_Reject,
     /* 409026 */ // Label 8336: @409026
     /* 409026 */ GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(409056), // Rule ID 1657 //
     /* 409031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 409034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 409037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409045 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 409045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 409050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409054 */   GIR_RootConstrainSelectedInstOperands,
     /* 409055 */   // GIR_Coverage, 1657,
     /* 409055 */   GIR_Done,
     /* 409056 */ // Label 8340: @409056
     /* 409056 */ GIM_Reject,
     /* 409057 */ // Label 8337: @409057
     /* 409057 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(409087), // Rule ID 1656 //
     /* 409062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 409065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 409068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409076 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 409076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 409081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409085 */   GIR_RootConstrainSelectedInstOperands,
     /* 409086 */   // GIR_Coverage, 1656,
     /* 409086 */   GIR_Done,
     /* 409087 */ // Label 8341: @409087
     /* 409087 */ GIM_Reject,
     /* 409088 */ // Label 8338: @409088
     /* 409088 */ GIM_Reject,
     /* 409089 */ // Label 140: @409089
     /* 409089 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8345*/ GIMT_Encode4(410321),
     /* 409100 */ /*GILLT_v2s64*//*Label 8342*/ GIMT_Encode4(409120), GIMT_Encode4(0),
     /* 409108 */ /*GILLT_v4s32*//*Label 8343*/ GIMT_Encode4(409681), GIMT_Encode4(0),
     /* 409116 */ /*GILLT_v8s16*//*Label 8344*/ GIMT_Encode4(410242),
     /* 409120 */ // Label 8342: @409120
     /* 409120 */ GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(409680),
     /* 409125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 409131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409135 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(409227), // Rule ID 2054 //
     /* 409140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409184 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409188 */     // MIs[3] Operand 1
     /* 409188 */     // No operand predicates
     /* 409188 */     // MIs[1] Operand 2
     /* 409188 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 409199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409208 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 409211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409225 */     GIR_RootConstrainSelectedInstOperands,
     /* 409226 */     // GIR_Coverage, 2054,
     /* 409226 */     GIR_EraseRootFromParent_Done,
     /* 409227 */   // Label 8347: @409227
     /* 409227 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(409319), // Rule ID 13524 //
     /* 409232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409276 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409280 */     // MIs[3] Operand 1
     /* 409280 */     // No operand predicates
     /* 409280 */     // MIs[1] Operand 2
     /* 409280 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 409291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409300 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 409303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409317 */     GIR_RootConstrainSelectedInstOperands,
     /* 409318 */     // GIR_Coverage, 13524,
     /* 409318 */     GIR_EraseRootFromParent_Done,
     /* 409319 */   // Label 8348: @409319
     /* 409319 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(409405), // Rule ID 13522 //
     /* 409324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409368 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409372 */     // MIs[3] Operand 1
     /* 409372 */     // No operand predicates
     /* 409372 */     // MIs[1] Operand 2
     /* 409372 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409389 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 409392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409403 */     GIR_RootConstrainSelectedInstOperands,
     /* 409404 */     // GIR_Coverage, 13522,
     /* 409404 */     GIR_EraseRootFromParent_Done,
     /* 409405 */   // Label 8349: @409405
     /* 409405 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(409491), // Rule ID 2052 //
     /* 409410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409458 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409462 */     // MIs[3] Operand 1
     /* 409462 */     // No operand predicates
     /* 409462 */     // MIs[1] Operand 2
     /* 409462 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409475 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 409478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409489 */     GIR_RootConstrainSelectedInstOperands,
     /* 409490 */     // GIR_Coverage, 2052,
     /* 409490 */     GIR_EraseRootFromParent_Done,
     /* 409491 */   // Label 8350: @409491
     /* 409491 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(409530), // Rule ID 1741 //
     /* 409496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409513 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 409513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 409516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 409528 */     GIR_RootConstrainSelectedInstOperands,
     /* 409529 */     // GIR_Coverage, 1741,
     /* 409529 */     GIR_EraseRootFromParent_Done,
     /* 409530 */   // Label 8351: @409530
     /* 409530 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(409593), // Rule ID 13523 //
     /* 409535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409571 */     // MIs[2] Operand 1
     /* 409571 */     // No operand predicates
     /* 409571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409577 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 409580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409591 */     GIR_RootConstrainSelectedInstOperands,
     /* 409592 */     // GIR_Coverage, 13523,
     /* 409592 */     GIR_EraseRootFromParent_Done,
     /* 409593 */   // Label 8352: @409593
     /* 409593 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(409656), // Rule ID 2053 //
     /* 409598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409634 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409638 */     // MIs[2] Operand 1
     /* 409638 */     // No operand predicates
     /* 409638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409640 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 409643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409654 */     GIR_RootConstrainSelectedInstOperands,
     /* 409655 */     // GIR_Coverage, 2053,
     /* 409655 */     GIR_EraseRootFromParent_Done,
     /* 409656 */   // Label 8353: @409656
     /* 409656 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(409679), // Rule ID 1740 //
     /* 409661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409672 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 409672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 409677 */     GIR_RootConstrainSelectedInstOperands,
     /* 409678 */     // GIR_Coverage, 1740,
     /* 409678 */     GIR_Done,
     /* 409679 */   // Label 8354: @409679
     /* 409679 */   GIM_Reject,
     /* 409680 */ // Label 8346: @409680
     /* 409680 */ GIM_Reject,
     /* 409681 */ // Label 8343: @409681
     /* 409681 */ GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(410241),
     /* 409686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 409689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 409692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409696 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(409788), // Rule ID 2051 //
     /* 409701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409745 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409749 */     // MIs[3] Operand 1
     /* 409749 */     // No operand predicates
     /* 409749 */     // MIs[1] Operand 2
     /* 409749 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409769 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 409772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409786 */     GIR_RootConstrainSelectedInstOperands,
     /* 409787 */     // GIR_Coverage, 2051,
     /* 409787 */     GIR_EraseRootFromParent_Done,
     /* 409788 */   // Label 8356: @409788
     /* 409788 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(409880), // Rule ID 13521 //
     /* 409793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409841 */     // MIs[3] Operand 1
     /* 409841 */     // No operand predicates
     /* 409841 */     // MIs[1] Operand 2
     /* 409841 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409861 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 409864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409878 */     GIR_RootConstrainSelectedInstOperands,
     /* 409879 */     // GIR_Coverage, 13521,
     /* 409879 */     GIR_EraseRootFromParent_Done,
     /* 409880 */   // Label 8357: @409880
     /* 409880 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(409966), // Rule ID 13519 //
     /* 409885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409929 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409933 */     // MIs[3] Operand 1
     /* 409933 */     // No operand predicates
     /* 409933 */     // MIs[1] Operand 2
     /* 409933 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409950 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 409953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409964 */     GIR_RootConstrainSelectedInstOperands,
     /* 409965 */     // GIR_Coverage, 13519,
     /* 409965 */     GIR_EraseRootFromParent_Done,
     /* 409966 */   // Label 8358: @409966
     /* 409966 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(410052), // Rule ID 2049 //
     /* 409971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410019 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410023 */     // MIs[3] Operand 1
     /* 410023 */     // No operand predicates
     /* 410023 */     // MIs[1] Operand 2
     /* 410023 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 410034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410036 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 410039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410050 */     GIR_RootConstrainSelectedInstOperands,
     /* 410051 */     // GIR_Coverage, 2049,
     /* 410051 */     GIR_EraseRootFromParent_Done,
     /* 410052 */   // Label 8359: @410052
     /* 410052 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(410091), // Rule ID 1739 //
     /* 410057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410074 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 410077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410089 */     GIR_RootConstrainSelectedInstOperands,
     /* 410090 */     // GIR_Coverage, 1739,
     /* 410090 */     GIR_EraseRootFromParent_Done,
     /* 410091 */   // Label 8360: @410091
     /* 410091 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(410154), // Rule ID 13520 //
     /* 410096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410128 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410132 */     // MIs[2] Operand 1
     /* 410132 */     // No operand predicates
     /* 410132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410138 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 410141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410152 */     GIR_RootConstrainSelectedInstOperands,
     /* 410153 */     // GIR_Coverage, 13520,
     /* 410153 */     GIR_EraseRootFromParent_Done,
     /* 410154 */   // Label 8361: @410154
     /* 410154 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(410217), // Rule ID 2050 //
     /* 410159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410199 */     // MIs[2] Operand 1
     /* 410199 */     // No operand predicates
     /* 410199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410201 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 410204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410215 */     GIR_RootConstrainSelectedInstOperands,
     /* 410216 */     // GIR_Coverage, 2050,
     /* 410216 */     GIR_EraseRootFromParent_Done,
     /* 410217 */   // Label 8362: @410217
     /* 410217 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(410240), // Rule ID 1738 //
     /* 410222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410233 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 410238 */     GIR_RootConstrainSelectedInstOperands,
     /* 410239 */     // GIR_Coverage, 1738,
     /* 410239 */     GIR_Done,
     /* 410240 */   // Label 8363: @410240
     /* 410240 */   GIM_Reject,
     /* 410241 */ // Label 8355: @410241
     /* 410241 */ GIM_Reject,
     /* 410242 */ // Label 8344: @410242
     /* 410242 */ GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(410320),
     /* 410247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410257 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(410296), // Rule ID 1737 //
     /* 410262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 410272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 410279 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 410282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410294 */     GIR_RootConstrainSelectedInstOperands,
     /* 410295 */     // GIR_Coverage, 1737,
     /* 410295 */     GIR_EraseRootFromParent_Done,
     /* 410296 */   // Label 8365: @410296
     /* 410296 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(410319), // Rule ID 1736 //
     /* 410301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410312 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 410317 */     GIR_RootConstrainSelectedInstOperands,
     /* 410318 */     // GIR_Coverage, 1736,
     /* 410318 */     GIR_Done,
     /* 410319 */   // Label 8366: @410319
     /* 410319 */   GIM_Reject,
     /* 410320 */ // Label 8364: @410320
     /* 410320 */ GIM_Reject,
     /* 410321 */ // Label 8345: @410321
     /* 410321 */ GIM_Reject,
     /* 410322 */ // Label 141: @410322
     /* 410322 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8385*/ GIMT_Encode4(411101),
     /* 410333 */ /*GILLT_v2s32*//*Label 8367*/ GIMT_Encode4(410409),
     /* 410337 */ /*GILLT_v2s64*//*Label 8368*/ GIMT_Encode4(410464),
     /* 410341 */ /*GILLT_v4s16*//*Label 8369*/ GIMT_Encode4(410519),
     /* 410345 */ /*GILLT_v4s32*//*Label 8370*/ GIMT_Encode4(410574),
     /* 410349 */ /*GILLT_v8s8*//*Label 8371*/ GIMT_Encode4(410629),
     /* 410353 */ /*GILLT_v8s16*//*Label 8372*/ GIMT_Encode4(410663),
     /* 410357 */ /*GILLT_v16s8*//*Label 8373*/ GIMT_Encode4(410718), GIMT_Encode4(0),
     /* 410365 */ /*GILLT_nxv2s1*//*Label 8374*/ GIMT_Encode4(410752),
     /* 410369 */ /*GILLT_nxv2s16*//*Label 8375*/ GIMT_Encode4(410778),
     /* 410373 */ /*GILLT_nxv2s32*//*Label 8376*/ GIMT_Encode4(410804),
     /* 410377 */ /*GILLT_nxv2s64*//*Label 8377*/ GIMT_Encode4(410830),
     /* 410381 */ /*GILLT_nxv4s1*//*Label 8378*/ GIMT_Encode4(410877),
     /* 410385 */ /*GILLT_nxv4s16*//*Label 8379*/ GIMT_Encode4(410903),
     /* 410389 */ /*GILLT_nxv4s32*//*Label 8380*/ GIMT_Encode4(410929),
     /* 410393 */ /*GILLT_nxv8s1*//*Label 8381*/ GIMT_Encode4(410976),
     /* 410397 */ /*GILLT_nxv8s16*//*Label 8382*/ GIMT_Encode4(411002),
     /* 410401 */ /*GILLT_nxv16s1*//*Label 8383*/ GIMT_Encode4(411049),
     /* 410405 */ /*GILLT_nxv16s8*//*Label 8384*/ GIMT_Encode4(411075),
     /* 410409 */ // Label 8367: @410409
     /* 410409 */ GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(410463),
     /* 410414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410432 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(410447), // Rule ID 1874 //
     /* 410437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410440 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 410440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 410445 */     GIR_RootConstrainSelectedInstOperands,
     /* 410446 */     // GIR_Coverage, 1874,
     /* 410446 */     GIR_Done,
     /* 410447 */   // Label 8387: @410447
     /* 410447 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(410462), // Rule ID 2505 //
     /* 410452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410455 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 410460 */     GIR_RootConstrainSelectedInstOperands,
     /* 410461 */     // GIR_Coverage, 2505,
     /* 410461 */     GIR_Done,
     /* 410462 */   // Label 8388: @410462
     /* 410462 */   GIM_Reject,
     /* 410463 */ // Label 8386: @410463
     /* 410463 */ GIM_Reject,
     /* 410464 */ // Label 8368: @410464
     /* 410464 */ GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(410518),
     /* 410469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410487 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(410502), // Rule ID 1876 //
     /* 410492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410495 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 410495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 410500 */     GIR_RootConstrainSelectedInstOperands,
     /* 410501 */     // GIR_Coverage, 1876,
     /* 410501 */     GIR_Done,
     /* 410502 */   // Label 8390: @410502
     /* 410502 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(410517), // Rule ID 2507 //
     /* 410507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410510 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 410510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 410515 */     GIR_RootConstrainSelectedInstOperands,
     /* 410516 */     // GIR_Coverage, 2507,
     /* 410516 */     GIR_Done,
     /* 410517 */   // Label 8391: @410517
     /* 410517 */   GIM_Reject,
     /* 410518 */ // Label 8389: @410518
     /* 410518 */ GIM_Reject,
     /* 410519 */ // Label 8369: @410519
     /* 410519 */ GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(410573),
     /* 410524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 410530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410542 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(410557), // Rule ID 1872 //
     /* 410547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410550 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 410555 */     GIR_RootConstrainSelectedInstOperands,
     /* 410556 */     // GIR_Coverage, 1872,
     /* 410556 */     GIR_Done,
     /* 410557 */   // Label 8393: @410557
     /* 410557 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(410572), // Rule ID 2503 //
     /* 410562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410565 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 410565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 410570 */     GIR_RootConstrainSelectedInstOperands,
     /* 410571 */     // GIR_Coverage, 2503,
     /* 410571 */     GIR_Done,
     /* 410572 */   // Label 8394: @410572
     /* 410572 */   GIM_Reject,
     /* 410573 */ // Label 8392: @410573
     /* 410573 */ GIM_Reject,
     /* 410574 */ // Label 8370: @410574
     /* 410574 */ GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(410628),
     /* 410579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 410585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410597 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(410612), // Rule ID 1875 //
     /* 410602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410605 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 410605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 410610 */     GIR_RootConstrainSelectedInstOperands,
     /* 410611 */     // GIR_Coverage, 1875,
     /* 410611 */     GIR_Done,
     /* 410612 */   // Label 8396: @410612
     /* 410612 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(410627), // Rule ID 2506 //
     /* 410617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410620 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 410620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 410625 */     GIR_RootConstrainSelectedInstOperands,
     /* 410626 */     // GIR_Coverage, 2506,
     /* 410626 */     GIR_Done,
     /* 410627 */   // Label 8397: @410627
     /* 410627 */   GIM_Reject,
     /* 410628 */ // Label 8395: @410628
     /* 410628 */ GIM_Reject,
     /* 410629 */ // Label 8371: @410629
     /* 410629 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(410662), // Rule ID 1870 //
     /* 410634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410655 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 410660 */   GIR_RootConstrainSelectedInstOperands,
     /* 410661 */   // GIR_Coverage, 1870,
     /* 410661 */   GIR_Done,
     /* 410662 */ // Label 8398: @410662
     /* 410662 */ GIM_Reject,
     /* 410663 */ // Label 8372: @410663
     /* 410663 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(410717),
     /* 410668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 410674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410686 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(410701), // Rule ID 1873 //
     /* 410691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410694 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 410699 */     GIR_RootConstrainSelectedInstOperands,
     /* 410700 */     // GIR_Coverage, 1873,
     /* 410700 */     GIR_Done,
     /* 410701 */   // Label 8400: @410701
     /* 410701 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(410716), // Rule ID 2504 //
     /* 410706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410709 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 410709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 410714 */     GIR_RootConstrainSelectedInstOperands,
     /* 410715 */     // GIR_Coverage, 2504,
     /* 410715 */     GIR_Done,
     /* 410716 */   // Label 8401: @410716
     /* 410716 */   GIM_Reject,
     /* 410717 */ // Label 8399: @410717
     /* 410717 */ GIM_Reject,
     /* 410718 */ // Label 8373: @410718
     /* 410718 */ GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(410751), // Rule ID 1871 //
     /* 410723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 410729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 410732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410744 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 410749 */   GIR_RootConstrainSelectedInstOperands,
     /* 410750 */   // GIR_Coverage, 1871,
     /* 410750 */   GIR_Done,
     /* 410751 */ // Label 8402: @410751
     /* 410751 */ GIM_Reject,
     /* 410752 */ // Label 8374: @410752
     /* 410752 */ GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(410777), // Rule ID 8987 //
     /* 410757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 410763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 410766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410770 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 410770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 410775 */   GIR_RootConstrainSelectedInstOperands,
     /* 410776 */   // GIR_Coverage, 8987,
     /* 410776 */   GIR_Done,
     /* 410777 */ // Label 8403: @410777
     /* 410777 */ GIM_Reject,
     /* 410778 */ // Label 8375: @410778
     /* 410778 */ GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(410803), // Rule ID 8963 //
     /* 410783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 410789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 410792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410796 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 410796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 410801 */   GIR_RootConstrainSelectedInstOperands,
     /* 410802 */   // GIR_Coverage, 8963,
     /* 410802 */   GIR_Done,
     /* 410803 */ // Label 8404: @410803
     /* 410803 */ GIM_Reject,
     /* 410804 */ // Label 8376: @410804
     /* 410804 */ GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(410829), // Rule ID 8964 //
     /* 410809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 410815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 410818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410822 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 410822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 410827 */   GIR_RootConstrainSelectedInstOperands,
     /* 410828 */   // GIR_Coverage, 8964,
     /* 410828 */   GIR_Done,
     /* 410829 */ // Label 8405: @410829
     /* 410829 */ GIM_Reject,
     /* 410830 */ // Label 8377: @410830
     /* 410830 */ GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(410876),
     /* 410835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 410838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 410841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410845 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(410860), // Rule ID 8959 //
     /* 410850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410853 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 410853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 410858 */     GIR_RootConstrainSelectedInstOperands,
     /* 410859 */     // GIR_Coverage, 8959,
     /* 410859 */     GIR_Done,
     /* 410860 */   // Label 8407: @410860
     /* 410860 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(410875), // Rule ID 8965 //
     /* 410865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410868 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 410868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 410873 */     GIR_RootConstrainSelectedInstOperands,
     /* 410874 */     // GIR_Coverage, 8965,
     /* 410874 */     GIR_Done,
     /* 410875 */   // Label 8408: @410875
     /* 410875 */   GIM_Reject,
     /* 410876 */ // Label 8406: @410876
     /* 410876 */ GIM_Reject,
     /* 410877 */ // Label 8378: @410877
     /* 410877 */ GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(410902), // Rule ID 8986 //
     /* 410882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 410888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 410891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410895 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 410895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 410900 */   GIR_RootConstrainSelectedInstOperands,
     /* 410901 */   // GIR_Coverage, 8986,
     /* 410901 */   GIR_Done,
     /* 410902 */ // Label 8409: @410902
     /* 410902 */ GIM_Reject,
     /* 410903 */ // Label 8379: @410903
     /* 410903 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(410928), // Rule ID 8961 //
     /* 410908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 410914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 410917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410921 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 410921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 410926 */   GIR_RootConstrainSelectedInstOperands,
     /* 410927 */   // GIR_Coverage, 8961,
     /* 410927 */   GIR_Done,
     /* 410928 */ // Label 8410: @410928
     /* 410928 */ GIM_Reject,
     /* 410929 */ // Label 8380: @410929
     /* 410929 */ GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(410975),
     /* 410934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 410937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 410940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410944 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(410959), // Rule ID 8958 //
     /* 410949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410952 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 410952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 410957 */     GIR_RootConstrainSelectedInstOperands,
     /* 410958 */     // GIR_Coverage, 8958,
     /* 410958 */     GIR_Done,
     /* 410959 */   // Label 8412: @410959
     /* 410959 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(410974), // Rule ID 8962 //
     /* 410964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410967 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 410967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 410972 */     GIR_RootConstrainSelectedInstOperands,
     /* 410973 */     // GIR_Coverage, 8962,
     /* 410973 */     GIR_Done,
     /* 410974 */   // Label 8413: @410974
     /* 410974 */   GIM_Reject,
     /* 410975 */ // Label 8411: @410975
     /* 410975 */ GIM_Reject,
     /* 410976 */ // Label 8381: @410976
     /* 410976 */ GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(411001), // Rule ID 8985 //
     /* 410981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 410987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 410990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410994 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 410994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 410999 */   GIR_RootConstrainSelectedInstOperands,
     /* 411000 */   // GIR_Coverage, 8985,
     /* 411000 */   GIR_Done,
     /* 411001 */ // Label 8414: @411001
     /* 411001 */ GIM_Reject,
     /* 411002 */ // Label 8382: @411002
     /* 411002 */ GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(411048),
     /* 411007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411017 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(411032), // Rule ID 8957 //
     /* 411022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411025 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 411030 */     GIR_RootConstrainSelectedInstOperands,
     /* 411031 */     // GIR_Coverage, 8957,
     /* 411031 */     GIR_Done,
     /* 411032 */   // Label 8416: @411032
     /* 411032 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(411047), // Rule ID 8960 //
     /* 411037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411040 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 411045 */     GIR_RootConstrainSelectedInstOperands,
     /* 411046 */     // GIR_Coverage, 8960,
     /* 411046 */     GIR_Done,
     /* 411047 */   // Label 8417: @411047
     /* 411047 */   GIM_Reject,
     /* 411048 */ // Label 8415: @411048
     /* 411048 */ GIM_Reject,
     /* 411049 */ // Label 8383: @411049
     /* 411049 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(411074), // Rule ID 2414 //
     /* 411054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411067 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 411072 */   GIR_RootConstrainSelectedInstOperands,
     /* 411073 */   // GIR_Coverage, 2414,
     /* 411073 */   GIR_Done,
     /* 411074 */ // Label 8418: @411074
     /* 411074 */ GIM_Reject,
     /* 411075 */ // Label 8384: @411075
     /* 411075 */ GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(411100), // Rule ID 8956 //
     /* 411080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 411086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411093 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 411093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 411098 */   GIR_RootConstrainSelectedInstOperands,
     /* 411099 */   // GIR_Coverage, 8956,
     /* 411099 */   GIR_Done,
     /* 411100 */ // Label 8419: @411100
     /* 411100 */ GIM_Reject,
     /* 411101 */ // Label 8385: @411101
     /* 411101 */ GIM_Reject,
     /* 411102 */ // Label 142: @411102
     /* 411102 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8438*/ GIMT_Encode4(411881),
     /* 411113 */ /*GILLT_v2s32*//*Label 8420*/ GIMT_Encode4(411189),
     /* 411117 */ /*GILLT_v2s64*//*Label 8421*/ GIMT_Encode4(411244),
     /* 411121 */ /*GILLT_v4s16*//*Label 8422*/ GIMT_Encode4(411299),
     /* 411125 */ /*GILLT_v4s32*//*Label 8423*/ GIMT_Encode4(411354),
     /* 411129 */ /*GILLT_v8s8*//*Label 8424*/ GIMT_Encode4(411409),
     /* 411133 */ /*GILLT_v8s16*//*Label 8425*/ GIMT_Encode4(411443),
     /* 411137 */ /*GILLT_v16s8*//*Label 8426*/ GIMT_Encode4(411498), GIMT_Encode4(0),
     /* 411145 */ /*GILLT_nxv2s1*//*Label 8427*/ GIMT_Encode4(411532),
     /* 411149 */ /*GILLT_nxv2s16*//*Label 8428*/ GIMT_Encode4(411558),
     /* 411153 */ /*GILLT_nxv2s32*//*Label 8429*/ GIMT_Encode4(411584),
     /* 411157 */ /*GILLT_nxv2s64*//*Label 8430*/ GIMT_Encode4(411610),
     /* 411161 */ /*GILLT_nxv4s1*//*Label 8431*/ GIMT_Encode4(411657),
     /* 411165 */ /*GILLT_nxv4s16*//*Label 8432*/ GIMT_Encode4(411683),
     /* 411169 */ /*GILLT_nxv4s32*//*Label 8433*/ GIMT_Encode4(411709),
     /* 411173 */ /*GILLT_nxv8s1*//*Label 8434*/ GIMT_Encode4(411756),
     /* 411177 */ /*GILLT_nxv8s16*//*Label 8435*/ GIMT_Encode4(411782),
     /* 411181 */ /*GILLT_nxv16s1*//*Label 8436*/ GIMT_Encode4(411829),
     /* 411185 */ /*GILLT_nxv16s8*//*Label 8437*/ GIMT_Encode4(411855),
     /* 411189 */ // Label 8420: @411189
     /* 411189 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(411243),
     /* 411194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 411200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411212 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(411227), // Rule ID 1881 //
     /* 411217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411220 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 411220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 411225 */     GIR_RootConstrainSelectedInstOperands,
     /* 411226 */     // GIR_Coverage, 1881,
     /* 411226 */     GIR_Done,
     /* 411227 */   // Label 8440: @411227
     /* 411227 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(411242), // Rule ID 5469 //
     /* 411232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411235 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 411240 */     GIR_RootConstrainSelectedInstOperands,
     /* 411241 */     // GIR_Coverage, 5469,
     /* 411241 */     GIR_Done,
     /* 411242 */   // Label 8441: @411242
     /* 411242 */   GIM_Reject,
     /* 411243 */ // Label 8439: @411243
     /* 411243 */ GIM_Reject,
     /* 411244 */ // Label 8421: @411244
     /* 411244 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(411298),
     /* 411249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 411255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411267 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(411282), // Rule ID 1883 //
     /* 411272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411275 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 411275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 411280 */     GIR_RootConstrainSelectedInstOperands,
     /* 411281 */     // GIR_Coverage, 1883,
     /* 411281 */     GIR_Done,
     /* 411282 */   // Label 8443: @411282
     /* 411282 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(411297), // Rule ID 5471 //
     /* 411287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411290 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 411295 */     GIR_RootConstrainSelectedInstOperands,
     /* 411296 */     // GIR_Coverage, 5471,
     /* 411296 */     GIR_Done,
     /* 411297 */   // Label 8444: @411297
     /* 411297 */   GIM_Reject,
     /* 411298 */ // Label 8442: @411298
     /* 411298 */ GIM_Reject,
     /* 411299 */ // Label 8422: @411299
     /* 411299 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(411353),
     /* 411304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 411310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411322 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(411337), // Rule ID 1879 //
     /* 411327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411330 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 411330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 411335 */     GIR_RootConstrainSelectedInstOperands,
     /* 411336 */     // GIR_Coverage, 1879,
     /* 411336 */     GIR_Done,
     /* 411337 */   // Label 8446: @411337
     /* 411337 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(411352), // Rule ID 5467 //
     /* 411342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411345 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 411345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 411350 */     GIR_RootConstrainSelectedInstOperands,
     /* 411351 */     // GIR_Coverage, 5467,
     /* 411351 */     GIR_Done,
     /* 411352 */   // Label 8447: @411352
     /* 411352 */   GIM_Reject,
     /* 411353 */ // Label 8445: @411353
     /* 411353 */ GIM_Reject,
     /* 411354 */ // Label 8423: @411354
     /* 411354 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(411408),
     /* 411359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 411365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411377 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(411392), // Rule ID 1882 //
     /* 411382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411385 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 411385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 411390 */     GIR_RootConstrainSelectedInstOperands,
     /* 411391 */     // GIR_Coverage, 1882,
     /* 411391 */     GIR_Done,
     /* 411392 */   // Label 8449: @411392
     /* 411392 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(411407), // Rule ID 5470 //
     /* 411397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411400 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 411400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 411405 */     GIR_RootConstrainSelectedInstOperands,
     /* 411406 */     // GIR_Coverage, 5470,
     /* 411406 */     GIR_Done,
     /* 411407 */   // Label 8450: @411407
     /* 411407 */   GIM_Reject,
     /* 411408 */ // Label 8448: @411408
     /* 411408 */ GIM_Reject,
     /* 411409 */ // Label 8424: @411409
     /* 411409 */ GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(411442), // Rule ID 1877 //
     /* 411414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 411423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411435 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 411435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 411440 */   GIR_RootConstrainSelectedInstOperands,
     /* 411441 */   // GIR_Coverage, 1877,
     /* 411441 */   GIR_Done,
     /* 411442 */ // Label 8451: @411442
     /* 411442 */ GIM_Reject,
     /* 411443 */ // Label 8425: @411443
     /* 411443 */ GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(411497),
     /* 411448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 411454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411466 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(411481), // Rule ID 1880 //
     /* 411471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411474 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 411474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 411479 */     GIR_RootConstrainSelectedInstOperands,
     /* 411480 */     // GIR_Coverage, 1880,
     /* 411480 */     GIR_Done,
     /* 411481 */   // Label 8453: @411481
     /* 411481 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(411496), // Rule ID 5468 //
     /* 411486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411489 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 411489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 411494 */     GIR_RootConstrainSelectedInstOperands,
     /* 411495 */     // GIR_Coverage, 5468,
     /* 411495 */     GIR_Done,
     /* 411496 */   // Label 8454: @411496
     /* 411496 */   GIM_Reject,
     /* 411497 */ // Label 8452: @411497
     /* 411497 */ GIM_Reject,
     /* 411498 */ // Label 8426: @411498
     /* 411498 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(411531), // Rule ID 1878 //
     /* 411503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 411509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 411512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411524 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 411524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 411529 */   GIR_RootConstrainSelectedInstOperands,
     /* 411530 */   // GIR_Coverage, 1878,
     /* 411530 */   GIR_Done,
     /* 411531 */ // Label 8455: @411531
     /* 411531 */ GIM_Reject,
     /* 411532 */ // Label 8427: @411532
     /* 411532 */ GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(411557), // Rule ID 8990 //
     /* 411537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 411543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 411546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411550 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 411550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 411555 */   GIR_RootConstrainSelectedInstOperands,
     /* 411556 */   // GIR_Coverage, 8990,
     /* 411556 */   GIR_Done,
     /* 411557 */ // Label 8456: @411557
     /* 411557 */ GIM_Reject,
     /* 411558 */ // Label 8428: @411558
     /* 411558 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(411583), // Rule ID 8973 //
     /* 411563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 411569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 411572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411576 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 411576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 411581 */   GIR_RootConstrainSelectedInstOperands,
     /* 411582 */   // GIR_Coverage, 8973,
     /* 411582 */   GIR_Done,
     /* 411583 */ // Label 8457: @411583
     /* 411583 */ GIM_Reject,
     /* 411584 */ // Label 8429: @411584
     /* 411584 */ GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(411609), // Rule ID 8974 //
     /* 411589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 411595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 411598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411602 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 411602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 411607 */   GIR_RootConstrainSelectedInstOperands,
     /* 411608 */   // GIR_Coverage, 8974,
     /* 411608 */   GIR_Done,
     /* 411609 */ // Label 8458: @411609
     /* 411609 */ GIM_Reject,
     /* 411610 */ // Label 8430: @411610
     /* 411610 */ GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(411656),
     /* 411615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 411618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 411621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411625 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(411640), // Rule ID 8969 //
     /* 411630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411633 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 411633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 411638 */     GIR_RootConstrainSelectedInstOperands,
     /* 411639 */     // GIR_Coverage, 8969,
     /* 411639 */     GIR_Done,
     /* 411640 */   // Label 8460: @411640
     /* 411640 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(411655), // Rule ID 8975 //
     /* 411645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411648 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 411648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 411653 */     GIR_RootConstrainSelectedInstOperands,
     /* 411654 */     // GIR_Coverage, 8975,
     /* 411654 */     GIR_Done,
     /* 411655 */   // Label 8461: @411655
     /* 411655 */   GIM_Reject,
     /* 411656 */ // Label 8459: @411656
     /* 411656 */ GIM_Reject,
     /* 411657 */ // Label 8431: @411657
     /* 411657 */ GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(411682), // Rule ID 8989 //
     /* 411662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 411668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 411671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411675 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 411675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 411680 */   GIR_RootConstrainSelectedInstOperands,
     /* 411681 */   // GIR_Coverage, 8989,
     /* 411681 */   GIR_Done,
     /* 411682 */ // Label 8462: @411682
     /* 411682 */ GIM_Reject,
     /* 411683 */ // Label 8432: @411683
     /* 411683 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(411708), // Rule ID 8971 //
     /* 411688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 411694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 411697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411701 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 411701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 411706 */   GIR_RootConstrainSelectedInstOperands,
     /* 411707 */   // GIR_Coverage, 8971,
     /* 411707 */   GIR_Done,
     /* 411708 */ // Label 8463: @411708
     /* 411708 */ GIM_Reject,
     /* 411709 */ // Label 8433: @411709
     /* 411709 */ GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(411755),
     /* 411714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 411717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 411720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411724 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(411739), // Rule ID 8968 //
     /* 411729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411732 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 411732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 411737 */     GIR_RootConstrainSelectedInstOperands,
     /* 411738 */     // GIR_Coverage, 8968,
     /* 411738 */     GIR_Done,
     /* 411739 */   // Label 8465: @411739
     /* 411739 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(411754), // Rule ID 8972 //
     /* 411744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411747 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 411747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 411752 */     GIR_RootConstrainSelectedInstOperands,
     /* 411753 */     // GIR_Coverage, 8972,
     /* 411753 */     GIR_Done,
     /* 411754 */   // Label 8466: @411754
     /* 411754 */   GIM_Reject,
     /* 411755 */ // Label 8464: @411755
     /* 411755 */ GIM_Reject,
     /* 411756 */ // Label 8434: @411756
     /* 411756 */ GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(411781), // Rule ID 8988 //
     /* 411761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 411767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 411770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411774 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 411774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 411779 */   GIR_RootConstrainSelectedInstOperands,
     /* 411780 */   // GIR_Coverage, 8988,
     /* 411780 */   GIR_Done,
     /* 411781 */ // Label 8467: @411781
     /* 411781 */ GIM_Reject,
     /* 411782 */ // Label 8435: @411782
     /* 411782 */ GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(411828),
     /* 411787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411797 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(411812), // Rule ID 8967 //
     /* 411802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411805 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 411810 */     GIR_RootConstrainSelectedInstOperands,
     /* 411811 */     // GIR_Coverage, 8967,
     /* 411811 */     GIR_Done,
     /* 411812 */   // Label 8469: @411812
     /* 411812 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(411827), // Rule ID 8970 //
     /* 411817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411820 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 411825 */     GIR_RootConstrainSelectedInstOperands,
     /* 411826 */     // GIR_Coverage, 8970,
     /* 411826 */     GIR_Done,
     /* 411827 */   // Label 8470: @411827
     /* 411827 */   GIM_Reject,
     /* 411828 */ // Label 8468: @411828
     /* 411828 */ GIM_Reject,
     /* 411829 */ // Label 8436: @411829
     /* 411829 */ GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(411854), // Rule ID 2418 //
     /* 411834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411847 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 411852 */   GIR_RootConstrainSelectedInstOperands,
     /* 411853 */   // GIR_Coverage, 2418,
     /* 411853 */   GIR_Done,
     /* 411854 */ // Label 8471: @411854
     /* 411854 */ GIM_Reject,
     /* 411855 */ // Label 8437: @411855
     /* 411855 */ GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(411880), // Rule ID 8966 //
     /* 411860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 411866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411873 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 411873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 411878 */   GIR_RootConstrainSelectedInstOperands,
     /* 411879 */   // GIR_Coverage, 8966,
     /* 411879 */   GIR_Done,
     /* 411880 */ // Label 8472: @411880
     /* 411880 */ GIM_Reject,
     /* 411881 */ // Label 8438: @411881
     /* 411881 */ GIM_Reject,
     /* 411882 */ // Label 143: @411882
     /* 411882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8479*/ GIMT_Encode4(412087),
     /* 411893 */ /*GILLT_s64*//*Label 8473*/ GIMT_Encode4(411925), GIMT_Encode4(0),
     /* 411901 */ /*GILLT_v2s32*//*Label 8474*/ GIMT_Encode4(411952),
     /* 411905 */ /*GILLT_v2s64*//*Label 8475*/ GIMT_Encode4(411979),
     /* 411909 */ /*GILLT_v4s16*//*Label 8476*/ GIMT_Encode4(412006),
     /* 411913 */ /*GILLT_v4s32*//*Label 8477*/ GIMT_Encode4(412033), GIMT_Encode4(0),
     /* 411921 */ /*GILLT_v8s16*//*Label 8478*/ GIMT_Encode4(412060),
     /* 411925 */ // Label 8473: @411925
     /* 411925 */ GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(411951), // Rule ID 1069 //
     /* 411930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411944 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 411944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 411949 */   GIR_RootConstrainSelectedInstOperands,
     /* 411950 */   // GIR_Coverage, 1069,
     /* 411950 */   GIR_Done,
     /* 411951 */ // Label 8480: @411951
     /* 411951 */ GIM_Reject,
     /* 411952 */ // Label 8474: @411952
     /* 411952 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(411978), // Rule ID 1065 //
     /* 411957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411971 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 411971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 411976 */   GIR_RootConstrainSelectedInstOperands,
     /* 411977 */   // GIR_Coverage, 1065,
     /* 411977 */   GIR_Done,
     /* 411978 */ // Label 8481: @411978
     /* 411978 */ GIM_Reject,
     /* 411979 */ // Label 8475: @411979
     /* 411979 */ GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(412005), // Rule ID 1071 //
     /* 411984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411998 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 411998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 412003 */   GIR_RootConstrainSelectedInstOperands,
     /* 412004 */   // GIR_Coverage, 1071,
     /* 412004 */   GIR_Done,
     /* 412005 */ // Label 8482: @412005
     /* 412005 */ GIM_Reject,
     /* 412006 */ // Label 8476: @412006
     /* 412006 */ GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(412032), // Rule ID 1061 //
     /* 412011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412025 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 412025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 412030 */   GIR_RootConstrainSelectedInstOperands,
     /* 412031 */   // GIR_Coverage, 1061,
     /* 412031 */   GIR_Done,
     /* 412032 */ // Label 8483: @412032
     /* 412032 */ GIM_Reject,
     /* 412033 */ // Label 8477: @412033
     /* 412033 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(412059), // Rule ID 1067 //
     /* 412038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412052 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 412052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 412057 */   GIR_RootConstrainSelectedInstOperands,
     /* 412058 */   // GIR_Coverage, 1067,
     /* 412058 */   GIR_Done,
     /* 412059 */ // Label 8484: @412059
     /* 412059 */ GIM_Reject,
     /* 412060 */ // Label 8478: @412060
     /* 412060 */ GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(412086), // Rule ID 1063 //
     /* 412065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412079 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 412079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 412084 */   GIR_RootConstrainSelectedInstOperands,
     /* 412085 */   // GIR_Coverage, 1063,
     /* 412085 */   GIR_Done,
     /* 412086 */ // Label 8485: @412086
     /* 412086 */ GIM_Reject,
     /* 412087 */ // Label 8479: @412087
     /* 412087 */ GIM_Reject,
     /* 412088 */ // Label 144: @412088
     /* 412088 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8488*/ GIMT_Encode4(412954),
     /* 412099 */ /*GILLT_v2s64*//*Label 8486*/ GIMT_Encode4(412111), GIMT_Encode4(0),
     /* 412107 */ /*GILLT_v4s32*//*Label 8487*/ GIMT_Encode4(412405),
     /* 412111 */ // Label 8486: @412111
     /* 412111 */ GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(412193), // Rule ID 5868 //
     /* 412116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412123 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 412131 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 412134 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 412139 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 412143 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412148 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412150 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 412150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 412153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 412157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412162 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 412166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 412182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412192 */   // GIR_Coverage, 5868,
     /* 412192 */   GIR_EraseRootFromParent_Done,
     /* 412193 */ // Label 8489: @412193
     /* 412193 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(412267), // Rule ID 5867 //
     /* 412198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412205 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412209 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 412213 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412217 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412222 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412224 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 412224 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 412227 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 412231 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412236 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 412240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 412256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412261 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412266 */   // GIR_Coverage, 5867,
     /* 412266 */   GIR_EraseRootFromParent_Done,
     /* 412267 */ // Label 8490: @412267
     /* 412267 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(412326), // Rule ID 5877 //
     /* 412272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412283 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 412283 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 412286 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 412290 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412295 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 412315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412325 */   // GIR_Coverage, 5877,
     /* 412325 */   GIR_EraseRootFromParent_Done,
     /* 412326 */ // Label 8491: @412326
     /* 412326 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(412404), // Rule ID 6005 //
     /* 412331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412342 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 412342 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 412345 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 412349 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412354 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 412360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 412363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 412367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 412377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 412385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 412388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412403 */   // GIR_Coverage, 6005,
     /* 412403 */   GIR_EraseRootFromParent_Done,
     /* 412404 */ // Label 8492: @412404
     /* 412404 */ GIM_Reject,
     /* 412405 */ // Label 8487: @412405
     /* 412405 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(412487), // Rule ID 5870 //
     /* 412410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412417 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 412425 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 412428 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 412433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 412437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412444 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 412444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 412451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412456 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 412460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412486 */   // GIR_Coverage, 5870,
     /* 412486 */   GIR_EraseRootFromParent_Done,
     /* 412487 */ // Label 8493: @412487
     /* 412487 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(412569), // Rule ID 5872 //
     /* 412492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 412507 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 412510 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 412515 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 412519 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412526 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 412526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 412533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412538 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 412542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412568 */   // GIR_Coverage, 5872,
     /* 412568 */   GIR_EraseRootFromParent_Done,
     /* 412569 */ // Label 8494: @412569
     /* 412569 */ GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(412643), // Rule ID 5869 //
     /* 412574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 412589 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412593 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412598 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412600 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 412600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 412607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412612 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 412616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412642 */   // GIR_Coverage, 5869,
     /* 412642 */   GIR_EraseRootFromParent_Done,
     /* 412643 */ // Label 8495: @412643
     /* 412643 */ GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(412717), // Rule ID 5871 //
     /* 412648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 412663 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412667 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412674 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 412674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 412681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412686 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 412690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412716 */   // GIR_Coverage, 5871,
     /* 412716 */   GIR_EraseRootFromParent_Done,
     /* 412717 */ // Label 8496: @412717
     /* 412717 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(412776), // Rule ID 5873 //
     /* 412722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412733 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 412733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 412740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412745 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412775 */   // GIR_Coverage, 5873,
     /* 412775 */   GIR_EraseRootFromParent_Done,
     /* 412776 */ // Label 8497: @412776
     /* 412776 */ GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(412835), // Rule ID 5874 //
     /* 412781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412792 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 412792 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 412795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 412799 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412804 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 412824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412834 */   // GIR_Coverage, 5874,
     /* 412834 */   GIR_EraseRootFromParent_Done,
     /* 412835 */ // Label 8498: @412835
     /* 412835 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(412894), // Rule ID 5875 //
     /* 412840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412851 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 412851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 412854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 412858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412863 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 412883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 412893 */   // GIR_Coverage, 5875,
     /* 412893 */   GIR_EraseRootFromParent_Done,
     /* 412894 */ // Label 8499: @412894
     /* 412894 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(412953), // Rule ID 5876 //
     /* 412899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412910 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 412910 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 412913 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 412917 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412922 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 412926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 412928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 412942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412952 */   // GIR_Coverage, 5876,
     /* 412952 */   GIR_EraseRootFromParent_Done,
     /* 412953 */ // Label 8500: @412953
     /* 412953 */ GIM_Reject,
     /* 412954 */ // Label 8488: @412954
     /* 412954 */ GIM_Reject,
     /* 412955 */ // Label 145: @412955
     /* 412955 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8505*/ GIMT_Encode4(413324),
     /* 412966 */ /*GILLT_v2s32*//*Label 8501*/ GIMT_Encode4(413026), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 412978 */ /*GILLT_v4s32*//*Label 8502*/ GIMT_Encode4(413146), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 413010 */ /*GILLT_nxv2s64*//*Label 8503*/ GIMT_Encode4(413266), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 413022 */ /*GILLT_nxv4s32*//*Label 8504*/ GIMT_Encode4(413295),
     /* 413026 */ // Label 8501: @413026
     /* 413026 */ GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(413145),
     /* 413031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 413037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 413040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413052 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(413125), // Rule ID 28 //
     /* 413057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 413060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 413064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 413068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413105 */     // MIs[3] Operand 1
     /* 413105 */     // No operand predicates
     /* 413105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413107 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 413110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 413114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413123 */     GIR_RootConstrainSelectedInstOperands,
     /* 413124 */     // GIR_Coverage, 28,
     /* 413124 */     GIR_EraseRootFromParent_Done,
     /* 413125 */   // Label 8507: @413125
     /* 413125 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(413144), // Rule ID 24 //
     /* 413130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 413133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413137 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 413137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 413142 */     GIR_RootConstrainSelectedInstOperands,
     /* 413143 */     // GIR_Coverage, 24,
     /* 413143 */     GIR_Done,
     /* 413144 */   // Label 8508: @413144
     /* 413144 */   GIM_Reject,
     /* 413145 */ // Label 8506: @413145
     /* 413145 */ GIM_Reject,
     /* 413146 */ // Label 8502: @413146
     /* 413146 */ GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(413265),
     /* 413151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 413157 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 413160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413172 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(413245), // Rule ID 29 //
     /* 413177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 413180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 413184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 413188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413221 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413225 */     // MIs[3] Operand 1
     /* 413225 */     // No operand predicates
     /* 413225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413227 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 413230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 413234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413243 */     GIR_RootConstrainSelectedInstOperands,
     /* 413244 */     // GIR_Coverage, 29,
     /* 413244 */     GIR_EraseRootFromParent_Done,
     /* 413245 */   // Label 8510: @413245
     /* 413245 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(413264), // Rule ID 25 //
     /* 413250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 413253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413257 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 413262 */     GIR_RootConstrainSelectedInstOperands,
     /* 413263 */     // GIR_Coverage, 25,
     /* 413263 */     GIR_Done,
     /* 413264 */   // Label 8511: @413264
     /* 413264 */   GIM_Reject,
     /* 413265 */ // Label 8509: @413265
     /* 413265 */ GIM_Reject,
     /* 413266 */ // Label 8503: @413266
     /* 413266 */ GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(413294), // Rule ID 7673 //
     /* 413271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 413277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 413280 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 413283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413287 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 413287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 413292 */   GIR_RootConstrainSelectedInstOperands,
     /* 413293 */   // GIR_Coverage, 7673,
     /* 413293 */   GIR_Done,
     /* 413294 */ // Label 8512: @413294
     /* 413294 */ GIM_Reject,
     /* 413295 */ // Label 8504: @413295
     /* 413295 */ GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(413323), // Rule ID 7672 //
     /* 413300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 413306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 413309 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 413312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413316 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 413316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 413321 */   GIR_RootConstrainSelectedInstOperands,
     /* 413322 */   // GIR_Coverage, 7672,
     /* 413322 */   GIR_Done,
     /* 413323 */ // Label 8513: @413323
     /* 413323 */ GIM_Reject,
     /* 413324 */ // Label 8505: @413324
     /* 413324 */ GIM_Reject,
     /* 413325 */ // Label 146: @413325
     /* 413325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8517*/ GIMT_Encode4(413441),
     /* 413336 */ /*GILLT_s16*//*Label 8514*/ GIMT_Encode4(413348),
     /* 413340 */ /*GILLT_s32*//*Label 8515*/ GIMT_Encode4(413379),
     /* 413344 */ /*GILLT_s64*//*Label 8516*/ GIMT_Encode4(413410),
     /* 413348 */ // Label 8514: @413348
     /* 413348 */ GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(413378), // Rule ID 1669 //
     /* 413353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 413356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 413359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 413363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 413367 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 413367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 413372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 413376 */   GIR_RootConstrainSelectedInstOperands,
     /* 413377 */   // GIR_Coverage, 1669,
     /* 413377 */   GIR_Done,
     /* 413378 */ // Label 8518: @413378
     /* 413378 */ GIM_Reject,
     /* 413379 */ // Label 8515: @413379
     /* 413379 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(413409), // Rule ID 1668 //
     /* 413384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 413387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 413390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413398 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 413398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 413403 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 413407 */   GIR_RootConstrainSelectedInstOperands,
     /* 413408 */   // GIR_Coverage, 1668,
     /* 413408 */   GIR_Done,
     /* 413409 */ // Label 8519: @413409
     /* 413409 */ GIM_Reject,
     /* 413410 */ // Label 8516: @413410
     /* 413410 */ GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(413440), // Rule ID 1667 //
     /* 413415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 413418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 413421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413429 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 413429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 413434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 413438 */   GIR_RootConstrainSelectedInstOperands,
     /* 413439 */   // GIR_Coverage, 1667,
     /* 413439 */   GIR_Done,
     /* 413440 */ // Label 8520: @413440
     /* 413440 */ GIM_Reject,
     /* 413441 */ // Label 8517: @413441
     /* 413441 */ GIM_Reject,
     /* 413442 */ // Label 147: @413442
     /* 413442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8524*/ GIMT_Encode4(414674),
     /* 413453 */ /*GILLT_v2s64*//*Label 8521*/ GIMT_Encode4(413473), GIMT_Encode4(0),
     /* 413461 */ /*GILLT_v4s32*//*Label 8522*/ GIMT_Encode4(414034), GIMT_Encode4(0),
     /* 413469 */ /*GILLT_v8s16*//*Label 8523*/ GIMT_Encode4(414595),
     /* 413473 */ // Label 8521: @413473
     /* 413473 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(414033),
     /* 413478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 413484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413488 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(413580), // Rule ID 2106 //
     /* 413493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 413504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413537 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413541 */     // MIs[3] Operand 1
     /* 413541 */     // No operand predicates
     /* 413541 */     // MIs[1] Operand 2
     /* 413541 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 413552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 413561 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 413564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 413571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413578 */     GIR_RootConstrainSelectedInstOperands,
     /* 413579 */     // GIR_Coverage, 2106,
     /* 413579 */     GIR_EraseRootFromParent_Done,
     /* 413580 */   // Label 8526: @413580
     /* 413580 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(413672), // Rule ID 13554 //
     /* 413585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 413596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413629 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413633 */     // MIs[3] Operand 1
     /* 413633 */     // No operand predicates
     /* 413633 */     // MIs[1] Operand 2
     /* 413633 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 413644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 413653 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 413656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 413663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413670 */     GIR_RootConstrainSelectedInstOperands,
     /* 413671 */     // GIR_Coverage, 13554,
     /* 413671 */     GIR_EraseRootFromParent_Done,
     /* 413672 */   // Label 8527: @413672
     /* 413672 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(413758), // Rule ID 13552 //
     /* 413677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 413688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413721 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413725 */     // MIs[3] Operand 1
     /* 413725 */     // No operand predicates
     /* 413725 */     // MIs[1] Operand 2
     /* 413725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 413736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413742 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 413745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413756 */     GIR_RootConstrainSelectedInstOperands,
     /* 413757 */     // GIR_Coverage, 13552,
     /* 413757 */     GIR_EraseRootFromParent_Done,
     /* 413758 */   // Label 8528: @413758
     /* 413758 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(413844), // Rule ID 2104 //
     /* 413763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 413778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413811 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413815 */     // MIs[3] Operand 1
     /* 413815 */     // No operand predicates
     /* 413815 */     // MIs[1] Operand 2
     /* 413815 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 413826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413828 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 413831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413842 */     GIR_RootConstrainSelectedInstOperands,
     /* 413843 */     // GIR_Coverage, 2104,
     /* 413843 */     GIR_EraseRootFromParent_Done,
     /* 413844 */   // Label 8529: @413844
     /* 413844 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(413883), // Rule ID 1831 //
     /* 413849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 413859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 413866 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 413866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 413869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 413876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 413881 */     GIR_RootConstrainSelectedInstOperands,
     /* 413882 */     // GIR_Coverage, 1831,
     /* 413882 */     GIR_EraseRootFromParent_Done,
     /* 413883 */   // Label 8530: @413883
     /* 413883 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(413946), // Rule ID 13553 //
     /* 413888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413924 */     // MIs[2] Operand 1
     /* 413924 */     // No operand predicates
     /* 413924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413930 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 413933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413944 */     GIR_RootConstrainSelectedInstOperands,
     /* 413945 */     // GIR_Coverage, 13553,
     /* 413945 */     GIR_EraseRootFromParent_Done,
     /* 413946 */   // Label 8531: @413946
     /* 413946 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(414009), // Rule ID 2105 //
     /* 413951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413987 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413991 */     // MIs[2] Operand 1
     /* 413991 */     // No operand predicates
     /* 413991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413993 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 413996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414007 */     GIR_RootConstrainSelectedInstOperands,
     /* 414008 */     // GIR_Coverage, 2105,
     /* 414008 */     GIR_EraseRootFromParent_Done,
     /* 414009 */   // Label 8532: @414009
     /* 414009 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(414032), // Rule ID 1830 //
     /* 414014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414025 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 414025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 414030 */     GIR_RootConstrainSelectedInstOperands,
     /* 414031 */     // GIR_Coverage, 1830,
     /* 414031 */     GIR_Done,
     /* 414032 */   // Label 8533: @414032
     /* 414032 */   GIM_Reject,
     /* 414033 */ // Label 8525: @414033
     /* 414033 */ GIM_Reject,
     /* 414034 */ // Label 8522: @414034
     /* 414034 */ GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(414594),
     /* 414039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414049 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(414141), // Rule ID 2103 //
     /* 414054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 414065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414098 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414102 */     // MIs[3] Operand 1
     /* 414102 */     // No operand predicates
     /* 414102 */     // MIs[1] Operand 2
     /* 414102 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 414113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 414122 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 414125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 414132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414139 */     GIR_RootConstrainSelectedInstOperands,
     /* 414140 */     // GIR_Coverage, 2103,
     /* 414140 */     GIR_EraseRootFromParent_Done,
     /* 414141 */   // Label 8535: @414141
     /* 414141 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(414233), // Rule ID 13551 //
     /* 414146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 414157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414190 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414194 */     // MIs[3] Operand 1
     /* 414194 */     // No operand predicates
     /* 414194 */     // MIs[1] Operand 2
     /* 414194 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 414205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 414214 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 414217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 414224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414231 */     GIR_RootConstrainSelectedInstOperands,
     /* 414232 */     // GIR_Coverage, 13551,
     /* 414232 */     GIR_EraseRootFromParent_Done,
     /* 414233 */   // Label 8536: @414233
     /* 414233 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(414319), // Rule ID 13549 //
     /* 414238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 414249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414286 */     // MIs[3] Operand 1
     /* 414286 */     // No operand predicates
     /* 414286 */     // MIs[1] Operand 2
     /* 414286 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 414297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414303 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 414306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414317 */     GIR_RootConstrainSelectedInstOperands,
     /* 414318 */     // GIR_Coverage, 13549,
     /* 414318 */     GIR_EraseRootFromParent_Done,
     /* 414319 */   // Label 8537: @414319
     /* 414319 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(414405), // Rule ID 2101 //
     /* 414324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 414339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414372 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414376 */     // MIs[3] Operand 1
     /* 414376 */     // No operand predicates
     /* 414376 */     // MIs[1] Operand 2
     /* 414376 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 414387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414389 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 414392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414403 */     GIR_RootConstrainSelectedInstOperands,
     /* 414404 */     // GIR_Coverage, 2101,
     /* 414404 */     GIR_EraseRootFromParent_Done,
     /* 414405 */   // Label 8538: @414405
     /* 414405 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(414444), // Rule ID 1829 //
     /* 414410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 414420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 414427 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 414427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 414430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 414437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 414442 */     GIR_RootConstrainSelectedInstOperands,
     /* 414443 */     // GIR_Coverage, 1829,
     /* 414443 */     GIR_EraseRootFromParent_Done,
     /* 414444 */   // Label 8539: @414444
     /* 414444 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(414507), // Rule ID 13550 //
     /* 414449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414481 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414485 */     // MIs[2] Operand 1
     /* 414485 */     // No operand predicates
     /* 414485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414491 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 414494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414505 */     GIR_RootConstrainSelectedInstOperands,
     /* 414506 */     // GIR_Coverage, 13550,
     /* 414506 */     GIR_EraseRootFromParent_Done,
     /* 414507 */   // Label 8540: @414507
     /* 414507 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(414570), // Rule ID 2102 //
     /* 414512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414548 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414552 */     // MIs[2] Operand 1
     /* 414552 */     // No operand predicates
     /* 414552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414554 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 414554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 414557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414568 */     GIR_RootConstrainSelectedInstOperands,
     /* 414569 */     // GIR_Coverage, 2102,
     /* 414569 */     GIR_EraseRootFromParent_Done,
     /* 414570 */   // Label 8541: @414570
     /* 414570 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(414593), // Rule ID 1828 //
     /* 414575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414586 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 414586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 414591 */     GIR_RootConstrainSelectedInstOperands,
     /* 414592 */     // GIR_Coverage, 1828,
     /* 414592 */     GIR_Done,
     /* 414593 */   // Label 8542: @414593
     /* 414593 */   GIM_Reject,
     /* 414594 */ // Label 8534: @414594
     /* 414594 */ GIM_Reject,
     /* 414595 */ // Label 8523: @414595
     /* 414595 */ GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(414673),
     /* 414600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 414603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 414606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414610 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(414649), // Rule ID 1827 //
     /* 414615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 414625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 414632 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 414632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 414635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 414642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 414647 */     GIR_RootConstrainSelectedInstOperands,
     /* 414648 */     // GIR_Coverage, 1827,
     /* 414648 */     GIR_EraseRootFromParent_Done,
     /* 414649 */   // Label 8544: @414649
     /* 414649 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(414672), // Rule ID 1826 //
     /* 414654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414665 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 414665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 414670 */     GIR_RootConstrainSelectedInstOperands,
     /* 414671 */     // GIR_Coverage, 1826,
     /* 414671 */     GIR_Done,
     /* 414672 */   // Label 8545: @414672
     /* 414672 */   GIM_Reject,
     /* 414673 */ // Label 8543: @414673
     /* 414673 */ GIM_Reject,
     /* 414674 */ // Label 8524: @414674
     /* 414674 */ GIM_Reject,
     /* 414675 */ // Label 148: @414675
     /* 414675 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8564*/ GIMT_Encode4(415454),
     /* 414686 */ /*GILLT_v2s32*//*Label 8546*/ GIMT_Encode4(414762),
     /* 414690 */ /*GILLT_v2s64*//*Label 8547*/ GIMT_Encode4(414817),
     /* 414694 */ /*GILLT_v4s16*//*Label 8548*/ GIMT_Encode4(414872),
     /* 414698 */ /*GILLT_v4s32*//*Label 8549*/ GIMT_Encode4(414927),
     /* 414702 */ /*GILLT_v8s8*//*Label 8550*/ GIMT_Encode4(414982),
     /* 414706 */ /*GILLT_v8s16*//*Label 8551*/ GIMT_Encode4(415016),
     /* 414710 */ /*GILLT_v16s8*//*Label 8552*/ GIMT_Encode4(415071), GIMT_Encode4(0),
     /* 414718 */ /*GILLT_nxv2s1*//*Label 8553*/ GIMT_Encode4(415105),
     /* 414722 */ /*GILLT_nxv2s16*//*Label 8554*/ GIMT_Encode4(415131),
     /* 414726 */ /*GILLT_nxv2s32*//*Label 8555*/ GIMT_Encode4(415157),
     /* 414730 */ /*GILLT_nxv2s64*//*Label 8556*/ GIMT_Encode4(415183),
     /* 414734 */ /*GILLT_nxv4s1*//*Label 8557*/ GIMT_Encode4(415230),
     /* 414738 */ /*GILLT_nxv4s16*//*Label 8558*/ GIMT_Encode4(415256),
     /* 414742 */ /*GILLT_nxv4s32*//*Label 8559*/ GIMT_Encode4(415282),
     /* 414746 */ /*GILLT_nxv8s1*//*Label 8560*/ GIMT_Encode4(415329),
     /* 414750 */ /*GILLT_nxv8s16*//*Label 8561*/ GIMT_Encode4(415355),
     /* 414754 */ /*GILLT_nxv16s1*//*Label 8562*/ GIMT_Encode4(415402),
     /* 414758 */ /*GILLT_nxv16s8*//*Label 8563*/ GIMT_Encode4(415428),
     /* 414762 */ // Label 8546: @414762
     /* 414762 */ GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(414816),
     /* 414767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 414770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 414773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414785 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(414800), // Rule ID 1888 //
     /* 414790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414793 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 414793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 414798 */     GIR_RootConstrainSelectedInstOperands,
     /* 414799 */     // GIR_Coverage, 1888,
     /* 414799 */     GIR_Done,
     /* 414800 */   // Label 8566: @414800
     /* 414800 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(414815), // Rule ID 5474 //
     /* 414805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414808 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 414808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 414813 */     GIR_RootConstrainSelectedInstOperands,
     /* 414814 */     // GIR_Coverage, 5474,
     /* 414814 */     GIR_Done,
     /* 414815 */   // Label 8567: @414815
     /* 414815 */   GIM_Reject,
     /* 414816 */ // Label 8565: @414816
     /* 414816 */ GIM_Reject,
     /* 414817 */ // Label 8547: @414817
     /* 414817 */ GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(414871),
     /* 414822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 414828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414840 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(414855), // Rule ID 1890 //
     /* 414845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414848 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 414848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 414853 */     GIR_RootConstrainSelectedInstOperands,
     /* 414854 */     // GIR_Coverage, 1890,
     /* 414854 */     GIR_Done,
     /* 414855 */   // Label 8569: @414855
     /* 414855 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(414870), // Rule ID 5476 //
     /* 414860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414863 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 414868 */     GIR_RootConstrainSelectedInstOperands,
     /* 414869 */     // GIR_Coverage, 5476,
     /* 414869 */     GIR_Done,
     /* 414870 */   // Label 8570: @414870
     /* 414870 */   GIM_Reject,
     /* 414871 */ // Label 8568: @414871
     /* 414871 */ GIM_Reject,
     /* 414872 */ // Label 8548: @414872
     /* 414872 */ GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(414926),
     /* 414877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414895 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(414910), // Rule ID 1886 //
     /* 414900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414903 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 414903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 414908 */     GIR_RootConstrainSelectedInstOperands,
     /* 414909 */     // GIR_Coverage, 1886,
     /* 414909 */     GIR_Done,
     /* 414910 */   // Label 8572: @414910
     /* 414910 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(414925), // Rule ID 5472 //
     /* 414915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414918 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 414923 */     GIR_RootConstrainSelectedInstOperands,
     /* 414924 */     // GIR_Coverage, 5472,
     /* 414924 */     GIR_Done,
     /* 414925 */   // Label 8573: @414925
     /* 414925 */   GIM_Reject,
     /* 414926 */ // Label 8571: @414926
     /* 414926 */ GIM_Reject,
     /* 414927 */ // Label 8549: @414927
     /* 414927 */ GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(414981),
     /* 414932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 414938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414950 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(414965), // Rule ID 1889 //
     /* 414955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414958 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 414958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 414963 */     GIR_RootConstrainSelectedInstOperands,
     /* 414964 */     // GIR_Coverage, 1889,
     /* 414964 */     GIR_Done,
     /* 414965 */   // Label 8575: @414965
     /* 414965 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(414980), // Rule ID 5475 //
     /* 414970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414973 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 414978 */     GIR_RootConstrainSelectedInstOperands,
     /* 414979 */     // GIR_Coverage, 5475,
     /* 414979 */     GIR_Done,
     /* 414980 */   // Label 8576: @414980
     /* 414980 */   GIM_Reject,
     /* 414981 */ // Label 8574: @414981
     /* 414981 */ GIM_Reject,
     /* 414982 */ // Label 8550: @414982
     /* 414982 */ GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(415015), // Rule ID 1884 //
     /* 414987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 414993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 414996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415008 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 415008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 415013 */   GIR_RootConstrainSelectedInstOperands,
     /* 415014 */   // GIR_Coverage, 1884,
     /* 415014 */   GIR_Done,
     /* 415015 */ // Label 8577: @415015
     /* 415015 */ GIM_Reject,
     /* 415016 */ // Label 8551: @415016
     /* 415016 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(415070),
     /* 415021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 415027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415039 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(415054), // Rule ID 1887 //
     /* 415044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415047 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 415047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 415052 */     GIR_RootConstrainSelectedInstOperands,
     /* 415053 */     // GIR_Coverage, 1887,
     /* 415053 */     GIR_Done,
     /* 415054 */   // Label 8579: @415054
     /* 415054 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(415069), // Rule ID 5473 //
     /* 415059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415062 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 415067 */     GIR_RootConstrainSelectedInstOperands,
     /* 415068 */     // GIR_Coverage, 5473,
     /* 415068 */     GIR_Done,
     /* 415069 */   // Label 8580: @415069
     /* 415069 */   GIM_Reject,
     /* 415070 */ // Label 8578: @415070
     /* 415070 */ GIM_Reject,
     /* 415071 */ // Label 8552: @415071
     /* 415071 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(415104), // Rule ID 1885 //
     /* 415076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 415082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 415085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415097 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 415097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 415102 */   GIR_RootConstrainSelectedInstOperands,
     /* 415103 */   // GIR_Coverage, 1885,
     /* 415103 */   GIR_Done,
     /* 415104 */ // Label 8581: @415104
     /* 415104 */ GIM_Reject,
     /* 415105 */ // Label 8553: @415105
     /* 415105 */ GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(415130), // Rule ID 8981 //
     /* 415110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 415116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 415119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415123 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 415123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 415128 */   GIR_RootConstrainSelectedInstOperands,
     /* 415129 */   // GIR_Coverage, 8981,
     /* 415129 */   GIR_Done,
     /* 415130 */ // Label 8582: @415130
     /* 415130 */ GIM_Reject,
     /* 415131 */ // Label 8554: @415131
     /* 415131 */ GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(415156), // Rule ID 8943 //
     /* 415136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 415142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 415145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415149 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 415149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 415154 */   GIR_RootConstrainSelectedInstOperands,
     /* 415155 */   // GIR_Coverage, 8943,
     /* 415155 */   GIR_Done,
     /* 415156 */ // Label 8583: @415156
     /* 415156 */ GIM_Reject,
     /* 415157 */ // Label 8555: @415157
     /* 415157 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(415182), // Rule ID 8944 //
     /* 415162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 415168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 415171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415175 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 415175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 415180 */   GIR_RootConstrainSelectedInstOperands,
     /* 415181 */   // GIR_Coverage, 8944,
     /* 415181 */   GIR_Done,
     /* 415182 */ // Label 8584: @415182
     /* 415182 */ GIM_Reject,
     /* 415183 */ // Label 8556: @415183
     /* 415183 */ GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(415229),
     /* 415188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 415191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 415194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415198 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(415213), // Rule ID 8939 //
     /* 415203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415206 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 415206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 415211 */     GIR_RootConstrainSelectedInstOperands,
     /* 415212 */     // GIR_Coverage, 8939,
     /* 415212 */     GIR_Done,
     /* 415213 */   // Label 8586: @415213
     /* 415213 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(415228), // Rule ID 8945 //
     /* 415218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415221 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 415221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 415226 */     GIR_RootConstrainSelectedInstOperands,
     /* 415227 */     // GIR_Coverage, 8945,
     /* 415227 */     GIR_Done,
     /* 415228 */   // Label 8587: @415228
     /* 415228 */   GIM_Reject,
     /* 415229 */ // Label 8585: @415229
     /* 415229 */ GIM_Reject,
     /* 415230 */ // Label 8557: @415230
     /* 415230 */ GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(415255), // Rule ID 8980 //
     /* 415235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 415241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 415244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415248 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 415248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 415253 */   GIR_RootConstrainSelectedInstOperands,
     /* 415254 */   // GIR_Coverage, 8980,
     /* 415254 */   GIR_Done,
     /* 415255 */ // Label 8588: @415255
     /* 415255 */ GIM_Reject,
     /* 415256 */ // Label 8558: @415256
     /* 415256 */ GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(415281), // Rule ID 8941 //
     /* 415261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 415267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 415270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415274 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 415274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 415279 */   GIR_RootConstrainSelectedInstOperands,
     /* 415280 */   // GIR_Coverage, 8941,
     /* 415280 */   GIR_Done,
     /* 415281 */ // Label 8589: @415281
     /* 415281 */ GIM_Reject,
     /* 415282 */ // Label 8559: @415282
     /* 415282 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(415328),
     /* 415287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 415290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 415293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415297 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(415312), // Rule ID 8938 //
     /* 415302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415305 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 415305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 415310 */     GIR_RootConstrainSelectedInstOperands,
     /* 415311 */     // GIR_Coverage, 8938,
     /* 415311 */     GIR_Done,
     /* 415312 */   // Label 8591: @415312
     /* 415312 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(415327), // Rule ID 8942 //
     /* 415317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415320 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 415320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 415325 */     GIR_RootConstrainSelectedInstOperands,
     /* 415326 */     // GIR_Coverage, 8942,
     /* 415326 */     GIR_Done,
     /* 415327 */   // Label 8592: @415327
     /* 415327 */   GIM_Reject,
     /* 415328 */ // Label 8590: @415328
     /* 415328 */ GIM_Reject,
     /* 415329 */ // Label 8560: @415329
     /* 415329 */ GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(415354), // Rule ID 8979 //
     /* 415334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 415340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 415343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415347 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 415347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 415352 */   GIR_RootConstrainSelectedInstOperands,
     /* 415353 */   // GIR_Coverage, 8979,
     /* 415353 */   GIR_Done,
     /* 415354 */ // Label 8593: @415354
     /* 415354 */ GIM_Reject,
     /* 415355 */ // Label 8561: @415355
     /* 415355 */ GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(415401),
     /* 415360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 415363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 415366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415370 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(415385), // Rule ID 8937 //
     /* 415375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415378 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 415378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 415383 */     GIR_RootConstrainSelectedInstOperands,
     /* 415384 */     // GIR_Coverage, 8937,
     /* 415384 */     GIR_Done,
     /* 415385 */   // Label 8595: @415385
     /* 415385 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(415400), // Rule ID 8940 //
     /* 415390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415393 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 415393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 415398 */     GIR_RootConstrainSelectedInstOperands,
     /* 415399 */     // GIR_Coverage, 8940,
     /* 415399 */     GIR_Done,
     /* 415400 */   // Label 8596: @415400
     /* 415400 */   GIM_Reject,
     /* 415401 */ // Label 8594: @415401
     /* 415401 */ GIM_Reject,
     /* 415402 */ // Label 8562: @415402
     /* 415402 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(415427), // Rule ID 2406 //
     /* 415407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 415413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 415416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415420 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 415420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 415425 */   GIR_RootConstrainSelectedInstOperands,
     /* 415426 */   // GIR_Coverage, 2406,
     /* 415426 */   GIR_Done,
     /* 415427 */ // Label 8597: @415427
     /* 415427 */ GIM_Reject,
     /* 415428 */ // Label 8563: @415428
     /* 415428 */ GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(415453), // Rule ID 8936 //
     /* 415433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 415439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 415442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415446 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 415446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 415451 */   GIR_RootConstrainSelectedInstOperands,
     /* 415452 */   // GIR_Coverage, 8936,
     /* 415452 */   GIR_Done,
     /* 415453 */ // Label 8598: @415453
     /* 415453 */ GIM_Reject,
     /* 415454 */ // Label 8564: @415454
     /* 415454 */ GIM_Reject,
     /* 415455 */ // Label 149: @415455
     /* 415455 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8617*/ GIMT_Encode4(416234),
     /* 415466 */ /*GILLT_v2s32*//*Label 8599*/ GIMT_Encode4(415542),
     /* 415470 */ /*GILLT_v2s64*//*Label 8600*/ GIMT_Encode4(415597),
     /* 415474 */ /*GILLT_v4s16*//*Label 8601*/ GIMT_Encode4(415652),
     /* 415478 */ /*GILLT_v4s32*//*Label 8602*/ GIMT_Encode4(415707),
     /* 415482 */ /*GILLT_v8s8*//*Label 8603*/ GIMT_Encode4(415762),
     /* 415486 */ /*GILLT_v8s16*//*Label 8604*/ GIMT_Encode4(415796),
     /* 415490 */ /*GILLT_v16s8*//*Label 8605*/ GIMT_Encode4(415851), GIMT_Encode4(0),
     /* 415498 */ /*GILLT_nxv2s1*//*Label 8606*/ GIMT_Encode4(415885),
     /* 415502 */ /*GILLT_nxv2s16*//*Label 8607*/ GIMT_Encode4(415911),
     /* 415506 */ /*GILLT_nxv2s32*//*Label 8608*/ GIMT_Encode4(415937),
     /* 415510 */ /*GILLT_nxv2s64*//*Label 8609*/ GIMT_Encode4(415963),
     /* 415514 */ /*GILLT_nxv4s1*//*Label 8610*/ GIMT_Encode4(416010),
     /* 415518 */ /*GILLT_nxv4s16*//*Label 8611*/ GIMT_Encode4(416036),
     /* 415522 */ /*GILLT_nxv4s32*//*Label 8612*/ GIMT_Encode4(416062),
     /* 415526 */ /*GILLT_nxv8s1*//*Label 8613*/ GIMT_Encode4(416109),
     /* 415530 */ /*GILLT_nxv8s16*//*Label 8614*/ GIMT_Encode4(416135),
     /* 415534 */ /*GILLT_nxv16s1*//*Label 8615*/ GIMT_Encode4(416182),
     /* 415538 */ /*GILLT_nxv16s8*//*Label 8616*/ GIMT_Encode4(416208),
     /* 415542 */ // Label 8599: @415542
     /* 415542 */ GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(415596),
     /* 415547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 415550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 415553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415565 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(415580), // Rule ID 1895 //
     /* 415570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415573 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 415573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 415578 */     GIR_RootConstrainSelectedInstOperands,
     /* 415579 */     // GIR_Coverage, 1895,
     /* 415579 */     GIR_Done,
     /* 415580 */   // Label 8619: @415580
     /* 415580 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(415595), // Rule ID 5479 //
     /* 415585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415588 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 415588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 415593 */     GIR_RootConstrainSelectedInstOperands,
     /* 415594 */     // GIR_Coverage, 5479,
     /* 415594 */     GIR_Done,
     /* 415595 */   // Label 8620: @415595
     /* 415595 */   GIM_Reject,
     /* 415596 */ // Label 8618: @415596
     /* 415596 */ GIM_Reject,
     /* 415597 */ // Label 8600: @415597
     /* 415597 */ GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(415651),
     /* 415602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 415605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 415608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415620 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(415635), // Rule ID 1897 //
     /* 415625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415628 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 415628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 415633 */     GIR_RootConstrainSelectedInstOperands,
     /* 415634 */     // GIR_Coverage, 1897,
     /* 415634 */     GIR_Done,
     /* 415635 */   // Label 8622: @415635
     /* 415635 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(415650), // Rule ID 5481 //
     /* 415640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415643 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 415643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 415648 */     GIR_RootConstrainSelectedInstOperands,
     /* 415649 */     // GIR_Coverage, 5481,
     /* 415649 */     GIR_Done,
     /* 415650 */   // Label 8623: @415650
     /* 415650 */   GIM_Reject,
     /* 415651 */ // Label 8621: @415651
     /* 415651 */ GIM_Reject,
     /* 415652 */ // Label 8601: @415652
     /* 415652 */ GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(415706),
     /* 415657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 415663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415675 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(415690), // Rule ID 1893 //
     /* 415680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415683 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 415683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 415688 */     GIR_RootConstrainSelectedInstOperands,
     /* 415689 */     // GIR_Coverage, 1893,
     /* 415689 */     GIR_Done,
     /* 415690 */   // Label 8625: @415690
     /* 415690 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(415705), // Rule ID 5477 //
     /* 415695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415698 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 415698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 415703 */     GIR_RootConstrainSelectedInstOperands,
     /* 415704 */     // GIR_Coverage, 5477,
     /* 415704 */     GIR_Done,
     /* 415705 */   // Label 8626: @415705
     /* 415705 */   GIM_Reject,
     /* 415706 */ // Label 8624: @415706
     /* 415706 */ GIM_Reject,
     /* 415707 */ // Label 8602: @415707
     /* 415707 */ GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(415761),
     /* 415712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 415718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415730 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(415745), // Rule ID 1896 //
     /* 415735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415738 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 415738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 415743 */     GIR_RootConstrainSelectedInstOperands,
     /* 415744 */     // GIR_Coverage, 1896,
     /* 415744 */     GIR_Done,
     /* 415745 */   // Label 8628: @415745
     /* 415745 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(415760), // Rule ID 5480 //
     /* 415750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415753 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 415758 */     GIR_RootConstrainSelectedInstOperands,
     /* 415759 */     // GIR_Coverage, 5480,
     /* 415759 */     GIR_Done,
     /* 415760 */   // Label 8629: @415760
     /* 415760 */   GIM_Reject,
     /* 415761 */ // Label 8627: @415761
     /* 415761 */ GIM_Reject,
     /* 415762 */ // Label 8603: @415762
     /* 415762 */ GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(415795), // Rule ID 1891 //
     /* 415767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 415773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 415776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415788 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 415788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 415793 */   GIR_RootConstrainSelectedInstOperands,
     /* 415794 */   // GIR_Coverage, 1891,
     /* 415794 */   GIR_Done,
     /* 415795 */ // Label 8630: @415795
     /* 415795 */ GIM_Reject,
     /* 415796 */ // Label 8604: @415796
     /* 415796 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(415850),
     /* 415801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 415807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415819 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(415834), // Rule ID 1894 //
     /* 415824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415827 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 415827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 415832 */     GIR_RootConstrainSelectedInstOperands,
     /* 415833 */     // GIR_Coverage, 1894,
     /* 415833 */     GIR_Done,
     /* 415834 */   // Label 8632: @415834
     /* 415834 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(415849), // Rule ID 5478 //
     /* 415839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415842 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 415847 */     GIR_RootConstrainSelectedInstOperands,
     /* 415848 */     // GIR_Coverage, 5478,
     /* 415848 */     GIR_Done,
     /* 415849 */   // Label 8633: @415849
     /* 415849 */   GIM_Reject,
     /* 415850 */ // Label 8631: @415850
     /* 415850 */ GIM_Reject,
     /* 415851 */ // Label 8605: @415851
     /* 415851 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(415884), // Rule ID 1892 //
     /* 415856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 415862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 415865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415877 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 415877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 415882 */   GIR_RootConstrainSelectedInstOperands,
     /* 415883 */   // GIR_Coverage, 1892,
     /* 415883 */   GIR_Done,
     /* 415884 */ // Label 8634: @415884
     /* 415884 */ GIM_Reject,
     /* 415885 */ // Label 8606: @415885
     /* 415885 */ GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(415910), // Rule ID 8984 //
     /* 415890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 415896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 415899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415903 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 415903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 415908 */   GIR_RootConstrainSelectedInstOperands,
     /* 415909 */   // GIR_Coverage, 8984,
     /* 415909 */   GIR_Done,
     /* 415910 */ // Label 8635: @415910
     /* 415910 */ GIM_Reject,
     /* 415911 */ // Label 8607: @415911
     /* 415911 */ GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(415936), // Rule ID 8953 //
     /* 415916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 415922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 415925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415929 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 415929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 415934 */   GIR_RootConstrainSelectedInstOperands,
     /* 415935 */   // GIR_Coverage, 8953,
     /* 415935 */   GIR_Done,
     /* 415936 */ // Label 8636: @415936
     /* 415936 */ GIM_Reject,
     /* 415937 */ // Label 8608: @415937
     /* 415937 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(415962), // Rule ID 8954 //
     /* 415942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 415948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 415951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415955 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 415955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 415960 */   GIR_RootConstrainSelectedInstOperands,
     /* 415961 */   // GIR_Coverage, 8954,
     /* 415961 */   GIR_Done,
     /* 415962 */ // Label 8637: @415962
     /* 415962 */ GIM_Reject,
     /* 415963 */ // Label 8609: @415963
     /* 415963 */ GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(416009),
     /* 415968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 415971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 415974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415978 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(415993), // Rule ID 8949 //
     /* 415983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415986 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 415986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 415991 */     GIR_RootConstrainSelectedInstOperands,
     /* 415992 */     // GIR_Coverage, 8949,
     /* 415992 */     GIR_Done,
     /* 415993 */   // Label 8639: @415993
     /* 415993 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(416008), // Rule ID 8955 //
     /* 415998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416001 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 416001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 416006 */     GIR_RootConstrainSelectedInstOperands,
     /* 416007 */     // GIR_Coverage, 8955,
     /* 416007 */     GIR_Done,
     /* 416008 */   // Label 8640: @416008
     /* 416008 */   GIM_Reject,
     /* 416009 */ // Label 8638: @416009
     /* 416009 */ GIM_Reject,
     /* 416010 */ // Label 8610: @416010
     /* 416010 */ GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(416035), // Rule ID 8983 //
     /* 416015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 416021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 416024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416028 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 416028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 416033 */   GIR_RootConstrainSelectedInstOperands,
     /* 416034 */   // GIR_Coverage, 8983,
     /* 416034 */   GIR_Done,
     /* 416035 */ // Label 8641: @416035
     /* 416035 */ GIM_Reject,
     /* 416036 */ // Label 8611: @416036
     /* 416036 */ GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(416061), // Rule ID 8951 //
     /* 416041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 416047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 416050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416054 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 416054 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 416059 */   GIR_RootConstrainSelectedInstOperands,
     /* 416060 */   // GIR_Coverage, 8951,
     /* 416060 */   GIR_Done,
     /* 416061 */ // Label 8642: @416061
     /* 416061 */ GIM_Reject,
     /* 416062 */ // Label 8612: @416062
     /* 416062 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(416108),
     /* 416067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 416070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 416073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416077 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(416092), // Rule ID 8948 //
     /* 416082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416085 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 416085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 416090 */     GIR_RootConstrainSelectedInstOperands,
     /* 416091 */     // GIR_Coverage, 8948,
     /* 416091 */     GIR_Done,
     /* 416092 */   // Label 8644: @416092
     /* 416092 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(416107), // Rule ID 8952 //
     /* 416097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416100 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 416100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 416105 */     GIR_RootConstrainSelectedInstOperands,
     /* 416106 */     // GIR_Coverage, 8952,
     /* 416106 */     GIR_Done,
     /* 416107 */   // Label 8645: @416107
     /* 416107 */   GIM_Reject,
     /* 416108 */ // Label 8643: @416108
     /* 416108 */ GIM_Reject,
     /* 416109 */ // Label 8613: @416109
     /* 416109 */ GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(416134), // Rule ID 8982 //
     /* 416114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 416120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 416123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416127 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 416127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 416132 */   GIR_RootConstrainSelectedInstOperands,
     /* 416133 */   // GIR_Coverage, 8982,
     /* 416133 */   GIR_Done,
     /* 416134 */ // Label 8646: @416134
     /* 416134 */ GIM_Reject,
     /* 416135 */ // Label 8614: @416135
     /* 416135 */ GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(416181),
     /* 416140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 416143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 416146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416150 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(416165), // Rule ID 8947 //
     /* 416155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416158 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 416158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 416163 */     GIR_RootConstrainSelectedInstOperands,
     /* 416164 */     // GIR_Coverage, 8947,
     /* 416164 */     GIR_Done,
     /* 416165 */   // Label 8648: @416165
     /* 416165 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(416180), // Rule ID 8950 //
     /* 416170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416173 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 416173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 416178 */     GIR_RootConstrainSelectedInstOperands,
     /* 416179 */     // GIR_Coverage, 8950,
     /* 416179 */     GIR_Done,
     /* 416180 */   // Label 8649: @416180
     /* 416180 */   GIM_Reject,
     /* 416181 */ // Label 8647: @416181
     /* 416181 */ GIM_Reject,
     /* 416182 */ // Label 8615: @416182
     /* 416182 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(416207), // Rule ID 2410 //
     /* 416187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 416193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 416196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416200 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 416200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 416205 */   GIR_RootConstrainSelectedInstOperands,
     /* 416206 */   // GIR_Coverage, 2410,
     /* 416206 */   GIR_Done,
     /* 416207 */ // Label 8650: @416207
     /* 416207 */ GIM_Reject,
     /* 416208 */ // Label 8616: @416208
     /* 416208 */ GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(416233), // Rule ID 8946 //
     /* 416213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 416219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 416222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416226 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 416226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 416231 */   GIR_RootConstrainSelectedInstOperands,
     /* 416232 */   // GIR_Coverage, 8946,
     /* 416232 */   GIR_Done,
     /* 416233 */ // Label 8651: @416233
     /* 416233 */ GIM_Reject,
     /* 416234 */ // Label 8617: @416234
     /* 416234 */ GIM_Reject,
     /* 416235 */ // Label 150: @416235
     /* 416235 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8660*/ GIMT_Encode4(416932),
     /* 416246 */ /*GILLT_s64*//*Label 8652*/ GIMT_Encode4(416282), GIMT_Encode4(0),
     /* 416254 */ /*GILLT_v2s32*//*Label 8653*/ GIMT_Encode4(416393),
     /* 416258 */ /*GILLT_v2s64*//*Label 8654*/ GIMT_Encode4(416470),
     /* 416262 */ /*GILLT_v4s16*//*Label 8655*/ GIMT_Encode4(416547),
     /* 416266 */ /*GILLT_v4s32*//*Label 8656*/ GIMT_Encode4(416624),
     /* 416270 */ /*GILLT_v8s8*//*Label 8657*/ GIMT_Encode4(416701),
     /* 416274 */ /*GILLT_v8s16*//*Label 8658*/ GIMT_Encode4(416778),
     /* 416278 */ /*GILLT_v16s8*//*Label 8659*/ GIMT_Encode4(416855),
     /* 416282 */ // Label 8652: @416282
     /* 416282 */ GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(416392),
     /* 416287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 416290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416298 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(416323), // Rule ID 5251 //
     /* 416303 */     // MIs[0] Operand 2
     /* 416303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 416314 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 416314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 416317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416321 */     GIR_RootConstrainSelectedInstOperands,
     /* 416322 */     // GIR_Coverage, 5251,
     /* 416322 */     GIR_EraseRootFromParent_Done,
     /* 416323 */   // Label 8662: @416323
     /* 416323 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(416357), // Rule ID 2120 //
     /* 416328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416331 */     // MIs[0] imm
     /* 416331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 416343 */     // MIs[1] Operand 1
     /* 416343 */     // No operand predicates
     /* 416343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416345 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 416348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416355 */     GIR_RootConstrainSelectedInstOperands,
     /* 416356 */     // GIR_Coverage, 2120,
     /* 416356 */     GIR_EraseRootFromParent_Done,
     /* 416357 */   // Label 8663: @416357
     /* 416357 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(416391), // Rule ID 6301 //
     /* 416362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416365 */     // MIs[0] imm
     /* 416365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 416377 */     // MIs[1] Operand 1
     /* 416377 */     // No operand predicates
     /* 416377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416379 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 416379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 416382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416389 */     GIR_RootConstrainSelectedInstOperands,
     /* 416390 */     // GIR_Coverage, 6301,
     /* 416390 */     GIR_EraseRootFromParent_Done,
     /* 416391 */   // Label 8664: @416391
     /* 416391 */   GIM_Reject,
     /* 416392 */ // Label 8661: @416392
     /* 416392 */ GIM_Reject,
     /* 416393 */ // Label 8653: @416393
     /* 416393 */ GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(416469),
     /* 416398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416409 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(416434), // Rule ID 4892 //
     /* 416414 */     // MIs[0] Operand 2
     /* 416414 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 416425 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 416425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 416428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416432 */     GIR_RootConstrainSelectedInstOperands,
     /* 416433 */     // GIR_Coverage, 4892,
     /* 416433 */     GIR_EraseRootFromParent_Done,
     /* 416434 */   // Label 8666: @416434
     /* 416434 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(416468), // Rule ID 2227 //
     /* 416439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416442 */     // MIs[0] imm
     /* 416442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 416454 */     // MIs[1] Operand 1
     /* 416454 */     // No operand predicates
     /* 416454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416456 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 416459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416466 */     GIR_RootConstrainSelectedInstOperands,
     /* 416467 */     // GIR_Coverage, 2227,
     /* 416467 */     GIR_EraseRootFromParent_Done,
     /* 416468 */   // Label 8667: @416468
     /* 416468 */   GIM_Reject,
     /* 416469 */ // Label 8665: @416469
     /* 416469 */ GIM_Reject,
     /* 416470 */ // Label 8654: @416470
     /* 416470 */ GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(416546),
     /* 416475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416486 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(416511), // Rule ID 4896 //
     /* 416491 */     // MIs[0] Operand 2
     /* 416491 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 416502 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 416502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 416505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416509 */     GIR_RootConstrainSelectedInstOperands,
     /* 416510 */     // GIR_Coverage, 4896,
     /* 416510 */     GIR_EraseRootFromParent_Done,
     /* 416511 */   // Label 8669: @416511
     /* 416511 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(416545), // Rule ID 2229 //
     /* 416516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416519 */     // MIs[0] imm
     /* 416519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 416531 */     // MIs[1] Operand 1
     /* 416531 */     // No operand predicates
     /* 416531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416533 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 416536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416543 */     GIR_RootConstrainSelectedInstOperands,
     /* 416544 */     // GIR_Coverage, 2229,
     /* 416544 */     GIR_EraseRootFromParent_Done,
     /* 416545 */   // Label 8670: @416545
     /* 416545 */   GIM_Reject,
     /* 416546 */ // Label 8668: @416546
     /* 416546 */ GIM_Reject,
     /* 416547 */ // Label 8655: @416547
     /* 416547 */ GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(416623),
     /* 416552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416563 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(416588), // Rule ID 4891 //
     /* 416568 */     // MIs[0] Operand 2
     /* 416568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 416579 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 416579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 416582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416586 */     GIR_RootConstrainSelectedInstOperands,
     /* 416587 */     // GIR_Coverage, 4891,
     /* 416587 */     GIR_EraseRootFromParent_Done,
     /* 416588 */   // Label 8672: @416588
     /* 416588 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(416622), // Rule ID 2225 //
     /* 416593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416596 */     // MIs[0] imm
     /* 416596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 416608 */     // MIs[1] Operand 1
     /* 416608 */     // No operand predicates
     /* 416608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416610 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 416613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416620 */     GIR_RootConstrainSelectedInstOperands,
     /* 416621 */     // GIR_Coverage, 2225,
     /* 416621 */     GIR_EraseRootFromParent_Done,
     /* 416622 */   // Label 8673: @416622
     /* 416622 */   GIM_Reject,
     /* 416623 */ // Label 8671: @416623
     /* 416623 */ GIM_Reject,
     /* 416624 */ // Label 8656: @416624
     /* 416624 */ GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(416700),
     /* 416629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416640 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(416665), // Rule ID 4895 //
     /* 416645 */     // MIs[0] Operand 2
     /* 416645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 416656 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 416656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 416659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416663 */     GIR_RootConstrainSelectedInstOperands,
     /* 416664 */     // GIR_Coverage, 4895,
     /* 416664 */     GIR_EraseRootFromParent_Done,
     /* 416665 */   // Label 8675: @416665
     /* 416665 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(416699), // Rule ID 2228 //
     /* 416670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416673 */     // MIs[0] imm
     /* 416673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 416685 */     // MIs[1] Operand 1
     /* 416685 */     // No operand predicates
     /* 416685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416687 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 416690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416697 */     GIR_RootConstrainSelectedInstOperands,
     /* 416698 */     // GIR_Coverage, 2228,
     /* 416698 */     GIR_EraseRootFromParent_Done,
     /* 416699 */   // Label 8676: @416699
     /* 416699 */   GIM_Reject,
     /* 416700 */ // Label 8674: @416700
     /* 416700 */ GIM_Reject,
     /* 416701 */ // Label 8657: @416701
     /* 416701 */ GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(416777),
     /* 416706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 416709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416717 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(416742), // Rule ID 4890 //
     /* 416722 */     // MIs[0] Operand 2
     /* 416722 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 416733 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 416733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 416736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416740 */     GIR_RootConstrainSelectedInstOperands,
     /* 416741 */     // GIR_Coverage, 4890,
     /* 416741 */     GIR_EraseRootFromParent_Done,
     /* 416742 */   // Label 8678: @416742
     /* 416742 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(416776), // Rule ID 2223 //
     /* 416747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416750 */     // MIs[0] imm
     /* 416750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 416762 */     // MIs[1] Operand 1
     /* 416762 */     // No operand predicates
     /* 416762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416764 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 416767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416774 */     GIR_RootConstrainSelectedInstOperands,
     /* 416775 */     // GIR_Coverage, 2223,
     /* 416775 */     GIR_EraseRootFromParent_Done,
     /* 416776 */   // Label 8679: @416776
     /* 416776 */   GIM_Reject,
     /* 416777 */ // Label 8677: @416777
     /* 416777 */ GIM_Reject,
     /* 416778 */ // Label 8658: @416778
     /* 416778 */ GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(416854),
     /* 416783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416794 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(416819), // Rule ID 4894 //
     /* 416799 */     // MIs[0] Operand 2
     /* 416799 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 416810 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 416810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 416813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416817 */     GIR_RootConstrainSelectedInstOperands,
     /* 416818 */     // GIR_Coverage, 4894,
     /* 416818 */     GIR_EraseRootFromParent_Done,
     /* 416819 */   // Label 8681: @416819
     /* 416819 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(416853), // Rule ID 2226 //
     /* 416824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416827 */     // MIs[0] imm
     /* 416827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 416839 */     // MIs[1] Operand 1
     /* 416839 */     // No operand predicates
     /* 416839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416841 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 416844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416851 */     GIR_RootConstrainSelectedInstOperands,
     /* 416852 */     // GIR_Coverage, 2226,
     /* 416852 */     GIR_EraseRootFromParent_Done,
     /* 416853 */   // Label 8682: @416853
     /* 416853 */   GIM_Reject,
     /* 416854 */ // Label 8680: @416854
     /* 416854 */ GIM_Reject,
     /* 416855 */ // Label 8659: @416855
     /* 416855 */ GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(416931),
     /* 416860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 416863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416871 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(416896), // Rule ID 4893 //
     /* 416876 */     // MIs[0] Operand 2
     /* 416876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 416887 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 416887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 416890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416894 */     GIR_RootConstrainSelectedInstOperands,
     /* 416895 */     // GIR_Coverage, 4893,
     /* 416895 */     GIR_EraseRootFromParent_Done,
     /* 416896 */   // Label 8684: @416896
     /* 416896 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(416930), // Rule ID 2224 //
     /* 416901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416904 */     // MIs[0] imm
     /* 416904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 416916 */     // MIs[1] Operand 1
     /* 416916 */     // No operand predicates
     /* 416916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416918 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 416918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 416921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 416928 */     GIR_RootConstrainSelectedInstOperands,
     /* 416929 */     // GIR_Coverage, 2224,
     /* 416929 */     GIR_EraseRootFromParent_Done,
     /* 416930 */   // Label 8685: @416930
     /* 416930 */   GIM_Reject,
     /* 416931 */ // Label 8683: @416931
     /* 416931 */ GIM_Reject,
     /* 416932 */ // Label 8660: @416932
     /* 416932 */ GIM_Reject,
     /* 416933 */ // Label 151: @416933
     /* 416933 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8694*/ GIMT_Encode4(417388),
     /* 416944 */ /*GILLT_s64*//*Label 8686*/ GIMT_Encode4(416980), GIMT_Encode4(0),
     /* 416952 */ /*GILLT_v2s32*//*Label 8687*/ GIMT_Encode4(417066),
     /* 416956 */ /*GILLT_v2s64*//*Label 8688*/ GIMT_Encode4(417112),
     /* 416960 */ /*GILLT_v4s16*//*Label 8689*/ GIMT_Encode4(417158),
     /* 416964 */ /*GILLT_v4s32*//*Label 8690*/ GIMT_Encode4(417204),
     /* 416968 */ /*GILLT_v8s8*//*Label 8691*/ GIMT_Encode4(417250),
     /* 416972 */ /*GILLT_v8s16*//*Label 8692*/ GIMT_Encode4(417296),
     /* 416976 */ /*GILLT_v16s8*//*Label 8693*/ GIMT_Encode4(417342),
     /* 416980 */ // Label 8686: @416980
     /* 416980 */ GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(417065),
     /* 416985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 416988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416996 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(417030), // Rule ID 2129 //
     /* 417001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417004 */     // MIs[0] imm
     /* 417004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 417016 */     // MIs[1] Operand 1
     /* 417016 */     // No operand predicates
     /* 417016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417018 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 417021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417028 */     GIR_RootConstrainSelectedInstOperands,
     /* 417029 */     // GIR_Coverage, 2129,
     /* 417029 */     GIR_EraseRootFromParent_Done,
     /* 417030 */   // Label 8696: @417030
     /* 417030 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(417064), // Rule ID 6304 //
     /* 417035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417038 */     // MIs[0] imm
     /* 417038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 417050 */     // MIs[1] Operand 1
     /* 417050 */     // No operand predicates
     /* 417050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417052 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 417052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 417055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417062 */     GIR_RootConstrainSelectedInstOperands,
     /* 417063 */     // GIR_Coverage, 6304,
     /* 417063 */     GIR_EraseRootFromParent_Done,
     /* 417064 */   // Label 8697: @417064
     /* 417064 */   GIM_Reject,
     /* 417065 */ // Label 8695: @417065
     /* 417065 */ GIM_Reject,
     /* 417066 */ // Label 8687: @417066
     /* 417066 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(417111), // Rule ID 2286 //
     /* 417071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417085 */   // MIs[0] imm
     /* 417085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417093 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 417097 */   // MIs[1] Operand 1
     /* 417097 */   // No operand predicates
     /* 417097 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417099 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 417102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417104 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417106 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417109 */   GIR_RootConstrainSelectedInstOperands,
     /* 417110 */   // GIR_Coverage, 2286,
     /* 417110 */   GIR_EraseRootFromParent_Done,
     /* 417111 */ // Label 8698: @417111
     /* 417111 */ GIM_Reject,
     /* 417112 */ // Label 8688: @417112
     /* 417112 */ GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(417157), // Rule ID 2288 //
     /* 417117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417131 */   // MIs[0] imm
     /* 417131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417139 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 417143 */   // MIs[1] Operand 1
     /* 417143 */   // No operand predicates
     /* 417143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417145 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 417148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417150 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417152 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417155 */   GIR_RootConstrainSelectedInstOperands,
     /* 417156 */   // GIR_Coverage, 2288,
     /* 417156 */   GIR_EraseRootFromParent_Done,
     /* 417157 */ // Label 8699: @417157
     /* 417157 */ GIM_Reject,
     /* 417158 */ // Label 8689: @417158
     /* 417158 */ GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(417203), // Rule ID 2284 //
     /* 417163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417177 */   // MIs[0] imm
     /* 417177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417185 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 417189 */   // MIs[1] Operand 1
     /* 417189 */   // No operand predicates
     /* 417189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417191 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 417194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417196 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417198 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417201 */   GIR_RootConstrainSelectedInstOperands,
     /* 417202 */   // GIR_Coverage, 2284,
     /* 417202 */   GIR_EraseRootFromParent_Done,
     /* 417203 */ // Label 8700: @417203
     /* 417203 */ GIM_Reject,
     /* 417204 */ // Label 8690: @417204
     /* 417204 */ GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(417249), // Rule ID 2287 //
     /* 417209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417223 */   // MIs[0] imm
     /* 417223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417231 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 417235 */   // MIs[1] Operand 1
     /* 417235 */   // No operand predicates
     /* 417235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417237 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 417240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417242 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417244 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417247 */   GIR_RootConstrainSelectedInstOperands,
     /* 417248 */   // GIR_Coverage, 2287,
     /* 417248 */   GIR_EraseRootFromParent_Done,
     /* 417249 */ // Label 8701: @417249
     /* 417249 */ GIM_Reject,
     /* 417250 */ // Label 8691: @417250
     /* 417250 */ GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(417295), // Rule ID 2282 //
     /* 417255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417269 */   // MIs[0] imm
     /* 417269 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417277 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 417281 */   // MIs[1] Operand 1
     /* 417281 */   // No operand predicates
     /* 417281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417283 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 417286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417288 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417290 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417293 */   GIR_RootConstrainSelectedInstOperands,
     /* 417294 */   // GIR_Coverage, 2282,
     /* 417294 */   GIR_EraseRootFromParent_Done,
     /* 417295 */ // Label 8702: @417295
     /* 417295 */ GIM_Reject,
     /* 417296 */ // Label 8692: @417296
     /* 417296 */ GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(417341), // Rule ID 2285 //
     /* 417301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417315 */   // MIs[0] imm
     /* 417315 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417319 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417323 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 417327 */   // MIs[1] Operand 1
     /* 417327 */   // No operand predicates
     /* 417327 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417329 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 417332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417334 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417336 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417339 */   GIR_RootConstrainSelectedInstOperands,
     /* 417340 */   // GIR_Coverage, 2285,
     /* 417340 */   GIR_EraseRootFromParent_Done,
     /* 417341 */ // Label 8703: @417341
     /* 417341 */ GIM_Reject,
     /* 417342 */ // Label 8693: @417342
     /* 417342 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(417387), // Rule ID 2283 //
     /* 417347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417361 */   // MIs[0] imm
     /* 417361 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417365 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417369 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 417373 */   // MIs[1] Operand 1
     /* 417373 */   // No operand predicates
     /* 417373 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417375 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 417375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 417378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417380 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417382 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 417385 */   GIR_RootConstrainSelectedInstOperands,
     /* 417386 */   // GIR_Coverage, 2283,
     /* 417386 */   GIR_EraseRootFromParent_Done,
     /* 417387 */ // Label 8704: @417387
     /* 417387 */ GIM_Reject,
     /* 417388 */ // Label 8694: @417388
     /* 417388 */ GIM_Reject,
     /* 417389 */ // Label 152: @417389
     /* 417389 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8723*/ GIMT_Encode4(418168),
     /* 417400 */ /*GILLT_v2s32*//*Label 8705*/ GIMT_Encode4(417476),
     /* 417404 */ /*GILLT_v2s64*//*Label 8706*/ GIMT_Encode4(417531),
     /* 417408 */ /*GILLT_v4s16*//*Label 8707*/ GIMT_Encode4(417586),
     /* 417412 */ /*GILLT_v4s32*//*Label 8708*/ GIMT_Encode4(417641),
     /* 417416 */ /*GILLT_v8s8*//*Label 8709*/ GIMT_Encode4(417696),
     /* 417420 */ /*GILLT_v8s16*//*Label 8710*/ GIMT_Encode4(417730),
     /* 417424 */ /*GILLT_v16s8*//*Label 8711*/ GIMT_Encode4(417785), GIMT_Encode4(0),
     /* 417432 */ /*GILLT_nxv2s1*//*Label 8712*/ GIMT_Encode4(417819),
     /* 417436 */ /*GILLT_nxv2s16*//*Label 8713*/ GIMT_Encode4(417845),
     /* 417440 */ /*GILLT_nxv2s32*//*Label 8714*/ GIMT_Encode4(417871),
     /* 417444 */ /*GILLT_nxv2s64*//*Label 8715*/ GIMT_Encode4(417897),
     /* 417448 */ /*GILLT_nxv4s1*//*Label 8716*/ GIMT_Encode4(417944),
     /* 417452 */ /*GILLT_nxv4s16*//*Label 8717*/ GIMT_Encode4(417970),
     /* 417456 */ /*GILLT_nxv4s32*//*Label 8718*/ GIMT_Encode4(417996),
     /* 417460 */ /*GILLT_nxv8s1*//*Label 8719*/ GIMT_Encode4(418043),
     /* 417464 */ /*GILLT_nxv8s16*//*Label 8720*/ GIMT_Encode4(418069),
     /* 417468 */ /*GILLT_nxv16s1*//*Label 8721*/ GIMT_Encode4(418116),
     /* 417472 */ /*GILLT_nxv16s8*//*Label 8722*/ GIMT_Encode4(418142),
     /* 417476 */ // Label 8705: @417476
     /* 417476 */ GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(417530),
     /* 417481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 417487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417499 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(417514), // Rule ID 1902 //
     /* 417504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417507 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 417507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 417512 */     GIR_RootConstrainSelectedInstOperands,
     /* 417513 */     // GIR_Coverage, 1902,
     /* 417513 */     GIR_Done,
     /* 417514 */   // Label 8725: @417514
     /* 417514 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(417529), // Rule ID 5484 //
     /* 417519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417522 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 417522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 417527 */     GIR_RootConstrainSelectedInstOperands,
     /* 417528 */     // GIR_Coverage, 5484,
     /* 417528 */     GIR_Done,
     /* 417529 */   // Label 8726: @417529
     /* 417529 */   GIM_Reject,
     /* 417530 */ // Label 8724: @417530
     /* 417530 */ GIM_Reject,
     /* 417531 */ // Label 8706: @417531
     /* 417531 */ GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(417585),
     /* 417536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 417542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417554 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(417569), // Rule ID 1904 //
     /* 417559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417562 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 417562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 417567 */     GIR_RootConstrainSelectedInstOperands,
     /* 417568 */     // GIR_Coverage, 1904,
     /* 417568 */     GIR_Done,
     /* 417569 */   // Label 8728: @417569
     /* 417569 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(417584), // Rule ID 5486 //
     /* 417574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417577 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 417577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 417582 */     GIR_RootConstrainSelectedInstOperands,
     /* 417583 */     // GIR_Coverage, 5486,
     /* 417583 */     GIR_Done,
     /* 417584 */   // Label 8729: @417584
     /* 417584 */   GIM_Reject,
     /* 417585 */ // Label 8727: @417585
     /* 417585 */ GIM_Reject,
     /* 417586 */ // Label 8707: @417586
     /* 417586 */ GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(417640),
     /* 417591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 417597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417609 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(417624), // Rule ID 1900 //
     /* 417614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417617 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 417617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 417622 */     GIR_RootConstrainSelectedInstOperands,
     /* 417623 */     // GIR_Coverage, 1900,
     /* 417623 */     GIR_Done,
     /* 417624 */   // Label 8731: @417624
     /* 417624 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(417639), // Rule ID 5482 //
     /* 417629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417632 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 417632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 417637 */     GIR_RootConstrainSelectedInstOperands,
     /* 417638 */     // GIR_Coverage, 5482,
     /* 417638 */     GIR_Done,
     /* 417639 */   // Label 8732: @417639
     /* 417639 */   GIM_Reject,
     /* 417640 */ // Label 8730: @417640
     /* 417640 */ GIM_Reject,
     /* 417641 */ // Label 8708: @417641
     /* 417641 */ GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(417695),
     /* 417646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 417652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417664 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(417679), // Rule ID 1903 //
     /* 417669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417672 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 417672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 417677 */     GIR_RootConstrainSelectedInstOperands,
     /* 417678 */     // GIR_Coverage, 1903,
     /* 417678 */     GIR_Done,
     /* 417679 */   // Label 8734: @417679
     /* 417679 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(417694), // Rule ID 5485 //
     /* 417684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417687 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 417687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 417692 */     GIR_RootConstrainSelectedInstOperands,
     /* 417693 */     // GIR_Coverage, 5485,
     /* 417693 */     GIR_Done,
     /* 417694 */   // Label 8735: @417694
     /* 417694 */   GIM_Reject,
     /* 417695 */ // Label 8733: @417695
     /* 417695 */ GIM_Reject,
     /* 417696 */ // Label 8709: @417696
     /* 417696 */ GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(417729), // Rule ID 1898 //
     /* 417701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 417710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417722 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 417722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 417727 */   GIR_RootConstrainSelectedInstOperands,
     /* 417728 */   // GIR_Coverage, 1898,
     /* 417728 */   GIR_Done,
     /* 417729 */ // Label 8736: @417729
     /* 417729 */ GIM_Reject,
     /* 417730 */ // Label 8710: @417730
     /* 417730 */ GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(417784),
     /* 417735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 417741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417753 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(417768), // Rule ID 1901 //
     /* 417758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417761 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 417761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 417766 */     GIR_RootConstrainSelectedInstOperands,
     /* 417767 */     // GIR_Coverage, 1901,
     /* 417767 */     GIR_Done,
     /* 417768 */   // Label 8738: @417768
     /* 417768 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(417783), // Rule ID 5483 //
     /* 417773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417776 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 417781 */     GIR_RootConstrainSelectedInstOperands,
     /* 417782 */     // GIR_Coverage, 5483,
     /* 417782 */     GIR_Done,
     /* 417783 */   // Label 8739: @417783
     /* 417783 */   GIM_Reject,
     /* 417784 */ // Label 8737: @417784
     /* 417784 */ GIM_Reject,
     /* 417785 */ // Label 8711: @417785
     /* 417785 */ GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(417818), // Rule ID 1899 //
     /* 417790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417811 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 417811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 417816 */   GIR_RootConstrainSelectedInstOperands,
     /* 417817 */   // GIR_Coverage, 1899,
     /* 417817 */   GIR_Done,
     /* 417818 */ // Label 8740: @417818
     /* 417818 */ GIM_Reject,
     /* 417819 */ // Label 8712: @417819
     /* 417819 */ GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(417844), // Rule ID 3348 //
     /* 417824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 417830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 417833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 417837 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 417837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 417842 */   GIR_RootConstrainSelectedInstOperands,
     /* 417843 */   // GIR_Coverage, 3348,
     /* 417843 */   GIR_Done,
     /* 417844 */ // Label 8741: @417844
     /* 417844 */ GIM_Reject,
     /* 417845 */ // Label 8713: @417845
     /* 417845 */ GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(417870), // Rule ID 2879 //
     /* 417850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 417856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 417859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417863 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 417863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 417868 */   GIR_RootConstrainSelectedInstOperands,
     /* 417869 */   // GIR_Coverage, 2879,
     /* 417869 */   GIR_Done,
     /* 417870 */ // Label 8742: @417870
     /* 417870 */ GIM_Reject,
     /* 417871 */ // Label 8714: @417871
     /* 417871 */ GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(417896), // Rule ID 2880 //
     /* 417876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 417882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 417885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417889 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 417889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 417894 */   GIR_RootConstrainSelectedInstOperands,
     /* 417895 */   // GIR_Coverage, 2880,
     /* 417895 */   GIR_Done,
     /* 417896 */ // Label 8743: @417896
     /* 417896 */ GIM_Reject,
     /* 417897 */ // Label 8715: @417897
     /* 417897 */ GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(417943),
     /* 417902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 417905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 417908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417912 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(417927), // Rule ID 2875 //
     /* 417917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417920 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 417920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 417925 */     GIR_RootConstrainSelectedInstOperands,
     /* 417926 */     // GIR_Coverage, 2875,
     /* 417926 */     GIR_Done,
     /* 417927 */   // Label 8745: @417927
     /* 417927 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(417942), // Rule ID 2881 //
     /* 417932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417935 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 417935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 417940 */     GIR_RootConstrainSelectedInstOperands,
     /* 417941 */     // GIR_Coverage, 2881,
     /* 417941 */     GIR_Done,
     /* 417942 */   // Label 8746: @417942
     /* 417942 */   GIM_Reject,
     /* 417943 */ // Label 8744: @417943
     /* 417943 */ GIM_Reject,
     /* 417944 */ // Label 8716: @417944
     /* 417944 */ GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(417969), // Rule ID 3347 //
     /* 417949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 417955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 417958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 417962 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 417962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 417967 */   GIR_RootConstrainSelectedInstOperands,
     /* 417968 */   // GIR_Coverage, 3347,
     /* 417968 */   GIR_Done,
     /* 417969 */ // Label 8747: @417969
     /* 417969 */ GIM_Reject,
     /* 417970 */ // Label 8717: @417970
     /* 417970 */ GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(417995), // Rule ID 2877 //
     /* 417975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 417981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 417984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417988 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 417988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 417993 */   GIR_RootConstrainSelectedInstOperands,
     /* 417994 */   // GIR_Coverage, 2877,
     /* 417994 */   GIR_Done,
     /* 417995 */ // Label 8748: @417995
     /* 417995 */ GIM_Reject,
     /* 417996 */ // Label 8718: @417996
     /* 417996 */ GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(418042),
     /* 418001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 418004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 418007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418011 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(418026), // Rule ID 2874 //
     /* 418016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418019 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 418019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 418024 */     GIR_RootConstrainSelectedInstOperands,
     /* 418025 */     // GIR_Coverage, 2874,
     /* 418025 */     GIR_Done,
     /* 418026 */   // Label 8750: @418026
     /* 418026 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(418041), // Rule ID 2878 //
     /* 418031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418034 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 418034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 418039 */     GIR_RootConstrainSelectedInstOperands,
     /* 418040 */     // GIR_Coverage, 2878,
     /* 418040 */     GIR_Done,
     /* 418041 */   // Label 8751: @418041
     /* 418041 */   GIM_Reject,
     /* 418042 */ // Label 8749: @418042
     /* 418042 */ GIM_Reject,
     /* 418043 */ // Label 8719: @418043
     /* 418043 */ GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(418068), // Rule ID 3346 //
     /* 418048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 418054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 418057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418061 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 418061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 418066 */   GIR_RootConstrainSelectedInstOperands,
     /* 418067 */   // GIR_Coverage, 3346,
     /* 418067 */   GIR_Done,
     /* 418068 */ // Label 8752: @418068
     /* 418068 */ GIM_Reject,
     /* 418069 */ // Label 8720: @418069
     /* 418069 */ GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(418115),
     /* 418074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 418077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 418080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418084 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(418099), // Rule ID 2873 //
     /* 418089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418092 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 418092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 418097 */     GIR_RootConstrainSelectedInstOperands,
     /* 418098 */     // GIR_Coverage, 2873,
     /* 418098 */     GIR_Done,
     /* 418099 */   // Label 8754: @418099
     /* 418099 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(418114), // Rule ID 2876 //
     /* 418104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418107 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 418107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 418112 */     GIR_RootConstrainSelectedInstOperands,
     /* 418113 */     // GIR_Coverage, 2876,
     /* 418113 */     GIR_Done,
     /* 418114 */   // Label 8755: @418114
     /* 418114 */   GIM_Reject,
     /* 418115 */ // Label 8753: @418115
     /* 418115 */ GIM_Reject,
     /* 418116 */ // Label 8721: @418116
     /* 418116 */ GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(418141), // Rule ID 2398 //
     /* 418121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 418127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 418130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418134 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 418134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 418139 */   GIR_RootConstrainSelectedInstOperands,
     /* 418140 */   // GIR_Coverage, 2398,
     /* 418140 */   GIR_Done,
     /* 418141 */ // Label 8756: @418141
     /* 418141 */ GIM_Reject,
     /* 418142 */ // Label 8722: @418142
     /* 418142 */ GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(418167), // Rule ID 2872 //
     /* 418147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 418153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 418156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418160 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 418160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 418165 */   GIR_RootConstrainSelectedInstOperands,
     /* 418166 */   // GIR_Coverage, 2872,
     /* 418166 */   GIR_Done,
     /* 418167 */ // Label 8757: @418167
     /* 418167 */ GIM_Reject,
     /* 418168 */ // Label 8723: @418168
     /* 418168 */ GIM_Reject,
     /* 418169 */ // Label 153: @418169
     /* 418169 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8776*/ GIMT_Encode4(418948),
     /* 418180 */ /*GILLT_v2s32*//*Label 8758*/ GIMT_Encode4(418256),
     /* 418184 */ /*GILLT_v2s64*//*Label 8759*/ GIMT_Encode4(418311),
     /* 418188 */ /*GILLT_v4s16*//*Label 8760*/ GIMT_Encode4(418366),
     /* 418192 */ /*GILLT_v4s32*//*Label 8761*/ GIMT_Encode4(418421),
     /* 418196 */ /*GILLT_v8s8*//*Label 8762*/ GIMT_Encode4(418476),
     /* 418200 */ /*GILLT_v8s16*//*Label 8763*/ GIMT_Encode4(418510),
     /* 418204 */ /*GILLT_v16s8*//*Label 8764*/ GIMT_Encode4(418565), GIMT_Encode4(0),
     /* 418212 */ /*GILLT_nxv2s1*//*Label 8765*/ GIMT_Encode4(418599),
     /* 418216 */ /*GILLT_nxv2s16*//*Label 8766*/ GIMT_Encode4(418625),
     /* 418220 */ /*GILLT_nxv2s32*//*Label 8767*/ GIMT_Encode4(418651),
     /* 418224 */ /*GILLT_nxv2s64*//*Label 8768*/ GIMT_Encode4(418677),
     /* 418228 */ /*GILLT_nxv4s1*//*Label 8769*/ GIMT_Encode4(418724),
     /* 418232 */ /*GILLT_nxv4s16*//*Label 8770*/ GIMT_Encode4(418750),
     /* 418236 */ /*GILLT_nxv4s32*//*Label 8771*/ GIMT_Encode4(418776),
     /* 418240 */ /*GILLT_nxv8s1*//*Label 8772*/ GIMT_Encode4(418823),
     /* 418244 */ /*GILLT_nxv8s16*//*Label 8773*/ GIMT_Encode4(418849),
     /* 418248 */ /*GILLT_nxv16s1*//*Label 8774*/ GIMT_Encode4(418896),
     /* 418252 */ /*GILLT_nxv16s8*//*Label 8775*/ GIMT_Encode4(418922),
     /* 418256 */ // Label 8758: @418256
     /* 418256 */ GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(418310),
     /* 418261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 418267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418279 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(418294), // Rule ID 1909 //
     /* 418284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418287 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 418287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 418292 */     GIR_RootConstrainSelectedInstOperands,
     /* 418293 */     // GIR_Coverage, 1909,
     /* 418293 */     GIR_Done,
     /* 418294 */   // Label 8778: @418294
     /* 418294 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(418309), // Rule ID 5489 //
     /* 418299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418302 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 418302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 418307 */     GIR_RootConstrainSelectedInstOperands,
     /* 418308 */     // GIR_Coverage, 5489,
     /* 418308 */     GIR_Done,
     /* 418309 */   // Label 8779: @418309
     /* 418309 */   GIM_Reject,
     /* 418310 */ // Label 8777: @418310
     /* 418310 */ GIM_Reject,
     /* 418311 */ // Label 8759: @418311
     /* 418311 */ GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(418365),
     /* 418316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 418322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418334 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(418349), // Rule ID 1911 //
     /* 418339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418342 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 418342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 418347 */     GIR_RootConstrainSelectedInstOperands,
     /* 418348 */     // GIR_Coverage, 1911,
     /* 418348 */     GIR_Done,
     /* 418349 */   // Label 8781: @418349
     /* 418349 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(418364), // Rule ID 5491 //
     /* 418354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418357 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 418357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 418362 */     GIR_RootConstrainSelectedInstOperands,
     /* 418363 */     // GIR_Coverage, 5491,
     /* 418363 */     GIR_Done,
     /* 418364 */   // Label 8782: @418364
     /* 418364 */   GIM_Reject,
     /* 418365 */ // Label 8780: @418365
     /* 418365 */ GIM_Reject,
     /* 418366 */ // Label 8760: @418366
     /* 418366 */ GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(418420),
     /* 418371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 418377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418389 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(418404), // Rule ID 1907 //
     /* 418394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418397 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 418397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 418402 */     GIR_RootConstrainSelectedInstOperands,
     /* 418403 */     // GIR_Coverage, 1907,
     /* 418403 */     GIR_Done,
     /* 418404 */   // Label 8784: @418404
     /* 418404 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(418419), // Rule ID 5487 //
     /* 418409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418412 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 418412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 418417 */     GIR_RootConstrainSelectedInstOperands,
     /* 418418 */     // GIR_Coverage, 5487,
     /* 418418 */     GIR_Done,
     /* 418419 */   // Label 8785: @418419
     /* 418419 */   GIM_Reject,
     /* 418420 */ // Label 8783: @418420
     /* 418420 */ GIM_Reject,
     /* 418421 */ // Label 8761: @418421
     /* 418421 */ GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(418475),
     /* 418426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418444 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(418459), // Rule ID 1910 //
     /* 418449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418452 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 418452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 418457 */     GIR_RootConstrainSelectedInstOperands,
     /* 418458 */     // GIR_Coverage, 1910,
     /* 418458 */     GIR_Done,
     /* 418459 */   // Label 8787: @418459
     /* 418459 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(418474), // Rule ID 5490 //
     /* 418464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418467 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 418467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 418472 */     GIR_RootConstrainSelectedInstOperands,
     /* 418473 */     // GIR_Coverage, 5490,
     /* 418473 */     GIR_Done,
     /* 418474 */   // Label 8788: @418474
     /* 418474 */   GIM_Reject,
     /* 418475 */ // Label 8786: @418475
     /* 418475 */ GIM_Reject,
     /* 418476 */ // Label 8762: @418476
     /* 418476 */ GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(418509), // Rule ID 1905 //
     /* 418481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 418490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418502 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 418502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 418507 */   GIR_RootConstrainSelectedInstOperands,
     /* 418508 */   // GIR_Coverage, 1905,
     /* 418508 */   GIR_Done,
     /* 418509 */ // Label 8789: @418509
     /* 418509 */ GIM_Reject,
     /* 418510 */ // Label 8763: @418510
     /* 418510 */ GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(418564),
     /* 418515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 418521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418533 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(418548), // Rule ID 1908 //
     /* 418538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418541 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 418541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 418546 */     GIR_RootConstrainSelectedInstOperands,
     /* 418547 */     // GIR_Coverage, 1908,
     /* 418547 */     GIR_Done,
     /* 418548 */   // Label 8791: @418548
     /* 418548 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(418563), // Rule ID 5488 //
     /* 418553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418556 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 418556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 418561 */     GIR_RootConstrainSelectedInstOperands,
     /* 418562 */     // GIR_Coverage, 5488,
     /* 418562 */     GIR_Done,
     /* 418563 */   // Label 8792: @418563
     /* 418563 */   GIM_Reject,
     /* 418564 */ // Label 8790: @418564
     /* 418564 */ GIM_Reject,
     /* 418565 */ // Label 8764: @418565
     /* 418565 */ GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(418598), // Rule ID 1906 //
     /* 418570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 418579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418591 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 418591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 418596 */   GIR_RootConstrainSelectedInstOperands,
     /* 418597 */   // GIR_Coverage, 1906,
     /* 418597 */   GIR_Done,
     /* 418598 */ // Label 8793: @418598
     /* 418598 */ GIM_Reject,
     /* 418599 */ // Label 8765: @418599
     /* 418599 */ GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(418624), // Rule ID 8978 //
     /* 418604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 418610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 418613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418617 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 418617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 418622 */   GIR_RootConstrainSelectedInstOperands,
     /* 418623 */   // GIR_Coverage, 8978,
     /* 418623 */   GIR_Done,
     /* 418624 */ // Label 8794: @418624
     /* 418624 */ GIM_Reject,
     /* 418625 */ // Label 8766: @418625
     /* 418625 */ GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(418650), // Rule ID 8933 //
     /* 418630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 418636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 418639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418643 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 418643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 418648 */   GIR_RootConstrainSelectedInstOperands,
     /* 418649 */   // GIR_Coverage, 8933,
     /* 418649 */   GIR_Done,
     /* 418650 */ // Label 8795: @418650
     /* 418650 */ GIM_Reject,
     /* 418651 */ // Label 8767: @418651
     /* 418651 */ GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(418676), // Rule ID 8934 //
     /* 418656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 418662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 418665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418669 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 418669 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 418674 */   GIR_RootConstrainSelectedInstOperands,
     /* 418675 */   // GIR_Coverage, 8934,
     /* 418675 */   GIR_Done,
     /* 418676 */ // Label 8796: @418676
     /* 418676 */ GIM_Reject,
     /* 418677 */ // Label 8768: @418677
     /* 418677 */ GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(418723),
     /* 418682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 418685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 418688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418692 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(418707), // Rule ID 8929 //
     /* 418697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418700 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 418700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 418705 */     GIR_RootConstrainSelectedInstOperands,
     /* 418706 */     // GIR_Coverage, 8929,
     /* 418706 */     GIR_Done,
     /* 418707 */   // Label 8798: @418707
     /* 418707 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(418722), // Rule ID 8935 //
     /* 418712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418715 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 418715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 418720 */     GIR_RootConstrainSelectedInstOperands,
     /* 418721 */     // GIR_Coverage, 8935,
     /* 418721 */     GIR_Done,
     /* 418722 */   // Label 8799: @418722
     /* 418722 */   GIM_Reject,
     /* 418723 */ // Label 8797: @418723
     /* 418723 */ GIM_Reject,
     /* 418724 */ // Label 8769: @418724
     /* 418724 */ GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(418749), // Rule ID 8977 //
     /* 418729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 418735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 418738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418742 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 418742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 418747 */   GIR_RootConstrainSelectedInstOperands,
     /* 418748 */   // GIR_Coverage, 8977,
     /* 418748 */   GIR_Done,
     /* 418749 */ // Label 8800: @418749
     /* 418749 */ GIM_Reject,
     /* 418750 */ // Label 8770: @418750
     /* 418750 */ GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(418775), // Rule ID 8931 //
     /* 418755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 418761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 418764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418768 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 418768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 418773 */   GIR_RootConstrainSelectedInstOperands,
     /* 418774 */   // GIR_Coverage, 8931,
     /* 418774 */   GIR_Done,
     /* 418775 */ // Label 8801: @418775
     /* 418775 */ GIM_Reject,
     /* 418776 */ // Label 8771: @418776
     /* 418776 */ GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(418822),
     /* 418781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 418784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 418787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418791 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(418806), // Rule ID 8928 //
     /* 418796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418799 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 418799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 418804 */     GIR_RootConstrainSelectedInstOperands,
     /* 418805 */     // GIR_Coverage, 8928,
     /* 418805 */     GIR_Done,
     /* 418806 */   // Label 8803: @418806
     /* 418806 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(418821), // Rule ID 8932 //
     /* 418811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418814 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 418814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 418819 */     GIR_RootConstrainSelectedInstOperands,
     /* 418820 */     // GIR_Coverage, 8932,
     /* 418820 */     GIR_Done,
     /* 418821 */   // Label 8804: @418821
     /* 418821 */   GIM_Reject,
     /* 418822 */ // Label 8802: @418822
     /* 418822 */ GIM_Reject,
     /* 418823 */ // Label 8772: @418823
     /* 418823 */ GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(418848), // Rule ID 8976 //
     /* 418828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 418834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 418837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418841 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 418841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 418846 */   GIR_RootConstrainSelectedInstOperands,
     /* 418847 */   // GIR_Coverage, 8976,
     /* 418847 */   GIR_Done,
     /* 418848 */ // Label 8805: @418848
     /* 418848 */ GIM_Reject,
     /* 418849 */ // Label 8773: @418849
     /* 418849 */ GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(418895),
     /* 418854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 418857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 418860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418864 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(418879), // Rule ID 8927 //
     /* 418869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418872 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 418872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 418877 */     GIR_RootConstrainSelectedInstOperands,
     /* 418878 */     // GIR_Coverage, 8927,
     /* 418878 */     GIR_Done,
     /* 418879 */   // Label 8807: @418879
     /* 418879 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(418894), // Rule ID 8930 //
     /* 418884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418887 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 418887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 418892 */     GIR_RootConstrainSelectedInstOperands,
     /* 418893 */     // GIR_Coverage, 8930,
     /* 418893 */     GIR_Done,
     /* 418894 */   // Label 8808: @418894
     /* 418894 */   GIM_Reject,
     /* 418895 */ // Label 8806: @418895
     /* 418895 */ GIM_Reject,
     /* 418896 */ // Label 8774: @418896
     /* 418896 */ GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(418921), // Rule ID 2402 //
     /* 418901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 418907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 418910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 418914 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 418914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 418919 */   GIR_RootConstrainSelectedInstOperands,
     /* 418920 */   // GIR_Coverage, 2402,
     /* 418920 */   GIR_Done,
     /* 418921 */ // Label 8809: @418921
     /* 418921 */ GIM_Reject,
     /* 418922 */ // Label 8775: @418922
     /* 418922 */ GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(418947), // Rule ID 8926 //
     /* 418927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 418930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 418933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 418936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 418940 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 418940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 418945 */   GIR_RootConstrainSelectedInstOperands,
     /* 418946 */   // GIR_Coverage, 8926,
     /* 418946 */   GIR_Done,
     /* 418947 */ // Label 8810: @418947
     /* 418947 */ GIM_Reject,
     /* 418948 */ // Label 8776: @418948
     /* 418948 */ GIM_Reject,
     /* 418949 */ // Label 154: @418949
     /* 418949 */ GIM_Reject,
     /* 418950 */ }; // Size: 418950 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
